#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 705
#define LARGE_STATE_COUNT 242
#define SYMBOL_COUNT 101
#define ALIAS_COUNT 0
#define TOKEN_COUNT 51
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 14
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 33

enum {
  sym_symbol = 1,
  sym_line_comment = 2,
  anon_sym_LPAREN = 3,
  anon_sym_RPAREN = 4,
  anon_sym_LBRACK = 5,
  anon_sym_RBRACK = 6,
  anon_sym_AT_LPAREN = 7,
  anon_sym_AT_LBRACK = 8,
  anon_sym_LBRACE = 9,
  anon_sym_RBRACE = 10,
  anon_sym_AT_LBRACE = 11,
  anon_sym_set = 12,
  anon_sym_def = 13,
  anon_sym_var = 14,
  anon_sym_quote = 15,
  anon_sym_splice = 16,
  anon_sym_quasiquote = 17,
  anon_sym_unquote = 18,
  anon_sym_break = 19,
  anon_sym_if = 20,
  anon_sym_do = 21,
  anon_sym_while = 22,
  anon_sym_fn = 23,
  anon_sym_upscope = 24,
  sym_variadic_marker = 25,
  sym_optional_marker = 26,
  sym_keys_marker = 27,
  anon_sym_SQUOTE = 28,
  anon_sym_SEMI = 29,
  anon_sym_TILDE = 30,
  anon_sym_COMMA = 31,
  anon_sym_PIPE = 32,
  anon_sym_defn = 33,
  anon_sym_defn_DASH = 34,
  anon_sym_varfn = 35,
  anon_sym_varfn_DASH = 36,
  anon_sym_defmacro = 37,
  anon_sym_defmacro_DASH = 38,
  sym_str_literal = 39,
  sym_buffer_literal = 40,
  aux_sym_number_literal_token1 = 41,
  aux_sym_number_literal_token2 = 42,
  aux_sym_number_literal_token3 = 43,
  anon_sym_true = 44,
  anon_sym_false = 45,
  sym_nil_literal = 46,
  sym_escape_sequence = 47,
  sym_keyword = 48,
  sym__long_str = 49,
  sym__long_buffer = 50,
  sym_source_file = 51,
  sym__expr = 52,
  sym_tuple = 53,
  sym_sqr_tuple = 54,
  sym_array = 55,
  sym_sqr_array = 56,
  sym_struct = 57,
  sym_table = 58,
  sym__struct_tables_commom = 59,
  sym_peg_set = 60,
  sym__special_forms = 61,
  sym_def = 62,
  sym_var = 63,
  sym_quote = 64,
  sym_splice = 65,
  sym_quasiquote = 66,
  sym_unquote = 67,
  sym_break = 68,
  sym_set = 69,
  sym_if = 70,
  sym_do = 71,
  sym_while = 72,
  sym_fn = 73,
  sym_upscope = 74,
  sym__parameters = 75,
  sym_parameters = 76,
  sym_tuple_parameters = 77,
  sym__shorthand = 78,
  sym_short_quote = 79,
  sym_short_splice = 80,
  sym_short_quasiquote = 81,
  sym_short_unquote = 82,
  sym_short_fn = 83,
  sym__specials = 84,
  sym_extra_defs = 85,
  sym__literals = 86,
  sym_long_str_literal = 87,
  sym_long_buffer_literal = 88,
  sym_number_literal = 89,
  sym_bool_literal = 90,
  sym_metadata = 91,
  sym__name = 92,
  sym_body = 93,
  sym__identifier = 94,
  aux_sym_source_file_repeat1 = 95,
  aux_sym_tuple_repeat1 = 96,
  aux_sym_struct_repeat1 = 97,
  aux_sym_def_repeat1 = 98,
  aux_sym_while_repeat1 = 99,
  aux_sym_parameters_repeat1 = 100,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_symbol] = "symbol",
  [sym_line_comment] = "line_comment",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_AT_LBRACK] = "@[",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_AT_LBRACE] = "@{",
  [anon_sym_set] = "set",
  [anon_sym_def] = "def",
  [anon_sym_var] = "var",
  [anon_sym_quote] = "quote",
  [anon_sym_splice] = "splice",
  [anon_sym_quasiquote] = "quasiquote",
  [anon_sym_unquote] = "unquote",
  [anon_sym_break] = "break",
  [anon_sym_if] = "if",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_fn] = "fn",
  [anon_sym_upscope] = "upscope",
  [sym_variadic_marker] = "variadic_marker",
  [sym_optional_marker] = "optional_marker",
  [sym_keys_marker] = "keys_marker",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_SEMI] = ";",
  [anon_sym_TILDE] = "~",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_defn] = "defn",
  [anon_sym_defn_DASH] = "defn-",
  [anon_sym_varfn] = "varfn",
  [anon_sym_varfn_DASH] = "varfn-",
  [anon_sym_defmacro] = "defmacro",
  [anon_sym_defmacro_DASH] = "defmacro-",
  [sym_str_literal] = "str_literal",
  [sym_buffer_literal] = "buffer_literal",
  [aux_sym_number_literal_token1] = "number_literal_token1",
  [aux_sym_number_literal_token2] = "number_literal_token2",
  [aux_sym_number_literal_token3] = "number_literal_token3",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_nil_literal] = "nil_literal",
  [sym_escape_sequence] = "escape_sequence",
  [sym_keyword] = "keyword",
  [sym__long_str] = "_long_str",
  [sym__long_buffer] = "_long_buffer",
  [sym_source_file] = "source_file",
  [sym__expr] = "_expr",
  [sym_tuple] = "tuple",
  [sym_sqr_tuple] = "sqr_tuple",
  [sym_array] = "array",
  [sym_sqr_array] = "sqr_array",
  [sym_struct] = "struct",
  [sym_table] = "table",
  [sym__struct_tables_commom] = "_struct_tables_commom",
  [sym_peg_set] = "peg_set",
  [sym__special_forms] = "_special_forms",
  [sym_def] = "def",
  [sym_var] = "var",
  [sym_quote] = "quote",
  [sym_splice] = "splice",
  [sym_quasiquote] = "quasiquote",
  [sym_unquote] = "unquote",
  [sym_break] = "break",
  [sym_set] = "set",
  [sym_if] = "if",
  [sym_do] = "do",
  [sym_while] = "while",
  [sym_fn] = "fn",
  [sym_upscope] = "upscope",
  [sym__parameters] = "_parameters",
  [sym_parameters] = "parameters",
  [sym_tuple_parameters] = "tuple_parameters",
  [sym__shorthand] = "_shorthand",
  [sym_short_quote] = "short_quote",
  [sym_short_splice] = "short_splice",
  [sym_short_quasiquote] = "short_quasiquote",
  [sym_short_unquote] = "short_unquote",
  [sym_short_fn] = "short_fn",
  [sym__specials] = "_specials",
  [sym_extra_defs] = "extra_defs",
  [sym__literals] = "_literals",
  [sym_long_str_literal] = "long_str_literal",
  [sym_long_buffer_literal] = "long_buffer_literal",
  [sym_number_literal] = "number_literal",
  [sym_bool_literal] = "bool_literal",
  [sym_metadata] = "metadata",
  [sym__name] = "_name",
  [sym_body] = "body",
  [sym__identifier] = "_identifier",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_struct_repeat1] = "struct_repeat1",
  [aux_sym_def_repeat1] = "def_repeat1",
  [aux_sym_while_repeat1] = "while_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_symbol] = sym_symbol,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_AT_LBRACK] = anon_sym_AT_LBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_AT_LBRACE] = anon_sym_AT_LBRACE,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_splice] = anon_sym_splice,
  [anon_sym_quasiquote] = anon_sym_quasiquote,
  [anon_sym_unquote] = anon_sym_unquote,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_upscope] = anon_sym_upscope,
  [sym_variadic_marker] = sym_variadic_marker,
  [sym_optional_marker] = sym_optional_marker,
  [sym_keys_marker] = sym_keys_marker,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_defn] = anon_sym_defn,
  [anon_sym_defn_DASH] = anon_sym_defn_DASH,
  [anon_sym_varfn] = anon_sym_varfn,
  [anon_sym_varfn_DASH] = anon_sym_varfn_DASH,
  [anon_sym_defmacro] = anon_sym_defmacro,
  [anon_sym_defmacro_DASH] = anon_sym_defmacro_DASH,
  [sym_str_literal] = sym_str_literal,
  [sym_buffer_literal] = sym_buffer_literal,
  [aux_sym_number_literal_token1] = aux_sym_number_literal_token1,
  [aux_sym_number_literal_token2] = aux_sym_number_literal_token2,
  [aux_sym_number_literal_token3] = aux_sym_number_literal_token3,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_nil_literal] = sym_nil_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_keyword] = sym_keyword,
  [sym__long_str] = sym__long_str,
  [sym__long_buffer] = sym__long_buffer,
  [sym_source_file] = sym_source_file,
  [sym__expr] = sym__expr,
  [sym_tuple] = sym_tuple,
  [sym_sqr_tuple] = sym_sqr_tuple,
  [sym_array] = sym_array,
  [sym_sqr_array] = sym_sqr_array,
  [sym_struct] = sym_struct,
  [sym_table] = sym_table,
  [sym__struct_tables_commom] = sym__struct_tables_commom,
  [sym_peg_set] = sym_peg_set,
  [sym__special_forms] = sym__special_forms,
  [sym_def] = sym_def,
  [sym_var] = sym_var,
  [sym_quote] = sym_quote,
  [sym_splice] = sym_splice,
  [sym_quasiquote] = sym_quasiquote,
  [sym_unquote] = sym_unquote,
  [sym_break] = sym_break,
  [sym_set] = sym_set,
  [sym_if] = sym_if,
  [sym_do] = sym_do,
  [sym_while] = sym_while,
  [sym_fn] = sym_fn,
  [sym_upscope] = sym_upscope,
  [sym__parameters] = sym__parameters,
  [sym_parameters] = sym_parameters,
  [sym_tuple_parameters] = sym_tuple_parameters,
  [sym__shorthand] = sym__shorthand,
  [sym_short_quote] = sym_short_quote,
  [sym_short_splice] = sym_short_splice,
  [sym_short_quasiquote] = sym_short_quasiquote,
  [sym_short_unquote] = sym_short_unquote,
  [sym_short_fn] = sym_short_fn,
  [sym__specials] = sym__specials,
  [sym_extra_defs] = sym_extra_defs,
  [sym__literals] = sym__literals,
  [sym_long_str_literal] = sym_long_str_literal,
  [sym_long_buffer_literal] = sym_long_buffer_literal,
  [sym_number_literal] = sym_number_literal,
  [sym_bool_literal] = sym_bool_literal,
  [sym_metadata] = sym_metadata,
  [sym__name] = sym__name,
  [sym_body] = sym_body,
  [sym__identifier] = sym__identifier,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_tuple_repeat1] = aux_sym_tuple_repeat1,
  [aux_sym_struct_repeat1] = aux_sym_struct_repeat1,
  [aux_sym_def_repeat1] = aux_sym_def_repeat1,
  [aux_sym_while_repeat1] = aux_sym_while_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_splice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quasiquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_upscope] = {
    .visible = true,
    .named = false,
  },
  [sym_variadic_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_keys_marker] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_number_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_nil_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym__long_str] = {
    .visible = false,
    .named = true,
  },
  [sym__long_buffer] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__expr] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_array] = {
    .visible = true,
    .named = true,
  },
  [sym_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_table] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_tables_commom] = {
    .visible = false,
    .named = true,
  },
  [sym_peg_set] = {
    .visible = true,
    .named = true,
  },
  [sym__special_forms] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_def] = {
    .visible = true,
    .named = true,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_fn] = {
    .visible = true,
    .named = true,
  },
  [sym_upscope] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__shorthand] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_short_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_short_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_fn] = {
    .visible = true,
    .named = true,
  },
  [sym__specials] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_extra_defs] = {
    .visible = true,
    .named = true,
  },
  [sym__literals] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_long_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_long_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bool_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_body = 1,
  field_condition = 2,
  field_else = 3,
  field_form = 4,
  field_item = 5,
  field_key = 6,
  field_l_value = 7,
  field_metadata = 8,
  field_name = 9,
  field_parameter = 10,
  field_parameters = 11,
  field_r_value = 12,
  field_then = 13,
  field_value = 14,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_body] = "body",
  [field_condition] = "condition",
  [field_else] = "else",
  [field_form] = "form",
  [field_item] = "item",
  [field_key] = "key",
  [field_l_value] = "l_value",
  [field_metadata] = "metadata",
  [field_name] = "name",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_r_value] = "r_value",
  [field_then] = "then",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 1},
  [7] = {.index = 7, .length = 2},
  [8] = {.index = 9, .length = 2},
  [9] = {.index = 11, .length = 2},
  [10] = {.index = 13, .length = 4},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 1},
  [13] = {.index = 19, .length = 2},
  [14] = {.index = 21, .length = 1},
  [15] = {.index = 22, .length = 1},
  [16] = {.index = 23, .length = 1},
  [17] = {.index = 24, .length = 2},
  [18] = {.index = 26, .length = 2},
  [19] = {.index = 28, .length = 2},
  [20] = {.index = 30, .length = 2},
  [21] = {.index = 32, .length = 2},
  [22] = {.index = 34, .length = 1},
  [23] = {.index = 35, .length = 2},
  [24] = {.index = 37, .length = 2},
  [25] = {.index = 39, .length = 2},
  [26] = {.index = 41, .length = 3},
  [27] = {.index = 44, .length = 3},
  [28] = {.index = 47, .length = 1},
  [29] = {.index = 48, .length = 3},
  [30] = {.index = 51, .length = 3},
  [31] = {.index = 54, .length = 2},
  [32] = {.index = 56, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_item, 0},
  [1] =
    {field_key, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [3] =
    {field_body, 1},
  [4] =
    {field_form, 0},
  [5] =
    {field_form, 0, .inherited = true},
  [6] =
    {field_item, 1, .inherited = true},
  [7] =
    {field_item, 0, .inherited = true},
    {field_item, 1, .inherited = true},
  [9] =
    {field_key, 0},
    {field_value, 1},
  [11] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [13] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [17] =
    {field_metadata, 0},
  [18] =
    {field_body, 2},
  [19] =
    {field_form, 0, .inherited = true},
    {field_form, 1, .inherited = true},
  [21] =
    {field_condition, 2},
  [22] =
    {field_parameter, 0},
  [23] =
    {field_parameters, 2},
  [24] =
    {field_l_value, 2},
    {field_r_value, 3},
  [26] =
    {field_name, 2},
    {field_value, 3},
  [28] =
    {field_metadata, 0, .inherited = true},
    {field_metadata, 1, .inherited = true},
  [30] =
    {field_condition, 2},
    {field_then, 3},
  [32] =
    {field_condition, 2},
    {field_form, 3, .inherited = true},
  [34] =
    {field_parameter, 1, .inherited = true},
  [35] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [37] =
    {field_body, 3},
    {field_parameters, 2},
  [39] =
    {field_name, 2},
    {field_parameters, 3},
  [41] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_value, 4},
  [44] =
    {field_condition, 2},
    {field_else, 4},
    {field_then, 3},
  [47] =
    {field_parameter, 2, .inherited = true},
  [48] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [51] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
  [54] =
    {field_parameter, 1, .inherited = true},
    {field_parameter, 3, .inherited = true},
  [56] =
    {field_body, 5},
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static inline bool sym_line_comment_character_set_1(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\r'
        ? c == '\t'
        : c <= '\r')
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '~')))));
}

static inline bool sym_escape_sequence_character_set_1(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\r'
        ? (c >= '\t' && c <= '\n')
        : c <= '\r')
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_1(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '{'
        ? c == '`'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_2(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '"')))
    : (c <= ')' || (c < '['
      ? (c < ';'
        ? c == ','
        : c <= ';')
      : (c <= '[' || (c < '`'
        ? c == ']'
        : c <= '~')))));
}

static inline bool sym_symbol_character_set_3(int32_t c) {
  return (c < ','
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == ' '
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < ']'
        ? c == ';'
        : c <= ']')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static inline bool sym_symbol_character_set_4(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ',' || (c < ']'
      ? (c < '['
        ? c == ';'
        : c <= '[')
      : (c <= ']' || (c < '|'
        ? c == '`'
        : c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '\\') ADVANCE(68);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`' &&
          lookahead != '}') ADVANCE(83);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '~') ADVANCE(40);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ']' &&
          lookahead != '`' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(83);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(43);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(44);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 5:
      if (lookahead == 'u') ADVANCE(7);
      if (lookahead == 'x') ADVANCE(18);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(8);
      if (lookahead == 'x') ADVANCE(19);
      if (lookahead != 0) ADVANCE(4);
      END_STATE();
    case 7:
      if (lookahead == '{') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 8:
      if (lookahead == '{') ADVANCE(17);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 9:
      if (lookahead == '}') ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '}') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '}') ADVANCE(4);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(4);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 20:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 21:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '&') ADVANCE(35);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(21)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 22:
      if (eof) ADVANCE(23);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '#') ADVANCE(24);
      if (lookahead == '\'') ADVANCE(38);
      if (lookahead == '(') ADVANCE(26);
      if (lookahead == ')') ADVANCE(27);
      if (lookahead == ',') ADVANCE(41);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (lookahead == ':') ADVANCE(59);
      if (lookahead == ';') ADVANCE(39);
      if (lookahead == '@') ADVANCE(60);
      if (lookahead == '[') ADVANCE(28);
      if (lookahead == ']') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead == '|') ADVANCE(42);
      if (lookahead == '}') ADVANCE(33);
      if (lookahead == '~') ADVANCE(40);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(61);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(22)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(83);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_line_comment);
      if (sym_line_comment_character_set_1(lookahead)) ADVANCE(25);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_AT_LBRACK);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_AT_LBRACE);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_variadic_marker);
      if (lookahead == 'k') ADVANCE(64);
      if (lookahead == 'o') ADVANCE(65);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_optional_marker);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_keys_marker);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_str_literal);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_buffer_literal);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == 'x') ADVANCE(63);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(47);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '_') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(47);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == 'r') ADVANCE(62);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(48);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(49);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(48);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(49);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(73);
      if (lookahead == '.') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(72);
      if (lookahead == '.') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(72);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_keyword);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '"') ADVANCE(4);
      if (lookahead == '(') ADVANCE(30);
      if (lookahead == '[') ADVANCE(31);
      if (lookahead == '{') ADVANCE(34);
      if (!sym_symbol_character_set_3(lookahead)) ADVANCE(83);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(75);
      if (lookahead == '0') ADVANCE(45);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(46);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'e') ADVANCE(69);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'p') ADVANCE(67);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 's') ADVANCE(37);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 't') ADVANCE(36);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'u') ADVANCE(70);
      if (lookahead == 'x') ADVANCE(79);
      if (sym_escape_sequence_character_set_1(lookahead)) ADVANCE(57);
      if (lookahead != 0) ADVANCE(58);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'y') ADVANCE(66);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '{') ADVANCE(14);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(76);
      if (!sym_symbol_character_set_4(lookahead)) ADVANCE(83);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(74);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(78);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(50);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(49);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(79);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(58);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(77);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(55);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      if (!sym_symbol_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_symbol);
      if (!sym_symbol_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'b') ADVANCE(1);
      if (lookahead == 'd') ADVANCE(2);
      if (lookahead == 'f') ADVANCE(3);
      if (lookahead == 'i') ADVANCE(4);
      if (lookahead == 'n') ADVANCE(5);
      if (lookahead == 'q') ADVANCE(6);
      if (lookahead == 's') ADVANCE(7);
      if (lookahead == 't') ADVANCE(8);
      if (lookahead == 'u') ADVANCE(9);
      if (lookahead == 'v') ADVANCE(10);
      if (lookahead == 'w') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'r') ADVANCE(12);
      END_STATE();
    case 2:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(14);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 4:
      if (lookahead == 'f') ADVANCE(17);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(18);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(19);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'p') ADVANCE(21);
      END_STATE();
    case 8:
      if (lookahead == 'r') ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'n') ADVANCE(23);
      if (lookahead == 'p') ADVANCE(24);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == 'h') ADVANCE(26);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(27);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(28);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 15:
      if (lookahead == 'l') ADVANCE(29);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 18:
      if (lookahead == 'l') ADVANCE(30);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(33);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(34);
      END_STATE();
    case 22:
      if (lookahead == 'u') ADVANCE(35);
      END_STATE();
    case 23:
      if (lookahead == 'q') ADVANCE(36);
      END_STATE();
    case 24:
      if (lookahead == 's') ADVANCE(37);
      END_STATE();
    case 25:
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(39);
      END_STATE();
    case 27:
      if (lookahead == 'a') ADVANCE(40);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'm') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_nil_literal);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(44);
      END_STATE();
    case 32:
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(46);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(49);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_var);
      if (lookahead == 'f') ADVANCE(50);
      END_STATE();
    case 39:
      if (lookahead == 'l') ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == 'k') ADVANCE(52);
      END_STATE();
    case 41:
      if (lookahead == 'a') ADVANCE(53);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_defn);
      if (lookahead == '-') ADVANCE(54);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(57);
      END_STATE();
    case 46:
      if (lookahead == 'c') ADVANCE(58);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(59);
      END_STATE();
    case 49:
      if (lookahead == 'o') ADVANCE(60);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(61);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(62);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 53:
      if (lookahead == 'c') ADVANCE(63);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_defn_DASH);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 56:
      if (lookahead == 'q') ADVANCE(64);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(65);
      END_STATE();
    case 59:
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 60:
      if (lookahead == 'p') ADVANCE(67);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_varfn);
      if (lookahead == '-') ADVANCE(68);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 63:
      if (lookahead == 'r') ADVANCE(69);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(70);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_splice);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(72);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_varfn_DASH);
      END_STATE();
    case 69:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 70:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_unquote);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_upscope);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_defmacro);
      if (lookahead == '-') ADVANCE(75);
      END_STATE();
    case 74:
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_defmacro_DASH);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_quasiquote);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 22, .external_lex_state = 1},
  [2] = {.lex_state = 22, .external_lex_state = 1},
  [3] = {.lex_state = 22, .external_lex_state = 1},
  [4] = {.lex_state = 22, .external_lex_state = 1},
  [5] = {.lex_state = 22, .external_lex_state = 1},
  [6] = {.lex_state = 22, .external_lex_state = 1},
  [7] = {.lex_state = 22, .external_lex_state = 1},
  [8] = {.lex_state = 1, .external_lex_state = 1},
  [9] = {.lex_state = 1, .external_lex_state = 1},
  [10] = {.lex_state = 1, .external_lex_state = 1},
  [11] = {.lex_state = 1, .external_lex_state = 1},
  [12] = {.lex_state = 1, .external_lex_state = 1},
  [13] = {.lex_state = 22, .external_lex_state = 1},
  [14] = {.lex_state = 22, .external_lex_state = 1},
  [15] = {.lex_state = 22, .external_lex_state = 1},
  [16] = {.lex_state = 22, .external_lex_state = 1},
  [17] = {.lex_state = 22, .external_lex_state = 1},
  [18] = {.lex_state = 22, .external_lex_state = 1},
  [19] = {.lex_state = 22, .external_lex_state = 1},
  [20] = {.lex_state = 22, .external_lex_state = 1},
  [21] = {.lex_state = 22, .external_lex_state = 1},
  [22] = {.lex_state = 22, .external_lex_state = 1},
  [23] = {.lex_state = 22, .external_lex_state = 1},
  [24] = {.lex_state = 22, .external_lex_state = 1},
  [25] = {.lex_state = 22, .external_lex_state = 1},
  [26] = {.lex_state = 22, .external_lex_state = 1},
  [27] = {.lex_state = 22, .external_lex_state = 1},
  [28] = {.lex_state = 22, .external_lex_state = 1},
  [29] = {.lex_state = 22, .external_lex_state = 1},
  [30] = {.lex_state = 22, .external_lex_state = 1},
  [31] = {.lex_state = 22, .external_lex_state = 1},
  [32] = {.lex_state = 22, .external_lex_state = 1},
  [33] = {.lex_state = 22, .external_lex_state = 1},
  [34] = {.lex_state = 22, .external_lex_state = 1},
  [35] = {.lex_state = 22, .external_lex_state = 1},
  [36] = {.lex_state = 22, .external_lex_state = 1},
  [37] = {.lex_state = 22, .external_lex_state = 1},
  [38] = {.lex_state = 22, .external_lex_state = 1},
  [39] = {.lex_state = 22, .external_lex_state = 1},
  [40] = {.lex_state = 22, .external_lex_state = 1},
  [41] = {.lex_state = 22, .external_lex_state = 1},
  [42] = {.lex_state = 22, .external_lex_state = 1},
  [43] = {.lex_state = 22, .external_lex_state = 1},
  [44] = {.lex_state = 22, .external_lex_state = 1},
  [45] = {.lex_state = 22, .external_lex_state = 1},
  [46] = {.lex_state = 22, .external_lex_state = 1},
  [47] = {.lex_state = 22, .external_lex_state = 1},
  [48] = {.lex_state = 22, .external_lex_state = 1},
  [49] = {.lex_state = 22, .external_lex_state = 1},
  [50] = {.lex_state = 22, .external_lex_state = 1},
  [51] = {.lex_state = 22, .external_lex_state = 1},
  [52] = {.lex_state = 22, .external_lex_state = 1},
  [53] = {.lex_state = 22, .external_lex_state = 1},
  [54] = {.lex_state = 22, .external_lex_state = 1},
  [55] = {.lex_state = 22, .external_lex_state = 1},
  [56] = {.lex_state = 22, .external_lex_state = 1},
  [57] = {.lex_state = 22, .external_lex_state = 1},
  [58] = {.lex_state = 22, .external_lex_state = 1},
  [59] = {.lex_state = 22, .external_lex_state = 1},
  [60] = {.lex_state = 22, .external_lex_state = 1},
  [61] = {.lex_state = 22, .external_lex_state = 1},
  [62] = {.lex_state = 22, .external_lex_state = 1},
  [63] = {.lex_state = 22, .external_lex_state = 1},
  [64] = {.lex_state = 22, .external_lex_state = 1},
  [65] = {.lex_state = 22, .external_lex_state = 1},
  [66] = {.lex_state = 22, .external_lex_state = 1},
  [67] = {.lex_state = 22, .external_lex_state = 1},
  [68] = {.lex_state = 22, .external_lex_state = 1},
  [69] = {.lex_state = 22, .external_lex_state = 1},
  [70] = {.lex_state = 22, .external_lex_state = 1},
  [71] = {.lex_state = 22, .external_lex_state = 1},
  [72] = {.lex_state = 22, .external_lex_state = 1},
  [73] = {.lex_state = 22, .external_lex_state = 1},
  [74] = {.lex_state = 22, .external_lex_state = 1},
  [75] = {.lex_state = 22, .external_lex_state = 1},
  [76] = {.lex_state = 22, .external_lex_state = 1},
  [77] = {.lex_state = 22, .external_lex_state = 1},
  [78] = {.lex_state = 22, .external_lex_state = 1},
  [79] = {.lex_state = 22, .external_lex_state = 1},
  [80] = {.lex_state = 22, .external_lex_state = 1},
  [81] = {.lex_state = 22, .external_lex_state = 1},
  [82] = {.lex_state = 22, .external_lex_state = 1},
  [83] = {.lex_state = 22, .external_lex_state = 1},
  [84] = {.lex_state = 22, .external_lex_state = 1},
  [85] = {.lex_state = 22, .external_lex_state = 1},
  [86] = {.lex_state = 22, .external_lex_state = 1},
  [87] = {.lex_state = 22, .external_lex_state = 1},
  [88] = {.lex_state = 22, .external_lex_state = 1},
  [89] = {.lex_state = 22, .external_lex_state = 1},
  [90] = {.lex_state = 22, .external_lex_state = 1},
  [91] = {.lex_state = 22, .external_lex_state = 1},
  [92] = {.lex_state = 22, .external_lex_state = 1},
  [93] = {.lex_state = 22, .external_lex_state = 1},
  [94] = {.lex_state = 22, .external_lex_state = 1},
  [95] = {.lex_state = 22, .external_lex_state = 1},
  [96] = {.lex_state = 22, .external_lex_state = 1},
  [97] = {.lex_state = 22, .external_lex_state = 1},
  [98] = {.lex_state = 22, .external_lex_state = 1},
  [99] = {.lex_state = 22, .external_lex_state = 1},
  [100] = {.lex_state = 22, .external_lex_state = 1},
  [101] = {.lex_state = 22, .external_lex_state = 1},
  [102] = {.lex_state = 22, .external_lex_state = 1},
  [103] = {.lex_state = 22, .external_lex_state = 1},
  [104] = {.lex_state = 22, .external_lex_state = 1},
  [105] = {.lex_state = 22, .external_lex_state = 1},
  [106] = {.lex_state = 22, .external_lex_state = 1},
  [107] = {.lex_state = 22, .external_lex_state = 1},
  [108] = {.lex_state = 22, .external_lex_state = 1},
  [109] = {.lex_state = 22, .external_lex_state = 1},
  [110] = {.lex_state = 22, .external_lex_state = 1},
  [111] = {.lex_state = 22, .external_lex_state = 1},
  [112] = {.lex_state = 22, .external_lex_state = 1},
  [113] = {.lex_state = 22, .external_lex_state = 1},
  [114] = {.lex_state = 22, .external_lex_state = 1},
  [115] = {.lex_state = 22, .external_lex_state = 1},
  [116] = {.lex_state = 22, .external_lex_state = 1},
  [117] = {.lex_state = 22, .external_lex_state = 1},
  [118] = {.lex_state = 22, .external_lex_state = 1},
  [119] = {.lex_state = 22, .external_lex_state = 1},
  [120] = {.lex_state = 22, .external_lex_state = 1},
  [121] = {.lex_state = 22, .external_lex_state = 1},
  [122] = {.lex_state = 22, .external_lex_state = 1},
  [123] = {.lex_state = 22, .external_lex_state = 1},
  [124] = {.lex_state = 22, .external_lex_state = 1},
  [125] = {.lex_state = 22, .external_lex_state = 1},
  [126] = {.lex_state = 22, .external_lex_state = 1},
  [127] = {.lex_state = 22, .external_lex_state = 1},
  [128] = {.lex_state = 22, .external_lex_state = 1},
  [129] = {.lex_state = 22, .external_lex_state = 1},
  [130] = {.lex_state = 22, .external_lex_state = 1},
  [131] = {.lex_state = 22, .external_lex_state = 1},
  [132] = {.lex_state = 22, .external_lex_state = 1},
  [133] = {.lex_state = 22, .external_lex_state = 1},
  [134] = {.lex_state = 22, .external_lex_state = 1},
  [135] = {.lex_state = 22, .external_lex_state = 1},
  [136] = {.lex_state = 22, .external_lex_state = 1},
  [137] = {.lex_state = 22, .external_lex_state = 1},
  [138] = {.lex_state = 22, .external_lex_state = 1},
  [139] = {.lex_state = 22, .external_lex_state = 1},
  [140] = {.lex_state = 22, .external_lex_state = 1},
  [141] = {.lex_state = 22, .external_lex_state = 1},
  [142] = {.lex_state = 22, .external_lex_state = 1},
  [143] = {.lex_state = 22, .external_lex_state = 1},
  [144] = {.lex_state = 22, .external_lex_state = 1},
  [145] = {.lex_state = 22, .external_lex_state = 1},
  [146] = {.lex_state = 22, .external_lex_state = 1},
  [147] = {.lex_state = 22, .external_lex_state = 1},
  [148] = {.lex_state = 22, .external_lex_state = 1},
  [149] = {.lex_state = 22, .external_lex_state = 1},
  [150] = {.lex_state = 22, .external_lex_state = 1},
  [151] = {.lex_state = 22, .external_lex_state = 1},
  [152] = {.lex_state = 22, .external_lex_state = 1},
  [153] = {.lex_state = 22, .external_lex_state = 1},
  [154] = {.lex_state = 22, .external_lex_state = 1},
  [155] = {.lex_state = 22, .external_lex_state = 1},
  [156] = {.lex_state = 22, .external_lex_state = 1},
  [157] = {.lex_state = 22, .external_lex_state = 1},
  [158] = {.lex_state = 22, .external_lex_state = 1},
  [159] = {.lex_state = 22, .external_lex_state = 1},
  [160] = {.lex_state = 22, .external_lex_state = 1},
  [161] = {.lex_state = 22, .external_lex_state = 1},
  [162] = {.lex_state = 22, .external_lex_state = 1},
  [163] = {.lex_state = 22, .external_lex_state = 1},
  [164] = {.lex_state = 22, .external_lex_state = 1},
  [165] = {.lex_state = 22, .external_lex_state = 1},
  [166] = {.lex_state = 22, .external_lex_state = 1},
  [167] = {.lex_state = 22, .external_lex_state = 1},
  [168] = {.lex_state = 22, .external_lex_state = 1},
  [169] = {.lex_state = 22, .external_lex_state = 1},
  [170] = {.lex_state = 22, .external_lex_state = 1},
  [171] = {.lex_state = 22, .external_lex_state = 1},
  [172] = {.lex_state = 22, .external_lex_state = 1},
  [173] = {.lex_state = 22, .external_lex_state = 1},
  [174] = {.lex_state = 22, .external_lex_state = 1},
  [175] = {.lex_state = 22, .external_lex_state = 1},
  [176] = {.lex_state = 22, .external_lex_state = 1},
  [177] = {.lex_state = 22, .external_lex_state = 1},
  [178] = {.lex_state = 22, .external_lex_state = 1},
  [179] = {.lex_state = 22, .external_lex_state = 1},
  [180] = {.lex_state = 22, .external_lex_state = 1},
  [181] = {.lex_state = 22, .external_lex_state = 1},
  [182] = {.lex_state = 22, .external_lex_state = 1},
  [183] = {.lex_state = 22, .external_lex_state = 1},
  [184] = {.lex_state = 22, .external_lex_state = 1},
  [185] = {.lex_state = 22, .external_lex_state = 1},
  [186] = {.lex_state = 22, .external_lex_state = 1},
  [187] = {.lex_state = 22, .external_lex_state = 1},
  [188] = {.lex_state = 22, .external_lex_state = 1},
  [189] = {.lex_state = 22, .external_lex_state = 1},
  [190] = {.lex_state = 22, .external_lex_state = 1},
  [191] = {.lex_state = 22, .external_lex_state = 1},
  [192] = {.lex_state = 22, .external_lex_state = 1},
  [193] = {.lex_state = 22, .external_lex_state = 1},
  [194] = {.lex_state = 22, .external_lex_state = 1},
  [195] = {.lex_state = 22, .external_lex_state = 1},
  [196] = {.lex_state = 22, .external_lex_state = 1},
  [197] = {.lex_state = 22, .external_lex_state = 1},
  [198] = {.lex_state = 22, .external_lex_state = 1},
  [199] = {.lex_state = 22, .external_lex_state = 1},
  [200] = {.lex_state = 22, .external_lex_state = 1},
  [201] = {.lex_state = 22, .external_lex_state = 1},
  [202] = {.lex_state = 22, .external_lex_state = 1},
  [203] = {.lex_state = 22, .external_lex_state = 1},
  [204] = {.lex_state = 22, .external_lex_state = 1},
  [205] = {.lex_state = 22, .external_lex_state = 1},
  [206] = {.lex_state = 22, .external_lex_state = 1},
  [207] = {.lex_state = 22, .external_lex_state = 1},
  [208] = {.lex_state = 22, .external_lex_state = 1},
  [209] = {.lex_state = 22, .external_lex_state = 1},
  [210] = {.lex_state = 22, .external_lex_state = 1},
  [211] = {.lex_state = 22, .external_lex_state = 1},
  [212] = {.lex_state = 22, .external_lex_state = 1},
  [213] = {.lex_state = 22, .external_lex_state = 1},
  [214] = {.lex_state = 22, .external_lex_state = 1},
  [215] = {.lex_state = 22, .external_lex_state = 1},
  [216] = {.lex_state = 22, .external_lex_state = 1},
  [217] = {.lex_state = 22, .external_lex_state = 1},
  [218] = {.lex_state = 22, .external_lex_state = 1},
  [219] = {.lex_state = 22, .external_lex_state = 1},
  [220] = {.lex_state = 22, .external_lex_state = 1},
  [221] = {.lex_state = 22, .external_lex_state = 1},
  [222] = {.lex_state = 22, .external_lex_state = 1},
  [223] = {.lex_state = 22, .external_lex_state = 1},
  [224] = {.lex_state = 22, .external_lex_state = 1},
  [225] = {.lex_state = 22, .external_lex_state = 1},
  [226] = {.lex_state = 22, .external_lex_state = 1},
  [227] = {.lex_state = 22, .external_lex_state = 1},
  [228] = {.lex_state = 22, .external_lex_state = 1},
  [229] = {.lex_state = 22, .external_lex_state = 1},
  [230] = {.lex_state = 22, .external_lex_state = 1},
  [231] = {.lex_state = 22, .external_lex_state = 1},
  [232] = {.lex_state = 22, .external_lex_state = 1},
  [233] = {.lex_state = 22, .external_lex_state = 1},
  [234] = {.lex_state = 22, .external_lex_state = 1},
  [235] = {.lex_state = 22, .external_lex_state = 1},
  [236] = {.lex_state = 22, .external_lex_state = 1},
  [237] = {.lex_state = 22, .external_lex_state = 1},
  [238] = {.lex_state = 22, .external_lex_state = 1},
  [239] = {.lex_state = 22, .external_lex_state = 1},
  [240] = {.lex_state = 22, .external_lex_state = 1},
  [241] = {.lex_state = 22, .external_lex_state = 1},
  [242] = {.lex_state = 22, .external_lex_state = 1},
  [243] = {.lex_state = 1, .external_lex_state = 1},
  [244] = {.lex_state = 1, .external_lex_state = 1},
  [245] = {.lex_state = 1, .external_lex_state = 1},
  [246] = {.lex_state = 1, .external_lex_state = 1},
  [247] = {.lex_state = 1, .external_lex_state = 1},
  [248] = {.lex_state = 1, .external_lex_state = 1},
  [249] = {.lex_state = 1, .external_lex_state = 1},
  [250] = {.lex_state = 1, .external_lex_state = 1},
  [251] = {.lex_state = 1, .external_lex_state = 1},
  [252] = {.lex_state = 1, .external_lex_state = 1},
  [253] = {.lex_state = 1, .external_lex_state = 1},
  [254] = {.lex_state = 1, .external_lex_state = 1},
  [255] = {.lex_state = 1, .external_lex_state = 1},
  [256] = {.lex_state = 1, .external_lex_state = 1},
  [257] = {.lex_state = 1, .external_lex_state = 1},
  [258] = {.lex_state = 1, .external_lex_state = 1},
  [259] = {.lex_state = 1, .external_lex_state = 1},
  [260] = {.lex_state = 1, .external_lex_state = 1},
  [261] = {.lex_state = 1, .external_lex_state = 1},
  [262] = {.lex_state = 1, .external_lex_state = 1},
  [263] = {.lex_state = 1, .external_lex_state = 1},
  [264] = {.lex_state = 1, .external_lex_state = 1},
  [265] = {.lex_state = 1, .external_lex_state = 1},
  [266] = {.lex_state = 1, .external_lex_state = 1},
  [267] = {.lex_state = 1, .external_lex_state = 1},
  [268] = {.lex_state = 1, .external_lex_state = 1},
  [269] = {.lex_state = 1, .external_lex_state = 1},
  [270] = {.lex_state = 1, .external_lex_state = 1},
  [271] = {.lex_state = 1, .external_lex_state = 1},
  [272] = {.lex_state = 1, .external_lex_state = 1},
  [273] = {.lex_state = 1, .external_lex_state = 1},
  [274] = {.lex_state = 1, .external_lex_state = 1},
  [275] = {.lex_state = 1, .external_lex_state = 1},
  [276] = {.lex_state = 1, .external_lex_state = 1},
  [277] = {.lex_state = 1, .external_lex_state = 1},
  [278] = {.lex_state = 1, .external_lex_state = 1},
  [279] = {.lex_state = 1, .external_lex_state = 1},
  [280] = {.lex_state = 1, .external_lex_state = 1},
  [281] = {.lex_state = 1, .external_lex_state = 1},
  [282] = {.lex_state = 1, .external_lex_state = 1},
  [283] = {.lex_state = 1, .external_lex_state = 1},
  [284] = {.lex_state = 1, .external_lex_state = 1},
  [285] = {.lex_state = 1, .external_lex_state = 1},
  [286] = {.lex_state = 1, .external_lex_state = 1},
  [287] = {.lex_state = 1, .external_lex_state = 1},
  [288] = {.lex_state = 1, .external_lex_state = 1},
  [289] = {.lex_state = 1, .external_lex_state = 1},
  [290] = {.lex_state = 1, .external_lex_state = 1},
  [291] = {.lex_state = 1, .external_lex_state = 1},
  [292] = {.lex_state = 1, .external_lex_state = 1},
  [293] = {.lex_state = 1, .external_lex_state = 1},
  [294] = {.lex_state = 1, .external_lex_state = 1},
  [295] = {.lex_state = 1, .external_lex_state = 1},
  [296] = {.lex_state = 1, .external_lex_state = 1},
  [297] = {.lex_state = 1, .external_lex_state = 1},
  [298] = {.lex_state = 1, .external_lex_state = 1},
  [299] = {.lex_state = 1, .external_lex_state = 1},
  [300] = {.lex_state = 1, .external_lex_state = 1},
  [301] = {.lex_state = 1, .external_lex_state = 1},
  [302] = {.lex_state = 1, .external_lex_state = 1},
  [303] = {.lex_state = 2, .external_lex_state = 2},
  [304] = {.lex_state = 2, .external_lex_state = 2},
  [305] = {.lex_state = 2, .external_lex_state = 2},
  [306] = {.lex_state = 2, .external_lex_state = 2},
  [307] = {.lex_state = 2, .external_lex_state = 2},
  [308] = {.lex_state = 2, .external_lex_state = 2},
  [309] = {.lex_state = 2, .external_lex_state = 2},
  [310] = {.lex_state = 2, .external_lex_state = 2},
  [311] = {.lex_state = 2, .external_lex_state = 2},
  [312] = {.lex_state = 2, .external_lex_state = 2},
  [313] = {.lex_state = 22, .external_lex_state = 1},
  [314] = {.lex_state = 22, .external_lex_state = 1},
  [315] = {.lex_state = 22, .external_lex_state = 1},
  [316] = {.lex_state = 22, .external_lex_state = 1},
  [317] = {.lex_state = 22, .external_lex_state = 1},
  [318] = {.lex_state = 22, .external_lex_state = 1},
  [319] = {.lex_state = 22, .external_lex_state = 1},
  [320] = {.lex_state = 22, .external_lex_state = 1},
  [321] = {.lex_state = 22, .external_lex_state = 1},
  [322] = {.lex_state = 22, .external_lex_state = 1},
  [323] = {.lex_state = 22, .external_lex_state = 1},
  [324] = {.lex_state = 22, .external_lex_state = 1},
  [325] = {.lex_state = 22, .external_lex_state = 1},
  [326] = {.lex_state = 22, .external_lex_state = 1},
  [327] = {.lex_state = 22, .external_lex_state = 1},
  [328] = {.lex_state = 22, .external_lex_state = 1},
  [329] = {.lex_state = 22, .external_lex_state = 1},
  [330] = {.lex_state = 22, .external_lex_state = 1},
  [331] = {.lex_state = 22, .external_lex_state = 1},
  [332] = {.lex_state = 22, .external_lex_state = 1},
  [333] = {.lex_state = 22, .external_lex_state = 1},
  [334] = {.lex_state = 22, .external_lex_state = 1},
  [335] = {.lex_state = 22, .external_lex_state = 1},
  [336] = {.lex_state = 22, .external_lex_state = 1},
  [337] = {.lex_state = 22, .external_lex_state = 1},
  [338] = {.lex_state = 22, .external_lex_state = 1},
  [339] = {.lex_state = 22, .external_lex_state = 1},
  [340] = {.lex_state = 22, .external_lex_state = 1},
  [341] = {.lex_state = 22, .external_lex_state = 1},
  [342] = {.lex_state = 22, .external_lex_state = 1},
  [343] = {.lex_state = 22, .external_lex_state = 1},
  [344] = {.lex_state = 22, .external_lex_state = 1},
  [345] = {.lex_state = 22, .external_lex_state = 1},
  [346] = {.lex_state = 22, .external_lex_state = 1},
  [347] = {.lex_state = 22, .external_lex_state = 1},
  [348] = {.lex_state = 22, .external_lex_state = 1},
  [349] = {.lex_state = 22, .external_lex_state = 1},
  [350] = {.lex_state = 22, .external_lex_state = 1},
  [351] = {.lex_state = 22, .external_lex_state = 1},
  [352] = {.lex_state = 22, .external_lex_state = 1},
  [353] = {.lex_state = 22, .external_lex_state = 1},
  [354] = {.lex_state = 22, .external_lex_state = 1},
  [355] = {.lex_state = 22, .external_lex_state = 1},
  [356] = {.lex_state = 22, .external_lex_state = 1},
  [357] = {.lex_state = 22, .external_lex_state = 1},
  [358] = {.lex_state = 22, .external_lex_state = 1},
  [359] = {.lex_state = 22, .external_lex_state = 1},
  [360] = {.lex_state = 22, .external_lex_state = 1},
  [361] = {.lex_state = 22, .external_lex_state = 1},
  [362] = {.lex_state = 22, .external_lex_state = 1},
  [363] = {.lex_state = 22, .external_lex_state = 1},
  [364] = {.lex_state = 22, .external_lex_state = 1},
  [365] = {.lex_state = 22, .external_lex_state = 1},
  [366] = {.lex_state = 22, .external_lex_state = 1},
  [367] = {.lex_state = 22, .external_lex_state = 1},
  [368] = {.lex_state = 22, .external_lex_state = 1},
  [369] = {.lex_state = 22, .external_lex_state = 1},
  [370] = {.lex_state = 22, .external_lex_state = 1},
  [371] = {.lex_state = 22, .external_lex_state = 1},
  [372] = {.lex_state = 22, .external_lex_state = 1},
  [373] = {.lex_state = 22, .external_lex_state = 1},
  [374] = {.lex_state = 22, .external_lex_state = 1},
  [375] = {.lex_state = 22, .external_lex_state = 1},
  [376] = {.lex_state = 22, .external_lex_state = 1},
  [377] = {.lex_state = 22, .external_lex_state = 1},
  [378] = {.lex_state = 22, .external_lex_state = 1},
  [379] = {.lex_state = 22, .external_lex_state = 1},
  [380] = {.lex_state = 22, .external_lex_state = 1},
  [381] = {.lex_state = 22, .external_lex_state = 1},
  [382] = {.lex_state = 22, .external_lex_state = 1},
  [383] = {.lex_state = 22, .external_lex_state = 1},
  [384] = {.lex_state = 22, .external_lex_state = 1},
  [385] = {.lex_state = 22, .external_lex_state = 1},
  [386] = {.lex_state = 22, .external_lex_state = 1},
  [387] = {.lex_state = 22, .external_lex_state = 1},
  [388] = {.lex_state = 22, .external_lex_state = 1},
  [389] = {.lex_state = 22, .external_lex_state = 1},
  [390] = {.lex_state = 22, .external_lex_state = 1},
  [391] = {.lex_state = 22, .external_lex_state = 1},
  [392] = {.lex_state = 22, .external_lex_state = 1},
  [393] = {.lex_state = 22, .external_lex_state = 1},
  [394] = {.lex_state = 22, .external_lex_state = 1},
  [395] = {.lex_state = 22, .external_lex_state = 1},
  [396] = {.lex_state = 22, .external_lex_state = 1},
  [397] = {.lex_state = 22, .external_lex_state = 1},
  [398] = {.lex_state = 22, .external_lex_state = 1},
  [399] = {.lex_state = 22, .external_lex_state = 1},
  [400] = {.lex_state = 22, .external_lex_state = 1},
  [401] = {.lex_state = 22, .external_lex_state = 1},
  [402] = {.lex_state = 22, .external_lex_state = 1},
  [403] = {.lex_state = 22, .external_lex_state = 1},
  [404] = {.lex_state = 22, .external_lex_state = 1},
  [405] = {.lex_state = 22, .external_lex_state = 1},
  [406] = {.lex_state = 22, .external_lex_state = 1},
  [407] = {.lex_state = 22, .external_lex_state = 1},
  [408] = {.lex_state = 22, .external_lex_state = 1},
  [409] = {.lex_state = 22, .external_lex_state = 1},
  [410] = {.lex_state = 22, .external_lex_state = 1},
  [411] = {.lex_state = 22, .external_lex_state = 1},
  [412] = {.lex_state = 22, .external_lex_state = 1},
  [413] = {.lex_state = 22, .external_lex_state = 1},
  [414] = {.lex_state = 22, .external_lex_state = 1},
  [415] = {.lex_state = 22, .external_lex_state = 1},
  [416] = {.lex_state = 22, .external_lex_state = 1},
  [417] = {.lex_state = 22, .external_lex_state = 1},
  [418] = {.lex_state = 22, .external_lex_state = 1},
  [419] = {.lex_state = 22, .external_lex_state = 1},
  [420] = {.lex_state = 22, .external_lex_state = 1},
  [421] = {.lex_state = 22, .external_lex_state = 1},
  [422] = {.lex_state = 22, .external_lex_state = 1},
  [423] = {.lex_state = 22, .external_lex_state = 1},
  [424] = {.lex_state = 22, .external_lex_state = 1},
  [425] = {.lex_state = 22, .external_lex_state = 1},
  [426] = {.lex_state = 22, .external_lex_state = 1},
  [427] = {.lex_state = 22, .external_lex_state = 1},
  [428] = {.lex_state = 22, .external_lex_state = 1},
  [429] = {.lex_state = 22, .external_lex_state = 1},
  [430] = {.lex_state = 22, .external_lex_state = 1},
  [431] = {.lex_state = 22, .external_lex_state = 1},
  [432] = {.lex_state = 22, .external_lex_state = 1},
  [433] = {.lex_state = 22, .external_lex_state = 1},
  [434] = {.lex_state = 22, .external_lex_state = 1},
  [435] = {.lex_state = 22, .external_lex_state = 1},
  [436] = {.lex_state = 22, .external_lex_state = 1},
  [437] = {.lex_state = 22, .external_lex_state = 1},
  [438] = {.lex_state = 22, .external_lex_state = 1},
  [439] = {.lex_state = 22, .external_lex_state = 1},
  [440] = {.lex_state = 22, .external_lex_state = 1},
  [441] = {.lex_state = 22, .external_lex_state = 1},
  [442] = {.lex_state = 22, .external_lex_state = 1},
  [443] = {.lex_state = 22, .external_lex_state = 1},
  [444] = {.lex_state = 22, .external_lex_state = 1},
  [445] = {.lex_state = 22, .external_lex_state = 1},
  [446] = {.lex_state = 22, .external_lex_state = 1},
  [447] = {.lex_state = 22, .external_lex_state = 1},
  [448] = {.lex_state = 22, .external_lex_state = 1},
  [449] = {.lex_state = 22, .external_lex_state = 1},
  [450] = {.lex_state = 22, .external_lex_state = 1},
  [451] = {.lex_state = 22, .external_lex_state = 1},
  [452] = {.lex_state = 22, .external_lex_state = 1},
  [453] = {.lex_state = 22, .external_lex_state = 1},
  [454] = {.lex_state = 22, .external_lex_state = 1},
  [455] = {.lex_state = 22, .external_lex_state = 1},
  [456] = {.lex_state = 22, .external_lex_state = 1},
  [457] = {.lex_state = 22, .external_lex_state = 1},
  [458] = {.lex_state = 22, .external_lex_state = 1},
  [459] = {.lex_state = 22, .external_lex_state = 1},
  [460] = {.lex_state = 22, .external_lex_state = 1},
  [461] = {.lex_state = 22, .external_lex_state = 1},
  [462] = {.lex_state = 22, .external_lex_state = 1},
  [463] = {.lex_state = 22, .external_lex_state = 1},
  [464] = {.lex_state = 22, .external_lex_state = 1},
  [465] = {.lex_state = 22, .external_lex_state = 1},
  [466] = {.lex_state = 22, .external_lex_state = 1},
  [467] = {.lex_state = 22, .external_lex_state = 1},
  [468] = {.lex_state = 22, .external_lex_state = 1},
  [469] = {.lex_state = 22, .external_lex_state = 1},
  [470] = {.lex_state = 22, .external_lex_state = 1},
  [471] = {.lex_state = 22, .external_lex_state = 1},
  [472] = {.lex_state = 22, .external_lex_state = 1},
  [473] = {.lex_state = 22, .external_lex_state = 1},
  [474] = {.lex_state = 22, .external_lex_state = 1},
  [475] = {.lex_state = 22, .external_lex_state = 1},
  [476] = {.lex_state = 22, .external_lex_state = 1},
  [477] = {.lex_state = 22, .external_lex_state = 1},
  [478] = {.lex_state = 22, .external_lex_state = 1},
  [479] = {.lex_state = 22, .external_lex_state = 1},
  [480] = {.lex_state = 22, .external_lex_state = 1},
  [481] = {.lex_state = 2, .external_lex_state = 2},
  [482] = {.lex_state = 2},
  [483] = {.lex_state = 2},
  [484] = {.lex_state = 2},
  [485] = {.lex_state = 2},
  [486] = {.lex_state = 2},
  [487] = {.lex_state = 2},
  [488] = {.lex_state = 2},
  [489] = {.lex_state = 2},
  [490] = {.lex_state = 2},
  [491] = {.lex_state = 2},
  [492] = {.lex_state = 2},
  [493] = {.lex_state = 2},
  [494] = {.lex_state = 2},
  [495] = {.lex_state = 2},
  [496] = {.lex_state = 2},
  [497] = {.lex_state = 2, .external_lex_state = 2},
  [498] = {.lex_state = 2, .external_lex_state = 2},
  [499] = {.lex_state = 2, .external_lex_state = 2},
  [500] = {.lex_state = 2, .external_lex_state = 2},
  [501] = {.lex_state = 2, .external_lex_state = 2},
  [502] = {.lex_state = 2, .external_lex_state = 2},
  [503] = {.lex_state = 2, .external_lex_state = 2},
  [504] = {.lex_state = 2, .external_lex_state = 2},
  [505] = {.lex_state = 2, .external_lex_state = 2},
  [506] = {.lex_state = 2, .external_lex_state = 2},
  [507] = {.lex_state = 2, .external_lex_state = 2},
  [508] = {.lex_state = 2, .external_lex_state = 2},
  [509] = {.lex_state = 2, .external_lex_state = 2},
  [510] = {.lex_state = 2, .external_lex_state = 2},
  [511] = {.lex_state = 2, .external_lex_state = 2},
  [512] = {.lex_state = 2, .external_lex_state = 2},
  [513] = {.lex_state = 2, .external_lex_state = 2},
  [514] = {.lex_state = 2, .external_lex_state = 2},
  [515] = {.lex_state = 2, .external_lex_state = 2},
  [516] = {.lex_state = 2, .external_lex_state = 2},
  [517] = {.lex_state = 2, .external_lex_state = 2},
  [518] = {.lex_state = 2, .external_lex_state = 2},
  [519] = {.lex_state = 2, .external_lex_state = 2},
  [520] = {.lex_state = 2, .external_lex_state = 2},
  [521] = {.lex_state = 2, .external_lex_state = 2},
  [522] = {.lex_state = 2, .external_lex_state = 2},
  [523] = {.lex_state = 2, .external_lex_state = 2},
  [524] = {.lex_state = 2, .external_lex_state = 2},
  [525] = {.lex_state = 2, .external_lex_state = 2},
  [526] = {.lex_state = 2, .external_lex_state = 2},
  [527] = {.lex_state = 2, .external_lex_state = 2},
  [528] = {.lex_state = 2, .external_lex_state = 2},
  [529] = {.lex_state = 2, .external_lex_state = 2},
  [530] = {.lex_state = 2, .external_lex_state = 2},
  [531] = {.lex_state = 2, .external_lex_state = 2},
  [532] = {.lex_state = 2, .external_lex_state = 2},
  [533] = {.lex_state = 2, .external_lex_state = 2},
  [534] = {.lex_state = 2, .external_lex_state = 2},
  [535] = {.lex_state = 2, .external_lex_state = 2},
  [536] = {.lex_state = 2, .external_lex_state = 2},
  [537] = {.lex_state = 2, .external_lex_state = 2},
  [538] = {.lex_state = 2, .external_lex_state = 2},
  [539] = {.lex_state = 2, .external_lex_state = 2},
  [540] = {.lex_state = 2, .external_lex_state = 2},
  [541] = {.lex_state = 2, .external_lex_state = 2},
  [542] = {.lex_state = 2, .external_lex_state = 2},
  [543] = {.lex_state = 2, .external_lex_state = 2},
  [544] = {.lex_state = 2, .external_lex_state = 2},
  [545] = {.lex_state = 2, .external_lex_state = 2},
  [546] = {.lex_state = 2, .external_lex_state = 2},
  [547] = {.lex_state = 2, .external_lex_state = 2},
  [548] = {.lex_state = 2, .external_lex_state = 2},
  [549] = {.lex_state = 2, .external_lex_state = 2},
  [550] = {.lex_state = 2, .external_lex_state = 2},
  [551] = {.lex_state = 2, .external_lex_state = 2},
  [552] = {.lex_state = 2, .external_lex_state = 2},
  [553] = {.lex_state = 2, .external_lex_state = 2},
  [554] = {.lex_state = 2, .external_lex_state = 2},
  [555] = {.lex_state = 2, .external_lex_state = 2},
  [556] = {.lex_state = 2, .external_lex_state = 2},
  [557] = {.lex_state = 2, .external_lex_state = 2},
  [558] = {.lex_state = 2},
  [559] = {.lex_state = 2},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 0},
  [563] = {.lex_state = 0},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 0},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 0},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 0},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 0},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 0},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 0},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 0},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 0},
  [640] = {.lex_state = 0},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 0},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 0},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 0},
  [673] = {.lex_state = 0},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 0},
  [677] = {.lex_state = 0},
  [678] = {.lex_state = 0},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 0},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 0},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 0},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 0},
  [693] = {.lex_state = 0},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 0},
};

enum {
  ts_external_token__long_str = 0,
  ts_external_token__long_buffer = 1,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__long_str] = sym__long_str,
  [ts_external_token__long_buffer] = sym__long_buffer,
};

static const bool ts_external_scanner_states[3][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__long_str] = true,
    [ts_external_token__long_buffer] = true,
  },
  [2] = {
    [ts_external_token__long_str] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_symbol] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_AT_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_AT_LBRACE] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_splice] = ACTIONS(1),
    [anon_sym_quasiquote] = ACTIONS(1),
    [anon_sym_unquote] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_upscope] = ACTIONS(1),
    [sym_variadic_marker] = ACTIONS(1),
    [sym_optional_marker] = ACTIONS(1),
    [sym_keys_marker] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_defn] = ACTIONS(1),
    [anon_sym_defn_DASH] = ACTIONS(1),
    [anon_sym_varfn] = ACTIONS(1),
    [anon_sym_varfn_DASH] = ACTIONS(1),
    [anon_sym_defmacro] = ACTIONS(1),
    [anon_sym_defmacro_DASH] = ACTIONS(1),
    [sym_str_literal] = ACTIONS(1),
    [sym_buffer_literal] = ACTIONS(1),
    [aux_sym_number_literal_token1] = ACTIONS(1),
    [aux_sym_number_literal_token2] = ACTIONS(1),
    [aux_sym_number_literal_token3] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_nil_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_keyword] = ACTIONS(1),
    [sym__long_str] = ACTIONS(1),
    [sym__long_buffer] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(689),
    [sym__expr] = STATE(139),
    [sym_tuple] = STATE(404),
    [sym_sqr_tuple] = STATE(404),
    [sym_array] = STATE(404),
    [sym_sqr_array] = STATE(404),
    [sym_struct] = STATE(404),
    [sym_table] = STATE(404),
    [sym_peg_set] = STATE(404),
    [sym__special_forms] = STATE(404),
    [sym_def] = STATE(432),
    [sym_var] = STATE(432),
    [sym_quote] = STATE(432),
    [sym_splice] = STATE(432),
    [sym_quasiquote] = STATE(432),
    [sym_unquote] = STATE(432),
    [sym_break] = STATE(432),
    [sym_set] = STATE(432),
    [sym_if] = STATE(432),
    [sym_do] = STATE(432),
    [sym_while] = STATE(432),
    [sym_fn] = STATE(432),
    [sym_upscope] = STATE(432),
    [sym__shorthand] = STATE(404),
    [sym_short_quote] = STATE(437),
    [sym_short_splice] = STATE(437),
    [sym_short_quasiquote] = STATE(437),
    [sym_short_unquote] = STATE(437),
    [sym_short_fn] = STATE(437),
    [sym__specials] = STATE(404),
    [sym_extra_defs] = STATE(451),
    [sym__literals] = STATE(404),
    [sym_long_str_literal] = STATE(386),
    [sym_long_buffer_literal] = STATE(386),
    [sym_number_literal] = STATE(386),
    [sym_bool_literal] = STATE(386),
    [sym__identifier] = STATE(404),
    [aux_sym_source_file_repeat1] = STATE(139),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [2] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(124),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(61),
    [anon_sym_def] = ACTIONS(63),
    [anon_sym_var] = ACTIONS(65),
    [anon_sym_quote] = ACTIONS(67),
    [anon_sym_splice] = ACTIONS(69),
    [anon_sym_quasiquote] = ACTIONS(71),
    [anon_sym_unquote] = ACTIONS(73),
    [anon_sym_break] = ACTIONS(75),
    [anon_sym_if] = ACTIONS(77),
    [anon_sym_do] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_fn] = ACTIONS(83),
    [anon_sym_upscope] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(97),
    [anon_sym_defn_DASH] = ACTIONS(97),
    [anon_sym_varfn] = ACTIONS(97),
    [anon_sym_varfn_DASH] = ACTIONS(97),
    [anon_sym_defmacro] = ACTIONS(97),
    [anon_sym_defmacro_DASH] = ACTIONS(97),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [3] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(115),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(115),
    [anon_sym_def] = ACTIONS(117),
    [anon_sym_var] = ACTIONS(119),
    [anon_sym_quote] = ACTIONS(121),
    [anon_sym_splice] = ACTIONS(123),
    [anon_sym_quasiquote] = ACTIONS(125),
    [anon_sym_unquote] = ACTIONS(127),
    [anon_sym_break] = ACTIONS(129),
    [anon_sym_if] = ACTIONS(131),
    [anon_sym_do] = ACTIONS(133),
    [anon_sym_while] = ACTIONS(135),
    [anon_sym_fn] = ACTIONS(137),
    [anon_sym_upscope] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(141),
    [anon_sym_defn_DASH] = ACTIONS(141),
    [anon_sym_varfn] = ACTIONS(141),
    [anon_sym_varfn_DASH] = ACTIONS(141),
    [anon_sym_defmacro] = ACTIONS(141),
    [anon_sym_defmacro_DASH] = ACTIONS(141),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [4] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(126),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(145),
    [anon_sym_def] = ACTIONS(147),
    [anon_sym_var] = ACTIONS(149),
    [anon_sym_quote] = ACTIONS(151),
    [anon_sym_splice] = ACTIONS(153),
    [anon_sym_quasiquote] = ACTIONS(155),
    [anon_sym_unquote] = ACTIONS(157),
    [anon_sym_break] = ACTIONS(159),
    [anon_sym_if] = ACTIONS(161),
    [anon_sym_do] = ACTIONS(163),
    [anon_sym_while] = ACTIONS(165),
    [anon_sym_fn] = ACTIONS(167),
    [anon_sym_upscope] = ACTIONS(169),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(171),
    [anon_sym_defn_DASH] = ACTIONS(171),
    [anon_sym_varfn] = ACTIONS(171),
    [anon_sym_varfn_DASH] = ACTIONS(171),
    [anon_sym_defmacro] = ACTIONS(171),
    [anon_sym_defmacro_DASH] = ACTIONS(171),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [5] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(134),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(177),
    [anon_sym_var] = ACTIONS(179),
    [anon_sym_quote] = ACTIONS(181),
    [anon_sym_splice] = ACTIONS(183),
    [anon_sym_quasiquote] = ACTIONS(185),
    [anon_sym_unquote] = ACTIONS(187),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_fn] = ACTIONS(197),
    [anon_sym_upscope] = ACTIONS(199),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(201),
    [anon_sym_defn_DASH] = ACTIONS(201),
    [anon_sym_varfn] = ACTIONS(201),
    [anon_sym_varfn_DASH] = ACTIONS(201),
    [anon_sym_defmacro] = ACTIONS(201),
    [anon_sym_defmacro_DASH] = ACTIONS(201),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [6] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(75),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(203),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(205),
    [anon_sym_def] = ACTIONS(207),
    [anon_sym_var] = ACTIONS(209),
    [anon_sym_quote] = ACTIONS(211),
    [anon_sym_splice] = ACTIONS(213),
    [anon_sym_quasiquote] = ACTIONS(215),
    [anon_sym_unquote] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(219),
    [anon_sym_if] = ACTIONS(221),
    [anon_sym_do] = ACTIONS(223),
    [anon_sym_while] = ACTIONS(225),
    [anon_sym_fn] = ACTIONS(227),
    [anon_sym_upscope] = ACTIONS(229),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(231),
    [anon_sym_defn_DASH] = ACTIONS(231),
    [anon_sym_varfn] = ACTIONS(231),
    [anon_sym_varfn_DASH] = ACTIONS(231),
    [anon_sym_defmacro] = ACTIONS(231),
    [anon_sym_defmacro_DASH] = ACTIONS(231),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [7] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(134),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_set] = ACTIONS(175),
    [anon_sym_def] = ACTIONS(177),
    [anon_sym_var] = ACTIONS(179),
    [anon_sym_quote] = ACTIONS(211),
    [anon_sym_splice] = ACTIONS(213),
    [anon_sym_quasiquote] = ACTIONS(215),
    [anon_sym_unquote] = ACTIONS(217),
    [anon_sym_break] = ACTIONS(189),
    [anon_sym_if] = ACTIONS(191),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_while] = ACTIONS(195),
    [anon_sym_fn] = ACTIONS(197),
    [anon_sym_upscope] = ACTIONS(199),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_defn] = ACTIONS(201),
    [anon_sym_defn_DASH] = ACTIONS(201),
    [anon_sym_varfn] = ACTIONS(201),
    [anon_sym_varfn_DASH] = ACTIONS(201),
    [anon_sym_defmacro] = ACTIONS(201),
    [anon_sym_defmacro_DASH] = ACTIONS(201),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [8] = {
    [sym__expr] = STATE(250),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [aux_sym_parameters_repeat1] = STATE(12),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_quote] = ACTIONS(211),
    [anon_sym_splice] = ACTIONS(213),
    [anon_sym_quasiquote] = ACTIONS(215),
    [anon_sym_unquote] = ACTIONS(217),
    [sym_variadic_marker] = ACTIONS(249),
    [sym_optional_marker] = ACTIONS(249),
    [sym_keys_marker] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [9] = {
    [sym__expr] = STATE(250),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(275),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(278),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(283),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(286),
    [anon_sym_AT_LBRACK] = ACTIONS(289),
    [anon_sym_LBRACE] = ACTIONS(292),
    [anon_sym_AT_LBRACE] = ACTIONS(295),
    [sym_variadic_marker] = ACTIONS(298),
    [sym_optional_marker] = ACTIONS(298),
    [sym_keys_marker] = ACTIONS(298),
    [anon_sym_SQUOTE] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(303),
    [anon_sym_TILDE] = ACTIONS(306),
    [anon_sym_COMMA] = ACTIONS(309),
    [anon_sym_PIPE] = ACTIONS(312),
    [sym_str_literal] = ACTIONS(315),
    [sym_buffer_literal] = ACTIONS(315),
    [aux_sym_number_literal_token1] = ACTIONS(318),
    [aux_sym_number_literal_token2] = ACTIONS(318),
    [aux_sym_number_literal_token3] = ACTIONS(318),
    [anon_sym_true] = ACTIONS(321),
    [anon_sym_false] = ACTIONS(321),
    [sym_nil_literal] = ACTIONS(324),
    [sym_keyword] = ACTIONS(327),
    [sym__long_str] = ACTIONS(330),
    [sym__long_buffer] = ACTIONS(333),
  },
  [10] = {
    [sym__expr] = STATE(250),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(336),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(338),
    [sym_optional_marker] = ACTIONS(340),
    [sym_keys_marker] = ACTIONS(342),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [11] = {
    [sym__expr] = STATE(250),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [aux_sym_parameters_repeat1] = STATE(10),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_RBRACK] = ACTIONS(344),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(346),
    [sym_optional_marker] = ACTIONS(346),
    [sym_keys_marker] = ACTIONS(346),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [12] = {
    [sym__expr] = STATE(250),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [aux_sym_parameters_repeat1] = STATE(9),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_RPAREN] = ACTIONS(348),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [sym_variadic_marker] = ACTIONS(350),
    [sym_optional_marker] = ACTIONS(352),
    [sym_keys_marker] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [13] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(356),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [14] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(579),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(358),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [15] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(637),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(360),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [16] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(631),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(362),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [17] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(364),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [18] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(366),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [19] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(625),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [20] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(597),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(370),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [21] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(372),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [22] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(622),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(374),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [23] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(376),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(281),
    [anon_sym_LBRACK] = ACTIONS(382),
    [anon_sym_RBRACK] = ACTIONS(281),
    [anon_sym_AT_LPAREN] = ACTIONS(385),
    [anon_sym_AT_LBRACK] = ACTIONS(388),
    [anon_sym_LBRACE] = ACTIONS(391),
    [anon_sym_AT_LBRACE] = ACTIONS(394),
    [anon_sym_SQUOTE] = ACTIONS(397),
    [anon_sym_SEMI] = ACTIONS(400),
    [anon_sym_TILDE] = ACTIONS(403),
    [anon_sym_COMMA] = ACTIONS(406),
    [anon_sym_PIPE] = ACTIONS(409),
    [sym_str_literal] = ACTIONS(412),
    [sym_buffer_literal] = ACTIONS(412),
    [aux_sym_number_literal_token1] = ACTIONS(415),
    [aux_sym_number_literal_token2] = ACTIONS(415),
    [aux_sym_number_literal_token3] = ACTIONS(415),
    [anon_sym_true] = ACTIONS(418),
    [anon_sym_false] = ACTIONS(418),
    [sym_nil_literal] = ACTIONS(421),
    [sym_keyword] = ACTIONS(424),
    [sym__long_str] = ACTIONS(427),
    [sym__long_buffer] = ACTIONS(430),
  },
  [24] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(17),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(433),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [25] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(18),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(435),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [26] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(687),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(437),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [27] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(601),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(439),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [28] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(594),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [29] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(592),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(443),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [30] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(591),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(445),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [31] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(585),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [32] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(449),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [33] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(688),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [34] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(678),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(453),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [35] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(699),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [36] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [37] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(570),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [38] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(698),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(461),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [39] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(577),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [40] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(53),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(465),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [41] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(576),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [42] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(32),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(469),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [43] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(13),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [44] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(51),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [45] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(694),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [46] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(36),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [47] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(48),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(479),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [48] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(481),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [49] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(21),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [50] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [51] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [52] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [53] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [54] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(561),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [55] = {
    [sym__expr] = STATE(235),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym__struct_tables_commom] = STATE(473),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_struct_repeat1] = STATE(55),
    [sym_symbol] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(498),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_AT_LPAREN] = ACTIONS(504),
    [anon_sym_AT_LBRACK] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(510),
    [anon_sym_RBRACE] = ACTIONS(513),
    [anon_sym_AT_LBRACE] = ACTIONS(515),
    [anon_sym_SQUOTE] = ACTIONS(518),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_TILDE] = ACTIONS(524),
    [anon_sym_COMMA] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(530),
    [sym_str_literal] = ACTIONS(533),
    [sym_buffer_literal] = ACTIONS(533),
    [aux_sym_number_literal_token1] = ACTIONS(536),
    [aux_sym_number_literal_token2] = ACTIONS(536),
    [aux_sym_number_literal_token3] = ACTIONS(536),
    [anon_sym_true] = ACTIONS(539),
    [anon_sym_false] = ACTIONS(539),
    [sym_nil_literal] = ACTIONS(542),
    [sym_keyword] = ACTIONS(545),
    [sym__long_str] = ACTIONS(548),
    [sym__long_buffer] = ACTIONS(551),
  },
  [56] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(560),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(554),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [57] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(605),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [58] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(606),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(558),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [59] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(562),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(560),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [60] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(562),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(568),
    [anon_sym_LBRACK] = ACTIONS(570),
    [anon_sym_RBRACK] = ACTIONS(568),
    [anon_sym_AT_LPAREN] = ACTIONS(573),
    [anon_sym_AT_LBRACK] = ACTIONS(576),
    [anon_sym_LBRACE] = ACTIONS(579),
    [anon_sym_AT_LBRACE] = ACTIONS(582),
    [anon_sym_SQUOTE] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(588),
    [anon_sym_TILDE] = ACTIONS(591),
    [anon_sym_COMMA] = ACTIONS(594),
    [anon_sym_PIPE] = ACTIONS(597),
    [sym_str_literal] = ACTIONS(600),
    [sym_buffer_literal] = ACTIONS(600),
    [aux_sym_number_literal_token1] = ACTIONS(603),
    [aux_sym_number_literal_token2] = ACTIONS(603),
    [aux_sym_number_literal_token3] = ACTIONS(603),
    [anon_sym_true] = ACTIONS(606),
    [anon_sym_false] = ACTIONS(606),
    [sym_nil_literal] = ACTIONS(609),
    [sym_keyword] = ACTIONS(612),
    [sym__long_str] = ACTIONS(615),
    [sym__long_buffer] = ACTIONS(618),
  },
  [61] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(638),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(621),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [62] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(640),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(623),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [63] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(566),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [64] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(595),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(627),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [65] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym_body] = STATE(596),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(629),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [66] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(631),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [67] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(122),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(633),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [68] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(635),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [69] = {
    [sym__expr] = STATE(628),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(142),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [70] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(665),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [71] = {
    [sym__expr] = STATE(627),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(140),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [72] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(667),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [73] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(669),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [74] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(671),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [75] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(673),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [76] = {
    [sym__expr] = STATE(76),
    [sym_tuple] = STATE(404),
    [sym_sqr_tuple] = STATE(404),
    [sym_array] = STATE(404),
    [sym_sqr_array] = STATE(404),
    [sym_struct] = STATE(404),
    [sym_table] = STATE(404),
    [sym_peg_set] = STATE(404),
    [sym__special_forms] = STATE(404),
    [sym_def] = STATE(432),
    [sym_var] = STATE(432),
    [sym_quote] = STATE(432),
    [sym_splice] = STATE(432),
    [sym_quasiquote] = STATE(432),
    [sym_unquote] = STATE(432),
    [sym_break] = STATE(432),
    [sym_set] = STATE(432),
    [sym_if] = STATE(432),
    [sym_do] = STATE(432),
    [sym_while] = STATE(432),
    [sym_fn] = STATE(432),
    [sym_upscope] = STATE(432),
    [sym__shorthand] = STATE(404),
    [sym_short_quote] = STATE(437),
    [sym_short_splice] = STATE(437),
    [sym_short_quasiquote] = STATE(437),
    [sym_short_unquote] = STATE(437),
    [sym_short_fn] = STATE(437),
    [sym__specials] = STATE(404),
    [sym_extra_defs] = STATE(451),
    [sym__literals] = STATE(404),
    [sym_long_str_literal] = STATE(386),
    [sym_long_buffer_literal] = STATE(386),
    [sym_number_literal] = STATE(386),
    [sym_bool_literal] = STATE(386),
    [sym__identifier] = STATE(404),
    [aux_sym_source_file_repeat1] = STATE(76),
    [ts_builtin_sym_end] = ACTIONS(675),
    [sym_symbol] = ACTIONS(677),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(680),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_AT_LPAREN] = ACTIONS(686),
    [anon_sym_AT_LBRACK] = ACTIONS(689),
    [anon_sym_LBRACE] = ACTIONS(692),
    [anon_sym_AT_LBRACE] = ACTIONS(695),
    [anon_sym_SQUOTE] = ACTIONS(698),
    [anon_sym_SEMI] = ACTIONS(701),
    [anon_sym_TILDE] = ACTIONS(704),
    [anon_sym_COMMA] = ACTIONS(707),
    [anon_sym_PIPE] = ACTIONS(710),
    [sym_str_literal] = ACTIONS(713),
    [sym_buffer_literal] = ACTIONS(713),
    [aux_sym_number_literal_token1] = ACTIONS(716),
    [aux_sym_number_literal_token2] = ACTIONS(716),
    [aux_sym_number_literal_token3] = ACTIONS(716),
    [anon_sym_true] = ACTIONS(719),
    [anon_sym_false] = ACTIONS(719),
    [sym_nil_literal] = ACTIONS(722),
    [sym_keyword] = ACTIONS(725),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(731),
  },
  [77] = {
    [sym__expr] = STATE(589),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [78] = {
    [sym__expr] = STATE(588),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [79] = {
    [sym__expr] = STATE(582),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(77),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [80] = {
    [sym__expr] = STATE(581),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(78),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [81] = {
    [sym__expr] = STATE(696),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(109),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [82] = {
    [sym__expr] = STATE(695),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(111),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [83] = {
    [sym__expr] = STATE(564),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [84] = {
    [sym__expr] = STATE(565),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [85] = {
    [sym__expr] = STATE(567),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(83),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [86] = {
    [sym__expr] = STATE(568),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(84),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [87] = {
    [sym__expr] = STATE(599),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [88] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(72),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(734),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [89] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(73),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(736),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [90] = {
    [sym__expr] = STATE(600),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [91] = {
    [sym__expr] = STATE(602),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(87),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [92] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(74),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(738),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [93] = {
    [sym__expr] = STATE(603),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(90),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [94] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(740),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [95] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(121),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(742),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [96] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(68),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [97] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(70),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(746),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [98] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(117),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(748),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [99] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(120),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(750),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [100] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(133),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(752),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [101] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(103),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(754),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [102] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [103] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(758),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [104] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(102),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(760),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [105] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(762),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [106] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(129),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(764),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [107] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(130),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(766),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [108] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(132),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(768),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [109] = {
    [sym__expr] = STATE(692),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [110] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(770),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [111] = {
    [sym__expr] = STATE(691),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [112] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(113),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(772),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [113] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(774),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [114] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(776),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [115] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(778),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [116] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [117] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(782),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [118] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(784),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [119] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(786),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(789),
    [anon_sym_RPAREN] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(794),
    [anon_sym_AT_LPAREN] = ACTIONS(797),
    [anon_sym_AT_LBRACK] = ACTIONS(800),
    [anon_sym_LBRACE] = ACTIONS(803),
    [anon_sym_AT_LBRACE] = ACTIONS(806),
    [anon_sym_SQUOTE] = ACTIONS(809),
    [anon_sym_SEMI] = ACTIONS(812),
    [anon_sym_TILDE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(818),
    [anon_sym_PIPE] = ACTIONS(821),
    [sym_str_literal] = ACTIONS(824),
    [sym_buffer_literal] = ACTIONS(824),
    [aux_sym_number_literal_token1] = ACTIONS(827),
    [aux_sym_number_literal_token2] = ACTIONS(827),
    [aux_sym_number_literal_token3] = ACTIONS(827),
    [anon_sym_true] = ACTIONS(830),
    [anon_sym_false] = ACTIONS(830),
    [sym_nil_literal] = ACTIONS(833),
    [sym_keyword] = ACTIONS(836),
    [sym__long_str] = ACTIONS(839),
    [sym__long_buffer] = ACTIONS(842),
  },
  [120] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(845),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [121] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(847),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [122] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(849),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [123] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(147),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(851),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [124] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(853),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [125] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(855),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [126] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [127] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(146),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(859),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [128] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [129] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [130] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(865),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [131] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(867),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [132] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(869),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [133] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(871),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [134] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(60),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [135] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(105),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(875),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [136] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(110),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [137] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(143),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [138] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_tuple_repeat1] = STATE(114),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [139] = {
    [sym__expr] = STATE(76),
    [sym_tuple] = STATE(404),
    [sym_sqr_tuple] = STATE(404),
    [sym_array] = STATE(404),
    [sym_sqr_array] = STATE(404),
    [sym_struct] = STATE(404),
    [sym_table] = STATE(404),
    [sym_peg_set] = STATE(404),
    [sym__special_forms] = STATE(404),
    [sym_def] = STATE(432),
    [sym_var] = STATE(432),
    [sym_quote] = STATE(432),
    [sym_splice] = STATE(432),
    [sym_quasiquote] = STATE(432),
    [sym_unquote] = STATE(432),
    [sym_break] = STATE(432),
    [sym_set] = STATE(432),
    [sym_if] = STATE(432),
    [sym_do] = STATE(432),
    [sym_while] = STATE(432),
    [sym_fn] = STATE(432),
    [sym_upscope] = STATE(432),
    [sym__shorthand] = STATE(404),
    [sym_short_quote] = STATE(437),
    [sym_short_splice] = STATE(437),
    [sym_short_quasiquote] = STATE(437),
    [sym_short_unquote] = STATE(437),
    [sym_short_fn] = STATE(437),
    [sym__specials] = STATE(404),
    [sym_extra_defs] = STATE(451),
    [sym__literals] = STATE(404),
    [sym_long_str_literal] = STATE(386),
    [sym_long_buffer_literal] = STATE(386),
    [sym_number_literal] = STATE(386),
    [sym_bool_literal] = STATE(386),
    [sym__identifier] = STATE(404),
    [aux_sym_source_file_repeat1] = STATE(76),
    [ts_builtin_sym_end] = ACTIONS(883),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [140] = {
    [sym__expr] = STATE(634),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [141] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(116),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(885),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [142] = {
    [sym__expr] = STATE(635),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(440),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(439),
    [sym_splice] = STATE(439),
    [sym_quasiquote] = STATE(439),
    [sym_unquote] = STATE(439),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(438),
    [sym_short_splice] = STATE(438),
    [sym_short_quasiquote] = STATE(438),
    [sym_short_unquote] = STATE(438),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(442),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym_metadata] = STATE(480),
    [sym__identifier] = STATE(679),
    [aux_sym_def_repeat1] = STATE(242),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(651),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(661),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(663),
  },
  [143] = {
    [sym__expr] = STATE(456),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_while_repeat1] = STATE(119),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [144] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(66),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(889),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [145] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(118),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [146] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(893),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [147] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [148] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(125),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [149] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(131),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(899),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [150] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [aux_sym_parameters_repeat1] = STATE(128),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_RPAREN] = ACTIONS(901),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [151] = {
    [sym__expr] = STATE(690),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(905),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [152] = {
    [sym__expr] = STATE(587),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(921),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [153] = {
    [sym__expr] = STATE(607),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(923),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [154] = {
    [sym__expr] = STATE(608),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(925),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [155] = {
    [sym__expr] = STATE(609),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [156] = {
    [sym__expr] = STATE(586),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(929),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [157] = {
    [sym__expr] = STATE(686),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [158] = {
    [sym__expr] = STATE(704),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(933),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [159] = {
    [sym__expr] = STATE(693),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [160] = {
    [sym__expr] = STATE(593),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(937),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [161] = {
    [sym__expr] = STATE(563),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [162] = {
    [sym__expr] = STATE(590),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [163] = {
    [sym__expr] = STATE(636),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(943),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [164] = {
    [sym__expr] = STATE(598),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(945),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [165] = {
    [sym__expr] = STATE(703),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [166] = {
    [sym__expr] = STATE(702),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [167] = {
    [sym__expr] = STATE(701),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(951),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [168] = {
    [sym__expr] = STATE(700),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [169] = {
    [sym__expr] = STATE(573),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(955),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [170] = {
    [sym__expr] = STATE(572),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(957),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [171] = {
    [sym__expr] = STATE(617),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(959),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [172] = {
    [sym__expr] = STATE(571),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(961),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [173] = {
    [sym__expr] = STATE(618),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(963),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [174] = {
    [sym__expr] = STATE(578),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(965),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [175] = {
    [sym__expr] = STATE(619),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [176] = {
    [sym__expr] = STATE(620),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [177] = {
    [sym__expr] = STATE(583),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [178] = {
    [sym__expr] = STATE(575),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(973),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [179] = {
    [sym__expr] = STATE(574),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(975),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [180] = {
    [sym__expr] = STATE(621),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [181] = {
    [sym__expr] = STATE(317),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [182] = {
    [sym__expr] = STATE(151),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [183] = {
    [sym__expr] = STATE(213),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [184] = {
    [sym__expr] = STATE(182),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [185] = {
    [sym__expr] = STATE(95),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [186] = {
    [sym__expr] = STATE(295),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [187] = {
    [sym__expr] = STATE(497),
    [sym_tuple] = STATE(532),
    [sym_sqr_tuple] = STATE(532),
    [sym_array] = STATE(532),
    [sym_sqr_array] = STATE(532),
    [sym_struct] = STATE(532),
    [sym_table] = STATE(532),
    [sym_peg_set] = STATE(532),
    [sym__special_forms] = STATE(532),
    [sym_def] = STATE(533),
    [sym_var] = STATE(533),
    [sym_quote] = STATE(533),
    [sym_splice] = STATE(533),
    [sym_quasiquote] = STATE(533),
    [sym_unquote] = STATE(533),
    [sym_break] = STATE(533),
    [sym_set] = STATE(533),
    [sym_if] = STATE(533),
    [sym_do] = STATE(533),
    [sym_while] = STATE(533),
    [sym_fn] = STATE(533),
    [sym_upscope] = STATE(533),
    [sym__shorthand] = STATE(532),
    [sym_short_quote] = STATE(508),
    [sym_short_splice] = STATE(508),
    [sym_short_quasiquote] = STATE(508),
    [sym_short_unquote] = STATE(508),
    [sym_short_fn] = STATE(508),
    [sym__specials] = STATE(532),
    [sym_extra_defs] = STATE(534),
    [sym__literals] = STATE(532),
    [sym_long_str_literal] = STATE(529),
    [sym_long_buffer_literal] = STATE(529),
    [sym_number_literal] = STATE(529),
    [sym_bool_literal] = STATE(529),
    [sym__identifier] = STATE(532),
    [sym_symbol] = ACTIONS(979),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_AT_LPAREN] = ACTIONS(985),
    [anon_sym_AT_LBRACK] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_AT_LBRACE] = ACTIONS(991),
    [anon_sym_SQUOTE] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [sym_str_literal] = ACTIONS(1003),
    [sym_buffer_literal] = ACTIONS(1003),
    [aux_sym_number_literal_token1] = ACTIONS(1005),
    [aux_sym_number_literal_token2] = ACTIONS(1005),
    [aux_sym_number_literal_token3] = ACTIONS(1005),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [sym_nil_literal] = ACTIONS(1009),
    [sym_keyword] = ACTIONS(1011),
    [sym__long_str] = ACTIONS(1013),
    [sym__long_buffer] = ACTIONS(1015),
  },
  [188] = {
    [sym__expr] = STATE(518),
    [sym_tuple] = STATE(532),
    [sym_sqr_tuple] = STATE(532),
    [sym_array] = STATE(532),
    [sym_sqr_array] = STATE(532),
    [sym_struct] = STATE(532),
    [sym_table] = STATE(532),
    [sym_peg_set] = STATE(532),
    [sym__special_forms] = STATE(532),
    [sym_def] = STATE(533),
    [sym_var] = STATE(533),
    [sym_quote] = STATE(533),
    [sym_splice] = STATE(533),
    [sym_quasiquote] = STATE(533),
    [sym_unquote] = STATE(533),
    [sym_break] = STATE(533),
    [sym_set] = STATE(533),
    [sym_if] = STATE(533),
    [sym_do] = STATE(533),
    [sym_while] = STATE(533),
    [sym_fn] = STATE(533),
    [sym_upscope] = STATE(533),
    [sym__shorthand] = STATE(532),
    [sym_short_quote] = STATE(508),
    [sym_short_splice] = STATE(508),
    [sym_short_quasiquote] = STATE(508),
    [sym_short_unquote] = STATE(508),
    [sym_short_fn] = STATE(508),
    [sym__specials] = STATE(532),
    [sym_extra_defs] = STATE(534),
    [sym__literals] = STATE(532),
    [sym_long_str_literal] = STATE(529),
    [sym_long_buffer_literal] = STATE(529),
    [sym_number_literal] = STATE(529),
    [sym_bool_literal] = STATE(529),
    [sym__identifier] = STATE(532),
    [sym_symbol] = ACTIONS(979),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_AT_LPAREN] = ACTIONS(985),
    [anon_sym_AT_LBRACK] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_AT_LBRACE] = ACTIONS(991),
    [anon_sym_SQUOTE] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [sym_str_literal] = ACTIONS(1003),
    [sym_buffer_literal] = ACTIONS(1003),
    [aux_sym_number_literal_token1] = ACTIONS(1005),
    [aux_sym_number_literal_token2] = ACTIONS(1005),
    [aux_sym_number_literal_token3] = ACTIONS(1005),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [sym_nil_literal] = ACTIONS(1009),
    [sym_keyword] = ACTIONS(1011),
    [sym__long_str] = ACTIONS(1013),
    [sym__long_buffer] = ACTIONS(1015),
  },
  [189] = {
    [sym__expr] = STATE(517),
    [sym_tuple] = STATE(532),
    [sym_sqr_tuple] = STATE(532),
    [sym_array] = STATE(532),
    [sym_sqr_array] = STATE(532),
    [sym_struct] = STATE(532),
    [sym_table] = STATE(532),
    [sym_peg_set] = STATE(532),
    [sym__special_forms] = STATE(532),
    [sym_def] = STATE(533),
    [sym_var] = STATE(533),
    [sym_quote] = STATE(533),
    [sym_splice] = STATE(533),
    [sym_quasiquote] = STATE(533),
    [sym_unquote] = STATE(533),
    [sym_break] = STATE(533),
    [sym_set] = STATE(533),
    [sym_if] = STATE(533),
    [sym_do] = STATE(533),
    [sym_while] = STATE(533),
    [sym_fn] = STATE(533),
    [sym_upscope] = STATE(533),
    [sym__shorthand] = STATE(532),
    [sym_short_quote] = STATE(508),
    [sym_short_splice] = STATE(508),
    [sym_short_quasiquote] = STATE(508),
    [sym_short_unquote] = STATE(508),
    [sym_short_fn] = STATE(508),
    [sym__specials] = STATE(532),
    [sym_extra_defs] = STATE(534),
    [sym__literals] = STATE(532),
    [sym_long_str_literal] = STATE(529),
    [sym_long_buffer_literal] = STATE(529),
    [sym_number_literal] = STATE(529),
    [sym_bool_literal] = STATE(529),
    [sym__identifier] = STATE(532),
    [sym_symbol] = ACTIONS(979),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_AT_LPAREN] = ACTIONS(985),
    [anon_sym_AT_LBRACK] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_AT_LBRACE] = ACTIONS(991),
    [anon_sym_SQUOTE] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [sym_str_literal] = ACTIONS(1003),
    [sym_buffer_literal] = ACTIONS(1003),
    [aux_sym_number_literal_token1] = ACTIONS(1005),
    [aux_sym_number_literal_token2] = ACTIONS(1005),
    [aux_sym_number_literal_token3] = ACTIONS(1005),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [sym_nil_literal] = ACTIONS(1009),
    [sym_keyword] = ACTIONS(1011),
    [sym__long_str] = ACTIONS(1013),
    [sym__long_buffer] = ACTIONS(1015),
  },
  [190] = {
    [sym__expr] = STATE(516),
    [sym_tuple] = STATE(532),
    [sym_sqr_tuple] = STATE(532),
    [sym_array] = STATE(532),
    [sym_sqr_array] = STATE(532),
    [sym_struct] = STATE(532),
    [sym_table] = STATE(532),
    [sym_peg_set] = STATE(532),
    [sym__special_forms] = STATE(532),
    [sym_def] = STATE(533),
    [sym_var] = STATE(533),
    [sym_quote] = STATE(533),
    [sym_splice] = STATE(533),
    [sym_quasiquote] = STATE(533),
    [sym_unquote] = STATE(533),
    [sym_break] = STATE(533),
    [sym_set] = STATE(533),
    [sym_if] = STATE(533),
    [sym_do] = STATE(533),
    [sym_while] = STATE(533),
    [sym_fn] = STATE(533),
    [sym_upscope] = STATE(533),
    [sym__shorthand] = STATE(532),
    [sym_short_quote] = STATE(508),
    [sym_short_splice] = STATE(508),
    [sym_short_quasiquote] = STATE(508),
    [sym_short_unquote] = STATE(508),
    [sym_short_fn] = STATE(508),
    [sym__specials] = STATE(532),
    [sym_extra_defs] = STATE(534),
    [sym__literals] = STATE(532),
    [sym_long_str_literal] = STATE(529),
    [sym_long_buffer_literal] = STATE(529),
    [sym_number_literal] = STATE(529),
    [sym_bool_literal] = STATE(529),
    [sym__identifier] = STATE(532),
    [sym_symbol] = ACTIONS(979),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_AT_LPAREN] = ACTIONS(985),
    [anon_sym_AT_LBRACK] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_AT_LBRACE] = ACTIONS(991),
    [anon_sym_SQUOTE] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [sym_str_literal] = ACTIONS(1003),
    [sym_buffer_literal] = ACTIONS(1003),
    [aux_sym_number_literal_token1] = ACTIONS(1005),
    [aux_sym_number_literal_token2] = ACTIONS(1005),
    [aux_sym_number_literal_token3] = ACTIONS(1005),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [sym_nil_literal] = ACTIONS(1009),
    [sym_keyword] = ACTIONS(1011),
    [sym__long_str] = ACTIONS(1013),
    [sym__long_buffer] = ACTIONS(1015),
  },
  [191] = {
    [sym__expr] = STATE(86),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [192] = {
    [sym__expr] = STATE(85),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [193] = {
    [sym__expr] = STATE(467),
    [sym_tuple] = STATE(404),
    [sym_sqr_tuple] = STATE(404),
    [sym_array] = STATE(404),
    [sym_sqr_array] = STATE(404),
    [sym_struct] = STATE(404),
    [sym_table] = STATE(404),
    [sym_peg_set] = STATE(404),
    [sym__special_forms] = STATE(404),
    [sym_def] = STATE(432),
    [sym_var] = STATE(432),
    [sym_quote] = STATE(432),
    [sym_splice] = STATE(432),
    [sym_quasiquote] = STATE(432),
    [sym_unquote] = STATE(432),
    [sym_break] = STATE(432),
    [sym_set] = STATE(432),
    [sym_if] = STATE(432),
    [sym_do] = STATE(432),
    [sym_while] = STATE(432),
    [sym_fn] = STATE(432),
    [sym_upscope] = STATE(432),
    [sym__shorthand] = STATE(404),
    [sym_short_quote] = STATE(437),
    [sym_short_splice] = STATE(437),
    [sym_short_quasiquote] = STATE(437),
    [sym_short_unquote] = STATE(437),
    [sym_short_fn] = STATE(437),
    [sym__specials] = STATE(404),
    [sym_extra_defs] = STATE(451),
    [sym__literals] = STATE(404),
    [sym_long_str_literal] = STATE(386),
    [sym_long_buffer_literal] = STATE(386),
    [sym_number_literal] = STATE(386),
    [sym_bool_literal] = STATE(386),
    [sym__identifier] = STATE(404),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [194] = {
    [sym__expr] = STATE(468),
    [sym_tuple] = STATE(404),
    [sym_sqr_tuple] = STATE(404),
    [sym_array] = STATE(404),
    [sym_sqr_array] = STATE(404),
    [sym_struct] = STATE(404),
    [sym_table] = STATE(404),
    [sym_peg_set] = STATE(404),
    [sym__special_forms] = STATE(404),
    [sym_def] = STATE(432),
    [sym_var] = STATE(432),
    [sym_quote] = STATE(432),
    [sym_splice] = STATE(432),
    [sym_quasiquote] = STATE(432),
    [sym_unquote] = STATE(432),
    [sym_break] = STATE(432),
    [sym_set] = STATE(432),
    [sym_if] = STATE(432),
    [sym_do] = STATE(432),
    [sym_while] = STATE(432),
    [sym_fn] = STATE(432),
    [sym_upscope] = STATE(432),
    [sym__shorthand] = STATE(404),
    [sym_short_quote] = STATE(437),
    [sym_short_splice] = STATE(437),
    [sym_short_quasiquote] = STATE(437),
    [sym_short_unquote] = STATE(437),
    [sym_short_fn] = STATE(437),
    [sym__specials] = STATE(404),
    [sym_extra_defs] = STATE(451),
    [sym__literals] = STATE(404),
    [sym_long_str_literal] = STATE(386),
    [sym_long_buffer_literal] = STATE(386),
    [sym_number_literal] = STATE(386),
    [sym_bool_literal] = STATE(386),
    [sym__identifier] = STATE(404),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [195] = {
    [sym__expr] = STATE(319),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [196] = {
    [sym__expr] = STATE(318),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [197] = {
    [sym__expr] = STATE(541),
    [sym_tuple] = STATE(532),
    [sym_sqr_tuple] = STATE(532),
    [sym_array] = STATE(532),
    [sym_sqr_array] = STATE(532),
    [sym_struct] = STATE(532),
    [sym_table] = STATE(532),
    [sym_peg_set] = STATE(532),
    [sym__special_forms] = STATE(532),
    [sym_def] = STATE(533),
    [sym_var] = STATE(533),
    [sym_quote] = STATE(533),
    [sym_splice] = STATE(533),
    [sym_quasiquote] = STATE(533),
    [sym_unquote] = STATE(533),
    [sym_break] = STATE(533),
    [sym_set] = STATE(533),
    [sym_if] = STATE(533),
    [sym_do] = STATE(533),
    [sym_while] = STATE(533),
    [sym_fn] = STATE(533),
    [sym_upscope] = STATE(533),
    [sym__shorthand] = STATE(532),
    [sym_short_quote] = STATE(508),
    [sym_short_splice] = STATE(508),
    [sym_short_quasiquote] = STATE(508),
    [sym_short_unquote] = STATE(508),
    [sym_short_fn] = STATE(508),
    [sym__specials] = STATE(532),
    [sym_extra_defs] = STATE(534),
    [sym__literals] = STATE(532),
    [sym_long_str_literal] = STATE(529),
    [sym_long_buffer_literal] = STATE(529),
    [sym_number_literal] = STATE(529),
    [sym_bool_literal] = STATE(529),
    [sym__identifier] = STATE(532),
    [sym_symbol] = ACTIONS(979),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(981),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_AT_LPAREN] = ACTIONS(985),
    [anon_sym_AT_LBRACK] = ACTIONS(987),
    [anon_sym_LBRACE] = ACTIONS(989),
    [anon_sym_AT_LBRACE] = ACTIONS(991),
    [anon_sym_SQUOTE] = ACTIONS(993),
    [anon_sym_SEMI] = ACTIONS(995),
    [anon_sym_TILDE] = ACTIONS(997),
    [anon_sym_COMMA] = ACTIONS(999),
    [anon_sym_PIPE] = ACTIONS(1001),
    [sym_str_literal] = ACTIONS(1003),
    [sym_buffer_literal] = ACTIONS(1003),
    [aux_sym_number_literal_token1] = ACTIONS(1005),
    [aux_sym_number_literal_token2] = ACTIONS(1005),
    [aux_sym_number_literal_token3] = ACTIONS(1005),
    [anon_sym_true] = ACTIONS(1007),
    [anon_sym_false] = ACTIONS(1007),
    [sym_nil_literal] = ACTIONS(1009),
    [sym_keyword] = ACTIONS(1011),
    [sym__long_str] = ACTIONS(1013),
    [sym__long_buffer] = ACTIONS(1015),
  },
  [198] = {
    [sym__expr] = STATE(316),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [199] = {
    [sym__expr] = STATE(315),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [200] = {
    [sym__expr] = STATE(221),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [201] = {
    [sym__expr] = STATE(469),
    [sym_tuple] = STATE(404),
    [sym_sqr_tuple] = STATE(404),
    [sym_array] = STATE(404),
    [sym_sqr_array] = STATE(404),
    [sym_struct] = STATE(404),
    [sym_table] = STATE(404),
    [sym_peg_set] = STATE(404),
    [sym__special_forms] = STATE(404),
    [sym_def] = STATE(432),
    [sym_var] = STATE(432),
    [sym_quote] = STATE(432),
    [sym_splice] = STATE(432),
    [sym_quasiquote] = STATE(432),
    [sym_unquote] = STATE(432),
    [sym_break] = STATE(432),
    [sym_set] = STATE(432),
    [sym_if] = STATE(432),
    [sym_do] = STATE(432),
    [sym_while] = STATE(432),
    [sym_fn] = STATE(432),
    [sym_upscope] = STATE(432),
    [sym__shorthand] = STATE(404),
    [sym_short_quote] = STATE(437),
    [sym_short_splice] = STATE(437),
    [sym_short_quasiquote] = STATE(437),
    [sym_short_unquote] = STATE(437),
    [sym_short_fn] = STATE(437),
    [sym__specials] = STATE(404),
    [sym_extra_defs] = STATE(451),
    [sym__literals] = STATE(404),
    [sym_long_str_literal] = STATE(386),
    [sym_long_buffer_literal] = STATE(386),
    [sym_number_literal] = STATE(386),
    [sym_bool_literal] = STATE(386),
    [sym__identifier] = STATE(404),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [202] = {
    [sym__expr] = STATE(230),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(465),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(464),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(466),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(1017),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [203] = {
    [sym__expr] = STATE(163),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [204] = {
    [sym__expr] = STATE(470),
    [sym_tuple] = STATE(404),
    [sym_sqr_tuple] = STATE(404),
    [sym_array] = STATE(404),
    [sym_sqr_array] = STATE(404),
    [sym_struct] = STATE(404),
    [sym_table] = STATE(404),
    [sym_peg_set] = STATE(404),
    [sym__special_forms] = STATE(404),
    [sym_def] = STATE(432),
    [sym_var] = STATE(432),
    [sym_quote] = STATE(432),
    [sym_splice] = STATE(432),
    [sym_quasiquote] = STATE(432),
    [sym_unquote] = STATE(432),
    [sym_break] = STATE(432),
    [sym_set] = STATE(432),
    [sym_if] = STATE(432),
    [sym_do] = STATE(432),
    [sym_while] = STATE(432),
    [sym_fn] = STATE(432),
    [sym_upscope] = STATE(432),
    [sym__shorthand] = STATE(404),
    [sym_short_quote] = STATE(437),
    [sym_short_splice] = STATE(437),
    [sym_short_quasiquote] = STATE(437),
    [sym_short_unquote] = STATE(437),
    [sym_short_fn] = STATE(437),
    [sym__specials] = STATE(404),
    [sym_extra_defs] = STATE(451),
    [sym__literals] = STATE(404),
    [sym_long_str_literal] = STATE(386),
    [sym_long_buffer_literal] = STATE(386),
    [sym_number_literal] = STATE(386),
    [sym_bool_literal] = STATE(386),
    [sym__identifier] = STATE(404),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [205] = {
    [sym__expr] = STATE(471),
    [sym_tuple] = STATE(404),
    [sym_sqr_tuple] = STATE(404),
    [sym_array] = STATE(404),
    [sym_sqr_array] = STATE(404),
    [sym_struct] = STATE(404),
    [sym_table] = STATE(404),
    [sym_peg_set] = STATE(404),
    [sym__special_forms] = STATE(404),
    [sym_def] = STATE(432),
    [sym_var] = STATE(432),
    [sym_quote] = STATE(432),
    [sym_splice] = STATE(432),
    [sym_quasiquote] = STATE(432),
    [sym_unquote] = STATE(432),
    [sym_break] = STATE(432),
    [sym_set] = STATE(432),
    [sym_if] = STATE(432),
    [sym_do] = STATE(432),
    [sym_while] = STATE(432),
    [sym_fn] = STATE(432),
    [sym_upscope] = STATE(432),
    [sym__shorthand] = STATE(404),
    [sym_short_quote] = STATE(437),
    [sym_short_splice] = STATE(437),
    [sym_short_quasiquote] = STATE(437),
    [sym_short_unquote] = STATE(437),
    [sym_short_fn] = STATE(437),
    [sym__specials] = STATE(404),
    [sym_extra_defs] = STATE(451),
    [sym__literals] = STATE(404),
    [sym_long_str_literal] = STATE(386),
    [sym_long_buffer_literal] = STATE(386),
    [sym_number_literal] = STATE(386),
    [sym_bool_literal] = STATE(386),
    [sym__identifier] = STATE(404),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(37),
    [sym_keyword] = ACTIONS(39),
    [sym__long_str] = ACTIONS(41),
    [sym__long_buffer] = ACTIONS(43),
  },
  [206] = {
    [sym__expr] = STATE(80),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [207] = {
    [sym__expr] = STATE(93),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [208] = {
    [sym__expr] = STATE(210),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(475),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(476),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(474),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(1019),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [209] = {
    [sym__expr] = STATE(141),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [210] = {
    [sym__expr] = STATE(604),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [211] = {
    [sym__expr] = STATE(79),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [212] = {
    [sym__expr] = STATE(91),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [213] = {
    [sym__expr] = STATE(164),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [214] = {
    [sym__expr] = STATE(229),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [215] = {
    [sym__expr] = STATE(71),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [216] = {
    [sym__expr] = STATE(218),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(379),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(385),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(380),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(1021),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [217] = {
    [sym__expr] = STATE(101),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [218] = {
    [sym__expr] = STATE(569),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [219] = {
    [sym__expr] = STATE(69),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [220] = {
    [sym__expr] = STATE(258),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [221] = {
    [sym__expr] = STATE(161),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [222] = {
    [sym__expr] = STATE(203),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [223] = {
    [sym__expr] = STATE(257),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [224] = {
    [sym__expr] = STATE(226),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(407),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(406),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(408),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(1023),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [225] = {
    [sym__expr] = STATE(137),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [226] = {
    [sym__expr] = STATE(580),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [227] = {
    [sym__expr] = STATE(82),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [228] = {
    [sym__expr] = STATE(256),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
  [229] = {
    [sym__expr] = STATE(162),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [230] = {
    [sym__expr] = STATE(697),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [231] = {
    [sym__expr] = STATE(81),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [232] = {
    [sym__expr] = STATE(234),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(433),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(434),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(431),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(1025),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [233] = {
    [sym__expr] = STATE(104),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [234] = {
    [sym__expr] = STATE(626),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [235] = {
    [sym__expr] = STATE(446),
    [sym_tuple] = STATE(330),
    [sym_sqr_tuple] = STATE(330),
    [sym_array] = STATE(330),
    [sym_sqr_array] = STATE(330),
    [sym_struct] = STATE(330),
    [sym_table] = STATE(330),
    [sym_peg_set] = STATE(330),
    [sym__special_forms] = STATE(330),
    [sym_def] = STATE(329),
    [sym_var] = STATE(329),
    [sym_quote] = STATE(329),
    [sym_splice] = STATE(329),
    [sym_quasiquote] = STATE(329),
    [sym_unquote] = STATE(329),
    [sym_break] = STATE(329),
    [sym_set] = STATE(329),
    [sym_if] = STATE(329),
    [sym_do] = STATE(329),
    [sym_while] = STATE(329),
    [sym_fn] = STATE(329),
    [sym_upscope] = STATE(329),
    [sym__shorthand] = STATE(330),
    [sym_short_quote] = STATE(328),
    [sym_short_splice] = STATE(328),
    [sym_short_quasiquote] = STATE(328),
    [sym_short_unquote] = STATE(328),
    [sym_short_fn] = STATE(328),
    [sym__specials] = STATE(330),
    [sym_extra_defs] = STATE(327),
    [sym__literals] = STATE(330),
    [sym_long_str_literal] = STATE(337),
    [sym_long_buffer_literal] = STATE(337),
    [sym_number_literal] = STATE(337),
    [sym_bool_literal] = STATE(337),
    [sym__identifier] = STATE(330),
    [sym_symbol] = ACTIONS(45),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_AT_LPAREN] = ACTIONS(53),
    [anon_sym_AT_LBRACK] = ACTIONS(55),
    [anon_sym_LBRACE] = ACTIONS(57),
    [anon_sym_AT_LBRACE] = ACTIONS(59),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_TILDE] = ACTIONS(91),
    [anon_sym_COMMA] = ACTIONS(93),
    [anon_sym_PIPE] = ACTIONS(95),
    [sym_str_literal] = ACTIONS(99),
    [sym_buffer_literal] = ACTIONS(99),
    [aux_sym_number_literal_token1] = ACTIONS(101),
    [aux_sym_number_literal_token2] = ACTIONS(101),
    [aux_sym_number_literal_token3] = ACTIONS(101),
    [anon_sym_true] = ACTIONS(103),
    [anon_sym_false] = ACTIONS(103),
    [sym_nil_literal] = ACTIONS(105),
    [sym_keyword] = ACTIONS(107),
    [sym__long_str] = ACTIONS(109),
    [sym__long_buffer] = ACTIONS(111),
  },
  [236] = {
    [sym__expr] = STATE(665),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [237] = {
    [sym__expr] = STATE(666),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [238] = {
    [sym__expr] = STATE(667),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [239] = {
    [sym__expr] = STATE(668),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [240] = {
    [sym__expr] = STATE(669),
    [sym_tuple] = STATE(679),
    [sym_sqr_tuple] = STATE(679),
    [sym_array] = STATE(679),
    [sym_sqr_array] = STATE(679),
    [sym_struct] = STATE(679),
    [sym_table] = STATE(679),
    [sym_peg_set] = STATE(679),
    [sym__special_forms] = STATE(679),
    [sym_def] = STATE(584),
    [sym_var] = STATE(584),
    [sym_quote] = STATE(584),
    [sym_splice] = STATE(584),
    [sym_quasiquote] = STATE(584),
    [sym_unquote] = STATE(584),
    [sym_break] = STATE(584),
    [sym_set] = STATE(584),
    [sym_if] = STATE(584),
    [sym_do] = STATE(584),
    [sym_while] = STATE(584),
    [sym_fn] = STATE(584),
    [sym_upscope] = STATE(584),
    [sym__shorthand] = STATE(679),
    [sym_short_quote] = STATE(677),
    [sym_short_splice] = STATE(677),
    [sym_short_quasiquote] = STATE(677),
    [sym_short_unquote] = STATE(677),
    [sym_short_fn] = STATE(677),
    [sym__specials] = STATE(679),
    [sym_extra_defs] = STATE(676),
    [sym__literals] = STATE(679),
    [sym_long_str_literal] = STATE(683),
    [sym_long_buffer_literal] = STATE(683),
    [sym_number_literal] = STATE(683),
    [sym_bool_literal] = STATE(683),
    [sym__identifier] = STATE(679),
    [sym_symbol] = ACTIONS(637),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(641),
    [anon_sym_AT_LPAREN] = ACTIONS(643),
    [anon_sym_AT_LBRACK] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(907),
    [anon_sym_AT_LBRACE] = ACTIONS(647),
    [anon_sym_SQUOTE] = ACTIONS(909),
    [anon_sym_SEMI] = ACTIONS(911),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_COMMA] = ACTIONS(915),
    [anon_sym_PIPE] = ACTIONS(649),
    [sym_str_literal] = ACTIONS(653),
    [sym_buffer_literal] = ACTIONS(653),
    [aux_sym_number_literal_token1] = ACTIONS(655),
    [aux_sym_number_literal_token2] = ACTIONS(655),
    [aux_sym_number_literal_token3] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(657),
    [sym_nil_literal] = ACTIONS(659),
    [sym_keyword] = ACTIONS(917),
    [sym__long_str] = ACTIONS(919),
    [sym__long_buffer] = ACTIONS(663),
  },
  [241] = {
    [sym__expr] = STATE(255),
    [sym_tuple] = STATE(290),
    [sym_sqr_tuple] = STATE(290),
    [sym_array] = STATE(290),
    [sym_sqr_array] = STATE(290),
    [sym_struct] = STATE(290),
    [sym_table] = STATE(290),
    [sym_peg_set] = STATE(290),
    [sym__special_forms] = STATE(290),
    [sym_def] = STATE(287),
    [sym_var] = STATE(287),
    [sym_quote] = STATE(287),
    [sym_splice] = STATE(287),
    [sym_quasiquote] = STATE(287),
    [sym_unquote] = STATE(287),
    [sym_break] = STATE(287),
    [sym_set] = STATE(287),
    [sym_if] = STATE(287),
    [sym_do] = STATE(287),
    [sym_while] = STATE(287),
    [sym_fn] = STATE(287),
    [sym_upscope] = STATE(287),
    [sym__shorthand] = STATE(290),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(290),
    [sym_extra_defs] = STATE(275),
    [sym__literals] = STATE(290),
    [sym_long_str_literal] = STATE(301),
    [sym_long_buffer_literal] = STATE(301),
    [sym_number_literal] = STATE(301),
    [sym_bool_literal] = STATE(301),
    [sym__identifier] = STATE(290),
    [sym_symbol] = ACTIONS(233),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(239),
    [anon_sym_AT_LPAREN] = ACTIONS(241),
    [anon_sym_AT_LBRACK] = ACTIONS(243),
    [anon_sym_LBRACE] = ACTIONS(245),
    [anon_sym_AT_LBRACE] = ACTIONS(247),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SEMI] = ACTIONS(253),
    [anon_sym_TILDE] = ACTIONS(255),
    [anon_sym_COMMA] = ACTIONS(257),
    [anon_sym_PIPE] = ACTIONS(259),
    [sym_str_literal] = ACTIONS(261),
    [sym_buffer_literal] = ACTIONS(261),
    [aux_sym_number_literal_token1] = ACTIONS(263),
    [aux_sym_number_literal_token2] = ACTIONS(263),
    [aux_sym_number_literal_token3] = ACTIONS(263),
    [anon_sym_true] = ACTIONS(265),
    [anon_sym_false] = ACTIONS(265),
    [sym_nil_literal] = ACTIONS(267),
    [sym_keyword] = ACTIONS(269),
    [sym__long_str] = ACTIONS(271),
    [sym__long_buffer] = ACTIONS(273),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1029), 1,
      anon_sym_LPAREN,
    ACTIONS(1034), 1,
      anon_sym_LBRACE,
    ACTIONS(1037), 1,
      anon_sym_SQUOTE,
    ACTIONS(1040), 1,
      anon_sym_SEMI,
    ACTIONS(1043), 1,
      anon_sym_TILDE,
    ACTIONS(1046), 1,
      anon_sym_COMMA,
    ACTIONS(1052), 1,
      sym__long_str,
    STATE(242), 1,
      aux_sym_def_repeat1,
    STATE(480), 1,
      sym_metadata,
    ACTIONS(1049), 2,
      sym_str_literal,
      sym_keyword,
    ACTIONS(1027), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1032), 7,
      sym__long_buffer,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    STATE(479), 10,
      sym_struct,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [65] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1057), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [101] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1061), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [137] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1065), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [173] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1067), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1069), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [209] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1071), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1073), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [245] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1075), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1077), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [281] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1079), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1081), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [317] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1083), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1085), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [353] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1087), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1089), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [389] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1091), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1093), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [425] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1097), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [461] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1101), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [497] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1105), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [533] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1109), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [569] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1113), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [605] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1117), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [641] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1121), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [677] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1125), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [713] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1129), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [749] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1133), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [785] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1137), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [821] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1141), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [857] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1145), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [893] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1149), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [929] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1153), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [965] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1157), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1001] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1161), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1037] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1165), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1073] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1169), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1109] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1173), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1145] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1177), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1181] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1181), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1217] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1185), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1253] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1189), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1289] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1193), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1325] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1361] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1397] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1205), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1433] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1209), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1469] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1213), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1505] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1541] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1221), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1577] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1225), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1613] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1229), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1649] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1685] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1237), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1721] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1241), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1757] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1245), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1793] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1249), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1829] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1253), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1865] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1257), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1901] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1261), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1937] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1263), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1265), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1973] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1267), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1269), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2009] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1271), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1273), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2045] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1275), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1277), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2081] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1281), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2117] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1283), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1285), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2153] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1287), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1289), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2189] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1291), 10,
      sym_variadic_marker,
      sym_optional_marker,
      sym_keys_marker,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1293), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2225] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(304), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(65), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2288] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(481), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(64), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2351] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(310), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(61), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2414] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(307), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(54), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2477] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(481), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(56), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2540] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(309), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(29), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2603] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(481), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(28), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2666] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(481), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(62), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2729] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(481), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(26), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2792] = 17,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(989), 1,
      anon_sym_LBRACE,
    ACTIONS(1013), 1,
      sym__long_str,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    ACTIONS(1299), 1,
      sym_str_literal,
    ACTIONS(1301), 1,
      sym_keyword,
    STATE(311), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    STATE(513), 2,
      sym_struct,
      sym_long_str_literal,
    STATE(33), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(411), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2855] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1271), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1273), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2889] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1229), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2923] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1263), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1265), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2957] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1105), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2991] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1109), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3025] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1113), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3059] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1117), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3093] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1283), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1285), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3127] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1275), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1277), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3161] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1205), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3195] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1193), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3229] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1267), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1269), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3263] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3297] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1125), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3331] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1185), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3365] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3399] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3433] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1245), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3467] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1129), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3501] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1281), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3535] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1291), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1293), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3569] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1189), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3603] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1181), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3637] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1177), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3671] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1287), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1289), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3705] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1065), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3739] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1121), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3773] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1173), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3807] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1169), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3841] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1165), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3875] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1161), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3909] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1157), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3943] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1153), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3977] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1149), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4011] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1145), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4045] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1141), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4079] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1137), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4113] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1133), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4147] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1061), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4181] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1225), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4215] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1213), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4249] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1221), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4283] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4317] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1101), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4351] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1097), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4385] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1091), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1093), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4419] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1087), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1089), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4453] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1057), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4487] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1261), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4521] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1257), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4555] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1253), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4589] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1249), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4623] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1209), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4657] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1079), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1081), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4691] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1075), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1077), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4725] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1071), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1073), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4759] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1241), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4793] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1067), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1069), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4827] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1237), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4861] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1303), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1305), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4894] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1083), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1085), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4927] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1181), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4959] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1075), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1077), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4991] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1307), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1309), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5023] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1311), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1313), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5055] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1315), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1317), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5087] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5121] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    ACTIONS(1287), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1289), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5155] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1065), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5187] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1315), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1317), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5219] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1321), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1323), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5251] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1149), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5283] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5317] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1287), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1289), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5349] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1325), 1,
      sym_symbol,
    ACTIONS(1127), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1129), 7,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1327), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5385] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1291), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1293), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5417] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1281), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5449] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1315), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1317), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5481] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1153), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5513] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1157), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5545] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1161), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5577] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1165), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5609] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1169), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5641] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1329), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1331), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5673] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1333), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1335), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5705] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1337), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1339), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5737] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1341), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1343), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5769] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1173), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5801] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1129), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5833] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1307), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1309), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5865] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1177), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5897] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1245), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5929] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1189), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5961] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1345), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [5995] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1345), 1,
      anon_sym_RPAREN,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6029] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1345), 1,
      anon_sym_RPAREN,
    ACTIONS(1287), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1289), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6063] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1193), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6095] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1145), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6127] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1325), 1,
      sym_symbol,
    ACTIONS(1349), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1347), 7,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1327), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [6163] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1141), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6195] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1137), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6227] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1351), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1353), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6259] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1351), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1353), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6291] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1061), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6323] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1351), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1353), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6355] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1355), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1357), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6387] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1355), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1357), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6419] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1355), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1357), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6451] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1121), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6483] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1205), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6515] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1359), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1361), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6547] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1133), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6579] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1363), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1365), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6611] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1209), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6643] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1057), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6675] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1213), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6707] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1067), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1069), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6739] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1071), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1073), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6771] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1367), 1,
      anon_sym_RPAREN,
    ACTIONS(1287), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1289), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6805] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6837] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1367), 1,
      anon_sym_RPAREN,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6871] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1367), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6905] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1307), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1309), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6937] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1079), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1081), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [6969] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7001] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1197), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1327), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7035] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1233), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1327), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7069] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1245), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1327), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7103] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1327), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7137] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1289), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1327), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7171] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7203] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1221), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7235] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1225), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7267] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1369), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1371), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7299] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1229), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7331] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1237), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7363] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1241), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7395] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1249), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7427] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1185), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7459] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1125), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7491] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1253), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7523] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7555] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1373), 1,
      sym_symbol,
    ACTIONS(1349), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1375), 7,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_keyword,
    ACTIONS(1347), 10,
      sym__long_str,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
  [7591] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1377), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1379), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7623] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1257), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7655] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1261), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7687] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1267), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1269), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7719] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1087), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1089), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7751] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1091), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1093), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7783] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1097), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7815] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1101), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7847] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1381), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7881] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1381), 1,
      anon_sym_RPAREN,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7915] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1381), 1,
      anon_sym_RPAREN,
    ACTIONS(1287), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1289), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7949] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1263), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1265), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [7981] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1105), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8013] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1109), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8045] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1113), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8077] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1117), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8109] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1283), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1285), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8141] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1383), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1385), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8173] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1387), 1,
      anon_sym_RPAREN,
    ACTIONS(1287), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1289), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8207] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1387), 1,
      anon_sym_RPAREN,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8241] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1387), 1,
      anon_sym_RPAREN,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8275] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1275), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1277), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8307] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1271), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1273), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8339] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1325), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1327), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8370] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1389), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1391), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [8401] = 14,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1027), 1,
      sym_symbol,
    ACTIONS(1032), 1,
      anon_sym_LBRACK,
    ACTIONS(1393), 1,
      anon_sym_LPAREN,
    ACTIONS(1396), 1,
      anon_sym_LBRACE,
    ACTIONS(1399), 1,
      anon_sym_SQUOTE,
    ACTIONS(1402), 1,
      anon_sym_SEMI,
    ACTIONS(1405), 1,
      anon_sym_TILDE,
    ACTIONS(1408), 1,
      anon_sym_COMMA,
    ACTIONS(1414), 1,
      sym__long_str,
    STATE(481), 1,
      aux_sym_def_repeat1,
    STATE(514), 1,
      sym_metadata,
    ACTIONS(1411), 2,
      sym_str_literal,
      sym_keyword,
    STATE(513), 10,
      sym_struct,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [8454] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(488), 1,
      sym__name,
    STATE(27), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(455), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8501] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(487), 1,
      sym__name,
    STATE(45), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(455), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8548] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(491), 1,
      sym__name,
    STATE(63), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(455), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8595] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(489), 1,
      sym__name,
    STATE(16), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(455), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8642] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(490), 1,
      sym__name,
    STATE(31), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(455), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8689] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(34), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8731] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(20), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8773] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(15), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8815] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(30), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8857] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(45), 1,
      sym_symbol,
    ACTIONS(87), 1,
      anon_sym_SQUOTE,
    ACTIONS(89), 1,
      anon_sym_SEMI,
    ACTIONS(91), 1,
      anon_sym_TILDE,
    ACTIONS(93), 1,
      anon_sym_COMMA,
    ACTIONS(107), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      anon_sym_LPAREN,
    ACTIONS(1297), 1,
      anon_sym_LBRACK,
    STATE(59), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [8899] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(979), 1,
      sym_symbol,
    ACTIONS(993), 1,
      anon_sym_SQUOTE,
    ACTIONS(995), 1,
      anon_sym_SEMI,
    ACTIONS(997), 1,
      anon_sym_TILDE,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1011), 1,
      sym_keyword,
    ACTIONS(1417), 1,
      anon_sym_LPAREN,
    STATE(308), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8936] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(979), 1,
      sym_symbol,
    ACTIONS(993), 1,
      anon_sym_SQUOTE,
    ACTIONS(995), 1,
      anon_sym_SEMI,
    ACTIONS(997), 1,
      anon_sym_TILDE,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1011), 1,
      sym_keyword,
    ACTIONS(1417), 1,
      anon_sym_LPAREN,
    STATE(312), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [8973] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(979), 1,
      sym_symbol,
    ACTIONS(993), 1,
      anon_sym_SQUOTE,
    ACTIONS(995), 1,
      anon_sym_SEMI,
    ACTIONS(997), 1,
      anon_sym_TILDE,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1011), 1,
      sym_keyword,
    ACTIONS(1417), 1,
      anon_sym_LPAREN,
    STATE(306), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [9010] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(979), 1,
      sym_symbol,
    ACTIONS(993), 1,
      anon_sym_SQUOTE,
    ACTIONS(995), 1,
      anon_sym_SEMI,
    ACTIONS(997), 1,
      anon_sym_TILDE,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1011), 1,
      sym_keyword,
    ACTIONS(1417), 1,
      anon_sym_LPAREN,
    STATE(305), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [9047] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(979), 1,
      sym_symbol,
    ACTIONS(993), 1,
      anon_sym_SQUOTE,
    ACTIONS(995), 1,
      anon_sym_SEMI,
    ACTIONS(997), 1,
      anon_sym_TILDE,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1011), 1,
      sym_keyword,
    ACTIONS(1417), 1,
      anon_sym_LPAREN,
    STATE(303), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [9084] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 1,
      sym_symbol,
    ACTIONS(1105), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9103] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1087), 1,
      sym_symbol,
    ACTIONS(1089), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9122] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 1,
      sym_symbol,
    ACTIONS(1165), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9141] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 1,
      sym_symbol,
    ACTIONS(1161), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9160] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 1,
      sym_symbol,
    ACTIONS(1157), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9179] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 1,
      sym_symbol,
    ACTIONS(1153), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9198] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 1,
      sym_symbol,
    ACTIONS(1149), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9217] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 1,
      sym_symbol,
    ACTIONS(1145), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9236] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 1,
      sym_symbol,
    ACTIONS(1141), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9255] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 1,
      sym_symbol,
    ACTIONS(1137), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9274] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 1,
      sym_symbol,
    ACTIONS(1133), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9293] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 1,
      sym_symbol,
    ACTIONS(1197), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9312] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 1,
      sym_symbol,
    ACTIONS(1173), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9331] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 1,
      sym_symbol,
    ACTIONS(1177), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9350] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 1,
      sym_symbol,
    ACTIONS(1181), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9369] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 1,
      sym_symbol,
    ACTIONS(1189), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9388] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1325), 1,
      sym_symbol,
    ACTIONS(1327), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9407] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1389), 1,
      sym_symbol,
    ACTIONS(1391), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9426] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 1,
      sym_symbol,
    ACTIONS(1129), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9445] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 1,
      sym_symbol,
    ACTIONS(1117), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9464] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 1,
      sym_symbol,
    ACTIONS(1113), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9483] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 1,
      sym_symbol,
    ACTIONS(1109), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9502] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 1,
      sym_symbol,
    ACTIONS(1101), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9521] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 1,
      sym_symbol,
    ACTIONS(1097), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9540] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1091), 1,
      sym_symbol,
    ACTIONS(1093), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9559] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 1,
      sym_symbol,
    ACTIONS(1169), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9578] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1079), 1,
      sym_symbol,
    ACTIONS(1081), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9597] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1075), 1,
      sym_symbol,
    ACTIONS(1077), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9616] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1071), 1,
      sym_symbol,
    ACTIONS(1073), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9635] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1067), 1,
      sym_symbol,
    ACTIONS(1069), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9654] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 1,
      sym_symbol,
    ACTIONS(1121), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9673] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1063), 1,
      sym_symbol,
    ACTIONS(1065), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9692] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1287), 1,
      sym_symbol,
    ACTIONS(1289), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9711] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1291), 1,
      sym_symbol,
    ACTIONS(1293), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9730] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 1,
      sym_symbol,
    ACTIONS(1281), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9749] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 1,
      sym_symbol,
    ACTIONS(1245), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9768] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 1,
      sym_symbol,
    ACTIONS(1233), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9787] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 1,
      sym_symbol,
    ACTIONS(1185), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9806] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 1,
      sym_symbol,
    ACTIONS(1125), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9825] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 1,
      sym_symbol,
    ACTIONS(1201), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9844] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1267), 1,
      sym_symbol,
    ACTIONS(1269), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9863] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1271), 1,
      sym_symbol,
    ACTIONS(1273), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9882] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1275), 1,
      sym_symbol,
    ACTIONS(1277), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9901] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1283), 1,
      sym_symbol,
    ACTIONS(1285), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9920] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1263), 1,
      sym_symbol,
    ACTIONS(1265), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9939] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 1,
      sym_symbol,
    ACTIONS(1261), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9958] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 1,
      sym_symbol,
    ACTIONS(1257), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9977] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 1,
      sym_symbol,
    ACTIONS(1253), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [9996] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 1,
      sym_symbol,
    ACTIONS(1249), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10015] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 1,
      sym_symbol,
    ACTIONS(1241), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10034] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 1,
      sym_symbol,
    ACTIONS(1193), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10053] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1059), 1,
      sym_symbol,
    ACTIONS(1061), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10072] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 1,
      sym_symbol,
    ACTIONS(1205), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10091] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 1,
      sym_symbol,
    ACTIONS(1209), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10110] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1055), 1,
      sym_symbol,
    ACTIONS(1057), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10129] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 1,
      sym_symbol,
    ACTIONS(1213), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10148] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 1,
      sym_symbol,
    ACTIONS(1217), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10167] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 1,
      sym_symbol,
    ACTIONS(1221), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10186] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 1,
      sym_symbol,
    ACTIONS(1225), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10205] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 1,
      sym_symbol,
    ACTIONS(1229), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10224] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 1,
      sym_symbol,
    ACTIONS(1237), 10,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [10243] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1419), 1,
      anon_sym_quote,
    ACTIONS(1421), 1,
      anon_sym_splice,
    ACTIONS(1423), 1,
      anon_sym_quasiquote,
    ACTIONS(1425), 1,
      anon_sym_unquote,
  [10259] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1427), 1,
      anon_sym_quote,
    ACTIONS(1429), 1,
      anon_sym_splice,
    ACTIONS(1431), 1,
      anon_sym_quasiquote,
    ACTIONS(1433), 1,
      anon_sym_unquote,
  [10275] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1435), 1,
      anon_sym_RPAREN,
  [10282] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1437), 1,
      anon_sym_RPAREN,
  [10289] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
  [10296] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1441), 1,
      anon_sym_RPAREN,
  [10303] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1443), 1,
      anon_sym_RPAREN,
  [10310] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
  [10317] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1447), 1,
      anon_sym_RPAREN,
  [10324] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
  [10331] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1451), 1,
      anon_sym_RPAREN,
  [10338] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1453), 1,
      anon_sym_RPAREN,
  [10345] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1455), 1,
      anon_sym_RPAREN,
  [10352] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1457), 1,
      anon_sym_RPAREN,
  [10359] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1459), 1,
      anon_sym_RPAREN,
  [10366] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1461), 1,
      anon_sym_RPAREN,
  [10373] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1463), 1,
      anon_sym_RPAREN,
  [10380] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1465), 1,
      anon_sym_RPAREN,
  [10387] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
  [10394] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1469), 1,
      anon_sym_RPAREN,
  [10401] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1471), 1,
      anon_sym_RPAREN,
  [10408] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1473), 1,
      anon_sym_RPAREN,
  [10415] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1475), 1,
      anon_sym_RPAREN,
  [10422] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1477), 1,
      anon_sym_RPAREN,
  [10429] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
  [10436] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1481), 1,
      anon_sym_RPAREN,
  [10443] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1233), 1,
      anon_sym_RPAREN,
  [10450] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1483), 1,
      anon_sym_RPAREN,
  [10457] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
  [10464] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
  [10471] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1489), 1,
      anon_sym_RPAREN,
  [10478] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1491), 1,
      anon_sym_RPAREN,
  [10485] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1493), 1,
      anon_sym_RPAREN,
  [10492] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1495), 1,
      anon_sym_RPAREN,
  [10499] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1497), 1,
      anon_sym_RPAREN,
  [10506] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1499), 1,
      anon_sym_RPAREN,
  [10513] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1501), 1,
      anon_sym_RPAREN,
  [10520] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1503), 1,
      anon_sym_RPAREN,
  [10527] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1505), 1,
      anon_sym_RPAREN,
  [10534] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1507), 1,
      anon_sym_RPAREN,
  [10541] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1509), 1,
      anon_sym_RPAREN,
  [10548] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1511), 1,
      anon_sym_RPAREN,
  [10555] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1513), 1,
      anon_sym_RPAREN,
  [10562] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
  [10569] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1517), 1,
      anon_sym_RPAREN,
  [10576] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1519), 1,
      anon_sym_RPAREN,
  [10583] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
  [10590] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1523), 1,
      anon_sym_RPAREN,
  [10597] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
  [10604] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1527), 1,
      anon_sym_RPAREN,
  [10611] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1529), 1,
      anon_sym_RPAREN,
  [10618] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1531), 1,
      anon_sym_RPAREN,
  [10625] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1133), 1,
      anon_sym_RPAREN,
  [10632] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1137), 1,
      anon_sym_RPAREN,
  [10639] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1141), 1,
      anon_sym_RPAREN,
  [10646] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1145), 1,
      anon_sym_RPAREN,
  [10653] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1149), 1,
      anon_sym_RPAREN,
  [10660] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1153), 1,
      anon_sym_RPAREN,
  [10667] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1157), 1,
      anon_sym_RPAREN,
  [10674] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1533), 1,
      anon_sym_RPAREN,
  [10681] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1535), 1,
      anon_sym_RPAREN,
  [10688] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1537), 1,
      anon_sym_RPAREN,
  [10695] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1539), 1,
      anon_sym_RPAREN,
  [10702] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1541), 1,
      anon_sym_RPAREN,
  [10709] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1543), 1,
      anon_sym_RPAREN,
  [10716] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1161), 1,
      anon_sym_RPAREN,
  [10723] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1165), 1,
      anon_sym_RPAREN,
  [10730] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1545), 1,
      anon_sym_RPAREN,
  [10737] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1547), 1,
      anon_sym_RPAREN,
  [10744] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1549), 1,
      anon_sym_RPAREN,
  [10751] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1551), 1,
      anon_sym_RPAREN,
  [10758] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1169), 1,
      anon_sym_RPAREN,
  [10765] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1173), 1,
      anon_sym_RPAREN,
  [10772] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1553), 1,
      anon_sym_RPAREN,
  [10779] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1177), 1,
      anon_sym_RPAREN,
  [10786] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1181), 1,
      anon_sym_RPAREN,
  [10793] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1555), 1,
      anon_sym_RPAREN,
  [10800] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1557), 1,
      anon_sym_RPAREN,
  [10807] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1559), 1,
      anon_sym_RPAREN,
  [10814] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1561), 1,
      anon_sym_RPAREN,
  [10821] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1563), 1,
      anon_sym_RPAREN,
  [10828] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1189), 1,
      anon_sym_RPAREN,
  [10835] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1565), 1,
      anon_sym_RPAREN,
  [10842] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1193), 1,
      anon_sym_RPAREN,
  [10849] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1061), 1,
      anon_sym_RPAREN,
  [10856] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1205), 1,
      anon_sym_RPAREN,
  [10863] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1209), 1,
      anon_sym_RPAREN,
  [10870] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1057), 1,
      anon_sym_RPAREN,
  [10877] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1213), 1,
      anon_sym_RPAREN,
  [10884] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1069), 1,
      anon_sym_RPAREN,
  [10891] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1073), 1,
      anon_sym_RPAREN,
  [10898] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1077), 1,
      anon_sym_RPAREN,
  [10905] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1081), 1,
      anon_sym_RPAREN,
  [10912] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1217), 1,
      anon_sym_RPAREN,
  [10919] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1221), 1,
      anon_sym_RPAREN,
  [10926] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1225), 1,
      anon_sym_RPAREN,
  [10933] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1229), 1,
      anon_sym_RPAREN,
  [10940] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1237), 1,
      anon_sym_RPAREN,
  [10947] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1241), 1,
      anon_sym_RPAREN,
  [10954] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
  [10961] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1253), 1,
      anon_sym_RPAREN,
  [10968] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1257), 1,
      anon_sym_RPAREN,
  [10975] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1261), 1,
      anon_sym_RPAREN,
  [10982] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1089), 1,
      anon_sym_RPAREN,
  [10989] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1093), 1,
      anon_sym_RPAREN,
  [10996] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1097), 1,
      anon_sym_RPAREN,
  [11003] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1101), 1,
      anon_sym_RPAREN,
  [11010] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1265), 1,
      anon_sym_RPAREN,
  [11017] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1105), 1,
      anon_sym_RPAREN,
  [11024] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1109), 1,
      anon_sym_RPAREN,
  [11031] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1113), 1,
      anon_sym_RPAREN,
  [11038] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
  [11045] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1285), 1,
      anon_sym_RPAREN,
  [11052] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1277), 1,
      anon_sym_RPAREN,
  [11059] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1273), 1,
      anon_sym_RPAREN,
  [11066] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1269), 1,
      anon_sym_RPAREN,
  [11073] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
  [11080] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1125), 1,
      anon_sym_RPAREN,
  [11087] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1185), 1,
      anon_sym_RPAREN,
  [11094] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1197), 1,
      anon_sym_RPAREN,
  [11101] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1567), 1,
      anon_sym_RPAREN,
  [11108] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1245), 1,
      anon_sym_RPAREN,
  [11115] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
  [11122] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1281), 1,
      anon_sym_RPAREN,
  [11129] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1293), 1,
      anon_sym_RPAREN,
  [11136] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1289), 1,
      anon_sym_RPAREN,
  [11143] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1065), 1,
      anon_sym_RPAREN,
  [11150] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1121), 1,
      anon_sym_RPAREN,
  [11157] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1569), 1,
      anon_sym_RPAREN,
  [11164] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1571), 1,
      anon_sym_RPAREN,
  [11171] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1573), 1,
      anon_sym_RPAREN,
  [11178] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1575), 1,
      ts_builtin_sym_end,
  [11185] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1577), 1,
      anon_sym_RPAREN,
  [11192] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1579), 1,
      anon_sym_RPAREN,
  [11199] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1581), 1,
      anon_sym_RPAREN,
  [11206] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1583), 1,
      anon_sym_RPAREN,
  [11213] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1585), 1,
      anon_sym_RPAREN,
  [11220] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1587), 1,
      anon_sym_RPAREN,
  [11227] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1589), 1,
      anon_sym_RPAREN,
  [11234] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1591), 1,
      anon_sym_RPAREN,
  [11241] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1593), 1,
      anon_sym_RPAREN,
  [11248] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1595), 1,
      anon_sym_RPAREN,
  [11255] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1597), 1,
      anon_sym_RPAREN,
  [11262] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1599), 1,
      anon_sym_RPAREN,
  [11269] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1601), 1,
      anon_sym_RPAREN,
  [11276] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1603), 1,
      anon_sym_RPAREN,
  [11283] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1605), 1,
      anon_sym_RPAREN,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(242)] = 0,
  [SMALL_STATE(243)] = 65,
  [SMALL_STATE(244)] = 101,
  [SMALL_STATE(245)] = 137,
  [SMALL_STATE(246)] = 173,
  [SMALL_STATE(247)] = 209,
  [SMALL_STATE(248)] = 245,
  [SMALL_STATE(249)] = 281,
  [SMALL_STATE(250)] = 317,
  [SMALL_STATE(251)] = 353,
  [SMALL_STATE(252)] = 389,
  [SMALL_STATE(253)] = 425,
  [SMALL_STATE(254)] = 461,
  [SMALL_STATE(255)] = 497,
  [SMALL_STATE(256)] = 533,
  [SMALL_STATE(257)] = 569,
  [SMALL_STATE(258)] = 605,
  [SMALL_STATE(259)] = 641,
  [SMALL_STATE(260)] = 677,
  [SMALL_STATE(261)] = 713,
  [SMALL_STATE(262)] = 749,
  [SMALL_STATE(263)] = 785,
  [SMALL_STATE(264)] = 821,
  [SMALL_STATE(265)] = 857,
  [SMALL_STATE(266)] = 893,
  [SMALL_STATE(267)] = 929,
  [SMALL_STATE(268)] = 965,
  [SMALL_STATE(269)] = 1001,
  [SMALL_STATE(270)] = 1037,
  [SMALL_STATE(271)] = 1073,
  [SMALL_STATE(272)] = 1109,
  [SMALL_STATE(273)] = 1145,
  [SMALL_STATE(274)] = 1181,
  [SMALL_STATE(275)] = 1217,
  [SMALL_STATE(276)] = 1253,
  [SMALL_STATE(277)] = 1289,
  [SMALL_STATE(278)] = 1325,
  [SMALL_STATE(279)] = 1361,
  [SMALL_STATE(280)] = 1397,
  [SMALL_STATE(281)] = 1433,
  [SMALL_STATE(282)] = 1469,
  [SMALL_STATE(283)] = 1505,
  [SMALL_STATE(284)] = 1541,
  [SMALL_STATE(285)] = 1577,
  [SMALL_STATE(286)] = 1613,
  [SMALL_STATE(287)] = 1649,
  [SMALL_STATE(288)] = 1685,
  [SMALL_STATE(289)] = 1721,
  [SMALL_STATE(290)] = 1757,
  [SMALL_STATE(291)] = 1793,
  [SMALL_STATE(292)] = 1829,
  [SMALL_STATE(293)] = 1865,
  [SMALL_STATE(294)] = 1901,
  [SMALL_STATE(295)] = 1937,
  [SMALL_STATE(296)] = 1973,
  [SMALL_STATE(297)] = 2009,
  [SMALL_STATE(298)] = 2045,
  [SMALL_STATE(299)] = 2081,
  [SMALL_STATE(300)] = 2117,
  [SMALL_STATE(301)] = 2153,
  [SMALL_STATE(302)] = 2189,
  [SMALL_STATE(303)] = 2225,
  [SMALL_STATE(304)] = 2288,
  [SMALL_STATE(305)] = 2351,
  [SMALL_STATE(306)] = 2414,
  [SMALL_STATE(307)] = 2477,
  [SMALL_STATE(308)] = 2540,
  [SMALL_STATE(309)] = 2603,
  [SMALL_STATE(310)] = 2666,
  [SMALL_STATE(311)] = 2729,
  [SMALL_STATE(312)] = 2792,
  [SMALL_STATE(313)] = 2855,
  [SMALL_STATE(314)] = 2889,
  [SMALL_STATE(315)] = 2923,
  [SMALL_STATE(316)] = 2957,
  [SMALL_STATE(317)] = 2991,
  [SMALL_STATE(318)] = 3025,
  [SMALL_STATE(319)] = 3059,
  [SMALL_STATE(320)] = 3093,
  [SMALL_STATE(321)] = 3127,
  [SMALL_STATE(322)] = 3161,
  [SMALL_STATE(323)] = 3195,
  [SMALL_STATE(324)] = 3229,
  [SMALL_STATE(325)] = 3263,
  [SMALL_STATE(326)] = 3297,
  [SMALL_STATE(327)] = 3331,
  [SMALL_STATE(328)] = 3365,
  [SMALL_STATE(329)] = 3399,
  [SMALL_STATE(330)] = 3433,
  [SMALL_STATE(331)] = 3467,
  [SMALL_STATE(332)] = 3501,
  [SMALL_STATE(333)] = 3535,
  [SMALL_STATE(334)] = 3569,
  [SMALL_STATE(335)] = 3603,
  [SMALL_STATE(336)] = 3637,
  [SMALL_STATE(337)] = 3671,
  [SMALL_STATE(338)] = 3705,
  [SMALL_STATE(339)] = 3739,
  [SMALL_STATE(340)] = 3773,
  [SMALL_STATE(341)] = 3807,
  [SMALL_STATE(342)] = 3841,
  [SMALL_STATE(343)] = 3875,
  [SMALL_STATE(344)] = 3909,
  [SMALL_STATE(345)] = 3943,
  [SMALL_STATE(346)] = 3977,
  [SMALL_STATE(347)] = 4011,
  [SMALL_STATE(348)] = 4045,
  [SMALL_STATE(349)] = 4079,
  [SMALL_STATE(350)] = 4113,
  [SMALL_STATE(351)] = 4147,
  [SMALL_STATE(352)] = 4181,
  [SMALL_STATE(353)] = 4215,
  [SMALL_STATE(354)] = 4249,
  [SMALL_STATE(355)] = 4283,
  [SMALL_STATE(356)] = 4317,
  [SMALL_STATE(357)] = 4351,
  [SMALL_STATE(358)] = 4385,
  [SMALL_STATE(359)] = 4419,
  [SMALL_STATE(360)] = 4453,
  [SMALL_STATE(361)] = 4487,
  [SMALL_STATE(362)] = 4521,
  [SMALL_STATE(363)] = 4555,
  [SMALL_STATE(364)] = 4589,
  [SMALL_STATE(365)] = 4623,
  [SMALL_STATE(366)] = 4657,
  [SMALL_STATE(367)] = 4691,
  [SMALL_STATE(368)] = 4725,
  [SMALL_STATE(369)] = 4759,
  [SMALL_STATE(370)] = 4793,
  [SMALL_STATE(371)] = 4827,
  [SMALL_STATE(372)] = 4861,
  [SMALL_STATE(373)] = 4894,
  [SMALL_STATE(374)] = 4927,
  [SMALL_STATE(375)] = 4959,
  [SMALL_STATE(376)] = 4991,
  [SMALL_STATE(377)] = 5023,
  [SMALL_STATE(378)] = 5055,
  [SMALL_STATE(379)] = 5087,
  [SMALL_STATE(380)] = 5121,
  [SMALL_STATE(381)] = 5155,
  [SMALL_STATE(382)] = 5187,
  [SMALL_STATE(383)] = 5219,
  [SMALL_STATE(384)] = 5251,
  [SMALL_STATE(385)] = 5283,
  [SMALL_STATE(386)] = 5317,
  [SMALL_STATE(387)] = 5349,
  [SMALL_STATE(388)] = 5385,
  [SMALL_STATE(389)] = 5417,
  [SMALL_STATE(390)] = 5449,
  [SMALL_STATE(391)] = 5481,
  [SMALL_STATE(392)] = 5513,
  [SMALL_STATE(393)] = 5545,
  [SMALL_STATE(394)] = 5577,
  [SMALL_STATE(395)] = 5609,
  [SMALL_STATE(396)] = 5641,
  [SMALL_STATE(397)] = 5673,
  [SMALL_STATE(398)] = 5705,
  [SMALL_STATE(399)] = 5737,
  [SMALL_STATE(400)] = 5769,
  [SMALL_STATE(401)] = 5801,
  [SMALL_STATE(402)] = 5833,
  [SMALL_STATE(403)] = 5865,
  [SMALL_STATE(404)] = 5897,
  [SMALL_STATE(405)] = 5929,
  [SMALL_STATE(406)] = 5961,
  [SMALL_STATE(407)] = 5995,
  [SMALL_STATE(408)] = 6029,
  [SMALL_STATE(409)] = 6063,
  [SMALL_STATE(410)] = 6095,
  [SMALL_STATE(411)] = 6127,
  [SMALL_STATE(412)] = 6163,
  [SMALL_STATE(413)] = 6195,
  [SMALL_STATE(414)] = 6227,
  [SMALL_STATE(415)] = 6259,
  [SMALL_STATE(416)] = 6291,
  [SMALL_STATE(417)] = 6323,
  [SMALL_STATE(418)] = 6355,
  [SMALL_STATE(419)] = 6387,
  [SMALL_STATE(420)] = 6419,
  [SMALL_STATE(421)] = 6451,
  [SMALL_STATE(422)] = 6483,
  [SMALL_STATE(423)] = 6515,
  [SMALL_STATE(424)] = 6547,
  [SMALL_STATE(425)] = 6579,
  [SMALL_STATE(426)] = 6611,
  [SMALL_STATE(427)] = 6643,
  [SMALL_STATE(428)] = 6675,
  [SMALL_STATE(429)] = 6707,
  [SMALL_STATE(430)] = 6739,
  [SMALL_STATE(431)] = 6771,
  [SMALL_STATE(432)] = 6805,
  [SMALL_STATE(433)] = 6837,
  [SMALL_STATE(434)] = 6871,
  [SMALL_STATE(435)] = 6905,
  [SMALL_STATE(436)] = 6937,
  [SMALL_STATE(437)] = 6969,
  [SMALL_STATE(438)] = 7001,
  [SMALL_STATE(439)] = 7035,
  [SMALL_STATE(440)] = 7069,
  [SMALL_STATE(441)] = 7103,
  [SMALL_STATE(442)] = 7137,
  [SMALL_STATE(443)] = 7171,
  [SMALL_STATE(444)] = 7203,
  [SMALL_STATE(445)] = 7235,
  [SMALL_STATE(446)] = 7267,
  [SMALL_STATE(447)] = 7299,
  [SMALL_STATE(448)] = 7331,
  [SMALL_STATE(449)] = 7363,
  [SMALL_STATE(450)] = 7395,
  [SMALL_STATE(451)] = 7427,
  [SMALL_STATE(452)] = 7459,
  [SMALL_STATE(453)] = 7491,
  [SMALL_STATE(454)] = 7523,
  [SMALL_STATE(455)] = 7555,
  [SMALL_STATE(456)] = 7591,
  [SMALL_STATE(457)] = 7623,
  [SMALL_STATE(458)] = 7655,
  [SMALL_STATE(459)] = 7687,
  [SMALL_STATE(460)] = 7719,
  [SMALL_STATE(461)] = 7751,
  [SMALL_STATE(462)] = 7783,
  [SMALL_STATE(463)] = 7815,
  [SMALL_STATE(464)] = 7847,
  [SMALL_STATE(465)] = 7881,
  [SMALL_STATE(466)] = 7915,
  [SMALL_STATE(467)] = 7949,
  [SMALL_STATE(468)] = 7981,
  [SMALL_STATE(469)] = 8013,
  [SMALL_STATE(470)] = 8045,
  [SMALL_STATE(471)] = 8077,
  [SMALL_STATE(472)] = 8109,
  [SMALL_STATE(473)] = 8141,
  [SMALL_STATE(474)] = 8173,
  [SMALL_STATE(475)] = 8207,
  [SMALL_STATE(476)] = 8241,
  [SMALL_STATE(477)] = 8275,
  [SMALL_STATE(478)] = 8307,
  [SMALL_STATE(479)] = 8339,
  [SMALL_STATE(480)] = 8370,
  [SMALL_STATE(481)] = 8401,
  [SMALL_STATE(482)] = 8454,
  [SMALL_STATE(483)] = 8501,
  [SMALL_STATE(484)] = 8548,
  [SMALL_STATE(485)] = 8595,
  [SMALL_STATE(486)] = 8642,
  [SMALL_STATE(487)] = 8689,
  [SMALL_STATE(488)] = 8731,
  [SMALL_STATE(489)] = 8773,
  [SMALL_STATE(490)] = 8815,
  [SMALL_STATE(491)] = 8857,
  [SMALL_STATE(492)] = 8899,
  [SMALL_STATE(493)] = 8936,
  [SMALL_STATE(494)] = 8973,
  [SMALL_STATE(495)] = 9010,
  [SMALL_STATE(496)] = 9047,
  [SMALL_STATE(497)] = 9084,
  [SMALL_STATE(498)] = 9103,
  [SMALL_STATE(499)] = 9122,
  [SMALL_STATE(500)] = 9141,
  [SMALL_STATE(501)] = 9160,
  [SMALL_STATE(502)] = 9179,
  [SMALL_STATE(503)] = 9198,
  [SMALL_STATE(504)] = 9217,
  [SMALL_STATE(505)] = 9236,
  [SMALL_STATE(506)] = 9255,
  [SMALL_STATE(507)] = 9274,
  [SMALL_STATE(508)] = 9293,
  [SMALL_STATE(509)] = 9312,
  [SMALL_STATE(510)] = 9331,
  [SMALL_STATE(511)] = 9350,
  [SMALL_STATE(512)] = 9369,
  [SMALL_STATE(513)] = 9388,
  [SMALL_STATE(514)] = 9407,
  [SMALL_STATE(515)] = 9426,
  [SMALL_STATE(516)] = 9445,
  [SMALL_STATE(517)] = 9464,
  [SMALL_STATE(518)] = 9483,
  [SMALL_STATE(519)] = 9502,
  [SMALL_STATE(520)] = 9521,
  [SMALL_STATE(521)] = 9540,
  [SMALL_STATE(522)] = 9559,
  [SMALL_STATE(523)] = 9578,
  [SMALL_STATE(524)] = 9597,
  [SMALL_STATE(525)] = 9616,
  [SMALL_STATE(526)] = 9635,
  [SMALL_STATE(527)] = 9654,
  [SMALL_STATE(528)] = 9673,
  [SMALL_STATE(529)] = 9692,
  [SMALL_STATE(530)] = 9711,
  [SMALL_STATE(531)] = 9730,
  [SMALL_STATE(532)] = 9749,
  [SMALL_STATE(533)] = 9768,
  [SMALL_STATE(534)] = 9787,
  [SMALL_STATE(535)] = 9806,
  [SMALL_STATE(536)] = 9825,
  [SMALL_STATE(537)] = 9844,
  [SMALL_STATE(538)] = 9863,
  [SMALL_STATE(539)] = 9882,
  [SMALL_STATE(540)] = 9901,
  [SMALL_STATE(541)] = 9920,
  [SMALL_STATE(542)] = 9939,
  [SMALL_STATE(543)] = 9958,
  [SMALL_STATE(544)] = 9977,
  [SMALL_STATE(545)] = 9996,
  [SMALL_STATE(546)] = 10015,
  [SMALL_STATE(547)] = 10034,
  [SMALL_STATE(548)] = 10053,
  [SMALL_STATE(549)] = 10072,
  [SMALL_STATE(550)] = 10091,
  [SMALL_STATE(551)] = 10110,
  [SMALL_STATE(552)] = 10129,
  [SMALL_STATE(553)] = 10148,
  [SMALL_STATE(554)] = 10167,
  [SMALL_STATE(555)] = 10186,
  [SMALL_STATE(556)] = 10205,
  [SMALL_STATE(557)] = 10224,
  [SMALL_STATE(558)] = 10243,
  [SMALL_STATE(559)] = 10259,
  [SMALL_STATE(560)] = 10275,
  [SMALL_STATE(561)] = 10282,
  [SMALL_STATE(562)] = 10289,
  [SMALL_STATE(563)] = 10296,
  [SMALL_STATE(564)] = 10303,
  [SMALL_STATE(565)] = 10310,
  [SMALL_STATE(566)] = 10317,
  [SMALL_STATE(567)] = 10324,
  [SMALL_STATE(568)] = 10331,
  [SMALL_STATE(569)] = 10338,
  [SMALL_STATE(570)] = 10345,
  [SMALL_STATE(571)] = 10352,
  [SMALL_STATE(572)] = 10359,
  [SMALL_STATE(573)] = 10366,
  [SMALL_STATE(574)] = 10373,
  [SMALL_STATE(575)] = 10380,
  [SMALL_STATE(576)] = 10387,
  [SMALL_STATE(577)] = 10394,
  [SMALL_STATE(578)] = 10401,
  [SMALL_STATE(579)] = 10408,
  [SMALL_STATE(580)] = 10415,
  [SMALL_STATE(581)] = 10422,
  [SMALL_STATE(582)] = 10429,
  [SMALL_STATE(583)] = 10436,
  [SMALL_STATE(584)] = 10443,
  [SMALL_STATE(585)] = 10450,
  [SMALL_STATE(586)] = 10457,
  [SMALL_STATE(587)] = 10464,
  [SMALL_STATE(588)] = 10471,
  [SMALL_STATE(589)] = 10478,
  [SMALL_STATE(590)] = 10485,
  [SMALL_STATE(591)] = 10492,
  [SMALL_STATE(592)] = 10499,
  [SMALL_STATE(593)] = 10506,
  [SMALL_STATE(594)] = 10513,
  [SMALL_STATE(595)] = 10520,
  [SMALL_STATE(596)] = 10527,
  [SMALL_STATE(597)] = 10534,
  [SMALL_STATE(598)] = 10541,
  [SMALL_STATE(599)] = 10548,
  [SMALL_STATE(600)] = 10555,
  [SMALL_STATE(601)] = 10562,
  [SMALL_STATE(602)] = 10569,
  [SMALL_STATE(603)] = 10576,
  [SMALL_STATE(604)] = 10583,
  [SMALL_STATE(605)] = 10590,
  [SMALL_STATE(606)] = 10597,
  [SMALL_STATE(607)] = 10604,
  [SMALL_STATE(608)] = 10611,
  [SMALL_STATE(609)] = 10618,
  [SMALL_STATE(610)] = 10625,
  [SMALL_STATE(611)] = 10632,
  [SMALL_STATE(612)] = 10639,
  [SMALL_STATE(613)] = 10646,
  [SMALL_STATE(614)] = 10653,
  [SMALL_STATE(615)] = 10660,
  [SMALL_STATE(616)] = 10667,
  [SMALL_STATE(617)] = 10674,
  [SMALL_STATE(618)] = 10681,
  [SMALL_STATE(619)] = 10688,
  [SMALL_STATE(620)] = 10695,
  [SMALL_STATE(621)] = 10702,
  [SMALL_STATE(622)] = 10709,
  [SMALL_STATE(623)] = 10716,
  [SMALL_STATE(624)] = 10723,
  [SMALL_STATE(625)] = 10730,
  [SMALL_STATE(626)] = 10737,
  [SMALL_STATE(627)] = 10744,
  [SMALL_STATE(628)] = 10751,
  [SMALL_STATE(629)] = 10758,
  [SMALL_STATE(630)] = 10765,
  [SMALL_STATE(631)] = 10772,
  [SMALL_STATE(632)] = 10779,
  [SMALL_STATE(633)] = 10786,
  [SMALL_STATE(634)] = 10793,
  [SMALL_STATE(635)] = 10800,
  [SMALL_STATE(636)] = 10807,
  [SMALL_STATE(637)] = 10814,
  [SMALL_STATE(638)] = 10821,
  [SMALL_STATE(639)] = 10828,
  [SMALL_STATE(640)] = 10835,
  [SMALL_STATE(641)] = 10842,
  [SMALL_STATE(642)] = 10849,
  [SMALL_STATE(643)] = 10856,
  [SMALL_STATE(644)] = 10863,
  [SMALL_STATE(645)] = 10870,
  [SMALL_STATE(646)] = 10877,
  [SMALL_STATE(647)] = 10884,
  [SMALL_STATE(648)] = 10891,
  [SMALL_STATE(649)] = 10898,
  [SMALL_STATE(650)] = 10905,
  [SMALL_STATE(651)] = 10912,
  [SMALL_STATE(652)] = 10919,
  [SMALL_STATE(653)] = 10926,
  [SMALL_STATE(654)] = 10933,
  [SMALL_STATE(655)] = 10940,
  [SMALL_STATE(656)] = 10947,
  [SMALL_STATE(657)] = 10954,
  [SMALL_STATE(658)] = 10961,
  [SMALL_STATE(659)] = 10968,
  [SMALL_STATE(660)] = 10975,
  [SMALL_STATE(661)] = 10982,
  [SMALL_STATE(662)] = 10989,
  [SMALL_STATE(663)] = 10996,
  [SMALL_STATE(664)] = 11003,
  [SMALL_STATE(665)] = 11010,
  [SMALL_STATE(666)] = 11017,
  [SMALL_STATE(667)] = 11024,
  [SMALL_STATE(668)] = 11031,
  [SMALL_STATE(669)] = 11038,
  [SMALL_STATE(670)] = 11045,
  [SMALL_STATE(671)] = 11052,
  [SMALL_STATE(672)] = 11059,
  [SMALL_STATE(673)] = 11066,
  [SMALL_STATE(674)] = 11073,
  [SMALL_STATE(675)] = 11080,
  [SMALL_STATE(676)] = 11087,
  [SMALL_STATE(677)] = 11094,
  [SMALL_STATE(678)] = 11101,
  [SMALL_STATE(679)] = 11108,
  [SMALL_STATE(680)] = 11115,
  [SMALL_STATE(681)] = 11122,
  [SMALL_STATE(682)] = 11129,
  [SMALL_STATE(683)] = 11136,
  [SMALL_STATE(684)] = 11143,
  [SMALL_STATE(685)] = 11150,
  [SMALL_STATE(686)] = 11157,
  [SMALL_STATE(687)] = 11164,
  [SMALL_STATE(688)] = 11171,
  [SMALL_STATE(689)] = 11178,
  [SMALL_STATE(690)] = 11185,
  [SMALL_STATE(691)] = 11192,
  [SMALL_STATE(692)] = 11199,
  [SMALL_STATE(693)] = 11206,
  [SMALL_STATE(694)] = 11213,
  [SMALL_STATE(695)] = 11220,
  [SMALL_STATE(696)] = 11227,
  [SMALL_STATE(697)] = 11234,
  [SMALL_STATE(698)] = 11241,
  [SMALL_STATE(699)] = 11248,
  [SMALL_STATE(700)] = 11255,
  [SMALL_STATE(701)] = 11262,
  [SMALL_STATE(702)] = 11269,
  [SMALL_STATE(703)] = 11276,
  [SMALL_STATE(704)] = 11283,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(389),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(493),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(225),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(494),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(482),
  [229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(261),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(4),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23),
  [283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(106),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(107),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(108),
  [292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(43),
  [295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(42),
  [298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23),
  [300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(220),
  [303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(223),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(228),
  [309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(241),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(186),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(301),
  [318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(302),
  [321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(299),
  [324] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(301),
  [327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(261),
  [330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(259),
  [333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(245),
  [336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(331),
  [379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(6),
  [382] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(92),
  [385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(89),
  [388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(88),
  [391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(52),
  [394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(47),
  [397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(195),
  [400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(196),
  [403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(181),
  [406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(198),
  [409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(199),
  [412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(337),
  [415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(333),
  [418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(332),
  [421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(337),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(331),
  [427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(339),
  [430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 23), SHIFT_REPEAT(338),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(331),
  [498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(6),
  [501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(92),
  [504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(89),
  [507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(88),
  [510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(52),
  [513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10),
  [515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(47),
  [518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(195),
  [521] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(196),
  [524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(181),
  [527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(198),
  [530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(199),
  [533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(337),
  [536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(333),
  [539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(332),
  [542] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(337),
  [545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(331),
  [548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(339),
  [551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(338),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(331),
  [565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(6),
  [568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7),
  [570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(92),
  [573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(89),
  [576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(88),
  [579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(52),
  [582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(47),
  [585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(195),
  [588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(196),
  [591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(181),
  [594] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(198),
  [597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(199),
  [600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(337),
  [603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(333),
  [606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(332),
  [609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(337),
  [612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(331),
  [615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(339),
  [618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(338),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(401),
  [680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2),
  [683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(112),
  [686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(96),
  [689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(97),
  [692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(44),
  [695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(40),
  [698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(205),
  [701] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(204),
  [704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(201),
  [707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(194),
  [710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(193),
  [713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(386),
  [716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(388),
  [719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(389),
  [722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(386),
  [725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(401),
  [728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(421),
  [731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(381),
  [734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 1, .production_id = 5),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(331),
  [789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(6),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13),
  [794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(92),
  [797] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(89),
  [800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(88),
  [803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(52),
  [806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(47),
  [809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(195),
  [812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(196),
  [815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(181),
  [818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(198),
  [821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(199),
  [824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(337),
  [827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(333),
  [830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(332),
  [833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(337),
  [836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(331),
  [839] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(339),
  [842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 13), SHIFT_REPEAT(338),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [1029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(558),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [1034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(52),
  [1037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(195),
  [1040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(196),
  [1043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(181),
  [1046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(198),
  [1049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(479),
  [1052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(339),
  [1055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 4, .production_id = 12),
  [1057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 4, .production_id = 12),
  [1059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_upscope, 4, .production_id = 12),
  [1061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_upscope, 4, .production_id = 12),
  [1063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_buffer_literal, 1),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_buffer_literal, 1),
  [1067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote, 4),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote, 4),
  [1071] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 4),
  [1073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 4),
  [1075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 4),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 4),
  [1079] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 4),
  [1081] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 4),
  [1083] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 15),
  [1085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 15),
  [1087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unquote, 3),
  [1089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unquote, 3),
  [1091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 3),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 3),
  [1095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 3),
  [1097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 3),
  [1099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 3),
  [1101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 3),
  [1103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_unquote, 2),
  [1105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_unquote, 2),
  [1107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_quasiquote, 2),
  [1109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_quasiquote, 2),
  [1111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_splice, 2),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_splice, 2),
  [1115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_quote, 2),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_quote, 2),
  [1119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_long_str_literal, 1),
  [1121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_long_str_literal, 1),
  [1123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier, 1),
  [1129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier, 1),
  [1131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 7, .production_id = 32),
  [1133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 7, .production_id = 32),
  [1135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 6, .production_id = 30),
  [1137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 6, .production_id = 30),
  [1139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 6, .production_id = 29),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 6, .production_id = 29),
  [1147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 6, .production_id = 27),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 6, .production_id = 27),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 6, .production_id = 26),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 6, .production_id = 26),
  [1155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 6, .production_id = 26),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 6, .production_id = 26),
  [1159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extra_defs, 5, .production_id = 25),
  [1161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extra_defs, 5, .production_id = 25),
  [1163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 5, .production_id = 25),
  [1165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 5, .production_id = 25),
  [1167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 5, .production_id = 24),
  [1169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 5, .production_id = 24),
  [1171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 5, .production_id = 21),
  [1173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 5, .production_id = 21),
  [1175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, .production_id = 20),
  [1177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, .production_id = 20),
  [1179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var, 5, .production_id = 18),
  [1181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var, 5, .production_id = 18),
  [1183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__specials, 1),
  [1185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__specials, 1),
  [1187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_def, 5, .production_id = 18),
  [1189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_def, 5, .production_id = 18),
  [1191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 5, .production_id = 17),
  [1193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 5, .production_id = 17),
  [1195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__shorthand, 1),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__shorthand, 1),
  [1199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_tuple, 2),
  [1201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_tuple, 2),
  [1203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fn, 4, .production_id = 16),
  [1205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fn, 4, .production_id = 16),
  [1207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 4, .production_id = 14),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 4, .production_id = 14),
  [1211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 4),
  [1213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 4),
  [1215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_peg_set, 4),
  [1217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_peg_set, 4),
  [1219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 3, .production_id = 9),
  [1221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 3, .production_id = 9),
  [1223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 3, .production_id = 9),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 3, .production_id = 9),
  [1227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__special_forms, 1),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__special_forms, 1),
  [1235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3, .production_id = 6),
  [1237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3, .production_id = 6),
  [1239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expr, 1),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expr, 1),
  [1247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_upscope, 3),
  [1253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_upscope, 3),
  [1255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do, 3),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do, 3),
  [1259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break, 3),
  [1261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break, 3),
  [1263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [1269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [1271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sqr_array, 2),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sqr_array, 2),
  [1275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct, 2),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct, 2),
  [1279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool_literal, 1),
  [1281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool_literal, 1),
  [1283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table, 2),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table, 2),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literals, 1),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literals, 1),
  [1291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_number_literal, 1),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_number_literal, 1),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [1303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, .production_id = 22),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, .production_id = 22),
  [1311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4, .production_id = 28),
  [1313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4, .production_id = 28),
  [1315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 4, .production_id = 22),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 4, .production_id = 22),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1321] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 4, .production_id = 28),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 4, .production_id = 28),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_metadata, 1),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_metadata, 1),
  [1329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, .production_id = 22),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, .production_id = 22),
  [1333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3),
  [1335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [1337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 3, .production_id = 22),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 3, .production_id = 22),
  [1341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 3),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 3),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [1349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__parameters, 1),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 5, .production_id = 31),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 5, .production_id = 31),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5, .production_id = 31),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5, .production_id = 31),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [1363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_parameters, 2),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_parameters, 2),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1373] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name, 1),
  [1375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 1),
  [1377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [1383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(559),
  [1396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(25),
  [1399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(190),
  [1402] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(189),
  [1405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(188),
  [1408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(187),
  [1411] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(513),
  [1414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(527),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1575] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_janet_external_scanner_create(void);
void tree_sitter_janet_external_scanner_destroy(void *);
bool tree_sitter_janet_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_janet_external_scanner_serialize(void *, char *);
void tree_sitter_janet_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_janet(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_symbol,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_janet_external_scanner_create,
      tree_sitter_janet_external_scanner_destroy,
      tree_sitter_janet_external_scanner_scan,
      tree_sitter_janet_external_scanner_serialize,
      tree_sitter_janet_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
