#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 873
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 143
#define ALIAS_COUNT 0
#define TOKEN_COUNT 89
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 13
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 19

enum ts_symbol_identifiers {
  anon_sym_ATclass = 1,
  anon_sym_LPARENexact_RPAREN = 2,
  anon_sym_COLON = 3,
  anon_sym_COMMA = 4,
  anon_sym_ATtype = 5,
  anon_sym_ATparam = 6,
  anon_sym_DOT_DOT_DOT = 7,
  anon_sym_QMARK = 8,
  anon_sym_ATalias = 9,
  anon_sym_PIPE = 10,
  anon_sym_ATreturn = 11,
  anon_sym_ATfield = 12,
  anon_sym_ATpublic = 13,
  anon_sym_ATprotected = 14,
  anon_sym_ATprivate = 15,
  anon_sym_ATgeneric = 16,
  anon_sym_ATvararg = 17,
  anon_sym_ATdiagnostic = 18,
  anon_sym_ATmeta = 19,
  anon_sym_ATmodule = 20,
  anon_sym_ATsource = 21,
  anon_sym_DOT = 22,
  anon_sym_ATversion = 23,
  anon_sym_5_DOT1 = 24,
  anon_sym_5_DOT2 = 25,
  anon_sym_5_DOT3 = 26,
  anon_sym_5_DOT4 = 27,
  anon_sym_JIT = 28,
  anon_sym_ATpackage = 29,
  anon_sym_AToperator = 30,
  anon_sym_LPAREN = 31,
  anon_sym_RPAREN = 32,
  anon_sym_ATnodiscard = 33,
  anon_sym_ATdeprecated = 34,
  anon_sym_ATcast = 35,
  anon_sym_DASH = 36,
  anon_sym_PLUS = 37,
  anon_sym_ATasync = 38,
  anon_sym_AToverload = 39,
  anon_sym_ATenum = 40,
  anon_sym_LPARENkey_RPAREN = 41,
  anon_sym_ATlanguage = 42,
  anon_sym_ATsee = 43,
  aux_sym_link_reference_token1 = 44,
  anon_sym_LBRACE = 45,
  anon_sym_ATlink = 46,
  anon_sym_RBRACE = 47,
  anon_sym_ATsince = 48,
  anon_sym_LBRACK_LBRACK = 49,
  anon_sym_ATas = 50,
  anon_sym_RBRACK_RBRACK = 51,
  anon_sym_LBRACK_EQ_LBRACK = 52,
  anon_sym_RBRACK_EQ_RBRACK = 53,
  anon_sym_public = 54,
  anon_sym_protected = 55,
  anon_sym_private = 56,
  anon_sym_package = 57,
  anon_sym_AT = 58,
  anon_sym_extends = 59,
  sym_comment = 60,
  anon_sym_LBRACK = 61,
  anon_sym_RBRACK = 62,
  anon_sym_table = 63,
  anon_sym_LT = 64,
  anon_sym_GT = 65,
  anon_sym_RBRACK2 = 66,
  anon_sym_fun = 67,
  anon_sym_function = 68,
  anon_sym_self = 69,
  anon_sym_POUND = 70,
  anon_sym_DQUOTE = 71,
  aux_sym_literal_type_token1 = 72,
  anon_sym_SQUOTE = 73,
  aux_sym_literal_type_token2 = 74,
  anon_sym_BQUOTE = 75,
  anon_sym_any = 76,
  anon_sym_boolean = 77,
  anon_sym_CFunction = 78,
  anon_sym_nil = 79,
  anon_sym_number = 80,
  anon_sym_string = 81,
  anon_sym_userdata = 82,
  anon_sym_void = 83,
  sym_string = 84,
  sym_number = 85,
  sym_numeric_literal_type = 86,
  sym_identifier = 87,
  sym_diagnostic_identifier = 88,
  sym_documentation = 89,
  sym_class_annotation = 90,
  sym_type_annotation = 91,
  sym_param_annotation = 92,
  sym_alias_annotation = 93,
  sym_continuation = 94,
  sym_return_annotation = 95,
  sym_field_annotation = 96,
  sym_qualifier_annotation = 97,
  sym_generic_annotation = 98,
  sym_vararg_annotation = 99,
  sym_diagnostic_annotation = 100,
  sym_meta_annotation = 101,
  sym_module_annotation = 102,
  sym_source_annotation = 103,
  sym_version_annotation = 104,
  sym_package_annotation = 105,
  sym_operator_annotation = 106,
  sym_nodiscard_annotation = 107,
  sym_deprecated_annotation = 108,
  sym_cast_annotation = 109,
  sym_async_annotation = 110,
  sym_overload_annotation = 111,
  sym_enum_annotation = 112,
  sym_language_injection = 113,
  sym_see_reference = 114,
  sym_link_reference = 115,
  sym_since_annotation = 116,
  sym_as_annotation = 117,
  sym_qualifier = 118,
  sym_class_at_comment = 119,
  sym_at_comment = 120,
  sym_type = 121,
  sym_array_type = 122,
  sym_table_type = 123,
  sym_table_literal_type = 124,
  sym_union_type = 125,
  sym_parenthesized_type = 126,
  sym_tuple_type = 127,
  sym_function_type = 128,
  sym_parameter = 129,
  sym_member_type = 130,
  sym_optional_type = 131,
  sym_literal_type = 132,
  sym_custom_type = 133,
  sym_builtin_type = 134,
  sym_positional_field = 135,
  sym_indexed_field = 136,
  aux_sym_class_annotation_repeat1 = 137,
  aux_sym_type_annotation_repeat1 = 138,
  aux_sym_diagnostic_annotation_repeat1 = 139,
  aux_sym_cast_annotation_repeat1 = 140,
  aux_sym_table_literal_type_repeat1 = 141,
  aux_sym_function_type_repeat1 = 142,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_ATclass] = "@class",
  [anon_sym_LPARENexact_RPAREN] = "(exact)",
  [anon_sym_COLON] = ":",
  [anon_sym_COMMA] = ",",
  [anon_sym_ATtype] = "@type",
  [anon_sym_ATparam] = "@param",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "\?",
  [anon_sym_ATalias] = "@alias",
  [anon_sym_PIPE] = "|",
  [anon_sym_ATreturn] = "@return",
  [anon_sym_ATfield] = "@field",
  [anon_sym_ATpublic] = "@public",
  [anon_sym_ATprotected] = "@protected",
  [anon_sym_ATprivate] = "@private",
  [anon_sym_ATgeneric] = "@generic",
  [anon_sym_ATvararg] = "@vararg",
  [anon_sym_ATdiagnostic] = "@diagnostic",
  [anon_sym_ATmeta] = "@meta",
  [anon_sym_ATmodule] = "@module",
  [anon_sym_ATsource] = "@source",
  [anon_sym_DOT] = ".",
  [anon_sym_ATversion] = "@version",
  [anon_sym_5_DOT1] = "5.1",
  [anon_sym_5_DOT2] = "5.2",
  [anon_sym_5_DOT3] = "5.3",
  [anon_sym_5_DOT4] = "5.4",
  [anon_sym_JIT] = "JIT",
  [anon_sym_ATpackage] = "@package",
  [anon_sym_AToperator] = "@operator",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_ATnodiscard] = "@nodiscard",
  [anon_sym_ATdeprecated] = "@deprecated",
  [anon_sym_ATcast] = "@cast",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [anon_sym_ATasync] = "@async",
  [anon_sym_AToverload] = "@overload",
  [anon_sym_ATenum] = "@enum",
  [anon_sym_LPARENkey_RPAREN] = "(key)",
  [anon_sym_ATlanguage] = "@language",
  [anon_sym_ATsee] = "@see",
  [aux_sym_link_reference_token1] = "comment",
  [anon_sym_LBRACE] = "{",
  [anon_sym_ATlink] = "@link",
  [anon_sym_RBRACE] = "}",
  [anon_sym_ATsince] = "@since",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_ATas] = "@as",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_LBRACK_EQ_LBRACK] = "[=[",
  [anon_sym_RBRACK_EQ_RBRACK] = "]=]",
  [anon_sym_public] = "public",
  [anon_sym_protected] = "protected",
  [anon_sym_private] = "private",
  [anon_sym_package] = "package",
  [anon_sym_AT] = "@",
  [anon_sym_extends] = "extends",
  [sym_comment] = "comment",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_table] = "table",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_RBRACK2] = "]",
  [anon_sym_fun] = "fun",
  [anon_sym_function] = "function",
  [anon_sym_self] = "self",
  [anon_sym_POUND] = "#",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_literal_type_token1] = "literal_type_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_literal_type_token2] = "literal_type_token2",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_any] = "any",
  [anon_sym_boolean] = "boolean",
  [anon_sym_CFunction] = "CFunction",
  [anon_sym_nil] = "nil",
  [anon_sym_number] = "number",
  [anon_sym_string] = "string",
  [anon_sym_userdata] = "userdata",
  [anon_sym_void] = "void",
  [sym_string] = "string",
  [sym_number] = "number",
  [sym_numeric_literal_type] = "numeric_literal_type",
  [sym_identifier] = "identifier",
  [sym_diagnostic_identifier] = "diagnostic_identifier",
  [sym_documentation] = "documentation",
  [sym_class_annotation] = "class_annotation",
  [sym_type_annotation] = "type_annotation",
  [sym_param_annotation] = "param_annotation",
  [sym_alias_annotation] = "alias_annotation",
  [sym_continuation] = "continuation",
  [sym_return_annotation] = "return_annotation",
  [sym_field_annotation] = "field_annotation",
  [sym_qualifier_annotation] = "qualifier_annotation",
  [sym_generic_annotation] = "generic_annotation",
  [sym_vararg_annotation] = "vararg_annotation",
  [sym_diagnostic_annotation] = "diagnostic_annotation",
  [sym_meta_annotation] = "meta_annotation",
  [sym_module_annotation] = "module_annotation",
  [sym_source_annotation] = "source_annotation",
  [sym_version_annotation] = "version_annotation",
  [sym_package_annotation] = "package_annotation",
  [sym_operator_annotation] = "operator_annotation",
  [sym_nodiscard_annotation] = "nodiscard_annotation",
  [sym_deprecated_annotation] = "deprecated_annotation",
  [sym_cast_annotation] = "cast_annotation",
  [sym_async_annotation] = "async_annotation",
  [sym_overload_annotation] = "overload_annotation",
  [sym_enum_annotation] = "enum_annotation",
  [sym_language_injection] = "language_injection",
  [sym_see_reference] = "see_reference",
  [sym_link_reference] = "link_reference",
  [sym_since_annotation] = "since_annotation",
  [sym_as_annotation] = "as_annotation",
  [sym_qualifier] = "qualifier",
  [sym_class_at_comment] = "class_at_comment",
  [sym_at_comment] = "at_comment",
  [sym_type] = "type",
  [sym_array_type] = "array_type",
  [sym_table_type] = "table_type",
  [sym_table_literal_type] = "table_literal_type",
  [sym_union_type] = "union_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_tuple_type] = "tuple_type",
  [sym_function_type] = "function_type",
  [sym_parameter] = "parameter",
  [sym_member_type] = "member_type",
  [sym_optional_type] = "optional_type",
  [sym_literal_type] = "literal_type",
  [sym_custom_type] = "custom_type",
  [sym_builtin_type] = "builtin_type",
  [sym_positional_field] = "positional_field",
  [sym_indexed_field] = "indexed_field",
  [aux_sym_class_annotation_repeat1] = "class_annotation_repeat1",
  [aux_sym_type_annotation_repeat1] = "type_annotation_repeat1",
  [aux_sym_diagnostic_annotation_repeat1] = "diagnostic_annotation_repeat1",
  [aux_sym_cast_annotation_repeat1] = "cast_annotation_repeat1",
  [aux_sym_table_literal_type_repeat1] = "table_literal_type_repeat1",
  [aux_sym_function_type_repeat1] = "function_type_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_ATclass] = anon_sym_ATclass,
  [anon_sym_LPARENexact_RPAREN] = anon_sym_LPARENexact_RPAREN,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_ATtype] = anon_sym_ATtype,
  [anon_sym_ATparam] = anon_sym_ATparam,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_ATalias] = anon_sym_ATalias,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_ATreturn] = anon_sym_ATreturn,
  [anon_sym_ATfield] = anon_sym_ATfield,
  [anon_sym_ATpublic] = anon_sym_ATpublic,
  [anon_sym_ATprotected] = anon_sym_ATprotected,
  [anon_sym_ATprivate] = anon_sym_ATprivate,
  [anon_sym_ATgeneric] = anon_sym_ATgeneric,
  [anon_sym_ATvararg] = anon_sym_ATvararg,
  [anon_sym_ATdiagnostic] = anon_sym_ATdiagnostic,
  [anon_sym_ATmeta] = anon_sym_ATmeta,
  [anon_sym_ATmodule] = anon_sym_ATmodule,
  [anon_sym_ATsource] = anon_sym_ATsource,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_ATversion] = anon_sym_ATversion,
  [anon_sym_5_DOT1] = anon_sym_5_DOT1,
  [anon_sym_5_DOT2] = anon_sym_5_DOT2,
  [anon_sym_5_DOT3] = anon_sym_5_DOT3,
  [anon_sym_5_DOT4] = anon_sym_5_DOT4,
  [anon_sym_JIT] = anon_sym_JIT,
  [anon_sym_ATpackage] = anon_sym_ATpackage,
  [anon_sym_AToperator] = anon_sym_AToperator,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_ATnodiscard] = anon_sym_ATnodiscard,
  [anon_sym_ATdeprecated] = anon_sym_ATdeprecated,
  [anon_sym_ATcast] = anon_sym_ATcast,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_ATasync] = anon_sym_ATasync,
  [anon_sym_AToverload] = anon_sym_AToverload,
  [anon_sym_ATenum] = anon_sym_ATenum,
  [anon_sym_LPARENkey_RPAREN] = anon_sym_LPARENkey_RPAREN,
  [anon_sym_ATlanguage] = anon_sym_ATlanguage,
  [anon_sym_ATsee] = anon_sym_ATsee,
  [aux_sym_link_reference_token1] = sym_comment,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_ATlink] = anon_sym_ATlink,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_ATsince] = anon_sym_ATsince,
  [anon_sym_LBRACK_LBRACK] = anon_sym_LBRACK_LBRACK,
  [anon_sym_ATas] = anon_sym_ATas,
  [anon_sym_RBRACK_RBRACK] = anon_sym_RBRACK_RBRACK,
  [anon_sym_LBRACK_EQ_LBRACK] = anon_sym_LBRACK_EQ_LBRACK,
  [anon_sym_RBRACK_EQ_RBRACK] = anon_sym_RBRACK_EQ_RBRACK,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_package] = anon_sym_package,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_extends] = anon_sym_extends,
  [sym_comment] = sym_comment,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_table] = anon_sym_table,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_RBRACK2] = anon_sym_RBRACK,
  [anon_sym_fun] = anon_sym_fun,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_self] = anon_sym_self,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_literal_type_token1] = aux_sym_literal_type_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_literal_type_token2] = aux_sym_literal_type_token2,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_CFunction] = anon_sym_CFunction,
  [anon_sym_nil] = anon_sym_nil,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_userdata] = anon_sym_userdata,
  [anon_sym_void] = anon_sym_void,
  [sym_string] = sym_string,
  [sym_number] = sym_number,
  [sym_numeric_literal_type] = sym_numeric_literal_type,
  [sym_identifier] = sym_identifier,
  [sym_diagnostic_identifier] = sym_diagnostic_identifier,
  [sym_documentation] = sym_documentation,
  [sym_class_annotation] = sym_class_annotation,
  [sym_type_annotation] = sym_type_annotation,
  [sym_param_annotation] = sym_param_annotation,
  [sym_alias_annotation] = sym_alias_annotation,
  [sym_continuation] = sym_continuation,
  [sym_return_annotation] = sym_return_annotation,
  [sym_field_annotation] = sym_field_annotation,
  [sym_qualifier_annotation] = sym_qualifier_annotation,
  [sym_generic_annotation] = sym_generic_annotation,
  [sym_vararg_annotation] = sym_vararg_annotation,
  [sym_diagnostic_annotation] = sym_diagnostic_annotation,
  [sym_meta_annotation] = sym_meta_annotation,
  [sym_module_annotation] = sym_module_annotation,
  [sym_source_annotation] = sym_source_annotation,
  [sym_version_annotation] = sym_version_annotation,
  [sym_package_annotation] = sym_package_annotation,
  [sym_operator_annotation] = sym_operator_annotation,
  [sym_nodiscard_annotation] = sym_nodiscard_annotation,
  [sym_deprecated_annotation] = sym_deprecated_annotation,
  [sym_cast_annotation] = sym_cast_annotation,
  [sym_async_annotation] = sym_async_annotation,
  [sym_overload_annotation] = sym_overload_annotation,
  [sym_enum_annotation] = sym_enum_annotation,
  [sym_language_injection] = sym_language_injection,
  [sym_see_reference] = sym_see_reference,
  [sym_link_reference] = sym_link_reference,
  [sym_since_annotation] = sym_since_annotation,
  [sym_as_annotation] = sym_as_annotation,
  [sym_qualifier] = sym_qualifier,
  [sym_class_at_comment] = sym_class_at_comment,
  [sym_at_comment] = sym_at_comment,
  [sym_type] = sym_type,
  [sym_array_type] = sym_array_type,
  [sym_table_type] = sym_table_type,
  [sym_table_literal_type] = sym_table_literal_type,
  [sym_union_type] = sym_union_type,
  [sym_parenthesized_type] = sym_parenthesized_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_function_type] = sym_function_type,
  [sym_parameter] = sym_parameter,
  [sym_member_type] = sym_member_type,
  [sym_optional_type] = sym_optional_type,
  [sym_literal_type] = sym_literal_type,
  [sym_custom_type] = sym_custom_type,
  [sym_builtin_type] = sym_builtin_type,
  [sym_positional_field] = sym_positional_field,
  [sym_indexed_field] = sym_indexed_field,
  [aux_sym_class_annotation_repeat1] = aux_sym_class_annotation_repeat1,
  [aux_sym_type_annotation_repeat1] = aux_sym_type_annotation_repeat1,
  [aux_sym_diagnostic_annotation_repeat1] = aux_sym_diagnostic_annotation_repeat1,
  [aux_sym_cast_annotation_repeat1] = aux_sym_cast_annotation_repeat1,
  [aux_sym_table_literal_type_repeat1] = aux_sym_table_literal_type_repeat1,
  [aux_sym_function_type_repeat1] = aux_sym_function_type_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_ATclass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPARENexact_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATtype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATparam] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATalias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATreturn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATfield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATpublic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATprotected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATprivate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATgeneric] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATvararg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATdiagnostic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATmeta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATmodule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATsource] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATversion] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_5_DOT1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_5_DOT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_5_DOT3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_5_DOT4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_JIT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATpackage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AToperator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATnodiscard] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATdeprecated] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATcast] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATasync] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AToverload] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATenum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPARENkey_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATlanguage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATsee] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_link_reference_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATlink] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATsince] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATas] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_EQ_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_EQ_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_package] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_table] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fun] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_self] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_literal_type_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_literal_type_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CFunction] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_userdata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_numeric_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_diagnostic_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_documentation] = {
    .visible = true,
    .named = true,
  },
  [sym_class_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_param_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_alias_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_continuation] = {
    .visible = true,
    .named = true,
  },
  [sym_return_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_field_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_qualifier_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_vararg_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_diagnostic_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_module_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_source_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_version_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_package_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_nodiscard_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_deprecated_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_async_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_overload_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_language_injection] = {
    .visible = true,
    .named = true,
  },
  [sym_see_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_link_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_since_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_as_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_class_at_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_at_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_table_type] = {
    .visible = true,
    .named = true,
  },
  [sym_table_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_member_type] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_custom_type] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_field] = {
    .visible = true,
    .named = true,
  },
  [sym_indexed_field] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_class_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_diagnostic_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_cast_annotation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_table_literal_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_type_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_extension = 1,
  field_field = 2,
  field_filename = 3,
  field_key = 4,
  field_major = 5,
  field_minor = 6,
  field_name = 7,
  field_parent_type = 8,
  field_patch = 9,
  field_start_column = 10,
  field_start_line = 11,
  field_value = 12,
  field_version = 13,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_extension] = "extension",
  [field_field] = "field",
  [field_filename] = "filename",
  [field_key] = "key",
  [field_major] = "major",
  [field_minor] = "minor",
  [field_name] = "name",
  [field_parent_type] = "parent_type",
  [field_patch] = "patch",
  [field_start_column] = "start_column",
  [field_start_line] = "start_line",
  [field_value] = "value",
  [field_version] = "version",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 3},
  [7] = {.index = 9, .length = 3},
  [8] = {.index = 12, .length = 2},
  [9] = {.index = 14, .length = 2},
  [10] = {.index = 16, .length = 2},
  [11] = {.index = 18, .length = 3},
  [12] = {.index = 21, .length = 2},
  [13] = {.index = 23, .length = 1},
  [14] = {.index = 24, .length = 4},
  [15] = {.index = 28, .length = 4},
  [16] = {.index = 32, .length = 1},
  [17] = {.index = 33, .length = 4},
  [18] = {.index = 37, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_version, 1},
  [1] =
    {field_parent_type, 3},
  [2] =
    {field_extension, 3},
    {field_filename, 1},
  [4] =
    {field_key, 2},
  [5] =
    {field_field, 1},
  [6] =
    {field_extension, 3},
    {field_filename, 1},
    {field_start_line, 5},
  [9] =
    {field_major, 1},
    {field_minor, 3},
    {field_patch, 5},
  [12] =
    {field_field, 1},
    {field_field, 4, .inherited = true},
  [14] =
    {field_field, 0, .inherited = true},
    {field_field, 1, .inherited = true},
  [16] =
    {field_key, 2},
    {field_value, 4},
  [18] =
    {field_field, 1},
    {field_field, 2},
    {field_field, 3},
  [21] =
    {field_field, 1},
    {field_field, 5, .inherited = true},
  [23] =
    {field_name, 4},
  [24] =
    {field_extension, 3},
    {field_filename, 1},
    {field_start_column, 7},
    {field_start_line, 5},
  [28] =
    {field_field, 1},
    {field_field, 2},
    {field_field, 3},
    {field_field, 6, .inherited = true},
  [32] =
    {field_name, 5},
  [33] =
    {field_field, 1},
    {field_field, 2},
    {field_field, 3},
    {field_field, 7, .inherited = true},
  [37] =
    {field_name, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 2,
  [5] = 2,
  [6] = 2,
  [7] = 2,
  [8] = 2,
  [9] = 2,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 12,
  [14] = 14,
  [15] = 12,
  [16] = 12,
  [17] = 17,
  [18] = 12,
  [19] = 19,
  [20] = 12,
  [21] = 21,
  [22] = 12,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 28,
  [38] = 29,
  [39] = 30,
  [40] = 31,
  [41] = 32,
  [42] = 42,
  [43] = 32,
  [44] = 33,
  [45] = 45,
  [46] = 34,
  [47] = 33,
  [48] = 36,
  [49] = 28,
  [50] = 29,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 30,
  [59] = 31,
  [60] = 32,
  [61] = 33,
  [62] = 34,
  [63] = 36,
  [64] = 28,
  [65] = 29,
  [66] = 30,
  [67] = 31,
  [68] = 32,
  [69] = 33,
  [70] = 34,
  [71] = 36,
  [72] = 28,
  [73] = 29,
  [74] = 30,
  [75] = 31,
  [76] = 32,
  [77] = 77,
  [78] = 78,
  [79] = 34,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 33,
  [87] = 31,
  [88] = 77,
  [89] = 52,
  [90] = 34,
  [91] = 91,
  [92] = 52,
  [93] = 52,
  [94] = 94,
  [95] = 36,
  [96] = 28,
  [97] = 51,
  [98] = 80,
  [99] = 29,
  [100] = 30,
  [101] = 31,
  [102] = 102,
  [103] = 56,
  [104] = 27,
  [105] = 32,
  [106] = 106,
  [107] = 52,
  [108] = 94,
  [109] = 109,
  [110] = 52,
  [111] = 111,
  [112] = 112,
  [113] = 80,
  [114] = 52,
  [115] = 84,
  [116] = 85,
  [117] = 77,
  [118] = 118,
  [119] = 119,
  [120] = 84,
  [121] = 121,
  [122] = 36,
  [123] = 28,
  [124] = 27,
  [125] = 56,
  [126] = 94,
  [127] = 127,
  [128] = 51,
  [129] = 94,
  [130] = 51,
  [131] = 131,
  [132] = 77,
  [133] = 30,
  [134] = 56,
  [135] = 27,
  [136] = 84,
  [137] = 29,
  [138] = 80,
  [139] = 33,
  [140] = 84,
  [141] = 77,
  [142] = 142,
  [143] = 27,
  [144] = 56,
  [145] = 34,
  [146] = 94,
  [147] = 147,
  [148] = 36,
  [149] = 51,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 170,
  [198] = 172,
  [199] = 168,
  [200] = 166,
  [201] = 157,
  [202] = 160,
  [203] = 152,
  [204] = 162,
  [205] = 205,
  [206] = 159,
  [207] = 167,
  [208] = 169,
  [209] = 165,
  [210] = 154,
  [211] = 163,
  [212] = 212,
  [213] = 155,
  [214] = 155,
  [215] = 193,
  [216] = 167,
  [217] = 160,
  [218] = 166,
  [219] = 165,
  [220] = 156,
  [221] = 158,
  [222] = 163,
  [223] = 169,
  [224] = 164,
  [225] = 225,
  [226] = 164,
  [227] = 153,
  [228] = 174,
  [229] = 171,
  [230] = 180,
  [231] = 152,
  [232] = 173,
  [233] = 188,
  [234] = 162,
  [235] = 156,
  [236] = 155,
  [237] = 159,
  [238] = 157,
  [239] = 189,
  [240] = 195,
  [241] = 161,
  [242] = 192,
  [243] = 190,
  [244] = 187,
  [245] = 186,
  [246] = 181,
  [247] = 177,
  [248] = 175,
  [249] = 194,
  [250] = 178,
  [251] = 182,
  [252] = 168,
  [253] = 183,
  [254] = 154,
  [255] = 255,
  [256] = 176,
  [257] = 185,
  [258] = 191,
  [259] = 161,
  [260] = 179,
  [261] = 153,
  [262] = 154,
  [263] = 184,
  [264] = 172,
  [265] = 171,
  [266] = 158,
  [267] = 170,
  [268] = 192,
  [269] = 269,
  [270] = 192,
  [271] = 195,
  [272] = 184,
  [273] = 191,
  [274] = 274,
  [275] = 275,
  [276] = 164,
  [277] = 158,
  [278] = 156,
  [279] = 185,
  [280] = 171,
  [281] = 176,
  [282] = 189,
  [283] = 153,
  [284] = 161,
  [285] = 171,
  [286] = 286,
  [287] = 190,
  [288] = 288,
  [289] = 188,
  [290] = 290,
  [291] = 171,
  [292] = 292,
  [293] = 187,
  [294] = 186,
  [295] = 153,
  [296] = 183,
  [297] = 160,
  [298] = 173,
  [299] = 180,
  [300] = 300,
  [301] = 155,
  [302] = 161,
  [303] = 182,
  [304] = 178,
  [305] = 154,
  [306] = 157,
  [307] = 159,
  [308] = 162,
  [309] = 174,
  [310] = 163,
  [311] = 165,
  [312] = 161,
  [313] = 172,
  [314] = 170,
  [315] = 166,
  [316] = 316,
  [317] = 152,
  [318] = 167,
  [319] = 166,
  [320] = 159,
  [321] = 184,
  [322] = 191,
  [323] = 185,
  [324] = 176,
  [325] = 167,
  [326] = 183,
  [327] = 194,
  [328] = 182,
  [329] = 178,
  [330] = 194,
  [331] = 175,
  [332] = 177,
  [333] = 152,
  [334] = 168,
  [335] = 181,
  [336] = 153,
  [337] = 186,
  [338] = 187,
  [339] = 156,
  [340] = 181,
  [341] = 169,
  [342] = 342,
  [343] = 170,
  [344] = 190,
  [345] = 175,
  [346] = 193,
  [347] = 195,
  [348] = 158,
  [349] = 172,
  [350] = 177,
  [351] = 189,
  [352] = 188,
  [353] = 353,
  [354] = 179,
  [355] = 164,
  [356] = 154,
  [357] = 173,
  [358] = 180,
  [359] = 155,
  [360] = 360,
  [361] = 193,
  [362] = 174,
  [363] = 363,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 184,
  [369] = 191,
  [370] = 185,
  [371] = 176,
  [372] = 372,
  [373] = 183,
  [374] = 161,
  [375] = 182,
  [376] = 178,
  [377] = 194,
  [378] = 175,
  [379] = 177,
  [380] = 179,
  [381] = 381,
  [382] = 181,
  [383] = 153,
  [384] = 186,
  [385] = 187,
  [386] = 372,
  [387] = 367,
  [388] = 171,
  [389] = 190,
  [390] = 192,
  [391] = 193,
  [392] = 195,
  [393] = 364,
  [394] = 176,
  [395] = 366,
  [396] = 189,
  [397] = 188,
  [398] = 365,
  [399] = 366,
  [400] = 367,
  [401] = 381,
  [402] = 173,
  [403] = 180,
  [404] = 183,
  [405] = 182,
  [406] = 372,
  [407] = 174,
  [408] = 178,
  [409] = 409,
  [410] = 364,
  [411] = 155,
  [412] = 154,
  [413] = 185,
  [414] = 191,
  [415] = 184,
  [416] = 365,
  [417] = 366,
  [418] = 367,
  [419] = 381,
  [420] = 420,
  [421] = 194,
  [422] = 381,
  [423] = 367,
  [424] = 175,
  [425] = 177,
  [426] = 381,
  [427] = 365,
  [428] = 181,
  [429] = 364,
  [430] = 372,
  [431] = 381,
  [432] = 365,
  [433] = 367,
  [434] = 366,
  [435] = 365,
  [436] = 364,
  [437] = 372,
  [438] = 381,
  [439] = 367,
  [440] = 366,
  [441] = 441,
  [442] = 365,
  [443] = 364,
  [444] = 372,
  [445] = 186,
  [446] = 187,
  [447] = 372,
  [448] = 190,
  [449] = 192,
  [450] = 193,
  [451] = 195,
  [452] = 189,
  [453] = 188,
  [454] = 173,
  [455] = 180,
  [456] = 364,
  [457] = 174,
  [458] = 366,
  [459] = 381,
  [460] = 460,
  [461] = 183,
  [462] = 460,
  [463] = 182,
  [464] = 178,
  [465] = 194,
  [466] = 175,
  [467] = 177,
  [468] = 181,
  [469] = 469,
  [470] = 186,
  [471] = 187,
  [472] = 460,
  [473] = 190,
  [474] = 192,
  [475] = 193,
  [476] = 195,
  [477] = 477,
  [478] = 189,
  [479] = 188,
  [480] = 342,
  [481] = 173,
  [482] = 180,
  [483] = 469,
  [484] = 460,
  [485] = 174,
  [486] = 469,
  [487] = 487,
  [488] = 469,
  [489] = 184,
  [490] = 176,
  [491] = 185,
  [492] = 191,
  [493] = 469,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 460,
  [499] = 469,
  [500] = 500,
  [501] = 460,
  [502] = 502,
  [503] = 469,
  [504] = 504,
  [505] = 505,
  [506] = 460,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 510,
  [512] = 512,
  [513] = 509,
  [514] = 510,
  [515] = 510,
  [516] = 516,
  [517] = 517,
  [518] = 509,
  [519] = 510,
  [520] = 520,
  [521] = 509,
  [522] = 510,
  [523] = 510,
  [524] = 509,
  [525] = 509,
  [526] = 526,
  [527] = 509,
  [528] = 528,
  [529] = 529,
  [530] = 160,
  [531] = 531,
  [532] = 162,
  [533] = 533,
  [534] = 534,
  [535] = 163,
  [536] = 157,
  [537] = 537,
  [538] = 538,
  [539] = 165,
  [540] = 168,
  [541] = 169,
  [542] = 542,
  [543] = 543,
  [544] = 160,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 153,
  [551] = 171,
  [552] = 552,
  [553] = 548,
  [554] = 547,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 555,
  [559] = 559,
  [560] = 547,
  [561] = 561,
  [562] = 549,
  [563] = 563,
  [564] = 161,
  [565] = 548,
  [566] = 552,
  [567] = 559,
  [568] = 568,
  [569] = 556,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 571,
  [574] = 570,
  [575] = 568,
  [576] = 556,
  [577] = 559,
  [578] = 578,
  [579] = 552,
  [580] = 548,
  [581] = 547,
  [582] = 555,
  [583] = 549,
  [584] = 556,
  [585] = 571,
  [586] = 570,
  [587] = 549,
  [588] = 568,
  [589] = 559,
  [590] = 552,
  [591] = 548,
  [592] = 547,
  [593] = 555,
  [594] = 570,
  [595] = 549,
  [596] = 556,
  [597] = 555,
  [598] = 529,
  [599] = 547,
  [600] = 571,
  [601] = 552,
  [602] = 602,
  [603] = 570,
  [604] = 548,
  [605] = 552,
  [606] = 559,
  [607] = 568,
  [608] = 548,
  [609] = 552,
  [610] = 559,
  [611] = 568,
  [612] = 570,
  [613] = 613,
  [614] = 555,
  [615] = 571,
  [616] = 616,
  [617] = 617,
  [618] = 556,
  [619] = 570,
  [620] = 549,
  [621] = 571,
  [622] = 622,
  [623] = 548,
  [624] = 552,
  [625] = 571,
  [626] = 626,
  [627] = 559,
  [628] = 556,
  [629] = 568,
  [630] = 568,
  [631] = 555,
  [632] = 549,
  [633] = 547,
  [634] = 634,
  [635] = 635,
  [636] = 547,
  [637] = 555,
  [638] = 638,
  [639] = 639,
  [640] = 640,
  [641] = 641,
  [642] = 642,
  [643] = 643,
  [644] = 644,
  [645] = 645,
  [646] = 642,
  [647] = 647,
  [648] = 642,
  [649] = 647,
  [650] = 642,
  [651] = 647,
  [652] = 652,
  [653] = 642,
  [654] = 647,
  [655] = 655,
  [656] = 656,
  [657] = 641,
  [658] = 658,
  [659] = 642,
  [660] = 647,
  [661] = 641,
  [662] = 642,
  [663] = 663,
  [664] = 638,
  [665] = 638,
  [666] = 647,
  [667] = 667,
  [668] = 668,
  [669] = 669,
  [670] = 638,
  [671] = 638,
  [672] = 672,
  [673] = 673,
  [674] = 641,
  [675] = 641,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 641,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 647,
  [687] = 638,
  [688] = 688,
  [689] = 689,
  [690] = 690,
  [691] = 641,
  [692] = 692,
  [693] = 693,
  [694] = 641,
  [695] = 638,
  [696] = 638,
  [697] = 697,
  [698] = 698,
  [699] = 697,
  [700] = 700,
  [701] = 701,
  [702] = 702,
  [703] = 703,
  [704] = 704,
  [705] = 702,
  [706] = 706,
  [707] = 707,
  [708] = 701,
  [709] = 700,
  [710] = 697,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 714,
  [715] = 715,
  [716] = 716,
  [717] = 717,
  [718] = 718,
  [719] = 719,
  [720] = 720,
  [721] = 721,
  [722] = 711,
  [723] = 697,
  [724] = 700,
  [725] = 701,
  [726] = 702,
  [727] = 727,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 731,
  [732] = 732,
  [733] = 733,
  [734] = 734,
  [735] = 735,
  [736] = 736,
  [737] = 737,
  [738] = 738,
  [739] = 739,
  [740] = 740,
  [741] = 741,
  [742] = 742,
  [743] = 743,
  [744] = 744,
  [745] = 745,
  [746] = 746,
  [747] = 747,
  [748] = 748,
  [749] = 749,
  [750] = 702,
  [751] = 751,
  [752] = 752,
  [753] = 701,
  [754] = 700,
  [755] = 755,
  [756] = 711,
  [757] = 757,
  [758] = 758,
  [759] = 759,
  [760] = 760,
  [761] = 761,
  [762] = 762,
  [763] = 744,
  [764] = 745,
  [765] = 746,
  [766] = 747,
  [767] = 767,
  [768] = 768,
  [769] = 769,
  [770] = 770,
  [771] = 771,
  [772] = 772,
  [773] = 773,
  [774] = 774,
  [775] = 744,
  [776] = 745,
  [777] = 746,
  [778] = 747,
  [779] = 779,
  [780] = 780,
  [781] = 781,
  [782] = 782,
  [783] = 783,
  [784] = 711,
  [785] = 785,
  [786] = 786,
  [787] = 744,
  [788] = 745,
  [789] = 746,
  [790] = 747,
  [791] = 791,
  [792] = 792,
  [793] = 793,
  [794] = 747,
  [795] = 746,
  [796] = 745,
  [797] = 744,
  [798] = 798,
  [799] = 744,
  [800] = 745,
  [801] = 746,
  [802] = 747,
  [803] = 803,
  [804] = 804,
  [805] = 805,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 809,
  [810] = 810,
  [811] = 744,
  [812] = 745,
  [813] = 746,
  [814] = 747,
  [815] = 815,
  [816] = 816,
  [817] = 817,
  [818] = 818,
  [819] = 819,
  [820] = 820,
  [821] = 702,
  [822] = 701,
  [823] = 700,
  [824] = 816,
  [825] = 697,
  [826] = 826,
  [827] = 827,
  [828] = 702,
  [829] = 711,
  [830] = 830,
  [831] = 701,
  [832] = 700,
  [833] = 826,
  [834] = 834,
  [835] = 816,
  [836] = 836,
  [837] = 826,
  [838] = 838,
  [839] = 816,
  [840] = 840,
  [841] = 826,
  [842] = 842,
  [843] = 816,
  [844] = 702,
  [845] = 826,
  [846] = 701,
  [847] = 816,
  [848] = 700,
  [849] = 826,
  [850] = 697,
  [851] = 816,
  [852] = 711,
  [853] = 826,
  [854] = 744,
  [855] = 798,
  [856] = 856,
  [857] = 798,
  [858] = 858,
  [859] = 798,
  [860] = 860,
  [861] = 798,
  [862] = 862,
  [863] = 798,
  [864] = 697,
  [865] = 798,
  [866] = 711,
  [867] = 867,
  [868] = 868,
  [869] = 869,
  [870] = 870,
  [871] = 871,
  [872] = 872,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(191);
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(224);
      if (lookahead == ')') ADVANCE(225);
      if (lookahead == '+') ADVANCE(230);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '-') ADVANCE(229);
      if (lookahead == '.') ADVANCE(214);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '>') ADVANCE(428);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == 'C') ADVANCE(47);
      if (lookahead == 'J') ADVANCE(48);
      if (lookahead == '[') ADVANCE(423);
      if (lookahead == ']') ADVANCE(424);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(105);
      if (lookahead == 'b') ADVANCE(115);
      if (lookahead == 'e') ADVANCE(136);
      if (lookahead == 'f') ADVANCE(133);
      if (lookahead == 'n') ADVANCE(88);
      if (lookahead == 'p') ADVANCE(52);
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(59);
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'v') ADVANCE(114);
      if (lookahead == '{') ADVANCE(370);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '}') ADVANCE(372);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(144)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(462);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(224);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == 'C') ADVANCE(466);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == ']') ADVANCE(45);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(511);
      if (lookahead == 'b') ADVANCE(519);
      if (lookahead == 'f') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(497);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 't') ADVANCE(467);
      if (lookahead == 'u') ADVANCE(526);
      if (lookahead == 'v') ADVANCE(518);
      if (lookahead == '{') ADVANCE(370);
      if (lookahead == '|') ADVANCE(201);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(464);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ')') ADVANCE(225);
      if (lookahead == '+') ADVANCE(230);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '-') ADVANCE(229);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '>') ADVANCE(428);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == 'C') ADVANCE(466);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == ']') ADVANCE(430);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(511);
      if (lookahead == 'b') ADVANCE(519);
      if (lookahead == 'f') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(497);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 't') ADVANCE(467);
      if (lookahead == 'u') ADVANCE(526);
      if (lookahead == 'v') ADVANCE(518);
      if (lookahead == '{') ADVANCE(370);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '}') ADVANCE(372);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(464);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == 'C') ADVANCE(466);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == ']') ADVANCE(429);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(511);
      if (lookahead == 'b') ADVANCE(519);
      if (lookahead == 'f') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(497);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 't') ADVANCE(467);
      if (lookahead == 'u') ADVANCE(526);
      if (lookahead == 'v') ADVANCE(518);
      if (lookahead == '{') ADVANCE(370);
      if (lookahead == '|') ADVANCE(201);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(462);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(224);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == 'C') ADVANCE(466);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == ']') ADVANCE(45);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(511);
      if (lookahead == 'b') ADVANCE(519);
      if (lookahead == 'f') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(497);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 't') ADVANCE(467);
      if (lookahead == 'u') ADVANCE(526);
      if (lookahead == 'v') ADVANCE(518);
      if (lookahead == '{') ADVANCE(370);
      if (lookahead == '|') ADVANCE(201);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(464);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ')') ADVANCE(225);
      if (lookahead == '+') ADVANCE(230);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '-') ADVANCE(229);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '>') ADVANCE(428);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == 'C') ADVANCE(466);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == ']') ADVANCE(430);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(511);
      if (lookahead == 'b') ADVANCE(519);
      if (lookahead == 'f') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(497);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 't') ADVANCE(467);
      if (lookahead == 'u') ADVANCE(526);
      if (lookahead == 'v') ADVANCE(518);
      if (lookahead == '{') ADVANCE(370);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '}') ADVANCE(372);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(464);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ')') ADVANCE(225);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(31);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '@') ADVANCE(56);
      if (lookahead == 'C') ADVANCE(466);
      if (lookahead == ']') ADVANCE(424);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(511);
      if (lookahead == 'b') ADVANCE(519);
      if (lookahead == 'f') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(497);
      if (lookahead == 's') ADVANCE(488);
      if (lookahead == 't') ADVANCE(467);
      if (lookahead == 'u') ADVANCE(526);
      if (lookahead == 'v') ADVANCE(518);
      if (lookahead == '{') ADVANCE(370);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(464);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ')') ADVANCE(225);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(31);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '@') ADVANCE(56);
      if (lookahead == 'C') ADVANCE(466);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(511);
      if (lookahead == 'b') ADVANCE(519);
      if (lookahead == 'f') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(497);
      if (lookahead == 's') ADVANCE(488);
      if (lookahead == 't') ADVANCE(467);
      if (lookahead == 'u') ADVANCE(526);
      if (lookahead == 'v') ADVANCE(518);
      if (lookahead == '{') ADVANCE(370);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(464);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '-') ADVANCE(142);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == 'C') ADVANCE(466);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == ']') ADVANCE(429);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(511);
      if (lookahead == 'b') ADVANCE(519);
      if (lookahead == 'f') ADVANCE(534);
      if (lookahead == 'n') ADVANCE(497);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 't') ADVANCE(467);
      if (lookahead == 'u') ADVANCE(526);
      if (lookahead == 'v') ADVANCE(518);
      if (lookahead == '{') ADVANCE(370);
      if (lookahead == '|') ADVANCE(201);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(462);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == '\'') ADVANCE(12);
      if (lookahead == '(') ADVANCE(98);
      if (lookahead == '.') ADVANCE(31);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '}') ADVANCE(372);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(463);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(11);
      if (lookahead == '\'') ADVANCE(12);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == 'p') ADVANCE(469);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(463);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(461);
      if (lookahead != 0) ADVANCE(11);
      END_STATE();
    case 12:
      if (lookahead == '\'') ADVANCE(461);
      if (lookahead != 0) ADVANCE(12);
      END_STATE();
    case 13:
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(13)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(389);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 14:
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(14)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(390);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 15:
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(15)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(391);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 16:
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(16)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(392);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 17:
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(17)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(393);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 18:
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(18)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(394);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 19:
      if (lookahead == ')') ADVANCE(193);
      END_STATE();
    case 20:
      if (lookahead == ')') ADVANCE(234);
      END_STATE();
    case 21:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(21)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(395);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 22:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(22)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(396);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 23:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(23)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(397);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 24:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(24)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(398);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 25:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(25)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(399);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 26:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(26)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(400);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 27:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(27)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(401);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 28:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(28)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(402);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 29:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(29)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(403);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 30:
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(30)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(404);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 31:
      if (lookahead == '.') ADVANCE(32);
      END_STATE();
    case 32:
      if (lookahead == '.') ADVANCE(198);
      END_STATE();
    case 33:
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(33)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(405);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 34:
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(34)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(406);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 35:
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(35)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(407);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 36:
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(36)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(408);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 37:
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(37)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(409);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 38:
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(38)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(410);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 39:
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(39)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(411);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 40:
      if (lookahead == '.') ADVANCE(42);
      END_STATE();
    case 41:
      if (lookahead == '.') ADVANCE(31);
      if (lookahead == 's') ADVANCE(489);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(41)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 42:
      if (lookahead == '1') ADVANCE(216);
      if (lookahead == '2') ADVANCE(217);
      if (lookahead == '3') ADVANCE(218);
      if (lookahead == '4') ADVANCE(219);
      END_STATE();
    case 43:
      if (lookahead == '5') ADVANCE(40);
      if (lookahead == 'J') ADVANCE(48);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43)
      END_STATE();
    case 44:
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(44)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(412);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 45:
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == ']') ADVANCE(376);
      END_STATE();
    case 46:
      if (lookahead == '@') ADVANCE(240);
      if (lookahead == '[') ADVANCE(237);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(46)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(238);
      if (lookahead != 0 &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 47:
      if (lookahead == 'F') ADVANCE(134);
      END_STATE();
    case 48:
      if (lookahead == 'I') ADVANCE(49);
      END_STATE();
    case 49:
      if (lookahead == 'T') ADVANCE(220);
      END_STATE();
    case 50:
      if (lookahead == '[') ADVANCE(377);
      END_STATE();
    case 51:
      if (lookahead == ']') ADVANCE(378);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(64);
      if (lookahead == 'r') ADVANCE(89);
      if (lookahead == 'u') ADVANCE(61);
      END_STATE();
    case 53:
      if (lookahead == 'a') ADVANCE(87);
      END_STATE();
    case 54:
      if (lookahead == 'a') ADVANCE(457);
      END_STATE();
    case 55:
      if (lookahead == 'a') ADVANCE(66);
      END_STATE();
    case 56:
      if (lookahead == 'a') ADVANCE(124);
      if (lookahead == 'l') ADVANCE(94);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(129);
      END_STATE();
    case 58:
      if (lookahead == 'a') ADVANCE(107);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(63);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(130);
      END_STATE();
    case 61:
      if (lookahead == 'b') ADVANCE(102);
      END_STATE();
    case 62:
      if (lookahead == 'b') ADVANCE(80);
      END_STATE();
    case 63:
      if (lookahead == 'b') ADVANCE(103);
      END_STATE();
    case 64:
      if (lookahead == 'c') ADVANCE(97);
      END_STATE();
    case 65:
      if (lookahead == 'c') ADVANCE(379);
      END_STATE();
    case 66:
      if (lookahead == 'c') ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'c') ADVANCE(131);
      END_STATE();
    case 68:
      if (lookahead == 'c') ADVANCE(132);
      END_STATE();
    case 69:
      if (lookahead == 'd') ADVANCE(459);
      END_STATE();
    case 70:
      if (lookahead == 'd') ADVANCE(381);
      END_STATE();
    case 71:
      if (lookahead == 'd') ADVANCE(123);
      END_STATE();
    case 72:
      if (lookahead == 'd') ADVANCE(57);
      END_STATE();
    case 73:
      if (lookahead == 'e') ADVANCE(425);
      END_STATE();
    case 74:
      if (lookahead == 'e') ADVANCE(385);
      END_STATE();
    case 75:
      if (lookahead == 'e') ADVANCE(383);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(419);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(76)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(414);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 78:
      if (lookahead == 'e') ADVANCE(100);
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 80:
      if (lookahead == 'e') ADVANCE(119);
      END_STATE();
    case 81:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 82:
      if (lookahead == 'e') ADVANCE(67);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 85:
      if (lookahead == 'f') ADVANCE(435);
      END_STATE();
    case 86:
      if (lookahead == 'g') ADVANCE(455);
      END_STATE();
    case 87:
      if (lookahead == 'g') ADVANCE(74);
      END_STATE();
    case 88:
      if (lookahead == 'i') ADVANCE(99);
      if (lookahead == 'u') ADVANCE(104);
      END_STATE();
    case 89:
      if (lookahead == 'i') ADVANCE(135);
      if (lookahead == 'o') ADVANCE(127);
      END_STATE();
    case 90:
      if (lookahead == 'i') ADVANCE(69);
      END_STATE();
    case 91:
      if (lookahead == 'i') ADVANCE(117);
      END_STATE();
    case 92:
      if (lookahead == 'i') ADVANCE(111);
      END_STATE();
    case 93:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 94:
      if (lookahead == 'i') ADVANCE(110);
      END_STATE();
    case 95:
      if (lookahead == 'i') ADVANCE(118);
      END_STATE();
    case 96:
      if (lookahead == 'k') ADVANCE(371);
      END_STATE();
    case 97:
      if (lookahead == 'k') ADVANCE(53);
      END_STATE();
    case 98:
      if (lookahead == 'k') ADVANCE(77);
      END_STATE();
    case 99:
      if (lookahead == 'l') ADVANCE(451);
      END_STATE();
    case 100:
      if (lookahead == 'l') ADVANCE(85);
      END_STATE();
    case 101:
      if (lookahead == 'l') ADVANCE(84);
      END_STATE();
    case 102:
      if (lookahead == 'l') ADVANCE(93);
      END_STATE();
    case 103:
      if (lookahead == 'l') ADVANCE(73);
      END_STATE();
    case 104:
      if (lookahead == 'm') ADVANCE(62);
      END_STATE();
    case 105:
      if (lookahead == 'n') ADVANCE(138);
      END_STATE();
    case 106:
      if (lookahead == 'n') ADVANCE(432);
      END_STATE();
    case 107:
      if (lookahead == 'n') ADVANCE(447);
      END_STATE();
    case 108:
      if (lookahead == 'n') ADVANCE(433);
      END_STATE();
    case 109:
      if (lookahead == 'n') ADVANCE(449);
      END_STATE();
    case 110:
      if (lookahead == 'n') ADVANCE(96);
      END_STATE();
    case 111:
      if (lookahead == 'n') ADVANCE(86);
      END_STATE();
    case 112:
      if (lookahead == 'n') ADVANCE(68);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(71);
      END_STATE();
    case 114:
      if (lookahead == 'o') ADVANCE(90);
      END_STATE();
    case 115:
      if (lookahead == 'o') ADVANCE(116);
      END_STATE();
    case 116:
      if (lookahead == 'o') ADVANCE(101);
      END_STATE();
    case 117:
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 118:
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 119:
      if (lookahead == 'r') ADVANCE(453);
      END_STATE();
    case 120:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 121:
      if (lookahead == 'r') ADVANCE(72);
      END_STATE();
    case 122:
      if (lookahead == 's') ADVANCE(79);
      END_STATE();
    case 123:
      if (lookahead == 's') ADVANCE(388);
      END_STATE();
    case 124:
      if (lookahead == 's') ADVANCE(375);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(19);
      END_STATE();
    case 126:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 127:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 128:
      if (lookahead == 't') ADVANCE(91);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(54);
      END_STATE();
    case 130:
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 132:
      if (lookahead == 't') ADVANCE(95);
      END_STATE();
    case 133:
      if (lookahead == 'u') ADVANCE(106);
      END_STATE();
    case 134:
      if (lookahead == 'u') ADVANCE(112);
      END_STATE();
    case 135:
      if (lookahead == 'v') ADVANCE(60);
      END_STATE();
    case 136:
      if (lookahead == 'x') ADVANCE(126);
      END_STATE();
    case 137:
      if (lookahead == 'x') ADVANCE(55);
      END_STATE();
    case 138:
      if (lookahead == 'y') ADVANCE(445);
      END_STATE();
    case 139:
      if (lookahead == 'y') ADVANCE(20);
      END_STATE();
    case 140:
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(140)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(420);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 141:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(141)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(539);
      END_STATE();
    case 142:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(464);
      END_STATE();
    case 143:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(465);
      END_STATE();
    case 144:
      if (eof) ADVANCE(191);
      if (lookahead == '"') ADVANCE(438);
      if (lookahead == '\'') ADVANCE(441);
      if (lookahead == '(') ADVANCE(224);
      if (lookahead == ')') ADVANCE(225);
      if (lookahead == '+') ADVANCE(230);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '-') ADVANCE(229);
      if (lookahead == '.') ADVANCE(214);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '>') ADVANCE(428);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == 'C') ADVANCE(47);
      if (lookahead == 'J') ADVANCE(48);
      if (lookahead == '[') ADVANCE(423);
      if (lookahead == ']') ADVANCE(429);
      if (lookahead == '`') ADVANCE(444);
      if (lookahead == 'a') ADVANCE(105);
      if (lookahead == 'b') ADVANCE(115);
      if (lookahead == 'e') ADVANCE(136);
      if (lookahead == 'f') ADVANCE(133);
      if (lookahead == 'n') ADVANCE(88);
      if (lookahead == 'p') ADVANCE(52);
      if (lookahead == 's') ADVANCE(78);
      if (lookahead == 't') ADVANCE(59);
      if (lookahead == 'u') ADVANCE(122);
      if (lookahead == 'v') ADVANCE(114);
      if (lookahead == '{') ADVANCE(370);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '}') ADVANCE(372);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(144)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(462);
      END_STATE();
    case 145:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(165)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(389);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 146:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(166)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(390);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 147:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(167)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(391);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 148:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(168)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(392);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 149:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(169)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(393);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 150:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(170)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(394);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 151:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(171)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(395);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 152:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(172)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(396);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 153:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(173)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(397);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 154:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(174)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(398);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 155:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(175)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(399);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 156:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(176)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(400);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 157:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(177)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(401);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 158:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(181)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(405);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 159:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(182)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(406);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 160:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(183)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(407);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 161:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(184)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(408);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 162:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(185)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(409);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 163:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(186)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(410);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 164:
      if (eof) ADVANCE(191);
      if (lookahead == '#') ADVANCE(437);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(187)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(411);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 165:
      if (eof) ADVANCE(191);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(165)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(389);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 166:
      if (eof) ADVANCE(191);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(166)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(390);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 167:
      if (eof) ADVANCE(191);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(167)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(391);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 168:
      if (eof) ADVANCE(191);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(168)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(392);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 169:
      if (eof) ADVANCE(191);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(169)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(393);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 170:
      if (eof) ADVANCE(191);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(170)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(394);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 171:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(171)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(395);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 172:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(172)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(396);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 173:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(173)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(397);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 174:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(174)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(398);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 175:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(175)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(399);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 176:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(176)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(400);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 177:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(177)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(401);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 178:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(178)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(402);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 179:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(179)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(403);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 180:
      if (eof) ADVANCE(191);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(180)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(404);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 181:
      if (eof) ADVANCE(191);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(181)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(405);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 182:
      if (eof) ADVANCE(191);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(182)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(406);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 183:
      if (eof) ADVANCE(191);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(183)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(407);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 184:
      if (eof) ADVANCE(191);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(184)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(408);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 185:
      if (eof) ADVANCE(191);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(185)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(409);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 186:
      if (eof) ADVANCE(191);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(186)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(410);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 187:
      if (eof) ADVANCE(191);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(187)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(411);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 188:
      if (eof) ADVANCE(191);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(188)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(412);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 189:
      if (eof) ADVANCE(191);
      if (lookahead == 'e') ADVANCE(419);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(189)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(414);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 190:
      if (eof) ADVANCE(191);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(190)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(420);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_ATclass);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_LPARENexact_RPAREN);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_ATtype);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_ATparam);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_ATalias);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_ATreturn);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_ATfield);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_ATpublic);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_ATprotected);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_ATprivate);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_ATgeneric);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_ATvararg);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_ATdiagnostic);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_ATmeta);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_ATmodule);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_ATsource);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(32);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_ATversion);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_5_DOT1);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_5_DOT2);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_5_DOT3);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_5_DOT4);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_JIT);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_ATpackage);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_AToperator);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == 'e') ADVANCE(137);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_ATnodiscard);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_ATdeprecated);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_ATcast);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(464);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_ATasync);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_AToverload);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_ATenum);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_LPARENkey_RPAREN);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_ATlanguage);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_ATsee);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == '=') ADVANCE(239);
      if (lookahead == '[') ADVANCE(374);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == '@') ADVANCE(240);
      if (lookahead == '[') ADVANCE(237);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(46)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(238);
      if (lookahead != 0 &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == '[') ADVANCE(377);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(311);
      if (lookahead == 'c') ADVANCE(241);
      if (lookahead == 'd') ADVANCE(276);
      if (lookahead == 'e') ADVANCE(318);
      if (lookahead == 'f') ADVANCE(303);
      if (lookahead == 'g') ADVANCE(287);
      if (lookahead == 'l') ADVANCE(248);
      if (lookahead == 'm') ADVANCE(277);
      if (lookahead == 'n') ADVANCE(326);
      if (lookahead == 'o') ADVANCE(332);
      if (lookahead == 'p') ADVANCE(242);
      if (lookahead == 'r') ADVANCE(288);
      if (lookahead == 's') ADVANCE(292);
      if (lookahead == 't') ADVANCE(367);
      if (lookahead == 'v') ADVANCE(243);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(347);
      if (lookahead == 'l') ADVANCE(246);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(259);
      if (lookahead == 'r') ADVANCE(302);
      if (lookahead == 'u') ADVANCE(258);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(339);
      if (lookahead == 'e') ADVANCE(335);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(299);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(210);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(349);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(317);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(323);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(300);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(345);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(270);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(354);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(336);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(338);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(301);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(356);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'a') ADVANCE(358);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'b') ADVANCE(314);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(310);
      if (lookahead == 'r') ADVANCE(247);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(204);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(207);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(209);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(281);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(283);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(254);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(357);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'c') ADVANCE(257);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'd') ADVANCE(203);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'd') ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'd') ADVANCE(226);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'd') ADVANCE(205);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'd') ADVANCE(227);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'd') ADVANCE(306);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'd') ADVANCE(362);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(331);
      if (lookahead == 'i') ADVANCE(244);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(353);
      if (lookahead == 'o') ADVANCE(275);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(313);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(236);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(196);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(373);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(211);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(221);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(206);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(235);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(325);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(359);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(268);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(337);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(267);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(279);
      if (lookahead == 'i') ADVANCE(319);
      if (lookahead == 'o') ADVANCE(363);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(272);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(344);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'e') ADVANCE(341);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'g') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'g') ADVANCE(365);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'g') ADVANCE(322);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'g') ADVANCE(284);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'g') ADVANCE(286);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'i') ADVANCE(366);
      if (lookahead == 'o') ADVANCE(355);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'i') ADVANCE(278);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'i') ADVANCE(327);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'i') ADVANCE(261);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'i') ADVANCE(351);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'i') ADVANCE(262);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'i') ADVANCE(263);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'i') ADVANCE(250);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'k') ADVANCE(249);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'l') ADVANCE(309);
      if (lookahead == 's') ADVANCE(368);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'l') ADVANCE(328);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'l') ADVANCE(269);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'l') ADVANCE(305);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'l') ADVANCE(282);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'm') ADVANCE(233);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'm') ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'n') ADVANCE(361);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'n') ADVANCE(264);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'n') ADVANCE(202);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'n') ADVANCE(215);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'n') ADVANCE(330);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'n') ADVANCE(298);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'n') ADVANCE(260);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'n') ADVANCE(294);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'o') ADVANCE(274);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'o') ADVANCE(321);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'o') ADVANCE(251);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'o') ADVANCE(334);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'o') ADVANCE(350);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'p') ADVANCE(342);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'p') ADVANCE(296);
      if (lookahead == 'v') ADVANCE(290);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'p') ADVANCE(280);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(222);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(348);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(297);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(312);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(271);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(253);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(320);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(252);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(289);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(265);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'r') ADVANCE(307);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 's') ADVANCE(200);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 's') ADVANCE(192);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 's') ADVANCE(352);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 's') ADVANCE(304);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 's') ADVANCE(346);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 's') ADVANCE(360);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 's') ADVANCE(266);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 't') ADVANCE(228);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 't') ADVANCE(245);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 't') ADVANCE(329);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 't') ADVANCE(291);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 't') ADVANCE(285);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 't') ADVANCE(293);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 't') ADVANCE(295);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 't') ADVANCE(364);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 't') ADVANCE(308);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'u') ADVANCE(316);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'u') ADVANCE(315);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'u') ADVANCE(343);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'u') ADVANCE(340);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'u') ADVANCE(255);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'v') ADVANCE(256);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'y') ADVANCE(333);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 368:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead == 'y') ADVANCE(324);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(aux_sym_link_reference_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '{') ADVANCE(369);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(anon_sym_ATlink);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(anon_sym_ATsince);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(anon_sym_ATas);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_LBRACK_EQ_LBRACK);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(anon_sym_RBRACK_EQ_RBRACK);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym_public);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(anon_sym_protected);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(anon_sym_private);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(anon_sym_package);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_package);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(13)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(389);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(14)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(390);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(15)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(391);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(16)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(392);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(17)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(393);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '(') ADVANCE(223);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(18)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(394);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(21)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(395);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(22)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(396);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(23)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(397);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(24)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(398);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(25)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(399);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(26)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(400);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(27)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(401);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(28)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(402);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(29)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(403);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ',') ADVANCE(195);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(30)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(404);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(33)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(405);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(34)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(406);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(35)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(407);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(36)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(408);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '<') ADVANCE(427);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(37)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(409);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '@') ADVANCE(387);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(38)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(410);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '.') ADVANCE(213);
      if (lookahead == '?') ADVANCE(199);
      if (lookahead == '[') ADVANCE(422);
      if (lookahead == '|') ADVANCE(201);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(39)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(411);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == ':') ADVANCE(194);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(44)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(412);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == 'd') ADVANCE(417);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(421);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == 'e') ADVANCE(419);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(76)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(414);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == 'e') ADVANCE(416);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(421);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == 'n') ADVANCE(413);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(421);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == 's') ADVANCE(388);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(421);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == 't') ADVANCE(415);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(421);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == 'x') ADVANCE(418);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(421);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(140)
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') ADVANCE(420);
      if (lookahead != 0) ADVANCE(421);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(421);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '=') ADVANCE(50);
      if (lookahead == '[') ADVANCE(374);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_table);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_table);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_RBRACK2);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(anon_sym_RBRACK2);
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == ']') ADVANCE(376);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(anon_sym_fun);
      if (lookahead == 'c') ADVANCE(528);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(anon_sym_fun);
      if (lookahead == 'c') ADVANCE(128);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_function);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_self);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(anon_sym_self);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(aux_sym_literal_type_token1);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(439);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(440);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(aux_sym_literal_type_token1);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(440);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(aux_sym_literal_type_token2);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(442);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(443);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(aux_sym_literal_type_token2);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(443);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(anon_sym_any);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(anon_sym_boolean);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(anon_sym_CFunction);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(anon_sym_CFunction);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(anon_sym_nil);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(anon_sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_string);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(anon_sym_userdata);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_userdata);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_void);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(462);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(463);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(sym_numeric_literal_type);
      if (lookahead == '.') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(464);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(sym_numeric_literal_type);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(465);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'F') ADVANCE(535);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(474);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(458);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(477);
      if (lookahead == 'r') ADVANCE(499);
      if (lookahead == 'u') ADVANCE(475);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(529);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(496);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(515);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(531);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'b') ADVANCE(508);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'b') ADVANCE(509);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'b') ADVANCE(491);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(504);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(380);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(532);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(533);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(460);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(382);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(470);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(426);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(386);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(384);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(472);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(506);
      if (lookahead == 't') ADVANCE(524);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(506);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(525);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(523);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(482);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(479);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(436);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g') ADVANCE(456);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g') ADVANCE(485);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(505);
      if (lookahead == 'u') ADVANCE(510);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(481);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(536);
      if (lookahead == 'o') ADVANCE(530);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(478);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(514);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(521);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(522);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'k') ADVANCE(471);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(452);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(494);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(487);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(484);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(500);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'm') ADVANCE(476);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(537);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(431);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(480);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(495);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(448);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(434);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(450);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(498);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(520);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(507);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(516);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(517);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(454);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(501);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(483);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(490);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(524);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(502);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(468);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(493);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(486);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(492);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(503);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(513);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'v') ADVANCE(473);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'y') ADVANCE(446);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(538);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(sym_diagnostic_identifier);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(539);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 46},
  [2] = {.lex_state = 6},
  [3] = {.lex_state = 6},
  [4] = {.lex_state = 6},
  [5] = {.lex_state = 6},
  [6] = {.lex_state = 6},
  [7] = {.lex_state = 6},
  [8] = {.lex_state = 6},
  [9] = {.lex_state = 6},
  [10] = {.lex_state = 2},
  [11] = {.lex_state = 2},
  [12] = {.lex_state = 3},
  [13] = {.lex_state = 3},
  [14] = {.lex_state = 1},
  [15] = {.lex_state = 3},
  [16] = {.lex_state = 3},
  [17] = {.lex_state = 2},
  [18] = {.lex_state = 3},
  [19] = {.lex_state = 2},
  [20] = {.lex_state = 3},
  [21] = {.lex_state = 2},
  [22] = {.lex_state = 3},
  [23] = {.lex_state = 2},
  [24] = {.lex_state = 3},
  [25] = {.lex_state = 2},
  [26] = {.lex_state = 2},
  [27] = {.lex_state = 2},
  [28] = {.lex_state = 2},
  [29] = {.lex_state = 2},
  [30] = {.lex_state = 2},
  [31] = {.lex_state = 2},
  [32] = {.lex_state = 2},
  [33] = {.lex_state = 2},
  [34] = {.lex_state = 2},
  [35] = {.lex_state = 2},
  [36] = {.lex_state = 2},
  [37] = {.lex_state = 2},
  [38] = {.lex_state = 2},
  [39] = {.lex_state = 2},
  [40] = {.lex_state = 2},
  [41] = {.lex_state = 2},
  [42] = {.lex_state = 2},
  [43] = {.lex_state = 2},
  [44] = {.lex_state = 2},
  [45] = {.lex_state = 2},
  [46] = {.lex_state = 2},
  [47] = {.lex_state = 2},
  [48] = {.lex_state = 2},
  [49] = {.lex_state = 2},
  [50] = {.lex_state = 2},
  [51] = {.lex_state = 2},
  [52] = {.lex_state = 2},
  [53] = {.lex_state = 2},
  [54] = {.lex_state = 2},
  [55] = {.lex_state = 2},
  [56] = {.lex_state = 2},
  [57] = {.lex_state = 2},
  [58] = {.lex_state = 2},
  [59] = {.lex_state = 2},
  [60] = {.lex_state = 2},
  [61] = {.lex_state = 2},
  [62] = {.lex_state = 2},
  [63] = {.lex_state = 2},
  [64] = {.lex_state = 2},
  [65] = {.lex_state = 2},
  [66] = {.lex_state = 2},
  [67] = {.lex_state = 2},
  [68] = {.lex_state = 2},
  [69] = {.lex_state = 2},
  [70] = {.lex_state = 2},
  [71] = {.lex_state = 2},
  [72] = {.lex_state = 2},
  [73] = {.lex_state = 2},
  [74] = {.lex_state = 2},
  [75] = {.lex_state = 2},
  [76] = {.lex_state = 2},
  [77] = {.lex_state = 2},
  [78] = {.lex_state = 2},
  [79] = {.lex_state = 2},
  [80] = {.lex_state = 2},
  [81] = {.lex_state = 2},
  [82] = {.lex_state = 2},
  [83] = {.lex_state = 2},
  [84] = {.lex_state = 2},
  [85] = {.lex_state = 2},
  [86] = {.lex_state = 2},
  [87] = {.lex_state = 2},
  [88] = {.lex_state = 2},
  [89] = {.lex_state = 2},
  [90] = {.lex_state = 2},
  [91] = {.lex_state = 2},
  [92] = {.lex_state = 2},
  [93] = {.lex_state = 2},
  [94] = {.lex_state = 2},
  [95] = {.lex_state = 2},
  [96] = {.lex_state = 2},
  [97] = {.lex_state = 2},
  [98] = {.lex_state = 2},
  [99] = {.lex_state = 2},
  [100] = {.lex_state = 2},
  [101] = {.lex_state = 2},
  [102] = {.lex_state = 2},
  [103] = {.lex_state = 2},
  [104] = {.lex_state = 2},
  [105] = {.lex_state = 2},
  [106] = {.lex_state = 2},
  [107] = {.lex_state = 2},
  [108] = {.lex_state = 2},
  [109] = {.lex_state = 2},
  [110] = {.lex_state = 2},
  [111] = {.lex_state = 2},
  [112] = {.lex_state = 2},
  [113] = {.lex_state = 2},
  [114] = {.lex_state = 2},
  [115] = {.lex_state = 2},
  [116] = {.lex_state = 2},
  [117] = {.lex_state = 2},
  [118] = {.lex_state = 2},
  [119] = {.lex_state = 2},
  [120] = {.lex_state = 2},
  [121] = {.lex_state = 2},
  [122] = {.lex_state = 2},
  [123] = {.lex_state = 2},
  [124] = {.lex_state = 2},
  [125] = {.lex_state = 2},
  [126] = {.lex_state = 2},
  [127] = {.lex_state = 2},
  [128] = {.lex_state = 2},
  [129] = {.lex_state = 2},
  [130] = {.lex_state = 2},
  [131] = {.lex_state = 2},
  [132] = {.lex_state = 2},
  [133] = {.lex_state = 2},
  [134] = {.lex_state = 2},
  [135] = {.lex_state = 2},
  [136] = {.lex_state = 2},
  [137] = {.lex_state = 2},
  [138] = {.lex_state = 2},
  [139] = {.lex_state = 2},
  [140] = {.lex_state = 2},
  [141] = {.lex_state = 2},
  [142] = {.lex_state = 2},
  [143] = {.lex_state = 2},
  [144] = {.lex_state = 2},
  [145] = {.lex_state = 2},
  [146] = {.lex_state = 2},
  [147] = {.lex_state = 2},
  [148] = {.lex_state = 2},
  [149] = {.lex_state = 2},
  [150] = {.lex_state = 2},
  [151] = {.lex_state = 2},
  [152] = {.lex_state = 2},
  [153] = {.lex_state = 2},
  [154] = {.lex_state = 2},
  [155] = {.lex_state = 2},
  [156] = {.lex_state = 2},
  [157] = {.lex_state = 2},
  [158] = {.lex_state = 2},
  [159] = {.lex_state = 2},
  [160] = {.lex_state = 2},
  [161] = {.lex_state = 2},
  [162] = {.lex_state = 2},
  [163] = {.lex_state = 2},
  [164] = {.lex_state = 2},
  [165] = {.lex_state = 2},
  [166] = {.lex_state = 2},
  [167] = {.lex_state = 2},
  [168] = {.lex_state = 2},
  [169] = {.lex_state = 2},
  [170] = {.lex_state = 2},
  [171] = {.lex_state = 2},
  [172] = {.lex_state = 2},
  [173] = {.lex_state = 2},
  [174] = {.lex_state = 2},
  [175] = {.lex_state = 2},
  [176] = {.lex_state = 2},
  [177] = {.lex_state = 2},
  [178] = {.lex_state = 2},
  [179] = {.lex_state = 2},
  [180] = {.lex_state = 2},
  [181] = {.lex_state = 2},
  [182] = {.lex_state = 2},
  [183] = {.lex_state = 2},
  [184] = {.lex_state = 2},
  [185] = {.lex_state = 2},
  [186] = {.lex_state = 2},
  [187] = {.lex_state = 2},
  [188] = {.lex_state = 2},
  [189] = {.lex_state = 2},
  [190] = {.lex_state = 2},
  [191] = {.lex_state = 2},
  [192] = {.lex_state = 2},
  [193] = {.lex_state = 2},
  [194] = {.lex_state = 2},
  [195] = {.lex_state = 2},
  [196] = {.lex_state = 156},
  [197] = {.lex_state = 152},
  [198] = {.lex_state = 152},
  [199] = {.lex_state = 152},
  [200] = {.lex_state = 152},
  [201] = {.lex_state = 152},
  [202] = {.lex_state = 152},
  [203] = {.lex_state = 152},
  [204] = {.lex_state = 152},
  [205] = {.lex_state = 156},
  [206] = {.lex_state = 152},
  [207] = {.lex_state = 152},
  [208] = {.lex_state = 152},
  [209] = {.lex_state = 152},
  [210] = {.lex_state = 145},
  [211] = {.lex_state = 152},
  [212] = {.lex_state = 156},
  [213] = {.lex_state = 151},
  [214] = {.lex_state = 158},
  [215] = {.lex_state = 152},
  [216] = {.lex_state = 156},
  [217] = {.lex_state = 156},
  [218] = {.lex_state = 156},
  [219] = {.lex_state = 156},
  [220] = {.lex_state = 152},
  [221] = {.lex_state = 152},
  [222] = {.lex_state = 156},
  [223] = {.lex_state = 156},
  [224] = {.lex_state = 152},
  [225] = {.lex_state = 159},
  [226] = {.lex_state = 152},
  [227] = {.lex_state = 152},
  [228] = {.lex_state = 152},
  [229] = {.lex_state = 152},
  [230] = {.lex_state = 152},
  [231] = {.lex_state = 156},
  [232] = {.lex_state = 152},
  [233] = {.lex_state = 152},
  [234] = {.lex_state = 156},
  [235] = {.lex_state = 152},
  [236] = {.lex_state = 154},
  [237] = {.lex_state = 156},
  [238] = {.lex_state = 156},
  [239] = {.lex_state = 152},
  [240] = {.lex_state = 152},
  [241] = {.lex_state = 152},
  [242] = {.lex_state = 152},
  [243] = {.lex_state = 152},
  [244] = {.lex_state = 152},
  [245] = {.lex_state = 152},
  [246] = {.lex_state = 152},
  [247] = {.lex_state = 152},
  [248] = {.lex_state = 152},
  [249] = {.lex_state = 152},
  [250] = {.lex_state = 152},
  [251] = {.lex_state = 152},
  [252] = {.lex_state = 156},
  [253] = {.lex_state = 152},
  [254] = {.lex_state = 146},
  [255] = {.lex_state = 159},
  [256] = {.lex_state = 152},
  [257] = {.lex_state = 152},
  [258] = {.lex_state = 152},
  [259] = {.lex_state = 152},
  [260] = {.lex_state = 152},
  [261] = {.lex_state = 152},
  [262] = {.lex_state = 148},
  [263] = {.lex_state = 152},
  [264] = {.lex_state = 156},
  [265] = {.lex_state = 152},
  [266] = {.lex_state = 152},
  [267] = {.lex_state = 156},
  [268] = {.lex_state = 156},
  [269] = {.lex_state = 163},
  [270] = {.lex_state = 159},
  [271] = {.lex_state = 159},
  [272] = {.lex_state = 159},
  [273] = {.lex_state = 159},
  [274] = {.lex_state = 163},
  [275] = {.lex_state = 163},
  [276] = {.lex_state = 153},
  [277] = {.lex_state = 153},
  [278] = {.lex_state = 153},
  [279] = {.lex_state = 159},
  [280] = {.lex_state = 159},
  [281] = {.lex_state = 159},
  [282] = {.lex_state = 159},
  [283] = {.lex_state = 159},
  [284] = {.lex_state = 159},
  [285] = {.lex_state = 153},
  [286] = {.lex_state = 163},
  [287] = {.lex_state = 159},
  [288] = {.lex_state = 163},
  [289] = {.lex_state = 159},
  [290] = {.lex_state = 163},
  [291] = {.lex_state = 159},
  [292] = {.lex_state = 157},
  [293] = {.lex_state = 159},
  [294] = {.lex_state = 159},
  [295] = {.lex_state = 153},
  [296] = {.lex_state = 159},
  [297] = {.lex_state = 157},
  [298] = {.lex_state = 159},
  [299] = {.lex_state = 159},
  [300] = {.lex_state = 10},
  [301] = {.lex_state = 155},
  [302] = {.lex_state = 159},
  [303] = {.lex_state = 159},
  [304] = {.lex_state = 159},
  [305] = {.lex_state = 147},
  [306] = {.lex_state = 157},
  [307] = {.lex_state = 157},
  [308] = {.lex_state = 157},
  [309] = {.lex_state = 159},
  [310] = {.lex_state = 157},
  [311] = {.lex_state = 157},
  [312] = {.lex_state = 153},
  [313] = {.lex_state = 157},
  [314] = {.lex_state = 157},
  [315] = {.lex_state = 157},
  [316] = {.lex_state = 163},
  [317] = {.lex_state = 157},
  [318] = {.lex_state = 157},
  [319] = {.lex_state = 157},
  [320] = {.lex_state = 157},
  [321] = {.lex_state = 156},
  [322] = {.lex_state = 156},
  [323] = {.lex_state = 156},
  [324] = {.lex_state = 156},
  [325] = {.lex_state = 157},
  [326] = {.lex_state = 156},
  [327] = {.lex_state = 159},
  [328] = {.lex_state = 156},
  [329] = {.lex_state = 156},
  [330] = {.lex_state = 156},
  [331] = {.lex_state = 156},
  [332] = {.lex_state = 156},
  [333] = {.lex_state = 157},
  [334] = {.lex_state = 157},
  [335] = {.lex_state = 156},
  [336] = {.lex_state = 159},
  [337] = {.lex_state = 156},
  [338] = {.lex_state = 156},
  [339] = {.lex_state = 153},
  [340] = {.lex_state = 159},
  [341] = {.lex_state = 157},
  [342] = {.lex_state = 156},
  [343] = {.lex_state = 157},
  [344] = {.lex_state = 156},
  [345] = {.lex_state = 159},
  [346] = {.lex_state = 156},
  [347] = {.lex_state = 156},
  [348] = {.lex_state = 153},
  [349] = {.lex_state = 157},
  [350] = {.lex_state = 159},
  [351] = {.lex_state = 156},
  [352] = {.lex_state = 156},
  [353] = {.lex_state = 157},
  [354] = {.lex_state = 156},
  [355] = {.lex_state = 153},
  [356] = {.lex_state = 149},
  [357] = {.lex_state = 156},
  [358] = {.lex_state = 156},
  [359] = {.lex_state = 161},
  [360] = {.lex_state = 163},
  [361] = {.lex_state = 159},
  [362] = {.lex_state = 156},
  [363] = {.lex_state = 157},
  [364] = {.lex_state = 2},
  [365] = {.lex_state = 2},
  [366] = {.lex_state = 2},
  [367] = {.lex_state = 2},
  [368] = {.lex_state = 163},
  [369] = {.lex_state = 163},
  [370] = {.lex_state = 163},
  [371] = {.lex_state = 163},
  [372] = {.lex_state = 2},
  [373] = {.lex_state = 163},
  [374] = {.lex_state = 160},
  [375] = {.lex_state = 163},
  [376] = {.lex_state = 163},
  [377] = {.lex_state = 163},
  [378] = {.lex_state = 163},
  [379] = {.lex_state = 163},
  [380] = {.lex_state = 157},
  [381] = {.lex_state = 2},
  [382] = {.lex_state = 163},
  [383] = {.lex_state = 160},
  [384] = {.lex_state = 163},
  [385] = {.lex_state = 163},
  [386] = {.lex_state = 2},
  [387] = {.lex_state = 2},
  [388] = {.lex_state = 160},
  [389] = {.lex_state = 163},
  [390] = {.lex_state = 163},
  [391] = {.lex_state = 163},
  [392] = {.lex_state = 163},
  [393] = {.lex_state = 2},
  [394] = {.lex_state = 157},
  [395] = {.lex_state = 2},
  [396] = {.lex_state = 163},
  [397] = {.lex_state = 163},
  [398] = {.lex_state = 2},
  [399] = {.lex_state = 2},
  [400] = {.lex_state = 2},
  [401] = {.lex_state = 2},
  [402] = {.lex_state = 163},
  [403] = {.lex_state = 163},
  [404] = {.lex_state = 157},
  [405] = {.lex_state = 157},
  [406] = {.lex_state = 2},
  [407] = {.lex_state = 163},
  [408] = {.lex_state = 157},
  [409] = {.lex_state = 157},
  [410] = {.lex_state = 2},
  [411] = {.lex_state = 162},
  [412] = {.lex_state = 150},
  [413] = {.lex_state = 157},
  [414] = {.lex_state = 157},
  [415] = {.lex_state = 157},
  [416] = {.lex_state = 2},
  [417] = {.lex_state = 2},
  [418] = {.lex_state = 2},
  [419] = {.lex_state = 2},
  [420] = {.lex_state = 2},
  [421] = {.lex_state = 157},
  [422] = {.lex_state = 2},
  [423] = {.lex_state = 2},
  [424] = {.lex_state = 157},
  [425] = {.lex_state = 157},
  [426] = {.lex_state = 2},
  [427] = {.lex_state = 2},
  [428] = {.lex_state = 157},
  [429] = {.lex_state = 2},
  [430] = {.lex_state = 2},
  [431] = {.lex_state = 2},
  [432] = {.lex_state = 2},
  [433] = {.lex_state = 2},
  [434] = {.lex_state = 2},
  [435] = {.lex_state = 2},
  [436] = {.lex_state = 2},
  [437] = {.lex_state = 2},
  [438] = {.lex_state = 2},
  [439] = {.lex_state = 2},
  [440] = {.lex_state = 2},
  [441] = {.lex_state = 157},
  [442] = {.lex_state = 2},
  [443] = {.lex_state = 2},
  [444] = {.lex_state = 2},
  [445] = {.lex_state = 157},
  [446] = {.lex_state = 157},
  [447] = {.lex_state = 2},
  [448] = {.lex_state = 157},
  [449] = {.lex_state = 157},
  [450] = {.lex_state = 157},
  [451] = {.lex_state = 157},
  [452] = {.lex_state = 157},
  [453] = {.lex_state = 157},
  [454] = {.lex_state = 157},
  [455] = {.lex_state = 157},
  [456] = {.lex_state = 2},
  [457] = {.lex_state = 157},
  [458] = {.lex_state = 2},
  [459] = {.lex_state = 2},
  [460] = {.lex_state = 2},
  [461] = {.lex_state = 164},
  [462] = {.lex_state = 2},
  [463] = {.lex_state = 164},
  [464] = {.lex_state = 164},
  [465] = {.lex_state = 164},
  [466] = {.lex_state = 164},
  [467] = {.lex_state = 164},
  [468] = {.lex_state = 164},
  [469] = {.lex_state = 2},
  [470] = {.lex_state = 164},
  [471] = {.lex_state = 164},
  [472] = {.lex_state = 2},
  [473] = {.lex_state = 164},
  [474] = {.lex_state = 164},
  [475] = {.lex_state = 164},
  [476] = {.lex_state = 164},
  [477] = {.lex_state = 2},
  [478] = {.lex_state = 164},
  [479] = {.lex_state = 164},
  [480] = {.lex_state = 2},
  [481] = {.lex_state = 164},
  [482] = {.lex_state = 164},
  [483] = {.lex_state = 2},
  [484] = {.lex_state = 2},
  [485] = {.lex_state = 164},
  [486] = {.lex_state = 2},
  [487] = {.lex_state = 164},
  [488] = {.lex_state = 2},
  [489] = {.lex_state = 164},
  [490] = {.lex_state = 164},
  [491] = {.lex_state = 164},
  [492] = {.lex_state = 164},
  [493] = {.lex_state = 2},
  [494] = {.lex_state = 2},
  [495] = {.lex_state = 2},
  [496] = {.lex_state = 2},
  [497] = {.lex_state = 2},
  [498] = {.lex_state = 2},
  [499] = {.lex_state = 2},
  [500] = {.lex_state = 2},
  [501] = {.lex_state = 2},
  [502] = {.lex_state = 164},
  [503] = {.lex_state = 2},
  [504] = {.lex_state = 164},
  [505] = {.lex_state = 164},
  [506] = {.lex_state = 2},
  [507] = {.lex_state = 3},
  [508] = {.lex_state = 1},
  [509] = {.lex_state = 2},
  [510] = {.lex_state = 3},
  [511] = {.lex_state = 3},
  [512] = {.lex_state = 179},
  [513] = {.lex_state = 2},
  [514] = {.lex_state = 3},
  [515] = {.lex_state = 3},
  [516] = {.lex_state = 1},
  [517] = {.lex_state = 179},
  [518] = {.lex_state = 2},
  [519] = {.lex_state = 3},
  [520] = {.lex_state = 2},
  [521] = {.lex_state = 2},
  [522] = {.lex_state = 3},
  [523] = {.lex_state = 3},
  [524] = {.lex_state = 2},
  [525] = {.lex_state = 2},
  [526] = {.lex_state = 179},
  [527] = {.lex_state = 2},
  [528] = {.lex_state = 2},
  [529] = {.lex_state = 179},
  [530] = {.lex_state = 179},
  [531] = {.lex_state = 43},
  [532] = {.lex_state = 180},
  [533] = {.lex_state = 180},
  [534] = {.lex_state = 180},
  [535] = {.lex_state = 180},
  [536] = {.lex_state = 180},
  [537] = {.lex_state = 41},
  [538] = {.lex_state = 178},
  [539] = {.lex_state = 180},
  [540] = {.lex_state = 180},
  [541] = {.lex_state = 180},
  [542] = {.lex_state = 180},
  [543] = {.lex_state = 180},
  [544] = {.lex_state = 180},
  [545] = {.lex_state = 180},
  [546] = {.lex_state = 9},
  [547] = {.lex_state = 0},
  [548] = {.lex_state = 0},
  [549] = {.lex_state = 9},
  [550] = {.lex_state = 188},
  [551] = {.lex_state = 188},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 0},
  [554] = {.lex_state = 0},
  [555] = {.lex_state = 0},
  [556] = {.lex_state = 0},
  [557] = {.lex_state = 188},
  [558] = {.lex_state = 0},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 9},
  [563] = {.lex_state = 9},
  [564] = {.lex_state = 188},
  [565] = {.lex_state = 0},
  [566] = {.lex_state = 0},
  [567] = {.lex_state = 0},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 0},
  [570] = {.lex_state = 0},
  [571] = {.lex_state = 0},
  [572] = {.lex_state = 180},
  [573] = {.lex_state = 0},
  [574] = {.lex_state = 0},
  [575] = {.lex_state = 0},
  [576] = {.lex_state = 0},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 0},
  [579] = {.lex_state = 0},
  [580] = {.lex_state = 0},
  [581] = {.lex_state = 0},
  [582] = {.lex_state = 0},
  [583] = {.lex_state = 9},
  [584] = {.lex_state = 0},
  [585] = {.lex_state = 0},
  [586] = {.lex_state = 0},
  [587] = {.lex_state = 9},
  [588] = {.lex_state = 0},
  [589] = {.lex_state = 0},
  [590] = {.lex_state = 0},
  [591] = {.lex_state = 0},
  [592] = {.lex_state = 0},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 0},
  [595] = {.lex_state = 9},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 0},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 0},
  [603] = {.lex_state = 0},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 0},
  [607] = {.lex_state = 0},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 0},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 0},
  [612] = {.lex_state = 0},
  [613] = {.lex_state = 0},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 188},
  [617] = {.lex_state = 180},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 9},
  [621] = {.lex_state = 0},
  [622] = {.lex_state = 0},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 0},
  [626] = {.lex_state = 0},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 0},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 9},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 188},
  [635] = {.lex_state = 189},
  [636] = {.lex_state = 0},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 190},
  [640] = {.lex_state = 190},
  [641] = {.lex_state = 0},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 190},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 190},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 190},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 0},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 190},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 190},
  [668] = {.lex_state = 190},
  [669] = {.lex_state = 0},
  [670] = {.lex_state = 0},
  [671] = {.lex_state = 0},
  [672] = {.lex_state = 190},
  [673] = {.lex_state = 9},
  [674] = {.lex_state = 0},
  [675] = {.lex_state = 0},
  [676] = {.lex_state = 190},
  [677] = {.lex_state = 9},
  [678] = {.lex_state = 190},
  [679] = {.lex_state = 190},
  [680] = {.lex_state = 190},
  [681] = {.lex_state = 0},
  [682] = {.lex_state = 6},
  [683] = {.lex_state = 190},
  [684] = {.lex_state = 190},
  [685] = {.lex_state = 190},
  [686] = {.lex_state = 0},
  [687] = {.lex_state = 0},
  [688] = {.lex_state = 0},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 190},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 9},
  [693] = {.lex_state = 9},
  [694] = {.lex_state = 0},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 0},
  [698] = {.lex_state = 0},
  [699] = {.lex_state = 0},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 9},
  [702] = {.lex_state = 6},
  [703] = {.lex_state = 0},
  [704] = {.lex_state = 9},
  [705] = {.lex_state = 6},
  [706] = {.lex_state = 0},
  [707] = {.lex_state = 9},
  [708] = {.lex_state = 9},
  [709] = {.lex_state = 0},
  [710] = {.lex_state = 0},
  [711] = {.lex_state = 0},
  [712] = {.lex_state = 0},
  [713] = {.lex_state = 0},
  [714] = {.lex_state = 0},
  [715] = {.lex_state = 0},
  [716] = {.lex_state = 0},
  [717] = {.lex_state = 9},
  [718] = {.lex_state = 0},
  [719] = {.lex_state = 0},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 0},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 0},
  [724] = {.lex_state = 0},
  [725] = {.lex_state = 9},
  [726] = {.lex_state = 6},
  [727] = {.lex_state = 10},
  [728] = {.lex_state = 9},
  [729] = {.lex_state = 141},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 0},
  [732] = {.lex_state = 0},
  [733] = {.lex_state = 9},
  [734] = {.lex_state = 0},
  [735] = {.lex_state = 141},
  [736] = {.lex_state = 10},
  [737] = {.lex_state = 9},
  [738] = {.lex_state = 0},
  [739] = {.lex_state = 3},
  [740] = {.lex_state = 0},
  [741] = {.lex_state = 0},
  [742] = {.lex_state = 3},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 6},
  [745] = {.lex_state = 439},
  [746] = {.lex_state = 442},
  [747] = {.lex_state = 9},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 9},
  [750] = {.lex_state = 6},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 9},
  [753] = {.lex_state = 9},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 0},
  [758] = {.lex_state = 3},
  [759] = {.lex_state = 2},
  [760] = {.lex_state = 6},
  [761] = {.lex_state = 0},
  [762] = {.lex_state = 0},
  [763] = {.lex_state = 6},
  [764] = {.lex_state = 439},
  [765] = {.lex_state = 442},
  [766] = {.lex_state = 9},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 9},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 190},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 10},
  [775] = {.lex_state = 6},
  [776] = {.lex_state = 439},
  [777] = {.lex_state = 442},
  [778] = {.lex_state = 9},
  [779] = {.lex_state = 0},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 2},
  [782] = {.lex_state = 0},
  [783] = {.lex_state = 0},
  [784] = {.lex_state = 0},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 6},
  [788] = {.lex_state = 439},
  [789] = {.lex_state = 442},
  [790] = {.lex_state = 9},
  [791] = {.lex_state = 0},
  [792] = {.lex_state = 10},
  [793] = {.lex_state = 0},
  [794] = {.lex_state = 9},
  [795] = {.lex_state = 442},
  [796] = {.lex_state = 439},
  [797] = {.lex_state = 6},
  [798] = {.lex_state = 3},
  [799] = {.lex_state = 6},
  [800] = {.lex_state = 439},
  [801] = {.lex_state = 442},
  [802] = {.lex_state = 9},
  [803] = {.lex_state = 0},
  [804] = {.lex_state = 0},
  [805] = {.lex_state = 6},
  [806] = {.lex_state = 6},
  [807] = {.lex_state = 10},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 9},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 6},
  [812] = {.lex_state = 439},
  [813] = {.lex_state = 442},
  [814] = {.lex_state = 9},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 9},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 9},
  [821] = {.lex_state = 6},
  [822] = {.lex_state = 9},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 9},
  [828] = {.lex_state = 6},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 0},
  [831] = {.lex_state = 9},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 0},
  [834] = {.lex_state = 0},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 0},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 0},
  [839] = {.lex_state = 0},
  [840] = {.lex_state = 0},
  [841] = {.lex_state = 0},
  [842] = {.lex_state = 0},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 6},
  [845] = {.lex_state = 0},
  [846] = {.lex_state = 9},
  [847] = {.lex_state = 0},
  [848] = {.lex_state = 0},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 0},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 6},
  [855] = {.lex_state = 3},
  [856] = {.lex_state = 0},
  [857] = {.lex_state = 3},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 3},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 3},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 3},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 3},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 10},
  [868] = {.lex_state = 2},
  [869] = {.lex_state = 141},
  [870] = {.lex_state = 9},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 9},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LPARENexact_RPAREN] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_JIT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_EQ_LBRACK] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_package] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_table] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_RBRACK2] = ACTIONS(1),
    [anon_sym_fun] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_self] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_CFunction] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_userdata] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_numeric_literal_type] = ACTIONS(1),
  },
  [1] = {
    [sym_documentation] = STATE(804),
    [sym_class_annotation] = STATE(803),
    [sym_type_annotation] = STATE(803),
    [sym_param_annotation] = STATE(803),
    [sym_alias_annotation] = STATE(803),
    [sym_continuation] = STATE(803),
    [sym_return_annotation] = STATE(803),
    [sym_field_annotation] = STATE(803),
    [sym_qualifier_annotation] = STATE(803),
    [sym_generic_annotation] = STATE(803),
    [sym_vararg_annotation] = STATE(803),
    [sym_diagnostic_annotation] = STATE(803),
    [sym_meta_annotation] = STATE(803),
    [sym_module_annotation] = STATE(803),
    [sym_source_annotation] = STATE(803),
    [sym_version_annotation] = STATE(803),
    [sym_package_annotation] = STATE(803),
    [sym_operator_annotation] = STATE(803),
    [sym_nodiscard_annotation] = STATE(803),
    [sym_deprecated_annotation] = STATE(803),
    [sym_cast_annotation] = STATE(803),
    [sym_async_annotation] = STATE(803),
    [sym_overload_annotation] = STATE(803),
    [sym_enum_annotation] = STATE(803),
    [sym_language_injection] = STATE(803),
    [sym_see_reference] = STATE(803),
    [sym_link_reference] = STATE(803),
    [sym_since_annotation] = STATE(803),
    [sym_as_annotation] = STATE(803),
    [anon_sym_ATclass] = ACTIONS(3),
    [anon_sym_ATtype] = ACTIONS(5),
    [anon_sym_ATparam] = ACTIONS(7),
    [anon_sym_ATalias] = ACTIONS(9),
    [anon_sym_PIPE] = ACTIONS(11),
    [anon_sym_ATreturn] = ACTIONS(13),
    [anon_sym_ATfield] = ACTIONS(15),
    [anon_sym_ATpublic] = ACTIONS(17),
    [anon_sym_ATprotected] = ACTIONS(17),
    [anon_sym_ATprivate] = ACTIONS(17),
    [anon_sym_ATgeneric] = ACTIONS(19),
    [anon_sym_ATvararg] = ACTIONS(21),
    [anon_sym_ATdiagnostic] = ACTIONS(23),
    [anon_sym_ATmeta] = ACTIONS(25),
    [anon_sym_ATmodule] = ACTIONS(27),
    [anon_sym_ATsource] = ACTIONS(29),
    [anon_sym_ATversion] = ACTIONS(31),
    [anon_sym_ATpackage] = ACTIONS(33),
    [anon_sym_AToperator] = ACTIONS(35),
    [anon_sym_ATnodiscard] = ACTIONS(37),
    [anon_sym_ATdeprecated] = ACTIONS(39),
    [anon_sym_ATcast] = ACTIONS(41),
    [anon_sym_ATasync] = ACTIONS(43),
    [anon_sym_AToverload] = ACTIONS(45),
    [anon_sym_ATenum] = ACTIONS(47),
    [anon_sym_ATlanguage] = ACTIONS(49),
    [anon_sym_ATsee] = ACTIONS(51),
    [aux_sym_link_reference_token1] = ACTIONS(53),
    [anon_sym_ATsince] = ACTIONS(55),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_EQ_LBRACK] = ACTIONS(59),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 17,
    ACTIONS(61), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(65), 1,
      anon_sym_RPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(75), 1,
      anon_sym_self,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(87), 1,
      sym_identifier,
    STATE(438), 1,
      sym_type,
    STATE(581), 1,
      sym_parameter,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [70] = 17,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(87), 1,
      sym_identifier,
    ACTIONS(89), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(91), 1,
      anon_sym_RPAREN,
    ACTIONS(93), 1,
      anon_sym_self,
    STATE(419), 1,
      sym_type,
    STATE(636), 1,
      sym_parameter,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [140] = 17,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(87), 1,
      sym_identifier,
    ACTIONS(95), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(97), 1,
      anon_sym_RPAREN,
    ACTIONS(99), 1,
      anon_sym_self,
    STATE(431), 1,
      sym_type,
    STATE(592), 1,
      sym_parameter,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [210] = 17,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(87), 1,
      sym_identifier,
    ACTIONS(101), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(103), 1,
      anon_sym_RPAREN,
    ACTIONS(105), 1,
      anon_sym_self,
    STATE(422), 1,
      sym_type,
    STATE(547), 1,
      sym_parameter,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [280] = 17,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(87), 1,
      sym_identifier,
    ACTIONS(107), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(109), 1,
      anon_sym_RPAREN,
    ACTIONS(111), 1,
      anon_sym_self,
    STATE(426), 1,
      sym_type,
    STATE(560), 1,
      sym_parameter,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [350] = 17,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(87), 1,
      sym_identifier,
    ACTIONS(113), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(115), 1,
      anon_sym_RPAREN,
    ACTIONS(117), 1,
      anon_sym_self,
    STATE(401), 1,
      sym_type,
    STATE(599), 1,
      sym_parameter,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [420] = 17,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(87), 1,
      sym_identifier,
    ACTIONS(119), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(121), 1,
      anon_sym_RPAREN,
    ACTIONS(123), 1,
      anon_sym_self,
    STATE(459), 1,
      sym_type,
    STATE(554), 1,
      sym_parameter,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [490] = 17,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(87), 1,
      sym_identifier,
    ACTIONS(125), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(127), 1,
      anon_sym_RPAREN,
    ACTIONS(129), 1,
      anon_sym_self,
    STATE(381), 1,
      sym_type,
    STATE(633), 1,
      sym_parameter,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [560] = 16,
    ACTIONS(131), 1,
      anon_sym_QMARK,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(135), 1,
      anon_sym_DASH,
    ACTIONS(137), 1,
      anon_sym_PLUS,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(292), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [627] = 16,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    ACTIONS(159), 1,
      anon_sym_QMARK,
    ACTIONS(161), 1,
      anon_sym_DASH,
    ACTIONS(163), 1,
      anon_sym_PLUS,
    STATE(409), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [694] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(165), 1,
      sym_number,
    STATE(519), 1,
      sym_type,
    ACTIONS(167), 2,
      sym_numeric_literal_type,
      sym_identifier,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [753] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(169), 1,
      sym_number,
    STATE(515), 1,
      sym_type,
    ACTIONS(167), 2,
      sym_numeric_literal_type,
      sym_identifier,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [812] = 14,
    ACTIONS(171), 1,
      anon_sym_LPARENexact_RPAREN,
    ACTIONS(173), 1,
      anon_sym_LPAREN,
    ACTIONS(175), 1,
      anon_sym_LBRACE,
    ACTIONS(177), 1,
      anon_sym_table,
    ACTIONS(179), 1,
      anon_sym_fun,
    ACTIONS(181), 1,
      anon_sym_function,
    ACTIONS(183), 1,
      anon_sym_DQUOTE,
    ACTIONS(185), 1,
      anon_sym_SQUOTE,
    ACTIONS(187), 1,
      anon_sym_BQUOTE,
    ACTIONS(191), 1,
      sym_numeric_literal_type,
    ACTIONS(193), 1,
      sym_identifier,
    STATE(255), 1,
      sym_type,
    ACTIONS(189), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(273), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [873] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(195), 1,
      sym_number,
    STATE(523), 1,
      sym_type,
    ACTIONS(167), 2,
      sym_numeric_literal_type,
      sym_identifier,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [932] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(197), 1,
      sym_number,
    STATE(514), 1,
      sym_type,
    ACTIONS(167), 2,
      sym_numeric_literal_type,
      sym_identifier,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [991] = 14,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    ACTIONS(199), 1,
      anon_sym_QMARK,
    STATE(441), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1052] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(201), 1,
      sym_number,
    STATE(522), 1,
      sym_type,
    ACTIONS(167), 2,
      sym_numeric_literal_type,
      sym_identifier,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1111] = 14,
    ACTIONS(203), 1,
      anon_sym_QMARK,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    STATE(286), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1172] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(227), 1,
      sym_number,
    STATE(511), 1,
      sym_type,
    ACTIONS(167), 2,
      sym_numeric_literal_type,
      sym_identifier,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1231] = 14,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(229), 1,
      anon_sym_QMARK,
    STATE(269), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1292] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(231), 1,
      sym_number,
    STATE(510), 1,
      sym_type,
    ACTIONS(167), 2,
      sym_numeric_literal_type,
      sym_identifier,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1351] = 14,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    ACTIONS(233), 1,
      anon_sym_QMARK,
    STATE(353), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1412] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(235), 1,
      sym_number,
    STATE(507), 1,
      sym_type,
    ACTIONS(167), 2,
      sym_numeric_literal_type,
      sym_identifier,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1471] = 14,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    ACTIONS(237), 1,
      anon_sym_QMARK,
    STATE(290), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1532] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(495), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1590] = 13,
    ACTIONS(239), 1,
      anon_sym_LPAREN,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(243), 1,
      anon_sym_table,
    ACTIONS(245), 1,
      anon_sym_fun,
    ACTIONS(247), 1,
      anon_sym_function,
    ACTIONS(249), 1,
      anon_sym_DQUOTE,
    ACTIONS(251), 1,
      anon_sym_SQUOTE,
    ACTIONS(253), 1,
      anon_sym_BQUOTE,
    ACTIONS(257), 1,
      sym_numeric_literal_type,
    ACTIONS(259), 1,
      sym_identifier,
    STATE(206), 1,
      sym_type,
    ACTIONS(255), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(258), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1648] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(442), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1706] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(440), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1764] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(439), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1822] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(503), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1880] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(501), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1938] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(437), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [1996] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(436), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2054] = 13,
    ACTIONS(261), 1,
      anon_sym_LPAREN,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_table,
    ACTIONS(267), 1,
      anon_sym_fun,
    ACTIONS(269), 1,
      anon_sym_function,
    ACTIONS(271), 1,
      anon_sym_DQUOTE,
    ACTIONS(273), 1,
      anon_sym_SQUOTE,
    ACTIONS(275), 1,
      anon_sym_BQUOTE,
    ACTIONS(279), 1,
      sym_numeric_literal_type,
    ACTIONS(281), 1,
      sym_identifier,
    STATE(505), 1,
      sym_type,
    ACTIONS(277), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(492), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2112] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(513), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2170] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(435), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2228] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(434), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2286] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(433), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2344] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(499), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2402] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(498), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2460] = 13,
    ACTIONS(175), 1,
      anon_sym_LBRACE,
    ACTIONS(177), 1,
      anon_sym_table,
    ACTIONS(179), 1,
      anon_sym_fun,
    ACTIONS(181), 1,
      anon_sym_function,
    ACTIONS(183), 1,
      anon_sym_DQUOTE,
    ACTIONS(185), 1,
      anon_sym_SQUOTE,
    ACTIONS(187), 1,
      anon_sym_BQUOTE,
    ACTIONS(191), 1,
      sym_numeric_literal_type,
    ACTIONS(193), 1,
      sym_identifier,
    ACTIONS(283), 1,
      anon_sym_LPAREN,
    STATE(225), 1,
      sym_type,
    ACTIONS(189), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(273), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2518] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(506), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2576] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(430), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2634] = 13,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    STATE(274), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2692] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(429), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2750] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(447), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2808] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(521), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2866] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(427), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2924] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(399), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [2982] = 13,
    ACTIONS(239), 1,
      anon_sym_LPAREN,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(243), 1,
      anon_sym_table,
    ACTIONS(245), 1,
      anon_sym_fun,
    ACTIONS(247), 1,
      anon_sym_function,
    ACTIONS(249), 1,
      anon_sym_DQUOTE,
    ACTIONS(251), 1,
      anon_sym_SQUOTE,
    ACTIONS(253), 1,
      anon_sym_BQUOTE,
    ACTIONS(257), 1,
      sym_numeric_literal_type,
    ACTIONS(285), 1,
      sym_identifier,
    STATE(207), 1,
      sym_type,
    ACTIONS(255), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(258), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3040] = 13,
    ACTIONS(239), 1,
      anon_sym_LPAREN,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(243), 1,
      anon_sym_table,
    ACTIONS(245), 1,
      anon_sym_fun,
    ACTIONS(247), 1,
      anon_sym_function,
    ACTIONS(249), 1,
      anon_sym_DQUOTE,
    ACTIONS(251), 1,
      anon_sym_SQUOTE,
    ACTIONS(253), 1,
      anon_sym_BQUOTE,
    ACTIONS(257), 1,
      sym_numeric_literal_type,
    ACTIONS(259), 1,
      sym_identifier,
    STATE(249), 1,
      sym_type,
    ACTIONS(255), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(258), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3098] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(500), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3156] = 13,
    ACTIONS(261), 1,
      anon_sym_LPAREN,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_table,
    ACTIONS(267), 1,
      anon_sym_fun,
    ACTIONS(269), 1,
      anon_sym_function,
    ACTIONS(271), 1,
      anon_sym_DQUOTE,
    ACTIONS(273), 1,
      anon_sym_SQUOTE,
    ACTIONS(275), 1,
      anon_sym_BQUOTE,
    ACTIONS(279), 1,
      sym_numeric_literal_type,
    ACTIONS(281), 1,
      sym_identifier,
    STATE(502), 1,
      sym_type,
    ACTIONS(277), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(492), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3214] = 13,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    STATE(288), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3272] = 13,
    ACTIONS(239), 1,
      anon_sym_LPAREN,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(243), 1,
      anon_sym_table,
    ACTIONS(245), 1,
      anon_sym_fun,
    ACTIONS(247), 1,
      anon_sym_function,
    ACTIONS(249), 1,
      anon_sym_DQUOTE,
    ACTIONS(251), 1,
      anon_sym_SQUOTE,
    ACTIONS(253), 1,
      anon_sym_BQUOTE,
    ACTIONS(257), 1,
      sym_numeric_literal_type,
    ACTIONS(259), 1,
      sym_identifier,
    STATE(200), 1,
      sym_type,
    ACTIONS(255), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(258), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3330] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(494), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3388] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(423), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3446] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(488), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3504] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(460), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3562] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(372), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3620] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(364), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3678] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(527), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3736] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(365), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3794] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(366), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3852] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(367), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3910] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(486), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [3968] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(484), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4026] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(386), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4084] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(393), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4142] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(518), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4200] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(398), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4258] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(458), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4316] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(400), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4374] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(483), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4432] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(462), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4490] = 13,
    ACTIONS(239), 1,
      anon_sym_LPAREN,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(243), 1,
      anon_sym_table,
    ACTIONS(245), 1,
      anon_sym_fun,
    ACTIONS(247), 1,
      anon_sym_function,
    ACTIONS(249), 1,
      anon_sym_DQUOTE,
    ACTIONS(251), 1,
      anon_sym_SQUOTE,
    ACTIONS(253), 1,
      anon_sym_BQUOTE,
    ACTIONS(257), 1,
      sym_numeric_literal_type,
    ACTIONS(287), 1,
      sym_identifier,
    STATE(197), 1,
      sym_type,
    ACTIONS(255), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(258), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4548] = 13,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    STATE(275), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4606] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(456), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4664] = 13,
    ACTIONS(239), 1,
      anon_sym_LPAREN,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(243), 1,
      anon_sym_table,
    ACTIONS(245), 1,
      anon_sym_fun,
    ACTIONS(247), 1,
      anon_sym_function,
    ACTIONS(249), 1,
      anon_sym_DQUOTE,
    ACTIONS(251), 1,
      anon_sym_SQUOTE,
    ACTIONS(253), 1,
      anon_sym_BQUOTE,
    ACTIONS(257), 1,
      sym_numeric_literal_type,
    ACTIONS(259), 1,
      sym_identifier,
    STATE(260), 1,
      sym_type,
    ACTIONS(255), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(258), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4722] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(508), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4780] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(516), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4838] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(497), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4896] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(309), 1,
      sym_identifier,
    STATE(264), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [4954] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(342), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5012] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(406), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5070] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(493), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5128] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(313), 1,
      sym_identifier,
    STATE(267), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5186] = 13,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    STATE(377), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5244] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(410), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5302] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(205), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5360] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(194), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5418] = 13,
    ACTIONS(175), 1,
      anon_sym_LBRACE,
    ACTIONS(177), 1,
      anon_sym_table,
    ACTIONS(179), 1,
      anon_sym_fun,
    ACTIONS(181), 1,
      anon_sym_function,
    ACTIONS(183), 1,
      anon_sym_DQUOTE,
    ACTIONS(185), 1,
      anon_sym_SQUOTE,
    ACTIONS(187), 1,
      anon_sym_BQUOTE,
    ACTIONS(191), 1,
      sym_numeric_literal_type,
    ACTIONS(193), 1,
      sym_identifier,
    ACTIONS(283), 1,
      anon_sym_LPAREN,
    STATE(327), 1,
      sym_type,
    ACTIONS(189), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(273), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5476] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(231), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5534] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(524), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5592] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(416), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5650] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(315), 1,
      sym_identifier,
    STATE(216), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5708] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(354), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5766] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(417), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5824] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(418), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5882] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(469), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5940] = 13,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    STATE(360), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [5998] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(218), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6056] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(237), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6114] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(472), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6172] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(496), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6230] = 13,
    ACTIONS(261), 1,
      anon_sym_LPAREN,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_table,
    ACTIONS(267), 1,
      anon_sym_fun,
    ACTIONS(269), 1,
      anon_sym_function,
    ACTIONS(271), 1,
      anon_sym_DQUOTE,
    ACTIONS(273), 1,
      anon_sym_SQUOTE,
    ACTIONS(275), 1,
      anon_sym_BQUOTE,
    ACTIONS(279), 1,
      sym_numeric_literal_type,
    ACTIONS(281), 1,
      sym_identifier,
    STATE(465), 1,
      sym_type,
    ACTIONS(277), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(492), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6288] = 13,
    ACTIONS(239), 1,
      anon_sym_LPAREN,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(243), 1,
      anon_sym_table,
    ACTIONS(245), 1,
      anon_sym_fun,
    ACTIONS(247), 1,
      anon_sym_function,
    ACTIONS(249), 1,
      anon_sym_DQUOTE,
    ACTIONS(251), 1,
      anon_sym_SQUOTE,
    ACTIONS(253), 1,
      anon_sym_BQUOTE,
    ACTIONS(257), 1,
      sym_numeric_literal_type,
    ACTIONS(259), 1,
      sym_identifier,
    STATE(203), 1,
      sym_type,
    ACTIONS(255), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(258), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6346] = 13,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    STATE(269), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6404] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(421), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6462] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(363), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6520] = 13,
    ACTIONS(261), 1,
      anon_sym_LPAREN,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_table,
    ACTIONS(267), 1,
      anon_sym_fun,
    ACTIONS(269), 1,
      anon_sym_function,
    ACTIONS(271), 1,
      anon_sym_DQUOTE,
    ACTIONS(273), 1,
      anon_sym_SQUOTE,
    ACTIONS(275), 1,
      anon_sym_BQUOTE,
    ACTIONS(279), 1,
      sym_numeric_literal_type,
    ACTIONS(281), 1,
      sym_identifier,
    STATE(504), 1,
      sym_type,
    ACTIONS(277), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(492), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6578] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(380), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6636] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(330), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6694] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(317), 1,
      sym_identifier,
    STATE(349), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6752] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(480), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6810] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(319), 1,
      sym_identifier,
    STATE(343), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6868] = 13,
    ACTIONS(261), 1,
      anon_sym_LPAREN,
    ACTIONS(263), 1,
      anon_sym_LBRACE,
    ACTIONS(265), 1,
      anon_sym_table,
    ACTIONS(267), 1,
      anon_sym_fun,
    ACTIONS(269), 1,
      anon_sym_function,
    ACTIONS(271), 1,
      anon_sym_DQUOTE,
    ACTIONS(273), 1,
      anon_sym_SQUOTE,
    ACTIONS(275), 1,
      anon_sym_BQUOTE,
    ACTIONS(279), 1,
      sym_numeric_literal_type,
    ACTIONS(281), 1,
      sym_identifier,
    STATE(487), 1,
      sym_type,
    ACTIONS(277), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(492), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6926] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(528), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [6984] = 13,
    ACTIONS(239), 1,
      anon_sym_LPAREN,
    ACTIONS(241), 1,
      anon_sym_LBRACE,
    ACTIONS(243), 1,
      anon_sym_table,
    ACTIONS(245), 1,
      anon_sym_fun,
    ACTIONS(247), 1,
      anon_sym_function,
    ACTIONS(249), 1,
      anon_sym_DQUOTE,
    ACTIONS(251), 1,
      anon_sym_SQUOTE,
    ACTIONS(253), 1,
      anon_sym_BQUOTE,
    ACTIONS(257), 1,
      sym_numeric_literal_type,
    ACTIONS(321), 1,
      sym_identifier,
    STATE(198), 1,
      sym_type,
    ACTIONS(255), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(258), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7042] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(477), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7100] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(525), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7158] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(432), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7216] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(159), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7274] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(166), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7332] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(333), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7390] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(520), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7448] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(323), 1,
      sym_identifier,
    STATE(167), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7506] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(152), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7564] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(325), 1,
      sym_identifier,
    STATE(325), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7622] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(212), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7680] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(327), 1,
      sym_identifier,
    STATE(170), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7738] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(387), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7796] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(315), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7854] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(307), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7912] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(329), 1,
      sym_identifier,
    STATE(172), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [7970] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(395), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8028] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(179), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8086] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(444), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8144] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(331), 1,
      sym_identifier,
    STATE(313), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8202] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(333), 1,
      sym_identifier,
    STATE(314), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8260] = 13,
    ACTIONS(289), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_LBRACE,
    ACTIONS(293), 1,
      anon_sym_table,
    ACTIONS(295), 1,
      anon_sym_fun,
    ACTIONS(297), 1,
      anon_sym_function,
    ACTIONS(299), 1,
      anon_sym_DQUOTE,
    ACTIONS(301), 1,
      anon_sym_SQUOTE,
    ACTIONS(303), 1,
      anon_sym_BQUOTE,
    ACTIONS(307), 1,
      sym_numeric_literal_type,
    ACTIONS(311), 1,
      sym_identifier,
    STATE(196), 1,
      sym_type,
    ACTIONS(305), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(322), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8318] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(320), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8376] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(319), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8434] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(443), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8492] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(157), 1,
      sym_identifier,
    STATE(317), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8550] = 13,
    ACTIONS(205), 1,
      anon_sym_LPAREN,
    ACTIONS(207), 1,
      anon_sym_LBRACE,
    ACTIONS(209), 1,
      anon_sym_table,
    ACTIONS(211), 1,
      anon_sym_fun,
    ACTIONS(213), 1,
      anon_sym_function,
    ACTIONS(215), 1,
      anon_sym_DQUOTE,
    ACTIONS(217), 1,
      anon_sym_SQUOTE,
    ACTIONS(219), 1,
      anon_sym_BQUOTE,
    ACTIONS(223), 1,
      sym_numeric_literal_type,
    ACTIONS(225), 1,
      sym_identifier,
    STATE(316), 1,
      sym_type,
    ACTIONS(221), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(369), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8608] = 13,
    ACTIONS(63), 1,
      anon_sym_LPAREN,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(69), 1,
      anon_sym_table,
    ACTIONS(71), 1,
      anon_sym_fun,
    ACTIONS(73), 1,
      anon_sym_function,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      anon_sym_SQUOTE,
    ACTIONS(81), 1,
      anon_sym_BQUOTE,
    ACTIONS(85), 1,
      sym_numeric_literal_type,
    ACTIONS(167), 1,
      sym_identifier,
    STATE(509), 1,
      sym_type,
    ACTIONS(83), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(191), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8666] = 13,
    ACTIONS(133), 1,
      anon_sym_LPAREN,
    ACTIONS(139), 1,
      anon_sym_LBRACE,
    ACTIONS(141), 1,
      anon_sym_table,
    ACTIONS(143), 1,
      anon_sym_fun,
    ACTIONS(145), 1,
      anon_sym_function,
    ACTIONS(147), 1,
      anon_sym_DQUOTE,
    ACTIONS(149), 1,
      anon_sym_SQUOTE,
    ACTIONS(151), 1,
      anon_sym_BQUOTE,
    ACTIONS(155), 1,
      sym_numeric_literal_type,
    ACTIONS(335), 1,
      sym_identifier,
    STATE(318), 1,
      sym_type,
    ACTIONS(153), 8,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
    STATE(414), 12,
      sym_array_type,
      sym_table_type,
      sym_table_literal_type,
      sym_union_type,
      sym_parenthesized_type,
      sym_tuple_type,
      sym_function_type,
      sym_member_type,
      sym_optional_type,
      sym_literal_type,
      sym_custom_type,
      sym_builtin_type,
  [8724] = 2,
    ACTIONS(337), 7,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_numeric_literal_type,
    ACTIONS(339), 12,
      anon_sym_table,
      anon_sym_fun,
      anon_sym_function,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
      sym_identifier,
  [8748] = 2,
    ACTIONS(341), 7,
      anon_sym_QMARK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_numeric_literal_type,
    ACTIONS(343), 12,
      anon_sym_table,
      anon_sym_fun,
      anon_sym_function,
      anon_sym_any,
      anon_sym_boolean,
      anon_sym_CFunction,
      anon_sym_nil,
      anon_sym_number,
      anon_sym_string,
      anon_sym_userdata,
      anon_sym_void,
      sym_identifier,
  [8772] = 8,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(357), 1,
      anon_sym_RBRACK2,
    STATE(165), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(353), 5,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_GT,
  [8802] = 3,
    ACTIONS(359), 1,
      anon_sym_COLON,
    ACTIONS(363), 1,
      anon_sym_RBRACK2,
    ACTIONS(361), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [8822] = 3,
    ACTIONS(367), 1,
      anon_sym_LPAREN,
    ACTIONS(369), 1,
      anon_sym_RBRACK2,
    ACTIONS(365), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [8842] = 3,
    ACTIONS(369), 1,
      anon_sym_RBRACK2,
    ACTIONS(371), 1,
      anon_sym_LT,
    ACTIONS(365), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [8862] = 3,
    ACTIONS(373), 1,
      anon_sym_COLON,
    ACTIONS(377), 1,
      anon_sym_RBRACK2,
    ACTIONS(375), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [8882] = 4,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(381), 1,
      anon_sym_RBRACK2,
    STATE(160), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(379), 10,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [8904] = 3,
    ACTIONS(377), 1,
      anon_sym_RBRACK2,
    ACTIONS(383), 1,
      anon_sym_COLON,
    ACTIONS(375), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [8924] = 8,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(387), 1,
      anon_sym_RBRACK2,
    STATE(157), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(385), 5,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_GT,
  [8954] = 4,
    ACTIONS(389), 1,
      anon_sym_COMMA,
    ACTIONS(394), 1,
      anon_sym_RBRACK2,
    STATE(160), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(392), 10,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [8976] = 3,
    ACTIONS(396), 1,
      anon_sym_COLON,
    ACTIONS(400), 1,
      anon_sym_RBRACK2,
    ACTIONS(398), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [8996] = 4,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(404), 1,
      anon_sym_RBRACK2,
    STATE(160), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(402), 10,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9018] = 4,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(408), 1,
      anon_sym_RBRACK2,
    STATE(160), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(406), 10,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9040] = 3,
    ACTIONS(377), 1,
      anon_sym_RBRACK2,
    ACTIONS(410), 1,
      anon_sym_COLON,
    ACTIONS(375), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9060] = 4,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(414), 1,
      anon_sym_RBRACK2,
    STATE(160), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(412), 10,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9082] = 8,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(418), 1,
      anon_sym_RBRACK2,
    STATE(162), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(416), 5,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_GT,
  [9112] = 8,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(422), 1,
      anon_sym_RBRACK2,
    STATE(163), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(420), 5,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_GT,
  [9142] = 4,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(422), 1,
      anon_sym_RBRACK2,
    STATE(160), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(420), 10,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9164] = 4,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(426), 1,
      anon_sym_RBRACK2,
    STATE(160), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(424), 10,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9186] = 8,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(426), 1,
      anon_sym_RBRACK2,
    STATE(168), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(424), 5,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_GT,
  [9216] = 3,
    ACTIONS(428), 1,
      anon_sym_COLON,
    ACTIONS(432), 1,
      anon_sym_RBRACK2,
    ACTIONS(430), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9236] = 8,
    ACTIONS(345), 1,
      anon_sym_COMMA,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(432), 1,
      anon_sym_RBRACK2,
    STATE(169), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(430), 5,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_GT,
  [9266] = 2,
    ACTIONS(436), 1,
      anon_sym_RBRACK2,
    ACTIONS(434), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9283] = 2,
    ACTIONS(440), 1,
      anon_sym_RBRACK2,
    ACTIONS(438), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9300] = 2,
    ACTIONS(444), 1,
      anon_sym_RBRACK2,
    ACTIONS(442), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9317] = 2,
    ACTIONS(448), 1,
      anon_sym_RBRACK2,
    ACTIONS(446), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9334] = 2,
    ACTIONS(452), 1,
      anon_sym_RBRACK2,
    ACTIONS(450), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9351] = 2,
    ACTIONS(456), 1,
      anon_sym_RBRACK2,
    ACTIONS(454), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9368] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(394), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(392), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_GT,
  [9393] = 2,
    ACTIONS(460), 1,
      anon_sym_RBRACK2,
    ACTIONS(458), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9410] = 2,
    ACTIONS(464), 1,
      anon_sym_RBRACK2,
    ACTIONS(462), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9427] = 2,
    ACTIONS(468), 1,
      anon_sym_RBRACK2,
    ACTIONS(466), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9444] = 2,
    ACTIONS(472), 1,
      anon_sym_RBRACK2,
    ACTIONS(470), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9461] = 2,
    ACTIONS(369), 1,
      anon_sym_RBRACK2,
    ACTIONS(365), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9478] = 2,
    ACTIONS(476), 1,
      anon_sym_RBRACK2,
    ACTIONS(474), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9495] = 2,
    ACTIONS(480), 1,
      anon_sym_RBRACK2,
    ACTIONS(478), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9512] = 2,
    ACTIONS(484), 1,
      anon_sym_RBRACK2,
    ACTIONS(482), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9529] = 2,
    ACTIONS(488), 1,
      anon_sym_RBRACK2,
    ACTIONS(486), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9546] = 2,
    ACTIONS(492), 1,
      anon_sym_RBRACK2,
    ACTIONS(490), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9563] = 2,
    ACTIONS(496), 1,
      anon_sym_RBRACK2,
    ACTIONS(494), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9580] = 2,
    ACTIONS(377), 1,
      anon_sym_RBRACK2,
    ACTIONS(375), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9597] = 2,
    ACTIONS(500), 1,
      anon_sym_RBRACK2,
    ACTIONS(498), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9614] = 2,
    ACTIONS(504), 1,
      anon_sym_RBRACK2,
    ACTIONS(502), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9631] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(508), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(506), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_GT,
  [9656] = 2,
    ACTIONS(512), 1,
      anon_sym_RBRACK2,
    ACTIONS(510), 11,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK_RBRACK,
      anon_sym_RBRACK_EQ_RBRACK,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_POUND,
  [9673] = 11,
    ACTIONS(514), 1,
      ts_builtin_sym_end,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(526), 1,
      sym_comment,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    STATE(517), 1,
      aux_sym_type_annotation_repeat1,
    STATE(748), 1,
      sym_at_comment,
  [9707] = 9,
    ACTIONS(424), 1,
      ts_builtin_sym_end,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    ACTIONS(534), 1,
      anon_sym_QMARK,
    ACTIONS(536), 1,
      anon_sym_PIPE,
    ACTIONS(538), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LBRACK,
    ACTIONS(542), 1,
      anon_sym_POUND,
    STATE(199), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(426), 3,
      anon_sym_COLON,
      anon_sym_AT,
      sym_comment,
  [9737] = 9,
    ACTIONS(430), 1,
      ts_builtin_sym_end,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    ACTIONS(534), 1,
      anon_sym_QMARK,
    ACTIONS(536), 1,
      anon_sym_PIPE,
    ACTIONS(538), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LBRACK,
    ACTIONS(542), 1,
      anon_sym_POUND,
    STATE(208), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(432), 3,
      anon_sym_COLON,
      anon_sym_AT,
      sym_comment,
  [9767] = 4,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    STATE(202), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(420), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(422), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [9787] = 9,
    ACTIONS(416), 1,
      ts_builtin_sym_end,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    ACTIONS(534), 1,
      anon_sym_QMARK,
    ACTIONS(536), 1,
      anon_sym_PIPE,
    ACTIONS(538), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LBRACK,
    ACTIONS(542), 1,
      anon_sym_POUND,
    STATE(204), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(418), 3,
      anon_sym_COLON,
      anon_sym_AT,
      sym_comment,
  [9817] = 4,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    STATE(202), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(379), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(381), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [9837] = 4,
    ACTIONS(544), 1,
      anon_sym_COMMA,
    STATE(202), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(392), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(394), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [9857] = 9,
    ACTIONS(353), 1,
      ts_builtin_sym_end,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    ACTIONS(534), 1,
      anon_sym_QMARK,
    ACTIONS(536), 1,
      anon_sym_PIPE,
    ACTIONS(538), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LBRACK,
    ACTIONS(542), 1,
      anon_sym_POUND,
    STATE(209), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(357), 3,
      anon_sym_COLON,
      anon_sym_AT,
      sym_comment,
  [9887] = 4,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    STATE(202), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(402), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(404), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [9907] = 11,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    ACTIONS(547), 1,
      ts_builtin_sym_end,
    ACTIONS(549), 1,
      anon_sym_COMMA,
    ACTIONS(551), 1,
      anon_sym_AT,
    ACTIONS(553), 1,
      sym_comment,
    STATE(526), 1,
      aux_sym_class_annotation_repeat1,
    STATE(767), 1,
      sym_class_at_comment,
  [9941] = 9,
    ACTIONS(385), 1,
      ts_builtin_sym_end,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    ACTIONS(534), 1,
      anon_sym_QMARK,
    ACTIONS(536), 1,
      anon_sym_PIPE,
    ACTIONS(538), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LBRACK,
    ACTIONS(542), 1,
      anon_sym_POUND,
    STATE(201), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(387), 3,
      anon_sym_COLON,
      anon_sym_AT,
      sym_comment,
  [9971] = 9,
    ACTIONS(420), 1,
      ts_builtin_sym_end,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    ACTIONS(534), 1,
      anon_sym_QMARK,
    ACTIONS(536), 1,
      anon_sym_PIPE,
    ACTIONS(538), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LBRACK,
    ACTIONS(542), 1,
      anon_sym_POUND,
    STATE(211), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(422), 3,
      anon_sym_COLON,
      anon_sym_AT,
      sym_comment,
  [10001] = 4,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    STATE(202), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(424), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(426), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10021] = 4,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    STATE(202), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(412), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(414), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10041] = 3,
    ACTIONS(555), 1,
      anon_sym_LPAREN,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10059] = 4,
    ACTIONS(532), 1,
      anon_sym_COMMA,
    STATE(202), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(406), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(408), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10079] = 11,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    ACTIONS(549), 1,
      anon_sym_COMMA,
    ACTIONS(551), 1,
      anon_sym_AT,
    ACTIONS(557), 1,
      ts_builtin_sym_end,
    ACTIONS(559), 1,
      sym_comment,
    STATE(512), 1,
      aux_sym_class_annotation_repeat1,
    STATE(818), 1,
      sym_class_at_comment,
  [10113] = 3,
    ACTIONS(561), 1,
      anon_sym_LT,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10131] = 3,
    ACTIONS(563), 1,
      anon_sym_LT,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10148] = 2,
    ACTIONS(502), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(504), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10163] = 9,
    ACTIONS(420), 1,
      ts_builtin_sym_end,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    STATE(222), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(422), 2,
      anon_sym_AT,
      sym_comment,
  [10192] = 4,
    ACTIONS(565), 1,
      anon_sym_COMMA,
    STATE(217), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(392), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(394), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10211] = 9,
    ACTIONS(416), 1,
      ts_builtin_sym_end,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    STATE(234), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(418), 2,
      anon_sym_AT,
      sym_comment,
  [10240] = 4,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    STATE(217), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(412), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(414), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10259] = 3,
    ACTIONS(568), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10276] = 3,
    ACTIONS(570), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10293] = 4,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    STATE(217), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(406), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(408), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10312] = 4,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    STATE(217), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(424), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(426), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10331] = 3,
    ACTIONS(572), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10348] = 10,
    ACTIONS(551), 1,
      anon_sym_AT,
    ACTIONS(574), 1,
      ts_builtin_sym_end,
    ACTIONS(576), 1,
      anon_sym_COLON,
    ACTIONS(578), 1,
      anon_sym_QMARK,
    ACTIONS(580), 1,
      anon_sym_PIPE,
    ACTIONS(582), 1,
      anon_sym_DOT,
    ACTIONS(584), 1,
      sym_comment,
    ACTIONS(586), 1,
      anon_sym_LBRACK,
    ACTIONS(588), 1,
      anon_sym_POUND,
    STATE(862), 1,
      sym_class_at_comment,
  [10379] = 3,
    ACTIONS(590), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10396] = 3,
    ACTIONS(592), 1,
      anon_sym_COLON,
    ACTIONS(361), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(363), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10413] = 2,
    ACTIONS(438), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(440), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10428] = 3,
    ACTIONS(594), 1,
      anon_sym_COLON,
    ACTIONS(430), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(432), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10445] = 2,
    ACTIONS(458), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(460), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10460] = 9,
    ACTIONS(353), 1,
      ts_builtin_sym_end,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    STATE(219), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(357), 2,
      anon_sym_AT,
      sym_comment,
  [10489] = 2,
    ACTIONS(434), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(436), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10504] = 2,
    ACTIONS(486), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(488), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10519] = 4,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    STATE(217), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(402), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(404), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10538] = 3,
    ACTIONS(596), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10555] = 3,
    ACTIONS(598), 1,
      anon_sym_LT,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10572] = 9,
    ACTIONS(385), 1,
      ts_builtin_sym_end,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    STATE(238), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(387), 2,
      anon_sym_AT,
      sym_comment,
  [10601] = 4,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    STATE(217), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(379), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(381), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10620] = 2,
    ACTIONS(490), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(492), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10635] = 2,
    ACTIONS(510), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(512), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10650] = 3,
    ACTIONS(600), 1,
      anon_sym_COLON,
    ACTIONS(398), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(400), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10667] = 2,
    ACTIONS(498), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(500), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10682] = 2,
    ACTIONS(494), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(496), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10697] = 2,
    ACTIONS(482), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(484), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10712] = 2,
    ACTIONS(478), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(480), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10727] = 2,
    ACTIONS(462), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(464), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10742] = 2,
    ACTIONS(450), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(452), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10757] = 2,
    ACTIONS(442), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(444), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10772] = 7,
    ACTIONS(506), 1,
      ts_builtin_sym_end,
    ACTIONS(534), 1,
      anon_sym_QMARK,
    ACTIONS(536), 1,
      anon_sym_PIPE,
    ACTIONS(538), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LBRACK,
    ACTIONS(542), 1,
      anon_sym_POUND,
    ACTIONS(508), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AT,
      sym_comment,
  [10797] = 2,
    ACTIONS(454), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(456), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10812] = 2,
    ACTIONS(466), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(468), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10827] = 4,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    STATE(217), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(420), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(422), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10846] = 2,
    ACTIONS(470), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(472), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10861] = 3,
    ACTIONS(602), 1,
      anon_sym_LPAREN,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10878] = 10,
    ACTIONS(551), 1,
      anon_sym_AT,
    ACTIONS(578), 1,
      anon_sym_QMARK,
    ACTIONS(580), 1,
      anon_sym_PIPE,
    ACTIONS(582), 1,
      anon_sym_DOT,
    ACTIONS(586), 1,
      anon_sym_LBRACK,
    ACTIONS(588), 1,
      anon_sym_POUND,
    ACTIONS(604), 1,
      ts_builtin_sym_end,
    ACTIONS(606), 1,
      anon_sym_COLON,
    ACTIONS(608), 1,
      sym_comment,
    STATE(751), 1,
      sym_class_at_comment,
  [10909] = 2,
    ACTIONS(446), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(448), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10924] = 2,
    ACTIONS(474), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(476), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10939] = 2,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10954] = 3,
    ACTIONS(610), 1,
      anon_sym_COLON,
    ACTIONS(398), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(400), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [10971] = 7,
    ACTIONS(392), 1,
      ts_builtin_sym_end,
    ACTIONS(534), 1,
      anon_sym_QMARK,
    ACTIONS(536), 1,
      anon_sym_PIPE,
    ACTIONS(538), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LBRACK,
    ACTIONS(542), 1,
      anon_sym_POUND,
    ACTIONS(394), 4,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_AT,
      sym_comment,
  [10996] = 3,
    ACTIONS(612), 1,
      anon_sym_COLON,
    ACTIONS(361), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(363), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11013] = 3,
    ACTIONS(614), 1,
      anon_sym_LPAREN,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11030] = 2,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 8,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11045] = 9,
    ACTIONS(430), 1,
      ts_builtin_sym_end,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    STATE(223), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(432), 2,
      anon_sym_AT,
      sym_comment,
  [11074] = 3,
    ACTIONS(616), 1,
      anon_sym_COLON,
    ACTIONS(430), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(432), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11091] = 3,
    ACTIONS(618), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11108] = 9,
    ACTIONS(424), 1,
      ts_builtin_sym_end,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    STATE(252), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(426), 2,
      anon_sym_AT,
      sym_comment,
  [11137] = 2,
    ACTIONS(498), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(500), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11151] = 9,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(620), 1,
      ts_builtin_sym_end,
    ACTIONS(622), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_PIPE,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(628), 1,
      sym_comment,
    ACTIONS(630), 1,
      anon_sym_LBRACK,
    ACTIONS(632), 1,
      anon_sym_POUND,
    STATE(719), 1,
      sym_at_comment,
  [11179] = 2,
    ACTIONS(498), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(500), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11193] = 2,
    ACTIONS(510), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(512), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11207] = 2,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11221] = 2,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11235] = 9,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(622), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_PIPE,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(630), 1,
      anon_sym_LBRACK,
    ACTIONS(632), 1,
      anon_sym_POUND,
    ACTIONS(634), 1,
      ts_builtin_sym_end,
    ACTIONS(636), 1,
      sym_comment,
    STATE(793), 1,
      sym_at_comment,
  [11263] = 9,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(622), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_PIPE,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(630), 1,
      anon_sym_LBRACK,
    ACTIONS(632), 1,
      anon_sym_POUND,
    ACTIONS(638), 1,
      ts_builtin_sym_end,
    ACTIONS(640), 1,
      sym_comment,
    STATE(743), 1,
      sym_at_comment,
  [11291] = 3,
    ACTIONS(642), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11307] = 3,
    ACTIONS(644), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11323] = 3,
    ACTIONS(646), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11339] = 2,
    ACTIONS(474), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(476), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11353] = 3,
    ACTIONS(616), 1,
      anon_sym_COLON,
    ACTIONS(430), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(432), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11369] = 2,
    ACTIONS(446), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(448), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11383] = 2,
    ACTIONS(490), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(492), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11397] = 3,
    ACTIONS(612), 1,
      anon_sym_COLON,
    ACTIONS(361), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(363), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11413] = 3,
    ACTIONS(610), 1,
      anon_sym_COLON,
    ACTIONS(398), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(400), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11429] = 3,
    ACTIONS(648), 1,
      anon_sym_COLON,
    ACTIONS(430), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(432), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11445] = 9,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(622), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_PIPE,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(630), 1,
      anon_sym_LBRACK,
    ACTIONS(632), 1,
      anon_sym_POUND,
    ACTIONS(650), 1,
      ts_builtin_sym_end,
    ACTIONS(652), 1,
      sym_comment,
    STATE(834), 1,
      sym_at_comment,
  [11473] = 2,
    ACTIONS(494), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(496), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11487] = 9,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(622), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_PIPE,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(630), 1,
      anon_sym_LBRACK,
    ACTIONS(632), 1,
      anon_sym_POUND,
    ACTIONS(654), 1,
      ts_builtin_sym_end,
    ACTIONS(656), 1,
      sym_comment,
    STATE(836), 1,
      sym_at_comment,
  [11515] = 2,
    ACTIONS(486), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(488), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11529] = 9,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(622), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_PIPE,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(630), 1,
      anon_sym_LBRACK,
    ACTIONS(632), 1,
      anon_sym_POUND,
    ACTIONS(658), 1,
      ts_builtin_sym_end,
    ACTIONS(660), 1,
      sym_comment,
    STATE(838), 1,
      sym_at_comment,
  [11557] = 3,
    ACTIONS(594), 1,
      anon_sym_COLON,
    ACTIONS(430), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(432), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11573] = 9,
    ACTIONS(662), 1,
      ts_builtin_sym_end,
    ACTIONS(664), 1,
      anon_sym_COMMA,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(672), 1,
      sym_comment,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    STATE(533), 1,
      aux_sym_cast_annotation_repeat1,
  [11601] = 2,
    ACTIONS(482), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(484), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11615] = 2,
    ACTIONS(478), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(480), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11629] = 3,
    ACTIONS(678), 1,
      anon_sym_COLON,
    ACTIONS(361), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(363), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11645] = 2,
    ACTIONS(470), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(472), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11659] = 4,
    ACTIONS(680), 1,
      anon_sym_COMMA,
    STATE(297), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(392), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(394), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11677] = 2,
    ACTIONS(434), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(436), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11691] = 2,
    ACTIONS(458), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(460), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11705] = 5,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(687), 1,
      sym_identifier,
    STATE(546), 1,
      sym_qualifier,
    STATE(25), 2,
      sym_positional_field,
      sym_indexed_field,
    ACTIONS(683), 4,
      anon_sym_public,
      anon_sym_protected,
      anon_sym_private,
      anon_sym_package,
  [11725] = 3,
    ACTIONS(689), 1,
      anon_sym_LT,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11741] = 3,
    ACTIONS(600), 1,
      anon_sym_COLON,
    ACTIONS(398), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(400), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11757] = 2,
    ACTIONS(466), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(468), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11771] = 2,
    ACTIONS(454), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(456), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11785] = 3,
    ACTIONS(691), 1,
      anon_sym_LPAREN,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11801] = 4,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(297), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(379), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(381), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11819] = 9,
    ACTIONS(385), 1,
      ts_builtin_sym_end,
    ACTIONS(387), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(306), 1,
      aux_sym_type_annotation_repeat1,
  [11847] = 4,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(297), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(402), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(404), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11865] = 2,
    ACTIONS(438), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(440), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [11879] = 4,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(297), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(406), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(408), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11897] = 4,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(297), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(412), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(414), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11915] = 3,
    ACTIONS(695), 1,
      anon_sym_COLON,
    ACTIONS(398), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(400), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [11931] = 9,
    ACTIONS(430), 1,
      ts_builtin_sym_end,
    ACTIONS(432), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(541), 1,
      aux_sym_type_annotation_repeat1,
  [11959] = 9,
    ACTIONS(424), 1,
      ts_builtin_sym_end,
    ACTIONS(426), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(540), 1,
      aux_sym_type_annotation_repeat1,
  [11987] = 9,
    ACTIONS(416), 1,
      ts_builtin_sym_end,
    ACTIONS(418), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(308), 1,
      aux_sym_type_annotation_repeat1,
  [12015] = 9,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(622), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_PIPE,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(630), 1,
      anon_sym_LBRACK,
    ACTIONS(632), 1,
      anon_sym_POUND,
    ACTIONS(697), 1,
      ts_builtin_sym_end,
    ACTIONS(699), 1,
      sym_comment,
    STATE(842), 1,
      sym_at_comment,
  [12043] = 9,
    ACTIONS(353), 1,
      ts_builtin_sym_end,
    ACTIONS(357), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(539), 1,
      aux_sym_type_annotation_repeat1,
  [12071] = 9,
    ACTIONS(420), 1,
      ts_builtin_sym_end,
    ACTIONS(422), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(535), 1,
      aux_sym_type_annotation_repeat1,
  [12099] = 9,
    ACTIONS(416), 1,
      ts_builtin_sym_end,
    ACTIONS(418), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(532), 1,
      aux_sym_type_annotation_repeat1,
  [12127] = 9,
    ACTIONS(385), 1,
      ts_builtin_sym_end,
    ACTIONS(387), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(536), 1,
      aux_sym_type_annotation_repeat1,
  [12155] = 2,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12169] = 2,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12183] = 2,
    ACTIONS(474), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(476), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12197] = 2,
    ACTIONS(446), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(448), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12211] = 9,
    ACTIONS(420), 1,
      ts_builtin_sym_end,
    ACTIONS(422), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(310), 1,
      aux_sym_type_annotation_repeat1,
  [12239] = 2,
    ACTIONS(470), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(472), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12253] = 7,
    ACTIONS(506), 1,
      ts_builtin_sym_end,
    ACTIONS(578), 1,
      anon_sym_QMARK,
    ACTIONS(580), 1,
      anon_sym_PIPE,
    ACTIONS(582), 1,
      anon_sym_DOT,
    ACTIONS(586), 1,
      anon_sym_LBRACK,
    ACTIONS(588), 1,
      anon_sym_POUND,
    ACTIONS(508), 3,
      anon_sym_COLON,
      anon_sym_AT,
      sym_comment,
  [12277] = 2,
    ACTIONS(466), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(468), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12291] = 2,
    ACTIONS(454), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(456), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12305] = 7,
    ACTIONS(506), 1,
      ts_builtin_sym_end,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    ACTIONS(508), 3,
      anon_sym_COMMA,
      anon_sym_AT,
      sym_comment,
  [12329] = 2,
    ACTIONS(442), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(444), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12343] = 2,
    ACTIONS(450), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(452), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12357] = 9,
    ACTIONS(353), 1,
      ts_builtin_sym_end,
    ACTIONS(357), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(311), 1,
      aux_sym_type_annotation_repeat1,
  [12385] = 4,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(297), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(420), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(422), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [12403] = 2,
    ACTIONS(462), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(464), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12417] = 3,
    ACTIONS(592), 1,
      anon_sym_COLON,
    ACTIONS(361), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(363), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12433] = 2,
    ACTIONS(478), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(480), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12447] = 2,
    ACTIONS(482), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(484), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12461] = 3,
    ACTIONS(701), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [12477] = 2,
    ACTIONS(462), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(464), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12491] = 4,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(297), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(424), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(426), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [12509] = 7,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    ACTIONS(703), 1,
      ts_builtin_sym_end,
    ACTIONS(705), 3,
      anon_sym_COMMA,
      anon_sym_AT,
      sym_comment,
  [12533] = 9,
    ACTIONS(424), 1,
      ts_builtin_sym_end,
    ACTIONS(426), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(334), 1,
      aux_sym_type_annotation_repeat1,
  [12561] = 2,
    ACTIONS(494), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(496), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12575] = 2,
    ACTIONS(442), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(444), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12589] = 2,
    ACTIONS(502), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(504), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12603] = 2,
    ACTIONS(510), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(512), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12617] = 3,
    ACTIONS(707), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [12633] = 9,
    ACTIONS(430), 1,
      ts_builtin_sym_end,
    ACTIONS(432), 1,
      sym_comment,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(341), 1,
      aux_sym_type_annotation_repeat1,
  [12661] = 2,
    ACTIONS(450), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(452), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12675] = 2,
    ACTIONS(490), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(492), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12689] = 2,
    ACTIONS(486), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(488), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12703] = 9,
    ACTIONS(664), 1,
      anon_sym_COMMA,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(709), 1,
      ts_builtin_sym_end,
    ACTIONS(711), 1,
      sym_comment,
    STATE(542), 1,
      aux_sym_cast_annotation_repeat1,
  [12731] = 7,
    ACTIONS(392), 1,
      ts_builtin_sym_end,
    ACTIONS(518), 1,
      anon_sym_QMARK,
    ACTIONS(520), 1,
      anon_sym_PIPE,
    ACTIONS(522), 1,
      anon_sym_DOT,
    ACTIONS(528), 1,
      anon_sym_LBRACK,
    ACTIONS(530), 1,
      anon_sym_POUND,
    ACTIONS(394), 3,
      anon_sym_COMMA,
      anon_sym_AT,
      sym_comment,
  [12755] = 3,
    ACTIONS(713), 1,
      anon_sym_COLON,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [12771] = 3,
    ACTIONS(715), 1,
      anon_sym_LPAREN,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12787] = 2,
    ACTIONS(434), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(436), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12801] = 2,
    ACTIONS(458), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(460), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12815] = 3,
    ACTIONS(717), 1,
      anon_sym_LT,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12831] = 9,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(622), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_PIPE,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(630), 1,
      anon_sym_LBRACK,
    ACTIONS(632), 1,
      anon_sym_POUND,
    ACTIONS(719), 1,
      ts_builtin_sym_end,
    ACTIONS(721), 1,
      sym_comment,
    STATE(718), 1,
      sym_at_comment,
  [12859] = 2,
    ACTIONS(502), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(504), 7,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12873] = 2,
    ACTIONS(438), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(440), 7,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [12887] = 8,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(723), 1,
      ts_builtin_sym_end,
    ACTIONS(725), 1,
      anon_sym_COMMA,
    ACTIONS(727), 1,
      sym_comment,
  [12912] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(731), 1,
      anon_sym_RBRACE,
    STATE(625), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [12935] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(733), 1,
      anon_sym_RBRACE,
    STATE(619), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [12958] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(735), 1,
      anon_sym_RBRACE,
    STATE(611), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [12981] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(739), 1,
      anon_sym_RPAREN,
    STATE(610), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13004] = 2,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13017] = 2,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13030] = 2,
    ACTIONS(474), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(476), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13043] = 2,
    ACTIONS(446), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(448), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13056] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(741), 1,
      anon_sym_RBRACE,
    STATE(628), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13079] = 2,
    ACTIONS(470), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(472), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13092] = 3,
    ACTIONS(695), 1,
      anon_sym_COLON,
    ACTIONS(398), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(400), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13107] = 2,
    ACTIONS(466), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(468), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13120] = 2,
    ACTIONS(454), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(456), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13133] = 7,
    ACTIONS(506), 1,
      ts_builtin_sym_end,
    ACTIONS(622), 1,
      anon_sym_QMARK,
    ACTIONS(624), 1,
      anon_sym_PIPE,
    ACTIONS(626), 1,
      anon_sym_DOT,
    ACTIONS(630), 1,
      anon_sym_LBRACK,
    ACTIONS(632), 1,
      anon_sym_POUND,
    ACTIONS(508), 2,
      anon_sym_AT,
      sym_comment,
  [13156] = 2,
    ACTIONS(442), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(444), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13169] = 2,
    ACTIONS(450), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(452), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13182] = 7,
    ACTIONS(392), 1,
      ts_builtin_sym_end,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(394), 2,
      anon_sym_COMMA,
      sym_comment,
  [13205] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(743), 1,
      anon_sym_RPAREN,
    STATE(548), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13228] = 2,
    ACTIONS(462), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(464), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13241] = 3,
    ACTIONS(678), 1,
      anon_sym_COLON,
    ACTIONS(361), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(363), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13256] = 2,
    ACTIONS(478), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(480), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13269] = 2,
    ACTIONS(482), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(484), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13282] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(745), 1,
      anon_sym_RBRACE,
    STATE(618), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13305] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(747), 1,
      anon_sym_RPAREN,
    STATE(559), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13328] = 3,
    ACTIONS(648), 1,
      anon_sym_COLON,
    ACTIONS(430), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(432), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13343] = 2,
    ACTIONS(494), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(496), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13356] = 2,
    ACTIONS(498), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(500), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13369] = 2,
    ACTIONS(502), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(504), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13382] = 2,
    ACTIONS(510), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(512), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13395] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(749), 1,
      anon_sym_RBRACE,
    STATE(615), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13418] = 2,
    ACTIONS(446), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(448), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13431] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(751), 1,
      anon_sym_RBRACE,
    STATE(630), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13454] = 2,
    ACTIONS(490), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(492), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13467] = 2,
    ACTIONS(486), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(488), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13480] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(753), 1,
      anon_sym_RBRACE,
    STATE(612), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13503] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(755), 1,
      anon_sym_RBRACE,
    STATE(629), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13526] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(757), 1,
      anon_sym_RPAREN,
    STATE(606), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13549] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(759), 1,
      anon_sym_RPAREN,
    STATE(604), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13572] = 2,
    ACTIONS(434), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(436), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13585] = 2,
    ACTIONS(458), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(460), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13598] = 2,
    ACTIONS(470), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(472), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13611] = 2,
    ACTIONS(466), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(468), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13624] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(761), 1,
      anon_sym_RBRACE,
    STATE(576), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13647] = 2,
    ACTIONS(438), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(440), 6,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_AT,
      sym_comment,
      anon_sym_LBRACK,
  [13660] = 2,
    ACTIONS(454), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(456), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13673] = 7,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(763), 1,
      ts_builtin_sym_end,
    ACTIONS(765), 2,
      anon_sym_COMMA,
      sym_comment,
  [13696] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(767), 1,
      anon_sym_RBRACE,
    STATE(573), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13719] = 3,
    ACTIONS(769), 1,
      anon_sym_LT,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13734] = 3,
    ACTIONS(771), 1,
      anon_sym_LPAREN,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13749] = 2,
    ACTIONS(474), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(476), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13762] = 2,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13775] = 2,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13788] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(773), 1,
      anon_sym_RBRACE,
    STATE(570), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13811] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(775), 1,
      anon_sym_RBRACE,
    STATE(568), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13834] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(777), 1,
      anon_sym_RPAREN,
    STATE(567), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13857] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(779), 1,
      anon_sym_RPAREN,
    STATE(608), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13880] = 3,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(783), 1,
      anon_sym_QMARK,
    ACTIONS(375), 6,
      anon_sym_COMMA,
      anon_sym_PIPE,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_POUND,
  [13895] = 7,
    ACTIONS(506), 1,
      ts_builtin_sym_end,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(508), 2,
      anon_sym_COMMA,
      sym_comment,
  [13918] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(785), 1,
      anon_sym_RPAREN,
    STATE(623), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13941] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(787), 1,
      anon_sym_RPAREN,
    STATE(627), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [13964] = 2,
    ACTIONS(442), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(444), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13977] = 2,
    ACTIONS(450), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(452), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [13990] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(789), 1,
      anon_sym_RPAREN,
    STATE(565), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14013] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(791), 1,
      anon_sym_RBRACE,
    STATE(603), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14036] = 2,
    ACTIONS(462), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(464), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14049] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(793), 1,
      anon_sym_RBRACE,
    STATE(600), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14072] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(795), 1,
      anon_sym_RBRACE,
    STATE(596), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14095] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(797), 1,
      anon_sym_RPAREN,
    STATE(591), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14118] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(799), 1,
      anon_sym_RBRACE,
    STATE(594), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14141] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(801), 1,
      anon_sym_RPAREN,
    STATE(589), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14164] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(803), 1,
      anon_sym_RBRACE,
    STATE(588), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14187] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(805), 1,
      anon_sym_RBRACE,
    STATE(586), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14210] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(807), 1,
      anon_sym_RBRACE,
    STATE(585), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14233] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(809), 1,
      anon_sym_RBRACE,
    STATE(584), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14256] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(811), 1,
      anon_sym_RPAREN,
    STATE(580), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14279] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(813), 1,
      anon_sym_RPAREN,
    STATE(577), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14302] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(815), 1,
      anon_sym_RBRACE,
    STATE(575), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14325] = 7,
    ACTIONS(666), 1,
      anon_sym_QMARK,
    ACTIONS(668), 1,
      anon_sym_PIPE,
    ACTIONS(670), 1,
      anon_sym_DOT,
    ACTIONS(674), 1,
      anon_sym_LBRACK,
    ACTIONS(676), 1,
      anon_sym_POUND,
    ACTIONS(817), 1,
      ts_builtin_sym_end,
    ACTIONS(819), 2,
      anon_sym_COMMA,
      sym_comment,
  [14348] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(821), 1,
      anon_sym_RBRACE,
    STATE(574), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14371] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(823), 1,
      anon_sym_RBRACE,
    STATE(571), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14394] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(825), 1,
      anon_sym_RBRACE,
    STATE(569), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14417] = 2,
    ACTIONS(478), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(480), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14430] = 2,
    ACTIONS(482), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(484), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14443] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(827), 1,
      anon_sym_RBRACE,
    STATE(556), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14466] = 2,
    ACTIONS(494), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(496), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14479] = 2,
    ACTIONS(498), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(500), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14492] = 2,
    ACTIONS(502), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(504), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14505] = 2,
    ACTIONS(510), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(512), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14518] = 2,
    ACTIONS(490), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(492), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14531] = 2,
    ACTIONS(486), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(488), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14544] = 2,
    ACTIONS(434), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(436), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14557] = 2,
    ACTIONS(458), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(460), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14570] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(829), 1,
      anon_sym_RBRACE,
    STATE(621), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14593] = 2,
    ACTIONS(438), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(440), 6,
      anon_sym_COMMA,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14606] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(831), 1,
      anon_sym_RBRACE,
    STATE(607), 1,
      aux_sym_table_literal_type_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14629] = 7,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(833), 1,
      anon_sym_RPAREN,
    STATE(553), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14652] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(835), 1,
      anon_sym_COMMA,
    ACTIONS(837), 1,
      anon_sym_RPAREN,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14672] = 2,
    ACTIONS(470), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(472), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14684] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(839), 1,
      anon_sym_COMMA,
    ACTIONS(841), 1,
      anon_sym_RPAREN,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14704] = 2,
    ACTIONS(466), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(468), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14716] = 2,
    ACTIONS(454), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(456), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14728] = 7,
    ACTIONS(506), 1,
      ts_builtin_sym_end,
    ACTIONS(508), 1,
      sym_comment,
    ACTIONS(843), 1,
      anon_sym_QMARK,
    ACTIONS(845), 1,
      anon_sym_PIPE,
    ACTIONS(847), 1,
      anon_sym_DOT,
    ACTIONS(849), 1,
      anon_sym_LBRACK,
    ACTIONS(851), 1,
      anon_sym_POUND,
  [14750] = 2,
    ACTIONS(442), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(444), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14762] = 2,
    ACTIONS(450), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(452), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14774] = 2,
    ACTIONS(462), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(464), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14786] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(853), 1,
      anon_sym_COMMA,
    ACTIONS(855), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14806] = 2,
    ACTIONS(478), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(480), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14818] = 2,
    ACTIONS(482), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(484), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14830] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(857), 1,
      anon_sym_COMMA,
    ACTIONS(859), 1,
      anon_sym_RPAREN,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [14850] = 2,
    ACTIONS(494), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(496), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14862] = 2,
    ACTIONS(498), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(500), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14874] = 2,
    ACTIONS(502), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(504), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14886] = 2,
    ACTIONS(510), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(512), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14898] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(861), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14916] = 2,
    ACTIONS(490), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(492), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14928] = 2,
    ACTIONS(486), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(488), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14940] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(703), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [14958] = 2,
    ACTIONS(434), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(436), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14970] = 2,
    ACTIONS(458), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(460), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [14982] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(863), 1,
      anon_sym_COMMA,
    ACTIONS(865), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15002] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(867), 1,
      anon_sym_COMMA,
    ACTIONS(869), 1,
      anon_sym_RPAREN,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15022] = 2,
    ACTIONS(438), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(440), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [15034] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(871), 1,
      anon_sym_COMMA,
    ACTIONS(873), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15054] = 7,
    ACTIONS(843), 1,
      anon_sym_QMARK,
    ACTIONS(845), 1,
      anon_sym_PIPE,
    ACTIONS(847), 1,
      anon_sym_DOT,
    ACTIONS(849), 1,
      anon_sym_LBRACK,
    ACTIONS(851), 1,
      anon_sym_POUND,
    ACTIONS(875), 1,
      ts_builtin_sym_end,
    ACTIONS(877), 1,
      sym_comment,
  [15076] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(879), 1,
      anon_sym_COMMA,
    ACTIONS(881), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15096] = 2,
    ACTIONS(365), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(369), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [15108] = 2,
    ACTIONS(446), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(448), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [15120] = 2,
    ACTIONS(474), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(476), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [15132] = 2,
    ACTIONS(375), 2,
      ts_builtin_sym_end,
      anon_sym_POUND,
    ACTIONS(377), 5,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_DOT,
      sym_comment,
      anon_sym_LBRACK,
  [15144] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(883), 1,
      anon_sym_COMMA,
    ACTIONS(885), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15164] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(887), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [15182] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(889), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [15200] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(891), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [15218] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(893), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [15236] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(895), 1,
      anon_sym_COMMA,
    ACTIONS(897), 1,
      anon_sym_RPAREN,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15256] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(899), 1,
      anon_sym_COMMA,
    ACTIONS(901), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15276] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
    ACTIONS(903), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [15294] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(905), 1,
      anon_sym_COMMA,
    ACTIONS(907), 1,
      anon_sym_RPAREN,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15314] = 7,
    ACTIONS(843), 1,
      anon_sym_QMARK,
    ACTIONS(845), 1,
      anon_sym_PIPE,
    ACTIONS(847), 1,
      anon_sym_DOT,
    ACTIONS(849), 1,
      anon_sym_LBRACK,
    ACTIONS(851), 1,
      anon_sym_POUND,
    ACTIONS(909), 1,
      ts_builtin_sym_end,
    ACTIONS(911), 1,
      sym_comment,
  [15336] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(913), 1,
      anon_sym_COMMA,
    ACTIONS(915), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15356] = 7,
    ACTIONS(843), 1,
      anon_sym_QMARK,
    ACTIONS(845), 1,
      anon_sym_PIPE,
    ACTIONS(847), 1,
      anon_sym_DOT,
    ACTIONS(849), 1,
      anon_sym_LBRACK,
    ACTIONS(851), 1,
      anon_sym_POUND,
    ACTIONS(917), 1,
      ts_builtin_sym_end,
    ACTIONS(919), 1,
      sym_comment,
  [15378] = 7,
    ACTIONS(843), 1,
      anon_sym_QMARK,
    ACTIONS(845), 1,
      anon_sym_PIPE,
    ACTIONS(847), 1,
      anon_sym_DOT,
    ACTIONS(849), 1,
      anon_sym_LBRACK,
    ACTIONS(851), 1,
      anon_sym_POUND,
    ACTIONS(921), 1,
      ts_builtin_sym_end,
    ACTIONS(923), 1,
      sym_comment,
  [15400] = 6,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(925), 1,
      anon_sym_COMMA,
    ACTIONS(927), 1,
      anon_sym_RPAREN,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15420] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(929), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15437] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(931), 1,
      anon_sym_RBRACK_RBRACK,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15454] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(933), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15471] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(935), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15488] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(937), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15505] = 6,
    ACTIONS(549), 1,
      anon_sym_COMMA,
    ACTIONS(551), 1,
      anon_sym_AT,
    ACTIONS(939), 1,
      ts_builtin_sym_end,
    ACTIONS(941), 1,
      sym_comment,
    STATE(529), 1,
      aux_sym_class_annotation_repeat1,
    STATE(782), 1,
      sym_class_at_comment,
  [15524] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(943), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15541] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(945), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15558] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(947), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15575] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(931), 1,
      anon_sym_RBRACK_EQ_RBRACK,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15592] = 6,
    ACTIONS(516), 1,
      anon_sym_COMMA,
    ACTIONS(524), 1,
      anon_sym_AT,
    ACTIONS(949), 1,
      ts_builtin_sym_end,
    ACTIONS(951), 1,
      sym_comment,
    STATE(530), 1,
      aux_sym_type_annotation_repeat1,
    STATE(830), 1,
      sym_at_comment,
  [15611] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(953), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15628] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(955), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15645] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(957), 1,
      anon_sym_RBRACE,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15662] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(959), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15679] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(961), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15696] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(963), 1,
      anon_sym_RBRACK2,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15713] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(965), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15730] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(967), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15747] = 6,
    ACTIONS(549), 1,
      anon_sym_COMMA,
    ACTIONS(551), 1,
      anon_sym_AT,
    ACTIONS(557), 1,
      ts_builtin_sym_end,
    ACTIONS(559), 1,
      sym_comment,
    STATE(529), 1,
      aux_sym_class_annotation_repeat1,
    STATE(818), 1,
      sym_class_at_comment,
  [15766] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(969), 1,
      anon_sym_GT,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15783] = 5,
    ACTIONS(347), 1,
      anon_sym_QMARK,
    ACTIONS(349), 1,
      anon_sym_PIPE,
    ACTIONS(355), 1,
      anon_sym_LBRACK,
    ACTIONS(971), 1,
      anon_sym_RPAREN,
    ACTIONS(351), 2,
      anon_sym_DOT,
      anon_sym_POUND,
  [15800] = 4,
    ACTIONS(703), 1,
      ts_builtin_sym_end,
    ACTIONS(973), 1,
      anon_sym_COMMA,
    STATE(529), 1,
      aux_sym_class_annotation_repeat1,
    ACTIONS(705), 2,
      anon_sym_AT,
      sym_comment,
  [15814] = 4,
    ACTIONS(392), 1,
      ts_builtin_sym_end,
    ACTIONS(565), 1,
      anon_sym_COMMA,
    STATE(530), 1,
      aux_sym_type_annotation_repeat1,
    ACTIONS(394), 2,
      anon_sym_AT,
      sym_comment,
  [15828] = 1,
    ACTIONS(976), 5,
      anon_sym_5_DOT1,
      anon_sym_5_DOT2,
      anon_sym_5_DOT3,
      anon_sym_5_DOT4,
      anon_sym_JIT,
  [15836] = 4,
    ACTIONS(402), 1,
      ts_builtin_sym_end,
    ACTIONS(404), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(544), 1,
      aux_sym_type_annotation_repeat1,
  [15849] = 4,
    ACTIONS(664), 1,
      anon_sym_COMMA,
    ACTIONS(709), 1,
      ts_builtin_sym_end,
    ACTIONS(711), 1,
      sym_comment,
    STATE(543), 1,
      aux_sym_cast_annotation_repeat1,
  [15862] = 4,
    ACTIONS(664), 1,
      anon_sym_COMMA,
    ACTIONS(709), 1,
      ts_builtin_sym_end,
    ACTIONS(711), 1,
      sym_comment,
    STATE(542), 1,
      aux_sym_cast_annotation_repeat1,
  [15875] = 4,
    ACTIONS(406), 1,
      ts_builtin_sym_end,
    ACTIONS(408), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(544), 1,
      aux_sym_type_annotation_repeat1,
  [15888] = 4,
    ACTIONS(379), 1,
      ts_builtin_sym_end,
    ACTIONS(381), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(544), 1,
      aux_sym_type_annotation_repeat1,
  [15901] = 3,
    ACTIONS(978), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(688), 1,
      sym_parameter,
    ACTIONS(980), 2,
      anon_sym_self,
      sym_identifier,
  [15912] = 4,
    ACTIONS(982), 1,
      ts_builtin_sym_end,
    ACTIONS(984), 1,
      anon_sym_COLON,
    ACTIONS(986), 1,
      anon_sym_COMMA,
    ACTIONS(988), 1,
      sym_comment,
  [15925] = 4,
    ACTIONS(412), 1,
      ts_builtin_sym_end,
    ACTIONS(414), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(544), 1,
      aux_sym_type_annotation_repeat1,
  [15938] = 4,
    ACTIONS(420), 1,
      ts_builtin_sym_end,
    ACTIONS(422), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(544), 1,
      aux_sym_type_annotation_repeat1,
  [15951] = 4,
    ACTIONS(424), 1,
      ts_builtin_sym_end,
    ACTIONS(426), 1,
      sym_comment,
    ACTIONS(693), 1,
      anon_sym_COMMA,
    STATE(544), 1,
      aux_sym_type_annotation_repeat1,
  [15964] = 4,
    ACTIONS(664), 1,
      anon_sym_COMMA,
    ACTIONS(990), 1,
      ts_builtin_sym_end,
    ACTIONS(992), 1,
      sym_comment,
    STATE(543), 1,
      aux_sym_cast_annotation_repeat1,
  [15977] = 4,
    ACTIONS(763), 1,
      ts_builtin_sym_end,
    ACTIONS(765), 1,
      sym_comment,
    ACTIONS(994), 1,
      anon_sym_COMMA,
    STATE(543), 1,
      aux_sym_cast_annotation_repeat1,
  [15990] = 4,
    ACTIONS(392), 1,
      ts_builtin_sym_end,
    ACTIONS(394), 1,
      sym_comment,
    ACTIONS(680), 1,
      anon_sym_COMMA,
    STATE(544), 1,
      aux_sym_type_annotation_repeat1,
  [16003] = 4,
    ACTIONS(662), 1,
      ts_builtin_sym_end,
    ACTIONS(664), 1,
      anon_sym_COMMA,
    ACTIONS(672), 1,
      sym_comment,
    STATE(533), 1,
      aux_sym_cast_annotation_repeat1,
  [16016] = 3,
    ACTIONS(685), 1,
      anon_sym_LBRACK,
    ACTIONS(997), 1,
      sym_identifier,
    STATE(21), 2,
      sym_positional_field,
      sym_indexed_field,
  [16027] = 3,
    ACTIONS(785), 1,
      anon_sym_RPAREN,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    STATE(624), 1,
      aux_sym_function_type_repeat1,
  [16037] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1001), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16047] = 3,
    ACTIONS(1003), 1,
      anon_sym_RBRACE,
    ACTIONS(1005), 1,
      anon_sym_LBRACK,
    ACTIONS(1007), 1,
      sym_identifier,
  [16057] = 3,
    ACTIONS(361), 1,
      ts_builtin_sym_end,
    ACTIONS(363), 1,
      sym_comment,
    ACTIONS(1009), 1,
      anon_sym_COLON,
  [16067] = 3,
    ACTIONS(430), 1,
      ts_builtin_sym_end,
    ACTIONS(432), 1,
      sym_comment,
    ACTIONS(1011), 1,
      anon_sym_COLON,
  [16077] = 3,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1013), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      aux_sym_function_type_repeat1,
  [16087] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1013), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16097] = 3,
    ACTIONS(833), 1,
      anon_sym_RPAREN,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    STATE(552), 1,
      aux_sym_function_type_repeat1,
  [16107] = 3,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(833), 1,
      anon_sym_RPAREN,
    ACTIONS(1015), 1,
      anon_sym_QMARK,
  [16117] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1017), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16127] = 3,
    ACTIONS(1019), 1,
      ts_builtin_sym_end,
    ACTIONS(1021), 1,
      anon_sym_COLON,
    ACTIONS(1023), 1,
      sym_comment,
  [16137] = 3,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(789), 1,
      anon_sym_RPAREN,
    ACTIONS(1025), 1,
      anon_sym_QMARK,
  [16147] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1027), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16157] = 3,
    ACTIONS(789), 1,
      anon_sym_RPAREN,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    STATE(566), 1,
      aux_sym_function_type_repeat1,
  [16167] = 3,
    ACTIONS(1029), 1,
      anon_sym_fun,
    ACTIONS(1031), 1,
      anon_sym_function,
    STATE(683), 1,
      sym_function_type,
  [16177] = 3,
    ACTIONS(1033), 1,
      anon_sym_RBRACE,
    ACTIONS(1035), 1,
      anon_sym_LBRACK,
    ACTIONS(1037), 1,
      sym_identifier,
  [16187] = 2,
    ACTIONS(1041), 1,
      sym_number,
    ACTIONS(1039), 2,
      sym_string,
      sym_identifier,
  [16195] = 3,
    ACTIONS(398), 1,
      ts_builtin_sym_end,
    ACTIONS(400), 1,
      sym_comment,
    ACTIONS(1043), 1,
      anon_sym_COLON,
  [16205] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16215] = 3,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      aux_sym_function_type_repeat1,
  [16225] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1047), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16235] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1049), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16245] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16255] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1053), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16265] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1055), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16275] = 2,
    ACTIONS(763), 1,
      ts_builtin_sym_end,
    ACTIONS(765), 2,
      anon_sym_COMMA,
      sym_comment,
  [16283] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1057), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16293] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1059), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16303] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1061), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16313] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1063), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16323] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1065), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16333] = 3,
    ACTIONS(1067), 1,
      ts_builtin_sym_end,
    ACTIONS(1069), 1,
      anon_sym_COMMA,
    STATE(626), 1,
      aux_sym_diagnostic_annotation_repeat1,
  [16343] = 3,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1071), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      aux_sym_function_type_repeat1,
  [16353] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1071), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16363] = 3,
    ACTIONS(811), 1,
      anon_sym_RPAREN,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    STATE(579), 1,
      aux_sym_function_type_repeat1,
  [16373] = 3,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(811), 1,
      anon_sym_RPAREN,
    ACTIONS(1073), 1,
      anon_sym_QMARK,
  [16383] = 3,
    ACTIONS(1075), 1,
      anon_sym_RBRACE,
    ACTIONS(1077), 1,
      anon_sym_LBRACK,
    ACTIONS(1079), 1,
      sym_identifier,
  [16393] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1081), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16403] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1083), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16413] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1085), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16423] = 3,
    ACTIONS(1087), 1,
      anon_sym_RBRACE,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1091), 1,
      sym_identifier,
  [16433] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1093), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16443] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1095), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16453] = 3,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1097), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      aux_sym_function_type_repeat1,
  [16463] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1097), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16473] = 3,
    ACTIONS(797), 1,
      anon_sym_RPAREN,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    STATE(590), 1,
      aux_sym_function_type_repeat1,
  [16483] = 3,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(797), 1,
      anon_sym_RPAREN,
    ACTIONS(1099), 1,
      anon_sym_QMARK,
  [16493] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1101), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16503] = 3,
    ACTIONS(1103), 1,
      anon_sym_RBRACE,
    ACTIONS(1105), 1,
      anon_sym_LBRACK,
    ACTIONS(1107), 1,
      sym_identifier,
  [16513] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1109), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16523] = 3,
    ACTIONS(759), 1,
      anon_sym_RPAREN,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(1111), 1,
      anon_sym_QMARK,
  [16533] = 3,
    ACTIONS(703), 1,
      anon_sym_RPAREN,
    ACTIONS(1113), 1,
      anon_sym_COMMA,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16543] = 3,
    ACTIONS(759), 1,
      anon_sym_RPAREN,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    STATE(605), 1,
      aux_sym_function_type_repeat1,
  [16553] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1116), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16563] = 3,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1118), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      aux_sym_function_type_repeat1,
  [16573] = 3,
    ACTIONS(1120), 1,
      anon_sym_COMMA,
    ACTIONS(1123), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16583] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1125), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16593] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1127), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16603] = 3,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1127), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      aux_sym_function_type_repeat1,
  [16613] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16623] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1131), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16633] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1118), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16643] = 3,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1001), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      aux_sym_function_type_repeat1,
  [16653] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1133), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16663] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1135), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16673] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1137), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16683] = 3,
    ACTIONS(1069), 1,
      anon_sym_COMMA,
    ACTIONS(1139), 1,
      ts_builtin_sym_end,
    STATE(578), 1,
      aux_sym_diagnostic_annotation_repeat1,
  [16693] = 3,
    ACTIONS(779), 1,
      anon_sym_RPAREN,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(1141), 1,
      anon_sym_QMARK,
  [16703] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1143), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16713] = 3,
    ACTIONS(1145), 1,
      ts_builtin_sym_end,
    ACTIONS(1147), 1,
      anon_sym_COLON,
    ACTIONS(1149), 1,
      sym_comment,
  [16723] = 2,
    ACTIONS(817), 1,
      ts_builtin_sym_end,
    ACTIONS(819), 2,
      anon_sym_COMMA,
      sym_comment,
  [16731] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1151), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16741] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1153), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16751] = 3,
    ACTIONS(1155), 1,
      anon_sym_RBRACE,
    ACTIONS(1157), 1,
      anon_sym_LBRACK,
    ACTIONS(1159), 1,
      sym_identifier,
  [16761] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1161), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16771] = 3,
    ACTIONS(1163), 1,
      anon_sym_COMMA,
    ACTIONS(1166), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      aux_sym_function_type_repeat1,
  [16781] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16791] = 3,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    STATE(622), 1,
      aux_sym_function_type_repeat1,
  [16801] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1170), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16811] = 3,
    ACTIONS(1172), 1,
      ts_builtin_sym_end,
    ACTIONS(1174), 1,
      anon_sym_COMMA,
    STATE(626), 1,
      aux_sym_diagnostic_annotation_repeat1,
  [16821] = 3,
    ACTIONS(737), 1,
      anon_sym_COMMA,
    ACTIONS(1177), 1,
      anon_sym_RPAREN,
    STATE(598), 1,
      aux_sym_class_annotation_repeat1,
  [16831] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1179), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16841] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1181), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16851] = 3,
    ACTIONS(729), 1,
      anon_sym_COMMA,
    ACTIONS(1183), 1,
      anon_sym_RBRACE,
    STATE(602), 1,
      aux_sym_table_literal_type_repeat1,
  [16861] = 3,
    ACTIONS(743), 1,
      anon_sym_RPAREN,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(1185), 1,
      anon_sym_QMARK,
  [16871] = 3,
    ACTIONS(1187), 1,
      anon_sym_RBRACE,
    ACTIONS(1189), 1,
      anon_sym_LBRACK,
    ACTIONS(1191), 1,
      sym_identifier,
  [16881] = 3,
    ACTIONS(743), 1,
      anon_sym_RPAREN,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    STATE(609), 1,
      aux_sym_function_type_repeat1,
  [16891] = 3,
    ACTIONS(1193), 1,
      ts_builtin_sym_end,
    ACTIONS(1195), 1,
      anon_sym_COLON,
    ACTIONS(1197), 1,
      sym_comment,
  [16901] = 3,
    ACTIONS(1199), 1,
      ts_builtin_sym_end,
    ACTIONS(1201), 1,
      anon_sym_extends,
    ACTIONS(1203), 1,
      sym_comment,
  [16911] = 3,
    ACTIONS(779), 1,
      anon_sym_RPAREN,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    STATE(601), 1,
      aux_sym_function_type_repeat1,
  [16921] = 3,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(785), 1,
      anon_sym_RPAREN,
    ACTIONS(1205), 1,
      anon_sym_QMARK,
  [16931] = 2,
    ACTIONS(743), 1,
      anon_sym_RPAREN,
    ACTIONS(781), 1,
      anon_sym_COLON,
  [16938] = 2,
    ACTIONS(1207), 1,
      ts_builtin_sym_end,
    ACTIONS(1209), 1,
      sym_comment,
  [16945] = 2,
    ACTIONS(1211), 1,
      ts_builtin_sym_end,
    ACTIONS(1213), 1,
      sym_comment,
  [16952] = 2,
    ACTIONS(1118), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 1,
      anon_sym_COLON,
  [16959] = 2,
    ACTIONS(1217), 1,
      anon_sym_COLON,
    ACTIONS(1219), 1,
      anon_sym_QMARK,
  [16966] = 2,
    ACTIONS(1221), 1,
      ts_builtin_sym_end,
    ACTIONS(1223), 1,
      sym_comment,
  [16973] = 2,
    ACTIONS(1225), 1,
      anon_sym_COLON,
    ACTIONS(1227), 1,
      anon_sym_QMARK,
  [16980] = 2,
    ACTIONS(1229), 1,
      anon_sym_COLON,
    ACTIONS(1231), 1,
      anon_sym_QMARK,
  [16987] = 2,
    ACTIONS(1233), 1,
      anon_sym_COLON,
    ACTIONS(1235), 1,
      anon_sym_QMARK,
  [16994] = 2,
    ACTIONS(1237), 1,
      anon_sym_COLON,
    ACTIONS(1239), 1,
      anon_sym_QMARK,
  [17001] = 2,
    ACTIONS(1241), 1,
      anon_sym_COLON,
    ACTIONS(1243), 1,
      anon_sym_QMARK,
  [17008] = 2,
    ACTIONS(1245), 1,
      anon_sym_COLON,
    ACTIONS(1247), 1,
      anon_sym_QMARK,
  [17015] = 2,
    ACTIONS(1249), 1,
      anon_sym_COLON,
    ACTIONS(1251), 1,
      anon_sym_QMARK,
  [17022] = 2,
    ACTIONS(1253), 1,
      anon_sym_COLON,
    ACTIONS(1255), 1,
      anon_sym_QMARK,
  [17029] = 2,
    ACTIONS(1257), 1,
      ts_builtin_sym_end,
    ACTIONS(1259), 1,
      sym_comment,
  [17036] = 2,
    ACTIONS(1261), 1,
      anon_sym_COLON,
    ACTIONS(1263), 1,
      anon_sym_QMARK,
  [17043] = 2,
    ACTIONS(1265), 1,
      anon_sym_COLON,
    ACTIONS(1267), 1,
      anon_sym_QMARK,
  [17050] = 2,
    ACTIONS(1269), 1,
      ts_builtin_sym_end,
    ACTIONS(1271), 1,
      sym_comment,
  [17057] = 2,
    ACTIONS(1273), 1,
      ts_builtin_sym_end,
    ACTIONS(1275), 1,
      anon_sym_COLON,
  [17064] = 2,
    ACTIONS(1001), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 1,
      anon_sym_COLON,
  [17071] = 1,
    ACTIONS(1172), 2,
      ts_builtin_sym_end,
      anon_sym_COMMA,
  [17076] = 2,
    ACTIONS(1277), 1,
      anon_sym_COLON,
    ACTIONS(1279), 1,
      anon_sym_QMARK,
  [17083] = 2,
    ACTIONS(1281), 1,
      anon_sym_COLON,
    ACTIONS(1283), 1,
      anon_sym_QMARK,
  [17090] = 2,
    ACTIONS(1013), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 1,
      anon_sym_COLON,
  [17097] = 2,
    ACTIONS(1285), 1,
      anon_sym_COLON,
    ACTIONS(1287), 1,
      anon_sym_QMARK,
  [17104] = 2,
    ACTIONS(1289), 1,
      ts_builtin_sym_end,
    ACTIONS(1291), 1,
      sym_comment,
  [17111] = 2,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(833), 1,
      anon_sym_RPAREN,
  [17118] = 2,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(789), 1,
      anon_sym_RPAREN,
  [17125] = 2,
    ACTIONS(1293), 1,
      anon_sym_COLON,
    ACTIONS(1295), 1,
      anon_sym_QMARK,
  [17132] = 2,
    ACTIONS(1297), 1,
      ts_builtin_sym_end,
    ACTIONS(1299), 1,
      sym_comment,
  [17139] = 2,
    ACTIONS(1301), 1,
      ts_builtin_sym_end,
    ACTIONS(1303), 1,
      sym_comment,
  [17146] = 2,
    ACTIONS(1305), 1,
      ts_builtin_sym_end,
    ACTIONS(1307), 1,
      anon_sym_COLON,
  [17153] = 2,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(785), 1,
      anon_sym_RPAREN,
  [17160] = 2,
    ACTIONS(779), 1,
      anon_sym_RPAREN,
    ACTIONS(781), 1,
      anon_sym_COLON,
  [17167] = 2,
    ACTIONS(1309), 1,
      ts_builtin_sym_end,
    ACTIONS(1311), 1,
      sym_comment,
  [17174] = 2,
    ACTIONS(1313), 1,
      anon_sym_LPARENkey_RPAREN,
    ACTIONS(1315), 1,
      sym_identifier,
  [17181] = 2,
    ACTIONS(1168), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 1,
      anon_sym_COLON,
  [17188] = 2,
    ACTIONS(1045), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 1,
      anon_sym_COLON,
  [17195] = 2,
    ACTIONS(1317), 1,
      ts_builtin_sym_end,
    ACTIONS(1319), 1,
      sym_comment,
  [17202] = 1,
    ACTIONS(1321), 2,
      anon_sym_LBRACK,
      sym_identifier,
  [17207] = 2,
    ACTIONS(1323), 1,
      ts_builtin_sym_end,
    ACTIONS(1325), 1,
      sym_comment,
  [17214] = 2,
    ACTIONS(1327), 1,
      ts_builtin_sym_end,
    ACTIONS(1329), 1,
      sym_comment,
  [17221] = 2,
    ACTIONS(1331), 1,
      ts_builtin_sym_end,
    ACTIONS(1333), 1,
      sym_comment,
  [17228] = 2,
    ACTIONS(1127), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 1,
      anon_sym_COLON,
  [17235] = 2,
    ACTIONS(1335), 1,
      anon_sym_COLON,
    ACTIONS(1337), 1,
      anon_sym_LPAREN,
  [17242] = 2,
    ACTIONS(1339), 1,
      ts_builtin_sym_end,
    ACTIONS(1341), 1,
      sym_comment,
  [17249] = 2,
    ACTIONS(1343), 1,
      ts_builtin_sym_end,
    ACTIONS(1345), 1,
      sym_comment,
  [17256] = 2,
    ACTIONS(1347), 1,
      ts_builtin_sym_end,
    ACTIONS(1349), 1,
      sym_comment,
  [17263] = 2,
    ACTIONS(1351), 1,
      anon_sym_COLON,
    ACTIONS(1353), 1,
      anon_sym_QMARK,
  [17270] = 2,
    ACTIONS(759), 1,
      anon_sym_RPAREN,
    ACTIONS(781), 1,
      anon_sym_COLON,
  [17277] = 1,
    ACTIONS(1166), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [17282] = 2,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(783), 1,
      anon_sym_QMARK,
  [17289] = 2,
    ACTIONS(1355), 1,
      ts_builtin_sym_end,
    ACTIONS(1357), 1,
      sym_comment,
  [17296] = 2,
    ACTIONS(1071), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 1,
      anon_sym_COLON,
  [17303] = 1,
    ACTIONS(1359), 2,
      anon_sym_DOT_DOT_DOT,
      sym_identifier,
  [17308] = 2,
    ACTIONS(1361), 1,
      anon_sym_LBRACK,
    ACTIONS(1363), 1,
      sym_identifier,
  [17315] = 2,
    ACTIONS(1097), 1,
      anon_sym_RPAREN,
    ACTIONS(1215), 1,
      anon_sym_COLON,
  [17322] = 2,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(811), 1,
      anon_sym_RPAREN,
  [17329] = 2,
    ACTIONS(781), 1,
      anon_sym_COLON,
    ACTIONS(797), 1,
      anon_sym_RPAREN,
  [17336] = 1,
    ACTIONS(1365), 1,
      anon_sym_SQUOTE,
  [17340] = 1,
    ACTIONS(1367), 1,
      anon_sym_COLON,
  [17344] = 1,
    ACTIONS(1369), 1,
      anon_sym_SQUOTE,
  [17348] = 1,
    ACTIONS(1371), 1,
      anon_sym_BQUOTE,
  [17352] = 1,
    ACTIONS(1373), 1,
      sym_identifier,
  [17356] = 1,
    ACTIONS(1375), 1,
      anon_sym_RBRACK,
  [17360] = 1,
    ACTIONS(1377), 1,
      ts_builtin_sym_end,
  [17364] = 1,
    ACTIONS(1379), 1,
      sym_identifier,
  [17368] = 1,
    ACTIONS(1381), 1,
      anon_sym_RBRACK,
  [17372] = 1,
    ACTIONS(1383), 1,
      ts_builtin_sym_end,
  [17376] = 1,
    ACTIONS(1385), 1,
      sym_identifier,
  [17380] = 1,
    ACTIONS(1387), 1,
      sym_identifier,
  [17384] = 1,
    ACTIONS(1389), 1,
      anon_sym_BQUOTE,
  [17388] = 1,
    ACTIONS(1391), 1,
      anon_sym_SQUOTE,
  [17392] = 1,
    ACTIONS(1391), 1,
      anon_sym_DQUOTE,
  [17396] = 1,
    ACTIONS(1393), 1,
      ts_builtin_sym_end,
  [17400] = 1,
    ACTIONS(1395), 1,
      ts_builtin_sym_end,
  [17404] = 1,
    ACTIONS(1397), 1,
      ts_builtin_sym_end,
  [17408] = 1,
    ACTIONS(1399), 1,
      ts_builtin_sym_end,
  [17412] = 1,
    ACTIONS(1401), 1,
      ts_builtin_sym_end,
  [17416] = 1,
    ACTIONS(1403), 1,
      sym_identifier,
  [17420] = 1,
    ACTIONS(1405), 1,
      ts_builtin_sym_end,
  [17424] = 1,
    ACTIONS(697), 1,
      ts_builtin_sym_end,
  [17428] = 1,
    ACTIONS(1407), 1,
      ts_builtin_sym_end,
  [17432] = 1,
    ACTIONS(1409), 1,
      ts_builtin_sym_end,
  [17436] = 1,
    ACTIONS(1411), 1,
      anon_sym_DQUOTE,
  [17440] = 1,
    ACTIONS(1411), 1,
      anon_sym_SQUOTE,
  [17444] = 1,
    ACTIONS(1413), 1,
      anon_sym_BQUOTE,
  [17448] = 1,
    ACTIONS(1415), 1,
      sym_identifier,
  [17452] = 1,
    ACTIONS(1417), 1,
      anon_sym_RBRACK,
  [17456] = 1,
    ACTIONS(1419), 1,
      sym_number,
  [17460] = 1,
    ACTIONS(1421), 1,
      sym_identifier,
  [17464] = 1,
    ACTIONS(1423), 1,
      sym_diagnostic_identifier,
  [17468] = 1,
    ACTIONS(1425), 1,
      ts_builtin_sym_end,
  [17472] = 1,
    ACTIONS(1427), 1,
      ts_builtin_sym_end,
  [17476] = 1,
    ACTIONS(1429), 1,
      ts_builtin_sym_end,
  [17480] = 1,
    ACTIONS(1431), 1,
      sym_identifier,
  [17484] = 1,
    ACTIONS(1433), 1,
      ts_builtin_sym_end,
  [17488] = 1,
    ACTIONS(1435), 1,
      sym_diagnostic_identifier,
  [17492] = 1,
    ACTIONS(1437), 1,
      sym_number,
  [17496] = 1,
    ACTIONS(1439), 1,
      sym_identifier,
  [17500] = 1,
    ACTIONS(1441), 1,
      ts_builtin_sym_end,
  [17504] = 1,
    ACTIONS(1443), 1,
      anon_sym_RBRACK2,
  [17508] = 1,
    ACTIONS(1445), 1,
      ts_builtin_sym_end,
  [17512] = 1,
    ACTIONS(1447), 1,
      anon_sym_COLON,
  [17516] = 1,
    ACTIONS(1449), 1,
      anon_sym_RBRACK2,
  [17520] = 1,
    ACTIONS(1451), 1,
      ts_builtin_sym_end,
  [17524] = 1,
    ACTIONS(1453), 1,
      anon_sym_LPAREN,
  [17528] = 1,
    ACTIONS(1455), 1,
      aux_sym_literal_type_token1,
  [17532] = 1,
    ACTIONS(1457), 1,
      aux_sym_literal_type_token2,
  [17536] = 1,
    ACTIONS(1459), 1,
      sym_identifier,
  [17540] = 1,
    ACTIONS(949), 1,
      ts_builtin_sym_end,
  [17544] = 1,
    ACTIONS(1461), 1,
      sym_identifier,
  [17548] = 1,
    ACTIONS(1463), 1,
      anon_sym_RBRACK,
  [17552] = 1,
    ACTIONS(574), 1,
      ts_builtin_sym_end,
  [17556] = 1,
    ACTIONS(1465), 1,
      sym_identifier,
  [17560] = 1,
    ACTIONS(1467), 1,
      sym_identifier,
  [17564] = 1,
    ACTIONS(1469), 1,
      anon_sym_BQUOTE,
  [17568] = 1,
    ACTIONS(1215), 1,
      anon_sym_COLON,
  [17572] = 1,
    ACTIONS(1365), 1,
      anon_sym_DQUOTE,
  [17576] = 1,
    ACTIONS(1355), 1,
      ts_builtin_sym_end,
  [17580] = 1,
    ACTIONS(929), 1,
      anon_sym_RBRACK2,
  [17584] = 1,
    ACTIONS(1471), 1,
      anon_sym_DOT,
  [17588] = 1,
    ACTIONS(1473), 1,
      anon_sym_ATlink,
  [17592] = 1,
    ACTIONS(1475), 1,
      anon_sym_COLON,
  [17596] = 1,
    ACTIONS(1477), 1,
      ts_builtin_sym_end,
  [17600] = 1,
    ACTIONS(1479), 1,
      anon_sym_LPAREN,
  [17604] = 1,
    ACTIONS(1481), 1,
      aux_sym_literal_type_token1,
  [17608] = 1,
    ACTIONS(1483), 1,
      aux_sym_literal_type_token2,
  [17612] = 1,
    ACTIONS(1485), 1,
      sym_identifier,
  [17616] = 1,
    ACTIONS(557), 1,
      ts_builtin_sym_end,
  [17620] = 1,
    ACTIONS(1487), 1,
      sym_identifier,
  [17624] = 1,
    ACTIONS(1489), 1,
      ts_builtin_sym_end,
  [17628] = 1,
    ACTIONS(1491), 1,
      ts_builtin_sym_end,
  [17632] = 1,
    ACTIONS(1493), 1,
      ts_builtin_sym_end,
  [17636] = 1,
    ACTIONS(1495), 1,
      sym_comment,
  [17640] = 1,
    ACTIONS(1497), 1,
      ts_builtin_sym_end,
  [17644] = 1,
    ACTIONS(1499), 1,
      sym_number,
  [17648] = 1,
    ACTIONS(1501), 1,
      anon_sym_LPAREN,
  [17652] = 1,
    ACTIONS(1503), 1,
      aux_sym_literal_type_token1,
  [17656] = 1,
    ACTIONS(1505), 1,
      aux_sym_literal_type_token2,
  [17660] = 1,
    ACTIONS(1507), 1,
      sym_identifier,
  [17664] = 1,
    ACTIONS(1509), 1,
      ts_builtin_sym_end,
  [17668] = 1,
    ACTIONS(781), 1,
      anon_sym_COLON,
  [17672] = 1,
    ACTIONS(1511), 1,
      anon_sym_DOT,
  [17676] = 1,
    ACTIONS(1513), 1,
      ts_builtin_sym_end,
  [17680] = 1,
    ACTIONS(1515), 1,
      ts_builtin_sym_end,
  [17684] = 1,
    ACTIONS(1369), 1,
      anon_sym_DQUOTE,
  [17688] = 1,
    ACTIONS(990), 1,
      ts_builtin_sym_end,
  [17692] = 1,
    ACTIONS(1517), 1,
      ts_builtin_sym_end,
  [17696] = 1,
    ACTIONS(367), 1,
      anon_sym_LPAREN,
  [17700] = 1,
    ACTIONS(1519), 1,
      aux_sym_literal_type_token1,
  [17704] = 1,
    ACTIONS(1521), 1,
      aux_sym_literal_type_token2,
  [17708] = 1,
    ACTIONS(1523), 1,
      sym_identifier,
  [17712] = 1,
    ACTIONS(1525), 1,
      ts_builtin_sym_end,
  [17716] = 1,
    ACTIONS(1527), 1,
      sym_number,
  [17720] = 1,
    ACTIONS(1529), 1,
      ts_builtin_sym_end,
  [17724] = 1,
    ACTIONS(1531), 1,
      sym_identifier,
  [17728] = 1,
    ACTIONS(1533), 1,
      aux_sym_literal_type_token2,
  [17732] = 1,
    ACTIONS(1535), 1,
      aux_sym_literal_type_token1,
  [17736] = 1,
    ACTIONS(1537), 1,
      anon_sym_LPAREN,
  [17740] = 1,
    ACTIONS(961), 1,
      anon_sym_RBRACK2,
  [17744] = 1,
    ACTIONS(1539), 1,
      anon_sym_LPAREN,
  [17748] = 1,
    ACTIONS(1541), 1,
      aux_sym_literal_type_token1,
  [17752] = 1,
    ACTIONS(1543), 1,
      aux_sym_literal_type_token2,
  [17756] = 1,
    ACTIONS(1545), 1,
      sym_identifier,
  [17760] = 1,
    ACTIONS(1547), 1,
      ts_builtin_sym_end,
  [17764] = 1,
    ACTIONS(1549), 1,
      ts_builtin_sym_end,
  [17768] = 1,
    ACTIONS(1551), 1,
      anon_sym_ATas,
  [17772] = 1,
    ACTIONS(1553), 1,
      anon_sym_ATas,
  [17776] = 1,
    ACTIONS(1555), 1,
      sym_number,
  [17780] = 1,
    ACTIONS(1557), 1,
      anon_sym_LBRACE,
  [17784] = 1,
    ACTIONS(1559), 1,
      sym_identifier,
  [17788] = 1,
    ACTIONS(1561), 1,
      ts_builtin_sym_end,
  [17792] = 1,
    ACTIONS(1563), 1,
      anon_sym_LPAREN,
  [17796] = 1,
    ACTIONS(1565), 1,
      aux_sym_literal_type_token1,
  [17800] = 1,
    ACTIONS(1567), 1,
      aux_sym_literal_type_token2,
  [17804] = 1,
    ACTIONS(1569), 1,
      sym_identifier,
  [17808] = 1,
    ACTIONS(1571), 1,
      ts_builtin_sym_end,
  [17812] = 1,
    ACTIONS(1573), 1,
      anon_sym_COLON,
  [17816] = 1,
    ACTIONS(1575), 1,
      sym_identifier,
  [17820] = 1,
    ACTIONS(939), 1,
      ts_builtin_sym_end,
  [17824] = 1,
    ACTIONS(1577), 1,
      ts_builtin_sym_end,
  [17828] = 1,
    ACTIONS(1579), 1,
      sym_identifier,
  [17832] = 1,
    ACTIONS(1581), 1,
      anon_sym_RBRACK,
  [17836] = 1,
    ACTIONS(1583), 1,
      sym_identifier,
  [17840] = 1,
    ACTIONS(1585), 1,
      anon_sym_BQUOTE,
  [17844] = 1,
    ACTIONS(1587), 1,
      anon_sym_COLON,
  [17848] = 1,
    ACTIONS(1589), 1,
      anon_sym_SQUOTE,
  [17852] = 1,
    ACTIONS(1591), 1,
      anon_sym_COLON,
  [17856] = 1,
    ACTIONS(1593), 1,
      sym_identifier,
  [17860] = 1,
    ACTIONS(1595), 1,
      anon_sym_RBRACK,
  [17864] = 1,
    ACTIONS(1589), 1,
      anon_sym_DQUOTE,
  [17868] = 1,
    ACTIONS(1597), 1,
      ts_builtin_sym_end,
  [17872] = 1,
    ACTIONS(1599), 1,
      sym_identifier,
  [17876] = 1,
    ACTIONS(1601), 1,
      anon_sym_BQUOTE,
  [17880] = 1,
    ACTIONS(1603), 1,
      anon_sym_COLON,
  [17884] = 1,
    ACTIONS(719), 1,
      ts_builtin_sym_end,
  [17888] = 1,
    ACTIONS(1605), 1,
      anon_sym_COLON,
  [17892] = 1,
    ACTIONS(1607), 1,
      ts_builtin_sym_end,
  [17896] = 1,
    ACTIONS(1609), 1,
      anon_sym_COLON,
  [17900] = 1,
    ACTIONS(620), 1,
      ts_builtin_sym_end,
  [17904] = 1,
    ACTIONS(1611), 1,
      anon_sym_COLON,
  [17908] = 1,
    ACTIONS(709), 1,
      ts_builtin_sym_end,
  [17912] = 1,
    ACTIONS(1613), 1,
      anon_sym_COLON,
  [17916] = 1,
    ACTIONS(1615), 1,
      ts_builtin_sym_end,
  [17920] = 1,
    ACTIONS(1617), 1,
      anon_sym_COLON,
  [17924] = 1,
    ACTIONS(1619), 1,
      anon_sym_RBRACK,
  [17928] = 1,
    ACTIONS(1621), 1,
      anon_sym_COLON,
  [17932] = 1,
    ACTIONS(1623), 1,
      sym_identifier,
  [17936] = 1,
    ACTIONS(1625), 1,
      anon_sym_COLON,
  [17940] = 1,
    ACTIONS(1627), 1,
      anon_sym_BQUOTE,
  [17944] = 1,
    ACTIONS(1629), 1,
      anon_sym_COLON,
  [17948] = 1,
    ACTIONS(1631), 1,
      anon_sym_SQUOTE,
  [17952] = 1,
    ACTIONS(1633), 1,
      anon_sym_COLON,
  [17956] = 1,
    ACTIONS(1631), 1,
      anon_sym_DQUOTE,
  [17960] = 1,
    ACTIONS(1635), 1,
      anon_sym_COLON,
  [17964] = 1,
    ACTIONS(1637), 1,
      anon_sym_LPAREN,
  [17968] = 1,
    ACTIONS(947), 1,
      anon_sym_RBRACK2,
  [17972] = 1,
    ACTIONS(1639), 1,
      ts_builtin_sym_end,
  [17976] = 1,
    ACTIONS(955), 1,
      anon_sym_RBRACK2,
  [17980] = 1,
    ACTIONS(1641), 1,
      ts_builtin_sym_end,
  [17984] = 1,
    ACTIONS(963), 1,
      anon_sym_RBRACK2,
  [17988] = 1,
    ACTIONS(1643), 1,
      anon_sym_COLON,
  [17992] = 1,
    ACTIONS(945), 1,
      anon_sym_RBRACK2,
  [17996] = 1,
    ACTIONS(547), 1,
      ts_builtin_sym_end,
  [18000] = 1,
    ACTIONS(937), 1,
      anon_sym_RBRACK2,
  [18004] = 1,
    ACTIONS(1645), 1,
      anon_sym_SQUOTE,
  [18008] = 1,
    ACTIONS(935), 1,
      anon_sym_RBRACK2,
  [18012] = 1,
    ACTIONS(1645), 1,
      anon_sym_DQUOTE,
  [18016] = 1,
    ACTIONS(1647), 1,
      sym_string,
  [18020] = 1,
    ACTIONS(1649), 1,
      anon_sym_DOT,
  [18024] = 1,
    ACTIONS(1651), 1,
      sym_diagnostic_identifier,
  [18028] = 1,
    ACTIONS(1653), 1,
      sym_identifier,
  [18032] = 1,
    ACTIONS(1655), 1,
      ts_builtin_sym_end,
  [18036] = 1,
    ACTIONS(1657), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 70,
  [SMALL_STATE(4)] = 140,
  [SMALL_STATE(5)] = 210,
  [SMALL_STATE(6)] = 280,
  [SMALL_STATE(7)] = 350,
  [SMALL_STATE(8)] = 420,
  [SMALL_STATE(9)] = 490,
  [SMALL_STATE(10)] = 560,
  [SMALL_STATE(11)] = 627,
  [SMALL_STATE(12)] = 694,
  [SMALL_STATE(13)] = 753,
  [SMALL_STATE(14)] = 812,
  [SMALL_STATE(15)] = 873,
  [SMALL_STATE(16)] = 932,
  [SMALL_STATE(17)] = 991,
  [SMALL_STATE(18)] = 1052,
  [SMALL_STATE(19)] = 1111,
  [SMALL_STATE(20)] = 1172,
  [SMALL_STATE(21)] = 1231,
  [SMALL_STATE(22)] = 1292,
  [SMALL_STATE(23)] = 1351,
  [SMALL_STATE(24)] = 1412,
  [SMALL_STATE(25)] = 1471,
  [SMALL_STATE(26)] = 1532,
  [SMALL_STATE(27)] = 1590,
  [SMALL_STATE(28)] = 1648,
  [SMALL_STATE(29)] = 1706,
  [SMALL_STATE(30)] = 1764,
  [SMALL_STATE(31)] = 1822,
  [SMALL_STATE(32)] = 1880,
  [SMALL_STATE(33)] = 1938,
  [SMALL_STATE(34)] = 1996,
  [SMALL_STATE(35)] = 2054,
  [SMALL_STATE(36)] = 2112,
  [SMALL_STATE(37)] = 2170,
  [SMALL_STATE(38)] = 2228,
  [SMALL_STATE(39)] = 2286,
  [SMALL_STATE(40)] = 2344,
  [SMALL_STATE(41)] = 2402,
  [SMALL_STATE(42)] = 2460,
  [SMALL_STATE(43)] = 2518,
  [SMALL_STATE(44)] = 2576,
  [SMALL_STATE(45)] = 2634,
  [SMALL_STATE(46)] = 2692,
  [SMALL_STATE(47)] = 2750,
  [SMALL_STATE(48)] = 2808,
  [SMALL_STATE(49)] = 2866,
  [SMALL_STATE(50)] = 2924,
  [SMALL_STATE(51)] = 2982,
  [SMALL_STATE(52)] = 3040,
  [SMALL_STATE(53)] = 3098,
  [SMALL_STATE(54)] = 3156,
  [SMALL_STATE(55)] = 3214,
  [SMALL_STATE(56)] = 3272,
  [SMALL_STATE(57)] = 3330,
  [SMALL_STATE(58)] = 3388,
  [SMALL_STATE(59)] = 3446,
  [SMALL_STATE(60)] = 3504,
  [SMALL_STATE(61)] = 3562,
  [SMALL_STATE(62)] = 3620,
  [SMALL_STATE(63)] = 3678,
  [SMALL_STATE(64)] = 3736,
  [SMALL_STATE(65)] = 3794,
  [SMALL_STATE(66)] = 3852,
  [SMALL_STATE(67)] = 3910,
  [SMALL_STATE(68)] = 3968,
  [SMALL_STATE(69)] = 4026,
  [SMALL_STATE(70)] = 4084,
  [SMALL_STATE(71)] = 4142,
  [SMALL_STATE(72)] = 4200,
  [SMALL_STATE(73)] = 4258,
  [SMALL_STATE(74)] = 4316,
  [SMALL_STATE(75)] = 4374,
  [SMALL_STATE(76)] = 4432,
  [SMALL_STATE(77)] = 4490,
  [SMALL_STATE(78)] = 4548,
  [SMALL_STATE(79)] = 4606,
  [SMALL_STATE(80)] = 4664,
  [SMALL_STATE(81)] = 4722,
  [SMALL_STATE(82)] = 4780,
  [SMALL_STATE(83)] = 4838,
  [SMALL_STATE(84)] = 4896,
  [SMALL_STATE(85)] = 4954,
  [SMALL_STATE(86)] = 5012,
  [SMALL_STATE(87)] = 5070,
  [SMALL_STATE(88)] = 5128,
  [SMALL_STATE(89)] = 5186,
  [SMALL_STATE(90)] = 5244,
  [SMALL_STATE(91)] = 5302,
  [SMALL_STATE(92)] = 5360,
  [SMALL_STATE(93)] = 5418,
  [SMALL_STATE(94)] = 5476,
  [SMALL_STATE(95)] = 5534,
  [SMALL_STATE(96)] = 5592,
  [SMALL_STATE(97)] = 5650,
  [SMALL_STATE(98)] = 5708,
  [SMALL_STATE(99)] = 5766,
  [SMALL_STATE(100)] = 5824,
  [SMALL_STATE(101)] = 5882,
  [SMALL_STATE(102)] = 5940,
  [SMALL_STATE(103)] = 5998,
  [SMALL_STATE(104)] = 6056,
  [SMALL_STATE(105)] = 6114,
  [SMALL_STATE(106)] = 6172,
  [SMALL_STATE(107)] = 6230,
  [SMALL_STATE(108)] = 6288,
  [SMALL_STATE(109)] = 6346,
  [SMALL_STATE(110)] = 6404,
  [SMALL_STATE(111)] = 6462,
  [SMALL_STATE(112)] = 6520,
  [SMALL_STATE(113)] = 6578,
  [SMALL_STATE(114)] = 6636,
  [SMALL_STATE(115)] = 6694,
  [SMALL_STATE(116)] = 6752,
  [SMALL_STATE(117)] = 6810,
  [SMALL_STATE(118)] = 6868,
  [SMALL_STATE(119)] = 6926,
  [SMALL_STATE(120)] = 6984,
  [SMALL_STATE(121)] = 7042,
  [SMALL_STATE(122)] = 7100,
  [SMALL_STATE(123)] = 7158,
  [SMALL_STATE(124)] = 7216,
  [SMALL_STATE(125)] = 7274,
  [SMALL_STATE(126)] = 7332,
  [SMALL_STATE(127)] = 7390,
  [SMALL_STATE(128)] = 7448,
  [SMALL_STATE(129)] = 7506,
  [SMALL_STATE(130)] = 7564,
  [SMALL_STATE(131)] = 7622,
  [SMALL_STATE(132)] = 7680,
  [SMALL_STATE(133)] = 7738,
  [SMALL_STATE(134)] = 7796,
  [SMALL_STATE(135)] = 7854,
  [SMALL_STATE(136)] = 7912,
  [SMALL_STATE(137)] = 7970,
  [SMALL_STATE(138)] = 8028,
  [SMALL_STATE(139)] = 8086,
  [SMALL_STATE(140)] = 8144,
  [SMALL_STATE(141)] = 8202,
  [SMALL_STATE(142)] = 8260,
  [SMALL_STATE(143)] = 8318,
  [SMALL_STATE(144)] = 8376,
  [SMALL_STATE(145)] = 8434,
  [SMALL_STATE(146)] = 8492,
  [SMALL_STATE(147)] = 8550,
  [SMALL_STATE(148)] = 8608,
  [SMALL_STATE(149)] = 8666,
  [SMALL_STATE(150)] = 8724,
  [SMALL_STATE(151)] = 8748,
  [SMALL_STATE(152)] = 8772,
  [SMALL_STATE(153)] = 8802,
  [SMALL_STATE(154)] = 8822,
  [SMALL_STATE(155)] = 8842,
  [SMALL_STATE(156)] = 8862,
  [SMALL_STATE(157)] = 8882,
  [SMALL_STATE(158)] = 8904,
  [SMALL_STATE(159)] = 8924,
  [SMALL_STATE(160)] = 8954,
  [SMALL_STATE(161)] = 8976,
  [SMALL_STATE(162)] = 8996,
  [SMALL_STATE(163)] = 9018,
  [SMALL_STATE(164)] = 9040,
  [SMALL_STATE(165)] = 9060,
  [SMALL_STATE(166)] = 9082,
  [SMALL_STATE(167)] = 9112,
  [SMALL_STATE(168)] = 9142,
  [SMALL_STATE(169)] = 9164,
  [SMALL_STATE(170)] = 9186,
  [SMALL_STATE(171)] = 9216,
  [SMALL_STATE(172)] = 9236,
  [SMALL_STATE(173)] = 9266,
  [SMALL_STATE(174)] = 9283,
  [SMALL_STATE(175)] = 9300,
  [SMALL_STATE(176)] = 9317,
  [SMALL_STATE(177)] = 9334,
  [SMALL_STATE(178)] = 9351,
  [SMALL_STATE(179)] = 9368,
  [SMALL_STATE(180)] = 9393,
  [SMALL_STATE(181)] = 9410,
  [SMALL_STATE(182)] = 9427,
  [SMALL_STATE(183)] = 9444,
  [SMALL_STATE(184)] = 9461,
  [SMALL_STATE(185)] = 9478,
  [SMALL_STATE(186)] = 9495,
  [SMALL_STATE(187)] = 9512,
  [SMALL_STATE(188)] = 9529,
  [SMALL_STATE(189)] = 9546,
  [SMALL_STATE(190)] = 9563,
  [SMALL_STATE(191)] = 9580,
  [SMALL_STATE(192)] = 9597,
  [SMALL_STATE(193)] = 9614,
  [SMALL_STATE(194)] = 9631,
  [SMALL_STATE(195)] = 9656,
  [SMALL_STATE(196)] = 9673,
  [SMALL_STATE(197)] = 9707,
  [SMALL_STATE(198)] = 9737,
  [SMALL_STATE(199)] = 9767,
  [SMALL_STATE(200)] = 9787,
  [SMALL_STATE(201)] = 9817,
  [SMALL_STATE(202)] = 9837,
  [SMALL_STATE(203)] = 9857,
  [SMALL_STATE(204)] = 9887,
  [SMALL_STATE(205)] = 9907,
  [SMALL_STATE(206)] = 9941,
  [SMALL_STATE(207)] = 9971,
  [SMALL_STATE(208)] = 10001,
  [SMALL_STATE(209)] = 10021,
  [SMALL_STATE(210)] = 10041,
  [SMALL_STATE(211)] = 10059,
  [SMALL_STATE(212)] = 10079,
  [SMALL_STATE(213)] = 10113,
  [SMALL_STATE(214)] = 10131,
  [SMALL_STATE(215)] = 10148,
  [SMALL_STATE(216)] = 10163,
  [SMALL_STATE(217)] = 10192,
  [SMALL_STATE(218)] = 10211,
  [SMALL_STATE(219)] = 10240,
  [SMALL_STATE(220)] = 10259,
  [SMALL_STATE(221)] = 10276,
  [SMALL_STATE(222)] = 10293,
  [SMALL_STATE(223)] = 10312,
  [SMALL_STATE(224)] = 10331,
  [SMALL_STATE(225)] = 10348,
  [SMALL_STATE(226)] = 10379,
  [SMALL_STATE(227)] = 10396,
  [SMALL_STATE(228)] = 10413,
  [SMALL_STATE(229)] = 10428,
  [SMALL_STATE(230)] = 10445,
  [SMALL_STATE(231)] = 10460,
  [SMALL_STATE(232)] = 10489,
  [SMALL_STATE(233)] = 10504,
  [SMALL_STATE(234)] = 10519,
  [SMALL_STATE(235)] = 10538,
  [SMALL_STATE(236)] = 10555,
  [SMALL_STATE(237)] = 10572,
  [SMALL_STATE(238)] = 10601,
  [SMALL_STATE(239)] = 10620,
  [SMALL_STATE(240)] = 10635,
  [SMALL_STATE(241)] = 10650,
  [SMALL_STATE(242)] = 10667,
  [SMALL_STATE(243)] = 10682,
  [SMALL_STATE(244)] = 10697,
  [SMALL_STATE(245)] = 10712,
  [SMALL_STATE(246)] = 10727,
  [SMALL_STATE(247)] = 10742,
  [SMALL_STATE(248)] = 10757,
  [SMALL_STATE(249)] = 10772,
  [SMALL_STATE(250)] = 10797,
  [SMALL_STATE(251)] = 10812,
  [SMALL_STATE(252)] = 10827,
  [SMALL_STATE(253)] = 10846,
  [SMALL_STATE(254)] = 10861,
  [SMALL_STATE(255)] = 10878,
  [SMALL_STATE(256)] = 10909,
  [SMALL_STATE(257)] = 10924,
  [SMALL_STATE(258)] = 10939,
  [SMALL_STATE(259)] = 10954,
  [SMALL_STATE(260)] = 10971,
  [SMALL_STATE(261)] = 10996,
  [SMALL_STATE(262)] = 11013,
  [SMALL_STATE(263)] = 11030,
  [SMALL_STATE(264)] = 11045,
  [SMALL_STATE(265)] = 11074,
  [SMALL_STATE(266)] = 11091,
  [SMALL_STATE(267)] = 11108,
  [SMALL_STATE(268)] = 11137,
  [SMALL_STATE(269)] = 11151,
  [SMALL_STATE(270)] = 11179,
  [SMALL_STATE(271)] = 11193,
  [SMALL_STATE(272)] = 11207,
  [SMALL_STATE(273)] = 11221,
  [SMALL_STATE(274)] = 11235,
  [SMALL_STATE(275)] = 11263,
  [SMALL_STATE(276)] = 11291,
  [SMALL_STATE(277)] = 11307,
  [SMALL_STATE(278)] = 11323,
  [SMALL_STATE(279)] = 11339,
  [SMALL_STATE(280)] = 11353,
  [SMALL_STATE(281)] = 11369,
  [SMALL_STATE(282)] = 11383,
  [SMALL_STATE(283)] = 11397,
  [SMALL_STATE(284)] = 11413,
  [SMALL_STATE(285)] = 11429,
  [SMALL_STATE(286)] = 11445,
  [SMALL_STATE(287)] = 11473,
  [SMALL_STATE(288)] = 11487,
  [SMALL_STATE(289)] = 11515,
  [SMALL_STATE(290)] = 11529,
  [SMALL_STATE(291)] = 11557,
  [SMALL_STATE(292)] = 11573,
  [SMALL_STATE(293)] = 11601,
  [SMALL_STATE(294)] = 11615,
  [SMALL_STATE(295)] = 11629,
  [SMALL_STATE(296)] = 11645,
  [SMALL_STATE(297)] = 11659,
  [SMALL_STATE(298)] = 11677,
  [SMALL_STATE(299)] = 11691,
  [SMALL_STATE(300)] = 11705,
  [SMALL_STATE(301)] = 11725,
  [SMALL_STATE(302)] = 11741,
  [SMALL_STATE(303)] = 11757,
  [SMALL_STATE(304)] = 11771,
  [SMALL_STATE(305)] = 11785,
  [SMALL_STATE(306)] = 11801,
  [SMALL_STATE(307)] = 11819,
  [SMALL_STATE(308)] = 11847,
  [SMALL_STATE(309)] = 11865,
  [SMALL_STATE(310)] = 11879,
  [SMALL_STATE(311)] = 11897,
  [SMALL_STATE(312)] = 11915,
  [SMALL_STATE(313)] = 11931,
  [SMALL_STATE(314)] = 11959,
  [SMALL_STATE(315)] = 11987,
  [SMALL_STATE(316)] = 12015,
  [SMALL_STATE(317)] = 12043,
  [SMALL_STATE(318)] = 12071,
  [SMALL_STATE(319)] = 12099,
  [SMALL_STATE(320)] = 12127,
  [SMALL_STATE(321)] = 12155,
  [SMALL_STATE(322)] = 12169,
  [SMALL_STATE(323)] = 12183,
  [SMALL_STATE(324)] = 12197,
  [SMALL_STATE(325)] = 12211,
  [SMALL_STATE(326)] = 12239,
  [SMALL_STATE(327)] = 12253,
  [SMALL_STATE(328)] = 12277,
  [SMALL_STATE(329)] = 12291,
  [SMALL_STATE(330)] = 12305,
  [SMALL_STATE(331)] = 12329,
  [SMALL_STATE(332)] = 12343,
  [SMALL_STATE(333)] = 12357,
  [SMALL_STATE(334)] = 12385,
  [SMALL_STATE(335)] = 12403,
  [SMALL_STATE(336)] = 12417,
  [SMALL_STATE(337)] = 12433,
  [SMALL_STATE(338)] = 12447,
  [SMALL_STATE(339)] = 12461,
  [SMALL_STATE(340)] = 12477,
  [SMALL_STATE(341)] = 12491,
  [SMALL_STATE(342)] = 12509,
  [SMALL_STATE(343)] = 12533,
  [SMALL_STATE(344)] = 12561,
  [SMALL_STATE(345)] = 12575,
  [SMALL_STATE(346)] = 12589,
  [SMALL_STATE(347)] = 12603,
  [SMALL_STATE(348)] = 12617,
  [SMALL_STATE(349)] = 12633,
  [SMALL_STATE(350)] = 12661,
  [SMALL_STATE(351)] = 12675,
  [SMALL_STATE(352)] = 12689,
  [SMALL_STATE(353)] = 12703,
  [SMALL_STATE(354)] = 12731,
  [SMALL_STATE(355)] = 12755,
  [SMALL_STATE(356)] = 12771,
  [SMALL_STATE(357)] = 12787,
  [SMALL_STATE(358)] = 12801,
  [SMALL_STATE(359)] = 12815,
  [SMALL_STATE(360)] = 12831,
  [SMALL_STATE(361)] = 12859,
  [SMALL_STATE(362)] = 12873,
  [SMALL_STATE(363)] = 12887,
  [SMALL_STATE(364)] = 12912,
  [SMALL_STATE(365)] = 12935,
  [SMALL_STATE(366)] = 12958,
  [SMALL_STATE(367)] = 12981,
  [SMALL_STATE(368)] = 13004,
  [SMALL_STATE(369)] = 13017,
  [SMALL_STATE(370)] = 13030,
  [SMALL_STATE(371)] = 13043,
  [SMALL_STATE(372)] = 13056,
  [SMALL_STATE(373)] = 13079,
  [SMALL_STATE(374)] = 13092,
  [SMALL_STATE(375)] = 13107,
  [SMALL_STATE(376)] = 13120,
  [SMALL_STATE(377)] = 13133,
  [SMALL_STATE(378)] = 13156,
  [SMALL_STATE(379)] = 13169,
  [SMALL_STATE(380)] = 13182,
  [SMALL_STATE(381)] = 13205,
  [SMALL_STATE(382)] = 13228,
  [SMALL_STATE(383)] = 13241,
  [SMALL_STATE(384)] = 13256,
  [SMALL_STATE(385)] = 13269,
  [SMALL_STATE(386)] = 13282,
  [SMALL_STATE(387)] = 13305,
  [SMALL_STATE(388)] = 13328,
  [SMALL_STATE(389)] = 13343,
  [SMALL_STATE(390)] = 13356,
  [SMALL_STATE(391)] = 13369,
  [SMALL_STATE(392)] = 13382,
  [SMALL_STATE(393)] = 13395,
  [SMALL_STATE(394)] = 13418,
  [SMALL_STATE(395)] = 13431,
  [SMALL_STATE(396)] = 13454,
  [SMALL_STATE(397)] = 13467,
  [SMALL_STATE(398)] = 13480,
  [SMALL_STATE(399)] = 13503,
  [SMALL_STATE(400)] = 13526,
  [SMALL_STATE(401)] = 13549,
  [SMALL_STATE(402)] = 13572,
  [SMALL_STATE(403)] = 13585,
  [SMALL_STATE(404)] = 13598,
  [SMALL_STATE(405)] = 13611,
  [SMALL_STATE(406)] = 13624,
  [SMALL_STATE(407)] = 13647,
  [SMALL_STATE(408)] = 13660,
  [SMALL_STATE(409)] = 13673,
  [SMALL_STATE(410)] = 13696,
  [SMALL_STATE(411)] = 13719,
  [SMALL_STATE(412)] = 13734,
  [SMALL_STATE(413)] = 13749,
  [SMALL_STATE(414)] = 13762,
  [SMALL_STATE(415)] = 13775,
  [SMALL_STATE(416)] = 13788,
  [SMALL_STATE(417)] = 13811,
  [SMALL_STATE(418)] = 13834,
  [SMALL_STATE(419)] = 13857,
  [SMALL_STATE(420)] = 13880,
  [SMALL_STATE(421)] = 13895,
  [SMALL_STATE(422)] = 13918,
  [SMALL_STATE(423)] = 13941,
  [SMALL_STATE(424)] = 13964,
  [SMALL_STATE(425)] = 13977,
  [SMALL_STATE(426)] = 13990,
  [SMALL_STATE(427)] = 14013,
  [SMALL_STATE(428)] = 14036,
  [SMALL_STATE(429)] = 14049,
  [SMALL_STATE(430)] = 14072,
  [SMALL_STATE(431)] = 14095,
  [SMALL_STATE(432)] = 14118,
  [SMALL_STATE(433)] = 14141,
  [SMALL_STATE(434)] = 14164,
  [SMALL_STATE(435)] = 14187,
  [SMALL_STATE(436)] = 14210,
  [SMALL_STATE(437)] = 14233,
  [SMALL_STATE(438)] = 14256,
  [SMALL_STATE(439)] = 14279,
  [SMALL_STATE(440)] = 14302,
  [SMALL_STATE(441)] = 14325,
  [SMALL_STATE(442)] = 14348,
  [SMALL_STATE(443)] = 14371,
  [SMALL_STATE(444)] = 14394,
  [SMALL_STATE(445)] = 14417,
  [SMALL_STATE(446)] = 14430,
  [SMALL_STATE(447)] = 14443,
  [SMALL_STATE(448)] = 14466,
  [SMALL_STATE(449)] = 14479,
  [SMALL_STATE(450)] = 14492,
  [SMALL_STATE(451)] = 14505,
  [SMALL_STATE(452)] = 14518,
  [SMALL_STATE(453)] = 14531,
  [SMALL_STATE(454)] = 14544,
  [SMALL_STATE(455)] = 14557,
  [SMALL_STATE(456)] = 14570,
  [SMALL_STATE(457)] = 14593,
  [SMALL_STATE(458)] = 14606,
  [SMALL_STATE(459)] = 14629,
  [SMALL_STATE(460)] = 14652,
  [SMALL_STATE(461)] = 14672,
  [SMALL_STATE(462)] = 14684,
  [SMALL_STATE(463)] = 14704,
  [SMALL_STATE(464)] = 14716,
  [SMALL_STATE(465)] = 14728,
  [SMALL_STATE(466)] = 14750,
  [SMALL_STATE(467)] = 14762,
  [SMALL_STATE(468)] = 14774,
  [SMALL_STATE(469)] = 14786,
  [SMALL_STATE(470)] = 14806,
  [SMALL_STATE(471)] = 14818,
  [SMALL_STATE(472)] = 14830,
  [SMALL_STATE(473)] = 14850,
  [SMALL_STATE(474)] = 14862,
  [SMALL_STATE(475)] = 14874,
  [SMALL_STATE(476)] = 14886,
  [SMALL_STATE(477)] = 14898,
  [SMALL_STATE(478)] = 14916,
  [SMALL_STATE(479)] = 14928,
  [SMALL_STATE(480)] = 14940,
  [SMALL_STATE(481)] = 14958,
  [SMALL_STATE(482)] = 14970,
  [SMALL_STATE(483)] = 14982,
  [SMALL_STATE(484)] = 15002,
  [SMALL_STATE(485)] = 15022,
  [SMALL_STATE(486)] = 15034,
  [SMALL_STATE(487)] = 15054,
  [SMALL_STATE(488)] = 15076,
  [SMALL_STATE(489)] = 15096,
  [SMALL_STATE(490)] = 15108,
  [SMALL_STATE(491)] = 15120,
  [SMALL_STATE(492)] = 15132,
  [SMALL_STATE(493)] = 15144,
  [SMALL_STATE(494)] = 15164,
  [SMALL_STATE(495)] = 15182,
  [SMALL_STATE(496)] = 15200,
  [SMALL_STATE(497)] = 15218,
  [SMALL_STATE(498)] = 15236,
  [SMALL_STATE(499)] = 15256,
  [SMALL_STATE(500)] = 15276,
  [SMALL_STATE(501)] = 15294,
  [SMALL_STATE(502)] = 15314,
  [SMALL_STATE(503)] = 15336,
  [SMALL_STATE(504)] = 15356,
  [SMALL_STATE(505)] = 15378,
  [SMALL_STATE(506)] = 15400,
  [SMALL_STATE(507)] = 15420,
  [SMALL_STATE(508)] = 15437,
  [SMALL_STATE(509)] = 15454,
  [SMALL_STATE(510)] = 15471,
  [SMALL_STATE(511)] = 15488,
  [SMALL_STATE(512)] = 15505,
  [SMALL_STATE(513)] = 15524,
  [SMALL_STATE(514)] = 15541,
  [SMALL_STATE(515)] = 15558,
  [SMALL_STATE(516)] = 15575,
  [SMALL_STATE(517)] = 15592,
  [SMALL_STATE(518)] = 15611,
  [SMALL_STATE(519)] = 15628,
  [SMALL_STATE(520)] = 15645,
  [SMALL_STATE(521)] = 15662,
  [SMALL_STATE(522)] = 15679,
  [SMALL_STATE(523)] = 15696,
  [SMALL_STATE(524)] = 15713,
  [SMALL_STATE(525)] = 15730,
  [SMALL_STATE(526)] = 15747,
  [SMALL_STATE(527)] = 15766,
  [SMALL_STATE(528)] = 15783,
  [SMALL_STATE(529)] = 15800,
  [SMALL_STATE(530)] = 15814,
  [SMALL_STATE(531)] = 15828,
  [SMALL_STATE(532)] = 15836,
  [SMALL_STATE(533)] = 15849,
  [SMALL_STATE(534)] = 15862,
  [SMALL_STATE(535)] = 15875,
  [SMALL_STATE(536)] = 15888,
  [SMALL_STATE(537)] = 15901,
  [SMALL_STATE(538)] = 15912,
  [SMALL_STATE(539)] = 15925,
  [SMALL_STATE(540)] = 15938,
  [SMALL_STATE(541)] = 15951,
  [SMALL_STATE(542)] = 15964,
  [SMALL_STATE(543)] = 15977,
  [SMALL_STATE(544)] = 15990,
  [SMALL_STATE(545)] = 16003,
  [SMALL_STATE(546)] = 16016,
  [SMALL_STATE(547)] = 16027,
  [SMALL_STATE(548)] = 16037,
  [SMALL_STATE(549)] = 16047,
  [SMALL_STATE(550)] = 16057,
  [SMALL_STATE(551)] = 16067,
  [SMALL_STATE(552)] = 16077,
  [SMALL_STATE(553)] = 16087,
  [SMALL_STATE(554)] = 16097,
  [SMALL_STATE(555)] = 16107,
  [SMALL_STATE(556)] = 16117,
  [SMALL_STATE(557)] = 16127,
  [SMALL_STATE(558)] = 16137,
  [SMALL_STATE(559)] = 16147,
  [SMALL_STATE(560)] = 16157,
  [SMALL_STATE(561)] = 16167,
  [SMALL_STATE(562)] = 16177,
  [SMALL_STATE(563)] = 16187,
  [SMALL_STATE(564)] = 16195,
  [SMALL_STATE(565)] = 16205,
  [SMALL_STATE(566)] = 16215,
  [SMALL_STATE(567)] = 16225,
  [SMALL_STATE(568)] = 16235,
  [SMALL_STATE(569)] = 16245,
  [SMALL_STATE(570)] = 16255,
  [SMALL_STATE(571)] = 16265,
  [SMALL_STATE(572)] = 16275,
  [SMALL_STATE(573)] = 16283,
  [SMALL_STATE(574)] = 16293,
  [SMALL_STATE(575)] = 16303,
  [SMALL_STATE(576)] = 16313,
  [SMALL_STATE(577)] = 16323,
  [SMALL_STATE(578)] = 16333,
  [SMALL_STATE(579)] = 16343,
  [SMALL_STATE(580)] = 16353,
  [SMALL_STATE(581)] = 16363,
  [SMALL_STATE(582)] = 16373,
  [SMALL_STATE(583)] = 16383,
  [SMALL_STATE(584)] = 16393,
  [SMALL_STATE(585)] = 16403,
  [SMALL_STATE(586)] = 16413,
  [SMALL_STATE(587)] = 16423,
  [SMALL_STATE(588)] = 16433,
  [SMALL_STATE(589)] = 16443,
  [SMALL_STATE(590)] = 16453,
  [SMALL_STATE(591)] = 16463,
  [SMALL_STATE(592)] = 16473,
  [SMALL_STATE(593)] = 16483,
  [SMALL_STATE(594)] = 16493,
  [SMALL_STATE(595)] = 16503,
  [SMALL_STATE(596)] = 16513,
  [SMALL_STATE(597)] = 16523,
  [SMALL_STATE(598)] = 16533,
  [SMALL_STATE(599)] = 16543,
  [SMALL_STATE(600)] = 16553,
  [SMALL_STATE(601)] = 16563,
  [SMALL_STATE(602)] = 16573,
  [SMALL_STATE(603)] = 16583,
  [SMALL_STATE(604)] = 16593,
  [SMALL_STATE(605)] = 16603,
  [SMALL_STATE(606)] = 16613,
  [SMALL_STATE(607)] = 16623,
  [SMALL_STATE(608)] = 16633,
  [SMALL_STATE(609)] = 16643,
  [SMALL_STATE(610)] = 16653,
  [SMALL_STATE(611)] = 16663,
  [SMALL_STATE(612)] = 16673,
  [SMALL_STATE(613)] = 16683,
  [SMALL_STATE(614)] = 16693,
  [SMALL_STATE(615)] = 16703,
  [SMALL_STATE(616)] = 16713,
  [SMALL_STATE(617)] = 16723,
  [SMALL_STATE(618)] = 16731,
  [SMALL_STATE(619)] = 16741,
  [SMALL_STATE(620)] = 16751,
  [SMALL_STATE(621)] = 16761,
  [SMALL_STATE(622)] = 16771,
  [SMALL_STATE(623)] = 16781,
  [SMALL_STATE(624)] = 16791,
  [SMALL_STATE(625)] = 16801,
  [SMALL_STATE(626)] = 16811,
  [SMALL_STATE(627)] = 16821,
  [SMALL_STATE(628)] = 16831,
  [SMALL_STATE(629)] = 16841,
  [SMALL_STATE(630)] = 16851,
  [SMALL_STATE(631)] = 16861,
  [SMALL_STATE(632)] = 16871,
  [SMALL_STATE(633)] = 16881,
  [SMALL_STATE(634)] = 16891,
  [SMALL_STATE(635)] = 16901,
  [SMALL_STATE(636)] = 16911,
  [SMALL_STATE(637)] = 16921,
  [SMALL_STATE(638)] = 16931,
  [SMALL_STATE(639)] = 16938,
  [SMALL_STATE(640)] = 16945,
  [SMALL_STATE(641)] = 16952,
  [SMALL_STATE(642)] = 16959,
  [SMALL_STATE(643)] = 16966,
  [SMALL_STATE(644)] = 16973,
  [SMALL_STATE(645)] = 16980,
  [SMALL_STATE(646)] = 16987,
  [SMALL_STATE(647)] = 16994,
  [SMALL_STATE(648)] = 17001,
  [SMALL_STATE(649)] = 17008,
  [SMALL_STATE(650)] = 17015,
  [SMALL_STATE(651)] = 17022,
  [SMALL_STATE(652)] = 17029,
  [SMALL_STATE(653)] = 17036,
  [SMALL_STATE(654)] = 17043,
  [SMALL_STATE(655)] = 17050,
  [SMALL_STATE(656)] = 17057,
  [SMALL_STATE(657)] = 17064,
  [SMALL_STATE(658)] = 17071,
  [SMALL_STATE(659)] = 17076,
  [SMALL_STATE(660)] = 17083,
  [SMALL_STATE(661)] = 17090,
  [SMALL_STATE(662)] = 17097,
  [SMALL_STATE(663)] = 17104,
  [SMALL_STATE(664)] = 17111,
  [SMALL_STATE(665)] = 17118,
  [SMALL_STATE(666)] = 17125,
  [SMALL_STATE(667)] = 17132,
  [SMALL_STATE(668)] = 17139,
  [SMALL_STATE(669)] = 17146,
  [SMALL_STATE(670)] = 17153,
  [SMALL_STATE(671)] = 17160,
  [SMALL_STATE(672)] = 17167,
  [SMALL_STATE(673)] = 17174,
  [SMALL_STATE(674)] = 17181,
  [SMALL_STATE(675)] = 17188,
  [SMALL_STATE(676)] = 17195,
  [SMALL_STATE(677)] = 17202,
  [SMALL_STATE(678)] = 17207,
  [SMALL_STATE(679)] = 17214,
  [SMALL_STATE(680)] = 17221,
  [SMALL_STATE(681)] = 17228,
  [SMALL_STATE(682)] = 17235,
  [SMALL_STATE(683)] = 17242,
  [SMALL_STATE(684)] = 17249,
  [SMALL_STATE(685)] = 17256,
  [SMALL_STATE(686)] = 17263,
  [SMALL_STATE(687)] = 17270,
  [SMALL_STATE(688)] = 17277,
  [SMALL_STATE(689)] = 17282,
  [SMALL_STATE(690)] = 17289,
  [SMALL_STATE(691)] = 17296,
  [SMALL_STATE(692)] = 17303,
  [SMALL_STATE(693)] = 17308,
  [SMALL_STATE(694)] = 17315,
  [SMALL_STATE(695)] = 17322,
  [SMALL_STATE(696)] = 17329,
  [SMALL_STATE(697)] = 17336,
  [SMALL_STATE(698)] = 17340,
  [SMALL_STATE(699)] = 17344,
  [SMALL_STATE(700)] = 17348,
  [SMALL_STATE(701)] = 17352,
  [SMALL_STATE(702)] = 17356,
  [SMALL_STATE(703)] = 17360,
  [SMALL_STATE(704)] = 17364,
  [SMALL_STATE(705)] = 17368,
  [SMALL_STATE(706)] = 17372,
  [SMALL_STATE(707)] = 17376,
  [SMALL_STATE(708)] = 17380,
  [SMALL_STATE(709)] = 17384,
  [SMALL_STATE(710)] = 17388,
  [SMALL_STATE(711)] = 17392,
  [SMALL_STATE(712)] = 17396,
  [SMALL_STATE(713)] = 17400,
  [SMALL_STATE(714)] = 17404,
  [SMALL_STATE(715)] = 17408,
  [SMALL_STATE(716)] = 17412,
  [SMALL_STATE(717)] = 17416,
  [SMALL_STATE(718)] = 17420,
  [SMALL_STATE(719)] = 17424,
  [SMALL_STATE(720)] = 17428,
  [SMALL_STATE(721)] = 17432,
  [SMALL_STATE(722)] = 17436,
  [SMALL_STATE(723)] = 17440,
  [SMALL_STATE(724)] = 17444,
  [SMALL_STATE(725)] = 17448,
  [SMALL_STATE(726)] = 17452,
  [SMALL_STATE(727)] = 17456,
  [SMALL_STATE(728)] = 17460,
  [SMALL_STATE(729)] = 17464,
  [SMALL_STATE(730)] = 17468,
  [SMALL_STATE(731)] = 17472,
  [SMALL_STATE(732)] = 17476,
  [SMALL_STATE(733)] = 17480,
  [SMALL_STATE(734)] = 17484,
  [SMALL_STATE(735)] = 17488,
  [SMALL_STATE(736)] = 17492,
  [SMALL_STATE(737)] = 17496,
  [SMALL_STATE(738)] = 17500,
  [SMALL_STATE(739)] = 17504,
  [SMALL_STATE(740)] = 17508,
  [SMALL_STATE(741)] = 17512,
  [SMALL_STATE(742)] = 17516,
  [SMALL_STATE(743)] = 17520,
  [SMALL_STATE(744)] = 17524,
  [SMALL_STATE(745)] = 17528,
  [SMALL_STATE(746)] = 17532,
  [SMALL_STATE(747)] = 17536,
  [SMALL_STATE(748)] = 17540,
  [SMALL_STATE(749)] = 17544,
  [SMALL_STATE(750)] = 17548,
  [SMALL_STATE(751)] = 17552,
  [SMALL_STATE(752)] = 17556,
  [SMALL_STATE(753)] = 17560,
  [SMALL_STATE(754)] = 17564,
  [SMALL_STATE(755)] = 17568,
  [SMALL_STATE(756)] = 17572,
  [SMALL_STATE(757)] = 17576,
  [SMALL_STATE(758)] = 17580,
  [SMALL_STATE(759)] = 17584,
  [SMALL_STATE(760)] = 17588,
  [SMALL_STATE(761)] = 17592,
  [SMALL_STATE(762)] = 17596,
  [SMALL_STATE(763)] = 17600,
  [SMALL_STATE(764)] = 17604,
  [SMALL_STATE(765)] = 17608,
  [SMALL_STATE(766)] = 17612,
  [SMALL_STATE(767)] = 17616,
  [SMALL_STATE(768)] = 17620,
  [SMALL_STATE(769)] = 17624,
  [SMALL_STATE(770)] = 17628,
  [SMALL_STATE(771)] = 17632,
  [SMALL_STATE(772)] = 17636,
  [SMALL_STATE(773)] = 17640,
  [SMALL_STATE(774)] = 17644,
  [SMALL_STATE(775)] = 17648,
  [SMALL_STATE(776)] = 17652,
  [SMALL_STATE(777)] = 17656,
  [SMALL_STATE(778)] = 17660,
  [SMALL_STATE(779)] = 17664,
  [SMALL_STATE(780)] = 17668,
  [SMALL_STATE(781)] = 17672,
  [SMALL_STATE(782)] = 17676,
  [SMALL_STATE(783)] = 17680,
  [SMALL_STATE(784)] = 17684,
  [SMALL_STATE(785)] = 17688,
  [SMALL_STATE(786)] = 17692,
  [SMALL_STATE(787)] = 17696,
  [SMALL_STATE(788)] = 17700,
  [SMALL_STATE(789)] = 17704,
  [SMALL_STATE(790)] = 17708,
  [SMALL_STATE(791)] = 17712,
  [SMALL_STATE(792)] = 17716,
  [SMALL_STATE(793)] = 17720,
  [SMALL_STATE(794)] = 17724,
  [SMALL_STATE(795)] = 17728,
  [SMALL_STATE(796)] = 17732,
  [SMALL_STATE(797)] = 17736,
  [SMALL_STATE(798)] = 17740,
  [SMALL_STATE(799)] = 17744,
  [SMALL_STATE(800)] = 17748,
  [SMALL_STATE(801)] = 17752,
  [SMALL_STATE(802)] = 17756,
  [SMALL_STATE(803)] = 17760,
  [SMALL_STATE(804)] = 17764,
  [SMALL_STATE(805)] = 17768,
  [SMALL_STATE(806)] = 17772,
  [SMALL_STATE(807)] = 17776,
  [SMALL_STATE(808)] = 17780,
  [SMALL_STATE(809)] = 17784,
  [SMALL_STATE(810)] = 17788,
  [SMALL_STATE(811)] = 17792,
  [SMALL_STATE(812)] = 17796,
  [SMALL_STATE(813)] = 17800,
  [SMALL_STATE(814)] = 17804,
  [SMALL_STATE(815)] = 17808,
  [SMALL_STATE(816)] = 17812,
  [SMALL_STATE(817)] = 17816,
  [SMALL_STATE(818)] = 17820,
  [SMALL_STATE(819)] = 17824,
  [SMALL_STATE(820)] = 17828,
  [SMALL_STATE(821)] = 17832,
  [SMALL_STATE(822)] = 17836,
  [SMALL_STATE(823)] = 17840,
  [SMALL_STATE(824)] = 17844,
  [SMALL_STATE(825)] = 17848,
  [SMALL_STATE(826)] = 17852,
  [SMALL_STATE(827)] = 17856,
  [SMALL_STATE(828)] = 17860,
  [SMALL_STATE(829)] = 17864,
  [SMALL_STATE(830)] = 17868,
  [SMALL_STATE(831)] = 17872,
  [SMALL_STATE(832)] = 17876,
  [SMALL_STATE(833)] = 17880,
  [SMALL_STATE(834)] = 17884,
  [SMALL_STATE(835)] = 17888,
  [SMALL_STATE(836)] = 17892,
  [SMALL_STATE(837)] = 17896,
  [SMALL_STATE(838)] = 17900,
  [SMALL_STATE(839)] = 17904,
  [SMALL_STATE(840)] = 17908,
  [SMALL_STATE(841)] = 17912,
  [SMALL_STATE(842)] = 17916,
  [SMALL_STATE(843)] = 17920,
  [SMALL_STATE(844)] = 17924,
  [SMALL_STATE(845)] = 17928,
  [SMALL_STATE(846)] = 17932,
  [SMALL_STATE(847)] = 17936,
  [SMALL_STATE(848)] = 17940,
  [SMALL_STATE(849)] = 17944,
  [SMALL_STATE(850)] = 17948,
  [SMALL_STATE(851)] = 17952,
  [SMALL_STATE(852)] = 17956,
  [SMALL_STATE(853)] = 17960,
  [SMALL_STATE(854)] = 17964,
  [SMALL_STATE(855)] = 17968,
  [SMALL_STATE(856)] = 17972,
  [SMALL_STATE(857)] = 17976,
  [SMALL_STATE(858)] = 17980,
  [SMALL_STATE(859)] = 17984,
  [SMALL_STATE(860)] = 17988,
  [SMALL_STATE(861)] = 17992,
  [SMALL_STATE(862)] = 17996,
  [SMALL_STATE(863)] = 18000,
  [SMALL_STATE(864)] = 18004,
  [SMALL_STATE(865)] = 18008,
  [SMALL_STATE(866)] = 18012,
  [SMALL_STATE(867)] = 18016,
  [SMALL_STATE(868)] = 18020,
  [SMALL_STATE(869)] = 18024,
  [SMALL_STATE(870)] = 18028,
  [SMALL_STATE(871)] = 18032,
  [SMALL_STATE(872)] = 18036,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(112),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(668),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(631),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(369),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(221),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexed_field, 3),
  [339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexed_field, 3),
  [341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_field, 3),
  [343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_field, 3),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 7, .production_id = 13),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 7, .production_id = 13),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4),
  [363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4),
  [365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_type, 1),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [369] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_type, 1),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1),
  [379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 10, .production_id = 18),
  [381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 10, .production_id = 18),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 9, .production_id = 18),
  [387] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 9, .production_id = 18),
  [389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_annotation_repeat1, 2), SHIFT_REPEAT(138),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_annotation_repeat1, 2),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_annotation_repeat1, 2),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3),
  [400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3),
  [402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 9, .production_id = 16),
  [404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 9, .production_id = 16),
  [406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 8),
  [408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 8),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 8, .production_id = 13),
  [414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 8, .production_id = 13),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 8, .production_id = 16),
  [418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 8, .production_id = 16),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 7),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 7),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 6),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 6),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5),
  [432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_literal_type, 8, .production_id = 15),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_literal_type, 8, .production_id = 15),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_literal_type, 9, .production_id = 17),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_literal_type, 9, .production_id = 17),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_type, 3),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_type, 3),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_type, 2),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3),
  [454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_custom_type, 3),
  [456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_custom_type, 3),
  [458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_literal_type, 8, .production_id = 11),
  [460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_literal_type, 8, .production_id = 11),
  [462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_type, 4, .production_id = 4),
  [464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_type, 4, .production_id = 4),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 3),
  [468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 3),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_type, 3),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_type, 3),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_literal_type, 2),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_literal_type, 2),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_literal_type, 5, .production_id = 5),
  [484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_literal_type, 5, .production_id = 5),
  [486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_literal_type, 7, .production_id = 12),
  [488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_literal_type, 7, .production_id = 12),
  [490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_literal_type, 7, .production_id = 11),
  [492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_literal_type, 7, .production_id = 11),
  [494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 6),
  [496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 6),
  [498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_literal_type, 6, .production_id = 8),
  [500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_literal_type, 6, .production_id = 8),
  [502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_literal_type, 6, .production_id = 5),
  [504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_literal_type, 6, .production_id = 5),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3),
  [508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3),
  [510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_type, 6, .production_id = 10),
  [512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_type, 6, .production_id = 10),
  [514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 2),
  [516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(114),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_annotation_repeat1, 2), SHIFT_REPEAT(80),
  [547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_annotation, 4),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_annotation, 5),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_annotation_repeat1, 2), SHIFT_REPEAT(98),
  [568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_annotation, 3),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(120),
  [602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_annotation, 2),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(97),
  [618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_annotation, 4),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continuation, 2),
  [636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_annotation, 2),
  [640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_annotation, 3),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_annotation, 3),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_annotation, 3),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_annotation, 3),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_annotation_repeat1, 2), SHIFT_REPEAT(113),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_annotation, 5),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_annotation_repeat1, 2),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_annotation_repeat1, 2),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_annotation, 4),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(785),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_annotation, 4),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 4, .production_id = 2),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_annotation_repeat1, 2),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cast_annotation_repeat1, 2),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_cast_annotation_repeat1, 3),
  [819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_cast_annotation_repeat1, 3),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_annotation, 4),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(740),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4),
  [889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_literal_type_repeat1, 7, .production_id = 11),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_literal_type_repeat1, 6, .production_id = 11),
  [893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_literal_type_repeat1, 5, .production_id = 5),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_literal_type_repeat1, 4, .production_id = 5),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_annotation, 7),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vararg_annotation, 2),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_see_reference, 2),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_annotation, 6),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 3),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_annotation_repeat1, 2), SHIFT_REPEAT(85),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 2),
  [984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_annotation, 5),
  [992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_cast_annotation_repeat1, 2), SHIFT_REPEAT(11),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deprecated_annotation, 1),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_diagnostic_annotation, 5),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_annotation_repeat1, 2), SHIFT_REPEAT(116),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_table_literal_type_repeat1, 2, .production_id = 9), SHIFT_REPEAT(693),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_table_literal_type_repeat1, 2, .production_id = 9),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_diagnostic_annotation, 4),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 4),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(734),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 2), SHIFT_REPEAT(537),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 2),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_diagnostic_annotation_repeat1, 2),
  [1174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_diagnostic_annotation_repeat1, 2), SHIFT_REPEAT(735),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 6, .production_id = 2),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_at_comment, 2),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(704),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference, 5),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_annotation, 1),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [1221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_annotation, 4),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_at_comment, 4),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [1269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 6),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_annotation, 4, .production_id = 3),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_at_comment, 2),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_annotation, 1),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nodiscard_annotation, 1),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_annotation, 6, .production_id = 6),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [1309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_annotation, 1),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_since_annotation, 6, .production_id = 7),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifier, 1),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 8, .production_id = 2),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_annotation, 2),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_version_annotation, 2, .production_id = 1),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overload_annotation, 2),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_annotation, 2),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_language_injection, 2),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [1355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_annotation, 3),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_at_comment, 5),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_overload_annotation, 3),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [1393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deprecated_annotation, 3),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 7, .production_id = 2),
  [1397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_version_annotation, 3, .production_id = 1),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_at_comment, 3),
  [1401] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_at_comment, 3),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [1405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_param_annotation, 5),
  [1407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 7),
  [1409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module_annotation, 3),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 5, .production_id = 2),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vararg_annotation, 3),
  [1429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 3),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 5),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [1441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_since_annotation, 7, .production_id = 7),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_annotation, 5),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_annotation, 3),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_language_injection, 3),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [1489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_see_reference, 3),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_annotation, 2),
  [1493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deprecated_annotation, 2),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [1497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nodiscard_annotation, 2),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package_annotation, 2),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_annotation, 7),
  [1515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_annotation, 2),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_annotation, 8, .production_id = 14),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [1525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_annotation, 8),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continuation, 3),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_documentation, 1),
  [1549] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_reference, 6),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_annotation, 5),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_annotation, 6),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_annotation, 4),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_annotation, 4),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [1615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_annotation, 6),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_annotation, 4),
  [1641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_annotation, 9, .production_id = 2),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualifier_annotation, 1),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_luadoc(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
