#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 557
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 196
#define ALIAS_COUNT 0
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 21
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 72

enum ts_symbol_identifiers {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_return = 3,
  anon_sym_SEMI = 4,
  anon_sym_EQ = 5,
  anon_sym_COMMA = 6,
  anon_sym_COLON_COLON = 7,
  sym_break_statement = 8,
  anon_sym_goto = 9,
  anon_sym_do = 10,
  anon_sym_end = 11,
  anon_sym_while = 12,
  anon_sym_repeat = 13,
  anon_sym_until = 14,
  anon_sym_if = 15,
  anon_sym_then = 16,
  anon_sym_elseif = 17,
  anon_sym_else = 18,
  anon_sym_for = 19,
  anon_sym_in = 20,
  anon_sym_function = 21,
  anon_sym_local = 22,
  anon_sym_DOT = 23,
  anon_sym_COLON = 24,
  anon_sym_LT = 25,
  anon_sym_GT = 26,
  anon_sym_nil = 27,
  sym_false = 28,
  sym_true = 29,
  sym_number = 30,
  anon_sym_DQUOTE = 31,
  anon_sym_SQUOTE = 32,
  aux_sym__doublequote_string_content_token1 = 33,
  aux_sym__singlequote_string_content_token1 = 34,
  sym_escape_sequence = 35,
  anon_sym_DOT_DOT_DOT = 36,
  anon_sym_LPAREN = 37,
  anon_sym_RPAREN = 38,
  anon_sym_LBRACK = 39,
  anon_sym_RBRACK = 40,
  anon_sym_LBRACE = 41,
  anon_sym_RBRACE = 42,
  anon_sym_or = 43,
  anon_sym_and = 44,
  anon_sym_LT_EQ = 45,
  anon_sym_EQ_EQ = 46,
  anon_sym_TILDE_EQ = 47,
  anon_sym_GT_EQ = 48,
  anon_sym_PLUS = 49,
  anon_sym_DASH = 50,
  anon_sym_STAR = 51,
  anon_sym_SLASH = 52,
  anon_sym_SLASH_SLASH = 53,
  anon_sym_PERCENT = 54,
  anon_sym_DOT_DOT = 55,
  anon_sym_CARET = 56,
  anon_sym_not = 57,
  anon_sym_POUND = 58,
  anon_sym_DASH_DASH = 59,
  aux_sym_comment_token1 = 60,
  anon_sym_PLUS_EQ = 61,
  anon_sym_DASH_EQ = 62,
  anon_sym_STAR_EQ = 63,
  anon_sym_SLASH_EQ = 64,
  anon_sym_PERCENT_EQ = 65,
  anon_sym_SLASH_SLASH_EQ = 66,
  anon_sym_CARET_EQ = 67,
  anon_sym_DOT_DOT_EQ = 68,
  sym_continue_statement = 69,
  anon_sym_export = 70,
  anon_sym_type = 71,
  anon_sym_typeof = 72,
  anon_sym_thread = 73,
  anon_sym_buffer = 74,
  anon_sym_any = 75,
  anon_sym_userdata = 76,
  anon_sym_unknown = 77,
  anon_sym_never = 78,
  anon_sym_string = 79,
  anon_sym_number = 80,
  anon_sym_table = 81,
  anon_sym_boolean = 82,
  anon_sym_DASH_GT = 83,
  anon_sym_PIPE = 84,
  anon_sym_AMP = 85,
  anon_sym_QMARK = 86,
  anon_sym_BQUOTE = 87,
  aux_sym__interpolation_string_content_token1 = 88,
  anon_sym_BSLASH_LBRACE = 89,
  aux_sym__escape_sequence_token1 = 90,
  sym__block_comment_start = 91,
  sym__block_comment_content = 92,
  sym__block_comment_end = 93,
  sym__block_string_start = 94,
  sym__block_string_content = 95,
  sym__block_string_end = 96,
  sym_chunk = 97,
  sym__block = 98,
  sym_statement = 99,
  sym_return_statement = 100,
  sym_empty_statement = 101,
  sym_assignment_statement = 102,
  sym__variable_assignment_varlist = 103,
  sym__variable_assignment_explist = 104,
  sym_do_statement = 105,
  sym_while_statement = 106,
  sym_repeat_statement = 107,
  sym_if_statement = 108,
  sym_elseif_statement = 109,
  sym_else_statement = 110,
  sym_for_statement = 111,
  sym_for_generic_clause = 112,
  sym_for_numeric_clause = 113,
  sym_declaration = 114,
  sym_function_declaration = 115,
  sym__local_function_declaration = 116,
  sym__function_name = 117,
  sym__function_name_prefix_expression = 118,
  sym__function_name_dot_index_expression = 119,
  sym__function_name_method_index_expression = 120,
  sym_variable_declaration = 121,
  sym__local_variable_assignment = 122,
  sym__name_list = 123,
  sym__att_name_list = 124,
  sym__attrib = 125,
  sym__expression_list = 126,
  sym_expression = 127,
  sym_nil = 128,
  sym_string = 129,
  sym__quote_string = 130,
  aux_sym__doublequote_string_content = 131,
  aux_sym__singlequote_string_content = 132,
  sym__block_string = 133,
  sym_vararg_expression = 134,
  sym_function_definition = 135,
  sym__function_body = 136,
  sym_parameters = 137,
  sym__parameter_list = 138,
  sym__prefix_expression = 139,
  sym_variable = 140,
  sym_bracket_index_expression = 141,
  sym_dot_index_expression = 142,
  sym_function_call = 143,
  sym_method_index_expression = 144,
  sym_arguments = 145,
  sym_parenthesized_expression = 146,
  sym_table_constructor = 147,
  sym__field_list = 148,
  sym__field_sep = 149,
  sym_field = 150,
  sym_binary_expression = 151,
  sym_unary_expression = 152,
  sym_comment = 153,
  sym_update_statement = 154,
  sym_type_definition = 155,
  sym_generic_type_list = 156,
  sym_parameter = 157,
  sym_type = 158,
  sym_builtin_type = 159,
  sym_tuple_type = 160,
  sym_function_type = 161,
  sym_generic_type = 162,
  sym_object_type = 163,
  sym_empty_type = 164,
  sym_field_type = 165,
  sym_object_field_type = 166,
  sym_union_type = 167,
  sym_intersection_type = 168,
  sym_optional_type = 169,
  sym_literal_type = 170,
  sym_variadic_type = 171,
  sym_cast_expression = 172,
  sym_if_expression = 173,
  sym_elseif_clause = 174,
  sym_else_clause = 175,
  sym__interpolated_string = 176,
  sym__interpolation_string_content = 177,
  sym__escape_sequence = 178,
  sym_interpolation = 179,
  aux_sym_chunk_repeat1 = 180,
  aux_sym__variable_assignment_varlist_repeat1 = 181,
  aux_sym__variable_assignment_explist_repeat1 = 182,
  aux_sym_if_statement_repeat1 = 183,
  aux_sym__name_list_repeat1 = 184,
  aux_sym__att_name_list_repeat1 = 185,
  aux_sym__expression_list_repeat1 = 186,
  aux_sym__parameter_list_repeat1 = 187,
  aux_sym__field_list_repeat1 = 188,
  aux_sym_generic_type_list_repeat1 = 189,
  aux_sym_tuple_type_repeat1 = 190,
  aux_sym_function_type_repeat1 = 191,
  aux_sym_object_type_repeat1 = 192,
  aux_sym_field_type_repeat1 = 193,
  aux_sym_if_expression_repeat1 = 194,
  aux_sym__interpolated_string_repeat1 = 195,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_return] = "return",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [anon_sym_COLON_COLON] = "::",
  [sym_break_statement] = "break_statement",
  [anon_sym_goto] = "goto",
  [anon_sym_do] = "do",
  [anon_sym_end] = "end",
  [anon_sym_while] = "while",
  [anon_sym_repeat] = "repeat",
  [anon_sym_until] = "until",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_elseif] = "elseif",
  [anon_sym_else] = "else",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_function] = "function",
  [anon_sym_local] = "local",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON] = ":",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_nil] = "nil",
  [sym_false] = "false",
  [sym_true] = "true",
  [sym_number] = "number",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_SQUOTE] = "'",
  [aux_sym__doublequote_string_content_token1] = "_doublequote_string_content_token1",
  [aux_sym__singlequote_string_content_token1] = "_singlequote_string_content_token1",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_or] = "or",
  [anon_sym_and] = "and",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_CARET] = "^",
  [anon_sym_not] = "not",
  [anon_sym_POUND] = "#",
  [anon_sym_DASH_DASH] = "--",
  [aux_sym_comment_token1] = "comment_content",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [sym_continue_statement] = "continue_statement",
  [anon_sym_export] = "export",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_thread] = "thread",
  [anon_sym_buffer] = "buffer",
  [anon_sym_any] = "any",
  [anon_sym_userdata] = "userdata",
  [anon_sym_unknown] = "unknown",
  [anon_sym_never] = "never",
  [anon_sym_string] = "string",
  [anon_sym_number] = "number",
  [anon_sym_table] = "table",
  [anon_sym_boolean] = "boolean",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_QMARK] = "\?",
  [anon_sym_BQUOTE] = "`",
  [aux_sym__interpolation_string_content_token1] = "_interpolation_string_content_token1",
  [anon_sym_BSLASH_LBRACE] = "\\{",
  [aux_sym__escape_sequence_token1] = "_escape_sequence_token1",
  [sym__block_comment_start] = "[[",
  [sym__block_comment_content] = "comment_content",
  [sym__block_comment_end] = "]]",
  [sym__block_string_start] = "[[",
  [sym__block_string_content] = "string_content",
  [sym__block_string_end] = "]]",
  [sym_chunk] = "chunk",
  [sym__block] = "block",
  [sym_statement] = "statement",
  [sym_return_statement] = "return_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_assignment_statement] = "assignment_statement",
  [sym__variable_assignment_varlist] = "variable_list",
  [sym__variable_assignment_explist] = "expression_list",
  [sym_do_statement] = "do_statement",
  [sym_while_statement] = "while_statement",
  [sym_repeat_statement] = "repeat_statement",
  [sym_if_statement] = "if_statement",
  [sym_elseif_statement] = "elseif_statement",
  [sym_else_statement] = "else_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_generic_clause] = "for_generic_clause",
  [sym_for_numeric_clause] = "for_numeric_clause",
  [sym_declaration] = "declaration",
  [sym_function_declaration] = "function_declaration",
  [sym__local_function_declaration] = "function_declaration",
  [sym__function_name] = "_function_name",
  [sym__function_name_prefix_expression] = "_function_name_prefix_expression",
  [sym__function_name_dot_index_expression] = "dot_index_expression",
  [sym__function_name_method_index_expression] = "method_index_expression",
  [sym_variable_declaration] = "variable_declaration",
  [sym__local_variable_assignment] = "assignment_statement",
  [sym__name_list] = "variable_list",
  [sym__att_name_list] = "variable_list",
  [sym__attrib] = "attribute",
  [sym__expression_list] = "expression_list",
  [sym_expression] = "expression",
  [sym_nil] = "nil",
  [sym_string] = "string",
  [sym__quote_string] = "_quote_string",
  [aux_sym__doublequote_string_content] = "_doublequote_string_content",
  [aux_sym__singlequote_string_content] = "_singlequote_string_content",
  [sym__block_string] = "_block_string",
  [sym_vararg_expression] = "vararg_expression",
  [sym_function_definition] = "function_definition",
  [sym__function_body] = "_function_body",
  [sym_parameters] = "parameters",
  [sym__parameter_list] = "_parameter_list",
  [sym__prefix_expression] = "_prefix_expression",
  [sym_variable] = "variable",
  [sym_bracket_index_expression] = "bracket_index_expression",
  [sym_dot_index_expression] = "dot_index_expression",
  [sym_function_call] = "function_call",
  [sym_method_index_expression] = "method_index_expression",
  [sym_arguments] = "arguments",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_table_constructor] = "table_constructor",
  [sym__field_list] = "_field_list",
  [sym__field_sep] = "_field_sep",
  [sym_field] = "field",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_comment] = "comment",
  [sym_update_statement] = "update_statement",
  [sym_type_definition] = "type_definition",
  [sym_generic_type_list] = "generic_type_list",
  [sym_parameter] = "parameter",
  [sym_type] = "type",
  [sym_builtin_type] = "builtin_type",
  [sym_tuple_type] = "tuple_type",
  [sym_function_type] = "function_type",
  [sym_generic_type] = "generic_type",
  [sym_object_type] = "object_type",
  [sym_empty_type] = "empty_type",
  [sym_field_type] = "field_type",
  [sym_object_field_type] = "object_field_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_optional_type] = "optional_type",
  [sym_literal_type] = "literal_type",
  [sym_variadic_type] = "variadic_type",
  [sym_cast_expression] = "cast_expression",
  [sym_if_expression] = "if_expression",
  [sym_elseif_clause] = "elseif_clause",
  [sym_else_clause] = "else_clause",
  [sym__interpolated_string] = "_interpolated_string",
  [sym__interpolation_string_content] = "string_content",
  [sym__escape_sequence] = "_escape_sequence",
  [sym_interpolation] = "interpolation",
  [aux_sym_chunk_repeat1] = "chunk_repeat1",
  [aux_sym__variable_assignment_varlist_repeat1] = "_variable_assignment_varlist_repeat1",
  [aux_sym__variable_assignment_explist_repeat1] = "_variable_assignment_explist_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym__name_list_repeat1] = "_name_list_repeat1",
  [aux_sym__att_name_list_repeat1] = "_att_name_list_repeat1",
  [aux_sym__expression_list_repeat1] = "_expression_list_repeat1",
  [aux_sym__parameter_list_repeat1] = "_parameter_list_repeat1",
  [aux_sym__field_list_repeat1] = "_field_list_repeat1",
  [aux_sym_generic_type_list_repeat1] = "generic_type_list_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_function_type_repeat1] = "function_type_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_field_type_repeat1] = "field_type_repeat1",
  [aux_sym_if_expression_repeat1] = "if_expression_repeat1",
  [aux_sym__interpolated_string_repeat1] = "_interpolated_string_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [sym_break_statement] = sym_break_statement,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_repeat] = anon_sym_repeat,
  [anon_sym_until] = anon_sym_until,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_elseif] = anon_sym_elseif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_local] = anon_sym_local,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_nil] = anon_sym_nil,
  [sym_false] = sym_false,
  [sym_true] = sym_true,
  [sym_number] = sym_number,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym__doublequote_string_content_token1] = aux_sym__doublequote_string_content_token1,
  [aux_sym__singlequote_string_content_token1] = aux_sym__singlequote_string_content_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [aux_sym_comment_token1] = sym__block_comment_content,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [sym_continue_statement] = sym_continue_statement,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_thread] = anon_sym_thread,
  [anon_sym_buffer] = anon_sym_buffer,
  [anon_sym_any] = anon_sym_any,
  [anon_sym_userdata] = anon_sym_userdata,
  [anon_sym_unknown] = anon_sym_unknown,
  [anon_sym_never] = anon_sym_never,
  [anon_sym_string] = anon_sym_string,
  [anon_sym_number] = anon_sym_number,
  [anon_sym_table] = anon_sym_table,
  [anon_sym_boolean] = anon_sym_boolean,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym__interpolation_string_content_token1] = aux_sym__interpolation_string_content_token1,
  [anon_sym_BSLASH_LBRACE] = anon_sym_BSLASH_LBRACE,
  [aux_sym__escape_sequence_token1] = aux_sym__escape_sequence_token1,
  [sym__block_comment_start] = sym__block_comment_start,
  [sym__block_comment_content] = sym__block_comment_content,
  [sym__block_comment_end] = sym__block_comment_end,
  [sym__block_string_start] = sym__block_comment_start,
  [sym__block_string_content] = sym__block_string_content,
  [sym__block_string_end] = sym__block_comment_end,
  [sym_chunk] = sym_chunk,
  [sym__block] = sym__block,
  [sym_statement] = sym_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_assignment_statement] = sym_assignment_statement,
  [sym__variable_assignment_varlist] = sym__variable_assignment_varlist,
  [sym__variable_assignment_explist] = sym__variable_assignment_explist,
  [sym_do_statement] = sym_do_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_repeat_statement] = sym_repeat_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elseif_statement] = sym_elseif_statement,
  [sym_else_statement] = sym_else_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_generic_clause] = sym_for_generic_clause,
  [sym_for_numeric_clause] = sym_for_numeric_clause,
  [sym_declaration] = sym_declaration,
  [sym_function_declaration] = sym_function_declaration,
  [sym__local_function_declaration] = sym_function_declaration,
  [sym__function_name] = sym__function_name,
  [sym__function_name_prefix_expression] = sym__function_name_prefix_expression,
  [sym__function_name_dot_index_expression] = sym_dot_index_expression,
  [sym__function_name_method_index_expression] = sym_method_index_expression,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym__local_variable_assignment] = sym_assignment_statement,
  [sym__name_list] = sym__variable_assignment_varlist,
  [sym__att_name_list] = sym__variable_assignment_varlist,
  [sym__attrib] = sym__attrib,
  [sym__expression_list] = sym__variable_assignment_explist,
  [sym_expression] = sym_expression,
  [sym_nil] = sym_nil,
  [sym_string] = sym_string,
  [sym__quote_string] = sym__quote_string,
  [aux_sym__doublequote_string_content] = aux_sym__doublequote_string_content,
  [aux_sym__singlequote_string_content] = aux_sym__singlequote_string_content,
  [sym__block_string] = sym__block_string,
  [sym_vararg_expression] = sym_vararg_expression,
  [sym_function_definition] = sym_function_definition,
  [sym__function_body] = sym__function_body,
  [sym_parameters] = sym_parameters,
  [sym__parameter_list] = sym__parameter_list,
  [sym__prefix_expression] = sym__prefix_expression,
  [sym_variable] = sym_variable,
  [sym_bracket_index_expression] = sym_bracket_index_expression,
  [sym_dot_index_expression] = sym_dot_index_expression,
  [sym_function_call] = sym_function_call,
  [sym_method_index_expression] = sym_method_index_expression,
  [sym_arguments] = sym_arguments,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_table_constructor] = sym_table_constructor,
  [sym__field_list] = sym__field_list,
  [sym__field_sep] = sym__field_sep,
  [sym_field] = sym_field,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_comment] = sym_comment,
  [sym_update_statement] = sym_update_statement,
  [sym_type_definition] = sym_type_definition,
  [sym_generic_type_list] = sym_generic_type_list,
  [sym_parameter] = sym_parameter,
  [sym_type] = sym_type,
  [sym_builtin_type] = sym_builtin_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_function_type] = sym_function_type,
  [sym_generic_type] = sym_generic_type,
  [sym_object_type] = sym_object_type,
  [sym_empty_type] = sym_empty_type,
  [sym_field_type] = sym_field_type,
  [sym_object_field_type] = sym_object_field_type,
  [sym_union_type] = sym_union_type,
  [sym_intersection_type] = sym_intersection_type,
  [sym_optional_type] = sym_optional_type,
  [sym_literal_type] = sym_literal_type,
  [sym_variadic_type] = sym_variadic_type,
  [sym_cast_expression] = sym_cast_expression,
  [sym_if_expression] = sym_if_expression,
  [sym_elseif_clause] = sym_elseif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym__interpolated_string] = sym__interpolated_string,
  [sym__interpolation_string_content] = sym__block_string_content,
  [sym__escape_sequence] = sym__escape_sequence,
  [sym_interpolation] = sym_interpolation,
  [aux_sym_chunk_repeat1] = aux_sym_chunk_repeat1,
  [aux_sym__variable_assignment_varlist_repeat1] = aux_sym__variable_assignment_varlist_repeat1,
  [aux_sym__variable_assignment_explist_repeat1] = aux_sym__variable_assignment_explist_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym__name_list_repeat1] = aux_sym__name_list_repeat1,
  [aux_sym__att_name_list_repeat1] = aux_sym__att_name_list_repeat1,
  [aux_sym__expression_list_repeat1] = aux_sym__expression_list_repeat1,
  [aux_sym__parameter_list_repeat1] = aux_sym__parameter_list_repeat1,
  [aux_sym__field_list_repeat1] = aux_sym__field_list_repeat1,
  [aux_sym_generic_type_list_repeat1] = aux_sym_generic_type_list_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_function_type_repeat1] = aux_sym_function_type_repeat1,
  [aux_sym_object_type_repeat1] = aux_sym_object_type_repeat1,
  [aux_sym_field_type_repeat1] = aux_sym_field_type_repeat1,
  [aux_sym_if_expression_repeat1] = aux_sym_if_expression_repeat1,
  [aux_sym__interpolated_string_repeat1] = aux_sym__interpolated_string_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_repeat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elseif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__doublequote_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__singlequote_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_comment_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thread] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_buffer] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_userdata] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unknown] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_never] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_table] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__interpolation_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__block_comment_start] = {
    .visible = true,
    .named = false,
  },
  [sym__block_comment_content] = {
    .visible = true,
    .named = true,
  },
  [sym__block_comment_end] = {
    .visible = true,
    .named = false,
  },
  [sym__block_string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__block_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__block_string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_chunk] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = true,
    .named = true,
  },
  [sym_statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_varlist] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_assignment_explist] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_else_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_generic_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_numeric_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__function_name_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__function_name_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__local_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__name_list] = {
    .visible = true,
    .named = true,
  },
  [sym__att_name_list] = {
    .visible = true,
    .named = true,
  },
  [sym__attrib] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__quote_string] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__doublequote_string_content] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__singlequote_string_content] = {
    .visible = false,
    .named = false,
  },
  [sym__block_string] = {
    .visible = false,
    .named = true,
  },
  [sym_vararg_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_bracket_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_dot_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_table_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__field_list] = {
    .visible = false,
    .named = true,
  },
  [sym__field_sep] = {
    .visible = false,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_update_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_type_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_type] = {
    .visible = true,
    .named = true,
  },
  [sym_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_object_field_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__interpolated_string] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolation_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_chunk_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_varlist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__variable_assignment_explist_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__att_name_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__expression_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__field_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpolated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_alternative = 1,
  field_arguments = 2,
  field_attribute = 3,
  field_body = 4,
  field_clause = 5,
  field_condition = 6,
  field_consequence = 7,
  field_content = 8,
  field_end = 9,
  field_field = 10,
  field_left = 11,
  field_local_declaration = 12,
  field_method = 13,
  field_name = 14,
  field_operand = 15,
  field_parameters = 16,
  field_right = 17,
  field_start = 18,
  field_step = 19,
  field_table = 20,
  field_value = 21,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_alternative] = "alternative",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_clause] = "clause",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_content] = "content",
  [field_end] = "end",
  [field_field] = "field",
  [field_left] = "left",
  [field_local_declaration] = "local_declaration",
  [field_method] = "method",
  [field_name] = "name",
  [field_operand] = "operand",
  [field_parameters] = "parameters",
  [field_right] = "right",
  [field_start] = "start",
  [field_step] = "step",
  [field_table] = "table",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 4},
  [3] = {.index = 5, .length = 1},
  [4] = {.index = 6, .length = 1},
  [5] = {.index = 7, .length = 2},
  [6] = {.index = 9, .length = 3},
  [7] = {.index = 12, .length = 1},
  [8] = {.index = 13, .length = 2},
  [9] = {.index = 15, .length = 2},
  [10] = {.index = 17, .length = 2},
  [11] = {.index = 19, .length = 2},
  [12] = {.index = 21, .length = 2},
  [13] = {.index = 23, .length = 3},
  [14] = {.index = 26, .length = 2},
  [15] = {.index = 28, .length = 2},
  [16] = {.index = 30, .length = 1},
  [17] = {.index = 31, .length = 1},
  [18] = {.index = 32, .length = 1},
  [19] = {.index = 33, .length = 1},
  [20] = {.index = 34, .length = 1},
  [21] = {.index = 35, .length = 3},
  [22] = {.index = 38, .length = 2},
  [23] = {.index = 40, .length = 3},
  [24] = {.index = 43, .length = 2},
  [25] = {.index = 45, .length = 2},
  [26] = {.index = 47, .length = 2},
  [27] = {.index = 49, .length = 1},
  [28] = {.index = 50, .length = 2},
  [29] = {.index = 52, .length = 1},
  [30] = {.index = 23, .length = 3},
  [31] = {.index = 53, .length = 1},
  [32] = {.index = 54, .length = 2},
  [33] = {.index = 56, .length = 2},
  [34] = {.index = 58, .length = 1},
  [35] = {.index = 59, .length = 2},
  [36] = {.index = 61, .length = 1},
  [37] = {.index = 62, .length = 1},
  [38] = {.index = 63, .length = 1},
  [39] = {.index = 64, .length = 3},
  [40] = {.index = 67, .length = 4},
  [41] = {.index = 71, .length = 4},
  [42] = {.index = 75, .length = 3},
  [43] = {.index = 78, .length = 2},
  [44] = {.index = 80, .length = 2},
  [45] = {.index = 82, .length = 2},
  [46] = {.index = 84, .length = 1},
  [47] = {.index = 85, .length = 2},
  [48] = {.index = 87, .length = 2},
  [49] = {.index = 89, .length = 2},
  [50] = {.index = 91, .length = 2},
  [51] = {.index = 93, .length = 2},
  [52] = {.index = 95, .length = 2},
  [53] = {.index = 97, .length = 2},
  [54] = {.index = 99, .length = 2},
  [55] = {.index = 101, .length = 3},
  [56] = {.index = 104, .length = 1},
  [57] = {.index = 105, .length = 1},
  [58] = {.index = 106, .length = 2},
  [59] = {.index = 108, .length = 2},
  [60] = {.index = 110, .length = 3},
  [61] = {.index = 113, .length = 3},
  [62] = {.index = 116, .length = 3},
  [63] = {.index = 119, .length = 3},
  [64] = {.index = 122, .length = 4},
  [65] = {.index = 126, .length = 1},
  [66] = {.index = 127, .length = 2},
  [67] = {.index = 129, .length = 2},
  [68] = {.index = 131, .length = 4},
  [69] = {.index = 135, .length = 2},
  [70] = {.index = 137, .length = 2},
  [71] = {.index = 139, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_local_declaration, 0, .inherited = true},
  [1] =
    {field_body, 0, .inherited = true},
    {field_local_declaration, 0},
    {field_name, 0, .inherited = true},
    {field_parameters, 0, .inherited = true},
  [5] =
    {field_local_declaration, 0},
  [6] =
    {field_name, 0},
  [7] =
    {field_content, 1},
    {field_start, 0},
  [9] =
    {field_content, 0, .inherited = true},
    {field_end, 0, .inherited = true},
    {field_start, 0, .inherited = true},
  [12] =
    {field_content, 0, .inherited = true},
  [13] =
    {field_field, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [15] =
    {field_method, 0, .inherited = true},
    {field_table, 0, .inherited = true},
  [17] =
    {field_attribute, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [19] =
    {field_arguments, 1},
    {field_name, 0},
  [21] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [23] =
    {field_content, 1},
    {field_end, 2},
    {field_start, 0},
  [26] =
    {field_body, 1, .inherited = true},
    {field_parameters, 1, .inherited = true},
  [28] =
    {field_end, 1},
    {field_start, 0},
  [30] =
    {field_value, 0},
  [31] =
    {field_operand, 1},
  [32] =
    {field_content, 0},
  [33] =
    {field_body, 1},
  [34] =
    {field_condition, 2},
  [35] =
    {field_body, 2, .inherited = true},
    {field_name, 1},
    {field_parameters, 2, .inherited = true},
  [38] =
    {field_attribute, 1},
    {field_name, 0},
  [40] =
    {field_attribute, 1, .inherited = true},
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [43] =
    {field_name, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [45] =
    {field_field, 2},
    {field_table, 0},
  [47] =
    {field_method, 2},
    {field_table, 0},
  [49] =
    {field_name, 1},
  [50] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [52] =
    {field_parameters, 0},
  [53] =
    {field_content, 1, .inherited = true},
  [54] =
    {field_content, 0, .inherited = true},
    {field_content, 1, .inherited = true},
  [56] =
    {field_left, 0},
    {field_right, 2},
  [58] =
    {field_condition, 1},
  [59] =
    {field_body, 1},
    {field_condition, 3},
  [61] =
    {field_alternative, 0},
  [62] =
    {field_clause, 1},
  [63] =
    {field_name, 0, .inherited = true},
  [64] =
    {field_body, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 3, .inherited = true},
  [67] =
    {field_attribute, 1},
    {field_attribute, 2, .inherited = true},
    {field_name, 0},
    {field_name, 2, .inherited = true},
  [71] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [75] =
    {field_attribute, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [78] =
    {field_value, 0},
    {field_value, 1, .inherited = true},
  [80] =
    {field_condition, 1},
    {field_consequence, 3},
  [82] =
    {field_body, 1},
    {field_parameters, 0},
  [84] =
    {field_parameters, 1},
  [85] =
    {field_name, 0},
    {field_value, 2},
  [87] =
    {field_body, 3},
    {field_condition, 1},
  [89] =
    {field_alternative, 3},
    {field_condition, 1},
  [91] =
    {field_alternative, 3, .inherited = true},
    {field_condition, 1},
  [93] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [95] =
    {field_body, 3},
    {field_clause, 1},
  [97] =
    {field_attribute, 2},
    {field_name, 1},
  [99] =
    {field_attribute, 3},
    {field_name, 0},
  [101] =
    {field_attribute, 3, .inherited = true},
    {field_name, 0},
    {field_name, 3, .inherited = true},
  [104] =
    {field_name, 2},
  [105] =
    {field_value, 1},
  [106] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [108] =
    {field_body, 2},
    {field_parameters, 1},
  [110] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [113] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [116] =
    {field_alternative, 3, .inherited = true},
    {field_alternative, 4},
    {field_condition, 1},
  [119] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
  [122] =
    {field_attribute, 3},
    {field_attribute, 4, .inherited = true},
    {field_name, 0},
    {field_name, 4, .inherited = true},
  [126] =
    {field_consequence, 1},
  [127] =
    {field_body, 3},
    {field_parameters, 0},
  [129] =
    {field_name, 1},
    {field_value, 4},
  [131] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [135] =
    {field_attribute, 4},
    {field_name, 1},
  [137] =
    {field_body, 4},
    {field_parameters, 1},
  [139] =
    {field_end, 4},
    {field_name, 0},
    {field_start, 2},
    {field_step, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [30] = {
    [1] = sym__block_string_content,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym__doublequote_string_content, 2,
    aux_sym__doublequote_string_content,
    sym__block_string_content,
  aux_sym__singlequote_string_content, 2,
    aux_sym__singlequote_string_content,
    sym__block_string_content,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 15,
  [32] = 32,
  [33] = 33,
  [34] = 17,
  [35] = 12,
  [36] = 36,
  [37] = 16,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 14,
  [58] = 19,
  [59] = 20,
  [60] = 10,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 21,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 18,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 85,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 105,
  [110] = 69,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 113,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 125,
  [129] = 120,
  [130] = 122,
  [131] = 123,
  [132] = 124,
  [133] = 127,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 152,
  [168] = 168,
  [169] = 159,
  [170] = 168,
  [171] = 171,
  [172] = 157,
  [173] = 134,
  [174] = 144,
  [175] = 154,
  [176] = 158,
  [177] = 160,
  [178] = 164,
  [179] = 165,
  [180] = 166,
  [181] = 181,
  [182] = 156,
  [183] = 183,
  [184] = 184,
  [185] = 184,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 207,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 292,
  [293] = 293,
  [294] = 294,
  [295] = 295,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 305,
  [308] = 308,
  [309] = 308,
  [310] = 310,
  [311] = 308,
  [312] = 305,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 317,
  [318] = 315,
  [319] = 319,
  [320] = 320,
  [321] = 313,
  [322] = 24,
  [323] = 23,
  [324] = 22,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 26,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 25,
  [337] = 27,
  [338] = 338,
  [339] = 339,
  [340] = 28,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 344,
  [347] = 339,
  [348] = 335,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 351,
  [353] = 333,
  [354] = 354,
  [355] = 342,
  [356] = 326,
  [357] = 325,
  [358] = 14,
  [359] = 334,
  [360] = 39,
  [361] = 40,
  [362] = 41,
  [363] = 42,
  [364] = 43,
  [365] = 44,
  [366] = 45,
  [367] = 367,
  [368] = 46,
  [369] = 47,
  [370] = 48,
  [371] = 49,
  [372] = 372,
  [373] = 50,
  [374] = 51,
  [375] = 53,
  [376] = 52,
  [377] = 377,
  [378] = 38,
  [379] = 16,
  [380] = 17,
  [381] = 12,
  [382] = 19,
  [383] = 20,
  [384] = 10,
  [385] = 385,
  [386] = 54,
  [387] = 387,
  [388] = 56,
  [389] = 55,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 30,
  [396] = 396,
  [397] = 61,
  [398] = 32,
  [399] = 399,
  [400] = 33,
  [401] = 29,
  [402] = 402,
  [403] = 403,
  [404] = 15,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 419,
  [420] = 420,
  [421] = 421,
  [422] = 405,
  [423] = 423,
  [424] = 424,
  [425] = 405,
  [426] = 424,
  [427] = 427,
  [428] = 428,
  [429] = 427,
  [430] = 421,
  [431] = 431,
  [432] = 424,
  [433] = 427,
  [434] = 428,
  [435] = 435,
  [436] = 428,
  [437] = 431,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 452,
  [454] = 443,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 442,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 456,
  [463] = 463,
  [464] = 408,
  [465] = 465,
  [466] = 466,
  [467] = 440,
  [468] = 468,
  [469] = 446,
  [470] = 470,
  [471] = 445,
  [472] = 472,
  [473] = 465,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 68,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 495,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 501,
  [513] = 513,
  [514] = 502,
  [515] = 515,
  [516] = 516,
  [517] = 498,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 508,
  [524] = 524,
  [525] = 525,
  [526] = 484,
  [527] = 490,
  [528] = 513,
  [529] = 524,
  [530] = 530,
  [531] = 531,
  [532] = 502,
  [533] = 533,
  [534] = 534,
  [535] = 535,
  [536] = 530,
  [537] = 537,
  [538] = 538,
  [539] = 539,
  [540] = 540,
  [541] = 541,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 510,
  [547] = 547,
  [548] = 548,
  [549] = 530,
  [550] = 521,
  [551] = 545,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(38);
      ADVANCE_MAP(
        '"', 63,
        '#', 103,
        '%', 98,
        '&', 120,
        '\'', 64,
        '(', 76,
        ')', 77,
        '*', 92,
        '+', 87,
        ',', 43,
        '-', 89,
        '.', 46,
        '/', 93,
        '0', 55,
        ':', 50,
        ';', 40,
        '<', 52,
        '=', 42,
        '>', 54,
        '?', 121,
        '[', 78,
        '\\', 16,
        ']', 79,
        '^', 102,
        '`', 122,
        '{', 80,
        '|', 119,
        '}', 81,
        '~', 13,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(56);
      if (lookahead > ' ' &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '"', 63,
        '%', 9,
        '&', 120,
        '\'', 64,
        '(', 76,
        '*', 10,
        '+', 11,
        ',', 43,
        '-', 4,
        '.', 48,
        '/', 8,
        ':', 49,
        '<', 51,
        '=', 41,
        '>', 53,
        '?', 121,
        '[', 78,
        '^', 12,
        '`', 122,
        '{', 80,
        '|', 119,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(63);
      if (lookahead == '-') ADVANCE(66);
      if (lookahead == '\\') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(65);
      if (lookahead != 0) ADVANCE(67);
      END_STATE();
    case 3:
      if (lookahead == '\'') ADVANCE(64);
      if (lookahead == '-') ADVANCE(69);
      if (lookahead == '\\') ADVANCE(17);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(68);
      if (lookahead != 0) ADVANCE(70);
      END_STATE();
    case 4:
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 5:
      if (lookahead == '-') ADVANCE(124);
      if (lookahead == '\\') ADVANCE(16);
      if (lookahead == '`') ADVANCE(122);
      if (lookahead == '{') ADVANCE(80);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(123);
      if (lookahead != 0) ADVANCE(125);
      END_STATE();
    case 6:
      if (lookahead == '.') ADVANCE(7);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 7:
      if (lookahead == '.') ADVANCE(75);
      END_STATE();
    case 8:
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 9:
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 10:
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 11:
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 12:
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 13:
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 14:
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 15:
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 16:
      if (lookahead == 'U') ADVANCE(74);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'x') ADVANCE(29);
      if (lookahead == '{') ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(73);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '?' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(71);
      if (lookahead != 0) ADVANCE(71);
      END_STATE();
    case 17:
      if (lookahead == 'U') ADVANCE(74);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'x') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(73);
      if (lookahead != 0) ADVANCE(71);
      END_STATE();
    case 18:
      if (lookahead == '{') ADVANCE(126);
      END_STATE();
    case 19:
      if (lookahead == '{') ADVANCE(26);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(28);
      END_STATE();
    case 20:
      if (lookahead == '}') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 22:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(61);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(62);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(71);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 26:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(20);
      END_STATE();
    case 27:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 28:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(29);
      END_STATE();
    case 29:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(24);
      END_STATE();
    case 30:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(28);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(30);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(32);
      END_STATE();
    case 34:
      if (eof) ADVANCE(38);
      ADVANCE_MAP(
        '"', 63,
        '#', 103,
        '%', 98,
        '&', 120,
        '\'', 64,
        '(', 76,
        ')', 77,
        '*', 92,
        '+', 87,
        ',', 43,
        '-', 89,
        '.', 46,
        '/', 93,
        '0', 55,
        ':', 50,
        ';', 40,
        '<', 52,
        '=', 42,
        '>', 54,
        '?', 121,
        '[', 78,
        '\\', 18,
        ']', 79,
        '^', 102,
        '`', 122,
        '{', 80,
        '|', 119,
        '}', 81,
        '~', 13,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(56);
      if (lookahead > ' ' &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 35:
      if (eof) ADVANCE(38);
      ADVANCE_MAP(
        '"', 63,
        '#', 103,
        '&', 120,
        '\'', 64,
        '(', 76,
        ')', 77,
        ',', 43,
        '-', 90,
        '.', 6,
        '0', 55,
        ';', 40,
        '>', 53,
        '?', 121,
        '[', 78,
        '`', 122,
        '{', 80,
        '|', 119,
        '}', 81,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(56);
      if (lookahead > ' ' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 36:
      if (eof) ADVANCE(38);
      ADVANCE_MAP(
        '"', 63,
        '#', 39,
        '%', 98,
        '&', 120,
        '\'', 64,
        '(', 76,
        ')', 77,
        '*', 92,
        '+', 87,
        ',', 43,
        '-', 88,
        '.', 45,
        '/', 93,
        ':', 50,
        ';', 40,
        '<', 52,
        '=', 42,
        '>', 54,
        '?', 121,
        '[', 78,
        ']', 79,
        '^', 102,
        '`', 122,
        '{', 80,
        '|', 119,
        '}', 81,
        '~', 13,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (lookahead > ' ' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 37:
      if (eof) ADVANCE(38);
      ADVANCE_MAP(
        '"', 63,
        '%', 97,
        '&', 120,
        '\'', 64,
        '(', 76,
        ')', 77,
        '*', 91,
        '+', 86,
        ',', 43,
        '-', 90,
        '.', 47,
        '/', 94,
        ':', 50,
        ';', 40,
        '<', 52,
        '=', 42,
        '>', 54,
        '?', 121,
        '[', 78,
        ']', 79,
        '^', 101,
        '`', 122,
        '{', 80,
        '|', 119,
        '}', 81,
        '~', 13,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(37);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(39);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(100);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(99);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(14);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(44);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(82);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(85);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(22);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(58);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(56);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(27);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(57);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(62);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(aux_sym__doublequote_string_content_token1);
      if (lookahead == '-') ADVANCE(66);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(67);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym__doublequote_string_content_token1);
      if (lookahead == '-') ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(67);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(aux_sym__doublequote_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(aux_sym__singlequote_string_content_token1);
      if (lookahead == '-') ADVANCE(69);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(70);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(aux_sym__singlequote_string_content_token1);
      if (lookahead == '-') ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(aux_sym__singlequote_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(70);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(71);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(72);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '=') ADVANCE(111);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(112);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(96);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(95);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '=') ADVANCE(117);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead > ' ' &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '?' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || 0x9f < lookahead)) ADVANCE(104);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(109);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == 0x0b ||
          lookahead == '\f' ||
          lookahead == ' ') ADVANCE(107);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(109);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead == '-') ADVANCE(106);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(109);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(aux_sym_comment_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(109);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(aux_sym__interpolation_string_content_token1);
      if (lookahead == '-') ADVANCE(124);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(123);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{') ADVANCE(125);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(aux_sym__interpolation_string_content_token1);
      if (lookahead == '-') ADVANCE(125);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{') ADVANCE(125);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym__interpolation_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\\' &&
          lookahead != '`' &&
          lookahead != '{') ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_BSLASH_LBRACE);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      ADVANCE_MAP(
        'a', 1,
        'b', 2,
        'c', 3,
        'd', 4,
        'e', 5,
        'f', 6,
        'g', 7,
        'i', 8,
        'l', 9,
        'n', 10,
        'o', 11,
        'r', 12,
        's', 13,
        't', 14,
        'u', 15,
        'w', 16,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'n') ADVANCE(17);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(18);
      if (lookahead == 'r') ADVANCE(19);
      if (lookahead == 'u') ADVANCE(20);
      END_STATE();
    case 3:
      if (lookahead == 'o') ADVANCE(21);
      END_STATE();
    case 4:
      if (lookahead == 'o') ADVANCE(22);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(23);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'x') ADVANCE(25);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(26);
      if (lookahead == 'o') ADVANCE(27);
      if (lookahead == 'u') ADVANCE(28);
      END_STATE();
    case 7:
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 9:
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(33);
      if (lookahead == 'i') ADVANCE(34);
      if (lookahead == 'o') ADVANCE(35);
      if (lookahead == 'u') ADVANCE(36);
      END_STATE();
    case 11:
      if (lookahead == 'r') ADVANCE(37);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(38);
      END_STATE();
    case 13:
      if (lookahead == 't') ADVANCE(39);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(40);
      if (lookahead == 'h') ADVANCE(41);
      if (lookahead == 'r') ADVANCE(42);
      if (lookahead == 'y') ADVANCE(43);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(44);
      if (lookahead == 's') ADVANCE(45);
      END_STATE();
    case 16:
      if (lookahead == 'h') ADVANCE(46);
      END_STATE();
    case 17:
      if (lookahead == 'd') ADVANCE(47);
      if (lookahead == 'y') ADVANCE(48);
      END_STATE();
    case 18:
      if (lookahead == 'o') ADVANCE(49);
      END_STATE();
    case 19:
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 20:
      if (lookahead == 'f') ADVANCE(51);
      END_STATE();
    case 21:
      if (lookahead == 'n') ADVANCE(52);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 23:
      if (lookahead == 's') ADVANCE(53);
      END_STATE();
    case 24:
      if (lookahead == 'd') ADVANCE(54);
      END_STATE();
    case 25:
      if (lookahead == 'p') ADVANCE(55);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(56);
      END_STATE();
    case 27:
      if (lookahead == 'r') ADVANCE(57);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(58);
      END_STATE();
    case 29:
      if (lookahead == 't') ADVANCE(59);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 32:
      if (lookahead == 'c') ADVANCE(60);
      END_STATE();
    case 33:
      if (lookahead == 'v') ADVANCE(61);
      END_STATE();
    case 34:
      if (lookahead == 'l') ADVANCE(62);
      END_STATE();
    case 35:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 36:
      if (lookahead == 'm') ADVANCE(64);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 38:
      if (lookahead == 'p') ADVANCE(65);
      if (lookahead == 't') ADVANCE(66);
      END_STATE();
    case 39:
      if (lookahead == 'r') ADVANCE(67);
      END_STATE();
    case 40:
      if (lookahead == 'b') ADVANCE(68);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(69);
      if (lookahead == 'r') ADVANCE(70);
      END_STATE();
    case 42:
      if (lookahead == 'u') ADVANCE(71);
      END_STATE();
    case 43:
      if (lookahead == 'p') ADVANCE(72);
      END_STATE();
    case 44:
      if (lookahead == 'k') ADVANCE(73);
      if (lookahead == 't') ADVANCE(74);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(75);
      END_STATE();
    case 46:
      if (lookahead == 'i') ADVANCE(76);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 49:
      if (lookahead == 'l') ADVANCE(77);
      END_STATE();
    case 50:
      if (lookahead == 'a') ADVANCE(78);
      END_STATE();
    case 51:
      if (lookahead == 'f') ADVANCE(79);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(80);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(81);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 55:
      if (lookahead == 'o') ADVANCE(82);
      END_STATE();
    case 56:
      if (lookahead == 's') ADVANCE(83);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 58:
      if (lookahead == 'c') ADVANCE(84);
      END_STATE();
    case 59:
      if (lookahead == 'o') ADVANCE(85);
      END_STATE();
    case 60:
      if (lookahead == 'a') ADVANCE(86);
      END_STATE();
    case 61:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 64:
      if (lookahead == 'b') ADVANCE(88);
      END_STATE();
    case 65:
      if (lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 66:
      if (lookahead == 'u') ADVANCE(90);
      END_STATE();
    case 67:
      if (lookahead == 'i') ADVANCE(91);
      END_STATE();
    case 68:
      if (lookahead == 'l') ADVANCE(92);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(94);
      END_STATE();
    case 71:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 72:
      if (lookahead == 'e') ADVANCE(96);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(98);
      END_STATE();
    case 75:
      if (lookahead == 'r') ADVANCE(99);
      END_STATE();
    case 76:
      if (lookahead == 'l') ADVANCE(100);
      END_STATE();
    case 77:
      if (lookahead == 'e') ADVANCE(101);
      END_STATE();
    case 78:
      if (lookahead == 'k') ADVANCE(102);
      END_STATE();
    case 79:
      if (lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 80:
      if (lookahead == 'i') ADVANCE(104);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == 'i') ADVANCE(105);
      END_STATE();
    case 82:
      if (lookahead == 'r') ADVANCE(106);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 84:
      if (lookahead == 't') ADVANCE(108);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(109);
      END_STATE();
    case 87:
      if (lookahead == 'r') ADVANCE(110);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 89:
      if (lookahead == 'a') ADVANCE(112);
      END_STATE();
    case 90:
      if (lookahead == 'r') ADVANCE(113);
      END_STATE();
    case 91:
      if (lookahead == 'n') ADVANCE(114);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(116);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(117);
      END_STATE();
    case 97:
      if (lookahead == 'o') ADVANCE(118);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 99:
      if (lookahead == 'd') ADVANCE(120);
      END_STATE();
    case 100:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 101:
      if (lookahead == 'a') ADVANCE(122);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_break_statement);
      END_STATE();
    case 103:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 104:
      if (lookahead == 'n') ADVANCE(124);
      END_STATE();
    case 105:
      if (lookahead == 'f') ADVANCE(125);
      END_STATE();
    case 106:
      if (lookahead == 't') ADVANCE(126);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 108:
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_never);
      END_STATE();
    case 111:
      if (lookahead == 'r') ADVANCE(128);
      END_STATE();
    case 112:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(130);
      END_STATE();
    case 114:
      if (lookahead == 'g') ADVANCE(131);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_table);
      END_STATE();
    case 116:
      if (lookahead == 'd') ADVANCE(132);
      END_STATE();
    case 117:
      if (lookahead == 'f') ADVANCE(133);
      END_STATE();
    case 118:
      if (lookahead == 'w') ADVANCE(134);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(135);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 122:
      if (lookahead == 'n') ADVANCE(136);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_buffer);
      END_STATE();
    case 124:
      if (lookahead == 'u') ADVANCE(137);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_elseif);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 127:
      if (lookahead == 'o') ADVANCE(138);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_repeat);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_thread);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 134:
      if (lookahead == 'n') ADVANCE(139);
      END_STATE();
    case 135:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 138:
      if (lookahead == 'n') ADVANCE(142);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_unknown);
      END_STATE();
    case 140:
      if (lookahead == 'a') ADVANCE(143);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_continue_statement);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_userdata);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 36, .external_lex_state = 2},
  [2] = {.lex_state = 36, .external_lex_state = 3},
  [3] = {.lex_state = 36, .external_lex_state = 3},
  [4] = {.lex_state = 36, .external_lex_state = 3},
  [5] = {.lex_state = 37, .external_lex_state = 3},
  [6] = {.lex_state = 37, .external_lex_state = 3},
  [7] = {.lex_state = 37, .external_lex_state = 3},
  [8] = {.lex_state = 37, .external_lex_state = 3},
  [9] = {.lex_state = 37, .external_lex_state = 3},
  [10] = {.lex_state = 37, .external_lex_state = 3},
  [11] = {.lex_state = 37, .external_lex_state = 3},
  [12] = {.lex_state = 37, .external_lex_state = 3},
  [13] = {.lex_state = 37, .external_lex_state = 3},
  [14] = {.lex_state = 37, .external_lex_state = 3},
  [15] = {.lex_state = 37, .external_lex_state = 3},
  [16] = {.lex_state = 37, .external_lex_state = 3},
  [17] = {.lex_state = 37, .external_lex_state = 3},
  [18] = {.lex_state = 37, .external_lex_state = 3},
  [19] = {.lex_state = 37, .external_lex_state = 3},
  [20] = {.lex_state = 37, .external_lex_state = 3},
  [21] = {.lex_state = 37, .external_lex_state = 3},
  [22] = {.lex_state = 37, .external_lex_state = 2},
  [23] = {.lex_state = 37, .external_lex_state = 2},
  [24] = {.lex_state = 37, .external_lex_state = 2},
  [25] = {.lex_state = 37, .external_lex_state = 2},
  [26] = {.lex_state = 37, .external_lex_state = 2},
  [27] = {.lex_state = 37, .external_lex_state = 2},
  [28] = {.lex_state = 37, .external_lex_state = 2},
  [29] = {.lex_state = 37, .external_lex_state = 2},
  [30] = {.lex_state = 37, .external_lex_state = 2},
  [31] = {.lex_state = 37, .external_lex_state = 2},
  [32] = {.lex_state = 37, .external_lex_state = 2},
  [33] = {.lex_state = 37, .external_lex_state = 2},
  [34] = {.lex_state = 37, .external_lex_state = 2},
  [35] = {.lex_state = 37, .external_lex_state = 2},
  [36] = {.lex_state = 0, .external_lex_state = 2},
  [37] = {.lex_state = 37, .external_lex_state = 2},
  [38] = {.lex_state = 37, .external_lex_state = 2},
  [39] = {.lex_state = 37, .external_lex_state = 2},
  [40] = {.lex_state = 37, .external_lex_state = 2},
  [41] = {.lex_state = 37, .external_lex_state = 2},
  [42] = {.lex_state = 37, .external_lex_state = 2},
  [43] = {.lex_state = 37, .external_lex_state = 2},
  [44] = {.lex_state = 37, .external_lex_state = 2},
  [45] = {.lex_state = 37, .external_lex_state = 2},
  [46] = {.lex_state = 37, .external_lex_state = 2},
  [47] = {.lex_state = 37, .external_lex_state = 2},
  [48] = {.lex_state = 37, .external_lex_state = 2},
  [49] = {.lex_state = 37, .external_lex_state = 2},
  [50] = {.lex_state = 37, .external_lex_state = 2},
  [51] = {.lex_state = 37, .external_lex_state = 2},
  [52] = {.lex_state = 37, .external_lex_state = 2},
  [53] = {.lex_state = 37, .external_lex_state = 2},
  [54] = {.lex_state = 37, .external_lex_state = 2},
  [55] = {.lex_state = 37, .external_lex_state = 2},
  [56] = {.lex_state = 37, .external_lex_state = 2},
  [57] = {.lex_state = 37, .external_lex_state = 2},
  [58] = {.lex_state = 37, .external_lex_state = 2},
  [59] = {.lex_state = 37, .external_lex_state = 2},
  [60] = {.lex_state = 37, .external_lex_state = 2},
  [61] = {.lex_state = 37, .external_lex_state = 2},
  [62] = {.lex_state = 37, .external_lex_state = 2},
  [63] = {.lex_state = 37, .external_lex_state = 2},
  [64] = {.lex_state = 37, .external_lex_state = 2},
  [65] = {.lex_state = 0, .external_lex_state = 2},
  [66] = {.lex_state = 37, .external_lex_state = 2},
  [67] = {.lex_state = 0, .external_lex_state = 2},
  [68] = {.lex_state = 37, .external_lex_state = 2},
  [69] = {.lex_state = 35, .external_lex_state = 3},
  [70] = {.lex_state = 0, .external_lex_state = 2},
  [71] = {.lex_state = 0, .external_lex_state = 2},
  [72] = {.lex_state = 0, .external_lex_state = 2},
  [73] = {.lex_state = 37, .external_lex_state = 2},
  [74] = {.lex_state = 37, .external_lex_state = 2},
  [75] = {.lex_state = 37, .external_lex_state = 2},
  [76] = {.lex_state = 0, .external_lex_state = 2},
  [77] = {.lex_state = 37, .external_lex_state = 2},
  [78] = {.lex_state = 37, .external_lex_state = 2},
  [79] = {.lex_state = 37, .external_lex_state = 2},
  [80] = {.lex_state = 37, .external_lex_state = 2},
  [81] = {.lex_state = 37, .external_lex_state = 2},
  [82] = {.lex_state = 37, .external_lex_state = 2},
  [83] = {.lex_state = 37, .external_lex_state = 2},
  [84] = {.lex_state = 37, .external_lex_state = 2},
  [85] = {.lex_state = 35, .external_lex_state = 3},
  [86] = {.lex_state = 37, .external_lex_state = 2},
  [87] = {.lex_state = 37, .external_lex_state = 2},
  [88] = {.lex_state = 37, .external_lex_state = 2},
  [89] = {.lex_state = 37, .external_lex_state = 2},
  [90] = {.lex_state = 37, .external_lex_state = 2},
  [91] = {.lex_state = 37, .external_lex_state = 2},
  [92] = {.lex_state = 37, .external_lex_state = 2},
  [93] = {.lex_state = 37, .external_lex_state = 2},
  [94] = {.lex_state = 0, .external_lex_state = 2},
  [95] = {.lex_state = 37, .external_lex_state = 2},
  [96] = {.lex_state = 37, .external_lex_state = 2},
  [97] = {.lex_state = 37, .external_lex_state = 2},
  [98] = {.lex_state = 37, .external_lex_state = 2},
  [99] = {.lex_state = 37, .external_lex_state = 2},
  [100] = {.lex_state = 37, .external_lex_state = 2},
  [101] = {.lex_state = 37, .external_lex_state = 2},
  [102] = {.lex_state = 35, .external_lex_state = 3},
  [103] = {.lex_state = 0, .external_lex_state = 2},
  [104] = {.lex_state = 0, .external_lex_state = 2},
  [105] = {.lex_state = 35, .external_lex_state = 3},
  [106] = {.lex_state = 0, .external_lex_state = 2},
  [107] = {.lex_state = 0, .external_lex_state = 2},
  [108] = {.lex_state = 0, .external_lex_state = 2},
  [109] = {.lex_state = 35, .external_lex_state = 3},
  [110] = {.lex_state = 35, .external_lex_state = 3},
  [111] = {.lex_state = 0, .external_lex_state = 2},
  [112] = {.lex_state = 35, .external_lex_state = 3},
  [113] = {.lex_state = 35, .external_lex_state = 3},
  [114] = {.lex_state = 0, .external_lex_state = 2},
  [115] = {.lex_state = 35, .external_lex_state = 3},
  [116] = {.lex_state = 0, .external_lex_state = 2},
  [117] = {.lex_state = 35, .external_lex_state = 3},
  [118] = {.lex_state = 35, .external_lex_state = 3},
  [119] = {.lex_state = 35, .external_lex_state = 3},
  [120] = {.lex_state = 35, .external_lex_state = 3},
  [121] = {.lex_state = 37, .external_lex_state = 2},
  [122] = {.lex_state = 35, .external_lex_state = 3},
  [123] = {.lex_state = 35, .external_lex_state = 3},
  [124] = {.lex_state = 35, .external_lex_state = 3},
  [125] = {.lex_state = 35, .external_lex_state = 3},
  [126] = {.lex_state = 35, .external_lex_state = 3},
  [127] = {.lex_state = 35, .external_lex_state = 3},
  [128] = {.lex_state = 35, .external_lex_state = 3},
  [129] = {.lex_state = 35, .external_lex_state = 3},
  [130] = {.lex_state = 35, .external_lex_state = 3},
  [131] = {.lex_state = 35, .external_lex_state = 3},
  [132] = {.lex_state = 35, .external_lex_state = 3},
  [133] = {.lex_state = 35, .external_lex_state = 3},
  [134] = {.lex_state = 35, .external_lex_state = 3},
  [135] = {.lex_state = 35, .external_lex_state = 3},
  [136] = {.lex_state = 35, .external_lex_state = 3},
  [137] = {.lex_state = 35, .external_lex_state = 3},
  [138] = {.lex_state = 35, .external_lex_state = 3},
  [139] = {.lex_state = 35, .external_lex_state = 3},
  [140] = {.lex_state = 35, .external_lex_state = 3},
  [141] = {.lex_state = 35, .external_lex_state = 3},
  [142] = {.lex_state = 35, .external_lex_state = 3},
  [143] = {.lex_state = 35, .external_lex_state = 3},
  [144] = {.lex_state = 35, .external_lex_state = 3},
  [145] = {.lex_state = 35, .external_lex_state = 3},
  [146] = {.lex_state = 35, .external_lex_state = 3},
  [147] = {.lex_state = 35, .external_lex_state = 3},
  [148] = {.lex_state = 37, .external_lex_state = 2},
  [149] = {.lex_state = 35, .external_lex_state = 3},
  [150] = {.lex_state = 35, .external_lex_state = 3},
  [151] = {.lex_state = 35, .external_lex_state = 3},
  [152] = {.lex_state = 35, .external_lex_state = 3},
  [153] = {.lex_state = 35, .external_lex_state = 3},
  [154] = {.lex_state = 35, .external_lex_state = 3},
  [155] = {.lex_state = 35, .external_lex_state = 3},
  [156] = {.lex_state = 35, .external_lex_state = 3},
  [157] = {.lex_state = 35, .external_lex_state = 3},
  [158] = {.lex_state = 35, .external_lex_state = 3},
  [159] = {.lex_state = 35, .external_lex_state = 3},
  [160] = {.lex_state = 35, .external_lex_state = 3},
  [161] = {.lex_state = 35, .external_lex_state = 3},
  [162] = {.lex_state = 35, .external_lex_state = 3},
  [163] = {.lex_state = 35, .external_lex_state = 3},
  [164] = {.lex_state = 35, .external_lex_state = 3},
  [165] = {.lex_state = 35, .external_lex_state = 3},
  [166] = {.lex_state = 35, .external_lex_state = 3},
  [167] = {.lex_state = 35, .external_lex_state = 3},
  [168] = {.lex_state = 35, .external_lex_state = 3},
  [169] = {.lex_state = 35, .external_lex_state = 3},
  [170] = {.lex_state = 35, .external_lex_state = 3},
  [171] = {.lex_state = 35, .external_lex_state = 3},
  [172] = {.lex_state = 35, .external_lex_state = 3},
  [173] = {.lex_state = 35, .external_lex_state = 3},
  [174] = {.lex_state = 35, .external_lex_state = 3},
  [175] = {.lex_state = 35, .external_lex_state = 3},
  [176] = {.lex_state = 35, .external_lex_state = 3},
  [177] = {.lex_state = 35, .external_lex_state = 3},
  [178] = {.lex_state = 35, .external_lex_state = 3},
  [179] = {.lex_state = 35, .external_lex_state = 3},
  [180] = {.lex_state = 35, .external_lex_state = 3},
  [181] = {.lex_state = 35, .external_lex_state = 3},
  [182] = {.lex_state = 35, .external_lex_state = 3},
  [183] = {.lex_state = 35, .external_lex_state = 3},
  [184] = {.lex_state = 35, .external_lex_state = 3},
  [185] = {.lex_state = 35, .external_lex_state = 3},
  [186] = {.lex_state = 35, .external_lex_state = 3},
  [187] = {.lex_state = 35, .external_lex_state = 3},
  [188] = {.lex_state = 35, .external_lex_state = 3},
  [189] = {.lex_state = 35, .external_lex_state = 3},
  [190] = {.lex_state = 35, .external_lex_state = 3},
  [191] = {.lex_state = 35, .external_lex_state = 3},
  [192] = {.lex_state = 37, .external_lex_state = 2},
  [193] = {.lex_state = 35, .external_lex_state = 3},
  [194] = {.lex_state = 35, .external_lex_state = 3},
  [195] = {.lex_state = 35, .external_lex_state = 3},
  [196] = {.lex_state = 35, .external_lex_state = 3},
  [197] = {.lex_state = 35, .external_lex_state = 3},
  [198] = {.lex_state = 35, .external_lex_state = 3},
  [199] = {.lex_state = 35, .external_lex_state = 3},
  [200] = {.lex_state = 35, .external_lex_state = 3},
  [201] = {.lex_state = 35, .external_lex_state = 3},
  [202] = {.lex_state = 35, .external_lex_state = 3},
  [203] = {.lex_state = 35, .external_lex_state = 3},
  [204] = {.lex_state = 35, .external_lex_state = 3},
  [205] = {.lex_state = 35, .external_lex_state = 3},
  [206] = {.lex_state = 37, .external_lex_state = 2},
  [207] = {.lex_state = 35, .external_lex_state = 3},
  [208] = {.lex_state = 35, .external_lex_state = 3},
  [209] = {.lex_state = 35, .external_lex_state = 3},
  [210] = {.lex_state = 35, .external_lex_state = 3},
  [211] = {.lex_state = 35, .external_lex_state = 3},
  [212] = {.lex_state = 35, .external_lex_state = 3},
  [213] = {.lex_state = 35, .external_lex_state = 3},
  [214] = {.lex_state = 35, .external_lex_state = 3},
  [215] = {.lex_state = 35, .external_lex_state = 3},
  [216] = {.lex_state = 35, .external_lex_state = 3},
  [217] = {.lex_state = 35, .external_lex_state = 3},
  [218] = {.lex_state = 35, .external_lex_state = 3},
  [219] = {.lex_state = 37, .external_lex_state = 3},
  [220] = {.lex_state = 36, .external_lex_state = 3},
  [221] = {.lex_state = 0, .external_lex_state = 2},
  [222] = {.lex_state = 0, .external_lex_state = 2},
  [223] = {.lex_state = 37, .external_lex_state = 2},
  [224] = {.lex_state = 0, .external_lex_state = 2},
  [225] = {.lex_state = 37, .external_lex_state = 2},
  [226] = {.lex_state = 0, .external_lex_state = 2},
  [227] = {.lex_state = 0, .external_lex_state = 2},
  [228] = {.lex_state = 0, .external_lex_state = 2},
  [229] = {.lex_state = 0, .external_lex_state = 2},
  [230] = {.lex_state = 0, .external_lex_state = 2},
  [231] = {.lex_state = 0, .external_lex_state = 2},
  [232] = {.lex_state = 0, .external_lex_state = 2},
  [233] = {.lex_state = 0, .external_lex_state = 2},
  [234] = {.lex_state = 0, .external_lex_state = 2},
  [235] = {.lex_state = 0, .external_lex_state = 2},
  [236] = {.lex_state = 0, .external_lex_state = 2},
  [237] = {.lex_state = 0, .external_lex_state = 2},
  [238] = {.lex_state = 0, .external_lex_state = 2},
  [239] = {.lex_state = 0, .external_lex_state = 2},
  [240] = {.lex_state = 0, .external_lex_state = 2},
  [241] = {.lex_state = 0, .external_lex_state = 2},
  [242] = {.lex_state = 0, .external_lex_state = 2},
  [243] = {.lex_state = 0, .external_lex_state = 2},
  [244] = {.lex_state = 0, .external_lex_state = 2},
  [245] = {.lex_state = 0, .external_lex_state = 2},
  [246] = {.lex_state = 37, .external_lex_state = 2},
  [247] = {.lex_state = 0, .external_lex_state = 2},
  [248] = {.lex_state = 0, .external_lex_state = 2},
  [249] = {.lex_state = 0, .external_lex_state = 2},
  [250] = {.lex_state = 0, .external_lex_state = 2},
  [251] = {.lex_state = 37, .external_lex_state = 2},
  [252] = {.lex_state = 0, .external_lex_state = 2},
  [253] = {.lex_state = 0, .external_lex_state = 2},
  [254] = {.lex_state = 0, .external_lex_state = 2},
  [255] = {.lex_state = 0, .external_lex_state = 2},
  [256] = {.lex_state = 0, .external_lex_state = 2},
  [257] = {.lex_state = 1, .external_lex_state = 3},
  [258] = {.lex_state = 0, .external_lex_state = 2},
  [259] = {.lex_state = 0, .external_lex_state = 2},
  [260] = {.lex_state = 0, .external_lex_state = 2},
  [261] = {.lex_state = 0, .external_lex_state = 2},
  [262] = {.lex_state = 0, .external_lex_state = 2},
  [263] = {.lex_state = 0, .external_lex_state = 2},
  [264] = {.lex_state = 0, .external_lex_state = 2},
  [265] = {.lex_state = 0, .external_lex_state = 2},
  [266] = {.lex_state = 37, .external_lex_state = 2},
  [267] = {.lex_state = 0, .external_lex_state = 2},
  [268] = {.lex_state = 0, .external_lex_state = 2},
  [269] = {.lex_state = 0, .external_lex_state = 2},
  [270] = {.lex_state = 0, .external_lex_state = 2},
  [271] = {.lex_state = 0, .external_lex_state = 2},
  [272] = {.lex_state = 0, .external_lex_state = 2},
  [273] = {.lex_state = 0, .external_lex_state = 2},
  [274] = {.lex_state = 0, .external_lex_state = 2},
  [275] = {.lex_state = 0, .external_lex_state = 2},
  [276] = {.lex_state = 37, .external_lex_state = 2},
  [277] = {.lex_state = 0, .external_lex_state = 2},
  [278] = {.lex_state = 0, .external_lex_state = 2},
  [279] = {.lex_state = 0, .external_lex_state = 2},
  [280] = {.lex_state = 0, .external_lex_state = 2},
  [281] = {.lex_state = 0, .external_lex_state = 2},
  [282] = {.lex_state = 0, .external_lex_state = 2},
  [283] = {.lex_state = 37, .external_lex_state = 2},
  [284] = {.lex_state = 1, .external_lex_state = 3},
  [285] = {.lex_state = 35, .external_lex_state = 3},
  [286] = {.lex_state = 37, .external_lex_state = 2},
  [287] = {.lex_state = 37, .external_lex_state = 2},
  [288] = {.lex_state = 37, .external_lex_state = 2},
  [289] = {.lex_state = 37, .external_lex_state = 2},
  [290] = {.lex_state = 37, .external_lex_state = 2},
  [291] = {.lex_state = 37, .external_lex_state = 2},
  [292] = {.lex_state = 37, .external_lex_state = 2},
  [293] = {.lex_state = 37, .external_lex_state = 2},
  [294] = {.lex_state = 37, .external_lex_state = 2},
  [295] = {.lex_state = 37, .external_lex_state = 2},
  [296] = {.lex_state = 37, .external_lex_state = 2},
  [297] = {.lex_state = 37, .external_lex_state = 2},
  [298] = {.lex_state = 37, .external_lex_state = 2},
  [299] = {.lex_state = 0, .external_lex_state = 2},
  [300] = {.lex_state = 0, .external_lex_state = 2},
  [301] = {.lex_state = 36, .external_lex_state = 3},
  [302] = {.lex_state = 0, .external_lex_state = 3},
  [303] = {.lex_state = 1, .external_lex_state = 2},
  [304] = {.lex_state = 1, .external_lex_state = 2},
  [305] = {.lex_state = 5, .external_lex_state = 2},
  [306] = {.lex_state = 5, .external_lex_state = 2},
  [307] = {.lex_state = 5, .external_lex_state = 2},
  [308] = {.lex_state = 5, .external_lex_state = 2},
  [309] = {.lex_state = 5, .external_lex_state = 2},
  [310] = {.lex_state = 0, .external_lex_state = 2},
  [311] = {.lex_state = 5, .external_lex_state = 2},
  [312] = {.lex_state = 5, .external_lex_state = 2},
  [313] = {.lex_state = 36, .external_lex_state = 2},
  [314] = {.lex_state = 36, .external_lex_state = 3},
  [315] = {.lex_state = 36, .external_lex_state = 2},
  [316] = {.lex_state = 1, .external_lex_state = 2},
  [317] = {.lex_state = 0, .external_lex_state = 2},
  [318] = {.lex_state = 36, .external_lex_state = 2},
  [319] = {.lex_state = 0, .external_lex_state = 2},
  [320] = {.lex_state = 36, .external_lex_state = 2},
  [321] = {.lex_state = 36, .external_lex_state = 2},
  [322] = {.lex_state = 1, .external_lex_state = 2},
  [323] = {.lex_state = 1, .external_lex_state = 2},
  [324] = {.lex_state = 1, .external_lex_state = 2},
  [325] = {.lex_state = 0, .external_lex_state = 2},
  [326] = {.lex_state = 0, .external_lex_state = 2},
  [327] = {.lex_state = 0, .external_lex_state = 2},
  [328] = {.lex_state = 5, .external_lex_state = 2},
  [329] = {.lex_state = 5, .external_lex_state = 2},
  [330] = {.lex_state = 5, .external_lex_state = 2},
  [331] = {.lex_state = 5, .external_lex_state = 2},
  [332] = {.lex_state = 35, .external_lex_state = 2},
  [333] = {.lex_state = 0, .external_lex_state = 2},
  [334] = {.lex_state = 0, .external_lex_state = 2},
  [335] = {.lex_state = 0, .external_lex_state = 2},
  [336] = {.lex_state = 35, .external_lex_state = 2},
  [337] = {.lex_state = 1, .external_lex_state = 2},
  [338] = {.lex_state = 5, .external_lex_state = 2},
  [339] = {.lex_state = 35, .external_lex_state = 2},
  [340] = {.lex_state = 35, .external_lex_state = 2},
  [341] = {.lex_state = 35, .external_lex_state = 2},
  [342] = {.lex_state = 0, .external_lex_state = 2},
  [343] = {.lex_state = 5, .external_lex_state = 2},
  [344] = {.lex_state = 0, .external_lex_state = 2},
  [345] = {.lex_state = 0, .external_lex_state = 3},
  [346] = {.lex_state = 0, .external_lex_state = 2},
  [347] = {.lex_state = 35, .external_lex_state = 2},
  [348] = {.lex_state = 0, .external_lex_state = 2},
  [349] = {.lex_state = 0, .external_lex_state = 2},
  [350] = {.lex_state = 0, .external_lex_state = 2},
  [351] = {.lex_state = 0, .external_lex_state = 2},
  [352] = {.lex_state = 0, .external_lex_state = 2},
  [353] = {.lex_state = 0, .external_lex_state = 2},
  [354] = {.lex_state = 0, .external_lex_state = 2},
  [355] = {.lex_state = 0, .external_lex_state = 2},
  [356] = {.lex_state = 0, .external_lex_state = 2},
  [357] = {.lex_state = 0, .external_lex_state = 2},
  [358] = {.lex_state = 35, .external_lex_state = 2},
  [359] = {.lex_state = 35, .external_lex_state = 2},
  [360] = {.lex_state = 35, .external_lex_state = 2},
  [361] = {.lex_state = 35, .external_lex_state = 2},
  [362] = {.lex_state = 35, .external_lex_state = 2},
  [363] = {.lex_state = 35, .external_lex_state = 2},
  [364] = {.lex_state = 35, .external_lex_state = 2},
  [365] = {.lex_state = 35, .external_lex_state = 2},
  [366] = {.lex_state = 35, .external_lex_state = 2},
  [367] = {.lex_state = 0, .external_lex_state = 2},
  [368] = {.lex_state = 35, .external_lex_state = 2},
  [369] = {.lex_state = 35, .external_lex_state = 2},
  [370] = {.lex_state = 35, .external_lex_state = 2},
  [371] = {.lex_state = 35, .external_lex_state = 2},
  [372] = {.lex_state = 0, .external_lex_state = 2},
  [373] = {.lex_state = 35, .external_lex_state = 2},
  [374] = {.lex_state = 35, .external_lex_state = 2},
  [375] = {.lex_state = 35, .external_lex_state = 2},
  [376] = {.lex_state = 35, .external_lex_state = 2},
  [377] = {.lex_state = 0, .external_lex_state = 2},
  [378] = {.lex_state = 35, .external_lex_state = 2},
  [379] = {.lex_state = 35, .external_lex_state = 2},
  [380] = {.lex_state = 35, .external_lex_state = 2},
  [381] = {.lex_state = 35, .external_lex_state = 2},
  [382] = {.lex_state = 35, .external_lex_state = 2},
  [383] = {.lex_state = 35, .external_lex_state = 2},
  [384] = {.lex_state = 35, .external_lex_state = 2},
  [385] = {.lex_state = 35, .external_lex_state = 2},
  [386] = {.lex_state = 35, .external_lex_state = 2},
  [387] = {.lex_state = 0, .external_lex_state = 2},
  [388] = {.lex_state = 35, .external_lex_state = 2},
  [389] = {.lex_state = 35, .external_lex_state = 2},
  [390] = {.lex_state = 0, .external_lex_state = 2},
  [391] = {.lex_state = 0, .external_lex_state = 2},
  [392] = {.lex_state = 0, .external_lex_state = 2},
  [393] = {.lex_state = 0, .external_lex_state = 2},
  [394] = {.lex_state = 0, .external_lex_state = 2},
  [395] = {.lex_state = 35, .external_lex_state = 2},
  [396] = {.lex_state = 0, .external_lex_state = 2},
  [397] = {.lex_state = 35, .external_lex_state = 2},
  [398] = {.lex_state = 35, .external_lex_state = 2},
  [399] = {.lex_state = 0, .external_lex_state = 2},
  [400] = {.lex_state = 35, .external_lex_state = 2},
  [401] = {.lex_state = 35, .external_lex_state = 2},
  [402] = {.lex_state = 0, .external_lex_state = 2},
  [403] = {.lex_state = 0, .external_lex_state = 2},
  [404] = {.lex_state = 35, .external_lex_state = 2},
  [405] = {.lex_state = 2, .external_lex_state = 2},
  [406] = {.lex_state = 0, .external_lex_state = 2},
  [407] = {.lex_state = 36, .external_lex_state = 2},
  [408] = {.lex_state = 0, .external_lex_state = 2},
  [409] = {.lex_state = 2, .external_lex_state = 2},
  [410] = {.lex_state = 3, .external_lex_state = 2},
  [411] = {.lex_state = 0, .external_lex_state = 2},
  [412] = {.lex_state = 0, .external_lex_state = 2},
  [413] = {.lex_state = 0, .external_lex_state = 2},
  [414] = {.lex_state = 35, .external_lex_state = 2},
  [415] = {.lex_state = 35, .external_lex_state = 2},
  [416] = {.lex_state = 36, .external_lex_state = 2},
  [417] = {.lex_state = 0, .external_lex_state = 2},
  [418] = {.lex_state = 0, .external_lex_state = 2},
  [419] = {.lex_state = 0, .external_lex_state = 2},
  [420] = {.lex_state = 36, .external_lex_state = 2},
  [421] = {.lex_state = 0, .external_lex_state = 2},
  [422] = {.lex_state = 2, .external_lex_state = 2},
  [423] = {.lex_state = 36, .external_lex_state = 2},
  [424] = {.lex_state = 3, .external_lex_state = 2},
  [425] = {.lex_state = 2, .external_lex_state = 2},
  [426] = {.lex_state = 3, .external_lex_state = 2},
  [427] = {.lex_state = 2, .external_lex_state = 2},
  [428] = {.lex_state = 3, .external_lex_state = 2},
  [429] = {.lex_state = 2, .external_lex_state = 2},
  [430] = {.lex_state = 0, .external_lex_state = 2},
  [431] = {.lex_state = 0, .external_lex_state = 2},
  [432] = {.lex_state = 3, .external_lex_state = 2},
  [433] = {.lex_state = 2, .external_lex_state = 2},
  [434] = {.lex_state = 3, .external_lex_state = 2},
  [435] = {.lex_state = 0, .external_lex_state = 2},
  [436] = {.lex_state = 3, .external_lex_state = 2},
  [437] = {.lex_state = 0, .external_lex_state = 2},
  [438] = {.lex_state = 0, .external_lex_state = 2},
  [439] = {.lex_state = 35, .external_lex_state = 2},
  [440] = {.lex_state = 0, .external_lex_state = 2},
  [441] = {.lex_state = 0, .external_lex_state = 2},
  [442] = {.lex_state = 0, .external_lex_state = 2},
  [443] = {.lex_state = 0, .external_lex_state = 2},
  [444] = {.lex_state = 0, .external_lex_state = 2},
  [445] = {.lex_state = 0, .external_lex_state = 2},
  [446] = {.lex_state = 0, .external_lex_state = 2},
  [447] = {.lex_state = 0, .external_lex_state = 2},
  [448] = {.lex_state = 35, .external_lex_state = 2},
  [449] = {.lex_state = 2, .external_lex_state = 2},
  [450] = {.lex_state = 0, .external_lex_state = 2},
  [451] = {.lex_state = 35, .external_lex_state = 2},
  [452] = {.lex_state = 0, .external_lex_state = 2},
  [453] = {.lex_state = 0, .external_lex_state = 2},
  [454] = {.lex_state = 0, .external_lex_state = 2},
  [455] = {.lex_state = 0, .external_lex_state = 2},
  [456] = {.lex_state = 35, .external_lex_state = 2},
  [457] = {.lex_state = 0, .external_lex_state = 2},
  [458] = {.lex_state = 0, .external_lex_state = 2},
  [459] = {.lex_state = 0, .external_lex_state = 2},
  [460] = {.lex_state = 0, .external_lex_state = 2},
  [461] = {.lex_state = 35, .external_lex_state = 2},
  [462] = {.lex_state = 35, .external_lex_state = 2},
  [463] = {.lex_state = 3, .external_lex_state = 2},
  [464] = {.lex_state = 35, .external_lex_state = 2},
  [465] = {.lex_state = 0, .external_lex_state = 2},
  [466] = {.lex_state = 0, .external_lex_state = 2},
  [467] = {.lex_state = 0, .external_lex_state = 2},
  [468] = {.lex_state = 0, .external_lex_state = 2},
  [469] = {.lex_state = 0, .external_lex_state = 2},
  [470] = {.lex_state = 0, .external_lex_state = 2},
  [471] = {.lex_state = 0, .external_lex_state = 2},
  [472] = {.lex_state = 0, .external_lex_state = 2},
  [473] = {.lex_state = 0, .external_lex_state = 2},
  [474] = {.lex_state = 0, .external_lex_state = 2},
  [475] = {.lex_state = 0, .external_lex_state = 2},
  [476] = {.lex_state = 0, .external_lex_state = 2},
  [477] = {.lex_state = 35, .external_lex_state = 2},
  [478] = {.lex_state = 0, .external_lex_state = 2},
  [479] = {.lex_state = 0, .external_lex_state = 2},
  [480] = {.lex_state = 35, .external_lex_state = 2},
  [481] = {.lex_state = 0, .external_lex_state = 4},
  [482] = {.lex_state = 0, .external_lex_state = 2},
  [483] = {.lex_state = 0, .external_lex_state = 2},
  [484] = {.lex_state = 0, .external_lex_state = 2},
  [485] = {.lex_state = 0, .external_lex_state = 2},
  [486] = {.lex_state = 0, .external_lex_state = 2},
  [487] = {.lex_state = 0, .external_lex_state = 2},
  [488] = {.lex_state = 107, .external_lex_state = 2},
  [489] = {.lex_state = 0, .external_lex_state = 2},
  [490] = {.lex_state = 0, .external_lex_state = 2},
  [491] = {.lex_state = 0, .external_lex_state = 5},
  [492] = {.lex_state = 0, .external_lex_state = 2},
  [493] = {.lex_state = 0, .external_lex_state = 2},
  [494] = {.lex_state = 0, .external_lex_state = 2},
  [495] = {.lex_state = 0, .external_lex_state = 2},
  [496] = {.lex_state = 0, .external_lex_state = 2},
  [497] = {.lex_state = 0, .external_lex_state = 2},
  [498] = {.lex_state = 0, .external_lex_state = 2},
  [499] = {.lex_state = 0, .external_lex_state = 2},
  [500] = {.lex_state = 0, .external_lex_state = 2},
  [501] = {.lex_state = 0, .external_lex_state = 2},
  [502] = {.lex_state = 0, .external_lex_state = 6},
  [503] = {.lex_state = 0, .external_lex_state = 2},
  [504] = {.lex_state = 0, .external_lex_state = 2},
  [505] = {.lex_state = 0, .external_lex_state = 2},
  [506] = {.lex_state = 0, .external_lex_state = 2},
  [507] = {.lex_state = 0, .external_lex_state = 2},
  [508] = {.lex_state = 0, .external_lex_state = 2},
  [509] = {.lex_state = 0, .external_lex_state = 2},
  [510] = {.lex_state = 0, .external_lex_state = 2},
  [511] = {.lex_state = 0, .external_lex_state = 2},
  [512] = {.lex_state = 0, .external_lex_state = 2},
  [513] = {.lex_state = 0, .external_lex_state = 2},
  [514] = {.lex_state = 0, .external_lex_state = 6},
  [515] = {.lex_state = 0, .external_lex_state = 2},
  [516] = {.lex_state = 0, .external_lex_state = 2},
  [517] = {.lex_state = 0, .external_lex_state = 2},
  [518] = {.lex_state = 0, .external_lex_state = 2},
  [519] = {.lex_state = 0, .external_lex_state = 2},
  [520] = {.lex_state = 0, .external_lex_state = 2},
  [521] = {.lex_state = 0, .external_lex_state = 2},
  [522] = {.lex_state = 0, .external_lex_state = 2},
  [523] = {.lex_state = 0, .external_lex_state = 2},
  [524] = {.lex_state = 0, .external_lex_state = 2},
  [525] = {.lex_state = 0, .external_lex_state = 2},
  [526] = {.lex_state = 0, .external_lex_state = 2},
  [527] = {.lex_state = 0, .external_lex_state = 2},
  [528] = {.lex_state = 0, .external_lex_state = 2},
  [529] = {.lex_state = 0, .external_lex_state = 2},
  [530] = {.lex_state = 0, .external_lex_state = 7},
  [531] = {.lex_state = 0, .external_lex_state = 2},
  [532] = {.lex_state = 0, .external_lex_state = 6},
  [533] = {.lex_state = 35, .external_lex_state = 2},
  [534] = {.lex_state = 0, .external_lex_state = 2},
  [535] = {.lex_state = 0, .external_lex_state = 2},
  [536] = {.lex_state = 0, .external_lex_state = 7},
  [537] = {.lex_state = 0, .external_lex_state = 2},
  [538] = {.lex_state = 0, .external_lex_state = 2},
  [539] = {.lex_state = 0, .external_lex_state = 2},
  [540] = {.lex_state = 0, .external_lex_state = 2},
  [541] = {.lex_state = 0, .external_lex_state = 2},
  [542] = {.lex_state = 0, .external_lex_state = 2},
  [543] = {.lex_state = 0, .external_lex_state = 2},
  [544] = {.lex_state = 0, .external_lex_state = 2},
  [545] = {.lex_state = 0, .external_lex_state = 2},
  [546] = {.lex_state = 0, .external_lex_state = 2},
  [547] = {.lex_state = 0, .external_lex_state = 2},
  [548] = {.lex_state = 0, .external_lex_state = 2},
  [549] = {.lex_state = 0, .external_lex_state = 7},
  [550] = {.lex_state = 0, .external_lex_state = 2},
  [551] = {.lex_state = 0, .external_lex_state = 2},
  [552] = {.lex_state = 0, .external_lex_state = 2},
  [553] = {.lex_state = 0, .external_lex_state = 2},
  [554] = {.lex_state = 0, .external_lex_state = 2},
  [555] = {(TSStateId)(-1)},
  [556] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [sym_break_statement] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_repeat] = ACTIONS(1),
    [anon_sym_until] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_elseif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_nil] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [sym_continue_statement] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_thread] = ACTIONS(1),
    [anon_sym_buffer] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_userdata] = ACTIONS(1),
    [anon_sym_unknown] = ACTIONS(1),
    [anon_sym_never] = ACTIONS(1),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_table] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_BSLASH_LBRACE] = ACTIONS(1),
    [aux_sym__escape_sequence_token1] = ACTIONS(1),
    [sym__block_comment_start] = ACTIONS(5),
    [sym__block_comment_content] = ACTIONS(1),
    [sym__block_comment_end] = ACTIONS(1),
    [sym__block_string_start] = ACTIONS(1),
    [sym__block_string_content] = ACTIONS(1),
    [sym__block_string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_chunk] = STATE(554),
    [sym_statement] = STATE(278),
    [sym_return_statement] = STATE(519),
    [sym_empty_statement] = STATE(259),
    [sym_assignment_statement] = STATE(259),
    [sym__variable_assignment_varlist] = STATE(316),
    [sym_do_statement] = STATE(259),
    [sym_while_statement] = STATE(259),
    [sym_repeat_statement] = STATE(259),
    [sym_if_statement] = STATE(259),
    [sym_for_statement] = STATE(259),
    [sym_declaration] = STATE(279),
    [sym_function_declaration] = STATE(244),
    [sym__local_function_declaration] = STATE(248),
    [sym_variable_declaration] = STATE(249),
    [sym__prefix_expression] = STATE(301),
    [sym_variable] = STATE(257),
    [sym_bracket_index_expression] = STATE(2),
    [sym_dot_index_expression] = STATE(2),
    [sym_function_call] = STATE(220),
    [sym_method_index_expression] = STATE(302),
    [sym_parenthesized_expression] = STATE(314),
    [sym_comment] = STATE(1),
    [sym_update_statement] = STATE(259),
    [sym_type_definition] = STATE(259),
    [aux_sym_chunk_repeat1] = STATE(111),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym_identifier] = ACTIONS(9),
    [sym_hash_bang_line] = ACTIONS(11),
    [anon_sym_return] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [sym_break_statement] = ACTIONS(17),
    [anon_sym_do] = ACTIONS(19),
    [anon_sym_while] = ACTIONS(21),
    [anon_sym_repeat] = ACTIONS(23),
    [anon_sym_if] = ACTIONS(25),
    [anon_sym_for] = ACTIONS(27),
    [anon_sym_function] = ACTIONS(29),
    [anon_sym_local] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(3),
    [sym_continue_statement] = ACTIONS(17),
    [anon_sym_export] = ACTIONS(35),
    [anon_sym_type] = ACTIONS(37),
    [sym__block_comment_start] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(2), 1,
      sym_comment,
    ACTIONS(39), 26,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_BQUOTE,
    ACTIONS(41), 33,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [73] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(3), 1,
      sym_comment,
    ACTIONS(43), 26,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_BQUOTE,
    ACTIONS(45), 33,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [146] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(4), 1,
      sym_comment,
    ACTIONS(47), 26,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
      anon_sym_BQUOTE,
    ACTIONS(49), 33,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [219] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(5), 1,
      sym_comment,
    ACTIONS(51), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(53), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [283] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(6), 1,
      sym_comment,
    ACTIONS(55), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(57), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [347] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(7), 1,
      sym_comment,
    ACTIONS(59), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(61), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [411] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(8), 1,
      sym_comment,
    ACTIONS(63), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(65), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [475] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(9), 1,
      sym_comment,
    ACTIONS(71), 2,
      anon_sym_DOT,
      anon_sym_COLON,
    ACTIONS(73), 7,
      sym__block_string_start,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(67), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(69), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [543] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(10), 1,
      sym_comment,
    ACTIONS(75), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(77), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [607] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(11), 1,
      sym_comment,
    ACTIONS(79), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(81), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [671] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(12), 1,
      sym_comment,
    ACTIONS(83), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(85), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [735] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(13), 1,
      sym_comment,
    ACTIONS(87), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(89), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [799] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(14), 1,
      sym_comment,
    ACTIONS(91), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(93), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [863] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(15), 1,
      sym_comment,
    ACTIONS(91), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(93), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [927] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(16), 1,
      sym_comment,
    ACTIONS(95), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(97), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [991] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(17), 1,
      sym_comment,
    ACTIONS(99), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(101), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1055] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(18), 1,
      sym_comment,
    ACTIONS(103), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(105), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1119] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(19), 1,
      sym_comment,
    ACTIONS(107), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(109), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1183] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(20), 1,
      sym_comment,
    ACTIONS(111), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(113), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1247] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(21), 1,
      sym_comment,
    ACTIONS(115), 24,
      sym__block_string_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
    ACTIONS(117), 26,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1311] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(123), 1,
      anon_sym_DOT,
    STATE(22), 1,
      sym_comment,
    STATE(23), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(119), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(121), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1377] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(129), 1,
      anon_sym_DOT,
    STATE(23), 2,
      sym_comment,
      aux_sym_field_type_repeat1,
    ACTIONS(125), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(127), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1441] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(123), 1,
      anon_sym_DOT,
    ACTIONS(136), 1,
      anon_sym_LT,
    STATE(22), 1,
      aux_sym_field_type_repeat1,
    STATE(24), 1,
      sym_comment,
    ACTIONS(132), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(134), 24,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1509] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(142), 1,
      anon_sym_DASH_GT,
    STATE(25), 1,
      sym_comment,
    ACTIONS(138), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(140), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1572] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(148), 1,
      anon_sym_DASH_GT,
    STATE(26), 1,
      sym_comment,
    ACTIONS(144), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(146), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1635] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(27), 1,
      sym_comment,
    ACTIONS(125), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(127), 26,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_DOT,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1696] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(154), 1,
      anon_sym_DASH_GT,
    STATE(28), 1,
      sym_comment,
    ACTIONS(150), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(152), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1759] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(29), 1,
      sym_comment,
    ACTIONS(156), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(158), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1819] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(30), 1,
      sym_comment,
    ACTIONS(160), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(162), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1879] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(31), 1,
      sym_comment,
    ACTIONS(91), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(93), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1939] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(32), 1,
      sym_comment,
    ACTIONS(164), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(166), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [1999] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    STATE(33), 1,
      sym_comment,
    ACTIONS(168), 20,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK,
    ACTIONS(170), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2061] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(34), 1,
      sym_comment,
    ACTIONS(99), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(101), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2121] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(35), 1,
      sym_comment,
    ACTIONS(83), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(85), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2181] = 39,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(176), 1,
      anon_sym_end,
    ACTIONS(178), 1,
      anon_sym_elseif,
    ACTIONS(180), 1,
      anon_sym_else,
    STATE(36), 1,
      sym_comment,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(350), 1,
      aux_sym_if_statement_repeat1,
    STATE(354), 1,
      sym__block,
    STATE(435), 1,
      sym_return_statement,
    STATE(438), 1,
      sym_elseif_statement,
    STATE(552), 1,
      sym_else_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [2309] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(37), 1,
      sym_comment,
    ACTIONS(95), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(97), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2369] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(38), 1,
      sym_comment,
    ACTIONS(182), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(184), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2435] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(39), 1,
      sym_comment,
    ACTIONS(190), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(192), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2501] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(40), 1,
      sym_comment,
    ACTIONS(194), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(196), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2561] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(41), 1,
      sym_comment,
    ACTIONS(198), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(200), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2621] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(42), 1,
      sym_comment,
    ACTIONS(202), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(204), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2687] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(43), 1,
      sym_comment,
    ACTIONS(206), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(208), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2747] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(44), 1,
      sym_comment,
    ACTIONS(210), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(212), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2807] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(45), 1,
      sym_comment,
    ACTIONS(214), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(216), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2873] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(46), 1,
      sym_comment,
    ACTIONS(218), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(220), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2933] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(47), 1,
      sym_comment,
    ACTIONS(222), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(224), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [2999] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(48), 1,
      sym_comment,
    ACTIONS(226), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(228), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3059] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(49), 1,
      sym_comment,
    ACTIONS(230), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(232), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3125] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(50), 1,
      sym_comment,
    ACTIONS(234), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(236), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3191] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(51), 1,
      sym_comment,
    ACTIONS(238), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(240), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3257] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(52), 1,
      sym_comment,
    ACTIONS(242), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(244), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3323] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(53), 1,
      sym_comment,
    ACTIONS(246), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(248), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3383] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(54), 1,
      sym_comment,
    ACTIONS(250), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(252), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3443] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(55), 1,
      sym_comment,
    ACTIONS(254), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(256), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3503] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(56), 1,
      sym_comment,
    ACTIONS(258), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(260), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3563] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(57), 1,
      sym_comment,
    ACTIONS(91), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(93), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3623] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(58), 1,
      sym_comment,
    ACTIONS(107), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(109), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3683] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(59), 1,
      sym_comment,
    ACTIONS(111), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(113), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3743] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(60), 1,
      sym_comment,
    ACTIONS(75), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(77), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3803] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(61), 1,
      sym_comment,
    ACTIONS(132), 21,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
    ACTIONS(134), 25,
      anon_sym_return,
      anon_sym_EQ,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3863] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(266), 1,
      anon_sym_elseif,
    ACTIONS(268), 1,
      anon_sym_else,
    STATE(62), 1,
      sym_comment,
    STATE(66), 1,
      aux_sym_if_expression_repeat1,
    STATE(88), 1,
      sym_elseif_clause,
    STATE(97), 1,
      sym_else_clause,
    ACTIONS(262), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(264), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [3932] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(266), 1,
      anon_sym_elseif,
    ACTIONS(268), 1,
      anon_sym_else,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(278), 1,
      anon_sym_or,
    ACTIONS(280), 1,
      anon_sym_and,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(62), 1,
      aux_sym_if_expression_repeat1,
    STATE(63), 1,
      sym_comment,
    STATE(88), 1,
      sym_elseif_clause,
    STATE(89), 1,
      sym_else_clause,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(270), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(272), 16,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4023] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(64), 1,
      sym_comment,
    ACTIONS(296), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(298), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4088] = 37,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(300), 1,
      anon_sym_end,
    STATE(65), 1,
      sym_comment,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(500), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4210] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(306), 1,
      anon_sym_elseif,
    STATE(88), 1,
      sym_elseif_clause,
    STATE(66), 2,
      sym_comment,
      aux_sym_if_expression_repeat1,
    ACTIONS(302), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(304), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4272] = 37,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(309), 1,
      anon_sym_end,
    STATE(67), 1,
      sym_comment,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(520), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4394] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(68), 1,
      sym_comment,
    ACTIONS(311), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(313), 25,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4451] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(315), 1,
      anon_sym_SEMI,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(69), 1,
      sym_comment,
    STATE(225), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(327), 1,
      sym__expression_list,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    ACTIONS(317), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [4558] = 31,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(345), 1,
      ts_builtin_sym_end,
    ACTIONS(347), 1,
      sym_identifier,
    ACTIONS(352), 1,
      anon_sym_SEMI,
    ACTIONS(358), 1,
      anon_sym_do,
    ACTIONS(361), 1,
      anon_sym_while,
    ACTIONS(364), 1,
      anon_sym_repeat,
    ACTIONS(367), 1,
      anon_sym_if,
    ACTIONS(370), 1,
      anon_sym_for,
    ACTIONS(373), 1,
      anon_sym_function,
    ACTIONS(376), 1,
      anon_sym_local,
    ACTIONS(379), 1,
      anon_sym_LPAREN,
    ACTIONS(382), 1,
      anon_sym_export,
    ACTIONS(385), 1,
      anon_sym_type,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    ACTIONS(355), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(70), 2,
      sym_comment,
      aux_sym_chunk_repeat1,
    ACTIONS(350), 5,
      anon_sym_return,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4667] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    STATE(71), 1,
      sym_comment,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(450), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(388), 3,
      anon_sym_end,
      anon_sym_elseif,
      anon_sym_else,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4782] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    STATE(70), 1,
      aux_sym_chunk_repeat1,
    STATE(72), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(418), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    ACTIONS(390), 4,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_else,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [4895] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(73), 1,
      sym_comment,
    ACTIONS(392), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(394), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [4951] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(278), 1,
      anon_sym_or,
    ACTIONS(280), 1,
      anon_sym_and,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(74), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(396), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(398), 18,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5029] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(75), 1,
      sym_comment,
    ACTIONS(400), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(402), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5085] = 35,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(404), 1,
      anon_sym_end,
    ACTIONS(406), 1,
      anon_sym_COLON,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(76), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(540), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [5201] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(77), 1,
      sym_comment,
    ACTIONS(115), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(117), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5257] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(78), 1,
      sym_comment,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(410), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5327] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(280), 1,
      anon_sym_and,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(79), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(408), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(410), 19,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5403] = 14,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(80), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(408), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(410), 20,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5477] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(81), 1,
      sym_comment,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 13,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_DOT_DOT,
    ACTIONS(410), 23,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5541] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(82), 1,
      sym_comment,
    ACTIONS(408), 16,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(410), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5601] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(83), 1,
      sym_comment,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(408), 11,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(410), 22,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5671] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(84), 1,
      sym_comment,
    ACTIONS(408), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(410), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5729] = 23,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(412), 1,
      sym_identifier,
    ACTIONS(414), 1,
      anon_sym_COMMA,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_LBRACK,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(428), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(85), 1,
      sym_comment,
    STATE(357), 1,
      sym_type,
    STATE(545), 1,
      sym_object_field_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [5821] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(86), 1,
      sym_comment,
    ACTIONS(430), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(432), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5877] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(87), 1,
      sym_comment,
    ACTIONS(434), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(436), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5933] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(88), 1,
      sym_comment,
    ACTIONS(438), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(440), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [5989] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(89), 1,
      sym_comment,
    ACTIONS(262), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(264), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6045] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(90), 1,
      sym_comment,
    ACTIONS(67), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(69), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6101] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(91), 1,
      sym_comment,
    ACTIONS(442), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(444), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6157] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(92), 1,
      sym_comment,
    ACTIONS(446), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(448), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6213] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(93), 1,
      sym_comment,
    ACTIONS(450), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(452), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6269] = 35,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(454), 1,
      anon_sym_end,
    ACTIONS(456), 1,
      anon_sym_COLON,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(94), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(534), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [6385] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(95), 1,
      sym_comment,
    ACTIONS(103), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(105), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6441] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(278), 1,
      anon_sym_or,
    ACTIONS(280), 1,
      anon_sym_and,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(96), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(458), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(460), 18,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6519] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(97), 1,
      sym_comment,
    ACTIONS(462), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(464), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6575] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(98), 1,
      sym_comment,
    ACTIONS(466), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(468), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6631] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(99), 1,
      sym_comment,
    ACTIONS(470), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(472), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6687] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(100), 1,
      sym_comment,
    ACTIONS(474), 17,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    ACTIONS(476), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6745] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(101), 1,
      sym_comment,
    ACTIONS(478), 18,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
    ACTIONS(480), 24,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_then,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_or,
      anon_sym_and,
      anon_sym_DASH,
      anon_sym_SLASH,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [6801] = 23,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(424), 1,
      anon_sym_LBRACK,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(482), 1,
      sym_identifier,
    ACTIONS(484), 1,
      anon_sym_COMMA,
    ACTIONS(486), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(102), 1,
      sym_comment,
    STATE(325), 1,
      sym_type,
    STATE(551), 1,
      sym_object_field_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [6893] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(488), 1,
      anon_sym_until,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(103), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(538), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7006] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(490), 1,
      anon_sym_end,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(104), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(543), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7119] = 31,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(496), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(105), 1,
      sym_comment,
    STATE(246), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(403), 1,
      sym_field,
    STATE(495), 1,
      sym__field_list,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [7226] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(498), 1,
      anon_sym_end,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(106), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(487), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7339] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(500), 1,
      anon_sym_end,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(107), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(496), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7452] = 34,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(174), 1,
      anon_sym_return,
    ACTIONS(502), 1,
      anon_sym_end,
    STATE(72), 1,
      aux_sym_chunk_repeat1,
    STATE(108), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(435), 1,
      sym_return_statement,
    STATE(511), 1,
      sym__block,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7565] = 31,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(504), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(109), 1,
      sym_comment,
    STATE(246), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(403), 1,
      sym_field,
    STATE(505), 1,
      sym__field_list,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [7672] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(315), 1,
      anon_sym_SEMI,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(506), 1,
      ts_builtin_sym_end,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(110), 1,
      sym_comment,
    STATE(225), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(327), 1,
      sym__expression_list,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [7776] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(508), 1,
      ts_builtin_sym_end,
    STATE(70), 1,
      aux_sym_chunk_repeat1,
    STATE(111), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(493), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [7886] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(510), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(112), 1,
      sym_comment,
    STATE(246), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(470), 1,
      sym_field,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [7990] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(512), 1,
      sym_identifier,
    ACTIONS(514), 1,
      anon_sym_COMMA,
    ACTIONS(516), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(113), 1,
      sym_comment,
    STATE(344), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [8076] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(508), 1,
      ts_builtin_sym_end,
    STATE(114), 1,
      sym_comment,
    STATE(116), 1,
      aux_sym_chunk_repeat1,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(493), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [8186] = 30,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    ACTIONS(518), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(115), 1,
      sym_comment,
    STATE(246), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(470), 1,
      sym_field,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8290] = 33,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_return,
    ACTIONS(15), 1,
      anon_sym_SEMI,
    ACTIONS(19), 1,
      anon_sym_do,
    ACTIONS(21), 1,
      anon_sym_while,
    ACTIONS(23), 1,
      anon_sym_repeat,
    ACTIONS(25), 1,
      anon_sym_if,
    ACTIONS(27), 1,
      anon_sym_for,
    ACTIONS(29), 1,
      anon_sym_function,
    ACTIONS(31), 1,
      anon_sym_local,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_export,
    ACTIONS(37), 1,
      anon_sym_type,
    ACTIONS(520), 1,
      ts_builtin_sym_end,
    STATE(70), 1,
      aux_sym_chunk_repeat1,
    STATE(116), 1,
      sym_comment,
    STATE(220), 1,
      sym_function_call,
    STATE(244), 1,
      sym_function_declaration,
    STATE(248), 1,
      sym__local_function_declaration,
    STATE(249), 1,
      sym_variable_declaration,
    STATE(257), 1,
      sym_variable,
    STATE(278), 1,
      sym_statement,
    STATE(279), 1,
      sym_declaration,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(314), 1,
      sym_parenthesized_expression,
    STATE(316), 1,
      sym__variable_assignment_varlist,
    STATE(507), 1,
      sym_return_statement,
    ACTIONS(17), 2,
      sym_break_statement,
      sym_continue_statement,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(259), 9,
      sym_empty_statement,
      sym_assignment_statement,
      sym_do_statement,
      sym_while_statement,
      sym_repeat_statement,
      sym_if_statement,
      sym_for_statement,
      sym_update_statement,
      sym_type_definition,
  [8400] = 21,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(522), 1,
      sym_identifier,
    ACTIONS(524), 1,
      anon_sym_COMMA,
    ACTIONS(526), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(117), 1,
      sym_comment,
    STATE(346), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [8486] = 29,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(492), 1,
      sym_identifier,
    ACTIONS(494), 1,
      anon_sym_LBRACK,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(118), 1,
      sym_comment,
    STATE(246), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(470), 1,
      sym_field,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [8587] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    ACTIONS(530), 1,
      anon_sym_typeof,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(119), 1,
      sym_comment,
    STATE(228), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [8670] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(120), 1,
      sym_comment,
    STATE(334), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [8753] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(278), 1,
      anon_sym_or,
    ACTIONS(280), 1,
      anon_sym_and,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(538), 1,
      anon_sym_COMMA,
    STATE(121), 1,
      sym_comment,
    STATE(237), 1,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(534), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(536), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [8832] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    ACTIONS(540), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(122), 1,
      sym_comment,
    STATE(334), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [8915] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    ACTIONS(542), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(123), 1,
      sym_comment,
    STATE(351), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [8998] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(544), 1,
      sym_identifier,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(124), 1,
      sym_comment,
    STATE(342), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9081] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(550), 1,
      anon_sym_GT,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(125), 1,
      sym_comment,
    STATE(339), 1,
      sym_type,
    STATE(358), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9164] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    ACTIONS(570), 1,
      anon_sym_typeof,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(126), 1,
      sym_comment,
    STATE(235), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9247] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(544), 1,
      sym_identifier,
    ACTIONS(572), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(127), 1,
      sym_comment,
    STATE(326), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9330] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    ACTIONS(574), 1,
      anon_sym_GT,
    STATE(128), 1,
      sym_comment,
    STATE(347), 1,
      sym_type,
    STATE(358), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9413] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    ACTIONS(576), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(129), 1,
      sym_comment,
    STATE(334), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9496] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    ACTIONS(578), 1,
      anon_sym_RBRACE,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(130), 1,
      sym_comment,
    STATE(334), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9579] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    ACTIONS(580), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(131), 1,
      sym_comment,
    STATE(352), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9662] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(544), 1,
      sym_identifier,
    ACTIONS(582), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(132), 1,
      sym_comment,
    STATE(355), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9745] = 20,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(544), 1,
      sym_identifier,
    ACTIONS(584), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(133), 1,
      sym_comment,
    STATE(356), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9828] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(134), 1,
      sym_comment,
    STATE(334), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [9908] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(135), 1,
      sym_comment,
    STATE(265), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10006] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(136), 1,
      sym_comment,
    STATE(268), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10104] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(137), 1,
      sym_comment,
    STATE(269), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10202] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(138), 1,
      sym_comment,
    STATE(372), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10282] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(139), 1,
      sym_comment,
    STATE(282), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10380] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(140), 1,
      sym_comment,
    STATE(271), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10478] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(65), 1,
      sym_type,
    STATE(141), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10558] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(142), 1,
      sym_comment,
    STATE(272), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10656] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(143), 1,
      sym_comment,
    STATE(222), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10736] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(42), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(144), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [10816] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(145), 1,
      sym_comment,
    STATE(273), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [10914] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(586), 1,
      anon_sym_RPAREN,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(146), 1,
      sym_comment,
    STATE(276), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11012] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(147), 1,
      sym_comment,
    STATE(221), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11092] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(278), 1,
      anon_sym_or,
    ACTIONS(280), 1,
      anon_sym_and,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(148), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(588), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(590), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [11166] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(149), 1,
      sym_comment,
    STATE(247), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [11264] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(67), 1,
      sym_type,
    STATE(150), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11344] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(151), 1,
      sym_comment,
    STATE(412), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11424] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(39), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(152), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11504] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(153), 1,
      sym_comment,
    STATE(413), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11584] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(45), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(154), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11664] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(155), 1,
      sym_comment,
    STATE(417), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11744] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(156), 1,
      sym_comment,
    STATE(335), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11824] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(38), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(157), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11904] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(47), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(158), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [11984] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(33), 1,
      sym_type,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(159), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12064] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(49), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(160), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12144] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(161), 1,
      sym_comment,
    STATE(367), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12224] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(162), 1,
      sym_comment,
    STATE(394), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12304] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(64), 1,
      sym_type,
    STATE(163), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12384] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(50), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(164), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12464] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(51), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(165), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12544] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(52), 1,
      sym_type,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(166), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12624] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(167), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(360), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12704] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(29), 1,
      sym_type,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(168), 1,
      sym_comment,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12784] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(169), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(400), 1,
      sym_type,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12864] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(170), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(401), 1,
      sym_type,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [12944] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(171), 1,
      sym_comment,
    STATE(225), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(489), 1,
      sym__expression_list,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [13042] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(172), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(378), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13122] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(173), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(359), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13202] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(174), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(363), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13282] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(175), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(366), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13362] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(176), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(369), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13442] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(177), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(371), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13522] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(178), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(373), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13602] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(179), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(374), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13682] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(548), 1,
      sym_identifier,
    ACTIONS(556), 1,
      anon_sym_DQUOTE,
    ACTIONS(558), 1,
      anon_sym_SQUOTE,
    ACTIONS(560), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(562), 1,
      anon_sym_LPAREN,
    ACTIONS(564), 1,
      anon_sym_LBRACE,
    ACTIONS(566), 1,
      anon_sym_BQUOTE,
    ACTIONS(568), 1,
      sym__block_string_start,
    STATE(180), 1,
      sym_comment,
    STATE(358), 1,
      sym__quote_string,
    STATE(376), 1,
      sym_type,
    STATE(379), 1,
      sym__interpolated_string,
    STATE(388), 1,
      sym_string,
    STATE(404), 1,
      sym__block_string,
    ACTIONS(554), 2,
      sym_false,
      sym_true,
    ACTIONS(552), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(397), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13762] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(181), 1,
      sym_comment,
    STATE(263), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [13860] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(182), 1,
      sym_comment,
    STATE(348), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [13940] = 28,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(121), 1,
      sym_expression,
    STATE(183), 1,
      sym_comment,
    STATE(264), 1,
      sym__variable_assignment_explist,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14038] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(184), 1,
      sym_comment,
    STATE(353), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14118] = 19,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    ACTIONS(420), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(422), 1,
      anon_sym_LPAREN,
    ACTIONS(426), 1,
      anon_sym_LBRACE,
    ACTIONS(528), 1,
      sym_identifier,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(56), 1,
      sym_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(185), 1,
      sym_comment,
    STATE(333), 1,
      sym_type,
    ACTIONS(418), 2,
      sym_false,
      sym_true,
    ACTIONS(416), 11,
      anon_sym_nil,
      anon_sym_thread,
      anon_sym_buffer,
      anon_sym_any,
      anon_sym_userdata,
      anon_sym_unknown,
      anon_sym_never,
      anon_sym_string,
      anon_sym_number,
      anon_sym_table,
      anon_sym_boolean,
    STATE(61), 12,
      sym_builtin_type,
      sym_tuple_type,
      sym_function_type,
      sym_generic_type,
      sym_object_type,
      sym_empty_type,
      sym_field_type,
      sym_union_type,
      sym_intersection_type,
      sym_optional_type,
      sym_literal_type,
      sym_variadic_type,
  [14198] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(186), 1,
      sym_comment,
    STATE(291), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14293] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(148), 1,
      sym_expression,
    STATE(187), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14388] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(188), 1,
      sym_comment,
    STATE(295), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14483] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(189), 1,
      sym_comment,
    STATE(288), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14578] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(190), 1,
      sym_comment,
    STATE(294), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14673] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(74), 1,
      sym_expression,
    STATE(191), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14768] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(278), 1,
      anon_sym_or,
    ACTIONS(280), 1,
      anon_sym_and,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(192), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(592), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(594), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [14841] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(193), 1,
      sym_comment,
    STATE(290), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [14936] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(194), 1,
      sym_comment,
    STATE(223), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15031] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(195), 1,
      sym_comment,
    STATE(298), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15126] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(96), 1,
      sym_expression,
    STATE(196), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15221] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(78), 1,
      sym_expression,
    STATE(197), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15316] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(79), 1,
      sym_expression,
    STATE(198), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15411] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(80), 1,
      sym_expression,
    STATE(199), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15506] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(81), 1,
      sym_expression,
    STATE(200), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15601] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(82), 1,
      sym_expression,
    STATE(201), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15696] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(83), 1,
      sym_expression,
    STATE(202), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15791] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(203), 1,
      sym_comment,
    STATE(286), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15886] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(204), 1,
      sym_comment,
    STATE(251), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [15981] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(205), 1,
      sym_comment,
    STATE(292), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16076] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(278), 1,
      anon_sym_or,
    ACTIONS(280), 1,
      anon_sym_and,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    STATE(206), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(596), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(598), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [16149] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(192), 1,
      sym_expression,
    STATE(207), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16244] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(208), 1,
      sym_comment,
    STATE(266), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16339] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(100), 1,
      sym_expression,
    STATE(209), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16434] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(210), 1,
      sym_comment,
    STATE(297), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16529] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(211), 1,
      sym_comment,
    STATE(283), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16624] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(212), 1,
      sym_comment,
    STATE(289), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16719] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(63), 1,
      sym_expression,
    STATE(213), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16814] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(214), 1,
      sym_comment,
    STATE(293), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [16909] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(206), 1,
      sym_expression,
    STATE(215), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17004] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(216), 1,
      sym_comment,
    STATE(287), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17099] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(217), 1,
      sym_comment,
    STATE(296), 1,
      sym_expression,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17194] = 27,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(9), 1,
      sym_identifier,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(319), 1,
      anon_sym_if,
    ACTIONS(321), 1,
      anon_sym_function,
    ACTIONS(323), 1,
      anon_sym_nil,
    ACTIONS(327), 1,
      sym_number,
    ACTIONS(329), 1,
      anon_sym_DQUOTE,
    ACTIONS(331), 1,
      anon_sym_SQUOTE,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(335), 1,
      anon_sym_LBRACE,
    ACTIONS(339), 1,
      anon_sym_POUND,
    ACTIONS(341), 1,
      anon_sym_BQUOTE,
    ACTIONS(343), 1,
      sym__block_string_start,
    STATE(31), 1,
      sym__block_string,
    STATE(37), 1,
      sym__interpolated_string,
    STATE(57), 1,
      sym__quote_string,
    STATE(84), 1,
      sym_expression,
    STATE(218), 1,
      sym_comment,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    ACTIONS(325), 2,
      sym_false,
      sym_true,
    ACTIONS(337), 2,
      anon_sym_DASH,
      anon_sym_not,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(9), 3,
      sym_variable,
      sym_function_call,
      sym_parenthesized_expression,
    STATE(90), 9,
      sym_nil,
      sym_string,
      sym_vararg_expression,
      sym_function_definition,
      sym_table_constructor,
      sym_binary_expression,
      sym_unary_expression,
      sym_cast_expression,
      sym_if_expression,
  [17289] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(600), 1,
      anon_sym_EQ,
    STATE(219), 1,
      sym_comment,
    ACTIONS(41), 6,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(39), 23,
      sym__block_string_start,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_or,
      anon_sym_and,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_CARET,
      anon_sym_BQUOTE,
  [17335] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(220), 1,
      sym_comment,
    ACTIONS(602), 2,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(73), 9,
      sym__block_string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(604), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17379] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(610), 1,
      anon_sym_COMMA,
    ACTIONS(612), 1,
      anon_sym_LT,
    STATE(221), 1,
      sym_comment,
    STATE(230), 1,
      aux_sym__att_name_list_repeat1,
    STATE(233), 1,
      sym__attrib,
    ACTIONS(606), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(608), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17435] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(612), 1,
      anon_sym_LT,
    STATE(222), 1,
      sym_comment,
    STATE(236), 1,
      sym__attrib,
    ACTIONS(614), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(616), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17486] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(620), 1,
      anon_sym_else,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    STATE(223), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(618), 8,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [17548] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      anon_sym_COMMA,
    ACTIONS(612), 1,
      anon_sym_LT,
    ACTIONS(630), 1,
      anon_sym_COLON,
    STATE(224), 1,
      sym_comment,
    STATE(229), 1,
      aux_sym__att_name_list_repeat1,
    STATE(231), 1,
      sym__attrib,
    ACTIONS(626), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(628), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17598] = 18,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(634), 1,
      anon_sym_COMMA,
    ACTIONS(636), 1,
      anon_sym_else,
    STATE(225), 1,
      sym_comment,
    STATE(319), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
    ACTIONS(632), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [17664] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(612), 1,
      anon_sym_LT,
    ACTIONS(642), 1,
      anon_sym_COLON,
    STATE(226), 1,
      sym_comment,
    STATE(240), 1,
      sym__attrib,
    ACTIONS(638), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(640), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17709] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      anon_sym_COMMA,
    STATE(227), 1,
      sym_comment,
    STATE(232), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(644), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(646), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17750] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(228), 1,
      sym_comment,
    ACTIONS(648), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(650), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17793] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      anon_sym_COMMA,
    STATE(229), 1,
      sym_comment,
    STATE(232), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(652), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(654), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17834] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      anon_sym_COMMA,
    STATE(230), 1,
      sym_comment,
    STATE(232), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(656), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(658), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17875] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      anon_sym_COMMA,
    STATE(231), 1,
      sym_comment,
    STATE(234), 1,
      aux_sym__att_name_list_repeat1,
    ACTIONS(660), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(662), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17916] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(668), 1,
      anon_sym_COMMA,
    STATE(232), 2,
      sym_comment,
      aux_sym__att_name_list_repeat1,
    ACTIONS(664), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(666), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17955] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      anon_sym_COMMA,
    STATE(227), 1,
      aux_sym__att_name_list_repeat1,
    STATE(233), 1,
      sym_comment,
    ACTIONS(671), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(673), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [17996] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(610), 1,
      anon_sym_COMMA,
    STATE(232), 1,
      aux_sym__att_name_list_repeat1,
    STATE(234), 1,
      sym_comment,
    ACTIONS(675), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_LPAREN,
    ACTIONS(677), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18037] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(235), 1,
      sym_comment,
    ACTIONS(679), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(681), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18080] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(236), 1,
      sym_comment,
    ACTIONS(683), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(685), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18116] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(538), 1,
      anon_sym_COMMA,
    STATE(237), 1,
      sym_comment,
    STATE(238), 1,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(687), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(689), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18156] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(695), 1,
      anon_sym_COMMA,
    STATE(238), 2,
      sym_comment,
      aux_sym__variable_assignment_explist_repeat1,
    ACTIONS(691), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(693), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18194] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(239), 1,
      sym_comment,
    ACTIONS(698), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(700), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18230] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(240), 1,
      sym_comment,
    ACTIONS(702), 5,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LPAREN,
    ACTIONS(704), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18266] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(710), 1,
      anon_sym_EQ,
    STATE(241), 1,
      sym_comment,
    ACTIONS(706), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(708), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18303] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(242), 1,
      sym_comment,
    ACTIONS(712), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(714), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18337] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(243), 1,
      sym_comment,
    ACTIONS(716), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(718), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18371] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(244), 1,
      sym_comment,
    ACTIONS(720), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(722), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18405] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(245), 1,
      sym_comment,
    ACTIONS(724), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(726), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18439] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    STATE(246), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(728), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18493] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(247), 1,
      sym_comment,
    ACTIONS(730), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(732), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18527] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(248), 1,
      sym_comment,
    ACTIONS(734), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(736), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18561] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(249), 1,
      sym_comment,
    ACTIONS(738), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(740), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18595] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(250), 1,
      sym_comment,
    ACTIONS(742), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(744), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18629] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    STATE(251), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(746), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [18683] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(252), 1,
      sym_comment,
    ACTIONS(748), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(750), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18717] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(253), 1,
      sym_comment,
    ACTIONS(752), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(754), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18751] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(254), 1,
      sym_comment,
    ACTIONS(756), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(758), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18785] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(255), 1,
      sym_comment,
    ACTIONS(760), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(762), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18819] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(256), 1,
      sym_comment,
    ACTIONS(764), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(766), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18853] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(71), 1,
      anon_sym_DOT,
    ACTIONS(770), 1,
      anon_sym_COMMA,
    STATE(257), 1,
      sym_comment,
    STATE(304), 1,
      aux_sym__variable_assignment_varlist_repeat1,
    ACTIONS(73), 8,
      sym__block_string_start,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(768), 9,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [18893] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(258), 1,
      sym_comment,
    ACTIONS(772), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(774), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18927] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(259), 1,
      sym_comment,
    ACTIONS(602), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(604), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18961] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(260), 1,
      sym_comment,
    ACTIONS(776), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(778), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [18995] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(261), 1,
      sym_comment,
    ACTIONS(780), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(782), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19029] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(262), 1,
      sym_comment,
    ACTIONS(784), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(786), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19063] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(263), 1,
      sym_comment,
    ACTIONS(788), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(790), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19097] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(264), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19131] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(265), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19165] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    STATE(266), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(796), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19219] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(267), 1,
      sym_comment,
    ACTIONS(798), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(800), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19253] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(268), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19287] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(269), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19321] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(270), 1,
      sym_comment,
    ACTIONS(802), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(804), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19355] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(271), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19389] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(272), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19423] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(273), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19457] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(274), 1,
      sym_comment,
    ACTIONS(806), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(808), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19491] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(275), 1,
      sym_comment,
    ACTIONS(810), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(812), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19525] = 17,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(634), 1,
      anon_sym_COMMA,
    ACTIONS(814), 1,
      anon_sym_RPAREN,
    STATE(276), 1,
      sym_comment,
    STATE(444), 1,
      aux_sym__expression_list_repeat1,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19583] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(277), 1,
      sym_comment,
    ACTIONS(816), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(818), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19617] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(278), 1,
      sym_comment,
    ACTIONS(820), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(822), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19651] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(279), 1,
      sym_comment,
    ACTIONS(824), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(826), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19685] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(280), 1,
      sym_comment,
    ACTIONS(828), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(830), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19719] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(281), 1,
      sym_comment,
    ACTIONS(832), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(834), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19753] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(282), 1,
      sym_comment,
    ACTIONS(792), 3,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
    ACTIONS(794), 17,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_until,
      anon_sym_if,
      anon_sym_elseif,
      anon_sym_else,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [19787] = 16,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(836), 1,
      anon_sym_COMMA,
    ACTIONS(838), 1,
      anon_sym_do,
    STATE(283), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19842] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(71), 1,
      anon_sym_DOT,
    STATE(284), 1,
      sym_comment,
    ACTIONS(73), 8,
      sym__block_string_start,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
    ACTIONS(840), 10,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [19877] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(285), 1,
      sym_comment,
    ACTIONS(842), 8,
      anon_sym_if,
      anon_sym_function,
      anon_sym_nil,
      sym_false,
      sym_true,
      anon_sym_DASH,
      anon_sym_not,
      sym_identifier,
    ACTIONS(844), 11,
      sym__block_string_start,
      sym_number,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_BQUOTE,
  [19910] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(846), 1,
      anon_sym_do,
    STATE(286), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [19962] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(848), 1,
      anon_sym_RBRACK,
    STATE(287), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20014] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(850), 1,
      anon_sym_RPAREN,
    STATE(288), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20066] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(852), 1,
      anon_sym_RPAREN,
    STATE(289), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20118] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(854), 1,
      anon_sym_then,
    STATE(290), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20170] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(856), 1,
      anon_sym_RPAREN,
    STATE(291), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20222] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(858), 1,
      anon_sym_do,
    STATE(292), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20274] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(860), 1,
      anon_sym_RBRACK,
    STATE(293), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20326] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(862), 1,
      anon_sym_RBRACE,
    STATE(294), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20378] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(864), 1,
      anon_sym_then,
    STATE(295), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20430] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(866), 1,
      anon_sym_then,
    STATE(296), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20482] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(868), 1,
      anon_sym_COMMA,
    STATE(297), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20534] = 15,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(274), 1,
      anon_sym_COLON_COLON,
    ACTIONS(284), 1,
      anon_sym_PLUS,
    ACTIONS(286), 1,
      anon_sym_DASH,
    ACTIONS(290), 1,
      anon_sym_SLASH,
    ACTIONS(292), 1,
      anon_sym_DOT_DOT,
    ACTIONS(294), 1,
      anon_sym_CARET,
    ACTIONS(622), 1,
      anon_sym_or,
    ACTIONS(624), 1,
      anon_sym_and,
    ACTIONS(870), 1,
      anon_sym_then,
    STATE(298), 1,
      sym_comment,
    ACTIONS(276), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(288), 3,
      anon_sym_STAR,
      anon_sym_SLASH_SLASH,
      anon_sym_PERCENT,
    ACTIONS(282), 4,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_GT_EQ,
  [20586] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(299), 1,
      sym_comment,
    ACTIONS(874), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
    ACTIONS(872), 14,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20617] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(300), 1,
      sym_comment,
    ACTIONS(878), 3,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
    ACTIONS(876), 14,
      anon_sym_return,
      sym_break_statement,
      anon_sym_do,
      anon_sym_end,
      anon_sym_while,
      anon_sym_repeat,
      anon_sym_if,
      anon_sym_for,
      anon_sym_function,
      anon_sym_local,
      sym_identifier,
      sym_continue_statement,
      anon_sym_export,
      anon_sym_type,
  [20648] = 17,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(880), 1,
      anon_sym_DOT,
    ACTIONS(882), 1,
      anon_sym_COLON,
    ACTIONS(884), 1,
      anon_sym_DQUOTE,
    ACTIONS(886), 1,
      anon_sym_SQUOTE,
    ACTIONS(888), 1,
      anon_sym_LPAREN,
    ACTIONS(890), 1,
      anon_sym_LBRACK,
    ACTIONS(892), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      anon_sym_BQUOTE,
    ACTIONS(896), 1,
      sym__block_string_start,
    STATE(7), 1,
      sym_arguments,
    STATE(14), 1,
      sym__quote_string,
    STATE(15), 1,
      sym__block_string,
    STATE(16), 1,
      sym__interpolated_string,
    STATE(301), 1,
      sym_comment,
    STATE(6), 2,
      sym_string,
      sym_table_constructor,
  [20701] = 14,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(884), 1,
      anon_sym_DQUOTE,
    ACTIONS(886), 1,
      anon_sym_SQUOTE,
    ACTIONS(888), 1,
      anon_sym_LPAREN,
    ACTIONS(892), 1,
      anon_sym_LBRACE,
    ACTIONS(894), 1,
      anon_sym_BQUOTE,
    ACTIONS(896), 1,
      sym__block_string_start,
    STATE(7), 1,
      sym_arguments,
    STATE(14), 1,
      sym__quote_string,
    STATE(15), 1,
      sym__block_string,
    STATE(16), 1,
      sym__interpolated_string,
    STATE(302), 1,
      sym_comment,
    STATE(6), 2,
      sym_string,
      sym_table_constructor,
  [20745] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(900), 1,
      anon_sym_COMMA,
    STATE(303), 2,
      sym_comment,
      aux_sym__variable_assignment_varlist_repeat1,
    ACTIONS(898), 9,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [20770] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(770), 1,
      anon_sym_COMMA,
    STATE(303), 1,
      aux_sym__variable_assignment_varlist_repeat1,
    STATE(304), 1,
      sym_comment,
    ACTIONS(903), 9,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_CARET_EQ,
      anon_sym_DOT_DOT_EQ,
  [20797] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(905), 1,
      sym_escape_sequence,
    ACTIONS(907), 1,
      anon_sym_LBRACE,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(911), 1,
      anon_sym_BQUOTE,
    ACTIONS(913), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(915), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(917), 1,
      aux_sym__escape_sequence_token1,
    STATE(305), 1,
      sym_comment,
    STATE(306), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(330), 1,
      sym__interpolation_string_content,
    STATE(331), 2,
      sym__escape_sequence,
      sym_interpolation,
  [20835] = 11,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(919), 1,
      sym_escape_sequence,
    ACTIONS(922), 1,
      anon_sym_LBRACE,
    ACTIONS(925), 1,
      anon_sym_BQUOTE,
    ACTIONS(927), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(930), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(933), 1,
      aux_sym__escape_sequence_token1,
    STATE(330), 1,
      sym__interpolation_string_content,
    STATE(306), 2,
      sym_comment,
      aux_sym__interpolated_string_repeat1,
    STATE(331), 2,
      sym__escape_sequence,
      sym_interpolation,
  [20871] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(905), 1,
      sym_escape_sequence,
    ACTIONS(907), 1,
      anon_sym_LBRACE,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(913), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(915), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(917), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(936), 1,
      anon_sym_BQUOTE,
    STATE(306), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(307), 1,
      sym_comment,
    STATE(330), 1,
      sym__interpolation_string_content,
    STATE(331), 2,
      sym__escape_sequence,
      sym_interpolation,
  [20909] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(905), 1,
      sym_escape_sequence,
    ACTIONS(907), 1,
      anon_sym_LBRACE,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(913), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(915), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(917), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(938), 1,
      anon_sym_BQUOTE,
    STATE(307), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(308), 1,
      sym_comment,
    STATE(330), 1,
      sym__interpolation_string_content,
    STATE(331), 2,
      sym__escape_sequence,
      sym_interpolation,
  [20947] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(905), 1,
      sym_escape_sequence,
    ACTIONS(907), 1,
      anon_sym_LBRACE,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(913), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(915), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(917), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(940), 1,
      anon_sym_BQUOTE,
    STATE(305), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(309), 1,
      sym_comment,
    STATE(330), 1,
      sym__interpolation_string_content,
    STATE(331), 2,
      sym__escape_sequence,
      sym_interpolation,
  [20985] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(620), 1,
      anon_sym_else,
    ACTIONS(942), 1,
      anon_sym_COMMA,
    STATE(310), 2,
      sym_comment,
      aux_sym__expression_list_repeat1,
    ACTIONS(618), 7,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
      anon_sym_RPAREN,
  [21011] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(905), 1,
      sym_escape_sequence,
    ACTIONS(907), 1,
      anon_sym_LBRACE,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(913), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(915), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(917), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(945), 1,
      anon_sym_BQUOTE,
    STATE(311), 1,
      sym_comment,
    STATE(312), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(330), 1,
      sym__interpolation_string_content,
    STATE(331), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21049] = 12,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(905), 1,
      sym_escape_sequence,
    ACTIONS(907), 1,
      anon_sym_LBRACE,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(913), 1,
      aux_sym__interpolation_string_content_token1,
    ACTIONS(915), 1,
      anon_sym_BSLASH_LBRACE,
    ACTIONS(917), 1,
      aux_sym__escape_sequence_token1,
    ACTIONS(947), 1,
      anon_sym_BQUOTE,
    STATE(306), 1,
      aux_sym__interpolated_string_repeat1,
    STATE(312), 1,
      sym_comment,
    STATE(330), 1,
      sym__interpolation_string_content,
    STATE(331), 2,
      sym__escape_sequence,
      sym_interpolation,
  [21087] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(949), 1,
      anon_sym_DOT,
    ACTIONS(951), 1,
      anon_sym_COLON,
    ACTIONS(953), 1,
      anon_sym_LT,
    STATE(22), 1,
      aux_sym_field_type_repeat1,
    STATE(313), 1,
      sym_comment,
    ACTIONS(132), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21116] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(314), 1,
      sym_comment,
    ACTIONS(73), 9,
      sym__block_string_start,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
  [21137] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(949), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LT,
    ACTIONS(955), 1,
      anon_sym_COLON,
    STATE(22), 1,
      aux_sym_field_type_repeat1,
    STATE(315), 1,
      sym_comment,
    ACTIONS(132), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21166] = 12,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(957), 1,
      anon_sym_EQ,
    ACTIONS(959), 1,
      anon_sym_PLUS_EQ,
    ACTIONS(961), 1,
      anon_sym_DASH_EQ,
    ACTIONS(963), 1,
      anon_sym_STAR_EQ,
    ACTIONS(965), 1,
      anon_sym_SLASH_EQ,
    ACTIONS(967), 1,
      anon_sym_PERCENT_EQ,
    ACTIONS(969), 1,
      anon_sym_SLASH_SLASH_EQ,
    ACTIONS(971), 1,
      anon_sym_CARET_EQ,
    ACTIONS(973), 1,
      anon_sym_DOT_DOT_EQ,
    STATE(316), 1,
      sym_comment,
  [21203] = 10,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(975), 1,
      sym_identifier,
    STATE(284), 1,
      sym_variable,
    STATE(301), 1,
      sym__prefix_expression,
    STATE(302), 1,
      sym_method_index_expression,
    STATE(317), 1,
      sym_comment,
    STATE(2), 2,
      sym_bracket_index_expression,
      sym_dot_index_expression,
    STATE(314), 2,
      sym_function_call,
      sym_parenthesized_expression,
  [21236] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(949), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LT,
    ACTIONS(977), 1,
      anon_sym_COLON,
    STATE(22), 1,
      aux_sym_field_type_repeat1,
    STATE(318), 1,
      sym_comment,
    ACTIONS(132), 5,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21265] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(634), 1,
      anon_sym_COMMA,
    ACTIONS(981), 1,
      anon_sym_else,
    STATE(310), 1,
      aux_sym__expression_list_repeat1,
    STATE(319), 1,
      sym_comment,
    ACTIONS(979), 6,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_do,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [21292] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(949), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LT,
    ACTIONS(983), 1,
      anon_sym_COLON,
    STATE(22), 1,
      aux_sym_field_type_repeat1,
    STATE(320), 1,
      sym_comment,
    ACTIONS(132), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21321] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(949), 1,
      anon_sym_DOT,
    ACTIONS(953), 1,
      anon_sym_LT,
    ACTIONS(985), 1,
      anon_sym_COLON,
    STATE(22), 1,
      aux_sym_field_type_repeat1,
    STATE(321), 1,
      sym_comment,
    ACTIONS(132), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21350] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(987), 1,
      anon_sym_DOT,
    ACTIONS(989), 1,
      anon_sym_LT,
    STATE(322), 1,
      sym_comment,
    STATE(324), 1,
      aux_sym_field_type_repeat1,
    ACTIONS(132), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21376] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(991), 1,
      anon_sym_DOT,
    STATE(323), 2,
      sym_comment,
      aux_sym_field_type_repeat1,
    ACTIONS(125), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21397] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(987), 1,
      anon_sym_DOT,
    STATE(323), 1,
      aux_sym_field_type_repeat1,
    STATE(324), 1,
      sym_comment,
    ACTIONS(119), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21420] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(994), 1,
      anon_sym_COMMA,
    ACTIONS(996), 1,
      anon_sym_RBRACE,
    STATE(325), 1,
      sym_comment,
    STATE(454), 1,
      aux_sym_tuple_type_repeat1,
  [21448] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1000), 1,
      anon_sym_RPAREN,
    STATE(326), 1,
      sym_comment,
    STATE(445), 1,
      aux_sym_tuple_type_repeat1,
  [21476] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1004), 1,
      anon_sym_SEMI,
    ACTIONS(1006), 1,
      anon_sym_else,
    STATE(327), 1,
      sym_comment,
    ACTIONS(1002), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [21498] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1010), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(328), 1,
      sym_comment,
    ACTIONS(1008), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [21518] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1014), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(329), 1,
      sym_comment,
    ACTIONS(1012), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [21538] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1018), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(330), 1,
      sym_comment,
    ACTIONS(1016), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [21558] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1022), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(331), 1,
      sym_comment,
    ACTIONS(1020), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [21578] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1024), 1,
      anon_sym_DASH_GT,
    STATE(332), 1,
      sym_comment,
    ACTIONS(144), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21598] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(1026), 1,
      anon_sym_COMMA,
    ACTIONS(1028), 1,
      anon_sym_RPAREN,
    STATE(333), 1,
      sym_comment,
    STATE(440), 1,
      aux_sym_function_type_repeat1,
  [21626] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(334), 1,
      sym_comment,
    ACTIONS(1030), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [21650] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(540), 1,
      anon_sym_RBRACE,
    ACTIONS(1032), 1,
      anon_sym_COMMA,
    STATE(335), 1,
      sym_comment,
    STATE(442), 1,
      aux_sym_object_type_repeat1,
  [21678] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1034), 1,
      anon_sym_DASH_GT,
    STATE(336), 1,
      sym_comment,
    ACTIONS(138), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21698] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(337), 1,
      sym_comment,
    ACTIONS(125), 6,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21716] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1038), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(338), 1,
      sym_comment,
    ACTIONS(1036), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [21736] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1040), 1,
      anon_sym_COMMA,
    ACTIONS(1042), 1,
      anon_sym_GT,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(339), 1,
      sym_comment,
    STATE(462), 1,
      aux_sym_tuple_type_repeat1,
  [21764] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1050), 1,
      anon_sym_DASH_GT,
    STATE(340), 1,
      sym_comment,
    ACTIONS(150), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [21784] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1052), 1,
      sym_identifier,
    ACTIONS(1054), 1,
      anon_sym_RPAREN,
    STATE(341), 1,
      sym_comment,
    STATE(447), 1,
      sym_vararg_expression,
    STATE(459), 1,
      sym_parameter,
    STATE(515), 1,
      sym__parameter_list,
  [21812] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(572), 1,
      anon_sym_RPAREN,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    STATE(342), 1,
      sym_comment,
    STATE(446), 1,
      aux_sym_tuple_type_repeat1,
  [21840] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1014), 1,
      aux_sym__interpolation_string_content_token1,
    STATE(343), 1,
      sym_comment,
    ACTIONS(1012), 5,
      sym_escape_sequence,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
      anon_sym_BSLASH_LBRACE,
      aux_sym__escape_sequence_token1,
  [21860] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1056), 1,
      anon_sym_RPAREN,
    STATE(344), 1,
      sym_comment,
    STATE(452), 1,
      aux_sym_tuple_type_repeat1,
  [21888] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(345), 1,
      sym_comment,
    ACTIONS(1058), 6,
      sym__block_string_start,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_BQUOTE,
  [21906] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1060), 1,
      anon_sym_RPAREN,
    STATE(346), 1,
      sym_comment,
    STATE(453), 1,
      aux_sym_tuple_type_repeat1,
  [21934] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1040), 1,
      anon_sym_COMMA,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    ACTIONS(1062), 1,
      anon_sym_GT,
    STATE(347), 1,
      sym_comment,
    STATE(456), 1,
      aux_sym_tuple_type_repeat1,
  [21962] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(578), 1,
      anon_sym_RBRACE,
    ACTIONS(1064), 1,
      anon_sym_COMMA,
    STATE(348), 1,
      sym_comment,
    STATE(458), 1,
      aux_sym_object_type_repeat1,
  [21990] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(180), 1,
      anon_sym_else,
    ACTIONS(1066), 1,
      anon_sym_end,
    ACTIONS(1068), 1,
      anon_sym_elseif,
    STATE(349), 1,
      sym_comment,
    STATE(396), 1,
      aux_sym_if_statement_repeat1,
    STATE(438), 1,
      sym_elseif_statement,
    STATE(539), 1,
      sym_else_statement,
  [22018] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(180), 1,
      anon_sym_else,
    ACTIONS(1068), 1,
      anon_sym_elseif,
    ACTIONS(1070), 1,
      anon_sym_end,
    STATE(350), 1,
      sym_comment,
    STATE(396), 1,
      aux_sym_if_statement_repeat1,
    STATE(438), 1,
      sym_elseif_statement,
    STATE(518), 1,
      sym_else_statement,
  [22046] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1072), 1,
      anon_sym_RPAREN,
    STATE(351), 1,
      sym_comment,
    STATE(473), 1,
      aux_sym_tuple_type_repeat1,
  [22074] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1074), 1,
      anon_sym_RPAREN,
    STATE(352), 1,
      sym_comment,
    STATE(465), 1,
      aux_sym_tuple_type_repeat1,
  [22102] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(1076), 1,
      anon_sym_COMMA,
    ACTIONS(1078), 1,
      anon_sym_RPAREN,
    STATE(353), 1,
      sym_comment,
    STATE(467), 1,
      aux_sym_function_type_repeat1,
  [22130] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(180), 1,
      anon_sym_else,
    ACTIONS(1068), 1,
      anon_sym_elseif,
    ACTIONS(1080), 1,
      anon_sym_end,
    STATE(349), 1,
      aux_sym_if_statement_repeat1,
    STATE(354), 1,
      sym_comment,
    STATE(438), 1,
      sym_elseif_statement,
    STATE(506), 1,
      sym_else_statement,
  [22158] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(584), 1,
      anon_sym_RPAREN,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    STATE(355), 1,
      sym_comment,
    STATE(469), 1,
      aux_sym_tuple_type_repeat1,
  [22186] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1082), 1,
      anon_sym_RPAREN,
    STATE(356), 1,
      sym_comment,
    STATE(471), 1,
      aux_sym_tuple_type_repeat1,
  [22214] = 9,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(1084), 1,
      anon_sym_COMMA,
    ACTIONS(1086), 1,
      anon_sym_RBRACE,
    STATE(357), 1,
      sym_comment,
    STATE(443), 1,
      aux_sym_tuple_type_repeat1,
  [22242] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(358), 1,
      sym_comment,
    ACTIONS(91), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22259] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(359), 1,
      sym_comment,
    ACTIONS(1030), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22282] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(360), 1,
      sym_comment,
    ACTIONS(190), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22305] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(361), 1,
      sym_comment,
    ACTIONS(194), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22322] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(362), 1,
      sym_comment,
    ACTIONS(198), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22339] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(363), 1,
      sym_comment,
    ACTIONS(202), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22362] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(364), 1,
      sym_comment,
    ACTIONS(206), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22379] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(365), 1,
      sym_comment,
    ACTIONS(210), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22396] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(366), 1,
      sym_comment,
    ACTIONS(214), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22419] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(367), 1,
      sym_comment,
    ACTIONS(1088), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [22442] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(368), 1,
      sym_comment,
    ACTIONS(218), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22459] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(369), 1,
      sym_comment,
    ACTIONS(222), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22482] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(370), 1,
      sym_comment,
    ACTIONS(226), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22499] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(371), 1,
      sym_comment,
    ACTIONS(230), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22522] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(372), 1,
      sym_comment,
    ACTIONS(1090), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [22545] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(373), 1,
      sym_comment,
    ACTIONS(234), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22568] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(374), 1,
      sym_comment,
    ACTIONS(238), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22591] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(375), 1,
      sym_comment,
    ACTIONS(246), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22608] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(376), 1,
      sym_comment,
    ACTIONS(242), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22631] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1006), 1,
      anon_sym_else,
    STATE(377), 1,
      sym_comment,
    ACTIONS(1002), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [22650] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1044), 1,
      anon_sym_PIPE,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    ACTIONS(1048), 1,
      anon_sym_QMARK,
    STATE(378), 1,
      sym_comment,
    ACTIONS(182), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [22673] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(379), 1,
      sym_comment,
    ACTIONS(95), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22690] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(380), 1,
      sym_comment,
    ACTIONS(99), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22707] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(381), 1,
      sym_comment,
    ACTIONS(83), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22724] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(382), 1,
      sym_comment,
    ACTIONS(107), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22741] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(383), 1,
      sym_comment,
    ACTIONS(111), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22758] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(384), 1,
      sym_comment,
    ACTIONS(75), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22775] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1092), 1,
      anon_sym_COMMA,
    ACTIONS(1094), 1,
      anon_sym_GT,
    ACTIONS(1096), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(385), 1,
      sym_comment,
    STATE(439), 1,
      aux_sym_generic_type_list_repeat1,
    STATE(461), 1,
      sym_vararg_expression,
  [22800] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(386), 1,
      sym_comment,
    ACTIONS(250), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22817] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1098), 1,
      sym_identifier,
    STATE(387), 1,
      sym_comment,
    STATE(402), 1,
      sym__function_name,
    STATE(416), 1,
      sym__function_name_prefix_expression,
    STATE(420), 1,
      sym__function_name_dot_index_expression,
    STATE(478), 1,
      sym__function_name_method_index_expression,
  [22842] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(388), 1,
      sym_comment,
    ACTIONS(258), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22859] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(389), 1,
      sym_comment,
    ACTIONS(254), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [22876] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1102), 1,
      anon_sym_else,
    STATE(390), 1,
      sym_comment,
    ACTIONS(1100), 4,
      ts_builtin_sym_end,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [22895] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(510), 1,
      anon_sym_RBRACE,
    STATE(115), 1,
      sym__field_sep,
    STATE(391), 1,
      sym_comment,
    STATE(393), 1,
      aux_sym__field_list_repeat1,
    ACTIONS(1104), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [22918] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1106), 1,
      anon_sym_LT,
    ACTIONS(1108), 1,
      anon_sym_LPAREN,
    STATE(94), 1,
      sym_parameters,
    STATE(243), 1,
      sym__function_body,
    STATE(392), 1,
      sym_comment,
    STATE(475), 1,
      sym_generic_type_list,
  [22943] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1113), 1,
      anon_sym_RBRACE,
    STATE(118), 1,
      sym__field_sep,
    ACTIONS(1110), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
    STATE(393), 2,
      sym_comment,
      aux_sym__field_list_repeat1,
  [22964] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    STATE(394), 1,
      sym_comment,
    ACTIONS(1115), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [22987] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(395), 1,
      sym_comment,
    ACTIONS(160), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23004] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1117), 1,
      anon_sym_end,
    ACTIONS(1119), 1,
      anon_sym_elseif,
    ACTIONS(1122), 1,
      anon_sym_else,
    STATE(438), 1,
      sym_elseif_statement,
    STATE(396), 2,
      sym_comment,
      aux_sym_if_statement_repeat1,
  [23027] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(397), 1,
      sym_comment,
    ACTIONS(132), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23044] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(398), 1,
      sym_comment,
    ACTIONS(164), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23061] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1106), 1,
      anon_sym_LT,
    ACTIONS(1108), 1,
      anon_sym_LPAREN,
    STATE(92), 1,
      sym__function_body,
    STATE(94), 1,
      sym_parameters,
    STATE(399), 1,
      sym_comment,
    STATE(475), 1,
      sym_generic_type_list,
  [23086] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1046), 1,
      anon_sym_AMP,
    STATE(400), 1,
      sym_comment,
    ACTIONS(168), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_QMARK,
  [23105] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(401), 1,
      sym_comment,
    ACTIONS(156), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23122] = 8,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1106), 1,
      anon_sym_LT,
    ACTIONS(1108), 1,
      anon_sym_LPAREN,
    STATE(94), 1,
      sym_parameters,
    STATE(258), 1,
      sym__function_body,
    STATE(402), 1,
      sym_comment,
    STATE(475), 1,
      sym_generic_type_list,
  [23147] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1124), 1,
      anon_sym_RBRACE,
    STATE(112), 1,
      sym__field_sep,
    STATE(391), 1,
      aux_sym__field_list_repeat1,
    STATE(403), 1,
      sym_comment,
    ACTIONS(1104), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [23170] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(404), 1,
      sym_comment,
    ACTIONS(91), 5,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK,
  [23187] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1126), 1,
      anon_sym_DQUOTE,
    STATE(405), 1,
      sym_comment,
    STATE(433), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1128), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [23207] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1130), 1,
      anon_sym_EQ,
    ACTIONS(1132), 1,
      anon_sym_COMMA,
    ACTIONS(1134), 1,
      anon_sym_in,
    STATE(406), 1,
      sym_comment,
    STATE(468), 1,
      aux_sym__name_list_repeat1,
  [23229] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(407), 1,
      sym_comment,
    ACTIONS(1136), 4,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
  [23245] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1138), 1,
      anon_sym_COMMA,
    ACTIONS(1030), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(408), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [23263] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1141), 1,
      anon_sym_DQUOTE,
    ACTIONS(1143), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
    STATE(409), 2,
      aux_sym__doublequote_string_content,
      sym_comment,
  [23281] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1146), 1,
      anon_sym_SQUOTE,
    ACTIONS(1148), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
    STATE(410), 2,
      aux_sym__singlequote_string_content,
      sym_comment,
  [23299] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1151), 1,
      sym_identifier,
    STATE(411), 1,
      sym_comment,
    STATE(482), 1,
      sym__name_list,
    STATE(516), 2,
      sym_for_generic_clause,
      sym_for_numeric_clause,
  [23319] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(1153), 1,
      anon_sym_EQ,
    STATE(412), 1,
      sym_comment,
  [23341] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(1155), 1,
      anon_sym_EQ,
    STATE(413), 1,
      sym_comment,
  [23363] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1096), 1,
      anon_sym_DOT_DOT_DOT,
    STATE(414), 1,
      sym_comment,
    STATE(477), 1,
      sym_vararg_expression,
    ACTIONS(1157), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [23383] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(333), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(1052), 1,
      sym_identifier,
    STATE(415), 1,
      sym_comment,
    STATE(447), 1,
      sym_vararg_expression,
    STATE(476), 1,
      sym_parameter,
  [23405] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1159), 1,
      anon_sym_DOT,
    ACTIONS(1161), 1,
      anon_sym_COLON,
    STATE(416), 1,
      sym_comment,
    ACTIONS(1163), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [23425] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(172), 1,
      anon_sym_AMP,
    ACTIONS(186), 1,
      anon_sym_PIPE,
    ACTIONS(188), 1,
      anon_sym_QMARK,
    ACTIONS(1165), 1,
      anon_sym_RBRACK,
    STATE(417), 1,
      sym_comment,
  [23447] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1169), 1,
      anon_sym_else,
    STATE(418), 1,
      sym_comment,
    ACTIONS(1167), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [23465] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1171), 1,
      sym_identifier,
    ACTIONS(1173), 1,
      anon_sym_function,
    STATE(241), 1,
      sym__att_name_list,
    STATE(256), 1,
      sym__local_variable_assignment,
    STATE(419), 1,
      sym_comment,
  [23487] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(420), 1,
      sym_comment,
    ACTIONS(1175), 4,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
  [23503] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(424), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      sym_identifier,
    ACTIONS(1179), 1,
      anon_sym_RBRACE,
    STATE(421), 1,
      sym_comment,
    STATE(544), 1,
      sym_object_field_type,
  [23525] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1181), 1,
      anon_sym_DQUOTE,
    STATE(422), 1,
      sym_comment,
    STATE(429), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1128), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [23545] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(423), 1,
      sym_comment,
    ACTIONS(1183), 4,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_LT,
      anon_sym_LPAREN,
  [23561] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1181), 1,
      anon_sym_SQUOTE,
    STATE(424), 1,
      sym_comment,
    STATE(436), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1185), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [23581] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1187), 1,
      anon_sym_DQUOTE,
    STATE(425), 1,
      sym_comment,
    STATE(427), 1,
      aux_sym__doublequote_string_content,
    ACTIONS(1128), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [23601] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1187), 1,
      anon_sym_SQUOTE,
    STATE(426), 1,
      sym_comment,
    STATE(428), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1185), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [23621] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1189), 1,
      anon_sym_DQUOTE,
    STATE(409), 1,
      aux_sym__doublequote_string_content,
    STATE(427), 1,
      sym_comment,
    ACTIONS(1128), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [23641] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1189), 1,
      anon_sym_SQUOTE,
    STATE(410), 1,
      aux_sym__singlequote_string_content,
    STATE(428), 1,
      sym_comment,
    ACTIONS(1185), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [23661] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1191), 1,
      anon_sym_DQUOTE,
    STATE(409), 1,
      aux_sym__doublequote_string_content,
    STATE(429), 1,
      sym_comment,
    ACTIONS(1128), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [23681] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(424), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      sym_identifier,
    ACTIONS(1193), 1,
      anon_sym_RBRACE,
    STATE(430), 1,
      sym_comment,
    STATE(544), 1,
      sym_object_field_type,
  [23703] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(424), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      sym_identifier,
    ACTIONS(1195), 1,
      anon_sym_RBRACE,
    STATE(431), 1,
      sym_comment,
    STATE(544), 1,
      sym_object_field_type,
  [23725] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1126), 1,
      anon_sym_SQUOTE,
    STATE(432), 1,
      sym_comment,
    STATE(434), 1,
      aux_sym__singlequote_string_content,
    ACTIONS(1185), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [23745] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1197), 1,
      anon_sym_DQUOTE,
    STATE(409), 1,
      aux_sym__doublequote_string_content,
    STATE(433), 1,
      sym_comment,
    ACTIONS(1128), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [23765] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1197), 1,
      anon_sym_SQUOTE,
    STATE(410), 1,
      aux_sym__singlequote_string_content,
    STATE(434), 1,
      sym_comment,
    ACTIONS(1185), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [23785] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(390), 1,
      anon_sym_else,
    STATE(435), 1,
      sym_comment,
    ACTIONS(1199), 3,
      anon_sym_end,
      anon_sym_until,
      anon_sym_elseif,
  [23803] = 6,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1191), 1,
      anon_sym_SQUOTE,
    STATE(410), 1,
      aux_sym__singlequote_string_content,
    STATE(436), 1,
      sym_comment,
    ACTIONS(1185), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [23823] = 7,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(424), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      sym_identifier,
    ACTIONS(1201), 1,
      anon_sym_RBRACE,
    STATE(437), 1,
      sym_comment,
    STATE(544), 1,
      sym_object_field_type,
  [23845] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1205), 1,
      anon_sym_else,
    STATE(438), 1,
      sym_comment,
    ACTIONS(1203), 2,
      anon_sym_end,
      anon_sym_elseif,
  [23862] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1092), 1,
      anon_sym_COMMA,
    ACTIONS(1207), 1,
      anon_sym_GT,
    STATE(439), 1,
      sym_comment,
    STATE(451), 1,
      aux_sym_generic_type_list_repeat1,
  [23881] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(546), 1,
      anon_sym_RPAREN,
    ACTIONS(1209), 1,
      anon_sym_COMMA,
    STATE(440), 1,
      sym_comment,
    STATE(466), 1,
      aux_sym_function_type_repeat1,
  [23900] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(424), 1,
      anon_sym_LBRACK,
    ACTIONS(1177), 1,
      sym_identifier,
    STATE(441), 1,
      sym_comment,
    STATE(544), 1,
      sym_object_field_type,
  [23919] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1179), 1,
      anon_sym_RBRACE,
    ACTIONS(1211), 1,
      anon_sym_COMMA,
    STATE(442), 1,
      sym_comment,
    STATE(472), 1,
      aux_sym_object_type_repeat1,
  [23938] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(532), 1,
      anon_sym_RBRACE,
    ACTIONS(1213), 1,
      anon_sym_COMMA,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(443), 1,
      sym_comment,
  [23957] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(634), 1,
      anon_sym_COMMA,
    ACTIONS(1215), 1,
      anon_sym_RPAREN,
    STATE(310), 1,
      aux_sym__expression_list_repeat1,
    STATE(444), 1,
      sym_comment,
  [23976] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1217), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(445), 1,
      sym_comment,
  [23995] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1000), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(446), 1,
      sym_comment,
  [24014] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1221), 1,
      anon_sym_COLON,
    STATE(447), 1,
      sym_comment,
    ACTIONS(1219), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [24031] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1092), 1,
      anon_sym_COMMA,
    ACTIONS(1223), 1,
      anon_sym_GT,
    STATE(448), 1,
      sym_comment,
    STATE(451), 1,
      aux_sym_generic_type_list_repeat1,
  [24050] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1225), 1,
      anon_sym_DQUOTE,
    STATE(449), 1,
      sym_comment,
    ACTIONS(1227), 2,
      aux_sym__doublequote_string_content_token1,
      sym_escape_sequence,
  [24067] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1231), 1,
      anon_sym_else,
    STATE(450), 1,
      sym_comment,
    ACTIONS(1229), 2,
      anon_sym_end,
      anon_sym_elseif,
  [24084] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1157), 1,
      anon_sym_GT,
    ACTIONS(1233), 1,
      anon_sym_COMMA,
    STATE(451), 2,
      sym_comment,
      aux_sym_generic_type_list_repeat1,
  [24101] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1236), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(452), 1,
      sym_comment,
  [24120] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1238), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(453), 1,
      sym_comment,
  [24139] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(576), 1,
      anon_sym_RBRACE,
    ACTIONS(1240), 1,
      anon_sym_COMMA,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(454), 1,
      sym_comment,
  [24158] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1242), 1,
      anon_sym_COMMA,
    ACTIONS(1245), 1,
      anon_sym_in,
    STATE(455), 2,
      sym_comment,
      aux_sym__name_list_repeat1,
  [24175] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1040), 1,
      anon_sym_COMMA,
    ACTIONS(1247), 1,
      anon_sym_GT,
    STATE(456), 1,
      sym_comment,
    STATE(464), 1,
      aux_sym_tuple_type_repeat1,
  [24194] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1249), 1,
      anon_sym_COMMA,
    ACTIONS(1252), 1,
      anon_sym_RPAREN,
    STATE(457), 2,
      sym_comment,
      aux_sym__parameter_list_repeat1,
  [24211] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1193), 1,
      anon_sym_RBRACE,
    ACTIONS(1254), 1,
      anon_sym_COMMA,
    STATE(458), 1,
      sym_comment,
    STATE(472), 1,
      aux_sym_object_type_repeat1,
  [24230] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1256), 1,
      anon_sym_COMMA,
    ACTIONS(1258), 1,
      anon_sym_RPAREN,
    STATE(459), 1,
      sym_comment,
    STATE(460), 1,
      aux_sym__parameter_list_repeat1,
  [24249] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1256), 1,
      anon_sym_COMMA,
    ACTIONS(1260), 1,
      anon_sym_RPAREN,
    STATE(457), 1,
      aux_sym__parameter_list_repeat1,
    STATE(460), 1,
      sym_comment,
  [24268] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1092), 1,
      anon_sym_COMMA,
    ACTIONS(1207), 1,
      anon_sym_GT,
    STATE(448), 1,
      aux_sym_generic_type_list_repeat1,
    STATE(461), 1,
      sym_comment,
  [24287] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1040), 1,
      anon_sym_COMMA,
    ACTIONS(1262), 1,
      anon_sym_GT,
    STATE(462), 1,
      sym_comment,
    STATE(464), 1,
      aux_sym_tuple_type_repeat1,
  [24306] = 5,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1264), 1,
      anon_sym_SQUOTE,
    STATE(463), 1,
      sym_comment,
    ACTIONS(1266), 2,
      aux_sym__singlequote_string_content_token1,
      sym_escape_sequence,
  [24323] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1030), 1,
      anon_sym_GT,
    ACTIONS(1268), 1,
      anon_sym_COMMA,
    STATE(464), 2,
      sym_comment,
      aux_sym_tuple_type_repeat1,
  [24340] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1078), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(465), 1,
      sym_comment,
  [24359] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1271), 1,
      anon_sym_COMMA,
    ACTIONS(1274), 1,
      anon_sym_RPAREN,
    STATE(466), 2,
      sym_comment,
      aux_sym_function_type_repeat1,
  [24376] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(582), 1,
      anon_sym_RPAREN,
    ACTIONS(1276), 1,
      anon_sym_COMMA,
    STATE(466), 1,
      aux_sym_function_type_repeat1,
    STATE(467), 1,
      sym_comment,
  [24395] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1132), 1,
      anon_sym_COMMA,
    ACTIONS(1278), 1,
      anon_sym_in,
    STATE(455), 1,
      aux_sym__name_list_repeat1,
    STATE(468), 1,
      sym_comment,
  [24414] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1082), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(469), 1,
      sym_comment,
  [24433] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(470), 1,
      sym_comment,
    ACTIONS(1113), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [24448] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1280), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(471), 1,
      sym_comment,
  [24467] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1282), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_RBRACE,
    STATE(472), 2,
      sym_comment,
      aux_sym_object_type_repeat1,
  [24484] = 6,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(998), 1,
      anon_sym_COMMA,
    ACTIONS(1028), 1,
      anon_sym_RPAREN,
    STATE(408), 1,
      aux_sym_tuple_type_repeat1,
    STATE(473), 1,
      sym_comment,
  [24503] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(474), 1,
      sym_comment,
    ACTIONS(1287), 2,
      anon_sym_COMMA,
      anon_sym_in,
  [24517] = 5,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1108), 1,
      anon_sym_LPAREN,
    STATE(76), 1,
      sym_parameters,
    STATE(475), 1,
      sym_comment,
  [24533] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(476), 1,
      sym_comment,
    ACTIONS(1252), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [24547] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(477), 1,
      sym_comment,
    ACTIONS(1289), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [24561] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(478), 1,
      sym_comment,
    ACTIONS(1291), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [24575] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(479), 1,
      sym_comment,
    ACTIONS(1293), 2,
      anon_sym_LT,
      anon_sym_LPAREN,
  [24589] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    STATE(480), 1,
      sym_comment,
    ACTIONS(311), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [24603] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1295), 1,
      sym__block_comment_content,
    STATE(481), 1,
      sym_comment,
  [24616] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1297), 1,
      anon_sym_in,
    STATE(482), 1,
      sym_comment,
  [24629] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1299), 1,
      sym_identifier,
    STATE(483), 1,
      sym_comment,
  [24642] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1301), 1,
      anon_sym_DASH_GT,
    STATE(484), 1,
      sym_comment,
  [24655] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1303), 1,
      anon_sym_type,
    STATE(485), 1,
      sym_comment,
  [24668] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1305), 1,
      sym_identifier,
    STATE(486), 1,
      sym_comment,
  [24681] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1307), 1,
      anon_sym_end,
    STATE(487), 1,
      sym_comment,
  [24694] = 4,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(909), 1,
      anon_sym_DASH_DASH,
    ACTIONS(1309), 1,
      aux_sym_comment_token1,
    STATE(488), 1,
      sym_comment,
  [24707] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1311), 1,
      anon_sym_do,
    STATE(489), 1,
      sym_comment,
  [24720] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1313), 1,
      anon_sym_DASH_GT,
    STATE(490), 1,
      sym_comment,
  [24733] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1315), 1,
      sym__block_comment_end,
    STATE(491), 1,
      sym_comment,
  [24746] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1317), 1,
      sym_identifier,
    STATE(492), 1,
      sym_comment,
  [24759] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(520), 1,
      ts_builtin_sym_end,
    STATE(493), 1,
      sym_comment,
  [24772] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1319), 1,
      anon_sym_LPAREN,
    STATE(494), 1,
      sym_comment,
  [24785] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1321), 1,
      anon_sym_RBRACE,
    STATE(495), 1,
      sym_comment,
  [24798] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1323), 1,
      anon_sym_end,
    STATE(496), 1,
      sym_comment,
  [24811] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(983), 1,
      anon_sym_COLON,
    STATE(497), 1,
      sym_comment,
  [24824] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(154), 1,
      anon_sym_DASH_GT,
    STATE(498), 1,
      sym_comment,
  [24837] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1325), 1,
      anon_sym_LPAREN,
    STATE(499), 1,
      sym_comment,
  [24850] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1327), 1,
      anon_sym_end,
    STATE(500), 1,
      sym_comment,
  [24863] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(142), 1,
      anon_sym_DASH_GT,
    STATE(501), 1,
      sym_comment,
  [24876] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1329), 1,
      sym__block_string_end,
    STATE(502), 1,
      sym_comment,
  [24889] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1331), 1,
      anon_sym_COLON,
    STATE(503), 1,
      sym_comment,
  [24902] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1333), 1,
      sym_identifier,
    STATE(504), 1,
      sym_comment,
  [24915] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1335), 1,
      anon_sym_RBRACE,
    STATE(505), 1,
      sym_comment,
  [24928] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1337), 1,
      anon_sym_end,
    STATE(506), 1,
      sym_comment,
  [24941] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1339), 1,
      ts_builtin_sym_end,
    STATE(507), 1,
      sym_comment,
  [24954] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(996), 1,
      anon_sym_RBRACE,
    STATE(508), 1,
      sym_comment,
  [24967] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1341), 1,
      anon_sym_LPAREN,
    STATE(509), 1,
      sym_comment,
  [24980] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1343), 1,
      sym_identifier,
    STATE(510), 1,
      sym_comment,
  [24993] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1345), 1,
      anon_sym_end,
    STATE(511), 1,
      sym_comment,
  [25006] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1034), 1,
      anon_sym_DASH_GT,
    STATE(512), 1,
      sym_comment,
  [25019] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1347), 1,
      anon_sym_DASH_GT,
    STATE(513), 1,
      sym_comment,
  [25032] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1349), 1,
      sym__block_string_end,
    STATE(514), 1,
      sym_comment,
  [25045] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1351), 1,
      anon_sym_RPAREN,
    STATE(515), 1,
      sym_comment,
  [25058] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1353), 1,
      anon_sym_do,
    STATE(516), 1,
      sym_comment,
  [25071] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1050), 1,
      anon_sym_DASH_GT,
    STATE(517), 1,
      sym_comment,
  [25084] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1355), 1,
      anon_sym_end,
    STATE(518), 1,
      sym_comment,
  [25097] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(508), 1,
      ts_builtin_sym_end,
    STATE(519), 1,
      sym_comment,
  [25110] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1357), 1,
      anon_sym_end,
    STATE(520), 1,
      sym_comment,
  [25123] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1359), 1,
      anon_sym_DASH_GT,
    STATE(521), 1,
      sym_comment,
  [25136] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1361), 1,
      sym_identifier,
    STATE(522), 1,
      sym_comment,
  [25149] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1086), 1,
      anon_sym_RBRACE,
    STATE(523), 1,
      sym_comment,
  [25162] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1363), 1,
      anon_sym_DASH_GT,
    STATE(524), 1,
      sym_comment,
  [25175] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1365), 1,
      sym_identifier,
    STATE(525), 1,
      sym_comment,
  [25188] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1367), 1,
      anon_sym_DASH_GT,
    STATE(526), 1,
      sym_comment,
  [25201] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1369), 1,
      anon_sym_DASH_GT,
    STATE(527), 1,
      sym_comment,
  [25214] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1371), 1,
      anon_sym_DASH_GT,
    STATE(528), 1,
      sym_comment,
  [25227] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1373), 1,
      anon_sym_DASH_GT,
    STATE(529), 1,
      sym_comment,
  [25240] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1375), 1,
      sym__block_string_content,
    STATE(530), 1,
      sym_comment,
  [25253] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1377), 1,
      sym_identifier,
    STATE(531), 1,
      sym_comment,
  [25266] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1379), 1,
      sym__block_string_end,
    STATE(532), 1,
      sym_comment,
  [25279] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1381), 1,
      anon_sym_GT,
    STATE(533), 1,
      sym_comment,
  [25292] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1383), 1,
      anon_sym_end,
    STATE(534), 1,
      sym_comment,
  [25305] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1385), 1,
      anon_sym_LPAREN,
    STATE(535), 1,
      sym_comment,
  [25318] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1387), 1,
      sym__block_string_content,
    STATE(536), 1,
      sym_comment,
  [25331] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1389), 1,
      sym_identifier,
    STATE(537), 1,
      sym_comment,
  [25344] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1391), 1,
      anon_sym_until,
    STATE(538), 1,
      sym_comment,
  [25357] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1393), 1,
      anon_sym_end,
    STATE(539), 1,
      sym_comment,
  [25370] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1395), 1,
      anon_sym_end,
    STATE(540), 1,
      sym_comment,
  [25383] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1397), 1,
      anon_sym_EQ,
    STATE(541), 1,
      sym_comment,
  [25396] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1399), 1,
      sym_identifier,
    STATE(542), 1,
      sym_comment,
  [25409] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1401), 1,
      anon_sym_end,
    STATE(543), 1,
      sym_comment,
  [25422] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1403), 1,
      anon_sym_COLON,
    STATE(544), 1,
      sym_comment,
  [25435] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(955), 1,
      anon_sym_COLON,
    STATE(545), 1,
      sym_comment,
  [25448] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1405), 1,
      sym_identifier,
    STATE(546), 1,
      sym_comment,
  [25461] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1407), 1,
      anon_sym_LPAREN,
    STATE(547), 1,
      sym_comment,
  [25474] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1409), 1,
      sym_identifier,
    STATE(548), 1,
      sym_comment,
  [25487] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1411), 1,
      sym__block_string_content,
    STATE(549), 1,
      sym_comment,
  [25500] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1413), 1,
      anon_sym_DASH_GT,
    STATE(550), 1,
      sym_comment,
  [25513] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(977), 1,
      anon_sym_COLON,
    STATE(551), 1,
      sym_comment,
  [25526] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1415), 1,
      anon_sym_end,
    STATE(552), 1,
      sym_comment,
  [25539] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1417), 1,
      sym_identifier,
    STATE(553), 1,
      sym_comment,
  [25552] = 4,
    ACTIONS(3), 1,
      anon_sym_DASH_DASH,
    ACTIONS(5), 1,
      sym__block_comment_start,
    ACTIONS(1419), 1,
      ts_builtin_sym_end,
    STATE(554), 1,
      sym_comment,
  [25565] = 1,
    ACTIONS(1421), 1,
      ts_builtin_sym_end,
  [25569] = 1,
    ACTIONS(1423), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 73,
  [SMALL_STATE(4)] = 146,
  [SMALL_STATE(5)] = 219,
  [SMALL_STATE(6)] = 283,
  [SMALL_STATE(7)] = 347,
  [SMALL_STATE(8)] = 411,
  [SMALL_STATE(9)] = 475,
  [SMALL_STATE(10)] = 543,
  [SMALL_STATE(11)] = 607,
  [SMALL_STATE(12)] = 671,
  [SMALL_STATE(13)] = 735,
  [SMALL_STATE(14)] = 799,
  [SMALL_STATE(15)] = 863,
  [SMALL_STATE(16)] = 927,
  [SMALL_STATE(17)] = 991,
  [SMALL_STATE(18)] = 1055,
  [SMALL_STATE(19)] = 1119,
  [SMALL_STATE(20)] = 1183,
  [SMALL_STATE(21)] = 1247,
  [SMALL_STATE(22)] = 1311,
  [SMALL_STATE(23)] = 1377,
  [SMALL_STATE(24)] = 1441,
  [SMALL_STATE(25)] = 1509,
  [SMALL_STATE(26)] = 1572,
  [SMALL_STATE(27)] = 1635,
  [SMALL_STATE(28)] = 1696,
  [SMALL_STATE(29)] = 1759,
  [SMALL_STATE(30)] = 1819,
  [SMALL_STATE(31)] = 1879,
  [SMALL_STATE(32)] = 1939,
  [SMALL_STATE(33)] = 1999,
  [SMALL_STATE(34)] = 2061,
  [SMALL_STATE(35)] = 2121,
  [SMALL_STATE(36)] = 2181,
  [SMALL_STATE(37)] = 2309,
  [SMALL_STATE(38)] = 2369,
  [SMALL_STATE(39)] = 2435,
  [SMALL_STATE(40)] = 2501,
  [SMALL_STATE(41)] = 2561,
  [SMALL_STATE(42)] = 2621,
  [SMALL_STATE(43)] = 2687,
  [SMALL_STATE(44)] = 2747,
  [SMALL_STATE(45)] = 2807,
  [SMALL_STATE(46)] = 2873,
  [SMALL_STATE(47)] = 2933,
  [SMALL_STATE(48)] = 2999,
  [SMALL_STATE(49)] = 3059,
  [SMALL_STATE(50)] = 3125,
  [SMALL_STATE(51)] = 3191,
  [SMALL_STATE(52)] = 3257,
  [SMALL_STATE(53)] = 3323,
  [SMALL_STATE(54)] = 3383,
  [SMALL_STATE(55)] = 3443,
  [SMALL_STATE(56)] = 3503,
  [SMALL_STATE(57)] = 3563,
  [SMALL_STATE(58)] = 3623,
  [SMALL_STATE(59)] = 3683,
  [SMALL_STATE(60)] = 3743,
  [SMALL_STATE(61)] = 3803,
  [SMALL_STATE(62)] = 3863,
  [SMALL_STATE(63)] = 3932,
  [SMALL_STATE(64)] = 4023,
  [SMALL_STATE(65)] = 4088,
  [SMALL_STATE(66)] = 4210,
  [SMALL_STATE(67)] = 4272,
  [SMALL_STATE(68)] = 4394,
  [SMALL_STATE(69)] = 4451,
  [SMALL_STATE(70)] = 4558,
  [SMALL_STATE(71)] = 4667,
  [SMALL_STATE(72)] = 4782,
  [SMALL_STATE(73)] = 4895,
  [SMALL_STATE(74)] = 4951,
  [SMALL_STATE(75)] = 5029,
  [SMALL_STATE(76)] = 5085,
  [SMALL_STATE(77)] = 5201,
  [SMALL_STATE(78)] = 5257,
  [SMALL_STATE(79)] = 5327,
  [SMALL_STATE(80)] = 5403,
  [SMALL_STATE(81)] = 5477,
  [SMALL_STATE(82)] = 5541,
  [SMALL_STATE(83)] = 5601,
  [SMALL_STATE(84)] = 5671,
  [SMALL_STATE(85)] = 5729,
  [SMALL_STATE(86)] = 5821,
  [SMALL_STATE(87)] = 5877,
  [SMALL_STATE(88)] = 5933,
  [SMALL_STATE(89)] = 5989,
  [SMALL_STATE(90)] = 6045,
  [SMALL_STATE(91)] = 6101,
  [SMALL_STATE(92)] = 6157,
  [SMALL_STATE(93)] = 6213,
  [SMALL_STATE(94)] = 6269,
  [SMALL_STATE(95)] = 6385,
  [SMALL_STATE(96)] = 6441,
  [SMALL_STATE(97)] = 6519,
  [SMALL_STATE(98)] = 6575,
  [SMALL_STATE(99)] = 6631,
  [SMALL_STATE(100)] = 6687,
  [SMALL_STATE(101)] = 6745,
  [SMALL_STATE(102)] = 6801,
  [SMALL_STATE(103)] = 6893,
  [SMALL_STATE(104)] = 7006,
  [SMALL_STATE(105)] = 7119,
  [SMALL_STATE(106)] = 7226,
  [SMALL_STATE(107)] = 7339,
  [SMALL_STATE(108)] = 7452,
  [SMALL_STATE(109)] = 7565,
  [SMALL_STATE(110)] = 7672,
  [SMALL_STATE(111)] = 7776,
  [SMALL_STATE(112)] = 7886,
  [SMALL_STATE(113)] = 7990,
  [SMALL_STATE(114)] = 8076,
  [SMALL_STATE(115)] = 8186,
  [SMALL_STATE(116)] = 8290,
  [SMALL_STATE(117)] = 8400,
  [SMALL_STATE(118)] = 8486,
  [SMALL_STATE(119)] = 8587,
  [SMALL_STATE(120)] = 8670,
  [SMALL_STATE(121)] = 8753,
  [SMALL_STATE(122)] = 8832,
  [SMALL_STATE(123)] = 8915,
  [SMALL_STATE(124)] = 8998,
  [SMALL_STATE(125)] = 9081,
  [SMALL_STATE(126)] = 9164,
  [SMALL_STATE(127)] = 9247,
  [SMALL_STATE(128)] = 9330,
  [SMALL_STATE(129)] = 9413,
  [SMALL_STATE(130)] = 9496,
  [SMALL_STATE(131)] = 9579,
  [SMALL_STATE(132)] = 9662,
  [SMALL_STATE(133)] = 9745,
  [SMALL_STATE(134)] = 9828,
  [SMALL_STATE(135)] = 9908,
  [SMALL_STATE(136)] = 10006,
  [SMALL_STATE(137)] = 10104,
  [SMALL_STATE(138)] = 10202,
  [SMALL_STATE(139)] = 10282,
  [SMALL_STATE(140)] = 10380,
  [SMALL_STATE(141)] = 10478,
  [SMALL_STATE(142)] = 10558,
  [SMALL_STATE(143)] = 10656,
  [SMALL_STATE(144)] = 10736,
  [SMALL_STATE(145)] = 10816,
  [SMALL_STATE(146)] = 10914,
  [SMALL_STATE(147)] = 11012,
  [SMALL_STATE(148)] = 11092,
  [SMALL_STATE(149)] = 11166,
  [SMALL_STATE(150)] = 11264,
  [SMALL_STATE(151)] = 11344,
  [SMALL_STATE(152)] = 11424,
  [SMALL_STATE(153)] = 11504,
  [SMALL_STATE(154)] = 11584,
  [SMALL_STATE(155)] = 11664,
  [SMALL_STATE(156)] = 11744,
  [SMALL_STATE(157)] = 11824,
  [SMALL_STATE(158)] = 11904,
  [SMALL_STATE(159)] = 11984,
  [SMALL_STATE(160)] = 12064,
  [SMALL_STATE(161)] = 12144,
  [SMALL_STATE(162)] = 12224,
  [SMALL_STATE(163)] = 12304,
  [SMALL_STATE(164)] = 12384,
  [SMALL_STATE(165)] = 12464,
  [SMALL_STATE(166)] = 12544,
  [SMALL_STATE(167)] = 12624,
  [SMALL_STATE(168)] = 12704,
  [SMALL_STATE(169)] = 12784,
  [SMALL_STATE(170)] = 12864,
  [SMALL_STATE(171)] = 12944,
  [SMALL_STATE(172)] = 13042,
  [SMALL_STATE(173)] = 13122,
  [SMALL_STATE(174)] = 13202,
  [SMALL_STATE(175)] = 13282,
  [SMALL_STATE(176)] = 13362,
  [SMALL_STATE(177)] = 13442,
  [SMALL_STATE(178)] = 13522,
  [SMALL_STATE(179)] = 13602,
  [SMALL_STATE(180)] = 13682,
  [SMALL_STATE(181)] = 13762,
  [SMALL_STATE(182)] = 13860,
  [SMALL_STATE(183)] = 13940,
  [SMALL_STATE(184)] = 14038,
  [SMALL_STATE(185)] = 14118,
  [SMALL_STATE(186)] = 14198,
  [SMALL_STATE(187)] = 14293,
  [SMALL_STATE(188)] = 14388,
  [SMALL_STATE(189)] = 14483,
  [SMALL_STATE(190)] = 14578,
  [SMALL_STATE(191)] = 14673,
  [SMALL_STATE(192)] = 14768,
  [SMALL_STATE(193)] = 14841,
  [SMALL_STATE(194)] = 14936,
  [SMALL_STATE(195)] = 15031,
  [SMALL_STATE(196)] = 15126,
  [SMALL_STATE(197)] = 15221,
  [SMALL_STATE(198)] = 15316,
  [SMALL_STATE(199)] = 15411,
  [SMALL_STATE(200)] = 15506,
  [SMALL_STATE(201)] = 15601,
  [SMALL_STATE(202)] = 15696,
  [SMALL_STATE(203)] = 15791,
  [SMALL_STATE(204)] = 15886,
  [SMALL_STATE(205)] = 15981,
  [SMALL_STATE(206)] = 16076,
  [SMALL_STATE(207)] = 16149,
  [SMALL_STATE(208)] = 16244,
  [SMALL_STATE(209)] = 16339,
  [SMALL_STATE(210)] = 16434,
  [SMALL_STATE(211)] = 16529,
  [SMALL_STATE(212)] = 16624,
  [SMALL_STATE(213)] = 16719,
  [SMALL_STATE(214)] = 16814,
  [SMALL_STATE(215)] = 16909,
  [SMALL_STATE(216)] = 17004,
  [SMALL_STATE(217)] = 17099,
  [SMALL_STATE(218)] = 17194,
  [SMALL_STATE(219)] = 17289,
  [SMALL_STATE(220)] = 17335,
  [SMALL_STATE(221)] = 17379,
  [SMALL_STATE(222)] = 17435,
  [SMALL_STATE(223)] = 17486,
  [SMALL_STATE(224)] = 17548,
  [SMALL_STATE(225)] = 17598,
  [SMALL_STATE(226)] = 17664,
  [SMALL_STATE(227)] = 17709,
  [SMALL_STATE(228)] = 17750,
  [SMALL_STATE(229)] = 17793,
  [SMALL_STATE(230)] = 17834,
  [SMALL_STATE(231)] = 17875,
  [SMALL_STATE(232)] = 17916,
  [SMALL_STATE(233)] = 17955,
  [SMALL_STATE(234)] = 17996,
  [SMALL_STATE(235)] = 18037,
  [SMALL_STATE(236)] = 18080,
  [SMALL_STATE(237)] = 18116,
  [SMALL_STATE(238)] = 18156,
  [SMALL_STATE(239)] = 18194,
  [SMALL_STATE(240)] = 18230,
  [SMALL_STATE(241)] = 18266,
  [SMALL_STATE(242)] = 18303,
  [SMALL_STATE(243)] = 18337,
  [SMALL_STATE(244)] = 18371,
  [SMALL_STATE(245)] = 18405,
  [SMALL_STATE(246)] = 18439,
  [SMALL_STATE(247)] = 18493,
  [SMALL_STATE(248)] = 18527,
  [SMALL_STATE(249)] = 18561,
  [SMALL_STATE(250)] = 18595,
  [SMALL_STATE(251)] = 18629,
  [SMALL_STATE(252)] = 18683,
  [SMALL_STATE(253)] = 18717,
  [SMALL_STATE(254)] = 18751,
  [SMALL_STATE(255)] = 18785,
  [SMALL_STATE(256)] = 18819,
  [SMALL_STATE(257)] = 18853,
  [SMALL_STATE(258)] = 18893,
  [SMALL_STATE(259)] = 18927,
  [SMALL_STATE(260)] = 18961,
  [SMALL_STATE(261)] = 18995,
  [SMALL_STATE(262)] = 19029,
  [SMALL_STATE(263)] = 19063,
  [SMALL_STATE(264)] = 19097,
  [SMALL_STATE(265)] = 19131,
  [SMALL_STATE(266)] = 19165,
  [SMALL_STATE(267)] = 19219,
  [SMALL_STATE(268)] = 19253,
  [SMALL_STATE(269)] = 19287,
  [SMALL_STATE(270)] = 19321,
  [SMALL_STATE(271)] = 19355,
  [SMALL_STATE(272)] = 19389,
  [SMALL_STATE(273)] = 19423,
  [SMALL_STATE(274)] = 19457,
  [SMALL_STATE(275)] = 19491,
  [SMALL_STATE(276)] = 19525,
  [SMALL_STATE(277)] = 19583,
  [SMALL_STATE(278)] = 19617,
  [SMALL_STATE(279)] = 19651,
  [SMALL_STATE(280)] = 19685,
  [SMALL_STATE(281)] = 19719,
  [SMALL_STATE(282)] = 19753,
  [SMALL_STATE(283)] = 19787,
  [SMALL_STATE(284)] = 19842,
  [SMALL_STATE(285)] = 19877,
  [SMALL_STATE(286)] = 19910,
  [SMALL_STATE(287)] = 19962,
  [SMALL_STATE(288)] = 20014,
  [SMALL_STATE(289)] = 20066,
  [SMALL_STATE(290)] = 20118,
  [SMALL_STATE(291)] = 20170,
  [SMALL_STATE(292)] = 20222,
  [SMALL_STATE(293)] = 20274,
  [SMALL_STATE(294)] = 20326,
  [SMALL_STATE(295)] = 20378,
  [SMALL_STATE(296)] = 20430,
  [SMALL_STATE(297)] = 20482,
  [SMALL_STATE(298)] = 20534,
  [SMALL_STATE(299)] = 20586,
  [SMALL_STATE(300)] = 20617,
  [SMALL_STATE(301)] = 20648,
  [SMALL_STATE(302)] = 20701,
  [SMALL_STATE(303)] = 20745,
  [SMALL_STATE(304)] = 20770,
  [SMALL_STATE(305)] = 20797,
  [SMALL_STATE(306)] = 20835,
  [SMALL_STATE(307)] = 20871,
  [SMALL_STATE(308)] = 20909,
  [SMALL_STATE(309)] = 20947,
  [SMALL_STATE(310)] = 20985,
  [SMALL_STATE(311)] = 21011,
  [SMALL_STATE(312)] = 21049,
  [SMALL_STATE(313)] = 21087,
  [SMALL_STATE(314)] = 21116,
  [SMALL_STATE(315)] = 21137,
  [SMALL_STATE(316)] = 21166,
  [SMALL_STATE(317)] = 21203,
  [SMALL_STATE(318)] = 21236,
  [SMALL_STATE(319)] = 21265,
  [SMALL_STATE(320)] = 21292,
  [SMALL_STATE(321)] = 21321,
  [SMALL_STATE(322)] = 21350,
  [SMALL_STATE(323)] = 21376,
  [SMALL_STATE(324)] = 21397,
  [SMALL_STATE(325)] = 21420,
  [SMALL_STATE(326)] = 21448,
  [SMALL_STATE(327)] = 21476,
  [SMALL_STATE(328)] = 21498,
  [SMALL_STATE(329)] = 21518,
  [SMALL_STATE(330)] = 21538,
  [SMALL_STATE(331)] = 21558,
  [SMALL_STATE(332)] = 21578,
  [SMALL_STATE(333)] = 21598,
  [SMALL_STATE(334)] = 21626,
  [SMALL_STATE(335)] = 21650,
  [SMALL_STATE(336)] = 21678,
  [SMALL_STATE(337)] = 21698,
  [SMALL_STATE(338)] = 21716,
  [SMALL_STATE(339)] = 21736,
  [SMALL_STATE(340)] = 21764,
  [SMALL_STATE(341)] = 21784,
  [SMALL_STATE(342)] = 21812,
  [SMALL_STATE(343)] = 21840,
  [SMALL_STATE(344)] = 21860,
  [SMALL_STATE(345)] = 21888,
  [SMALL_STATE(346)] = 21906,
  [SMALL_STATE(347)] = 21934,
  [SMALL_STATE(348)] = 21962,
  [SMALL_STATE(349)] = 21990,
  [SMALL_STATE(350)] = 22018,
  [SMALL_STATE(351)] = 22046,
  [SMALL_STATE(352)] = 22074,
  [SMALL_STATE(353)] = 22102,
  [SMALL_STATE(354)] = 22130,
  [SMALL_STATE(355)] = 22158,
  [SMALL_STATE(356)] = 22186,
  [SMALL_STATE(357)] = 22214,
  [SMALL_STATE(358)] = 22242,
  [SMALL_STATE(359)] = 22259,
  [SMALL_STATE(360)] = 22282,
  [SMALL_STATE(361)] = 22305,
  [SMALL_STATE(362)] = 22322,
  [SMALL_STATE(363)] = 22339,
  [SMALL_STATE(364)] = 22362,
  [SMALL_STATE(365)] = 22379,
  [SMALL_STATE(366)] = 22396,
  [SMALL_STATE(367)] = 22419,
  [SMALL_STATE(368)] = 22442,
  [SMALL_STATE(369)] = 22459,
  [SMALL_STATE(370)] = 22482,
  [SMALL_STATE(371)] = 22499,
  [SMALL_STATE(372)] = 22522,
  [SMALL_STATE(373)] = 22545,
  [SMALL_STATE(374)] = 22568,
  [SMALL_STATE(375)] = 22591,
  [SMALL_STATE(376)] = 22608,
  [SMALL_STATE(377)] = 22631,
  [SMALL_STATE(378)] = 22650,
  [SMALL_STATE(379)] = 22673,
  [SMALL_STATE(380)] = 22690,
  [SMALL_STATE(381)] = 22707,
  [SMALL_STATE(382)] = 22724,
  [SMALL_STATE(383)] = 22741,
  [SMALL_STATE(384)] = 22758,
  [SMALL_STATE(385)] = 22775,
  [SMALL_STATE(386)] = 22800,
  [SMALL_STATE(387)] = 22817,
  [SMALL_STATE(388)] = 22842,
  [SMALL_STATE(389)] = 22859,
  [SMALL_STATE(390)] = 22876,
  [SMALL_STATE(391)] = 22895,
  [SMALL_STATE(392)] = 22918,
  [SMALL_STATE(393)] = 22943,
  [SMALL_STATE(394)] = 22964,
  [SMALL_STATE(395)] = 22987,
  [SMALL_STATE(396)] = 23004,
  [SMALL_STATE(397)] = 23027,
  [SMALL_STATE(398)] = 23044,
  [SMALL_STATE(399)] = 23061,
  [SMALL_STATE(400)] = 23086,
  [SMALL_STATE(401)] = 23105,
  [SMALL_STATE(402)] = 23122,
  [SMALL_STATE(403)] = 23147,
  [SMALL_STATE(404)] = 23170,
  [SMALL_STATE(405)] = 23187,
  [SMALL_STATE(406)] = 23207,
  [SMALL_STATE(407)] = 23229,
  [SMALL_STATE(408)] = 23245,
  [SMALL_STATE(409)] = 23263,
  [SMALL_STATE(410)] = 23281,
  [SMALL_STATE(411)] = 23299,
  [SMALL_STATE(412)] = 23319,
  [SMALL_STATE(413)] = 23341,
  [SMALL_STATE(414)] = 23363,
  [SMALL_STATE(415)] = 23383,
  [SMALL_STATE(416)] = 23405,
  [SMALL_STATE(417)] = 23425,
  [SMALL_STATE(418)] = 23447,
  [SMALL_STATE(419)] = 23465,
  [SMALL_STATE(420)] = 23487,
  [SMALL_STATE(421)] = 23503,
  [SMALL_STATE(422)] = 23525,
  [SMALL_STATE(423)] = 23545,
  [SMALL_STATE(424)] = 23561,
  [SMALL_STATE(425)] = 23581,
  [SMALL_STATE(426)] = 23601,
  [SMALL_STATE(427)] = 23621,
  [SMALL_STATE(428)] = 23641,
  [SMALL_STATE(429)] = 23661,
  [SMALL_STATE(430)] = 23681,
  [SMALL_STATE(431)] = 23703,
  [SMALL_STATE(432)] = 23725,
  [SMALL_STATE(433)] = 23745,
  [SMALL_STATE(434)] = 23765,
  [SMALL_STATE(435)] = 23785,
  [SMALL_STATE(436)] = 23803,
  [SMALL_STATE(437)] = 23823,
  [SMALL_STATE(438)] = 23845,
  [SMALL_STATE(439)] = 23862,
  [SMALL_STATE(440)] = 23881,
  [SMALL_STATE(441)] = 23900,
  [SMALL_STATE(442)] = 23919,
  [SMALL_STATE(443)] = 23938,
  [SMALL_STATE(444)] = 23957,
  [SMALL_STATE(445)] = 23976,
  [SMALL_STATE(446)] = 23995,
  [SMALL_STATE(447)] = 24014,
  [SMALL_STATE(448)] = 24031,
  [SMALL_STATE(449)] = 24050,
  [SMALL_STATE(450)] = 24067,
  [SMALL_STATE(451)] = 24084,
  [SMALL_STATE(452)] = 24101,
  [SMALL_STATE(453)] = 24120,
  [SMALL_STATE(454)] = 24139,
  [SMALL_STATE(455)] = 24158,
  [SMALL_STATE(456)] = 24175,
  [SMALL_STATE(457)] = 24194,
  [SMALL_STATE(458)] = 24211,
  [SMALL_STATE(459)] = 24230,
  [SMALL_STATE(460)] = 24249,
  [SMALL_STATE(461)] = 24268,
  [SMALL_STATE(462)] = 24287,
  [SMALL_STATE(463)] = 24306,
  [SMALL_STATE(464)] = 24323,
  [SMALL_STATE(465)] = 24340,
  [SMALL_STATE(466)] = 24359,
  [SMALL_STATE(467)] = 24376,
  [SMALL_STATE(468)] = 24395,
  [SMALL_STATE(469)] = 24414,
  [SMALL_STATE(470)] = 24433,
  [SMALL_STATE(471)] = 24448,
  [SMALL_STATE(472)] = 24467,
  [SMALL_STATE(473)] = 24484,
  [SMALL_STATE(474)] = 24503,
  [SMALL_STATE(475)] = 24517,
  [SMALL_STATE(476)] = 24533,
  [SMALL_STATE(477)] = 24547,
  [SMALL_STATE(478)] = 24561,
  [SMALL_STATE(479)] = 24575,
  [SMALL_STATE(480)] = 24589,
  [SMALL_STATE(481)] = 24603,
  [SMALL_STATE(482)] = 24616,
  [SMALL_STATE(483)] = 24629,
  [SMALL_STATE(484)] = 24642,
  [SMALL_STATE(485)] = 24655,
  [SMALL_STATE(486)] = 24668,
  [SMALL_STATE(487)] = 24681,
  [SMALL_STATE(488)] = 24694,
  [SMALL_STATE(489)] = 24707,
  [SMALL_STATE(490)] = 24720,
  [SMALL_STATE(491)] = 24733,
  [SMALL_STATE(492)] = 24746,
  [SMALL_STATE(493)] = 24759,
  [SMALL_STATE(494)] = 24772,
  [SMALL_STATE(495)] = 24785,
  [SMALL_STATE(496)] = 24798,
  [SMALL_STATE(497)] = 24811,
  [SMALL_STATE(498)] = 24824,
  [SMALL_STATE(499)] = 24837,
  [SMALL_STATE(500)] = 24850,
  [SMALL_STATE(501)] = 24863,
  [SMALL_STATE(502)] = 24876,
  [SMALL_STATE(503)] = 24889,
  [SMALL_STATE(504)] = 24902,
  [SMALL_STATE(505)] = 24915,
  [SMALL_STATE(506)] = 24928,
  [SMALL_STATE(507)] = 24941,
  [SMALL_STATE(508)] = 24954,
  [SMALL_STATE(509)] = 24967,
  [SMALL_STATE(510)] = 24980,
  [SMALL_STATE(511)] = 24993,
  [SMALL_STATE(512)] = 25006,
  [SMALL_STATE(513)] = 25019,
  [SMALL_STATE(514)] = 25032,
  [SMALL_STATE(515)] = 25045,
  [SMALL_STATE(516)] = 25058,
  [SMALL_STATE(517)] = 25071,
  [SMALL_STATE(518)] = 25084,
  [SMALL_STATE(519)] = 25097,
  [SMALL_STATE(520)] = 25110,
  [SMALL_STATE(521)] = 25123,
  [SMALL_STATE(522)] = 25136,
  [SMALL_STATE(523)] = 25149,
  [SMALL_STATE(524)] = 25162,
  [SMALL_STATE(525)] = 25175,
  [SMALL_STATE(526)] = 25188,
  [SMALL_STATE(527)] = 25201,
  [SMALL_STATE(528)] = 25214,
  [SMALL_STATE(529)] = 25227,
  [SMALL_STATE(530)] = 25240,
  [SMALL_STATE(531)] = 25253,
  [SMALL_STATE(532)] = 25266,
  [SMALL_STATE(533)] = 25279,
  [SMALL_STATE(534)] = 25292,
  [SMALL_STATE(535)] = 25305,
  [SMALL_STATE(536)] = 25318,
  [SMALL_STATE(537)] = 25331,
  [SMALL_STATE(538)] = 25344,
  [SMALL_STATE(539)] = 25357,
  [SMALL_STATE(540)] = 25370,
  [SMALL_STATE(541)] = 25383,
  [SMALL_STATE(542)] = 25396,
  [SMALL_STATE(543)] = 25409,
  [SMALL_STATE(544)] = 25422,
  [SMALL_STATE(545)] = 25435,
  [SMALL_STATE(546)] = 25448,
  [SMALL_STATE(547)] = 25461,
  [SMALL_STATE(548)] = 25474,
  [SMALL_STATE(549)] = 25487,
  [SMALL_STATE(550)] = 25500,
  [SMALL_STATE(551)] = 25513,
  [SMALL_STATE(552)] = 25526,
  [SMALL_STATE(553)] = 25539,
  [SMALL_STATE(554)] = 25552,
  [SMALL_STATE(555)] = 25565,
  [SMALL_STATE(556)] = 25569,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 0, 0, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1, 0, 0),
  [41] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1, 0, 0),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dot_index_expression, 3, 0, 25),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dot_index_expression, 3, 0, 25),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracket_index_expression, 4, 0, 25),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracket_index_expression, 4, 0, 25),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2, 0, 0),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2, 0, 0),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 1, 0, 0),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 1, 0, 0),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 2, 0, 11),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 2, 0, 11),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [65] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression, 1, 0, 0),
  [69] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression, 1, 0, 0),
  [71] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_expression, 1, 0, 0),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_expression, 1, 0, 0),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string, 3, 0, 31),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_string, 3, 0, 31),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3, 0, 0),
  [81] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3, 0, 0),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string, 2, 0, 0),
  [85] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_string, 2, 0, 0),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4, 0, 0),
  [89] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4, 0, 0),
  [91] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 6),
  [93] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 6),
  [95] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 1, 0, 7),
  [97] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 1, 0, 7),
  [99] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quote_string, 2, 0, 15),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__quote_string, 2, 0, 15),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 2, 0, 0),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 2, 0, 0),
  [107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_string, 3, 0, 13),
  [109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_string, 3, 0, 13),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quote_string, 3, 0, 30),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__quote_string, 3, 0, 30),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_table_constructor, 3, 0, 0),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_table_constructor, 3, 0, 0),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_type, 2, 0, 0),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_type, 2, 0, 0),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(546),
  [125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0),
  [127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0),
  [129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(546),
  [132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type, 1, 0, 0),
  [136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_type, 2, 0, 0),
  [146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_type, 2, 0, 0),
  [148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_intersection_type, 3, 0, 0),
  [160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 3, 0, 0),
  [162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 3, 0, 0),
  [164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 3, 0, 0),
  [166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 3, 0, 0),
  [168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_type, 3, 0, 0),
  [170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_type, 3, 0, 0),
  [172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, 0, 0),
  [184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, 0, 0),
  [186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_type, 2, 0, 0),
  [192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variadic_type, 2, 0, 0),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 4, 0, 0),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 4, 0, 0),
  [198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 4, 0, 0),
  [200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 4, 0, 0),
  [202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, 0, 0),
  [204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, 0, 0),
  [206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 5, 0, 0),
  [208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 5, 0, 0),
  [210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 5, 0, 0),
  [212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 5, 0, 0),
  [214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 6, 0, 0),
  [216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 6, 0, 0),
  [218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 6, 0, 0),
  [220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 6, 0, 0),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 7, 0, 0),
  [224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 7, 0, 0),
  [226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 7, 0, 0),
  [228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 7, 0, 0),
  [230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 8, 0, 0),
  [232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 8, 0, 0),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 9, 0, 0),
  [236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 9, 0, 0),
  [238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 10, 0, 0),
  [240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 10, 0, 0),
  [242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 11, 0, 0),
  [244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 11, 0, 0),
  [246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_type, 2, 0, 0),
  [248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_type, 2, 0, 0),
  [250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type, 2, 0, 0),
  [256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_optional_type, 2, 0, 0),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_type, 1, 0, 0),
  [260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_type, 1, 0, 0),
  [262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 5, 0, 44),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 5, 0, 44),
  [266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, 0, 44),
  [272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, 0, 44),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 3, 0, 0),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0),
  [306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 2, 0, 0), SHIFT_REPEAT(193),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vararg_expression, 1, 0, 0),
  [313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vararg_expression, 1, 0, 0),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 1, 0, 0),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(399),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0),
  [347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(2),
  [350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0),
  [352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(277),
  [355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(259),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(104),
  [361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(205),
  [364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(103),
  [367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(217),
  [370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(411),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(387),
  [376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(419),
  [379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(186),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(485),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 2, 0, 0), SHIFT_REPEAT(153),
  [388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 3, 0, 34),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 1, 0, 0),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, 0, 45),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 3, 0, 45),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_clause, 4, 0, 44),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_clause, 4, 0, 44),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, 0, 29),
  [402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 2, 0, 29),
  [404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 33),
  [410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 33),
  [412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 3, 0, 46),
  [432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 3, 0, 46),
  [434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nil, 1, 0, 0),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nil, 1, 0, 0),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_expression_repeat1, 1, 0, 0),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 4, 0, 29),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 4, 0, 29),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 2, 0, 14),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 2, 0, 14),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 4, 0, 59),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 4, 0, 59),
  [454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 2, 0, 65),
  [460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 2, 0, 65),
  [462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 6, 0, 44),
  [464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 6, 0, 44),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 5, 0, 66),
  [468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 5, 0, 66),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 5, 0, 46),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 5, 0, 46),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 17),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 17),
  [478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 6, 0, 70),
  [480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 6, 0, 70),
  [482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(219),
  [494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_statement, 1, 0, 0),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(280),
  [504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1, 0, 0),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 1, 0, 0),
  [510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 2, 0, 0),
  [512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 3, 0, 0),
  [520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 2, 0, 0),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 1, 0, 16),
  [536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 1, 0, 16),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 57),
  [590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 57),
  [592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 4, 0, 35),
  [594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 4, 0, 35),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_statement, 3, 0, 20),
  [598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_statement, 3, 0, 20),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 0),
  [604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 0),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 3, 0, 4),
  [608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 3, 0, 4),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 4, 0, 27),
  [616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 4, 0, 27),
  [618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2, 0, 0),
  [620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__expression_list_repeat1, 2, 0, 0),
  [622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 1, 0, 4),
  [628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 1, 0, 4),
  [630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 1, 0, 0),
  [634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 1, 0, 0),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 27),
  [640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 27),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 5, 0, 64),
  [646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 5, 0, 64),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 5, 0, 56),
  [650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 5, 0, 56),
  [652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 2, 0, 23),
  [654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 2, 0, 23),
  [656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 4, 0, 55),
  [658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 4, 0, 55),
  [660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 2, 0, 22),
  [662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 2, 0, 22),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 41),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 41),
  [668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 2, 0, 41), SHIFT_REPEAT(537),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 4, 0, 54),
  [673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 4, 0, 54),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__att_name_list, 3, 0, 40),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__att_name_list, 3, 0, 40),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 4, 0, 27),
  [681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 4, 0, 27),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 5, 0, 69),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 5, 0, 69),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_explist, 2, 0, 43),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_assignment_explist, 2, 0, 43),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 58),
  [693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 58),
  [695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_explist_repeat1, 2, 0, 58), SHIFT_REPEAT(187),
  [698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attrib, 3, 0, 0),
  [700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attrib, 3, 0, 0),
  [702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__att_name_list_repeat1, 3, 0, 53),
  [704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__att_name_list_repeat1, 3, 0, 53),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 10),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 10),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 50),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 50),
  [716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_function_declaration, 4, 0, 39),
  [718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_function_declaration, 4, 0, 39),
  [720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 0),
  [722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 0),
  [724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 2, 0, 0),
  [726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 2, 0, 0),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 1, 0, 16),
  [730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__local_variable_assignment, 3, 0, 42),
  [732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__local_variable_assignment, 3, 0, 42),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 2),
  [736] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 2),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration, 1, 0, 3),
  [740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration, 1, 0, 3),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 3, 0, 19),
  [744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 3, 0, 19),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3, 0, 47),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, 0, 48),
  [750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, 0, 48),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 44),
  [754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 44),
  [756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, 0, 49),
  [758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, 0, 49),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 5, 0, 52),
  [762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 5, 0, 52),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 2, 0, 0),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 1, 0, 4),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 3, 0, 21),
  [774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 3, 0, 21),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 60),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 60),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 61),
  [782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 61),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, 0, 62),
  [786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, 0, 62),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_statement, 3, 0, 24),
  [790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_statement, 3, 0, 24),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_statement, 3, 0, 24),
  [794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_statement, 3, 0, 24),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 5, 0, 67),
  [798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, 0, 68),
  [800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, 0, 68),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 4, 0, 37),
  [804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 4, 0, 37),
  [806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 7, 0, 27),
  [808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 7, 0, 27),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_definition, 8, 0, 56),
  [812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_definition, 8, 0, 56),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1, 0, 0),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_chunk_repeat1, 1, 0, 0),
  [822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_chunk_repeat1, 1, 0, 0),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1, 0, 1),
  [826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1, 0, 1),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, 0, 34),
  [830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, 0, 34),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, 0, 34),
  [834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, 0, 34),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 5, 0, 63),
  [840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, 0, 27),
  [842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__field_sep, 1, 0, 0),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_sep, 1, 0, 0),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_numeric_clause, 7, 0, 71),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2, 0, 0),
  [874] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2, 0, 0),
  [876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3, 0, 0),
  [878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3, 0, 0),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, 0, 28),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__variable_assignment_varlist_repeat1, 2, 0, 28), SHIFT_REPEAT(317),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_assignment_varlist, 2, 0, 12),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(343),
  [922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(190),
  [925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32),
  [927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(328),
  [930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(328),
  [933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 2, 0, 32), SHIFT_REPEAT(329),
  [936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__expression_list_repeat1, 2, 0, 0), SHIFT_REPEAT(194),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 2, 0, 0),
  [981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 2, 0, 0),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [991] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_type_repeat1, 2, 0, 0), SHIFT_REPEAT(510),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2, 0, 0),
  [1008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolation_string_content, 1, 0, 0),
  [1010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolation_string_content, 1, 0, 0),
  [1012] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__escape_sequence, 1, 0, 0),
  [1014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__escape_sequence, 1, 0, 0),
  [1016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 18),
  [1018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 18),
  [1020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 0),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__interpolated_string_repeat1, 1, 0, 0),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0),
  [1032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3, 0, 0),
  [1038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3, 0, 0),
  [1040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [1054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_index_expression, 3, 0, 26),
  [1060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 4, 0, 0),
  [1090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, 0, 0),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3, 0, 0),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2, 0, 0), SHIFT_REPEAT(285),
  [1113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__field_list_repeat1, 2, 0, 0),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 4, 0, 0),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 51),
  [1119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 51), SHIFT_REPEAT(195),
  [1122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, 0, 51),
  [1124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__field_list, 1, 0, 0),
  [1126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [1128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_list, 1, 0, 4),
  [1136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1, 0, 0),
  [1138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(134),
  [1141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__doublequote_string_content, 2, 0, 0),
  [1143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__doublequote_string_content, 2, 0, 0), SHIFT_REPEAT(449),
  [1146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__singlequote_string_content, 2, 0, 0),
  [1148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__singlequote_string_content, 2, 0, 0), SHIFT_REPEAT(463),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_type_list_repeat1, 2, 0, 0),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1, 0, 0),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 2, 0, 0),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 2, 0, 0),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(224),
  [1173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_prefix_expression, 1, 0, 8),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_dot_index_expression, 3, 0, 25),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 1, 0, 0),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 36),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, 0, 36),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__doublequote_string_content, 1, 0, 0),
  [1227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__doublequote_string_content, 1, 0, 0),
  [1229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_statement, 4, 0, 44),
  [1231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_statement, 4, 0, 44),
  [1233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_type_list_repeat1, 2, 0, 0), SHIFT_REPEAT(522),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, 0, 28), SHIFT_REPEAT(553),
  [1245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, 0, 28),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(415),
  [1252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameter_list_repeat1, 2, 0, 0),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 1, 0, 0),
  [1260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_list, 2, 0, 0),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__singlequote_string_content, 1, 0, 0),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__singlequote_string_content, 1, 0, 0),
  [1268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2, 0, 0), SHIFT_REPEAT(173),
  [1271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 2, 0, 0), SHIFT_REPEAT(504),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_type_repeat1, 2, 0, 0),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name_list, 2, 0, 12),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0), SHIFT_REPEAT(441),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_type_repeat1, 2, 0, 0),
  [1287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__name_list_repeat1, 2, 0, 27),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_type_list_repeat1, 3, 0, 0),
  [1291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name, 1, 0, 9),
  [1293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_name_method_index_expression, 3, 0, 26),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(555),
  [1311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_generic_clause, 3, 0, 38),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_list, 5, 0, 0),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_statement, 2, 0, 19),
  [1325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_list, 4, 0, 0),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_field_type, 3, 0, 0),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chunk, 3, 0, 0),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1385] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_list, 3, 0, 0),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1419] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 2, 0, 5),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comment, 3, 0, 13),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__block_comment_start = 0,
  ts_external_token__block_comment_content = 1,
  ts_external_token__block_comment_end = 2,
  ts_external_token__block_string_start = 3,
  ts_external_token__block_string_content = 4,
  ts_external_token__block_string_end = 5,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__block_comment_start] = sym__block_comment_start,
  [ts_external_token__block_comment_content] = sym__block_comment_content,
  [ts_external_token__block_comment_end] = sym__block_comment_end,
  [ts_external_token__block_string_start] = sym__block_string_start,
  [ts_external_token__block_string_content] = sym__block_string_content,
  [ts_external_token__block_string_end] = sym__block_string_end,
};

static const bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
    [ts_external_token__block_comment_end] = true,
    [ts_external_token__block_string_start] = true,
    [ts_external_token__block_string_content] = true,
    [ts_external_token__block_string_end] = true,
  },
  [2] = {
    [ts_external_token__block_comment_start] = true,
  },
  [3] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_string_start] = true,
  },
  [4] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_content] = true,
  },
  [5] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_comment_end] = true,
  },
  [6] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_string_end] = true,
  },
  [7] = {
    [ts_external_token__block_comment_start] = true,
    [ts_external_token__block_string_content] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_luau_external_scanner_create(void);
void tree_sitter_luau_external_scanner_destroy(void *);
bool tree_sitter_luau_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_luau_external_scanner_serialize(void *, char *);
void tree_sitter_luau_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_luau(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_luau_external_scanner_create,
      tree_sitter_luau_external_scanner_destroy,
      tree_sitter_luau_external_scanner_scan,
      tree_sitter_luau_external_scanner_serialize,
      tree_sitter_luau_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
