#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1954
#define LARGE_STATE_COUNT 598
#define SYMBOL_COUNT 230
#define ALIAS_COUNT 0
#define TOKEN_COUNT 138
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 11
#define MAX_ALIAS_SEQUENCE_LENGTH 23
#define PRODUCTION_ID_COUNT 27

enum ts_symbol_identifiers {
  anon_sym_CR = 1,
  anon_sym_LF = 2,
  aux_sym_package_token1 = 3,
  sym__dollar = 4,
  aux_sym_method_token1 = 5,
  aux_sym_method_token2 = 6,
  aux_sym_method_token3 = 7,
  aux_sym_method_token4 = 8,
  anon_sym_DOT = 9,
  anon_sym_LPAREN = 10,
  anon_sym_COMMA = 11,
  aux_sym_method_token5 = 12,
  aux_sym_method_token6 = 13,
  anon_sym_RPAREN = 14,
  anon_sym_LT_LT = 15,
  anon_sym_CARET_LT_LT = 16,
  anon_sym_LBRACK = 17,
  anon_sym_RBRACK = 18,
  aux_sym_method_token7 = 19,
  aux_sym_procedure_token1 = 20,
  aux_sym_procedure_token2 = 21,
  aux_sym_block_token1 = 22,
  aux_sym_block_token2 = 23,
  anon_sym__and_LT_LT = 24,
  anon_sym__andif_LT_LT = 25,
  anon_sym__or_LT_LT = 26,
  anon_sym__orif_LT_LT = 27,
  anon_sym__xor_LT_LT = 28,
  anon_sym_STAR_STAR_LT_LT = 29,
  anon_sym_STAR_STAR_CARET_LT_LT = 30,
  anon_sym_STAR_LT_LT = 31,
  anon_sym_STAR_CARET_LT_LT = 32,
  anon_sym_SLASH_LT_LT = 33,
  anon_sym_SLASH_CARET_LT_LT = 34,
  anon_sym__mod_LT_LT = 35,
  anon_sym__div_LT_LT = 36,
  anon_sym_DASH_LT_LT = 37,
  anon_sym_DASH_CARET_LT_LT = 38,
  anon_sym_PLUS_LT_LT = 39,
  anon_sym_PLUS_CARET_LT_LT = 40,
  aux_sym_if_token1 = 41,
  aux_sym_if_token2 = 42,
  aux_sym_if_token3 = 43,
  aux_sym_elif_token1 = 44,
  aux_sym_else_token1 = 45,
  aux_sym_loop_token1 = 46,
  aux_sym_loop_token2 = 47,
  aux_sym_finally_token1 = 48,
  aux_sym_finally_token2 = 49,
  aux_sym_handling_token1 = 50,
  aux_sym_handling_token2 = 51,
  aux_sym_catch_token1 = 52,
  aux_sym_catch_token2 = 53,
  aux_sym_throw_token1 = 54,
  aux_sym_primitive_token1 = 55,
  aux_sym_iterator_token1 = 56,
  aux_sym_iterator_token2 = 57,
  aux_sym_while_token1 = 58,
  aux_sym_try_token1 = 59,
  aux_sym_try_token2 = 60,
  aux_sym_try_token3 = 61,
  aux_sym_loopbody_token1 = 62,
  aux_sym_leave_token1 = 63,
  aux_sym_continue_token1 = 64,
  aux_sym_protect_token1 = 65,
  aux_sym_protect_token2 = 66,
  aux_sym_protect_token3 = 67,
  aux_sym_protect_token4 = 68,
  aux_sym_lock_token1 = 69,
  aux_sym_lock_token2 = 70,
  aux_sym_pragma_token1 = 71,
  aux_sym_pragma_token2 = 72,
  anon_sym_PERCENT = 73,
  aux_sym_character_literal_token1 = 74,
  anon_sym_SPACE = 75,
  anon_sym_DQUOTE = 76,
  aux_sym_string_literal_token1 = 77,
  aux_sym_string_literal_token2 = 78,
  anon_sym_SQUOTE = 79,
  aux_sym_string_literal_token3 = 80,
  sym_regex_literal = 81,
  aux_sym_slot_accessor_token1 = 82,
  aux_sym_true_token1 = 83,
  aux_sym_false_token1 = 84,
  aux_sym_maybe_token1 = 85,
  aux_sym_unset_token1 = 86,
  aux_sym_super_token1 = 87,
  aux_sym_self_token1 = 88,
  aux_sym_clone_token1 = 89,
  aux_sym_thisthread_token1 = 90,
  aux_sym_class_token1 = 91,
  aux_sym_class_token2 = 92,
  anon_sym_SEMI = 93,
  aux_sym_global_token1 = 94,
  aux_sym_local_token1 = 95,
  aux_sym__global_assignment_token1 = 96,
  aux_sym_dynamic_token1 = 97,
  aux_sym_import_token1 = 98,
  aux_sym_return_token1 = 99,
  anon_sym_GT_GT = 100,
  aux_sym_scatter_token1 = 101,
  aux_sym_allresults_token1 = 102,
  sym_label = 103,
  sym_dynamic_variable = 104,
  sym_global_variable = 105,
  sym_global_reference = 106,
  sym_number = 107,
  anon_sym_LBRACE = 108,
  anon_sym_RBRACE = 109,
  aux_sym_relational_operator_token1 = 110,
  aux_sym_relational_operator_token2 = 111,
  aux_sym_relational_operator_token3 = 112,
  anon_sym_EQ = 113,
  anon_sym_TILDE_EQ = 114,
  anon_sym_LT_GT = 115,
  anon_sym_GT_EQ = 116,
  anon_sym_LT_EQ = 117,
  anon_sym_LT = 118,
  anon_sym_GT = 119,
  aux_sym_logical_operator_token1 = 120,
  aux_sym_logical_operator_token2 = 121,
  aux_sym_logical_operator_token3 = 122,
  aux_sym_logical_operator_token4 = 123,
  aux_sym_logical_operator_token5 = 124,
  aux_sym_logical_operator_token6 = 125,
  anon_sym_STAR_STAR = 126,
  anon_sym_STAR = 127,
  anon_sym_SLASH = 128,
  aux_sym_arithmetic_operator_token1 = 129,
  aux_sym_arithmetic_operator_token2 = 130,
  anon_sym_DASH = 131,
  anon_sym_PLUS = 132,
  aux_sym_unary_operator_token1 = 133,
  anon_sym_TILDE = 134,
  sym_symbol = 135,
  aux_sym_documentation_token1 = 136,
  sym_comment = 137,
  sym_source_file = 138,
  sym__line_terminator = 139,
  sym_fragment = 140,
  sym_package = 141,
  sym__method_declaration = 142,
  sym_method = 143,
  sym_procedure = 144,
  sym_argument = 145,
  sym__arguments = 146,
  sym_block = 147,
  sym_assignment = 148,
  sym_if = 149,
  sym_elif = 150,
  sym_else = 151,
  sym_loop = 152,
  sym_finally = 153,
  sym_handling = 154,
  sym_catch = 155,
  sym_throw = 156,
  sym_primitive = 157,
  sym_iterator = 158,
  sym_while = 159,
  sym_try = 160,
  sym_loopbody = 161,
  sym_leave = 162,
  sym_continue = 163,
  sym_protect = 164,
  sym_lock = 165,
  sym_pragma = 166,
  sym__literal = 167,
  sym_character_literal = 168,
  sym_string_literal = 169,
  sym_call = 170,
  sym_invoke = 171,
  sym_indexed_access = 172,
  sym_slot_accessor = 173,
  sym__expression_list = 174,
  sym_true = 175,
  sym_false = 176,
  sym_maybe = 177,
  sym_unset = 178,
  sym_super = 179,
  sym_self = 180,
  sym_clone = 181,
  sym_thisthread = 182,
  sym_class = 183,
  sym__terminator = 184,
  sym__top_level_statement = 185,
  sym__expression = 186,
  sym__codeblock = 187,
  sym__defvar = 188,
  sym_global = 189,
  sym_local = 190,
  sym__global_assignment = 191,
  sym_constant = 192,
  sym_dynamic = 193,
  sym_import = 194,
  sym_dynamic_import = 195,
  sym_return = 196,
  sym__definition = 197,
  sym_gather = 198,
  sym_scatter = 199,
  sym_allresults = 200,
  sym_parenthesized_expression = 201,
  sym__variable = 202,
  sym_variable = 203,
  sym_identifier = 204,
  sym__identifier = 205,
  sym__identifier_list = 206,
  sym_vector = 207,
  sym_relational_operator = 208,
  sym_logical_operator = 209,
  sym_arithmetic_operator = 210,
  sym_unary_operator = 211,
  sym_documentation = 212,
  aux_sym_source_file_repeat1 = 213,
  aux_sym_fragment_repeat1 = 214,
  aux_sym_package_repeat1 = 215,
  aux_sym_method_repeat1 = 216,
  aux_sym_if_repeat1 = 217,
  aux_sym_handling_repeat1 = 218,
  aux_sym_try_repeat1 = 219,
  aux_sym_try_repeat2 = 220,
  aux_sym_loopbody_repeat1 = 221,
  aux_sym_string_literal_repeat1 = 222,
  aux_sym_string_literal_repeat2 = 223,
  aux_sym__codeblock_repeat1 = 224,
  aux_sym_global_repeat1 = 225,
  aux_sym_local_repeat1 = 226,
  aux_sym_dynamic_repeat1 = 227,
  aux_sym__identifier_list_repeat1 = 228,
  aux_sym_documentation_repeat1 = 229,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_CR] = "\r",
  [anon_sym_LF] = "\n",
  [aux_sym_package_token1] = "_package",
  [sym__dollar] = "_dollar",
  [aux_sym_method_token1] = "_abstract",
  [aux_sym_method_token2] = "_private",
  [aux_sym_method_token3] = "_iter",
  [aux_sym_method_token4] = "_method",
  [anon_sym_DOT] = ".",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [aux_sym_method_token5] = "_optional",
  [aux_sym_method_token6] = "_gather",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_CARET_LT_LT] = "^<<",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [aux_sym_method_token7] = "_endmethod",
  [aux_sym_procedure_token1] = "_proc",
  [aux_sym_procedure_token2] = "_endproc",
  [aux_sym_block_token1] = "_block",
  [aux_sym_block_token2] = "_endblock",
  [anon_sym__and_LT_LT] = "_and<<",
  [anon_sym__andif_LT_LT] = "_andif<<",
  [anon_sym__or_LT_LT] = "_or<<",
  [anon_sym__orif_LT_LT] = "_orif<<",
  [anon_sym__xor_LT_LT] = "_xor<<",
  [anon_sym_STAR_STAR_LT_LT] = "**<<",
  [anon_sym_STAR_STAR_CARET_LT_LT] = "**^<<",
  [anon_sym_STAR_LT_LT] = "*<<",
  [anon_sym_STAR_CARET_LT_LT] = "*^<<",
  [anon_sym_SLASH_LT_LT] = "/<<",
  [anon_sym_SLASH_CARET_LT_LT] = "/^<<",
  [anon_sym__mod_LT_LT] = "_mod<<",
  [anon_sym__div_LT_LT] = "_div<<",
  [anon_sym_DASH_LT_LT] = "-<<",
  [anon_sym_DASH_CARET_LT_LT] = "-^<<",
  [anon_sym_PLUS_LT_LT] = "+<<",
  [anon_sym_PLUS_CARET_LT_LT] = "+^<<",
  [aux_sym_if_token1] = "_if",
  [aux_sym_if_token2] = "_then",
  [aux_sym_if_token3] = "_endif",
  [aux_sym_elif_token1] = "_elif",
  [aux_sym_else_token1] = "_else",
  [aux_sym_loop_token1] = "_loop",
  [aux_sym_loop_token2] = "_endloop",
  [aux_sym_finally_token1] = "_finally",
  [aux_sym_finally_token2] = "_with",
  [aux_sym_handling_token1] = "_handling",
  [aux_sym_handling_token2] = "_default",
  [aux_sym_catch_token1] = "_catch",
  [aux_sym_catch_token2] = "_endcatch",
  [aux_sym_throw_token1] = "_throw",
  [aux_sym_primitive_token1] = "_primitive",
  [aux_sym_iterator_token1] = "_for",
  [aux_sym_iterator_token2] = "_over",
  [aux_sym_while_token1] = "_while",
  [aux_sym_try_token1] = "_try",
  [aux_sym_try_token2] = "_when",
  [aux_sym_try_token3] = "_endtry",
  [aux_sym_loopbody_token1] = "_loopbody",
  [aux_sym_leave_token1] = "_leave",
  [aux_sym_continue_token1] = "_continue",
  [aux_sym_protect_token1] = "_protect",
  [aux_sym_protect_token2] = "_locking",
  [aux_sym_protect_token3] = "_protection",
  [aux_sym_protect_token4] = "_endprotect",
  [aux_sym_lock_token1] = "_lock",
  [aux_sym_lock_token2] = "_endlock",
  [aux_sym_pragma_token1] = "_pragma",
  [aux_sym_pragma_token2] = "pragma_token2",
  [anon_sym_PERCENT] = "%",
  [aux_sym_character_literal_token1] = "character_literal_token1",
  [anon_sym_SPACE] = " ",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_literal_token1] = "string_literal_token1",
  [aux_sym_string_literal_token2] = "string_literal_token2",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_literal_token3] = "string_literal_token3",
  [sym_regex_literal] = "regex_literal",
  [aux_sym_slot_accessor_token1] = "slot_accessor_token1",
  [aux_sym_true_token1] = "_true",
  [aux_sym_false_token1] = "_false",
  [aux_sym_maybe_token1] = "_maybe",
  [aux_sym_unset_token1] = "_unset",
  [aux_sym_super_token1] = "_super",
  [aux_sym_self_token1] = "_self",
  [aux_sym_clone_token1] = "_clone",
  [aux_sym_thisthread_token1] = "_thisthread",
  [aux_sym_class_token1] = "_class",
  [aux_sym_class_token2] = "class_token2",
  [anon_sym_SEMI] = ";",
  [aux_sym_global_token1] = "_global",
  [aux_sym_local_token1] = "_local",
  [aux_sym__global_assignment_token1] = "_constant",
  [aux_sym_dynamic_token1] = "_dynamic",
  [aux_sym_import_token1] = "_import",
  [aux_sym_return_token1] = "_return",
  [anon_sym_GT_GT] = ">>",
  [aux_sym_scatter_token1] = "_scatter",
  [aux_sym_allresults_token1] = "_allresults",
  [sym_label] = "label",
  [sym_dynamic_variable] = "dynamic_variable",
  [sym_global_variable] = "global_variable",
  [sym_global_reference] = "global_reference",
  [sym_number] = "number",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [aux_sym_relational_operator_token1] = "_is",
  [aux_sym_relational_operator_token2] = "_isnt",
  [aux_sym_relational_operator_token3] = "_cf",
  [anon_sym_EQ] = "=",
  [anon_sym_TILDE_EQ] = "~=",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [aux_sym_logical_operator_token1] = "_and",
  [aux_sym_logical_operator_token2] = "_or",
  [aux_sym_logical_operator_token3] = "_xor",
  [aux_sym_logical_operator_token4] = "_andif",
  [aux_sym_logical_operator_token5] = "_orif",
  [aux_sym_logical_operator_token6] = "_xorif",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [aux_sym_arithmetic_operator_token1] = "_mod",
  [aux_sym_arithmetic_operator_token2] = "_div",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS] = "+",
  [aux_sym_unary_operator_token1] = "_not",
  [anon_sym_TILDE] = "~",
  [sym_symbol] = "symbol",
  [aux_sym_documentation_token1] = "documentation_token1",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym__line_terminator] = "_line_terminator",
  [sym_fragment] = "fragment",
  [sym_package] = "package",
  [sym__method_declaration] = "_method_declaration",
  [sym_method] = "method",
  [sym_procedure] = "procedure",
  [sym_argument] = "argument",
  [sym__arguments] = "_arguments",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_if] = "if",
  [sym_elif] = "elif",
  [sym_else] = "else",
  [sym_loop] = "loop",
  [sym_finally] = "finally",
  [sym_handling] = "handling",
  [sym_catch] = "catch",
  [sym_throw] = "throw",
  [sym_primitive] = "primitive",
  [sym_iterator] = "iterator",
  [sym_while] = "while",
  [sym_try] = "try",
  [sym_loopbody] = "loopbody",
  [sym_leave] = "leave",
  [sym_continue] = "continue",
  [sym_protect] = "protect",
  [sym_lock] = "lock",
  [sym_pragma] = "pragma",
  [sym__literal] = "_literal",
  [sym_character_literal] = "character_literal",
  [sym_string_literal] = "string_literal",
  [sym_call] = "call",
  [sym_invoke] = "invoke",
  [sym_indexed_access] = "indexed_access",
  [sym_slot_accessor] = "slot_accessor",
  [sym__expression_list] = "_expression_list",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_maybe] = "maybe",
  [sym_unset] = "unset",
  [sym_super] = "super",
  [sym_self] = "self",
  [sym_clone] = "clone",
  [sym_thisthread] = "thisthread",
  [sym_class] = "class",
  [sym__terminator] = "_terminator",
  [sym__top_level_statement] = "_top_level_statement",
  [sym__expression] = "_expression",
  [sym__codeblock] = "_codeblock",
  [sym__defvar] = "_defvar",
  [sym_global] = "global",
  [sym_local] = "local",
  [sym__global_assignment] = "_global_assignment",
  [sym_constant] = "constant",
  [sym_dynamic] = "dynamic",
  [sym_import] = "import",
  [sym_dynamic_import] = "dynamic_import",
  [sym_return] = "return",
  [sym__definition] = "_definition",
  [sym_gather] = "gather",
  [sym_scatter] = "scatter",
  [sym_allresults] = "allresults",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__variable] = "_variable",
  [sym_variable] = "variable",
  [sym_identifier] = "identifier",
  [sym__identifier] = "_identifier",
  [sym__identifier_list] = "_identifier_list",
  [sym_vector] = "vector",
  [sym_relational_operator] = "relational_operator",
  [sym_logical_operator] = "logical_operator",
  [sym_arithmetic_operator] = "arithmetic_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_documentation] = "documentation",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_fragment_repeat1] = "fragment_repeat1",
  [aux_sym_package_repeat1] = "package_repeat1",
  [aux_sym_method_repeat1] = "method_repeat1",
  [aux_sym_if_repeat1] = "if_repeat1",
  [aux_sym_handling_repeat1] = "handling_repeat1",
  [aux_sym_try_repeat1] = "try_repeat1",
  [aux_sym_try_repeat2] = "try_repeat2",
  [aux_sym_loopbody_repeat1] = "loopbody_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_string_literal_repeat2] = "string_literal_repeat2",
  [aux_sym__codeblock_repeat1] = "_codeblock_repeat1",
  [aux_sym_global_repeat1] = "global_repeat1",
  [aux_sym_local_repeat1] = "local_repeat1",
  [aux_sym_dynamic_repeat1] = "dynamic_repeat1",
  [aux_sym__identifier_list_repeat1] = "_identifier_list_repeat1",
  [aux_sym_documentation_repeat1] = "documentation_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_CR] = anon_sym_CR,
  [anon_sym_LF] = anon_sym_LF,
  [aux_sym_package_token1] = aux_sym_package_token1,
  [sym__dollar] = sym__dollar,
  [aux_sym_method_token1] = aux_sym_method_token1,
  [aux_sym_method_token2] = aux_sym_method_token2,
  [aux_sym_method_token3] = aux_sym_method_token3,
  [aux_sym_method_token4] = aux_sym_method_token4,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [aux_sym_method_token5] = aux_sym_method_token5,
  [aux_sym_method_token6] = aux_sym_method_token6,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_CARET_LT_LT] = anon_sym_CARET_LT_LT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [aux_sym_method_token7] = aux_sym_method_token7,
  [aux_sym_procedure_token1] = aux_sym_procedure_token1,
  [aux_sym_procedure_token2] = aux_sym_procedure_token2,
  [aux_sym_block_token1] = aux_sym_block_token1,
  [aux_sym_block_token2] = aux_sym_block_token2,
  [anon_sym__and_LT_LT] = anon_sym__and_LT_LT,
  [anon_sym__andif_LT_LT] = anon_sym__andif_LT_LT,
  [anon_sym__or_LT_LT] = anon_sym__or_LT_LT,
  [anon_sym__orif_LT_LT] = anon_sym__orif_LT_LT,
  [anon_sym__xor_LT_LT] = anon_sym__xor_LT_LT,
  [anon_sym_STAR_STAR_LT_LT] = anon_sym_STAR_STAR_LT_LT,
  [anon_sym_STAR_STAR_CARET_LT_LT] = anon_sym_STAR_STAR_CARET_LT_LT,
  [anon_sym_STAR_LT_LT] = anon_sym_STAR_LT_LT,
  [anon_sym_STAR_CARET_LT_LT] = anon_sym_STAR_CARET_LT_LT,
  [anon_sym_SLASH_LT_LT] = anon_sym_SLASH_LT_LT,
  [anon_sym_SLASH_CARET_LT_LT] = anon_sym_SLASH_CARET_LT_LT,
  [anon_sym__mod_LT_LT] = anon_sym__mod_LT_LT,
  [anon_sym__div_LT_LT] = anon_sym__div_LT_LT,
  [anon_sym_DASH_LT_LT] = anon_sym_DASH_LT_LT,
  [anon_sym_DASH_CARET_LT_LT] = anon_sym_DASH_CARET_LT_LT,
  [anon_sym_PLUS_LT_LT] = anon_sym_PLUS_LT_LT,
  [anon_sym_PLUS_CARET_LT_LT] = anon_sym_PLUS_CARET_LT_LT,
  [aux_sym_if_token1] = aux_sym_if_token1,
  [aux_sym_if_token2] = aux_sym_if_token2,
  [aux_sym_if_token3] = aux_sym_if_token3,
  [aux_sym_elif_token1] = aux_sym_elif_token1,
  [aux_sym_else_token1] = aux_sym_else_token1,
  [aux_sym_loop_token1] = aux_sym_loop_token1,
  [aux_sym_loop_token2] = aux_sym_loop_token2,
  [aux_sym_finally_token1] = aux_sym_finally_token1,
  [aux_sym_finally_token2] = aux_sym_finally_token2,
  [aux_sym_handling_token1] = aux_sym_handling_token1,
  [aux_sym_handling_token2] = aux_sym_handling_token2,
  [aux_sym_catch_token1] = aux_sym_catch_token1,
  [aux_sym_catch_token2] = aux_sym_catch_token2,
  [aux_sym_throw_token1] = aux_sym_throw_token1,
  [aux_sym_primitive_token1] = aux_sym_primitive_token1,
  [aux_sym_iterator_token1] = aux_sym_iterator_token1,
  [aux_sym_iterator_token2] = aux_sym_iterator_token2,
  [aux_sym_while_token1] = aux_sym_while_token1,
  [aux_sym_try_token1] = aux_sym_try_token1,
  [aux_sym_try_token2] = aux_sym_try_token2,
  [aux_sym_try_token3] = aux_sym_try_token3,
  [aux_sym_loopbody_token1] = aux_sym_loopbody_token1,
  [aux_sym_leave_token1] = aux_sym_leave_token1,
  [aux_sym_continue_token1] = aux_sym_continue_token1,
  [aux_sym_protect_token1] = aux_sym_protect_token1,
  [aux_sym_protect_token2] = aux_sym_protect_token2,
  [aux_sym_protect_token3] = aux_sym_protect_token3,
  [aux_sym_protect_token4] = aux_sym_protect_token4,
  [aux_sym_lock_token1] = aux_sym_lock_token1,
  [aux_sym_lock_token2] = aux_sym_lock_token2,
  [aux_sym_pragma_token1] = aux_sym_pragma_token1,
  [aux_sym_pragma_token2] = aux_sym_pragma_token2,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [aux_sym_character_literal_token1] = aux_sym_character_literal_token1,
  [anon_sym_SPACE] = anon_sym_SPACE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_literal_token1] = aux_sym_string_literal_token1,
  [aux_sym_string_literal_token2] = aux_sym_string_literal_token2,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_literal_token3] = aux_sym_string_literal_token3,
  [sym_regex_literal] = sym_regex_literal,
  [aux_sym_slot_accessor_token1] = aux_sym_slot_accessor_token1,
  [aux_sym_true_token1] = aux_sym_true_token1,
  [aux_sym_false_token1] = aux_sym_false_token1,
  [aux_sym_maybe_token1] = aux_sym_maybe_token1,
  [aux_sym_unset_token1] = aux_sym_unset_token1,
  [aux_sym_super_token1] = aux_sym_super_token1,
  [aux_sym_self_token1] = aux_sym_self_token1,
  [aux_sym_clone_token1] = aux_sym_clone_token1,
  [aux_sym_thisthread_token1] = aux_sym_thisthread_token1,
  [aux_sym_class_token1] = aux_sym_class_token1,
  [aux_sym_class_token2] = aux_sym_class_token2,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [aux_sym_global_token1] = aux_sym_global_token1,
  [aux_sym_local_token1] = aux_sym_local_token1,
  [aux_sym__global_assignment_token1] = aux_sym__global_assignment_token1,
  [aux_sym_dynamic_token1] = aux_sym_dynamic_token1,
  [aux_sym_import_token1] = aux_sym_import_token1,
  [aux_sym_return_token1] = aux_sym_return_token1,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [aux_sym_scatter_token1] = aux_sym_scatter_token1,
  [aux_sym_allresults_token1] = aux_sym_allresults_token1,
  [sym_label] = sym_label,
  [sym_dynamic_variable] = sym_dynamic_variable,
  [sym_global_variable] = sym_global_variable,
  [sym_global_reference] = sym_global_reference,
  [sym_number] = sym_number,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [aux_sym_relational_operator_token1] = aux_sym_relational_operator_token1,
  [aux_sym_relational_operator_token2] = aux_sym_relational_operator_token2,
  [aux_sym_relational_operator_token3] = aux_sym_relational_operator_token3,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_TILDE_EQ] = anon_sym_TILDE_EQ,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [aux_sym_logical_operator_token1] = aux_sym_logical_operator_token1,
  [aux_sym_logical_operator_token2] = aux_sym_logical_operator_token2,
  [aux_sym_logical_operator_token3] = aux_sym_logical_operator_token3,
  [aux_sym_logical_operator_token4] = aux_sym_logical_operator_token4,
  [aux_sym_logical_operator_token5] = aux_sym_logical_operator_token5,
  [aux_sym_logical_operator_token6] = aux_sym_logical_operator_token6,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [aux_sym_arithmetic_operator_token1] = aux_sym_arithmetic_operator_token1,
  [aux_sym_arithmetic_operator_token2] = aux_sym_arithmetic_operator_token2,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [aux_sym_unary_operator_token1] = aux_sym_unary_operator_token1,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [sym_symbol] = sym_symbol,
  [aux_sym_documentation_token1] = aux_sym_documentation_token1,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym__line_terminator] = sym__line_terminator,
  [sym_fragment] = sym_fragment,
  [sym_package] = sym_package,
  [sym__method_declaration] = sym__method_declaration,
  [sym_method] = sym_method,
  [sym_procedure] = sym_procedure,
  [sym_argument] = sym_argument,
  [sym__arguments] = sym__arguments,
  [sym_block] = sym_block,
  [sym_assignment] = sym_assignment,
  [sym_if] = sym_if,
  [sym_elif] = sym_elif,
  [sym_else] = sym_else,
  [sym_loop] = sym_loop,
  [sym_finally] = sym_finally,
  [sym_handling] = sym_handling,
  [sym_catch] = sym_catch,
  [sym_throw] = sym_throw,
  [sym_primitive] = sym_primitive,
  [sym_iterator] = sym_iterator,
  [sym_while] = sym_while,
  [sym_try] = sym_try,
  [sym_loopbody] = sym_loopbody,
  [sym_leave] = sym_leave,
  [sym_continue] = sym_continue,
  [sym_protect] = sym_protect,
  [sym_lock] = sym_lock,
  [sym_pragma] = sym_pragma,
  [sym__literal] = sym__literal,
  [sym_character_literal] = sym_character_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_call] = sym_call,
  [sym_invoke] = sym_invoke,
  [sym_indexed_access] = sym_indexed_access,
  [sym_slot_accessor] = sym_slot_accessor,
  [sym__expression_list] = sym__expression_list,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_maybe] = sym_maybe,
  [sym_unset] = sym_unset,
  [sym_super] = sym_super,
  [sym_self] = sym_self,
  [sym_clone] = sym_clone,
  [sym_thisthread] = sym_thisthread,
  [sym_class] = sym_class,
  [sym__terminator] = sym__terminator,
  [sym__top_level_statement] = sym__top_level_statement,
  [sym__expression] = sym__expression,
  [sym__codeblock] = sym__codeblock,
  [sym__defvar] = sym__defvar,
  [sym_global] = sym_global,
  [sym_local] = sym_local,
  [sym__global_assignment] = sym__global_assignment,
  [sym_constant] = sym_constant,
  [sym_dynamic] = sym_dynamic,
  [sym_import] = sym_import,
  [sym_dynamic_import] = sym_dynamic_import,
  [sym_return] = sym_return,
  [sym__definition] = sym__definition,
  [sym_gather] = sym_gather,
  [sym_scatter] = sym_scatter,
  [sym_allresults] = sym_allresults,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__variable] = sym__variable,
  [sym_variable] = sym_variable,
  [sym_identifier] = sym_identifier,
  [sym__identifier] = sym__identifier,
  [sym__identifier_list] = sym__identifier_list,
  [sym_vector] = sym_vector,
  [sym_relational_operator] = sym_relational_operator,
  [sym_logical_operator] = sym_logical_operator,
  [sym_arithmetic_operator] = sym_arithmetic_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_documentation] = sym_documentation,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_fragment_repeat1] = aux_sym_fragment_repeat1,
  [aux_sym_package_repeat1] = aux_sym_package_repeat1,
  [aux_sym_method_repeat1] = aux_sym_method_repeat1,
  [aux_sym_if_repeat1] = aux_sym_if_repeat1,
  [aux_sym_handling_repeat1] = aux_sym_handling_repeat1,
  [aux_sym_try_repeat1] = aux_sym_try_repeat1,
  [aux_sym_try_repeat2] = aux_sym_try_repeat2,
  [aux_sym_loopbody_repeat1] = aux_sym_loopbody_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_string_literal_repeat2] = aux_sym_string_literal_repeat2,
  [aux_sym__codeblock_repeat1] = aux_sym__codeblock_repeat1,
  [aux_sym_global_repeat1] = aux_sym_global_repeat1,
  [aux_sym_local_repeat1] = aux_sym_local_repeat1,
  [aux_sym_dynamic_repeat1] = aux_sym_dynamic_repeat1,
  [aux_sym__identifier_list_repeat1] = aux_sym__identifier_list_repeat1,
  [aux_sym_documentation_repeat1] = aux_sym_documentation_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_CR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_package_token1] = {
    .visible = true,
    .named = false,
  },
  [sym__dollar] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_method_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_method_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_method_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_method_token4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_method_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_method_token6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_method_token7] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_procedure_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_block_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_block_token2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__and_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__andif_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__or_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__orif_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__xor_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_CARET_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_CARET_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_CARET_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__mod_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__div_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_CARET_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_CARET_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_if_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_elif_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_else_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_loop_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_loop_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_finally_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_finally_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_handling_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_handling_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_catch_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_catch_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_throw_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_primitive_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_iterator_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_iterator_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_while_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_try_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_try_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_try_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_loopbody_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_leave_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_continue_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_protect_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_protect_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_protect_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_protect_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_lock_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_lock_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pragma_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pragma_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_character_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SPACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [sym_regex_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_slot_accessor_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_true_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_false_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_maybe_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_unset_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_super_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_self_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_clone_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_thisthread_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_class_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_class_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_global_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_local_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__global_assignment_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_dynamic_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_import_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_return_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_scatter_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_allresults_token1] = {
    .visible = true,
    .named = false,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_relational_operator_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_relational_operator_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_relational_operator_token3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_operator_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_operator_token2] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_operator_token3] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_operator_token4] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_operator_token5] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_logical_operator_token6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_arithmetic_operator_token1] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_arithmetic_operator_token2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_unary_operator_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_documentation_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__line_terminator] = {
    .visible = false,
    .named = true,
  },
  [sym_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_package] = {
    .visible = true,
    .named = true,
  },
  [sym__method_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_procedure] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym__arguments] = {
    .visible = false,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_elif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym_loop] = {
    .visible = true,
    .named = true,
  },
  [sym_finally] = {
    .visible = true,
    .named = true,
  },
  [sym_handling] = {
    .visible = true,
    .named = true,
  },
  [sym_catch] = {
    .visible = true,
    .named = true,
  },
  [sym_throw] = {
    .visible = true,
    .named = true,
  },
  [sym_primitive] = {
    .visible = true,
    .named = true,
  },
  [sym_iterator] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_try] = {
    .visible = true,
    .named = true,
  },
  [sym_loopbody] = {
    .visible = true,
    .named = true,
  },
  [sym_leave] = {
    .visible = true,
    .named = true,
  },
  [sym_continue] = {
    .visible = true,
    .named = true,
  },
  [sym_protect] = {
    .visible = true,
    .named = true,
  },
  [sym_lock] = {
    .visible = true,
    .named = true,
  },
  [sym_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_invoke] = {
    .visible = true,
    .named = true,
  },
  [sym_indexed_access] = {
    .visible = true,
    .named = true,
  },
  [sym_slot_accessor] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_list] = {
    .visible = false,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_maybe] = {
    .visible = true,
    .named = true,
  },
  [sym_unset] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_clone] = {
    .visible = true,
    .named = true,
  },
  [sym_thisthread] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__codeblock] = {
    .visible = false,
    .named = true,
  },
  [sym__defvar] = {
    .visible = false,
    .named = true,
  },
  [sym_global] = {
    .visible = true,
    .named = true,
  },
  [sym_local] = {
    .visible = true,
    .named = true,
  },
  [sym__global_assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic] = {
    .visible = true,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic_import] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym__definition] = {
    .visible = false,
    .named = true,
  },
  [sym_gather] = {
    .visible = true,
    .named = true,
  },
  [sym_scatter] = {
    .visible = true,
    .named = true,
  },
  [sym_allresults] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier_list] = {
    .visible = false,
    .named = true,
  },
  [sym_vector] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_logical_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_arithmetic_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_documentation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fragment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_package_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_method_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_handling_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_loopbody_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__codeblock_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_local_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dynamic_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__identifier_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_documentation_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_condition = 1,
  field_exemplarname = 2,
  field_index = 3,
  field_java_classname = 4,
  field_left = 5,
  field_message = 6,
  field_name = 7,
  field_operator = 8,
  field_raised_condition = 9,
  field_receiver = 10,
  field_right = 11,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_condition] = "condition",
  [field_exemplarname] = "exemplarname",
  [field_index] = "index",
  [field_java_classname] = "java_classname",
  [field_left] = "left",
  [field_message] = "message",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_raised_condition] = "raised_condition",
  [field_receiver] = "receiver",
  [field_right] = "right",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 2},
  [6] = {.index = 6, .length = 3},
  [7] = {.index = 9, .length = 1},
  [8] = {.index = 10, .length = 3},
  [9] = {.index = 13, .length = 3},
  [10] = {.index = 16, .length = 1},
  [11] = {.index = 17, .length = 2},
  [12] = {.index = 19, .length = 1},
  [13] = {.index = 20, .length = 2},
  [14] = {.index = 22, .length = 1},
  [15] = {.index = 23, .length = 4},
  [16] = {.index = 27, .length = 2},
  [17] = {.index = 29, .length = 2},
  [18] = {.index = 31, .length = 2},
  [19] = {.index = 33, .length = 1},
  [20] = {.index = 34, .length = 2},
  [21] = {.index = 36, .length = 2},
  [22] = {.index = 38, .length = 1},
  [23] = {.index = 39, .length = 2},
  [24] = {.index = 41, .length = 1},
  [25] = {.index = 42, .length = 2},
  [26] = {.index = 44, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_java_classname, 1},
  [1] =
    {field_operator, 0},
  [2] =
    {field_raised_condition, 1},
  [3] =
    {field_raised_condition, 1, .inherited = true},
  [4] =
    {field_raised_condition, 0, .inherited = true},
    {field_raised_condition, 1, .inherited = true},
  [6] =
    {field_message, 2},
    {field_operator, 1},
    {field_receiver, 0},
  [9] =
    {field_receiver, 0},
  [10] =
    {field_index, 1},
    {field_index, 2},
    {field_receiver, 0},
  [13] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [16] =
    {field_condition, 1},
  [17] =
    {field_condition, 0, .inherited = true},
    {field_condition, 1, .inherited = true},
  [19] =
    {field_condition, 2},
  [20] =
    {field_raised_condition, 1},
    {field_raised_condition, 2, .inherited = true},
  [22] =
    {field_raised_condition, 2, .inherited = true},
  [23] =
    {field_index, 1},
    {field_index, 2},
    {field_index, 3},
    {field_receiver, 0},
  [27] =
    {field_condition, 1},
    {field_condition, 2, .inherited = true},
  [29] =
    {field_condition, 2},
    {field_raised_condition, 3, .inherited = true},
  [31] =
    {field_exemplarname, 1},
    {field_name, 3},
  [33] =
    {field_exemplarname, 1},
  [34] =
    {field_condition, 2},
    {field_raised_condition, 4, .inherited = true},
  [36] =
    {field_exemplarname, 2},
    {field_name, 4},
  [38] =
    {field_exemplarname, 2},
  [39] =
    {field_exemplarname, 3},
    {field_name, 5},
  [41] =
    {field_exemplarname, 3},
  [42] =
    {field_exemplarname, 4},
    {field_name, 6},
  [44] =
    {field_exemplarname, 4},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 2,
  [5] = 3,
  [6] = 3,
  [7] = 3,
  [8] = 2,
  [9] = 2,
  [10] = 3,
  [11] = 3,
  [12] = 2,
  [13] = 2,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 16,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 39,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 28,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 23,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 85,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 102,
  [103] = 103,
  [104] = 102,
  [105] = 96,
  [106] = 106,
  [107] = 100,
  [108] = 108,
  [109] = 106,
  [110] = 98,
  [111] = 111,
  [112] = 95,
  [113] = 113,
  [114] = 111,
  [115] = 115,
  [116] = 115,
  [117] = 113,
  [118] = 108,
  [119] = 119,
  [120] = 97,
  [121] = 119,
  [122] = 101,
  [123] = 99,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 126,
  [130] = 125,
  [131] = 128,
  [132] = 132,
  [133] = 133,
  [134] = 133,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 137,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 136,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 148,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 165,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 156,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 160,
  [181] = 181,
  [182] = 154,
  [183] = 183,
  [184] = 159,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 163,
  [192] = 185,
  [193] = 193,
  [194] = 194,
  [195] = 171,
  [196] = 167,
  [197] = 155,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 172,
  [207] = 183,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 166,
  [221] = 221,
  [222] = 216,
  [223] = 209,
  [224] = 169,
  [225] = 225,
  [226] = 188,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 179,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 143,
  [242] = 242,
  [243] = 14,
  [244] = 15,
  [245] = 245,
  [246] = 245,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 249,
  [251] = 248,
  [252] = 252,
  [253] = 252,
  [254] = 254,
  [255] = 254,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 257,
  [261] = 256,
  [262] = 262,
  [263] = 257,
  [264] = 259,
  [265] = 265,
  [266] = 256,
  [267] = 267,
  [268] = 267,
  [269] = 259,
  [270] = 265,
  [271] = 258,
  [272] = 262,
  [273] = 259,
  [274] = 257,
  [275] = 275,
  [276] = 276,
  [277] = 262,
  [278] = 278,
  [279] = 259,
  [280] = 257,
  [281] = 256,
  [282] = 256,
  [283] = 257,
  [284] = 257,
  [285] = 275,
  [286] = 276,
  [287] = 258,
  [288] = 258,
  [289] = 257,
  [290] = 256,
  [291] = 259,
  [292] = 257,
  [293] = 278,
  [294] = 259,
  [295] = 256,
  [296] = 258,
  [297] = 259,
  [298] = 258,
  [299] = 259,
  [300] = 256,
  [301] = 256,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 304,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 302,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 304,
  [317] = 317,
  [318] = 309,
  [319] = 302,
  [320] = 304,
  [321] = 321,
  [322] = 317,
  [323] = 314,
  [324] = 324,
  [325] = 325,
  [326] = 326,
  [327] = 327,
  [328] = 328,
  [329] = 313,
  [330] = 310,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 302,
  [342] = 304,
  [343] = 343,
  [344] = 344,
  [345] = 345,
  [346] = 321,
  [347] = 313,
  [348] = 348,
  [349] = 314,
  [350] = 317,
  [351] = 351,
  [352] = 344,
  [353] = 353,
  [354] = 354,
  [355] = 324,
  [356] = 351,
  [357] = 357,
  [358] = 326,
  [359] = 333,
  [360] = 328,
  [361] = 335,
  [362] = 327,
  [363] = 363,
  [364] = 364,
  [365] = 304,
  [366] = 302,
  [367] = 367,
  [368] = 368,
  [369] = 313,
  [370] = 314,
  [371] = 317,
  [372] = 303,
  [373] = 373,
  [374] = 343,
  [375] = 338,
  [376] = 376,
  [377] = 364,
  [378] = 336,
  [379] = 306,
  [380] = 317,
  [381] = 332,
  [382] = 305,
  [383] = 383,
  [384] = 363,
  [385] = 385,
  [386] = 304,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 304,
  [391] = 314,
  [392] = 385,
  [393] = 317,
  [394] = 357,
  [395] = 313,
  [396] = 373,
  [397] = 324,
  [398] = 354,
  [399] = 399,
  [400] = 400,
  [401] = 326,
  [402] = 402,
  [403] = 388,
  [404] = 314,
  [405] = 317,
  [406] = 302,
  [407] = 313,
  [408] = 304,
  [409] = 388,
  [410] = 333,
  [411] = 400,
  [412] = 373,
  [413] = 335,
  [414] = 303,
  [415] = 348,
  [416] = 314,
  [417] = 400,
  [418] = 317,
  [419] = 315,
  [420] = 335,
  [421] = 333,
  [422] = 376,
  [423] = 326,
  [424] = 324,
  [425] = 368,
  [426] = 324,
  [427] = 326,
  [428] = 333,
  [429] = 335,
  [430] = 363,
  [431] = 363,
  [432] = 373,
  [433] = 383,
  [434] = 303,
  [435] = 334,
  [436] = 317,
  [437] = 335,
  [438] = 333,
  [439] = 388,
  [440] = 400,
  [441] = 441,
  [442] = 326,
  [443] = 324,
  [444] = 313,
  [445] = 388,
  [446] = 324,
  [447] = 399,
  [448] = 353,
  [449] = 373,
  [450] = 345,
  [451] = 400,
  [452] = 303,
  [453] = 314,
  [454] = 339,
  [455] = 387,
  [456] = 331,
  [457] = 333,
  [458] = 313,
  [459] = 340,
  [460] = 325,
  [461] = 335,
  [462] = 326,
  [463] = 463,
  [464] = 313,
  [465] = 363,
  [466] = 303,
  [467] = 337,
  [468] = 388,
  [469] = 387,
  [470] = 335,
  [471] = 333,
  [472] = 324,
  [473] = 326,
  [474] = 400,
  [475] = 333,
  [476] = 335,
  [477] = 326,
  [478] = 324,
  [479] = 373,
  [480] = 363,
  [481] = 314,
  [482] = 367,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 498,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 506,
  [507] = 507,
  [508] = 508,
  [509] = 509,
  [510] = 510,
  [511] = 511,
  [512] = 512,
  [513] = 513,
  [514] = 514,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 484,
  [527] = 527,
  [528] = 485,
  [529] = 529,
  [530] = 530,
  [531] = 531,
  [532] = 532,
  [533] = 533,
  [534] = 534,
  [535] = 519,
  [536] = 536,
  [537] = 537,
  [538] = 517,
  [539] = 539,
  [540] = 506,
  [541] = 505,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 557,
  [558] = 536,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 565,
  [566] = 566,
  [567] = 567,
  [568] = 542,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 572,
  [573] = 573,
  [574] = 496,
  [575] = 575,
  [576] = 498,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 581,
  [582] = 582,
  [583] = 583,
  [584] = 584,
  [585] = 585,
  [586] = 586,
  [587] = 587,
  [588] = 588,
  [589] = 589,
  [590] = 590,
  [591] = 591,
  [592] = 592,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 498,
  [599] = 599,
  [600] = 600,
  [601] = 601,
  [602] = 517,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 533,
  [607] = 607,
  [608] = 529,
  [609] = 498,
  [610] = 496,
  [611] = 542,
  [612] = 536,
  [613] = 496,
  [614] = 519,
  [615] = 484,
  [616] = 485,
  [617] = 506,
  [618] = 505,
  [619] = 607,
  [620] = 620,
  [621] = 584,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 583,
  [626] = 626,
  [627] = 519,
  [628] = 517,
  [629] = 629,
  [630] = 506,
  [631] = 505,
  [632] = 585,
  [633] = 536,
  [634] = 542,
  [635] = 635,
  [636] = 533,
  [637] = 599,
  [638] = 603,
  [639] = 601,
  [640] = 623,
  [641] = 641,
  [642] = 624,
  [643] = 604,
  [644] = 629,
  [645] = 620,
  [646] = 622,
  [647] = 605,
  [648] = 529,
  [649] = 626,
  [650] = 599,
  [651] = 651,
  [652] = 652,
  [653] = 653,
  [654] = 626,
  [655] = 655,
  [656] = 656,
  [657] = 605,
  [658] = 658,
  [659] = 659,
  [660] = 660,
  [661] = 661,
  [662] = 532,
  [663] = 663,
  [664] = 664,
  [665] = 622,
  [666] = 666,
  [667] = 604,
  [668] = 603,
  [669] = 624,
  [670] = 629,
  [671] = 671,
  [672] = 623,
  [673] = 673,
  [674] = 674,
  [675] = 675,
  [676] = 676,
  [677] = 677,
  [678] = 678,
  [679] = 679,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 686,
  [687] = 687,
  [688] = 483,
  [689] = 689,
  [690] = 690,
  [691] = 691,
  [692] = 692,
  [693] = 693,
  [694] = 483,
  [695] = 483,
  [696] = 696,
  [697] = 584,
  [698] = 496,
  [699] = 542,
  [700] = 485,
  [701] = 498,
  [702] = 583,
  [703] = 484,
  [704] = 506,
  [705] = 536,
  [706] = 505,
  [707] = 585,
  [708] = 484,
  [709] = 485,
  [710] = 519,
  [711] = 517,
  [712] = 542,
  [713] = 557,
  [714] = 556,
  [715] = 519,
  [716] = 496,
  [717] = 517,
  [718] = 487,
  [719] = 597,
  [720] = 595,
  [721] = 594,
  [722] = 593,
  [723] = 498,
  [724] = 591,
  [725] = 590,
  [726] = 599,
  [727] = 589,
  [728] = 603,
  [729] = 604,
  [730] = 527,
  [731] = 605,
  [732] = 620,
  [733] = 500,
  [734] = 585,
  [735] = 583,
  [736] = 512,
  [737] = 514,
  [738] = 523,
  [739] = 536,
  [740] = 548,
  [741] = 549,
  [742] = 584,
  [743] = 485,
  [744] = 484,
  [745] = 536,
  [746] = 497,
  [747] = 501,
  [748] = 524,
  [749] = 502,
  [750] = 503,
  [751] = 519,
  [752] = 587,
  [753] = 583,
  [754] = 580,
  [755] = 578,
  [756] = 515,
  [757] = 629,
  [758] = 575,
  [759] = 571,
  [760] = 493,
  [761] = 570,
  [762] = 569,
  [763] = 562,
  [764] = 504,
  [765] = 506,
  [766] = 489,
  [767] = 505,
  [768] = 626,
  [769] = 488,
  [770] = 555,
  [771] = 624,
  [772] = 581,
  [773] = 623,
  [774] = 622,
  [775] = 542,
  [776] = 554,
  [777] = 550,
  [778] = 530,
  [779] = 584,
  [780] = 496,
  [781] = 601,
  [782] = 498,
  [783] = 572,
  [784] = 539,
  [785] = 536,
  [786] = 510,
  [787] = 596,
  [788] = 521,
  [789] = 542,
  [790] = 567,
  [791] = 529,
  [792] = 533,
  [793] = 607,
  [794] = 565,
  [795] = 532,
  [796] = 509,
  [797] = 508,
  [798] = 564,
  [799] = 592,
  [800] = 486,
  [801] = 607,
  [802] = 518,
  [803] = 579,
  [804] = 496,
  [805] = 498,
  [806] = 520,
  [807] = 582,
  [808] = 560,
  [809] = 543,
  [810] = 491,
  [811] = 516,
  [812] = 561,
  [813] = 492,
  [814] = 490,
  [815] = 559,
  [816] = 494,
  [817] = 525,
  [818] = 531,
  [819] = 495,
  [820] = 585,
  [821] = 499,
  [822] = 586,
  [823] = 511,
  [824] = 534,
  [825] = 566,
  [826] = 522,
  [827] = 519,
  [828] = 517,
  [829] = 537,
  [830] = 577,
  [831] = 513,
  [832] = 545,
  [833] = 506,
  [834] = 505,
  [835] = 544,
  [836] = 507,
  [837] = 517,
  [838] = 563,
  [839] = 573,
  [840] = 506,
  [841] = 588,
  [842] = 553,
  [843] = 505,
  [844] = 552,
  [845] = 533,
  [846] = 551,
  [847] = 547,
  [848] = 546,
  [849] = 529,
  [850] = 506,
  [851] = 533,
  [852] = 624,
  [853] = 496,
  [854] = 542,
  [855] = 629,
  [856] = 536,
  [857] = 498,
  [858] = 496,
  [859] = 620,
  [860] = 626,
  [861] = 603,
  [862] = 604,
  [863] = 624,
  [864] = 605,
  [865] = 623,
  [866] = 604,
  [867] = 603,
  [868] = 622,
  [869] = 622,
  [870] = 599,
  [871] = 620,
  [872] = 505,
  [873] = 623,
  [874] = 605,
  [875] = 542,
  [876] = 517,
  [877] = 536,
  [878] = 607,
  [879] = 484,
  [880] = 519,
  [881] = 626,
  [882] = 485,
  [883] = 601,
  [884] = 599,
  [885] = 601,
  [886] = 505,
  [887] = 498,
  [888] = 506,
  [889] = 517,
  [890] = 498,
  [891] = 519,
  [892] = 496,
  [893] = 542,
  [894] = 583,
  [895] = 585,
  [896] = 584,
  [897] = 519,
  [898] = 517,
  [899] = 506,
  [900] = 505,
  [901] = 629,
  [902] = 607,
  [903] = 600,
  [904] = 529,
  [905] = 536,
  [906] = 906,
  [907] = 485,
  [908] = 519,
  [909] = 635,
  [910] = 623,
  [911] = 641,
  [912] = 624,
  [913] = 533,
  [914] = 626,
  [915] = 622,
  [916] = 916,
  [917] = 916,
  [918] = 505,
  [919] = 506,
  [920] = 920,
  [921] = 620,
  [922] = 498,
  [923] = 601,
  [924] = 906,
  [925] = 484,
  [926] = 529,
  [927] = 629,
  [928] = 599,
  [929] = 603,
  [930] = 920,
  [931] = 604,
  [932] = 605,
  [933] = 536,
  [934] = 542,
  [935] = 496,
  [936] = 517,
  [937] = 624,
  [938] = 626,
  [939] = 661,
  [940] = 651,
  [941] = 629,
  [942] = 623,
  [943] = 533,
  [944] = 673,
  [945] = 622,
  [946] = 605,
  [947] = 604,
  [948] = 529,
  [949] = 659,
  [950] = 652,
  [951] = 656,
  [952] = 674,
  [953] = 671,
  [954] = 676,
  [955] = 675,
  [956] = 663,
  [957] = 660,
  [958] = 603,
  [959] = 599,
  [960] = 658,
  [961] = 653,
  [962] = 666,
  [963] = 664,
  [964] = 655,
  [965] = 965,
  [966] = 966,
  [967] = 604,
  [968] = 968,
  [969] = 603,
  [970] = 599,
  [971] = 971,
  [972] = 972,
  [973] = 965,
  [974] = 974,
  [975] = 966,
  [976] = 965,
  [977] = 965,
  [978] = 965,
  [979] = 979,
  [980] = 974,
  [981] = 968,
  [982] = 965,
  [983] = 965,
  [984] = 979,
  [985] = 605,
  [986] = 965,
  [987] = 623,
  [988] = 626,
  [989] = 629,
  [990] = 624,
  [991] = 965,
  [992] = 972,
  [993] = 622,
  [994] = 971,
  [995] = 995,
  [996] = 996,
  [997] = 997,
  [998] = 998,
  [999] = 999,
  [1000] = 641,
  [1001] = 1001,
  [1002] = 1002,
  [1003] = 1003,
  [1004] = 1004,
  [1005] = 1005,
  [1006] = 1006,
  [1007] = 1007,
  [1008] = 1008,
  [1009] = 1006,
  [1010] = 1010,
  [1011] = 1003,
  [1012] = 1012,
  [1013] = 1013,
  [1014] = 1014,
  [1015] = 1010,
  [1016] = 1012,
  [1017] = 1008,
  [1018] = 1013,
  [1019] = 1004,
  [1020] = 1005,
  [1021] = 1007,
  [1022] = 1022,
  [1023] = 1023,
  [1024] = 1024,
  [1025] = 1025,
  [1026] = 1026,
  [1027] = 1027,
  [1028] = 1028,
  [1029] = 1029,
  [1030] = 1030,
  [1031] = 687,
  [1032] = 1032,
  [1033] = 686,
  [1034] = 1034,
  [1035] = 1035,
  [1036] = 1036,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1040,
  [1041] = 691,
  [1042] = 680,
  [1043] = 1043,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1047,
  [1048] = 1048,
  [1049] = 1049,
  [1050] = 1050,
  [1051] = 1051,
  [1052] = 1052,
  [1053] = 1053,
  [1054] = 1054,
  [1055] = 1055,
  [1056] = 1040,
  [1057] = 1032,
  [1058] = 1058,
  [1059] = 1059,
  [1060] = 1060,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 690,
  [1064] = 1058,
  [1065] = 1029,
  [1066] = 1034,
  [1067] = 1036,
  [1068] = 1030,
  [1069] = 693,
  [1070] = 1070,
  [1071] = 1028,
  [1072] = 1037,
  [1073] = 1073,
  [1074] = 1024,
  [1075] = 1062,
  [1076] = 1059,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1080,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1081,
  [1085] = 1085,
  [1086] = 1044,
  [1087] = 1083,
  [1088] = 683,
  [1089] = 1082,
  [1090] = 1085,
  [1091] = 1091,
  [1092] = 1092,
  [1093] = 1093,
  [1094] = 1094,
  [1095] = 1095,
  [1096] = 1096,
  [1097] = 1097,
  [1098] = 1098,
  [1099] = 1099,
  [1100] = 1100,
  [1101] = 1100,
  [1102] = 1102,
  [1103] = 1053,
  [1104] = 1104,
  [1105] = 1105,
  [1106] = 1106,
  [1107] = 1107,
  [1108] = 1108,
  [1109] = 1054,
  [1110] = 1110,
  [1111] = 1111,
  [1112] = 1050,
  [1113] = 1113,
  [1114] = 1114,
  [1115] = 1055,
  [1116] = 1046,
  [1117] = 1117,
  [1118] = 1118,
  [1119] = 1119,
  [1120] = 1047,
  [1121] = 1051,
  [1122] = 1122,
  [1123] = 1123,
  [1124] = 1124,
  [1125] = 1125,
  [1126] = 1126,
  [1127] = 1048,
  [1128] = 1045,
  [1129] = 1129,
  [1130] = 1130,
  [1131] = 1131,
  [1132] = 1132,
  [1133] = 1133,
  [1134] = 1134,
  [1135] = 1102,
  [1136] = 1136,
  [1137] = 1137,
  [1138] = 1138,
  [1139] = 1139,
  [1140] = 1140,
  [1141] = 1141,
  [1142] = 1142,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1145,
  [1146] = 1146,
  [1147] = 1147,
  [1148] = 693,
  [1149] = 1149,
  [1150] = 1150,
  [1151] = 1151,
  [1152] = 690,
  [1153] = 1153,
  [1154] = 692,
  [1155] = 1155,
  [1156] = 1156,
  [1157] = 1157,
  [1158] = 1158,
  [1159] = 687,
  [1160] = 1160,
  [1161] = 1104,
  [1162] = 1162,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1167,
  [1168] = 1168,
  [1169] = 1150,
  [1170] = 686,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1173,
  [1174] = 1174,
  [1175] = 1105,
  [1176] = 1176,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1179,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1174,
  [1183] = 689,
  [1184] = 1184,
  [1185] = 1185,
  [1186] = 1186,
  [1187] = 1180,
  [1188] = 1188,
  [1189] = 1160,
  [1190] = 1190,
  [1191] = 1158,
  [1192] = 1192,
  [1193] = 1193,
  [1194] = 1194,
  [1195] = 1134,
  [1196] = 1196,
  [1197] = 1176,
  [1198] = 1198,
  [1199] = 1199,
  [1200] = 691,
  [1201] = 1201,
  [1202] = 1178,
  [1203] = 1203,
  [1204] = 1204,
  [1205] = 1205,
  [1206] = 1206,
  [1207] = 1207,
  [1208] = 1208,
  [1209] = 1209,
  [1210] = 1210,
  [1211] = 1211,
  [1212] = 1212,
  [1213] = 1213,
  [1214] = 1214,
  [1215] = 1215,
  [1216] = 689,
  [1217] = 1217,
  [1218] = 1218,
  [1219] = 1219,
  [1220] = 1220,
  [1221] = 1221,
  [1222] = 1222,
  [1223] = 1223,
  [1224] = 1224,
  [1225] = 1221,
  [1226] = 1226,
  [1227] = 1227,
  [1228] = 1228,
  [1229] = 1229,
  [1230] = 1230,
  [1231] = 1231,
  [1232] = 1232,
  [1233] = 1233,
  [1234] = 1234,
  [1235] = 1235,
  [1236] = 1236,
  [1237] = 1237,
  [1238] = 1238,
  [1239] = 1239,
  [1240] = 1240,
  [1241] = 1209,
  [1242] = 1242,
  [1243] = 1243,
  [1244] = 1244,
  [1245] = 1245,
  [1246] = 1242,
  [1247] = 1247,
  [1248] = 1248,
  [1249] = 1249,
  [1250] = 692,
  [1251] = 1205,
  [1252] = 683,
  [1253] = 1239,
  [1254] = 1254,
  [1255] = 1255,
  [1256] = 1256,
  [1257] = 1257,
  [1258] = 1258,
  [1259] = 1210,
  [1260] = 1260,
  [1261] = 1261,
  [1262] = 1262,
  [1263] = 1254,
  [1264] = 1264,
  [1265] = 1265,
  [1266] = 1266,
  [1267] = 1220,
  [1268] = 1215,
  [1269] = 1269,
  [1270] = 1270,
  [1271] = 1217,
  [1272] = 1272,
  [1273] = 1273,
  [1274] = 1274,
  [1275] = 1275,
  [1276] = 1276,
  [1277] = 1249,
  [1278] = 1278,
  [1279] = 1279,
  [1280] = 1280,
  [1281] = 1281,
  [1282] = 1219,
  [1283] = 1283,
  [1284] = 1245,
  [1285] = 1285,
  [1286] = 1286,
  [1287] = 1287,
  [1288] = 1288,
  [1289] = 1289,
  [1290] = 1235,
  [1291] = 1291,
  [1292] = 1292,
  [1293] = 1293,
  [1294] = 1294,
  [1295] = 1273,
  [1296] = 1288,
  [1297] = 1297,
  [1298] = 1298,
  [1299] = 1299,
  [1300] = 1248,
  [1301] = 1301,
  [1302] = 1281,
  [1303] = 1303,
  [1304] = 1304,
  [1305] = 1305,
  [1306] = 1236,
  [1307] = 1307,
  [1308] = 1208,
  [1309] = 1238,
  [1310] = 1283,
  [1311] = 1247,
  [1312] = 1312,
  [1313] = 1298,
  [1314] = 1228,
  [1315] = 1266,
  [1316] = 1316,
  [1317] = 1317,
  [1318] = 1318,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1227,
  [1325] = 1231,
  [1326] = 1326,
  [1327] = 1327,
  [1328] = 1328,
  [1329] = 1329,
  [1330] = 1330,
  [1331] = 1331,
  [1332] = 1332,
  [1333] = 1333,
  [1334] = 1269,
  [1335] = 1222,
  [1336] = 1291,
  [1337] = 1337,
  [1338] = 1338,
  [1339] = 1339,
  [1340] = 1340,
  [1341] = 1341,
  [1342] = 1342,
  [1343] = 1343,
  [1344] = 1344,
  [1345] = 1345,
  [1346] = 1346,
  [1347] = 1347,
  [1348] = 1348,
  [1349] = 1349,
  [1350] = 1350,
  [1351] = 1351,
  [1352] = 1352,
  [1353] = 1353,
  [1354] = 1354,
  [1355] = 1355,
  [1356] = 1351,
  [1357] = 1357,
  [1358] = 1358,
  [1359] = 1351,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1363,
  [1364] = 1364,
  [1365] = 1365,
  [1366] = 1366,
  [1367] = 1367,
  [1368] = 1368,
  [1369] = 1368,
  [1370] = 1370,
  [1371] = 1371,
  [1372] = 1372,
  [1373] = 1373,
  [1374] = 1374,
  [1375] = 1375,
  [1376] = 1376,
  [1377] = 1377,
  [1378] = 1378,
  [1379] = 1379,
  [1380] = 1380,
  [1381] = 1381,
  [1382] = 1351,
  [1383] = 1383,
  [1384] = 1384,
  [1385] = 1385,
  [1386] = 1343,
  [1387] = 1387,
  [1388] = 1388,
  [1389] = 1389,
  [1390] = 1390,
  [1391] = 1391,
  [1392] = 1392,
  [1393] = 1393,
  [1394] = 1394,
  [1395] = 1395,
  [1396] = 1396,
  [1397] = 1368,
  [1398] = 1398,
  [1399] = 1399,
  [1400] = 1400,
  [1401] = 1401,
  [1402] = 1351,
  [1403] = 1403,
  [1404] = 1404,
  [1405] = 1405,
  [1406] = 1406,
  [1407] = 1407,
  [1408] = 1408,
  [1409] = 1409,
  [1410] = 1410,
  [1411] = 1411,
  [1412] = 1412,
  [1413] = 1413,
  [1414] = 1414,
  [1415] = 1415,
  [1416] = 1416,
  [1417] = 1417,
  [1418] = 1418,
  [1419] = 1403,
  [1420] = 1420,
  [1421] = 1421,
  [1422] = 1422,
  [1423] = 1351,
  [1424] = 1424,
  [1425] = 1425,
  [1426] = 1426,
  [1427] = 1427,
  [1428] = 1428,
  [1429] = 1429,
  [1430] = 1348,
  [1431] = 1368,
  [1432] = 1432,
  [1433] = 1433,
  [1434] = 1434,
  [1435] = 1435,
  [1436] = 1436,
  [1437] = 1437,
  [1438] = 1393,
  [1439] = 1439,
  [1440] = 1440,
  [1441] = 1441,
  [1442] = 1409,
  [1443] = 1443,
  [1444] = 1351,
  [1445] = 1426,
  [1446] = 1433,
  [1447] = 677,
  [1448] = 1434,
  [1449] = 1449,
  [1450] = 1450,
  [1451] = 1451,
  [1452] = 1452,
  [1453] = 1453,
  [1454] = 1416,
  [1455] = 1455,
  [1456] = 1349,
  [1457] = 1457,
  [1458] = 1458,
  [1459] = 1459,
  [1460] = 1399,
  [1461] = 1461,
  [1462] = 1375,
  [1463] = 1463,
  [1464] = 1464,
  [1465] = 1465,
  [1466] = 1466,
  [1467] = 1467,
  [1468] = 1361,
  [1469] = 1469,
  [1470] = 1466,
  [1471] = 1471,
  [1472] = 1472,
  [1473] = 1473,
  [1474] = 1037,
  [1475] = 1404,
  [1476] = 1476,
  [1477] = 1408,
  [1478] = 1478,
  [1479] = 1364,
  [1480] = 1480,
  [1481] = 1481,
  [1482] = 1482,
  [1483] = 1463,
  [1484] = 1484,
  [1485] = 1044,
  [1486] = 1486,
  [1487] = 1339,
  [1488] = 1439,
  [1489] = 1400,
  [1490] = 1490,
  [1491] = 678,
  [1492] = 1492,
  [1493] = 1493,
  [1494] = 1433,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1459,
  [1498] = 1498,
  [1499] = 1388,
  [1500] = 1387,
  [1501] = 1383,
  [1502] = 1381,
  [1503] = 1450,
  [1504] = 1504,
  [1505] = 1505,
  [1506] = 1506,
  [1507] = 1371,
  [1508] = 1377,
  [1509] = 1509,
  [1510] = 1510,
  [1511] = 1511,
  [1512] = 1512,
  [1513] = 1513,
  [1514] = 1486,
  [1515] = 1515,
  [1516] = 1422,
  [1517] = 1368,
  [1518] = 1496,
  [1519] = 1519,
  [1520] = 1520,
  [1521] = 1521,
  [1522] = 1522,
  [1523] = 1523,
  [1524] = 1524,
  [1525] = 1352,
  [1526] = 1526,
  [1527] = 1363,
  [1528] = 1393,
  [1529] = 1365,
  [1530] = 1530,
  [1531] = 1504,
  [1532] = 1351,
  [1533] = 1533,
  [1534] = 1490,
  [1535] = 1535,
  [1536] = 1536,
  [1537] = 1537,
  [1538] = 1538,
  [1539] = 1537,
  [1540] = 1490,
  [1541] = 1351,
  [1542] = 1370,
  [1543] = 1543,
  [1544] = 1476,
  [1545] = 1368,
  [1546] = 1546,
  [1547] = 1547,
  [1548] = 1458,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1551,
  [1552] = 1552,
  [1553] = 1553,
  [1554] = 1554,
  [1555] = 1555,
  [1556] = 1556,
  [1557] = 1557,
  [1558] = 1558,
  [1559] = 1559,
  [1560] = 1560,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1563,
  [1564] = 1564,
  [1565] = 1564,
  [1566] = 1566,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1571,
  [1572] = 1572,
  [1573] = 1573,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1576,
  [1577] = 1577,
  [1578] = 1578,
  [1579] = 1579,
  [1580] = 1580,
  [1581] = 1581,
  [1582] = 1582,
  [1583] = 1583,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1586,
  [1587] = 1587,
  [1588] = 1588,
  [1589] = 1588,
  [1590] = 1590,
  [1591] = 1591,
  [1592] = 1567,
  [1593] = 1593,
  [1594] = 1594,
  [1595] = 1595,
  [1596] = 1596,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1599,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1603,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1606,
  [1607] = 1561,
  [1608] = 1608,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1559,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1619,
  [1628] = 1628,
  [1629] = 1629,
  [1630] = 1630,
  [1631] = 1631,
  [1632] = 1632,
  [1633] = 1633,
  [1634] = 1634,
  [1635] = 1560,
  [1636] = 1636,
  [1637] = 1637,
  [1638] = 1638,
  [1639] = 1639,
  [1640] = 1640,
  [1641] = 1641,
  [1642] = 1642,
  [1643] = 1643,
  [1644] = 1644,
  [1645] = 1595,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 1648,
  [1649] = 1649,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1653,
  [1654] = 1557,
  [1655] = 1655,
  [1656] = 1656,
  [1657] = 1657,
  [1658] = 1630,
  [1659] = 1659,
  [1660] = 1660,
  [1661] = 1661,
  [1662] = 1662,
  [1663] = 1616,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1667,
  [1668] = 1618,
  [1669] = 1669,
  [1670] = 1670,
  [1671] = 1671,
  [1672] = 1672,
  [1673] = 1673,
  [1674] = 1674,
  [1675] = 1675,
  [1676] = 1676,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1673,
  [1682] = 1682,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1689,
  [1690] = 1690,
  [1691] = 1691,
  [1692] = 1692,
  [1693] = 1693,
  [1694] = 1694,
  [1695] = 1695,
  [1696] = 1696,
  [1697] = 1697,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1700,
  [1701] = 1701,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1704,
  [1705] = 1705,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1709,
  [1710] = 1710,
  [1711] = 1711,
  [1712] = 1712,
  [1713] = 1713,
  [1714] = 1694,
  [1715] = 1715,
  [1716] = 1716,
  [1717] = 1717,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1722,
  [1723] = 1723,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 1726,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1729,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1734,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1737,
  [1738] = 1738,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1743,
  [1744] = 1744,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1747,
  [1748] = 1748,
  [1749] = 1749,
  [1750] = 1750,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1723,
  [1754] = 1754,
  [1755] = 1755,
  [1756] = 1756,
  [1757] = 1757,
  [1758] = 1758,
  [1759] = 1759,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1764,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1768,
  [1769] = 1769,
  [1770] = 1770,
  [1771] = 1771,
  [1772] = 1767,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1775,
  [1776] = 1776,
  [1777] = 1752,
  [1778] = 1778,
  [1779] = 1779,
  [1780] = 1780,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1722,
  [1786] = 1786,
  [1787] = 1757,
  [1788] = 1775,
  [1789] = 1789,
  [1790] = 1711,
  [1791] = 1791,
  [1792] = 1704,
  [1793] = 1793,
  [1794] = 1690,
  [1795] = 1795,
  [1796] = 1796,
  [1797] = 1688,
  [1798] = 1798,
  [1799] = 1679,
  [1800] = 1800,
  [1801] = 1793,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1807,
  [1808] = 1808,
  [1809] = 1809,
  [1810] = 1810,
  [1811] = 1811,
  [1812] = 1812,
  [1813] = 1813,
  [1814] = 1814,
  [1815] = 1815,
  [1816] = 1816,
  [1817] = 1817,
  [1818] = 1818,
  [1819] = 1712,
  [1820] = 1820,
  [1821] = 1821,
  [1822] = 1822,
  [1823] = 1758,
  [1824] = 1824,
  [1825] = 1812,
  [1826] = 1791,
  [1827] = 1827,
  [1828] = 1828,
  [1829] = 1829,
  [1830] = 1830,
  [1831] = 1831,
  [1832] = 1771,
  [1833] = 1833,
  [1834] = 1834,
  [1835] = 1731,
  [1836] = 1836,
  [1837] = 1837,
  [1838] = 1838,
  [1839] = 1839,
  [1840] = 1840,
  [1841] = 1841,
  [1842] = 1842,
  [1843] = 1811,
  [1844] = 1844,
  [1845] = 1845,
  [1846] = 1737,
  [1847] = 1745,
  [1848] = 1729,
  [1849] = 1849,
  [1850] = 1850,
  [1851] = 1851,
  [1852] = 1727,
  [1853] = 1853,
  [1854] = 1694,
  [1855] = 1809,
  [1856] = 1856,
  [1857] = 1857,
  [1858] = 1858,
  [1859] = 1859,
  [1860] = 1675,
  [1861] = 1861,
  [1862] = 1755,
  [1863] = 1863,
  [1864] = 1864,
  [1865] = 1865,
  [1866] = 1738,
  [1867] = 1687,
  [1868] = 1868,
  [1869] = 1869,
  [1870] = 1870,
  [1871] = 1871,
  [1872] = 1872,
  [1873] = 1873,
  [1874] = 1874,
  [1875] = 1875,
  [1876] = 1876,
  [1877] = 1877,
  [1878] = 1871,
  [1879] = 1879,
  [1880] = 1880,
  [1881] = 1864,
  [1882] = 1882,
  [1883] = 1693,
  [1884] = 1884,
  [1885] = 1697,
  [1886] = 1870,
  [1887] = 1882,
  [1888] = 1888,
  [1889] = 1880,
  [1890] = 1890,
  [1891] = 1803,
  [1892] = 1672,
  [1893] = 1893,
  [1894] = 1849,
  [1895] = 1701,
  [1896] = 1896,
  [1897] = 1703,
  [1898] = 1898,
  [1899] = 1857,
  [1900] = 1900,
  [1901] = 1853,
  [1902] = 1821,
  [1903] = 1903,
  [1904] = 1904,
  [1905] = 1694,
  [1906] = 1906,
  [1907] = 1907,
  [1908] = 1720,
  [1909] = 1734,
  [1910] = 1910,
  [1911] = 1735,
  [1912] = 1912,
  [1913] = 1913,
  [1914] = 1914,
  [1915] = 1915,
  [1916] = 1916,
  [1917] = 1917,
  [1918] = 1839,
  [1919] = 1919,
  [1920] = 1920,
  [1921] = 1836,
  [1922] = 1922,
  [1923] = 1923,
  [1924] = 1884,
  [1925] = 1925,
  [1926] = 1741,
  [1927] = 1837,
  [1928] = 1744,
  [1929] = 1925,
  [1930] = 1930,
  [1931] = 1747,
  [1932] = 1691,
  [1933] = 1933,
  [1934] = 1868,
  [1935] = 1935,
  [1936] = 1936,
  [1937] = 1754,
  [1938] = 1765,
  [1939] = 1939,
  [1940] = 1796,
  [1941] = 1708,
  [1942] = 1802,
  [1943] = 1678,
  [1944] = 1817,
  [1945] = 1945,
  [1946] = 1876,
  [1947] = 1947,
  [1948] = 1827,
  [1949] = 1840,
  [1950] = 1950,
  [1951] = 1684,
  [1952] = 1713,
  [1953] = 1953,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(385);
      ADVANCE_MAP(
        '!', 17,
        '"', 470,
        '#', 553,
        '$', 2,
        '%', 465,
        '\'', 476,
        '(', 396,
        ')', 400,
        '*', 537,
        '+', 547,
        ',', 397,
        '-', 545,
        '.', 395,
        '/', 538,
        ':', 75,
        ';', 491,
        '<', 522,
        '=', 517,
        '>', 524,
        '@', 502,
        '[', 403,
        ']', 404,
        '^', 42,
        '_', 50,
        '{', 512,
        '|', 77,
        '}', 513,
        '~', 550,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(478);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(390);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(390);
      if (lookahead == '\r') ADVANCE(1);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '\n', 387,
        '\r', 386,
        '!', 17,
        '"', 470,
        '#', 554,
        '%', 465,
        '\'', 476,
        '(', 396,
        '*', 537,
        '+', 547,
        ',', 397,
        '-', 545,
        '.', 395,
        '/', 538,
        ':', 75,
        ';', 491,
        '<', 522,
        '=', 517,
        '>', 524,
        '@', 383,
        '[', 403,
        '^', 42,
        '_', 52,
        '{', 512,
        '~', 550,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(3);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(478);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '\n', 387,
        '\r', 386,
        '!', 17,
        '"', 470,
        '#', 554,
        '%', 465,
        '\'', 476,
        '(', 396,
        '*', 537,
        '+', 547,
        ',', 397,
        '-', 545,
        '.', 395,
        '/', 538,
        ':', 75,
        ';', 491,
        '<', 522,
        '=', 517,
        '>', 524,
        '@', 383,
        '[', 403,
        '^', 42,
        '_', 53,
        '{', 512,
        '~', 550,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(4);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(478);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '\n', 387,
        '\r', 386,
        '#', 554,
        '(', 396,
        '*', 537,
        '+', 547,
        ',', 397,
        '-', 545,
        '.', 395,
        '/', 539,
        ';', 491,
        '<', 522,
        '=', 517,
        '>', 523,
        '@', 503,
        '[', 403,
        '^', 42,
        '_', 55,
        '~', 48,
      );
      if (('\t' <= lookahead && lookahead <= '\f') ||
          lookahead == ' ') SKIP(5);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(480);
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(6);
      if (lookahead == ' ') ADVANCE(469);
      if (lookahead == '#') ADVANCE(466);
      if (('\t' <= lookahead && lookahead <= '\r')) ADVANCE(467);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(468);
      if (lookahead != 0) ADVANCE(466);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(474);
      if (lookahead == '"') ADVANCE(470);
      if (lookahead == '#') ADVANCE(471);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(472);
      if (lookahead != 0) ADVANCE(471);
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(475);
      if (lookahead == '#') ADVANCE(473);
      if (lookahead == '\'') ADVANCE(476);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(475);
      if (lookahead != 0) ADVANCE(473);
      END_STATE();
    case 9:
      if (lookahead == '\n') ADVANCE(388);
      if (lookahead == '#') ADVANCE(554);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(17);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 17,
        '"', 470,
        '#', 553,
        '%', 465,
        '\'', 476,
        '(', 396,
        '+', 546,
        '-', 544,
        '.', 395,
        '/', 23,
        ':', 75,
        '>', 49,
        '@', 383,
        '_', 88,
        '{', 512,
        '~', 549,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(478);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 17,
        '"', 470,
        '#', 554,
        '%', 465,
        '\'', 476,
        '(', 396,
        '+', 546,
        '-', 544,
        '.', 395,
        '/', 23,
        ':', 75,
        '>', 49,
        '@', 502,
        '_', 108,
        '{', 512,
        '~', 549,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(12);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(478);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 17,
        '"', 470,
        '#', 554,
        '%', 465,
        '\'', 476,
        '(', 396,
        '+', 546,
        '-', 544,
        '.', 395,
        '/', 23,
        ':', 75,
        '>', 49,
        '@', 383,
        '_', 109,
        '{', 512,
        '~', 549,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(13);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(478);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 17,
        '"', 470,
        '#', 554,
        '%', 465,
        '\'', 476,
        '(', 396,
        '+', 546,
        '-', 544,
        '.', 395,
        '/', 23,
        ':', 75,
        '>', 49,
        '@', 383,
        '_', 110,
        '{', 512,
        '~', 549,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(478);
      END_STATE();
    case 15:
      if (lookahead == '!') ADVANCE(17);
      if (lookahead == '#') ADVANCE(554);
      if (lookahead == '_') ADVANCE(137);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(15);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(479);
      END_STATE();
    case 16:
      if (lookahead == '!') ADVANCE(17);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(506);
      END_STATE();
    case 17:
      if (lookahead == '!') ADVANCE(505);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(17);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '#', 554,
        '(', 396,
        ')', 400,
        '*', 537,
        '+', 547,
        ',', 397,
        '-', 545,
        '.', 395,
        '/', 539,
        '<', 522,
        '=', 517,
        '>', 523,
        '@', 503,
        '[', 403,
        ']', 404,
        '^', 42,
        '_', 54,
        '}', 513,
        '~', 48,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(480);
      END_STATE();
    case 19:
      if (lookahead == '+') ADVANCE(381);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(511);
      END_STATE();
    case 20:
      if (lookahead == '/') ADVANCE(477);
      if (lookahead == '<') ADVANCE(420);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 21:
      if (lookahead == '/') ADVANCE(477);
      if (lookahead == '<') ADVANCE(422);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(477);
      if (lookahead == '<') ADVANCE(21);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 23:
      if (lookahead == '/') ADVANCE(477);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 24:
      if (lookahead == '<') ADVANCE(417);
      END_STATE();
    case 25:
      if (lookahead == '<') ADVANCE(427);
      END_STATE();
    case 26:
      if (lookahead == '<') ADVANCE(425);
      END_STATE();
    case 27:
      if (lookahead == '<') ADVANCE(402);
      END_STATE();
    case 28:
      if (lookahead == '<') ADVANCE(415);
      END_STATE();
    case 29:
      if (lookahead == '<') ADVANCE(418);
      END_STATE();
    case 30:
      if (lookahead == '<') ADVANCE(428);
      END_STATE();
    case 31:
      if (lookahead == '<') ADVANCE(426);
      END_STATE();
    case 32:
      if (lookahead == '<') ADVANCE(416);
      END_STATE();
    case 33:
      if (lookahead == '<') ADVANCE(412);
      END_STATE();
    case 34:
      if (lookahead == '<') ADVANCE(410);
      END_STATE();
    case 35:
      if (lookahead == '<') ADVANCE(424);
      END_STATE();
    case 36:
      if (lookahead == '<') ADVANCE(423);
      END_STATE();
    case 37:
      if (lookahead == '<') ADVANCE(414);
      END_STATE();
    case 38:
      if (lookahead == '<') ADVANCE(413);
      END_STATE();
    case 39:
      if (lookahead == '<') ADVANCE(411);
      END_STATE();
    case 40:
      if (lookahead == '<') ADVANCE(419);
      END_STATE();
    case 41:
      if (lookahead == '<') ADVANCE(421);
      END_STATE();
    case 42:
      if (lookahead == '<') ADVANCE(27);
      END_STATE();
    case 43:
      if (lookahead == '<') ADVANCE(29);
      END_STATE();
    case 44:
      if (lookahead == '<') ADVANCE(30);
      END_STATE();
    case 45:
      if (lookahead == '<') ADVANCE(31);
      END_STATE();
    case 46:
      if (lookahead == '<') ADVANCE(32);
      END_STATE();
    case 47:
      if (lookahead == '<') ADVANCE(41);
      END_STATE();
    case 48:
      if (lookahead == '=') ADVANCE(518);
      END_STATE();
    case 49:
      if (lookahead == '>') ADVANCE(498);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        'A', 117,
        'D', 153,
        'M', 80,
        'O', 302,
        'X', 278,
        'a', 63,
        'd', 61,
        'm', 68,
        'o', 71,
        'x', 65,
        'B', 242,
        'b', 242,
        'C', 95,
        'c', 95,
        'E', 236,
        'e', 236,
        'F', 92,
        'f', 92,
        'G', 113,
        'g', 113,
        'H', 98,
        'h', 98,
        'I', 188,
        'i', 188,
        'L', 165,
        'l', 165,
        'N', 285,
        'n', 285,
        'P', 82,
        'p', 82,
        'R', 170,
        'r', 170,
        'S', 130,
        's', 130,
        'T', 202,
        't', 202,
        'U', 264,
        'u', 264,
        'W', 203,
        'w', 203,
      );
      END_STATE();
    case 51:
      ADVANCE_MAP(
        'A', 117,
        'D', 153,
        'M', 80,
        'O', 302,
        'X', 278,
        'a', 63,
        'd', 61,
        'm', 68,
        'o', 71,
        'x', 65,
        'B', 242,
        'b', 242,
        'C', 95,
        'c', 95,
        'E', 236,
        'e', 236,
        'F', 92,
        'f', 92,
        'G', 113,
        'g', 113,
        'H', 98,
        'h', 98,
        'I', 188,
        'i', 188,
        'L', 166,
        'l', 166,
        'N', 285,
        'n', 285,
        'P', 83,
        'p', 83,
        'R', 170,
        'r', 170,
        'S', 130,
        's', 130,
        'T', 202,
        't', 202,
        'U', 264,
        'u', 264,
        'W', 203,
        'w', 203,
      );
      END_STATE();
    case 52:
      ADVANCE_MAP(
        'A', 241,
        'D', 215,
        'M', 81,
        'O', 306,
        'X', 278,
        'a', 64,
        'd', 60,
        'm', 67,
        'o', 72,
        'x', 65,
        'B', 242,
        'b', 242,
        'C', 96,
        'c', 96,
        'E', 236,
        'e', 236,
        'F', 92,
        'f', 92,
        'G', 112,
        'g', 112,
        'H', 98,
        'h', 98,
        'I', 190,
        'i', 190,
        'L', 167,
        'l', 167,
        'N', 285,
        'n', 285,
        'P', 314,
        'p', 314,
        'R', 170,
        'r', 170,
        'S', 130,
        's', 130,
        'T', 207,
        't', 207,
        'U', 264,
        'u', 264,
        'W', 203,
        'w', 203,
      );
      END_STATE();
    case 53:
      ADVANCE_MAP(
        'A', 241,
        'D', 215,
        'M', 81,
        'O', 306,
        'X', 278,
        'a', 64,
        'd', 60,
        'm', 67,
        'o', 72,
        'x', 65,
        'B', 242,
        'b', 242,
        'C', 96,
        'c', 96,
        'E', 236,
        'e', 236,
        'F', 92,
        'f', 92,
        'G', 112,
        'g', 112,
        'H', 98,
        'h', 98,
        'I', 190,
        'i', 190,
        'L', 167,
        'l', 167,
        'N', 285,
        'n', 285,
        'P', 324,
        'p', 324,
        'R', 170,
        'r', 170,
        'S', 130,
        's', 130,
        'T', 207,
        't', 207,
        'U', 264,
        'u', 264,
        'W', 203,
        'w', 203,
      );
      END_STATE();
    case 54:
      ADVANCE_MAP(
        'A', 258,
        'D', 215,
        'M', 280,
        'O', 301,
        'X', 278,
        'a', 62,
        'd', 60,
        'm', 66,
        'o', 70,
        'x', 65,
        'C', 187,
        'c', 187,
        'G', 112,
        'g', 112,
        'I', 325,
        'i', 325,
        'L', 284,
        'l', 284,
        'T', 212,
        't', 212,
        'W', 230,
        'w', 230,
      );
      END_STATE();
    case 55:
      ADVANCE_MAP(
        'A', 258,
        'D', 215,
        'M', 280,
        'O', 305,
        'X', 278,
        'a', 62,
        'd', 60,
        'm', 66,
        'o', 69,
        'x', 65,
        'C', 186,
        'c', 186,
        'E', 236,
        'e', 236,
        'F', 228,
        'f', 228,
        'I', 325,
        'i', 325,
        'P', 323,
        'p', 323,
        'W', 211,
        'w', 211,
      );
      END_STATE();
    case 56:
      if (lookahead == 'D') ADVANCE(526);
      if (lookahead == 'd') ADVANCE(525);
      END_STATE();
    case 57:
      if (lookahead == 'D') ADVANCE(540);
      if (lookahead == 'd') ADVANCE(541);
      END_STATE();
    case 58:
      if (lookahead == 'F') ADVANCE(533);
      if (lookahead == 'f') ADVANCE(534);
      END_STATE();
    case 59:
      if (lookahead == 'F') ADVANCE(531);
      if (lookahead == 'f') ADVANCE(532);
      END_STATE();
    case 60:
      if (lookahead == 'I') ADVANCE(370);
      if (lookahead == 'i') ADVANCE(74);
      END_STATE();
    case 61:
      if (lookahead == 'I') ADVANCE(370);
      if (lookahead == 'i') ADVANCE(74);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(197);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(269);
      END_STATE();
    case 62:
      if (lookahead == 'N') ADVANCE(143);
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 63:
      if (lookahead == 'N') ADVANCE(143);
      if (lookahead == 'n') ADVANCE(56);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(329);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 64:
      if (lookahead == 'N') ADVANCE(143);
      if (lookahead == 'n') ADVANCE(56);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 65:
      if (lookahead == 'O') ADVANCE(307);
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 66:
      if (lookahead == 'O') ADVANCE(144);
      if (lookahead == 'o') ADVANCE(57);
      END_STATE();
    case 67:
      if (lookahead == 'O') ADVANCE(144);
      if (lookahead == 'o') ADVANCE(57);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(375);
      END_STATE();
    case 68:
      if (lookahead == 'O') ADVANCE(144);
      if (lookahead == 'o') ADVANCE(57);
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(375);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 69:
      if (lookahead == 'R') ADVANCE(528);
      if (lookahead == 'r') ADVANCE(527);
      END_STATE();
    case 70:
      if (lookahead == 'R') ADVANCE(528);
      if (lookahead == 'r') ADVANCE(527);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(337);
      END_STATE();
    case 71:
      if (lookahead == 'R') ADVANCE(528);
      if (lookahead == 'r') ADVANCE(527);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(337);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(169);
      END_STATE();
    case 72:
      if (lookahead == 'R') ADVANCE(528);
      if (lookahead == 'r') ADVANCE(527);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(169);
      END_STATE();
    case 73:
      if (lookahead == 'R') ADVANCE(530);
      if (lookahead == 'r') ADVANCE(529);
      END_STATE();
    case 74:
      if (lookahead == 'V') ADVANCE(542);
      if (lookahead == 'v') ADVANCE(543);
      END_STATE();
    case 75:
      if (lookahead == '|') ADVANCE(76);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(551);
      END_STATE();
    case 76:
      if (lookahead == '|') ADVANCE(551);
      if (lookahead != 0) ADVANCE(76);
      END_STATE();
    case 77:
      if (lookahead == '|') ADVANCE(490);
      if (lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(77);
      END_STATE();
    case 78:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(375);
      END_STATE();
    case 79:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(375);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(336);
      END_STATE();
    case 80:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(375);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(336);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(144);
      END_STATE();
    case 81:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(375);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(144);
      END_STATE();
    case 82:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(123);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(84);
      END_STATE();
    case 83:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(123);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(85);
      END_STATE();
    case 84:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(200);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(254);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(124);
      END_STATE();
    case 85:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(200);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(254);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(125);
      END_STATE();
    case 86:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(255);
      END_STATE();
    case 87:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(462);
      END_STATE();
    case 88:
      ADVANCE_MAP(
        'A', 116,
        'a', 116,
        'B', 242,
        'b', 242,
        'C', 97,
        'c', 97,
        'D', 379,
        'd', 379,
        'E', 272,
        'e', 272,
        'F', 93,
        'f', 93,
        'G', 113,
        'g', 113,
        'H', 98,
        'h', 98,
        'I', 189,
        'i', 189,
        'L', 166,
        'l', 166,
        'M', 79,
        'm', 79,
        'N', 285,
        'n', 285,
        'O', 371,
        'o', 371,
        'P', 316,
        'p', 316,
        'R', 170,
        'r', 170,
        'S', 130,
        's', 130,
        'T', 207,
        't', 207,
        'U', 264,
        'u', 264,
        'W', 209,
        'w', 209,
      );
      END_STATE();
    case 89:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(372);
      END_STATE();
    case 90:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 91:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(366);
      END_STATE();
    case 92:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(270);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(308);
      END_STATE();
    case 93:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(245);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(308);
      END_STATE();
    case 94:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(328);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(271);
      END_STATE();
    case 95:
      ADVANCE_MAP(
        'A', 349,
        'a', 349,
        'F', 516,
        'f', 516,
        'L', 94,
        'l', 94,
        'O', 259,
        'o', 259,
      );
      END_STATE();
    case 96:
      ADVANCE_MAP(
        'A', 349,
        'a', 349,
        'F', 516,
        'f', 516,
        'L', 94,
        'l', 94,
        'O', 275,
        'o', 275,
      );
      END_STATE();
    case 97:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(349);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(94);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(259);
      END_STATE();
    case 98:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(267);
      END_STATE();
    case 99:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(247);
      END_STATE();
    case 100:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(237);
      END_STATE();
    case 101:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(237);
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(460);
      END_STATE();
    case 102:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(237);
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(459);
      END_STATE();
    case 103:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(148);
      END_STATE();
    case 104:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(357);
      END_STATE();
    case 105:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(238);
      END_STATE();
    case 106:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(274);
      END_STATE();
    case 107:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(239);
      END_STATE();
    case 108:
      ADVANCE_MAP(
        'A', 240,
        'a', 240,
        'B', 242,
        'b', 242,
        'C', 97,
        'c', 97,
        'D', 379,
        'd', 379,
        'E', 273,
        'e', 273,
        'F', 92,
        'f', 92,
        'G', 113,
        'g', 113,
        'H', 98,
        'h', 98,
        'I', 189,
        'i', 189,
        'L', 166,
        'l', 166,
        'M', 78,
        'm', 78,
        'N', 285,
        'n', 285,
        'O', 371,
        'o', 371,
        'P', 314,
        'p', 314,
        'R', 170,
        'r', 170,
        'S', 130,
        's', 130,
        'T', 207,
        't', 207,
        'U', 264,
        'u', 264,
        'W', 209,
        'w', 209,
      );
      END_STATE();
    case 109:
      ADVANCE_MAP(
        'A', 240,
        'a', 240,
        'B', 242,
        'b', 242,
        'C', 97,
        'c', 97,
        'D', 379,
        'd', 379,
        'F', 93,
        'f', 93,
        'G', 113,
        'g', 113,
        'H', 98,
        'h', 98,
        'I', 189,
        'i', 189,
        'L', 165,
        'l', 165,
        'M', 78,
        'm', 78,
        'N', 285,
        'n', 285,
        'O', 371,
        'o', 371,
        'P', 324,
        'p', 324,
        'R', 170,
        'r', 170,
        'S', 130,
        's', 130,
        'T', 207,
        't', 207,
        'U', 264,
        'u', 264,
        'W', 209,
        'w', 209,
      );
      END_STATE();
    case 110:
      ADVANCE_MAP(
        'A', 240,
        'a', 240,
        'B', 242,
        'b', 242,
        'C', 97,
        'c', 97,
        'D', 379,
        'd', 379,
        'F', 93,
        'f', 93,
        'G', 113,
        'g', 113,
        'H', 98,
        'h', 98,
        'I', 189,
        'i', 189,
        'L', 166,
        'l', 166,
        'M', 78,
        'm', 78,
        'N', 285,
        'n', 285,
        'O', 371,
        'o', 371,
        'P', 324,
        'p', 324,
        'R', 170,
        'r', 170,
        'S', 130,
        's', 130,
        'T', 207,
        't', 207,
        'U', 264,
        'u', 264,
        'W', 209,
        'w', 209,
      );
      END_STATE();
    case 111:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(358);
      END_STATE();
    case 112:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(350);
      END_STATE();
    case 113:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(350);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(282);
      END_STATE();
    case 114:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(363);
      END_STATE();
    case 115:
      if (lookahead == 'A' ||
          lookahead == 'a') ADVANCE(138);
      END_STATE();
    case 116:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(329);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 117:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(329);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(244);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 118:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(156);
      END_STATE();
    case 119:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(105);
      END_STATE();
    case 120:
      ADVANCE_MAP(
        'B', 252,
        'b', 252,
        'C', 114,
        'c', 114,
        'I', 196,
        'i', 196,
        'L', 281,
        'l', 281,
        'M', 185,
        'm', 185,
        'P', 318,
        'p', 318,
        'T', 315,
        't', 315,
      );
      END_STATE();
    case 121:
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(252);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(292);
      END_STATE();
    case 122:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(101);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 123:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(235);
      END_STATE();
    case 124:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(406);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(168);
      END_STATE();
    case 125:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(406);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(184);
      END_STATE();
    case 126:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(495);
      END_STATE();
    case 127:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(407);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(183);
      END_STATE();
    case 128:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(102);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 129:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(231);
      END_STATE();
    case 130:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(104);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(246);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(304);
      END_STATE();
    case 131:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(232);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(299);
      END_STATE();
    case 132:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(205);
      END_STATE();
    case 133:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(233);
      END_STATE();
    case 134:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(234);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 135:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(206);
      END_STATE();
    case 136:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(344);
      END_STATE();
    case 137:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(294);
      END_STATE();
    case 138:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(345);
      END_STATE();
    case 139:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(347);
      END_STATE();
    case 140:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(348);
      END_STATE();
    case 141:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(362);
      END_STATE();
    case 142:
      if (lookahead == 'C' ||
          lookahead == 'c') ADVANCE(100);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(300);
      END_STATE();
    case 143:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(526);
      END_STATE();
    case 144:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(540);
      END_STATE();
    case 145:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(120);
      END_STATE();
    case 146:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(394);
      END_STATE();
    case 147:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(405);
      END_STATE();
    case 148:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(488);
      END_STATE();
    case 149:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(121);
      END_STATE();
    case 150:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(257);
      END_STATE();
    case 151:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(378);
      END_STATE();
    case 152:
      if (lookahead == 'D' ||
          lookahead == 'd') ADVANCE(251);
      END_STATE();
    case 153:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(197);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(370);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(269);
      END_STATE();
    case 154:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(433);
      END_STATE();
    case 155:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(481);
      END_STATE();
    case 156:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(483);
      END_STATE();
    case 157:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(487);
      END_STATE();
    case 158:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(482);
      END_STATE();
    case 159:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(452);
      END_STATE();
    case 160:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(447);
      END_STATE();
    case 161:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(389);
      END_STATE();
    case 162:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(392);
      END_STATE();
    case 163:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(453);
      END_STATE();
    case 164:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(444);
      END_STATE();
    case 165:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(89);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(122);
      END_STATE();
    case 166:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(89);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(128);
      END_STATE();
    case 167:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(89);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(134);
      END_STATE();
    case 168:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(136);
      END_STATE();
    case 169:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 170:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(339);
      END_STATE();
    case 171:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(310);
      END_STATE();
    case 172:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 173:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(260);
      END_STATE();
    case 174:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(260);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(334);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(279);
      END_STATE();
    case 175:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(335);
      END_STATE();
    case 176:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(261);
      END_STATE();
    case 177:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(261);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(248);
      END_STATE();
    case 178:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(103);
      END_STATE();
    case 179:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(341);
      END_STATE();
    case 180:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(311);
      END_STATE();
    case 181:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(312);
      END_STATE();
    case 182:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 183:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(139);
      END_STATE();
    case 184:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 185:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(361);
      END_STATE();
    case 186:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(516);
      END_STATE();
    case 187:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(516);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(277);
      END_STATE();
    case 188:
      ADVANCE_MAP(
        'F', 429,
        'f', 429,
        'M', 303,
        'm', 303,
        'S', 514,
        's', 514,
        'T', 171,
        't', 171,
      );
      END_STATE();
    case 189:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(429);
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(303);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(171);
      END_STATE();
    case 190:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(429);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(514);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(171);
      END_STATE();
    case 191:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(533);
      END_STATE();
    case 192:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(432);
      END_STATE();
    case 193:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(486);
      END_STATE();
    case 194:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(531);
      END_STATE();
    case 195:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(535);
      END_STATE();
    case 196:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(431);
      END_STATE();
    case 197:
      if (lookahead == 'F' ||
          lookahead == 'f') ADVANCE(91);
      END_STATE();
    case 198:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(456);
      END_STATE();
    case 199:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(439);
      END_STATE();
    case 200:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(256);
      END_STATE();
    case 201:
      if (lookahead == 'G' ||
          lookahead == 'g') ADVANCE(161);
      END_STATE();
    case 202:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(174);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(365);
      END_STATE();
    case 203:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(177);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(352);
      END_STATE();
    case 204:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(438);
      END_STATE();
    case 205:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(441);
      END_STATE();
    case 206:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(442);
      END_STATE();
    case 207:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(225);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(365);
      END_STATE();
    case 208:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(287);
      END_STATE();
    case 209:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(219);
      END_STATE();
    case 210:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(289);
      END_STATE();
    case 211:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(176);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(352);
      END_STATE();
    case 212:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(173);
      END_STATE();
    case 213:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(322);
      END_STATE();
    case 214:
      if (lookahead == 'H' ||
          lookahead == 'h') ADVANCE(181);
      END_STATE();
    case 215:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(370);
      END_STATE();
    case 216:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(254);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(125);
      END_STATE();
    case 217:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(192);
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(154);
      END_STATE();
    case 218:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 219:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(248);
      END_STATE();
    case 220:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(297);
      END_STATE();
    case 221:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(266);
      END_STATE();
    case 222:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 223:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(268);
      END_STATE();
    case 224:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(354);
      END_STATE();
    case 225:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(334);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(279);
      END_STATE();
    case 226:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(253);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(124);
      END_STATE();
    case 227:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(253);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(125);
      END_STATE();
    case 228:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(270);
      END_STATE();
    case 229:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(373);
      END_STATE();
    case 230:
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(352);
      END_STATE();
    case 231:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(408);
      END_STATE();
    case 232:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(461);
      END_STATE();
    case 233:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(409);
      END_STATE();
    case 234:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(459);
      END_STATE();
    case 235:
      if (lookahead == 'K' ||
          lookahead == 'k') ADVANCE(90);
      END_STATE();
    case 236:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(217);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(145);
      END_STATE();
    case 237:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(493);
      END_STATE();
    case 238:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(492);
      END_STATE();
    case 239:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(398);
      END_STATE();
    case 240:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(244);
      END_STATE();
    case 241:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(244);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 242:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(295);
      END_STATE();
    case 243:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(377);
      END_STATE();
    case 244:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(317);
      END_STATE();
    case 245:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(330);
      END_STATE();
    case 246:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(193);
      END_STATE();
    case 247:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(243);
      END_STATE();
    case 248:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(160);
      END_STATE();
    case 249:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(343);
      END_STATE();
    case 250:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(356);
      END_STATE();
    case 251:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(223);
      END_STATE();
    case 252:
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(296);
      END_STATE();
    case 253:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(224);
      END_STATE();
    case 254:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(224);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(111);
      END_STATE();
    case 255:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(218);
      END_STATE();
    case 256:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(87);
      END_STATE();
    case 257:
      if (lookahead == 'M' ||
          lookahead == 'm') ADVANCE(185);
      END_STATE();
    case 258:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 259:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(332);
      END_STATE();
    case 260:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(430);
      END_STATE();
    case 261:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(449);
      END_STATE();
    case 262:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(497);
      END_STATE();
    case 263:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(457);
      END_STATE();
    case 264:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(333);
      END_STATE();
    case 265:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(198);
      END_STATE();
    case 266:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(368);
      END_STATE();
    case 267:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(152);
      END_STATE();
    case 268:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(199);
      END_STATE();
    case 269:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(86);
      END_STATE();
    case 270:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(99);
      END_STATE();
    case 271:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(157);
      END_STATE();
    case 272:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(150);
      END_STATE();
    case 273:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(149);
      END_STATE();
    case 274:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(346);
      END_STATE();
    case 275:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(351);
      END_STATE();
    case 276:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(107);
      END_STATE();
    case 277:
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(331);
      END_STATE();
    case 278:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(307);
      END_STATE();
    case 279:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(374);
      END_STATE();
    case 280:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(144);
      END_STATE();
    case 281:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(131);
      END_STATE();
    case 282:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(119);
      END_STATE();
    case 283:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(127);
      END_STATE();
    case 284:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(142);
      END_STATE();
    case 285:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(338);
      END_STATE();
    case 286:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(299);
      END_STATE();
    case 287:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(146);
      END_STATE();
    case 288:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(151);
      END_STATE();
    case 289:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(147);
      END_STATE();
    case 290:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(321);
      END_STATE();
    case 291:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(263);
      END_STATE();
    case 292:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(286);
      END_STATE();
    case 293:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(359);
      END_STATE();
    case 294:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(277);
      END_STATE();
    case 295:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(129);
      END_STATE();
    case 296:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(133);
      END_STATE();
    case 297:
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(276);
      END_STATE();
    case 298:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(435);
      END_STATE();
    case 299:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(436);
      END_STATE();
    case 300:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(434);
      END_STATE();
    case 301:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(337);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(528);
      END_STATE();
    case 302:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(337);
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(528);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(169);
      END_STATE();
    case 303:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(290);
      END_STATE();
    case 304:
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(180);
      END_STATE();
    case 305:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(528);
      END_STATE();
    case 306:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(528);
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(169);
      END_STATE();
    case 307:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(530);
      END_STATE();
    case 308:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(445);
      END_STATE();
    case 309:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(446);
      END_STATE();
    case 310:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(393);
      END_STATE();
    case 311:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(485);
      END_STATE();
    case 312:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(399);
      END_STATE();
    case 313:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(499);
      END_STATE();
    case 314:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 315:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(376);
      END_STATE();
    case 316:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(216);
      END_STATE();
    case 317:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 318:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(283);
      END_STATE();
    case 319:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(115);
      END_STATE();
    case 320:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(262);
      END_STATE();
    case 321:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(342);
      END_STATE();
    case 322:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(178);
      END_STATE();
    case 323:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(293);
      END_STATE();
    case 324:
      if (lookahead == 'R' ||
          lookahead == 'r') ADVANCE(226);
      END_STATE();
    case 325:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(514);
      END_STATE();
    case 326:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(489);
      END_STATE();
    case 327:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(500);
      END_STATE();
    case 328:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(326);
      END_STATE();
    case 329:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(355);
      END_STATE();
    case 330:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(158);
      END_STATE();
    case 331:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(360);
      END_STATE();
    case 332:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(360);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(221);
      END_STATE();
    case 333:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(179);
      END_STATE();
    case 334:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(353);
      END_STATE();
    case 335:
      if (lookahead == 'S' ||
          lookahead == 's') ADVANCE(369);
      END_STATE();
    case 336:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(208);
      END_STATE();
    case 337:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(220);
      END_STATE();
    case 338:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(548);
      END_STATE();
    case 339:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(367);
      END_STATE();
    case 340:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(515);
      END_STATE();
    case 341:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(484);
      END_STATE();
    case 342:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(496);
      END_STATE();
    case 343:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(440);
      END_STATE();
    case 344:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(455);
      END_STATE();
    case 345:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(391);
      END_STATE();
    case 346:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(494);
      END_STATE();
    case 347:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(458);
      END_STATE();
    case 348:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(454);
      END_STATE();
    case 349:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(132);
      END_STATE();
    case 350:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(214);
      END_STATE();
    case 351:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(221);
      END_STATE();
    case 352:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(204);
      END_STATE();
    case 353:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(213);
      END_STATE();
    case 354:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(229);
      END_STATE();
    case 355:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(319);
      END_STATE();
    case 356:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(327);
      END_STATE();
    case 357:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(364);
      END_STATE();
    case 358:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(162);
      END_STATE();
    case 359:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(172);
      END_STATE();
    case 360:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(106);
      END_STATE();
    case 361:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(210);
      END_STATE();
    case 362:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(222);
      END_STATE();
    case 363:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(135);
      END_STATE();
    case 364:
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(182);
      END_STATE();
    case 365:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(155);
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(448);
      END_STATE();
    case 366:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(249);
      END_STATE();
    case 367:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(320);
      END_STATE();
    case 368:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(163);
      END_STATE();
    case 369:
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(250);
      END_STATE();
    case 370:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(542);
      END_STATE();
    case 371:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(169);
      END_STATE();
    case 372:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(159);
      END_STATE();
    case 373:
      if (lookahead == 'V' ||
          lookahead == 'v') ADVANCE(164);
      END_STATE();
    case 374:
      if (lookahead == 'W' ||
          lookahead == 'w') ADVANCE(443);
      END_STATE();
    case 375:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(118);
      END_STATE();
    case 376:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(450);
      END_STATE();
    case 377:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(437);
      END_STATE();
    case 378:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(451);
      END_STATE();
    case 379:
      if (lookahead == 'Y' ||
          lookahead == 'y') ADVANCE(269);
      END_STATE();
    case 380:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(510);
      END_STATE();
    case 381:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(511);
      END_STATE();
    case 382:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(508);
      END_STATE();
    case 383:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(507);
      END_STATE();
    case 384:
      if (eof) ADVANCE(385);
      ADVANCE_MAP(
        '!', 17,
        '"', 470,
        '#', 554,
        '$', 2,
        '%', 465,
        '\'', 476,
        '(', 396,
        ')', 400,
        '*', 537,
        '+', 547,
        ',', 397,
        '-', 545,
        '.', 395,
        '/', 538,
        ':', 75,
        '<', 522,
        '=', 517,
        '>', 524,
        '@', 383,
        '[', 403,
        ']', 404,
        '^', 42,
        '_', 51,
        '{', 512,
        '|', 77,
        '}', 513,
        '~', 550,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(384);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(478);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_CR);
      if (lookahead == '\n') ADVANCE(387);
      if (lookahead == '\r') ADVANCE(386);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(387);
      if (lookahead == '\r') ADVANCE(386);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n') ADVANCE(388);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(aux_sym_package_token1);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(sym__dollar);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(aux_sym_method_token1);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(aux_sym_method_token2);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(aux_sym_method_token3);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(aux_sym_method_token4);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(aux_sym_method_token5);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(aux_sym_method_token6);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(anon_sym_CARET_LT_LT);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym_method_token7);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym_procedure_token1);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(aux_sym_procedure_token2);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(aux_sym_block_token1);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(aux_sym_block_token2);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(anon_sym__and_LT_LT);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(anon_sym__andif_LT_LT);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(anon_sym__or_LT_LT);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(anon_sym__orif_LT_LT);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(anon_sym__xor_LT_LT);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_LT_LT);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_CARET_LT_LT);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(anon_sym_STAR_LT_LT);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(anon_sym_STAR_CARET_LT_LT);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(anon_sym_SLASH_LT_LT);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(anon_sym_SLASH_LT_LT);
      if (lookahead == '/') ADVANCE(477);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(anon_sym_SLASH_CARET_LT_LT);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_SLASH_CARET_LT_LT);
      if (lookahead == '/') ADVANCE(477);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(anon_sym__mod_LT_LT);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(anon_sym__div_LT_LT);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_DASH_LT_LT);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(anon_sym_DASH_CARET_LT_LT);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(anon_sym_PLUS_LT_LT);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(anon_sym_PLUS_CARET_LT_LT);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(aux_sym_if_token1);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(aux_sym_if_token2);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(aux_sym_if_token3);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(aux_sym_elif_token1);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(aux_sym_else_token1);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(aux_sym_loop_token1);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(aux_sym_loop_token1);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(288);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(aux_sym_loop_token2);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(aux_sym_finally_token1);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(aux_sym_finally_token2);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(aux_sym_handling_token1);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(aux_sym_handling_token2);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(aux_sym_catch_token1);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(aux_sym_catch_token2);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(aux_sym_throw_token1);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(aux_sym_primitive_token1);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(aux_sym_iterator_token1);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(aux_sym_iterator_token2);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(aux_sym_while_token1);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(aux_sym_try_token1);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(aux_sym_try_token2);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(aux_sym_try_token3);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(aux_sym_loopbody_token1);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(aux_sym_leave_token1);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(aux_sym_continue_token1);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(aux_sym_protect_token1);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(aux_sym_protect_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(aux_sym_protect_token2);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(aux_sym_protect_token3);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(aux_sym_protect_token4);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(aux_sym_lock_token1);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(aux_sym_lock_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(265);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(aux_sym_lock_token2);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(aux_sym_pragma_token1);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(aux_sym_pragma_token2);
      if (lookahead == '#') ADVANCE(464);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(463);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(464);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(aux_sym_pragma_token2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(464);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == ' ') ADVANCE(469);
      if (lookahead == '#') ADVANCE(466);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) ADVANCE(467);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(468);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead)) ADVANCE(466);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(480);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_SPACE);
      if (lookahead == ' ') ADVANCE(469);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r')) ADVANCE(467);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      if (lookahead == '\n') ADVANCE(474);
      if (lookahead == '#') ADVANCE(471);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(472);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#') ADVANCE(471);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(aux_sym_string_literal_token2);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(aux_sym_string_literal_token2);
      if (lookahead == '\n') ADVANCE(474);
      if (lookahead == '"') ADVANCE(470);
      if (lookahead == '#') ADVANCE(471);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(472);
      if (lookahead != 0) ADVANCE(471);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(aux_sym_string_literal_token2);
      if (lookahead == '\n') ADVANCE(475);
      if (lookahead == '#') ADVANCE(473);
      if (lookahead == '\'') ADVANCE(476);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(475);
      if (lookahead != 0) ADVANCE(473);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(sym_regex_literal);
      ADVANCE_MAP(
        '/', 477,
        'C', 477,
        'X', 477,
        'd', 477,
        'i', 477,
        'l', 477,
        'm', 477,
        'q', 477,
        's', 477,
        'u', 477,
      );
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(aux_sym_slot_accessor_token1);
      if (lookahead == ':') ADVANCE(16);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(478);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(aux_sym_slot_accessor_token1);
      if (lookahead == ':') ADVANCE(10);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(479);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(aux_sym_slot_accessor_token1);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(480);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(aux_sym_true_token1);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(aux_sym_false_token1);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(aux_sym_maybe_token1);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(aux_sym_unset_token1);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(aux_sym_super_token1);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(aux_sym_self_token1);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(aux_sym_clone_token1);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(aux_sym_thisthread_token1);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(aux_sym_class_token1);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(aux_sym_class_token2);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(aux_sym_global_token1);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(aux_sym_local_token1);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(aux_sym__global_assignment_token1);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(aux_sym_dynamic_token1);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(aux_sym_import_token1);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(aux_sym_return_token1);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(aux_sym_scatter_token1);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(aux_sym_allresults_token1);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_label);
      if (lookahead == ':') ADVANCE(382);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(501);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(sym_label);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(504);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          lookahead == '_') ADVANCE(504);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(501);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(sym_label);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(504);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(504);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(sym_label);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(504);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(sym_dynamic_variable);
      if (lookahead == '!') ADVANCE(505);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(17);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(sym_global_variable);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(506);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(sym_global_reference);
      if (lookahead == ':') ADVANCE(382);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(507);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_global_reference);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(508);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(380);
      if (lookahead == 'e') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(509);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'e') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(510);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(511);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(aux_sym_relational_operator_token1);
      if (lookahead == 'N' ||
          lookahead == 'n') ADVANCE(340);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(aux_sym_relational_operator_token2);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(aux_sym_relational_operator_token3);
      END_STATE();
    case 517:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_TILDE_EQ);
      END_STATE();
    case 519:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 520:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(401);
      if (lookahead == '=') ADVANCE(521);
      if (lookahead == '>') ADVANCE(519);
      END_STATE();
    case 523:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(520);
      END_STATE();
    case 524:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(520);
      if (lookahead == '>') ADVANCE(498);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(aux_sym_logical_operator_token1);
      if (lookahead == '<') ADVANCE(34);
      if (lookahead == 'I') ADVANCE(194);
      if (lookahead == 'i') ADVANCE(59);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(aux_sym_logical_operator_token1);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(194);
      END_STATE();
    case 527:
      ACCEPT_TOKEN(aux_sym_logical_operator_token2);
      if (lookahead == '<') ADVANCE(33);
      if (lookahead == 'I') ADVANCE(191);
      if (lookahead == 'i') ADVANCE(58);
      END_STATE();
    case 528:
      ACCEPT_TOKEN(aux_sym_logical_operator_token2);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(191);
      END_STATE();
    case 529:
      ACCEPT_TOKEN(aux_sym_logical_operator_token3);
      if (lookahead == '<') ADVANCE(37);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(aux_sym_logical_operator_token3);
      if (lookahead == 'I' ||
          lookahead == 'i') ADVANCE(195);
      END_STATE();
    case 531:
      ACCEPT_TOKEN(aux_sym_logical_operator_token4);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(aux_sym_logical_operator_token4);
      if (lookahead == '<') ADVANCE(39);
      END_STATE();
    case 533:
      ACCEPT_TOKEN(aux_sym_logical_operator_token5);
      END_STATE();
    case 534:
      ACCEPT_TOKEN(aux_sym_logical_operator_token5);
      if (lookahead == '<') ADVANCE(38);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(aux_sym_logical_operator_token6);
      END_STATE();
    case 536:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '<') ADVANCE(28);
      if (lookahead == '^') ADVANCE(46);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(536);
      if (lookahead == '<') ADVANCE(24);
      if (lookahead == '^') ADVANCE(43);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(477);
      if (lookahead == '<') ADVANCE(20);
      if (lookahead == '^') ADVANCE(22);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 539:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '<') ADVANCE(40);
      if (lookahead == '^') ADVANCE(47);
      END_STATE();
    case 540:
      ACCEPT_TOKEN(aux_sym_arithmetic_operator_token1);
      END_STATE();
    case 541:
      ACCEPT_TOKEN(aux_sym_arithmetic_operator_token1);
      if (lookahead == '<') ADVANCE(36);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(aux_sym_arithmetic_operator_token2);
      END_STATE();
    case 543:
      ACCEPT_TOKEN(aux_sym_arithmetic_operator_token2);
      if (lookahead == '<') ADVANCE(35);
      END_STATE();
    case 544:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 545:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '<') ADVANCE(26);
      if (lookahead == '^') ADVANCE(45);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 547:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '<') ADVANCE(25);
      if (lookahead == '^') ADVANCE(44);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(aux_sym_unary_operator_token1);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '=') ADVANCE(518);
      END_STATE();
    case 551:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '|') ADVANCE(76);
      if (lookahead == '!' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '?' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(551);
      END_STATE();
    case 552:
      ACCEPT_TOKEN(aux_sym_documentation_token1);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(552);
      END_STATE();
    case 553:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '#') ADVANCE(552);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(554);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(554);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 384},
  [2] = {.lex_state = 3},
  [3] = {.lex_state = 3},
  [4] = {.lex_state = 3},
  [5] = {.lex_state = 3},
  [6] = {.lex_state = 384},
  [7] = {.lex_state = 4},
  [8] = {.lex_state = 4},
  [9] = {.lex_state = 384},
  [10] = {.lex_state = 4},
  [11] = {.lex_state = 384},
  [12] = {.lex_state = 4},
  [13] = {.lex_state = 384},
  [14] = {.lex_state = 384},
  [15] = {.lex_state = 384},
  [16] = {.lex_state = 384},
  [17] = {.lex_state = 384},
  [18] = {.lex_state = 384},
  [19] = {.lex_state = 384},
  [20] = {.lex_state = 384},
  [21] = {.lex_state = 11},
  [22] = {.lex_state = 11},
  [23] = {.lex_state = 12},
  [24] = {.lex_state = 384},
  [25] = {.lex_state = 11},
  [26] = {.lex_state = 11},
  [27] = {.lex_state = 11},
  [28] = {.lex_state = 384},
  [29] = {.lex_state = 11},
  [30] = {.lex_state = 11},
  [31] = {.lex_state = 11},
  [32] = {.lex_state = 384},
  [33] = {.lex_state = 11},
  [34] = {.lex_state = 11},
  [35] = {.lex_state = 11},
  [36] = {.lex_state = 11},
  [37] = {.lex_state = 11},
  [38] = {.lex_state = 11},
  [39] = {.lex_state = 11},
  [40] = {.lex_state = 11},
  [41] = {.lex_state = 11},
  [42] = {.lex_state = 11},
  [43] = {.lex_state = 384},
  [44] = {.lex_state = 11},
  [45] = {.lex_state = 11},
  [46] = {.lex_state = 11},
  [47] = {.lex_state = 11},
  [48] = {.lex_state = 11},
  [49] = {.lex_state = 12},
  [50] = {.lex_state = 11},
  [51] = {.lex_state = 11},
  [52] = {.lex_state = 11},
  [53] = {.lex_state = 11},
  [54] = {.lex_state = 11},
  [55] = {.lex_state = 11},
  [56] = {.lex_state = 384},
  [57] = {.lex_state = 11},
  [58] = {.lex_state = 11},
  [59] = {.lex_state = 11},
  [60] = {.lex_state = 11},
  [61] = {.lex_state = 11},
  [62] = {.lex_state = 11},
  [63] = {.lex_state = 11},
  [64] = {.lex_state = 11},
  [65] = {.lex_state = 11},
  [66] = {.lex_state = 11},
  [67] = {.lex_state = 11},
  [68] = {.lex_state = 11},
  [69] = {.lex_state = 11},
  [70] = {.lex_state = 11},
  [71] = {.lex_state = 11},
  [72] = {.lex_state = 11},
  [73] = {.lex_state = 384},
  [74] = {.lex_state = 11},
  [75] = {.lex_state = 11},
  [76] = {.lex_state = 11},
  [77] = {.lex_state = 11},
  [78] = {.lex_state = 11},
  [79] = {.lex_state = 11},
  [80] = {.lex_state = 11},
  [81] = {.lex_state = 11},
  [82] = {.lex_state = 11},
  [83] = {.lex_state = 11},
  [84] = {.lex_state = 11},
  [85] = {.lex_state = 12},
  [86] = {.lex_state = 11},
  [87] = {.lex_state = 12},
  [88] = {.lex_state = 11},
  [89] = {.lex_state = 11},
  [90] = {.lex_state = 11},
  [91] = {.lex_state = 11},
  [92] = {.lex_state = 11},
  [93] = {.lex_state = 11},
  [94] = {.lex_state = 11},
  [95] = {.lex_state = 384},
  [96] = {.lex_state = 384},
  [97] = {.lex_state = 384},
  [98] = {.lex_state = 384},
  [99] = {.lex_state = 384},
  [100] = {.lex_state = 384},
  [101] = {.lex_state = 384},
  [102] = {.lex_state = 384},
  [103] = {.lex_state = 384},
  [104] = {.lex_state = 384},
  [105] = {.lex_state = 384},
  [106] = {.lex_state = 384},
  [107] = {.lex_state = 384},
  [108] = {.lex_state = 384},
  [109] = {.lex_state = 384},
  [110] = {.lex_state = 384},
  [111] = {.lex_state = 384},
  [112] = {.lex_state = 384},
  [113] = {.lex_state = 384},
  [114] = {.lex_state = 384},
  [115] = {.lex_state = 384},
  [116] = {.lex_state = 384},
  [117] = {.lex_state = 384},
  [118] = {.lex_state = 384},
  [119] = {.lex_state = 384},
  [120] = {.lex_state = 384},
  [121] = {.lex_state = 384},
  [122] = {.lex_state = 384},
  [123] = {.lex_state = 384},
  [124] = {.lex_state = 384},
  [125] = {.lex_state = 12},
  [126] = {.lex_state = 12},
  [127] = {.lex_state = 384},
  [128] = {.lex_state = 13},
  [129] = {.lex_state = 12},
  [130] = {.lex_state = 12},
  [131] = {.lex_state = 13},
  [132] = {.lex_state = 384},
  [133] = {.lex_state = 12},
  [134] = {.lex_state = 12},
  [135] = {.lex_state = 384},
  [136] = {.lex_state = 384},
  [137] = {.lex_state = 384},
  [138] = {.lex_state = 384},
  [139] = {.lex_state = 384},
  [140] = {.lex_state = 384},
  [141] = {.lex_state = 384},
  [142] = {.lex_state = 384},
  [143] = {.lex_state = 384},
  [144] = {.lex_state = 384},
  [145] = {.lex_state = 384},
  [146] = {.lex_state = 384},
  [147] = {.lex_state = 384},
  [148] = {.lex_state = 384},
  [149] = {.lex_state = 384},
  [150] = {.lex_state = 384},
  [151] = {.lex_state = 384},
  [152] = {.lex_state = 384},
  [153] = {.lex_state = 384},
  [154] = {.lex_state = 384},
  [155] = {.lex_state = 384},
  [156] = {.lex_state = 384},
  [157] = {.lex_state = 384},
  [158] = {.lex_state = 384},
  [159] = {.lex_state = 384},
  [160] = {.lex_state = 384},
  [161] = {.lex_state = 384},
  [162] = {.lex_state = 384},
  [163] = {.lex_state = 384},
  [164] = {.lex_state = 384},
  [165] = {.lex_state = 384},
  [166] = {.lex_state = 14},
  [167] = {.lex_state = 384},
  [168] = {.lex_state = 384},
  [169] = {.lex_state = 384},
  [170] = {.lex_state = 384},
  [171] = {.lex_state = 384},
  [172] = {.lex_state = 384},
  [173] = {.lex_state = 384},
  [174] = {.lex_state = 384},
  [175] = {.lex_state = 384},
  [176] = {.lex_state = 384},
  [177] = {.lex_state = 384},
  [178] = {.lex_state = 384},
  [179] = {.lex_state = 384},
  [180] = {.lex_state = 384},
  [181] = {.lex_state = 384},
  [182] = {.lex_state = 384},
  [183] = {.lex_state = 384},
  [184] = {.lex_state = 384},
  [185] = {.lex_state = 384},
  [186] = {.lex_state = 384},
  [187] = {.lex_state = 384},
  [188] = {.lex_state = 384},
  [189] = {.lex_state = 384},
  [190] = {.lex_state = 384},
  [191] = {.lex_state = 384},
  [192] = {.lex_state = 384},
  [193] = {.lex_state = 384},
  [194] = {.lex_state = 384},
  [195] = {.lex_state = 384},
  [196] = {.lex_state = 384},
  [197] = {.lex_state = 384},
  [198] = {.lex_state = 384},
  [199] = {.lex_state = 384},
  [200] = {.lex_state = 384},
  [201] = {.lex_state = 384},
  [202] = {.lex_state = 384},
  [203] = {.lex_state = 384},
  [204] = {.lex_state = 384},
  [205] = {.lex_state = 384},
  [206] = {.lex_state = 384},
  [207] = {.lex_state = 384},
  [208] = {.lex_state = 384},
  [209] = {.lex_state = 384},
  [210] = {.lex_state = 384},
  [211] = {.lex_state = 384},
  [212] = {.lex_state = 384},
  [213] = {.lex_state = 384},
  [214] = {.lex_state = 384},
  [215] = {.lex_state = 384},
  [216] = {.lex_state = 384},
  [217] = {.lex_state = 384},
  [218] = {.lex_state = 384},
  [219] = {.lex_state = 384},
  [220] = {.lex_state = 14},
  [221] = {.lex_state = 384},
  [222] = {.lex_state = 384},
  [223] = {.lex_state = 384},
  [224] = {.lex_state = 384},
  [225] = {.lex_state = 384},
  [226] = {.lex_state = 384},
  [227] = {.lex_state = 384},
  [228] = {.lex_state = 384},
  [229] = {.lex_state = 384},
  [230] = {.lex_state = 384},
  [231] = {.lex_state = 384},
  [232] = {.lex_state = 384},
  [233] = {.lex_state = 384},
  [234] = {.lex_state = 384},
  [235] = {.lex_state = 384},
  [236] = {.lex_state = 384},
  [237] = {.lex_state = 384},
  [238] = {.lex_state = 384},
  [239] = {.lex_state = 384},
  [240] = {.lex_state = 384},
  [241] = {.lex_state = 384},
  [242] = {.lex_state = 384},
  [243] = {.lex_state = 14},
  [244] = {.lex_state = 14},
  [245] = {.lex_state = 384},
  [246] = {.lex_state = 384},
  [247] = {.lex_state = 11},
  [248] = {.lex_state = 384},
  [249] = {.lex_state = 384},
  [250] = {.lex_state = 384},
  [251] = {.lex_state = 384},
  [252] = {.lex_state = 384},
  [253] = {.lex_state = 384},
  [254] = {.lex_state = 384},
  [255] = {.lex_state = 384},
  [256] = {.lex_state = 384},
  [257] = {.lex_state = 384},
  [258] = {.lex_state = 384},
  [259] = {.lex_state = 384},
  [260] = {.lex_state = 384},
  [261] = {.lex_state = 384},
  [262] = {.lex_state = 384},
  [263] = {.lex_state = 384},
  [264] = {.lex_state = 384},
  [265] = {.lex_state = 384},
  [266] = {.lex_state = 384},
  [267] = {.lex_state = 384},
  [268] = {.lex_state = 384},
  [269] = {.lex_state = 384},
  [270] = {.lex_state = 384},
  [271] = {.lex_state = 384},
  [272] = {.lex_state = 384},
  [273] = {.lex_state = 384},
  [274] = {.lex_state = 384},
  [275] = {.lex_state = 384},
  [276] = {.lex_state = 384},
  [277] = {.lex_state = 384},
  [278] = {.lex_state = 384},
  [279] = {.lex_state = 384},
  [280] = {.lex_state = 384},
  [281] = {.lex_state = 384},
  [282] = {.lex_state = 384},
  [283] = {.lex_state = 384},
  [284] = {.lex_state = 384},
  [285] = {.lex_state = 384},
  [286] = {.lex_state = 384},
  [287] = {.lex_state = 384},
  [288] = {.lex_state = 384},
  [289] = {.lex_state = 384},
  [290] = {.lex_state = 384},
  [291] = {.lex_state = 384},
  [292] = {.lex_state = 384},
  [293] = {.lex_state = 384},
  [294] = {.lex_state = 384},
  [295] = {.lex_state = 384},
  [296] = {.lex_state = 384},
  [297] = {.lex_state = 384},
  [298] = {.lex_state = 384},
  [299] = {.lex_state = 384},
  [300] = {.lex_state = 384},
  [301] = {.lex_state = 384},
  [302] = {.lex_state = 384},
  [303] = {.lex_state = 384},
  [304] = {.lex_state = 384},
  [305] = {.lex_state = 384},
  [306] = {.lex_state = 384},
  [307] = {.lex_state = 384},
  [308] = {.lex_state = 384},
  [309] = {.lex_state = 384},
  [310] = {.lex_state = 384},
  [311] = {.lex_state = 384},
  [312] = {.lex_state = 384},
  [313] = {.lex_state = 384},
  [314] = {.lex_state = 384},
  [315] = {.lex_state = 384},
  [316] = {.lex_state = 384},
  [317] = {.lex_state = 384},
  [318] = {.lex_state = 384},
  [319] = {.lex_state = 384},
  [320] = {.lex_state = 384},
  [321] = {.lex_state = 384},
  [322] = {.lex_state = 384},
  [323] = {.lex_state = 384},
  [324] = {.lex_state = 384},
  [325] = {.lex_state = 384},
  [326] = {.lex_state = 384},
  [327] = {.lex_state = 384},
  [328] = {.lex_state = 384},
  [329] = {.lex_state = 384},
  [330] = {.lex_state = 384},
  [331] = {.lex_state = 384},
  [332] = {.lex_state = 384},
  [333] = {.lex_state = 384},
  [334] = {.lex_state = 384},
  [335] = {.lex_state = 384},
  [336] = {.lex_state = 384},
  [337] = {.lex_state = 384},
  [338] = {.lex_state = 384},
  [339] = {.lex_state = 384},
  [340] = {.lex_state = 384},
  [341] = {.lex_state = 384},
  [342] = {.lex_state = 384},
  [343] = {.lex_state = 384},
  [344] = {.lex_state = 384},
  [345] = {.lex_state = 384},
  [346] = {.lex_state = 384},
  [347] = {.lex_state = 384},
  [348] = {.lex_state = 384},
  [349] = {.lex_state = 384},
  [350] = {.lex_state = 384},
  [351] = {.lex_state = 384},
  [352] = {.lex_state = 384},
  [353] = {.lex_state = 384},
  [354] = {.lex_state = 384},
  [355] = {.lex_state = 384},
  [356] = {.lex_state = 384},
  [357] = {.lex_state = 384},
  [358] = {.lex_state = 384},
  [359] = {.lex_state = 384},
  [360] = {.lex_state = 384},
  [361] = {.lex_state = 384},
  [362] = {.lex_state = 384},
  [363] = {.lex_state = 384},
  [364] = {.lex_state = 384},
  [365] = {.lex_state = 384},
  [366] = {.lex_state = 384},
  [367] = {.lex_state = 384},
  [368] = {.lex_state = 384},
  [369] = {.lex_state = 384},
  [370] = {.lex_state = 384},
  [371] = {.lex_state = 384},
  [372] = {.lex_state = 384},
  [373] = {.lex_state = 384},
  [374] = {.lex_state = 384},
  [375] = {.lex_state = 384},
  [376] = {.lex_state = 384},
  [377] = {.lex_state = 384},
  [378] = {.lex_state = 384},
  [379] = {.lex_state = 384},
  [380] = {.lex_state = 384},
  [381] = {.lex_state = 384},
  [382] = {.lex_state = 384},
  [383] = {.lex_state = 384},
  [384] = {.lex_state = 384},
  [385] = {.lex_state = 384},
  [386] = {.lex_state = 384},
  [387] = {.lex_state = 384},
  [388] = {.lex_state = 384},
  [389] = {.lex_state = 384},
  [390] = {.lex_state = 384},
  [391] = {.lex_state = 384},
  [392] = {.lex_state = 384},
  [393] = {.lex_state = 384},
  [394] = {.lex_state = 384},
  [395] = {.lex_state = 384},
  [396] = {.lex_state = 384},
  [397] = {.lex_state = 384},
  [398] = {.lex_state = 384},
  [399] = {.lex_state = 384},
  [400] = {.lex_state = 384},
  [401] = {.lex_state = 384},
  [402] = {.lex_state = 384},
  [403] = {.lex_state = 384},
  [404] = {.lex_state = 384},
  [405] = {.lex_state = 384},
  [406] = {.lex_state = 384},
  [407] = {.lex_state = 384},
  [408] = {.lex_state = 384},
  [409] = {.lex_state = 384},
  [410] = {.lex_state = 384},
  [411] = {.lex_state = 384},
  [412] = {.lex_state = 384},
  [413] = {.lex_state = 384},
  [414] = {.lex_state = 384},
  [415] = {.lex_state = 384},
  [416] = {.lex_state = 384},
  [417] = {.lex_state = 384},
  [418] = {.lex_state = 384},
  [419] = {.lex_state = 384},
  [420] = {.lex_state = 384},
  [421] = {.lex_state = 384},
  [422] = {.lex_state = 384},
  [423] = {.lex_state = 384},
  [424] = {.lex_state = 384},
  [425] = {.lex_state = 384},
  [426] = {.lex_state = 384},
  [427] = {.lex_state = 384},
  [428] = {.lex_state = 384},
  [429] = {.lex_state = 384},
  [430] = {.lex_state = 384},
  [431] = {.lex_state = 384},
  [432] = {.lex_state = 384},
  [433] = {.lex_state = 384},
  [434] = {.lex_state = 384},
  [435] = {.lex_state = 384},
  [436] = {.lex_state = 384},
  [437] = {.lex_state = 384},
  [438] = {.lex_state = 384},
  [439] = {.lex_state = 384},
  [440] = {.lex_state = 384},
  [441] = {.lex_state = 384},
  [442] = {.lex_state = 384},
  [443] = {.lex_state = 384},
  [444] = {.lex_state = 384},
  [445] = {.lex_state = 384},
  [446] = {.lex_state = 384},
  [447] = {.lex_state = 384},
  [448] = {.lex_state = 384},
  [449] = {.lex_state = 384},
  [450] = {.lex_state = 384},
  [451] = {.lex_state = 384},
  [452] = {.lex_state = 384},
  [453] = {.lex_state = 384},
  [454] = {.lex_state = 384},
  [455] = {.lex_state = 384},
  [456] = {.lex_state = 384},
  [457] = {.lex_state = 384},
  [458] = {.lex_state = 384},
  [459] = {.lex_state = 384},
  [460] = {.lex_state = 384},
  [461] = {.lex_state = 384},
  [462] = {.lex_state = 384},
  [463] = {.lex_state = 384},
  [464] = {.lex_state = 384},
  [465] = {.lex_state = 384},
  [466] = {.lex_state = 384},
  [467] = {.lex_state = 384},
  [468] = {.lex_state = 384},
  [469] = {.lex_state = 384},
  [470] = {.lex_state = 384},
  [471] = {.lex_state = 384},
  [472] = {.lex_state = 384},
  [473] = {.lex_state = 384},
  [474] = {.lex_state = 384},
  [475] = {.lex_state = 384},
  [476] = {.lex_state = 384},
  [477] = {.lex_state = 384},
  [478] = {.lex_state = 384},
  [479] = {.lex_state = 384},
  [480] = {.lex_state = 384},
  [481] = {.lex_state = 384},
  [482] = {.lex_state = 384},
  [483] = {.lex_state = 384},
  [484] = {.lex_state = 5},
  [485] = {.lex_state = 5},
  [486] = {.lex_state = 5},
  [487] = {.lex_state = 5},
  [488] = {.lex_state = 5},
  [489] = {.lex_state = 5},
  [490] = {.lex_state = 5},
  [491] = {.lex_state = 5},
  [492] = {.lex_state = 5},
  [493] = {.lex_state = 5},
  [494] = {.lex_state = 5},
  [495] = {.lex_state = 5},
  [496] = {.lex_state = 5},
  [497] = {.lex_state = 5},
  [498] = {.lex_state = 5},
  [499] = {.lex_state = 5},
  [500] = {.lex_state = 5},
  [501] = {.lex_state = 5},
  [502] = {.lex_state = 5},
  [503] = {.lex_state = 5},
  [504] = {.lex_state = 5},
  [505] = {.lex_state = 5},
  [506] = {.lex_state = 5},
  [507] = {.lex_state = 5},
  [508] = {.lex_state = 5},
  [509] = {.lex_state = 5},
  [510] = {.lex_state = 5},
  [511] = {.lex_state = 5},
  [512] = {.lex_state = 5},
  [513] = {.lex_state = 5},
  [514] = {.lex_state = 5},
  [515] = {.lex_state = 5},
  [516] = {.lex_state = 5},
  [517] = {.lex_state = 5},
  [518] = {.lex_state = 5},
  [519] = {.lex_state = 5},
  [520] = {.lex_state = 5},
  [521] = {.lex_state = 5},
  [522] = {.lex_state = 5},
  [523] = {.lex_state = 5},
  [524] = {.lex_state = 5},
  [525] = {.lex_state = 5},
  [526] = {.lex_state = 5},
  [527] = {.lex_state = 5},
  [528] = {.lex_state = 5},
  [529] = {.lex_state = 5},
  [530] = {.lex_state = 5},
  [531] = {.lex_state = 5},
  [532] = {.lex_state = 5},
  [533] = {.lex_state = 5},
  [534] = {.lex_state = 5},
  [535] = {.lex_state = 5},
  [536] = {.lex_state = 5},
  [537] = {.lex_state = 5},
  [538] = {.lex_state = 5},
  [539] = {.lex_state = 5},
  [540] = {.lex_state = 5},
  [541] = {.lex_state = 5},
  [542] = {.lex_state = 5},
  [543] = {.lex_state = 5},
  [544] = {.lex_state = 5},
  [545] = {.lex_state = 5},
  [546] = {.lex_state = 5},
  [547] = {.lex_state = 5},
  [548] = {.lex_state = 5},
  [549] = {.lex_state = 5},
  [550] = {.lex_state = 5},
  [551] = {.lex_state = 5},
  [552] = {.lex_state = 5},
  [553] = {.lex_state = 5},
  [554] = {.lex_state = 5},
  [555] = {.lex_state = 5},
  [556] = {.lex_state = 5},
  [557] = {.lex_state = 5},
  [558] = {.lex_state = 5},
  [559] = {.lex_state = 5},
  [560] = {.lex_state = 5},
  [561] = {.lex_state = 5},
  [562] = {.lex_state = 5},
  [563] = {.lex_state = 5},
  [564] = {.lex_state = 5},
  [565] = {.lex_state = 5},
  [566] = {.lex_state = 5},
  [567] = {.lex_state = 5},
  [568] = {.lex_state = 5},
  [569] = {.lex_state = 5},
  [570] = {.lex_state = 5},
  [571] = {.lex_state = 5},
  [572] = {.lex_state = 5},
  [573] = {.lex_state = 5},
  [574] = {.lex_state = 5},
  [575] = {.lex_state = 5},
  [576] = {.lex_state = 5},
  [577] = {.lex_state = 5},
  [578] = {.lex_state = 5},
  [579] = {.lex_state = 5},
  [580] = {.lex_state = 5},
  [581] = {.lex_state = 5},
  [582] = {.lex_state = 5},
  [583] = {.lex_state = 5},
  [584] = {.lex_state = 5},
  [585] = {.lex_state = 5},
  [586] = {.lex_state = 5},
  [587] = {.lex_state = 5},
  [588] = {.lex_state = 5},
  [589] = {.lex_state = 5},
  [590] = {.lex_state = 5},
  [591] = {.lex_state = 5},
  [592] = {.lex_state = 5},
  [593] = {.lex_state = 5},
  [594] = {.lex_state = 5},
  [595] = {.lex_state = 5},
  [596] = {.lex_state = 5},
  [597] = {.lex_state = 5},
  [598] = {.lex_state = 5},
  [599] = {.lex_state = 5},
  [600] = {.lex_state = 5},
  [601] = {.lex_state = 5},
  [602] = {.lex_state = 5},
  [603] = {.lex_state = 5},
  [604] = {.lex_state = 5},
  [605] = {.lex_state = 5},
  [606] = {.lex_state = 5},
  [607] = {.lex_state = 5},
  [608] = {.lex_state = 5},
  [609] = {.lex_state = 5},
  [610] = {.lex_state = 5},
  [611] = {.lex_state = 5},
  [612] = {.lex_state = 5},
  [613] = {.lex_state = 5},
  [614] = {.lex_state = 5},
  [615] = {.lex_state = 5},
  [616] = {.lex_state = 5},
  [617] = {.lex_state = 5},
  [618] = {.lex_state = 5},
  [619] = {.lex_state = 5},
  [620] = {.lex_state = 5},
  [621] = {.lex_state = 5},
  [622] = {.lex_state = 5},
  [623] = {.lex_state = 5},
  [624] = {.lex_state = 5},
  [625] = {.lex_state = 5},
  [626] = {.lex_state = 5},
  [627] = {.lex_state = 5},
  [628] = {.lex_state = 5},
  [629] = {.lex_state = 5},
  [630] = {.lex_state = 5},
  [631] = {.lex_state = 5},
  [632] = {.lex_state = 5},
  [633] = {.lex_state = 5},
  [634] = {.lex_state = 5},
  [635] = {.lex_state = 5},
  [636] = {.lex_state = 5},
  [637] = {.lex_state = 5},
  [638] = {.lex_state = 5},
  [639] = {.lex_state = 5},
  [640] = {.lex_state = 5},
  [641] = {.lex_state = 5},
  [642] = {.lex_state = 5},
  [643] = {.lex_state = 5},
  [644] = {.lex_state = 5},
  [645] = {.lex_state = 5},
  [646] = {.lex_state = 5},
  [647] = {.lex_state = 5},
  [648] = {.lex_state = 5},
  [649] = {.lex_state = 5},
  [650] = {.lex_state = 5},
  [651] = {.lex_state = 5},
  [652] = {.lex_state = 5},
  [653] = {.lex_state = 5},
  [654] = {.lex_state = 5},
  [655] = {.lex_state = 5},
  [656] = {.lex_state = 5},
  [657] = {.lex_state = 5},
  [658] = {.lex_state = 5},
  [659] = {.lex_state = 5},
  [660] = {.lex_state = 5},
  [661] = {.lex_state = 5},
  [662] = {.lex_state = 384},
  [663] = {.lex_state = 5},
  [664] = {.lex_state = 5},
  [665] = {.lex_state = 5},
  [666] = {.lex_state = 5},
  [667] = {.lex_state = 5},
  [668] = {.lex_state = 5},
  [669] = {.lex_state = 5},
  [670] = {.lex_state = 5},
  [671] = {.lex_state = 5},
  [672] = {.lex_state = 5},
  [673] = {.lex_state = 5},
  [674] = {.lex_state = 5},
  [675] = {.lex_state = 5},
  [676] = {.lex_state = 5},
  [677] = {.lex_state = 384},
  [678] = {.lex_state = 384},
  [679] = {.lex_state = 384},
  [680] = {.lex_state = 384},
  [681] = {.lex_state = 384},
  [682] = {.lex_state = 11},
  [683] = {.lex_state = 384},
  [684] = {.lex_state = 11},
  [685] = {.lex_state = 384},
  [686] = {.lex_state = 384},
  [687] = {.lex_state = 384},
  [688] = {.lex_state = 384},
  [689] = {.lex_state = 384},
  [690] = {.lex_state = 384},
  [691] = {.lex_state = 384},
  [692] = {.lex_state = 384},
  [693] = {.lex_state = 384},
  [694] = {.lex_state = 11},
  [695] = {.lex_state = 14},
  [696] = {.lex_state = 11},
  [697] = {.lex_state = 18},
  [698] = {.lex_state = 18},
  [699] = {.lex_state = 18},
  [700] = {.lex_state = 18},
  [701] = {.lex_state = 18},
  [702] = {.lex_state = 18},
  [703] = {.lex_state = 18},
  [704] = {.lex_state = 18},
  [705] = {.lex_state = 18},
  [706] = {.lex_state = 18},
  [707] = {.lex_state = 18},
  [708] = {.lex_state = 18},
  [709] = {.lex_state = 18},
  [710] = {.lex_state = 18},
  [711] = {.lex_state = 18},
  [712] = {.lex_state = 18},
  [713] = {.lex_state = 18},
  [714] = {.lex_state = 18},
  [715] = {.lex_state = 18},
  [716] = {.lex_state = 18},
  [717] = {.lex_state = 18},
  [718] = {.lex_state = 18},
  [719] = {.lex_state = 18},
  [720] = {.lex_state = 18},
  [721] = {.lex_state = 18},
  [722] = {.lex_state = 18},
  [723] = {.lex_state = 18},
  [724] = {.lex_state = 18},
  [725] = {.lex_state = 18},
  [726] = {.lex_state = 18},
  [727] = {.lex_state = 18},
  [728] = {.lex_state = 18},
  [729] = {.lex_state = 18},
  [730] = {.lex_state = 18},
  [731] = {.lex_state = 18},
  [732] = {.lex_state = 18},
  [733] = {.lex_state = 18},
  [734] = {.lex_state = 5},
  [735] = {.lex_state = 5},
  [736] = {.lex_state = 18},
  [737] = {.lex_state = 18},
  [738] = {.lex_state = 18},
  [739] = {.lex_state = 5},
  [740] = {.lex_state = 18},
  [741] = {.lex_state = 18},
  [742] = {.lex_state = 18},
  [743] = {.lex_state = 5},
  [744] = {.lex_state = 5},
  [745] = {.lex_state = 18},
  [746] = {.lex_state = 18},
  [747] = {.lex_state = 18},
  [748] = {.lex_state = 18},
  [749] = {.lex_state = 18},
  [750] = {.lex_state = 18},
  [751] = {.lex_state = 5},
  [752] = {.lex_state = 18},
  [753] = {.lex_state = 18},
  [754] = {.lex_state = 18},
  [755] = {.lex_state = 18},
  [756] = {.lex_state = 18},
  [757] = {.lex_state = 18},
  [758] = {.lex_state = 18},
  [759] = {.lex_state = 18},
  [760] = {.lex_state = 18},
  [761] = {.lex_state = 18},
  [762] = {.lex_state = 18},
  [763] = {.lex_state = 18},
  [764] = {.lex_state = 18},
  [765] = {.lex_state = 18},
  [766] = {.lex_state = 18},
  [767] = {.lex_state = 18},
  [768] = {.lex_state = 18},
  [769] = {.lex_state = 18},
  [770] = {.lex_state = 18},
  [771] = {.lex_state = 18},
  [772] = {.lex_state = 18},
  [773] = {.lex_state = 18},
  [774] = {.lex_state = 18},
  [775] = {.lex_state = 5},
  [776] = {.lex_state = 18},
  [777] = {.lex_state = 18},
  [778] = {.lex_state = 18},
  [779] = {.lex_state = 5},
  [780] = {.lex_state = 5},
  [781] = {.lex_state = 18},
  [782] = {.lex_state = 5},
  [783] = {.lex_state = 18},
  [784] = {.lex_state = 18},
  [785] = {.lex_state = 5},
  [786] = {.lex_state = 18},
  [787] = {.lex_state = 18},
  [788] = {.lex_state = 18},
  [789] = {.lex_state = 5},
  [790] = {.lex_state = 18},
  [791] = {.lex_state = 18},
  [792] = {.lex_state = 18},
  [793] = {.lex_state = 18},
  [794] = {.lex_state = 18},
  [795] = {.lex_state = 18},
  [796] = {.lex_state = 18},
  [797] = {.lex_state = 18},
  [798] = {.lex_state = 18},
  [799] = {.lex_state = 18},
  [800] = {.lex_state = 18},
  [801] = {.lex_state = 18},
  [802] = {.lex_state = 18},
  [803] = {.lex_state = 18},
  [804] = {.lex_state = 5},
  [805] = {.lex_state = 5},
  [806] = {.lex_state = 18},
  [807] = {.lex_state = 18},
  [808] = {.lex_state = 18},
  [809] = {.lex_state = 18},
  [810] = {.lex_state = 18},
  [811] = {.lex_state = 18},
  [812] = {.lex_state = 18},
  [813] = {.lex_state = 18},
  [814] = {.lex_state = 18},
  [815] = {.lex_state = 18},
  [816] = {.lex_state = 18},
  [817] = {.lex_state = 18},
  [818] = {.lex_state = 18},
  [819] = {.lex_state = 18},
  [820] = {.lex_state = 18},
  [821] = {.lex_state = 18},
  [822] = {.lex_state = 18},
  [823] = {.lex_state = 18},
  [824] = {.lex_state = 18},
  [825] = {.lex_state = 5},
  [826] = {.lex_state = 18},
  [827] = {.lex_state = 5},
  [828] = {.lex_state = 5},
  [829] = {.lex_state = 18},
  [830] = {.lex_state = 18},
  [831] = {.lex_state = 18},
  [832] = {.lex_state = 18},
  [833] = {.lex_state = 5},
  [834] = {.lex_state = 5},
  [835] = {.lex_state = 18},
  [836] = {.lex_state = 18},
  [837] = {.lex_state = 5},
  [838] = {.lex_state = 18},
  [839] = {.lex_state = 18},
  [840] = {.lex_state = 5},
  [841] = {.lex_state = 18},
  [842] = {.lex_state = 18},
  [843] = {.lex_state = 5},
  [844] = {.lex_state = 18},
  [845] = {.lex_state = 18},
  [846] = {.lex_state = 18},
  [847] = {.lex_state = 18},
  [848] = {.lex_state = 18},
  [849] = {.lex_state = 18},
  [850] = {.lex_state = 5},
  [851] = {.lex_state = 5},
  [852] = {.lex_state = 18},
  [853] = {.lex_state = 5},
  [854] = {.lex_state = 5},
  [855] = {.lex_state = 5},
  [856] = {.lex_state = 5},
  [857] = {.lex_state = 5},
  [858] = {.lex_state = 5},
  [859] = {.lex_state = 5},
  [860] = {.lex_state = 5},
  [861] = {.lex_state = 18},
  [862] = {.lex_state = 18},
  [863] = {.lex_state = 5},
  [864] = {.lex_state = 5},
  [865] = {.lex_state = 5},
  [866] = {.lex_state = 5},
  [867] = {.lex_state = 5},
  [868] = {.lex_state = 18},
  [869] = {.lex_state = 5},
  [870] = {.lex_state = 5},
  [871] = {.lex_state = 18},
  [872] = {.lex_state = 5},
  [873] = {.lex_state = 18},
  [874] = {.lex_state = 18},
  [875] = {.lex_state = 5},
  [876] = {.lex_state = 5},
  [877] = {.lex_state = 5},
  [878] = {.lex_state = 5},
  [879] = {.lex_state = 5},
  [880] = {.lex_state = 5},
  [881] = {.lex_state = 18},
  [882] = {.lex_state = 5},
  [883] = {.lex_state = 5},
  [884] = {.lex_state = 18},
  [885] = {.lex_state = 18},
  [886] = {.lex_state = 5},
  [887] = {.lex_state = 18},
  [888] = {.lex_state = 5},
  [889] = {.lex_state = 5},
  [890] = {.lex_state = 5},
  [891] = {.lex_state = 5},
  [892] = {.lex_state = 18},
  [893] = {.lex_state = 18},
  [894] = {.lex_state = 5},
  [895] = {.lex_state = 5},
  [896] = {.lex_state = 5},
  [897] = {.lex_state = 18},
  [898] = {.lex_state = 18},
  [899] = {.lex_state = 18},
  [900] = {.lex_state = 18},
  [901] = {.lex_state = 18},
  [902] = {.lex_state = 5},
  [903] = {.lex_state = 5},
  [904] = {.lex_state = 5},
  [905] = {.lex_state = 18},
  [906] = {.lex_state = 5},
  [907] = {.lex_state = 18},
  [908] = {.lex_state = 18},
  [909] = {.lex_state = 5},
  [910] = {.lex_state = 5},
  [911] = {.lex_state = 5},
  [912] = {.lex_state = 5},
  [913] = {.lex_state = 5},
  [914] = {.lex_state = 5},
  [915] = {.lex_state = 5},
  [916] = {.lex_state = 5},
  [917] = {.lex_state = 5},
  [918] = {.lex_state = 18},
  [919] = {.lex_state = 18},
  [920] = {.lex_state = 5},
  [921] = {.lex_state = 5},
  [922] = {.lex_state = 18},
  [923] = {.lex_state = 5},
  [924] = {.lex_state = 5},
  [925] = {.lex_state = 18},
  [926] = {.lex_state = 5},
  [927] = {.lex_state = 5},
  [928] = {.lex_state = 5},
  [929] = {.lex_state = 5},
  [930] = {.lex_state = 5},
  [931] = {.lex_state = 5},
  [932] = {.lex_state = 5},
  [933] = {.lex_state = 18},
  [934] = {.lex_state = 18},
  [935] = {.lex_state = 18},
  [936] = {.lex_state = 18},
  [937] = {.lex_state = 5},
  [938] = {.lex_state = 5},
  [939] = {.lex_state = 5},
  [940] = {.lex_state = 5},
  [941] = {.lex_state = 5},
  [942] = {.lex_state = 5},
  [943] = {.lex_state = 18},
  [944] = {.lex_state = 5},
  [945] = {.lex_state = 5},
  [946] = {.lex_state = 5},
  [947] = {.lex_state = 5},
  [948] = {.lex_state = 18},
  [949] = {.lex_state = 5},
  [950] = {.lex_state = 5},
  [951] = {.lex_state = 5},
  [952] = {.lex_state = 5},
  [953] = {.lex_state = 5},
  [954] = {.lex_state = 5},
  [955] = {.lex_state = 5},
  [956] = {.lex_state = 5},
  [957] = {.lex_state = 5},
  [958] = {.lex_state = 5},
  [959] = {.lex_state = 5},
  [960] = {.lex_state = 5},
  [961] = {.lex_state = 5},
  [962] = {.lex_state = 5},
  [963] = {.lex_state = 5},
  [964] = {.lex_state = 5},
  [965] = {.lex_state = 18},
  [966] = {.lex_state = 18},
  [967] = {.lex_state = 18},
  [968] = {.lex_state = 18},
  [969] = {.lex_state = 18},
  [970] = {.lex_state = 18},
  [971] = {.lex_state = 18},
  [972] = {.lex_state = 18},
  [973] = {.lex_state = 18},
  [974] = {.lex_state = 18},
  [975] = {.lex_state = 18},
  [976] = {.lex_state = 18},
  [977] = {.lex_state = 18},
  [978] = {.lex_state = 18},
  [979] = {.lex_state = 18},
  [980] = {.lex_state = 18},
  [981] = {.lex_state = 18},
  [982] = {.lex_state = 18},
  [983] = {.lex_state = 18},
  [984] = {.lex_state = 18},
  [985] = {.lex_state = 18},
  [986] = {.lex_state = 18},
  [987] = {.lex_state = 18},
  [988] = {.lex_state = 18},
  [989] = {.lex_state = 18},
  [990] = {.lex_state = 18},
  [991] = {.lex_state = 18},
  [992] = {.lex_state = 18},
  [993] = {.lex_state = 18},
  [994] = {.lex_state = 18},
  [995] = {.lex_state = 5},
  [996] = {.lex_state = 5},
  [997] = {.lex_state = 5},
  [998] = {.lex_state = 5},
  [999] = {.lex_state = 18},
  [1000] = {.lex_state = 18},
  [1001] = {.lex_state = 5},
  [1002] = {.lex_state = 5},
  [1003] = {.lex_state = 18},
  [1004] = {.lex_state = 18},
  [1005] = {.lex_state = 18},
  [1006] = {.lex_state = 18},
  [1007] = {.lex_state = 18},
  [1008] = {.lex_state = 18},
  [1009] = {.lex_state = 18},
  [1010] = {.lex_state = 18},
  [1011] = {.lex_state = 18},
  [1012] = {.lex_state = 18},
  [1013] = {.lex_state = 18},
  [1014] = {.lex_state = 18},
  [1015] = {.lex_state = 18},
  [1016] = {.lex_state = 18},
  [1017] = {.lex_state = 18},
  [1018] = {.lex_state = 18},
  [1019] = {.lex_state = 18},
  [1020] = {.lex_state = 18},
  [1021] = {.lex_state = 18},
  [1022] = {.lex_state = 18},
  [1023] = {.lex_state = 4},
  [1024] = {.lex_state = 3},
  [1025] = {.lex_state = 4},
  [1026] = {.lex_state = 4},
  [1027] = {.lex_state = 4},
  [1028] = {.lex_state = 3},
  [1029] = {.lex_state = 3},
  [1030] = {.lex_state = 3},
  [1031] = {.lex_state = 4},
  [1032] = {.lex_state = 3},
  [1033] = {.lex_state = 4},
  [1034] = {.lex_state = 3},
  [1035] = {.lex_state = 4},
  [1036] = {.lex_state = 3},
  [1037] = {.lex_state = 3},
  [1038] = {.lex_state = 4},
  [1039] = {.lex_state = 4},
  [1040] = {.lex_state = 3},
  [1041] = {.lex_state = 4},
  [1042] = {.lex_state = 4},
  [1043] = {.lex_state = 4},
  [1044] = {.lex_state = 3},
  [1045] = {.lex_state = 3},
  [1046] = {.lex_state = 3},
  [1047] = {.lex_state = 3},
  [1048] = {.lex_state = 3},
  [1049] = {.lex_state = 4},
  [1050] = {.lex_state = 3},
  [1051] = {.lex_state = 3},
  [1052] = {.lex_state = 4},
  [1053] = {.lex_state = 3},
  [1054] = {.lex_state = 3},
  [1055] = {.lex_state = 3},
  [1056] = {.lex_state = 4},
  [1057] = {.lex_state = 4},
  [1058] = {.lex_state = 18},
  [1059] = {.lex_state = 18},
  [1060] = {.lex_state = 3},
  [1061] = {.lex_state = 18},
  [1062] = {.lex_state = 18},
  [1063] = {.lex_state = 18},
  [1064] = {.lex_state = 18},
  [1065] = {.lex_state = 4},
  [1066] = {.lex_state = 4},
  [1067] = {.lex_state = 4},
  [1068] = {.lex_state = 4},
  [1069] = {.lex_state = 18},
  [1070] = {.lex_state = 18},
  [1071] = {.lex_state = 4},
  [1072] = {.lex_state = 4},
  [1073] = {.lex_state = 3},
  [1074] = {.lex_state = 4},
  [1075] = {.lex_state = 18},
  [1076] = {.lex_state = 18},
  [1077] = {.lex_state = 18},
  [1078] = {.lex_state = 3},
  [1079] = {.lex_state = 18},
  [1080] = {.lex_state = 3},
  [1081] = {.lex_state = 384},
  [1082] = {.lex_state = 18},
  [1083] = {.lex_state = 384},
  [1084] = {.lex_state = 384},
  [1085] = {.lex_state = 384},
  [1086] = {.lex_state = 4},
  [1087] = {.lex_state = 384},
  [1088] = {.lex_state = 384},
  [1089] = {.lex_state = 18},
  [1090] = {.lex_state = 384},
  [1091] = {.lex_state = 3},
  [1092] = {.lex_state = 3},
  [1093] = {.lex_state = 384},
  [1094] = {.lex_state = 18},
  [1095] = {.lex_state = 3},
  [1096] = {.lex_state = 18},
  [1097] = {.lex_state = 3},
  [1098] = {.lex_state = 3},
  [1099] = {.lex_state = 384},
  [1100] = {.lex_state = 18},
  [1101] = {.lex_state = 18},
  [1102] = {.lex_state = 18},
  [1103] = {.lex_state = 4},
  [1104] = {.lex_state = 18},
  [1105] = {.lex_state = 18},
  [1106] = {.lex_state = 18},
  [1107] = {.lex_state = 3},
  [1108] = {.lex_state = 384},
  [1109] = {.lex_state = 4},
  [1110] = {.lex_state = 384},
  [1111] = {.lex_state = 3},
  [1112] = {.lex_state = 4},
  [1113] = {.lex_state = 18},
  [1114] = {.lex_state = 3},
  [1115] = {.lex_state = 4},
  [1116] = {.lex_state = 4},
  [1117] = {.lex_state = 3},
  [1118] = {.lex_state = 384},
  [1119] = {.lex_state = 18},
  [1120] = {.lex_state = 4},
  [1121] = {.lex_state = 4},
  [1122] = {.lex_state = 3},
  [1123] = {.lex_state = 18},
  [1124] = {.lex_state = 3},
  [1125] = {.lex_state = 3},
  [1126] = {.lex_state = 384},
  [1127] = {.lex_state = 4},
  [1128] = {.lex_state = 4},
  [1129] = {.lex_state = 3},
  [1130] = {.lex_state = 18},
  [1131] = {.lex_state = 384},
  [1132] = {.lex_state = 3},
  [1133] = {.lex_state = 3},
  [1134] = {.lex_state = 384},
  [1135] = {.lex_state = 18},
  [1136] = {.lex_state = 18},
  [1137] = {.lex_state = 15},
  [1138] = {.lex_state = 3},
  [1139] = {.lex_state = 384},
  [1140] = {.lex_state = 3},
  [1141] = {.lex_state = 18},
  [1142] = {.lex_state = 3},
  [1143] = {.lex_state = 18},
  [1144] = {.lex_state = 3},
  [1145] = {.lex_state = 18},
  [1146] = {.lex_state = 3},
  [1147] = {.lex_state = 384},
  [1148] = {.lex_state = 5},
  [1149] = {.lex_state = 384},
  [1150] = {.lex_state = 18},
  [1151] = {.lex_state = 3},
  [1152] = {.lex_state = 5},
  [1153] = {.lex_state = 3},
  [1154] = {.lex_state = 384},
  [1155] = {.lex_state = 18},
  [1156] = {.lex_state = 3},
  [1157] = {.lex_state = 3},
  [1158] = {.lex_state = 384},
  [1159] = {.lex_state = 384},
  [1160] = {.lex_state = 384},
  [1161] = {.lex_state = 18},
  [1162] = {.lex_state = 3},
  [1163] = {.lex_state = 3},
  [1164] = {.lex_state = 18},
  [1165] = {.lex_state = 18},
  [1166] = {.lex_state = 3},
  [1167] = {.lex_state = 3},
  [1168] = {.lex_state = 3},
  [1169] = {.lex_state = 18},
  [1170] = {.lex_state = 384},
  [1171] = {.lex_state = 3},
  [1172] = {.lex_state = 384},
  [1173] = {.lex_state = 3},
  [1174] = {.lex_state = 384},
  [1175] = {.lex_state = 18},
  [1176] = {.lex_state = 384},
  [1177] = {.lex_state = 3},
  [1178] = {.lex_state = 18},
  [1179] = {.lex_state = 15},
  [1180] = {.lex_state = 384},
  [1181] = {.lex_state = 3},
  [1182] = {.lex_state = 384},
  [1183] = {.lex_state = 384},
  [1184] = {.lex_state = 3},
  [1185] = {.lex_state = 3},
  [1186] = {.lex_state = 3},
  [1187] = {.lex_state = 384},
  [1188] = {.lex_state = 3},
  [1189] = {.lex_state = 384},
  [1190] = {.lex_state = 18},
  [1191] = {.lex_state = 384},
  [1192] = {.lex_state = 18},
  [1193] = {.lex_state = 3},
  [1194] = {.lex_state = 3},
  [1195] = {.lex_state = 384},
  [1196] = {.lex_state = 3},
  [1197] = {.lex_state = 384},
  [1198] = {.lex_state = 3},
  [1199] = {.lex_state = 3},
  [1200] = {.lex_state = 384},
  [1201] = {.lex_state = 3},
  [1202] = {.lex_state = 18},
  [1203] = {.lex_state = 3},
  [1204] = {.lex_state = 18},
  [1205] = {.lex_state = 6},
  [1206] = {.lex_state = 18},
  [1207] = {.lex_state = 18},
  [1208] = {.lex_state = 18},
  [1209] = {.lex_state = 18},
  [1210] = {.lex_state = 18},
  [1211] = {.lex_state = 18},
  [1212] = {.lex_state = 18},
  [1213] = {.lex_state = 18},
  [1214] = {.lex_state = 18},
  [1215] = {.lex_state = 18},
  [1216] = {.lex_state = 3},
  [1217] = {.lex_state = 18},
  [1218] = {.lex_state = 18},
  [1219] = {.lex_state = 18},
  [1220] = {.lex_state = 18},
  [1221] = {.lex_state = 18},
  [1222] = {.lex_state = 18},
  [1223] = {.lex_state = 18},
  [1224] = {.lex_state = 18},
  [1225] = {.lex_state = 18},
  [1226] = {.lex_state = 7},
  [1227] = {.lex_state = 18},
  [1228] = {.lex_state = 18},
  [1229] = {.lex_state = 18},
  [1230] = {.lex_state = 8},
  [1231] = {.lex_state = 18},
  [1232] = {.lex_state = 18},
  [1233] = {.lex_state = 18},
  [1234] = {.lex_state = 18},
  [1235] = {.lex_state = 18},
  [1236] = {.lex_state = 8},
  [1237] = {.lex_state = 18},
  [1238] = {.lex_state = 7},
  [1239] = {.lex_state = 18},
  [1240] = {.lex_state = 18},
  [1241] = {.lex_state = 18},
  [1242] = {.lex_state = 18},
  [1243] = {.lex_state = 15},
  [1244] = {.lex_state = 18},
  [1245] = {.lex_state = 8},
  [1246] = {.lex_state = 18},
  [1247] = {.lex_state = 18},
  [1248] = {.lex_state = 18},
  [1249] = {.lex_state = 7},
  [1250] = {.lex_state = 3},
  [1251] = {.lex_state = 6},
  [1252] = {.lex_state = 3},
  [1253] = {.lex_state = 18},
  [1254] = {.lex_state = 18},
  [1255] = {.lex_state = 18},
  [1256] = {.lex_state = 18},
  [1257] = {.lex_state = 18},
  [1258] = {.lex_state = 18},
  [1259] = {.lex_state = 18},
  [1260] = {.lex_state = 18},
  [1261] = {.lex_state = 18},
  [1262] = {.lex_state = 18},
  [1263] = {.lex_state = 18},
  [1264] = {.lex_state = 18},
  [1265] = {.lex_state = 18},
  [1266] = {.lex_state = 18},
  [1267] = {.lex_state = 18},
  [1268] = {.lex_state = 18},
  [1269] = {.lex_state = 18},
  [1270] = {.lex_state = 18},
  [1271] = {.lex_state = 18},
  [1272] = {.lex_state = 18},
  [1273] = {.lex_state = 18},
  [1274] = {.lex_state = 18},
  [1275] = {.lex_state = 18},
  [1276] = {.lex_state = 18},
  [1277] = {.lex_state = 7},
  [1278] = {.lex_state = 18},
  [1279] = {.lex_state = 18},
  [1280] = {.lex_state = 18},
  [1281] = {.lex_state = 18},
  [1282] = {.lex_state = 18},
  [1283] = {.lex_state = 384},
  [1284] = {.lex_state = 8},
  [1285] = {.lex_state = 18},
  [1286] = {.lex_state = 18},
  [1287] = {.lex_state = 18},
  [1288] = {.lex_state = 18},
  [1289] = {.lex_state = 18},
  [1290] = {.lex_state = 18},
  [1291] = {.lex_state = 18},
  [1292] = {.lex_state = 18},
  [1293] = {.lex_state = 18},
  [1294] = {.lex_state = 18},
  [1295] = {.lex_state = 18},
  [1296] = {.lex_state = 18},
  [1297] = {.lex_state = 18},
  [1298] = {.lex_state = 18},
  [1299] = {.lex_state = 18},
  [1300] = {.lex_state = 18},
  [1301] = {.lex_state = 18},
  [1302] = {.lex_state = 18},
  [1303] = {.lex_state = 15},
  [1304] = {.lex_state = 18},
  [1305] = {.lex_state = 18},
  [1306] = {.lex_state = 8},
  [1307] = {.lex_state = 18},
  [1308] = {.lex_state = 18},
  [1309] = {.lex_state = 7},
  [1310] = {.lex_state = 384},
  [1311] = {.lex_state = 18},
  [1312] = {.lex_state = 18},
  [1313] = {.lex_state = 18},
  [1314] = {.lex_state = 18},
  [1315] = {.lex_state = 18},
  [1316] = {.lex_state = 18},
  [1317] = {.lex_state = 18},
  [1318] = {.lex_state = 18},
  [1319] = {.lex_state = 18},
  [1320] = {.lex_state = 18},
  [1321] = {.lex_state = 18},
  [1322] = {.lex_state = 18},
  [1323] = {.lex_state = 18},
  [1324] = {.lex_state = 18},
  [1325] = {.lex_state = 18},
  [1326] = {.lex_state = 18},
  [1327] = {.lex_state = 18},
  [1328] = {.lex_state = 18},
  [1329] = {.lex_state = 18},
  [1330] = {.lex_state = 18},
  [1331] = {.lex_state = 18},
  [1332] = {.lex_state = 18},
  [1333] = {.lex_state = 18},
  [1334] = {.lex_state = 18},
  [1335] = {.lex_state = 18},
  [1336] = {.lex_state = 18},
  [1337] = {.lex_state = 18},
  [1338] = {.lex_state = 18},
  [1339] = {.lex_state = 384},
  [1340] = {.lex_state = 18},
  [1341] = {.lex_state = 18},
  [1342] = {.lex_state = 18},
  [1343] = {.lex_state = 18},
  [1344] = {.lex_state = 18},
  [1345] = {.lex_state = 3},
  [1346] = {.lex_state = 3},
  [1347] = {.lex_state = 18},
  [1348] = {.lex_state = 18},
  [1349] = {.lex_state = 384},
  [1350] = {.lex_state = 384},
  [1351] = {.lex_state = 384},
  [1352] = {.lex_state = 384},
  [1353] = {.lex_state = 18},
  [1354] = {.lex_state = 384},
  [1355] = {.lex_state = 3},
  [1356] = {.lex_state = 384},
  [1357] = {.lex_state = 384},
  [1358] = {.lex_state = 3},
  [1359] = {.lex_state = 384},
  [1360] = {.lex_state = 3},
  [1361] = {.lex_state = 18},
  [1362] = {.lex_state = 18},
  [1363] = {.lex_state = 384},
  [1364] = {.lex_state = 18},
  [1365] = {.lex_state = 384},
  [1366] = {.lex_state = 3},
  [1367] = {.lex_state = 18},
  [1368] = {.lex_state = 18},
  [1369] = {.lex_state = 18},
  [1370] = {.lex_state = 384},
  [1371] = {.lex_state = 384},
  [1372] = {.lex_state = 3},
  [1373] = {.lex_state = 3},
  [1374] = {.lex_state = 384},
  [1375] = {.lex_state = 384},
  [1376] = {.lex_state = 3},
  [1377] = {.lex_state = 384},
  [1378] = {.lex_state = 3},
  [1379] = {.lex_state = 384},
  [1380] = {.lex_state = 18},
  [1381] = {.lex_state = 384},
  [1382] = {.lex_state = 384},
  [1383] = {.lex_state = 384},
  [1384] = {.lex_state = 18},
  [1385] = {.lex_state = 384},
  [1386] = {.lex_state = 18},
  [1387] = {.lex_state = 384},
  [1388] = {.lex_state = 384},
  [1389] = {.lex_state = 3},
  [1390] = {.lex_state = 3},
  [1391] = {.lex_state = 18},
  [1392] = {.lex_state = 18},
  [1393] = {.lex_state = 18},
  [1394] = {.lex_state = 384},
  [1395] = {.lex_state = 3},
  [1396] = {.lex_state = 3},
  [1397] = {.lex_state = 18},
  [1398] = {.lex_state = 3},
  [1399] = {.lex_state = 18},
  [1400] = {.lex_state = 18},
  [1401] = {.lex_state = 3},
  [1402] = {.lex_state = 384},
  [1403] = {.lex_state = 18},
  [1404] = {.lex_state = 384},
  [1405] = {.lex_state = 384},
  [1406] = {.lex_state = 18},
  [1407] = {.lex_state = 18},
  [1408] = {.lex_state = 18},
  [1409] = {.lex_state = 18},
  [1410] = {.lex_state = 3},
  [1411] = {.lex_state = 18},
  [1412] = {.lex_state = 18},
  [1413] = {.lex_state = 3},
  [1414] = {.lex_state = 384},
  [1415] = {.lex_state = 384},
  [1416] = {.lex_state = 18},
  [1417] = {.lex_state = 384},
  [1418] = {.lex_state = 3},
  [1419] = {.lex_state = 18},
  [1420] = {.lex_state = 18},
  [1421] = {.lex_state = 18},
  [1422] = {.lex_state = 384},
  [1423] = {.lex_state = 384},
  [1424] = {.lex_state = 3},
  [1425] = {.lex_state = 3},
  [1426] = {.lex_state = 384},
  [1427] = {.lex_state = 3},
  [1428] = {.lex_state = 3},
  [1429] = {.lex_state = 18},
  [1430] = {.lex_state = 18},
  [1431] = {.lex_state = 18},
  [1432] = {.lex_state = 3},
  [1433] = {.lex_state = 18},
  [1434] = {.lex_state = 18},
  [1435] = {.lex_state = 3},
  [1436] = {.lex_state = 18},
  [1437] = {.lex_state = 18},
  [1438] = {.lex_state = 18},
  [1439] = {.lex_state = 384},
  [1440] = {.lex_state = 384},
  [1441] = {.lex_state = 3},
  [1442] = {.lex_state = 18},
  [1443] = {.lex_state = 3},
  [1444] = {.lex_state = 384},
  [1445] = {.lex_state = 384},
  [1446] = {.lex_state = 18},
  [1447] = {.lex_state = 3},
  [1448] = {.lex_state = 18},
  [1449] = {.lex_state = 18},
  [1450] = {.lex_state = 18},
  [1451] = {.lex_state = 384},
  [1452] = {.lex_state = 18},
  [1453] = {.lex_state = 3},
  [1454] = {.lex_state = 18},
  [1455] = {.lex_state = 18},
  [1456] = {.lex_state = 384},
  [1457] = {.lex_state = 3},
  [1458] = {.lex_state = 18},
  [1459] = {.lex_state = 18},
  [1460] = {.lex_state = 18},
  [1461] = {.lex_state = 3},
  [1462] = {.lex_state = 384},
  [1463] = {.lex_state = 384},
  [1464] = {.lex_state = 18},
  [1465] = {.lex_state = 3},
  [1466] = {.lex_state = 18},
  [1467] = {.lex_state = 18},
  [1468] = {.lex_state = 18},
  [1469] = {.lex_state = 18},
  [1470] = {.lex_state = 18},
  [1471] = {.lex_state = 18},
  [1472] = {.lex_state = 3},
  [1473] = {.lex_state = 18},
  [1474] = {.lex_state = 384},
  [1475] = {.lex_state = 384},
  [1476] = {.lex_state = 384},
  [1477] = {.lex_state = 18},
  [1478] = {.lex_state = 3},
  [1479] = {.lex_state = 18},
  [1480] = {.lex_state = 18},
  [1481] = {.lex_state = 3},
  [1482] = {.lex_state = 3},
  [1483] = {.lex_state = 384},
  [1484] = {.lex_state = 384},
  [1485] = {.lex_state = 384},
  [1486] = {.lex_state = 384},
  [1487] = {.lex_state = 384},
  [1488] = {.lex_state = 384},
  [1489] = {.lex_state = 18},
  [1490] = {.lex_state = 18},
  [1491] = {.lex_state = 3},
  [1492] = {.lex_state = 3},
  [1493] = {.lex_state = 384},
  [1494] = {.lex_state = 18},
  [1495] = {.lex_state = 3},
  [1496] = {.lex_state = 384},
  [1497] = {.lex_state = 18},
  [1498] = {.lex_state = 3},
  [1499] = {.lex_state = 384},
  [1500] = {.lex_state = 384},
  [1501] = {.lex_state = 384},
  [1502] = {.lex_state = 384},
  [1503] = {.lex_state = 18},
  [1504] = {.lex_state = 384},
  [1505] = {.lex_state = 3},
  [1506] = {.lex_state = 18},
  [1507] = {.lex_state = 384},
  [1508] = {.lex_state = 384},
  [1509] = {.lex_state = 384},
  [1510] = {.lex_state = 3},
  [1511] = {.lex_state = 3},
  [1512] = {.lex_state = 384},
  [1513] = {.lex_state = 18},
  [1514] = {.lex_state = 384},
  [1515] = {.lex_state = 18},
  [1516] = {.lex_state = 384},
  [1517] = {.lex_state = 18},
  [1518] = {.lex_state = 384},
  [1519] = {.lex_state = 3},
  [1520] = {.lex_state = 18},
  [1521] = {.lex_state = 3},
  [1522] = {.lex_state = 3},
  [1523] = {.lex_state = 18},
  [1524] = {.lex_state = 384},
  [1525] = {.lex_state = 384},
  [1526] = {.lex_state = 3},
  [1527] = {.lex_state = 384},
  [1528] = {.lex_state = 18},
  [1529] = {.lex_state = 384},
  [1530] = {.lex_state = 3},
  [1531] = {.lex_state = 384},
  [1532] = {.lex_state = 384},
  [1533] = {.lex_state = 18},
  [1534] = {.lex_state = 18},
  [1535] = {.lex_state = 384},
  [1536] = {.lex_state = 3},
  [1537] = {.lex_state = 384},
  [1538] = {.lex_state = 18},
  [1539] = {.lex_state = 384},
  [1540] = {.lex_state = 18},
  [1541] = {.lex_state = 384},
  [1542] = {.lex_state = 384},
  [1543] = {.lex_state = 3},
  [1544] = {.lex_state = 384},
  [1545] = {.lex_state = 18},
  [1546] = {.lex_state = 3},
  [1547] = {.lex_state = 384},
  [1548] = {.lex_state = 18},
  [1549] = {.lex_state = 18},
  [1550] = {.lex_state = 3},
  [1551] = {.lex_state = 384},
  [1552] = {.lex_state = 384},
  [1553] = {.lex_state = 3},
  [1554] = {.lex_state = 3},
  [1555] = {.lex_state = 3},
  [1556] = {.lex_state = 3},
  [1557] = {.lex_state = 384},
  [1558] = {.lex_state = 3},
  [1559] = {.lex_state = 384},
  [1560] = {.lex_state = 384},
  [1561] = {.lex_state = 384},
  [1562] = {.lex_state = 384},
  [1563] = {.lex_state = 3},
  [1564] = {.lex_state = 384},
  [1565] = {.lex_state = 384},
  [1566] = {.lex_state = 3},
  [1567] = {.lex_state = 18},
  [1568] = {.lex_state = 3},
  [1569] = {.lex_state = 3},
  [1570] = {.lex_state = 3},
  [1571] = {.lex_state = 3},
  [1572] = {.lex_state = 3},
  [1573] = {.lex_state = 3},
  [1574] = {.lex_state = 3},
  [1575] = {.lex_state = 3},
  [1576] = {.lex_state = 3},
  [1577] = {.lex_state = 3},
  [1578] = {.lex_state = 3},
  [1579] = {.lex_state = 3},
  [1580] = {.lex_state = 3},
  [1581] = {.lex_state = 3},
  [1582] = {.lex_state = 3},
  [1583] = {.lex_state = 3},
  [1584] = {.lex_state = 3},
  [1585] = {.lex_state = 3},
  [1586] = {.lex_state = 3},
  [1587] = {.lex_state = 384},
  [1588] = {.lex_state = 18},
  [1589] = {.lex_state = 18},
  [1590] = {.lex_state = 384},
  [1591] = {.lex_state = 3},
  [1592] = {.lex_state = 18},
  [1593] = {.lex_state = 3},
  [1594] = {.lex_state = 3},
  [1595] = {.lex_state = 384},
  [1596] = {.lex_state = 3},
  [1597] = {.lex_state = 3},
  [1598] = {.lex_state = 3},
  [1599] = {.lex_state = 3},
  [1600] = {.lex_state = 3},
  [1601] = {.lex_state = 3},
  [1602] = {.lex_state = 3},
  [1603] = {.lex_state = 3},
  [1604] = {.lex_state = 18},
  [1605] = {.lex_state = 384},
  [1606] = {.lex_state = 3},
  [1607] = {.lex_state = 384},
  [1608] = {.lex_state = 3},
  [1609] = {.lex_state = 3},
  [1610] = {.lex_state = 3},
  [1611] = {.lex_state = 3},
  [1612] = {.lex_state = 3},
  [1613] = {.lex_state = 3},
  [1614] = {.lex_state = 3},
  [1615] = {.lex_state = 3},
  [1616] = {.lex_state = 384},
  [1617] = {.lex_state = 3},
  [1618] = {.lex_state = 384},
  [1619] = {.lex_state = 384},
  [1620] = {.lex_state = 3},
  [1621] = {.lex_state = 3},
  [1622] = {.lex_state = 384},
  [1623] = {.lex_state = 3},
  [1624] = {.lex_state = 3},
  [1625] = {.lex_state = 3},
  [1626] = {.lex_state = 384},
  [1627] = {.lex_state = 384},
  [1628] = {.lex_state = 384},
  [1629] = {.lex_state = 3},
  [1630] = {.lex_state = 384},
  [1631] = {.lex_state = 384},
  [1632] = {.lex_state = 3},
  [1633] = {.lex_state = 3},
  [1634] = {.lex_state = 3},
  [1635] = {.lex_state = 384},
  [1636] = {.lex_state = 3},
  [1637] = {.lex_state = 3},
  [1638] = {.lex_state = 3},
  [1639] = {.lex_state = 3},
  [1640] = {.lex_state = 3},
  [1641] = {.lex_state = 3},
  [1642] = {.lex_state = 3},
  [1643] = {.lex_state = 3},
  [1644] = {.lex_state = 3},
  [1645] = {.lex_state = 384},
  [1646] = {.lex_state = 3},
  [1647] = {.lex_state = 3},
  [1648] = {.lex_state = 3},
  [1649] = {.lex_state = 384},
  [1650] = {.lex_state = 384},
  [1651] = {.lex_state = 3},
  [1652] = {.lex_state = 3},
  [1653] = {.lex_state = 3},
  [1654] = {.lex_state = 384},
  [1655] = {.lex_state = 3},
  [1656] = {.lex_state = 3},
  [1657] = {.lex_state = 3},
  [1658] = {.lex_state = 384},
  [1659] = {.lex_state = 3},
  [1660] = {.lex_state = 3},
  [1661] = {.lex_state = 3},
  [1662] = {.lex_state = 3},
  [1663] = {.lex_state = 384},
  [1664] = {.lex_state = 3},
  [1665] = {.lex_state = 3},
  [1666] = {.lex_state = 3},
  [1667] = {.lex_state = 3},
  [1668] = {.lex_state = 384},
  [1669] = {.lex_state = 384},
  [1670] = {.lex_state = 3},
  [1671] = {.lex_state = 3},
  [1672] = {.lex_state = 384},
  [1673] = {.lex_state = 384},
  [1674] = {.lex_state = 384},
  [1675] = {.lex_state = 384},
  [1676] = {.lex_state = 384},
  [1677] = {.lex_state = 384},
  [1678] = {.lex_state = 384},
  [1679] = {.lex_state = 384},
  [1680] = {.lex_state = 384},
  [1681] = {.lex_state = 384},
  [1682] = {.lex_state = 384},
  [1683] = {.lex_state = 384},
  [1684] = {.lex_state = 384},
  [1685] = {.lex_state = 384},
  [1686] = {.lex_state = 384},
  [1687] = {.lex_state = 384},
  [1688] = {.lex_state = 13},
  [1689] = {.lex_state = 384},
  [1690] = {.lex_state = 384},
  [1691] = {.lex_state = 384},
  [1692] = {.lex_state = 384},
  [1693] = {.lex_state = 384},
  [1694] = {.lex_state = 9},
  [1695] = {.lex_state = 384},
  [1696] = {.lex_state = 384},
  [1697] = {.lex_state = 384},
  [1698] = {.lex_state = 384},
  [1699] = {.lex_state = 384},
  [1700] = {.lex_state = 384},
  [1701] = {.lex_state = 384},
  [1702] = {.lex_state = 384},
  [1703] = {.lex_state = 384},
  [1704] = {.lex_state = 384},
  [1705] = {.lex_state = 384},
  [1706] = {.lex_state = 384},
  [1707] = {.lex_state = 384},
  [1708] = {.lex_state = 384},
  [1709] = {.lex_state = 384},
  [1710] = {.lex_state = 384},
  [1711] = {.lex_state = 384},
  [1712] = {.lex_state = 384},
  [1713] = {.lex_state = 384},
  [1714] = {.lex_state = 9},
  [1715] = {.lex_state = 384},
  [1716] = {.lex_state = 384},
  [1717] = {.lex_state = 384},
  [1718] = {.lex_state = 384},
  [1719] = {.lex_state = 384},
  [1720] = {.lex_state = 384},
  [1721] = {.lex_state = 384},
  [1722] = {.lex_state = 384},
  [1723] = {.lex_state = 384},
  [1724] = {.lex_state = 384},
  [1725] = {.lex_state = 384},
  [1726] = {.lex_state = 384},
  [1727] = {.lex_state = 384},
  [1728] = {.lex_state = 384},
  [1729] = {.lex_state = 384},
  [1730] = {.lex_state = 384},
  [1731] = {.lex_state = 384},
  [1732] = {.lex_state = 384},
  [1733] = {.lex_state = 384},
  [1734] = {.lex_state = 384},
  [1735] = {.lex_state = 384},
  [1736] = {.lex_state = 384},
  [1737] = {.lex_state = 384},
  [1738] = {.lex_state = 384},
  [1739] = {.lex_state = 384},
  [1740] = {.lex_state = 384},
  [1741] = {.lex_state = 384},
  [1742] = {.lex_state = 384},
  [1743] = {.lex_state = 384},
  [1744] = {.lex_state = 384},
  [1745] = {.lex_state = 384},
  [1746] = {.lex_state = 384},
  [1747] = {.lex_state = 384},
  [1748] = {.lex_state = 384},
  [1749] = {.lex_state = 384},
  [1750] = {.lex_state = 384},
  [1751] = {.lex_state = 384},
  [1752] = {.lex_state = 384},
  [1753] = {.lex_state = 384},
  [1754] = {.lex_state = 384},
  [1755] = {.lex_state = 13},
  [1756] = {.lex_state = 384},
  [1757] = {.lex_state = 384},
  [1758] = {.lex_state = 384},
  [1759] = {.lex_state = 384},
  [1760] = {.lex_state = 384},
  [1761] = {.lex_state = 384},
  [1762] = {.lex_state = 384},
  [1763] = {.lex_state = 384},
  [1764] = {.lex_state = 384},
  [1765] = {.lex_state = 384},
  [1766] = {.lex_state = 384},
  [1767] = {.lex_state = 384},
  [1768] = {.lex_state = 384},
  [1769] = {.lex_state = 384},
  [1770] = {.lex_state = 384},
  [1771] = {.lex_state = 384},
  [1772] = {.lex_state = 384},
  [1773] = {.lex_state = 384},
  [1774] = {.lex_state = 384},
  [1775] = {.lex_state = 384},
  [1776] = {.lex_state = 384},
  [1777] = {.lex_state = 384},
  [1778] = {.lex_state = 384},
  [1779] = {.lex_state = 384},
  [1780] = {.lex_state = 384},
  [1781] = {.lex_state = 384},
  [1782] = {.lex_state = 384},
  [1783] = {.lex_state = 384},
  [1784] = {.lex_state = 384},
  [1785] = {.lex_state = 384},
  [1786] = {.lex_state = 384},
  [1787] = {.lex_state = 384},
  [1788] = {.lex_state = 384},
  [1789] = {.lex_state = 384},
  [1790] = {.lex_state = 384},
  [1791] = {.lex_state = 384},
  [1792] = {.lex_state = 384},
  [1793] = {.lex_state = 384},
  [1794] = {.lex_state = 384},
  [1795] = {.lex_state = 384},
  [1796] = {.lex_state = 384},
  [1797] = {.lex_state = 13},
  [1798] = {.lex_state = 384},
  [1799] = {.lex_state = 384},
  [1800] = {.lex_state = 384},
  [1801] = {.lex_state = 384},
  [1802] = {.lex_state = 384},
  [1803] = {.lex_state = 384},
  [1804] = {.lex_state = 384},
  [1805] = {.lex_state = 384},
  [1806] = {.lex_state = 384},
  [1807] = {.lex_state = 384},
  [1808] = {.lex_state = 384},
  [1809] = {.lex_state = 384},
  [1810] = {.lex_state = 384},
  [1811] = {.lex_state = 384},
  [1812] = {.lex_state = 384},
  [1813] = {.lex_state = 384},
  [1814] = {.lex_state = 384},
  [1815] = {.lex_state = 384},
  [1816] = {.lex_state = 384},
  [1817] = {.lex_state = 384},
  [1818] = {.lex_state = 384},
  [1819] = {.lex_state = 384},
  [1820] = {.lex_state = 384},
  [1821] = {.lex_state = 384},
  [1822] = {.lex_state = 384},
  [1823] = {.lex_state = 384},
  [1824] = {.lex_state = 384},
  [1825] = {.lex_state = 384},
  [1826] = {.lex_state = 384},
  [1827] = {.lex_state = 384},
  [1828] = {.lex_state = 384},
  [1829] = {.lex_state = 384},
  [1830] = {.lex_state = 384},
  [1831] = {.lex_state = 384},
  [1832] = {.lex_state = 384},
  [1833] = {.lex_state = 384},
  [1834] = {.lex_state = 384},
  [1835] = {.lex_state = 384},
  [1836] = {.lex_state = 384},
  [1837] = {.lex_state = 384},
  [1838] = {.lex_state = 384},
  [1839] = {.lex_state = 384},
  [1840] = {.lex_state = 384},
  [1841] = {.lex_state = 384},
  [1842] = {.lex_state = 384},
  [1843] = {.lex_state = 384},
  [1844] = {.lex_state = 384},
  [1845] = {.lex_state = 384},
  [1846] = {.lex_state = 384},
  [1847] = {.lex_state = 384},
  [1848] = {.lex_state = 384},
  [1849] = {.lex_state = 384},
  [1850] = {.lex_state = 384},
  [1851] = {.lex_state = 384},
  [1852] = {.lex_state = 384},
  [1853] = {.lex_state = 384},
  [1854] = {.lex_state = 9},
  [1855] = {.lex_state = 384},
  [1856] = {.lex_state = 384},
  [1857] = {.lex_state = 384},
  [1858] = {.lex_state = 384},
  [1859] = {.lex_state = 384},
  [1860] = {.lex_state = 384},
  [1861] = {.lex_state = 384},
  [1862] = {.lex_state = 13},
  [1863] = {.lex_state = 384},
  [1864] = {.lex_state = 384},
  [1865] = {.lex_state = 384},
  [1866] = {.lex_state = 384},
  [1867] = {.lex_state = 384},
  [1868] = {.lex_state = 384},
  [1869] = {.lex_state = 384},
  [1870] = {.lex_state = 384},
  [1871] = {.lex_state = 384},
  [1872] = {.lex_state = 384},
  [1873] = {.lex_state = 384},
  [1874] = {.lex_state = 384},
  [1875] = {.lex_state = 384},
  [1876] = {.lex_state = 384},
  [1877] = {.lex_state = 384},
  [1878] = {.lex_state = 384},
  [1879] = {.lex_state = 384},
  [1880] = {.lex_state = 384},
  [1881] = {.lex_state = 384},
  [1882] = {.lex_state = 384},
  [1883] = {.lex_state = 384},
  [1884] = {.lex_state = 384},
  [1885] = {.lex_state = 384},
  [1886] = {.lex_state = 384},
  [1887] = {.lex_state = 384},
  [1888] = {.lex_state = 384},
  [1889] = {.lex_state = 384},
  [1890] = {.lex_state = 384},
  [1891] = {.lex_state = 384},
  [1892] = {.lex_state = 384},
  [1893] = {.lex_state = 384},
  [1894] = {.lex_state = 384},
  [1895] = {.lex_state = 384},
  [1896] = {.lex_state = 384},
  [1897] = {.lex_state = 384},
  [1898] = {.lex_state = 384},
  [1899] = {.lex_state = 384},
  [1900] = {.lex_state = 384},
  [1901] = {.lex_state = 384},
  [1902] = {.lex_state = 384},
  [1903] = {.lex_state = 384},
  [1904] = {.lex_state = 384},
  [1905] = {.lex_state = 9},
  [1906] = {.lex_state = 384},
  [1907] = {.lex_state = 384},
  [1908] = {.lex_state = 384},
  [1909] = {.lex_state = 384},
  [1910] = {.lex_state = 384},
  [1911] = {.lex_state = 384},
  [1912] = {.lex_state = 384},
  [1913] = {.lex_state = 384},
  [1914] = {.lex_state = 384},
  [1915] = {.lex_state = 384},
  [1916] = {.lex_state = 384},
  [1917] = {.lex_state = 384},
  [1918] = {.lex_state = 384},
  [1919] = {.lex_state = 384},
  [1920] = {.lex_state = 384},
  [1921] = {.lex_state = 384},
  [1922] = {.lex_state = 463},
  [1923] = {.lex_state = 384},
  [1924] = {.lex_state = 384},
  [1925] = {.lex_state = 18},
  [1926] = {.lex_state = 384},
  [1927] = {.lex_state = 384},
  [1928] = {.lex_state = 384},
  [1929] = {.lex_state = 18},
  [1930] = {.lex_state = 384},
  [1931] = {.lex_state = 384},
  [1932] = {.lex_state = 384},
  [1933] = {.lex_state = 384},
  [1934] = {.lex_state = 384},
  [1935] = {.lex_state = 384},
  [1936] = {.lex_state = 384},
  [1937] = {.lex_state = 384},
  [1938] = {.lex_state = 384},
  [1939] = {.lex_state = 384},
  [1940] = {.lex_state = 384},
  [1941] = {.lex_state = 384},
  [1942] = {.lex_state = 384},
  [1943] = {.lex_state = 384},
  [1944] = {.lex_state = 384},
  [1945] = {.lex_state = 384},
  [1946] = {.lex_state = 384},
  [1947] = {.lex_state = 384},
  [1948] = {.lex_state = 384},
  [1949] = {.lex_state = 384},
  [1950] = {.lex_state = 384},
  [1951] = {.lex_state = 384},
  [1952] = {.lex_state = 384},
  [1953] = {.lex_state = 384},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [aux_sym_package_token1] = ACTIONS(1),
    [sym__dollar] = ACTIONS(1),
    [aux_sym_method_token1] = ACTIONS(1),
    [aux_sym_method_token2] = ACTIONS(1),
    [aux_sym_method_token3] = ACTIONS(1),
    [aux_sym_method_token4] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [aux_sym_method_token5] = ACTIONS(1),
    [aux_sym_method_token6] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_CARET_LT_LT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [aux_sym_method_token7] = ACTIONS(1),
    [aux_sym_procedure_token1] = ACTIONS(1),
    [aux_sym_procedure_token2] = ACTIONS(1),
    [aux_sym_block_token1] = ACTIONS(1),
    [aux_sym_block_token2] = ACTIONS(1),
    [anon_sym__and_LT_LT] = ACTIONS(1),
    [anon_sym__andif_LT_LT] = ACTIONS(1),
    [anon_sym__or_LT_LT] = ACTIONS(1),
    [anon_sym__orif_LT_LT] = ACTIONS(1),
    [anon_sym__xor_LT_LT] = ACTIONS(1),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1),
    [anon_sym_STAR_LT_LT] = ACTIONS(1),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1),
    [anon_sym__mod_LT_LT] = ACTIONS(1),
    [anon_sym__div_LT_LT] = ACTIONS(1),
    [anon_sym_DASH_LT_LT] = ACTIONS(1),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1),
    [aux_sym_if_token1] = ACTIONS(1),
    [aux_sym_if_token2] = ACTIONS(1),
    [aux_sym_if_token3] = ACTIONS(1),
    [aux_sym_elif_token1] = ACTIONS(1),
    [aux_sym_else_token1] = ACTIONS(1),
    [aux_sym_loop_token1] = ACTIONS(1),
    [aux_sym_loop_token2] = ACTIONS(1),
    [aux_sym_finally_token1] = ACTIONS(1),
    [aux_sym_finally_token2] = ACTIONS(1),
    [aux_sym_handling_token1] = ACTIONS(1),
    [aux_sym_handling_token2] = ACTIONS(1),
    [aux_sym_catch_token1] = ACTIONS(1),
    [aux_sym_catch_token2] = ACTIONS(1),
    [aux_sym_throw_token1] = ACTIONS(1),
    [aux_sym_primitive_token1] = ACTIONS(1),
    [aux_sym_iterator_token1] = ACTIONS(1),
    [aux_sym_iterator_token2] = ACTIONS(1),
    [aux_sym_while_token1] = ACTIONS(1),
    [aux_sym_try_token1] = ACTIONS(1),
    [aux_sym_try_token2] = ACTIONS(1),
    [aux_sym_try_token3] = ACTIONS(1),
    [aux_sym_loopbody_token1] = ACTIONS(1),
    [aux_sym_leave_token1] = ACTIONS(1),
    [aux_sym_continue_token1] = ACTIONS(1),
    [aux_sym_protect_token1] = ACTIONS(1),
    [aux_sym_protect_token2] = ACTIONS(1),
    [aux_sym_protect_token3] = ACTIONS(1),
    [aux_sym_protect_token4] = ACTIONS(1),
    [aux_sym_lock_token1] = ACTIONS(1),
    [aux_sym_lock_token2] = ACTIONS(1),
    [aux_sym_pragma_token1] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_regex_literal] = ACTIONS(1),
    [aux_sym_slot_accessor_token1] = ACTIONS(1),
    [aux_sym_true_token1] = ACTIONS(1),
    [aux_sym_false_token1] = ACTIONS(1),
    [aux_sym_maybe_token1] = ACTIONS(1),
    [aux_sym_unset_token1] = ACTIONS(1),
    [aux_sym_super_token1] = ACTIONS(1),
    [aux_sym_self_token1] = ACTIONS(1),
    [aux_sym_clone_token1] = ACTIONS(1),
    [aux_sym_thisthread_token1] = ACTIONS(1),
    [aux_sym_class_token1] = ACTIONS(1),
    [aux_sym_class_token2] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [aux_sym_global_token1] = ACTIONS(1),
    [aux_sym_local_token1] = ACTIONS(1),
    [aux_sym__global_assignment_token1] = ACTIONS(1),
    [aux_sym_dynamic_token1] = ACTIONS(1),
    [aux_sym_import_token1] = ACTIONS(1),
    [aux_sym_return_token1] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [aux_sym_scatter_token1] = ACTIONS(1),
    [aux_sym_allresults_token1] = ACTIONS(1),
    [sym_label] = ACTIONS(1),
    [sym_dynamic_variable] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [sym_global_reference] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [aux_sym_relational_operator_token1] = ACTIONS(1),
    [aux_sym_relational_operator_token2] = ACTIONS(1),
    [aux_sym_relational_operator_token3] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_TILDE_EQ] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [aux_sym_logical_operator_token1] = ACTIONS(1),
    [aux_sym_logical_operator_token2] = ACTIONS(1),
    [aux_sym_logical_operator_token3] = ACTIONS(1),
    [aux_sym_logical_operator_token4] = ACTIONS(1),
    [aux_sym_logical_operator_token5] = ACTIONS(1),
    [aux_sym_logical_operator_token6] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [aux_sym_unary_operator_token1] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [sym_symbol] = ACTIONS(1),
    [aux_sym_documentation_token1] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(1893),
    [sym_fragment] = STATE(19),
    [sym_package] = STATE(19),
    [sym__method_declaration] = STATE(1390),
    [sym_method] = STATE(1390),
    [sym_procedure] = STATE(996),
    [sym_block] = STATE(996),
    [sym_assignment] = STATE(996),
    [sym_if] = STATE(996),
    [sym_loop] = STATE(996),
    [sym_handling] = STATE(996),
    [sym_catch] = STATE(996),
    [sym_throw] = STATE(996),
    [sym_primitive] = STATE(996),
    [sym_iterator] = STATE(996),
    [sym_while] = STATE(996),
    [sym_try] = STATE(996),
    [sym_loopbody] = STATE(996),
    [sym_leave] = STATE(996),
    [sym_continue] = STATE(996),
    [sym_protect] = STATE(996),
    [sym_lock] = STATE(996),
    [sym_pragma] = STATE(247),
    [sym__literal] = STATE(996),
    [sym_character_literal] = STATE(996),
    [sym_string_literal] = STATE(996),
    [sym_call] = STATE(996),
    [sym_invoke] = STATE(996),
    [sym_indexed_access] = STATE(996),
    [sym_slot_accessor] = STATE(996),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_maybe] = STATE(996),
    [sym_unset] = STATE(996),
    [sym_super] = STATE(996),
    [sym_self] = STATE(996),
    [sym_clone] = STATE(996),
    [sym_thisthread] = STATE(996),
    [sym_class] = STATE(996),
    [sym__top_level_statement] = STATE(1390),
    [sym__expression] = STATE(996),
    [sym__global_assignment] = STATE(1390),
    [sym_return] = STATE(996),
    [sym__definition] = STATE(1390),
    [sym_gather] = STATE(996),
    [sym_scatter] = STATE(996),
    [sym_allresults] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym__variable] = STATE(996),
    [sym_variable] = STATE(996),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(996),
    [sym_relational_operator] = STATE(996),
    [sym_logical_operator] = STATE(996),
    [sym_arithmetic_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [aux_sym_source_file_repeat1] = STATE(19),
    [aux_sym_fragment_repeat1] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(5),
    [aux_sym_package_token1] = ACTIONS(7),
    [sym__dollar] = ACTIONS(9),
    [aux_sym_method_token1] = ACTIONS(11),
    [aux_sym_method_token2] = ACTIONS(13),
    [aux_sym_method_token3] = ACTIONS(15),
    [aux_sym_method_token4] = ACTIONS(17),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [aux_sym_pragma_token1] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(67),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(89),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_global_reference] = ACTIONS(67),
    [sym_number] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(67),
    [sym_comment] = ACTIONS(103),
  },
  [2] = {
    [sym_procedure] = STATE(584),
    [sym_block] = STATE(584),
    [sym_assignment] = STATE(584),
    [sym_if] = STATE(584),
    [sym_loop] = STATE(584),
    [sym_handling] = STATE(584),
    [sym_catch] = STATE(584),
    [sym_throw] = STATE(584),
    [sym_primitive] = STATE(584),
    [sym_iterator] = STATE(584),
    [sym_while] = STATE(584),
    [sym_try] = STATE(584),
    [sym_loopbody] = STATE(584),
    [sym_leave] = STATE(584),
    [sym_continue] = STATE(584),
    [sym_protect] = STATE(584),
    [sym_lock] = STATE(584),
    [sym__literal] = STATE(584),
    [sym_character_literal] = STATE(584),
    [sym_string_literal] = STATE(584),
    [sym_call] = STATE(584),
    [sym_invoke] = STATE(584),
    [sym_indexed_access] = STATE(584),
    [sym_slot_accessor] = STATE(584),
    [sym__expression_list] = STATE(550),
    [sym_true] = STATE(584),
    [sym_false] = STATE(584),
    [sym_maybe] = STATE(584),
    [sym_unset] = STATE(584),
    [sym_super] = STATE(584),
    [sym_self] = STATE(584),
    [sym_clone] = STATE(584),
    [sym_thisthread] = STATE(584),
    [sym_class] = STATE(584),
    [sym__expression] = STATE(584),
    [sym_return] = STATE(584),
    [sym_gather] = STATE(584),
    [sym_scatter] = STATE(584),
    [sym_allresults] = STATE(584),
    [sym_parenthesized_expression] = STATE(584),
    [sym__variable] = STATE(584),
    [sym_variable] = STATE(584),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(584),
    [sym_relational_operator] = STATE(584),
    [sym_logical_operator] = STATE(584),
    [sym_arithmetic_operator] = STATE(584),
    [sym_unary_operator] = STATE(584),
    [anon_sym_CR] = ACTIONS(105),
    [anon_sym_LF] = ACTIONS(105),
    [aux_sym_method_token3] = ACTIONS(107),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(105),
    [aux_sym_method_token6] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(105),
    [anon_sym_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(105),
    [aux_sym_method_token7] = ACTIONS(105),
    [aux_sym_procedure_token1] = ACTIONS(115),
    [aux_sym_procedure_token2] = ACTIONS(105),
    [aux_sym_block_token1] = ACTIONS(117),
    [aux_sym_block_token2] = ACTIONS(105),
    [anon_sym__and_LT_LT] = ACTIONS(105),
    [anon_sym__andif_LT_LT] = ACTIONS(105),
    [anon_sym__or_LT_LT] = ACTIONS(105),
    [anon_sym__orif_LT_LT] = ACTIONS(105),
    [anon_sym__xor_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym__mod_LT_LT] = ACTIONS(105),
    [anon_sym__div_LT_LT] = ACTIONS(105),
    [anon_sym_DASH_LT_LT] = ACTIONS(105),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_PLUS_LT_LT] = ACTIONS(105),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(105),
    [aux_sym_if_token1] = ACTIONS(119),
    [aux_sym_if_token3] = ACTIONS(105),
    [aux_sym_elif_token1] = ACTIONS(105),
    [aux_sym_else_token1] = ACTIONS(105),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(105),
    [aux_sym_finally_token1] = ACTIONS(105),
    [aux_sym_finally_token2] = ACTIONS(105),
    [aux_sym_handling_token1] = ACTIONS(121),
    [aux_sym_catch_token1] = ACTIONS(123),
    [aux_sym_catch_token2] = ACTIONS(105),
    [aux_sym_throw_token1] = ACTIONS(125),
    [aux_sym_primitive_token1] = ACTIONS(127),
    [aux_sym_iterator_token1] = ACTIONS(129),
    [aux_sym_iterator_token2] = ACTIONS(131),
    [aux_sym_while_token1] = ACTIONS(133),
    [aux_sym_try_token1] = ACTIONS(135),
    [aux_sym_try_token2] = ACTIONS(105),
    [aux_sym_try_token3] = ACTIONS(105),
    [aux_sym_loopbody_token1] = ACTIONS(137),
    [aux_sym_leave_token1] = ACTIONS(139),
    [aux_sym_continue_token1] = ACTIONS(141),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token4] = ACTIONS(105),
    [aux_sym_lock_token1] = ACTIONS(145),
    [aux_sym_lock_token2] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [sym_regex_literal] = ACTIONS(153),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(155),
    [aux_sym_false_token1] = ACTIONS(157),
    [aux_sym_maybe_token1] = ACTIONS(159),
    [aux_sym_unset_token1] = ACTIONS(161),
    [aux_sym_super_token1] = ACTIONS(163),
    [aux_sym_self_token1] = ACTIONS(165),
    [aux_sym_clone_token1] = ACTIONS(167),
    [aux_sym_thisthread_token1] = ACTIONS(169),
    [aux_sym_class_token1] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(105),
    [aux_sym_return_token1] = ACTIONS(173),
    [anon_sym_GT_GT] = ACTIONS(175),
    [aux_sym_scatter_token1] = ACTIONS(177),
    [aux_sym_allresults_token1] = ACTIONS(179),
    [sym_dynamic_variable] = ACTIONS(153),
    [sym_global_variable] = ACTIONS(153),
    [sym_global_reference] = ACTIONS(153),
    [sym_number] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(181),
    [aux_sym_relational_operator_token1] = ACTIONS(105),
    [aux_sym_relational_operator_token2] = ACTIONS(105),
    [aux_sym_relational_operator_token3] = ACTIONS(105),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_TILDE_EQ] = ACTIONS(105),
    [anon_sym_LT_GT] = ACTIONS(105),
    [anon_sym_GT_EQ] = ACTIONS(105),
    [anon_sym_LT_EQ] = ACTIONS(105),
    [anon_sym_LT] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(105),
    [aux_sym_logical_operator_token1] = ACTIONS(105),
    [aux_sym_logical_operator_token2] = ACTIONS(105),
    [aux_sym_logical_operator_token3] = ACTIONS(105),
    [aux_sym_logical_operator_token4] = ACTIONS(105),
    [aux_sym_logical_operator_token5] = ACTIONS(105),
    [aux_sym_logical_operator_token6] = ACTIONS(105),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_STAR] = ACTIONS(105),
    [anon_sym_SLASH] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(183),
    [aux_sym_unary_operator_token1] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(183),
    [sym_symbol] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
  },
  [3] = {
    [sym_procedure] = STATE(584),
    [sym_block] = STATE(584),
    [sym_assignment] = STATE(584),
    [sym_if] = STATE(584),
    [sym_loop] = STATE(584),
    [sym_handling] = STATE(584),
    [sym_catch] = STATE(584),
    [sym_throw] = STATE(584),
    [sym_primitive] = STATE(584),
    [sym_iterator] = STATE(584),
    [sym_while] = STATE(584),
    [sym_try] = STATE(584),
    [sym_loopbody] = STATE(584),
    [sym_leave] = STATE(584),
    [sym_continue] = STATE(584),
    [sym_protect] = STATE(584),
    [sym_lock] = STATE(584),
    [sym__literal] = STATE(584),
    [sym_character_literal] = STATE(584),
    [sym_string_literal] = STATE(584),
    [sym_call] = STATE(584),
    [sym_invoke] = STATE(584),
    [sym_indexed_access] = STATE(584),
    [sym_slot_accessor] = STATE(584),
    [sym__expression_list] = STATE(534),
    [sym_true] = STATE(584),
    [sym_false] = STATE(584),
    [sym_maybe] = STATE(584),
    [sym_unset] = STATE(584),
    [sym_super] = STATE(584),
    [sym_self] = STATE(584),
    [sym_clone] = STATE(584),
    [sym_thisthread] = STATE(584),
    [sym_class] = STATE(584),
    [sym__expression] = STATE(584),
    [sym_return] = STATE(584),
    [sym_gather] = STATE(584),
    [sym_scatter] = STATE(584),
    [sym_allresults] = STATE(584),
    [sym_parenthesized_expression] = STATE(584),
    [sym__variable] = STATE(584),
    [sym_variable] = STATE(584),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(584),
    [sym_relational_operator] = STATE(584),
    [sym_logical_operator] = STATE(584),
    [sym_arithmetic_operator] = STATE(584),
    [sym_unary_operator] = STATE(584),
    [anon_sym_CR] = ACTIONS(185),
    [anon_sym_LF] = ACTIONS(185),
    [aux_sym_method_token3] = ACTIONS(107),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(185),
    [aux_sym_method_token6] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(185),
    [anon_sym_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(185),
    [aux_sym_method_token7] = ACTIONS(185),
    [aux_sym_procedure_token1] = ACTIONS(115),
    [aux_sym_procedure_token2] = ACTIONS(185),
    [aux_sym_block_token1] = ACTIONS(117),
    [aux_sym_block_token2] = ACTIONS(185),
    [anon_sym__and_LT_LT] = ACTIONS(185),
    [anon_sym__andif_LT_LT] = ACTIONS(185),
    [anon_sym__or_LT_LT] = ACTIONS(185),
    [anon_sym__orif_LT_LT] = ACTIONS(185),
    [anon_sym__xor_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym__mod_LT_LT] = ACTIONS(185),
    [anon_sym__div_LT_LT] = ACTIONS(185),
    [anon_sym_DASH_LT_LT] = ACTIONS(185),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_PLUS_LT_LT] = ACTIONS(185),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(185),
    [aux_sym_if_token1] = ACTIONS(119),
    [aux_sym_if_token3] = ACTIONS(185),
    [aux_sym_elif_token1] = ACTIONS(185),
    [aux_sym_else_token1] = ACTIONS(185),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(185),
    [aux_sym_finally_token1] = ACTIONS(185),
    [aux_sym_finally_token2] = ACTIONS(185),
    [aux_sym_handling_token1] = ACTIONS(121),
    [aux_sym_catch_token1] = ACTIONS(123),
    [aux_sym_catch_token2] = ACTIONS(185),
    [aux_sym_throw_token1] = ACTIONS(125),
    [aux_sym_primitive_token1] = ACTIONS(127),
    [aux_sym_iterator_token1] = ACTIONS(129),
    [aux_sym_iterator_token2] = ACTIONS(131),
    [aux_sym_while_token1] = ACTIONS(133),
    [aux_sym_try_token1] = ACTIONS(135),
    [aux_sym_try_token2] = ACTIONS(185),
    [aux_sym_try_token3] = ACTIONS(185),
    [aux_sym_loopbody_token1] = ACTIONS(137),
    [aux_sym_leave_token1] = ACTIONS(139),
    [aux_sym_continue_token1] = ACTIONS(141),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token4] = ACTIONS(185),
    [aux_sym_lock_token1] = ACTIONS(145),
    [aux_sym_lock_token2] = ACTIONS(185),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [sym_regex_literal] = ACTIONS(153),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(155),
    [aux_sym_false_token1] = ACTIONS(157),
    [aux_sym_maybe_token1] = ACTIONS(159),
    [aux_sym_unset_token1] = ACTIONS(161),
    [aux_sym_super_token1] = ACTIONS(163),
    [aux_sym_self_token1] = ACTIONS(165),
    [aux_sym_clone_token1] = ACTIONS(167),
    [aux_sym_thisthread_token1] = ACTIONS(169),
    [aux_sym_class_token1] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(185),
    [aux_sym_return_token1] = ACTIONS(173),
    [anon_sym_GT_GT] = ACTIONS(175),
    [aux_sym_scatter_token1] = ACTIONS(177),
    [aux_sym_allresults_token1] = ACTIONS(179),
    [sym_dynamic_variable] = ACTIONS(153),
    [sym_global_variable] = ACTIONS(153),
    [sym_global_reference] = ACTIONS(153),
    [sym_number] = ACTIONS(153),
    [anon_sym_LBRACE] = ACTIONS(181),
    [aux_sym_relational_operator_token1] = ACTIONS(185),
    [aux_sym_relational_operator_token2] = ACTIONS(185),
    [aux_sym_relational_operator_token3] = ACTIONS(185),
    [anon_sym_EQ] = ACTIONS(185),
    [anon_sym_TILDE_EQ] = ACTIONS(185),
    [anon_sym_LT_GT] = ACTIONS(185),
    [anon_sym_GT_EQ] = ACTIONS(185),
    [anon_sym_LT_EQ] = ACTIONS(185),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [aux_sym_logical_operator_token1] = ACTIONS(185),
    [aux_sym_logical_operator_token2] = ACTIONS(185),
    [aux_sym_logical_operator_token3] = ACTIONS(185),
    [aux_sym_logical_operator_token4] = ACTIONS(185),
    [aux_sym_logical_operator_token5] = ACTIONS(185),
    [aux_sym_logical_operator_token6] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_PLUS] = ACTIONS(183),
    [aux_sym_unary_operator_token1] = ACTIONS(183),
    [anon_sym_TILDE] = ACTIONS(183),
    [sym_symbol] = ACTIONS(153),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym_procedure] = STATE(621),
    [sym_block] = STATE(621),
    [sym_assignment] = STATE(621),
    [sym_if] = STATE(621),
    [sym_loop] = STATE(621),
    [sym_handling] = STATE(621),
    [sym_catch] = STATE(621),
    [sym_throw] = STATE(621),
    [sym_primitive] = STATE(621),
    [sym_iterator] = STATE(621),
    [sym_while] = STATE(621),
    [sym_try] = STATE(621),
    [sym_loopbody] = STATE(621),
    [sym_leave] = STATE(621),
    [sym_continue] = STATE(621),
    [sym_protect] = STATE(621),
    [sym_lock] = STATE(621),
    [sym__literal] = STATE(621),
    [sym_character_literal] = STATE(621),
    [sym_string_literal] = STATE(621),
    [sym_call] = STATE(621),
    [sym_invoke] = STATE(621),
    [sym_indexed_access] = STATE(621),
    [sym_slot_accessor] = STATE(621),
    [sym__expression_list] = STATE(550),
    [sym_true] = STATE(621),
    [sym_false] = STATE(621),
    [sym_maybe] = STATE(621),
    [sym_unset] = STATE(621),
    [sym_super] = STATE(621),
    [sym_self] = STATE(621),
    [sym_clone] = STATE(621),
    [sym_thisthread] = STATE(621),
    [sym_class] = STATE(621),
    [sym__expression] = STATE(621),
    [sym_return] = STATE(621),
    [sym_gather] = STATE(621),
    [sym_scatter] = STATE(621),
    [sym_allresults] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym__variable] = STATE(621),
    [sym_variable] = STATE(621),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(621),
    [sym_relational_operator] = STATE(621),
    [sym_logical_operator] = STATE(621),
    [sym_arithmetic_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [anon_sym_CR] = ACTIONS(105),
    [anon_sym_LF] = ACTIONS(105),
    [aux_sym_method_token3] = ACTIONS(107),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(105),
    [aux_sym_method_token6] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(105),
    [anon_sym_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(105),
    [aux_sym_method_token7] = ACTIONS(105),
    [aux_sym_procedure_token1] = ACTIONS(115),
    [aux_sym_procedure_token2] = ACTIONS(105),
    [aux_sym_block_token1] = ACTIONS(117),
    [aux_sym_block_token2] = ACTIONS(105),
    [anon_sym__and_LT_LT] = ACTIONS(105),
    [anon_sym__andif_LT_LT] = ACTIONS(105),
    [anon_sym__or_LT_LT] = ACTIONS(105),
    [anon_sym__orif_LT_LT] = ACTIONS(105),
    [anon_sym__xor_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym__mod_LT_LT] = ACTIONS(105),
    [anon_sym__div_LT_LT] = ACTIONS(105),
    [anon_sym_DASH_LT_LT] = ACTIONS(105),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_PLUS_LT_LT] = ACTIONS(105),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(105),
    [aux_sym_if_token1] = ACTIONS(119),
    [aux_sym_if_token3] = ACTIONS(105),
    [aux_sym_elif_token1] = ACTIONS(105),
    [aux_sym_else_token1] = ACTIONS(105),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(105),
    [aux_sym_finally_token1] = ACTIONS(105),
    [aux_sym_handling_token1] = ACTIONS(189),
    [aux_sym_catch_token1] = ACTIONS(123),
    [aux_sym_catch_token2] = ACTIONS(105),
    [aux_sym_throw_token1] = ACTIONS(191),
    [aux_sym_primitive_token1] = ACTIONS(127),
    [aux_sym_iterator_token1] = ACTIONS(129),
    [aux_sym_iterator_token2] = ACTIONS(131),
    [aux_sym_while_token1] = ACTIONS(133),
    [aux_sym_try_token1] = ACTIONS(135),
    [aux_sym_try_token2] = ACTIONS(105),
    [aux_sym_try_token3] = ACTIONS(105),
    [aux_sym_loopbody_token1] = ACTIONS(137),
    [aux_sym_leave_token1] = ACTIONS(193),
    [aux_sym_continue_token1] = ACTIONS(195),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token4] = ACTIONS(105),
    [aux_sym_lock_token1] = ACTIONS(145),
    [aux_sym_lock_token2] = ACTIONS(105),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [sym_regex_literal] = ACTIONS(197),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(155),
    [aux_sym_false_token1] = ACTIONS(157),
    [aux_sym_maybe_token1] = ACTIONS(159),
    [aux_sym_unset_token1] = ACTIONS(161),
    [aux_sym_super_token1] = ACTIONS(163),
    [aux_sym_self_token1] = ACTIONS(165),
    [aux_sym_clone_token1] = ACTIONS(167),
    [aux_sym_thisthread_token1] = ACTIONS(169),
    [aux_sym_class_token1] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(105),
    [aux_sym_return_token1] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(201),
    [aux_sym_scatter_token1] = ACTIONS(203),
    [aux_sym_allresults_token1] = ACTIONS(205),
    [sym_dynamic_variable] = ACTIONS(197),
    [sym_global_variable] = ACTIONS(197),
    [sym_global_reference] = ACTIONS(197),
    [sym_number] = ACTIONS(197),
    [anon_sym_LBRACE] = ACTIONS(181),
    [aux_sym_relational_operator_token1] = ACTIONS(105),
    [aux_sym_relational_operator_token2] = ACTIONS(105),
    [aux_sym_relational_operator_token3] = ACTIONS(105),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_TILDE_EQ] = ACTIONS(105),
    [anon_sym_LT_GT] = ACTIONS(105),
    [anon_sym_GT_EQ] = ACTIONS(105),
    [anon_sym_LT_EQ] = ACTIONS(105),
    [anon_sym_LT] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(105),
    [aux_sym_logical_operator_token1] = ACTIONS(105),
    [aux_sym_logical_operator_token2] = ACTIONS(105),
    [aux_sym_logical_operator_token3] = ACTIONS(105),
    [aux_sym_logical_operator_token4] = ACTIONS(105),
    [aux_sym_logical_operator_token5] = ACTIONS(105),
    [aux_sym_logical_operator_token6] = ACTIONS(105),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_STAR] = ACTIONS(105),
    [anon_sym_SLASH] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(207),
    [aux_sym_unary_operator_token1] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_symbol] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym_procedure] = STATE(621),
    [sym_block] = STATE(621),
    [sym_assignment] = STATE(621),
    [sym_if] = STATE(621),
    [sym_loop] = STATE(621),
    [sym_handling] = STATE(621),
    [sym_catch] = STATE(621),
    [sym_throw] = STATE(621),
    [sym_primitive] = STATE(621),
    [sym_iterator] = STATE(621),
    [sym_while] = STATE(621),
    [sym_try] = STATE(621),
    [sym_loopbody] = STATE(621),
    [sym_leave] = STATE(621),
    [sym_continue] = STATE(621),
    [sym_protect] = STATE(621),
    [sym_lock] = STATE(621),
    [sym__literal] = STATE(621),
    [sym_character_literal] = STATE(621),
    [sym_string_literal] = STATE(621),
    [sym_call] = STATE(621),
    [sym_invoke] = STATE(621),
    [sym_indexed_access] = STATE(621),
    [sym_slot_accessor] = STATE(621),
    [sym__expression_list] = STATE(534),
    [sym_true] = STATE(621),
    [sym_false] = STATE(621),
    [sym_maybe] = STATE(621),
    [sym_unset] = STATE(621),
    [sym_super] = STATE(621),
    [sym_self] = STATE(621),
    [sym_clone] = STATE(621),
    [sym_thisthread] = STATE(621),
    [sym_class] = STATE(621),
    [sym__expression] = STATE(621),
    [sym_return] = STATE(621),
    [sym_gather] = STATE(621),
    [sym_scatter] = STATE(621),
    [sym_allresults] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym__variable] = STATE(621),
    [sym_variable] = STATE(621),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(621),
    [sym_relational_operator] = STATE(621),
    [sym_logical_operator] = STATE(621),
    [sym_arithmetic_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [anon_sym_CR] = ACTIONS(185),
    [anon_sym_LF] = ACTIONS(185),
    [aux_sym_method_token3] = ACTIONS(107),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(185),
    [aux_sym_method_token6] = ACTIONS(187),
    [anon_sym_LT_LT] = ACTIONS(185),
    [anon_sym_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(185),
    [aux_sym_method_token7] = ACTIONS(185),
    [aux_sym_procedure_token1] = ACTIONS(115),
    [aux_sym_procedure_token2] = ACTIONS(185),
    [aux_sym_block_token1] = ACTIONS(117),
    [aux_sym_block_token2] = ACTIONS(185),
    [anon_sym__and_LT_LT] = ACTIONS(185),
    [anon_sym__andif_LT_LT] = ACTIONS(185),
    [anon_sym__or_LT_LT] = ACTIONS(185),
    [anon_sym__orif_LT_LT] = ACTIONS(185),
    [anon_sym__xor_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym__mod_LT_LT] = ACTIONS(185),
    [anon_sym__div_LT_LT] = ACTIONS(185),
    [anon_sym_DASH_LT_LT] = ACTIONS(185),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_PLUS_LT_LT] = ACTIONS(185),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(185),
    [aux_sym_if_token1] = ACTIONS(119),
    [aux_sym_if_token3] = ACTIONS(185),
    [aux_sym_elif_token1] = ACTIONS(185),
    [aux_sym_else_token1] = ACTIONS(185),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(185),
    [aux_sym_finally_token1] = ACTIONS(185),
    [aux_sym_handling_token1] = ACTIONS(189),
    [aux_sym_catch_token1] = ACTIONS(123),
    [aux_sym_catch_token2] = ACTIONS(185),
    [aux_sym_throw_token1] = ACTIONS(191),
    [aux_sym_primitive_token1] = ACTIONS(127),
    [aux_sym_iterator_token1] = ACTIONS(129),
    [aux_sym_iterator_token2] = ACTIONS(131),
    [aux_sym_while_token1] = ACTIONS(133),
    [aux_sym_try_token1] = ACTIONS(135),
    [aux_sym_try_token2] = ACTIONS(185),
    [aux_sym_try_token3] = ACTIONS(185),
    [aux_sym_loopbody_token1] = ACTIONS(137),
    [aux_sym_leave_token1] = ACTIONS(193),
    [aux_sym_continue_token1] = ACTIONS(195),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token4] = ACTIONS(185),
    [aux_sym_lock_token1] = ACTIONS(145),
    [aux_sym_lock_token2] = ACTIONS(185),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [sym_regex_literal] = ACTIONS(197),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(155),
    [aux_sym_false_token1] = ACTIONS(157),
    [aux_sym_maybe_token1] = ACTIONS(159),
    [aux_sym_unset_token1] = ACTIONS(161),
    [aux_sym_super_token1] = ACTIONS(163),
    [aux_sym_self_token1] = ACTIONS(165),
    [aux_sym_clone_token1] = ACTIONS(167),
    [aux_sym_thisthread_token1] = ACTIONS(169),
    [aux_sym_class_token1] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(185),
    [aux_sym_return_token1] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(201),
    [aux_sym_scatter_token1] = ACTIONS(203),
    [aux_sym_allresults_token1] = ACTIONS(205),
    [sym_dynamic_variable] = ACTIONS(197),
    [sym_global_variable] = ACTIONS(197),
    [sym_global_reference] = ACTIONS(197),
    [sym_number] = ACTIONS(197),
    [anon_sym_LBRACE] = ACTIONS(181),
    [aux_sym_relational_operator_token1] = ACTIONS(185),
    [aux_sym_relational_operator_token2] = ACTIONS(185),
    [aux_sym_relational_operator_token3] = ACTIONS(185),
    [anon_sym_EQ] = ACTIONS(185),
    [anon_sym_TILDE_EQ] = ACTIONS(185),
    [anon_sym_LT_GT] = ACTIONS(185),
    [anon_sym_GT_EQ] = ACTIONS(185),
    [anon_sym_LT_EQ] = ACTIONS(185),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [aux_sym_logical_operator_token1] = ACTIONS(185),
    [aux_sym_logical_operator_token2] = ACTIONS(185),
    [aux_sym_logical_operator_token3] = ACTIONS(185),
    [aux_sym_logical_operator_token4] = ACTIONS(185),
    [aux_sym_logical_operator_token5] = ACTIONS(185),
    [aux_sym_logical_operator_token6] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(207),
    [anon_sym_PLUS] = ACTIONS(207),
    [aux_sym_unary_operator_token1] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_symbol] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
  },
  [6] = {
    [sym_procedure] = STATE(697),
    [sym_block] = STATE(697),
    [sym_assignment] = STATE(697),
    [sym_if] = STATE(697),
    [sym_loop] = STATE(697),
    [sym_handling] = STATE(697),
    [sym_catch] = STATE(697),
    [sym_throw] = STATE(697),
    [sym_primitive] = STATE(697),
    [sym_iterator] = STATE(697),
    [sym_while] = STATE(697),
    [sym_try] = STATE(697),
    [sym_loopbody] = STATE(697),
    [sym_leave] = STATE(697),
    [sym_continue] = STATE(697),
    [sym_protect] = STATE(697),
    [sym_lock] = STATE(697),
    [sym__literal] = STATE(697),
    [sym_character_literal] = STATE(697),
    [sym_string_literal] = STATE(697),
    [sym_call] = STATE(697),
    [sym_invoke] = STATE(697),
    [sym_indexed_access] = STATE(697),
    [sym_slot_accessor] = STATE(697),
    [sym__expression_list] = STATE(824),
    [sym_true] = STATE(697),
    [sym_false] = STATE(697),
    [sym_maybe] = STATE(697),
    [sym_unset] = STATE(697),
    [sym_super] = STATE(697),
    [sym_self] = STATE(697),
    [sym_clone] = STATE(697),
    [sym_thisthread] = STATE(697),
    [sym_class] = STATE(697),
    [sym__expression] = STATE(697),
    [sym_return] = STATE(697),
    [sym_gather] = STATE(697),
    [sym_scatter] = STATE(697),
    [sym_allresults] = STATE(697),
    [sym_parenthesized_expression] = STATE(697),
    [sym__variable] = STATE(697),
    [sym_variable] = STATE(697),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(697),
    [sym_relational_operator] = STATE(697),
    [sym_logical_operator] = STATE(697),
    [sym_arithmetic_operator] = STATE(697),
    [sym_unary_operator] = STATE(697),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(215),
    [aux_sym_method_token6] = ACTIONS(217),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_LT_LT] = ACTIONS(215),
    [anon_sym_CARET_LT_LT] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(215),
    [anon_sym_RBRACK] = ACTIONS(215),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [anon_sym__and_LT_LT] = ACTIONS(215),
    [anon_sym__andif_LT_LT] = ACTIONS(215),
    [anon_sym__or_LT_LT] = ACTIONS(215),
    [anon_sym__orif_LT_LT] = ACTIONS(215),
    [anon_sym__xor_LT_LT] = ACTIONS(215),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(215),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(215),
    [anon_sym_STAR_LT_LT] = ACTIONS(215),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(215),
    [anon_sym_SLASH_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym__mod_LT_LT] = ACTIONS(215),
    [anon_sym__div_LT_LT] = ACTIONS(215),
    [anon_sym_DASH_LT_LT] = ACTIONS(215),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(215),
    [anon_sym_PLUS_LT_LT] = ACTIONS(215),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(215),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_if_token2] = ACTIONS(215),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_finally_token2] = ACTIONS(215),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(259),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(259),
    [sym_global_reference] = ACTIONS(259),
    [sym_number] = ACTIONS(259),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_RBRACE] = ACTIONS(215),
    [aux_sym_relational_operator_token1] = ACTIONS(185),
    [aux_sym_relational_operator_token2] = ACTIONS(215),
    [aux_sym_relational_operator_token3] = ACTIONS(215),
    [anon_sym_EQ] = ACTIONS(215),
    [anon_sym_TILDE_EQ] = ACTIONS(215),
    [anon_sym_LT_GT] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(215),
    [anon_sym_LT_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [aux_sym_logical_operator_token1] = ACTIONS(185),
    [aux_sym_logical_operator_token2] = ACTIONS(185),
    [aux_sym_logical_operator_token3] = ACTIONS(185),
    [aux_sym_logical_operator_token4] = ACTIONS(185),
    [aux_sym_logical_operator_token5] = ACTIONS(185),
    [aux_sym_logical_operator_token6] = ACTIONS(215),
    [anon_sym_STAR_STAR] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(291),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_symbol] = ACTIONS(259),
    [sym_comment] = ACTIONS(103),
  },
  [7] = {
    [sym_procedure] = STATE(779),
    [sym_block] = STATE(779),
    [sym_assignment] = STATE(779),
    [sym_if] = STATE(779),
    [sym_loop] = STATE(779),
    [sym_handling] = STATE(779),
    [sym_catch] = STATE(779),
    [sym_throw] = STATE(779),
    [sym_primitive] = STATE(779),
    [sym_iterator] = STATE(779),
    [sym_while] = STATE(779),
    [sym_try] = STATE(779),
    [sym_loopbody] = STATE(779),
    [sym_leave] = STATE(779),
    [sym_continue] = STATE(779),
    [sym_protect] = STATE(779),
    [sym_lock] = STATE(779),
    [sym__literal] = STATE(779),
    [sym_character_literal] = STATE(779),
    [sym_string_literal] = STATE(779),
    [sym_call] = STATE(779),
    [sym_invoke] = STATE(779),
    [sym_indexed_access] = STATE(779),
    [sym_slot_accessor] = STATE(779),
    [sym__expression_list] = STATE(534),
    [sym_true] = STATE(779),
    [sym_false] = STATE(779),
    [sym_maybe] = STATE(779),
    [sym_unset] = STATE(779),
    [sym_super] = STATE(779),
    [sym_self] = STATE(779),
    [sym_clone] = STATE(779),
    [sym_thisthread] = STATE(779),
    [sym_class] = STATE(779),
    [sym__expression] = STATE(779),
    [sym_return] = STATE(779),
    [sym_gather] = STATE(779),
    [sym_scatter] = STATE(779),
    [sym_allresults] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym__variable] = STATE(779),
    [sym_variable] = STATE(779),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(779),
    [sym_relational_operator] = STATE(779),
    [sym_logical_operator] = STATE(779),
    [sym_arithmetic_operator] = STATE(779),
    [sym_unary_operator] = STATE(779),
    [anon_sym_CR] = ACTIONS(185),
    [anon_sym_LF] = ACTIONS(185),
    [aux_sym_method_token3] = ACTIONS(107),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(185),
    [aux_sym_method_token6] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(185),
    [anon_sym_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(185),
    [aux_sym_procedure_token1] = ACTIONS(115),
    [aux_sym_block_token1] = ACTIONS(117),
    [anon_sym__and_LT_LT] = ACTIONS(185),
    [anon_sym__andif_LT_LT] = ACTIONS(185),
    [anon_sym__or_LT_LT] = ACTIONS(185),
    [anon_sym__orif_LT_LT] = ACTIONS(185),
    [anon_sym__xor_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym__mod_LT_LT] = ACTIONS(185),
    [anon_sym__div_LT_LT] = ACTIONS(185),
    [anon_sym_DASH_LT_LT] = ACTIONS(185),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_PLUS_LT_LT] = ACTIONS(185),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(185),
    [aux_sym_if_token1] = ACTIONS(119),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_finally_token2] = ACTIONS(185),
    [aux_sym_handling_token1] = ACTIONS(297),
    [aux_sym_catch_token1] = ACTIONS(123),
    [aux_sym_throw_token1] = ACTIONS(299),
    [aux_sym_primitive_token1] = ACTIONS(127),
    [aux_sym_iterator_token1] = ACTIONS(129),
    [aux_sym_iterator_token2] = ACTIONS(131),
    [aux_sym_while_token1] = ACTIONS(133),
    [aux_sym_try_token1] = ACTIONS(135),
    [aux_sym_loopbody_token1] = ACTIONS(137),
    [aux_sym_leave_token1] = ACTIONS(139),
    [aux_sym_continue_token1] = ACTIONS(141),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token3] = ACTIONS(185),
    [aux_sym_lock_token1] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [sym_regex_literal] = ACTIONS(301),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(155),
    [aux_sym_false_token1] = ACTIONS(157),
    [aux_sym_maybe_token1] = ACTIONS(159),
    [aux_sym_unset_token1] = ACTIONS(161),
    [aux_sym_super_token1] = ACTIONS(163),
    [aux_sym_self_token1] = ACTIONS(165),
    [aux_sym_clone_token1] = ACTIONS(167),
    [aux_sym_thisthread_token1] = ACTIONS(169),
    [aux_sym_class_token1] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(185),
    [aux_sym_return_token1] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(305),
    [aux_sym_scatter_token1] = ACTIONS(307),
    [aux_sym_allresults_token1] = ACTIONS(309),
    [sym_dynamic_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_global_reference] = ACTIONS(301),
    [sym_number] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(181),
    [aux_sym_relational_operator_token1] = ACTIONS(185),
    [aux_sym_relational_operator_token2] = ACTIONS(185),
    [aux_sym_relational_operator_token3] = ACTIONS(185),
    [anon_sym_EQ] = ACTIONS(185),
    [anon_sym_TILDE_EQ] = ACTIONS(185),
    [anon_sym_LT_GT] = ACTIONS(185),
    [anon_sym_GT_EQ] = ACTIONS(185),
    [anon_sym_LT_EQ] = ACTIONS(185),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [aux_sym_logical_operator_token1] = ACTIONS(185),
    [aux_sym_logical_operator_token2] = ACTIONS(185),
    [aux_sym_logical_operator_token3] = ACTIONS(185),
    [aux_sym_logical_operator_token4] = ACTIONS(185),
    [aux_sym_logical_operator_token5] = ACTIONS(185),
    [aux_sym_logical_operator_token6] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_PLUS] = ACTIONS(311),
    [aux_sym_unary_operator_token1] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(311),
    [sym_symbol] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
  },
  [8] = {
    [sym_procedure] = STATE(779),
    [sym_block] = STATE(779),
    [sym_assignment] = STATE(779),
    [sym_if] = STATE(779),
    [sym_loop] = STATE(779),
    [sym_handling] = STATE(779),
    [sym_catch] = STATE(779),
    [sym_throw] = STATE(779),
    [sym_primitive] = STATE(779),
    [sym_iterator] = STATE(779),
    [sym_while] = STATE(779),
    [sym_try] = STATE(779),
    [sym_loopbody] = STATE(779),
    [sym_leave] = STATE(779),
    [sym_continue] = STATE(779),
    [sym_protect] = STATE(779),
    [sym_lock] = STATE(779),
    [sym__literal] = STATE(779),
    [sym_character_literal] = STATE(779),
    [sym_string_literal] = STATE(779),
    [sym_call] = STATE(779),
    [sym_invoke] = STATE(779),
    [sym_indexed_access] = STATE(779),
    [sym_slot_accessor] = STATE(779),
    [sym__expression_list] = STATE(550),
    [sym_true] = STATE(779),
    [sym_false] = STATE(779),
    [sym_maybe] = STATE(779),
    [sym_unset] = STATE(779),
    [sym_super] = STATE(779),
    [sym_self] = STATE(779),
    [sym_clone] = STATE(779),
    [sym_thisthread] = STATE(779),
    [sym_class] = STATE(779),
    [sym__expression] = STATE(779),
    [sym_return] = STATE(779),
    [sym_gather] = STATE(779),
    [sym_scatter] = STATE(779),
    [sym_allresults] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym__variable] = STATE(779),
    [sym_variable] = STATE(779),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(779),
    [sym_relational_operator] = STATE(779),
    [sym_logical_operator] = STATE(779),
    [sym_arithmetic_operator] = STATE(779),
    [sym_unary_operator] = STATE(779),
    [anon_sym_CR] = ACTIONS(105),
    [anon_sym_LF] = ACTIONS(105),
    [aux_sym_method_token3] = ACTIONS(107),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(105),
    [aux_sym_method_token6] = ACTIONS(295),
    [anon_sym_LT_LT] = ACTIONS(105),
    [anon_sym_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(105),
    [aux_sym_procedure_token1] = ACTIONS(115),
    [aux_sym_block_token1] = ACTIONS(117),
    [anon_sym__and_LT_LT] = ACTIONS(105),
    [anon_sym__andif_LT_LT] = ACTIONS(105),
    [anon_sym__or_LT_LT] = ACTIONS(105),
    [anon_sym__orif_LT_LT] = ACTIONS(105),
    [anon_sym__xor_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym__mod_LT_LT] = ACTIONS(105),
    [anon_sym__div_LT_LT] = ACTIONS(105),
    [anon_sym_DASH_LT_LT] = ACTIONS(105),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_PLUS_LT_LT] = ACTIONS(105),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(105),
    [aux_sym_if_token1] = ACTIONS(119),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_finally_token2] = ACTIONS(105),
    [aux_sym_handling_token1] = ACTIONS(297),
    [aux_sym_catch_token1] = ACTIONS(123),
    [aux_sym_throw_token1] = ACTIONS(299),
    [aux_sym_primitive_token1] = ACTIONS(127),
    [aux_sym_iterator_token1] = ACTIONS(129),
    [aux_sym_iterator_token2] = ACTIONS(131),
    [aux_sym_while_token1] = ACTIONS(133),
    [aux_sym_try_token1] = ACTIONS(135),
    [aux_sym_loopbody_token1] = ACTIONS(137),
    [aux_sym_leave_token1] = ACTIONS(139),
    [aux_sym_continue_token1] = ACTIONS(141),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token3] = ACTIONS(105),
    [aux_sym_lock_token1] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [sym_regex_literal] = ACTIONS(301),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(155),
    [aux_sym_false_token1] = ACTIONS(157),
    [aux_sym_maybe_token1] = ACTIONS(159),
    [aux_sym_unset_token1] = ACTIONS(161),
    [aux_sym_super_token1] = ACTIONS(163),
    [aux_sym_self_token1] = ACTIONS(165),
    [aux_sym_clone_token1] = ACTIONS(167),
    [aux_sym_thisthread_token1] = ACTIONS(169),
    [aux_sym_class_token1] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(105),
    [aux_sym_return_token1] = ACTIONS(303),
    [anon_sym_GT_GT] = ACTIONS(305),
    [aux_sym_scatter_token1] = ACTIONS(307),
    [aux_sym_allresults_token1] = ACTIONS(309),
    [sym_dynamic_variable] = ACTIONS(301),
    [sym_global_variable] = ACTIONS(301),
    [sym_global_reference] = ACTIONS(301),
    [sym_number] = ACTIONS(301),
    [anon_sym_LBRACE] = ACTIONS(181),
    [aux_sym_relational_operator_token1] = ACTIONS(105),
    [aux_sym_relational_operator_token2] = ACTIONS(105),
    [aux_sym_relational_operator_token3] = ACTIONS(105),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_TILDE_EQ] = ACTIONS(105),
    [anon_sym_LT_GT] = ACTIONS(105),
    [anon_sym_GT_EQ] = ACTIONS(105),
    [anon_sym_LT_EQ] = ACTIONS(105),
    [anon_sym_LT] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(105),
    [aux_sym_logical_operator_token1] = ACTIONS(105),
    [aux_sym_logical_operator_token2] = ACTIONS(105),
    [aux_sym_logical_operator_token3] = ACTIONS(105),
    [aux_sym_logical_operator_token4] = ACTIONS(105),
    [aux_sym_logical_operator_token5] = ACTIONS(105),
    [aux_sym_logical_operator_token6] = ACTIONS(105),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_STAR] = ACTIONS(105),
    [anon_sym_SLASH] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(311),
    [anon_sym_PLUS] = ACTIONS(311),
    [aux_sym_unary_operator_token1] = ACTIONS(311),
    [anon_sym_TILDE] = ACTIONS(311),
    [sym_symbol] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
  },
  [9] = {
    [sym_procedure] = STATE(697),
    [sym_block] = STATE(697),
    [sym_assignment] = STATE(697),
    [sym_if] = STATE(697),
    [sym_loop] = STATE(697),
    [sym_handling] = STATE(697),
    [sym_catch] = STATE(697),
    [sym_throw] = STATE(697),
    [sym_primitive] = STATE(697),
    [sym_iterator] = STATE(697),
    [sym_while] = STATE(697),
    [sym_try] = STATE(697),
    [sym_loopbody] = STATE(697),
    [sym_leave] = STATE(697),
    [sym_continue] = STATE(697),
    [sym_protect] = STATE(697),
    [sym_lock] = STATE(697),
    [sym__literal] = STATE(697),
    [sym_character_literal] = STATE(697),
    [sym_string_literal] = STATE(697),
    [sym_call] = STATE(697),
    [sym_invoke] = STATE(697),
    [sym_indexed_access] = STATE(697),
    [sym_slot_accessor] = STATE(697),
    [sym__expression_list] = STATE(777),
    [sym_true] = STATE(697),
    [sym_false] = STATE(697),
    [sym_maybe] = STATE(697),
    [sym_unset] = STATE(697),
    [sym_super] = STATE(697),
    [sym_self] = STATE(697),
    [sym_clone] = STATE(697),
    [sym_thisthread] = STATE(697),
    [sym_class] = STATE(697),
    [sym__expression] = STATE(697),
    [sym_return] = STATE(697),
    [sym_gather] = STATE(697),
    [sym_scatter] = STATE(697),
    [sym_allresults] = STATE(697),
    [sym_parenthesized_expression] = STATE(697),
    [sym__variable] = STATE(697),
    [sym_variable] = STATE(697),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(697),
    [sym_relational_operator] = STATE(697),
    [sym_logical_operator] = STATE(697),
    [sym_arithmetic_operator] = STATE(697),
    [sym_unary_operator] = STATE(697),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(313),
    [aux_sym_method_token6] = ACTIONS(217),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_CARET_LT_LT] = ACTIONS(313),
    [anon_sym_LBRACK] = ACTIONS(313),
    [anon_sym_RBRACK] = ACTIONS(313),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [anon_sym__and_LT_LT] = ACTIONS(313),
    [anon_sym__andif_LT_LT] = ACTIONS(313),
    [anon_sym__or_LT_LT] = ACTIONS(313),
    [anon_sym__orif_LT_LT] = ACTIONS(313),
    [anon_sym__xor_LT_LT] = ACTIONS(313),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(313),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(313),
    [anon_sym_STAR_LT_LT] = ACTIONS(313),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(313),
    [anon_sym_SLASH_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym__mod_LT_LT] = ACTIONS(313),
    [anon_sym__div_LT_LT] = ACTIONS(313),
    [anon_sym_DASH_LT_LT] = ACTIONS(313),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(313),
    [anon_sym_PLUS_LT_LT] = ACTIONS(313),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(313),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_if_token2] = ACTIONS(313),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_finally_token2] = ACTIONS(313),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(259),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(259),
    [sym_global_reference] = ACTIONS(259),
    [sym_number] = ACTIONS(259),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_RBRACE] = ACTIONS(313),
    [aux_sym_relational_operator_token1] = ACTIONS(105),
    [aux_sym_relational_operator_token2] = ACTIONS(313),
    [aux_sym_relational_operator_token3] = ACTIONS(313),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_TILDE_EQ] = ACTIONS(313),
    [anon_sym_LT_GT] = ACTIONS(313),
    [anon_sym_GT_EQ] = ACTIONS(313),
    [anon_sym_LT_EQ] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(105),
    [aux_sym_logical_operator_token1] = ACTIONS(105),
    [aux_sym_logical_operator_token2] = ACTIONS(105),
    [aux_sym_logical_operator_token3] = ACTIONS(105),
    [aux_sym_logical_operator_token4] = ACTIONS(105),
    [aux_sym_logical_operator_token5] = ACTIONS(105),
    [aux_sym_logical_operator_token6] = ACTIONS(313),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_STAR] = ACTIONS(105),
    [anon_sym_SLASH] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(291),
    [anon_sym_PLUS] = ACTIONS(291),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(291),
    [sym_symbol] = ACTIONS(259),
    [sym_comment] = ACTIONS(103),
  },
  [10] = {
    [sym_procedure] = STATE(896),
    [sym_block] = STATE(896),
    [sym_assignment] = STATE(896),
    [sym_if] = STATE(896),
    [sym_loop] = STATE(896),
    [sym_handling] = STATE(896),
    [sym_catch] = STATE(896),
    [sym_throw] = STATE(896),
    [sym_primitive] = STATE(896),
    [sym_iterator] = STATE(896),
    [sym_while] = STATE(896),
    [sym_try] = STATE(896),
    [sym_loopbody] = STATE(896),
    [sym_leave] = STATE(896),
    [sym_continue] = STATE(896),
    [sym_protect] = STATE(896),
    [sym_lock] = STATE(896),
    [sym__literal] = STATE(896),
    [sym_character_literal] = STATE(896),
    [sym_string_literal] = STATE(896),
    [sym_call] = STATE(896),
    [sym_invoke] = STATE(896),
    [sym_indexed_access] = STATE(896),
    [sym_slot_accessor] = STATE(896),
    [sym__expression_list] = STATE(534),
    [sym_true] = STATE(896),
    [sym_false] = STATE(896),
    [sym_maybe] = STATE(896),
    [sym_unset] = STATE(896),
    [sym_super] = STATE(896),
    [sym_self] = STATE(896),
    [sym_clone] = STATE(896),
    [sym_thisthread] = STATE(896),
    [sym_class] = STATE(896),
    [sym__expression] = STATE(896),
    [sym_return] = STATE(896),
    [sym_gather] = STATE(896),
    [sym_scatter] = STATE(896),
    [sym_allresults] = STATE(896),
    [sym_parenthesized_expression] = STATE(896),
    [sym__variable] = STATE(896),
    [sym_variable] = STATE(896),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(896),
    [sym_relational_operator] = STATE(896),
    [sym_logical_operator] = STATE(896),
    [sym_arithmetic_operator] = STATE(896),
    [sym_unary_operator] = STATE(896),
    [anon_sym_CR] = ACTIONS(185),
    [anon_sym_LF] = ACTIONS(185),
    [aux_sym_method_token3] = ACTIONS(107),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(185),
    [aux_sym_method_token6] = ACTIONS(315),
    [anon_sym_LT_LT] = ACTIONS(185),
    [anon_sym_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_LBRACK] = ACTIONS(185),
    [aux_sym_procedure_token1] = ACTIONS(115),
    [aux_sym_block_token1] = ACTIONS(117),
    [anon_sym__and_LT_LT] = ACTIONS(185),
    [anon_sym__andif_LT_LT] = ACTIONS(185),
    [anon_sym__or_LT_LT] = ACTIONS(185),
    [anon_sym__orif_LT_LT] = ACTIONS(185),
    [anon_sym__xor_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_LT_LT] = ACTIONS(185),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym__mod_LT_LT] = ACTIONS(185),
    [anon_sym__div_LT_LT] = ACTIONS(185),
    [anon_sym_DASH_LT_LT] = ACTIONS(185),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym_PLUS_LT_LT] = ACTIONS(185),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(185),
    [aux_sym_if_token1] = ACTIONS(119),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(317),
    [aux_sym_catch_token1] = ACTIONS(123),
    [aux_sym_throw_token1] = ACTIONS(319),
    [aux_sym_primitive_token1] = ACTIONS(127),
    [aux_sym_iterator_token1] = ACTIONS(129),
    [aux_sym_iterator_token2] = ACTIONS(131),
    [aux_sym_while_token1] = ACTIONS(133),
    [aux_sym_try_token1] = ACTIONS(135),
    [aux_sym_loopbody_token1] = ACTIONS(137),
    [aux_sym_leave_token1] = ACTIONS(321),
    [aux_sym_continue_token1] = ACTIONS(323),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token3] = ACTIONS(185),
    [aux_sym_lock_token1] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [sym_regex_literal] = ACTIONS(325),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(155),
    [aux_sym_false_token1] = ACTIONS(157),
    [aux_sym_maybe_token1] = ACTIONS(159),
    [aux_sym_unset_token1] = ACTIONS(161),
    [aux_sym_super_token1] = ACTIONS(163),
    [aux_sym_self_token1] = ACTIONS(165),
    [aux_sym_clone_token1] = ACTIONS(167),
    [aux_sym_thisthread_token1] = ACTIONS(169),
    [aux_sym_class_token1] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(185),
    [aux_sym_return_token1] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(329),
    [aux_sym_scatter_token1] = ACTIONS(331),
    [aux_sym_allresults_token1] = ACTIONS(333),
    [sym_dynamic_variable] = ACTIONS(325),
    [sym_global_variable] = ACTIONS(325),
    [sym_global_reference] = ACTIONS(325),
    [sym_number] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(181),
    [aux_sym_relational_operator_token1] = ACTIONS(185),
    [aux_sym_relational_operator_token2] = ACTIONS(185),
    [aux_sym_relational_operator_token3] = ACTIONS(185),
    [anon_sym_EQ] = ACTIONS(185),
    [anon_sym_TILDE_EQ] = ACTIONS(185),
    [anon_sym_LT_GT] = ACTIONS(185),
    [anon_sym_GT_EQ] = ACTIONS(185),
    [anon_sym_LT_EQ] = ACTIONS(185),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [aux_sym_logical_operator_token1] = ACTIONS(185),
    [aux_sym_logical_operator_token2] = ACTIONS(185),
    [aux_sym_logical_operator_token3] = ACTIONS(185),
    [aux_sym_logical_operator_token4] = ACTIONS(185),
    [aux_sym_logical_operator_token5] = ACTIONS(185),
    [aux_sym_logical_operator_token6] = ACTIONS(185),
    [anon_sym_STAR_STAR] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(335),
    [aux_sym_unary_operator_token1] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(335),
    [sym_symbol] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
  },
  [11] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(824),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(215),
    [aux_sym_method_token6] = ACTIONS(337),
    [anon_sym_RPAREN] = ACTIONS(215),
    [anon_sym_LT_LT] = ACTIONS(215),
    [anon_sym_CARET_LT_LT] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(215),
    [anon_sym_RBRACK] = ACTIONS(215),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [anon_sym__and_LT_LT] = ACTIONS(215),
    [anon_sym__andif_LT_LT] = ACTIONS(215),
    [anon_sym__or_LT_LT] = ACTIONS(215),
    [anon_sym__orif_LT_LT] = ACTIONS(215),
    [anon_sym__xor_LT_LT] = ACTIONS(215),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(215),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(215),
    [anon_sym_STAR_LT_LT] = ACTIONS(215),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(215),
    [anon_sym_SLASH_LT_LT] = ACTIONS(185),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(185),
    [anon_sym__mod_LT_LT] = ACTIONS(215),
    [anon_sym__div_LT_LT] = ACTIONS(215),
    [anon_sym_DASH_LT_LT] = ACTIONS(215),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(215),
    [anon_sym_PLUS_LT_LT] = ACTIONS(215),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(215),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_if_token2] = ACTIONS(215),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_RBRACE] = ACTIONS(215),
    [aux_sym_relational_operator_token1] = ACTIONS(185),
    [aux_sym_relational_operator_token2] = ACTIONS(215),
    [aux_sym_relational_operator_token3] = ACTIONS(215),
    [anon_sym_EQ] = ACTIONS(215),
    [anon_sym_TILDE_EQ] = ACTIONS(215),
    [anon_sym_LT_GT] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(215),
    [anon_sym_LT_EQ] = ACTIONS(215),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(185),
    [aux_sym_logical_operator_token1] = ACTIONS(185),
    [aux_sym_logical_operator_token2] = ACTIONS(185),
    [aux_sym_logical_operator_token3] = ACTIONS(185),
    [aux_sym_logical_operator_token4] = ACTIONS(185),
    [aux_sym_logical_operator_token5] = ACTIONS(185),
    [aux_sym_logical_operator_token6] = ACTIONS(215),
    [anon_sym_STAR_STAR] = ACTIONS(185),
    [anon_sym_STAR] = ACTIONS(185),
    [anon_sym_SLASH] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(185),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(185),
    [anon_sym_DASH] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(357),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [12] = {
    [sym_procedure] = STATE(896),
    [sym_block] = STATE(896),
    [sym_assignment] = STATE(896),
    [sym_if] = STATE(896),
    [sym_loop] = STATE(896),
    [sym_handling] = STATE(896),
    [sym_catch] = STATE(896),
    [sym_throw] = STATE(896),
    [sym_primitive] = STATE(896),
    [sym_iterator] = STATE(896),
    [sym_while] = STATE(896),
    [sym_try] = STATE(896),
    [sym_loopbody] = STATE(896),
    [sym_leave] = STATE(896),
    [sym_continue] = STATE(896),
    [sym_protect] = STATE(896),
    [sym_lock] = STATE(896),
    [sym__literal] = STATE(896),
    [sym_character_literal] = STATE(896),
    [sym_string_literal] = STATE(896),
    [sym_call] = STATE(896),
    [sym_invoke] = STATE(896),
    [sym_indexed_access] = STATE(896),
    [sym_slot_accessor] = STATE(896),
    [sym__expression_list] = STATE(550),
    [sym_true] = STATE(896),
    [sym_false] = STATE(896),
    [sym_maybe] = STATE(896),
    [sym_unset] = STATE(896),
    [sym_super] = STATE(896),
    [sym_self] = STATE(896),
    [sym_clone] = STATE(896),
    [sym_thisthread] = STATE(896),
    [sym_class] = STATE(896),
    [sym__expression] = STATE(896),
    [sym_return] = STATE(896),
    [sym_gather] = STATE(896),
    [sym_scatter] = STATE(896),
    [sym_allresults] = STATE(896),
    [sym_parenthesized_expression] = STATE(896),
    [sym__variable] = STATE(896),
    [sym_variable] = STATE(896),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(896),
    [sym_relational_operator] = STATE(896),
    [sym_logical_operator] = STATE(896),
    [sym_arithmetic_operator] = STATE(896),
    [sym_unary_operator] = STATE(896),
    [anon_sym_CR] = ACTIONS(105),
    [anon_sym_LF] = ACTIONS(105),
    [aux_sym_method_token3] = ACTIONS(107),
    [anon_sym_DOT] = ACTIONS(109),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(105),
    [aux_sym_method_token6] = ACTIONS(315),
    [anon_sym_LT_LT] = ACTIONS(105),
    [anon_sym_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(105),
    [aux_sym_procedure_token1] = ACTIONS(115),
    [aux_sym_block_token1] = ACTIONS(117),
    [anon_sym__and_LT_LT] = ACTIONS(105),
    [anon_sym__andif_LT_LT] = ACTIONS(105),
    [anon_sym__or_LT_LT] = ACTIONS(105),
    [anon_sym__orif_LT_LT] = ACTIONS(105),
    [anon_sym__xor_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_LT_LT] = ACTIONS(105),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym__mod_LT_LT] = ACTIONS(105),
    [anon_sym__div_LT_LT] = ACTIONS(105),
    [anon_sym_DASH_LT_LT] = ACTIONS(105),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym_PLUS_LT_LT] = ACTIONS(105),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(105),
    [aux_sym_if_token1] = ACTIONS(119),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(317),
    [aux_sym_catch_token1] = ACTIONS(123),
    [aux_sym_throw_token1] = ACTIONS(319),
    [aux_sym_primitive_token1] = ACTIONS(127),
    [aux_sym_iterator_token1] = ACTIONS(129),
    [aux_sym_iterator_token2] = ACTIONS(131),
    [aux_sym_while_token1] = ACTIONS(133),
    [aux_sym_try_token1] = ACTIONS(135),
    [aux_sym_loopbody_token1] = ACTIONS(137),
    [aux_sym_leave_token1] = ACTIONS(321),
    [aux_sym_continue_token1] = ACTIONS(323),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token3] = ACTIONS(105),
    [aux_sym_lock_token1] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(149),
    [anon_sym_SQUOTE] = ACTIONS(151),
    [sym_regex_literal] = ACTIONS(325),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(155),
    [aux_sym_false_token1] = ACTIONS(157),
    [aux_sym_maybe_token1] = ACTIONS(159),
    [aux_sym_unset_token1] = ACTIONS(161),
    [aux_sym_super_token1] = ACTIONS(163),
    [aux_sym_self_token1] = ACTIONS(165),
    [aux_sym_clone_token1] = ACTIONS(167),
    [aux_sym_thisthread_token1] = ACTIONS(169),
    [aux_sym_class_token1] = ACTIONS(171),
    [anon_sym_SEMI] = ACTIONS(105),
    [aux_sym_return_token1] = ACTIONS(327),
    [anon_sym_GT_GT] = ACTIONS(329),
    [aux_sym_scatter_token1] = ACTIONS(331),
    [aux_sym_allresults_token1] = ACTIONS(333),
    [sym_dynamic_variable] = ACTIONS(325),
    [sym_global_variable] = ACTIONS(325),
    [sym_global_reference] = ACTIONS(325),
    [sym_number] = ACTIONS(325),
    [anon_sym_LBRACE] = ACTIONS(181),
    [aux_sym_relational_operator_token1] = ACTIONS(105),
    [aux_sym_relational_operator_token2] = ACTIONS(105),
    [aux_sym_relational_operator_token3] = ACTIONS(105),
    [anon_sym_EQ] = ACTIONS(105),
    [anon_sym_TILDE_EQ] = ACTIONS(105),
    [anon_sym_LT_GT] = ACTIONS(105),
    [anon_sym_GT_EQ] = ACTIONS(105),
    [anon_sym_LT_EQ] = ACTIONS(105),
    [anon_sym_LT] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(105),
    [aux_sym_logical_operator_token1] = ACTIONS(105),
    [aux_sym_logical_operator_token2] = ACTIONS(105),
    [aux_sym_logical_operator_token3] = ACTIONS(105),
    [aux_sym_logical_operator_token4] = ACTIONS(105),
    [aux_sym_logical_operator_token5] = ACTIONS(105),
    [aux_sym_logical_operator_token6] = ACTIONS(105),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_STAR] = ACTIONS(105),
    [anon_sym_SLASH] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_PLUS] = ACTIONS(335),
    [aux_sym_unary_operator_token1] = ACTIONS(335),
    [anon_sym_TILDE] = ACTIONS(335),
    [sym_symbol] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
  },
  [13] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(777),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(313),
    [aux_sym_method_token6] = ACTIONS(337),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_CARET_LT_LT] = ACTIONS(313),
    [anon_sym_LBRACK] = ACTIONS(313),
    [anon_sym_RBRACK] = ACTIONS(313),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [anon_sym__and_LT_LT] = ACTIONS(313),
    [anon_sym__andif_LT_LT] = ACTIONS(313),
    [anon_sym__or_LT_LT] = ACTIONS(313),
    [anon_sym__orif_LT_LT] = ACTIONS(313),
    [anon_sym__xor_LT_LT] = ACTIONS(313),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(313),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(313),
    [anon_sym_STAR_LT_LT] = ACTIONS(313),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(313),
    [anon_sym_SLASH_LT_LT] = ACTIONS(105),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(105),
    [anon_sym__mod_LT_LT] = ACTIONS(313),
    [anon_sym__div_LT_LT] = ACTIONS(313),
    [anon_sym_DASH_LT_LT] = ACTIONS(313),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(313),
    [anon_sym_PLUS_LT_LT] = ACTIONS(313),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(313),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_if_token2] = ACTIONS(313),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_RBRACE] = ACTIONS(313),
    [aux_sym_relational_operator_token1] = ACTIONS(105),
    [aux_sym_relational_operator_token2] = ACTIONS(313),
    [aux_sym_relational_operator_token3] = ACTIONS(313),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_TILDE_EQ] = ACTIONS(313),
    [anon_sym_LT_GT] = ACTIONS(313),
    [anon_sym_GT_EQ] = ACTIONS(313),
    [anon_sym_LT_EQ] = ACTIONS(313),
    [anon_sym_LT] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(105),
    [aux_sym_logical_operator_token1] = ACTIONS(105),
    [aux_sym_logical_operator_token2] = ACTIONS(105),
    [aux_sym_logical_operator_token3] = ACTIONS(105),
    [aux_sym_logical_operator_token4] = ACTIONS(105),
    [aux_sym_logical_operator_token5] = ACTIONS(105),
    [aux_sym_logical_operator_token6] = ACTIONS(313),
    [anon_sym_STAR_STAR] = ACTIONS(105),
    [anon_sym_STAR] = ACTIONS(105),
    [anon_sym_SLASH] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(105),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(105),
    [anon_sym_DASH] = ACTIONS(357),
    [anon_sym_PLUS] = ACTIONS(357),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(357),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [14] = {
    [sym_procedure] = STATE(674),
    [sym_block] = STATE(674),
    [sym_assignment] = STATE(674),
    [sym_if] = STATE(674),
    [sym_loop] = STATE(674),
    [sym_handling] = STATE(674),
    [sym_catch] = STATE(674),
    [sym_throw] = STATE(674),
    [sym_primitive] = STATE(674),
    [sym_iterator] = STATE(674),
    [sym_while] = STATE(674),
    [sym_try] = STATE(674),
    [sym_loopbody] = STATE(674),
    [sym_leave] = STATE(674),
    [sym_continue] = STATE(674),
    [sym_protect] = STATE(674),
    [sym_lock] = STATE(674),
    [sym__literal] = STATE(674),
    [sym_character_literal] = STATE(674),
    [sym_string_literal] = STATE(674),
    [sym_call] = STATE(674),
    [sym_invoke] = STATE(674),
    [sym_indexed_access] = STATE(674),
    [sym_slot_accessor] = STATE(674),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_maybe] = STATE(674),
    [sym_unset] = STATE(674),
    [sym_super] = STATE(674),
    [sym_self] = STATE(674),
    [sym_clone] = STATE(674),
    [sym_thisthread] = STATE(674),
    [sym_class] = STATE(674),
    [sym__expression] = STATE(674),
    [sym__defvar] = STATE(1052),
    [sym_global] = STATE(1052),
    [sym_local] = STATE(1052),
    [sym_constant] = STATE(1052),
    [sym_dynamic] = STATE(1052),
    [sym_import] = STATE(1052),
    [sym_dynamic_import] = STATE(1052),
    [sym_return] = STATE(674),
    [sym_gather] = STATE(674),
    [sym_scatter] = STATE(674),
    [sym_allresults] = STATE(674),
    [sym_parenthesized_expression] = STATE(674),
    [sym__variable] = STATE(674),
    [sym_variable] = STATE(674),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(674),
    [sym_relational_operator] = STATE(674),
    [sym_logical_operator] = STATE(674),
    [sym_arithmetic_operator] = STATE(674),
    [sym_unary_operator] = STATE(674),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(363),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(363),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_block_token2] = ACTIONS(363),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_if_token3] = ACTIONS(363),
    [aux_sym_elif_token1] = ACTIONS(363),
    [aux_sym_else_token1] = ACTIONS(363),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(363),
    [aux_sym_finally_token1] = ACTIONS(363),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_catch_token2] = ACTIONS(363),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_try_token2] = ACTIONS(363),
    [aux_sym_try_token3] = ACTIONS(363),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(363),
    [aux_sym_lock_token1] = ACTIONS(57),
    [aux_sym_lock_token2] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(365),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(365),
    [sym_global_variable] = ACTIONS(365),
    [sym_global_reference] = ACTIONS(365),
    [sym_number] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(365),
    [sym_comment] = ACTIONS(103),
  },
  [15] = {
    [sym_procedure] = STATE(674),
    [sym_block] = STATE(674),
    [sym_assignment] = STATE(674),
    [sym_if] = STATE(674),
    [sym_loop] = STATE(674),
    [sym_handling] = STATE(674),
    [sym_catch] = STATE(674),
    [sym_throw] = STATE(674),
    [sym_primitive] = STATE(674),
    [sym_iterator] = STATE(674),
    [sym_while] = STATE(674),
    [sym_try] = STATE(674),
    [sym_loopbody] = STATE(674),
    [sym_leave] = STATE(674),
    [sym_continue] = STATE(674),
    [sym_protect] = STATE(674),
    [sym_lock] = STATE(674),
    [sym__literal] = STATE(674),
    [sym_character_literal] = STATE(674),
    [sym_string_literal] = STATE(674),
    [sym_call] = STATE(674),
    [sym_invoke] = STATE(674),
    [sym_indexed_access] = STATE(674),
    [sym_slot_accessor] = STATE(674),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_maybe] = STATE(674),
    [sym_unset] = STATE(674),
    [sym_super] = STATE(674),
    [sym_self] = STATE(674),
    [sym_clone] = STATE(674),
    [sym_thisthread] = STATE(674),
    [sym_class] = STATE(674),
    [sym__expression] = STATE(674),
    [sym__defvar] = STATE(1052),
    [sym_global] = STATE(1052),
    [sym_local] = STATE(1052),
    [sym_constant] = STATE(1052),
    [sym_dynamic] = STATE(1052),
    [sym_import] = STATE(1052),
    [sym_dynamic_import] = STATE(1052),
    [sym_return] = STATE(674),
    [sym_gather] = STATE(674),
    [sym_scatter] = STATE(674),
    [sym_allresults] = STATE(674),
    [sym_parenthesized_expression] = STATE(674),
    [sym__variable] = STATE(674),
    [sym_variable] = STATE(674),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(674),
    [sym_relational_operator] = STATE(674),
    [sym_logical_operator] = STATE(674),
    [sym_arithmetic_operator] = STATE(674),
    [sym_unary_operator] = STATE(674),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(377),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(377),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_block_token2] = ACTIONS(377),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_if_token3] = ACTIONS(377),
    [aux_sym_elif_token1] = ACTIONS(377),
    [aux_sym_else_token1] = ACTIONS(377),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(377),
    [aux_sym_finally_token1] = ACTIONS(377),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_catch_token2] = ACTIONS(377),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_try_token2] = ACTIONS(377),
    [aux_sym_try_token3] = ACTIONS(377),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(377),
    [aux_sym_lock_token1] = ACTIONS(57),
    [aux_sym_lock_token2] = ACTIONS(377),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(365),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(365),
    [sym_global_variable] = ACTIONS(365),
    [sym_global_reference] = ACTIONS(365),
    [sym_number] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(365),
    [sym_comment] = ACTIONS(103),
  },
  [16] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_elif] = STATE(1090),
    [sym_else] = STATE(1691),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1081),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_if_repeat1] = STATE(1090),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_if_token3] = ACTIONS(379),
    [aux_sym_elif_token1] = ACTIONS(381),
    [aux_sym_else_token1] = ACTIONS(383),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [17] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_elif] = STATE(1085),
    [sym_else] = STATE(1932),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1084),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_if_repeat1] = STATE(1085),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_if_token3] = ACTIONS(387),
    [aux_sym_elif_token1] = ACTIONS(381),
    [aux_sym_else_token1] = ACTIONS(383),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [18] = {
    [sym_fragment] = STATE(18),
    [sym_package] = STATE(18),
    [sym__method_declaration] = STATE(1390),
    [sym_method] = STATE(1390),
    [sym_procedure] = STATE(996),
    [sym_block] = STATE(996),
    [sym_assignment] = STATE(996),
    [sym_if] = STATE(996),
    [sym_loop] = STATE(996),
    [sym_handling] = STATE(996),
    [sym_catch] = STATE(996),
    [sym_throw] = STATE(996),
    [sym_primitive] = STATE(996),
    [sym_iterator] = STATE(996),
    [sym_while] = STATE(996),
    [sym_try] = STATE(996),
    [sym_loopbody] = STATE(996),
    [sym_leave] = STATE(996),
    [sym_continue] = STATE(996),
    [sym_protect] = STATE(996),
    [sym_lock] = STATE(996),
    [sym_pragma] = STATE(247),
    [sym__literal] = STATE(996),
    [sym_character_literal] = STATE(996),
    [sym_string_literal] = STATE(996),
    [sym_call] = STATE(996),
    [sym_invoke] = STATE(996),
    [sym_indexed_access] = STATE(996),
    [sym_slot_accessor] = STATE(996),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_maybe] = STATE(996),
    [sym_unset] = STATE(996),
    [sym_super] = STATE(996),
    [sym_self] = STATE(996),
    [sym_clone] = STATE(996),
    [sym_thisthread] = STATE(996),
    [sym_class] = STATE(996),
    [sym__top_level_statement] = STATE(1390),
    [sym__expression] = STATE(996),
    [sym__global_assignment] = STATE(1390),
    [sym_return] = STATE(996),
    [sym__definition] = STATE(1390),
    [sym_gather] = STATE(996),
    [sym_scatter] = STATE(996),
    [sym_allresults] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym__variable] = STATE(996),
    [sym_variable] = STATE(996),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(996),
    [sym_relational_operator] = STATE(996),
    [sym_logical_operator] = STATE(996),
    [sym_arithmetic_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [aux_sym_source_file_repeat1] = STATE(18),
    [aux_sym_fragment_repeat1] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(389),
    [aux_sym_package_token1] = ACTIONS(391),
    [sym__dollar] = ACTIONS(394),
    [aux_sym_method_token1] = ACTIONS(397),
    [aux_sym_method_token2] = ACTIONS(400),
    [aux_sym_method_token3] = ACTIONS(403),
    [aux_sym_method_token4] = ACTIONS(406),
    [anon_sym_DOT] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(412),
    [aux_sym_method_token6] = ACTIONS(415),
    [aux_sym_procedure_token1] = ACTIONS(418),
    [aux_sym_block_token1] = ACTIONS(421),
    [aux_sym_if_token1] = ACTIONS(424),
    [aux_sym_loop_token1] = ACTIONS(427),
    [aux_sym_handling_token1] = ACTIONS(430),
    [aux_sym_catch_token1] = ACTIONS(433),
    [aux_sym_throw_token1] = ACTIONS(436),
    [aux_sym_primitive_token1] = ACTIONS(439),
    [aux_sym_iterator_token1] = ACTIONS(442),
    [aux_sym_iterator_token2] = ACTIONS(445),
    [aux_sym_while_token1] = ACTIONS(448),
    [aux_sym_try_token1] = ACTIONS(451),
    [aux_sym_loopbody_token1] = ACTIONS(454),
    [aux_sym_leave_token1] = ACTIONS(457),
    [aux_sym_continue_token1] = ACTIONS(460),
    [aux_sym_protect_token1] = ACTIONS(463),
    [aux_sym_lock_token1] = ACTIONS(466),
    [aux_sym_pragma_token1] = ACTIONS(469),
    [anon_sym_PERCENT] = ACTIONS(472),
    [anon_sym_DQUOTE] = ACTIONS(475),
    [anon_sym_SQUOTE] = ACTIONS(478),
    [sym_regex_literal] = ACTIONS(481),
    [aux_sym_slot_accessor_token1] = ACTIONS(484),
    [aux_sym_true_token1] = ACTIONS(487),
    [aux_sym_false_token1] = ACTIONS(490),
    [aux_sym_maybe_token1] = ACTIONS(493),
    [aux_sym_unset_token1] = ACTIONS(496),
    [aux_sym_super_token1] = ACTIONS(499),
    [aux_sym_self_token1] = ACTIONS(502),
    [aux_sym_clone_token1] = ACTIONS(505),
    [aux_sym_thisthread_token1] = ACTIONS(508),
    [aux_sym_class_token1] = ACTIONS(511),
    [aux_sym_global_token1] = ACTIONS(514),
    [aux_sym_return_token1] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(520),
    [aux_sym_scatter_token1] = ACTIONS(523),
    [aux_sym_allresults_token1] = ACTIONS(526),
    [sym_dynamic_variable] = ACTIONS(481),
    [sym_global_variable] = ACTIONS(481),
    [sym_global_reference] = ACTIONS(481),
    [sym_number] = ACTIONS(481),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_DASH] = ACTIONS(532),
    [anon_sym_PLUS] = ACTIONS(532),
    [aux_sym_unary_operator_token1] = ACTIONS(532),
    [anon_sym_TILDE] = ACTIONS(532),
    [sym_symbol] = ACTIONS(481),
    [sym_comment] = ACTIONS(103),
  },
  [19] = {
    [sym_fragment] = STATE(18),
    [sym_package] = STATE(18),
    [sym__method_declaration] = STATE(1390),
    [sym_method] = STATE(1390),
    [sym_procedure] = STATE(996),
    [sym_block] = STATE(996),
    [sym_assignment] = STATE(996),
    [sym_if] = STATE(996),
    [sym_loop] = STATE(996),
    [sym_handling] = STATE(996),
    [sym_catch] = STATE(996),
    [sym_throw] = STATE(996),
    [sym_primitive] = STATE(996),
    [sym_iterator] = STATE(996),
    [sym_while] = STATE(996),
    [sym_try] = STATE(996),
    [sym_loopbody] = STATE(996),
    [sym_leave] = STATE(996),
    [sym_continue] = STATE(996),
    [sym_protect] = STATE(996),
    [sym_lock] = STATE(996),
    [sym_pragma] = STATE(247),
    [sym__literal] = STATE(996),
    [sym_character_literal] = STATE(996),
    [sym_string_literal] = STATE(996),
    [sym_call] = STATE(996),
    [sym_invoke] = STATE(996),
    [sym_indexed_access] = STATE(996),
    [sym_slot_accessor] = STATE(996),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_maybe] = STATE(996),
    [sym_unset] = STATE(996),
    [sym_super] = STATE(996),
    [sym_self] = STATE(996),
    [sym_clone] = STATE(996),
    [sym_thisthread] = STATE(996),
    [sym_class] = STATE(996),
    [sym__top_level_statement] = STATE(1390),
    [sym__expression] = STATE(996),
    [sym__global_assignment] = STATE(1390),
    [sym_return] = STATE(996),
    [sym__definition] = STATE(1390),
    [sym_gather] = STATE(996),
    [sym_scatter] = STATE(996),
    [sym_allresults] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym__variable] = STATE(996),
    [sym_variable] = STATE(996),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(996),
    [sym_relational_operator] = STATE(996),
    [sym_logical_operator] = STATE(996),
    [sym_arithmetic_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [aux_sym_source_file_repeat1] = STATE(18),
    [aux_sym_fragment_repeat1] = STATE(124),
    [ts_builtin_sym_end] = ACTIONS(535),
    [aux_sym_package_token1] = ACTIONS(7),
    [sym__dollar] = ACTIONS(537),
    [aux_sym_method_token1] = ACTIONS(11),
    [aux_sym_method_token2] = ACTIONS(13),
    [aux_sym_method_token3] = ACTIONS(15),
    [aux_sym_method_token4] = ACTIONS(17),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [aux_sym_pragma_token1] = ACTIONS(59),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(67),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(89),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(67),
    [sym_global_variable] = ACTIONS(67),
    [sym_global_reference] = ACTIONS(67),
    [sym_number] = ACTIONS(67),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(67),
    [sym_comment] = ACTIONS(103),
  },
  [20] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1649),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_try_repeat1] = STATE(32),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COMMA] = ACTIONS(539),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_try_token2] = ACTIONS(541),
    [aux_sym_try_token3] = ACTIONS(541),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [21] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1856),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(135),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(543),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1784),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(193),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(547),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_finally] = STATE(1846),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1488),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(549),
    [aux_sym_finally_token1] = ACTIONS(551),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(553),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [24] = {
    [sym_fragment] = STATE(73),
    [sym__method_declaration] = STATE(1390),
    [sym_method] = STATE(1390),
    [sym_procedure] = STATE(996),
    [sym_block] = STATE(996),
    [sym_assignment] = STATE(996),
    [sym_if] = STATE(996),
    [sym_loop] = STATE(996),
    [sym_handling] = STATE(996),
    [sym_catch] = STATE(996),
    [sym_throw] = STATE(996),
    [sym_primitive] = STATE(996),
    [sym_iterator] = STATE(996),
    [sym_while] = STATE(996),
    [sym_try] = STATE(996),
    [sym_loopbody] = STATE(996),
    [sym_leave] = STATE(996),
    [sym_continue] = STATE(996),
    [sym_protect] = STATE(996),
    [sym_lock] = STATE(996),
    [sym_pragma] = STATE(247),
    [sym__literal] = STATE(996),
    [sym_character_literal] = STATE(996),
    [sym_string_literal] = STATE(996),
    [sym_call] = STATE(996),
    [sym_invoke] = STATE(996),
    [sym_indexed_access] = STATE(996),
    [sym_slot_accessor] = STATE(996),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_maybe] = STATE(996),
    [sym_unset] = STATE(996),
    [sym_super] = STATE(996),
    [sym_self] = STATE(996),
    [sym_clone] = STATE(996),
    [sym_thisthread] = STATE(996),
    [sym_class] = STATE(996),
    [sym__top_level_statement] = STATE(1390),
    [sym__expression] = STATE(996),
    [sym__global_assignment] = STATE(1390),
    [sym_return] = STATE(996),
    [sym__definition] = STATE(1390),
    [sym_gather] = STATE(996),
    [sym_scatter] = STATE(996),
    [sym_allresults] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym__variable] = STATE(996),
    [sym_variable] = STATE(996),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(996),
    [sym_relational_operator] = STATE(996),
    [sym_logical_operator] = STATE(996),
    [sym_arithmetic_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [aux_sym_fragment_repeat1] = STATE(124),
    [aux_sym_package_repeat1] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(557),
    [aux_sym_package_token1] = ACTIONS(557),
    [sym__dollar] = ACTIONS(557),
    [aux_sym_method_token1] = ACTIONS(557),
    [aux_sym_method_token2] = ACTIONS(557),
    [aux_sym_method_token3] = ACTIONS(557),
    [aux_sym_method_token4] = ACTIONS(557),
    [anon_sym_DOT] = ACTIONS(557),
    [anon_sym_LPAREN] = ACTIONS(557),
    [aux_sym_method_token6] = ACTIONS(557),
    [aux_sym_procedure_token1] = ACTIONS(557),
    [aux_sym_block_token1] = ACTIONS(557),
    [aux_sym_if_token1] = ACTIONS(557),
    [aux_sym_loop_token1] = ACTIONS(559),
    [aux_sym_handling_token1] = ACTIONS(557),
    [aux_sym_catch_token1] = ACTIONS(557),
    [aux_sym_throw_token1] = ACTIONS(557),
    [aux_sym_primitive_token1] = ACTIONS(557),
    [aux_sym_iterator_token1] = ACTIONS(557),
    [aux_sym_iterator_token2] = ACTIONS(557),
    [aux_sym_while_token1] = ACTIONS(557),
    [aux_sym_try_token1] = ACTIONS(557),
    [aux_sym_loopbody_token1] = ACTIONS(557),
    [aux_sym_leave_token1] = ACTIONS(557),
    [aux_sym_continue_token1] = ACTIONS(557),
    [aux_sym_protect_token1] = ACTIONS(557),
    [aux_sym_lock_token1] = ACTIONS(557),
    [aux_sym_pragma_token1] = ACTIONS(557),
    [anon_sym_PERCENT] = ACTIONS(557),
    [anon_sym_DQUOTE] = ACTIONS(557),
    [anon_sym_SQUOTE] = ACTIONS(557),
    [sym_regex_literal] = ACTIONS(557),
    [aux_sym_slot_accessor_token1] = ACTIONS(559),
    [aux_sym_true_token1] = ACTIONS(557),
    [aux_sym_false_token1] = ACTIONS(557),
    [aux_sym_maybe_token1] = ACTIONS(557),
    [aux_sym_unset_token1] = ACTIONS(557),
    [aux_sym_super_token1] = ACTIONS(557),
    [aux_sym_self_token1] = ACTIONS(557),
    [aux_sym_clone_token1] = ACTIONS(557),
    [aux_sym_thisthread_token1] = ACTIONS(557),
    [aux_sym_class_token1] = ACTIONS(557),
    [aux_sym_global_token1] = ACTIONS(557),
    [aux_sym_return_token1] = ACTIONS(557),
    [anon_sym_GT_GT] = ACTIONS(557),
    [aux_sym_scatter_token1] = ACTIONS(557),
    [aux_sym_allresults_token1] = ACTIONS(557),
    [sym_dynamic_variable] = ACTIONS(557),
    [sym_global_variable] = ACTIONS(557),
    [sym_global_reference] = ACTIONS(557),
    [sym_number] = ACTIONS(557),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_DASH] = ACTIONS(557),
    [anon_sym_PLUS] = ACTIONS(557),
    [aux_sym_unary_operator_token1] = ACTIONS(557),
    [anon_sym_TILDE] = ACTIONS(557),
    [sym_symbol] = ACTIONS(557),
    [sym_comment] = ACTIONS(103),
  },
  [25] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1696),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(239),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(561),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [26] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1795),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(225),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(563),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [27] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1692),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(215),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(565),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1371),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_try_repeat2] = STATE(1377),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_finally_token2] = ACTIONS(567),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_try_token2] = ACTIONS(569),
    [aux_sym_try_token3] = ACTIONS(571),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [29] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1685),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(213),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(573),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1804),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(234),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(575),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1773),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(187),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(577),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [32] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1551),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_try_repeat1] = STATE(679),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [anon_sym_COMMA] = ACTIONS(539),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_try_token2] = ACTIONS(579),
    [aux_sym_try_token3] = ACTIONS(579),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [33] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1677),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(181),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(581),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [34] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1888),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(200),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(583),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1676),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(218),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(585),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [36] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1923),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(231),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(587),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1877),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(177),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(589),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [38] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1896),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(201),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(591),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [39] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1873),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(164),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(593),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [40] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1906),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(205),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(595),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [41] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1814),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(232),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(597),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1807),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(178),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(599),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [43] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1507),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_try_repeat2] = STATE(1508),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_finally_token2] = ACTIONS(601),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_try_token2] = ACTIONS(569),
    [aux_sym_try_token3] = ACTIONS(603),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [44] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1822),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(228),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(605),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [45] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1716),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(221),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(607),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [46] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1761),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(161),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(609),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1829),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(217),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(611),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [48] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1699),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(227),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(613),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [49] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_finally] = STATE(1737),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1439),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(615),
    [aux_sym_finally_token1] = ACTIONS(551),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(617),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [50] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1806),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(173),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(619),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1715),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(176),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(621),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1920),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(219),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(623),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1947),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(214),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(625),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [54] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1748),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(153),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(627),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [55] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1776),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(189),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(629),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_fragment] = STATE(24),
    [sym__method_declaration] = STATE(1390),
    [sym_method] = STATE(1390),
    [sym_procedure] = STATE(996),
    [sym_block] = STATE(996),
    [sym_assignment] = STATE(996),
    [sym_if] = STATE(996),
    [sym_loop] = STATE(996),
    [sym_handling] = STATE(996),
    [sym_catch] = STATE(996),
    [sym_throw] = STATE(996),
    [sym_primitive] = STATE(996),
    [sym_iterator] = STATE(996),
    [sym_while] = STATE(996),
    [sym_try] = STATE(996),
    [sym_loopbody] = STATE(996),
    [sym_leave] = STATE(996),
    [sym_continue] = STATE(996),
    [sym_protect] = STATE(996),
    [sym_lock] = STATE(996),
    [sym_pragma] = STATE(247),
    [sym__literal] = STATE(996),
    [sym_character_literal] = STATE(996),
    [sym_string_literal] = STATE(996),
    [sym_call] = STATE(996),
    [sym_invoke] = STATE(996),
    [sym_indexed_access] = STATE(996),
    [sym_slot_accessor] = STATE(996),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_maybe] = STATE(996),
    [sym_unset] = STATE(996),
    [sym_super] = STATE(996),
    [sym_self] = STATE(996),
    [sym_clone] = STATE(996),
    [sym_thisthread] = STATE(996),
    [sym_class] = STATE(996),
    [sym__top_level_statement] = STATE(1390),
    [sym__expression] = STATE(996),
    [sym__global_assignment] = STATE(1390),
    [sym_return] = STATE(996),
    [sym__definition] = STATE(1390),
    [sym_gather] = STATE(996),
    [sym_scatter] = STATE(996),
    [sym_allresults] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym__variable] = STATE(996),
    [sym_variable] = STATE(996),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(996),
    [sym_relational_operator] = STATE(996),
    [sym_logical_operator] = STATE(996),
    [sym_arithmetic_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [aux_sym_fragment_repeat1] = STATE(124),
    [aux_sym_package_repeat1] = STATE(24),
    [ts_builtin_sym_end] = ACTIONS(631),
    [aux_sym_package_token1] = ACTIONS(631),
    [sym__dollar] = ACTIONS(631),
    [aux_sym_method_token1] = ACTIONS(631),
    [aux_sym_method_token2] = ACTIONS(631),
    [aux_sym_method_token3] = ACTIONS(631),
    [aux_sym_method_token4] = ACTIONS(631),
    [anon_sym_DOT] = ACTIONS(631),
    [anon_sym_LPAREN] = ACTIONS(631),
    [aux_sym_method_token6] = ACTIONS(631),
    [aux_sym_procedure_token1] = ACTIONS(631),
    [aux_sym_block_token1] = ACTIONS(631),
    [aux_sym_if_token1] = ACTIONS(631),
    [aux_sym_loop_token1] = ACTIONS(633),
    [aux_sym_handling_token1] = ACTIONS(631),
    [aux_sym_catch_token1] = ACTIONS(631),
    [aux_sym_throw_token1] = ACTIONS(631),
    [aux_sym_primitive_token1] = ACTIONS(631),
    [aux_sym_iterator_token1] = ACTIONS(631),
    [aux_sym_iterator_token2] = ACTIONS(631),
    [aux_sym_while_token1] = ACTIONS(631),
    [aux_sym_try_token1] = ACTIONS(631),
    [aux_sym_loopbody_token1] = ACTIONS(631),
    [aux_sym_leave_token1] = ACTIONS(631),
    [aux_sym_continue_token1] = ACTIONS(631),
    [aux_sym_protect_token1] = ACTIONS(631),
    [aux_sym_lock_token1] = ACTIONS(631),
    [aux_sym_pragma_token1] = ACTIONS(631),
    [anon_sym_PERCENT] = ACTIONS(631),
    [anon_sym_DQUOTE] = ACTIONS(631),
    [anon_sym_SQUOTE] = ACTIONS(631),
    [sym_regex_literal] = ACTIONS(631),
    [aux_sym_slot_accessor_token1] = ACTIONS(633),
    [aux_sym_true_token1] = ACTIONS(631),
    [aux_sym_false_token1] = ACTIONS(631),
    [aux_sym_maybe_token1] = ACTIONS(631),
    [aux_sym_unset_token1] = ACTIONS(631),
    [aux_sym_super_token1] = ACTIONS(631),
    [aux_sym_self_token1] = ACTIONS(631),
    [aux_sym_clone_token1] = ACTIONS(631),
    [aux_sym_thisthread_token1] = ACTIONS(631),
    [aux_sym_class_token1] = ACTIONS(631),
    [aux_sym_global_token1] = ACTIONS(631),
    [aux_sym_return_token1] = ACTIONS(631),
    [anon_sym_GT_GT] = ACTIONS(631),
    [aux_sym_scatter_token1] = ACTIONS(631),
    [aux_sym_allresults_token1] = ACTIONS(631),
    [sym_dynamic_variable] = ACTIONS(631),
    [sym_global_variable] = ACTIONS(631),
    [sym_global_reference] = ACTIONS(631),
    [sym_number] = ACTIONS(631),
    [anon_sym_LBRACE] = ACTIONS(631),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_PLUS] = ACTIONS(631),
    [aux_sym_unary_operator_token1] = ACTIONS(631),
    [anon_sym_TILDE] = ACTIONS(631),
    [sym_symbol] = ACTIONS(631),
    [sym_comment] = ACTIONS(103),
  },
  [57] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1742),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(151),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(635),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [58] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1740),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(152),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(637),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [59] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1739),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(150),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(639),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1833),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(210),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(641),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1850),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(145),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(643),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1841),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(204),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(645),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1706),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(235),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(647),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1915),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(212),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(649),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1844),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(199),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(651),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1872),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(139),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(653),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1903),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(240),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(655),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1935),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(237),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(657),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1869),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(158),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(659),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1851),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(175),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(661),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1912),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(203),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(663),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1939),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(242),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(665),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_fragment] = STATE(73),
    [sym__method_declaration] = STATE(1390),
    [sym_method] = STATE(1390),
    [sym_procedure] = STATE(996),
    [sym_block] = STATE(996),
    [sym_assignment] = STATE(996),
    [sym_if] = STATE(996),
    [sym_loop] = STATE(996),
    [sym_handling] = STATE(996),
    [sym_catch] = STATE(996),
    [sym_throw] = STATE(996),
    [sym_primitive] = STATE(996),
    [sym_iterator] = STATE(996),
    [sym_while] = STATE(996),
    [sym_try] = STATE(996),
    [sym_loopbody] = STATE(996),
    [sym_leave] = STATE(996),
    [sym_continue] = STATE(996),
    [sym_protect] = STATE(996),
    [sym_lock] = STATE(996),
    [sym_pragma] = STATE(247),
    [sym__literal] = STATE(996),
    [sym_character_literal] = STATE(996),
    [sym_string_literal] = STATE(996),
    [sym_call] = STATE(996),
    [sym_invoke] = STATE(996),
    [sym_indexed_access] = STATE(996),
    [sym_slot_accessor] = STATE(996),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_maybe] = STATE(996),
    [sym_unset] = STATE(996),
    [sym_super] = STATE(996),
    [sym_self] = STATE(996),
    [sym_clone] = STATE(996),
    [sym_thisthread] = STATE(996),
    [sym_class] = STATE(996),
    [sym__top_level_statement] = STATE(1390),
    [sym__expression] = STATE(996),
    [sym__global_assignment] = STATE(1390),
    [sym_return] = STATE(996),
    [sym__definition] = STATE(1390),
    [sym_gather] = STATE(996),
    [sym_scatter] = STATE(996),
    [sym_allresults] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym__variable] = STATE(996),
    [sym_variable] = STATE(996),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(996),
    [sym_relational_operator] = STATE(996),
    [sym_logical_operator] = STATE(996),
    [sym_arithmetic_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [aux_sym_fragment_repeat1] = STATE(124),
    [aux_sym_package_repeat1] = STATE(73),
    [ts_builtin_sym_end] = ACTIONS(667),
    [aux_sym_package_token1] = ACTIONS(667),
    [sym__dollar] = ACTIONS(667),
    [aux_sym_method_token1] = ACTIONS(669),
    [aux_sym_method_token2] = ACTIONS(672),
    [aux_sym_method_token3] = ACTIONS(675),
    [aux_sym_method_token4] = ACTIONS(678),
    [anon_sym_DOT] = ACTIONS(681),
    [anon_sym_LPAREN] = ACTIONS(684),
    [aux_sym_method_token6] = ACTIONS(687),
    [aux_sym_procedure_token1] = ACTIONS(690),
    [aux_sym_block_token1] = ACTIONS(693),
    [aux_sym_if_token1] = ACTIONS(696),
    [aux_sym_loop_token1] = ACTIONS(699),
    [aux_sym_handling_token1] = ACTIONS(702),
    [aux_sym_catch_token1] = ACTIONS(705),
    [aux_sym_throw_token1] = ACTIONS(708),
    [aux_sym_primitive_token1] = ACTIONS(711),
    [aux_sym_iterator_token1] = ACTIONS(714),
    [aux_sym_iterator_token2] = ACTIONS(717),
    [aux_sym_while_token1] = ACTIONS(720),
    [aux_sym_try_token1] = ACTIONS(723),
    [aux_sym_loopbody_token1] = ACTIONS(726),
    [aux_sym_leave_token1] = ACTIONS(729),
    [aux_sym_continue_token1] = ACTIONS(732),
    [aux_sym_protect_token1] = ACTIONS(735),
    [aux_sym_lock_token1] = ACTIONS(738),
    [aux_sym_pragma_token1] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(744),
    [anon_sym_DQUOTE] = ACTIONS(747),
    [anon_sym_SQUOTE] = ACTIONS(750),
    [sym_regex_literal] = ACTIONS(753),
    [aux_sym_slot_accessor_token1] = ACTIONS(756),
    [aux_sym_true_token1] = ACTIONS(759),
    [aux_sym_false_token1] = ACTIONS(762),
    [aux_sym_maybe_token1] = ACTIONS(765),
    [aux_sym_unset_token1] = ACTIONS(768),
    [aux_sym_super_token1] = ACTIONS(771),
    [aux_sym_self_token1] = ACTIONS(774),
    [aux_sym_clone_token1] = ACTIONS(777),
    [aux_sym_thisthread_token1] = ACTIONS(780),
    [aux_sym_class_token1] = ACTIONS(783),
    [aux_sym_global_token1] = ACTIONS(786),
    [aux_sym_return_token1] = ACTIONS(789),
    [anon_sym_GT_GT] = ACTIONS(792),
    [aux_sym_scatter_token1] = ACTIONS(795),
    [aux_sym_allresults_token1] = ACTIONS(798),
    [sym_dynamic_variable] = ACTIONS(753),
    [sym_global_variable] = ACTIONS(753),
    [sym_global_reference] = ACTIONS(753),
    [sym_number] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(801),
    [anon_sym_DASH] = ACTIONS(804),
    [anon_sym_PLUS] = ACTIONS(804),
    [aux_sym_unary_operator_token1] = ACTIONS(804),
    [anon_sym_TILDE] = ACTIONS(804),
    [sym_symbol] = ACTIONS(753),
    [sym_comment] = ACTIONS(103),
  },
  [74] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1730),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(140),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(807),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1710),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(229),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(809),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1953),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(144),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(811),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1913),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(236),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(813),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1907),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(202),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(815),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1769),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(186),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(817),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1861),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(147),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(819),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1760),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(168),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(821),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1728),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(138),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(823),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1936),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(162),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(825),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1709),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(208),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(827),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_finally] = STATE(1928),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1542),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(829),
    [aux_sym_finally_token1] = ACTIONS(551),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(831),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [86] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1779),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(165),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(833),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_finally] = STATE(1744),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1370),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(835),
    [aux_sym_finally_token1] = ACTIONS(551),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(837),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [88] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1945),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(149),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(839),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1865),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(141),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(841),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1919),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(230),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(843),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1875),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(194),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(845),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1707),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(211),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(847),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1783),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(170),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(849),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1930),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [sym_documentation] = STATE(238),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(851),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1765),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(853),
    [anon_sym_CARET_LT_LT] = ACTIONS(853),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(855),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [96] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1811),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_CARET_LT_LT] = ACTIONS(857),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(859),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [97] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1753),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_CARET_LT_LT] = ACTIONS(861),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(863),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [98] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1745),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(865),
    [anon_sym_CARET_LT_LT] = ACTIONS(865),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(867),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [99] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_finally] = STATE(1944),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1544),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(869),
    [aux_sym_finally_token1] = ACTIONS(551),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [100] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1675),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(871),
    [anon_sym_CARET_LT_LT] = ACTIONS(871),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(873),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [101] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1365),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_try_repeat2] = STATE(1363),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_try_token2] = ACTIONS(569),
    [aux_sym_try_token3] = ACTIONS(875),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [102] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1788),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(877),
    [anon_sym_CARET_LT_LT] = ACTIONS(877),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(879),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [103] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1547),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_if_token3] = ACTIONS(881),
    [aux_sym_elif_token1] = ACTIONS(881),
    [aux_sym_else_token1] = ACTIONS(881),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [104] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1775),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(883),
    [anon_sym_CARET_LT_LT] = ACTIONS(883),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(885),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [105] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1843),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(887),
    [anon_sym_CARET_LT_LT] = ACTIONS(887),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(889),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [106] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1787),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_CARET_LT_LT] = ACTIONS(891),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(893),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [107] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1860),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(895),
    [anon_sym_CARET_LT_LT] = ACTIONS(895),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(897),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [108] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1902),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_CARET_LT_LT] = ACTIONS(899),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(901),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [109] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1757),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_CARET_LT_LT] = ACTIONS(903),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(905),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [110] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1847),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(907),
    [anon_sym_CARET_LT_LT] = ACTIONS(907),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(909),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [111] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1720),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_CARET_LT_LT] = ACTIONS(911),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(913),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [112] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1938),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(915),
    [anon_sym_CARET_LT_LT] = ACTIONS(915),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(917),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [113] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1711),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(919),
    [anon_sym_CARET_LT_LT] = ACTIONS(919),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(921),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [114] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1908),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(923),
    [anon_sym_CARET_LT_LT] = ACTIONS(923),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(925),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [115] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1794),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_CARET_LT_LT] = ACTIONS(927),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(929),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [116] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1690),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(931),
    [anon_sym_CARET_LT_LT] = ACTIONS(931),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(933),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [117] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1790),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_CARET_LT_LT] = ACTIONS(935),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(937),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [118] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1821),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_CARET_LT_LT] = ACTIONS(939),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(941),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [119] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_finally] = STATE(1885),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1502),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(943),
    [aux_sym_finally_token1] = ACTIONS(551),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [120] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1723),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [anon_sym_LT_LT] = ACTIONS(945),
    [anon_sym_CARET_LT_LT] = ACTIONS(945),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(947),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [121] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_finally] = STATE(1697),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1381),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(949),
    [aux_sym_finally_token1] = ACTIONS(551),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [122] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1529),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_try_repeat2] = STATE(1527),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_try_token2] = ACTIONS(569),
    [aux_sym_try_token3] = ACTIONS(951),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [123] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_finally] = STATE(1817),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1476),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(953),
    [aux_sym_finally_token1] = ACTIONS(551),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [124] = {
    [sym__method_declaration] = STATE(1390),
    [sym_method] = STATE(1390),
    [sym_procedure] = STATE(996),
    [sym_block] = STATE(996),
    [sym_assignment] = STATE(996),
    [sym_if] = STATE(996),
    [sym_loop] = STATE(996),
    [sym_handling] = STATE(996),
    [sym_catch] = STATE(996),
    [sym_throw] = STATE(996),
    [sym_primitive] = STATE(996),
    [sym_iterator] = STATE(996),
    [sym_while] = STATE(996),
    [sym_try] = STATE(996),
    [sym_loopbody] = STATE(996),
    [sym_leave] = STATE(996),
    [sym_continue] = STATE(996),
    [sym_protect] = STATE(996),
    [sym_lock] = STATE(996),
    [sym_pragma] = STATE(247),
    [sym__literal] = STATE(996),
    [sym_character_literal] = STATE(996),
    [sym_string_literal] = STATE(996),
    [sym_call] = STATE(996),
    [sym_invoke] = STATE(996),
    [sym_indexed_access] = STATE(996),
    [sym_slot_accessor] = STATE(996),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_maybe] = STATE(996),
    [sym_unset] = STATE(996),
    [sym_super] = STATE(996),
    [sym_self] = STATE(996),
    [sym_clone] = STATE(996),
    [sym_thisthread] = STATE(996),
    [sym_class] = STATE(996),
    [sym__top_level_statement] = STATE(1390),
    [sym__expression] = STATE(996),
    [sym__global_assignment] = STATE(1390),
    [sym_return] = STATE(996),
    [sym__definition] = STATE(1390),
    [sym_gather] = STATE(996),
    [sym_scatter] = STATE(996),
    [sym_allresults] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym__variable] = STATE(996),
    [sym_variable] = STATE(996),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(996),
    [sym_relational_operator] = STATE(996),
    [sym_logical_operator] = STATE(996),
    [sym_arithmetic_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [aux_sym_fragment_repeat1] = STATE(132),
    [ts_builtin_sym_end] = ACTIONS(955),
    [aux_sym_package_token1] = ACTIONS(955),
    [sym__dollar] = ACTIONS(955),
    [aux_sym_method_token1] = ACTIONS(955),
    [aux_sym_method_token2] = ACTIONS(955),
    [aux_sym_method_token3] = ACTIONS(955),
    [aux_sym_method_token4] = ACTIONS(955),
    [anon_sym_DOT] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(955),
    [aux_sym_method_token6] = ACTIONS(955),
    [aux_sym_procedure_token1] = ACTIONS(955),
    [aux_sym_block_token1] = ACTIONS(955),
    [aux_sym_if_token1] = ACTIONS(955),
    [aux_sym_loop_token1] = ACTIONS(957),
    [aux_sym_handling_token1] = ACTIONS(955),
    [aux_sym_catch_token1] = ACTIONS(955),
    [aux_sym_throw_token1] = ACTIONS(955),
    [aux_sym_primitive_token1] = ACTIONS(955),
    [aux_sym_iterator_token1] = ACTIONS(955),
    [aux_sym_iterator_token2] = ACTIONS(955),
    [aux_sym_while_token1] = ACTIONS(955),
    [aux_sym_try_token1] = ACTIONS(955),
    [aux_sym_loopbody_token1] = ACTIONS(955),
    [aux_sym_leave_token1] = ACTIONS(955),
    [aux_sym_continue_token1] = ACTIONS(955),
    [aux_sym_protect_token1] = ACTIONS(955),
    [aux_sym_lock_token1] = ACTIONS(955),
    [aux_sym_pragma_token1] = ACTIONS(955),
    [anon_sym_PERCENT] = ACTIONS(955),
    [anon_sym_DQUOTE] = ACTIONS(955),
    [anon_sym_SQUOTE] = ACTIONS(955),
    [sym_regex_literal] = ACTIONS(955),
    [aux_sym_slot_accessor_token1] = ACTIONS(957),
    [aux_sym_true_token1] = ACTIONS(955),
    [aux_sym_false_token1] = ACTIONS(955),
    [aux_sym_maybe_token1] = ACTIONS(955),
    [aux_sym_unset_token1] = ACTIONS(955),
    [aux_sym_super_token1] = ACTIONS(955),
    [aux_sym_self_token1] = ACTIONS(955),
    [aux_sym_clone_token1] = ACTIONS(955),
    [aux_sym_thisthread_token1] = ACTIONS(955),
    [aux_sym_class_token1] = ACTIONS(955),
    [aux_sym_global_token1] = ACTIONS(955),
    [aux_sym_return_token1] = ACTIONS(955),
    [anon_sym_GT_GT] = ACTIONS(955),
    [aux_sym_scatter_token1] = ACTIONS(955),
    [aux_sym_allresults_token1] = ACTIONS(955),
    [sym_dynamic_variable] = ACTIONS(955),
    [sym_global_variable] = ACTIONS(955),
    [sym_global_reference] = ACTIONS(955),
    [sym_number] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(955),
    [anon_sym_DASH] = ACTIONS(955),
    [anon_sym_PLUS] = ACTIONS(955),
    [aux_sym_unary_operator_token1] = ACTIONS(955),
    [anon_sym_TILDE] = ACTIONS(955),
    [sym_symbol] = ACTIONS(955),
    [sym_comment] = ACTIONS(103),
  },
  [125] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1878),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_block_token2] = ACTIONS(959),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(961),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [126] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1886),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(963),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(965),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [127] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1698),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(967),
    [aux_sym_finally_token2] = ACTIONS(969),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [128] = {
    [sym_procedure] = STATE(825),
    [sym_block] = STATE(825),
    [sym_assignment] = STATE(825),
    [sym_if] = STATE(825),
    [sym_loop] = STATE(825),
    [sym_handling] = STATE(825),
    [sym_catch] = STATE(825),
    [sym_throw] = STATE(825),
    [sym_primitive] = STATE(825),
    [sym_iterator] = STATE(825),
    [sym_while] = STATE(825),
    [sym_try] = STATE(825),
    [sym_loopbody] = STATE(825),
    [sym_leave] = STATE(825),
    [sym_continue] = STATE(825),
    [sym_protect] = STATE(825),
    [sym_lock] = STATE(825),
    [sym__literal] = STATE(825),
    [sym_character_literal] = STATE(825),
    [sym_string_literal] = STATE(825),
    [sym_call] = STATE(825),
    [sym_invoke] = STATE(825),
    [sym_indexed_access] = STATE(825),
    [sym_slot_accessor] = STATE(825),
    [sym_true] = STATE(825),
    [sym_false] = STATE(825),
    [sym_maybe] = STATE(825),
    [sym_unset] = STATE(825),
    [sym_super] = STATE(825),
    [sym_self] = STATE(825),
    [sym_clone] = STATE(825),
    [sym_thisthread] = STATE(825),
    [sym_class] = STATE(825),
    [sym__expression] = STATE(825),
    [sym__codeblock] = STATE(1755),
    [sym__defvar] = STATE(1065),
    [sym_global] = STATE(1065),
    [sym_local] = STATE(1065),
    [sym_constant] = STATE(1065),
    [sym_dynamic] = STATE(1065),
    [sym_import] = STATE(1065),
    [sym_dynamic_import] = STATE(1065),
    [sym_return] = STATE(825),
    [sym_gather] = STATE(825),
    [sym_scatter] = STATE(825),
    [sym_allresults] = STATE(825),
    [sym_parenthesized_expression] = STATE(825),
    [sym__variable] = STATE(825),
    [sym_variable] = STATE(825),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(825),
    [sym_relational_operator] = STATE(825),
    [sym_logical_operator] = STATE(825),
    [sym_arithmetic_operator] = STATE(825),
    [sym_unary_operator] = STATE(825),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token2] = ACTIONS(981),
    [aux_sym_protect_token3] = ACTIONS(983),
    [aux_sym_lock_token1] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(985),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(987),
    [aux_sym__global_assignment_token1] = ACTIONS(989),
    [aux_sym_dynamic_token1] = ACTIONS(991),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(985),
    [sym_global_variable] = ACTIONS(985),
    [sym_global_reference] = ACTIONS(985),
    [sym_number] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(985),
    [sym_comment] = ACTIONS(103),
  },
  [129] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1870),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(1003),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(1005),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [130] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1871),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_block_token2] = ACTIONS(1007),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(1009),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [131] = {
    [sym_procedure] = STATE(825),
    [sym_block] = STATE(825),
    [sym_assignment] = STATE(825),
    [sym_if] = STATE(825),
    [sym_loop] = STATE(825),
    [sym_handling] = STATE(825),
    [sym_catch] = STATE(825),
    [sym_throw] = STATE(825),
    [sym_primitive] = STATE(825),
    [sym_iterator] = STATE(825),
    [sym_while] = STATE(825),
    [sym_try] = STATE(825),
    [sym_loopbody] = STATE(825),
    [sym_leave] = STATE(825),
    [sym_continue] = STATE(825),
    [sym_protect] = STATE(825),
    [sym_lock] = STATE(825),
    [sym__literal] = STATE(825),
    [sym_character_literal] = STATE(825),
    [sym_string_literal] = STATE(825),
    [sym_call] = STATE(825),
    [sym_invoke] = STATE(825),
    [sym_indexed_access] = STATE(825),
    [sym_slot_accessor] = STATE(825),
    [sym_true] = STATE(825),
    [sym_false] = STATE(825),
    [sym_maybe] = STATE(825),
    [sym_unset] = STATE(825),
    [sym_super] = STATE(825),
    [sym_self] = STATE(825),
    [sym_clone] = STATE(825),
    [sym_thisthread] = STATE(825),
    [sym_class] = STATE(825),
    [sym__expression] = STATE(825),
    [sym__codeblock] = STATE(1862),
    [sym__defvar] = STATE(1065),
    [sym_global] = STATE(1065),
    [sym_local] = STATE(1065),
    [sym_constant] = STATE(1065),
    [sym_dynamic] = STATE(1065),
    [sym_import] = STATE(1065),
    [sym_dynamic_import] = STATE(1065),
    [sym_return] = STATE(825),
    [sym_gather] = STATE(825),
    [sym_scatter] = STATE(825),
    [sym_allresults] = STATE(825),
    [sym_parenthesized_expression] = STATE(825),
    [sym__variable] = STATE(825),
    [sym_variable] = STATE(825),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(825),
    [sym_relational_operator] = STATE(825),
    [sym_logical_operator] = STATE(825),
    [sym_arithmetic_operator] = STATE(825),
    [sym_unary_operator] = STATE(825),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token2] = ACTIONS(1011),
    [aux_sym_protect_token3] = ACTIONS(1013),
    [aux_sym_lock_token1] = ACTIONS(145),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(985),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(987),
    [aux_sym__global_assignment_token1] = ACTIONS(989),
    [aux_sym_dynamic_token1] = ACTIONS(991),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(985),
    [sym_global_variable] = ACTIONS(985),
    [sym_global_reference] = ACTIONS(985),
    [sym_number] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(985),
    [sym_comment] = ACTIONS(103),
  },
  [132] = {
    [sym__method_declaration] = STATE(1390),
    [sym_method] = STATE(1390),
    [sym_procedure] = STATE(996),
    [sym_block] = STATE(996),
    [sym_assignment] = STATE(996),
    [sym_if] = STATE(996),
    [sym_loop] = STATE(996),
    [sym_handling] = STATE(996),
    [sym_catch] = STATE(996),
    [sym_throw] = STATE(996),
    [sym_primitive] = STATE(996),
    [sym_iterator] = STATE(996),
    [sym_while] = STATE(996),
    [sym_try] = STATE(996),
    [sym_loopbody] = STATE(996),
    [sym_leave] = STATE(996),
    [sym_continue] = STATE(996),
    [sym_protect] = STATE(996),
    [sym_lock] = STATE(996),
    [sym_pragma] = STATE(247),
    [sym__literal] = STATE(996),
    [sym_character_literal] = STATE(996),
    [sym_string_literal] = STATE(996),
    [sym_call] = STATE(996),
    [sym_invoke] = STATE(996),
    [sym_indexed_access] = STATE(996),
    [sym_slot_accessor] = STATE(996),
    [sym_true] = STATE(996),
    [sym_false] = STATE(996),
    [sym_maybe] = STATE(996),
    [sym_unset] = STATE(996),
    [sym_super] = STATE(996),
    [sym_self] = STATE(996),
    [sym_clone] = STATE(996),
    [sym_thisthread] = STATE(996),
    [sym_class] = STATE(996),
    [sym__top_level_statement] = STATE(1390),
    [sym__expression] = STATE(996),
    [sym__global_assignment] = STATE(1390),
    [sym_return] = STATE(996),
    [sym__definition] = STATE(1390),
    [sym_gather] = STATE(996),
    [sym_scatter] = STATE(996),
    [sym_allresults] = STATE(996),
    [sym_parenthesized_expression] = STATE(996),
    [sym__variable] = STATE(996),
    [sym_variable] = STATE(996),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(996),
    [sym_relational_operator] = STATE(996),
    [sym_logical_operator] = STATE(996),
    [sym_arithmetic_operator] = STATE(996),
    [sym_unary_operator] = STATE(996),
    [aux_sym_fragment_repeat1] = STATE(132),
    [ts_builtin_sym_end] = ACTIONS(1015),
    [aux_sym_package_token1] = ACTIONS(1015),
    [sym__dollar] = ACTIONS(1015),
    [aux_sym_method_token1] = ACTIONS(1017),
    [aux_sym_method_token2] = ACTIONS(1020),
    [aux_sym_method_token3] = ACTIONS(1023),
    [aux_sym_method_token4] = ACTIONS(1026),
    [anon_sym_DOT] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1032),
    [aux_sym_method_token6] = ACTIONS(1035),
    [aux_sym_procedure_token1] = ACTIONS(1038),
    [aux_sym_block_token1] = ACTIONS(1041),
    [aux_sym_if_token1] = ACTIONS(1044),
    [aux_sym_loop_token1] = ACTIONS(1047),
    [aux_sym_handling_token1] = ACTIONS(1050),
    [aux_sym_catch_token1] = ACTIONS(1053),
    [aux_sym_throw_token1] = ACTIONS(1056),
    [aux_sym_primitive_token1] = ACTIONS(1059),
    [aux_sym_iterator_token1] = ACTIONS(1062),
    [aux_sym_iterator_token2] = ACTIONS(1065),
    [aux_sym_while_token1] = ACTIONS(1068),
    [aux_sym_try_token1] = ACTIONS(1071),
    [aux_sym_loopbody_token1] = ACTIONS(1074),
    [aux_sym_leave_token1] = ACTIONS(1077),
    [aux_sym_continue_token1] = ACTIONS(1080),
    [aux_sym_protect_token1] = ACTIONS(1083),
    [aux_sym_lock_token1] = ACTIONS(1086),
    [aux_sym_pragma_token1] = ACTIONS(1089),
    [anon_sym_PERCENT] = ACTIONS(1092),
    [anon_sym_DQUOTE] = ACTIONS(1095),
    [anon_sym_SQUOTE] = ACTIONS(1098),
    [sym_regex_literal] = ACTIONS(1101),
    [aux_sym_slot_accessor_token1] = ACTIONS(1104),
    [aux_sym_true_token1] = ACTIONS(1107),
    [aux_sym_false_token1] = ACTIONS(1110),
    [aux_sym_maybe_token1] = ACTIONS(1113),
    [aux_sym_unset_token1] = ACTIONS(1116),
    [aux_sym_super_token1] = ACTIONS(1119),
    [aux_sym_self_token1] = ACTIONS(1122),
    [aux_sym_clone_token1] = ACTIONS(1125),
    [aux_sym_thisthread_token1] = ACTIONS(1128),
    [aux_sym_class_token1] = ACTIONS(1131),
    [aux_sym_global_token1] = ACTIONS(1134),
    [aux_sym_return_token1] = ACTIONS(1137),
    [anon_sym_GT_GT] = ACTIONS(1140),
    [aux_sym_scatter_token1] = ACTIONS(1143),
    [aux_sym_allresults_token1] = ACTIONS(1146),
    [sym_dynamic_variable] = ACTIONS(1101),
    [sym_global_variable] = ACTIONS(1101),
    [sym_global_reference] = ACTIONS(1101),
    [sym_number] = ACTIONS(1101),
    [anon_sym_LBRACE] = ACTIONS(1149),
    [anon_sym_DASH] = ACTIONS(1152),
    [anon_sym_PLUS] = ACTIONS(1152),
    [aux_sym_unary_operator_token1] = ACTIONS(1152),
    [anon_sym_TILDE] = ACTIONS(1152),
    [sym_symbol] = ACTIONS(1101),
    [sym_comment] = ACTIONS(103),
  },
  [133] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1741),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(1155),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(1157),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [134] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1926),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(1159),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_label] = ACTIONS(1161),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(555),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [135] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1873),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(593),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [136] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1902),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(901),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [137] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1860),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(897),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [138] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1769),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(817),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [139] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1875),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(845),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [140] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1773),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(577),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [141] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1888),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(583),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [142] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1675),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(873),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [143] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1832),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(1163),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [144] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1923),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(587),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [145] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1879),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1165),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [146] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1821),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(941),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [147] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1877),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(589),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [148] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1843),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(889),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [149] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1939),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(665),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [150] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1776),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(629),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [151] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1780),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1167),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [152] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1696),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(561),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [153] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1784),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(547),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [154] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1812),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(1169),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [155] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1892),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(1171),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [156] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1788),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(879),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [157] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1811),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(859),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [158] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1896),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(591),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [159] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1794),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(929),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [160] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1883),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(1173),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [161] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1795),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(563),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [162] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1806),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(619),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [163] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1790),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(937),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [164] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1906),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(595),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [165] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1685),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(573),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [166] = {
    [sym_procedure] = STATE(825),
    [sym_block] = STATE(825),
    [sym_assignment] = STATE(825),
    [sym_if] = STATE(825),
    [sym_loop] = STATE(825),
    [sym_handling] = STATE(825),
    [sym_catch] = STATE(825),
    [sym_throw] = STATE(825),
    [sym_primitive] = STATE(825),
    [sym_iterator] = STATE(825),
    [sym_while] = STATE(825),
    [sym_try] = STATE(825),
    [sym_loopbody] = STATE(825),
    [sym_leave] = STATE(825),
    [sym_continue] = STATE(825),
    [sym_protect] = STATE(825),
    [sym_lock] = STATE(825),
    [sym__literal] = STATE(825),
    [sym_character_literal] = STATE(825),
    [sym_string_literal] = STATE(825),
    [sym_call] = STATE(825),
    [sym_invoke] = STATE(825),
    [sym_indexed_access] = STATE(825),
    [sym_slot_accessor] = STATE(825),
    [sym_true] = STATE(825),
    [sym_false] = STATE(825),
    [sym_maybe] = STATE(825),
    [sym_unset] = STATE(825),
    [sym_super] = STATE(825),
    [sym_self] = STATE(825),
    [sym_clone] = STATE(825),
    [sym_thisthread] = STATE(825),
    [sym_class] = STATE(825),
    [sym__expression] = STATE(825),
    [sym__codeblock] = STATE(1688),
    [sym__defvar] = STATE(1065),
    [sym_global] = STATE(1065),
    [sym_local] = STATE(1065),
    [sym_constant] = STATE(1065),
    [sym_dynamic] = STATE(1065),
    [sym_import] = STATE(1065),
    [sym_dynamic_import] = STATE(1065),
    [sym_return] = STATE(825),
    [sym_gather] = STATE(825),
    [sym_scatter] = STATE(825),
    [sym_allresults] = STATE(825),
    [sym_parenthesized_expression] = STATE(825),
    [sym__variable] = STATE(825),
    [sym_variable] = STATE(825),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(825),
    [sym_relational_operator] = STATE(825),
    [sym_logical_operator] = STATE(825),
    [sym_arithmetic_operator] = STATE(825),
    [sym_unary_operator] = STATE(825),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token3] = ACTIONS(1175),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(985),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(987),
    [aux_sym__global_assignment_token1] = ACTIONS(989),
    [aux_sym_dynamic_token1] = ACTIONS(991),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(985),
    [sym_global_variable] = ACTIONS(985),
    [sym_global_reference] = ACTIONS(985),
    [sym_number] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(985),
    [sym_comment] = ACTIONS(103),
  },
  [167] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1909),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [aux_sym_lock_token2] = ACTIONS(1177),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [168] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1935),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(657),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [169] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1787),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(893),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [170] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1682),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1179),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [171] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1911),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(1181),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [172] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1747),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_catch_token2] = ACTIONS(1183),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [173] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1677),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(581),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [174] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1775),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(885),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [175] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1869),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(659),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [176] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1706),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(647),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [177] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1919),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(843),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [178] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1676),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(585),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [179] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1827),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(1185),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [180] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1693),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(1187),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [181] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1721),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1189),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [182] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1825),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(1191),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [183] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1753),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(863),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [184] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1690),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(933),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [185] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1866),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(1193),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [186] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1804),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(575),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [187] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1808),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1195),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [188] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1745),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(867),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [189] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1814),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(597),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [190] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1950),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(1197),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [191] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1711),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(921),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [192] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1738),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(1199),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [193] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1822),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(605),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [194] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1699),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(613),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [195] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1735),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(1201),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [196] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1734),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [aux_sym_lock_token2] = ACTIONS(1203),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [197] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1672),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(1205),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [198] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1702),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_if_token3] = ACTIONS(1207),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [199] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1865),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(841),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [200] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1930),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(851),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [201] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1945),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(839),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [202] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1900),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1209),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [203] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1904),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1211),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [204] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1861),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(819),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [205] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1760),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(821),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [206] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1931),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_catch_token2] = ACTIONS(1213),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [207] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1723),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(947),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [208] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1936),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(825),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [209] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1835),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(1215),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [210] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1856),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(543),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [211] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1933),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1217),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [212] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1907),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(815),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [213] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1730),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(807),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [214] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1920),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(623),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [215] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1739),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(639),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [216] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1836),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_block_token2] = ACTIONS(1219),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [217] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1851),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(661),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [218] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1716),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(607),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [219] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1910),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1221),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [220] = {
    [sym_procedure] = STATE(825),
    [sym_block] = STATE(825),
    [sym_assignment] = STATE(825),
    [sym_if] = STATE(825),
    [sym_loop] = STATE(825),
    [sym_handling] = STATE(825),
    [sym_catch] = STATE(825),
    [sym_throw] = STATE(825),
    [sym_primitive] = STATE(825),
    [sym_iterator] = STATE(825),
    [sym_while] = STATE(825),
    [sym_try] = STATE(825),
    [sym_loopbody] = STATE(825),
    [sym_leave] = STATE(825),
    [sym_continue] = STATE(825),
    [sym_protect] = STATE(825),
    [sym_lock] = STATE(825),
    [sym__literal] = STATE(825),
    [sym_character_literal] = STATE(825),
    [sym_string_literal] = STATE(825),
    [sym_call] = STATE(825),
    [sym_invoke] = STATE(825),
    [sym_indexed_access] = STATE(825),
    [sym_slot_accessor] = STATE(825),
    [sym_true] = STATE(825),
    [sym_false] = STATE(825),
    [sym_maybe] = STATE(825),
    [sym_unset] = STATE(825),
    [sym_super] = STATE(825),
    [sym_self] = STATE(825),
    [sym_clone] = STATE(825),
    [sym_thisthread] = STATE(825),
    [sym_class] = STATE(825),
    [sym__expression] = STATE(825),
    [sym__codeblock] = STATE(1797),
    [sym__defvar] = STATE(1065),
    [sym_global] = STATE(1065),
    [sym_local] = STATE(1065),
    [sym_constant] = STATE(1065),
    [sym_dynamic] = STATE(1065),
    [sym_import] = STATE(1065),
    [sym_dynamic_import] = STATE(1065),
    [sym_return] = STATE(825),
    [sym_gather] = STATE(825),
    [sym_scatter] = STATE(825),
    [sym_allresults] = STATE(825),
    [sym_parenthesized_expression] = STATE(825),
    [sym__variable] = STATE(825),
    [sym_variable] = STATE(825),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(825),
    [sym_relational_operator] = STATE(825),
    [sym_logical_operator] = STATE(825),
    [sym_arithmetic_operator] = STATE(825),
    [sym_unary_operator] = STATE(825),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token3] = ACTIONS(1223),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(985),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(987),
    [aux_sym__global_assignment_token1] = ACTIONS(989),
    [aux_sym_dynamic_token1] = ACTIONS(991),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(985),
    [sym_global_variable] = ACTIONS(985),
    [sym_global_reference] = ACTIONS(985),
    [sym_number] = ACTIONS(985),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(985),
    [sym_comment] = ACTIONS(103),
  },
  [221] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1761),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(609),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [222] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1921),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_block_token2] = ACTIONS(1225),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [223] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1731),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_loop_token2] = ACTIONS(1227),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [224] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1757),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(905),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [225] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1829),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(611),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [226] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1847),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_procedure_token2] = ACTIONS(909),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [227] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1710),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(809),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [228] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1844),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(651),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [229] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1756),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1229),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [230] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1953),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(811),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [231] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1912),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(663),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [232] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1841),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(645),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [233] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1948),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(1231),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [234] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1833),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(641),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [235] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1748),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(627),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [236] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1746),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1233),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [237] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1915),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(649),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [238] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1947),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(625),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [239] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1742),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(635),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [240] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1740),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(637),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [241] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1771),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_protect_token4] = ACTIONS(1235),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [242] = {
    [sym_procedure] = STATE(566),
    [sym_block] = STATE(566),
    [sym_assignment] = STATE(566),
    [sym_if] = STATE(566),
    [sym_loop] = STATE(566),
    [sym_handling] = STATE(566),
    [sym_catch] = STATE(566),
    [sym_throw] = STATE(566),
    [sym_primitive] = STATE(566),
    [sym_iterator] = STATE(566),
    [sym_while] = STATE(566),
    [sym_try] = STATE(566),
    [sym_loopbody] = STATE(566),
    [sym_leave] = STATE(566),
    [sym_continue] = STATE(566),
    [sym_protect] = STATE(566),
    [sym_lock] = STATE(566),
    [sym__literal] = STATE(566),
    [sym_character_literal] = STATE(566),
    [sym_string_literal] = STATE(566),
    [sym_call] = STATE(566),
    [sym_invoke] = STATE(566),
    [sym_indexed_access] = STATE(566),
    [sym_slot_accessor] = STATE(566),
    [sym_true] = STATE(566),
    [sym_false] = STATE(566),
    [sym_maybe] = STATE(566),
    [sym_unset] = STATE(566),
    [sym_super] = STATE(566),
    [sym_self] = STATE(566),
    [sym_clone] = STATE(566),
    [sym_thisthread] = STATE(566),
    [sym_class] = STATE(566),
    [sym__expression] = STATE(566),
    [sym__codeblock] = STATE(1917),
    [sym__defvar] = STATE(1029),
    [sym_global] = STATE(1029),
    [sym_local] = STATE(1029),
    [sym_constant] = STATE(1029),
    [sym_dynamic] = STATE(1029),
    [sym_import] = STATE(1029),
    [sym_dynamic_import] = STATE(1029),
    [sym_return] = STATE(566),
    [sym_gather] = STATE(566),
    [sym_scatter] = STATE(566),
    [sym_allresults] = STATE(566),
    [sym_parenthesized_expression] = STATE(566),
    [sym__variable] = STATE(566),
    [sym_variable] = STATE(566),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(566),
    [sym_relational_operator] = STATE(566),
    [sym_logical_operator] = STATE(566),
    [sym_arithmetic_operator] = STATE(566),
    [sym_unary_operator] = STATE(566),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_method_token7] = ACTIONS(1237),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(385),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(385),
    [sym_global_variable] = ACTIONS(385),
    [sym_global_reference] = ACTIONS(385),
    [sym_number] = ACTIONS(385),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(385),
    [sym_comment] = ACTIONS(103),
  },
  [243] = {
    [sym_procedure] = STATE(952),
    [sym_block] = STATE(952),
    [sym_assignment] = STATE(952),
    [sym_if] = STATE(952),
    [sym_loop] = STATE(952),
    [sym_handling] = STATE(952),
    [sym_catch] = STATE(952),
    [sym_throw] = STATE(952),
    [sym_primitive] = STATE(952),
    [sym_iterator] = STATE(952),
    [sym_while] = STATE(952),
    [sym_try] = STATE(952),
    [sym_loopbody] = STATE(952),
    [sym_leave] = STATE(952),
    [sym_continue] = STATE(952),
    [sym_protect] = STATE(952),
    [sym_lock] = STATE(952),
    [sym__literal] = STATE(952),
    [sym_character_literal] = STATE(952),
    [sym_string_literal] = STATE(952),
    [sym_call] = STATE(952),
    [sym_invoke] = STATE(952),
    [sym_indexed_access] = STATE(952),
    [sym_slot_accessor] = STATE(952),
    [sym_true] = STATE(952),
    [sym_false] = STATE(952),
    [sym_maybe] = STATE(952),
    [sym_unset] = STATE(952),
    [sym_super] = STATE(952),
    [sym_self] = STATE(952),
    [sym_clone] = STATE(952),
    [sym_thisthread] = STATE(952),
    [sym_class] = STATE(952),
    [sym__expression] = STATE(952),
    [sym__defvar] = STATE(1052),
    [sym_global] = STATE(1052),
    [sym_local] = STATE(1052),
    [sym_constant] = STATE(1052),
    [sym_dynamic] = STATE(1052),
    [sym_import] = STATE(1052),
    [sym_dynamic_import] = STATE(1052),
    [sym_return] = STATE(952),
    [sym_gather] = STATE(952),
    [sym_scatter] = STATE(952),
    [sym_allresults] = STATE(952),
    [sym_parenthesized_expression] = STATE(952),
    [sym__variable] = STATE(952),
    [sym_variable] = STATE(952),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(952),
    [sym_relational_operator] = STATE(952),
    [sym_logical_operator] = STATE(952),
    [sym_arithmetic_operator] = STATE(952),
    [sym_unary_operator] = STATE(952),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token3] = ACTIONS(363),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1239),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(987),
    [aux_sym__global_assignment_token1] = ACTIONS(989),
    [aux_sym_dynamic_token1] = ACTIONS(991),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_global_reference] = ACTIONS(1239),
    [sym_number] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1239),
    [sym_comment] = ACTIONS(103),
  },
  [244] = {
    [sym_procedure] = STATE(952),
    [sym_block] = STATE(952),
    [sym_assignment] = STATE(952),
    [sym_if] = STATE(952),
    [sym_loop] = STATE(952),
    [sym_handling] = STATE(952),
    [sym_catch] = STATE(952),
    [sym_throw] = STATE(952),
    [sym_primitive] = STATE(952),
    [sym_iterator] = STATE(952),
    [sym_while] = STATE(952),
    [sym_try] = STATE(952),
    [sym_loopbody] = STATE(952),
    [sym_leave] = STATE(952),
    [sym_continue] = STATE(952),
    [sym_protect] = STATE(952),
    [sym_lock] = STATE(952),
    [sym__literal] = STATE(952),
    [sym_character_literal] = STATE(952),
    [sym_string_literal] = STATE(952),
    [sym_call] = STATE(952),
    [sym_invoke] = STATE(952),
    [sym_indexed_access] = STATE(952),
    [sym_slot_accessor] = STATE(952),
    [sym_true] = STATE(952),
    [sym_false] = STATE(952),
    [sym_maybe] = STATE(952),
    [sym_unset] = STATE(952),
    [sym_super] = STATE(952),
    [sym_self] = STATE(952),
    [sym_clone] = STATE(952),
    [sym_thisthread] = STATE(952),
    [sym_class] = STATE(952),
    [sym__expression] = STATE(952),
    [sym__defvar] = STATE(1052),
    [sym_global] = STATE(1052),
    [sym_local] = STATE(1052),
    [sym_constant] = STATE(1052),
    [sym_dynamic] = STATE(1052),
    [sym_import] = STATE(1052),
    [sym_dynamic_import] = STATE(1052),
    [sym_return] = STATE(952),
    [sym_gather] = STATE(952),
    [sym_scatter] = STATE(952),
    [sym_allresults] = STATE(952),
    [sym_parenthesized_expression] = STATE(952),
    [sym__variable] = STATE(952),
    [sym_variable] = STATE(952),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(952),
    [sym_relational_operator] = STATE(952),
    [sym_logical_operator] = STATE(952),
    [sym_arithmetic_operator] = STATE(952),
    [sym_unary_operator] = STATE(952),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(143),
    [aux_sym_protect_token3] = ACTIONS(377),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1239),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(987),
    [aux_sym__global_assignment_token1] = ACTIONS(989),
    [aux_sym_dynamic_token1] = ACTIONS(991),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_global_reference] = ACTIONS(1239),
    [sym_number] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1239),
    [sym_comment] = ACTIONS(103),
  },
  [245] = {
    [sym_procedure] = STATE(674),
    [sym_block] = STATE(674),
    [sym_assignment] = STATE(674),
    [sym_if] = STATE(674),
    [sym_loop] = STATE(674),
    [sym_handling] = STATE(674),
    [sym_catch] = STATE(674),
    [sym_throw] = STATE(674),
    [sym_primitive] = STATE(674),
    [sym_iterator] = STATE(674),
    [sym_while] = STATE(674),
    [sym_try] = STATE(674),
    [sym_loopbody] = STATE(674),
    [sym_leave] = STATE(674),
    [sym_continue] = STATE(674),
    [sym_protect] = STATE(674),
    [sym_lock] = STATE(674),
    [sym__literal] = STATE(674),
    [sym_character_literal] = STATE(674),
    [sym_string_literal] = STATE(674),
    [sym_call] = STATE(674),
    [sym_invoke] = STATE(674),
    [sym_indexed_access] = STATE(674),
    [sym_slot_accessor] = STATE(674),
    [sym_true] = STATE(674),
    [sym_false] = STATE(674),
    [sym_maybe] = STATE(674),
    [sym_unset] = STATE(674),
    [sym_super] = STATE(674),
    [sym_self] = STATE(674),
    [sym_clone] = STATE(674),
    [sym_thisthread] = STATE(674),
    [sym_class] = STATE(674),
    [sym__expression] = STATE(674),
    [sym__defvar] = STATE(1052),
    [sym_global] = STATE(1052),
    [sym_local] = STATE(1052),
    [sym_constant] = STATE(1052),
    [sym_dynamic] = STATE(1052),
    [sym_import] = STATE(1052),
    [sym_dynamic_import] = STATE(1052),
    [sym_return] = STATE(674),
    [sym_gather] = STATE(674),
    [sym_scatter] = STATE(674),
    [sym_allresults] = STATE(674),
    [sym_parenthesized_expression] = STATE(674),
    [sym__variable] = STATE(674),
    [sym_variable] = STATE(674),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(674),
    [sym_relational_operator] = STATE(674),
    [sym_logical_operator] = STATE(674),
    [sym_arithmetic_operator] = STATE(674),
    [sym_unary_operator] = STATE(674),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(365),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(369),
    [aux_sym__global_assignment_token1] = ACTIONS(371),
    [aux_sym_dynamic_token1] = ACTIONS(373),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(365),
    [sym_global_variable] = ACTIONS(365),
    [sym_global_reference] = ACTIONS(365),
    [sym_number] = ACTIONS(365),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(365),
    [sym_comment] = ACTIONS(103),
  },
  [246] = {
    [sym_procedure] = STATE(952),
    [sym_block] = STATE(952),
    [sym_assignment] = STATE(952),
    [sym_if] = STATE(952),
    [sym_loop] = STATE(952),
    [sym_handling] = STATE(952),
    [sym_catch] = STATE(952),
    [sym_throw] = STATE(952),
    [sym_primitive] = STATE(952),
    [sym_iterator] = STATE(952),
    [sym_while] = STATE(952),
    [sym_try] = STATE(952),
    [sym_loopbody] = STATE(952),
    [sym_leave] = STATE(952),
    [sym_continue] = STATE(952),
    [sym_protect] = STATE(952),
    [sym_lock] = STATE(952),
    [sym__literal] = STATE(952),
    [sym_character_literal] = STATE(952),
    [sym_string_literal] = STATE(952),
    [sym_call] = STATE(952),
    [sym_invoke] = STATE(952),
    [sym_indexed_access] = STATE(952),
    [sym_slot_accessor] = STATE(952),
    [sym_true] = STATE(952),
    [sym_false] = STATE(952),
    [sym_maybe] = STATE(952),
    [sym_unset] = STATE(952),
    [sym_super] = STATE(952),
    [sym_self] = STATE(952),
    [sym_clone] = STATE(952),
    [sym_thisthread] = STATE(952),
    [sym_class] = STATE(952),
    [sym__expression] = STATE(952),
    [sym__defvar] = STATE(1052),
    [sym_global] = STATE(1052),
    [sym_local] = STATE(1052),
    [sym_constant] = STATE(1052),
    [sym_dynamic] = STATE(1052),
    [sym_import] = STATE(1052),
    [sym_dynamic_import] = STATE(1052),
    [sym_return] = STATE(952),
    [sym_gather] = STATE(952),
    [sym_scatter] = STATE(952),
    [sym_allresults] = STATE(952),
    [sym_parenthesized_expression] = STATE(952),
    [sym__variable] = STATE(952),
    [sym_variable] = STATE(952),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(952),
    [sym_relational_operator] = STATE(952),
    [sym_logical_operator] = STATE(952),
    [sym_arithmetic_operator] = STATE(952),
    [sym_unary_operator] = STATE(952),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1239),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_global_token1] = ACTIONS(367),
    [aux_sym_local_token1] = ACTIONS(987),
    [aux_sym__global_assignment_token1] = ACTIONS(989),
    [aux_sym_dynamic_token1] = ACTIONS(991),
    [aux_sym_import_token1] = ACTIONS(375),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1239),
    [sym_global_variable] = ACTIONS(1239),
    [sym_global_reference] = ACTIONS(1239),
    [sym_number] = ACTIONS(1239),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1239),
    [sym_comment] = ACTIONS(103),
  },
  [247] = {
    [sym_method] = STATE(1602),
    [sym_procedure] = STATE(1022),
    [sym_block] = STATE(1022),
    [sym_assignment] = STATE(1022),
    [sym_if] = STATE(1022),
    [sym_loop] = STATE(1022),
    [sym_handling] = STATE(1022),
    [sym_catch] = STATE(1022),
    [sym_throw] = STATE(1022),
    [sym_primitive] = STATE(1022),
    [sym_iterator] = STATE(1022),
    [sym_while] = STATE(1022),
    [sym_try] = STATE(1022),
    [sym_loopbody] = STATE(1022),
    [sym_leave] = STATE(1022),
    [sym_continue] = STATE(1022),
    [sym_protect] = STATE(1022),
    [sym_lock] = STATE(1022),
    [sym__literal] = STATE(1022),
    [sym_character_literal] = STATE(1022),
    [sym_string_literal] = STATE(1022),
    [sym_call] = STATE(998),
    [sym_invoke] = STATE(998),
    [sym_indexed_access] = STATE(1022),
    [sym_slot_accessor] = STATE(1022),
    [sym_true] = STATE(1022),
    [sym_false] = STATE(1022),
    [sym_maybe] = STATE(1022),
    [sym_unset] = STATE(1022),
    [sym_super] = STATE(1022),
    [sym_self] = STATE(1022),
    [sym_clone] = STATE(1022),
    [sym_thisthread] = STATE(1022),
    [sym_class] = STATE(1022),
    [sym__expression] = STATE(1022),
    [sym_return] = STATE(1022),
    [sym_gather] = STATE(1022),
    [sym_scatter] = STATE(1022),
    [sym_allresults] = STATE(1022),
    [sym_parenthesized_expression] = STATE(1022),
    [sym__variable] = STATE(1022),
    [sym_variable] = STATE(1022),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1022),
    [sym_relational_operator] = STATE(1022),
    [sym_logical_operator] = STATE(1022),
    [sym_arithmetic_operator] = STATE(1022),
    [sym_unary_operator] = STATE(1022),
    [sym_documentation] = STATE(441),
    [aux_sym_documentation_repeat1] = STATE(682),
    [aux_sym_method_token1] = ACTIONS(11),
    [aux_sym_method_token2] = ACTIONS(13),
    [aux_sym_method_token3] = ACTIONS(1241),
    [aux_sym_method_token4] = ACTIONS(17),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1251),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_global_token1] = ACTIONS(1253),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1251),
    [sym_global_variable] = ACTIONS(1251),
    [sym_global_reference] = ACTIONS(1251),
    [sym_number] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1251),
    [aux_sym_documentation_token1] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
  },
  [248] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1942),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [249] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1940),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [250] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1796),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [anon_sym_RBRACK] = ACTIONS(1265),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [251] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1802),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [anon_sym_RPAREN] = ACTIONS(1267),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [252] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1867),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [anon_sym_RPAREN] = ACTIONS(1269),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [253] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1687),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [254] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1857),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [255] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1899),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_RBRACE] = ACTIONS(1275),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [256] = {
    [sym_procedure] = STATE(927),
    [sym_block] = STATE(927),
    [sym_assignment] = STATE(927),
    [sym_if] = STATE(927),
    [sym_loop] = STATE(927),
    [sym_handling] = STATE(927),
    [sym_catch] = STATE(927),
    [sym_throw] = STATE(927),
    [sym_primitive] = STATE(927),
    [sym_iterator] = STATE(927),
    [sym_while] = STATE(927),
    [sym_try] = STATE(927),
    [sym_loopbody] = STATE(927),
    [sym_leave] = STATE(927),
    [sym_continue] = STATE(927),
    [sym_protect] = STATE(927),
    [sym_lock] = STATE(927),
    [sym__literal] = STATE(927),
    [sym_character_literal] = STATE(927),
    [sym_string_literal] = STATE(927),
    [sym_call] = STATE(927),
    [sym_invoke] = STATE(927),
    [sym_indexed_access] = STATE(927),
    [sym_slot_accessor] = STATE(927),
    [sym_true] = STATE(927),
    [sym_false] = STATE(927),
    [sym_maybe] = STATE(927),
    [sym_unset] = STATE(927),
    [sym_super] = STATE(927),
    [sym_self] = STATE(927),
    [sym_clone] = STATE(927),
    [sym_thisthread] = STATE(927),
    [sym_class] = STATE(927),
    [sym__expression] = STATE(927),
    [sym_return] = STATE(927),
    [sym_gather] = STATE(927),
    [sym_scatter] = STATE(927),
    [sym_allresults] = STATE(927),
    [sym_parenthesized_expression] = STATE(927),
    [sym__variable] = STATE(927),
    [sym_variable] = STATE(927),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(927),
    [sym_relational_operator] = STATE(927),
    [sym_logical_operator] = STATE(927),
    [sym_arithmetic_operator] = STATE(927),
    [sym_unary_operator] = STATE(927),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_handling_token2] = ACTIONS(1281),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1287),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1287),
    [sym_global_variable] = ACTIONS(1287),
    [sym_global_reference] = ACTIONS(1287),
    [sym_number] = ACTIONS(1287),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1287),
    [sym_comment] = ACTIONS(103),
  },
  [257] = {
    [sym_procedure] = STATE(649),
    [sym_block] = STATE(649),
    [sym_assignment] = STATE(649),
    [sym_if] = STATE(649),
    [sym_loop] = STATE(649),
    [sym_handling] = STATE(649),
    [sym_catch] = STATE(649),
    [sym_throw] = STATE(649),
    [sym_primitive] = STATE(649),
    [sym_iterator] = STATE(649),
    [sym_while] = STATE(649),
    [sym_try] = STATE(649),
    [sym_loopbody] = STATE(649),
    [sym_leave] = STATE(649),
    [sym_continue] = STATE(649),
    [sym_protect] = STATE(649),
    [sym_lock] = STATE(649),
    [sym__literal] = STATE(649),
    [sym_character_literal] = STATE(649),
    [sym_string_literal] = STATE(649),
    [sym_call] = STATE(649),
    [sym_invoke] = STATE(649),
    [sym_indexed_access] = STATE(649),
    [sym_slot_accessor] = STATE(649),
    [sym_true] = STATE(649),
    [sym_false] = STATE(649),
    [sym_maybe] = STATE(649),
    [sym_unset] = STATE(649),
    [sym_super] = STATE(649),
    [sym_self] = STATE(649),
    [sym_clone] = STATE(649),
    [sym_thisthread] = STATE(649),
    [sym_class] = STATE(649),
    [sym__expression] = STATE(649),
    [sym_return] = STATE(649),
    [sym_gather] = STATE(649),
    [sym_scatter] = STATE(649),
    [sym_allresults] = STATE(649),
    [sym_parenthesized_expression] = STATE(649),
    [sym__variable] = STATE(649),
    [sym_variable] = STATE(649),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(649),
    [sym_relational_operator] = STATE(649),
    [sym_logical_operator] = STATE(649),
    [sym_arithmetic_operator] = STATE(649),
    [sym_unary_operator] = STATE(649),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_handling_token2] = ACTIONS(1299),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1305),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1305),
    [sym_global_variable] = ACTIONS(1305),
    [sym_global_reference] = ACTIONS(1305),
    [sym_number] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1305),
    [sym_comment] = ACTIONS(103),
  },
  [258] = {
    [sym_procedure] = STATE(621),
    [sym_block] = STATE(621),
    [sym_assignment] = STATE(621),
    [sym_if] = STATE(621),
    [sym_loop] = STATE(621),
    [sym_handling] = STATE(621),
    [sym_catch] = STATE(621),
    [sym_throw] = STATE(621),
    [sym_primitive] = STATE(621),
    [sym_iterator] = STATE(621),
    [sym_while] = STATE(621),
    [sym_try] = STATE(621),
    [sym_loopbody] = STATE(621),
    [sym_leave] = STATE(621),
    [sym_continue] = STATE(621),
    [sym_protect] = STATE(621),
    [sym_lock] = STATE(621),
    [sym__literal] = STATE(621),
    [sym_character_literal] = STATE(621),
    [sym_string_literal] = STATE(621),
    [sym_call] = STATE(621),
    [sym_invoke] = STATE(621),
    [sym_indexed_access] = STATE(621),
    [sym_slot_accessor] = STATE(621),
    [sym__expression_list] = STATE(534),
    [sym_true] = STATE(621),
    [sym_false] = STATE(621),
    [sym_maybe] = STATE(621),
    [sym_unset] = STATE(621),
    [sym_super] = STATE(621),
    [sym_self] = STATE(621),
    [sym_clone] = STATE(621),
    [sym_thisthread] = STATE(621),
    [sym_class] = STATE(621),
    [sym__expression] = STATE(621),
    [sym_return] = STATE(621),
    [sym_gather] = STATE(621),
    [sym_scatter] = STATE(621),
    [sym_allresults] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym__variable] = STATE(621),
    [sym_variable] = STATE(621),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(621),
    [sym_relational_operator] = STATE(621),
    [sym_logical_operator] = STATE(621),
    [sym_arithmetic_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1313),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1313),
    [sym_global_variable] = ACTIONS(1313),
    [sym_global_reference] = ACTIONS(1313),
    [sym_number] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1313),
    [sym_comment] = ACTIONS(103),
  },
  [259] = {
    [sym_procedure] = STATE(991),
    [sym_block] = STATE(991),
    [sym_assignment] = STATE(991),
    [sym_if] = STATE(991),
    [sym_loop] = STATE(991),
    [sym_handling] = STATE(991),
    [sym_catch] = STATE(991),
    [sym_throw] = STATE(991),
    [sym_primitive] = STATE(991),
    [sym_iterator] = STATE(991),
    [sym_while] = STATE(991),
    [sym_try] = STATE(991),
    [sym_loopbody] = STATE(991),
    [sym_leave] = STATE(991),
    [sym_continue] = STATE(991),
    [sym_protect] = STATE(991),
    [sym_lock] = STATE(991),
    [sym__literal] = STATE(991),
    [sym_character_literal] = STATE(991),
    [sym_string_literal] = STATE(991),
    [sym_call] = STATE(991),
    [sym_invoke] = STATE(991),
    [sym_indexed_access] = STATE(991),
    [sym_slot_accessor] = STATE(991),
    [sym_true] = STATE(991),
    [sym_false] = STATE(991),
    [sym_maybe] = STATE(991),
    [sym_unset] = STATE(991),
    [sym_super] = STATE(991),
    [sym_self] = STATE(991),
    [sym_clone] = STATE(991),
    [sym_thisthread] = STATE(991),
    [sym_class] = STATE(991),
    [sym__expression] = STATE(991),
    [sym_return] = STATE(991),
    [sym_gather] = STATE(991),
    [sym_scatter] = STATE(991),
    [sym_allresults] = STATE(991),
    [sym_parenthesized_expression] = STATE(991),
    [sym__variable] = STATE(991),
    [sym_variable] = STATE(991),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(991),
    [sym_relational_operator] = STATE(991),
    [sym_logical_operator] = STATE(991),
    [sym_arithmetic_operator] = STATE(991),
    [sym_unary_operator] = STATE(991),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1315),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1317),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1317),
    [sym_global_variable] = ACTIONS(1317),
    [sym_global_reference] = ACTIONS(1317),
    [sym_number] = ACTIONS(1317),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1317),
    [sym_comment] = ACTIONS(103),
  },
  [260] = {
    [sym_procedure] = STATE(626),
    [sym_block] = STATE(626),
    [sym_assignment] = STATE(626),
    [sym_if] = STATE(626),
    [sym_loop] = STATE(626),
    [sym_handling] = STATE(626),
    [sym_catch] = STATE(626),
    [sym_throw] = STATE(626),
    [sym_primitive] = STATE(626),
    [sym_iterator] = STATE(626),
    [sym_while] = STATE(626),
    [sym_try] = STATE(626),
    [sym_loopbody] = STATE(626),
    [sym_leave] = STATE(626),
    [sym_continue] = STATE(626),
    [sym_protect] = STATE(626),
    [sym_lock] = STATE(626),
    [sym__literal] = STATE(626),
    [sym_character_literal] = STATE(626),
    [sym_string_literal] = STATE(626),
    [sym_call] = STATE(626),
    [sym_invoke] = STATE(626),
    [sym_indexed_access] = STATE(626),
    [sym_slot_accessor] = STATE(626),
    [sym_true] = STATE(626),
    [sym_false] = STATE(626),
    [sym_maybe] = STATE(626),
    [sym_unset] = STATE(626),
    [sym_super] = STATE(626),
    [sym_self] = STATE(626),
    [sym_clone] = STATE(626),
    [sym_thisthread] = STATE(626),
    [sym_class] = STATE(626),
    [sym__expression] = STATE(626),
    [sym_return] = STATE(626),
    [sym_gather] = STATE(626),
    [sym_scatter] = STATE(626),
    [sym_allresults] = STATE(626),
    [sym_parenthesized_expression] = STATE(626),
    [sym__variable] = STATE(626),
    [sym_variable] = STATE(626),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(626),
    [sym_relational_operator] = STATE(626),
    [sym_logical_operator] = STATE(626),
    [sym_arithmetic_operator] = STATE(626),
    [sym_unary_operator] = STATE(626),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_handling_token2] = ACTIONS(1299),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1329),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1329),
    [sym_global_variable] = ACTIONS(1329),
    [sym_global_reference] = ACTIONS(1329),
    [sym_number] = ACTIONS(1329),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1329),
    [sym_comment] = ACTIONS(103),
  },
  [261] = {
    [sym_procedure] = STATE(629),
    [sym_block] = STATE(629),
    [sym_assignment] = STATE(629),
    [sym_if] = STATE(629),
    [sym_loop] = STATE(629),
    [sym_handling] = STATE(629),
    [sym_catch] = STATE(629),
    [sym_throw] = STATE(629),
    [sym_primitive] = STATE(629),
    [sym_iterator] = STATE(629),
    [sym_while] = STATE(629),
    [sym_try] = STATE(629),
    [sym_loopbody] = STATE(629),
    [sym_leave] = STATE(629),
    [sym_continue] = STATE(629),
    [sym_protect] = STATE(629),
    [sym_lock] = STATE(629),
    [sym__literal] = STATE(629),
    [sym_character_literal] = STATE(629),
    [sym_string_literal] = STATE(629),
    [sym_call] = STATE(629),
    [sym_invoke] = STATE(629),
    [sym_indexed_access] = STATE(629),
    [sym_slot_accessor] = STATE(629),
    [sym_true] = STATE(629),
    [sym_false] = STATE(629),
    [sym_maybe] = STATE(629),
    [sym_unset] = STATE(629),
    [sym_super] = STATE(629),
    [sym_self] = STATE(629),
    [sym_clone] = STATE(629),
    [sym_thisthread] = STATE(629),
    [sym_class] = STATE(629),
    [sym__expression] = STATE(629),
    [sym_return] = STATE(629),
    [sym_gather] = STATE(629),
    [sym_scatter] = STATE(629),
    [sym_allresults] = STATE(629),
    [sym_parenthesized_expression] = STATE(629),
    [sym__variable] = STATE(629),
    [sym_variable] = STATE(629),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(629),
    [sym_relational_operator] = STATE(629),
    [sym_logical_operator] = STATE(629),
    [sym_arithmetic_operator] = STATE(629),
    [sym_unary_operator] = STATE(629),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_handling_token2] = ACTIONS(1281),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1341),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1341),
    [sym_global_variable] = ACTIONS(1341),
    [sym_global_reference] = ACTIONS(1341),
    [sym_number] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1341),
    [sym_comment] = ACTIONS(103),
  },
  [262] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(713),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [263] = {
    [sym_procedure] = STATE(881),
    [sym_block] = STATE(881),
    [sym_assignment] = STATE(881),
    [sym_if] = STATE(881),
    [sym_loop] = STATE(881),
    [sym_handling] = STATE(881),
    [sym_catch] = STATE(881),
    [sym_throw] = STATE(881),
    [sym_primitive] = STATE(881),
    [sym_iterator] = STATE(881),
    [sym_while] = STATE(881),
    [sym_try] = STATE(881),
    [sym_loopbody] = STATE(881),
    [sym_leave] = STATE(881),
    [sym_continue] = STATE(881),
    [sym_protect] = STATE(881),
    [sym_lock] = STATE(881),
    [sym__literal] = STATE(881),
    [sym_character_literal] = STATE(881),
    [sym_string_literal] = STATE(881),
    [sym_call] = STATE(881),
    [sym_invoke] = STATE(881),
    [sym_indexed_access] = STATE(881),
    [sym_slot_accessor] = STATE(881),
    [sym_true] = STATE(881),
    [sym_false] = STATE(881),
    [sym_maybe] = STATE(881),
    [sym_unset] = STATE(881),
    [sym_super] = STATE(881),
    [sym_self] = STATE(881),
    [sym_clone] = STATE(881),
    [sym_thisthread] = STATE(881),
    [sym_class] = STATE(881),
    [sym__expression] = STATE(881),
    [sym_return] = STATE(881),
    [sym_gather] = STATE(881),
    [sym_scatter] = STATE(881),
    [sym_allresults] = STATE(881),
    [sym_parenthesized_expression] = STATE(881),
    [sym__variable] = STATE(881),
    [sym_variable] = STATE(881),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(881),
    [sym_relational_operator] = STATE(881),
    [sym_logical_operator] = STATE(881),
    [sym_arithmetic_operator] = STATE(881),
    [sym_unary_operator] = STATE(881),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_handling_token2] = ACTIONS(1343),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1345),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1345),
    [sym_global_variable] = ACTIONS(1345),
    [sym_global_reference] = ACTIONS(1345),
    [sym_number] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1345),
    [sym_comment] = ACTIONS(103),
  },
  [264] = {
    [sym_procedure] = STATE(965),
    [sym_block] = STATE(965),
    [sym_assignment] = STATE(965),
    [sym_if] = STATE(965),
    [sym_loop] = STATE(965),
    [sym_handling] = STATE(965),
    [sym_catch] = STATE(965),
    [sym_throw] = STATE(965),
    [sym_primitive] = STATE(965),
    [sym_iterator] = STATE(965),
    [sym_while] = STATE(965),
    [sym_try] = STATE(965),
    [sym_loopbody] = STATE(965),
    [sym_leave] = STATE(965),
    [sym_continue] = STATE(965),
    [sym_protect] = STATE(965),
    [sym_lock] = STATE(965),
    [sym__literal] = STATE(965),
    [sym_character_literal] = STATE(965),
    [sym_string_literal] = STATE(965),
    [sym_call] = STATE(965),
    [sym_invoke] = STATE(965),
    [sym_indexed_access] = STATE(965),
    [sym_slot_accessor] = STATE(965),
    [sym_true] = STATE(965),
    [sym_false] = STATE(965),
    [sym_maybe] = STATE(965),
    [sym_unset] = STATE(965),
    [sym_super] = STATE(965),
    [sym_self] = STATE(965),
    [sym_clone] = STATE(965),
    [sym_thisthread] = STATE(965),
    [sym_class] = STATE(965),
    [sym__expression] = STATE(965),
    [sym_return] = STATE(965),
    [sym_gather] = STATE(965),
    [sym_scatter] = STATE(965),
    [sym_allresults] = STATE(965),
    [sym_parenthesized_expression] = STATE(965),
    [sym__variable] = STATE(965),
    [sym_variable] = STATE(965),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(965),
    [sym_relational_operator] = STATE(965),
    [sym_logical_operator] = STATE(965),
    [sym_arithmetic_operator] = STATE(965),
    [sym_unary_operator] = STATE(965),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1347),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1349),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1349),
    [sym_global_variable] = ACTIONS(1349),
    [sym_global_reference] = ACTIONS(1349),
    [sym_number] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1349),
    [sym_comment] = ACTIONS(103),
  },
  [265] = {
    [sym_procedure] = STATE(994),
    [sym_block] = STATE(994),
    [sym_assignment] = STATE(994),
    [sym_if] = STATE(994),
    [sym_loop] = STATE(994),
    [sym_handling] = STATE(994),
    [sym_catch] = STATE(994),
    [sym_throw] = STATE(994),
    [sym_primitive] = STATE(994),
    [sym_iterator] = STATE(994),
    [sym_while] = STATE(994),
    [sym_try] = STATE(994),
    [sym_loopbody] = STATE(994),
    [sym_leave] = STATE(994),
    [sym_continue] = STATE(994),
    [sym_protect] = STATE(994),
    [sym_lock] = STATE(994),
    [sym__literal] = STATE(994),
    [sym_character_literal] = STATE(994),
    [sym_string_literal] = STATE(994),
    [sym_call] = STATE(994),
    [sym_invoke] = STATE(994),
    [sym_indexed_access] = STATE(994),
    [sym_slot_accessor] = STATE(994),
    [sym__expression_list] = STATE(1881),
    [sym_true] = STATE(994),
    [sym_false] = STATE(994),
    [sym_maybe] = STATE(994),
    [sym_unset] = STATE(994),
    [sym_super] = STATE(994),
    [sym_self] = STATE(994),
    [sym_clone] = STATE(994),
    [sym_thisthread] = STATE(994),
    [sym_class] = STATE(994),
    [sym__expression] = STATE(994),
    [sym_return] = STATE(994),
    [sym_gather] = STATE(994),
    [sym_scatter] = STATE(994),
    [sym_allresults] = STATE(994),
    [sym_parenthesized_expression] = STATE(994),
    [sym__variable] = STATE(994),
    [sym_variable] = STATE(994),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(994),
    [sym_relational_operator] = STATE(994),
    [sym_logical_operator] = STATE(994),
    [sym_arithmetic_operator] = STATE(994),
    [sym_unary_operator] = STATE(994),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1351),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1351),
    [sym_global_variable] = ACTIONS(1351),
    [sym_global_reference] = ACTIONS(1351),
    [sym_number] = ACTIONS(1351),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1351),
    [sym_comment] = ACTIONS(103),
  },
  [266] = {
    [sym_procedure] = STATE(670),
    [sym_block] = STATE(670),
    [sym_assignment] = STATE(670),
    [sym_if] = STATE(670),
    [sym_loop] = STATE(670),
    [sym_handling] = STATE(670),
    [sym_catch] = STATE(670),
    [sym_throw] = STATE(670),
    [sym_primitive] = STATE(670),
    [sym_iterator] = STATE(670),
    [sym_while] = STATE(670),
    [sym_try] = STATE(670),
    [sym_loopbody] = STATE(670),
    [sym_leave] = STATE(670),
    [sym_continue] = STATE(670),
    [sym_protect] = STATE(670),
    [sym_lock] = STATE(670),
    [sym__literal] = STATE(670),
    [sym_character_literal] = STATE(670),
    [sym_string_literal] = STATE(670),
    [sym_call] = STATE(670),
    [sym_invoke] = STATE(670),
    [sym_indexed_access] = STATE(670),
    [sym_slot_accessor] = STATE(670),
    [sym_true] = STATE(670),
    [sym_false] = STATE(670),
    [sym_maybe] = STATE(670),
    [sym_unset] = STATE(670),
    [sym_super] = STATE(670),
    [sym_self] = STATE(670),
    [sym_clone] = STATE(670),
    [sym_thisthread] = STATE(670),
    [sym_class] = STATE(670),
    [sym__expression] = STATE(670),
    [sym_return] = STATE(670),
    [sym_gather] = STATE(670),
    [sym_scatter] = STATE(670),
    [sym_allresults] = STATE(670),
    [sym_parenthesized_expression] = STATE(670),
    [sym__variable] = STATE(670),
    [sym_variable] = STATE(670),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(670),
    [sym_relational_operator] = STATE(670),
    [sym_logical_operator] = STATE(670),
    [sym_arithmetic_operator] = STATE(670),
    [sym_unary_operator] = STATE(670),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_handling_token2] = ACTIONS(1281),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1353),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1353),
    [sym_global_variable] = ACTIONS(1353),
    [sym_global_reference] = ACTIONS(1353),
    [sym_number] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1353),
    [sym_comment] = ACTIONS(103),
  },
  [267] = {
    [sym_procedure] = STATE(972),
    [sym_block] = STATE(972),
    [sym_assignment] = STATE(972),
    [sym_if] = STATE(972),
    [sym_loop] = STATE(972),
    [sym_handling] = STATE(972),
    [sym_catch] = STATE(972),
    [sym_throw] = STATE(972),
    [sym_primitive] = STATE(972),
    [sym_iterator] = STATE(972),
    [sym_while] = STATE(972),
    [sym_try] = STATE(972),
    [sym_loopbody] = STATE(972),
    [sym_leave] = STATE(972),
    [sym_continue] = STATE(972),
    [sym_protect] = STATE(972),
    [sym_lock] = STATE(972),
    [sym__literal] = STATE(972),
    [sym_character_literal] = STATE(972),
    [sym_string_literal] = STATE(972),
    [sym_call] = STATE(972),
    [sym_invoke] = STATE(972),
    [sym_indexed_access] = STATE(972),
    [sym_slot_accessor] = STATE(972),
    [sym__expression_list] = STATE(1864),
    [sym_true] = STATE(972),
    [sym_false] = STATE(972),
    [sym_maybe] = STATE(972),
    [sym_unset] = STATE(972),
    [sym_super] = STATE(972),
    [sym_self] = STATE(972),
    [sym_clone] = STATE(972),
    [sym_thisthread] = STATE(972),
    [sym_class] = STATE(972),
    [sym__expression] = STATE(972),
    [sym_return] = STATE(972),
    [sym_gather] = STATE(972),
    [sym_scatter] = STATE(972),
    [sym_allresults] = STATE(972),
    [sym_parenthesized_expression] = STATE(972),
    [sym__variable] = STATE(972),
    [sym_variable] = STATE(972),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(972),
    [sym_relational_operator] = STATE(972),
    [sym_logical_operator] = STATE(972),
    [sym_arithmetic_operator] = STATE(972),
    [sym_unary_operator] = STATE(972),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1355),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1355),
    [sym_global_variable] = ACTIONS(1355),
    [sym_global_reference] = ACTIONS(1355),
    [sym_number] = ACTIONS(1355),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1355),
    [sym_comment] = ACTIONS(103),
  },
  [268] = {
    [sym_procedure] = STATE(992),
    [sym_block] = STATE(992),
    [sym_assignment] = STATE(992),
    [sym_if] = STATE(992),
    [sym_loop] = STATE(992),
    [sym_handling] = STATE(992),
    [sym_catch] = STATE(992),
    [sym_throw] = STATE(992),
    [sym_primitive] = STATE(992),
    [sym_iterator] = STATE(992),
    [sym_while] = STATE(992),
    [sym_try] = STATE(992),
    [sym_loopbody] = STATE(992),
    [sym_leave] = STATE(992),
    [sym_continue] = STATE(992),
    [sym_protect] = STATE(992),
    [sym_lock] = STATE(992),
    [sym__literal] = STATE(992),
    [sym_character_literal] = STATE(992),
    [sym_string_literal] = STATE(992),
    [sym_call] = STATE(992),
    [sym_invoke] = STATE(992),
    [sym_indexed_access] = STATE(992),
    [sym_slot_accessor] = STATE(992),
    [sym__expression_list] = STATE(1881),
    [sym_true] = STATE(992),
    [sym_false] = STATE(992),
    [sym_maybe] = STATE(992),
    [sym_unset] = STATE(992),
    [sym_super] = STATE(992),
    [sym_self] = STATE(992),
    [sym_clone] = STATE(992),
    [sym_thisthread] = STATE(992),
    [sym_class] = STATE(992),
    [sym__expression] = STATE(992),
    [sym_return] = STATE(992),
    [sym_gather] = STATE(992),
    [sym_scatter] = STATE(992),
    [sym_allresults] = STATE(992),
    [sym_parenthesized_expression] = STATE(992),
    [sym__variable] = STATE(992),
    [sym_variable] = STATE(992),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(992),
    [sym_relational_operator] = STATE(992),
    [sym_logical_operator] = STATE(992),
    [sym_arithmetic_operator] = STATE(992),
    [sym_unary_operator] = STATE(992),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1357),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1357),
    [sym_global_variable] = ACTIONS(1357),
    [sym_global_reference] = ACTIONS(1357),
    [sym_number] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1357),
    [sym_comment] = ACTIONS(103),
  },
  [269] = {
    [sym_procedure] = STATE(982),
    [sym_block] = STATE(982),
    [sym_assignment] = STATE(982),
    [sym_if] = STATE(982),
    [sym_loop] = STATE(982),
    [sym_handling] = STATE(982),
    [sym_catch] = STATE(982),
    [sym_throw] = STATE(982),
    [sym_primitive] = STATE(982),
    [sym_iterator] = STATE(982),
    [sym_while] = STATE(982),
    [sym_try] = STATE(982),
    [sym_loopbody] = STATE(982),
    [sym_leave] = STATE(982),
    [sym_continue] = STATE(982),
    [sym_protect] = STATE(982),
    [sym_lock] = STATE(982),
    [sym__literal] = STATE(982),
    [sym_character_literal] = STATE(982),
    [sym_string_literal] = STATE(982),
    [sym_call] = STATE(982),
    [sym_invoke] = STATE(982),
    [sym_indexed_access] = STATE(982),
    [sym_slot_accessor] = STATE(982),
    [sym_true] = STATE(982),
    [sym_false] = STATE(982),
    [sym_maybe] = STATE(982),
    [sym_unset] = STATE(982),
    [sym_super] = STATE(982),
    [sym_self] = STATE(982),
    [sym_clone] = STATE(982),
    [sym_thisthread] = STATE(982),
    [sym_class] = STATE(982),
    [sym__expression] = STATE(982),
    [sym_return] = STATE(982),
    [sym_gather] = STATE(982),
    [sym_scatter] = STATE(982),
    [sym_allresults] = STATE(982),
    [sym_parenthesized_expression] = STATE(982),
    [sym__variable] = STATE(982),
    [sym_variable] = STATE(982),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(982),
    [sym_relational_operator] = STATE(982),
    [sym_logical_operator] = STATE(982),
    [sym_arithmetic_operator] = STATE(982),
    [sym_unary_operator] = STATE(982),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1347),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1359),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1359),
    [sym_global_variable] = ACTIONS(1359),
    [sym_global_reference] = ACTIONS(1359),
    [sym_number] = ACTIONS(1359),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1359),
    [sym_comment] = ACTIONS(103),
  },
  [270] = {
    [sym_procedure] = STATE(971),
    [sym_block] = STATE(971),
    [sym_assignment] = STATE(971),
    [sym_if] = STATE(971),
    [sym_loop] = STATE(971),
    [sym_handling] = STATE(971),
    [sym_catch] = STATE(971),
    [sym_throw] = STATE(971),
    [sym_primitive] = STATE(971),
    [sym_iterator] = STATE(971),
    [sym_while] = STATE(971),
    [sym_try] = STATE(971),
    [sym_loopbody] = STATE(971),
    [sym_leave] = STATE(971),
    [sym_continue] = STATE(971),
    [sym_protect] = STATE(971),
    [sym_lock] = STATE(971),
    [sym__literal] = STATE(971),
    [sym_character_literal] = STATE(971),
    [sym_string_literal] = STATE(971),
    [sym_call] = STATE(971),
    [sym_invoke] = STATE(971),
    [sym_indexed_access] = STATE(971),
    [sym_slot_accessor] = STATE(971),
    [sym__expression_list] = STATE(1864),
    [sym_true] = STATE(971),
    [sym_false] = STATE(971),
    [sym_maybe] = STATE(971),
    [sym_unset] = STATE(971),
    [sym_super] = STATE(971),
    [sym_self] = STATE(971),
    [sym_clone] = STATE(971),
    [sym_thisthread] = STATE(971),
    [sym_class] = STATE(971),
    [sym__expression] = STATE(971),
    [sym_return] = STATE(971),
    [sym_gather] = STATE(971),
    [sym_scatter] = STATE(971),
    [sym_allresults] = STATE(971),
    [sym_parenthesized_expression] = STATE(971),
    [sym__variable] = STATE(971),
    [sym_variable] = STATE(971),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(971),
    [sym_relational_operator] = STATE(971),
    [sym_logical_operator] = STATE(971),
    [sym_arithmetic_operator] = STATE(971),
    [sym_unary_operator] = STATE(971),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1361),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1361),
    [sym_global_variable] = ACTIONS(1361),
    [sym_global_reference] = ACTIONS(1361),
    [sym_number] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1361),
    [sym_comment] = ACTIONS(103),
  },
  [271] = {
    [sym_procedure] = STATE(584),
    [sym_block] = STATE(584),
    [sym_assignment] = STATE(584),
    [sym_if] = STATE(584),
    [sym_loop] = STATE(584),
    [sym_handling] = STATE(584),
    [sym_catch] = STATE(584),
    [sym_throw] = STATE(584),
    [sym_primitive] = STATE(584),
    [sym_iterator] = STATE(584),
    [sym_while] = STATE(584),
    [sym_try] = STATE(584),
    [sym_loopbody] = STATE(584),
    [sym_leave] = STATE(584),
    [sym_continue] = STATE(584),
    [sym_protect] = STATE(584),
    [sym_lock] = STATE(584),
    [sym__literal] = STATE(584),
    [sym_character_literal] = STATE(584),
    [sym_string_literal] = STATE(584),
    [sym_call] = STATE(584),
    [sym_invoke] = STATE(584),
    [sym_indexed_access] = STATE(584),
    [sym_slot_accessor] = STATE(584),
    [sym__expression_list] = STATE(534),
    [sym_true] = STATE(584),
    [sym_false] = STATE(584),
    [sym_maybe] = STATE(584),
    [sym_unset] = STATE(584),
    [sym_super] = STATE(584),
    [sym_self] = STATE(584),
    [sym_clone] = STATE(584),
    [sym_thisthread] = STATE(584),
    [sym_class] = STATE(584),
    [sym__expression] = STATE(584),
    [sym_return] = STATE(584),
    [sym_gather] = STATE(584),
    [sym_scatter] = STATE(584),
    [sym_allresults] = STATE(584),
    [sym_parenthesized_expression] = STATE(584),
    [sym__variable] = STATE(584),
    [sym_variable] = STATE(584),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(584),
    [sym_relational_operator] = STATE(584),
    [sym_logical_operator] = STATE(584),
    [sym_arithmetic_operator] = STATE(584),
    [sym_unary_operator] = STATE(584),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1363),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1363),
    [sym_global_variable] = ACTIONS(1363),
    [sym_global_reference] = ACTIONS(1363),
    [sym_number] = ACTIONS(1363),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1363),
    [sym_comment] = ACTIONS(103),
  },
  [272] = {
    [sym_procedure] = STATE(621),
    [sym_block] = STATE(621),
    [sym_assignment] = STATE(621),
    [sym_if] = STATE(621),
    [sym_loop] = STATE(621),
    [sym_handling] = STATE(621),
    [sym_catch] = STATE(621),
    [sym_throw] = STATE(621),
    [sym_primitive] = STATE(621),
    [sym_iterator] = STATE(621),
    [sym_while] = STATE(621),
    [sym_try] = STATE(621),
    [sym_loopbody] = STATE(621),
    [sym_leave] = STATE(621),
    [sym_continue] = STATE(621),
    [sym_protect] = STATE(621),
    [sym_lock] = STATE(621),
    [sym__literal] = STATE(621),
    [sym_character_literal] = STATE(621),
    [sym_string_literal] = STATE(621),
    [sym_call] = STATE(621),
    [sym_invoke] = STATE(621),
    [sym_indexed_access] = STATE(621),
    [sym_slot_accessor] = STATE(621),
    [sym__expression_list] = STATE(557),
    [sym_true] = STATE(621),
    [sym_false] = STATE(621),
    [sym_maybe] = STATE(621),
    [sym_unset] = STATE(621),
    [sym_super] = STATE(621),
    [sym_self] = STATE(621),
    [sym_clone] = STATE(621),
    [sym_thisthread] = STATE(621),
    [sym_class] = STATE(621),
    [sym__expression] = STATE(621),
    [sym_return] = STATE(621),
    [sym_gather] = STATE(621),
    [sym_scatter] = STATE(621),
    [sym_allresults] = STATE(621),
    [sym_parenthesized_expression] = STATE(621),
    [sym__variable] = STATE(621),
    [sym_variable] = STATE(621),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(621),
    [sym_relational_operator] = STATE(621),
    [sym_logical_operator] = STATE(621),
    [sym_arithmetic_operator] = STATE(621),
    [sym_unary_operator] = STATE(621),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1313),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1313),
    [sym_global_variable] = ACTIONS(1313),
    [sym_global_reference] = ACTIONS(1313),
    [sym_number] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1313),
    [sym_comment] = ACTIONS(103),
  },
  [273] = {
    [sym_procedure] = STATE(983),
    [sym_block] = STATE(983),
    [sym_assignment] = STATE(983),
    [sym_if] = STATE(983),
    [sym_loop] = STATE(983),
    [sym_handling] = STATE(983),
    [sym_catch] = STATE(983),
    [sym_throw] = STATE(983),
    [sym_primitive] = STATE(983),
    [sym_iterator] = STATE(983),
    [sym_while] = STATE(983),
    [sym_try] = STATE(983),
    [sym_loopbody] = STATE(983),
    [sym_leave] = STATE(983),
    [sym_continue] = STATE(983),
    [sym_protect] = STATE(983),
    [sym_lock] = STATE(983),
    [sym__literal] = STATE(983),
    [sym_character_literal] = STATE(983),
    [sym_string_literal] = STATE(983),
    [sym_call] = STATE(983),
    [sym_invoke] = STATE(983),
    [sym_indexed_access] = STATE(983),
    [sym_slot_accessor] = STATE(983),
    [sym_true] = STATE(983),
    [sym_false] = STATE(983),
    [sym_maybe] = STATE(983),
    [sym_unset] = STATE(983),
    [sym_super] = STATE(983),
    [sym_self] = STATE(983),
    [sym_clone] = STATE(983),
    [sym_thisthread] = STATE(983),
    [sym_class] = STATE(983),
    [sym__expression] = STATE(983),
    [sym_return] = STATE(983),
    [sym_gather] = STATE(983),
    [sym_scatter] = STATE(983),
    [sym_allresults] = STATE(983),
    [sym_parenthesized_expression] = STATE(983),
    [sym__variable] = STATE(983),
    [sym_variable] = STATE(983),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(983),
    [sym_relational_operator] = STATE(983),
    [sym_logical_operator] = STATE(983),
    [sym_arithmetic_operator] = STATE(983),
    [sym_unary_operator] = STATE(983),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1315),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1365),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1365),
    [sym_global_variable] = ACTIONS(1365),
    [sym_global_reference] = ACTIONS(1365),
    [sym_number] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1365),
    [sym_comment] = ACTIONS(103),
  },
  [274] = {
    [sym_procedure] = STATE(654),
    [sym_block] = STATE(654),
    [sym_assignment] = STATE(654),
    [sym_if] = STATE(654),
    [sym_loop] = STATE(654),
    [sym_handling] = STATE(654),
    [sym_catch] = STATE(654),
    [sym_throw] = STATE(654),
    [sym_primitive] = STATE(654),
    [sym_iterator] = STATE(654),
    [sym_while] = STATE(654),
    [sym_try] = STATE(654),
    [sym_loopbody] = STATE(654),
    [sym_leave] = STATE(654),
    [sym_continue] = STATE(654),
    [sym_protect] = STATE(654),
    [sym_lock] = STATE(654),
    [sym__literal] = STATE(654),
    [sym_character_literal] = STATE(654),
    [sym_string_literal] = STATE(654),
    [sym_call] = STATE(654),
    [sym_invoke] = STATE(654),
    [sym_indexed_access] = STATE(654),
    [sym_slot_accessor] = STATE(654),
    [sym_true] = STATE(654),
    [sym_false] = STATE(654),
    [sym_maybe] = STATE(654),
    [sym_unset] = STATE(654),
    [sym_super] = STATE(654),
    [sym_self] = STATE(654),
    [sym_clone] = STATE(654),
    [sym_thisthread] = STATE(654),
    [sym_class] = STATE(654),
    [sym__expression] = STATE(654),
    [sym_return] = STATE(654),
    [sym_gather] = STATE(654),
    [sym_scatter] = STATE(654),
    [sym_allresults] = STATE(654),
    [sym_parenthesized_expression] = STATE(654),
    [sym__variable] = STATE(654),
    [sym_variable] = STATE(654),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(654),
    [sym_relational_operator] = STATE(654),
    [sym_logical_operator] = STATE(654),
    [sym_arithmetic_operator] = STATE(654),
    [sym_unary_operator] = STATE(654),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_handling_token2] = ACTIONS(1299),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1367),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1367),
    [sym_global_variable] = ACTIONS(1367),
    [sym_global_reference] = ACTIONS(1367),
    [sym_number] = ACTIONS(1367),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1367),
    [sym_comment] = ACTIONS(103),
  },
  [275] = {
    [sym_procedure] = STATE(981),
    [sym_block] = STATE(981),
    [sym_assignment] = STATE(981),
    [sym_if] = STATE(981),
    [sym_loop] = STATE(981),
    [sym_handling] = STATE(981),
    [sym_catch] = STATE(981),
    [sym_throw] = STATE(981),
    [sym_primitive] = STATE(981),
    [sym_iterator] = STATE(981),
    [sym_while] = STATE(981),
    [sym_try] = STATE(981),
    [sym_loopbody] = STATE(981),
    [sym_leave] = STATE(981),
    [sym_continue] = STATE(981),
    [sym_protect] = STATE(981),
    [sym_lock] = STATE(981),
    [sym__literal] = STATE(981),
    [sym_character_literal] = STATE(981),
    [sym_string_literal] = STATE(981),
    [sym_call] = STATE(981),
    [sym_invoke] = STATE(981),
    [sym_indexed_access] = STATE(981),
    [sym_slot_accessor] = STATE(981),
    [sym__expression_list] = STATE(1881),
    [sym_true] = STATE(981),
    [sym_false] = STATE(981),
    [sym_maybe] = STATE(981),
    [sym_unset] = STATE(981),
    [sym_super] = STATE(981),
    [sym_self] = STATE(981),
    [sym_clone] = STATE(981),
    [sym_thisthread] = STATE(981),
    [sym_class] = STATE(981),
    [sym__expression] = STATE(981),
    [sym_return] = STATE(981),
    [sym_gather] = STATE(981),
    [sym_scatter] = STATE(981),
    [sym_allresults] = STATE(981),
    [sym_parenthesized_expression] = STATE(981),
    [sym__variable] = STATE(981),
    [sym_variable] = STATE(981),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(981),
    [sym_relational_operator] = STATE(981),
    [sym_logical_operator] = STATE(981),
    [sym_arithmetic_operator] = STATE(981),
    [sym_unary_operator] = STATE(981),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1369),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1369),
    [sym_global_variable] = ACTIONS(1369),
    [sym_global_reference] = ACTIONS(1369),
    [sym_number] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1369),
    [sym_comment] = ACTIONS(103),
  },
  [276] = {
    [sym_procedure] = STATE(980),
    [sym_block] = STATE(980),
    [sym_assignment] = STATE(980),
    [sym_if] = STATE(980),
    [sym_loop] = STATE(980),
    [sym_handling] = STATE(980),
    [sym_catch] = STATE(980),
    [sym_throw] = STATE(980),
    [sym_primitive] = STATE(980),
    [sym_iterator] = STATE(980),
    [sym_while] = STATE(980),
    [sym_try] = STATE(980),
    [sym_loopbody] = STATE(980),
    [sym_leave] = STATE(980),
    [sym_continue] = STATE(980),
    [sym_protect] = STATE(980),
    [sym_lock] = STATE(980),
    [sym__literal] = STATE(980),
    [sym_character_literal] = STATE(980),
    [sym_string_literal] = STATE(980),
    [sym_call] = STATE(980),
    [sym_invoke] = STATE(980),
    [sym_indexed_access] = STATE(980),
    [sym_slot_accessor] = STATE(980),
    [sym__expression_list] = STATE(1881),
    [sym_true] = STATE(980),
    [sym_false] = STATE(980),
    [sym_maybe] = STATE(980),
    [sym_unset] = STATE(980),
    [sym_super] = STATE(980),
    [sym_self] = STATE(980),
    [sym_clone] = STATE(980),
    [sym_thisthread] = STATE(980),
    [sym_class] = STATE(980),
    [sym__expression] = STATE(980),
    [sym_return] = STATE(980),
    [sym_gather] = STATE(980),
    [sym_scatter] = STATE(980),
    [sym_allresults] = STATE(980),
    [sym_parenthesized_expression] = STATE(980),
    [sym__variable] = STATE(980),
    [sym_variable] = STATE(980),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(980),
    [sym_relational_operator] = STATE(980),
    [sym_logical_operator] = STATE(980),
    [sym_arithmetic_operator] = STATE(980),
    [sym_unary_operator] = STATE(980),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1371),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1371),
    [sym_global_variable] = ACTIONS(1371),
    [sym_global_reference] = ACTIONS(1371),
    [sym_number] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1371),
    [sym_comment] = ACTIONS(103),
  },
  [277] = {
    [sym_procedure] = STATE(896),
    [sym_block] = STATE(896),
    [sym_assignment] = STATE(896),
    [sym_if] = STATE(896),
    [sym_loop] = STATE(896),
    [sym_handling] = STATE(896),
    [sym_catch] = STATE(896),
    [sym_throw] = STATE(896),
    [sym_primitive] = STATE(896),
    [sym_iterator] = STATE(896),
    [sym_while] = STATE(896),
    [sym_try] = STATE(896),
    [sym_loopbody] = STATE(896),
    [sym_leave] = STATE(896),
    [sym_continue] = STATE(896),
    [sym_protect] = STATE(896),
    [sym_lock] = STATE(896),
    [sym__literal] = STATE(896),
    [sym_character_literal] = STATE(896),
    [sym_string_literal] = STATE(896),
    [sym_call] = STATE(896),
    [sym_invoke] = STATE(896),
    [sym_indexed_access] = STATE(896),
    [sym_slot_accessor] = STATE(896),
    [sym__expression_list] = STATE(557),
    [sym_true] = STATE(896),
    [sym_false] = STATE(896),
    [sym_maybe] = STATE(896),
    [sym_unset] = STATE(896),
    [sym_super] = STATE(896),
    [sym_self] = STATE(896),
    [sym_clone] = STATE(896),
    [sym_thisthread] = STATE(896),
    [sym_class] = STATE(896),
    [sym__expression] = STATE(896),
    [sym_return] = STATE(896),
    [sym_gather] = STATE(896),
    [sym_scatter] = STATE(896),
    [sym_allresults] = STATE(896),
    [sym_parenthesized_expression] = STATE(896),
    [sym__variable] = STATE(896),
    [sym_variable] = STATE(896),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(896),
    [sym_relational_operator] = STATE(896),
    [sym_logical_operator] = STATE(896),
    [sym_arithmetic_operator] = STATE(896),
    [sym_unary_operator] = STATE(896),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1373),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1373),
    [sym_global_variable] = ACTIONS(1373),
    [sym_global_reference] = ACTIONS(1373),
    [sym_number] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1373),
    [sym_comment] = ACTIONS(103),
  },
  [278] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1864),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [279] = {
    [sym_procedure] = STATE(986),
    [sym_block] = STATE(986),
    [sym_assignment] = STATE(986),
    [sym_if] = STATE(986),
    [sym_loop] = STATE(986),
    [sym_handling] = STATE(986),
    [sym_catch] = STATE(986),
    [sym_throw] = STATE(986),
    [sym_primitive] = STATE(986),
    [sym_iterator] = STATE(986),
    [sym_while] = STATE(986),
    [sym_try] = STATE(986),
    [sym_loopbody] = STATE(986),
    [sym_leave] = STATE(986),
    [sym_continue] = STATE(986),
    [sym_protect] = STATE(986),
    [sym_lock] = STATE(986),
    [sym__literal] = STATE(986),
    [sym_character_literal] = STATE(986),
    [sym_string_literal] = STATE(986),
    [sym_call] = STATE(986),
    [sym_invoke] = STATE(986),
    [sym_indexed_access] = STATE(986),
    [sym_slot_accessor] = STATE(986),
    [sym_true] = STATE(986),
    [sym_false] = STATE(986),
    [sym_maybe] = STATE(986),
    [sym_unset] = STATE(986),
    [sym_super] = STATE(986),
    [sym_self] = STATE(986),
    [sym_clone] = STATE(986),
    [sym_thisthread] = STATE(986),
    [sym_class] = STATE(986),
    [sym__expression] = STATE(986),
    [sym_return] = STATE(986),
    [sym_gather] = STATE(986),
    [sym_scatter] = STATE(986),
    [sym_allresults] = STATE(986),
    [sym_parenthesized_expression] = STATE(986),
    [sym__variable] = STATE(986),
    [sym_variable] = STATE(986),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(986),
    [sym_relational_operator] = STATE(986),
    [sym_logical_operator] = STATE(986),
    [sym_arithmetic_operator] = STATE(986),
    [sym_unary_operator] = STATE(986),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1315),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1375),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1375),
    [sym_global_variable] = ACTIONS(1375),
    [sym_global_reference] = ACTIONS(1375),
    [sym_number] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1375),
    [sym_comment] = ACTIONS(103),
  },
  [280] = {
    [sym_procedure] = STATE(938),
    [sym_block] = STATE(938),
    [sym_assignment] = STATE(938),
    [sym_if] = STATE(938),
    [sym_loop] = STATE(938),
    [sym_handling] = STATE(938),
    [sym_catch] = STATE(938),
    [sym_throw] = STATE(938),
    [sym_primitive] = STATE(938),
    [sym_iterator] = STATE(938),
    [sym_while] = STATE(938),
    [sym_try] = STATE(938),
    [sym_loopbody] = STATE(938),
    [sym_leave] = STATE(938),
    [sym_continue] = STATE(938),
    [sym_protect] = STATE(938),
    [sym_lock] = STATE(938),
    [sym__literal] = STATE(938),
    [sym_character_literal] = STATE(938),
    [sym_string_literal] = STATE(938),
    [sym_call] = STATE(938),
    [sym_invoke] = STATE(938),
    [sym_indexed_access] = STATE(938),
    [sym_slot_accessor] = STATE(938),
    [sym_true] = STATE(938),
    [sym_false] = STATE(938),
    [sym_maybe] = STATE(938),
    [sym_unset] = STATE(938),
    [sym_super] = STATE(938),
    [sym_self] = STATE(938),
    [sym_clone] = STATE(938),
    [sym_thisthread] = STATE(938),
    [sym_class] = STATE(938),
    [sym__expression] = STATE(938),
    [sym_return] = STATE(938),
    [sym_gather] = STATE(938),
    [sym_scatter] = STATE(938),
    [sym_allresults] = STATE(938),
    [sym_parenthesized_expression] = STATE(938),
    [sym__variable] = STATE(938),
    [sym_variable] = STATE(938),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(938),
    [sym_relational_operator] = STATE(938),
    [sym_logical_operator] = STATE(938),
    [sym_arithmetic_operator] = STATE(938),
    [sym_unary_operator] = STATE(938),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_handling_token2] = ACTIONS(1299),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1377),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1377),
    [sym_global_variable] = ACTIONS(1377),
    [sym_global_reference] = ACTIONS(1377),
    [sym_number] = ACTIONS(1377),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1377),
    [sym_comment] = ACTIONS(103),
  },
  [281] = {
    [sym_procedure] = STATE(941),
    [sym_block] = STATE(941),
    [sym_assignment] = STATE(941),
    [sym_if] = STATE(941),
    [sym_loop] = STATE(941),
    [sym_handling] = STATE(941),
    [sym_catch] = STATE(941),
    [sym_throw] = STATE(941),
    [sym_primitive] = STATE(941),
    [sym_iterator] = STATE(941),
    [sym_while] = STATE(941),
    [sym_try] = STATE(941),
    [sym_loopbody] = STATE(941),
    [sym_leave] = STATE(941),
    [sym_continue] = STATE(941),
    [sym_protect] = STATE(941),
    [sym_lock] = STATE(941),
    [sym__literal] = STATE(941),
    [sym_character_literal] = STATE(941),
    [sym_string_literal] = STATE(941),
    [sym_call] = STATE(941),
    [sym_invoke] = STATE(941),
    [sym_indexed_access] = STATE(941),
    [sym_slot_accessor] = STATE(941),
    [sym_true] = STATE(941),
    [sym_false] = STATE(941),
    [sym_maybe] = STATE(941),
    [sym_unset] = STATE(941),
    [sym_super] = STATE(941),
    [sym_self] = STATE(941),
    [sym_clone] = STATE(941),
    [sym_thisthread] = STATE(941),
    [sym_class] = STATE(941),
    [sym__expression] = STATE(941),
    [sym_return] = STATE(941),
    [sym_gather] = STATE(941),
    [sym_scatter] = STATE(941),
    [sym_allresults] = STATE(941),
    [sym_parenthesized_expression] = STATE(941),
    [sym__variable] = STATE(941),
    [sym_variable] = STATE(941),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(941),
    [sym_relational_operator] = STATE(941),
    [sym_logical_operator] = STATE(941),
    [sym_arithmetic_operator] = STATE(941),
    [sym_unary_operator] = STATE(941),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_handling_token2] = ACTIONS(1281),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1379),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1379),
    [sym_global_variable] = ACTIONS(1379),
    [sym_global_reference] = ACTIONS(1379),
    [sym_number] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1379),
    [sym_comment] = ACTIONS(103),
  },
  [282] = {
    [sym_procedure] = STATE(855),
    [sym_block] = STATE(855),
    [sym_assignment] = STATE(855),
    [sym_if] = STATE(855),
    [sym_loop] = STATE(855),
    [sym_handling] = STATE(855),
    [sym_catch] = STATE(855),
    [sym_throw] = STATE(855),
    [sym_primitive] = STATE(855),
    [sym_iterator] = STATE(855),
    [sym_while] = STATE(855),
    [sym_try] = STATE(855),
    [sym_loopbody] = STATE(855),
    [sym_leave] = STATE(855),
    [sym_continue] = STATE(855),
    [sym_protect] = STATE(855),
    [sym_lock] = STATE(855),
    [sym__literal] = STATE(855),
    [sym_character_literal] = STATE(855),
    [sym_string_literal] = STATE(855),
    [sym_call] = STATE(855),
    [sym_invoke] = STATE(855),
    [sym_indexed_access] = STATE(855),
    [sym_slot_accessor] = STATE(855),
    [sym_true] = STATE(855),
    [sym_false] = STATE(855),
    [sym_maybe] = STATE(855),
    [sym_unset] = STATE(855),
    [sym_super] = STATE(855),
    [sym_self] = STATE(855),
    [sym_clone] = STATE(855),
    [sym_thisthread] = STATE(855),
    [sym_class] = STATE(855),
    [sym__expression] = STATE(855),
    [sym_return] = STATE(855),
    [sym_gather] = STATE(855),
    [sym_scatter] = STATE(855),
    [sym_allresults] = STATE(855),
    [sym_parenthesized_expression] = STATE(855),
    [sym__variable] = STATE(855),
    [sym_variable] = STATE(855),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(855),
    [sym_relational_operator] = STATE(855),
    [sym_logical_operator] = STATE(855),
    [sym_arithmetic_operator] = STATE(855),
    [sym_unary_operator] = STATE(855),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_handling_token2] = ACTIONS(1281),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1387),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1387),
    [sym_global_variable] = ACTIONS(1387),
    [sym_global_reference] = ACTIONS(1387),
    [sym_number] = ACTIONS(1387),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1387),
    [sym_comment] = ACTIONS(103),
  },
  [283] = {
    [sym_procedure] = STATE(914),
    [sym_block] = STATE(914),
    [sym_assignment] = STATE(914),
    [sym_if] = STATE(914),
    [sym_loop] = STATE(914),
    [sym_handling] = STATE(914),
    [sym_catch] = STATE(914),
    [sym_throw] = STATE(914),
    [sym_primitive] = STATE(914),
    [sym_iterator] = STATE(914),
    [sym_while] = STATE(914),
    [sym_try] = STATE(914),
    [sym_loopbody] = STATE(914),
    [sym_leave] = STATE(914),
    [sym_continue] = STATE(914),
    [sym_protect] = STATE(914),
    [sym_lock] = STATE(914),
    [sym__literal] = STATE(914),
    [sym_character_literal] = STATE(914),
    [sym_string_literal] = STATE(914),
    [sym_call] = STATE(914),
    [sym_invoke] = STATE(914),
    [sym_indexed_access] = STATE(914),
    [sym_slot_accessor] = STATE(914),
    [sym_true] = STATE(914),
    [sym_false] = STATE(914),
    [sym_maybe] = STATE(914),
    [sym_unset] = STATE(914),
    [sym_super] = STATE(914),
    [sym_self] = STATE(914),
    [sym_clone] = STATE(914),
    [sym_thisthread] = STATE(914),
    [sym_class] = STATE(914),
    [sym__expression] = STATE(914),
    [sym_return] = STATE(914),
    [sym_gather] = STATE(914),
    [sym_scatter] = STATE(914),
    [sym_allresults] = STATE(914),
    [sym_parenthesized_expression] = STATE(914),
    [sym__variable] = STATE(914),
    [sym_variable] = STATE(914),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(914),
    [sym_relational_operator] = STATE(914),
    [sym_logical_operator] = STATE(914),
    [sym_arithmetic_operator] = STATE(914),
    [sym_unary_operator] = STATE(914),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_handling_token2] = ACTIONS(1299),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1399),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1399),
    [sym_global_variable] = ACTIONS(1399),
    [sym_global_reference] = ACTIONS(1399),
    [sym_number] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1399),
    [sym_comment] = ACTIONS(103),
  },
  [284] = {
    [sym_procedure] = STATE(860),
    [sym_block] = STATE(860),
    [sym_assignment] = STATE(860),
    [sym_if] = STATE(860),
    [sym_loop] = STATE(860),
    [sym_handling] = STATE(860),
    [sym_catch] = STATE(860),
    [sym_throw] = STATE(860),
    [sym_primitive] = STATE(860),
    [sym_iterator] = STATE(860),
    [sym_while] = STATE(860),
    [sym_try] = STATE(860),
    [sym_loopbody] = STATE(860),
    [sym_leave] = STATE(860),
    [sym_continue] = STATE(860),
    [sym_protect] = STATE(860),
    [sym_lock] = STATE(860),
    [sym__literal] = STATE(860),
    [sym_character_literal] = STATE(860),
    [sym_string_literal] = STATE(860),
    [sym_call] = STATE(860),
    [sym_invoke] = STATE(860),
    [sym_indexed_access] = STATE(860),
    [sym_slot_accessor] = STATE(860),
    [sym_true] = STATE(860),
    [sym_false] = STATE(860),
    [sym_maybe] = STATE(860),
    [sym_unset] = STATE(860),
    [sym_super] = STATE(860),
    [sym_self] = STATE(860),
    [sym_clone] = STATE(860),
    [sym_thisthread] = STATE(860),
    [sym_class] = STATE(860),
    [sym__expression] = STATE(860),
    [sym_return] = STATE(860),
    [sym_gather] = STATE(860),
    [sym_scatter] = STATE(860),
    [sym_allresults] = STATE(860),
    [sym_parenthesized_expression] = STATE(860),
    [sym__variable] = STATE(860),
    [sym_variable] = STATE(860),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(860),
    [sym_relational_operator] = STATE(860),
    [sym_logical_operator] = STATE(860),
    [sym_arithmetic_operator] = STATE(860),
    [sym_unary_operator] = STATE(860),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_handling_token2] = ACTIONS(1299),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1401),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1401),
    [sym_global_variable] = ACTIONS(1401),
    [sym_global_reference] = ACTIONS(1401),
    [sym_number] = ACTIONS(1401),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1401),
    [sym_comment] = ACTIONS(103),
  },
  [285] = {
    [sym_procedure] = STATE(968),
    [sym_block] = STATE(968),
    [sym_assignment] = STATE(968),
    [sym_if] = STATE(968),
    [sym_loop] = STATE(968),
    [sym_handling] = STATE(968),
    [sym_catch] = STATE(968),
    [sym_throw] = STATE(968),
    [sym_primitive] = STATE(968),
    [sym_iterator] = STATE(968),
    [sym_while] = STATE(968),
    [sym_try] = STATE(968),
    [sym_loopbody] = STATE(968),
    [sym_leave] = STATE(968),
    [sym_continue] = STATE(968),
    [sym_protect] = STATE(968),
    [sym_lock] = STATE(968),
    [sym__literal] = STATE(968),
    [sym_character_literal] = STATE(968),
    [sym_string_literal] = STATE(968),
    [sym_call] = STATE(968),
    [sym_invoke] = STATE(968),
    [sym_indexed_access] = STATE(968),
    [sym_slot_accessor] = STATE(968),
    [sym__expression_list] = STATE(1864),
    [sym_true] = STATE(968),
    [sym_false] = STATE(968),
    [sym_maybe] = STATE(968),
    [sym_unset] = STATE(968),
    [sym_super] = STATE(968),
    [sym_self] = STATE(968),
    [sym_clone] = STATE(968),
    [sym_thisthread] = STATE(968),
    [sym_class] = STATE(968),
    [sym__expression] = STATE(968),
    [sym_return] = STATE(968),
    [sym_gather] = STATE(968),
    [sym_scatter] = STATE(968),
    [sym_allresults] = STATE(968),
    [sym_parenthesized_expression] = STATE(968),
    [sym__variable] = STATE(968),
    [sym_variable] = STATE(968),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(968),
    [sym_relational_operator] = STATE(968),
    [sym_logical_operator] = STATE(968),
    [sym_arithmetic_operator] = STATE(968),
    [sym_unary_operator] = STATE(968),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1403),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1403),
    [sym_global_variable] = ACTIONS(1403),
    [sym_global_reference] = ACTIONS(1403),
    [sym_number] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1403),
    [sym_comment] = ACTIONS(103),
  },
  [286] = {
    [sym_procedure] = STATE(974),
    [sym_block] = STATE(974),
    [sym_assignment] = STATE(974),
    [sym_if] = STATE(974),
    [sym_loop] = STATE(974),
    [sym_handling] = STATE(974),
    [sym_catch] = STATE(974),
    [sym_throw] = STATE(974),
    [sym_primitive] = STATE(974),
    [sym_iterator] = STATE(974),
    [sym_while] = STATE(974),
    [sym_try] = STATE(974),
    [sym_loopbody] = STATE(974),
    [sym_leave] = STATE(974),
    [sym_continue] = STATE(974),
    [sym_protect] = STATE(974),
    [sym_lock] = STATE(974),
    [sym__literal] = STATE(974),
    [sym_character_literal] = STATE(974),
    [sym_string_literal] = STATE(974),
    [sym_call] = STATE(974),
    [sym_invoke] = STATE(974),
    [sym_indexed_access] = STATE(974),
    [sym_slot_accessor] = STATE(974),
    [sym__expression_list] = STATE(1864),
    [sym_true] = STATE(974),
    [sym_false] = STATE(974),
    [sym_maybe] = STATE(974),
    [sym_unset] = STATE(974),
    [sym_super] = STATE(974),
    [sym_self] = STATE(974),
    [sym_clone] = STATE(974),
    [sym_thisthread] = STATE(974),
    [sym_class] = STATE(974),
    [sym__expression] = STATE(974),
    [sym_return] = STATE(974),
    [sym_gather] = STATE(974),
    [sym_scatter] = STATE(974),
    [sym_allresults] = STATE(974),
    [sym_parenthesized_expression] = STATE(974),
    [sym__variable] = STATE(974),
    [sym_variable] = STATE(974),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(974),
    [sym_relational_operator] = STATE(974),
    [sym_logical_operator] = STATE(974),
    [sym_arithmetic_operator] = STATE(974),
    [sym_unary_operator] = STATE(974),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1405),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1405),
    [sym_global_variable] = ACTIONS(1405),
    [sym_global_reference] = ACTIONS(1405),
    [sym_number] = ACTIONS(1405),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1405),
    [sym_comment] = ACTIONS(103),
  },
  [287] = {
    [sym_procedure] = STATE(896),
    [sym_block] = STATE(896),
    [sym_assignment] = STATE(896),
    [sym_if] = STATE(896),
    [sym_loop] = STATE(896),
    [sym_handling] = STATE(896),
    [sym_catch] = STATE(896),
    [sym_throw] = STATE(896),
    [sym_primitive] = STATE(896),
    [sym_iterator] = STATE(896),
    [sym_while] = STATE(896),
    [sym_try] = STATE(896),
    [sym_loopbody] = STATE(896),
    [sym_leave] = STATE(896),
    [sym_continue] = STATE(896),
    [sym_protect] = STATE(896),
    [sym_lock] = STATE(896),
    [sym__literal] = STATE(896),
    [sym_character_literal] = STATE(896),
    [sym_string_literal] = STATE(896),
    [sym_call] = STATE(896),
    [sym_invoke] = STATE(896),
    [sym_indexed_access] = STATE(896),
    [sym_slot_accessor] = STATE(896),
    [sym__expression_list] = STATE(534),
    [sym_true] = STATE(896),
    [sym_false] = STATE(896),
    [sym_maybe] = STATE(896),
    [sym_unset] = STATE(896),
    [sym_super] = STATE(896),
    [sym_self] = STATE(896),
    [sym_clone] = STATE(896),
    [sym_thisthread] = STATE(896),
    [sym_class] = STATE(896),
    [sym__expression] = STATE(896),
    [sym_return] = STATE(896),
    [sym_gather] = STATE(896),
    [sym_scatter] = STATE(896),
    [sym_allresults] = STATE(896),
    [sym_parenthesized_expression] = STATE(896),
    [sym__variable] = STATE(896),
    [sym_variable] = STATE(896),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(896),
    [sym_relational_operator] = STATE(896),
    [sym_logical_operator] = STATE(896),
    [sym_arithmetic_operator] = STATE(896),
    [sym_unary_operator] = STATE(896),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1373),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1373),
    [sym_global_variable] = ACTIONS(1373),
    [sym_global_reference] = ACTIONS(1373),
    [sym_number] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1373),
    [sym_comment] = ACTIONS(103),
  },
  [288] = {
    [sym_procedure] = STATE(779),
    [sym_block] = STATE(779),
    [sym_assignment] = STATE(779),
    [sym_if] = STATE(779),
    [sym_loop] = STATE(779),
    [sym_handling] = STATE(779),
    [sym_catch] = STATE(779),
    [sym_throw] = STATE(779),
    [sym_primitive] = STATE(779),
    [sym_iterator] = STATE(779),
    [sym_while] = STATE(779),
    [sym_try] = STATE(779),
    [sym_loopbody] = STATE(779),
    [sym_leave] = STATE(779),
    [sym_continue] = STATE(779),
    [sym_protect] = STATE(779),
    [sym_lock] = STATE(779),
    [sym__literal] = STATE(779),
    [sym_character_literal] = STATE(779),
    [sym_string_literal] = STATE(779),
    [sym_call] = STATE(779),
    [sym_invoke] = STATE(779),
    [sym_indexed_access] = STATE(779),
    [sym_slot_accessor] = STATE(779),
    [sym__expression_list] = STATE(534),
    [sym_true] = STATE(779),
    [sym_false] = STATE(779),
    [sym_maybe] = STATE(779),
    [sym_unset] = STATE(779),
    [sym_super] = STATE(779),
    [sym_self] = STATE(779),
    [sym_clone] = STATE(779),
    [sym_thisthread] = STATE(779),
    [sym_class] = STATE(779),
    [sym__expression] = STATE(779),
    [sym_return] = STATE(779),
    [sym_gather] = STATE(779),
    [sym_scatter] = STATE(779),
    [sym_allresults] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym__variable] = STATE(779),
    [sym_variable] = STATE(779),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(779),
    [sym_relational_operator] = STATE(779),
    [sym_logical_operator] = STATE(779),
    [sym_arithmetic_operator] = STATE(779),
    [sym_unary_operator] = STATE(779),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1407),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1407),
    [sym_global_variable] = ACTIONS(1407),
    [sym_global_reference] = ACTIONS(1407),
    [sym_number] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1407),
    [sym_comment] = ACTIONS(103),
  },
  [289] = {
    [sym_procedure] = STATE(988),
    [sym_block] = STATE(988),
    [sym_assignment] = STATE(988),
    [sym_if] = STATE(988),
    [sym_loop] = STATE(988),
    [sym_handling] = STATE(988),
    [sym_catch] = STATE(988),
    [sym_throw] = STATE(988),
    [sym_primitive] = STATE(988),
    [sym_iterator] = STATE(988),
    [sym_while] = STATE(988),
    [sym_try] = STATE(988),
    [sym_loopbody] = STATE(988),
    [sym_leave] = STATE(988),
    [sym_continue] = STATE(988),
    [sym_protect] = STATE(988),
    [sym_lock] = STATE(988),
    [sym__literal] = STATE(988),
    [sym_character_literal] = STATE(988),
    [sym_string_literal] = STATE(988),
    [sym_call] = STATE(988),
    [sym_invoke] = STATE(988),
    [sym_indexed_access] = STATE(988),
    [sym_slot_accessor] = STATE(988),
    [sym_true] = STATE(988),
    [sym_false] = STATE(988),
    [sym_maybe] = STATE(988),
    [sym_unset] = STATE(988),
    [sym_super] = STATE(988),
    [sym_self] = STATE(988),
    [sym_clone] = STATE(988),
    [sym_thisthread] = STATE(988),
    [sym_class] = STATE(988),
    [sym__expression] = STATE(988),
    [sym_return] = STATE(988),
    [sym_gather] = STATE(988),
    [sym_scatter] = STATE(988),
    [sym_allresults] = STATE(988),
    [sym_parenthesized_expression] = STATE(988),
    [sym__variable] = STATE(988),
    [sym_variable] = STATE(988),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(988),
    [sym_relational_operator] = STATE(988),
    [sym_logical_operator] = STATE(988),
    [sym_arithmetic_operator] = STATE(988),
    [sym_unary_operator] = STATE(988),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_handling_token2] = ACTIONS(1343),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1409),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1409),
    [sym_global_variable] = ACTIONS(1409),
    [sym_global_reference] = ACTIONS(1409),
    [sym_number] = ACTIONS(1409),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1409),
    [sym_comment] = ACTIONS(103),
  },
  [290] = {
    [sym_procedure] = STATE(757),
    [sym_block] = STATE(757),
    [sym_assignment] = STATE(757),
    [sym_if] = STATE(757),
    [sym_loop] = STATE(757),
    [sym_handling] = STATE(757),
    [sym_catch] = STATE(757),
    [sym_throw] = STATE(757),
    [sym_primitive] = STATE(757),
    [sym_iterator] = STATE(757),
    [sym_while] = STATE(757),
    [sym_try] = STATE(757),
    [sym_loopbody] = STATE(757),
    [sym_leave] = STATE(757),
    [sym_continue] = STATE(757),
    [sym_protect] = STATE(757),
    [sym_lock] = STATE(757),
    [sym__literal] = STATE(757),
    [sym_character_literal] = STATE(757),
    [sym_string_literal] = STATE(757),
    [sym_call] = STATE(757),
    [sym_invoke] = STATE(757),
    [sym_indexed_access] = STATE(757),
    [sym_slot_accessor] = STATE(757),
    [sym_true] = STATE(757),
    [sym_false] = STATE(757),
    [sym_maybe] = STATE(757),
    [sym_unset] = STATE(757),
    [sym_super] = STATE(757),
    [sym_self] = STATE(757),
    [sym_clone] = STATE(757),
    [sym_thisthread] = STATE(757),
    [sym_class] = STATE(757),
    [sym__expression] = STATE(757),
    [sym_return] = STATE(757),
    [sym_gather] = STATE(757),
    [sym_scatter] = STATE(757),
    [sym_allresults] = STATE(757),
    [sym_parenthesized_expression] = STATE(757),
    [sym__variable] = STATE(757),
    [sym_variable] = STATE(757),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(757),
    [sym_relational_operator] = STATE(757),
    [sym_logical_operator] = STATE(757),
    [sym_arithmetic_operator] = STATE(757),
    [sym_unary_operator] = STATE(757),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1411),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1413),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_global_reference] = ACTIONS(1413),
    [sym_number] = ACTIONS(1413),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1413),
    [sym_comment] = ACTIONS(103),
  },
  [291] = {
    [sym_procedure] = STATE(977),
    [sym_block] = STATE(977),
    [sym_assignment] = STATE(977),
    [sym_if] = STATE(977),
    [sym_loop] = STATE(977),
    [sym_handling] = STATE(977),
    [sym_catch] = STATE(977),
    [sym_throw] = STATE(977),
    [sym_primitive] = STATE(977),
    [sym_iterator] = STATE(977),
    [sym_while] = STATE(977),
    [sym_try] = STATE(977),
    [sym_loopbody] = STATE(977),
    [sym_leave] = STATE(977),
    [sym_continue] = STATE(977),
    [sym_protect] = STATE(977),
    [sym_lock] = STATE(977),
    [sym__literal] = STATE(977),
    [sym_character_literal] = STATE(977),
    [sym_string_literal] = STATE(977),
    [sym_call] = STATE(977),
    [sym_invoke] = STATE(977),
    [sym_indexed_access] = STATE(977),
    [sym_slot_accessor] = STATE(977),
    [sym_true] = STATE(977),
    [sym_false] = STATE(977),
    [sym_maybe] = STATE(977),
    [sym_unset] = STATE(977),
    [sym_super] = STATE(977),
    [sym_self] = STATE(977),
    [sym_clone] = STATE(977),
    [sym_thisthread] = STATE(977),
    [sym_class] = STATE(977),
    [sym__expression] = STATE(977),
    [sym_return] = STATE(977),
    [sym_gather] = STATE(977),
    [sym_scatter] = STATE(977),
    [sym_allresults] = STATE(977),
    [sym_parenthesized_expression] = STATE(977),
    [sym__variable] = STATE(977),
    [sym_variable] = STATE(977),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(977),
    [sym_relational_operator] = STATE(977),
    [sym_logical_operator] = STATE(977),
    [sym_arithmetic_operator] = STATE(977),
    [sym_unary_operator] = STATE(977),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1315),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1415),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1415),
    [sym_global_variable] = ACTIONS(1415),
    [sym_global_reference] = ACTIONS(1415),
    [sym_number] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1415),
    [sym_comment] = ACTIONS(103),
  },
  [292] = {
    [sym_procedure] = STATE(768),
    [sym_block] = STATE(768),
    [sym_assignment] = STATE(768),
    [sym_if] = STATE(768),
    [sym_loop] = STATE(768),
    [sym_handling] = STATE(768),
    [sym_catch] = STATE(768),
    [sym_throw] = STATE(768),
    [sym_primitive] = STATE(768),
    [sym_iterator] = STATE(768),
    [sym_while] = STATE(768),
    [sym_try] = STATE(768),
    [sym_loopbody] = STATE(768),
    [sym_leave] = STATE(768),
    [sym_continue] = STATE(768),
    [sym_protect] = STATE(768),
    [sym_lock] = STATE(768),
    [sym__literal] = STATE(768),
    [sym_character_literal] = STATE(768),
    [sym_string_literal] = STATE(768),
    [sym_call] = STATE(768),
    [sym_invoke] = STATE(768),
    [sym_indexed_access] = STATE(768),
    [sym_slot_accessor] = STATE(768),
    [sym_true] = STATE(768),
    [sym_false] = STATE(768),
    [sym_maybe] = STATE(768),
    [sym_unset] = STATE(768),
    [sym_super] = STATE(768),
    [sym_self] = STATE(768),
    [sym_clone] = STATE(768),
    [sym_thisthread] = STATE(768),
    [sym_class] = STATE(768),
    [sym__expression] = STATE(768),
    [sym_return] = STATE(768),
    [sym_gather] = STATE(768),
    [sym_scatter] = STATE(768),
    [sym_allresults] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym__variable] = STATE(768),
    [sym_variable] = STATE(768),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(768),
    [sym_relational_operator] = STATE(768),
    [sym_logical_operator] = STATE(768),
    [sym_arithmetic_operator] = STATE(768),
    [sym_unary_operator] = STATE(768),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1343),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1417),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1417),
    [sym_global_variable] = ACTIONS(1417),
    [sym_global_reference] = ACTIONS(1417),
    [sym_number] = ACTIONS(1417),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1417),
    [sym_comment] = ACTIONS(103),
  },
  [293] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(1881),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [294] = {
    [sym_procedure] = STATE(976),
    [sym_block] = STATE(976),
    [sym_assignment] = STATE(976),
    [sym_if] = STATE(976),
    [sym_loop] = STATE(976),
    [sym_handling] = STATE(976),
    [sym_catch] = STATE(976),
    [sym_throw] = STATE(976),
    [sym_primitive] = STATE(976),
    [sym_iterator] = STATE(976),
    [sym_while] = STATE(976),
    [sym_try] = STATE(976),
    [sym_loopbody] = STATE(976),
    [sym_leave] = STATE(976),
    [sym_continue] = STATE(976),
    [sym_protect] = STATE(976),
    [sym_lock] = STATE(976),
    [sym__literal] = STATE(976),
    [sym_character_literal] = STATE(976),
    [sym_string_literal] = STATE(976),
    [sym_call] = STATE(976),
    [sym_invoke] = STATE(976),
    [sym_indexed_access] = STATE(976),
    [sym_slot_accessor] = STATE(976),
    [sym_true] = STATE(976),
    [sym_false] = STATE(976),
    [sym_maybe] = STATE(976),
    [sym_unset] = STATE(976),
    [sym_super] = STATE(976),
    [sym_self] = STATE(976),
    [sym_clone] = STATE(976),
    [sym_thisthread] = STATE(976),
    [sym_class] = STATE(976),
    [sym__expression] = STATE(976),
    [sym_return] = STATE(976),
    [sym_gather] = STATE(976),
    [sym_scatter] = STATE(976),
    [sym_allresults] = STATE(976),
    [sym_parenthesized_expression] = STATE(976),
    [sym__variable] = STATE(976),
    [sym_variable] = STATE(976),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(976),
    [sym_relational_operator] = STATE(976),
    [sym_logical_operator] = STATE(976),
    [sym_arithmetic_operator] = STATE(976),
    [sym_unary_operator] = STATE(976),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1315),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1419),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1419),
    [sym_global_variable] = ACTIONS(1419),
    [sym_global_reference] = ACTIONS(1419),
    [sym_number] = ACTIONS(1419),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1419),
    [sym_comment] = ACTIONS(103),
  },
  [295] = {
    [sym_procedure] = STATE(989),
    [sym_block] = STATE(989),
    [sym_assignment] = STATE(989),
    [sym_if] = STATE(989),
    [sym_loop] = STATE(989),
    [sym_handling] = STATE(989),
    [sym_catch] = STATE(989),
    [sym_throw] = STATE(989),
    [sym_primitive] = STATE(989),
    [sym_iterator] = STATE(989),
    [sym_while] = STATE(989),
    [sym_try] = STATE(989),
    [sym_loopbody] = STATE(989),
    [sym_leave] = STATE(989),
    [sym_continue] = STATE(989),
    [sym_protect] = STATE(989),
    [sym_lock] = STATE(989),
    [sym__literal] = STATE(989),
    [sym_character_literal] = STATE(989),
    [sym_string_literal] = STATE(989),
    [sym_call] = STATE(989),
    [sym_invoke] = STATE(989),
    [sym_indexed_access] = STATE(989),
    [sym_slot_accessor] = STATE(989),
    [sym_true] = STATE(989),
    [sym_false] = STATE(989),
    [sym_maybe] = STATE(989),
    [sym_unset] = STATE(989),
    [sym_super] = STATE(989),
    [sym_self] = STATE(989),
    [sym_clone] = STATE(989),
    [sym_thisthread] = STATE(989),
    [sym_class] = STATE(989),
    [sym__expression] = STATE(989),
    [sym_return] = STATE(989),
    [sym_gather] = STATE(989),
    [sym_scatter] = STATE(989),
    [sym_allresults] = STATE(989),
    [sym_parenthesized_expression] = STATE(989),
    [sym__variable] = STATE(989),
    [sym_variable] = STATE(989),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(989),
    [sym_relational_operator] = STATE(989),
    [sym_logical_operator] = STATE(989),
    [sym_arithmetic_operator] = STATE(989),
    [sym_unary_operator] = STATE(989),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_handling_token2] = ACTIONS(1411),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1421),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1421),
    [sym_global_variable] = ACTIONS(1421),
    [sym_global_reference] = ACTIONS(1421),
    [sym_number] = ACTIONS(1421),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1421),
    [sym_comment] = ACTIONS(103),
  },
  [296] = {
    [sym_procedure] = STATE(742),
    [sym_block] = STATE(742),
    [sym_assignment] = STATE(742),
    [sym_if] = STATE(742),
    [sym_loop] = STATE(742),
    [sym_handling] = STATE(742),
    [sym_catch] = STATE(742),
    [sym_throw] = STATE(742),
    [sym_primitive] = STATE(742),
    [sym_iterator] = STATE(742),
    [sym_while] = STATE(742),
    [sym_try] = STATE(742),
    [sym_loopbody] = STATE(742),
    [sym_leave] = STATE(742),
    [sym_continue] = STATE(742),
    [sym_protect] = STATE(742),
    [sym_lock] = STATE(742),
    [sym__literal] = STATE(742),
    [sym_character_literal] = STATE(742),
    [sym_string_literal] = STATE(742),
    [sym_call] = STATE(742),
    [sym_invoke] = STATE(742),
    [sym_indexed_access] = STATE(742),
    [sym_slot_accessor] = STATE(742),
    [sym__expression_list] = STATE(824),
    [sym_true] = STATE(742),
    [sym_false] = STATE(742),
    [sym_maybe] = STATE(742),
    [sym_unset] = STATE(742),
    [sym_super] = STATE(742),
    [sym_self] = STATE(742),
    [sym_clone] = STATE(742),
    [sym_thisthread] = STATE(742),
    [sym_class] = STATE(742),
    [sym__expression] = STATE(742),
    [sym_return] = STATE(742),
    [sym_gather] = STATE(742),
    [sym_scatter] = STATE(742),
    [sym_allresults] = STATE(742),
    [sym_parenthesized_expression] = STATE(742),
    [sym__variable] = STATE(742),
    [sym_variable] = STATE(742),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(742),
    [sym_relational_operator] = STATE(742),
    [sym_logical_operator] = STATE(742),
    [sym_arithmetic_operator] = STATE(742),
    [sym_unary_operator] = STATE(742),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(347),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(347),
    [sym_global_variable] = ACTIONS(347),
    [sym_global_reference] = ACTIONS(347),
    [sym_number] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(347),
    [sym_comment] = ACTIONS(103),
  },
  [297] = {
    [sym_procedure] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(978),
    [sym_if] = STATE(978),
    [sym_loop] = STATE(978),
    [sym_handling] = STATE(978),
    [sym_catch] = STATE(978),
    [sym_throw] = STATE(978),
    [sym_primitive] = STATE(978),
    [sym_iterator] = STATE(978),
    [sym_while] = STATE(978),
    [sym_try] = STATE(978),
    [sym_loopbody] = STATE(978),
    [sym_leave] = STATE(978),
    [sym_continue] = STATE(978),
    [sym_protect] = STATE(978),
    [sym_lock] = STATE(978),
    [sym__literal] = STATE(978),
    [sym_character_literal] = STATE(978),
    [sym_string_literal] = STATE(978),
    [sym_call] = STATE(978),
    [sym_invoke] = STATE(978),
    [sym_indexed_access] = STATE(978),
    [sym_slot_accessor] = STATE(978),
    [sym_true] = STATE(978),
    [sym_false] = STATE(978),
    [sym_maybe] = STATE(978),
    [sym_unset] = STATE(978),
    [sym_super] = STATE(978),
    [sym_self] = STATE(978),
    [sym_clone] = STATE(978),
    [sym_thisthread] = STATE(978),
    [sym_class] = STATE(978),
    [sym__expression] = STATE(978),
    [sym_return] = STATE(978),
    [sym_gather] = STATE(978),
    [sym_scatter] = STATE(978),
    [sym_allresults] = STATE(978),
    [sym_parenthesized_expression] = STATE(978),
    [sym__variable] = STATE(978),
    [sym_variable] = STATE(978),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(978),
    [sym_relational_operator] = STATE(978),
    [sym_logical_operator] = STATE(978),
    [sym_arithmetic_operator] = STATE(978),
    [sym_unary_operator] = STATE(978),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1347),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1423),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1423),
    [sym_global_variable] = ACTIONS(1423),
    [sym_global_reference] = ACTIONS(1423),
    [sym_number] = ACTIONS(1423),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1423),
    [sym_comment] = ACTIONS(103),
  },
  [298] = {
    [sym_procedure] = STATE(697),
    [sym_block] = STATE(697),
    [sym_assignment] = STATE(697),
    [sym_if] = STATE(697),
    [sym_loop] = STATE(697),
    [sym_handling] = STATE(697),
    [sym_catch] = STATE(697),
    [sym_throw] = STATE(697),
    [sym_primitive] = STATE(697),
    [sym_iterator] = STATE(697),
    [sym_while] = STATE(697),
    [sym_try] = STATE(697),
    [sym_loopbody] = STATE(697),
    [sym_leave] = STATE(697),
    [sym_continue] = STATE(697),
    [sym_protect] = STATE(697),
    [sym_lock] = STATE(697),
    [sym__literal] = STATE(697),
    [sym_character_literal] = STATE(697),
    [sym_string_literal] = STATE(697),
    [sym_call] = STATE(697),
    [sym_invoke] = STATE(697),
    [sym_indexed_access] = STATE(697),
    [sym_slot_accessor] = STATE(697),
    [sym__expression_list] = STATE(824),
    [sym_true] = STATE(697),
    [sym_false] = STATE(697),
    [sym_maybe] = STATE(697),
    [sym_unset] = STATE(697),
    [sym_super] = STATE(697),
    [sym_self] = STATE(697),
    [sym_clone] = STATE(697),
    [sym_thisthread] = STATE(697),
    [sym_class] = STATE(697),
    [sym__expression] = STATE(697),
    [sym_return] = STATE(697),
    [sym_gather] = STATE(697),
    [sym_scatter] = STATE(697),
    [sym_allresults] = STATE(697),
    [sym_parenthesized_expression] = STATE(697),
    [sym__variable] = STATE(697),
    [sym_variable] = STATE(697),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(697),
    [sym_relational_operator] = STATE(697),
    [sym_logical_operator] = STATE(697),
    [sym_arithmetic_operator] = STATE(697),
    [sym_unary_operator] = STATE(697),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(259),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(259),
    [sym_global_variable] = ACTIONS(259),
    [sym_global_reference] = ACTIONS(259),
    [sym_number] = ACTIONS(259),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(259),
    [sym_comment] = ACTIONS(103),
  },
  [299] = {
    [sym_procedure] = STATE(973),
    [sym_block] = STATE(973),
    [sym_assignment] = STATE(973),
    [sym_if] = STATE(973),
    [sym_loop] = STATE(973),
    [sym_handling] = STATE(973),
    [sym_catch] = STATE(973),
    [sym_throw] = STATE(973),
    [sym_primitive] = STATE(973),
    [sym_iterator] = STATE(973),
    [sym_while] = STATE(973),
    [sym_try] = STATE(973),
    [sym_loopbody] = STATE(973),
    [sym_leave] = STATE(973),
    [sym_continue] = STATE(973),
    [sym_protect] = STATE(973),
    [sym_lock] = STATE(973),
    [sym__literal] = STATE(973),
    [sym_character_literal] = STATE(973),
    [sym_string_literal] = STATE(973),
    [sym_call] = STATE(973),
    [sym_invoke] = STATE(973),
    [sym_indexed_access] = STATE(973),
    [sym_slot_accessor] = STATE(973),
    [sym_true] = STATE(973),
    [sym_false] = STATE(973),
    [sym_maybe] = STATE(973),
    [sym_unset] = STATE(973),
    [sym_super] = STATE(973),
    [sym_self] = STATE(973),
    [sym_clone] = STATE(973),
    [sym_thisthread] = STATE(973),
    [sym_class] = STATE(973),
    [sym__expression] = STATE(973),
    [sym_return] = STATE(973),
    [sym_gather] = STATE(973),
    [sym_scatter] = STATE(973),
    [sym_allresults] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym__variable] = STATE(973),
    [sym_variable] = STATE(973),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(973),
    [sym_relational_operator] = STATE(973),
    [sym_logical_operator] = STATE(973),
    [sym_arithmetic_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_handling_token2] = ACTIONS(1315),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1425),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1425),
    [sym_global_variable] = ACTIONS(1425),
    [sym_global_reference] = ACTIONS(1425),
    [sym_number] = ACTIONS(1425),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1425),
    [sym_comment] = ACTIONS(103),
  },
  [300] = {
    [sym_procedure] = STATE(644),
    [sym_block] = STATE(644),
    [sym_assignment] = STATE(644),
    [sym_if] = STATE(644),
    [sym_loop] = STATE(644),
    [sym_handling] = STATE(644),
    [sym_catch] = STATE(644),
    [sym_throw] = STATE(644),
    [sym_primitive] = STATE(644),
    [sym_iterator] = STATE(644),
    [sym_while] = STATE(644),
    [sym_try] = STATE(644),
    [sym_loopbody] = STATE(644),
    [sym_leave] = STATE(644),
    [sym_continue] = STATE(644),
    [sym_protect] = STATE(644),
    [sym_lock] = STATE(644),
    [sym__literal] = STATE(644),
    [sym_character_literal] = STATE(644),
    [sym_string_literal] = STATE(644),
    [sym_call] = STATE(644),
    [sym_invoke] = STATE(644),
    [sym_indexed_access] = STATE(644),
    [sym_slot_accessor] = STATE(644),
    [sym_true] = STATE(644),
    [sym_false] = STATE(644),
    [sym_maybe] = STATE(644),
    [sym_unset] = STATE(644),
    [sym_super] = STATE(644),
    [sym_self] = STATE(644),
    [sym_clone] = STATE(644),
    [sym_thisthread] = STATE(644),
    [sym_class] = STATE(644),
    [sym__expression] = STATE(644),
    [sym_return] = STATE(644),
    [sym_gather] = STATE(644),
    [sym_scatter] = STATE(644),
    [sym_allresults] = STATE(644),
    [sym_parenthesized_expression] = STATE(644),
    [sym__variable] = STATE(644),
    [sym_variable] = STATE(644),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(644),
    [sym_relational_operator] = STATE(644),
    [sym_logical_operator] = STATE(644),
    [sym_arithmetic_operator] = STATE(644),
    [sym_unary_operator] = STATE(644),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_handling_token2] = ACTIONS(1281),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1427),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1427),
    [sym_global_variable] = ACTIONS(1427),
    [sym_global_reference] = ACTIONS(1427),
    [sym_number] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1427),
    [sym_comment] = ACTIONS(103),
  },
  [301] = {
    [sym_procedure] = STATE(901),
    [sym_block] = STATE(901),
    [sym_assignment] = STATE(901),
    [sym_if] = STATE(901),
    [sym_loop] = STATE(901),
    [sym_handling] = STATE(901),
    [sym_catch] = STATE(901),
    [sym_throw] = STATE(901),
    [sym_primitive] = STATE(901),
    [sym_iterator] = STATE(901),
    [sym_while] = STATE(901),
    [sym_try] = STATE(901),
    [sym_loopbody] = STATE(901),
    [sym_leave] = STATE(901),
    [sym_continue] = STATE(901),
    [sym_protect] = STATE(901),
    [sym_lock] = STATE(901),
    [sym__literal] = STATE(901),
    [sym_character_literal] = STATE(901),
    [sym_string_literal] = STATE(901),
    [sym_call] = STATE(901),
    [sym_invoke] = STATE(901),
    [sym_indexed_access] = STATE(901),
    [sym_slot_accessor] = STATE(901),
    [sym_true] = STATE(901),
    [sym_false] = STATE(901),
    [sym_maybe] = STATE(901),
    [sym_unset] = STATE(901),
    [sym_super] = STATE(901),
    [sym_self] = STATE(901),
    [sym_clone] = STATE(901),
    [sym_thisthread] = STATE(901),
    [sym_class] = STATE(901),
    [sym__expression] = STATE(901),
    [sym_return] = STATE(901),
    [sym_gather] = STATE(901),
    [sym_scatter] = STATE(901),
    [sym_allresults] = STATE(901),
    [sym_parenthesized_expression] = STATE(901),
    [sym__variable] = STATE(901),
    [sym_variable] = STATE(901),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(901),
    [sym_relational_operator] = STATE(901),
    [sym_logical_operator] = STATE(901),
    [sym_arithmetic_operator] = STATE(901),
    [sym_unary_operator] = STATE(901),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_handling_token2] = ACTIONS(1411),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1429),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1429),
    [sym_global_variable] = ACTIONS(1429),
    [sym_global_reference] = ACTIONS(1429),
    [sym_number] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1429),
    [sym_comment] = ACTIONS(103),
  },
  [302] = {
    [sym_procedure] = STATE(902),
    [sym_block] = STATE(902),
    [sym_assignment] = STATE(902),
    [sym_if] = STATE(902),
    [sym_loop] = STATE(902),
    [sym_handling] = STATE(902),
    [sym_catch] = STATE(902),
    [sym_throw] = STATE(902),
    [sym_primitive] = STATE(902),
    [sym_iterator] = STATE(902),
    [sym_while] = STATE(902),
    [sym_try] = STATE(902),
    [sym_loopbody] = STATE(902),
    [sym_leave] = STATE(902),
    [sym_continue] = STATE(902),
    [sym_protect] = STATE(902),
    [sym_lock] = STATE(902),
    [sym__literal] = STATE(902),
    [sym_character_literal] = STATE(902),
    [sym_string_literal] = STATE(902),
    [sym_call] = STATE(902),
    [sym_invoke] = STATE(902),
    [sym_indexed_access] = STATE(902),
    [sym_slot_accessor] = STATE(902),
    [sym_true] = STATE(902),
    [sym_false] = STATE(902),
    [sym_maybe] = STATE(902),
    [sym_unset] = STATE(902),
    [sym_super] = STATE(902),
    [sym_self] = STATE(902),
    [sym_clone] = STATE(902),
    [sym_thisthread] = STATE(902),
    [sym_class] = STATE(902),
    [sym__expression] = STATE(902),
    [sym_return] = STATE(902),
    [sym_gather] = STATE(902),
    [sym_scatter] = STATE(902),
    [sym_allresults] = STATE(902),
    [sym_parenthesized_expression] = STATE(902),
    [sym__variable] = STATE(902),
    [sym_variable] = STATE(902),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(902),
    [sym_relational_operator] = STATE(902),
    [sym_logical_operator] = STATE(902),
    [sym_arithmetic_operator] = STATE(902),
    [sym_unary_operator] = STATE(902),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1431),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1431),
    [sym_global_variable] = ACTIONS(1431),
    [sym_global_reference] = ACTIONS(1431),
    [sym_number] = ACTIONS(1431),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1431),
    [sym_comment] = ACTIONS(103),
  },
  [303] = {
    [sym_procedure] = STATE(633),
    [sym_block] = STATE(633),
    [sym_assignment] = STATE(633),
    [sym_if] = STATE(633),
    [sym_loop] = STATE(633),
    [sym_handling] = STATE(633),
    [sym_catch] = STATE(633),
    [sym_throw] = STATE(633),
    [sym_primitive] = STATE(633),
    [sym_iterator] = STATE(633),
    [sym_while] = STATE(633),
    [sym_try] = STATE(633),
    [sym_loopbody] = STATE(633),
    [sym_leave] = STATE(633),
    [sym_continue] = STATE(633),
    [sym_protect] = STATE(633),
    [sym_lock] = STATE(633),
    [sym__literal] = STATE(633),
    [sym_character_literal] = STATE(633),
    [sym_string_literal] = STATE(633),
    [sym_call] = STATE(633),
    [sym_invoke] = STATE(633),
    [sym_indexed_access] = STATE(633),
    [sym_slot_accessor] = STATE(633),
    [sym_true] = STATE(633),
    [sym_false] = STATE(633),
    [sym_maybe] = STATE(633),
    [sym_unset] = STATE(633),
    [sym_super] = STATE(633),
    [sym_self] = STATE(633),
    [sym_clone] = STATE(633),
    [sym_thisthread] = STATE(633),
    [sym_class] = STATE(633),
    [sym__expression] = STATE(633),
    [sym_return] = STATE(633),
    [sym_gather] = STATE(633),
    [sym_scatter] = STATE(633),
    [sym_allresults] = STATE(633),
    [sym_parenthesized_expression] = STATE(633),
    [sym__variable] = STATE(633),
    [sym_variable] = STATE(633),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(633),
    [sym_relational_operator] = STATE(633),
    [sym_logical_operator] = STATE(633),
    [sym_arithmetic_operator] = STATE(633),
    [sym_unary_operator] = STATE(633),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1435),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1435),
    [sym_global_variable] = ACTIONS(1435),
    [sym_global_reference] = ACTIONS(1435),
    [sym_number] = ACTIONS(1435),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1435),
    [sym_comment] = ACTIONS(103),
  },
  [304] = {
    [sym_procedure] = STATE(650),
    [sym_block] = STATE(650),
    [sym_assignment] = STATE(650),
    [sym_if] = STATE(650),
    [sym_loop] = STATE(650),
    [sym_handling] = STATE(650),
    [sym_catch] = STATE(650),
    [sym_throw] = STATE(650),
    [sym_primitive] = STATE(650),
    [sym_iterator] = STATE(650),
    [sym_while] = STATE(650),
    [sym_try] = STATE(650),
    [sym_loopbody] = STATE(650),
    [sym_leave] = STATE(650),
    [sym_continue] = STATE(650),
    [sym_protect] = STATE(650),
    [sym_lock] = STATE(650),
    [sym__literal] = STATE(650),
    [sym_character_literal] = STATE(650),
    [sym_string_literal] = STATE(650),
    [sym_call] = STATE(650),
    [sym_invoke] = STATE(650),
    [sym_indexed_access] = STATE(650),
    [sym_slot_accessor] = STATE(650),
    [sym_true] = STATE(650),
    [sym_false] = STATE(650),
    [sym_maybe] = STATE(650),
    [sym_unset] = STATE(650),
    [sym_super] = STATE(650),
    [sym_self] = STATE(650),
    [sym_clone] = STATE(650),
    [sym_thisthread] = STATE(650),
    [sym_class] = STATE(650),
    [sym__expression] = STATE(650),
    [sym_return] = STATE(650),
    [sym_gather] = STATE(650),
    [sym_scatter] = STATE(650),
    [sym_allresults] = STATE(650),
    [sym_parenthesized_expression] = STATE(650),
    [sym__variable] = STATE(650),
    [sym_variable] = STATE(650),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(650),
    [sym_relational_operator] = STATE(650),
    [sym_logical_operator] = STATE(650),
    [sym_arithmetic_operator] = STATE(650),
    [sym_unary_operator] = STATE(650),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1437),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1437),
    [sym_global_variable] = ACTIONS(1437),
    [sym_global_reference] = ACTIONS(1437),
    [sym_number] = ACTIONS(1437),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1437),
    [sym_comment] = ACTIONS(103),
  },
  [305] = {
    [sym_procedure] = STATE(1008),
    [sym_block] = STATE(1008),
    [sym_assignment] = STATE(1008),
    [sym_if] = STATE(1008),
    [sym_loop] = STATE(1008),
    [sym_handling] = STATE(1008),
    [sym_catch] = STATE(1008),
    [sym_throw] = STATE(1008),
    [sym_primitive] = STATE(1008),
    [sym_iterator] = STATE(1008),
    [sym_while] = STATE(1008),
    [sym_try] = STATE(1008),
    [sym_loopbody] = STATE(1008),
    [sym_leave] = STATE(1008),
    [sym_continue] = STATE(1008),
    [sym_protect] = STATE(1008),
    [sym_lock] = STATE(1008),
    [sym__literal] = STATE(1008),
    [sym_character_literal] = STATE(1008),
    [sym_string_literal] = STATE(1008),
    [sym_call] = STATE(1008),
    [sym_invoke] = STATE(1008),
    [sym_indexed_access] = STATE(1008),
    [sym_slot_accessor] = STATE(1008),
    [sym_true] = STATE(1008),
    [sym_false] = STATE(1008),
    [sym_maybe] = STATE(1008),
    [sym_unset] = STATE(1008),
    [sym_super] = STATE(1008),
    [sym_self] = STATE(1008),
    [sym_clone] = STATE(1008),
    [sym_thisthread] = STATE(1008),
    [sym_class] = STATE(1008),
    [sym__expression] = STATE(1008),
    [sym_return] = STATE(1008),
    [sym_gather] = STATE(1008),
    [sym_scatter] = STATE(1008),
    [sym_allresults] = STATE(1008),
    [sym_parenthesized_expression] = STATE(1008),
    [sym__variable] = STATE(1008),
    [sym_variable] = STATE(1008),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1008),
    [sym_relational_operator] = STATE(1008),
    [sym_logical_operator] = STATE(1008),
    [sym_arithmetic_operator] = STATE(1008),
    [sym_unary_operator] = STATE(1008),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1439),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1439),
    [sym_global_variable] = ACTIONS(1439),
    [sym_global_reference] = ACTIONS(1439),
    [sym_number] = ACTIONS(1439),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1439),
    [sym_comment] = ACTIONS(103),
  },
  [306] = {
    [sym_procedure] = STATE(930),
    [sym_block] = STATE(930),
    [sym_assignment] = STATE(930),
    [sym_if] = STATE(930),
    [sym_loop] = STATE(930),
    [sym_handling] = STATE(930),
    [sym_catch] = STATE(930),
    [sym_throw] = STATE(930),
    [sym_primitive] = STATE(930),
    [sym_iterator] = STATE(930),
    [sym_while] = STATE(930),
    [sym_try] = STATE(930),
    [sym_loopbody] = STATE(930),
    [sym_leave] = STATE(930),
    [sym_continue] = STATE(930),
    [sym_protect] = STATE(930),
    [sym_lock] = STATE(930),
    [sym__literal] = STATE(930),
    [sym_character_literal] = STATE(930),
    [sym_string_literal] = STATE(930),
    [sym_call] = STATE(930),
    [sym_invoke] = STATE(930),
    [sym_indexed_access] = STATE(930),
    [sym_slot_accessor] = STATE(930),
    [sym_true] = STATE(930),
    [sym_false] = STATE(930),
    [sym_maybe] = STATE(930),
    [sym_unset] = STATE(930),
    [sym_super] = STATE(930),
    [sym_self] = STATE(930),
    [sym_clone] = STATE(930),
    [sym_thisthread] = STATE(930),
    [sym_class] = STATE(930),
    [sym__expression] = STATE(930),
    [sym_return] = STATE(930),
    [sym_gather] = STATE(930),
    [sym_scatter] = STATE(930),
    [sym_allresults] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym__variable] = STATE(930),
    [sym_variable] = STATE(930),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(930),
    [sym_relational_operator] = STATE(930),
    [sym_logical_operator] = STATE(930),
    [sym_arithmetic_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1441),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1441),
    [sym_global_variable] = ACTIONS(1441),
    [sym_global_reference] = ACTIONS(1441),
    [sym_number] = ACTIONS(1441),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1441),
    [sym_comment] = ACTIONS(103),
  },
  [307] = {
    [sym_procedure] = STATE(928),
    [sym_block] = STATE(928),
    [sym_assignment] = STATE(928),
    [sym_if] = STATE(928),
    [sym_loop] = STATE(928),
    [sym_handling] = STATE(928),
    [sym_catch] = STATE(928),
    [sym_throw] = STATE(928),
    [sym_primitive] = STATE(928),
    [sym_iterator] = STATE(928),
    [sym_while] = STATE(928),
    [sym_try] = STATE(928),
    [sym_loopbody] = STATE(928),
    [sym_leave] = STATE(928),
    [sym_continue] = STATE(928),
    [sym_protect] = STATE(928),
    [sym_lock] = STATE(928),
    [sym__literal] = STATE(928),
    [sym_character_literal] = STATE(928),
    [sym_string_literal] = STATE(928),
    [sym_call] = STATE(928),
    [sym_invoke] = STATE(928),
    [sym_indexed_access] = STATE(928),
    [sym_slot_accessor] = STATE(928),
    [sym_true] = STATE(928),
    [sym_false] = STATE(928),
    [sym_maybe] = STATE(928),
    [sym_unset] = STATE(928),
    [sym_super] = STATE(928),
    [sym_self] = STATE(928),
    [sym_clone] = STATE(928),
    [sym_thisthread] = STATE(928),
    [sym_class] = STATE(928),
    [sym__expression] = STATE(928),
    [sym_return] = STATE(928),
    [sym_gather] = STATE(928),
    [sym_scatter] = STATE(928),
    [sym_allresults] = STATE(928),
    [sym_parenthesized_expression] = STATE(928),
    [sym__variable] = STATE(928),
    [sym_variable] = STATE(928),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(928),
    [sym_relational_operator] = STATE(928),
    [sym_logical_operator] = STATE(928),
    [sym_arithmetic_operator] = STATE(928),
    [sym_unary_operator] = STATE(928),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1443),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1443),
    [sym_global_variable] = ACTIONS(1443),
    [sym_global_reference] = ACTIONS(1443),
    [sym_number] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1443),
    [sym_comment] = ACTIONS(103),
  },
  [308] = {
    [sym_procedure] = STATE(1002),
    [sym_block] = STATE(1002),
    [sym_assignment] = STATE(1002),
    [sym_if] = STATE(1002),
    [sym_loop] = STATE(1002),
    [sym_handling] = STATE(1002),
    [sym_catch] = STATE(1002),
    [sym_throw] = STATE(1002),
    [sym_primitive] = STATE(1002),
    [sym_iterator] = STATE(1002),
    [sym_while] = STATE(1002),
    [sym_try] = STATE(1002),
    [sym_loopbody] = STATE(1002),
    [sym_leave] = STATE(1002),
    [sym_continue] = STATE(1002),
    [sym_protect] = STATE(1002),
    [sym_lock] = STATE(1002),
    [sym__literal] = STATE(1002),
    [sym_character_literal] = STATE(1002),
    [sym_string_literal] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_invoke] = STATE(1002),
    [sym_indexed_access] = STATE(1002),
    [sym_slot_accessor] = STATE(1002),
    [sym_true] = STATE(1002),
    [sym_false] = STATE(1002),
    [sym_maybe] = STATE(1002),
    [sym_unset] = STATE(1002),
    [sym_super] = STATE(1002),
    [sym_self] = STATE(1002),
    [sym_clone] = STATE(1002),
    [sym_thisthread] = STATE(1002),
    [sym_class] = STATE(1002),
    [sym__expression] = STATE(1002),
    [sym_return] = STATE(1002),
    [sym_gather] = STATE(1002),
    [sym_scatter] = STATE(1002),
    [sym_allresults] = STATE(1002),
    [sym_parenthesized_expression] = STATE(1002),
    [sym__variable] = STATE(1002),
    [sym_variable] = STATE(1002),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(1002),
    [sym_relational_operator] = STATE(1002),
    [sym_logical_operator] = STATE(1002),
    [sym_arithmetic_operator] = STATE(1002),
    [sym_unary_operator] = STATE(1002),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1445),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1445),
    [sym_global_variable] = ACTIONS(1445),
    [sym_global_reference] = ACTIONS(1445),
    [sym_number] = ACTIONS(1445),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1445),
    [sym_comment] = ACTIONS(103),
  },
  [309] = {
    [sym_procedure] = STATE(1021),
    [sym_block] = STATE(1021),
    [sym_assignment] = STATE(1021),
    [sym_if] = STATE(1021),
    [sym_loop] = STATE(1021),
    [sym_handling] = STATE(1021),
    [sym_catch] = STATE(1021),
    [sym_throw] = STATE(1021),
    [sym_primitive] = STATE(1021),
    [sym_iterator] = STATE(1021),
    [sym_while] = STATE(1021),
    [sym_try] = STATE(1021),
    [sym_loopbody] = STATE(1021),
    [sym_leave] = STATE(1021),
    [sym_continue] = STATE(1021),
    [sym_protect] = STATE(1021),
    [sym_lock] = STATE(1021),
    [sym__literal] = STATE(1021),
    [sym_character_literal] = STATE(1021),
    [sym_string_literal] = STATE(1021),
    [sym_call] = STATE(1021),
    [sym_invoke] = STATE(1021),
    [sym_indexed_access] = STATE(1021),
    [sym_slot_accessor] = STATE(1021),
    [sym_true] = STATE(1021),
    [sym_false] = STATE(1021),
    [sym_maybe] = STATE(1021),
    [sym_unset] = STATE(1021),
    [sym_super] = STATE(1021),
    [sym_self] = STATE(1021),
    [sym_clone] = STATE(1021),
    [sym_thisthread] = STATE(1021),
    [sym_class] = STATE(1021),
    [sym__expression] = STATE(1021),
    [sym_return] = STATE(1021),
    [sym_gather] = STATE(1021),
    [sym_scatter] = STATE(1021),
    [sym_allresults] = STATE(1021),
    [sym_parenthesized_expression] = STATE(1021),
    [sym__variable] = STATE(1021),
    [sym_variable] = STATE(1021),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1021),
    [sym_relational_operator] = STATE(1021),
    [sym_logical_operator] = STATE(1021),
    [sym_arithmetic_operator] = STATE(1021),
    [sym_unary_operator] = STATE(1021),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1447),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1447),
    [sym_global_variable] = ACTIONS(1447),
    [sym_global_reference] = ACTIONS(1447),
    [sym_number] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1447),
    [sym_comment] = ACTIONS(103),
  },
  [310] = {
    [sym_procedure] = STATE(675),
    [sym_block] = STATE(675),
    [sym_assignment] = STATE(675),
    [sym_if] = STATE(675),
    [sym_loop] = STATE(675),
    [sym_handling] = STATE(675),
    [sym_catch] = STATE(675),
    [sym_throw] = STATE(675),
    [sym_primitive] = STATE(675),
    [sym_iterator] = STATE(675),
    [sym_while] = STATE(675),
    [sym_try] = STATE(675),
    [sym_loopbody] = STATE(675),
    [sym_leave] = STATE(675),
    [sym_continue] = STATE(675),
    [sym_protect] = STATE(675),
    [sym_lock] = STATE(675),
    [sym__literal] = STATE(675),
    [sym_character_literal] = STATE(675),
    [sym_string_literal] = STATE(675),
    [sym_call] = STATE(675),
    [sym_invoke] = STATE(675),
    [sym_indexed_access] = STATE(675),
    [sym_slot_accessor] = STATE(675),
    [sym_true] = STATE(675),
    [sym_false] = STATE(675),
    [sym_maybe] = STATE(675),
    [sym_unset] = STATE(675),
    [sym_super] = STATE(675),
    [sym_self] = STATE(675),
    [sym_clone] = STATE(675),
    [sym_thisthread] = STATE(675),
    [sym_class] = STATE(675),
    [sym__expression] = STATE(675),
    [sym_return] = STATE(675),
    [sym_gather] = STATE(675),
    [sym_scatter] = STATE(675),
    [sym_allresults] = STATE(675),
    [sym_parenthesized_expression] = STATE(675),
    [sym__variable] = STATE(675),
    [sym_variable] = STATE(675),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(675),
    [sym_relational_operator] = STATE(675),
    [sym_logical_operator] = STATE(675),
    [sym_arithmetic_operator] = STATE(675),
    [sym_unary_operator] = STATE(675),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1449),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1449),
    [sym_global_variable] = ACTIONS(1449),
    [sym_global_reference] = ACTIONS(1449),
    [sym_number] = ACTIONS(1449),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1449),
    [sym_comment] = ACTIONS(103),
  },
  [311] = {
    [sym_procedure] = STATE(607),
    [sym_block] = STATE(607),
    [sym_assignment] = STATE(607),
    [sym_if] = STATE(607),
    [sym_loop] = STATE(607),
    [sym_handling] = STATE(607),
    [sym_catch] = STATE(607),
    [sym_throw] = STATE(607),
    [sym_primitive] = STATE(607),
    [sym_iterator] = STATE(607),
    [sym_while] = STATE(607),
    [sym_try] = STATE(607),
    [sym_loopbody] = STATE(607),
    [sym_leave] = STATE(607),
    [sym_continue] = STATE(607),
    [sym_protect] = STATE(607),
    [sym_lock] = STATE(607),
    [sym__literal] = STATE(607),
    [sym_character_literal] = STATE(607),
    [sym_string_literal] = STATE(607),
    [sym_call] = STATE(607),
    [sym_invoke] = STATE(607),
    [sym_indexed_access] = STATE(607),
    [sym_slot_accessor] = STATE(607),
    [sym_true] = STATE(607),
    [sym_false] = STATE(607),
    [sym_maybe] = STATE(607),
    [sym_unset] = STATE(607),
    [sym_super] = STATE(607),
    [sym_self] = STATE(607),
    [sym_clone] = STATE(607),
    [sym_thisthread] = STATE(607),
    [sym_class] = STATE(607),
    [sym__expression] = STATE(607),
    [sym_return] = STATE(607),
    [sym_gather] = STATE(607),
    [sym_scatter] = STATE(607),
    [sym_allresults] = STATE(607),
    [sym_parenthesized_expression] = STATE(607),
    [sym__variable] = STATE(607),
    [sym_variable] = STATE(607),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(607),
    [sym_relational_operator] = STATE(607),
    [sym_logical_operator] = STATE(607),
    [sym_arithmetic_operator] = STATE(607),
    [sym_unary_operator] = STATE(607),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1451),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1451),
    [sym_global_variable] = ACTIONS(1451),
    [sym_global_reference] = ACTIONS(1451),
    [sym_number] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1451),
    [sym_comment] = ACTIONS(103),
  },
  [312] = {
    [sym_procedure] = STATE(1014),
    [sym_block] = STATE(1014),
    [sym_assignment] = STATE(1014),
    [sym_if] = STATE(1014),
    [sym_loop] = STATE(1014),
    [sym_handling] = STATE(1014),
    [sym_catch] = STATE(1014),
    [sym_throw] = STATE(1014),
    [sym_primitive] = STATE(1014),
    [sym_iterator] = STATE(1014),
    [sym_while] = STATE(1014),
    [sym_try] = STATE(1014),
    [sym_loopbody] = STATE(1014),
    [sym_leave] = STATE(1014),
    [sym_continue] = STATE(1014),
    [sym_protect] = STATE(1014),
    [sym_lock] = STATE(1014),
    [sym__literal] = STATE(1014),
    [sym_character_literal] = STATE(1014),
    [sym_string_literal] = STATE(1014),
    [sym_call] = STATE(1014),
    [sym_invoke] = STATE(1014),
    [sym_indexed_access] = STATE(1014),
    [sym_slot_accessor] = STATE(1014),
    [sym_true] = STATE(1014),
    [sym_false] = STATE(1014),
    [sym_maybe] = STATE(1014),
    [sym_unset] = STATE(1014),
    [sym_super] = STATE(1014),
    [sym_self] = STATE(1014),
    [sym_clone] = STATE(1014),
    [sym_thisthread] = STATE(1014),
    [sym_class] = STATE(1014),
    [sym__expression] = STATE(1014),
    [sym_return] = STATE(1014),
    [sym_gather] = STATE(1014),
    [sym_scatter] = STATE(1014),
    [sym_allresults] = STATE(1014),
    [sym_parenthesized_expression] = STATE(1014),
    [sym__variable] = STATE(1014),
    [sym_variable] = STATE(1014),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1014),
    [sym_relational_operator] = STATE(1014),
    [sym_logical_operator] = STATE(1014),
    [sym_arithmetic_operator] = STATE(1014),
    [sym_unary_operator] = STATE(1014),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1453),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1453),
    [sym_global_variable] = ACTIONS(1453),
    [sym_global_reference] = ACTIONS(1453),
    [sym_number] = ACTIONS(1453),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1453),
    [sym_comment] = ACTIONS(103),
  },
  [313] = {
    [sym_procedure] = STATE(867),
    [sym_block] = STATE(867),
    [sym_assignment] = STATE(867),
    [sym_if] = STATE(867),
    [sym_loop] = STATE(867),
    [sym_handling] = STATE(867),
    [sym_catch] = STATE(867),
    [sym_throw] = STATE(867),
    [sym_primitive] = STATE(867),
    [sym_iterator] = STATE(867),
    [sym_while] = STATE(867),
    [sym_try] = STATE(867),
    [sym_loopbody] = STATE(867),
    [sym_leave] = STATE(867),
    [sym_continue] = STATE(867),
    [sym_protect] = STATE(867),
    [sym_lock] = STATE(867),
    [sym__literal] = STATE(867),
    [sym_character_literal] = STATE(867),
    [sym_string_literal] = STATE(867),
    [sym_call] = STATE(867),
    [sym_invoke] = STATE(867),
    [sym_indexed_access] = STATE(867),
    [sym_slot_accessor] = STATE(867),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_maybe] = STATE(867),
    [sym_unset] = STATE(867),
    [sym_super] = STATE(867),
    [sym_self] = STATE(867),
    [sym_clone] = STATE(867),
    [sym_thisthread] = STATE(867),
    [sym_class] = STATE(867),
    [sym__expression] = STATE(867),
    [sym_return] = STATE(867),
    [sym_gather] = STATE(867),
    [sym_scatter] = STATE(867),
    [sym_allresults] = STATE(867),
    [sym_parenthesized_expression] = STATE(867),
    [sym__variable] = STATE(867),
    [sym_variable] = STATE(867),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(867),
    [sym_relational_operator] = STATE(867),
    [sym_logical_operator] = STATE(867),
    [sym_arithmetic_operator] = STATE(867),
    [sym_unary_operator] = STATE(867),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1455),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1455),
    [sym_global_variable] = ACTIONS(1455),
    [sym_global_reference] = ACTIONS(1455),
    [sym_number] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1455),
    [sym_comment] = ACTIONS(103),
  },
  [314] = {
    [sym_procedure] = STATE(866),
    [sym_block] = STATE(866),
    [sym_assignment] = STATE(866),
    [sym_if] = STATE(866),
    [sym_loop] = STATE(866),
    [sym_handling] = STATE(866),
    [sym_catch] = STATE(866),
    [sym_throw] = STATE(866),
    [sym_primitive] = STATE(866),
    [sym_iterator] = STATE(866),
    [sym_while] = STATE(866),
    [sym_try] = STATE(866),
    [sym_loopbody] = STATE(866),
    [sym_leave] = STATE(866),
    [sym_continue] = STATE(866),
    [sym_protect] = STATE(866),
    [sym_lock] = STATE(866),
    [sym__literal] = STATE(866),
    [sym_character_literal] = STATE(866),
    [sym_string_literal] = STATE(866),
    [sym_call] = STATE(866),
    [sym_invoke] = STATE(866),
    [sym_indexed_access] = STATE(866),
    [sym_slot_accessor] = STATE(866),
    [sym_true] = STATE(866),
    [sym_false] = STATE(866),
    [sym_maybe] = STATE(866),
    [sym_unset] = STATE(866),
    [sym_super] = STATE(866),
    [sym_self] = STATE(866),
    [sym_clone] = STATE(866),
    [sym_thisthread] = STATE(866),
    [sym_class] = STATE(866),
    [sym__expression] = STATE(866),
    [sym_return] = STATE(866),
    [sym_gather] = STATE(866),
    [sym_scatter] = STATE(866),
    [sym_allresults] = STATE(866),
    [sym_parenthesized_expression] = STATE(866),
    [sym__variable] = STATE(866),
    [sym_variable] = STATE(866),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(866),
    [sym_relational_operator] = STATE(866),
    [sym_logical_operator] = STATE(866),
    [sym_arithmetic_operator] = STATE(866),
    [sym_unary_operator] = STATE(866),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1457),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1457),
    [sym_global_variable] = ACTIONS(1457),
    [sym_global_reference] = ACTIONS(1457),
    [sym_number] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1457),
    [sym_comment] = ACTIONS(103),
  },
  [315] = {
    [sym_procedure] = STATE(960),
    [sym_block] = STATE(960),
    [sym_assignment] = STATE(960),
    [sym_if] = STATE(960),
    [sym_loop] = STATE(960),
    [sym_handling] = STATE(960),
    [sym_catch] = STATE(960),
    [sym_throw] = STATE(960),
    [sym_primitive] = STATE(960),
    [sym_iterator] = STATE(960),
    [sym_while] = STATE(960),
    [sym_try] = STATE(960),
    [sym_loopbody] = STATE(960),
    [sym_leave] = STATE(960),
    [sym_continue] = STATE(960),
    [sym_protect] = STATE(960),
    [sym_lock] = STATE(960),
    [sym__literal] = STATE(960),
    [sym_character_literal] = STATE(960),
    [sym_string_literal] = STATE(960),
    [sym_call] = STATE(960),
    [sym_invoke] = STATE(960),
    [sym_indexed_access] = STATE(960),
    [sym_slot_accessor] = STATE(960),
    [sym_true] = STATE(960),
    [sym_false] = STATE(960),
    [sym_maybe] = STATE(960),
    [sym_unset] = STATE(960),
    [sym_super] = STATE(960),
    [sym_self] = STATE(960),
    [sym_clone] = STATE(960),
    [sym_thisthread] = STATE(960),
    [sym_class] = STATE(960),
    [sym__expression] = STATE(960),
    [sym_return] = STATE(960),
    [sym_gather] = STATE(960),
    [sym_scatter] = STATE(960),
    [sym_allresults] = STATE(960),
    [sym_parenthesized_expression] = STATE(960),
    [sym__variable] = STATE(960),
    [sym_variable] = STATE(960),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(960),
    [sym_relational_operator] = STATE(960),
    [sym_logical_operator] = STATE(960),
    [sym_arithmetic_operator] = STATE(960),
    [sym_unary_operator] = STATE(960),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1459),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1459),
    [sym_global_variable] = ACTIONS(1459),
    [sym_global_reference] = ACTIONS(1459),
    [sym_number] = ACTIONS(1459),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1459),
    [sym_comment] = ACTIONS(103),
  },
  [316] = {
    [sym_procedure] = STATE(870),
    [sym_block] = STATE(870),
    [sym_assignment] = STATE(870),
    [sym_if] = STATE(870),
    [sym_loop] = STATE(870),
    [sym_handling] = STATE(870),
    [sym_catch] = STATE(870),
    [sym_throw] = STATE(870),
    [sym_primitive] = STATE(870),
    [sym_iterator] = STATE(870),
    [sym_while] = STATE(870),
    [sym_try] = STATE(870),
    [sym_loopbody] = STATE(870),
    [sym_leave] = STATE(870),
    [sym_continue] = STATE(870),
    [sym_protect] = STATE(870),
    [sym_lock] = STATE(870),
    [sym__literal] = STATE(870),
    [sym_character_literal] = STATE(870),
    [sym_string_literal] = STATE(870),
    [sym_call] = STATE(870),
    [sym_invoke] = STATE(870),
    [sym_indexed_access] = STATE(870),
    [sym_slot_accessor] = STATE(870),
    [sym_true] = STATE(870),
    [sym_false] = STATE(870),
    [sym_maybe] = STATE(870),
    [sym_unset] = STATE(870),
    [sym_super] = STATE(870),
    [sym_self] = STATE(870),
    [sym_clone] = STATE(870),
    [sym_thisthread] = STATE(870),
    [sym_class] = STATE(870),
    [sym__expression] = STATE(870),
    [sym_return] = STATE(870),
    [sym_gather] = STATE(870),
    [sym_scatter] = STATE(870),
    [sym_allresults] = STATE(870),
    [sym_parenthesized_expression] = STATE(870),
    [sym__variable] = STATE(870),
    [sym_variable] = STATE(870),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(870),
    [sym_relational_operator] = STATE(870),
    [sym_logical_operator] = STATE(870),
    [sym_arithmetic_operator] = STATE(870),
    [sym_unary_operator] = STATE(870),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1461),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1461),
    [sym_global_variable] = ACTIONS(1461),
    [sym_global_reference] = ACTIONS(1461),
    [sym_number] = ACTIONS(1461),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1461),
    [sym_comment] = ACTIONS(103),
  },
  [317] = {
    [sym_procedure] = STATE(647),
    [sym_block] = STATE(647),
    [sym_assignment] = STATE(647),
    [sym_if] = STATE(647),
    [sym_loop] = STATE(647),
    [sym_handling] = STATE(647),
    [sym_catch] = STATE(647),
    [sym_throw] = STATE(647),
    [sym_primitive] = STATE(647),
    [sym_iterator] = STATE(647),
    [sym_while] = STATE(647),
    [sym_try] = STATE(647),
    [sym_loopbody] = STATE(647),
    [sym_leave] = STATE(647),
    [sym_continue] = STATE(647),
    [sym_protect] = STATE(647),
    [sym_lock] = STATE(647),
    [sym__literal] = STATE(647),
    [sym_character_literal] = STATE(647),
    [sym_string_literal] = STATE(647),
    [sym_call] = STATE(647),
    [sym_invoke] = STATE(647),
    [sym_indexed_access] = STATE(647),
    [sym_slot_accessor] = STATE(647),
    [sym_true] = STATE(647),
    [sym_false] = STATE(647),
    [sym_maybe] = STATE(647),
    [sym_unset] = STATE(647),
    [sym_super] = STATE(647),
    [sym_self] = STATE(647),
    [sym_clone] = STATE(647),
    [sym_thisthread] = STATE(647),
    [sym_class] = STATE(647),
    [sym__expression] = STATE(647),
    [sym_return] = STATE(647),
    [sym_gather] = STATE(647),
    [sym_scatter] = STATE(647),
    [sym_allresults] = STATE(647),
    [sym_parenthesized_expression] = STATE(647),
    [sym__variable] = STATE(647),
    [sym_variable] = STATE(647),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(647),
    [sym_relational_operator] = STATE(647),
    [sym_logical_operator] = STATE(647),
    [sym_arithmetic_operator] = STATE(647),
    [sym_unary_operator] = STATE(647),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1463),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1463),
    [sym_global_variable] = ACTIONS(1463),
    [sym_global_reference] = ACTIONS(1463),
    [sym_number] = ACTIONS(1463),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1463),
    [sym_comment] = ACTIONS(103),
  },
  [318] = {
    [sym_procedure] = STATE(1007),
    [sym_block] = STATE(1007),
    [sym_assignment] = STATE(1007),
    [sym_if] = STATE(1007),
    [sym_loop] = STATE(1007),
    [sym_handling] = STATE(1007),
    [sym_catch] = STATE(1007),
    [sym_throw] = STATE(1007),
    [sym_primitive] = STATE(1007),
    [sym_iterator] = STATE(1007),
    [sym_while] = STATE(1007),
    [sym_try] = STATE(1007),
    [sym_loopbody] = STATE(1007),
    [sym_leave] = STATE(1007),
    [sym_continue] = STATE(1007),
    [sym_protect] = STATE(1007),
    [sym_lock] = STATE(1007),
    [sym__literal] = STATE(1007),
    [sym_character_literal] = STATE(1007),
    [sym_string_literal] = STATE(1007),
    [sym_call] = STATE(1007),
    [sym_invoke] = STATE(1007),
    [sym_indexed_access] = STATE(1007),
    [sym_slot_accessor] = STATE(1007),
    [sym_true] = STATE(1007),
    [sym_false] = STATE(1007),
    [sym_maybe] = STATE(1007),
    [sym_unset] = STATE(1007),
    [sym_super] = STATE(1007),
    [sym_self] = STATE(1007),
    [sym_clone] = STATE(1007),
    [sym_thisthread] = STATE(1007),
    [sym_class] = STATE(1007),
    [sym__expression] = STATE(1007),
    [sym_return] = STATE(1007),
    [sym_gather] = STATE(1007),
    [sym_scatter] = STATE(1007),
    [sym_allresults] = STATE(1007),
    [sym_parenthesized_expression] = STATE(1007),
    [sym__variable] = STATE(1007),
    [sym_variable] = STATE(1007),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1007),
    [sym_relational_operator] = STATE(1007),
    [sym_logical_operator] = STATE(1007),
    [sym_arithmetic_operator] = STATE(1007),
    [sym_unary_operator] = STATE(1007),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1465),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1465),
    [sym_global_variable] = ACTIONS(1465),
    [sym_global_reference] = ACTIONS(1465),
    [sym_number] = ACTIONS(1465),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1465),
    [sym_comment] = ACTIONS(103),
  },
  [319] = {
    [sym_procedure] = STATE(878),
    [sym_block] = STATE(878),
    [sym_assignment] = STATE(878),
    [sym_if] = STATE(878),
    [sym_loop] = STATE(878),
    [sym_handling] = STATE(878),
    [sym_catch] = STATE(878),
    [sym_throw] = STATE(878),
    [sym_primitive] = STATE(878),
    [sym_iterator] = STATE(878),
    [sym_while] = STATE(878),
    [sym_try] = STATE(878),
    [sym_loopbody] = STATE(878),
    [sym_leave] = STATE(878),
    [sym_continue] = STATE(878),
    [sym_protect] = STATE(878),
    [sym_lock] = STATE(878),
    [sym__literal] = STATE(878),
    [sym_character_literal] = STATE(878),
    [sym_string_literal] = STATE(878),
    [sym_call] = STATE(878),
    [sym_invoke] = STATE(878),
    [sym_indexed_access] = STATE(878),
    [sym_slot_accessor] = STATE(878),
    [sym_true] = STATE(878),
    [sym_false] = STATE(878),
    [sym_maybe] = STATE(878),
    [sym_unset] = STATE(878),
    [sym_super] = STATE(878),
    [sym_self] = STATE(878),
    [sym_clone] = STATE(878),
    [sym_thisthread] = STATE(878),
    [sym_class] = STATE(878),
    [sym__expression] = STATE(878),
    [sym_return] = STATE(878),
    [sym_gather] = STATE(878),
    [sym_scatter] = STATE(878),
    [sym_allresults] = STATE(878),
    [sym_parenthesized_expression] = STATE(878),
    [sym__variable] = STATE(878),
    [sym_variable] = STATE(878),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(878),
    [sym_relational_operator] = STATE(878),
    [sym_logical_operator] = STATE(878),
    [sym_arithmetic_operator] = STATE(878),
    [sym_unary_operator] = STATE(878),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1467),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1467),
    [sym_global_variable] = ACTIONS(1467),
    [sym_global_reference] = ACTIONS(1467),
    [sym_number] = ACTIONS(1467),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1467),
    [sym_comment] = ACTIONS(103),
  },
  [320] = {
    [sym_procedure] = STATE(959),
    [sym_block] = STATE(959),
    [sym_assignment] = STATE(959),
    [sym_if] = STATE(959),
    [sym_loop] = STATE(959),
    [sym_handling] = STATE(959),
    [sym_catch] = STATE(959),
    [sym_throw] = STATE(959),
    [sym_primitive] = STATE(959),
    [sym_iterator] = STATE(959),
    [sym_while] = STATE(959),
    [sym_try] = STATE(959),
    [sym_loopbody] = STATE(959),
    [sym_leave] = STATE(959),
    [sym_continue] = STATE(959),
    [sym_protect] = STATE(959),
    [sym_lock] = STATE(959),
    [sym__literal] = STATE(959),
    [sym_character_literal] = STATE(959),
    [sym_string_literal] = STATE(959),
    [sym_call] = STATE(959),
    [sym_invoke] = STATE(959),
    [sym_indexed_access] = STATE(959),
    [sym_slot_accessor] = STATE(959),
    [sym_true] = STATE(959),
    [sym_false] = STATE(959),
    [sym_maybe] = STATE(959),
    [sym_unset] = STATE(959),
    [sym_super] = STATE(959),
    [sym_self] = STATE(959),
    [sym_clone] = STATE(959),
    [sym_thisthread] = STATE(959),
    [sym_class] = STATE(959),
    [sym__expression] = STATE(959),
    [sym_return] = STATE(959),
    [sym_gather] = STATE(959),
    [sym_scatter] = STATE(959),
    [sym_allresults] = STATE(959),
    [sym_parenthesized_expression] = STATE(959),
    [sym__variable] = STATE(959),
    [sym_variable] = STATE(959),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(959),
    [sym_relational_operator] = STATE(959),
    [sym_logical_operator] = STATE(959),
    [sym_arithmetic_operator] = STATE(959),
    [sym_unary_operator] = STATE(959),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1469),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1469),
    [sym_global_variable] = ACTIONS(1469),
    [sym_global_reference] = ACTIONS(1469),
    [sym_number] = ACTIONS(1469),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1469),
    [sym_comment] = ACTIONS(103),
  },
  [321] = {
    [sym_procedure] = STATE(963),
    [sym_block] = STATE(963),
    [sym_assignment] = STATE(963),
    [sym_if] = STATE(963),
    [sym_loop] = STATE(963),
    [sym_handling] = STATE(963),
    [sym_catch] = STATE(963),
    [sym_throw] = STATE(963),
    [sym_primitive] = STATE(963),
    [sym_iterator] = STATE(963),
    [sym_while] = STATE(963),
    [sym_try] = STATE(963),
    [sym_loopbody] = STATE(963),
    [sym_leave] = STATE(963),
    [sym_continue] = STATE(963),
    [sym_protect] = STATE(963),
    [sym_lock] = STATE(963),
    [sym__literal] = STATE(963),
    [sym_character_literal] = STATE(963),
    [sym_string_literal] = STATE(963),
    [sym_call] = STATE(963),
    [sym_invoke] = STATE(963),
    [sym_indexed_access] = STATE(963),
    [sym_slot_accessor] = STATE(963),
    [sym_true] = STATE(963),
    [sym_false] = STATE(963),
    [sym_maybe] = STATE(963),
    [sym_unset] = STATE(963),
    [sym_super] = STATE(963),
    [sym_self] = STATE(963),
    [sym_clone] = STATE(963),
    [sym_thisthread] = STATE(963),
    [sym_class] = STATE(963),
    [sym__expression] = STATE(963),
    [sym_return] = STATE(963),
    [sym_gather] = STATE(963),
    [sym_scatter] = STATE(963),
    [sym_allresults] = STATE(963),
    [sym_parenthesized_expression] = STATE(963),
    [sym__variable] = STATE(963),
    [sym_variable] = STATE(963),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(963),
    [sym_relational_operator] = STATE(963),
    [sym_logical_operator] = STATE(963),
    [sym_arithmetic_operator] = STATE(963),
    [sym_unary_operator] = STATE(963),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1471),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1471),
    [sym_global_variable] = ACTIONS(1471),
    [sym_global_reference] = ACTIONS(1471),
    [sym_number] = ACTIONS(1471),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1471),
    [sym_comment] = ACTIONS(103),
  },
  [322] = {
    [sym_procedure] = STATE(864),
    [sym_block] = STATE(864),
    [sym_assignment] = STATE(864),
    [sym_if] = STATE(864),
    [sym_loop] = STATE(864),
    [sym_handling] = STATE(864),
    [sym_catch] = STATE(864),
    [sym_throw] = STATE(864),
    [sym_primitive] = STATE(864),
    [sym_iterator] = STATE(864),
    [sym_while] = STATE(864),
    [sym_try] = STATE(864),
    [sym_loopbody] = STATE(864),
    [sym_leave] = STATE(864),
    [sym_continue] = STATE(864),
    [sym_protect] = STATE(864),
    [sym_lock] = STATE(864),
    [sym__literal] = STATE(864),
    [sym_character_literal] = STATE(864),
    [sym_string_literal] = STATE(864),
    [sym_call] = STATE(864),
    [sym_invoke] = STATE(864),
    [sym_indexed_access] = STATE(864),
    [sym_slot_accessor] = STATE(864),
    [sym_true] = STATE(864),
    [sym_false] = STATE(864),
    [sym_maybe] = STATE(864),
    [sym_unset] = STATE(864),
    [sym_super] = STATE(864),
    [sym_self] = STATE(864),
    [sym_clone] = STATE(864),
    [sym_thisthread] = STATE(864),
    [sym_class] = STATE(864),
    [sym__expression] = STATE(864),
    [sym_return] = STATE(864),
    [sym_gather] = STATE(864),
    [sym_scatter] = STATE(864),
    [sym_allresults] = STATE(864),
    [sym_parenthesized_expression] = STATE(864),
    [sym__variable] = STATE(864),
    [sym_variable] = STATE(864),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(864),
    [sym_relational_operator] = STATE(864),
    [sym_logical_operator] = STATE(864),
    [sym_arithmetic_operator] = STATE(864),
    [sym_unary_operator] = STATE(864),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1473),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1473),
    [sym_global_variable] = ACTIONS(1473),
    [sym_global_reference] = ACTIONS(1473),
    [sym_number] = ACTIONS(1473),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1473),
    [sym_comment] = ACTIONS(103),
  },
  [323] = {
    [sym_procedure] = STATE(643),
    [sym_block] = STATE(643),
    [sym_assignment] = STATE(643),
    [sym_if] = STATE(643),
    [sym_loop] = STATE(643),
    [sym_handling] = STATE(643),
    [sym_catch] = STATE(643),
    [sym_throw] = STATE(643),
    [sym_primitive] = STATE(643),
    [sym_iterator] = STATE(643),
    [sym_while] = STATE(643),
    [sym_try] = STATE(643),
    [sym_loopbody] = STATE(643),
    [sym_leave] = STATE(643),
    [sym_continue] = STATE(643),
    [sym_protect] = STATE(643),
    [sym_lock] = STATE(643),
    [sym__literal] = STATE(643),
    [sym_character_literal] = STATE(643),
    [sym_string_literal] = STATE(643),
    [sym_call] = STATE(643),
    [sym_invoke] = STATE(643),
    [sym_indexed_access] = STATE(643),
    [sym_slot_accessor] = STATE(643),
    [sym_true] = STATE(643),
    [sym_false] = STATE(643),
    [sym_maybe] = STATE(643),
    [sym_unset] = STATE(643),
    [sym_super] = STATE(643),
    [sym_self] = STATE(643),
    [sym_clone] = STATE(643),
    [sym_thisthread] = STATE(643),
    [sym_class] = STATE(643),
    [sym__expression] = STATE(643),
    [sym_return] = STATE(643),
    [sym_gather] = STATE(643),
    [sym_scatter] = STATE(643),
    [sym_allresults] = STATE(643),
    [sym_parenthesized_expression] = STATE(643),
    [sym__variable] = STATE(643),
    [sym_variable] = STATE(643),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(643),
    [sym_relational_operator] = STATE(643),
    [sym_logical_operator] = STATE(643),
    [sym_arithmetic_operator] = STATE(643),
    [sym_unary_operator] = STATE(643),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1475),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1475),
    [sym_global_variable] = ACTIONS(1475),
    [sym_global_reference] = ACTIONS(1475),
    [sym_number] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1475),
    [sym_comment] = ACTIONS(103),
  },
  [324] = {
    [sym_procedure] = STATE(869),
    [sym_block] = STATE(869),
    [sym_assignment] = STATE(869),
    [sym_if] = STATE(869),
    [sym_loop] = STATE(869),
    [sym_handling] = STATE(869),
    [sym_catch] = STATE(869),
    [sym_throw] = STATE(869),
    [sym_primitive] = STATE(869),
    [sym_iterator] = STATE(869),
    [sym_while] = STATE(869),
    [sym_try] = STATE(869),
    [sym_loopbody] = STATE(869),
    [sym_leave] = STATE(869),
    [sym_continue] = STATE(869),
    [sym_protect] = STATE(869),
    [sym_lock] = STATE(869),
    [sym__literal] = STATE(869),
    [sym_character_literal] = STATE(869),
    [sym_string_literal] = STATE(869),
    [sym_call] = STATE(869),
    [sym_invoke] = STATE(869),
    [sym_indexed_access] = STATE(869),
    [sym_slot_accessor] = STATE(869),
    [sym_true] = STATE(869),
    [sym_false] = STATE(869),
    [sym_maybe] = STATE(869),
    [sym_unset] = STATE(869),
    [sym_super] = STATE(869),
    [sym_self] = STATE(869),
    [sym_clone] = STATE(869),
    [sym_thisthread] = STATE(869),
    [sym_class] = STATE(869),
    [sym__expression] = STATE(869),
    [sym_return] = STATE(869),
    [sym_gather] = STATE(869),
    [sym_scatter] = STATE(869),
    [sym_allresults] = STATE(869),
    [sym_parenthesized_expression] = STATE(869),
    [sym__variable] = STATE(869),
    [sym_variable] = STATE(869),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(869),
    [sym_relational_operator] = STATE(869),
    [sym_logical_operator] = STATE(869),
    [sym_arithmetic_operator] = STATE(869),
    [sym_unary_operator] = STATE(869),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1477),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1477),
    [sym_global_variable] = ACTIONS(1477),
    [sym_global_reference] = ACTIONS(1477),
    [sym_number] = ACTIONS(1477),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1477),
    [sym_comment] = ACTIONS(103),
  },
  [325] = {
    [sym_procedure] = STATE(962),
    [sym_block] = STATE(962),
    [sym_assignment] = STATE(962),
    [sym_if] = STATE(962),
    [sym_loop] = STATE(962),
    [sym_handling] = STATE(962),
    [sym_catch] = STATE(962),
    [sym_throw] = STATE(962),
    [sym_primitive] = STATE(962),
    [sym_iterator] = STATE(962),
    [sym_while] = STATE(962),
    [sym_try] = STATE(962),
    [sym_loopbody] = STATE(962),
    [sym_leave] = STATE(962),
    [sym_continue] = STATE(962),
    [sym_protect] = STATE(962),
    [sym_lock] = STATE(962),
    [sym__literal] = STATE(962),
    [sym_character_literal] = STATE(962),
    [sym_string_literal] = STATE(962),
    [sym_call] = STATE(962),
    [sym_invoke] = STATE(962),
    [sym_indexed_access] = STATE(962),
    [sym_slot_accessor] = STATE(962),
    [sym_true] = STATE(962),
    [sym_false] = STATE(962),
    [sym_maybe] = STATE(962),
    [sym_unset] = STATE(962),
    [sym_super] = STATE(962),
    [sym_self] = STATE(962),
    [sym_clone] = STATE(962),
    [sym_thisthread] = STATE(962),
    [sym_class] = STATE(962),
    [sym__expression] = STATE(962),
    [sym_return] = STATE(962),
    [sym_gather] = STATE(962),
    [sym_scatter] = STATE(962),
    [sym_allresults] = STATE(962),
    [sym_parenthesized_expression] = STATE(962),
    [sym__variable] = STATE(962),
    [sym_variable] = STATE(962),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(962),
    [sym_relational_operator] = STATE(962),
    [sym_logical_operator] = STATE(962),
    [sym_arithmetic_operator] = STATE(962),
    [sym_unary_operator] = STATE(962),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1479),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1479),
    [sym_global_variable] = ACTIONS(1479),
    [sym_global_reference] = ACTIONS(1479),
    [sym_number] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1479),
    [sym_comment] = ACTIONS(103),
  },
  [326] = {
    [sym_procedure] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(865),
    [sym_if] = STATE(865),
    [sym_loop] = STATE(865),
    [sym_handling] = STATE(865),
    [sym_catch] = STATE(865),
    [sym_throw] = STATE(865),
    [sym_primitive] = STATE(865),
    [sym_iterator] = STATE(865),
    [sym_while] = STATE(865),
    [sym_try] = STATE(865),
    [sym_loopbody] = STATE(865),
    [sym_leave] = STATE(865),
    [sym_continue] = STATE(865),
    [sym_protect] = STATE(865),
    [sym_lock] = STATE(865),
    [sym__literal] = STATE(865),
    [sym_character_literal] = STATE(865),
    [sym_string_literal] = STATE(865),
    [sym_call] = STATE(865),
    [sym_invoke] = STATE(865),
    [sym_indexed_access] = STATE(865),
    [sym_slot_accessor] = STATE(865),
    [sym_true] = STATE(865),
    [sym_false] = STATE(865),
    [sym_maybe] = STATE(865),
    [sym_unset] = STATE(865),
    [sym_super] = STATE(865),
    [sym_self] = STATE(865),
    [sym_clone] = STATE(865),
    [sym_thisthread] = STATE(865),
    [sym_class] = STATE(865),
    [sym__expression] = STATE(865),
    [sym_return] = STATE(865),
    [sym_gather] = STATE(865),
    [sym_scatter] = STATE(865),
    [sym_allresults] = STATE(865),
    [sym_parenthesized_expression] = STATE(865),
    [sym__variable] = STATE(865),
    [sym_variable] = STATE(865),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(865),
    [sym_relational_operator] = STATE(865),
    [sym_logical_operator] = STATE(865),
    [sym_arithmetic_operator] = STATE(865),
    [sym_unary_operator] = STATE(865),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1481),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1481),
    [sym_global_variable] = ACTIONS(1481),
    [sym_global_reference] = ACTIONS(1481),
    [sym_number] = ACTIONS(1481),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1481),
    [sym_comment] = ACTIONS(103),
  },
  [327] = {
    [sym_procedure] = STATE(1012),
    [sym_block] = STATE(1012),
    [sym_assignment] = STATE(1012),
    [sym_if] = STATE(1012),
    [sym_loop] = STATE(1012),
    [sym_handling] = STATE(1012),
    [sym_catch] = STATE(1012),
    [sym_throw] = STATE(1012),
    [sym_primitive] = STATE(1012),
    [sym_iterator] = STATE(1012),
    [sym_while] = STATE(1012),
    [sym_try] = STATE(1012),
    [sym_loopbody] = STATE(1012),
    [sym_leave] = STATE(1012),
    [sym_continue] = STATE(1012),
    [sym_protect] = STATE(1012),
    [sym_lock] = STATE(1012),
    [sym__literal] = STATE(1012),
    [sym_character_literal] = STATE(1012),
    [sym_string_literal] = STATE(1012),
    [sym_call] = STATE(1012),
    [sym_invoke] = STATE(1012),
    [sym_indexed_access] = STATE(1012),
    [sym_slot_accessor] = STATE(1012),
    [sym_true] = STATE(1012),
    [sym_false] = STATE(1012),
    [sym_maybe] = STATE(1012),
    [sym_unset] = STATE(1012),
    [sym_super] = STATE(1012),
    [sym_self] = STATE(1012),
    [sym_clone] = STATE(1012),
    [sym_thisthread] = STATE(1012),
    [sym_class] = STATE(1012),
    [sym__expression] = STATE(1012),
    [sym_return] = STATE(1012),
    [sym_gather] = STATE(1012),
    [sym_scatter] = STATE(1012),
    [sym_allresults] = STATE(1012),
    [sym_parenthesized_expression] = STATE(1012),
    [sym__variable] = STATE(1012),
    [sym_variable] = STATE(1012),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1012),
    [sym_relational_operator] = STATE(1012),
    [sym_logical_operator] = STATE(1012),
    [sym_arithmetic_operator] = STATE(1012),
    [sym_unary_operator] = STATE(1012),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1483),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1483),
    [sym_global_variable] = ACTIONS(1483),
    [sym_global_reference] = ACTIONS(1483),
    [sym_number] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1483),
    [sym_comment] = ACTIONS(103),
  },
  [328] = {
    [sym_procedure] = STATE(956),
    [sym_block] = STATE(956),
    [sym_assignment] = STATE(956),
    [sym_if] = STATE(956),
    [sym_loop] = STATE(956),
    [sym_handling] = STATE(956),
    [sym_catch] = STATE(956),
    [sym_throw] = STATE(956),
    [sym_primitive] = STATE(956),
    [sym_iterator] = STATE(956),
    [sym_while] = STATE(956),
    [sym_try] = STATE(956),
    [sym_loopbody] = STATE(956),
    [sym_leave] = STATE(956),
    [sym_continue] = STATE(956),
    [sym_protect] = STATE(956),
    [sym_lock] = STATE(956),
    [sym__literal] = STATE(956),
    [sym_character_literal] = STATE(956),
    [sym_string_literal] = STATE(956),
    [sym_call] = STATE(956),
    [sym_invoke] = STATE(956),
    [sym_indexed_access] = STATE(956),
    [sym_slot_accessor] = STATE(956),
    [sym_true] = STATE(956),
    [sym_false] = STATE(956),
    [sym_maybe] = STATE(956),
    [sym_unset] = STATE(956),
    [sym_super] = STATE(956),
    [sym_self] = STATE(956),
    [sym_clone] = STATE(956),
    [sym_thisthread] = STATE(956),
    [sym_class] = STATE(956),
    [sym__expression] = STATE(956),
    [sym_return] = STATE(956),
    [sym_gather] = STATE(956),
    [sym_scatter] = STATE(956),
    [sym_allresults] = STATE(956),
    [sym_parenthesized_expression] = STATE(956),
    [sym__variable] = STATE(956),
    [sym_variable] = STATE(956),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(956),
    [sym_relational_operator] = STATE(956),
    [sym_logical_operator] = STATE(956),
    [sym_arithmetic_operator] = STATE(956),
    [sym_unary_operator] = STATE(956),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1485),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1485),
    [sym_global_variable] = ACTIONS(1485),
    [sym_global_reference] = ACTIONS(1485),
    [sym_number] = ACTIONS(1485),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1485),
    [sym_comment] = ACTIONS(103),
  },
  [329] = {
    [sym_procedure] = STATE(638),
    [sym_block] = STATE(638),
    [sym_assignment] = STATE(638),
    [sym_if] = STATE(638),
    [sym_loop] = STATE(638),
    [sym_handling] = STATE(638),
    [sym_catch] = STATE(638),
    [sym_throw] = STATE(638),
    [sym_primitive] = STATE(638),
    [sym_iterator] = STATE(638),
    [sym_while] = STATE(638),
    [sym_try] = STATE(638),
    [sym_loopbody] = STATE(638),
    [sym_leave] = STATE(638),
    [sym_continue] = STATE(638),
    [sym_protect] = STATE(638),
    [sym_lock] = STATE(638),
    [sym__literal] = STATE(638),
    [sym_character_literal] = STATE(638),
    [sym_string_literal] = STATE(638),
    [sym_call] = STATE(638),
    [sym_invoke] = STATE(638),
    [sym_indexed_access] = STATE(638),
    [sym_slot_accessor] = STATE(638),
    [sym_true] = STATE(638),
    [sym_false] = STATE(638),
    [sym_maybe] = STATE(638),
    [sym_unset] = STATE(638),
    [sym_super] = STATE(638),
    [sym_self] = STATE(638),
    [sym_clone] = STATE(638),
    [sym_thisthread] = STATE(638),
    [sym_class] = STATE(638),
    [sym__expression] = STATE(638),
    [sym_return] = STATE(638),
    [sym_gather] = STATE(638),
    [sym_scatter] = STATE(638),
    [sym_allresults] = STATE(638),
    [sym_parenthesized_expression] = STATE(638),
    [sym__variable] = STATE(638),
    [sym_variable] = STATE(638),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(638),
    [sym_relational_operator] = STATE(638),
    [sym_logical_operator] = STATE(638),
    [sym_arithmetic_operator] = STATE(638),
    [sym_unary_operator] = STATE(638),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1487),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1487),
    [sym_global_variable] = ACTIONS(1487),
    [sym_global_reference] = ACTIONS(1487),
    [sym_number] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1487),
    [sym_comment] = ACTIONS(103),
  },
  [330] = {
    [sym_procedure] = STATE(955),
    [sym_block] = STATE(955),
    [sym_assignment] = STATE(955),
    [sym_if] = STATE(955),
    [sym_loop] = STATE(955),
    [sym_handling] = STATE(955),
    [sym_catch] = STATE(955),
    [sym_throw] = STATE(955),
    [sym_primitive] = STATE(955),
    [sym_iterator] = STATE(955),
    [sym_while] = STATE(955),
    [sym_try] = STATE(955),
    [sym_loopbody] = STATE(955),
    [sym_leave] = STATE(955),
    [sym_continue] = STATE(955),
    [sym_protect] = STATE(955),
    [sym_lock] = STATE(955),
    [sym__literal] = STATE(955),
    [sym_character_literal] = STATE(955),
    [sym_string_literal] = STATE(955),
    [sym_call] = STATE(955),
    [sym_invoke] = STATE(955),
    [sym_indexed_access] = STATE(955),
    [sym_slot_accessor] = STATE(955),
    [sym_true] = STATE(955),
    [sym_false] = STATE(955),
    [sym_maybe] = STATE(955),
    [sym_unset] = STATE(955),
    [sym_super] = STATE(955),
    [sym_self] = STATE(955),
    [sym_clone] = STATE(955),
    [sym_thisthread] = STATE(955),
    [sym_class] = STATE(955),
    [sym__expression] = STATE(955),
    [sym_return] = STATE(955),
    [sym_gather] = STATE(955),
    [sym_scatter] = STATE(955),
    [sym_allresults] = STATE(955),
    [sym_parenthesized_expression] = STATE(955),
    [sym__variable] = STATE(955),
    [sym_variable] = STATE(955),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(955),
    [sym_relational_operator] = STATE(955),
    [sym_logical_operator] = STATE(955),
    [sym_arithmetic_operator] = STATE(955),
    [sym_unary_operator] = STATE(955),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1489),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1489),
    [sym_global_variable] = ACTIONS(1489),
    [sym_global_reference] = ACTIONS(1489),
    [sym_number] = ACTIONS(1489),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1489),
    [sym_comment] = ACTIONS(103),
  },
  [331] = {
    [sym_procedure] = STATE(909),
    [sym_block] = STATE(909),
    [sym_assignment] = STATE(909),
    [sym_if] = STATE(909),
    [sym_loop] = STATE(909),
    [sym_handling] = STATE(909),
    [sym_catch] = STATE(909),
    [sym_throw] = STATE(909),
    [sym_primitive] = STATE(909),
    [sym_iterator] = STATE(909),
    [sym_while] = STATE(909),
    [sym_try] = STATE(909),
    [sym_loopbody] = STATE(909),
    [sym_leave] = STATE(909),
    [sym_continue] = STATE(909),
    [sym_protect] = STATE(909),
    [sym_lock] = STATE(909),
    [sym__literal] = STATE(909),
    [sym_character_literal] = STATE(909),
    [sym_string_literal] = STATE(909),
    [sym_call] = STATE(909),
    [sym_invoke] = STATE(909),
    [sym_indexed_access] = STATE(909),
    [sym_slot_accessor] = STATE(909),
    [sym_true] = STATE(909),
    [sym_false] = STATE(909),
    [sym_maybe] = STATE(909),
    [sym_unset] = STATE(909),
    [sym_super] = STATE(909),
    [sym_self] = STATE(909),
    [sym_clone] = STATE(909),
    [sym_thisthread] = STATE(909),
    [sym_class] = STATE(909),
    [sym__expression] = STATE(909),
    [sym_return] = STATE(909),
    [sym_gather] = STATE(909),
    [sym_scatter] = STATE(909),
    [sym_allresults] = STATE(909),
    [sym_parenthesized_expression] = STATE(909),
    [sym__variable] = STATE(909),
    [sym_variable] = STATE(909),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(909),
    [sym_relational_operator] = STATE(909),
    [sym_logical_operator] = STATE(909),
    [sym_arithmetic_operator] = STATE(909),
    [sym_unary_operator] = STATE(909),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1491),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1491),
    [sym_global_variable] = ACTIONS(1491),
    [sym_global_reference] = ACTIONS(1491),
    [sym_number] = ACTIONS(1491),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1491),
    [sym_comment] = ACTIONS(103),
  },
  [332] = {
    [sym_procedure] = STATE(954),
    [sym_block] = STATE(954),
    [sym_assignment] = STATE(954),
    [sym_if] = STATE(954),
    [sym_loop] = STATE(954),
    [sym_handling] = STATE(954),
    [sym_catch] = STATE(954),
    [sym_throw] = STATE(954),
    [sym_primitive] = STATE(954),
    [sym_iterator] = STATE(954),
    [sym_while] = STATE(954),
    [sym_try] = STATE(954),
    [sym_loopbody] = STATE(954),
    [sym_leave] = STATE(954),
    [sym_continue] = STATE(954),
    [sym_protect] = STATE(954),
    [sym_lock] = STATE(954),
    [sym__literal] = STATE(954),
    [sym_character_literal] = STATE(954),
    [sym_string_literal] = STATE(954),
    [sym_call] = STATE(954),
    [sym_invoke] = STATE(954),
    [sym_indexed_access] = STATE(954),
    [sym_slot_accessor] = STATE(954),
    [sym_true] = STATE(954),
    [sym_false] = STATE(954),
    [sym_maybe] = STATE(954),
    [sym_unset] = STATE(954),
    [sym_super] = STATE(954),
    [sym_self] = STATE(954),
    [sym_clone] = STATE(954),
    [sym_thisthread] = STATE(954),
    [sym_class] = STATE(954),
    [sym__expression] = STATE(954),
    [sym_return] = STATE(954),
    [sym_gather] = STATE(954),
    [sym_scatter] = STATE(954),
    [sym_allresults] = STATE(954),
    [sym_parenthesized_expression] = STATE(954),
    [sym__variable] = STATE(954),
    [sym_variable] = STATE(954),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(954),
    [sym_relational_operator] = STATE(954),
    [sym_logical_operator] = STATE(954),
    [sym_arithmetic_operator] = STATE(954),
    [sym_unary_operator] = STATE(954),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1493),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1493),
    [sym_global_variable] = ACTIONS(1493),
    [sym_global_reference] = ACTIONS(1493),
    [sym_number] = ACTIONS(1493),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1493),
    [sym_comment] = ACTIONS(103),
  },
  [333] = {
    [sym_procedure] = STATE(863),
    [sym_block] = STATE(863),
    [sym_assignment] = STATE(863),
    [sym_if] = STATE(863),
    [sym_loop] = STATE(863),
    [sym_handling] = STATE(863),
    [sym_catch] = STATE(863),
    [sym_throw] = STATE(863),
    [sym_primitive] = STATE(863),
    [sym_iterator] = STATE(863),
    [sym_while] = STATE(863),
    [sym_try] = STATE(863),
    [sym_loopbody] = STATE(863),
    [sym_leave] = STATE(863),
    [sym_continue] = STATE(863),
    [sym_protect] = STATE(863),
    [sym_lock] = STATE(863),
    [sym__literal] = STATE(863),
    [sym_character_literal] = STATE(863),
    [sym_string_literal] = STATE(863),
    [sym_call] = STATE(863),
    [sym_invoke] = STATE(863),
    [sym_indexed_access] = STATE(863),
    [sym_slot_accessor] = STATE(863),
    [sym_true] = STATE(863),
    [sym_false] = STATE(863),
    [sym_maybe] = STATE(863),
    [sym_unset] = STATE(863),
    [sym_super] = STATE(863),
    [sym_self] = STATE(863),
    [sym_clone] = STATE(863),
    [sym_thisthread] = STATE(863),
    [sym_class] = STATE(863),
    [sym__expression] = STATE(863),
    [sym_return] = STATE(863),
    [sym_gather] = STATE(863),
    [sym_scatter] = STATE(863),
    [sym_allresults] = STATE(863),
    [sym_parenthesized_expression] = STATE(863),
    [sym__variable] = STATE(863),
    [sym_variable] = STATE(863),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(863),
    [sym_relational_operator] = STATE(863),
    [sym_logical_operator] = STATE(863),
    [sym_arithmetic_operator] = STATE(863),
    [sym_unary_operator] = STATE(863),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1495),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1495),
    [sym_global_variable] = ACTIONS(1495),
    [sym_global_reference] = ACTIONS(1495),
    [sym_number] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1495),
    [sym_comment] = ACTIONS(103),
  },
  [334] = {
    [sym_procedure] = STATE(953),
    [sym_block] = STATE(953),
    [sym_assignment] = STATE(953),
    [sym_if] = STATE(953),
    [sym_loop] = STATE(953),
    [sym_handling] = STATE(953),
    [sym_catch] = STATE(953),
    [sym_throw] = STATE(953),
    [sym_primitive] = STATE(953),
    [sym_iterator] = STATE(953),
    [sym_while] = STATE(953),
    [sym_try] = STATE(953),
    [sym_loopbody] = STATE(953),
    [sym_leave] = STATE(953),
    [sym_continue] = STATE(953),
    [sym_protect] = STATE(953),
    [sym_lock] = STATE(953),
    [sym__literal] = STATE(953),
    [sym_character_literal] = STATE(953),
    [sym_string_literal] = STATE(953),
    [sym_call] = STATE(953),
    [sym_invoke] = STATE(953),
    [sym_indexed_access] = STATE(953),
    [sym_slot_accessor] = STATE(953),
    [sym_true] = STATE(953),
    [sym_false] = STATE(953),
    [sym_maybe] = STATE(953),
    [sym_unset] = STATE(953),
    [sym_super] = STATE(953),
    [sym_self] = STATE(953),
    [sym_clone] = STATE(953),
    [sym_thisthread] = STATE(953),
    [sym_class] = STATE(953),
    [sym__expression] = STATE(953),
    [sym_return] = STATE(953),
    [sym_gather] = STATE(953),
    [sym_scatter] = STATE(953),
    [sym_allresults] = STATE(953),
    [sym_parenthesized_expression] = STATE(953),
    [sym__variable] = STATE(953),
    [sym_variable] = STATE(953),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(953),
    [sym_relational_operator] = STATE(953),
    [sym_logical_operator] = STATE(953),
    [sym_arithmetic_operator] = STATE(953),
    [sym_unary_operator] = STATE(953),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1497),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1497),
    [sym_global_variable] = ACTIONS(1497),
    [sym_global_reference] = ACTIONS(1497),
    [sym_number] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1497),
    [sym_comment] = ACTIONS(103),
  },
  [335] = {
    [sym_procedure] = STATE(507),
    [sym_block] = STATE(507),
    [sym_assignment] = STATE(507),
    [sym_if] = STATE(507),
    [sym_loop] = STATE(507),
    [sym_handling] = STATE(507),
    [sym_catch] = STATE(507),
    [sym_throw] = STATE(507),
    [sym_primitive] = STATE(507),
    [sym_iterator] = STATE(507),
    [sym_while] = STATE(507),
    [sym_try] = STATE(507),
    [sym_loopbody] = STATE(507),
    [sym_leave] = STATE(507),
    [sym_continue] = STATE(507),
    [sym_protect] = STATE(507),
    [sym_lock] = STATE(507),
    [sym__literal] = STATE(507),
    [sym_character_literal] = STATE(507),
    [sym_string_literal] = STATE(507),
    [sym_call] = STATE(507),
    [sym_invoke] = STATE(507),
    [sym_indexed_access] = STATE(507),
    [sym_slot_accessor] = STATE(507),
    [sym_true] = STATE(507),
    [sym_false] = STATE(507),
    [sym_maybe] = STATE(507),
    [sym_unset] = STATE(507),
    [sym_super] = STATE(507),
    [sym_self] = STATE(507),
    [sym_clone] = STATE(507),
    [sym_thisthread] = STATE(507),
    [sym_class] = STATE(507),
    [sym__expression] = STATE(507),
    [sym_return] = STATE(507),
    [sym_gather] = STATE(507),
    [sym_scatter] = STATE(507),
    [sym_allresults] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym__variable] = STATE(507),
    [sym_variable] = STATE(507),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(507),
    [sym_relational_operator] = STATE(507),
    [sym_logical_operator] = STATE(507),
    [sym_arithmetic_operator] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1499),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1499),
    [sym_global_variable] = ACTIONS(1499),
    [sym_global_reference] = ACTIONS(1499),
    [sym_number] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1499),
    [sym_comment] = ACTIONS(103),
  },
  [336] = {
    [sym_procedure] = STATE(1009),
    [sym_block] = STATE(1009),
    [sym_assignment] = STATE(1009),
    [sym_if] = STATE(1009),
    [sym_loop] = STATE(1009),
    [sym_handling] = STATE(1009),
    [sym_catch] = STATE(1009),
    [sym_throw] = STATE(1009),
    [sym_primitive] = STATE(1009),
    [sym_iterator] = STATE(1009),
    [sym_while] = STATE(1009),
    [sym_try] = STATE(1009),
    [sym_loopbody] = STATE(1009),
    [sym_leave] = STATE(1009),
    [sym_continue] = STATE(1009),
    [sym_protect] = STATE(1009),
    [sym_lock] = STATE(1009),
    [sym__literal] = STATE(1009),
    [sym_character_literal] = STATE(1009),
    [sym_string_literal] = STATE(1009),
    [sym_call] = STATE(1009),
    [sym_invoke] = STATE(1009),
    [sym_indexed_access] = STATE(1009),
    [sym_slot_accessor] = STATE(1009),
    [sym_true] = STATE(1009),
    [sym_false] = STATE(1009),
    [sym_maybe] = STATE(1009),
    [sym_unset] = STATE(1009),
    [sym_super] = STATE(1009),
    [sym_self] = STATE(1009),
    [sym_clone] = STATE(1009),
    [sym_thisthread] = STATE(1009),
    [sym_class] = STATE(1009),
    [sym__expression] = STATE(1009),
    [sym_return] = STATE(1009),
    [sym_gather] = STATE(1009),
    [sym_scatter] = STATE(1009),
    [sym_allresults] = STATE(1009),
    [sym_parenthesized_expression] = STATE(1009),
    [sym__variable] = STATE(1009),
    [sym_variable] = STATE(1009),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1009),
    [sym_relational_operator] = STATE(1009),
    [sym_logical_operator] = STATE(1009),
    [sym_arithmetic_operator] = STATE(1009),
    [sym_unary_operator] = STATE(1009),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1501),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1501),
    [sym_global_variable] = ACTIONS(1501),
    [sym_global_reference] = ACTIONS(1501),
    [sym_number] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1501),
    [sym_comment] = ACTIONS(103),
  },
  [337] = {
    [sym_procedure] = STATE(951),
    [sym_block] = STATE(951),
    [sym_assignment] = STATE(951),
    [sym_if] = STATE(951),
    [sym_loop] = STATE(951),
    [sym_handling] = STATE(951),
    [sym_catch] = STATE(951),
    [sym_throw] = STATE(951),
    [sym_primitive] = STATE(951),
    [sym_iterator] = STATE(951),
    [sym_while] = STATE(951),
    [sym_try] = STATE(951),
    [sym_loopbody] = STATE(951),
    [sym_leave] = STATE(951),
    [sym_continue] = STATE(951),
    [sym_protect] = STATE(951),
    [sym_lock] = STATE(951),
    [sym__literal] = STATE(951),
    [sym_character_literal] = STATE(951),
    [sym_string_literal] = STATE(951),
    [sym_call] = STATE(951),
    [sym_invoke] = STATE(951),
    [sym_indexed_access] = STATE(951),
    [sym_slot_accessor] = STATE(951),
    [sym_true] = STATE(951),
    [sym_false] = STATE(951),
    [sym_maybe] = STATE(951),
    [sym_unset] = STATE(951),
    [sym_super] = STATE(951),
    [sym_self] = STATE(951),
    [sym_clone] = STATE(951),
    [sym_thisthread] = STATE(951),
    [sym_class] = STATE(951),
    [sym__expression] = STATE(951),
    [sym_return] = STATE(951),
    [sym_gather] = STATE(951),
    [sym_scatter] = STATE(951),
    [sym_allresults] = STATE(951),
    [sym_parenthesized_expression] = STATE(951),
    [sym__variable] = STATE(951),
    [sym_variable] = STATE(951),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(951),
    [sym_relational_operator] = STATE(951),
    [sym_logical_operator] = STATE(951),
    [sym_arithmetic_operator] = STATE(951),
    [sym_unary_operator] = STATE(951),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1503),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1503),
    [sym_global_variable] = ACTIONS(1503),
    [sym_global_reference] = ACTIONS(1503),
    [sym_number] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1503),
    [sym_comment] = ACTIONS(103),
  },
  [338] = {
    [sym_procedure] = STATE(1003),
    [sym_block] = STATE(1003),
    [sym_assignment] = STATE(1003),
    [sym_if] = STATE(1003),
    [sym_loop] = STATE(1003),
    [sym_handling] = STATE(1003),
    [sym_catch] = STATE(1003),
    [sym_throw] = STATE(1003),
    [sym_primitive] = STATE(1003),
    [sym_iterator] = STATE(1003),
    [sym_while] = STATE(1003),
    [sym_try] = STATE(1003),
    [sym_loopbody] = STATE(1003),
    [sym_leave] = STATE(1003),
    [sym_continue] = STATE(1003),
    [sym_protect] = STATE(1003),
    [sym_lock] = STATE(1003),
    [sym__literal] = STATE(1003),
    [sym_character_literal] = STATE(1003),
    [sym_string_literal] = STATE(1003),
    [sym_call] = STATE(1003),
    [sym_invoke] = STATE(1003),
    [sym_indexed_access] = STATE(1003),
    [sym_slot_accessor] = STATE(1003),
    [sym_true] = STATE(1003),
    [sym_false] = STATE(1003),
    [sym_maybe] = STATE(1003),
    [sym_unset] = STATE(1003),
    [sym_super] = STATE(1003),
    [sym_self] = STATE(1003),
    [sym_clone] = STATE(1003),
    [sym_thisthread] = STATE(1003),
    [sym_class] = STATE(1003),
    [sym__expression] = STATE(1003),
    [sym_return] = STATE(1003),
    [sym_gather] = STATE(1003),
    [sym_scatter] = STATE(1003),
    [sym_allresults] = STATE(1003),
    [sym_parenthesized_expression] = STATE(1003),
    [sym__variable] = STATE(1003),
    [sym_variable] = STATE(1003),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1003),
    [sym_relational_operator] = STATE(1003),
    [sym_logical_operator] = STATE(1003),
    [sym_arithmetic_operator] = STATE(1003),
    [sym_unary_operator] = STATE(1003),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1505),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1505),
    [sym_global_variable] = ACTIONS(1505),
    [sym_global_reference] = ACTIONS(1505),
    [sym_number] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1505),
    [sym_comment] = ACTIONS(103),
  },
  [339] = {
    [sym_procedure] = STATE(1013),
    [sym_block] = STATE(1013),
    [sym_assignment] = STATE(1013),
    [sym_if] = STATE(1013),
    [sym_loop] = STATE(1013),
    [sym_handling] = STATE(1013),
    [sym_catch] = STATE(1013),
    [sym_throw] = STATE(1013),
    [sym_primitive] = STATE(1013),
    [sym_iterator] = STATE(1013),
    [sym_while] = STATE(1013),
    [sym_try] = STATE(1013),
    [sym_loopbody] = STATE(1013),
    [sym_leave] = STATE(1013),
    [sym_continue] = STATE(1013),
    [sym_protect] = STATE(1013),
    [sym_lock] = STATE(1013),
    [sym__literal] = STATE(1013),
    [sym_character_literal] = STATE(1013),
    [sym_string_literal] = STATE(1013),
    [sym_call] = STATE(1013),
    [sym_invoke] = STATE(1013),
    [sym_indexed_access] = STATE(1013),
    [sym_slot_accessor] = STATE(1013),
    [sym_true] = STATE(1013),
    [sym_false] = STATE(1013),
    [sym_maybe] = STATE(1013),
    [sym_unset] = STATE(1013),
    [sym_super] = STATE(1013),
    [sym_self] = STATE(1013),
    [sym_clone] = STATE(1013),
    [sym_thisthread] = STATE(1013),
    [sym_class] = STATE(1013),
    [sym__expression] = STATE(1013),
    [sym_return] = STATE(1013),
    [sym_gather] = STATE(1013),
    [sym_scatter] = STATE(1013),
    [sym_allresults] = STATE(1013),
    [sym_parenthesized_expression] = STATE(1013),
    [sym__variable] = STATE(1013),
    [sym_variable] = STATE(1013),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1013),
    [sym_relational_operator] = STATE(1013),
    [sym_logical_operator] = STATE(1013),
    [sym_arithmetic_operator] = STATE(1013),
    [sym_unary_operator] = STATE(1013),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1507),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1507),
    [sym_global_variable] = ACTIONS(1507),
    [sym_global_reference] = ACTIONS(1507),
    [sym_number] = ACTIONS(1507),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1507),
    [sym_comment] = ACTIONS(103),
  },
  [340] = {
    [sym_procedure] = STATE(961),
    [sym_block] = STATE(961),
    [sym_assignment] = STATE(961),
    [sym_if] = STATE(961),
    [sym_loop] = STATE(961),
    [sym_handling] = STATE(961),
    [sym_catch] = STATE(961),
    [sym_throw] = STATE(961),
    [sym_primitive] = STATE(961),
    [sym_iterator] = STATE(961),
    [sym_while] = STATE(961),
    [sym_try] = STATE(961),
    [sym_loopbody] = STATE(961),
    [sym_leave] = STATE(961),
    [sym_continue] = STATE(961),
    [sym_protect] = STATE(961),
    [sym_lock] = STATE(961),
    [sym__literal] = STATE(961),
    [sym_character_literal] = STATE(961),
    [sym_string_literal] = STATE(961),
    [sym_call] = STATE(961),
    [sym_invoke] = STATE(961),
    [sym_indexed_access] = STATE(961),
    [sym_slot_accessor] = STATE(961),
    [sym_true] = STATE(961),
    [sym_false] = STATE(961),
    [sym_maybe] = STATE(961),
    [sym_unset] = STATE(961),
    [sym_super] = STATE(961),
    [sym_self] = STATE(961),
    [sym_clone] = STATE(961),
    [sym_thisthread] = STATE(961),
    [sym_class] = STATE(961),
    [sym__expression] = STATE(961),
    [sym_return] = STATE(961),
    [sym_gather] = STATE(961),
    [sym_scatter] = STATE(961),
    [sym_allresults] = STATE(961),
    [sym_parenthesized_expression] = STATE(961),
    [sym__variable] = STATE(961),
    [sym_variable] = STATE(961),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(961),
    [sym_relational_operator] = STATE(961),
    [sym_logical_operator] = STATE(961),
    [sym_arithmetic_operator] = STATE(961),
    [sym_unary_operator] = STATE(961),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1509),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1509),
    [sym_global_variable] = ACTIONS(1509),
    [sym_global_reference] = ACTIONS(1509),
    [sym_number] = ACTIONS(1509),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1509),
    [sym_comment] = ACTIONS(103),
  },
  [341] = {
    [sym_procedure] = STATE(619),
    [sym_block] = STATE(619),
    [sym_assignment] = STATE(619),
    [sym_if] = STATE(619),
    [sym_loop] = STATE(619),
    [sym_handling] = STATE(619),
    [sym_catch] = STATE(619),
    [sym_throw] = STATE(619),
    [sym_primitive] = STATE(619),
    [sym_iterator] = STATE(619),
    [sym_while] = STATE(619),
    [sym_try] = STATE(619),
    [sym_loopbody] = STATE(619),
    [sym_leave] = STATE(619),
    [sym_continue] = STATE(619),
    [sym_protect] = STATE(619),
    [sym_lock] = STATE(619),
    [sym__literal] = STATE(619),
    [sym_character_literal] = STATE(619),
    [sym_string_literal] = STATE(619),
    [sym_call] = STATE(619),
    [sym_invoke] = STATE(619),
    [sym_indexed_access] = STATE(619),
    [sym_slot_accessor] = STATE(619),
    [sym_true] = STATE(619),
    [sym_false] = STATE(619),
    [sym_maybe] = STATE(619),
    [sym_unset] = STATE(619),
    [sym_super] = STATE(619),
    [sym_self] = STATE(619),
    [sym_clone] = STATE(619),
    [sym_thisthread] = STATE(619),
    [sym_class] = STATE(619),
    [sym__expression] = STATE(619),
    [sym_return] = STATE(619),
    [sym_gather] = STATE(619),
    [sym_scatter] = STATE(619),
    [sym_allresults] = STATE(619),
    [sym_parenthesized_expression] = STATE(619),
    [sym__variable] = STATE(619),
    [sym_variable] = STATE(619),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(619),
    [sym_relational_operator] = STATE(619),
    [sym_logical_operator] = STATE(619),
    [sym_arithmetic_operator] = STATE(619),
    [sym_unary_operator] = STATE(619),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1511),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1511),
    [sym_global_variable] = ACTIONS(1511),
    [sym_global_reference] = ACTIONS(1511),
    [sym_number] = ACTIONS(1511),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1511),
    [sym_comment] = ACTIONS(103),
  },
  [342] = {
    [sym_procedure] = STATE(599),
    [sym_block] = STATE(599),
    [sym_assignment] = STATE(599),
    [sym_if] = STATE(599),
    [sym_loop] = STATE(599),
    [sym_handling] = STATE(599),
    [sym_catch] = STATE(599),
    [sym_throw] = STATE(599),
    [sym_primitive] = STATE(599),
    [sym_iterator] = STATE(599),
    [sym_while] = STATE(599),
    [sym_try] = STATE(599),
    [sym_loopbody] = STATE(599),
    [sym_leave] = STATE(599),
    [sym_continue] = STATE(599),
    [sym_protect] = STATE(599),
    [sym_lock] = STATE(599),
    [sym__literal] = STATE(599),
    [sym_character_literal] = STATE(599),
    [sym_string_literal] = STATE(599),
    [sym_call] = STATE(599),
    [sym_invoke] = STATE(599),
    [sym_indexed_access] = STATE(599),
    [sym_slot_accessor] = STATE(599),
    [sym_true] = STATE(599),
    [sym_false] = STATE(599),
    [sym_maybe] = STATE(599),
    [sym_unset] = STATE(599),
    [sym_super] = STATE(599),
    [sym_self] = STATE(599),
    [sym_clone] = STATE(599),
    [sym_thisthread] = STATE(599),
    [sym_class] = STATE(599),
    [sym__expression] = STATE(599),
    [sym_return] = STATE(599),
    [sym_gather] = STATE(599),
    [sym_scatter] = STATE(599),
    [sym_allresults] = STATE(599),
    [sym_parenthesized_expression] = STATE(599),
    [sym__variable] = STATE(599),
    [sym_variable] = STATE(599),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(599),
    [sym_relational_operator] = STATE(599),
    [sym_logical_operator] = STATE(599),
    [sym_arithmetic_operator] = STATE(599),
    [sym_unary_operator] = STATE(599),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1513),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1513),
    [sym_global_variable] = ACTIONS(1513),
    [sym_global_reference] = ACTIONS(1513),
    [sym_number] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1513),
    [sym_comment] = ACTIONS(103),
  },
  [343] = {
    [sym_procedure] = STATE(917),
    [sym_block] = STATE(917),
    [sym_assignment] = STATE(917),
    [sym_if] = STATE(917),
    [sym_loop] = STATE(917),
    [sym_handling] = STATE(917),
    [sym_catch] = STATE(917),
    [sym_throw] = STATE(917),
    [sym_primitive] = STATE(917),
    [sym_iterator] = STATE(917),
    [sym_while] = STATE(917),
    [sym_try] = STATE(917),
    [sym_loopbody] = STATE(917),
    [sym_leave] = STATE(917),
    [sym_continue] = STATE(917),
    [sym_protect] = STATE(917),
    [sym_lock] = STATE(917),
    [sym__literal] = STATE(917),
    [sym_character_literal] = STATE(917),
    [sym_string_literal] = STATE(917),
    [sym_call] = STATE(917),
    [sym_invoke] = STATE(917),
    [sym_indexed_access] = STATE(917),
    [sym_slot_accessor] = STATE(917),
    [sym_true] = STATE(917),
    [sym_false] = STATE(917),
    [sym_maybe] = STATE(917),
    [sym_unset] = STATE(917),
    [sym_super] = STATE(917),
    [sym_self] = STATE(917),
    [sym_clone] = STATE(917),
    [sym_thisthread] = STATE(917),
    [sym_class] = STATE(917),
    [sym__expression] = STATE(917),
    [sym_return] = STATE(917),
    [sym_gather] = STATE(917),
    [sym_scatter] = STATE(917),
    [sym_allresults] = STATE(917),
    [sym_parenthesized_expression] = STATE(917),
    [sym__variable] = STATE(917),
    [sym_variable] = STATE(917),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(917),
    [sym_relational_operator] = STATE(917),
    [sym_logical_operator] = STATE(917),
    [sym_arithmetic_operator] = STATE(917),
    [sym_unary_operator] = STATE(917),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1515),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1515),
    [sym_global_variable] = ACTIONS(1515),
    [sym_global_reference] = ACTIONS(1515),
    [sym_number] = ACTIONS(1515),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1515),
    [sym_comment] = ACTIONS(103),
  },
  [344] = {
    [sym_procedure] = STATE(1015),
    [sym_block] = STATE(1015),
    [sym_assignment] = STATE(1015),
    [sym_if] = STATE(1015),
    [sym_loop] = STATE(1015),
    [sym_handling] = STATE(1015),
    [sym_catch] = STATE(1015),
    [sym_throw] = STATE(1015),
    [sym_primitive] = STATE(1015),
    [sym_iterator] = STATE(1015),
    [sym_while] = STATE(1015),
    [sym_try] = STATE(1015),
    [sym_loopbody] = STATE(1015),
    [sym_leave] = STATE(1015),
    [sym_continue] = STATE(1015),
    [sym_protect] = STATE(1015),
    [sym_lock] = STATE(1015),
    [sym__literal] = STATE(1015),
    [sym_character_literal] = STATE(1015),
    [sym_string_literal] = STATE(1015),
    [sym_call] = STATE(1015),
    [sym_invoke] = STATE(1015),
    [sym_indexed_access] = STATE(1015),
    [sym_slot_accessor] = STATE(1015),
    [sym_true] = STATE(1015),
    [sym_false] = STATE(1015),
    [sym_maybe] = STATE(1015),
    [sym_unset] = STATE(1015),
    [sym_super] = STATE(1015),
    [sym_self] = STATE(1015),
    [sym_clone] = STATE(1015),
    [sym_thisthread] = STATE(1015),
    [sym_class] = STATE(1015),
    [sym__expression] = STATE(1015),
    [sym_return] = STATE(1015),
    [sym_gather] = STATE(1015),
    [sym_scatter] = STATE(1015),
    [sym_allresults] = STATE(1015),
    [sym_parenthesized_expression] = STATE(1015),
    [sym__variable] = STATE(1015),
    [sym_variable] = STATE(1015),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1015),
    [sym_relational_operator] = STATE(1015),
    [sym_logical_operator] = STATE(1015),
    [sym_arithmetic_operator] = STATE(1015),
    [sym_unary_operator] = STATE(1015),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1517),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1517),
    [sym_global_variable] = ACTIONS(1517),
    [sym_global_reference] = ACTIONS(1517),
    [sym_number] = ACTIONS(1517),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1517),
    [sym_comment] = ACTIONS(103),
  },
  [345] = {
    [sym_procedure] = STATE(957),
    [sym_block] = STATE(957),
    [sym_assignment] = STATE(957),
    [sym_if] = STATE(957),
    [sym_loop] = STATE(957),
    [sym_handling] = STATE(957),
    [sym_catch] = STATE(957),
    [sym_throw] = STATE(957),
    [sym_primitive] = STATE(957),
    [sym_iterator] = STATE(957),
    [sym_while] = STATE(957),
    [sym_try] = STATE(957),
    [sym_loopbody] = STATE(957),
    [sym_leave] = STATE(957),
    [sym_continue] = STATE(957),
    [sym_protect] = STATE(957),
    [sym_lock] = STATE(957),
    [sym__literal] = STATE(957),
    [sym_character_literal] = STATE(957),
    [sym_string_literal] = STATE(957),
    [sym_call] = STATE(957),
    [sym_invoke] = STATE(957),
    [sym_indexed_access] = STATE(957),
    [sym_slot_accessor] = STATE(957),
    [sym_true] = STATE(957),
    [sym_false] = STATE(957),
    [sym_maybe] = STATE(957),
    [sym_unset] = STATE(957),
    [sym_super] = STATE(957),
    [sym_self] = STATE(957),
    [sym_clone] = STATE(957),
    [sym_thisthread] = STATE(957),
    [sym_class] = STATE(957),
    [sym__expression] = STATE(957),
    [sym_return] = STATE(957),
    [sym_gather] = STATE(957),
    [sym_scatter] = STATE(957),
    [sym_allresults] = STATE(957),
    [sym_parenthesized_expression] = STATE(957),
    [sym__variable] = STATE(957),
    [sym_variable] = STATE(957),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(957),
    [sym_relational_operator] = STATE(957),
    [sym_logical_operator] = STATE(957),
    [sym_arithmetic_operator] = STATE(957),
    [sym_unary_operator] = STATE(957),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1519),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1519),
    [sym_global_variable] = ACTIONS(1519),
    [sym_global_reference] = ACTIONS(1519),
    [sym_number] = ACTIONS(1519),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1519),
    [sym_comment] = ACTIONS(103),
  },
  [346] = {
    [sym_procedure] = STATE(664),
    [sym_block] = STATE(664),
    [sym_assignment] = STATE(664),
    [sym_if] = STATE(664),
    [sym_loop] = STATE(664),
    [sym_handling] = STATE(664),
    [sym_catch] = STATE(664),
    [sym_throw] = STATE(664),
    [sym_primitive] = STATE(664),
    [sym_iterator] = STATE(664),
    [sym_while] = STATE(664),
    [sym_try] = STATE(664),
    [sym_loopbody] = STATE(664),
    [sym_leave] = STATE(664),
    [sym_continue] = STATE(664),
    [sym_protect] = STATE(664),
    [sym_lock] = STATE(664),
    [sym__literal] = STATE(664),
    [sym_character_literal] = STATE(664),
    [sym_string_literal] = STATE(664),
    [sym_call] = STATE(664),
    [sym_invoke] = STATE(664),
    [sym_indexed_access] = STATE(664),
    [sym_slot_accessor] = STATE(664),
    [sym_true] = STATE(664),
    [sym_false] = STATE(664),
    [sym_maybe] = STATE(664),
    [sym_unset] = STATE(664),
    [sym_super] = STATE(664),
    [sym_self] = STATE(664),
    [sym_clone] = STATE(664),
    [sym_thisthread] = STATE(664),
    [sym_class] = STATE(664),
    [sym__expression] = STATE(664),
    [sym_return] = STATE(664),
    [sym_gather] = STATE(664),
    [sym_scatter] = STATE(664),
    [sym_allresults] = STATE(664),
    [sym_parenthesized_expression] = STATE(664),
    [sym__variable] = STATE(664),
    [sym_variable] = STATE(664),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(664),
    [sym_relational_operator] = STATE(664),
    [sym_logical_operator] = STATE(664),
    [sym_arithmetic_operator] = STATE(664),
    [sym_unary_operator] = STATE(664),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1521),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1521),
    [sym_global_variable] = ACTIONS(1521),
    [sym_global_reference] = ACTIONS(1521),
    [sym_number] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1521),
    [sym_comment] = ACTIONS(103),
  },
  [347] = {
    [sym_procedure] = STATE(728),
    [sym_block] = STATE(728),
    [sym_assignment] = STATE(728),
    [sym_if] = STATE(728),
    [sym_loop] = STATE(728),
    [sym_handling] = STATE(728),
    [sym_catch] = STATE(728),
    [sym_throw] = STATE(728),
    [sym_primitive] = STATE(728),
    [sym_iterator] = STATE(728),
    [sym_while] = STATE(728),
    [sym_try] = STATE(728),
    [sym_loopbody] = STATE(728),
    [sym_leave] = STATE(728),
    [sym_continue] = STATE(728),
    [sym_protect] = STATE(728),
    [sym_lock] = STATE(728),
    [sym__literal] = STATE(728),
    [sym_character_literal] = STATE(728),
    [sym_string_literal] = STATE(728),
    [sym_call] = STATE(728),
    [sym_invoke] = STATE(728),
    [sym_indexed_access] = STATE(728),
    [sym_slot_accessor] = STATE(728),
    [sym_true] = STATE(728),
    [sym_false] = STATE(728),
    [sym_maybe] = STATE(728),
    [sym_unset] = STATE(728),
    [sym_super] = STATE(728),
    [sym_self] = STATE(728),
    [sym_clone] = STATE(728),
    [sym_thisthread] = STATE(728),
    [sym_class] = STATE(728),
    [sym__expression] = STATE(728),
    [sym_return] = STATE(728),
    [sym_gather] = STATE(728),
    [sym_scatter] = STATE(728),
    [sym_allresults] = STATE(728),
    [sym_parenthesized_expression] = STATE(728),
    [sym__variable] = STATE(728),
    [sym_variable] = STATE(728),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(728),
    [sym_relational_operator] = STATE(728),
    [sym_logical_operator] = STATE(728),
    [sym_arithmetic_operator] = STATE(728),
    [sym_unary_operator] = STATE(728),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1523),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1523),
    [sym_global_variable] = ACTIONS(1523),
    [sym_global_reference] = ACTIONS(1523),
    [sym_number] = ACTIONS(1523),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1523),
    [sym_comment] = ACTIONS(103),
  },
  [348] = {
    [sym_procedure] = STATE(940),
    [sym_block] = STATE(940),
    [sym_assignment] = STATE(940),
    [sym_if] = STATE(940),
    [sym_loop] = STATE(940),
    [sym_handling] = STATE(940),
    [sym_catch] = STATE(940),
    [sym_throw] = STATE(940),
    [sym_primitive] = STATE(940),
    [sym_iterator] = STATE(940),
    [sym_while] = STATE(940),
    [sym_try] = STATE(940),
    [sym_loopbody] = STATE(940),
    [sym_leave] = STATE(940),
    [sym_continue] = STATE(940),
    [sym_protect] = STATE(940),
    [sym_lock] = STATE(940),
    [sym__literal] = STATE(940),
    [sym_character_literal] = STATE(940),
    [sym_string_literal] = STATE(940),
    [sym_call] = STATE(940),
    [sym_invoke] = STATE(940),
    [sym_indexed_access] = STATE(940),
    [sym_slot_accessor] = STATE(940),
    [sym_true] = STATE(940),
    [sym_false] = STATE(940),
    [sym_maybe] = STATE(940),
    [sym_unset] = STATE(940),
    [sym_super] = STATE(940),
    [sym_self] = STATE(940),
    [sym_clone] = STATE(940),
    [sym_thisthread] = STATE(940),
    [sym_class] = STATE(940),
    [sym__expression] = STATE(940),
    [sym_return] = STATE(940),
    [sym_gather] = STATE(940),
    [sym_scatter] = STATE(940),
    [sym_allresults] = STATE(940),
    [sym_parenthesized_expression] = STATE(940),
    [sym__variable] = STATE(940),
    [sym_variable] = STATE(940),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(940),
    [sym_relational_operator] = STATE(940),
    [sym_logical_operator] = STATE(940),
    [sym_arithmetic_operator] = STATE(940),
    [sym_unary_operator] = STATE(940),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1525),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1525),
    [sym_global_variable] = ACTIONS(1525),
    [sym_global_reference] = ACTIONS(1525),
    [sym_number] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1525),
    [sym_comment] = ACTIONS(103),
  },
  [349] = {
    [sym_procedure] = STATE(729),
    [sym_block] = STATE(729),
    [sym_assignment] = STATE(729),
    [sym_if] = STATE(729),
    [sym_loop] = STATE(729),
    [sym_handling] = STATE(729),
    [sym_catch] = STATE(729),
    [sym_throw] = STATE(729),
    [sym_primitive] = STATE(729),
    [sym_iterator] = STATE(729),
    [sym_while] = STATE(729),
    [sym_try] = STATE(729),
    [sym_loopbody] = STATE(729),
    [sym_leave] = STATE(729),
    [sym_continue] = STATE(729),
    [sym_protect] = STATE(729),
    [sym_lock] = STATE(729),
    [sym__literal] = STATE(729),
    [sym_character_literal] = STATE(729),
    [sym_string_literal] = STATE(729),
    [sym_call] = STATE(729),
    [sym_invoke] = STATE(729),
    [sym_indexed_access] = STATE(729),
    [sym_slot_accessor] = STATE(729),
    [sym_true] = STATE(729),
    [sym_false] = STATE(729),
    [sym_maybe] = STATE(729),
    [sym_unset] = STATE(729),
    [sym_super] = STATE(729),
    [sym_self] = STATE(729),
    [sym_clone] = STATE(729),
    [sym_thisthread] = STATE(729),
    [sym_class] = STATE(729),
    [sym__expression] = STATE(729),
    [sym_return] = STATE(729),
    [sym_gather] = STATE(729),
    [sym_scatter] = STATE(729),
    [sym_allresults] = STATE(729),
    [sym_parenthesized_expression] = STATE(729),
    [sym__variable] = STATE(729),
    [sym_variable] = STATE(729),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(729),
    [sym_relational_operator] = STATE(729),
    [sym_logical_operator] = STATE(729),
    [sym_arithmetic_operator] = STATE(729),
    [sym_unary_operator] = STATE(729),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1527),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1527),
    [sym_global_variable] = ACTIONS(1527),
    [sym_global_reference] = ACTIONS(1527),
    [sym_number] = ACTIONS(1527),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1527),
    [sym_comment] = ACTIONS(103),
  },
  [350] = {
    [sym_procedure] = STATE(731),
    [sym_block] = STATE(731),
    [sym_assignment] = STATE(731),
    [sym_if] = STATE(731),
    [sym_loop] = STATE(731),
    [sym_handling] = STATE(731),
    [sym_catch] = STATE(731),
    [sym_throw] = STATE(731),
    [sym_primitive] = STATE(731),
    [sym_iterator] = STATE(731),
    [sym_while] = STATE(731),
    [sym_try] = STATE(731),
    [sym_loopbody] = STATE(731),
    [sym_leave] = STATE(731),
    [sym_continue] = STATE(731),
    [sym_protect] = STATE(731),
    [sym_lock] = STATE(731),
    [sym__literal] = STATE(731),
    [sym_character_literal] = STATE(731),
    [sym_string_literal] = STATE(731),
    [sym_call] = STATE(731),
    [sym_invoke] = STATE(731),
    [sym_indexed_access] = STATE(731),
    [sym_slot_accessor] = STATE(731),
    [sym_true] = STATE(731),
    [sym_false] = STATE(731),
    [sym_maybe] = STATE(731),
    [sym_unset] = STATE(731),
    [sym_super] = STATE(731),
    [sym_self] = STATE(731),
    [sym_clone] = STATE(731),
    [sym_thisthread] = STATE(731),
    [sym_class] = STATE(731),
    [sym__expression] = STATE(731),
    [sym_return] = STATE(731),
    [sym_gather] = STATE(731),
    [sym_scatter] = STATE(731),
    [sym_allresults] = STATE(731),
    [sym_parenthesized_expression] = STATE(731),
    [sym__variable] = STATE(731),
    [sym_variable] = STATE(731),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(731),
    [sym_relational_operator] = STATE(731),
    [sym_logical_operator] = STATE(731),
    [sym_arithmetic_operator] = STATE(731),
    [sym_unary_operator] = STATE(731),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1529),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1529),
    [sym_global_variable] = ACTIONS(1529),
    [sym_global_reference] = ACTIONS(1529),
    [sym_number] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1529),
    [sym_comment] = ACTIONS(103),
  },
  [351] = {
    [sym_procedure] = STATE(979),
    [sym_block] = STATE(979),
    [sym_assignment] = STATE(979),
    [sym_if] = STATE(979),
    [sym_loop] = STATE(979),
    [sym_handling] = STATE(979),
    [sym_catch] = STATE(979),
    [sym_throw] = STATE(979),
    [sym_primitive] = STATE(979),
    [sym_iterator] = STATE(979),
    [sym_while] = STATE(979),
    [sym_try] = STATE(979),
    [sym_loopbody] = STATE(979),
    [sym_leave] = STATE(979),
    [sym_continue] = STATE(979),
    [sym_protect] = STATE(979),
    [sym_lock] = STATE(979),
    [sym__literal] = STATE(979),
    [sym_character_literal] = STATE(979),
    [sym_string_literal] = STATE(979),
    [sym_call] = STATE(979),
    [sym_invoke] = STATE(979),
    [sym_indexed_access] = STATE(979),
    [sym_slot_accessor] = STATE(979),
    [sym_true] = STATE(979),
    [sym_false] = STATE(979),
    [sym_maybe] = STATE(979),
    [sym_unset] = STATE(979),
    [sym_super] = STATE(979),
    [sym_self] = STATE(979),
    [sym_clone] = STATE(979),
    [sym_thisthread] = STATE(979),
    [sym_class] = STATE(979),
    [sym__expression] = STATE(979),
    [sym_return] = STATE(979),
    [sym_gather] = STATE(979),
    [sym_scatter] = STATE(979),
    [sym_allresults] = STATE(979),
    [sym_parenthesized_expression] = STATE(979),
    [sym__variable] = STATE(979),
    [sym_variable] = STATE(979),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(979),
    [sym_relational_operator] = STATE(979),
    [sym_logical_operator] = STATE(979),
    [sym_arithmetic_operator] = STATE(979),
    [sym_unary_operator] = STATE(979),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1531),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1531),
    [sym_global_variable] = ACTIONS(1531),
    [sym_global_reference] = ACTIONS(1531),
    [sym_number] = ACTIONS(1531),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1531),
    [sym_comment] = ACTIONS(103),
  },
  [352] = {
    [sym_procedure] = STATE(1010),
    [sym_block] = STATE(1010),
    [sym_assignment] = STATE(1010),
    [sym_if] = STATE(1010),
    [sym_loop] = STATE(1010),
    [sym_handling] = STATE(1010),
    [sym_catch] = STATE(1010),
    [sym_throw] = STATE(1010),
    [sym_primitive] = STATE(1010),
    [sym_iterator] = STATE(1010),
    [sym_while] = STATE(1010),
    [sym_try] = STATE(1010),
    [sym_loopbody] = STATE(1010),
    [sym_leave] = STATE(1010),
    [sym_continue] = STATE(1010),
    [sym_protect] = STATE(1010),
    [sym_lock] = STATE(1010),
    [sym__literal] = STATE(1010),
    [sym_character_literal] = STATE(1010),
    [sym_string_literal] = STATE(1010),
    [sym_call] = STATE(1010),
    [sym_invoke] = STATE(1010),
    [sym_indexed_access] = STATE(1010),
    [sym_slot_accessor] = STATE(1010),
    [sym_true] = STATE(1010),
    [sym_false] = STATE(1010),
    [sym_maybe] = STATE(1010),
    [sym_unset] = STATE(1010),
    [sym_super] = STATE(1010),
    [sym_self] = STATE(1010),
    [sym_clone] = STATE(1010),
    [sym_thisthread] = STATE(1010),
    [sym_class] = STATE(1010),
    [sym__expression] = STATE(1010),
    [sym_return] = STATE(1010),
    [sym_gather] = STATE(1010),
    [sym_scatter] = STATE(1010),
    [sym_allresults] = STATE(1010),
    [sym_parenthesized_expression] = STATE(1010),
    [sym__variable] = STATE(1010),
    [sym_variable] = STATE(1010),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1010),
    [sym_relational_operator] = STATE(1010),
    [sym_logical_operator] = STATE(1010),
    [sym_arithmetic_operator] = STATE(1010),
    [sym_unary_operator] = STATE(1010),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1533),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1533),
    [sym_global_variable] = ACTIONS(1533),
    [sym_global_reference] = ACTIONS(1533),
    [sym_number] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1533),
    [sym_comment] = ACTIONS(103),
  },
  [353] = {
    [sym_procedure] = STATE(1020),
    [sym_block] = STATE(1020),
    [sym_assignment] = STATE(1020),
    [sym_if] = STATE(1020),
    [sym_loop] = STATE(1020),
    [sym_handling] = STATE(1020),
    [sym_catch] = STATE(1020),
    [sym_throw] = STATE(1020),
    [sym_primitive] = STATE(1020),
    [sym_iterator] = STATE(1020),
    [sym_while] = STATE(1020),
    [sym_try] = STATE(1020),
    [sym_loopbody] = STATE(1020),
    [sym_leave] = STATE(1020),
    [sym_continue] = STATE(1020),
    [sym_protect] = STATE(1020),
    [sym_lock] = STATE(1020),
    [sym__literal] = STATE(1020),
    [sym_character_literal] = STATE(1020),
    [sym_string_literal] = STATE(1020),
    [sym_call] = STATE(1020),
    [sym_invoke] = STATE(1020),
    [sym_indexed_access] = STATE(1020),
    [sym_slot_accessor] = STATE(1020),
    [sym_true] = STATE(1020),
    [sym_false] = STATE(1020),
    [sym_maybe] = STATE(1020),
    [sym_unset] = STATE(1020),
    [sym_super] = STATE(1020),
    [sym_self] = STATE(1020),
    [sym_clone] = STATE(1020),
    [sym_thisthread] = STATE(1020),
    [sym_class] = STATE(1020),
    [sym__expression] = STATE(1020),
    [sym_return] = STATE(1020),
    [sym_gather] = STATE(1020),
    [sym_scatter] = STATE(1020),
    [sym_allresults] = STATE(1020),
    [sym_parenthesized_expression] = STATE(1020),
    [sym__variable] = STATE(1020),
    [sym_variable] = STATE(1020),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1020),
    [sym_relational_operator] = STATE(1020),
    [sym_logical_operator] = STATE(1020),
    [sym_arithmetic_operator] = STATE(1020),
    [sym_unary_operator] = STATE(1020),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1535),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1535),
    [sym_global_variable] = ACTIONS(1535),
    [sym_global_reference] = ACTIONS(1535),
    [sym_number] = ACTIONS(1535),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1535),
    [sym_comment] = ACTIONS(103),
  },
  [354] = {
    [sym_procedure] = STATE(673),
    [sym_block] = STATE(673),
    [sym_assignment] = STATE(673),
    [sym_if] = STATE(673),
    [sym_loop] = STATE(673),
    [sym_handling] = STATE(673),
    [sym_catch] = STATE(673),
    [sym_throw] = STATE(673),
    [sym_primitive] = STATE(673),
    [sym_iterator] = STATE(673),
    [sym_while] = STATE(673),
    [sym_try] = STATE(673),
    [sym_loopbody] = STATE(673),
    [sym_leave] = STATE(673),
    [sym_continue] = STATE(673),
    [sym_protect] = STATE(673),
    [sym_lock] = STATE(673),
    [sym__literal] = STATE(673),
    [sym_character_literal] = STATE(673),
    [sym_string_literal] = STATE(673),
    [sym_call] = STATE(673),
    [sym_invoke] = STATE(673),
    [sym_indexed_access] = STATE(673),
    [sym_slot_accessor] = STATE(673),
    [sym_true] = STATE(673),
    [sym_false] = STATE(673),
    [sym_maybe] = STATE(673),
    [sym_unset] = STATE(673),
    [sym_super] = STATE(673),
    [sym_self] = STATE(673),
    [sym_clone] = STATE(673),
    [sym_thisthread] = STATE(673),
    [sym_class] = STATE(673),
    [sym__expression] = STATE(673),
    [sym_return] = STATE(673),
    [sym_gather] = STATE(673),
    [sym_scatter] = STATE(673),
    [sym_allresults] = STATE(673),
    [sym_parenthesized_expression] = STATE(673),
    [sym__variable] = STATE(673),
    [sym_variable] = STATE(673),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(673),
    [sym_relational_operator] = STATE(673),
    [sym_logical_operator] = STATE(673),
    [sym_arithmetic_operator] = STATE(673),
    [sym_unary_operator] = STATE(673),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1537),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1537),
    [sym_global_variable] = ACTIONS(1537),
    [sym_global_reference] = ACTIONS(1537),
    [sym_number] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1537),
    [sym_comment] = ACTIONS(103),
  },
  [355] = {
    [sym_procedure] = STATE(774),
    [sym_block] = STATE(774),
    [sym_assignment] = STATE(774),
    [sym_if] = STATE(774),
    [sym_loop] = STATE(774),
    [sym_handling] = STATE(774),
    [sym_catch] = STATE(774),
    [sym_throw] = STATE(774),
    [sym_primitive] = STATE(774),
    [sym_iterator] = STATE(774),
    [sym_while] = STATE(774),
    [sym_try] = STATE(774),
    [sym_loopbody] = STATE(774),
    [sym_leave] = STATE(774),
    [sym_continue] = STATE(774),
    [sym_protect] = STATE(774),
    [sym_lock] = STATE(774),
    [sym__literal] = STATE(774),
    [sym_character_literal] = STATE(774),
    [sym_string_literal] = STATE(774),
    [sym_call] = STATE(774),
    [sym_invoke] = STATE(774),
    [sym_indexed_access] = STATE(774),
    [sym_slot_accessor] = STATE(774),
    [sym_true] = STATE(774),
    [sym_false] = STATE(774),
    [sym_maybe] = STATE(774),
    [sym_unset] = STATE(774),
    [sym_super] = STATE(774),
    [sym_self] = STATE(774),
    [sym_clone] = STATE(774),
    [sym_thisthread] = STATE(774),
    [sym_class] = STATE(774),
    [sym__expression] = STATE(774),
    [sym_return] = STATE(774),
    [sym_gather] = STATE(774),
    [sym_scatter] = STATE(774),
    [sym_allresults] = STATE(774),
    [sym_parenthesized_expression] = STATE(774),
    [sym__variable] = STATE(774),
    [sym_variable] = STATE(774),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(774),
    [sym_relational_operator] = STATE(774),
    [sym_logical_operator] = STATE(774),
    [sym_arithmetic_operator] = STATE(774),
    [sym_unary_operator] = STATE(774),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1539),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1539),
    [sym_global_variable] = ACTIONS(1539),
    [sym_global_reference] = ACTIONS(1539),
    [sym_number] = ACTIONS(1539),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1539),
    [sym_comment] = ACTIONS(103),
  },
  [356] = {
    [sym_procedure] = STATE(984),
    [sym_block] = STATE(984),
    [sym_assignment] = STATE(984),
    [sym_if] = STATE(984),
    [sym_loop] = STATE(984),
    [sym_handling] = STATE(984),
    [sym_catch] = STATE(984),
    [sym_throw] = STATE(984),
    [sym_primitive] = STATE(984),
    [sym_iterator] = STATE(984),
    [sym_while] = STATE(984),
    [sym_try] = STATE(984),
    [sym_loopbody] = STATE(984),
    [sym_leave] = STATE(984),
    [sym_continue] = STATE(984),
    [sym_protect] = STATE(984),
    [sym_lock] = STATE(984),
    [sym__literal] = STATE(984),
    [sym_character_literal] = STATE(984),
    [sym_string_literal] = STATE(984),
    [sym_call] = STATE(984),
    [sym_invoke] = STATE(984),
    [sym_indexed_access] = STATE(984),
    [sym_slot_accessor] = STATE(984),
    [sym_true] = STATE(984),
    [sym_false] = STATE(984),
    [sym_maybe] = STATE(984),
    [sym_unset] = STATE(984),
    [sym_super] = STATE(984),
    [sym_self] = STATE(984),
    [sym_clone] = STATE(984),
    [sym_thisthread] = STATE(984),
    [sym_class] = STATE(984),
    [sym__expression] = STATE(984),
    [sym_return] = STATE(984),
    [sym_gather] = STATE(984),
    [sym_scatter] = STATE(984),
    [sym_allresults] = STATE(984),
    [sym_parenthesized_expression] = STATE(984),
    [sym__variable] = STATE(984),
    [sym_variable] = STATE(984),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(984),
    [sym_relational_operator] = STATE(984),
    [sym_logical_operator] = STATE(984),
    [sym_arithmetic_operator] = STATE(984),
    [sym_unary_operator] = STATE(984),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1541),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1541),
    [sym_global_variable] = ACTIONS(1541),
    [sym_global_reference] = ACTIONS(1541),
    [sym_number] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1541),
    [sym_comment] = ACTIONS(103),
  },
  [357] = {
    [sym_procedure] = STATE(659),
    [sym_block] = STATE(659),
    [sym_assignment] = STATE(659),
    [sym_if] = STATE(659),
    [sym_loop] = STATE(659),
    [sym_handling] = STATE(659),
    [sym_catch] = STATE(659),
    [sym_throw] = STATE(659),
    [sym_primitive] = STATE(659),
    [sym_iterator] = STATE(659),
    [sym_while] = STATE(659),
    [sym_try] = STATE(659),
    [sym_loopbody] = STATE(659),
    [sym_leave] = STATE(659),
    [sym_continue] = STATE(659),
    [sym_protect] = STATE(659),
    [sym_lock] = STATE(659),
    [sym__literal] = STATE(659),
    [sym_character_literal] = STATE(659),
    [sym_string_literal] = STATE(659),
    [sym_call] = STATE(659),
    [sym_invoke] = STATE(659),
    [sym_indexed_access] = STATE(659),
    [sym_slot_accessor] = STATE(659),
    [sym_true] = STATE(659),
    [sym_false] = STATE(659),
    [sym_maybe] = STATE(659),
    [sym_unset] = STATE(659),
    [sym_super] = STATE(659),
    [sym_self] = STATE(659),
    [sym_clone] = STATE(659),
    [sym_thisthread] = STATE(659),
    [sym_class] = STATE(659),
    [sym__expression] = STATE(659),
    [sym_return] = STATE(659),
    [sym_gather] = STATE(659),
    [sym_scatter] = STATE(659),
    [sym_allresults] = STATE(659),
    [sym_parenthesized_expression] = STATE(659),
    [sym__variable] = STATE(659),
    [sym_variable] = STATE(659),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(659),
    [sym_relational_operator] = STATE(659),
    [sym_logical_operator] = STATE(659),
    [sym_arithmetic_operator] = STATE(659),
    [sym_unary_operator] = STATE(659),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1543),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1543),
    [sym_global_variable] = ACTIONS(1543),
    [sym_global_reference] = ACTIONS(1543),
    [sym_number] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1543),
    [sym_comment] = ACTIONS(103),
  },
  [358] = {
    [sym_procedure] = STATE(773),
    [sym_block] = STATE(773),
    [sym_assignment] = STATE(773),
    [sym_if] = STATE(773),
    [sym_loop] = STATE(773),
    [sym_handling] = STATE(773),
    [sym_catch] = STATE(773),
    [sym_throw] = STATE(773),
    [sym_primitive] = STATE(773),
    [sym_iterator] = STATE(773),
    [sym_while] = STATE(773),
    [sym_try] = STATE(773),
    [sym_loopbody] = STATE(773),
    [sym_leave] = STATE(773),
    [sym_continue] = STATE(773),
    [sym_protect] = STATE(773),
    [sym_lock] = STATE(773),
    [sym__literal] = STATE(773),
    [sym_character_literal] = STATE(773),
    [sym_string_literal] = STATE(773),
    [sym_call] = STATE(773),
    [sym_invoke] = STATE(773),
    [sym_indexed_access] = STATE(773),
    [sym_slot_accessor] = STATE(773),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_maybe] = STATE(773),
    [sym_unset] = STATE(773),
    [sym_super] = STATE(773),
    [sym_self] = STATE(773),
    [sym_clone] = STATE(773),
    [sym_thisthread] = STATE(773),
    [sym_class] = STATE(773),
    [sym__expression] = STATE(773),
    [sym_return] = STATE(773),
    [sym_gather] = STATE(773),
    [sym_scatter] = STATE(773),
    [sym_allresults] = STATE(773),
    [sym_parenthesized_expression] = STATE(773),
    [sym__variable] = STATE(773),
    [sym_variable] = STATE(773),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(773),
    [sym_relational_operator] = STATE(773),
    [sym_logical_operator] = STATE(773),
    [sym_arithmetic_operator] = STATE(773),
    [sym_unary_operator] = STATE(773),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1545),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1545),
    [sym_global_variable] = ACTIONS(1545),
    [sym_global_reference] = ACTIONS(1545),
    [sym_number] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1545),
    [sym_comment] = ACTIONS(103),
  },
  [359] = {
    [sym_procedure] = STATE(771),
    [sym_block] = STATE(771),
    [sym_assignment] = STATE(771),
    [sym_if] = STATE(771),
    [sym_loop] = STATE(771),
    [sym_handling] = STATE(771),
    [sym_catch] = STATE(771),
    [sym_throw] = STATE(771),
    [sym_primitive] = STATE(771),
    [sym_iterator] = STATE(771),
    [sym_while] = STATE(771),
    [sym_try] = STATE(771),
    [sym_loopbody] = STATE(771),
    [sym_leave] = STATE(771),
    [sym_continue] = STATE(771),
    [sym_protect] = STATE(771),
    [sym_lock] = STATE(771),
    [sym__literal] = STATE(771),
    [sym_character_literal] = STATE(771),
    [sym_string_literal] = STATE(771),
    [sym_call] = STATE(771),
    [sym_invoke] = STATE(771),
    [sym_indexed_access] = STATE(771),
    [sym_slot_accessor] = STATE(771),
    [sym_true] = STATE(771),
    [sym_false] = STATE(771),
    [sym_maybe] = STATE(771),
    [sym_unset] = STATE(771),
    [sym_super] = STATE(771),
    [sym_self] = STATE(771),
    [sym_clone] = STATE(771),
    [sym_thisthread] = STATE(771),
    [sym_class] = STATE(771),
    [sym__expression] = STATE(771),
    [sym_return] = STATE(771),
    [sym_gather] = STATE(771),
    [sym_scatter] = STATE(771),
    [sym_allresults] = STATE(771),
    [sym_parenthesized_expression] = STATE(771),
    [sym__variable] = STATE(771),
    [sym_variable] = STATE(771),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(771),
    [sym_relational_operator] = STATE(771),
    [sym_logical_operator] = STATE(771),
    [sym_arithmetic_operator] = STATE(771),
    [sym_unary_operator] = STATE(771),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1547),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1547),
    [sym_global_variable] = ACTIONS(1547),
    [sym_global_reference] = ACTIONS(1547),
    [sym_number] = ACTIONS(1547),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1547),
    [sym_comment] = ACTIONS(103),
  },
  [360] = {
    [sym_procedure] = STATE(663),
    [sym_block] = STATE(663),
    [sym_assignment] = STATE(663),
    [sym_if] = STATE(663),
    [sym_loop] = STATE(663),
    [sym_handling] = STATE(663),
    [sym_catch] = STATE(663),
    [sym_throw] = STATE(663),
    [sym_primitive] = STATE(663),
    [sym_iterator] = STATE(663),
    [sym_while] = STATE(663),
    [sym_try] = STATE(663),
    [sym_loopbody] = STATE(663),
    [sym_leave] = STATE(663),
    [sym_continue] = STATE(663),
    [sym_protect] = STATE(663),
    [sym_lock] = STATE(663),
    [sym__literal] = STATE(663),
    [sym_character_literal] = STATE(663),
    [sym_string_literal] = STATE(663),
    [sym_call] = STATE(663),
    [sym_invoke] = STATE(663),
    [sym_indexed_access] = STATE(663),
    [sym_slot_accessor] = STATE(663),
    [sym_true] = STATE(663),
    [sym_false] = STATE(663),
    [sym_maybe] = STATE(663),
    [sym_unset] = STATE(663),
    [sym_super] = STATE(663),
    [sym_self] = STATE(663),
    [sym_clone] = STATE(663),
    [sym_thisthread] = STATE(663),
    [sym_class] = STATE(663),
    [sym__expression] = STATE(663),
    [sym_return] = STATE(663),
    [sym_gather] = STATE(663),
    [sym_scatter] = STATE(663),
    [sym_allresults] = STATE(663),
    [sym_parenthesized_expression] = STATE(663),
    [sym__variable] = STATE(663),
    [sym_variable] = STATE(663),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(663),
    [sym_relational_operator] = STATE(663),
    [sym_logical_operator] = STATE(663),
    [sym_arithmetic_operator] = STATE(663),
    [sym_unary_operator] = STATE(663),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1549),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1549),
    [sym_global_variable] = ACTIONS(1549),
    [sym_global_reference] = ACTIONS(1549),
    [sym_number] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1549),
    [sym_comment] = ACTIONS(103),
  },
  [361] = {
    [sym_procedure] = STATE(836),
    [sym_block] = STATE(836),
    [sym_assignment] = STATE(836),
    [sym_if] = STATE(836),
    [sym_loop] = STATE(836),
    [sym_handling] = STATE(836),
    [sym_catch] = STATE(836),
    [sym_throw] = STATE(836),
    [sym_primitive] = STATE(836),
    [sym_iterator] = STATE(836),
    [sym_while] = STATE(836),
    [sym_try] = STATE(836),
    [sym_loopbody] = STATE(836),
    [sym_leave] = STATE(836),
    [sym_continue] = STATE(836),
    [sym_protect] = STATE(836),
    [sym_lock] = STATE(836),
    [sym__literal] = STATE(836),
    [sym_character_literal] = STATE(836),
    [sym_string_literal] = STATE(836),
    [sym_call] = STATE(836),
    [sym_invoke] = STATE(836),
    [sym_indexed_access] = STATE(836),
    [sym_slot_accessor] = STATE(836),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_maybe] = STATE(836),
    [sym_unset] = STATE(836),
    [sym_super] = STATE(836),
    [sym_self] = STATE(836),
    [sym_clone] = STATE(836),
    [sym_thisthread] = STATE(836),
    [sym_class] = STATE(836),
    [sym__expression] = STATE(836),
    [sym_return] = STATE(836),
    [sym_gather] = STATE(836),
    [sym_scatter] = STATE(836),
    [sym_allresults] = STATE(836),
    [sym_parenthesized_expression] = STATE(836),
    [sym__variable] = STATE(836),
    [sym_variable] = STATE(836),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(836),
    [sym_relational_operator] = STATE(836),
    [sym_logical_operator] = STATE(836),
    [sym_arithmetic_operator] = STATE(836),
    [sym_unary_operator] = STATE(836),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1551),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1551),
    [sym_global_variable] = ACTIONS(1551),
    [sym_global_reference] = ACTIONS(1551),
    [sym_number] = ACTIONS(1551),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1551),
    [sym_comment] = ACTIONS(103),
  },
  [362] = {
    [sym_procedure] = STATE(1016),
    [sym_block] = STATE(1016),
    [sym_assignment] = STATE(1016),
    [sym_if] = STATE(1016),
    [sym_loop] = STATE(1016),
    [sym_handling] = STATE(1016),
    [sym_catch] = STATE(1016),
    [sym_throw] = STATE(1016),
    [sym_primitive] = STATE(1016),
    [sym_iterator] = STATE(1016),
    [sym_while] = STATE(1016),
    [sym_try] = STATE(1016),
    [sym_loopbody] = STATE(1016),
    [sym_leave] = STATE(1016),
    [sym_continue] = STATE(1016),
    [sym_protect] = STATE(1016),
    [sym_lock] = STATE(1016),
    [sym__literal] = STATE(1016),
    [sym_character_literal] = STATE(1016),
    [sym_string_literal] = STATE(1016),
    [sym_call] = STATE(1016),
    [sym_invoke] = STATE(1016),
    [sym_indexed_access] = STATE(1016),
    [sym_slot_accessor] = STATE(1016),
    [sym_true] = STATE(1016),
    [sym_false] = STATE(1016),
    [sym_maybe] = STATE(1016),
    [sym_unset] = STATE(1016),
    [sym_super] = STATE(1016),
    [sym_self] = STATE(1016),
    [sym_clone] = STATE(1016),
    [sym_thisthread] = STATE(1016),
    [sym_class] = STATE(1016),
    [sym__expression] = STATE(1016),
    [sym_return] = STATE(1016),
    [sym_gather] = STATE(1016),
    [sym_scatter] = STATE(1016),
    [sym_allresults] = STATE(1016),
    [sym_parenthesized_expression] = STATE(1016),
    [sym__variable] = STATE(1016),
    [sym_variable] = STATE(1016),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1016),
    [sym_relational_operator] = STATE(1016),
    [sym_logical_operator] = STATE(1016),
    [sym_arithmetic_operator] = STATE(1016),
    [sym_unary_operator] = STATE(1016),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1553),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1553),
    [sym_global_variable] = ACTIONS(1553),
    [sym_global_reference] = ACTIONS(1553),
    [sym_number] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1553),
    [sym_comment] = ACTIONS(103),
  },
  [363] = {
    [sym_procedure] = STATE(601),
    [sym_block] = STATE(601),
    [sym_assignment] = STATE(601),
    [sym_if] = STATE(601),
    [sym_loop] = STATE(601),
    [sym_handling] = STATE(601),
    [sym_catch] = STATE(601),
    [sym_throw] = STATE(601),
    [sym_primitive] = STATE(601),
    [sym_iterator] = STATE(601),
    [sym_while] = STATE(601),
    [sym_try] = STATE(601),
    [sym_loopbody] = STATE(601),
    [sym_leave] = STATE(601),
    [sym_continue] = STATE(601),
    [sym_protect] = STATE(601),
    [sym_lock] = STATE(601),
    [sym__literal] = STATE(601),
    [sym_character_literal] = STATE(601),
    [sym_string_literal] = STATE(601),
    [sym_call] = STATE(601),
    [sym_invoke] = STATE(601),
    [sym_indexed_access] = STATE(601),
    [sym_slot_accessor] = STATE(601),
    [sym_true] = STATE(601),
    [sym_false] = STATE(601),
    [sym_maybe] = STATE(601),
    [sym_unset] = STATE(601),
    [sym_super] = STATE(601),
    [sym_self] = STATE(601),
    [sym_clone] = STATE(601),
    [sym_thisthread] = STATE(601),
    [sym_class] = STATE(601),
    [sym__expression] = STATE(601),
    [sym_return] = STATE(601),
    [sym_gather] = STATE(601),
    [sym_scatter] = STATE(601),
    [sym_allresults] = STATE(601),
    [sym_parenthesized_expression] = STATE(601),
    [sym__variable] = STATE(601),
    [sym_variable] = STATE(601),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(601),
    [sym_relational_operator] = STATE(601),
    [sym_logical_operator] = STATE(601),
    [sym_arithmetic_operator] = STATE(601),
    [sym_unary_operator] = STATE(601),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1555),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1555),
    [sym_global_variable] = ACTIONS(1555),
    [sym_global_reference] = ACTIONS(1555),
    [sym_number] = ACTIONS(1555),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1555),
    [sym_comment] = ACTIONS(103),
  },
  [364] = {
    [sym_procedure] = STATE(652),
    [sym_block] = STATE(652),
    [sym_assignment] = STATE(652),
    [sym_if] = STATE(652),
    [sym_loop] = STATE(652),
    [sym_handling] = STATE(652),
    [sym_catch] = STATE(652),
    [sym_throw] = STATE(652),
    [sym_primitive] = STATE(652),
    [sym_iterator] = STATE(652),
    [sym_while] = STATE(652),
    [sym_try] = STATE(652),
    [sym_loopbody] = STATE(652),
    [sym_leave] = STATE(652),
    [sym_continue] = STATE(652),
    [sym_protect] = STATE(652),
    [sym_lock] = STATE(652),
    [sym__literal] = STATE(652),
    [sym_character_literal] = STATE(652),
    [sym_string_literal] = STATE(652),
    [sym_call] = STATE(652),
    [sym_invoke] = STATE(652),
    [sym_indexed_access] = STATE(652),
    [sym_slot_accessor] = STATE(652),
    [sym_true] = STATE(652),
    [sym_false] = STATE(652),
    [sym_maybe] = STATE(652),
    [sym_unset] = STATE(652),
    [sym_super] = STATE(652),
    [sym_self] = STATE(652),
    [sym_clone] = STATE(652),
    [sym_thisthread] = STATE(652),
    [sym_class] = STATE(652),
    [sym__expression] = STATE(652),
    [sym_return] = STATE(652),
    [sym_gather] = STATE(652),
    [sym_scatter] = STATE(652),
    [sym_allresults] = STATE(652),
    [sym_parenthesized_expression] = STATE(652),
    [sym__variable] = STATE(652),
    [sym_variable] = STATE(652),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(652),
    [sym_relational_operator] = STATE(652),
    [sym_logical_operator] = STATE(652),
    [sym_arithmetic_operator] = STATE(652),
    [sym_unary_operator] = STATE(652),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1557),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1557),
    [sym_global_variable] = ACTIONS(1557),
    [sym_global_reference] = ACTIONS(1557),
    [sym_number] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1557),
    [sym_comment] = ACTIONS(103),
  },
  [365] = {
    [sym_procedure] = STATE(884),
    [sym_block] = STATE(884),
    [sym_assignment] = STATE(884),
    [sym_if] = STATE(884),
    [sym_loop] = STATE(884),
    [sym_handling] = STATE(884),
    [sym_catch] = STATE(884),
    [sym_throw] = STATE(884),
    [sym_primitive] = STATE(884),
    [sym_iterator] = STATE(884),
    [sym_while] = STATE(884),
    [sym_try] = STATE(884),
    [sym_loopbody] = STATE(884),
    [sym_leave] = STATE(884),
    [sym_continue] = STATE(884),
    [sym_protect] = STATE(884),
    [sym_lock] = STATE(884),
    [sym__literal] = STATE(884),
    [sym_character_literal] = STATE(884),
    [sym_string_literal] = STATE(884),
    [sym_call] = STATE(884),
    [sym_invoke] = STATE(884),
    [sym_indexed_access] = STATE(884),
    [sym_slot_accessor] = STATE(884),
    [sym_true] = STATE(884),
    [sym_false] = STATE(884),
    [sym_maybe] = STATE(884),
    [sym_unset] = STATE(884),
    [sym_super] = STATE(884),
    [sym_self] = STATE(884),
    [sym_clone] = STATE(884),
    [sym_thisthread] = STATE(884),
    [sym_class] = STATE(884),
    [sym__expression] = STATE(884),
    [sym_return] = STATE(884),
    [sym_gather] = STATE(884),
    [sym_scatter] = STATE(884),
    [sym_allresults] = STATE(884),
    [sym_parenthesized_expression] = STATE(884),
    [sym__variable] = STATE(884),
    [sym_variable] = STATE(884),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(884),
    [sym_relational_operator] = STATE(884),
    [sym_logical_operator] = STATE(884),
    [sym_arithmetic_operator] = STATE(884),
    [sym_unary_operator] = STATE(884),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1559),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1559),
    [sym_global_variable] = ACTIONS(1559),
    [sym_global_reference] = ACTIONS(1559),
    [sym_number] = ACTIONS(1559),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1559),
    [sym_comment] = ACTIONS(103),
  },
  [366] = {
    [sym_procedure] = STATE(801),
    [sym_block] = STATE(801),
    [sym_assignment] = STATE(801),
    [sym_if] = STATE(801),
    [sym_loop] = STATE(801),
    [sym_handling] = STATE(801),
    [sym_catch] = STATE(801),
    [sym_throw] = STATE(801),
    [sym_primitive] = STATE(801),
    [sym_iterator] = STATE(801),
    [sym_while] = STATE(801),
    [sym_try] = STATE(801),
    [sym_loopbody] = STATE(801),
    [sym_leave] = STATE(801),
    [sym_continue] = STATE(801),
    [sym_protect] = STATE(801),
    [sym_lock] = STATE(801),
    [sym__literal] = STATE(801),
    [sym_character_literal] = STATE(801),
    [sym_string_literal] = STATE(801),
    [sym_call] = STATE(801),
    [sym_invoke] = STATE(801),
    [sym_indexed_access] = STATE(801),
    [sym_slot_accessor] = STATE(801),
    [sym_true] = STATE(801),
    [sym_false] = STATE(801),
    [sym_maybe] = STATE(801),
    [sym_unset] = STATE(801),
    [sym_super] = STATE(801),
    [sym_self] = STATE(801),
    [sym_clone] = STATE(801),
    [sym_thisthread] = STATE(801),
    [sym_class] = STATE(801),
    [sym__expression] = STATE(801),
    [sym_return] = STATE(801),
    [sym_gather] = STATE(801),
    [sym_scatter] = STATE(801),
    [sym_allresults] = STATE(801),
    [sym_parenthesized_expression] = STATE(801),
    [sym__variable] = STATE(801),
    [sym_variable] = STATE(801),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(801),
    [sym_relational_operator] = STATE(801),
    [sym_logical_operator] = STATE(801),
    [sym_arithmetic_operator] = STATE(801),
    [sym_unary_operator] = STATE(801),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1561),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1561),
    [sym_global_variable] = ACTIONS(1561),
    [sym_global_reference] = ACTIONS(1561),
    [sym_number] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1561),
    [sym_comment] = ACTIONS(103),
  },
  [367] = {
    [sym_procedure] = STATE(1004),
    [sym_block] = STATE(1004),
    [sym_assignment] = STATE(1004),
    [sym_if] = STATE(1004),
    [sym_loop] = STATE(1004),
    [sym_handling] = STATE(1004),
    [sym_catch] = STATE(1004),
    [sym_throw] = STATE(1004),
    [sym_primitive] = STATE(1004),
    [sym_iterator] = STATE(1004),
    [sym_while] = STATE(1004),
    [sym_try] = STATE(1004),
    [sym_loopbody] = STATE(1004),
    [sym_leave] = STATE(1004),
    [sym_continue] = STATE(1004),
    [sym_protect] = STATE(1004),
    [sym_lock] = STATE(1004),
    [sym__literal] = STATE(1004),
    [sym_character_literal] = STATE(1004),
    [sym_string_literal] = STATE(1004),
    [sym_call] = STATE(1004),
    [sym_invoke] = STATE(1004),
    [sym_indexed_access] = STATE(1004),
    [sym_slot_accessor] = STATE(1004),
    [sym_true] = STATE(1004),
    [sym_false] = STATE(1004),
    [sym_maybe] = STATE(1004),
    [sym_unset] = STATE(1004),
    [sym_super] = STATE(1004),
    [sym_self] = STATE(1004),
    [sym_clone] = STATE(1004),
    [sym_thisthread] = STATE(1004),
    [sym_class] = STATE(1004),
    [sym__expression] = STATE(1004),
    [sym_return] = STATE(1004),
    [sym_gather] = STATE(1004),
    [sym_scatter] = STATE(1004),
    [sym_allresults] = STATE(1004),
    [sym_parenthesized_expression] = STATE(1004),
    [sym__variable] = STATE(1004),
    [sym_variable] = STATE(1004),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1004),
    [sym_relational_operator] = STATE(1004),
    [sym_logical_operator] = STATE(1004),
    [sym_arithmetic_operator] = STATE(1004),
    [sym_unary_operator] = STATE(1004),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1563),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1563),
    [sym_global_variable] = ACTIONS(1563),
    [sym_global_reference] = ACTIONS(1563),
    [sym_number] = ACTIONS(1563),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1563),
    [sym_comment] = ACTIONS(103),
  },
  [368] = {
    [sym_procedure] = STATE(655),
    [sym_block] = STATE(655),
    [sym_assignment] = STATE(655),
    [sym_if] = STATE(655),
    [sym_loop] = STATE(655),
    [sym_handling] = STATE(655),
    [sym_catch] = STATE(655),
    [sym_throw] = STATE(655),
    [sym_primitive] = STATE(655),
    [sym_iterator] = STATE(655),
    [sym_while] = STATE(655),
    [sym_try] = STATE(655),
    [sym_loopbody] = STATE(655),
    [sym_leave] = STATE(655),
    [sym_continue] = STATE(655),
    [sym_protect] = STATE(655),
    [sym_lock] = STATE(655),
    [sym__literal] = STATE(655),
    [sym_character_literal] = STATE(655),
    [sym_string_literal] = STATE(655),
    [sym_call] = STATE(655),
    [sym_invoke] = STATE(655),
    [sym_indexed_access] = STATE(655),
    [sym_slot_accessor] = STATE(655),
    [sym_true] = STATE(655),
    [sym_false] = STATE(655),
    [sym_maybe] = STATE(655),
    [sym_unset] = STATE(655),
    [sym_super] = STATE(655),
    [sym_self] = STATE(655),
    [sym_clone] = STATE(655),
    [sym_thisthread] = STATE(655),
    [sym_class] = STATE(655),
    [sym__expression] = STATE(655),
    [sym_return] = STATE(655),
    [sym_gather] = STATE(655),
    [sym_scatter] = STATE(655),
    [sym_allresults] = STATE(655),
    [sym_parenthesized_expression] = STATE(655),
    [sym__variable] = STATE(655),
    [sym_variable] = STATE(655),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(655),
    [sym_relational_operator] = STATE(655),
    [sym_logical_operator] = STATE(655),
    [sym_arithmetic_operator] = STATE(655),
    [sym_unary_operator] = STATE(655),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1565),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1565),
    [sym_global_variable] = ACTIONS(1565),
    [sym_global_reference] = ACTIONS(1565),
    [sym_number] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1565),
    [sym_comment] = ACTIONS(103),
  },
  [369] = {
    [sym_procedure] = STATE(668),
    [sym_block] = STATE(668),
    [sym_assignment] = STATE(668),
    [sym_if] = STATE(668),
    [sym_loop] = STATE(668),
    [sym_handling] = STATE(668),
    [sym_catch] = STATE(668),
    [sym_throw] = STATE(668),
    [sym_primitive] = STATE(668),
    [sym_iterator] = STATE(668),
    [sym_while] = STATE(668),
    [sym_try] = STATE(668),
    [sym_loopbody] = STATE(668),
    [sym_leave] = STATE(668),
    [sym_continue] = STATE(668),
    [sym_protect] = STATE(668),
    [sym_lock] = STATE(668),
    [sym__literal] = STATE(668),
    [sym_character_literal] = STATE(668),
    [sym_string_literal] = STATE(668),
    [sym_call] = STATE(668),
    [sym_invoke] = STATE(668),
    [sym_indexed_access] = STATE(668),
    [sym_slot_accessor] = STATE(668),
    [sym_true] = STATE(668),
    [sym_false] = STATE(668),
    [sym_maybe] = STATE(668),
    [sym_unset] = STATE(668),
    [sym_super] = STATE(668),
    [sym_self] = STATE(668),
    [sym_clone] = STATE(668),
    [sym_thisthread] = STATE(668),
    [sym_class] = STATE(668),
    [sym__expression] = STATE(668),
    [sym_return] = STATE(668),
    [sym_gather] = STATE(668),
    [sym_scatter] = STATE(668),
    [sym_allresults] = STATE(668),
    [sym_parenthesized_expression] = STATE(668),
    [sym__variable] = STATE(668),
    [sym_variable] = STATE(668),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(668),
    [sym_relational_operator] = STATE(668),
    [sym_logical_operator] = STATE(668),
    [sym_arithmetic_operator] = STATE(668),
    [sym_unary_operator] = STATE(668),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1567),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1567),
    [sym_global_variable] = ACTIONS(1567),
    [sym_global_reference] = ACTIONS(1567),
    [sym_number] = ACTIONS(1567),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1567),
    [sym_comment] = ACTIONS(103),
  },
  [370] = {
    [sym_procedure] = STATE(667),
    [sym_block] = STATE(667),
    [sym_assignment] = STATE(667),
    [sym_if] = STATE(667),
    [sym_loop] = STATE(667),
    [sym_handling] = STATE(667),
    [sym_catch] = STATE(667),
    [sym_throw] = STATE(667),
    [sym_primitive] = STATE(667),
    [sym_iterator] = STATE(667),
    [sym_while] = STATE(667),
    [sym_try] = STATE(667),
    [sym_loopbody] = STATE(667),
    [sym_leave] = STATE(667),
    [sym_continue] = STATE(667),
    [sym_protect] = STATE(667),
    [sym_lock] = STATE(667),
    [sym__literal] = STATE(667),
    [sym_character_literal] = STATE(667),
    [sym_string_literal] = STATE(667),
    [sym_call] = STATE(667),
    [sym_invoke] = STATE(667),
    [sym_indexed_access] = STATE(667),
    [sym_slot_accessor] = STATE(667),
    [sym_true] = STATE(667),
    [sym_false] = STATE(667),
    [sym_maybe] = STATE(667),
    [sym_unset] = STATE(667),
    [sym_super] = STATE(667),
    [sym_self] = STATE(667),
    [sym_clone] = STATE(667),
    [sym_thisthread] = STATE(667),
    [sym_class] = STATE(667),
    [sym__expression] = STATE(667),
    [sym_return] = STATE(667),
    [sym_gather] = STATE(667),
    [sym_scatter] = STATE(667),
    [sym_allresults] = STATE(667),
    [sym_parenthesized_expression] = STATE(667),
    [sym__variable] = STATE(667),
    [sym_variable] = STATE(667),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(667),
    [sym_relational_operator] = STATE(667),
    [sym_logical_operator] = STATE(667),
    [sym_arithmetic_operator] = STATE(667),
    [sym_unary_operator] = STATE(667),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1569),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1569),
    [sym_global_variable] = ACTIONS(1569),
    [sym_global_reference] = ACTIONS(1569),
    [sym_number] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1569),
    [sym_comment] = ACTIONS(103),
  },
  [371] = {
    [sym_procedure] = STATE(657),
    [sym_block] = STATE(657),
    [sym_assignment] = STATE(657),
    [sym_if] = STATE(657),
    [sym_loop] = STATE(657),
    [sym_handling] = STATE(657),
    [sym_catch] = STATE(657),
    [sym_throw] = STATE(657),
    [sym_primitive] = STATE(657),
    [sym_iterator] = STATE(657),
    [sym_while] = STATE(657),
    [sym_try] = STATE(657),
    [sym_loopbody] = STATE(657),
    [sym_leave] = STATE(657),
    [sym_continue] = STATE(657),
    [sym_protect] = STATE(657),
    [sym_lock] = STATE(657),
    [sym__literal] = STATE(657),
    [sym_character_literal] = STATE(657),
    [sym_string_literal] = STATE(657),
    [sym_call] = STATE(657),
    [sym_invoke] = STATE(657),
    [sym_indexed_access] = STATE(657),
    [sym_slot_accessor] = STATE(657),
    [sym_true] = STATE(657),
    [sym_false] = STATE(657),
    [sym_maybe] = STATE(657),
    [sym_unset] = STATE(657),
    [sym_super] = STATE(657),
    [sym_self] = STATE(657),
    [sym_clone] = STATE(657),
    [sym_thisthread] = STATE(657),
    [sym_class] = STATE(657),
    [sym__expression] = STATE(657),
    [sym_return] = STATE(657),
    [sym_gather] = STATE(657),
    [sym_scatter] = STATE(657),
    [sym_allresults] = STATE(657),
    [sym_parenthesized_expression] = STATE(657),
    [sym__variable] = STATE(657),
    [sym_variable] = STATE(657),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(657),
    [sym_relational_operator] = STATE(657),
    [sym_logical_operator] = STATE(657),
    [sym_arithmetic_operator] = STATE(657),
    [sym_unary_operator] = STATE(657),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1571),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1571),
    [sym_global_variable] = ACTIONS(1571),
    [sym_global_reference] = ACTIONS(1571),
    [sym_number] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1571),
    [sym_comment] = ACTIONS(103),
  },
  [372] = {
    [sym_procedure] = STATE(612),
    [sym_block] = STATE(612),
    [sym_assignment] = STATE(612),
    [sym_if] = STATE(612),
    [sym_loop] = STATE(612),
    [sym_handling] = STATE(612),
    [sym_catch] = STATE(612),
    [sym_throw] = STATE(612),
    [sym_primitive] = STATE(612),
    [sym_iterator] = STATE(612),
    [sym_while] = STATE(612),
    [sym_try] = STATE(612),
    [sym_loopbody] = STATE(612),
    [sym_leave] = STATE(612),
    [sym_continue] = STATE(612),
    [sym_protect] = STATE(612),
    [sym_lock] = STATE(612),
    [sym__literal] = STATE(612),
    [sym_character_literal] = STATE(612),
    [sym_string_literal] = STATE(612),
    [sym_call] = STATE(612),
    [sym_invoke] = STATE(612),
    [sym_indexed_access] = STATE(612),
    [sym_slot_accessor] = STATE(612),
    [sym_true] = STATE(612),
    [sym_false] = STATE(612),
    [sym_maybe] = STATE(612),
    [sym_unset] = STATE(612),
    [sym_super] = STATE(612),
    [sym_self] = STATE(612),
    [sym_clone] = STATE(612),
    [sym_thisthread] = STATE(612),
    [sym_class] = STATE(612),
    [sym__expression] = STATE(612),
    [sym_return] = STATE(612),
    [sym_gather] = STATE(612),
    [sym_scatter] = STATE(612),
    [sym_allresults] = STATE(612),
    [sym_parenthesized_expression] = STATE(612),
    [sym__variable] = STATE(612),
    [sym_variable] = STATE(612),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(612),
    [sym_relational_operator] = STATE(612),
    [sym_logical_operator] = STATE(612),
    [sym_arithmetic_operator] = STATE(612),
    [sym_unary_operator] = STATE(612),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1573),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1573),
    [sym_global_variable] = ACTIONS(1573),
    [sym_global_reference] = ACTIONS(1573),
    [sym_number] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1573),
    [sym_comment] = ACTIONS(103),
  },
  [373] = {
    [sym_procedure] = STATE(611),
    [sym_block] = STATE(611),
    [sym_assignment] = STATE(611),
    [sym_if] = STATE(611),
    [sym_loop] = STATE(611),
    [sym_handling] = STATE(611),
    [sym_catch] = STATE(611),
    [sym_throw] = STATE(611),
    [sym_primitive] = STATE(611),
    [sym_iterator] = STATE(611),
    [sym_while] = STATE(611),
    [sym_try] = STATE(611),
    [sym_loopbody] = STATE(611),
    [sym_leave] = STATE(611),
    [sym_continue] = STATE(611),
    [sym_protect] = STATE(611),
    [sym_lock] = STATE(611),
    [sym__literal] = STATE(611),
    [sym_character_literal] = STATE(611),
    [sym_string_literal] = STATE(611),
    [sym_call] = STATE(611),
    [sym_invoke] = STATE(611),
    [sym_indexed_access] = STATE(611),
    [sym_slot_accessor] = STATE(611),
    [sym_true] = STATE(611),
    [sym_false] = STATE(611),
    [sym_maybe] = STATE(611),
    [sym_unset] = STATE(611),
    [sym_super] = STATE(611),
    [sym_self] = STATE(611),
    [sym_clone] = STATE(611),
    [sym_thisthread] = STATE(611),
    [sym_class] = STATE(611),
    [sym__expression] = STATE(611),
    [sym_return] = STATE(611),
    [sym_gather] = STATE(611),
    [sym_scatter] = STATE(611),
    [sym_allresults] = STATE(611),
    [sym_parenthesized_expression] = STATE(611),
    [sym__variable] = STATE(611),
    [sym_variable] = STATE(611),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(611),
    [sym_relational_operator] = STATE(611),
    [sym_logical_operator] = STATE(611),
    [sym_arithmetic_operator] = STATE(611),
    [sym_unary_operator] = STATE(611),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1577),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1577),
    [sym_global_variable] = ACTIONS(1577),
    [sym_global_reference] = ACTIONS(1577),
    [sym_number] = ACTIONS(1577),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1577),
    [sym_comment] = ACTIONS(103),
  },
  [374] = {
    [sym_procedure] = STATE(916),
    [sym_block] = STATE(916),
    [sym_assignment] = STATE(916),
    [sym_if] = STATE(916),
    [sym_loop] = STATE(916),
    [sym_handling] = STATE(916),
    [sym_catch] = STATE(916),
    [sym_throw] = STATE(916),
    [sym_primitive] = STATE(916),
    [sym_iterator] = STATE(916),
    [sym_while] = STATE(916),
    [sym_try] = STATE(916),
    [sym_loopbody] = STATE(916),
    [sym_leave] = STATE(916),
    [sym_continue] = STATE(916),
    [sym_protect] = STATE(916),
    [sym_lock] = STATE(916),
    [sym__literal] = STATE(916),
    [sym_character_literal] = STATE(916),
    [sym_string_literal] = STATE(916),
    [sym_call] = STATE(916),
    [sym_invoke] = STATE(916),
    [sym_indexed_access] = STATE(916),
    [sym_slot_accessor] = STATE(916),
    [sym_true] = STATE(916),
    [sym_false] = STATE(916),
    [sym_maybe] = STATE(916),
    [sym_unset] = STATE(916),
    [sym_super] = STATE(916),
    [sym_self] = STATE(916),
    [sym_clone] = STATE(916),
    [sym_thisthread] = STATE(916),
    [sym_class] = STATE(916),
    [sym__expression] = STATE(916),
    [sym_return] = STATE(916),
    [sym_gather] = STATE(916),
    [sym_scatter] = STATE(916),
    [sym_allresults] = STATE(916),
    [sym_parenthesized_expression] = STATE(916),
    [sym__variable] = STATE(916),
    [sym_variable] = STATE(916),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(916),
    [sym_relational_operator] = STATE(916),
    [sym_logical_operator] = STATE(916),
    [sym_arithmetic_operator] = STATE(916),
    [sym_unary_operator] = STATE(916),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1579),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1579),
    [sym_global_variable] = ACTIONS(1579),
    [sym_global_reference] = ACTIONS(1579),
    [sym_number] = ACTIONS(1579),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1579),
    [sym_comment] = ACTIONS(103),
  },
  [375] = {
    [sym_procedure] = STATE(1011),
    [sym_block] = STATE(1011),
    [sym_assignment] = STATE(1011),
    [sym_if] = STATE(1011),
    [sym_loop] = STATE(1011),
    [sym_handling] = STATE(1011),
    [sym_catch] = STATE(1011),
    [sym_throw] = STATE(1011),
    [sym_primitive] = STATE(1011),
    [sym_iterator] = STATE(1011),
    [sym_while] = STATE(1011),
    [sym_try] = STATE(1011),
    [sym_loopbody] = STATE(1011),
    [sym_leave] = STATE(1011),
    [sym_continue] = STATE(1011),
    [sym_protect] = STATE(1011),
    [sym_lock] = STATE(1011),
    [sym__literal] = STATE(1011),
    [sym_character_literal] = STATE(1011),
    [sym_string_literal] = STATE(1011),
    [sym_call] = STATE(1011),
    [sym_invoke] = STATE(1011),
    [sym_indexed_access] = STATE(1011),
    [sym_slot_accessor] = STATE(1011),
    [sym_true] = STATE(1011),
    [sym_false] = STATE(1011),
    [sym_maybe] = STATE(1011),
    [sym_unset] = STATE(1011),
    [sym_super] = STATE(1011),
    [sym_self] = STATE(1011),
    [sym_clone] = STATE(1011),
    [sym_thisthread] = STATE(1011),
    [sym_class] = STATE(1011),
    [sym__expression] = STATE(1011),
    [sym_return] = STATE(1011),
    [sym_gather] = STATE(1011),
    [sym_scatter] = STATE(1011),
    [sym_allresults] = STATE(1011),
    [sym_parenthesized_expression] = STATE(1011),
    [sym__variable] = STATE(1011),
    [sym_variable] = STATE(1011),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1011),
    [sym_relational_operator] = STATE(1011),
    [sym_logical_operator] = STATE(1011),
    [sym_arithmetic_operator] = STATE(1011),
    [sym_unary_operator] = STATE(1011),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1581),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1581),
    [sym_global_variable] = ACTIONS(1581),
    [sym_global_reference] = ACTIONS(1581),
    [sym_number] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1581),
    [sym_comment] = ACTIONS(103),
  },
  [376] = {
    [sym_procedure] = STATE(661),
    [sym_block] = STATE(661),
    [sym_assignment] = STATE(661),
    [sym_if] = STATE(661),
    [sym_loop] = STATE(661),
    [sym_handling] = STATE(661),
    [sym_catch] = STATE(661),
    [sym_throw] = STATE(661),
    [sym_primitive] = STATE(661),
    [sym_iterator] = STATE(661),
    [sym_while] = STATE(661),
    [sym_try] = STATE(661),
    [sym_loopbody] = STATE(661),
    [sym_leave] = STATE(661),
    [sym_continue] = STATE(661),
    [sym_protect] = STATE(661),
    [sym_lock] = STATE(661),
    [sym__literal] = STATE(661),
    [sym_character_literal] = STATE(661),
    [sym_string_literal] = STATE(661),
    [sym_call] = STATE(661),
    [sym_invoke] = STATE(661),
    [sym_indexed_access] = STATE(661),
    [sym_slot_accessor] = STATE(661),
    [sym_true] = STATE(661),
    [sym_false] = STATE(661),
    [sym_maybe] = STATE(661),
    [sym_unset] = STATE(661),
    [sym_super] = STATE(661),
    [sym_self] = STATE(661),
    [sym_clone] = STATE(661),
    [sym_thisthread] = STATE(661),
    [sym_class] = STATE(661),
    [sym__expression] = STATE(661),
    [sym_return] = STATE(661),
    [sym_gather] = STATE(661),
    [sym_scatter] = STATE(661),
    [sym_allresults] = STATE(661),
    [sym_parenthesized_expression] = STATE(661),
    [sym__variable] = STATE(661),
    [sym_variable] = STATE(661),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(661),
    [sym_relational_operator] = STATE(661),
    [sym_logical_operator] = STATE(661),
    [sym_arithmetic_operator] = STATE(661),
    [sym_unary_operator] = STATE(661),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1583),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1583),
    [sym_global_variable] = ACTIONS(1583),
    [sym_global_reference] = ACTIONS(1583),
    [sym_number] = ACTIONS(1583),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1583),
    [sym_comment] = ACTIONS(103),
  },
  [377] = {
    [sym_procedure] = STATE(950),
    [sym_block] = STATE(950),
    [sym_assignment] = STATE(950),
    [sym_if] = STATE(950),
    [sym_loop] = STATE(950),
    [sym_handling] = STATE(950),
    [sym_catch] = STATE(950),
    [sym_throw] = STATE(950),
    [sym_primitive] = STATE(950),
    [sym_iterator] = STATE(950),
    [sym_while] = STATE(950),
    [sym_try] = STATE(950),
    [sym_loopbody] = STATE(950),
    [sym_leave] = STATE(950),
    [sym_continue] = STATE(950),
    [sym_protect] = STATE(950),
    [sym_lock] = STATE(950),
    [sym__literal] = STATE(950),
    [sym_character_literal] = STATE(950),
    [sym_string_literal] = STATE(950),
    [sym_call] = STATE(950),
    [sym_invoke] = STATE(950),
    [sym_indexed_access] = STATE(950),
    [sym_slot_accessor] = STATE(950),
    [sym_true] = STATE(950),
    [sym_false] = STATE(950),
    [sym_maybe] = STATE(950),
    [sym_unset] = STATE(950),
    [sym_super] = STATE(950),
    [sym_self] = STATE(950),
    [sym_clone] = STATE(950),
    [sym_thisthread] = STATE(950),
    [sym_class] = STATE(950),
    [sym__expression] = STATE(950),
    [sym_return] = STATE(950),
    [sym_gather] = STATE(950),
    [sym_scatter] = STATE(950),
    [sym_allresults] = STATE(950),
    [sym_parenthesized_expression] = STATE(950),
    [sym__variable] = STATE(950),
    [sym_variable] = STATE(950),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(950),
    [sym_relational_operator] = STATE(950),
    [sym_logical_operator] = STATE(950),
    [sym_arithmetic_operator] = STATE(950),
    [sym_unary_operator] = STATE(950),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1585),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1585),
    [sym_global_variable] = ACTIONS(1585),
    [sym_global_reference] = ACTIONS(1585),
    [sym_number] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1585),
    [sym_comment] = ACTIONS(103),
  },
  [378] = {
    [sym_procedure] = STATE(1006),
    [sym_block] = STATE(1006),
    [sym_assignment] = STATE(1006),
    [sym_if] = STATE(1006),
    [sym_loop] = STATE(1006),
    [sym_handling] = STATE(1006),
    [sym_catch] = STATE(1006),
    [sym_throw] = STATE(1006),
    [sym_primitive] = STATE(1006),
    [sym_iterator] = STATE(1006),
    [sym_while] = STATE(1006),
    [sym_try] = STATE(1006),
    [sym_loopbody] = STATE(1006),
    [sym_leave] = STATE(1006),
    [sym_continue] = STATE(1006),
    [sym_protect] = STATE(1006),
    [sym_lock] = STATE(1006),
    [sym__literal] = STATE(1006),
    [sym_character_literal] = STATE(1006),
    [sym_string_literal] = STATE(1006),
    [sym_call] = STATE(1006),
    [sym_invoke] = STATE(1006),
    [sym_indexed_access] = STATE(1006),
    [sym_slot_accessor] = STATE(1006),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_maybe] = STATE(1006),
    [sym_unset] = STATE(1006),
    [sym_super] = STATE(1006),
    [sym_self] = STATE(1006),
    [sym_clone] = STATE(1006),
    [sym_thisthread] = STATE(1006),
    [sym_class] = STATE(1006),
    [sym__expression] = STATE(1006),
    [sym_return] = STATE(1006),
    [sym_gather] = STATE(1006),
    [sym_scatter] = STATE(1006),
    [sym_allresults] = STATE(1006),
    [sym_parenthesized_expression] = STATE(1006),
    [sym__variable] = STATE(1006),
    [sym_variable] = STATE(1006),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1006),
    [sym_relational_operator] = STATE(1006),
    [sym_logical_operator] = STATE(1006),
    [sym_arithmetic_operator] = STATE(1006),
    [sym_unary_operator] = STATE(1006),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1587),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1587),
    [sym_global_variable] = ACTIONS(1587),
    [sym_global_reference] = ACTIONS(1587),
    [sym_number] = ACTIONS(1587),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1587),
    [sym_comment] = ACTIONS(103),
  },
  [379] = {
    [sym_procedure] = STATE(920),
    [sym_block] = STATE(920),
    [sym_assignment] = STATE(920),
    [sym_if] = STATE(920),
    [sym_loop] = STATE(920),
    [sym_handling] = STATE(920),
    [sym_catch] = STATE(920),
    [sym_throw] = STATE(920),
    [sym_primitive] = STATE(920),
    [sym_iterator] = STATE(920),
    [sym_while] = STATE(920),
    [sym_try] = STATE(920),
    [sym_loopbody] = STATE(920),
    [sym_leave] = STATE(920),
    [sym_continue] = STATE(920),
    [sym_protect] = STATE(920),
    [sym_lock] = STATE(920),
    [sym__literal] = STATE(920),
    [sym_character_literal] = STATE(920),
    [sym_string_literal] = STATE(920),
    [sym_call] = STATE(920),
    [sym_invoke] = STATE(920),
    [sym_indexed_access] = STATE(920),
    [sym_slot_accessor] = STATE(920),
    [sym_true] = STATE(920),
    [sym_false] = STATE(920),
    [sym_maybe] = STATE(920),
    [sym_unset] = STATE(920),
    [sym_super] = STATE(920),
    [sym_self] = STATE(920),
    [sym_clone] = STATE(920),
    [sym_thisthread] = STATE(920),
    [sym_class] = STATE(920),
    [sym__expression] = STATE(920),
    [sym_return] = STATE(920),
    [sym_gather] = STATE(920),
    [sym_scatter] = STATE(920),
    [sym_allresults] = STATE(920),
    [sym_parenthesized_expression] = STATE(920),
    [sym__variable] = STATE(920),
    [sym_variable] = STATE(920),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(920),
    [sym_relational_operator] = STATE(920),
    [sym_logical_operator] = STATE(920),
    [sym_arithmetic_operator] = STATE(920),
    [sym_unary_operator] = STATE(920),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1589),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1589),
    [sym_global_variable] = ACTIONS(1589),
    [sym_global_reference] = ACTIONS(1589),
    [sym_number] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1589),
    [sym_comment] = ACTIONS(103),
  },
  [380] = {
    [sym_procedure] = STATE(932),
    [sym_block] = STATE(932),
    [sym_assignment] = STATE(932),
    [sym_if] = STATE(932),
    [sym_loop] = STATE(932),
    [sym_handling] = STATE(932),
    [sym_catch] = STATE(932),
    [sym_throw] = STATE(932),
    [sym_primitive] = STATE(932),
    [sym_iterator] = STATE(932),
    [sym_while] = STATE(932),
    [sym_try] = STATE(932),
    [sym_loopbody] = STATE(932),
    [sym_leave] = STATE(932),
    [sym_continue] = STATE(932),
    [sym_protect] = STATE(932),
    [sym_lock] = STATE(932),
    [sym__literal] = STATE(932),
    [sym_character_literal] = STATE(932),
    [sym_string_literal] = STATE(932),
    [sym_call] = STATE(932),
    [sym_invoke] = STATE(932),
    [sym_indexed_access] = STATE(932),
    [sym_slot_accessor] = STATE(932),
    [sym_true] = STATE(932),
    [sym_false] = STATE(932),
    [sym_maybe] = STATE(932),
    [sym_unset] = STATE(932),
    [sym_super] = STATE(932),
    [sym_self] = STATE(932),
    [sym_clone] = STATE(932),
    [sym_thisthread] = STATE(932),
    [sym_class] = STATE(932),
    [sym__expression] = STATE(932),
    [sym_return] = STATE(932),
    [sym_gather] = STATE(932),
    [sym_scatter] = STATE(932),
    [sym_allresults] = STATE(932),
    [sym_parenthesized_expression] = STATE(932),
    [sym__variable] = STATE(932),
    [sym_variable] = STATE(932),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(932),
    [sym_relational_operator] = STATE(932),
    [sym_logical_operator] = STATE(932),
    [sym_arithmetic_operator] = STATE(932),
    [sym_unary_operator] = STATE(932),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1591),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1591),
    [sym_global_variable] = ACTIONS(1591),
    [sym_global_reference] = ACTIONS(1591),
    [sym_number] = ACTIONS(1591),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1591),
    [sym_comment] = ACTIONS(103),
  },
  [381] = {
    [sym_procedure] = STATE(676),
    [sym_block] = STATE(676),
    [sym_assignment] = STATE(676),
    [sym_if] = STATE(676),
    [sym_loop] = STATE(676),
    [sym_handling] = STATE(676),
    [sym_catch] = STATE(676),
    [sym_throw] = STATE(676),
    [sym_primitive] = STATE(676),
    [sym_iterator] = STATE(676),
    [sym_while] = STATE(676),
    [sym_try] = STATE(676),
    [sym_loopbody] = STATE(676),
    [sym_leave] = STATE(676),
    [sym_continue] = STATE(676),
    [sym_protect] = STATE(676),
    [sym_lock] = STATE(676),
    [sym__literal] = STATE(676),
    [sym_character_literal] = STATE(676),
    [sym_string_literal] = STATE(676),
    [sym_call] = STATE(676),
    [sym_invoke] = STATE(676),
    [sym_indexed_access] = STATE(676),
    [sym_slot_accessor] = STATE(676),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_maybe] = STATE(676),
    [sym_unset] = STATE(676),
    [sym_super] = STATE(676),
    [sym_self] = STATE(676),
    [sym_clone] = STATE(676),
    [sym_thisthread] = STATE(676),
    [sym_class] = STATE(676),
    [sym__expression] = STATE(676),
    [sym_return] = STATE(676),
    [sym_gather] = STATE(676),
    [sym_scatter] = STATE(676),
    [sym_allresults] = STATE(676),
    [sym_parenthesized_expression] = STATE(676),
    [sym__variable] = STATE(676),
    [sym_variable] = STATE(676),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(676),
    [sym_relational_operator] = STATE(676),
    [sym_logical_operator] = STATE(676),
    [sym_arithmetic_operator] = STATE(676),
    [sym_unary_operator] = STATE(676),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1593),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1593),
    [sym_global_variable] = ACTIONS(1593),
    [sym_global_reference] = ACTIONS(1593),
    [sym_number] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1593),
    [sym_comment] = ACTIONS(103),
  },
  [382] = {
    [sym_procedure] = STATE(1017),
    [sym_block] = STATE(1017),
    [sym_assignment] = STATE(1017),
    [sym_if] = STATE(1017),
    [sym_loop] = STATE(1017),
    [sym_handling] = STATE(1017),
    [sym_catch] = STATE(1017),
    [sym_throw] = STATE(1017),
    [sym_primitive] = STATE(1017),
    [sym_iterator] = STATE(1017),
    [sym_while] = STATE(1017),
    [sym_try] = STATE(1017),
    [sym_loopbody] = STATE(1017),
    [sym_leave] = STATE(1017),
    [sym_continue] = STATE(1017),
    [sym_protect] = STATE(1017),
    [sym_lock] = STATE(1017),
    [sym__literal] = STATE(1017),
    [sym_character_literal] = STATE(1017),
    [sym_string_literal] = STATE(1017),
    [sym_call] = STATE(1017),
    [sym_invoke] = STATE(1017),
    [sym_indexed_access] = STATE(1017),
    [sym_slot_accessor] = STATE(1017),
    [sym_true] = STATE(1017),
    [sym_false] = STATE(1017),
    [sym_maybe] = STATE(1017),
    [sym_unset] = STATE(1017),
    [sym_super] = STATE(1017),
    [sym_self] = STATE(1017),
    [sym_clone] = STATE(1017),
    [sym_thisthread] = STATE(1017),
    [sym_class] = STATE(1017),
    [sym__expression] = STATE(1017),
    [sym_return] = STATE(1017),
    [sym_gather] = STATE(1017),
    [sym_scatter] = STATE(1017),
    [sym_allresults] = STATE(1017),
    [sym_parenthesized_expression] = STATE(1017),
    [sym__variable] = STATE(1017),
    [sym_variable] = STATE(1017),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1017),
    [sym_relational_operator] = STATE(1017),
    [sym_logical_operator] = STATE(1017),
    [sym_arithmetic_operator] = STATE(1017),
    [sym_unary_operator] = STATE(1017),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1595),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1595),
    [sym_global_variable] = ACTIONS(1595),
    [sym_global_reference] = ACTIONS(1595),
    [sym_number] = ACTIONS(1595),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1595),
    [sym_comment] = ACTIONS(103),
  },
  [383] = {
    [sym_procedure] = STATE(600),
    [sym_block] = STATE(600),
    [sym_assignment] = STATE(600),
    [sym_if] = STATE(600),
    [sym_loop] = STATE(600),
    [sym_handling] = STATE(600),
    [sym_catch] = STATE(600),
    [sym_throw] = STATE(600),
    [sym_primitive] = STATE(600),
    [sym_iterator] = STATE(600),
    [sym_while] = STATE(600),
    [sym_try] = STATE(600),
    [sym_loopbody] = STATE(600),
    [sym_leave] = STATE(600),
    [sym_continue] = STATE(600),
    [sym_protect] = STATE(600),
    [sym_lock] = STATE(600),
    [sym__literal] = STATE(600),
    [sym_character_literal] = STATE(600),
    [sym_string_literal] = STATE(600),
    [sym_call] = STATE(600),
    [sym_invoke] = STATE(600),
    [sym_indexed_access] = STATE(600),
    [sym_slot_accessor] = STATE(600),
    [sym_true] = STATE(600),
    [sym_false] = STATE(600),
    [sym_maybe] = STATE(600),
    [sym_unset] = STATE(600),
    [sym_super] = STATE(600),
    [sym_self] = STATE(600),
    [sym_clone] = STATE(600),
    [sym_thisthread] = STATE(600),
    [sym_class] = STATE(600),
    [sym__expression] = STATE(600),
    [sym_return] = STATE(600),
    [sym_gather] = STATE(600),
    [sym_scatter] = STATE(600),
    [sym_allresults] = STATE(600),
    [sym_parenthesized_expression] = STATE(600),
    [sym__variable] = STATE(600),
    [sym_variable] = STATE(600),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(600),
    [sym_relational_operator] = STATE(600),
    [sym_logical_operator] = STATE(600),
    [sym_arithmetic_operator] = STATE(600),
    [sym_unary_operator] = STATE(600),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1597),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1597),
    [sym_global_variable] = ACTIONS(1597),
    [sym_global_reference] = ACTIONS(1597),
    [sym_number] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1597),
    [sym_comment] = ACTIONS(103),
  },
  [384] = {
    [sym_procedure] = STATE(781),
    [sym_block] = STATE(781),
    [sym_assignment] = STATE(781),
    [sym_if] = STATE(781),
    [sym_loop] = STATE(781),
    [sym_handling] = STATE(781),
    [sym_catch] = STATE(781),
    [sym_throw] = STATE(781),
    [sym_primitive] = STATE(781),
    [sym_iterator] = STATE(781),
    [sym_while] = STATE(781),
    [sym_try] = STATE(781),
    [sym_loopbody] = STATE(781),
    [sym_leave] = STATE(781),
    [sym_continue] = STATE(781),
    [sym_protect] = STATE(781),
    [sym_lock] = STATE(781),
    [sym__literal] = STATE(781),
    [sym_character_literal] = STATE(781),
    [sym_string_literal] = STATE(781),
    [sym_call] = STATE(781),
    [sym_invoke] = STATE(781),
    [sym_indexed_access] = STATE(781),
    [sym_slot_accessor] = STATE(781),
    [sym_true] = STATE(781),
    [sym_false] = STATE(781),
    [sym_maybe] = STATE(781),
    [sym_unset] = STATE(781),
    [sym_super] = STATE(781),
    [sym_self] = STATE(781),
    [sym_clone] = STATE(781),
    [sym_thisthread] = STATE(781),
    [sym_class] = STATE(781),
    [sym__expression] = STATE(781),
    [sym_return] = STATE(781),
    [sym_gather] = STATE(781),
    [sym_scatter] = STATE(781),
    [sym_allresults] = STATE(781),
    [sym_parenthesized_expression] = STATE(781),
    [sym__variable] = STATE(781),
    [sym_variable] = STATE(781),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(781),
    [sym_relational_operator] = STATE(781),
    [sym_logical_operator] = STATE(781),
    [sym_arithmetic_operator] = STATE(781),
    [sym_unary_operator] = STATE(781),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1599),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1599),
    [sym_global_variable] = ACTIONS(1599),
    [sym_global_reference] = ACTIONS(1599),
    [sym_number] = ACTIONS(1599),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1599),
    [sym_comment] = ACTIONS(103),
  },
  [385] = {
    [sym_procedure] = STATE(975),
    [sym_block] = STATE(975),
    [sym_assignment] = STATE(975),
    [sym_if] = STATE(975),
    [sym_loop] = STATE(975),
    [sym_handling] = STATE(975),
    [sym_catch] = STATE(975),
    [sym_throw] = STATE(975),
    [sym_primitive] = STATE(975),
    [sym_iterator] = STATE(975),
    [sym_while] = STATE(975),
    [sym_try] = STATE(975),
    [sym_loopbody] = STATE(975),
    [sym_leave] = STATE(975),
    [sym_continue] = STATE(975),
    [sym_protect] = STATE(975),
    [sym_lock] = STATE(975),
    [sym__literal] = STATE(975),
    [sym_character_literal] = STATE(975),
    [sym_string_literal] = STATE(975),
    [sym_call] = STATE(975),
    [sym_invoke] = STATE(975),
    [sym_indexed_access] = STATE(975),
    [sym_slot_accessor] = STATE(975),
    [sym_true] = STATE(975),
    [sym_false] = STATE(975),
    [sym_maybe] = STATE(975),
    [sym_unset] = STATE(975),
    [sym_super] = STATE(975),
    [sym_self] = STATE(975),
    [sym_clone] = STATE(975),
    [sym_thisthread] = STATE(975),
    [sym_class] = STATE(975),
    [sym__expression] = STATE(975),
    [sym_return] = STATE(975),
    [sym_gather] = STATE(975),
    [sym_scatter] = STATE(975),
    [sym_allresults] = STATE(975),
    [sym_parenthesized_expression] = STATE(975),
    [sym__variable] = STATE(975),
    [sym_variable] = STATE(975),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(975),
    [sym_relational_operator] = STATE(975),
    [sym_logical_operator] = STATE(975),
    [sym_arithmetic_operator] = STATE(975),
    [sym_unary_operator] = STATE(975),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1601),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1601),
    [sym_global_variable] = ACTIONS(1601),
    [sym_global_reference] = ACTIONS(1601),
    [sym_number] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1601),
    [sym_comment] = ACTIONS(103),
  },
  [386] = {
    [sym_procedure] = STATE(637),
    [sym_block] = STATE(637),
    [sym_assignment] = STATE(637),
    [sym_if] = STATE(637),
    [sym_loop] = STATE(637),
    [sym_handling] = STATE(637),
    [sym_catch] = STATE(637),
    [sym_throw] = STATE(637),
    [sym_primitive] = STATE(637),
    [sym_iterator] = STATE(637),
    [sym_while] = STATE(637),
    [sym_try] = STATE(637),
    [sym_loopbody] = STATE(637),
    [sym_leave] = STATE(637),
    [sym_continue] = STATE(637),
    [sym_protect] = STATE(637),
    [sym_lock] = STATE(637),
    [sym__literal] = STATE(637),
    [sym_character_literal] = STATE(637),
    [sym_string_literal] = STATE(637),
    [sym_call] = STATE(637),
    [sym_invoke] = STATE(637),
    [sym_indexed_access] = STATE(637),
    [sym_slot_accessor] = STATE(637),
    [sym_true] = STATE(637),
    [sym_false] = STATE(637),
    [sym_maybe] = STATE(637),
    [sym_unset] = STATE(637),
    [sym_super] = STATE(637),
    [sym_self] = STATE(637),
    [sym_clone] = STATE(637),
    [sym_thisthread] = STATE(637),
    [sym_class] = STATE(637),
    [sym__expression] = STATE(637),
    [sym_return] = STATE(637),
    [sym_gather] = STATE(637),
    [sym_scatter] = STATE(637),
    [sym_allresults] = STATE(637),
    [sym_parenthesized_expression] = STATE(637),
    [sym__variable] = STATE(637),
    [sym_variable] = STATE(637),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(637),
    [sym_relational_operator] = STATE(637),
    [sym_logical_operator] = STATE(637),
    [sym_arithmetic_operator] = STATE(637),
    [sym_unary_operator] = STATE(637),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1603),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1603),
    [sym_global_variable] = ACTIONS(1603),
    [sym_global_reference] = ACTIONS(1603),
    [sym_number] = ACTIONS(1603),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1603),
    [sym_comment] = ACTIONS(103),
  },
  [387] = {
    [sym_procedure] = STATE(1000),
    [sym_block] = STATE(1000),
    [sym_assignment] = STATE(1000),
    [sym_if] = STATE(1000),
    [sym_loop] = STATE(1000),
    [sym_handling] = STATE(1000),
    [sym_catch] = STATE(1000),
    [sym_throw] = STATE(1000),
    [sym_primitive] = STATE(1000),
    [sym_iterator] = STATE(1000),
    [sym_while] = STATE(1000),
    [sym_try] = STATE(1000),
    [sym_loopbody] = STATE(1000),
    [sym_leave] = STATE(1000),
    [sym_continue] = STATE(1000),
    [sym_protect] = STATE(1000),
    [sym_lock] = STATE(1000),
    [sym__literal] = STATE(1000),
    [sym_character_literal] = STATE(1000),
    [sym_string_literal] = STATE(1000),
    [sym_call] = STATE(1000),
    [sym_invoke] = STATE(1000),
    [sym_indexed_access] = STATE(1000),
    [sym_slot_accessor] = STATE(1000),
    [sym_true] = STATE(1000),
    [sym_false] = STATE(1000),
    [sym_maybe] = STATE(1000),
    [sym_unset] = STATE(1000),
    [sym_super] = STATE(1000),
    [sym_self] = STATE(1000),
    [sym_clone] = STATE(1000),
    [sym_thisthread] = STATE(1000),
    [sym_class] = STATE(1000),
    [sym__expression] = STATE(1000),
    [sym_return] = STATE(1000),
    [sym_gather] = STATE(1000),
    [sym_scatter] = STATE(1000),
    [sym_allresults] = STATE(1000),
    [sym_parenthesized_expression] = STATE(1000),
    [sym__variable] = STATE(1000),
    [sym_variable] = STATE(1000),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1000),
    [sym_relational_operator] = STATE(1000),
    [sym_logical_operator] = STATE(1000),
    [sym_arithmetic_operator] = STATE(1000),
    [sym_unary_operator] = STATE(1000),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1605),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1605),
    [sym_global_variable] = ACTIONS(1605),
    [sym_global_reference] = ACTIONS(1605),
    [sym_number] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1605),
    [sym_comment] = ACTIONS(103),
  },
  [388] = {
    [sym_procedure] = STATE(857),
    [sym_block] = STATE(857),
    [sym_assignment] = STATE(857),
    [sym_if] = STATE(857),
    [sym_loop] = STATE(857),
    [sym_handling] = STATE(857),
    [sym_catch] = STATE(857),
    [sym_throw] = STATE(857),
    [sym_primitive] = STATE(857),
    [sym_iterator] = STATE(857),
    [sym_while] = STATE(857),
    [sym_try] = STATE(857),
    [sym_loopbody] = STATE(857),
    [sym_leave] = STATE(857),
    [sym_continue] = STATE(857),
    [sym_protect] = STATE(857),
    [sym_lock] = STATE(857),
    [sym__literal] = STATE(857),
    [sym_character_literal] = STATE(857),
    [sym_string_literal] = STATE(857),
    [sym_call] = STATE(857),
    [sym_invoke] = STATE(857),
    [sym_indexed_access] = STATE(857),
    [sym_slot_accessor] = STATE(857),
    [sym_true] = STATE(857),
    [sym_false] = STATE(857),
    [sym_maybe] = STATE(857),
    [sym_unset] = STATE(857),
    [sym_super] = STATE(857),
    [sym_self] = STATE(857),
    [sym_clone] = STATE(857),
    [sym_thisthread] = STATE(857),
    [sym_class] = STATE(857),
    [sym__expression] = STATE(857),
    [sym_return] = STATE(857),
    [sym_gather] = STATE(857),
    [sym_scatter] = STATE(857),
    [sym_allresults] = STATE(857),
    [sym_parenthesized_expression] = STATE(857),
    [sym__variable] = STATE(857),
    [sym_variable] = STATE(857),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(857),
    [sym_relational_operator] = STATE(857),
    [sym_logical_operator] = STATE(857),
    [sym_arithmetic_operator] = STATE(857),
    [sym_unary_operator] = STATE(857),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1609),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1609),
    [sym_global_variable] = ACTIONS(1609),
    [sym_global_reference] = ACTIONS(1609),
    [sym_number] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1609),
    [sym_comment] = ACTIONS(103),
  },
  [389] = {
    [sym_procedure] = STATE(999),
    [sym_block] = STATE(999),
    [sym_assignment] = STATE(999),
    [sym_if] = STATE(999),
    [sym_loop] = STATE(999),
    [sym_handling] = STATE(999),
    [sym_catch] = STATE(999),
    [sym_throw] = STATE(999),
    [sym_primitive] = STATE(999),
    [sym_iterator] = STATE(999),
    [sym_while] = STATE(999),
    [sym_try] = STATE(999),
    [sym_loopbody] = STATE(999),
    [sym_leave] = STATE(999),
    [sym_continue] = STATE(999),
    [sym_protect] = STATE(999),
    [sym_lock] = STATE(999),
    [sym__literal] = STATE(999),
    [sym_character_literal] = STATE(999),
    [sym_string_literal] = STATE(999),
    [sym_call] = STATE(999),
    [sym_invoke] = STATE(999),
    [sym_indexed_access] = STATE(999),
    [sym_slot_accessor] = STATE(999),
    [sym_true] = STATE(999),
    [sym_false] = STATE(999),
    [sym_maybe] = STATE(999),
    [sym_unset] = STATE(999),
    [sym_super] = STATE(999),
    [sym_self] = STATE(999),
    [sym_clone] = STATE(999),
    [sym_thisthread] = STATE(999),
    [sym_class] = STATE(999),
    [sym__expression] = STATE(999),
    [sym_return] = STATE(999),
    [sym_gather] = STATE(999),
    [sym_scatter] = STATE(999),
    [sym_allresults] = STATE(999),
    [sym_parenthesized_expression] = STATE(999),
    [sym__variable] = STATE(999),
    [sym_variable] = STATE(999),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(999),
    [sym_relational_operator] = STATE(999),
    [sym_logical_operator] = STATE(999),
    [sym_arithmetic_operator] = STATE(999),
    [sym_unary_operator] = STATE(999),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1611),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1611),
    [sym_global_variable] = ACTIONS(1611),
    [sym_global_reference] = ACTIONS(1611),
    [sym_number] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1611),
    [sym_comment] = ACTIONS(103),
  },
  [390] = {
    [sym_procedure] = STATE(970),
    [sym_block] = STATE(970),
    [sym_assignment] = STATE(970),
    [sym_if] = STATE(970),
    [sym_loop] = STATE(970),
    [sym_handling] = STATE(970),
    [sym_catch] = STATE(970),
    [sym_throw] = STATE(970),
    [sym_primitive] = STATE(970),
    [sym_iterator] = STATE(970),
    [sym_while] = STATE(970),
    [sym_try] = STATE(970),
    [sym_loopbody] = STATE(970),
    [sym_leave] = STATE(970),
    [sym_continue] = STATE(970),
    [sym_protect] = STATE(970),
    [sym_lock] = STATE(970),
    [sym__literal] = STATE(970),
    [sym_character_literal] = STATE(970),
    [sym_string_literal] = STATE(970),
    [sym_call] = STATE(970),
    [sym_invoke] = STATE(970),
    [sym_indexed_access] = STATE(970),
    [sym_slot_accessor] = STATE(970),
    [sym_true] = STATE(970),
    [sym_false] = STATE(970),
    [sym_maybe] = STATE(970),
    [sym_unset] = STATE(970),
    [sym_super] = STATE(970),
    [sym_self] = STATE(970),
    [sym_clone] = STATE(970),
    [sym_thisthread] = STATE(970),
    [sym_class] = STATE(970),
    [sym__expression] = STATE(970),
    [sym_return] = STATE(970),
    [sym_gather] = STATE(970),
    [sym_scatter] = STATE(970),
    [sym_allresults] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym__variable] = STATE(970),
    [sym_variable] = STATE(970),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(970),
    [sym_relational_operator] = STATE(970),
    [sym_logical_operator] = STATE(970),
    [sym_arithmetic_operator] = STATE(970),
    [sym_unary_operator] = STATE(970),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1613),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1613),
    [sym_global_variable] = ACTIONS(1613),
    [sym_global_reference] = ACTIONS(1613),
    [sym_number] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1613),
    [sym_comment] = ACTIONS(103),
  },
  [391] = {
    [sym_procedure] = STATE(967),
    [sym_block] = STATE(967),
    [sym_assignment] = STATE(967),
    [sym_if] = STATE(967),
    [sym_loop] = STATE(967),
    [sym_handling] = STATE(967),
    [sym_catch] = STATE(967),
    [sym_throw] = STATE(967),
    [sym_primitive] = STATE(967),
    [sym_iterator] = STATE(967),
    [sym_while] = STATE(967),
    [sym_try] = STATE(967),
    [sym_loopbody] = STATE(967),
    [sym_leave] = STATE(967),
    [sym_continue] = STATE(967),
    [sym_protect] = STATE(967),
    [sym_lock] = STATE(967),
    [sym__literal] = STATE(967),
    [sym_character_literal] = STATE(967),
    [sym_string_literal] = STATE(967),
    [sym_call] = STATE(967),
    [sym_invoke] = STATE(967),
    [sym_indexed_access] = STATE(967),
    [sym_slot_accessor] = STATE(967),
    [sym_true] = STATE(967),
    [sym_false] = STATE(967),
    [sym_maybe] = STATE(967),
    [sym_unset] = STATE(967),
    [sym_super] = STATE(967),
    [sym_self] = STATE(967),
    [sym_clone] = STATE(967),
    [sym_thisthread] = STATE(967),
    [sym_class] = STATE(967),
    [sym__expression] = STATE(967),
    [sym_return] = STATE(967),
    [sym_gather] = STATE(967),
    [sym_scatter] = STATE(967),
    [sym_allresults] = STATE(967),
    [sym_parenthesized_expression] = STATE(967),
    [sym__variable] = STATE(967),
    [sym_variable] = STATE(967),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(967),
    [sym_relational_operator] = STATE(967),
    [sym_logical_operator] = STATE(967),
    [sym_arithmetic_operator] = STATE(967),
    [sym_unary_operator] = STATE(967),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1615),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1615),
    [sym_global_variable] = ACTIONS(1615),
    [sym_global_reference] = ACTIONS(1615),
    [sym_number] = ACTIONS(1615),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1615),
    [sym_comment] = ACTIONS(103),
  },
  [392] = {
    [sym_procedure] = STATE(966),
    [sym_block] = STATE(966),
    [sym_assignment] = STATE(966),
    [sym_if] = STATE(966),
    [sym_loop] = STATE(966),
    [sym_handling] = STATE(966),
    [sym_catch] = STATE(966),
    [sym_throw] = STATE(966),
    [sym_primitive] = STATE(966),
    [sym_iterator] = STATE(966),
    [sym_while] = STATE(966),
    [sym_try] = STATE(966),
    [sym_loopbody] = STATE(966),
    [sym_leave] = STATE(966),
    [sym_continue] = STATE(966),
    [sym_protect] = STATE(966),
    [sym_lock] = STATE(966),
    [sym__literal] = STATE(966),
    [sym_character_literal] = STATE(966),
    [sym_string_literal] = STATE(966),
    [sym_call] = STATE(966),
    [sym_invoke] = STATE(966),
    [sym_indexed_access] = STATE(966),
    [sym_slot_accessor] = STATE(966),
    [sym_true] = STATE(966),
    [sym_false] = STATE(966),
    [sym_maybe] = STATE(966),
    [sym_unset] = STATE(966),
    [sym_super] = STATE(966),
    [sym_self] = STATE(966),
    [sym_clone] = STATE(966),
    [sym_thisthread] = STATE(966),
    [sym_class] = STATE(966),
    [sym__expression] = STATE(966),
    [sym_return] = STATE(966),
    [sym_gather] = STATE(966),
    [sym_scatter] = STATE(966),
    [sym_allresults] = STATE(966),
    [sym_parenthesized_expression] = STATE(966),
    [sym__variable] = STATE(966),
    [sym_variable] = STATE(966),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(966),
    [sym_relational_operator] = STATE(966),
    [sym_logical_operator] = STATE(966),
    [sym_arithmetic_operator] = STATE(966),
    [sym_unary_operator] = STATE(966),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1617),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1617),
    [sym_global_variable] = ACTIONS(1617),
    [sym_global_reference] = ACTIONS(1617),
    [sym_number] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1617),
    [sym_comment] = ACTIONS(103),
  },
  [393] = {
    [sym_procedure] = STATE(985),
    [sym_block] = STATE(985),
    [sym_assignment] = STATE(985),
    [sym_if] = STATE(985),
    [sym_loop] = STATE(985),
    [sym_handling] = STATE(985),
    [sym_catch] = STATE(985),
    [sym_throw] = STATE(985),
    [sym_primitive] = STATE(985),
    [sym_iterator] = STATE(985),
    [sym_while] = STATE(985),
    [sym_try] = STATE(985),
    [sym_loopbody] = STATE(985),
    [sym_leave] = STATE(985),
    [sym_continue] = STATE(985),
    [sym_protect] = STATE(985),
    [sym_lock] = STATE(985),
    [sym__literal] = STATE(985),
    [sym_character_literal] = STATE(985),
    [sym_string_literal] = STATE(985),
    [sym_call] = STATE(985),
    [sym_invoke] = STATE(985),
    [sym_indexed_access] = STATE(985),
    [sym_slot_accessor] = STATE(985),
    [sym_true] = STATE(985),
    [sym_false] = STATE(985),
    [sym_maybe] = STATE(985),
    [sym_unset] = STATE(985),
    [sym_super] = STATE(985),
    [sym_self] = STATE(985),
    [sym_clone] = STATE(985),
    [sym_thisthread] = STATE(985),
    [sym_class] = STATE(985),
    [sym__expression] = STATE(985),
    [sym_return] = STATE(985),
    [sym_gather] = STATE(985),
    [sym_scatter] = STATE(985),
    [sym_allresults] = STATE(985),
    [sym_parenthesized_expression] = STATE(985),
    [sym__variable] = STATE(985),
    [sym_variable] = STATE(985),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(985),
    [sym_relational_operator] = STATE(985),
    [sym_logical_operator] = STATE(985),
    [sym_arithmetic_operator] = STATE(985),
    [sym_unary_operator] = STATE(985),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1619),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1619),
    [sym_global_variable] = ACTIONS(1619),
    [sym_global_reference] = ACTIONS(1619),
    [sym_number] = ACTIONS(1619),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1619),
    [sym_comment] = ACTIONS(103),
  },
  [394] = {
    [sym_procedure] = STATE(949),
    [sym_block] = STATE(949),
    [sym_assignment] = STATE(949),
    [sym_if] = STATE(949),
    [sym_loop] = STATE(949),
    [sym_handling] = STATE(949),
    [sym_catch] = STATE(949),
    [sym_throw] = STATE(949),
    [sym_primitive] = STATE(949),
    [sym_iterator] = STATE(949),
    [sym_while] = STATE(949),
    [sym_try] = STATE(949),
    [sym_loopbody] = STATE(949),
    [sym_leave] = STATE(949),
    [sym_continue] = STATE(949),
    [sym_protect] = STATE(949),
    [sym_lock] = STATE(949),
    [sym__literal] = STATE(949),
    [sym_character_literal] = STATE(949),
    [sym_string_literal] = STATE(949),
    [sym_call] = STATE(949),
    [sym_invoke] = STATE(949),
    [sym_indexed_access] = STATE(949),
    [sym_slot_accessor] = STATE(949),
    [sym_true] = STATE(949),
    [sym_false] = STATE(949),
    [sym_maybe] = STATE(949),
    [sym_unset] = STATE(949),
    [sym_super] = STATE(949),
    [sym_self] = STATE(949),
    [sym_clone] = STATE(949),
    [sym_thisthread] = STATE(949),
    [sym_class] = STATE(949),
    [sym__expression] = STATE(949),
    [sym_return] = STATE(949),
    [sym_gather] = STATE(949),
    [sym_scatter] = STATE(949),
    [sym_allresults] = STATE(949),
    [sym_parenthesized_expression] = STATE(949),
    [sym__variable] = STATE(949),
    [sym_variable] = STATE(949),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(949),
    [sym_relational_operator] = STATE(949),
    [sym_logical_operator] = STATE(949),
    [sym_arithmetic_operator] = STATE(949),
    [sym_unary_operator] = STATE(949),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1621),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1621),
    [sym_global_variable] = ACTIONS(1621),
    [sym_global_reference] = ACTIONS(1621),
    [sym_number] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1621),
    [sym_comment] = ACTIONS(103),
  },
  [395] = {
    [sym_procedure] = STATE(603),
    [sym_block] = STATE(603),
    [sym_assignment] = STATE(603),
    [sym_if] = STATE(603),
    [sym_loop] = STATE(603),
    [sym_handling] = STATE(603),
    [sym_catch] = STATE(603),
    [sym_throw] = STATE(603),
    [sym_primitive] = STATE(603),
    [sym_iterator] = STATE(603),
    [sym_while] = STATE(603),
    [sym_try] = STATE(603),
    [sym_loopbody] = STATE(603),
    [sym_leave] = STATE(603),
    [sym_continue] = STATE(603),
    [sym_protect] = STATE(603),
    [sym_lock] = STATE(603),
    [sym__literal] = STATE(603),
    [sym_character_literal] = STATE(603),
    [sym_string_literal] = STATE(603),
    [sym_call] = STATE(603),
    [sym_invoke] = STATE(603),
    [sym_indexed_access] = STATE(603),
    [sym_slot_accessor] = STATE(603),
    [sym_true] = STATE(603),
    [sym_false] = STATE(603),
    [sym_maybe] = STATE(603),
    [sym_unset] = STATE(603),
    [sym_super] = STATE(603),
    [sym_self] = STATE(603),
    [sym_clone] = STATE(603),
    [sym_thisthread] = STATE(603),
    [sym_class] = STATE(603),
    [sym__expression] = STATE(603),
    [sym_return] = STATE(603),
    [sym_gather] = STATE(603),
    [sym_scatter] = STATE(603),
    [sym_allresults] = STATE(603),
    [sym_parenthesized_expression] = STATE(603),
    [sym__variable] = STATE(603),
    [sym_variable] = STATE(603),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(603),
    [sym_relational_operator] = STATE(603),
    [sym_logical_operator] = STATE(603),
    [sym_arithmetic_operator] = STATE(603),
    [sym_unary_operator] = STATE(603),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1623),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1623),
    [sym_global_variable] = ACTIONS(1623),
    [sym_global_reference] = ACTIONS(1623),
    [sym_number] = ACTIONS(1623),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1623),
    [sym_comment] = ACTIONS(103),
  },
  [396] = {
    [sym_procedure] = STATE(634),
    [sym_block] = STATE(634),
    [sym_assignment] = STATE(634),
    [sym_if] = STATE(634),
    [sym_loop] = STATE(634),
    [sym_handling] = STATE(634),
    [sym_catch] = STATE(634),
    [sym_throw] = STATE(634),
    [sym_primitive] = STATE(634),
    [sym_iterator] = STATE(634),
    [sym_while] = STATE(634),
    [sym_try] = STATE(634),
    [sym_loopbody] = STATE(634),
    [sym_leave] = STATE(634),
    [sym_continue] = STATE(634),
    [sym_protect] = STATE(634),
    [sym_lock] = STATE(634),
    [sym__literal] = STATE(634),
    [sym_character_literal] = STATE(634),
    [sym_string_literal] = STATE(634),
    [sym_call] = STATE(634),
    [sym_invoke] = STATE(634),
    [sym_indexed_access] = STATE(634),
    [sym_slot_accessor] = STATE(634),
    [sym_true] = STATE(634),
    [sym_false] = STATE(634),
    [sym_maybe] = STATE(634),
    [sym_unset] = STATE(634),
    [sym_super] = STATE(634),
    [sym_self] = STATE(634),
    [sym_clone] = STATE(634),
    [sym_thisthread] = STATE(634),
    [sym_class] = STATE(634),
    [sym__expression] = STATE(634),
    [sym_return] = STATE(634),
    [sym_gather] = STATE(634),
    [sym_scatter] = STATE(634),
    [sym_allresults] = STATE(634),
    [sym_parenthesized_expression] = STATE(634),
    [sym__variable] = STATE(634),
    [sym_variable] = STATE(634),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(634),
    [sym_relational_operator] = STATE(634),
    [sym_logical_operator] = STATE(634),
    [sym_arithmetic_operator] = STATE(634),
    [sym_unary_operator] = STATE(634),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1625),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1625),
    [sym_global_variable] = ACTIONS(1625),
    [sym_global_reference] = ACTIONS(1625),
    [sym_number] = ACTIONS(1625),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1625),
    [sym_comment] = ACTIONS(103),
  },
  [397] = {
    [sym_procedure] = STATE(646),
    [sym_block] = STATE(646),
    [sym_assignment] = STATE(646),
    [sym_if] = STATE(646),
    [sym_loop] = STATE(646),
    [sym_handling] = STATE(646),
    [sym_catch] = STATE(646),
    [sym_throw] = STATE(646),
    [sym_primitive] = STATE(646),
    [sym_iterator] = STATE(646),
    [sym_while] = STATE(646),
    [sym_try] = STATE(646),
    [sym_loopbody] = STATE(646),
    [sym_leave] = STATE(646),
    [sym_continue] = STATE(646),
    [sym_protect] = STATE(646),
    [sym_lock] = STATE(646),
    [sym__literal] = STATE(646),
    [sym_character_literal] = STATE(646),
    [sym_string_literal] = STATE(646),
    [sym_call] = STATE(646),
    [sym_invoke] = STATE(646),
    [sym_indexed_access] = STATE(646),
    [sym_slot_accessor] = STATE(646),
    [sym_true] = STATE(646),
    [sym_false] = STATE(646),
    [sym_maybe] = STATE(646),
    [sym_unset] = STATE(646),
    [sym_super] = STATE(646),
    [sym_self] = STATE(646),
    [sym_clone] = STATE(646),
    [sym_thisthread] = STATE(646),
    [sym_class] = STATE(646),
    [sym__expression] = STATE(646),
    [sym_return] = STATE(646),
    [sym_gather] = STATE(646),
    [sym_scatter] = STATE(646),
    [sym_allresults] = STATE(646),
    [sym_parenthesized_expression] = STATE(646),
    [sym__variable] = STATE(646),
    [sym_variable] = STATE(646),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(646),
    [sym_relational_operator] = STATE(646),
    [sym_logical_operator] = STATE(646),
    [sym_arithmetic_operator] = STATE(646),
    [sym_unary_operator] = STATE(646),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1627),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1627),
    [sym_global_variable] = ACTIONS(1627),
    [sym_global_reference] = ACTIONS(1627),
    [sym_number] = ACTIONS(1627),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1627),
    [sym_comment] = ACTIONS(103),
  },
  [398] = {
    [sym_procedure] = STATE(944),
    [sym_block] = STATE(944),
    [sym_assignment] = STATE(944),
    [sym_if] = STATE(944),
    [sym_loop] = STATE(944),
    [sym_handling] = STATE(944),
    [sym_catch] = STATE(944),
    [sym_throw] = STATE(944),
    [sym_primitive] = STATE(944),
    [sym_iterator] = STATE(944),
    [sym_while] = STATE(944),
    [sym_try] = STATE(944),
    [sym_loopbody] = STATE(944),
    [sym_leave] = STATE(944),
    [sym_continue] = STATE(944),
    [sym_protect] = STATE(944),
    [sym_lock] = STATE(944),
    [sym__literal] = STATE(944),
    [sym_character_literal] = STATE(944),
    [sym_string_literal] = STATE(944),
    [sym_call] = STATE(944),
    [sym_invoke] = STATE(944),
    [sym_indexed_access] = STATE(944),
    [sym_slot_accessor] = STATE(944),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_maybe] = STATE(944),
    [sym_unset] = STATE(944),
    [sym_super] = STATE(944),
    [sym_self] = STATE(944),
    [sym_clone] = STATE(944),
    [sym_thisthread] = STATE(944),
    [sym_class] = STATE(944),
    [sym__expression] = STATE(944),
    [sym_return] = STATE(944),
    [sym_gather] = STATE(944),
    [sym_scatter] = STATE(944),
    [sym_allresults] = STATE(944),
    [sym_parenthesized_expression] = STATE(944),
    [sym__variable] = STATE(944),
    [sym_variable] = STATE(944),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(944),
    [sym_relational_operator] = STATE(944),
    [sym_logical_operator] = STATE(944),
    [sym_arithmetic_operator] = STATE(944),
    [sym_unary_operator] = STATE(944),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1629),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1629),
    [sym_global_variable] = ACTIONS(1629),
    [sym_global_reference] = ACTIONS(1629),
    [sym_number] = ACTIONS(1629),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1629),
    [sym_comment] = ACTIONS(103),
  },
  [399] = {
    [sym_procedure] = STATE(906),
    [sym_block] = STATE(906),
    [sym_assignment] = STATE(906),
    [sym_if] = STATE(906),
    [sym_loop] = STATE(906),
    [sym_handling] = STATE(906),
    [sym_catch] = STATE(906),
    [sym_throw] = STATE(906),
    [sym_primitive] = STATE(906),
    [sym_iterator] = STATE(906),
    [sym_while] = STATE(906),
    [sym_try] = STATE(906),
    [sym_loopbody] = STATE(906),
    [sym_leave] = STATE(906),
    [sym_continue] = STATE(906),
    [sym_protect] = STATE(906),
    [sym_lock] = STATE(906),
    [sym__literal] = STATE(906),
    [sym_character_literal] = STATE(906),
    [sym_string_literal] = STATE(906),
    [sym_call] = STATE(906),
    [sym_invoke] = STATE(906),
    [sym_indexed_access] = STATE(906),
    [sym_slot_accessor] = STATE(906),
    [sym_true] = STATE(906),
    [sym_false] = STATE(906),
    [sym_maybe] = STATE(906),
    [sym_unset] = STATE(906),
    [sym_super] = STATE(906),
    [sym_self] = STATE(906),
    [sym_clone] = STATE(906),
    [sym_thisthread] = STATE(906),
    [sym_class] = STATE(906),
    [sym__expression] = STATE(906),
    [sym_return] = STATE(906),
    [sym_gather] = STATE(906),
    [sym_scatter] = STATE(906),
    [sym_allresults] = STATE(906),
    [sym_parenthesized_expression] = STATE(906),
    [sym__variable] = STATE(906),
    [sym_variable] = STATE(906),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(906),
    [sym_relational_operator] = STATE(906),
    [sym_logical_operator] = STATE(906),
    [sym_arithmetic_operator] = STATE(906),
    [sym_unary_operator] = STATE(906),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1631),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1631),
    [sym_global_variable] = ACTIONS(1631),
    [sym_global_reference] = ACTIONS(1631),
    [sym_number] = ACTIONS(1631),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1631),
    [sym_comment] = ACTIONS(103),
  },
  [400] = {
    [sym_procedure] = STATE(610),
    [sym_block] = STATE(610),
    [sym_assignment] = STATE(610),
    [sym_if] = STATE(610),
    [sym_loop] = STATE(610),
    [sym_handling] = STATE(610),
    [sym_catch] = STATE(610),
    [sym_throw] = STATE(610),
    [sym_primitive] = STATE(610),
    [sym_iterator] = STATE(610),
    [sym_while] = STATE(610),
    [sym_try] = STATE(610),
    [sym_loopbody] = STATE(610),
    [sym_leave] = STATE(610),
    [sym_continue] = STATE(610),
    [sym_protect] = STATE(610),
    [sym_lock] = STATE(610),
    [sym__literal] = STATE(610),
    [sym_character_literal] = STATE(610),
    [sym_string_literal] = STATE(610),
    [sym_call] = STATE(610),
    [sym_invoke] = STATE(610),
    [sym_indexed_access] = STATE(610),
    [sym_slot_accessor] = STATE(610),
    [sym_true] = STATE(610),
    [sym_false] = STATE(610),
    [sym_maybe] = STATE(610),
    [sym_unset] = STATE(610),
    [sym_super] = STATE(610),
    [sym_self] = STATE(610),
    [sym_clone] = STATE(610),
    [sym_thisthread] = STATE(610),
    [sym_class] = STATE(610),
    [sym__expression] = STATE(610),
    [sym_return] = STATE(610),
    [sym_gather] = STATE(610),
    [sym_scatter] = STATE(610),
    [sym_allresults] = STATE(610),
    [sym_parenthesized_expression] = STATE(610),
    [sym__variable] = STATE(610),
    [sym_variable] = STATE(610),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(610),
    [sym_relational_operator] = STATE(610),
    [sym_logical_operator] = STATE(610),
    [sym_arithmetic_operator] = STATE(610),
    [sym_unary_operator] = STATE(610),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1635),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_global_reference] = ACTIONS(1635),
    [sym_number] = ACTIONS(1635),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1635),
    [sym_comment] = ACTIONS(103),
  },
  [401] = {
    [sym_procedure] = STATE(640),
    [sym_block] = STATE(640),
    [sym_assignment] = STATE(640),
    [sym_if] = STATE(640),
    [sym_loop] = STATE(640),
    [sym_handling] = STATE(640),
    [sym_catch] = STATE(640),
    [sym_throw] = STATE(640),
    [sym_primitive] = STATE(640),
    [sym_iterator] = STATE(640),
    [sym_while] = STATE(640),
    [sym_try] = STATE(640),
    [sym_loopbody] = STATE(640),
    [sym_leave] = STATE(640),
    [sym_continue] = STATE(640),
    [sym_protect] = STATE(640),
    [sym_lock] = STATE(640),
    [sym__literal] = STATE(640),
    [sym_character_literal] = STATE(640),
    [sym_string_literal] = STATE(640),
    [sym_call] = STATE(640),
    [sym_invoke] = STATE(640),
    [sym_indexed_access] = STATE(640),
    [sym_slot_accessor] = STATE(640),
    [sym_true] = STATE(640),
    [sym_false] = STATE(640),
    [sym_maybe] = STATE(640),
    [sym_unset] = STATE(640),
    [sym_super] = STATE(640),
    [sym_self] = STATE(640),
    [sym_clone] = STATE(640),
    [sym_thisthread] = STATE(640),
    [sym_class] = STATE(640),
    [sym__expression] = STATE(640),
    [sym_return] = STATE(640),
    [sym_gather] = STATE(640),
    [sym_scatter] = STATE(640),
    [sym_allresults] = STATE(640),
    [sym_parenthesized_expression] = STATE(640),
    [sym__variable] = STATE(640),
    [sym_variable] = STATE(640),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(640),
    [sym_relational_operator] = STATE(640),
    [sym_logical_operator] = STATE(640),
    [sym_arithmetic_operator] = STATE(640),
    [sym_unary_operator] = STATE(640),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1637),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1637),
    [sym_global_variable] = ACTIONS(1637),
    [sym_global_reference] = ACTIONS(1637),
    [sym_number] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1637),
    [sym_comment] = ACTIONS(103),
  },
  [402] = {
    [sym_procedure] = STATE(995),
    [sym_block] = STATE(995),
    [sym_assignment] = STATE(995),
    [sym_if] = STATE(995),
    [sym_loop] = STATE(995),
    [sym_handling] = STATE(995),
    [sym_catch] = STATE(995),
    [sym_throw] = STATE(995),
    [sym_primitive] = STATE(995),
    [sym_iterator] = STATE(995),
    [sym_while] = STATE(995),
    [sym_try] = STATE(995),
    [sym_loopbody] = STATE(995),
    [sym_leave] = STATE(995),
    [sym_continue] = STATE(995),
    [sym_protect] = STATE(995),
    [sym_lock] = STATE(995),
    [sym__literal] = STATE(995),
    [sym_character_literal] = STATE(995),
    [sym_string_literal] = STATE(995),
    [sym_call] = STATE(995),
    [sym_invoke] = STATE(995),
    [sym_indexed_access] = STATE(995),
    [sym_slot_accessor] = STATE(995),
    [sym_true] = STATE(995),
    [sym_false] = STATE(995),
    [sym_maybe] = STATE(995),
    [sym_unset] = STATE(995),
    [sym_super] = STATE(995),
    [sym_self] = STATE(995),
    [sym_clone] = STATE(995),
    [sym_thisthread] = STATE(995),
    [sym_class] = STATE(995),
    [sym__expression] = STATE(995),
    [sym_return] = STATE(995),
    [sym_gather] = STATE(995),
    [sym_scatter] = STATE(995),
    [sym_allresults] = STATE(995),
    [sym_parenthesized_expression] = STATE(995),
    [sym__variable] = STATE(995),
    [sym_variable] = STATE(995),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(995),
    [sym_relational_operator] = STATE(995),
    [sym_logical_operator] = STATE(995),
    [sym_arithmetic_operator] = STATE(995),
    [sym_unary_operator] = STATE(995),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1639),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1639),
    [sym_global_variable] = ACTIONS(1639),
    [sym_global_reference] = ACTIONS(1639),
    [sym_number] = ACTIONS(1639),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1639),
    [sym_comment] = ACTIONS(103),
  },
  [403] = {
    [sym_procedure] = STATE(609),
    [sym_block] = STATE(609),
    [sym_assignment] = STATE(609),
    [sym_if] = STATE(609),
    [sym_loop] = STATE(609),
    [sym_handling] = STATE(609),
    [sym_catch] = STATE(609),
    [sym_throw] = STATE(609),
    [sym_primitive] = STATE(609),
    [sym_iterator] = STATE(609),
    [sym_while] = STATE(609),
    [sym_try] = STATE(609),
    [sym_loopbody] = STATE(609),
    [sym_leave] = STATE(609),
    [sym_continue] = STATE(609),
    [sym_protect] = STATE(609),
    [sym_lock] = STATE(609),
    [sym__literal] = STATE(609),
    [sym_character_literal] = STATE(609),
    [sym_string_literal] = STATE(609),
    [sym_call] = STATE(609),
    [sym_invoke] = STATE(609),
    [sym_indexed_access] = STATE(609),
    [sym_slot_accessor] = STATE(609),
    [sym_true] = STATE(609),
    [sym_false] = STATE(609),
    [sym_maybe] = STATE(609),
    [sym_unset] = STATE(609),
    [sym_super] = STATE(609),
    [sym_self] = STATE(609),
    [sym_clone] = STATE(609),
    [sym_thisthread] = STATE(609),
    [sym_class] = STATE(609),
    [sym__expression] = STATE(609),
    [sym_return] = STATE(609),
    [sym_gather] = STATE(609),
    [sym_scatter] = STATE(609),
    [sym_allresults] = STATE(609),
    [sym_parenthesized_expression] = STATE(609),
    [sym__variable] = STATE(609),
    [sym_variable] = STATE(609),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(609),
    [sym_relational_operator] = STATE(609),
    [sym_logical_operator] = STATE(609),
    [sym_arithmetic_operator] = STATE(609),
    [sym_unary_operator] = STATE(609),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1641),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1641),
    [sym_global_variable] = ACTIONS(1641),
    [sym_global_reference] = ACTIONS(1641),
    [sym_number] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1641),
    [sym_comment] = ACTIONS(103),
  },
  [404] = {
    [sym_procedure] = STATE(604),
    [sym_block] = STATE(604),
    [sym_assignment] = STATE(604),
    [sym_if] = STATE(604),
    [sym_loop] = STATE(604),
    [sym_handling] = STATE(604),
    [sym_catch] = STATE(604),
    [sym_throw] = STATE(604),
    [sym_primitive] = STATE(604),
    [sym_iterator] = STATE(604),
    [sym_while] = STATE(604),
    [sym_try] = STATE(604),
    [sym_loopbody] = STATE(604),
    [sym_leave] = STATE(604),
    [sym_continue] = STATE(604),
    [sym_protect] = STATE(604),
    [sym_lock] = STATE(604),
    [sym__literal] = STATE(604),
    [sym_character_literal] = STATE(604),
    [sym_string_literal] = STATE(604),
    [sym_call] = STATE(604),
    [sym_invoke] = STATE(604),
    [sym_indexed_access] = STATE(604),
    [sym_slot_accessor] = STATE(604),
    [sym_true] = STATE(604),
    [sym_false] = STATE(604),
    [sym_maybe] = STATE(604),
    [sym_unset] = STATE(604),
    [sym_super] = STATE(604),
    [sym_self] = STATE(604),
    [sym_clone] = STATE(604),
    [sym_thisthread] = STATE(604),
    [sym_class] = STATE(604),
    [sym__expression] = STATE(604),
    [sym_return] = STATE(604),
    [sym_gather] = STATE(604),
    [sym_scatter] = STATE(604),
    [sym_allresults] = STATE(604),
    [sym_parenthesized_expression] = STATE(604),
    [sym__variable] = STATE(604),
    [sym_variable] = STATE(604),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(604),
    [sym_relational_operator] = STATE(604),
    [sym_logical_operator] = STATE(604),
    [sym_arithmetic_operator] = STATE(604),
    [sym_unary_operator] = STATE(604),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1643),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1643),
    [sym_global_variable] = ACTIONS(1643),
    [sym_global_reference] = ACTIONS(1643),
    [sym_number] = ACTIONS(1643),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1643),
    [sym_comment] = ACTIONS(103),
  },
  [405] = {
    [sym_procedure] = STATE(605),
    [sym_block] = STATE(605),
    [sym_assignment] = STATE(605),
    [sym_if] = STATE(605),
    [sym_loop] = STATE(605),
    [sym_handling] = STATE(605),
    [sym_catch] = STATE(605),
    [sym_throw] = STATE(605),
    [sym_primitive] = STATE(605),
    [sym_iterator] = STATE(605),
    [sym_while] = STATE(605),
    [sym_try] = STATE(605),
    [sym_loopbody] = STATE(605),
    [sym_leave] = STATE(605),
    [sym_continue] = STATE(605),
    [sym_protect] = STATE(605),
    [sym_lock] = STATE(605),
    [sym__literal] = STATE(605),
    [sym_character_literal] = STATE(605),
    [sym_string_literal] = STATE(605),
    [sym_call] = STATE(605),
    [sym_invoke] = STATE(605),
    [sym_indexed_access] = STATE(605),
    [sym_slot_accessor] = STATE(605),
    [sym_true] = STATE(605),
    [sym_false] = STATE(605),
    [sym_maybe] = STATE(605),
    [sym_unset] = STATE(605),
    [sym_super] = STATE(605),
    [sym_self] = STATE(605),
    [sym_clone] = STATE(605),
    [sym_thisthread] = STATE(605),
    [sym_class] = STATE(605),
    [sym__expression] = STATE(605),
    [sym_return] = STATE(605),
    [sym_gather] = STATE(605),
    [sym_scatter] = STATE(605),
    [sym_allresults] = STATE(605),
    [sym_parenthesized_expression] = STATE(605),
    [sym__variable] = STATE(605),
    [sym_variable] = STATE(605),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(605),
    [sym_relational_operator] = STATE(605),
    [sym_logical_operator] = STATE(605),
    [sym_arithmetic_operator] = STATE(605),
    [sym_unary_operator] = STATE(605),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1645),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1645),
    [sym_global_variable] = ACTIONS(1645),
    [sym_global_reference] = ACTIONS(1645),
    [sym_number] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1645),
    [sym_comment] = ACTIONS(103),
  },
  [406] = {
    [sym_procedure] = STATE(793),
    [sym_block] = STATE(793),
    [sym_assignment] = STATE(793),
    [sym_if] = STATE(793),
    [sym_loop] = STATE(793),
    [sym_handling] = STATE(793),
    [sym_catch] = STATE(793),
    [sym_throw] = STATE(793),
    [sym_primitive] = STATE(793),
    [sym_iterator] = STATE(793),
    [sym_while] = STATE(793),
    [sym_try] = STATE(793),
    [sym_loopbody] = STATE(793),
    [sym_leave] = STATE(793),
    [sym_continue] = STATE(793),
    [sym_protect] = STATE(793),
    [sym_lock] = STATE(793),
    [sym__literal] = STATE(793),
    [sym_character_literal] = STATE(793),
    [sym_string_literal] = STATE(793),
    [sym_call] = STATE(793),
    [sym_invoke] = STATE(793),
    [sym_indexed_access] = STATE(793),
    [sym_slot_accessor] = STATE(793),
    [sym_true] = STATE(793),
    [sym_false] = STATE(793),
    [sym_maybe] = STATE(793),
    [sym_unset] = STATE(793),
    [sym_super] = STATE(793),
    [sym_self] = STATE(793),
    [sym_clone] = STATE(793),
    [sym_thisthread] = STATE(793),
    [sym_class] = STATE(793),
    [sym__expression] = STATE(793),
    [sym_return] = STATE(793),
    [sym_gather] = STATE(793),
    [sym_scatter] = STATE(793),
    [sym_allresults] = STATE(793),
    [sym_parenthesized_expression] = STATE(793),
    [sym__variable] = STATE(793),
    [sym_variable] = STATE(793),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(793),
    [sym_relational_operator] = STATE(793),
    [sym_logical_operator] = STATE(793),
    [sym_arithmetic_operator] = STATE(793),
    [sym_unary_operator] = STATE(793),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1647),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1647),
    [sym_global_variable] = ACTIONS(1647),
    [sym_global_reference] = ACTIONS(1647),
    [sym_number] = ACTIONS(1647),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1647),
    [sym_comment] = ACTIONS(103),
  },
  [407] = {
    [sym_procedure] = STATE(861),
    [sym_block] = STATE(861),
    [sym_assignment] = STATE(861),
    [sym_if] = STATE(861),
    [sym_loop] = STATE(861),
    [sym_handling] = STATE(861),
    [sym_catch] = STATE(861),
    [sym_throw] = STATE(861),
    [sym_primitive] = STATE(861),
    [sym_iterator] = STATE(861),
    [sym_while] = STATE(861),
    [sym_try] = STATE(861),
    [sym_loopbody] = STATE(861),
    [sym_leave] = STATE(861),
    [sym_continue] = STATE(861),
    [sym_protect] = STATE(861),
    [sym_lock] = STATE(861),
    [sym__literal] = STATE(861),
    [sym_character_literal] = STATE(861),
    [sym_string_literal] = STATE(861),
    [sym_call] = STATE(861),
    [sym_invoke] = STATE(861),
    [sym_indexed_access] = STATE(861),
    [sym_slot_accessor] = STATE(861),
    [sym_true] = STATE(861),
    [sym_false] = STATE(861),
    [sym_maybe] = STATE(861),
    [sym_unset] = STATE(861),
    [sym_super] = STATE(861),
    [sym_self] = STATE(861),
    [sym_clone] = STATE(861),
    [sym_thisthread] = STATE(861),
    [sym_class] = STATE(861),
    [sym__expression] = STATE(861),
    [sym_return] = STATE(861),
    [sym_gather] = STATE(861),
    [sym_scatter] = STATE(861),
    [sym_allresults] = STATE(861),
    [sym_parenthesized_expression] = STATE(861),
    [sym__variable] = STATE(861),
    [sym_variable] = STATE(861),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(861),
    [sym_relational_operator] = STATE(861),
    [sym_logical_operator] = STATE(861),
    [sym_arithmetic_operator] = STATE(861),
    [sym_unary_operator] = STATE(861),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1649),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1649),
    [sym_global_variable] = ACTIONS(1649),
    [sym_global_reference] = ACTIONS(1649),
    [sym_number] = ACTIONS(1649),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1649),
    [sym_comment] = ACTIONS(103),
  },
  [408] = {
    [sym_procedure] = STATE(726),
    [sym_block] = STATE(726),
    [sym_assignment] = STATE(726),
    [sym_if] = STATE(726),
    [sym_loop] = STATE(726),
    [sym_handling] = STATE(726),
    [sym_catch] = STATE(726),
    [sym_throw] = STATE(726),
    [sym_primitive] = STATE(726),
    [sym_iterator] = STATE(726),
    [sym_while] = STATE(726),
    [sym_try] = STATE(726),
    [sym_loopbody] = STATE(726),
    [sym_leave] = STATE(726),
    [sym_continue] = STATE(726),
    [sym_protect] = STATE(726),
    [sym_lock] = STATE(726),
    [sym__literal] = STATE(726),
    [sym_character_literal] = STATE(726),
    [sym_string_literal] = STATE(726),
    [sym_call] = STATE(726),
    [sym_invoke] = STATE(726),
    [sym_indexed_access] = STATE(726),
    [sym_slot_accessor] = STATE(726),
    [sym_true] = STATE(726),
    [sym_false] = STATE(726),
    [sym_maybe] = STATE(726),
    [sym_unset] = STATE(726),
    [sym_super] = STATE(726),
    [sym_self] = STATE(726),
    [sym_clone] = STATE(726),
    [sym_thisthread] = STATE(726),
    [sym_class] = STATE(726),
    [sym__expression] = STATE(726),
    [sym_return] = STATE(726),
    [sym_gather] = STATE(726),
    [sym_scatter] = STATE(726),
    [sym_allresults] = STATE(726),
    [sym_parenthesized_expression] = STATE(726),
    [sym__variable] = STATE(726),
    [sym_variable] = STATE(726),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(726),
    [sym_relational_operator] = STATE(726),
    [sym_logical_operator] = STATE(726),
    [sym_arithmetic_operator] = STATE(726),
    [sym_unary_operator] = STATE(726),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(217),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(227),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(231),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(245),
    [aux_sym_continue_token1] = ACTIONS(247),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1651),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(281),
    [anon_sym_GT_GT] = ACTIONS(283),
    [aux_sym_scatter_token1] = ACTIONS(285),
    [aux_sym_allresults_token1] = ACTIONS(287),
    [sym_dynamic_variable] = ACTIONS(1651),
    [sym_global_variable] = ACTIONS(1651),
    [sym_global_reference] = ACTIONS(1651),
    [sym_number] = ACTIONS(1651),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(293),
    [anon_sym_PLUS] = ACTIONS(293),
    [aux_sym_unary_operator_token1] = ACTIONS(293),
    [anon_sym_TILDE] = ACTIONS(293),
    [sym_symbol] = ACTIONS(1651),
    [sym_comment] = ACTIONS(103),
  },
  [409] = {
    [sym_procedure] = STATE(890),
    [sym_block] = STATE(890),
    [sym_assignment] = STATE(890),
    [sym_if] = STATE(890),
    [sym_loop] = STATE(890),
    [sym_handling] = STATE(890),
    [sym_catch] = STATE(890),
    [sym_throw] = STATE(890),
    [sym_primitive] = STATE(890),
    [sym_iterator] = STATE(890),
    [sym_while] = STATE(890),
    [sym_try] = STATE(890),
    [sym_loopbody] = STATE(890),
    [sym_leave] = STATE(890),
    [sym_continue] = STATE(890),
    [sym_protect] = STATE(890),
    [sym_lock] = STATE(890),
    [sym__literal] = STATE(890),
    [sym_character_literal] = STATE(890),
    [sym_string_literal] = STATE(890),
    [sym_call] = STATE(890),
    [sym_invoke] = STATE(890),
    [sym_indexed_access] = STATE(890),
    [sym_slot_accessor] = STATE(890),
    [sym_true] = STATE(890),
    [sym_false] = STATE(890),
    [sym_maybe] = STATE(890),
    [sym_unset] = STATE(890),
    [sym_super] = STATE(890),
    [sym_self] = STATE(890),
    [sym_clone] = STATE(890),
    [sym_thisthread] = STATE(890),
    [sym_class] = STATE(890),
    [sym__expression] = STATE(890),
    [sym_return] = STATE(890),
    [sym_gather] = STATE(890),
    [sym_scatter] = STATE(890),
    [sym_allresults] = STATE(890),
    [sym_parenthesized_expression] = STATE(890),
    [sym__variable] = STATE(890),
    [sym_variable] = STATE(890),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(890),
    [sym_relational_operator] = STATE(890),
    [sym_logical_operator] = STATE(890),
    [sym_arithmetic_operator] = STATE(890),
    [sym_unary_operator] = STATE(890),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1653),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1653),
    [sym_global_variable] = ACTIONS(1653),
    [sym_global_reference] = ACTIONS(1653),
    [sym_number] = ACTIONS(1653),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1653),
    [sym_comment] = ACTIONS(103),
  },
  [410] = {
    [sym_procedure] = STATE(642),
    [sym_block] = STATE(642),
    [sym_assignment] = STATE(642),
    [sym_if] = STATE(642),
    [sym_loop] = STATE(642),
    [sym_handling] = STATE(642),
    [sym_catch] = STATE(642),
    [sym_throw] = STATE(642),
    [sym_primitive] = STATE(642),
    [sym_iterator] = STATE(642),
    [sym_while] = STATE(642),
    [sym_try] = STATE(642),
    [sym_loopbody] = STATE(642),
    [sym_leave] = STATE(642),
    [sym_continue] = STATE(642),
    [sym_protect] = STATE(642),
    [sym_lock] = STATE(642),
    [sym__literal] = STATE(642),
    [sym_character_literal] = STATE(642),
    [sym_string_literal] = STATE(642),
    [sym_call] = STATE(642),
    [sym_invoke] = STATE(642),
    [sym_indexed_access] = STATE(642),
    [sym_slot_accessor] = STATE(642),
    [sym_true] = STATE(642),
    [sym_false] = STATE(642),
    [sym_maybe] = STATE(642),
    [sym_unset] = STATE(642),
    [sym_super] = STATE(642),
    [sym_self] = STATE(642),
    [sym_clone] = STATE(642),
    [sym_thisthread] = STATE(642),
    [sym_class] = STATE(642),
    [sym__expression] = STATE(642),
    [sym_return] = STATE(642),
    [sym_gather] = STATE(642),
    [sym_scatter] = STATE(642),
    [sym_allresults] = STATE(642),
    [sym_parenthesized_expression] = STATE(642),
    [sym__variable] = STATE(642),
    [sym_variable] = STATE(642),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(642),
    [sym_relational_operator] = STATE(642),
    [sym_logical_operator] = STATE(642),
    [sym_arithmetic_operator] = STATE(642),
    [sym_unary_operator] = STATE(642),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1655),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1655),
    [sym_global_variable] = ACTIONS(1655),
    [sym_global_reference] = ACTIONS(1655),
    [sym_number] = ACTIONS(1655),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1655),
    [sym_comment] = ACTIONS(103),
  },
  [411] = {
    [sym_procedure] = STATE(853),
    [sym_block] = STATE(853),
    [sym_assignment] = STATE(853),
    [sym_if] = STATE(853),
    [sym_loop] = STATE(853),
    [sym_handling] = STATE(853),
    [sym_catch] = STATE(853),
    [sym_throw] = STATE(853),
    [sym_primitive] = STATE(853),
    [sym_iterator] = STATE(853),
    [sym_while] = STATE(853),
    [sym_try] = STATE(853),
    [sym_loopbody] = STATE(853),
    [sym_leave] = STATE(853),
    [sym_continue] = STATE(853),
    [sym_protect] = STATE(853),
    [sym_lock] = STATE(853),
    [sym__literal] = STATE(853),
    [sym_character_literal] = STATE(853),
    [sym_string_literal] = STATE(853),
    [sym_call] = STATE(853),
    [sym_invoke] = STATE(853),
    [sym_indexed_access] = STATE(853),
    [sym_slot_accessor] = STATE(853),
    [sym_true] = STATE(853),
    [sym_false] = STATE(853),
    [sym_maybe] = STATE(853),
    [sym_unset] = STATE(853),
    [sym_super] = STATE(853),
    [sym_self] = STATE(853),
    [sym_clone] = STATE(853),
    [sym_thisthread] = STATE(853),
    [sym_class] = STATE(853),
    [sym__expression] = STATE(853),
    [sym_return] = STATE(853),
    [sym_gather] = STATE(853),
    [sym_scatter] = STATE(853),
    [sym_allresults] = STATE(853),
    [sym_parenthesized_expression] = STATE(853),
    [sym__variable] = STATE(853),
    [sym_variable] = STATE(853),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(853),
    [sym_relational_operator] = STATE(853),
    [sym_logical_operator] = STATE(853),
    [sym_arithmetic_operator] = STATE(853),
    [sym_unary_operator] = STATE(853),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1657),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1657),
    [sym_global_variable] = ACTIONS(1657),
    [sym_global_reference] = ACTIONS(1657),
    [sym_number] = ACTIONS(1657),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1657),
    [sym_comment] = ACTIONS(103),
  },
  [412] = {
    [sym_procedure] = STATE(854),
    [sym_block] = STATE(854),
    [sym_assignment] = STATE(854),
    [sym_if] = STATE(854),
    [sym_loop] = STATE(854),
    [sym_handling] = STATE(854),
    [sym_catch] = STATE(854),
    [sym_throw] = STATE(854),
    [sym_primitive] = STATE(854),
    [sym_iterator] = STATE(854),
    [sym_while] = STATE(854),
    [sym_try] = STATE(854),
    [sym_loopbody] = STATE(854),
    [sym_leave] = STATE(854),
    [sym_continue] = STATE(854),
    [sym_protect] = STATE(854),
    [sym_lock] = STATE(854),
    [sym__literal] = STATE(854),
    [sym_character_literal] = STATE(854),
    [sym_string_literal] = STATE(854),
    [sym_call] = STATE(854),
    [sym_invoke] = STATE(854),
    [sym_indexed_access] = STATE(854),
    [sym_slot_accessor] = STATE(854),
    [sym_true] = STATE(854),
    [sym_false] = STATE(854),
    [sym_maybe] = STATE(854),
    [sym_unset] = STATE(854),
    [sym_super] = STATE(854),
    [sym_self] = STATE(854),
    [sym_clone] = STATE(854),
    [sym_thisthread] = STATE(854),
    [sym_class] = STATE(854),
    [sym__expression] = STATE(854),
    [sym_return] = STATE(854),
    [sym_gather] = STATE(854),
    [sym_scatter] = STATE(854),
    [sym_allresults] = STATE(854),
    [sym_parenthesized_expression] = STATE(854),
    [sym__variable] = STATE(854),
    [sym_variable] = STATE(854),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(854),
    [sym_relational_operator] = STATE(854),
    [sym_logical_operator] = STATE(854),
    [sym_arithmetic_operator] = STATE(854),
    [sym_unary_operator] = STATE(854),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1659),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1659),
    [sym_global_variable] = ACTIONS(1659),
    [sym_global_reference] = ACTIONS(1659),
    [sym_number] = ACTIONS(1659),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1659),
    [sym_comment] = ACTIONS(103),
  },
  [413] = {
    [sym_procedure] = STATE(507),
    [sym_block] = STATE(507),
    [sym_assignment] = STATE(507),
    [sym_if] = STATE(507),
    [sym_loop] = STATE(507),
    [sym_handling] = STATE(507),
    [sym_catch] = STATE(507),
    [sym_throw] = STATE(507),
    [sym_primitive] = STATE(507),
    [sym_iterator] = STATE(507),
    [sym_while] = STATE(507),
    [sym_try] = STATE(507),
    [sym_loopbody] = STATE(507),
    [sym_leave] = STATE(507),
    [sym_continue] = STATE(507),
    [sym_protect] = STATE(507),
    [sym_lock] = STATE(507),
    [sym__literal] = STATE(507),
    [sym_character_literal] = STATE(507),
    [sym_string_literal] = STATE(507),
    [sym_call] = STATE(507),
    [sym_invoke] = STATE(507),
    [sym_indexed_access] = STATE(507),
    [sym_slot_accessor] = STATE(507),
    [sym_true] = STATE(507),
    [sym_false] = STATE(507),
    [sym_maybe] = STATE(507),
    [sym_unset] = STATE(507),
    [sym_super] = STATE(507),
    [sym_self] = STATE(507),
    [sym_clone] = STATE(507),
    [sym_thisthread] = STATE(507),
    [sym_class] = STATE(507),
    [sym__expression] = STATE(507),
    [sym_return] = STATE(507),
    [sym_gather] = STATE(507),
    [sym_scatter] = STATE(507),
    [sym_allresults] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym__variable] = STATE(507),
    [sym_variable] = STATE(507),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(507),
    [sym_relational_operator] = STATE(507),
    [sym_logical_operator] = STATE(507),
    [sym_arithmetic_operator] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1499),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1499),
    [sym_global_variable] = ACTIONS(1499),
    [sym_global_reference] = ACTIONS(1499),
    [sym_number] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1499),
    [sym_comment] = ACTIONS(103),
  },
  [414] = {
    [sym_procedure] = STATE(856),
    [sym_block] = STATE(856),
    [sym_assignment] = STATE(856),
    [sym_if] = STATE(856),
    [sym_loop] = STATE(856),
    [sym_handling] = STATE(856),
    [sym_catch] = STATE(856),
    [sym_throw] = STATE(856),
    [sym_primitive] = STATE(856),
    [sym_iterator] = STATE(856),
    [sym_while] = STATE(856),
    [sym_try] = STATE(856),
    [sym_loopbody] = STATE(856),
    [sym_leave] = STATE(856),
    [sym_continue] = STATE(856),
    [sym_protect] = STATE(856),
    [sym_lock] = STATE(856),
    [sym__literal] = STATE(856),
    [sym_character_literal] = STATE(856),
    [sym_string_literal] = STATE(856),
    [sym_call] = STATE(856),
    [sym_invoke] = STATE(856),
    [sym_indexed_access] = STATE(856),
    [sym_slot_accessor] = STATE(856),
    [sym_true] = STATE(856),
    [sym_false] = STATE(856),
    [sym_maybe] = STATE(856),
    [sym_unset] = STATE(856),
    [sym_super] = STATE(856),
    [sym_self] = STATE(856),
    [sym_clone] = STATE(856),
    [sym_thisthread] = STATE(856),
    [sym_class] = STATE(856),
    [sym__expression] = STATE(856),
    [sym_return] = STATE(856),
    [sym_gather] = STATE(856),
    [sym_scatter] = STATE(856),
    [sym_allresults] = STATE(856),
    [sym_parenthesized_expression] = STATE(856),
    [sym__variable] = STATE(856),
    [sym_variable] = STATE(856),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(856),
    [sym_relational_operator] = STATE(856),
    [sym_logical_operator] = STATE(856),
    [sym_arithmetic_operator] = STATE(856),
    [sym_unary_operator] = STATE(856),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1661),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1661),
    [sym_global_variable] = ACTIONS(1661),
    [sym_global_reference] = ACTIONS(1661),
    [sym_number] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1661),
    [sym_comment] = ACTIONS(103),
  },
  [415] = {
    [sym_procedure] = STATE(651),
    [sym_block] = STATE(651),
    [sym_assignment] = STATE(651),
    [sym_if] = STATE(651),
    [sym_loop] = STATE(651),
    [sym_handling] = STATE(651),
    [sym_catch] = STATE(651),
    [sym_throw] = STATE(651),
    [sym_primitive] = STATE(651),
    [sym_iterator] = STATE(651),
    [sym_while] = STATE(651),
    [sym_try] = STATE(651),
    [sym_loopbody] = STATE(651),
    [sym_leave] = STATE(651),
    [sym_continue] = STATE(651),
    [sym_protect] = STATE(651),
    [sym_lock] = STATE(651),
    [sym__literal] = STATE(651),
    [sym_character_literal] = STATE(651),
    [sym_string_literal] = STATE(651),
    [sym_call] = STATE(651),
    [sym_invoke] = STATE(651),
    [sym_indexed_access] = STATE(651),
    [sym_slot_accessor] = STATE(651),
    [sym_true] = STATE(651),
    [sym_false] = STATE(651),
    [sym_maybe] = STATE(651),
    [sym_unset] = STATE(651),
    [sym_super] = STATE(651),
    [sym_self] = STATE(651),
    [sym_clone] = STATE(651),
    [sym_thisthread] = STATE(651),
    [sym_class] = STATE(651),
    [sym__expression] = STATE(651),
    [sym_return] = STATE(651),
    [sym_gather] = STATE(651),
    [sym_scatter] = STATE(651),
    [sym_allresults] = STATE(651),
    [sym_parenthesized_expression] = STATE(651),
    [sym__variable] = STATE(651),
    [sym_variable] = STATE(651),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(651),
    [sym_relational_operator] = STATE(651),
    [sym_logical_operator] = STATE(651),
    [sym_arithmetic_operator] = STATE(651),
    [sym_unary_operator] = STATE(651),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1663),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1663),
    [sym_global_variable] = ACTIONS(1663),
    [sym_global_reference] = ACTIONS(1663),
    [sym_number] = ACTIONS(1663),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1663),
    [sym_comment] = ACTIONS(103),
  },
  [416] = {
    [sym_procedure] = STATE(862),
    [sym_block] = STATE(862),
    [sym_assignment] = STATE(862),
    [sym_if] = STATE(862),
    [sym_loop] = STATE(862),
    [sym_handling] = STATE(862),
    [sym_catch] = STATE(862),
    [sym_throw] = STATE(862),
    [sym_primitive] = STATE(862),
    [sym_iterator] = STATE(862),
    [sym_while] = STATE(862),
    [sym_try] = STATE(862),
    [sym_loopbody] = STATE(862),
    [sym_leave] = STATE(862),
    [sym_continue] = STATE(862),
    [sym_protect] = STATE(862),
    [sym_lock] = STATE(862),
    [sym__literal] = STATE(862),
    [sym_character_literal] = STATE(862),
    [sym_string_literal] = STATE(862),
    [sym_call] = STATE(862),
    [sym_invoke] = STATE(862),
    [sym_indexed_access] = STATE(862),
    [sym_slot_accessor] = STATE(862),
    [sym_true] = STATE(862),
    [sym_false] = STATE(862),
    [sym_maybe] = STATE(862),
    [sym_unset] = STATE(862),
    [sym_super] = STATE(862),
    [sym_self] = STATE(862),
    [sym_clone] = STATE(862),
    [sym_thisthread] = STATE(862),
    [sym_class] = STATE(862),
    [sym__expression] = STATE(862),
    [sym_return] = STATE(862),
    [sym_gather] = STATE(862),
    [sym_scatter] = STATE(862),
    [sym_allresults] = STATE(862),
    [sym_parenthesized_expression] = STATE(862),
    [sym__variable] = STATE(862),
    [sym_variable] = STATE(862),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(862),
    [sym_relational_operator] = STATE(862),
    [sym_logical_operator] = STATE(862),
    [sym_arithmetic_operator] = STATE(862),
    [sym_unary_operator] = STATE(862),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1665),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1665),
    [sym_global_variable] = ACTIONS(1665),
    [sym_global_reference] = ACTIONS(1665),
    [sym_number] = ACTIONS(1665),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1665),
    [sym_comment] = ACTIONS(103),
  },
  [417] = {
    [sym_procedure] = STATE(858),
    [sym_block] = STATE(858),
    [sym_assignment] = STATE(858),
    [sym_if] = STATE(858),
    [sym_loop] = STATE(858),
    [sym_handling] = STATE(858),
    [sym_catch] = STATE(858),
    [sym_throw] = STATE(858),
    [sym_primitive] = STATE(858),
    [sym_iterator] = STATE(858),
    [sym_while] = STATE(858),
    [sym_try] = STATE(858),
    [sym_loopbody] = STATE(858),
    [sym_leave] = STATE(858),
    [sym_continue] = STATE(858),
    [sym_protect] = STATE(858),
    [sym_lock] = STATE(858),
    [sym__literal] = STATE(858),
    [sym_character_literal] = STATE(858),
    [sym_string_literal] = STATE(858),
    [sym_call] = STATE(858),
    [sym_invoke] = STATE(858),
    [sym_indexed_access] = STATE(858),
    [sym_slot_accessor] = STATE(858),
    [sym_true] = STATE(858),
    [sym_false] = STATE(858),
    [sym_maybe] = STATE(858),
    [sym_unset] = STATE(858),
    [sym_super] = STATE(858),
    [sym_self] = STATE(858),
    [sym_clone] = STATE(858),
    [sym_thisthread] = STATE(858),
    [sym_class] = STATE(858),
    [sym__expression] = STATE(858),
    [sym_return] = STATE(858),
    [sym_gather] = STATE(858),
    [sym_scatter] = STATE(858),
    [sym_allresults] = STATE(858),
    [sym_parenthesized_expression] = STATE(858),
    [sym__variable] = STATE(858),
    [sym_variable] = STATE(858),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(858),
    [sym_relational_operator] = STATE(858),
    [sym_logical_operator] = STATE(858),
    [sym_arithmetic_operator] = STATE(858),
    [sym_unary_operator] = STATE(858),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1667),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1667),
    [sym_global_variable] = ACTIONS(1667),
    [sym_global_reference] = ACTIONS(1667),
    [sym_number] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1667),
    [sym_comment] = ACTIONS(103),
  },
  [418] = {
    [sym_procedure] = STATE(874),
    [sym_block] = STATE(874),
    [sym_assignment] = STATE(874),
    [sym_if] = STATE(874),
    [sym_loop] = STATE(874),
    [sym_handling] = STATE(874),
    [sym_catch] = STATE(874),
    [sym_throw] = STATE(874),
    [sym_primitive] = STATE(874),
    [sym_iterator] = STATE(874),
    [sym_while] = STATE(874),
    [sym_try] = STATE(874),
    [sym_loopbody] = STATE(874),
    [sym_leave] = STATE(874),
    [sym_continue] = STATE(874),
    [sym_protect] = STATE(874),
    [sym_lock] = STATE(874),
    [sym__literal] = STATE(874),
    [sym_character_literal] = STATE(874),
    [sym_string_literal] = STATE(874),
    [sym_call] = STATE(874),
    [sym_invoke] = STATE(874),
    [sym_indexed_access] = STATE(874),
    [sym_slot_accessor] = STATE(874),
    [sym_true] = STATE(874),
    [sym_false] = STATE(874),
    [sym_maybe] = STATE(874),
    [sym_unset] = STATE(874),
    [sym_super] = STATE(874),
    [sym_self] = STATE(874),
    [sym_clone] = STATE(874),
    [sym_thisthread] = STATE(874),
    [sym_class] = STATE(874),
    [sym__expression] = STATE(874),
    [sym_return] = STATE(874),
    [sym_gather] = STATE(874),
    [sym_scatter] = STATE(874),
    [sym_allresults] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym__variable] = STATE(874),
    [sym_variable] = STATE(874),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(874),
    [sym_relational_operator] = STATE(874),
    [sym_logical_operator] = STATE(874),
    [sym_arithmetic_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1669),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1669),
    [sym_global_variable] = ACTIONS(1669),
    [sym_global_reference] = ACTIONS(1669),
    [sym_number] = ACTIONS(1669),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1669),
    [sym_comment] = ACTIONS(103),
  },
  [419] = {
    [sym_procedure] = STATE(658),
    [sym_block] = STATE(658),
    [sym_assignment] = STATE(658),
    [sym_if] = STATE(658),
    [sym_loop] = STATE(658),
    [sym_handling] = STATE(658),
    [sym_catch] = STATE(658),
    [sym_throw] = STATE(658),
    [sym_primitive] = STATE(658),
    [sym_iterator] = STATE(658),
    [sym_while] = STATE(658),
    [sym_try] = STATE(658),
    [sym_loopbody] = STATE(658),
    [sym_leave] = STATE(658),
    [sym_continue] = STATE(658),
    [sym_protect] = STATE(658),
    [sym_lock] = STATE(658),
    [sym__literal] = STATE(658),
    [sym_character_literal] = STATE(658),
    [sym_string_literal] = STATE(658),
    [sym_call] = STATE(658),
    [sym_invoke] = STATE(658),
    [sym_indexed_access] = STATE(658),
    [sym_slot_accessor] = STATE(658),
    [sym_true] = STATE(658),
    [sym_false] = STATE(658),
    [sym_maybe] = STATE(658),
    [sym_unset] = STATE(658),
    [sym_super] = STATE(658),
    [sym_self] = STATE(658),
    [sym_clone] = STATE(658),
    [sym_thisthread] = STATE(658),
    [sym_class] = STATE(658),
    [sym__expression] = STATE(658),
    [sym_return] = STATE(658),
    [sym_gather] = STATE(658),
    [sym_scatter] = STATE(658),
    [sym_allresults] = STATE(658),
    [sym_parenthesized_expression] = STATE(658),
    [sym__variable] = STATE(658),
    [sym_variable] = STATE(658),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(658),
    [sym_relational_operator] = STATE(658),
    [sym_logical_operator] = STATE(658),
    [sym_arithmetic_operator] = STATE(658),
    [sym_unary_operator] = STATE(658),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1671),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1671),
    [sym_global_variable] = ACTIONS(1671),
    [sym_global_reference] = ACTIONS(1671),
    [sym_number] = ACTIONS(1671),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1671),
    [sym_comment] = ACTIONS(103),
  },
  [420] = {
    [sym_procedure] = STATE(507),
    [sym_block] = STATE(507),
    [sym_assignment] = STATE(507),
    [sym_if] = STATE(507),
    [sym_loop] = STATE(507),
    [sym_handling] = STATE(507),
    [sym_catch] = STATE(507),
    [sym_throw] = STATE(507),
    [sym_primitive] = STATE(507),
    [sym_iterator] = STATE(507),
    [sym_while] = STATE(507),
    [sym_try] = STATE(507),
    [sym_loopbody] = STATE(507),
    [sym_leave] = STATE(507),
    [sym_continue] = STATE(507),
    [sym_protect] = STATE(507),
    [sym_lock] = STATE(507),
    [sym__literal] = STATE(507),
    [sym_character_literal] = STATE(507),
    [sym_string_literal] = STATE(507),
    [sym_call] = STATE(507),
    [sym_invoke] = STATE(507),
    [sym_indexed_access] = STATE(507),
    [sym_slot_accessor] = STATE(507),
    [sym_true] = STATE(507),
    [sym_false] = STATE(507),
    [sym_maybe] = STATE(507),
    [sym_unset] = STATE(507),
    [sym_super] = STATE(507),
    [sym_self] = STATE(507),
    [sym_clone] = STATE(507),
    [sym_thisthread] = STATE(507),
    [sym_class] = STATE(507),
    [sym__expression] = STATE(507),
    [sym_return] = STATE(507),
    [sym_gather] = STATE(507),
    [sym_scatter] = STATE(507),
    [sym_allresults] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym__variable] = STATE(507),
    [sym_variable] = STATE(507),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(507),
    [sym_relational_operator] = STATE(507),
    [sym_logical_operator] = STATE(507),
    [sym_arithmetic_operator] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1499),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1499),
    [sym_global_variable] = ACTIONS(1499),
    [sym_global_reference] = ACTIONS(1499),
    [sym_number] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1499),
    [sym_comment] = ACTIONS(103),
  },
  [421] = {
    [sym_procedure] = STATE(937),
    [sym_block] = STATE(937),
    [sym_assignment] = STATE(937),
    [sym_if] = STATE(937),
    [sym_loop] = STATE(937),
    [sym_handling] = STATE(937),
    [sym_catch] = STATE(937),
    [sym_throw] = STATE(937),
    [sym_primitive] = STATE(937),
    [sym_iterator] = STATE(937),
    [sym_while] = STATE(937),
    [sym_try] = STATE(937),
    [sym_loopbody] = STATE(937),
    [sym_leave] = STATE(937),
    [sym_continue] = STATE(937),
    [sym_protect] = STATE(937),
    [sym_lock] = STATE(937),
    [sym__literal] = STATE(937),
    [sym_character_literal] = STATE(937),
    [sym_string_literal] = STATE(937),
    [sym_call] = STATE(937),
    [sym_invoke] = STATE(937),
    [sym_indexed_access] = STATE(937),
    [sym_slot_accessor] = STATE(937),
    [sym_true] = STATE(937),
    [sym_false] = STATE(937),
    [sym_maybe] = STATE(937),
    [sym_unset] = STATE(937),
    [sym_super] = STATE(937),
    [sym_self] = STATE(937),
    [sym_clone] = STATE(937),
    [sym_thisthread] = STATE(937),
    [sym_class] = STATE(937),
    [sym__expression] = STATE(937),
    [sym_return] = STATE(937),
    [sym_gather] = STATE(937),
    [sym_scatter] = STATE(937),
    [sym_allresults] = STATE(937),
    [sym_parenthesized_expression] = STATE(937),
    [sym__variable] = STATE(937),
    [sym_variable] = STATE(937),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(937),
    [sym_relational_operator] = STATE(937),
    [sym_logical_operator] = STATE(937),
    [sym_arithmetic_operator] = STATE(937),
    [sym_unary_operator] = STATE(937),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1673),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1673),
    [sym_global_variable] = ACTIONS(1673),
    [sym_global_reference] = ACTIONS(1673),
    [sym_number] = ACTIONS(1673),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1673),
    [sym_comment] = ACTIONS(103),
  },
  [422] = {
    [sym_procedure] = STATE(939),
    [sym_block] = STATE(939),
    [sym_assignment] = STATE(939),
    [sym_if] = STATE(939),
    [sym_loop] = STATE(939),
    [sym_handling] = STATE(939),
    [sym_catch] = STATE(939),
    [sym_throw] = STATE(939),
    [sym_primitive] = STATE(939),
    [sym_iterator] = STATE(939),
    [sym_while] = STATE(939),
    [sym_try] = STATE(939),
    [sym_loopbody] = STATE(939),
    [sym_leave] = STATE(939),
    [sym_continue] = STATE(939),
    [sym_protect] = STATE(939),
    [sym_lock] = STATE(939),
    [sym__literal] = STATE(939),
    [sym_character_literal] = STATE(939),
    [sym_string_literal] = STATE(939),
    [sym_call] = STATE(939),
    [sym_invoke] = STATE(939),
    [sym_indexed_access] = STATE(939),
    [sym_slot_accessor] = STATE(939),
    [sym_true] = STATE(939),
    [sym_false] = STATE(939),
    [sym_maybe] = STATE(939),
    [sym_unset] = STATE(939),
    [sym_super] = STATE(939),
    [sym_self] = STATE(939),
    [sym_clone] = STATE(939),
    [sym_thisthread] = STATE(939),
    [sym_class] = STATE(939),
    [sym__expression] = STATE(939),
    [sym_return] = STATE(939),
    [sym_gather] = STATE(939),
    [sym_scatter] = STATE(939),
    [sym_allresults] = STATE(939),
    [sym_parenthesized_expression] = STATE(939),
    [sym__variable] = STATE(939),
    [sym_variable] = STATE(939),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(939),
    [sym_relational_operator] = STATE(939),
    [sym_logical_operator] = STATE(939),
    [sym_arithmetic_operator] = STATE(939),
    [sym_unary_operator] = STATE(939),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1675),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1675),
    [sym_global_variable] = ACTIONS(1675),
    [sym_global_reference] = ACTIONS(1675),
    [sym_number] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1675),
    [sym_comment] = ACTIONS(103),
  },
  [423] = {
    [sym_procedure] = STATE(942),
    [sym_block] = STATE(942),
    [sym_assignment] = STATE(942),
    [sym_if] = STATE(942),
    [sym_loop] = STATE(942),
    [sym_handling] = STATE(942),
    [sym_catch] = STATE(942),
    [sym_throw] = STATE(942),
    [sym_primitive] = STATE(942),
    [sym_iterator] = STATE(942),
    [sym_while] = STATE(942),
    [sym_try] = STATE(942),
    [sym_loopbody] = STATE(942),
    [sym_leave] = STATE(942),
    [sym_continue] = STATE(942),
    [sym_protect] = STATE(942),
    [sym_lock] = STATE(942),
    [sym__literal] = STATE(942),
    [sym_character_literal] = STATE(942),
    [sym_string_literal] = STATE(942),
    [sym_call] = STATE(942),
    [sym_invoke] = STATE(942),
    [sym_indexed_access] = STATE(942),
    [sym_slot_accessor] = STATE(942),
    [sym_true] = STATE(942),
    [sym_false] = STATE(942),
    [sym_maybe] = STATE(942),
    [sym_unset] = STATE(942),
    [sym_super] = STATE(942),
    [sym_self] = STATE(942),
    [sym_clone] = STATE(942),
    [sym_thisthread] = STATE(942),
    [sym_class] = STATE(942),
    [sym__expression] = STATE(942),
    [sym_return] = STATE(942),
    [sym_gather] = STATE(942),
    [sym_scatter] = STATE(942),
    [sym_allresults] = STATE(942),
    [sym_parenthesized_expression] = STATE(942),
    [sym__variable] = STATE(942),
    [sym_variable] = STATE(942),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(942),
    [sym_relational_operator] = STATE(942),
    [sym_logical_operator] = STATE(942),
    [sym_arithmetic_operator] = STATE(942),
    [sym_unary_operator] = STATE(942),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1677),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1677),
    [sym_global_variable] = ACTIONS(1677),
    [sym_global_reference] = ACTIONS(1677),
    [sym_number] = ACTIONS(1677),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1677),
    [sym_comment] = ACTIONS(103),
  },
  [424] = {
    [sym_procedure] = STATE(945),
    [sym_block] = STATE(945),
    [sym_assignment] = STATE(945),
    [sym_if] = STATE(945),
    [sym_loop] = STATE(945),
    [sym_handling] = STATE(945),
    [sym_catch] = STATE(945),
    [sym_throw] = STATE(945),
    [sym_primitive] = STATE(945),
    [sym_iterator] = STATE(945),
    [sym_while] = STATE(945),
    [sym_try] = STATE(945),
    [sym_loopbody] = STATE(945),
    [sym_leave] = STATE(945),
    [sym_continue] = STATE(945),
    [sym_protect] = STATE(945),
    [sym_lock] = STATE(945),
    [sym__literal] = STATE(945),
    [sym_character_literal] = STATE(945),
    [sym_string_literal] = STATE(945),
    [sym_call] = STATE(945),
    [sym_invoke] = STATE(945),
    [sym_indexed_access] = STATE(945),
    [sym_slot_accessor] = STATE(945),
    [sym_true] = STATE(945),
    [sym_false] = STATE(945),
    [sym_maybe] = STATE(945),
    [sym_unset] = STATE(945),
    [sym_super] = STATE(945),
    [sym_self] = STATE(945),
    [sym_clone] = STATE(945),
    [sym_thisthread] = STATE(945),
    [sym_class] = STATE(945),
    [sym__expression] = STATE(945),
    [sym_return] = STATE(945),
    [sym_gather] = STATE(945),
    [sym_scatter] = STATE(945),
    [sym_allresults] = STATE(945),
    [sym_parenthesized_expression] = STATE(945),
    [sym__variable] = STATE(945),
    [sym_variable] = STATE(945),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(945),
    [sym_relational_operator] = STATE(945),
    [sym_logical_operator] = STATE(945),
    [sym_arithmetic_operator] = STATE(945),
    [sym_unary_operator] = STATE(945),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1679),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1679),
    [sym_global_variable] = ACTIONS(1679),
    [sym_global_reference] = ACTIONS(1679),
    [sym_number] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1679),
    [sym_comment] = ACTIONS(103),
  },
  [425] = {
    [sym_procedure] = STATE(964),
    [sym_block] = STATE(964),
    [sym_assignment] = STATE(964),
    [sym_if] = STATE(964),
    [sym_loop] = STATE(964),
    [sym_handling] = STATE(964),
    [sym_catch] = STATE(964),
    [sym_throw] = STATE(964),
    [sym_primitive] = STATE(964),
    [sym_iterator] = STATE(964),
    [sym_while] = STATE(964),
    [sym_try] = STATE(964),
    [sym_loopbody] = STATE(964),
    [sym_leave] = STATE(964),
    [sym_continue] = STATE(964),
    [sym_protect] = STATE(964),
    [sym_lock] = STATE(964),
    [sym__literal] = STATE(964),
    [sym_character_literal] = STATE(964),
    [sym_string_literal] = STATE(964),
    [sym_call] = STATE(964),
    [sym_invoke] = STATE(964),
    [sym_indexed_access] = STATE(964),
    [sym_slot_accessor] = STATE(964),
    [sym_true] = STATE(964),
    [sym_false] = STATE(964),
    [sym_maybe] = STATE(964),
    [sym_unset] = STATE(964),
    [sym_super] = STATE(964),
    [sym_self] = STATE(964),
    [sym_clone] = STATE(964),
    [sym_thisthread] = STATE(964),
    [sym_class] = STATE(964),
    [sym__expression] = STATE(964),
    [sym_return] = STATE(964),
    [sym_gather] = STATE(964),
    [sym_scatter] = STATE(964),
    [sym_allresults] = STATE(964),
    [sym_parenthesized_expression] = STATE(964),
    [sym__variable] = STATE(964),
    [sym_variable] = STATE(964),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(964),
    [sym_relational_operator] = STATE(964),
    [sym_logical_operator] = STATE(964),
    [sym_arithmetic_operator] = STATE(964),
    [sym_unary_operator] = STATE(964),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1681),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1681),
    [sym_global_variable] = ACTIONS(1681),
    [sym_global_reference] = ACTIONS(1681),
    [sym_number] = ACTIONS(1681),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1681),
    [sym_comment] = ACTIONS(103),
  },
  [426] = {
    [sym_procedure] = STATE(622),
    [sym_block] = STATE(622),
    [sym_assignment] = STATE(622),
    [sym_if] = STATE(622),
    [sym_loop] = STATE(622),
    [sym_handling] = STATE(622),
    [sym_catch] = STATE(622),
    [sym_throw] = STATE(622),
    [sym_primitive] = STATE(622),
    [sym_iterator] = STATE(622),
    [sym_while] = STATE(622),
    [sym_try] = STATE(622),
    [sym_loopbody] = STATE(622),
    [sym_leave] = STATE(622),
    [sym_continue] = STATE(622),
    [sym_protect] = STATE(622),
    [sym_lock] = STATE(622),
    [sym__literal] = STATE(622),
    [sym_character_literal] = STATE(622),
    [sym_string_literal] = STATE(622),
    [sym_call] = STATE(622),
    [sym_invoke] = STATE(622),
    [sym_indexed_access] = STATE(622),
    [sym_slot_accessor] = STATE(622),
    [sym_true] = STATE(622),
    [sym_false] = STATE(622),
    [sym_maybe] = STATE(622),
    [sym_unset] = STATE(622),
    [sym_super] = STATE(622),
    [sym_self] = STATE(622),
    [sym_clone] = STATE(622),
    [sym_thisthread] = STATE(622),
    [sym_class] = STATE(622),
    [sym__expression] = STATE(622),
    [sym_return] = STATE(622),
    [sym_gather] = STATE(622),
    [sym_scatter] = STATE(622),
    [sym_allresults] = STATE(622),
    [sym_parenthesized_expression] = STATE(622),
    [sym__variable] = STATE(622),
    [sym_variable] = STATE(622),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(622),
    [sym_relational_operator] = STATE(622),
    [sym_logical_operator] = STATE(622),
    [sym_arithmetic_operator] = STATE(622),
    [sym_unary_operator] = STATE(622),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1683),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1683),
    [sym_global_variable] = ACTIONS(1683),
    [sym_global_reference] = ACTIONS(1683),
    [sym_number] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1683),
    [sym_comment] = ACTIONS(103),
  },
  [427] = {
    [sym_procedure] = STATE(623),
    [sym_block] = STATE(623),
    [sym_assignment] = STATE(623),
    [sym_if] = STATE(623),
    [sym_loop] = STATE(623),
    [sym_handling] = STATE(623),
    [sym_catch] = STATE(623),
    [sym_throw] = STATE(623),
    [sym_primitive] = STATE(623),
    [sym_iterator] = STATE(623),
    [sym_while] = STATE(623),
    [sym_try] = STATE(623),
    [sym_loopbody] = STATE(623),
    [sym_leave] = STATE(623),
    [sym_continue] = STATE(623),
    [sym_protect] = STATE(623),
    [sym_lock] = STATE(623),
    [sym__literal] = STATE(623),
    [sym_character_literal] = STATE(623),
    [sym_string_literal] = STATE(623),
    [sym_call] = STATE(623),
    [sym_invoke] = STATE(623),
    [sym_indexed_access] = STATE(623),
    [sym_slot_accessor] = STATE(623),
    [sym_true] = STATE(623),
    [sym_false] = STATE(623),
    [sym_maybe] = STATE(623),
    [sym_unset] = STATE(623),
    [sym_super] = STATE(623),
    [sym_self] = STATE(623),
    [sym_clone] = STATE(623),
    [sym_thisthread] = STATE(623),
    [sym_class] = STATE(623),
    [sym__expression] = STATE(623),
    [sym_return] = STATE(623),
    [sym_gather] = STATE(623),
    [sym_scatter] = STATE(623),
    [sym_allresults] = STATE(623),
    [sym_parenthesized_expression] = STATE(623),
    [sym__variable] = STATE(623),
    [sym_variable] = STATE(623),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(623),
    [sym_relational_operator] = STATE(623),
    [sym_logical_operator] = STATE(623),
    [sym_arithmetic_operator] = STATE(623),
    [sym_unary_operator] = STATE(623),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1685),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1685),
    [sym_global_variable] = ACTIONS(1685),
    [sym_global_reference] = ACTIONS(1685),
    [sym_number] = ACTIONS(1685),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1685),
    [sym_comment] = ACTIONS(103),
  },
  [428] = {
    [sym_procedure] = STATE(624),
    [sym_block] = STATE(624),
    [sym_assignment] = STATE(624),
    [sym_if] = STATE(624),
    [sym_loop] = STATE(624),
    [sym_handling] = STATE(624),
    [sym_catch] = STATE(624),
    [sym_throw] = STATE(624),
    [sym_primitive] = STATE(624),
    [sym_iterator] = STATE(624),
    [sym_while] = STATE(624),
    [sym_try] = STATE(624),
    [sym_loopbody] = STATE(624),
    [sym_leave] = STATE(624),
    [sym_continue] = STATE(624),
    [sym_protect] = STATE(624),
    [sym_lock] = STATE(624),
    [sym__literal] = STATE(624),
    [sym_character_literal] = STATE(624),
    [sym_string_literal] = STATE(624),
    [sym_call] = STATE(624),
    [sym_invoke] = STATE(624),
    [sym_indexed_access] = STATE(624),
    [sym_slot_accessor] = STATE(624),
    [sym_true] = STATE(624),
    [sym_false] = STATE(624),
    [sym_maybe] = STATE(624),
    [sym_unset] = STATE(624),
    [sym_super] = STATE(624),
    [sym_self] = STATE(624),
    [sym_clone] = STATE(624),
    [sym_thisthread] = STATE(624),
    [sym_class] = STATE(624),
    [sym__expression] = STATE(624),
    [sym_return] = STATE(624),
    [sym_gather] = STATE(624),
    [sym_scatter] = STATE(624),
    [sym_allresults] = STATE(624),
    [sym_parenthesized_expression] = STATE(624),
    [sym__variable] = STATE(624),
    [sym_variable] = STATE(624),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(624),
    [sym_relational_operator] = STATE(624),
    [sym_logical_operator] = STATE(624),
    [sym_arithmetic_operator] = STATE(624),
    [sym_unary_operator] = STATE(624),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1687),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1687),
    [sym_global_variable] = ACTIONS(1687),
    [sym_global_reference] = ACTIONS(1687),
    [sym_number] = ACTIONS(1687),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1687),
    [sym_comment] = ACTIONS(103),
  },
  [429] = {
    [sym_procedure] = STATE(507),
    [sym_block] = STATE(507),
    [sym_assignment] = STATE(507),
    [sym_if] = STATE(507),
    [sym_loop] = STATE(507),
    [sym_handling] = STATE(507),
    [sym_catch] = STATE(507),
    [sym_throw] = STATE(507),
    [sym_primitive] = STATE(507),
    [sym_iterator] = STATE(507),
    [sym_while] = STATE(507),
    [sym_try] = STATE(507),
    [sym_loopbody] = STATE(507),
    [sym_leave] = STATE(507),
    [sym_continue] = STATE(507),
    [sym_protect] = STATE(507),
    [sym_lock] = STATE(507),
    [sym__literal] = STATE(507),
    [sym_character_literal] = STATE(507),
    [sym_string_literal] = STATE(507),
    [sym_call] = STATE(507),
    [sym_invoke] = STATE(507),
    [sym_indexed_access] = STATE(507),
    [sym_slot_accessor] = STATE(507),
    [sym_true] = STATE(507),
    [sym_false] = STATE(507),
    [sym_maybe] = STATE(507),
    [sym_unset] = STATE(507),
    [sym_super] = STATE(507),
    [sym_self] = STATE(507),
    [sym_clone] = STATE(507),
    [sym_thisthread] = STATE(507),
    [sym_class] = STATE(507),
    [sym__expression] = STATE(507),
    [sym_return] = STATE(507),
    [sym_gather] = STATE(507),
    [sym_scatter] = STATE(507),
    [sym_allresults] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym__variable] = STATE(507),
    [sym_variable] = STATE(507),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(507),
    [sym_relational_operator] = STATE(507),
    [sym_logical_operator] = STATE(507),
    [sym_arithmetic_operator] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1319),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1321),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1323),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1499),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1331),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [aux_sym_scatter_token1] = ACTIONS(1335),
    [aux_sym_allresults_token1] = ACTIONS(1337),
    [sym_dynamic_variable] = ACTIONS(1499),
    [sym_global_variable] = ACTIONS(1499),
    [sym_global_reference] = ACTIONS(1499),
    [sym_number] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1339),
    [anon_sym_PLUS] = ACTIONS(1339),
    [aux_sym_unary_operator_token1] = ACTIONS(1339),
    [anon_sym_TILDE] = ACTIONS(1339),
    [sym_symbol] = ACTIONS(1499),
    [sym_comment] = ACTIONS(103),
  },
  [430] = {
    [sym_procedure] = STATE(923),
    [sym_block] = STATE(923),
    [sym_assignment] = STATE(923),
    [sym_if] = STATE(923),
    [sym_loop] = STATE(923),
    [sym_handling] = STATE(923),
    [sym_catch] = STATE(923),
    [sym_throw] = STATE(923),
    [sym_primitive] = STATE(923),
    [sym_iterator] = STATE(923),
    [sym_while] = STATE(923),
    [sym_try] = STATE(923),
    [sym_loopbody] = STATE(923),
    [sym_leave] = STATE(923),
    [sym_continue] = STATE(923),
    [sym_protect] = STATE(923),
    [sym_lock] = STATE(923),
    [sym__literal] = STATE(923),
    [sym_character_literal] = STATE(923),
    [sym_string_literal] = STATE(923),
    [sym_call] = STATE(923),
    [sym_invoke] = STATE(923),
    [sym_indexed_access] = STATE(923),
    [sym_slot_accessor] = STATE(923),
    [sym_true] = STATE(923),
    [sym_false] = STATE(923),
    [sym_maybe] = STATE(923),
    [sym_unset] = STATE(923),
    [sym_super] = STATE(923),
    [sym_self] = STATE(923),
    [sym_clone] = STATE(923),
    [sym_thisthread] = STATE(923),
    [sym_class] = STATE(923),
    [sym__expression] = STATE(923),
    [sym_return] = STATE(923),
    [sym_gather] = STATE(923),
    [sym_scatter] = STATE(923),
    [sym_allresults] = STATE(923),
    [sym_parenthesized_expression] = STATE(923),
    [sym__variable] = STATE(923),
    [sym_variable] = STATE(923),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(923),
    [sym_relational_operator] = STATE(923),
    [sym_logical_operator] = STATE(923),
    [sym_arithmetic_operator] = STATE(923),
    [sym_unary_operator] = STATE(923),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1689),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1689),
    [sym_global_variable] = ACTIONS(1689),
    [sym_global_reference] = ACTIONS(1689),
    [sym_number] = ACTIONS(1689),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1689),
    [sym_comment] = ACTIONS(103),
  },
  [431] = {
    [sym_procedure] = STATE(883),
    [sym_block] = STATE(883),
    [sym_assignment] = STATE(883),
    [sym_if] = STATE(883),
    [sym_loop] = STATE(883),
    [sym_handling] = STATE(883),
    [sym_catch] = STATE(883),
    [sym_throw] = STATE(883),
    [sym_primitive] = STATE(883),
    [sym_iterator] = STATE(883),
    [sym_while] = STATE(883),
    [sym_try] = STATE(883),
    [sym_loopbody] = STATE(883),
    [sym_leave] = STATE(883),
    [sym_continue] = STATE(883),
    [sym_protect] = STATE(883),
    [sym_lock] = STATE(883),
    [sym__literal] = STATE(883),
    [sym_character_literal] = STATE(883),
    [sym_string_literal] = STATE(883),
    [sym_call] = STATE(883),
    [sym_invoke] = STATE(883),
    [sym_indexed_access] = STATE(883),
    [sym_slot_accessor] = STATE(883),
    [sym_true] = STATE(883),
    [sym_false] = STATE(883),
    [sym_maybe] = STATE(883),
    [sym_unset] = STATE(883),
    [sym_super] = STATE(883),
    [sym_self] = STATE(883),
    [sym_clone] = STATE(883),
    [sym_thisthread] = STATE(883),
    [sym_class] = STATE(883),
    [sym__expression] = STATE(883),
    [sym_return] = STATE(883),
    [sym_gather] = STATE(883),
    [sym_scatter] = STATE(883),
    [sym_allresults] = STATE(883),
    [sym_parenthesized_expression] = STATE(883),
    [sym__variable] = STATE(883),
    [sym_variable] = STATE(883),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(883),
    [sym_relational_operator] = STATE(883),
    [sym_logical_operator] = STATE(883),
    [sym_arithmetic_operator] = STATE(883),
    [sym_unary_operator] = STATE(883),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1381),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1383),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(1385),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1325),
    [aux_sym_continue_token1] = ACTIONS(1327),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1691),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(1389),
    [anon_sym_GT_GT] = ACTIONS(1391),
    [aux_sym_scatter_token1] = ACTIONS(1393),
    [aux_sym_allresults_token1] = ACTIONS(1395),
    [sym_dynamic_variable] = ACTIONS(1691),
    [sym_global_variable] = ACTIONS(1691),
    [sym_global_reference] = ACTIONS(1691),
    [sym_number] = ACTIONS(1691),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [aux_sym_unary_operator_token1] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1397),
    [sym_symbol] = ACTIONS(1691),
    [sym_comment] = ACTIONS(103),
  },
  [432] = {
    [sym_procedure] = STATE(875),
    [sym_block] = STATE(875),
    [sym_assignment] = STATE(875),
    [sym_if] = STATE(875),
    [sym_loop] = STATE(875),
    [sym_handling] = STATE(875),
    [sym_catch] = STATE(875),
    [sym_throw] = STATE(875),
    [sym_primitive] = STATE(875),
    [sym_iterator] = STATE(875),
    [sym_while] = STATE(875),
    [sym_try] = STATE(875),
    [sym_loopbody] = STATE(875),
    [sym_leave] = STATE(875),
    [sym_continue] = STATE(875),
    [sym_protect] = STATE(875),
    [sym_lock] = STATE(875),
    [sym__literal] = STATE(875),
    [sym_character_literal] = STATE(875),
    [sym_string_literal] = STATE(875),
    [sym_call] = STATE(875),
    [sym_invoke] = STATE(875),
    [sym_indexed_access] = STATE(875),
    [sym_slot_accessor] = STATE(875),
    [sym_true] = STATE(875),
    [sym_false] = STATE(875),
    [sym_maybe] = STATE(875),
    [sym_unset] = STATE(875),
    [sym_super] = STATE(875),
    [sym_self] = STATE(875),
    [sym_clone] = STATE(875),
    [sym_thisthread] = STATE(875),
    [sym_class] = STATE(875),
    [sym__expression] = STATE(875),
    [sym_return] = STATE(875),
    [sym_gather] = STATE(875),
    [sym_scatter] = STATE(875),
    [sym_allresults] = STATE(875),
    [sym_parenthesized_expression] = STATE(875),
    [sym__variable] = STATE(875),
    [sym_variable] = STATE(875),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(875),
    [sym_relational_operator] = STATE(875),
    [sym_logical_operator] = STATE(875),
    [sym_arithmetic_operator] = STATE(875),
    [sym_unary_operator] = STATE(875),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1575),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1693),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1693),
    [sym_global_variable] = ACTIONS(1693),
    [sym_global_reference] = ACTIONS(1693),
    [sym_number] = ACTIONS(1693),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1693),
    [sym_comment] = ACTIONS(103),
  },
  [433] = {
    [sym_procedure] = STATE(903),
    [sym_block] = STATE(903),
    [sym_assignment] = STATE(903),
    [sym_if] = STATE(903),
    [sym_loop] = STATE(903),
    [sym_handling] = STATE(903),
    [sym_catch] = STATE(903),
    [sym_throw] = STATE(903),
    [sym_primitive] = STATE(903),
    [sym_iterator] = STATE(903),
    [sym_while] = STATE(903),
    [sym_try] = STATE(903),
    [sym_loopbody] = STATE(903),
    [sym_leave] = STATE(903),
    [sym_continue] = STATE(903),
    [sym_protect] = STATE(903),
    [sym_lock] = STATE(903),
    [sym__literal] = STATE(903),
    [sym_character_literal] = STATE(903),
    [sym_string_literal] = STATE(903),
    [sym_call] = STATE(903),
    [sym_invoke] = STATE(903),
    [sym_indexed_access] = STATE(903),
    [sym_slot_accessor] = STATE(903),
    [sym_true] = STATE(903),
    [sym_false] = STATE(903),
    [sym_maybe] = STATE(903),
    [sym_unset] = STATE(903),
    [sym_super] = STATE(903),
    [sym_self] = STATE(903),
    [sym_clone] = STATE(903),
    [sym_thisthread] = STATE(903),
    [sym_class] = STATE(903),
    [sym__expression] = STATE(903),
    [sym_return] = STATE(903),
    [sym_gather] = STATE(903),
    [sym_scatter] = STATE(903),
    [sym_allresults] = STATE(903),
    [sym_parenthesized_expression] = STATE(903),
    [sym__variable] = STATE(903),
    [sym_variable] = STATE(903),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(903),
    [sym_relational_operator] = STATE(903),
    [sym_logical_operator] = STATE(903),
    [sym_arithmetic_operator] = STATE(903),
    [sym_unary_operator] = STATE(903),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1695),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1695),
    [sym_global_variable] = ACTIONS(1695),
    [sym_global_reference] = ACTIONS(1695),
    [sym_number] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1695),
    [sym_comment] = ACTIONS(103),
  },
  [434] = {
    [sym_procedure] = STATE(877),
    [sym_block] = STATE(877),
    [sym_assignment] = STATE(877),
    [sym_if] = STATE(877),
    [sym_loop] = STATE(877),
    [sym_handling] = STATE(877),
    [sym_catch] = STATE(877),
    [sym_throw] = STATE(877),
    [sym_primitive] = STATE(877),
    [sym_iterator] = STATE(877),
    [sym_while] = STATE(877),
    [sym_try] = STATE(877),
    [sym_loopbody] = STATE(877),
    [sym_leave] = STATE(877),
    [sym_continue] = STATE(877),
    [sym_protect] = STATE(877),
    [sym_lock] = STATE(877),
    [sym__literal] = STATE(877),
    [sym_character_literal] = STATE(877),
    [sym_string_literal] = STATE(877),
    [sym_call] = STATE(877),
    [sym_invoke] = STATE(877),
    [sym_indexed_access] = STATE(877),
    [sym_slot_accessor] = STATE(877),
    [sym_true] = STATE(877),
    [sym_false] = STATE(877),
    [sym_maybe] = STATE(877),
    [sym_unset] = STATE(877),
    [sym_super] = STATE(877),
    [sym_self] = STATE(877),
    [sym_clone] = STATE(877),
    [sym_thisthread] = STATE(877),
    [sym_class] = STATE(877),
    [sym__expression] = STATE(877),
    [sym_return] = STATE(877),
    [sym_gather] = STATE(877),
    [sym_scatter] = STATE(877),
    [sym_allresults] = STATE(877),
    [sym_parenthesized_expression] = STATE(877),
    [sym__variable] = STATE(877),
    [sym_variable] = STATE(877),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(877),
    [sym_relational_operator] = STATE(877),
    [sym_logical_operator] = STATE(877),
    [sym_arithmetic_operator] = STATE(877),
    [sym_unary_operator] = STATE(877),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1697),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1697),
    [sym_global_variable] = ACTIONS(1697),
    [sym_global_reference] = ACTIONS(1697),
    [sym_number] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1697),
    [sym_comment] = ACTIONS(103),
  },
  [435] = {
    [sym_procedure] = STATE(671),
    [sym_block] = STATE(671),
    [sym_assignment] = STATE(671),
    [sym_if] = STATE(671),
    [sym_loop] = STATE(671),
    [sym_handling] = STATE(671),
    [sym_catch] = STATE(671),
    [sym_throw] = STATE(671),
    [sym_primitive] = STATE(671),
    [sym_iterator] = STATE(671),
    [sym_while] = STATE(671),
    [sym_try] = STATE(671),
    [sym_loopbody] = STATE(671),
    [sym_leave] = STATE(671),
    [sym_continue] = STATE(671),
    [sym_protect] = STATE(671),
    [sym_lock] = STATE(671),
    [sym__literal] = STATE(671),
    [sym_character_literal] = STATE(671),
    [sym_string_literal] = STATE(671),
    [sym_call] = STATE(671),
    [sym_invoke] = STATE(671),
    [sym_indexed_access] = STATE(671),
    [sym_slot_accessor] = STATE(671),
    [sym_true] = STATE(671),
    [sym_false] = STATE(671),
    [sym_maybe] = STATE(671),
    [sym_unset] = STATE(671),
    [sym_super] = STATE(671),
    [sym_self] = STATE(671),
    [sym_clone] = STATE(671),
    [sym_thisthread] = STATE(671),
    [sym_class] = STATE(671),
    [sym__expression] = STATE(671),
    [sym_return] = STATE(671),
    [sym_gather] = STATE(671),
    [sym_scatter] = STATE(671),
    [sym_allresults] = STATE(671),
    [sym_parenthesized_expression] = STATE(671),
    [sym__variable] = STATE(671),
    [sym_variable] = STATE(671),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(671),
    [sym_relational_operator] = STATE(671),
    [sym_logical_operator] = STATE(671),
    [sym_arithmetic_operator] = STATE(671),
    [sym_unary_operator] = STATE(671),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1699),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1699),
    [sym_global_variable] = ACTIONS(1699),
    [sym_global_reference] = ACTIONS(1699),
    [sym_number] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1699),
    [sym_comment] = ACTIONS(103),
  },
  [436] = {
    [sym_procedure] = STATE(946),
    [sym_block] = STATE(946),
    [sym_assignment] = STATE(946),
    [sym_if] = STATE(946),
    [sym_loop] = STATE(946),
    [sym_handling] = STATE(946),
    [sym_catch] = STATE(946),
    [sym_throw] = STATE(946),
    [sym_primitive] = STATE(946),
    [sym_iterator] = STATE(946),
    [sym_while] = STATE(946),
    [sym_try] = STATE(946),
    [sym_loopbody] = STATE(946),
    [sym_leave] = STATE(946),
    [sym_continue] = STATE(946),
    [sym_protect] = STATE(946),
    [sym_lock] = STATE(946),
    [sym__literal] = STATE(946),
    [sym_character_literal] = STATE(946),
    [sym_string_literal] = STATE(946),
    [sym_call] = STATE(946),
    [sym_invoke] = STATE(946),
    [sym_indexed_access] = STATE(946),
    [sym_slot_accessor] = STATE(946),
    [sym_true] = STATE(946),
    [sym_false] = STATE(946),
    [sym_maybe] = STATE(946),
    [sym_unset] = STATE(946),
    [sym_super] = STATE(946),
    [sym_self] = STATE(946),
    [sym_clone] = STATE(946),
    [sym_thisthread] = STATE(946),
    [sym_class] = STATE(946),
    [sym__expression] = STATE(946),
    [sym_return] = STATE(946),
    [sym_gather] = STATE(946),
    [sym_scatter] = STATE(946),
    [sym_allresults] = STATE(946),
    [sym_parenthesized_expression] = STATE(946),
    [sym__variable] = STATE(946),
    [sym_variable] = STATE(946),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(946),
    [sym_relational_operator] = STATE(946),
    [sym_logical_operator] = STATE(946),
    [sym_arithmetic_operator] = STATE(946),
    [sym_unary_operator] = STATE(946),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1701),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1701),
    [sym_global_variable] = ACTIONS(1701),
    [sym_global_reference] = ACTIONS(1701),
    [sym_number] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1701),
    [sym_comment] = ACTIONS(103),
  },
  [437] = {
    [sym_procedure] = STATE(507),
    [sym_block] = STATE(507),
    [sym_assignment] = STATE(507),
    [sym_if] = STATE(507),
    [sym_loop] = STATE(507),
    [sym_handling] = STATE(507),
    [sym_catch] = STATE(507),
    [sym_throw] = STATE(507),
    [sym_primitive] = STATE(507),
    [sym_iterator] = STATE(507),
    [sym_while] = STATE(507),
    [sym_try] = STATE(507),
    [sym_loopbody] = STATE(507),
    [sym_leave] = STATE(507),
    [sym_continue] = STATE(507),
    [sym_protect] = STATE(507),
    [sym_lock] = STATE(507),
    [sym__literal] = STATE(507),
    [sym_character_literal] = STATE(507),
    [sym_string_literal] = STATE(507),
    [sym_call] = STATE(507),
    [sym_invoke] = STATE(507),
    [sym_indexed_access] = STATE(507),
    [sym_slot_accessor] = STATE(507),
    [sym_true] = STATE(507),
    [sym_false] = STATE(507),
    [sym_maybe] = STATE(507),
    [sym_unset] = STATE(507),
    [sym_super] = STATE(507),
    [sym_self] = STATE(507),
    [sym_clone] = STATE(507),
    [sym_thisthread] = STATE(507),
    [sym_class] = STATE(507),
    [sym__expression] = STATE(507),
    [sym_return] = STATE(507),
    [sym_gather] = STATE(507),
    [sym_scatter] = STATE(507),
    [sym_allresults] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym__variable] = STATE(507),
    [sym_variable] = STATE(507),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(507),
    [sym_relational_operator] = STATE(507),
    [sym_logical_operator] = STATE(507),
    [sym_arithmetic_operator] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1499),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1499),
    [sym_global_variable] = ACTIONS(1499),
    [sym_global_reference] = ACTIONS(1499),
    [sym_number] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1499),
    [sym_comment] = ACTIONS(103),
  },
  [438] = {
    [sym_procedure] = STATE(912),
    [sym_block] = STATE(912),
    [sym_assignment] = STATE(912),
    [sym_if] = STATE(912),
    [sym_loop] = STATE(912),
    [sym_handling] = STATE(912),
    [sym_catch] = STATE(912),
    [sym_throw] = STATE(912),
    [sym_primitive] = STATE(912),
    [sym_iterator] = STATE(912),
    [sym_while] = STATE(912),
    [sym_try] = STATE(912),
    [sym_loopbody] = STATE(912),
    [sym_leave] = STATE(912),
    [sym_continue] = STATE(912),
    [sym_protect] = STATE(912),
    [sym_lock] = STATE(912),
    [sym__literal] = STATE(912),
    [sym_character_literal] = STATE(912),
    [sym_string_literal] = STATE(912),
    [sym_call] = STATE(912),
    [sym_invoke] = STATE(912),
    [sym_indexed_access] = STATE(912),
    [sym_slot_accessor] = STATE(912),
    [sym_true] = STATE(912),
    [sym_false] = STATE(912),
    [sym_maybe] = STATE(912),
    [sym_unset] = STATE(912),
    [sym_super] = STATE(912),
    [sym_self] = STATE(912),
    [sym_clone] = STATE(912),
    [sym_thisthread] = STATE(912),
    [sym_class] = STATE(912),
    [sym__expression] = STATE(912),
    [sym_return] = STATE(912),
    [sym_gather] = STATE(912),
    [sym_scatter] = STATE(912),
    [sym_allresults] = STATE(912),
    [sym_parenthesized_expression] = STATE(912),
    [sym__variable] = STATE(912),
    [sym_variable] = STATE(912),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(912),
    [sym_relational_operator] = STATE(912),
    [sym_logical_operator] = STATE(912),
    [sym_arithmetic_operator] = STATE(912),
    [sym_unary_operator] = STATE(912),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1703),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1703),
    [sym_global_variable] = ACTIONS(1703),
    [sym_global_reference] = ACTIONS(1703),
    [sym_number] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1703),
    [sym_comment] = ACTIONS(103),
  },
  [439] = {
    [sym_procedure] = STATE(922),
    [sym_block] = STATE(922),
    [sym_assignment] = STATE(922),
    [sym_if] = STATE(922),
    [sym_loop] = STATE(922),
    [sym_handling] = STATE(922),
    [sym_catch] = STATE(922),
    [sym_throw] = STATE(922),
    [sym_primitive] = STATE(922),
    [sym_iterator] = STATE(922),
    [sym_while] = STATE(922),
    [sym_try] = STATE(922),
    [sym_loopbody] = STATE(922),
    [sym_leave] = STATE(922),
    [sym_continue] = STATE(922),
    [sym_protect] = STATE(922),
    [sym_lock] = STATE(922),
    [sym__literal] = STATE(922),
    [sym_character_literal] = STATE(922),
    [sym_string_literal] = STATE(922),
    [sym_call] = STATE(922),
    [sym_invoke] = STATE(922),
    [sym_indexed_access] = STATE(922),
    [sym_slot_accessor] = STATE(922),
    [sym_true] = STATE(922),
    [sym_false] = STATE(922),
    [sym_maybe] = STATE(922),
    [sym_unset] = STATE(922),
    [sym_super] = STATE(922),
    [sym_self] = STATE(922),
    [sym_clone] = STATE(922),
    [sym_thisthread] = STATE(922),
    [sym_class] = STATE(922),
    [sym__expression] = STATE(922),
    [sym_return] = STATE(922),
    [sym_gather] = STATE(922),
    [sym_scatter] = STATE(922),
    [sym_allresults] = STATE(922),
    [sym_parenthesized_expression] = STATE(922),
    [sym__variable] = STATE(922),
    [sym_variable] = STATE(922),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(922),
    [sym_relational_operator] = STATE(922),
    [sym_logical_operator] = STATE(922),
    [sym_arithmetic_operator] = STATE(922),
    [sym_unary_operator] = STATE(922),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(1705),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1707),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1707),
    [sym_global_variable] = ACTIONS(1707),
    [sym_global_reference] = ACTIONS(1707),
    [sym_number] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1707),
    [sym_comment] = ACTIONS(103),
  },
  [440] = {
    [sym_procedure] = STATE(935),
    [sym_block] = STATE(935),
    [sym_assignment] = STATE(935),
    [sym_if] = STATE(935),
    [sym_loop] = STATE(935),
    [sym_handling] = STATE(935),
    [sym_catch] = STATE(935),
    [sym_throw] = STATE(935),
    [sym_primitive] = STATE(935),
    [sym_iterator] = STATE(935),
    [sym_while] = STATE(935),
    [sym_try] = STATE(935),
    [sym_loopbody] = STATE(935),
    [sym_leave] = STATE(935),
    [sym_continue] = STATE(935),
    [sym_protect] = STATE(935),
    [sym_lock] = STATE(935),
    [sym__literal] = STATE(935),
    [sym_character_literal] = STATE(935),
    [sym_string_literal] = STATE(935),
    [sym_call] = STATE(935),
    [sym_invoke] = STATE(935),
    [sym_indexed_access] = STATE(935),
    [sym_slot_accessor] = STATE(935),
    [sym_true] = STATE(935),
    [sym_false] = STATE(935),
    [sym_maybe] = STATE(935),
    [sym_unset] = STATE(935),
    [sym_super] = STATE(935),
    [sym_self] = STATE(935),
    [sym_clone] = STATE(935),
    [sym_thisthread] = STATE(935),
    [sym_class] = STATE(935),
    [sym__expression] = STATE(935),
    [sym_return] = STATE(935),
    [sym_gather] = STATE(935),
    [sym_scatter] = STATE(935),
    [sym_allresults] = STATE(935),
    [sym_parenthesized_expression] = STATE(935),
    [sym__variable] = STATE(935),
    [sym_variable] = STATE(935),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(935),
    [sym_relational_operator] = STATE(935),
    [sym_logical_operator] = STATE(935),
    [sym_arithmetic_operator] = STATE(935),
    [sym_unary_operator] = STATE(935),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1711),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1711),
    [sym_global_variable] = ACTIONS(1711),
    [sym_global_reference] = ACTIONS(1711),
    [sym_number] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1711),
    [sym_comment] = ACTIONS(103),
  },
  [441] = {
    [sym_procedure] = STATE(1022),
    [sym_block] = STATE(1022),
    [sym_assignment] = STATE(1022),
    [sym_if] = STATE(1022),
    [sym_loop] = STATE(1022),
    [sym_handling] = STATE(1022),
    [sym_catch] = STATE(1022),
    [sym_throw] = STATE(1022),
    [sym_primitive] = STATE(1022),
    [sym_iterator] = STATE(1022),
    [sym_while] = STATE(1022),
    [sym_try] = STATE(1022),
    [sym_loopbody] = STATE(1022),
    [sym_leave] = STATE(1022),
    [sym_continue] = STATE(1022),
    [sym_protect] = STATE(1022),
    [sym_lock] = STATE(1022),
    [sym__literal] = STATE(1022),
    [sym_character_literal] = STATE(1022),
    [sym_string_literal] = STATE(1022),
    [sym_call] = STATE(1001),
    [sym_invoke] = STATE(1001),
    [sym_indexed_access] = STATE(1022),
    [sym_slot_accessor] = STATE(1022),
    [sym_true] = STATE(1022),
    [sym_false] = STATE(1022),
    [sym_maybe] = STATE(1022),
    [sym_unset] = STATE(1022),
    [sym_super] = STATE(1022),
    [sym_self] = STATE(1022),
    [sym_clone] = STATE(1022),
    [sym_thisthread] = STATE(1022),
    [sym_class] = STATE(1022),
    [sym__expression] = STATE(1022),
    [sym_return] = STATE(1022),
    [sym_gather] = STATE(1022),
    [sym_scatter] = STATE(1022),
    [sym_allresults] = STATE(1022),
    [sym_parenthesized_expression] = STATE(1022),
    [sym__variable] = STATE(1022),
    [sym_variable] = STATE(1022),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1022),
    [sym_relational_operator] = STATE(1022),
    [sym_logical_operator] = STATE(1022),
    [sym_arithmetic_operator] = STATE(1022),
    [sym_unary_operator] = STATE(1022),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1251),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1251),
    [sym_global_variable] = ACTIONS(1251),
    [sym_global_reference] = ACTIONS(1251),
    [sym_number] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1251),
    [sym_comment] = ACTIONS(103),
  },
  [442] = {
    [sym_procedure] = STATE(910),
    [sym_block] = STATE(910),
    [sym_assignment] = STATE(910),
    [sym_if] = STATE(910),
    [sym_loop] = STATE(910),
    [sym_handling] = STATE(910),
    [sym_catch] = STATE(910),
    [sym_throw] = STATE(910),
    [sym_primitive] = STATE(910),
    [sym_iterator] = STATE(910),
    [sym_while] = STATE(910),
    [sym_try] = STATE(910),
    [sym_loopbody] = STATE(910),
    [sym_leave] = STATE(910),
    [sym_continue] = STATE(910),
    [sym_protect] = STATE(910),
    [sym_lock] = STATE(910),
    [sym__literal] = STATE(910),
    [sym_character_literal] = STATE(910),
    [sym_string_literal] = STATE(910),
    [sym_call] = STATE(910),
    [sym_invoke] = STATE(910),
    [sym_indexed_access] = STATE(910),
    [sym_slot_accessor] = STATE(910),
    [sym_true] = STATE(910),
    [sym_false] = STATE(910),
    [sym_maybe] = STATE(910),
    [sym_unset] = STATE(910),
    [sym_super] = STATE(910),
    [sym_self] = STATE(910),
    [sym_clone] = STATE(910),
    [sym_thisthread] = STATE(910),
    [sym_class] = STATE(910),
    [sym__expression] = STATE(910),
    [sym_return] = STATE(910),
    [sym_gather] = STATE(910),
    [sym_scatter] = STATE(910),
    [sym_allresults] = STATE(910),
    [sym_parenthesized_expression] = STATE(910),
    [sym__variable] = STATE(910),
    [sym_variable] = STATE(910),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(910),
    [sym_relational_operator] = STATE(910),
    [sym_logical_operator] = STATE(910),
    [sym_arithmetic_operator] = STATE(910),
    [sym_unary_operator] = STATE(910),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1713),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1713),
    [sym_global_variable] = ACTIONS(1713),
    [sym_global_reference] = ACTIONS(1713),
    [sym_number] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1713),
    [sym_comment] = ACTIONS(103),
  },
  [443] = {
    [sym_procedure] = STATE(915),
    [sym_block] = STATE(915),
    [sym_assignment] = STATE(915),
    [sym_if] = STATE(915),
    [sym_loop] = STATE(915),
    [sym_handling] = STATE(915),
    [sym_catch] = STATE(915),
    [sym_throw] = STATE(915),
    [sym_primitive] = STATE(915),
    [sym_iterator] = STATE(915),
    [sym_while] = STATE(915),
    [sym_try] = STATE(915),
    [sym_loopbody] = STATE(915),
    [sym_leave] = STATE(915),
    [sym_continue] = STATE(915),
    [sym_protect] = STATE(915),
    [sym_lock] = STATE(915),
    [sym__literal] = STATE(915),
    [sym_character_literal] = STATE(915),
    [sym_string_literal] = STATE(915),
    [sym_call] = STATE(915),
    [sym_invoke] = STATE(915),
    [sym_indexed_access] = STATE(915),
    [sym_slot_accessor] = STATE(915),
    [sym_true] = STATE(915),
    [sym_false] = STATE(915),
    [sym_maybe] = STATE(915),
    [sym_unset] = STATE(915),
    [sym_super] = STATE(915),
    [sym_self] = STATE(915),
    [sym_clone] = STATE(915),
    [sym_thisthread] = STATE(915),
    [sym_class] = STATE(915),
    [sym__expression] = STATE(915),
    [sym_return] = STATE(915),
    [sym_gather] = STATE(915),
    [sym_scatter] = STATE(915),
    [sym_allresults] = STATE(915),
    [sym_parenthesized_expression] = STATE(915),
    [sym__variable] = STATE(915),
    [sym_variable] = STATE(915),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(915),
    [sym_relational_operator] = STATE(915),
    [sym_logical_operator] = STATE(915),
    [sym_arithmetic_operator] = STATE(915),
    [sym_unary_operator] = STATE(915),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1715),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1715),
    [sym_global_variable] = ACTIONS(1715),
    [sym_global_reference] = ACTIONS(1715),
    [sym_number] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1715),
    [sym_comment] = ACTIONS(103),
  },
  [444] = {
    [sym_procedure] = STATE(969),
    [sym_block] = STATE(969),
    [sym_assignment] = STATE(969),
    [sym_if] = STATE(969),
    [sym_loop] = STATE(969),
    [sym_handling] = STATE(969),
    [sym_catch] = STATE(969),
    [sym_throw] = STATE(969),
    [sym_primitive] = STATE(969),
    [sym_iterator] = STATE(969),
    [sym_while] = STATE(969),
    [sym_try] = STATE(969),
    [sym_loopbody] = STATE(969),
    [sym_leave] = STATE(969),
    [sym_continue] = STATE(969),
    [sym_protect] = STATE(969),
    [sym_lock] = STATE(969),
    [sym__literal] = STATE(969),
    [sym_character_literal] = STATE(969),
    [sym_string_literal] = STATE(969),
    [sym_call] = STATE(969),
    [sym_invoke] = STATE(969),
    [sym_indexed_access] = STATE(969),
    [sym_slot_accessor] = STATE(969),
    [sym_true] = STATE(969),
    [sym_false] = STATE(969),
    [sym_maybe] = STATE(969),
    [sym_unset] = STATE(969),
    [sym_super] = STATE(969),
    [sym_self] = STATE(969),
    [sym_clone] = STATE(969),
    [sym_thisthread] = STATE(969),
    [sym_class] = STATE(969),
    [sym__expression] = STATE(969),
    [sym_return] = STATE(969),
    [sym_gather] = STATE(969),
    [sym_scatter] = STATE(969),
    [sym_allresults] = STATE(969),
    [sym_parenthesized_expression] = STATE(969),
    [sym__variable] = STATE(969),
    [sym_variable] = STATE(969),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(969),
    [sym_relational_operator] = STATE(969),
    [sym_logical_operator] = STATE(969),
    [sym_arithmetic_operator] = STATE(969),
    [sym_unary_operator] = STATE(969),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1717),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1717),
    [sym_global_variable] = ACTIONS(1717),
    [sym_global_reference] = ACTIONS(1717),
    [sym_number] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1717),
    [sym_comment] = ACTIONS(103),
  },
  [445] = {
    [sym_procedure] = STATE(723),
    [sym_block] = STATE(723),
    [sym_assignment] = STATE(723),
    [sym_if] = STATE(723),
    [sym_loop] = STATE(723),
    [sym_handling] = STATE(723),
    [sym_catch] = STATE(723),
    [sym_throw] = STATE(723),
    [sym_primitive] = STATE(723),
    [sym_iterator] = STATE(723),
    [sym_while] = STATE(723),
    [sym_try] = STATE(723),
    [sym_loopbody] = STATE(723),
    [sym_leave] = STATE(723),
    [sym_continue] = STATE(723),
    [sym_protect] = STATE(723),
    [sym_lock] = STATE(723),
    [sym__literal] = STATE(723),
    [sym_character_literal] = STATE(723),
    [sym_string_literal] = STATE(723),
    [sym_call] = STATE(723),
    [sym_invoke] = STATE(723),
    [sym_indexed_access] = STATE(723),
    [sym_slot_accessor] = STATE(723),
    [sym_true] = STATE(723),
    [sym_false] = STATE(723),
    [sym_maybe] = STATE(723),
    [sym_unset] = STATE(723),
    [sym_super] = STATE(723),
    [sym_self] = STATE(723),
    [sym_clone] = STATE(723),
    [sym_thisthread] = STATE(723),
    [sym_class] = STATE(723),
    [sym__expression] = STATE(723),
    [sym_return] = STATE(723),
    [sym_gather] = STATE(723),
    [sym_scatter] = STATE(723),
    [sym_allresults] = STATE(723),
    [sym_parenthesized_expression] = STATE(723),
    [sym__variable] = STATE(723),
    [sym_variable] = STATE(723),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(723),
    [sym_relational_operator] = STATE(723),
    [sym_logical_operator] = STATE(723),
    [sym_arithmetic_operator] = STATE(723),
    [sym_unary_operator] = STATE(723),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(1705),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1719),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1719),
    [sym_global_variable] = ACTIONS(1719),
    [sym_global_reference] = ACTIONS(1719),
    [sym_number] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1719),
    [sym_comment] = ACTIONS(103),
  },
  [446] = {
    [sym_procedure] = STATE(665),
    [sym_block] = STATE(665),
    [sym_assignment] = STATE(665),
    [sym_if] = STATE(665),
    [sym_loop] = STATE(665),
    [sym_handling] = STATE(665),
    [sym_catch] = STATE(665),
    [sym_throw] = STATE(665),
    [sym_primitive] = STATE(665),
    [sym_iterator] = STATE(665),
    [sym_while] = STATE(665),
    [sym_try] = STATE(665),
    [sym_loopbody] = STATE(665),
    [sym_leave] = STATE(665),
    [sym_continue] = STATE(665),
    [sym_protect] = STATE(665),
    [sym_lock] = STATE(665),
    [sym__literal] = STATE(665),
    [sym_character_literal] = STATE(665),
    [sym_string_literal] = STATE(665),
    [sym_call] = STATE(665),
    [sym_invoke] = STATE(665),
    [sym_indexed_access] = STATE(665),
    [sym_slot_accessor] = STATE(665),
    [sym_true] = STATE(665),
    [sym_false] = STATE(665),
    [sym_maybe] = STATE(665),
    [sym_unset] = STATE(665),
    [sym_super] = STATE(665),
    [sym_self] = STATE(665),
    [sym_clone] = STATE(665),
    [sym_thisthread] = STATE(665),
    [sym_class] = STATE(665),
    [sym__expression] = STATE(665),
    [sym_return] = STATE(665),
    [sym_gather] = STATE(665),
    [sym_scatter] = STATE(665),
    [sym_allresults] = STATE(665),
    [sym_parenthesized_expression] = STATE(665),
    [sym__variable] = STATE(665),
    [sym_variable] = STATE(665),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(665),
    [sym_relational_operator] = STATE(665),
    [sym_logical_operator] = STATE(665),
    [sym_arithmetic_operator] = STATE(665),
    [sym_unary_operator] = STATE(665),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1721),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1721),
    [sym_global_variable] = ACTIONS(1721),
    [sym_global_reference] = ACTIONS(1721),
    [sym_number] = ACTIONS(1721),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1721),
    [sym_comment] = ACTIONS(103),
  },
  [447] = {
    [sym_procedure] = STATE(924),
    [sym_block] = STATE(924),
    [sym_assignment] = STATE(924),
    [sym_if] = STATE(924),
    [sym_loop] = STATE(924),
    [sym_handling] = STATE(924),
    [sym_catch] = STATE(924),
    [sym_throw] = STATE(924),
    [sym_primitive] = STATE(924),
    [sym_iterator] = STATE(924),
    [sym_while] = STATE(924),
    [sym_try] = STATE(924),
    [sym_loopbody] = STATE(924),
    [sym_leave] = STATE(924),
    [sym_continue] = STATE(924),
    [sym_protect] = STATE(924),
    [sym_lock] = STATE(924),
    [sym__literal] = STATE(924),
    [sym_character_literal] = STATE(924),
    [sym_string_literal] = STATE(924),
    [sym_call] = STATE(924),
    [sym_invoke] = STATE(924),
    [sym_indexed_access] = STATE(924),
    [sym_slot_accessor] = STATE(924),
    [sym_true] = STATE(924),
    [sym_false] = STATE(924),
    [sym_maybe] = STATE(924),
    [sym_unset] = STATE(924),
    [sym_super] = STATE(924),
    [sym_self] = STATE(924),
    [sym_clone] = STATE(924),
    [sym_thisthread] = STATE(924),
    [sym_class] = STATE(924),
    [sym__expression] = STATE(924),
    [sym_return] = STATE(924),
    [sym_gather] = STATE(924),
    [sym_scatter] = STATE(924),
    [sym_allresults] = STATE(924),
    [sym_parenthesized_expression] = STATE(924),
    [sym__variable] = STATE(924),
    [sym_variable] = STATE(924),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(924),
    [sym_relational_operator] = STATE(924),
    [sym_logical_operator] = STATE(924),
    [sym_arithmetic_operator] = STATE(924),
    [sym_unary_operator] = STATE(924),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1723),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1723),
    [sym_global_variable] = ACTIONS(1723),
    [sym_global_reference] = ACTIONS(1723),
    [sym_number] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1723),
    [sym_comment] = ACTIONS(103),
  },
  [448] = {
    [sym_procedure] = STATE(1005),
    [sym_block] = STATE(1005),
    [sym_assignment] = STATE(1005),
    [sym_if] = STATE(1005),
    [sym_loop] = STATE(1005),
    [sym_handling] = STATE(1005),
    [sym_catch] = STATE(1005),
    [sym_throw] = STATE(1005),
    [sym_primitive] = STATE(1005),
    [sym_iterator] = STATE(1005),
    [sym_while] = STATE(1005),
    [sym_try] = STATE(1005),
    [sym_loopbody] = STATE(1005),
    [sym_leave] = STATE(1005),
    [sym_continue] = STATE(1005),
    [sym_protect] = STATE(1005),
    [sym_lock] = STATE(1005),
    [sym__literal] = STATE(1005),
    [sym_character_literal] = STATE(1005),
    [sym_string_literal] = STATE(1005),
    [sym_call] = STATE(1005),
    [sym_invoke] = STATE(1005),
    [sym_indexed_access] = STATE(1005),
    [sym_slot_accessor] = STATE(1005),
    [sym_true] = STATE(1005),
    [sym_false] = STATE(1005),
    [sym_maybe] = STATE(1005),
    [sym_unset] = STATE(1005),
    [sym_super] = STATE(1005),
    [sym_self] = STATE(1005),
    [sym_clone] = STATE(1005),
    [sym_thisthread] = STATE(1005),
    [sym_class] = STATE(1005),
    [sym__expression] = STATE(1005),
    [sym_return] = STATE(1005),
    [sym_gather] = STATE(1005),
    [sym_scatter] = STATE(1005),
    [sym_allresults] = STATE(1005),
    [sym_parenthesized_expression] = STATE(1005),
    [sym__variable] = STATE(1005),
    [sym_variable] = STATE(1005),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1005),
    [sym_relational_operator] = STATE(1005),
    [sym_logical_operator] = STATE(1005),
    [sym_arithmetic_operator] = STATE(1005),
    [sym_unary_operator] = STATE(1005),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1725),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1725),
    [sym_global_variable] = ACTIONS(1725),
    [sym_global_reference] = ACTIONS(1725),
    [sym_number] = ACTIONS(1725),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1725),
    [sym_comment] = ACTIONS(103),
  },
  [449] = {
    [sym_procedure] = STATE(934),
    [sym_block] = STATE(934),
    [sym_assignment] = STATE(934),
    [sym_if] = STATE(934),
    [sym_loop] = STATE(934),
    [sym_handling] = STATE(934),
    [sym_catch] = STATE(934),
    [sym_throw] = STATE(934),
    [sym_primitive] = STATE(934),
    [sym_iterator] = STATE(934),
    [sym_while] = STATE(934),
    [sym_try] = STATE(934),
    [sym_loopbody] = STATE(934),
    [sym_leave] = STATE(934),
    [sym_continue] = STATE(934),
    [sym_protect] = STATE(934),
    [sym_lock] = STATE(934),
    [sym__literal] = STATE(934),
    [sym_character_literal] = STATE(934),
    [sym_string_literal] = STATE(934),
    [sym_call] = STATE(934),
    [sym_invoke] = STATE(934),
    [sym_indexed_access] = STATE(934),
    [sym_slot_accessor] = STATE(934),
    [sym_true] = STATE(934),
    [sym_false] = STATE(934),
    [sym_maybe] = STATE(934),
    [sym_unset] = STATE(934),
    [sym_super] = STATE(934),
    [sym_self] = STATE(934),
    [sym_clone] = STATE(934),
    [sym_thisthread] = STATE(934),
    [sym_class] = STATE(934),
    [sym__expression] = STATE(934),
    [sym_return] = STATE(934),
    [sym_gather] = STATE(934),
    [sym_scatter] = STATE(934),
    [sym_allresults] = STATE(934),
    [sym_parenthesized_expression] = STATE(934),
    [sym__variable] = STATE(934),
    [sym_variable] = STATE(934),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(934),
    [sym_relational_operator] = STATE(934),
    [sym_logical_operator] = STATE(934),
    [sym_arithmetic_operator] = STATE(934),
    [sym_unary_operator] = STATE(934),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1729),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1729),
    [sym_global_variable] = ACTIONS(1729),
    [sym_global_reference] = ACTIONS(1729),
    [sym_number] = ACTIONS(1729),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1729),
    [sym_comment] = ACTIONS(103),
  },
  [450] = {
    [sym_procedure] = STATE(660),
    [sym_block] = STATE(660),
    [sym_assignment] = STATE(660),
    [sym_if] = STATE(660),
    [sym_loop] = STATE(660),
    [sym_handling] = STATE(660),
    [sym_catch] = STATE(660),
    [sym_throw] = STATE(660),
    [sym_primitive] = STATE(660),
    [sym_iterator] = STATE(660),
    [sym_while] = STATE(660),
    [sym_try] = STATE(660),
    [sym_loopbody] = STATE(660),
    [sym_leave] = STATE(660),
    [sym_continue] = STATE(660),
    [sym_protect] = STATE(660),
    [sym_lock] = STATE(660),
    [sym__literal] = STATE(660),
    [sym_character_literal] = STATE(660),
    [sym_string_literal] = STATE(660),
    [sym_call] = STATE(660),
    [sym_invoke] = STATE(660),
    [sym_indexed_access] = STATE(660),
    [sym_slot_accessor] = STATE(660),
    [sym_true] = STATE(660),
    [sym_false] = STATE(660),
    [sym_maybe] = STATE(660),
    [sym_unset] = STATE(660),
    [sym_super] = STATE(660),
    [sym_self] = STATE(660),
    [sym_clone] = STATE(660),
    [sym_thisthread] = STATE(660),
    [sym_class] = STATE(660),
    [sym__expression] = STATE(660),
    [sym_return] = STATE(660),
    [sym_gather] = STATE(660),
    [sym_scatter] = STATE(660),
    [sym_allresults] = STATE(660),
    [sym_parenthesized_expression] = STATE(660),
    [sym__variable] = STATE(660),
    [sym_variable] = STATE(660),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(660),
    [sym_relational_operator] = STATE(660),
    [sym_logical_operator] = STATE(660),
    [sym_arithmetic_operator] = STATE(660),
    [sym_unary_operator] = STATE(660),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1731),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1731),
    [sym_global_variable] = ACTIONS(1731),
    [sym_global_reference] = ACTIONS(1731),
    [sym_number] = ACTIONS(1731),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1731),
    [sym_comment] = ACTIONS(103),
  },
  [451] = {
    [sym_procedure] = STATE(716),
    [sym_block] = STATE(716),
    [sym_assignment] = STATE(716),
    [sym_if] = STATE(716),
    [sym_loop] = STATE(716),
    [sym_handling] = STATE(716),
    [sym_catch] = STATE(716),
    [sym_throw] = STATE(716),
    [sym_primitive] = STATE(716),
    [sym_iterator] = STATE(716),
    [sym_while] = STATE(716),
    [sym_try] = STATE(716),
    [sym_loopbody] = STATE(716),
    [sym_leave] = STATE(716),
    [sym_continue] = STATE(716),
    [sym_protect] = STATE(716),
    [sym_lock] = STATE(716),
    [sym__literal] = STATE(716),
    [sym_character_literal] = STATE(716),
    [sym_string_literal] = STATE(716),
    [sym_call] = STATE(716),
    [sym_invoke] = STATE(716),
    [sym_indexed_access] = STATE(716),
    [sym_slot_accessor] = STATE(716),
    [sym_true] = STATE(716),
    [sym_false] = STATE(716),
    [sym_maybe] = STATE(716),
    [sym_unset] = STATE(716),
    [sym_super] = STATE(716),
    [sym_self] = STATE(716),
    [sym_clone] = STATE(716),
    [sym_thisthread] = STATE(716),
    [sym_class] = STATE(716),
    [sym__expression] = STATE(716),
    [sym_return] = STATE(716),
    [sym_gather] = STATE(716),
    [sym_scatter] = STATE(716),
    [sym_allresults] = STATE(716),
    [sym_parenthesized_expression] = STATE(716),
    [sym__variable] = STATE(716),
    [sym_variable] = STATE(716),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(716),
    [sym_relational_operator] = STATE(716),
    [sym_logical_operator] = STATE(716),
    [sym_arithmetic_operator] = STATE(716),
    [sym_unary_operator] = STATE(716),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(1709),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1733),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1733),
    [sym_global_variable] = ACTIONS(1733),
    [sym_global_reference] = ACTIONS(1733),
    [sym_number] = ACTIONS(1733),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1733),
    [sym_comment] = ACTIONS(103),
  },
  [452] = {
    [sym_procedure] = STATE(933),
    [sym_block] = STATE(933),
    [sym_assignment] = STATE(933),
    [sym_if] = STATE(933),
    [sym_loop] = STATE(933),
    [sym_handling] = STATE(933),
    [sym_catch] = STATE(933),
    [sym_throw] = STATE(933),
    [sym_primitive] = STATE(933),
    [sym_iterator] = STATE(933),
    [sym_while] = STATE(933),
    [sym_try] = STATE(933),
    [sym_loopbody] = STATE(933),
    [sym_leave] = STATE(933),
    [sym_continue] = STATE(933),
    [sym_protect] = STATE(933),
    [sym_lock] = STATE(933),
    [sym__literal] = STATE(933),
    [sym_character_literal] = STATE(933),
    [sym_string_literal] = STATE(933),
    [sym_call] = STATE(933),
    [sym_invoke] = STATE(933),
    [sym_indexed_access] = STATE(933),
    [sym_slot_accessor] = STATE(933),
    [sym_true] = STATE(933),
    [sym_false] = STATE(933),
    [sym_maybe] = STATE(933),
    [sym_unset] = STATE(933),
    [sym_super] = STATE(933),
    [sym_self] = STATE(933),
    [sym_clone] = STATE(933),
    [sym_thisthread] = STATE(933),
    [sym_class] = STATE(933),
    [sym__expression] = STATE(933),
    [sym_return] = STATE(933),
    [sym_gather] = STATE(933),
    [sym_scatter] = STATE(933),
    [sym_allresults] = STATE(933),
    [sym_parenthesized_expression] = STATE(933),
    [sym__variable] = STATE(933),
    [sym_variable] = STATE(933),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(933),
    [sym_relational_operator] = STATE(933),
    [sym_logical_operator] = STATE(933),
    [sym_arithmetic_operator] = STATE(933),
    [sym_unary_operator] = STATE(933),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1737),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1737),
    [sym_global_variable] = ACTIONS(1737),
    [sym_global_reference] = ACTIONS(1737),
    [sym_number] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1737),
    [sym_comment] = ACTIONS(103),
  },
  [453] = {
    [sym_procedure] = STATE(947),
    [sym_block] = STATE(947),
    [sym_assignment] = STATE(947),
    [sym_if] = STATE(947),
    [sym_loop] = STATE(947),
    [sym_handling] = STATE(947),
    [sym_catch] = STATE(947),
    [sym_throw] = STATE(947),
    [sym_primitive] = STATE(947),
    [sym_iterator] = STATE(947),
    [sym_while] = STATE(947),
    [sym_try] = STATE(947),
    [sym_loopbody] = STATE(947),
    [sym_leave] = STATE(947),
    [sym_continue] = STATE(947),
    [sym_protect] = STATE(947),
    [sym_lock] = STATE(947),
    [sym__literal] = STATE(947),
    [sym_character_literal] = STATE(947),
    [sym_string_literal] = STATE(947),
    [sym_call] = STATE(947),
    [sym_invoke] = STATE(947),
    [sym_indexed_access] = STATE(947),
    [sym_slot_accessor] = STATE(947),
    [sym_true] = STATE(947),
    [sym_false] = STATE(947),
    [sym_maybe] = STATE(947),
    [sym_unset] = STATE(947),
    [sym_super] = STATE(947),
    [sym_self] = STATE(947),
    [sym_clone] = STATE(947),
    [sym_thisthread] = STATE(947),
    [sym_class] = STATE(947),
    [sym__expression] = STATE(947),
    [sym_return] = STATE(947),
    [sym_gather] = STATE(947),
    [sym_scatter] = STATE(947),
    [sym_allresults] = STATE(947),
    [sym_parenthesized_expression] = STATE(947),
    [sym__variable] = STATE(947),
    [sym_variable] = STATE(947),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(947),
    [sym_relational_operator] = STATE(947),
    [sym_logical_operator] = STATE(947),
    [sym_arithmetic_operator] = STATE(947),
    [sym_unary_operator] = STATE(947),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1739),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1739),
    [sym_global_variable] = ACTIONS(1739),
    [sym_global_reference] = ACTIONS(1739),
    [sym_number] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1739),
    [sym_comment] = ACTIONS(103),
  },
  [454] = {
    [sym_procedure] = STATE(1018),
    [sym_block] = STATE(1018),
    [sym_assignment] = STATE(1018),
    [sym_if] = STATE(1018),
    [sym_loop] = STATE(1018),
    [sym_handling] = STATE(1018),
    [sym_catch] = STATE(1018),
    [sym_throw] = STATE(1018),
    [sym_primitive] = STATE(1018),
    [sym_iterator] = STATE(1018),
    [sym_while] = STATE(1018),
    [sym_try] = STATE(1018),
    [sym_loopbody] = STATE(1018),
    [sym_leave] = STATE(1018),
    [sym_continue] = STATE(1018),
    [sym_protect] = STATE(1018),
    [sym_lock] = STATE(1018),
    [sym__literal] = STATE(1018),
    [sym_character_literal] = STATE(1018),
    [sym_string_literal] = STATE(1018),
    [sym_call] = STATE(1018),
    [sym_invoke] = STATE(1018),
    [sym_indexed_access] = STATE(1018),
    [sym_slot_accessor] = STATE(1018),
    [sym_true] = STATE(1018),
    [sym_false] = STATE(1018),
    [sym_maybe] = STATE(1018),
    [sym_unset] = STATE(1018),
    [sym_super] = STATE(1018),
    [sym_self] = STATE(1018),
    [sym_clone] = STATE(1018),
    [sym_thisthread] = STATE(1018),
    [sym_class] = STATE(1018),
    [sym__expression] = STATE(1018),
    [sym_return] = STATE(1018),
    [sym_gather] = STATE(1018),
    [sym_scatter] = STATE(1018),
    [sym_allresults] = STATE(1018),
    [sym_parenthesized_expression] = STATE(1018),
    [sym__variable] = STATE(1018),
    [sym_variable] = STATE(1018),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1018),
    [sym_relational_operator] = STATE(1018),
    [sym_logical_operator] = STATE(1018),
    [sym_arithmetic_operator] = STATE(1018),
    [sym_unary_operator] = STATE(1018),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1741),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1741),
    [sym_global_variable] = ACTIONS(1741),
    [sym_global_reference] = ACTIONS(1741),
    [sym_number] = ACTIONS(1741),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1741),
    [sym_comment] = ACTIONS(103),
  },
  [455] = {
    [sym_procedure] = STATE(641),
    [sym_block] = STATE(641),
    [sym_assignment] = STATE(641),
    [sym_if] = STATE(641),
    [sym_loop] = STATE(641),
    [sym_handling] = STATE(641),
    [sym_catch] = STATE(641),
    [sym_throw] = STATE(641),
    [sym_primitive] = STATE(641),
    [sym_iterator] = STATE(641),
    [sym_while] = STATE(641),
    [sym_try] = STATE(641),
    [sym_loopbody] = STATE(641),
    [sym_leave] = STATE(641),
    [sym_continue] = STATE(641),
    [sym_protect] = STATE(641),
    [sym_lock] = STATE(641),
    [sym__literal] = STATE(641),
    [sym_character_literal] = STATE(641),
    [sym_string_literal] = STATE(641),
    [sym_call] = STATE(641),
    [sym_invoke] = STATE(641),
    [sym_indexed_access] = STATE(641),
    [sym_slot_accessor] = STATE(641),
    [sym_true] = STATE(641),
    [sym_false] = STATE(641),
    [sym_maybe] = STATE(641),
    [sym_unset] = STATE(641),
    [sym_super] = STATE(641),
    [sym_self] = STATE(641),
    [sym_clone] = STATE(641),
    [sym_thisthread] = STATE(641),
    [sym_class] = STATE(641),
    [sym__expression] = STATE(641),
    [sym_return] = STATE(641),
    [sym_gather] = STATE(641),
    [sym_scatter] = STATE(641),
    [sym_allresults] = STATE(641),
    [sym_parenthesized_expression] = STATE(641),
    [sym__variable] = STATE(641),
    [sym_variable] = STATE(641),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(641),
    [sym_relational_operator] = STATE(641),
    [sym_logical_operator] = STATE(641),
    [sym_arithmetic_operator] = STATE(641),
    [sym_unary_operator] = STATE(641),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1743),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1743),
    [sym_global_variable] = ACTIONS(1743),
    [sym_global_reference] = ACTIONS(1743),
    [sym_number] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1743),
    [sym_comment] = ACTIONS(103),
  },
  [456] = {
    [sym_procedure] = STATE(635),
    [sym_block] = STATE(635),
    [sym_assignment] = STATE(635),
    [sym_if] = STATE(635),
    [sym_loop] = STATE(635),
    [sym_handling] = STATE(635),
    [sym_catch] = STATE(635),
    [sym_throw] = STATE(635),
    [sym_primitive] = STATE(635),
    [sym_iterator] = STATE(635),
    [sym_while] = STATE(635),
    [sym_try] = STATE(635),
    [sym_loopbody] = STATE(635),
    [sym_leave] = STATE(635),
    [sym_continue] = STATE(635),
    [sym_protect] = STATE(635),
    [sym_lock] = STATE(635),
    [sym__literal] = STATE(635),
    [sym_character_literal] = STATE(635),
    [sym_string_literal] = STATE(635),
    [sym_call] = STATE(635),
    [sym_invoke] = STATE(635),
    [sym_indexed_access] = STATE(635),
    [sym_slot_accessor] = STATE(635),
    [sym_true] = STATE(635),
    [sym_false] = STATE(635),
    [sym_maybe] = STATE(635),
    [sym_unset] = STATE(635),
    [sym_super] = STATE(635),
    [sym_self] = STATE(635),
    [sym_clone] = STATE(635),
    [sym_thisthread] = STATE(635),
    [sym_class] = STATE(635),
    [sym__expression] = STATE(635),
    [sym_return] = STATE(635),
    [sym_gather] = STATE(635),
    [sym_scatter] = STATE(635),
    [sym_allresults] = STATE(635),
    [sym_parenthesized_expression] = STATE(635),
    [sym__variable] = STATE(635),
    [sym_variable] = STATE(635),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(635),
    [sym_relational_operator] = STATE(635),
    [sym_logical_operator] = STATE(635),
    [sym_arithmetic_operator] = STATE(635),
    [sym_unary_operator] = STATE(635),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1745),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1745),
    [sym_global_variable] = ACTIONS(1745),
    [sym_global_reference] = ACTIONS(1745),
    [sym_number] = ACTIONS(1745),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1745),
    [sym_comment] = ACTIONS(103),
  },
  [457] = {
    [sym_procedure] = STATE(669),
    [sym_block] = STATE(669),
    [sym_assignment] = STATE(669),
    [sym_if] = STATE(669),
    [sym_loop] = STATE(669),
    [sym_handling] = STATE(669),
    [sym_catch] = STATE(669),
    [sym_throw] = STATE(669),
    [sym_primitive] = STATE(669),
    [sym_iterator] = STATE(669),
    [sym_while] = STATE(669),
    [sym_try] = STATE(669),
    [sym_loopbody] = STATE(669),
    [sym_leave] = STATE(669),
    [sym_continue] = STATE(669),
    [sym_protect] = STATE(669),
    [sym_lock] = STATE(669),
    [sym__literal] = STATE(669),
    [sym_character_literal] = STATE(669),
    [sym_string_literal] = STATE(669),
    [sym_call] = STATE(669),
    [sym_invoke] = STATE(669),
    [sym_indexed_access] = STATE(669),
    [sym_slot_accessor] = STATE(669),
    [sym_true] = STATE(669),
    [sym_false] = STATE(669),
    [sym_maybe] = STATE(669),
    [sym_unset] = STATE(669),
    [sym_super] = STATE(669),
    [sym_self] = STATE(669),
    [sym_clone] = STATE(669),
    [sym_thisthread] = STATE(669),
    [sym_class] = STATE(669),
    [sym__expression] = STATE(669),
    [sym_return] = STATE(669),
    [sym_gather] = STATE(669),
    [sym_scatter] = STATE(669),
    [sym_allresults] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym__variable] = STATE(669),
    [sym_variable] = STATE(669),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(669),
    [sym_relational_operator] = STATE(669),
    [sym_logical_operator] = STATE(669),
    [sym_arithmetic_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1747),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1747),
    [sym_global_variable] = ACTIONS(1747),
    [sym_global_reference] = ACTIONS(1747),
    [sym_number] = ACTIONS(1747),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1747),
    [sym_comment] = ACTIONS(103),
  },
  [458] = {
    [sym_procedure] = STATE(958),
    [sym_block] = STATE(958),
    [sym_assignment] = STATE(958),
    [sym_if] = STATE(958),
    [sym_loop] = STATE(958),
    [sym_handling] = STATE(958),
    [sym_catch] = STATE(958),
    [sym_throw] = STATE(958),
    [sym_primitive] = STATE(958),
    [sym_iterator] = STATE(958),
    [sym_while] = STATE(958),
    [sym_try] = STATE(958),
    [sym_loopbody] = STATE(958),
    [sym_leave] = STATE(958),
    [sym_continue] = STATE(958),
    [sym_protect] = STATE(958),
    [sym_lock] = STATE(958),
    [sym__literal] = STATE(958),
    [sym_character_literal] = STATE(958),
    [sym_string_literal] = STATE(958),
    [sym_call] = STATE(958),
    [sym_invoke] = STATE(958),
    [sym_indexed_access] = STATE(958),
    [sym_slot_accessor] = STATE(958),
    [sym_true] = STATE(958),
    [sym_false] = STATE(958),
    [sym_maybe] = STATE(958),
    [sym_unset] = STATE(958),
    [sym_super] = STATE(958),
    [sym_self] = STATE(958),
    [sym_clone] = STATE(958),
    [sym_thisthread] = STATE(958),
    [sym_class] = STATE(958),
    [sym__expression] = STATE(958),
    [sym_return] = STATE(958),
    [sym_gather] = STATE(958),
    [sym_scatter] = STATE(958),
    [sym_allresults] = STATE(958),
    [sym_parenthesized_expression] = STATE(958),
    [sym__variable] = STATE(958),
    [sym_variable] = STATE(958),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(958),
    [sym_relational_operator] = STATE(958),
    [sym_logical_operator] = STATE(958),
    [sym_arithmetic_operator] = STATE(958),
    [sym_unary_operator] = STATE(958),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(971),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(973),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(977),
    [aux_sym_continue_token1] = ACTIONS(979),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1749),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(997),
    [aux_sym_allresults_token1] = ACTIONS(999),
    [sym_dynamic_variable] = ACTIONS(1749),
    [sym_global_variable] = ACTIONS(1749),
    [sym_global_reference] = ACTIONS(1749),
    [sym_number] = ACTIONS(1749),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1001),
    [anon_sym_PLUS] = ACTIONS(1001),
    [aux_sym_unary_operator_token1] = ACTIONS(1001),
    [anon_sym_TILDE] = ACTIONS(1001),
    [sym_symbol] = ACTIONS(1749),
    [sym_comment] = ACTIONS(103),
  },
  [459] = {
    [sym_procedure] = STATE(653),
    [sym_block] = STATE(653),
    [sym_assignment] = STATE(653),
    [sym_if] = STATE(653),
    [sym_loop] = STATE(653),
    [sym_handling] = STATE(653),
    [sym_catch] = STATE(653),
    [sym_throw] = STATE(653),
    [sym_primitive] = STATE(653),
    [sym_iterator] = STATE(653),
    [sym_while] = STATE(653),
    [sym_try] = STATE(653),
    [sym_loopbody] = STATE(653),
    [sym_leave] = STATE(653),
    [sym_continue] = STATE(653),
    [sym_protect] = STATE(653),
    [sym_lock] = STATE(653),
    [sym__literal] = STATE(653),
    [sym_character_literal] = STATE(653),
    [sym_string_literal] = STATE(653),
    [sym_call] = STATE(653),
    [sym_invoke] = STATE(653),
    [sym_indexed_access] = STATE(653),
    [sym_slot_accessor] = STATE(653),
    [sym_true] = STATE(653),
    [sym_false] = STATE(653),
    [sym_maybe] = STATE(653),
    [sym_unset] = STATE(653),
    [sym_super] = STATE(653),
    [sym_self] = STATE(653),
    [sym_clone] = STATE(653),
    [sym_thisthread] = STATE(653),
    [sym_class] = STATE(653),
    [sym__expression] = STATE(653),
    [sym_return] = STATE(653),
    [sym_gather] = STATE(653),
    [sym_scatter] = STATE(653),
    [sym_allresults] = STATE(653),
    [sym_parenthesized_expression] = STATE(653),
    [sym__variable] = STATE(653),
    [sym_variable] = STATE(653),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(653),
    [sym_relational_operator] = STATE(653),
    [sym_logical_operator] = STATE(653),
    [sym_arithmetic_operator] = STATE(653),
    [sym_unary_operator] = STATE(653),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1751),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1751),
    [sym_global_variable] = ACTIONS(1751),
    [sym_global_reference] = ACTIONS(1751),
    [sym_number] = ACTIONS(1751),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1751),
    [sym_comment] = ACTIONS(103),
  },
  [460] = {
    [sym_procedure] = STATE(666),
    [sym_block] = STATE(666),
    [sym_assignment] = STATE(666),
    [sym_if] = STATE(666),
    [sym_loop] = STATE(666),
    [sym_handling] = STATE(666),
    [sym_catch] = STATE(666),
    [sym_throw] = STATE(666),
    [sym_primitive] = STATE(666),
    [sym_iterator] = STATE(666),
    [sym_while] = STATE(666),
    [sym_try] = STATE(666),
    [sym_loopbody] = STATE(666),
    [sym_leave] = STATE(666),
    [sym_continue] = STATE(666),
    [sym_protect] = STATE(666),
    [sym_lock] = STATE(666),
    [sym__literal] = STATE(666),
    [sym_character_literal] = STATE(666),
    [sym_string_literal] = STATE(666),
    [sym_call] = STATE(666),
    [sym_invoke] = STATE(666),
    [sym_indexed_access] = STATE(666),
    [sym_slot_accessor] = STATE(666),
    [sym_true] = STATE(666),
    [sym_false] = STATE(666),
    [sym_maybe] = STATE(666),
    [sym_unset] = STATE(666),
    [sym_super] = STATE(666),
    [sym_self] = STATE(666),
    [sym_clone] = STATE(666),
    [sym_thisthread] = STATE(666),
    [sym_class] = STATE(666),
    [sym__expression] = STATE(666),
    [sym_return] = STATE(666),
    [sym_gather] = STATE(666),
    [sym_scatter] = STATE(666),
    [sym_allresults] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym__variable] = STATE(666),
    [sym_variable] = STATE(666),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(666),
    [sym_relational_operator] = STATE(666),
    [sym_logical_operator] = STATE(666),
    [sym_arithmetic_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1753),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1753),
    [sym_global_variable] = ACTIONS(1753),
    [sym_global_reference] = ACTIONS(1753),
    [sym_number] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1753),
    [sym_comment] = ACTIONS(103),
  },
  [461] = {
    [sym_procedure] = STATE(507),
    [sym_block] = STATE(507),
    [sym_assignment] = STATE(507),
    [sym_if] = STATE(507),
    [sym_loop] = STATE(507),
    [sym_handling] = STATE(507),
    [sym_catch] = STATE(507),
    [sym_throw] = STATE(507),
    [sym_primitive] = STATE(507),
    [sym_iterator] = STATE(507),
    [sym_while] = STATE(507),
    [sym_try] = STATE(507),
    [sym_loopbody] = STATE(507),
    [sym_leave] = STATE(507),
    [sym_continue] = STATE(507),
    [sym_protect] = STATE(507),
    [sym_lock] = STATE(507),
    [sym__literal] = STATE(507),
    [sym_character_literal] = STATE(507),
    [sym_string_literal] = STATE(507),
    [sym_call] = STATE(507),
    [sym_invoke] = STATE(507),
    [sym_indexed_access] = STATE(507),
    [sym_slot_accessor] = STATE(507),
    [sym_true] = STATE(507),
    [sym_false] = STATE(507),
    [sym_maybe] = STATE(507),
    [sym_unset] = STATE(507),
    [sym_super] = STATE(507),
    [sym_self] = STATE(507),
    [sym_clone] = STATE(507),
    [sym_thisthread] = STATE(507),
    [sym_class] = STATE(507),
    [sym__expression] = STATE(507),
    [sym_return] = STATE(507),
    [sym_gather] = STATE(507),
    [sym_scatter] = STATE(507),
    [sym_allresults] = STATE(507),
    [sym_parenthesized_expression] = STATE(507),
    [sym__variable] = STATE(507),
    [sym_variable] = STATE(507),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(507),
    [sym_relational_operator] = STATE(507),
    [sym_logical_operator] = STATE(507),
    [sym_arithmetic_operator] = STATE(507),
    [sym_unary_operator] = STATE(507),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1499),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1499),
    [sym_global_variable] = ACTIONS(1499),
    [sym_global_reference] = ACTIONS(1499),
    [sym_number] = ACTIONS(1499),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1499),
    [sym_comment] = ACTIONS(103),
  },
  [462] = {
    [sym_procedure] = STATE(672),
    [sym_block] = STATE(672),
    [sym_assignment] = STATE(672),
    [sym_if] = STATE(672),
    [sym_loop] = STATE(672),
    [sym_handling] = STATE(672),
    [sym_catch] = STATE(672),
    [sym_throw] = STATE(672),
    [sym_primitive] = STATE(672),
    [sym_iterator] = STATE(672),
    [sym_while] = STATE(672),
    [sym_try] = STATE(672),
    [sym_loopbody] = STATE(672),
    [sym_leave] = STATE(672),
    [sym_continue] = STATE(672),
    [sym_protect] = STATE(672),
    [sym_lock] = STATE(672),
    [sym__literal] = STATE(672),
    [sym_character_literal] = STATE(672),
    [sym_string_literal] = STATE(672),
    [sym_call] = STATE(672),
    [sym_invoke] = STATE(672),
    [sym_indexed_access] = STATE(672),
    [sym_slot_accessor] = STATE(672),
    [sym_true] = STATE(672),
    [sym_false] = STATE(672),
    [sym_maybe] = STATE(672),
    [sym_unset] = STATE(672),
    [sym_super] = STATE(672),
    [sym_self] = STATE(672),
    [sym_clone] = STATE(672),
    [sym_thisthread] = STATE(672),
    [sym_class] = STATE(672),
    [sym__expression] = STATE(672),
    [sym_return] = STATE(672),
    [sym_gather] = STATE(672),
    [sym_scatter] = STATE(672),
    [sym_allresults] = STATE(672),
    [sym_parenthesized_expression] = STATE(672),
    [sym__variable] = STATE(672),
    [sym_variable] = STATE(672),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(672),
    [sym_relational_operator] = STATE(672),
    [sym_logical_operator] = STATE(672),
    [sym_arithmetic_operator] = STATE(672),
    [sym_unary_operator] = STATE(672),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1755),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1755),
    [sym_global_variable] = ACTIONS(1755),
    [sym_global_reference] = ACTIONS(1755),
    [sym_number] = ACTIONS(1755),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1755),
    [sym_comment] = ACTIONS(103),
  },
  [463] = {
    [sym_procedure] = STATE(997),
    [sym_block] = STATE(997),
    [sym_assignment] = STATE(997),
    [sym_if] = STATE(997),
    [sym_loop] = STATE(997),
    [sym_handling] = STATE(997),
    [sym_catch] = STATE(997),
    [sym_throw] = STATE(997),
    [sym_primitive] = STATE(997),
    [sym_iterator] = STATE(997),
    [sym_while] = STATE(997),
    [sym_try] = STATE(997),
    [sym_loopbody] = STATE(997),
    [sym_leave] = STATE(997),
    [sym_continue] = STATE(997),
    [sym_protect] = STATE(997),
    [sym_lock] = STATE(997),
    [sym__literal] = STATE(997),
    [sym_character_literal] = STATE(997),
    [sym_string_literal] = STATE(997),
    [sym_call] = STATE(997),
    [sym_invoke] = STATE(997),
    [sym_indexed_access] = STATE(997),
    [sym_slot_accessor] = STATE(997),
    [sym_true] = STATE(997),
    [sym_false] = STATE(997),
    [sym_maybe] = STATE(997),
    [sym_unset] = STATE(997),
    [sym_super] = STATE(997),
    [sym_self] = STATE(997),
    [sym_clone] = STATE(997),
    [sym_thisthread] = STATE(997),
    [sym_class] = STATE(997),
    [sym__expression] = STATE(997),
    [sym_return] = STATE(997),
    [sym_gather] = STATE(997),
    [sym_scatter] = STATE(997),
    [sym_allresults] = STATE(997),
    [sym_parenthesized_expression] = STATE(997),
    [sym__variable] = STATE(997),
    [sym_variable] = STATE(997),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(997),
    [sym_relational_operator] = STATE(997),
    [sym_logical_operator] = STATE(997),
    [sym_arithmetic_operator] = STATE(997),
    [sym_unary_operator] = STATE(997),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1757),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_global_reference] = ACTIONS(1757),
    [sym_number] = ACTIONS(1757),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1757),
    [sym_comment] = ACTIONS(103),
  },
  [464] = {
    [sym_procedure] = STATE(929),
    [sym_block] = STATE(929),
    [sym_assignment] = STATE(929),
    [sym_if] = STATE(929),
    [sym_loop] = STATE(929),
    [sym_handling] = STATE(929),
    [sym_catch] = STATE(929),
    [sym_throw] = STATE(929),
    [sym_primitive] = STATE(929),
    [sym_iterator] = STATE(929),
    [sym_while] = STATE(929),
    [sym_try] = STATE(929),
    [sym_loopbody] = STATE(929),
    [sym_leave] = STATE(929),
    [sym_continue] = STATE(929),
    [sym_protect] = STATE(929),
    [sym_lock] = STATE(929),
    [sym__literal] = STATE(929),
    [sym_character_literal] = STATE(929),
    [sym_string_literal] = STATE(929),
    [sym_call] = STATE(929),
    [sym_invoke] = STATE(929),
    [sym_indexed_access] = STATE(929),
    [sym_slot_accessor] = STATE(929),
    [sym_true] = STATE(929),
    [sym_false] = STATE(929),
    [sym_maybe] = STATE(929),
    [sym_unset] = STATE(929),
    [sym_super] = STATE(929),
    [sym_self] = STATE(929),
    [sym_clone] = STATE(929),
    [sym_thisthread] = STATE(929),
    [sym_class] = STATE(929),
    [sym__expression] = STATE(929),
    [sym_return] = STATE(929),
    [sym_gather] = STATE(929),
    [sym_scatter] = STATE(929),
    [sym_allresults] = STATE(929),
    [sym_parenthesized_expression] = STATE(929),
    [sym__variable] = STATE(929),
    [sym_variable] = STATE(929),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(929),
    [sym_relational_operator] = STATE(929),
    [sym_logical_operator] = STATE(929),
    [sym_arithmetic_operator] = STATE(929),
    [sym_unary_operator] = STATE(929),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1759),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1759),
    [sym_global_variable] = ACTIONS(1759),
    [sym_global_reference] = ACTIONS(1759),
    [sym_number] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1759),
    [sym_comment] = ACTIONS(103),
  },
  [465] = {
    [sym_procedure] = STATE(639),
    [sym_block] = STATE(639),
    [sym_assignment] = STATE(639),
    [sym_if] = STATE(639),
    [sym_loop] = STATE(639),
    [sym_handling] = STATE(639),
    [sym_catch] = STATE(639),
    [sym_throw] = STATE(639),
    [sym_primitive] = STATE(639),
    [sym_iterator] = STATE(639),
    [sym_while] = STATE(639),
    [sym_try] = STATE(639),
    [sym_loopbody] = STATE(639),
    [sym_leave] = STATE(639),
    [sym_continue] = STATE(639),
    [sym_protect] = STATE(639),
    [sym_lock] = STATE(639),
    [sym__literal] = STATE(639),
    [sym_character_literal] = STATE(639),
    [sym_string_literal] = STATE(639),
    [sym_call] = STATE(639),
    [sym_invoke] = STATE(639),
    [sym_indexed_access] = STATE(639),
    [sym_slot_accessor] = STATE(639),
    [sym_true] = STATE(639),
    [sym_false] = STATE(639),
    [sym_maybe] = STATE(639),
    [sym_unset] = STATE(639),
    [sym_super] = STATE(639),
    [sym_self] = STATE(639),
    [sym_clone] = STATE(639),
    [sym_thisthread] = STATE(639),
    [sym_class] = STATE(639),
    [sym__expression] = STATE(639),
    [sym_return] = STATE(639),
    [sym_gather] = STATE(639),
    [sym_scatter] = STATE(639),
    [sym_allresults] = STATE(639),
    [sym_parenthesized_expression] = STATE(639),
    [sym__variable] = STATE(639),
    [sym_variable] = STATE(639),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(639),
    [sym_relational_operator] = STATE(639),
    [sym_logical_operator] = STATE(639),
    [sym_arithmetic_operator] = STATE(639),
    [sym_unary_operator] = STATE(639),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1761),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1761),
    [sym_global_variable] = ACTIONS(1761),
    [sym_global_reference] = ACTIONS(1761),
    [sym_number] = ACTIONS(1761),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1761),
    [sym_comment] = ACTIONS(103),
  },
  [466] = {
    [sym_procedure] = STATE(745),
    [sym_block] = STATE(745),
    [sym_assignment] = STATE(745),
    [sym_if] = STATE(745),
    [sym_loop] = STATE(745),
    [sym_handling] = STATE(745),
    [sym_catch] = STATE(745),
    [sym_throw] = STATE(745),
    [sym_primitive] = STATE(745),
    [sym_iterator] = STATE(745),
    [sym_while] = STATE(745),
    [sym_try] = STATE(745),
    [sym_loopbody] = STATE(745),
    [sym_leave] = STATE(745),
    [sym_continue] = STATE(745),
    [sym_protect] = STATE(745),
    [sym_lock] = STATE(745),
    [sym__literal] = STATE(745),
    [sym_character_literal] = STATE(745),
    [sym_string_literal] = STATE(745),
    [sym_call] = STATE(745),
    [sym_invoke] = STATE(745),
    [sym_indexed_access] = STATE(745),
    [sym_slot_accessor] = STATE(745),
    [sym_true] = STATE(745),
    [sym_false] = STATE(745),
    [sym_maybe] = STATE(745),
    [sym_unset] = STATE(745),
    [sym_super] = STATE(745),
    [sym_self] = STATE(745),
    [sym_clone] = STATE(745),
    [sym_thisthread] = STATE(745),
    [sym_class] = STATE(745),
    [sym__expression] = STATE(745),
    [sym_return] = STATE(745),
    [sym_gather] = STATE(745),
    [sym_scatter] = STATE(745),
    [sym_allresults] = STATE(745),
    [sym_parenthesized_expression] = STATE(745),
    [sym__variable] = STATE(745),
    [sym_variable] = STATE(745),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(745),
    [sym_relational_operator] = STATE(745),
    [sym_logical_operator] = STATE(745),
    [sym_arithmetic_operator] = STATE(745),
    [sym_unary_operator] = STATE(745),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1763),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1763),
    [sym_global_variable] = ACTIONS(1763),
    [sym_global_reference] = ACTIONS(1763),
    [sym_number] = ACTIONS(1763),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1763),
    [sym_comment] = ACTIONS(103),
  },
  [467] = {
    [sym_procedure] = STATE(656),
    [sym_block] = STATE(656),
    [sym_assignment] = STATE(656),
    [sym_if] = STATE(656),
    [sym_loop] = STATE(656),
    [sym_handling] = STATE(656),
    [sym_catch] = STATE(656),
    [sym_throw] = STATE(656),
    [sym_primitive] = STATE(656),
    [sym_iterator] = STATE(656),
    [sym_while] = STATE(656),
    [sym_try] = STATE(656),
    [sym_loopbody] = STATE(656),
    [sym_leave] = STATE(656),
    [sym_continue] = STATE(656),
    [sym_protect] = STATE(656),
    [sym_lock] = STATE(656),
    [sym__literal] = STATE(656),
    [sym_character_literal] = STATE(656),
    [sym_string_literal] = STATE(656),
    [sym_call] = STATE(656),
    [sym_invoke] = STATE(656),
    [sym_indexed_access] = STATE(656),
    [sym_slot_accessor] = STATE(656),
    [sym_true] = STATE(656),
    [sym_false] = STATE(656),
    [sym_maybe] = STATE(656),
    [sym_unset] = STATE(656),
    [sym_super] = STATE(656),
    [sym_self] = STATE(656),
    [sym_clone] = STATE(656),
    [sym_thisthread] = STATE(656),
    [sym_class] = STATE(656),
    [sym__expression] = STATE(656),
    [sym_return] = STATE(656),
    [sym_gather] = STATE(656),
    [sym_scatter] = STATE(656),
    [sym_allresults] = STATE(656),
    [sym_parenthesized_expression] = STATE(656),
    [sym__variable] = STATE(656),
    [sym_variable] = STATE(656),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(656),
    [sym_relational_operator] = STATE(656),
    [sym_logical_operator] = STATE(656),
    [sym_arithmetic_operator] = STATE(656),
    [sym_unary_operator] = STATE(656),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(23),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(33),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(51),
    [aux_sym_continue_token1] = ACTIONS(53),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1765),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(95),
    [aux_sym_allresults_token1] = ACTIONS(97),
    [sym_dynamic_variable] = ACTIONS(1765),
    [sym_global_variable] = ACTIONS(1765),
    [sym_global_reference] = ACTIONS(1765),
    [sym_number] = ACTIONS(1765),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [aux_sym_unary_operator_token1] = ACTIONS(101),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_symbol] = ACTIONS(1765),
    [sym_comment] = ACTIONS(103),
  },
  [468] = {
    [sym_procedure] = STATE(598),
    [sym_block] = STATE(598),
    [sym_assignment] = STATE(598),
    [sym_if] = STATE(598),
    [sym_loop] = STATE(598),
    [sym_handling] = STATE(598),
    [sym_catch] = STATE(598),
    [sym_throw] = STATE(598),
    [sym_primitive] = STATE(598),
    [sym_iterator] = STATE(598),
    [sym_while] = STATE(598),
    [sym_try] = STATE(598),
    [sym_loopbody] = STATE(598),
    [sym_leave] = STATE(598),
    [sym_continue] = STATE(598),
    [sym_protect] = STATE(598),
    [sym_lock] = STATE(598),
    [sym__literal] = STATE(598),
    [sym_character_literal] = STATE(598),
    [sym_string_literal] = STATE(598),
    [sym_call] = STATE(598),
    [sym_invoke] = STATE(598),
    [sym_indexed_access] = STATE(598),
    [sym_slot_accessor] = STATE(598),
    [sym_true] = STATE(598),
    [sym_false] = STATE(598),
    [sym_maybe] = STATE(598),
    [sym_unset] = STATE(598),
    [sym_super] = STATE(598),
    [sym_self] = STATE(598),
    [sym_clone] = STATE(598),
    [sym_thisthread] = STATE(598),
    [sym_class] = STATE(598),
    [sym__expression] = STATE(598),
    [sym_return] = STATE(598),
    [sym_gather] = STATE(598),
    [sym_scatter] = STATE(598),
    [sym_allresults] = STATE(598),
    [sym_parenthesized_expression] = STATE(598),
    [sym__variable] = STATE(598),
    [sym_variable] = STATE(598),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(598),
    [sym_relational_operator] = STATE(598),
    [sym_logical_operator] = STATE(598),
    [sym_arithmetic_operator] = STATE(598),
    [sym_unary_operator] = STATE(598),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1607),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1767),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1767),
    [sym_global_variable] = ACTIONS(1767),
    [sym_global_reference] = ACTIONS(1767),
    [sym_number] = ACTIONS(1767),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1767),
    [sym_comment] = ACTIONS(103),
  },
  [469] = {
    [sym_procedure] = STATE(911),
    [sym_block] = STATE(911),
    [sym_assignment] = STATE(911),
    [sym_if] = STATE(911),
    [sym_loop] = STATE(911),
    [sym_handling] = STATE(911),
    [sym_catch] = STATE(911),
    [sym_throw] = STATE(911),
    [sym_primitive] = STATE(911),
    [sym_iterator] = STATE(911),
    [sym_while] = STATE(911),
    [sym_try] = STATE(911),
    [sym_loopbody] = STATE(911),
    [sym_leave] = STATE(911),
    [sym_continue] = STATE(911),
    [sym_protect] = STATE(911),
    [sym_lock] = STATE(911),
    [sym__literal] = STATE(911),
    [sym_character_literal] = STATE(911),
    [sym_string_literal] = STATE(911),
    [sym_call] = STATE(911),
    [sym_invoke] = STATE(911),
    [sym_indexed_access] = STATE(911),
    [sym_slot_accessor] = STATE(911),
    [sym_true] = STATE(911),
    [sym_false] = STATE(911),
    [sym_maybe] = STATE(911),
    [sym_unset] = STATE(911),
    [sym_super] = STATE(911),
    [sym_self] = STATE(911),
    [sym_clone] = STATE(911),
    [sym_thisthread] = STATE(911),
    [sym_class] = STATE(911),
    [sym__expression] = STATE(911),
    [sym_return] = STATE(911),
    [sym_gather] = STATE(911),
    [sym_scatter] = STATE(911),
    [sym_allresults] = STATE(911),
    [sym_parenthesized_expression] = STATE(911),
    [sym__variable] = STATE(911),
    [sym_variable] = STATE(911),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(911),
    [sym_relational_operator] = STATE(911),
    [sym_logical_operator] = STATE(911),
    [sym_arithmetic_operator] = STATE(911),
    [sym_unary_operator] = STATE(911),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1769),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1769),
    [sym_global_variable] = ACTIONS(1769),
    [sym_global_reference] = ACTIONS(1769),
    [sym_number] = ACTIONS(1769),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1769),
    [sym_comment] = ACTIONS(103),
  },
  [470] = {
    [sym_procedure] = STATE(836),
    [sym_block] = STATE(836),
    [sym_assignment] = STATE(836),
    [sym_if] = STATE(836),
    [sym_loop] = STATE(836),
    [sym_handling] = STATE(836),
    [sym_catch] = STATE(836),
    [sym_throw] = STATE(836),
    [sym_primitive] = STATE(836),
    [sym_iterator] = STATE(836),
    [sym_while] = STATE(836),
    [sym_try] = STATE(836),
    [sym_loopbody] = STATE(836),
    [sym_leave] = STATE(836),
    [sym_continue] = STATE(836),
    [sym_protect] = STATE(836),
    [sym_lock] = STATE(836),
    [sym__literal] = STATE(836),
    [sym_character_literal] = STATE(836),
    [sym_string_literal] = STATE(836),
    [sym_call] = STATE(836),
    [sym_invoke] = STATE(836),
    [sym_indexed_access] = STATE(836),
    [sym_slot_accessor] = STATE(836),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_maybe] = STATE(836),
    [sym_unset] = STATE(836),
    [sym_super] = STATE(836),
    [sym_self] = STATE(836),
    [sym_clone] = STATE(836),
    [sym_thisthread] = STATE(836),
    [sym_class] = STATE(836),
    [sym__expression] = STATE(836),
    [sym_return] = STATE(836),
    [sym_gather] = STATE(836),
    [sym_scatter] = STATE(836),
    [sym_allresults] = STATE(836),
    [sym_parenthesized_expression] = STATE(836),
    [sym__variable] = STATE(836),
    [sym_variable] = STATE(836),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(836),
    [sym_relational_operator] = STATE(836),
    [sym_logical_operator] = STATE(836),
    [sym_arithmetic_operator] = STATE(836),
    [sym_unary_operator] = STATE(836),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1551),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1551),
    [sym_global_variable] = ACTIONS(1551),
    [sym_global_reference] = ACTIONS(1551),
    [sym_number] = ACTIONS(1551),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1551),
    [sym_comment] = ACTIONS(103),
  },
  [471] = {
    [sym_procedure] = STATE(852),
    [sym_block] = STATE(852),
    [sym_assignment] = STATE(852),
    [sym_if] = STATE(852),
    [sym_loop] = STATE(852),
    [sym_handling] = STATE(852),
    [sym_catch] = STATE(852),
    [sym_throw] = STATE(852),
    [sym_primitive] = STATE(852),
    [sym_iterator] = STATE(852),
    [sym_while] = STATE(852),
    [sym_try] = STATE(852),
    [sym_loopbody] = STATE(852),
    [sym_leave] = STATE(852),
    [sym_continue] = STATE(852),
    [sym_protect] = STATE(852),
    [sym_lock] = STATE(852),
    [sym__literal] = STATE(852),
    [sym_character_literal] = STATE(852),
    [sym_string_literal] = STATE(852),
    [sym_call] = STATE(852),
    [sym_invoke] = STATE(852),
    [sym_indexed_access] = STATE(852),
    [sym_slot_accessor] = STATE(852),
    [sym_true] = STATE(852),
    [sym_false] = STATE(852),
    [sym_maybe] = STATE(852),
    [sym_unset] = STATE(852),
    [sym_super] = STATE(852),
    [sym_self] = STATE(852),
    [sym_clone] = STATE(852),
    [sym_thisthread] = STATE(852),
    [sym_class] = STATE(852),
    [sym__expression] = STATE(852),
    [sym_return] = STATE(852),
    [sym_gather] = STATE(852),
    [sym_scatter] = STATE(852),
    [sym_allresults] = STATE(852),
    [sym_parenthesized_expression] = STATE(852),
    [sym__variable] = STATE(852),
    [sym_variable] = STATE(852),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(852),
    [sym_relational_operator] = STATE(852),
    [sym_logical_operator] = STATE(852),
    [sym_arithmetic_operator] = STATE(852),
    [sym_unary_operator] = STATE(852),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1771),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1771),
    [sym_global_variable] = ACTIONS(1771),
    [sym_global_reference] = ACTIONS(1771),
    [sym_number] = ACTIONS(1771),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1771),
    [sym_comment] = ACTIONS(103),
  },
  [472] = {
    [sym_procedure] = STATE(993),
    [sym_block] = STATE(993),
    [sym_assignment] = STATE(993),
    [sym_if] = STATE(993),
    [sym_loop] = STATE(993),
    [sym_handling] = STATE(993),
    [sym_catch] = STATE(993),
    [sym_throw] = STATE(993),
    [sym_primitive] = STATE(993),
    [sym_iterator] = STATE(993),
    [sym_while] = STATE(993),
    [sym_try] = STATE(993),
    [sym_loopbody] = STATE(993),
    [sym_leave] = STATE(993),
    [sym_continue] = STATE(993),
    [sym_protect] = STATE(993),
    [sym_lock] = STATE(993),
    [sym__literal] = STATE(993),
    [sym_character_literal] = STATE(993),
    [sym_string_literal] = STATE(993),
    [sym_call] = STATE(993),
    [sym_invoke] = STATE(993),
    [sym_indexed_access] = STATE(993),
    [sym_slot_accessor] = STATE(993),
    [sym_true] = STATE(993),
    [sym_false] = STATE(993),
    [sym_maybe] = STATE(993),
    [sym_unset] = STATE(993),
    [sym_super] = STATE(993),
    [sym_self] = STATE(993),
    [sym_clone] = STATE(993),
    [sym_thisthread] = STATE(993),
    [sym_class] = STATE(993),
    [sym__expression] = STATE(993),
    [sym_return] = STATE(993),
    [sym_gather] = STATE(993),
    [sym_scatter] = STATE(993),
    [sym_allresults] = STATE(993),
    [sym_parenthesized_expression] = STATE(993),
    [sym__variable] = STATE(993),
    [sym_variable] = STATE(993),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(993),
    [sym_relational_operator] = STATE(993),
    [sym_logical_operator] = STATE(993),
    [sym_arithmetic_operator] = STATE(993),
    [sym_unary_operator] = STATE(993),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1773),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1773),
    [sym_global_variable] = ACTIONS(1773),
    [sym_global_reference] = ACTIONS(1773),
    [sym_number] = ACTIONS(1773),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1773),
    [sym_comment] = ACTIONS(103),
  },
  [473] = {
    [sym_procedure] = STATE(987),
    [sym_block] = STATE(987),
    [sym_assignment] = STATE(987),
    [sym_if] = STATE(987),
    [sym_loop] = STATE(987),
    [sym_handling] = STATE(987),
    [sym_catch] = STATE(987),
    [sym_throw] = STATE(987),
    [sym_primitive] = STATE(987),
    [sym_iterator] = STATE(987),
    [sym_while] = STATE(987),
    [sym_try] = STATE(987),
    [sym_loopbody] = STATE(987),
    [sym_leave] = STATE(987),
    [sym_continue] = STATE(987),
    [sym_protect] = STATE(987),
    [sym_lock] = STATE(987),
    [sym__literal] = STATE(987),
    [sym_character_literal] = STATE(987),
    [sym_string_literal] = STATE(987),
    [sym_call] = STATE(987),
    [sym_invoke] = STATE(987),
    [sym_indexed_access] = STATE(987),
    [sym_slot_accessor] = STATE(987),
    [sym_true] = STATE(987),
    [sym_false] = STATE(987),
    [sym_maybe] = STATE(987),
    [sym_unset] = STATE(987),
    [sym_super] = STATE(987),
    [sym_self] = STATE(987),
    [sym_clone] = STATE(987),
    [sym_thisthread] = STATE(987),
    [sym_class] = STATE(987),
    [sym__expression] = STATE(987),
    [sym_return] = STATE(987),
    [sym_gather] = STATE(987),
    [sym_scatter] = STATE(987),
    [sym_allresults] = STATE(987),
    [sym_parenthesized_expression] = STATE(987),
    [sym__variable] = STATE(987),
    [sym_variable] = STATE(987),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(987),
    [sym_relational_operator] = STATE(987),
    [sym_logical_operator] = STATE(987),
    [sym_arithmetic_operator] = STATE(987),
    [sym_unary_operator] = STATE(987),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1775),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1775),
    [sym_global_variable] = ACTIONS(1775),
    [sym_global_reference] = ACTIONS(1775),
    [sym_number] = ACTIONS(1775),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1775),
    [sym_comment] = ACTIONS(103),
  },
  [474] = {
    [sym_procedure] = STATE(613),
    [sym_block] = STATE(613),
    [sym_assignment] = STATE(613),
    [sym_if] = STATE(613),
    [sym_loop] = STATE(613),
    [sym_handling] = STATE(613),
    [sym_catch] = STATE(613),
    [sym_throw] = STATE(613),
    [sym_primitive] = STATE(613),
    [sym_iterator] = STATE(613),
    [sym_while] = STATE(613),
    [sym_try] = STATE(613),
    [sym_loopbody] = STATE(613),
    [sym_leave] = STATE(613),
    [sym_continue] = STATE(613),
    [sym_protect] = STATE(613),
    [sym_lock] = STATE(613),
    [sym__literal] = STATE(613),
    [sym_character_literal] = STATE(613),
    [sym_string_literal] = STATE(613),
    [sym_call] = STATE(613),
    [sym_invoke] = STATE(613),
    [sym_indexed_access] = STATE(613),
    [sym_slot_accessor] = STATE(613),
    [sym_true] = STATE(613),
    [sym_false] = STATE(613),
    [sym_maybe] = STATE(613),
    [sym_unset] = STATE(613),
    [sym_super] = STATE(613),
    [sym_self] = STATE(613),
    [sym_clone] = STATE(613),
    [sym_thisthread] = STATE(613),
    [sym_class] = STATE(613),
    [sym__expression] = STATE(613),
    [sym_return] = STATE(613),
    [sym_gather] = STATE(613),
    [sym_scatter] = STATE(613),
    [sym_allresults] = STATE(613),
    [sym_parenthesized_expression] = STATE(613),
    [sym__variable] = STATE(613),
    [sym_variable] = STATE(613),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(613),
    [sym_relational_operator] = STATE(613),
    [sym_logical_operator] = STATE(613),
    [sym_arithmetic_operator] = STATE(613),
    [sym_unary_operator] = STATE(613),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [aux_sym_method_token6] = ACTIONS(1295),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1297),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(37),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1301),
    [aux_sym_continue_token1] = ACTIONS(1303),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1777),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(91),
    [anon_sym_GT_GT] = ACTIONS(93),
    [aux_sym_scatter_token1] = ACTIONS(1307),
    [aux_sym_allresults_token1] = ACTIONS(1309),
    [sym_dynamic_variable] = ACTIONS(1777),
    [sym_global_variable] = ACTIONS(1777),
    [sym_global_reference] = ACTIONS(1777),
    [sym_number] = ACTIONS(1777),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1311),
    [anon_sym_PLUS] = ACTIONS(1311),
    [aux_sym_unary_operator_token1] = ACTIONS(1311),
    [anon_sym_TILDE] = ACTIONS(1311),
    [sym_symbol] = ACTIONS(1777),
    [sym_comment] = ACTIONS(103),
  },
  [475] = {
    [sym_procedure] = STATE(990),
    [sym_block] = STATE(990),
    [sym_assignment] = STATE(990),
    [sym_if] = STATE(990),
    [sym_loop] = STATE(990),
    [sym_handling] = STATE(990),
    [sym_catch] = STATE(990),
    [sym_throw] = STATE(990),
    [sym_primitive] = STATE(990),
    [sym_iterator] = STATE(990),
    [sym_while] = STATE(990),
    [sym_try] = STATE(990),
    [sym_loopbody] = STATE(990),
    [sym_leave] = STATE(990),
    [sym_continue] = STATE(990),
    [sym_protect] = STATE(990),
    [sym_lock] = STATE(990),
    [sym__literal] = STATE(990),
    [sym_character_literal] = STATE(990),
    [sym_string_literal] = STATE(990),
    [sym_call] = STATE(990),
    [sym_invoke] = STATE(990),
    [sym_indexed_access] = STATE(990),
    [sym_slot_accessor] = STATE(990),
    [sym_true] = STATE(990),
    [sym_false] = STATE(990),
    [sym_maybe] = STATE(990),
    [sym_unset] = STATE(990),
    [sym_super] = STATE(990),
    [sym_self] = STATE(990),
    [sym_clone] = STATE(990),
    [sym_thisthread] = STATE(990),
    [sym_class] = STATE(990),
    [sym__expression] = STATE(990),
    [sym_return] = STATE(990),
    [sym_gather] = STATE(990),
    [sym_scatter] = STATE(990),
    [sym_allresults] = STATE(990),
    [sym_parenthesized_expression] = STATE(990),
    [sym__variable] = STATE(990),
    [sym_variable] = STATE(990),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(990),
    [sym_relational_operator] = STATE(990),
    [sym_logical_operator] = STATE(990),
    [sym_arithmetic_operator] = STATE(990),
    [sym_unary_operator] = STATE(990),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1779),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1779),
    [sym_global_variable] = ACTIONS(1779),
    [sym_global_reference] = ACTIONS(1779),
    [sym_number] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1779),
    [sym_comment] = ACTIONS(103),
  },
  [476] = {
    [sym_procedure] = STATE(836),
    [sym_block] = STATE(836),
    [sym_assignment] = STATE(836),
    [sym_if] = STATE(836),
    [sym_loop] = STATE(836),
    [sym_handling] = STATE(836),
    [sym_catch] = STATE(836),
    [sym_throw] = STATE(836),
    [sym_primitive] = STATE(836),
    [sym_iterator] = STATE(836),
    [sym_while] = STATE(836),
    [sym_try] = STATE(836),
    [sym_loopbody] = STATE(836),
    [sym_leave] = STATE(836),
    [sym_continue] = STATE(836),
    [sym_protect] = STATE(836),
    [sym_lock] = STATE(836),
    [sym__literal] = STATE(836),
    [sym_character_literal] = STATE(836),
    [sym_string_literal] = STATE(836),
    [sym_call] = STATE(836),
    [sym_invoke] = STATE(836),
    [sym_indexed_access] = STATE(836),
    [sym_slot_accessor] = STATE(836),
    [sym_true] = STATE(836),
    [sym_false] = STATE(836),
    [sym_maybe] = STATE(836),
    [sym_unset] = STATE(836),
    [sym_super] = STATE(836),
    [sym_self] = STATE(836),
    [sym_clone] = STATE(836),
    [sym_thisthread] = STATE(836),
    [sym_class] = STATE(836),
    [sym__expression] = STATE(836),
    [sym_return] = STATE(836),
    [sym_gather] = STATE(836),
    [sym_scatter] = STATE(836),
    [sym_allresults] = STATE(836),
    [sym_parenthesized_expression] = STATE(836),
    [sym__variable] = STATE(836),
    [sym_variable] = STATE(836),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(836),
    [sym_relational_operator] = STATE(836),
    [sym_logical_operator] = STATE(836),
    [sym_arithmetic_operator] = STATE(836),
    [sym_unary_operator] = STATE(836),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1551),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1551),
    [sym_global_variable] = ACTIONS(1551),
    [sym_global_reference] = ACTIONS(1551),
    [sym_number] = ACTIONS(1551),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1551),
    [sym_comment] = ACTIONS(103),
  },
  [477] = {
    [sym_procedure] = STATE(873),
    [sym_block] = STATE(873),
    [sym_assignment] = STATE(873),
    [sym_if] = STATE(873),
    [sym_loop] = STATE(873),
    [sym_handling] = STATE(873),
    [sym_catch] = STATE(873),
    [sym_throw] = STATE(873),
    [sym_primitive] = STATE(873),
    [sym_iterator] = STATE(873),
    [sym_while] = STATE(873),
    [sym_try] = STATE(873),
    [sym_loopbody] = STATE(873),
    [sym_leave] = STATE(873),
    [sym_continue] = STATE(873),
    [sym_protect] = STATE(873),
    [sym_lock] = STATE(873),
    [sym__literal] = STATE(873),
    [sym_character_literal] = STATE(873),
    [sym_string_literal] = STATE(873),
    [sym_call] = STATE(873),
    [sym_invoke] = STATE(873),
    [sym_indexed_access] = STATE(873),
    [sym_slot_accessor] = STATE(873),
    [sym_true] = STATE(873),
    [sym_false] = STATE(873),
    [sym_maybe] = STATE(873),
    [sym_unset] = STATE(873),
    [sym_super] = STATE(873),
    [sym_self] = STATE(873),
    [sym_clone] = STATE(873),
    [sym_thisthread] = STATE(873),
    [sym_class] = STATE(873),
    [sym__expression] = STATE(873),
    [sym_return] = STATE(873),
    [sym_gather] = STATE(873),
    [sym_scatter] = STATE(873),
    [sym_allresults] = STATE(873),
    [sym_parenthesized_expression] = STATE(873),
    [sym__variable] = STATE(873),
    [sym_variable] = STATE(873),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(873),
    [sym_relational_operator] = STATE(873),
    [sym_logical_operator] = STATE(873),
    [sym_arithmetic_operator] = STATE(873),
    [sym_unary_operator] = STATE(873),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1781),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1781),
    [sym_global_variable] = ACTIONS(1781),
    [sym_global_reference] = ACTIONS(1781),
    [sym_number] = ACTIONS(1781),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1781),
    [sym_comment] = ACTIONS(103),
  },
  [478] = {
    [sym_procedure] = STATE(868),
    [sym_block] = STATE(868),
    [sym_assignment] = STATE(868),
    [sym_if] = STATE(868),
    [sym_loop] = STATE(868),
    [sym_handling] = STATE(868),
    [sym_catch] = STATE(868),
    [sym_throw] = STATE(868),
    [sym_primitive] = STATE(868),
    [sym_iterator] = STATE(868),
    [sym_while] = STATE(868),
    [sym_try] = STATE(868),
    [sym_loopbody] = STATE(868),
    [sym_leave] = STATE(868),
    [sym_continue] = STATE(868),
    [sym_protect] = STATE(868),
    [sym_lock] = STATE(868),
    [sym__literal] = STATE(868),
    [sym_character_literal] = STATE(868),
    [sym_string_literal] = STATE(868),
    [sym_call] = STATE(868),
    [sym_invoke] = STATE(868),
    [sym_indexed_access] = STATE(868),
    [sym_slot_accessor] = STATE(868),
    [sym_true] = STATE(868),
    [sym_false] = STATE(868),
    [sym_maybe] = STATE(868),
    [sym_unset] = STATE(868),
    [sym_super] = STATE(868),
    [sym_self] = STATE(868),
    [sym_clone] = STATE(868),
    [sym_thisthread] = STATE(868),
    [sym_class] = STATE(868),
    [sym__expression] = STATE(868),
    [sym_return] = STATE(868),
    [sym_gather] = STATE(868),
    [sym_scatter] = STATE(868),
    [sym_allresults] = STATE(868),
    [sym_parenthesized_expression] = STATE(868),
    [sym__variable] = STATE(868),
    [sym_variable] = STATE(868),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(868),
    [sym_relational_operator] = STATE(868),
    [sym_logical_operator] = STATE(868),
    [sym_arithmetic_operator] = STATE(868),
    [sym_unary_operator] = STATE(868),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1783),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1783),
    [sym_global_variable] = ACTIONS(1783),
    [sym_global_reference] = ACTIONS(1783),
    [sym_number] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1783),
    [sym_comment] = ACTIONS(103),
  },
  [479] = {
    [sym_procedure] = STATE(712),
    [sym_block] = STATE(712),
    [sym_assignment] = STATE(712),
    [sym_if] = STATE(712),
    [sym_loop] = STATE(712),
    [sym_handling] = STATE(712),
    [sym_catch] = STATE(712),
    [sym_throw] = STATE(712),
    [sym_primitive] = STATE(712),
    [sym_iterator] = STATE(712),
    [sym_while] = STATE(712),
    [sym_try] = STATE(712),
    [sym_loopbody] = STATE(712),
    [sym_leave] = STATE(712),
    [sym_continue] = STATE(712),
    [sym_protect] = STATE(712),
    [sym_lock] = STATE(712),
    [sym__literal] = STATE(712),
    [sym_character_literal] = STATE(712),
    [sym_string_literal] = STATE(712),
    [sym_call] = STATE(712),
    [sym_invoke] = STATE(712),
    [sym_indexed_access] = STATE(712),
    [sym_slot_accessor] = STATE(712),
    [sym_true] = STATE(712),
    [sym_false] = STATE(712),
    [sym_maybe] = STATE(712),
    [sym_unset] = STATE(712),
    [sym_super] = STATE(712),
    [sym_self] = STATE(712),
    [sym_clone] = STATE(712),
    [sym_thisthread] = STATE(712),
    [sym_class] = STATE(712),
    [sym__expression] = STATE(712),
    [sym_return] = STATE(712),
    [sym_gather] = STATE(712),
    [sym_scatter] = STATE(712),
    [sym_allresults] = STATE(712),
    [sym_parenthesized_expression] = STATE(712),
    [sym__variable] = STATE(712),
    [sym_variable] = STATE(712),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(712),
    [sym_relational_operator] = STATE(712),
    [sym_logical_operator] = STATE(712),
    [sym_arithmetic_operator] = STATE(712),
    [sym_unary_operator] = STATE(712),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1785),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1785),
    [sym_global_variable] = ACTIONS(1785),
    [sym_global_reference] = ACTIONS(1785),
    [sym_number] = ACTIONS(1785),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1785),
    [sym_comment] = ACTIONS(103),
  },
  [480] = {
    [sym_procedure] = STATE(885),
    [sym_block] = STATE(885),
    [sym_assignment] = STATE(885),
    [sym_if] = STATE(885),
    [sym_loop] = STATE(885),
    [sym_handling] = STATE(885),
    [sym_catch] = STATE(885),
    [sym_throw] = STATE(885),
    [sym_primitive] = STATE(885),
    [sym_iterator] = STATE(885),
    [sym_while] = STATE(885),
    [sym_try] = STATE(885),
    [sym_loopbody] = STATE(885),
    [sym_leave] = STATE(885),
    [sym_continue] = STATE(885),
    [sym_protect] = STATE(885),
    [sym_lock] = STATE(885),
    [sym__literal] = STATE(885),
    [sym_character_literal] = STATE(885),
    [sym_string_literal] = STATE(885),
    [sym_call] = STATE(885),
    [sym_invoke] = STATE(885),
    [sym_indexed_access] = STATE(885),
    [sym_slot_accessor] = STATE(885),
    [sym_true] = STATE(885),
    [sym_false] = STATE(885),
    [sym_maybe] = STATE(885),
    [sym_unset] = STATE(885),
    [sym_super] = STATE(885),
    [sym_self] = STATE(885),
    [sym_clone] = STATE(885),
    [sym_thisthread] = STATE(885),
    [sym_class] = STATE(885),
    [sym__expression] = STATE(885),
    [sym_return] = STATE(885),
    [sym_gather] = STATE(885),
    [sym_scatter] = STATE(885),
    [sym_allresults] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym__variable] = STATE(885),
    [sym_variable] = STATE(885),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(885),
    [sym_relational_operator] = STATE(885),
    [sym_logical_operator] = STATE(885),
    [sym_arithmetic_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(337),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(339),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(343),
    [aux_sym_continue_token1] = ACTIONS(345),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1787),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(353),
    [aux_sym_allresults_token1] = ACTIONS(355),
    [sym_dynamic_variable] = ACTIONS(1787),
    [sym_global_variable] = ACTIONS(1787),
    [sym_global_reference] = ACTIONS(1787),
    [sym_number] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(359),
    [anon_sym_PLUS] = ACTIONS(359),
    [aux_sym_unary_operator_token1] = ACTIONS(359),
    [anon_sym_TILDE] = ACTIONS(359),
    [sym_symbol] = ACTIONS(1787),
    [sym_comment] = ACTIONS(103),
  },
  [481] = {
    [sym_procedure] = STATE(931),
    [sym_block] = STATE(931),
    [sym_assignment] = STATE(931),
    [sym_if] = STATE(931),
    [sym_loop] = STATE(931),
    [sym_handling] = STATE(931),
    [sym_catch] = STATE(931),
    [sym_throw] = STATE(931),
    [sym_primitive] = STATE(931),
    [sym_iterator] = STATE(931),
    [sym_while] = STATE(931),
    [sym_try] = STATE(931),
    [sym_loopbody] = STATE(931),
    [sym_leave] = STATE(931),
    [sym_continue] = STATE(931),
    [sym_protect] = STATE(931),
    [sym_lock] = STATE(931),
    [sym__literal] = STATE(931),
    [sym_character_literal] = STATE(931),
    [sym_string_literal] = STATE(931),
    [sym_call] = STATE(931),
    [sym_invoke] = STATE(931),
    [sym_indexed_access] = STATE(931),
    [sym_slot_accessor] = STATE(931),
    [sym_true] = STATE(931),
    [sym_false] = STATE(931),
    [sym_maybe] = STATE(931),
    [sym_unset] = STATE(931),
    [sym_super] = STATE(931),
    [sym_self] = STATE(931),
    [sym_clone] = STATE(931),
    [sym_thisthread] = STATE(931),
    [sym_class] = STATE(931),
    [sym__expression] = STATE(931),
    [sym_return] = STATE(931),
    [sym_gather] = STATE(931),
    [sym_scatter] = STATE(931),
    [sym_allresults] = STATE(931),
    [sym_parenthesized_expression] = STATE(931),
    [sym__variable] = STATE(931),
    [sym_variable] = STATE(931),
    [sym__identifier] = STATE(581),
    [sym_vector] = STATE(931),
    [sym_relational_operator] = STATE(931),
    [sym_logical_operator] = STATE(931),
    [sym_arithmetic_operator] = STATE(931),
    [sym_unary_operator] = STATE(931),
    [aux_sym_method_token3] = ACTIONS(361),
    [anon_sym_DOT] = ACTIONS(19),
    [anon_sym_LPAREN] = ACTIONS(21),
    [aux_sym_method_token6] = ACTIONS(1277),
    [aux_sym_procedure_token1] = ACTIONS(25),
    [aux_sym_block_token1] = ACTIONS(27),
    [aux_sym_if_token1] = ACTIONS(29),
    [aux_sym_loop_token1] = ACTIONS(31),
    [aux_sym_handling_token1] = ACTIONS(1279),
    [aux_sym_catch_token1] = ACTIONS(35),
    [aux_sym_throw_token1] = ACTIONS(975),
    [aux_sym_primitive_token1] = ACTIONS(39),
    [aux_sym_iterator_token1] = ACTIONS(41),
    [aux_sym_iterator_token2] = ACTIONS(43),
    [aux_sym_while_token1] = ACTIONS(45),
    [aux_sym_try_token1] = ACTIONS(47),
    [aux_sym_loopbody_token1] = ACTIONS(49),
    [aux_sym_leave_token1] = ACTIONS(1283),
    [aux_sym_continue_token1] = ACTIONS(1285),
    [aux_sym_protect_token1] = ACTIONS(55),
    [aux_sym_lock_token1] = ACTIONS(57),
    [anon_sym_PERCENT] = ACTIONS(61),
    [anon_sym_DQUOTE] = ACTIONS(63),
    [anon_sym_SQUOTE] = ACTIONS(65),
    [sym_regex_literal] = ACTIONS(1789),
    [aux_sym_slot_accessor_token1] = ACTIONS(69),
    [aux_sym_true_token1] = ACTIONS(71),
    [aux_sym_false_token1] = ACTIONS(73),
    [aux_sym_maybe_token1] = ACTIONS(75),
    [aux_sym_unset_token1] = ACTIONS(77),
    [aux_sym_super_token1] = ACTIONS(79),
    [aux_sym_self_token1] = ACTIONS(81),
    [aux_sym_clone_token1] = ACTIONS(83),
    [aux_sym_thisthread_token1] = ACTIONS(85),
    [aux_sym_class_token1] = ACTIONS(87),
    [aux_sym_return_token1] = ACTIONS(993),
    [anon_sym_GT_GT] = ACTIONS(995),
    [aux_sym_scatter_token1] = ACTIONS(1289),
    [aux_sym_allresults_token1] = ACTIONS(1291),
    [sym_dynamic_variable] = ACTIONS(1789),
    [sym_global_variable] = ACTIONS(1789),
    [sym_global_reference] = ACTIONS(1789),
    [sym_number] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(99),
    [anon_sym_DASH] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1293),
    [aux_sym_unary_operator_token1] = ACTIONS(1293),
    [anon_sym_TILDE] = ACTIONS(1293),
    [sym_symbol] = ACTIONS(1789),
    [sym_comment] = ACTIONS(103),
  },
  [482] = {
    [sym_procedure] = STATE(1019),
    [sym_block] = STATE(1019),
    [sym_assignment] = STATE(1019),
    [sym_if] = STATE(1019),
    [sym_loop] = STATE(1019),
    [sym_handling] = STATE(1019),
    [sym_catch] = STATE(1019),
    [sym_throw] = STATE(1019),
    [sym_primitive] = STATE(1019),
    [sym_iterator] = STATE(1019),
    [sym_while] = STATE(1019),
    [sym_try] = STATE(1019),
    [sym_loopbody] = STATE(1019),
    [sym_leave] = STATE(1019),
    [sym_continue] = STATE(1019),
    [sym_protect] = STATE(1019),
    [sym_lock] = STATE(1019),
    [sym__literal] = STATE(1019),
    [sym_character_literal] = STATE(1019),
    [sym_string_literal] = STATE(1019),
    [sym_call] = STATE(1019),
    [sym_invoke] = STATE(1019),
    [sym_indexed_access] = STATE(1019),
    [sym_slot_accessor] = STATE(1019),
    [sym_true] = STATE(1019),
    [sym_false] = STATE(1019),
    [sym_maybe] = STATE(1019),
    [sym_unset] = STATE(1019),
    [sym_super] = STATE(1019),
    [sym_self] = STATE(1019),
    [sym_clone] = STATE(1019),
    [sym_thisthread] = STATE(1019),
    [sym_class] = STATE(1019),
    [sym__expression] = STATE(1019),
    [sym_return] = STATE(1019),
    [sym_gather] = STATE(1019),
    [sym_scatter] = STATE(1019),
    [sym_allresults] = STATE(1019),
    [sym_parenthesized_expression] = STATE(1019),
    [sym__variable] = STATE(1019),
    [sym_variable] = STATE(1019),
    [sym__identifier] = STATE(772),
    [sym_vector] = STATE(1019),
    [sym_relational_operator] = STATE(1019),
    [sym_logical_operator] = STATE(1019),
    [sym_arithmetic_operator] = STATE(1019),
    [sym_unary_operator] = STATE(1019),
    [aux_sym_method_token3] = ACTIONS(209),
    [anon_sym_DOT] = ACTIONS(211),
    [anon_sym_LPAREN] = ACTIONS(213),
    [aux_sym_method_token6] = ACTIONS(1243),
    [aux_sym_procedure_token1] = ACTIONS(219),
    [aux_sym_block_token1] = ACTIONS(221),
    [aux_sym_if_token1] = ACTIONS(223),
    [aux_sym_loop_token1] = ACTIONS(225),
    [aux_sym_handling_token1] = ACTIONS(1245),
    [aux_sym_catch_token1] = ACTIONS(229),
    [aux_sym_throw_token1] = ACTIONS(341),
    [aux_sym_primitive_token1] = ACTIONS(233),
    [aux_sym_iterator_token1] = ACTIONS(235),
    [aux_sym_iterator_token2] = ACTIONS(237),
    [aux_sym_while_token1] = ACTIONS(239),
    [aux_sym_try_token1] = ACTIONS(241),
    [aux_sym_loopbody_token1] = ACTIONS(243),
    [aux_sym_leave_token1] = ACTIONS(1247),
    [aux_sym_continue_token1] = ACTIONS(1249),
    [aux_sym_protect_token1] = ACTIONS(249),
    [aux_sym_lock_token1] = ACTIONS(251),
    [anon_sym_PERCENT] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(255),
    [anon_sym_SQUOTE] = ACTIONS(257),
    [sym_regex_literal] = ACTIONS(1791),
    [aux_sym_slot_accessor_token1] = ACTIONS(261),
    [aux_sym_true_token1] = ACTIONS(263),
    [aux_sym_false_token1] = ACTIONS(265),
    [aux_sym_maybe_token1] = ACTIONS(267),
    [aux_sym_unset_token1] = ACTIONS(269),
    [aux_sym_super_token1] = ACTIONS(271),
    [aux_sym_self_token1] = ACTIONS(273),
    [aux_sym_clone_token1] = ACTIONS(275),
    [aux_sym_thisthread_token1] = ACTIONS(277),
    [aux_sym_class_token1] = ACTIONS(279),
    [aux_sym_return_token1] = ACTIONS(349),
    [anon_sym_GT_GT] = ACTIONS(351),
    [aux_sym_scatter_token1] = ACTIONS(1255),
    [aux_sym_allresults_token1] = ACTIONS(1257),
    [sym_dynamic_variable] = ACTIONS(1791),
    [sym_global_variable] = ACTIONS(1791),
    [sym_global_reference] = ACTIONS(1791),
    [sym_number] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(289),
    [anon_sym_DASH] = ACTIONS(1259),
    [anon_sym_PLUS] = ACTIONS(1259),
    [aux_sym_unary_operator_token1] = ACTIONS(1259),
    [anon_sym_TILDE] = ACTIONS(1259),
    [sym_symbol] = ACTIONS(1791),
    [sym_comment] = ACTIONS(103),
  },
  [483] = {
    [aux_sym_method_token3] = ACTIONS(1793),
    [anon_sym_DOT] = ACTIONS(1793),
    [anon_sym_LPAREN] = ACTIONS(1793),
    [aux_sym_method_token6] = ACTIONS(1793),
    [aux_sym_method_token7] = ACTIONS(1793),
    [aux_sym_procedure_token1] = ACTIONS(1793),
    [aux_sym_procedure_token2] = ACTIONS(1793),
    [aux_sym_block_token1] = ACTIONS(1793),
    [aux_sym_block_token2] = ACTIONS(1793),
    [aux_sym_if_token1] = ACTIONS(1793),
    [aux_sym_if_token3] = ACTIONS(1793),
    [aux_sym_elif_token1] = ACTIONS(1793),
    [aux_sym_else_token1] = ACTIONS(1793),
    [aux_sym_loop_token1] = ACTIONS(1795),
    [aux_sym_loop_token2] = ACTIONS(1793),
    [aux_sym_finally_token1] = ACTIONS(1793),
    [aux_sym_handling_token1] = ACTIONS(1793),
    [aux_sym_catch_token1] = ACTIONS(1793),
    [aux_sym_catch_token2] = ACTIONS(1793),
    [aux_sym_throw_token1] = ACTIONS(1793),
    [aux_sym_primitive_token1] = ACTIONS(1793),
    [aux_sym_iterator_token1] = ACTIONS(1793),
    [aux_sym_iterator_token2] = ACTIONS(1793),
    [aux_sym_while_token1] = ACTIONS(1793),
    [aux_sym_try_token1] = ACTIONS(1793),
    [aux_sym_try_token2] = ACTIONS(1793),
    [aux_sym_try_token3] = ACTIONS(1793),
    [aux_sym_loopbody_token1] = ACTIONS(1793),
    [aux_sym_leave_token1] = ACTIONS(1793),
    [aux_sym_continue_token1] = ACTIONS(1793),
    [aux_sym_protect_token1] = ACTIONS(1793),
    [aux_sym_protect_token4] = ACTIONS(1793),
    [aux_sym_lock_token1] = ACTIONS(1793),
    [aux_sym_lock_token2] = ACTIONS(1793),
    [anon_sym_PERCENT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [sym_regex_literal] = ACTIONS(1793),
    [aux_sym_slot_accessor_token1] = ACTIONS(1795),
    [aux_sym_true_token1] = ACTIONS(1793),
    [aux_sym_false_token1] = ACTIONS(1793),
    [aux_sym_maybe_token1] = ACTIONS(1793),
    [aux_sym_unset_token1] = ACTIONS(1793),
    [aux_sym_super_token1] = ACTIONS(1793),
    [aux_sym_self_token1] = ACTIONS(1793),
    [aux_sym_clone_token1] = ACTIONS(1793),
    [aux_sym_thisthread_token1] = ACTIONS(1793),
    [aux_sym_class_token1] = ACTIONS(1793),
    [aux_sym_global_token1] = ACTIONS(1793),
    [aux_sym_local_token1] = ACTIONS(1793),
    [aux_sym__global_assignment_token1] = ACTIONS(1793),
    [aux_sym_dynamic_token1] = ACTIONS(1793),
    [aux_sym_import_token1] = ACTIONS(1793),
    [aux_sym_return_token1] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [aux_sym_scatter_token1] = ACTIONS(1793),
    [aux_sym_allresults_token1] = ACTIONS(1793),
    [sym_dynamic_variable] = ACTIONS(1793),
    [sym_global_variable] = ACTIONS(1793),
    [sym_global_reference] = ACTIONS(1793),
    [sym_number] = ACTIONS(1793),
    [anon_sym_LBRACE] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_PLUS] = ACTIONS(1793),
    [aux_sym_unary_operator_token1] = ACTIONS(1793),
    [anon_sym_TILDE] = ACTIONS(1793),
    [sym_symbol] = ACTIONS(1793),
    [sym_comment] = ACTIONS(103),
  },
  [484] = {
    [anon_sym_CR] = ACTIONS(1797),
    [anon_sym_LF] = ACTIONS(1797),
    [anon_sym_DOT] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1797),
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_LT_LT] = ACTIONS(1797),
    [anon_sym_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [aux_sym_method_token7] = ACTIONS(1797),
    [aux_sym_procedure_token2] = ACTIONS(1797),
    [aux_sym_block_token2] = ACTIONS(1797),
    [anon_sym__and_LT_LT] = ACTIONS(1797),
    [anon_sym__andif_LT_LT] = ACTIONS(1797),
    [anon_sym__or_LT_LT] = ACTIONS(1797),
    [anon_sym__orif_LT_LT] = ACTIONS(1797),
    [anon_sym__xor_LT_LT] = ACTIONS(1797),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1797),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym_STAR_LT_LT] = ACTIONS(1797),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1797),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym__mod_LT_LT] = ACTIONS(1797),
    [anon_sym__div_LT_LT] = ACTIONS(1797),
    [anon_sym_DASH_LT_LT] = ACTIONS(1797),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1797),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1797),
    [aux_sym_if_token3] = ACTIONS(1797),
    [aux_sym_elif_token1] = ACTIONS(1797),
    [aux_sym_else_token1] = ACTIONS(1797),
    [aux_sym_loop_token2] = ACTIONS(1797),
    [aux_sym_finally_token1] = ACTIONS(1797),
    [aux_sym_finally_token2] = ACTIONS(1797),
    [aux_sym_catch_token2] = ACTIONS(1797),
    [aux_sym_try_token2] = ACTIONS(1797),
    [aux_sym_try_token3] = ACTIONS(1797),
    [aux_sym_protect_token3] = ACTIONS(1797),
    [aux_sym_protect_token4] = ACTIONS(1797),
    [aux_sym_lock_token2] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1797),
    [sym_label] = ACTIONS(1799),
    [aux_sym_relational_operator_token1] = ACTIONS(1797),
    [aux_sym_relational_operator_token2] = ACTIONS(1797),
    [aux_sym_relational_operator_token3] = ACTIONS(1797),
    [anon_sym_EQ] = ACTIONS(1797),
    [anon_sym_TILDE_EQ] = ACTIONS(1797),
    [anon_sym_LT_GT] = ACTIONS(1797),
    [anon_sym_GT_EQ] = ACTIONS(1797),
    [anon_sym_LT_EQ] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(1797),
    [anon_sym_GT] = ACTIONS(1797),
    [aux_sym_logical_operator_token1] = ACTIONS(1797),
    [aux_sym_logical_operator_token2] = ACTIONS(1797),
    [aux_sym_logical_operator_token3] = ACTIONS(1797),
    [aux_sym_logical_operator_token4] = ACTIONS(1797),
    [aux_sym_logical_operator_token5] = ACTIONS(1797),
    [aux_sym_logical_operator_token6] = ACTIONS(1797),
    [anon_sym_STAR_STAR] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1797),
    [anon_sym_SLASH] = ACTIONS(1797),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1797),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_PLUS] = ACTIONS(1797),
    [sym_comment] = ACTIONS(3),
  },
  [485] = {
    [anon_sym_CR] = ACTIONS(1801),
    [anon_sym_LF] = ACTIONS(1801),
    [anon_sym_DOT] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1801),
    [anon_sym_COMMA] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [aux_sym_method_token7] = ACTIONS(1801),
    [aux_sym_procedure_token2] = ACTIONS(1801),
    [aux_sym_block_token2] = ACTIONS(1801),
    [anon_sym__and_LT_LT] = ACTIONS(1801),
    [anon_sym__andif_LT_LT] = ACTIONS(1801),
    [anon_sym__or_LT_LT] = ACTIONS(1801),
    [anon_sym__orif_LT_LT] = ACTIONS(1801),
    [anon_sym__xor_LT_LT] = ACTIONS(1801),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1801),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym_STAR_LT_LT] = ACTIONS(1801),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1801),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym__mod_LT_LT] = ACTIONS(1801),
    [anon_sym__div_LT_LT] = ACTIONS(1801),
    [anon_sym_DASH_LT_LT] = ACTIONS(1801),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1801),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1801),
    [aux_sym_if_token3] = ACTIONS(1801),
    [aux_sym_elif_token1] = ACTIONS(1801),
    [aux_sym_else_token1] = ACTIONS(1801),
    [aux_sym_loop_token2] = ACTIONS(1801),
    [aux_sym_finally_token1] = ACTIONS(1801),
    [aux_sym_finally_token2] = ACTIONS(1801),
    [aux_sym_catch_token2] = ACTIONS(1801),
    [aux_sym_try_token2] = ACTIONS(1801),
    [aux_sym_try_token3] = ACTIONS(1801),
    [aux_sym_protect_token3] = ACTIONS(1801),
    [aux_sym_protect_token4] = ACTIONS(1801),
    [aux_sym_lock_token2] = ACTIONS(1801),
    [anon_sym_SEMI] = ACTIONS(1801),
    [sym_label] = ACTIONS(1803),
    [aux_sym_relational_operator_token1] = ACTIONS(1801),
    [aux_sym_relational_operator_token2] = ACTIONS(1801),
    [aux_sym_relational_operator_token3] = ACTIONS(1801),
    [anon_sym_EQ] = ACTIONS(1801),
    [anon_sym_TILDE_EQ] = ACTIONS(1801),
    [anon_sym_LT_GT] = ACTIONS(1801),
    [anon_sym_GT_EQ] = ACTIONS(1801),
    [anon_sym_LT_EQ] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [aux_sym_logical_operator_token1] = ACTIONS(1801),
    [aux_sym_logical_operator_token2] = ACTIONS(1801),
    [aux_sym_logical_operator_token3] = ACTIONS(1801),
    [aux_sym_logical_operator_token4] = ACTIONS(1801),
    [aux_sym_logical_operator_token5] = ACTIONS(1801),
    [aux_sym_logical_operator_token6] = ACTIONS(1801),
    [anon_sym_STAR_STAR] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_SLASH] = ACTIONS(1801),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1801),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_PLUS] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [486] = {
    [anon_sym_CR] = ACTIONS(1805),
    [anon_sym_LF] = ACTIONS(1805),
    [anon_sym_DOT] = ACTIONS(1805),
    [anon_sym_LPAREN] = ACTIONS(1805),
    [anon_sym_COMMA] = ACTIONS(1805),
    [anon_sym_LT_LT] = ACTIONS(1805),
    [anon_sym_CARET_LT_LT] = ACTIONS(1805),
    [anon_sym_LBRACK] = ACTIONS(1805),
    [aux_sym_method_token7] = ACTIONS(1805),
    [aux_sym_procedure_token2] = ACTIONS(1805),
    [aux_sym_block_token2] = ACTIONS(1805),
    [anon_sym__and_LT_LT] = ACTIONS(1805),
    [anon_sym__andif_LT_LT] = ACTIONS(1805),
    [anon_sym__or_LT_LT] = ACTIONS(1805),
    [anon_sym__orif_LT_LT] = ACTIONS(1805),
    [anon_sym__xor_LT_LT] = ACTIONS(1805),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1805),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1805),
    [anon_sym_STAR_LT_LT] = ACTIONS(1805),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1805),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1805),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1805),
    [anon_sym__mod_LT_LT] = ACTIONS(1805),
    [anon_sym__div_LT_LT] = ACTIONS(1805),
    [anon_sym_DASH_LT_LT] = ACTIONS(1805),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1805),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1805),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1805),
    [aux_sym_if_token3] = ACTIONS(1805),
    [aux_sym_elif_token1] = ACTIONS(1805),
    [aux_sym_else_token1] = ACTIONS(1805),
    [aux_sym_loop_token2] = ACTIONS(1805),
    [aux_sym_finally_token1] = ACTIONS(1805),
    [aux_sym_finally_token2] = ACTIONS(1805),
    [aux_sym_catch_token2] = ACTIONS(1805),
    [aux_sym_try_token2] = ACTIONS(1805),
    [aux_sym_try_token3] = ACTIONS(1805),
    [aux_sym_protect_token3] = ACTIONS(1805),
    [aux_sym_protect_token4] = ACTIONS(1805),
    [aux_sym_lock_token2] = ACTIONS(1805),
    [anon_sym_SEMI] = ACTIONS(1805),
    [aux_sym_relational_operator_token1] = ACTIONS(1805),
    [aux_sym_relational_operator_token2] = ACTIONS(1805),
    [aux_sym_relational_operator_token3] = ACTIONS(1805),
    [anon_sym_EQ] = ACTIONS(1805),
    [anon_sym_TILDE_EQ] = ACTIONS(1805),
    [anon_sym_LT_GT] = ACTIONS(1805),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_LT_EQ] = ACTIONS(1805),
    [anon_sym_LT] = ACTIONS(1805),
    [anon_sym_GT] = ACTIONS(1805),
    [aux_sym_logical_operator_token1] = ACTIONS(1805),
    [aux_sym_logical_operator_token2] = ACTIONS(1805),
    [aux_sym_logical_operator_token3] = ACTIONS(1805),
    [aux_sym_logical_operator_token4] = ACTIONS(1805),
    [aux_sym_logical_operator_token5] = ACTIONS(1805),
    [aux_sym_logical_operator_token6] = ACTIONS(1805),
    [anon_sym_STAR_STAR] = ACTIONS(1805),
    [anon_sym_STAR] = ACTIONS(1805),
    [anon_sym_SLASH] = ACTIONS(1805),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1805),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1805),
    [anon_sym_PLUS] = ACTIONS(1805),
    [sym_comment] = ACTIONS(3),
  },
  [487] = {
    [anon_sym_CR] = ACTIONS(1807),
    [anon_sym_LF] = ACTIONS(1807),
    [anon_sym_DOT] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1807),
    [anon_sym_COMMA] = ACTIONS(1807),
    [anon_sym_LT_LT] = ACTIONS(1807),
    [anon_sym_CARET_LT_LT] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(1807),
    [aux_sym_method_token7] = ACTIONS(1807),
    [aux_sym_procedure_token2] = ACTIONS(1807),
    [aux_sym_block_token2] = ACTIONS(1807),
    [anon_sym__and_LT_LT] = ACTIONS(1807),
    [anon_sym__andif_LT_LT] = ACTIONS(1807),
    [anon_sym__or_LT_LT] = ACTIONS(1807),
    [anon_sym__orif_LT_LT] = ACTIONS(1807),
    [anon_sym__xor_LT_LT] = ACTIONS(1807),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1807),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1807),
    [anon_sym_STAR_LT_LT] = ACTIONS(1807),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1807),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1807),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1807),
    [anon_sym__mod_LT_LT] = ACTIONS(1807),
    [anon_sym__div_LT_LT] = ACTIONS(1807),
    [anon_sym_DASH_LT_LT] = ACTIONS(1807),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1807),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1807),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1807),
    [aux_sym_if_token3] = ACTIONS(1807),
    [aux_sym_elif_token1] = ACTIONS(1807),
    [aux_sym_else_token1] = ACTIONS(1807),
    [aux_sym_loop_token2] = ACTIONS(1807),
    [aux_sym_finally_token1] = ACTIONS(1807),
    [aux_sym_finally_token2] = ACTIONS(1807),
    [aux_sym_catch_token2] = ACTIONS(1807),
    [aux_sym_try_token2] = ACTIONS(1807),
    [aux_sym_try_token3] = ACTIONS(1807),
    [aux_sym_protect_token3] = ACTIONS(1807),
    [aux_sym_protect_token4] = ACTIONS(1807),
    [aux_sym_lock_token2] = ACTIONS(1807),
    [anon_sym_SEMI] = ACTIONS(1807),
    [aux_sym_relational_operator_token1] = ACTIONS(1807),
    [aux_sym_relational_operator_token2] = ACTIONS(1807),
    [aux_sym_relational_operator_token3] = ACTIONS(1807),
    [anon_sym_EQ] = ACTIONS(1807),
    [anon_sym_TILDE_EQ] = ACTIONS(1807),
    [anon_sym_LT_GT] = ACTIONS(1807),
    [anon_sym_GT_EQ] = ACTIONS(1807),
    [anon_sym_LT_EQ] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_GT] = ACTIONS(1807),
    [aux_sym_logical_operator_token1] = ACTIONS(1807),
    [aux_sym_logical_operator_token2] = ACTIONS(1807),
    [aux_sym_logical_operator_token3] = ACTIONS(1807),
    [aux_sym_logical_operator_token4] = ACTIONS(1807),
    [aux_sym_logical_operator_token5] = ACTIONS(1807),
    [aux_sym_logical_operator_token6] = ACTIONS(1807),
    [anon_sym_STAR_STAR] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1807),
    [anon_sym_SLASH] = ACTIONS(1807),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1807),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
  },
  [488] = {
    [anon_sym_CR] = ACTIONS(1809),
    [anon_sym_LF] = ACTIONS(1809),
    [anon_sym_DOT] = ACTIONS(1809),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_COMMA] = ACTIONS(1809),
    [anon_sym_LT_LT] = ACTIONS(1809),
    [anon_sym_CARET_LT_LT] = ACTIONS(1809),
    [anon_sym_LBRACK] = ACTIONS(1809),
    [aux_sym_method_token7] = ACTIONS(1809),
    [aux_sym_procedure_token2] = ACTIONS(1809),
    [aux_sym_block_token2] = ACTIONS(1809),
    [anon_sym__and_LT_LT] = ACTIONS(1809),
    [anon_sym__andif_LT_LT] = ACTIONS(1809),
    [anon_sym__or_LT_LT] = ACTIONS(1809),
    [anon_sym__orif_LT_LT] = ACTIONS(1809),
    [anon_sym__xor_LT_LT] = ACTIONS(1809),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1809),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1809),
    [anon_sym_STAR_LT_LT] = ACTIONS(1809),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1809),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1809),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1809),
    [anon_sym__mod_LT_LT] = ACTIONS(1809),
    [anon_sym__div_LT_LT] = ACTIONS(1809),
    [anon_sym_DASH_LT_LT] = ACTIONS(1809),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1809),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1809),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1809),
    [aux_sym_if_token3] = ACTIONS(1809),
    [aux_sym_elif_token1] = ACTIONS(1809),
    [aux_sym_else_token1] = ACTIONS(1809),
    [aux_sym_loop_token2] = ACTIONS(1809),
    [aux_sym_finally_token1] = ACTIONS(1809),
    [aux_sym_finally_token2] = ACTIONS(1809),
    [aux_sym_catch_token2] = ACTIONS(1809),
    [aux_sym_try_token2] = ACTIONS(1809),
    [aux_sym_try_token3] = ACTIONS(1809),
    [aux_sym_protect_token3] = ACTIONS(1809),
    [aux_sym_protect_token4] = ACTIONS(1809),
    [aux_sym_lock_token2] = ACTIONS(1809),
    [anon_sym_SEMI] = ACTIONS(1809),
    [aux_sym_relational_operator_token1] = ACTIONS(1809),
    [aux_sym_relational_operator_token2] = ACTIONS(1809),
    [aux_sym_relational_operator_token3] = ACTIONS(1809),
    [anon_sym_EQ] = ACTIONS(1809),
    [anon_sym_TILDE_EQ] = ACTIONS(1809),
    [anon_sym_LT_GT] = ACTIONS(1809),
    [anon_sym_GT_EQ] = ACTIONS(1809),
    [anon_sym_LT_EQ] = ACTIONS(1809),
    [anon_sym_LT] = ACTIONS(1809),
    [anon_sym_GT] = ACTIONS(1809),
    [aux_sym_logical_operator_token1] = ACTIONS(1809),
    [aux_sym_logical_operator_token2] = ACTIONS(1809),
    [aux_sym_logical_operator_token3] = ACTIONS(1809),
    [aux_sym_logical_operator_token4] = ACTIONS(1809),
    [aux_sym_logical_operator_token5] = ACTIONS(1809),
    [aux_sym_logical_operator_token6] = ACTIONS(1809),
    [anon_sym_STAR_STAR] = ACTIONS(1809),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1809),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1809),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1809),
    [anon_sym_DASH] = ACTIONS(1809),
    [anon_sym_PLUS] = ACTIONS(1809),
    [sym_comment] = ACTIONS(3),
  },
  [489] = {
    [anon_sym_CR] = ACTIONS(1811),
    [anon_sym_LF] = ACTIONS(1811),
    [anon_sym_DOT] = ACTIONS(1811),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_COMMA] = ACTIONS(1811),
    [anon_sym_LT_LT] = ACTIONS(1811),
    [anon_sym_CARET_LT_LT] = ACTIONS(1811),
    [anon_sym_LBRACK] = ACTIONS(1811),
    [aux_sym_method_token7] = ACTIONS(1811),
    [aux_sym_procedure_token2] = ACTIONS(1811),
    [aux_sym_block_token2] = ACTIONS(1811),
    [anon_sym__and_LT_LT] = ACTIONS(1811),
    [anon_sym__andif_LT_LT] = ACTIONS(1811),
    [anon_sym__or_LT_LT] = ACTIONS(1811),
    [anon_sym__orif_LT_LT] = ACTIONS(1811),
    [anon_sym__xor_LT_LT] = ACTIONS(1811),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1811),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1811),
    [anon_sym_STAR_LT_LT] = ACTIONS(1811),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1811),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1811),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1811),
    [anon_sym__mod_LT_LT] = ACTIONS(1811),
    [anon_sym__div_LT_LT] = ACTIONS(1811),
    [anon_sym_DASH_LT_LT] = ACTIONS(1811),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1811),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1811),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1811),
    [aux_sym_if_token3] = ACTIONS(1811),
    [aux_sym_elif_token1] = ACTIONS(1811),
    [aux_sym_else_token1] = ACTIONS(1811),
    [aux_sym_loop_token2] = ACTIONS(1811),
    [aux_sym_finally_token1] = ACTIONS(1811),
    [aux_sym_finally_token2] = ACTIONS(1811),
    [aux_sym_catch_token2] = ACTIONS(1811),
    [aux_sym_try_token2] = ACTIONS(1811),
    [aux_sym_try_token3] = ACTIONS(1811),
    [aux_sym_protect_token3] = ACTIONS(1811),
    [aux_sym_protect_token4] = ACTIONS(1811),
    [aux_sym_lock_token2] = ACTIONS(1811),
    [anon_sym_SEMI] = ACTIONS(1811),
    [aux_sym_relational_operator_token1] = ACTIONS(1811),
    [aux_sym_relational_operator_token2] = ACTIONS(1811),
    [aux_sym_relational_operator_token3] = ACTIONS(1811),
    [anon_sym_EQ] = ACTIONS(1811),
    [anon_sym_TILDE_EQ] = ACTIONS(1811),
    [anon_sym_LT_GT] = ACTIONS(1811),
    [anon_sym_GT_EQ] = ACTIONS(1811),
    [anon_sym_LT_EQ] = ACTIONS(1811),
    [anon_sym_LT] = ACTIONS(1811),
    [anon_sym_GT] = ACTIONS(1811),
    [aux_sym_logical_operator_token1] = ACTIONS(1811),
    [aux_sym_logical_operator_token2] = ACTIONS(1811),
    [aux_sym_logical_operator_token3] = ACTIONS(1811),
    [aux_sym_logical_operator_token4] = ACTIONS(1811),
    [aux_sym_logical_operator_token5] = ACTIONS(1811),
    [aux_sym_logical_operator_token6] = ACTIONS(1811),
    [anon_sym_STAR_STAR] = ACTIONS(1811),
    [anon_sym_STAR] = ACTIONS(1811),
    [anon_sym_SLASH] = ACTIONS(1811),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1811),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_PLUS] = ACTIONS(1811),
    [sym_comment] = ACTIONS(3),
  },
  [490] = {
    [anon_sym_CR] = ACTIONS(1813),
    [anon_sym_LF] = ACTIONS(1813),
    [anon_sym_DOT] = ACTIONS(1813),
    [anon_sym_LPAREN] = ACTIONS(1813),
    [anon_sym_COMMA] = ACTIONS(1813),
    [anon_sym_LT_LT] = ACTIONS(1813),
    [anon_sym_CARET_LT_LT] = ACTIONS(1813),
    [anon_sym_LBRACK] = ACTIONS(1813),
    [aux_sym_method_token7] = ACTIONS(1813),
    [aux_sym_procedure_token2] = ACTIONS(1813),
    [aux_sym_block_token2] = ACTIONS(1813),
    [anon_sym__and_LT_LT] = ACTIONS(1813),
    [anon_sym__andif_LT_LT] = ACTIONS(1813),
    [anon_sym__or_LT_LT] = ACTIONS(1813),
    [anon_sym__orif_LT_LT] = ACTIONS(1813),
    [anon_sym__xor_LT_LT] = ACTIONS(1813),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1813),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1813),
    [anon_sym_STAR_LT_LT] = ACTIONS(1813),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1813),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1813),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1813),
    [anon_sym__mod_LT_LT] = ACTIONS(1813),
    [anon_sym__div_LT_LT] = ACTIONS(1813),
    [anon_sym_DASH_LT_LT] = ACTIONS(1813),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1813),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1813),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1813),
    [aux_sym_if_token3] = ACTIONS(1813),
    [aux_sym_elif_token1] = ACTIONS(1813),
    [aux_sym_else_token1] = ACTIONS(1813),
    [aux_sym_loop_token2] = ACTIONS(1813),
    [aux_sym_finally_token1] = ACTIONS(1813),
    [aux_sym_finally_token2] = ACTIONS(1813),
    [aux_sym_catch_token2] = ACTIONS(1813),
    [aux_sym_try_token2] = ACTIONS(1813),
    [aux_sym_try_token3] = ACTIONS(1813),
    [aux_sym_protect_token3] = ACTIONS(1813),
    [aux_sym_protect_token4] = ACTIONS(1813),
    [aux_sym_lock_token2] = ACTIONS(1813),
    [anon_sym_SEMI] = ACTIONS(1813),
    [aux_sym_relational_operator_token1] = ACTIONS(1813),
    [aux_sym_relational_operator_token2] = ACTIONS(1813),
    [aux_sym_relational_operator_token3] = ACTIONS(1813),
    [anon_sym_EQ] = ACTIONS(1813),
    [anon_sym_TILDE_EQ] = ACTIONS(1813),
    [anon_sym_LT_GT] = ACTIONS(1813),
    [anon_sym_GT_EQ] = ACTIONS(1813),
    [anon_sym_LT_EQ] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1813),
    [anon_sym_GT] = ACTIONS(1813),
    [aux_sym_logical_operator_token1] = ACTIONS(1813),
    [aux_sym_logical_operator_token2] = ACTIONS(1813),
    [aux_sym_logical_operator_token3] = ACTIONS(1813),
    [aux_sym_logical_operator_token4] = ACTIONS(1813),
    [aux_sym_logical_operator_token5] = ACTIONS(1813),
    [aux_sym_logical_operator_token6] = ACTIONS(1813),
    [anon_sym_STAR_STAR] = ACTIONS(1813),
    [anon_sym_STAR] = ACTIONS(1813),
    [anon_sym_SLASH] = ACTIONS(1813),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1813),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1813),
    [anon_sym_DASH] = ACTIONS(1813),
    [anon_sym_PLUS] = ACTIONS(1813),
    [sym_comment] = ACTIONS(3),
  },
  [491] = {
    [anon_sym_CR] = ACTIONS(1815),
    [anon_sym_LF] = ACTIONS(1815),
    [anon_sym_DOT] = ACTIONS(1815),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_COMMA] = ACTIONS(1815),
    [anon_sym_LT_LT] = ACTIONS(1815),
    [anon_sym_CARET_LT_LT] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(1815),
    [aux_sym_method_token7] = ACTIONS(1815),
    [aux_sym_procedure_token2] = ACTIONS(1815),
    [aux_sym_block_token2] = ACTIONS(1815),
    [anon_sym__and_LT_LT] = ACTIONS(1815),
    [anon_sym__andif_LT_LT] = ACTIONS(1815),
    [anon_sym__or_LT_LT] = ACTIONS(1815),
    [anon_sym__orif_LT_LT] = ACTIONS(1815),
    [anon_sym__xor_LT_LT] = ACTIONS(1815),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1815),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1815),
    [anon_sym_STAR_LT_LT] = ACTIONS(1815),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1815),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1815),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1815),
    [anon_sym__mod_LT_LT] = ACTIONS(1815),
    [anon_sym__div_LT_LT] = ACTIONS(1815),
    [anon_sym_DASH_LT_LT] = ACTIONS(1815),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1815),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1815),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1815),
    [aux_sym_if_token3] = ACTIONS(1815),
    [aux_sym_elif_token1] = ACTIONS(1815),
    [aux_sym_else_token1] = ACTIONS(1815),
    [aux_sym_loop_token2] = ACTIONS(1815),
    [aux_sym_finally_token1] = ACTIONS(1815),
    [aux_sym_finally_token2] = ACTIONS(1815),
    [aux_sym_catch_token2] = ACTIONS(1815),
    [aux_sym_try_token2] = ACTIONS(1815),
    [aux_sym_try_token3] = ACTIONS(1815),
    [aux_sym_protect_token3] = ACTIONS(1815),
    [aux_sym_protect_token4] = ACTIONS(1815),
    [aux_sym_lock_token2] = ACTIONS(1815),
    [anon_sym_SEMI] = ACTIONS(1815),
    [aux_sym_relational_operator_token1] = ACTIONS(1815),
    [aux_sym_relational_operator_token2] = ACTIONS(1815),
    [aux_sym_relational_operator_token3] = ACTIONS(1815),
    [anon_sym_EQ] = ACTIONS(1815),
    [anon_sym_TILDE_EQ] = ACTIONS(1815),
    [anon_sym_LT_GT] = ACTIONS(1815),
    [anon_sym_GT_EQ] = ACTIONS(1815),
    [anon_sym_LT_EQ] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_GT] = ACTIONS(1815),
    [aux_sym_logical_operator_token1] = ACTIONS(1815),
    [aux_sym_logical_operator_token2] = ACTIONS(1815),
    [aux_sym_logical_operator_token3] = ACTIONS(1815),
    [aux_sym_logical_operator_token4] = ACTIONS(1815),
    [aux_sym_logical_operator_token5] = ACTIONS(1815),
    [aux_sym_logical_operator_token6] = ACTIONS(1815),
    [anon_sym_STAR_STAR] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_SLASH] = ACTIONS(1815),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1815),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_PLUS] = ACTIONS(1815),
    [sym_comment] = ACTIONS(3),
  },
  [492] = {
    [anon_sym_CR] = ACTIONS(1817),
    [anon_sym_LF] = ACTIONS(1817),
    [anon_sym_DOT] = ACTIONS(1817),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_COMMA] = ACTIONS(1817),
    [anon_sym_LT_LT] = ACTIONS(1817),
    [anon_sym_CARET_LT_LT] = ACTIONS(1817),
    [anon_sym_LBRACK] = ACTIONS(1817),
    [aux_sym_method_token7] = ACTIONS(1817),
    [aux_sym_procedure_token2] = ACTIONS(1817),
    [aux_sym_block_token2] = ACTIONS(1817),
    [anon_sym__and_LT_LT] = ACTIONS(1817),
    [anon_sym__andif_LT_LT] = ACTIONS(1817),
    [anon_sym__or_LT_LT] = ACTIONS(1817),
    [anon_sym__orif_LT_LT] = ACTIONS(1817),
    [anon_sym__xor_LT_LT] = ACTIONS(1817),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1817),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1817),
    [anon_sym_STAR_LT_LT] = ACTIONS(1817),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1817),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1817),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1817),
    [anon_sym__mod_LT_LT] = ACTIONS(1817),
    [anon_sym__div_LT_LT] = ACTIONS(1817),
    [anon_sym_DASH_LT_LT] = ACTIONS(1817),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1817),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1817),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1817),
    [aux_sym_if_token3] = ACTIONS(1817),
    [aux_sym_elif_token1] = ACTIONS(1817),
    [aux_sym_else_token1] = ACTIONS(1817),
    [aux_sym_loop_token2] = ACTIONS(1817),
    [aux_sym_finally_token1] = ACTIONS(1817),
    [aux_sym_finally_token2] = ACTIONS(1817),
    [aux_sym_catch_token2] = ACTIONS(1817),
    [aux_sym_try_token2] = ACTIONS(1817),
    [aux_sym_try_token3] = ACTIONS(1817),
    [aux_sym_protect_token3] = ACTIONS(1817),
    [aux_sym_protect_token4] = ACTIONS(1817),
    [aux_sym_lock_token2] = ACTIONS(1817),
    [anon_sym_SEMI] = ACTIONS(1817),
    [aux_sym_relational_operator_token1] = ACTIONS(1817),
    [aux_sym_relational_operator_token2] = ACTIONS(1817),
    [aux_sym_relational_operator_token3] = ACTIONS(1817),
    [anon_sym_EQ] = ACTIONS(1817),
    [anon_sym_TILDE_EQ] = ACTIONS(1817),
    [anon_sym_LT_GT] = ACTIONS(1817),
    [anon_sym_GT_EQ] = ACTIONS(1817),
    [anon_sym_LT_EQ] = ACTIONS(1817),
    [anon_sym_LT] = ACTIONS(1817),
    [anon_sym_GT] = ACTIONS(1817),
    [aux_sym_logical_operator_token1] = ACTIONS(1817),
    [aux_sym_logical_operator_token2] = ACTIONS(1817),
    [aux_sym_logical_operator_token3] = ACTIONS(1817),
    [aux_sym_logical_operator_token4] = ACTIONS(1817),
    [aux_sym_logical_operator_token5] = ACTIONS(1817),
    [aux_sym_logical_operator_token6] = ACTIONS(1817),
    [anon_sym_STAR_STAR] = ACTIONS(1817),
    [anon_sym_STAR] = ACTIONS(1817),
    [anon_sym_SLASH] = ACTIONS(1817),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1817),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1817),
    [anon_sym_DASH] = ACTIONS(1817),
    [anon_sym_PLUS] = ACTIONS(1817),
    [sym_comment] = ACTIONS(3),
  },
  [493] = {
    [anon_sym_CR] = ACTIONS(1819),
    [anon_sym_LF] = ACTIONS(1819),
    [anon_sym_DOT] = ACTIONS(1819),
    [anon_sym_LPAREN] = ACTIONS(1819),
    [anon_sym_COMMA] = ACTIONS(1819),
    [anon_sym_LT_LT] = ACTIONS(1819),
    [anon_sym_CARET_LT_LT] = ACTIONS(1819),
    [anon_sym_LBRACK] = ACTIONS(1819),
    [aux_sym_method_token7] = ACTIONS(1819),
    [aux_sym_procedure_token2] = ACTIONS(1819),
    [aux_sym_block_token2] = ACTIONS(1819),
    [anon_sym__and_LT_LT] = ACTIONS(1819),
    [anon_sym__andif_LT_LT] = ACTIONS(1819),
    [anon_sym__or_LT_LT] = ACTIONS(1819),
    [anon_sym__orif_LT_LT] = ACTIONS(1819),
    [anon_sym__xor_LT_LT] = ACTIONS(1819),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1819),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1819),
    [anon_sym_STAR_LT_LT] = ACTIONS(1819),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1819),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1819),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1819),
    [anon_sym__mod_LT_LT] = ACTIONS(1819),
    [anon_sym__div_LT_LT] = ACTIONS(1819),
    [anon_sym_DASH_LT_LT] = ACTIONS(1819),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1819),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1819),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1819),
    [aux_sym_if_token3] = ACTIONS(1819),
    [aux_sym_elif_token1] = ACTIONS(1819),
    [aux_sym_else_token1] = ACTIONS(1819),
    [aux_sym_loop_token2] = ACTIONS(1819),
    [aux_sym_finally_token1] = ACTIONS(1819),
    [aux_sym_finally_token2] = ACTIONS(1819),
    [aux_sym_catch_token2] = ACTIONS(1819),
    [aux_sym_try_token2] = ACTIONS(1819),
    [aux_sym_try_token3] = ACTIONS(1819),
    [aux_sym_protect_token3] = ACTIONS(1819),
    [aux_sym_protect_token4] = ACTIONS(1819),
    [aux_sym_lock_token2] = ACTIONS(1819),
    [anon_sym_SEMI] = ACTIONS(1819),
    [aux_sym_relational_operator_token1] = ACTIONS(1819),
    [aux_sym_relational_operator_token2] = ACTIONS(1819),
    [aux_sym_relational_operator_token3] = ACTIONS(1819),
    [anon_sym_EQ] = ACTIONS(1819),
    [anon_sym_TILDE_EQ] = ACTIONS(1819),
    [anon_sym_LT_GT] = ACTIONS(1819),
    [anon_sym_GT_EQ] = ACTIONS(1819),
    [anon_sym_LT_EQ] = ACTIONS(1819),
    [anon_sym_LT] = ACTIONS(1819),
    [anon_sym_GT] = ACTIONS(1819),
    [aux_sym_logical_operator_token1] = ACTIONS(1819),
    [aux_sym_logical_operator_token2] = ACTIONS(1819),
    [aux_sym_logical_operator_token3] = ACTIONS(1819),
    [aux_sym_logical_operator_token4] = ACTIONS(1819),
    [aux_sym_logical_operator_token5] = ACTIONS(1819),
    [aux_sym_logical_operator_token6] = ACTIONS(1819),
    [anon_sym_STAR_STAR] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_SLASH] = ACTIONS(1819),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1819),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_PLUS] = ACTIONS(1819),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [anon_sym_CR] = ACTIONS(1821),
    [anon_sym_LF] = ACTIONS(1821),
    [anon_sym_DOT] = ACTIONS(1821),
    [anon_sym_LPAREN] = ACTIONS(1821),
    [anon_sym_COMMA] = ACTIONS(1821),
    [anon_sym_LT_LT] = ACTIONS(1821),
    [anon_sym_CARET_LT_LT] = ACTIONS(1821),
    [anon_sym_LBRACK] = ACTIONS(1821),
    [aux_sym_method_token7] = ACTIONS(1821),
    [aux_sym_procedure_token2] = ACTIONS(1821),
    [aux_sym_block_token2] = ACTIONS(1821),
    [anon_sym__and_LT_LT] = ACTIONS(1821),
    [anon_sym__andif_LT_LT] = ACTIONS(1821),
    [anon_sym__or_LT_LT] = ACTIONS(1821),
    [anon_sym__orif_LT_LT] = ACTIONS(1821),
    [anon_sym__xor_LT_LT] = ACTIONS(1821),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1821),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1821),
    [anon_sym_STAR_LT_LT] = ACTIONS(1821),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1821),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1821),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1821),
    [anon_sym__mod_LT_LT] = ACTIONS(1821),
    [anon_sym__div_LT_LT] = ACTIONS(1821),
    [anon_sym_DASH_LT_LT] = ACTIONS(1821),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1821),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1821),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1821),
    [aux_sym_if_token3] = ACTIONS(1821),
    [aux_sym_elif_token1] = ACTIONS(1821),
    [aux_sym_else_token1] = ACTIONS(1821),
    [aux_sym_loop_token2] = ACTIONS(1821),
    [aux_sym_finally_token1] = ACTIONS(1821),
    [aux_sym_finally_token2] = ACTIONS(1821),
    [aux_sym_catch_token2] = ACTIONS(1821),
    [aux_sym_try_token2] = ACTIONS(1821),
    [aux_sym_try_token3] = ACTIONS(1821),
    [aux_sym_protect_token3] = ACTIONS(1821),
    [aux_sym_protect_token4] = ACTIONS(1821),
    [aux_sym_lock_token2] = ACTIONS(1821),
    [anon_sym_SEMI] = ACTIONS(1821),
    [aux_sym_relational_operator_token1] = ACTIONS(1821),
    [aux_sym_relational_operator_token2] = ACTIONS(1821),
    [aux_sym_relational_operator_token3] = ACTIONS(1821),
    [anon_sym_EQ] = ACTIONS(1821),
    [anon_sym_TILDE_EQ] = ACTIONS(1821),
    [anon_sym_LT_GT] = ACTIONS(1821),
    [anon_sym_GT_EQ] = ACTIONS(1821),
    [anon_sym_LT_EQ] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(1821),
    [anon_sym_GT] = ACTIONS(1821),
    [aux_sym_logical_operator_token1] = ACTIONS(1821),
    [aux_sym_logical_operator_token2] = ACTIONS(1821),
    [aux_sym_logical_operator_token3] = ACTIONS(1821),
    [aux_sym_logical_operator_token4] = ACTIONS(1821),
    [aux_sym_logical_operator_token5] = ACTIONS(1821),
    [aux_sym_logical_operator_token6] = ACTIONS(1821),
    [anon_sym_STAR_STAR] = ACTIONS(1821),
    [anon_sym_STAR] = ACTIONS(1821),
    [anon_sym_SLASH] = ACTIONS(1821),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1821),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1821),
    [anon_sym_DASH] = ACTIONS(1821),
    [anon_sym_PLUS] = ACTIONS(1821),
    [sym_comment] = ACTIONS(3),
  },
  [495] = {
    [anon_sym_CR] = ACTIONS(1823),
    [anon_sym_LF] = ACTIONS(1823),
    [anon_sym_DOT] = ACTIONS(1823),
    [anon_sym_LPAREN] = ACTIONS(1823),
    [anon_sym_COMMA] = ACTIONS(1823),
    [anon_sym_LT_LT] = ACTIONS(1823),
    [anon_sym_CARET_LT_LT] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1823),
    [aux_sym_method_token7] = ACTIONS(1823),
    [aux_sym_procedure_token2] = ACTIONS(1823),
    [aux_sym_block_token2] = ACTIONS(1823),
    [anon_sym__and_LT_LT] = ACTIONS(1823),
    [anon_sym__andif_LT_LT] = ACTIONS(1823),
    [anon_sym__or_LT_LT] = ACTIONS(1823),
    [anon_sym__orif_LT_LT] = ACTIONS(1823),
    [anon_sym__xor_LT_LT] = ACTIONS(1823),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1823),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1823),
    [anon_sym_STAR_LT_LT] = ACTIONS(1823),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1823),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1823),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1823),
    [anon_sym__mod_LT_LT] = ACTIONS(1823),
    [anon_sym__div_LT_LT] = ACTIONS(1823),
    [anon_sym_DASH_LT_LT] = ACTIONS(1823),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1823),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1823),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1823),
    [aux_sym_if_token3] = ACTIONS(1823),
    [aux_sym_elif_token1] = ACTIONS(1823),
    [aux_sym_else_token1] = ACTIONS(1823),
    [aux_sym_loop_token2] = ACTIONS(1823),
    [aux_sym_finally_token1] = ACTIONS(1823),
    [aux_sym_finally_token2] = ACTIONS(1823),
    [aux_sym_catch_token2] = ACTIONS(1823),
    [aux_sym_try_token2] = ACTIONS(1823),
    [aux_sym_try_token3] = ACTIONS(1823),
    [aux_sym_protect_token3] = ACTIONS(1823),
    [aux_sym_protect_token4] = ACTIONS(1823),
    [aux_sym_lock_token2] = ACTIONS(1823),
    [anon_sym_SEMI] = ACTIONS(1823),
    [aux_sym_relational_operator_token1] = ACTIONS(1823),
    [aux_sym_relational_operator_token2] = ACTIONS(1823),
    [aux_sym_relational_operator_token3] = ACTIONS(1823),
    [anon_sym_EQ] = ACTIONS(1823),
    [anon_sym_TILDE_EQ] = ACTIONS(1823),
    [anon_sym_LT_GT] = ACTIONS(1823),
    [anon_sym_GT_EQ] = ACTIONS(1823),
    [anon_sym_LT_EQ] = ACTIONS(1823),
    [anon_sym_LT] = ACTIONS(1823),
    [anon_sym_GT] = ACTIONS(1823),
    [aux_sym_logical_operator_token1] = ACTIONS(1823),
    [aux_sym_logical_operator_token2] = ACTIONS(1823),
    [aux_sym_logical_operator_token3] = ACTIONS(1823),
    [aux_sym_logical_operator_token4] = ACTIONS(1823),
    [aux_sym_logical_operator_token5] = ACTIONS(1823),
    [aux_sym_logical_operator_token6] = ACTIONS(1823),
    [anon_sym_STAR_STAR] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_SLASH] = ACTIONS(1823),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1823),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_PLUS] = ACTIONS(1823),
    [sym_comment] = ACTIONS(3),
  },
  [496] = {
    [aux_sym_loopbody_repeat1] = STATE(506),
    [anon_sym_CR] = ACTIONS(1825),
    [anon_sym_LF] = ACTIONS(1825),
    [anon_sym_DOT] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(1825),
    [aux_sym_procedure_token2] = ACTIONS(1825),
    [aux_sym_block_token2] = ACTIONS(1825),
    [anon_sym__and_LT_LT] = ACTIONS(1833),
    [anon_sym__andif_LT_LT] = ACTIONS(1833),
    [anon_sym__or_LT_LT] = ACTIONS(1833),
    [anon_sym__orif_LT_LT] = ACTIONS(1833),
    [anon_sym__xor_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym__mod_LT_LT] = ACTIONS(1833),
    [anon_sym__div_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1833),
    [aux_sym_if_token3] = ACTIONS(1825),
    [aux_sym_elif_token1] = ACTIONS(1825),
    [aux_sym_else_token1] = ACTIONS(1825),
    [aux_sym_loop_token2] = ACTIONS(1825),
    [aux_sym_finally_token1] = ACTIONS(1825),
    [aux_sym_finally_token2] = ACTIONS(1825),
    [aux_sym_catch_token2] = ACTIONS(1825),
    [aux_sym_try_token2] = ACTIONS(1825),
    [aux_sym_try_token3] = ACTIONS(1825),
    [aux_sym_protect_token4] = ACTIONS(1825),
    [aux_sym_lock_token2] = ACTIONS(1825),
    [anon_sym_SEMI] = ACTIONS(1825),
    [aux_sym_relational_operator_token1] = ACTIONS(1837),
    [aux_sym_relational_operator_token2] = ACTIONS(1837),
    [aux_sym_relational_operator_token3] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_TILDE_EQ] = ACTIONS(1837),
    [anon_sym_LT_GT] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_GT] = ACTIONS(1837),
    [aux_sym_logical_operator_token1] = ACTIONS(1839),
    [aux_sym_logical_operator_token2] = ACTIONS(1839),
    [aux_sym_logical_operator_token3] = ACTIONS(1839),
    [aux_sym_logical_operator_token4] = ACTIONS(1839),
    [aux_sym_logical_operator_token5] = ACTIONS(1839),
    [aux_sym_logical_operator_token6] = ACTIONS(1839),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [anon_sym_CR] = ACTIONS(1843),
    [anon_sym_LF] = ACTIONS(1843),
    [anon_sym_DOT] = ACTIONS(1843),
    [anon_sym_LPAREN] = ACTIONS(1843),
    [anon_sym_COMMA] = ACTIONS(1843),
    [anon_sym_LT_LT] = ACTIONS(1843),
    [anon_sym_CARET_LT_LT] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [aux_sym_method_token7] = ACTIONS(1843),
    [aux_sym_procedure_token2] = ACTIONS(1843),
    [aux_sym_block_token2] = ACTIONS(1843),
    [anon_sym__and_LT_LT] = ACTIONS(1843),
    [anon_sym__andif_LT_LT] = ACTIONS(1843),
    [anon_sym__or_LT_LT] = ACTIONS(1843),
    [anon_sym__orif_LT_LT] = ACTIONS(1843),
    [anon_sym__xor_LT_LT] = ACTIONS(1843),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1843),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1843),
    [anon_sym_STAR_LT_LT] = ACTIONS(1843),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1843),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1843),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1843),
    [anon_sym__mod_LT_LT] = ACTIONS(1843),
    [anon_sym__div_LT_LT] = ACTIONS(1843),
    [anon_sym_DASH_LT_LT] = ACTIONS(1843),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1843),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1843),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1843),
    [aux_sym_if_token3] = ACTIONS(1843),
    [aux_sym_elif_token1] = ACTIONS(1843),
    [aux_sym_else_token1] = ACTIONS(1843),
    [aux_sym_loop_token2] = ACTIONS(1843),
    [aux_sym_finally_token1] = ACTIONS(1843),
    [aux_sym_finally_token2] = ACTIONS(1843),
    [aux_sym_catch_token2] = ACTIONS(1843),
    [aux_sym_try_token2] = ACTIONS(1843),
    [aux_sym_try_token3] = ACTIONS(1843),
    [aux_sym_protect_token3] = ACTIONS(1843),
    [aux_sym_protect_token4] = ACTIONS(1843),
    [aux_sym_lock_token2] = ACTIONS(1843),
    [anon_sym_SEMI] = ACTIONS(1843),
    [aux_sym_relational_operator_token1] = ACTIONS(1843),
    [aux_sym_relational_operator_token2] = ACTIONS(1843),
    [aux_sym_relational_operator_token3] = ACTIONS(1843),
    [anon_sym_EQ] = ACTIONS(1843),
    [anon_sym_TILDE_EQ] = ACTIONS(1843),
    [anon_sym_LT_GT] = ACTIONS(1843),
    [anon_sym_GT_EQ] = ACTIONS(1843),
    [anon_sym_LT_EQ] = ACTIONS(1843),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_GT] = ACTIONS(1843),
    [aux_sym_logical_operator_token1] = ACTIONS(1843),
    [aux_sym_logical_operator_token2] = ACTIONS(1843),
    [aux_sym_logical_operator_token3] = ACTIONS(1843),
    [aux_sym_logical_operator_token4] = ACTIONS(1843),
    [aux_sym_logical_operator_token5] = ACTIONS(1843),
    [aux_sym_logical_operator_token6] = ACTIONS(1843),
    [anon_sym_STAR_STAR] = ACTIONS(1843),
    [anon_sym_STAR] = ACTIONS(1843),
    [anon_sym_SLASH] = ACTIONS(1843),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1843),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_PLUS] = ACTIONS(1843),
    [sym_comment] = ACTIONS(3),
  },
  [498] = {
    [aux_sym_loopbody_repeat1] = STATE(505),
    [anon_sym_CR] = ACTIONS(1845),
    [anon_sym_LF] = ACTIONS(1845),
    [anon_sym_DOT] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(1845),
    [aux_sym_procedure_token2] = ACTIONS(1845),
    [aux_sym_block_token2] = ACTIONS(1845),
    [anon_sym__and_LT_LT] = ACTIONS(1833),
    [anon_sym__andif_LT_LT] = ACTIONS(1833),
    [anon_sym__or_LT_LT] = ACTIONS(1833),
    [anon_sym__orif_LT_LT] = ACTIONS(1833),
    [anon_sym__xor_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym__mod_LT_LT] = ACTIONS(1833),
    [anon_sym__div_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1833),
    [aux_sym_if_token3] = ACTIONS(1845),
    [aux_sym_elif_token1] = ACTIONS(1845),
    [aux_sym_else_token1] = ACTIONS(1845),
    [aux_sym_loop_token2] = ACTIONS(1845),
    [aux_sym_finally_token1] = ACTIONS(1845),
    [aux_sym_finally_token2] = ACTIONS(1845),
    [aux_sym_catch_token2] = ACTIONS(1845),
    [aux_sym_try_token2] = ACTIONS(1845),
    [aux_sym_try_token3] = ACTIONS(1845),
    [aux_sym_protect_token4] = ACTIONS(1845),
    [aux_sym_lock_token2] = ACTIONS(1845),
    [anon_sym_SEMI] = ACTIONS(1845),
    [aux_sym_relational_operator_token1] = ACTIONS(1837),
    [aux_sym_relational_operator_token2] = ACTIONS(1837),
    [aux_sym_relational_operator_token3] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_TILDE_EQ] = ACTIONS(1837),
    [anon_sym_LT_GT] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_GT] = ACTIONS(1837),
    [aux_sym_logical_operator_token1] = ACTIONS(1839),
    [aux_sym_logical_operator_token2] = ACTIONS(1839),
    [aux_sym_logical_operator_token3] = ACTIONS(1839),
    [aux_sym_logical_operator_token4] = ACTIONS(1839),
    [aux_sym_logical_operator_token5] = ACTIONS(1839),
    [aux_sym_logical_operator_token6] = ACTIONS(1839),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [anon_sym_CR] = ACTIONS(1847),
    [anon_sym_LF] = ACTIONS(1847),
    [anon_sym_DOT] = ACTIONS(1847),
    [anon_sym_LPAREN] = ACTIONS(1847),
    [anon_sym_COMMA] = ACTIONS(1847),
    [anon_sym_LT_LT] = ACTIONS(1847),
    [anon_sym_CARET_LT_LT] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [aux_sym_method_token7] = ACTIONS(1847),
    [aux_sym_procedure_token2] = ACTIONS(1847),
    [aux_sym_block_token2] = ACTIONS(1847),
    [anon_sym__and_LT_LT] = ACTIONS(1847),
    [anon_sym__andif_LT_LT] = ACTIONS(1847),
    [anon_sym__or_LT_LT] = ACTIONS(1847),
    [anon_sym__orif_LT_LT] = ACTIONS(1847),
    [anon_sym__xor_LT_LT] = ACTIONS(1847),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1847),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1847),
    [anon_sym_STAR_LT_LT] = ACTIONS(1847),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1847),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1847),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1847),
    [anon_sym__mod_LT_LT] = ACTIONS(1847),
    [anon_sym__div_LT_LT] = ACTIONS(1847),
    [anon_sym_DASH_LT_LT] = ACTIONS(1847),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1847),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1847),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1847),
    [aux_sym_if_token3] = ACTIONS(1847),
    [aux_sym_elif_token1] = ACTIONS(1847),
    [aux_sym_else_token1] = ACTIONS(1847),
    [aux_sym_loop_token2] = ACTIONS(1847),
    [aux_sym_finally_token1] = ACTIONS(1847),
    [aux_sym_finally_token2] = ACTIONS(1847),
    [aux_sym_catch_token2] = ACTIONS(1847),
    [aux_sym_try_token2] = ACTIONS(1847),
    [aux_sym_try_token3] = ACTIONS(1847),
    [aux_sym_protect_token3] = ACTIONS(1847),
    [aux_sym_protect_token4] = ACTIONS(1847),
    [aux_sym_lock_token2] = ACTIONS(1847),
    [anon_sym_SEMI] = ACTIONS(1847),
    [aux_sym_relational_operator_token1] = ACTIONS(1847),
    [aux_sym_relational_operator_token2] = ACTIONS(1847),
    [aux_sym_relational_operator_token3] = ACTIONS(1847),
    [anon_sym_EQ] = ACTIONS(1847),
    [anon_sym_TILDE_EQ] = ACTIONS(1847),
    [anon_sym_LT_GT] = ACTIONS(1847),
    [anon_sym_GT_EQ] = ACTIONS(1847),
    [anon_sym_LT_EQ] = ACTIONS(1847),
    [anon_sym_LT] = ACTIONS(1847),
    [anon_sym_GT] = ACTIONS(1847),
    [aux_sym_logical_operator_token1] = ACTIONS(1847),
    [aux_sym_logical_operator_token2] = ACTIONS(1847),
    [aux_sym_logical_operator_token3] = ACTIONS(1847),
    [aux_sym_logical_operator_token4] = ACTIONS(1847),
    [aux_sym_logical_operator_token5] = ACTIONS(1847),
    [aux_sym_logical_operator_token6] = ACTIONS(1847),
    [anon_sym_STAR_STAR] = ACTIONS(1847),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_SLASH] = ACTIONS(1847),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1847),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1847),
    [anon_sym_DASH] = ACTIONS(1847),
    [anon_sym_PLUS] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
  },
  [500] = {
    [anon_sym_CR] = ACTIONS(1849),
    [anon_sym_LF] = ACTIONS(1849),
    [anon_sym_DOT] = ACTIONS(1849),
    [anon_sym_LPAREN] = ACTIONS(1849),
    [anon_sym_COMMA] = ACTIONS(1849),
    [anon_sym_LT_LT] = ACTIONS(1849),
    [anon_sym_CARET_LT_LT] = ACTIONS(1849),
    [anon_sym_LBRACK] = ACTIONS(1849),
    [aux_sym_method_token7] = ACTIONS(1849),
    [aux_sym_procedure_token2] = ACTIONS(1849),
    [aux_sym_block_token2] = ACTIONS(1849),
    [anon_sym__and_LT_LT] = ACTIONS(1849),
    [anon_sym__andif_LT_LT] = ACTIONS(1849),
    [anon_sym__or_LT_LT] = ACTIONS(1849),
    [anon_sym__orif_LT_LT] = ACTIONS(1849),
    [anon_sym__xor_LT_LT] = ACTIONS(1849),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1849),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1849),
    [anon_sym_STAR_LT_LT] = ACTIONS(1849),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1849),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1849),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1849),
    [anon_sym__mod_LT_LT] = ACTIONS(1849),
    [anon_sym__div_LT_LT] = ACTIONS(1849),
    [anon_sym_DASH_LT_LT] = ACTIONS(1849),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1849),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1849),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1849),
    [aux_sym_if_token3] = ACTIONS(1849),
    [aux_sym_elif_token1] = ACTIONS(1849),
    [aux_sym_else_token1] = ACTIONS(1849),
    [aux_sym_loop_token2] = ACTIONS(1849),
    [aux_sym_finally_token1] = ACTIONS(1849),
    [aux_sym_finally_token2] = ACTIONS(1849),
    [aux_sym_catch_token2] = ACTIONS(1849),
    [aux_sym_try_token2] = ACTIONS(1849),
    [aux_sym_try_token3] = ACTIONS(1849),
    [aux_sym_protect_token3] = ACTIONS(1849),
    [aux_sym_protect_token4] = ACTIONS(1849),
    [aux_sym_lock_token2] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1849),
    [aux_sym_relational_operator_token1] = ACTIONS(1849),
    [aux_sym_relational_operator_token2] = ACTIONS(1849),
    [aux_sym_relational_operator_token3] = ACTIONS(1849),
    [anon_sym_EQ] = ACTIONS(1849),
    [anon_sym_TILDE_EQ] = ACTIONS(1849),
    [anon_sym_LT_GT] = ACTIONS(1849),
    [anon_sym_GT_EQ] = ACTIONS(1849),
    [anon_sym_LT_EQ] = ACTIONS(1849),
    [anon_sym_LT] = ACTIONS(1849),
    [anon_sym_GT] = ACTIONS(1849),
    [aux_sym_logical_operator_token1] = ACTIONS(1849),
    [aux_sym_logical_operator_token2] = ACTIONS(1849),
    [aux_sym_logical_operator_token3] = ACTIONS(1849),
    [aux_sym_logical_operator_token4] = ACTIONS(1849),
    [aux_sym_logical_operator_token5] = ACTIONS(1849),
    [aux_sym_logical_operator_token6] = ACTIONS(1849),
    [anon_sym_STAR_STAR] = ACTIONS(1849),
    [anon_sym_STAR] = ACTIONS(1849),
    [anon_sym_SLASH] = ACTIONS(1849),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1849),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1849),
    [anon_sym_DASH] = ACTIONS(1849),
    [anon_sym_PLUS] = ACTIONS(1849),
    [sym_comment] = ACTIONS(3),
  },
  [501] = {
    [anon_sym_CR] = ACTIONS(1851),
    [anon_sym_LF] = ACTIONS(1851),
    [anon_sym_DOT] = ACTIONS(1851),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [anon_sym_COMMA] = ACTIONS(1851),
    [anon_sym_LT_LT] = ACTIONS(1851),
    [anon_sym_CARET_LT_LT] = ACTIONS(1851),
    [anon_sym_LBRACK] = ACTIONS(1851),
    [aux_sym_method_token7] = ACTIONS(1851),
    [aux_sym_procedure_token2] = ACTIONS(1851),
    [aux_sym_block_token2] = ACTIONS(1851),
    [anon_sym__and_LT_LT] = ACTIONS(1851),
    [anon_sym__andif_LT_LT] = ACTIONS(1851),
    [anon_sym__or_LT_LT] = ACTIONS(1851),
    [anon_sym__orif_LT_LT] = ACTIONS(1851),
    [anon_sym__xor_LT_LT] = ACTIONS(1851),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1851),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1851),
    [anon_sym_STAR_LT_LT] = ACTIONS(1851),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1851),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1851),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1851),
    [anon_sym__mod_LT_LT] = ACTIONS(1851),
    [anon_sym__div_LT_LT] = ACTIONS(1851),
    [anon_sym_DASH_LT_LT] = ACTIONS(1851),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1851),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1851),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1851),
    [aux_sym_if_token3] = ACTIONS(1851),
    [aux_sym_elif_token1] = ACTIONS(1851),
    [aux_sym_else_token1] = ACTIONS(1851),
    [aux_sym_loop_token2] = ACTIONS(1851),
    [aux_sym_finally_token1] = ACTIONS(1851),
    [aux_sym_finally_token2] = ACTIONS(1851),
    [aux_sym_catch_token2] = ACTIONS(1851),
    [aux_sym_try_token2] = ACTIONS(1851),
    [aux_sym_try_token3] = ACTIONS(1851),
    [aux_sym_protect_token3] = ACTIONS(1851),
    [aux_sym_protect_token4] = ACTIONS(1851),
    [aux_sym_lock_token2] = ACTIONS(1851),
    [anon_sym_SEMI] = ACTIONS(1851),
    [aux_sym_relational_operator_token1] = ACTIONS(1851),
    [aux_sym_relational_operator_token2] = ACTIONS(1851),
    [aux_sym_relational_operator_token3] = ACTIONS(1851),
    [anon_sym_EQ] = ACTIONS(1851),
    [anon_sym_TILDE_EQ] = ACTIONS(1851),
    [anon_sym_LT_GT] = ACTIONS(1851),
    [anon_sym_GT_EQ] = ACTIONS(1851),
    [anon_sym_LT_EQ] = ACTIONS(1851),
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_GT] = ACTIONS(1851),
    [aux_sym_logical_operator_token1] = ACTIONS(1851),
    [aux_sym_logical_operator_token2] = ACTIONS(1851),
    [aux_sym_logical_operator_token3] = ACTIONS(1851),
    [aux_sym_logical_operator_token4] = ACTIONS(1851),
    [aux_sym_logical_operator_token5] = ACTIONS(1851),
    [aux_sym_logical_operator_token6] = ACTIONS(1851),
    [anon_sym_STAR_STAR] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1851),
    [anon_sym_SLASH] = ACTIONS(1851),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1851),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_PLUS] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
  },
  [502] = {
    [anon_sym_CR] = ACTIONS(1853),
    [anon_sym_LF] = ACTIONS(1853),
    [anon_sym_DOT] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1853),
    [anon_sym_COMMA] = ACTIONS(1853),
    [anon_sym_LT_LT] = ACTIONS(1853),
    [anon_sym_CARET_LT_LT] = ACTIONS(1853),
    [anon_sym_LBRACK] = ACTIONS(1853),
    [aux_sym_method_token7] = ACTIONS(1853),
    [aux_sym_procedure_token2] = ACTIONS(1853),
    [aux_sym_block_token2] = ACTIONS(1853),
    [anon_sym__and_LT_LT] = ACTIONS(1853),
    [anon_sym__andif_LT_LT] = ACTIONS(1853),
    [anon_sym__or_LT_LT] = ACTIONS(1853),
    [anon_sym__orif_LT_LT] = ACTIONS(1853),
    [anon_sym__xor_LT_LT] = ACTIONS(1853),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1853),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1853),
    [anon_sym_STAR_LT_LT] = ACTIONS(1853),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1853),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1853),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1853),
    [anon_sym__mod_LT_LT] = ACTIONS(1853),
    [anon_sym__div_LT_LT] = ACTIONS(1853),
    [anon_sym_DASH_LT_LT] = ACTIONS(1853),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1853),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1853),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1853),
    [aux_sym_if_token3] = ACTIONS(1853),
    [aux_sym_elif_token1] = ACTIONS(1853),
    [aux_sym_else_token1] = ACTIONS(1853),
    [aux_sym_loop_token2] = ACTIONS(1853),
    [aux_sym_finally_token1] = ACTIONS(1853),
    [aux_sym_finally_token2] = ACTIONS(1853),
    [aux_sym_catch_token2] = ACTIONS(1853),
    [aux_sym_try_token2] = ACTIONS(1853),
    [aux_sym_try_token3] = ACTIONS(1853),
    [aux_sym_protect_token3] = ACTIONS(1853),
    [aux_sym_protect_token4] = ACTIONS(1853),
    [aux_sym_lock_token2] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1853),
    [aux_sym_relational_operator_token1] = ACTIONS(1853),
    [aux_sym_relational_operator_token2] = ACTIONS(1853),
    [aux_sym_relational_operator_token3] = ACTIONS(1853),
    [anon_sym_EQ] = ACTIONS(1853),
    [anon_sym_TILDE_EQ] = ACTIONS(1853),
    [anon_sym_LT_GT] = ACTIONS(1853),
    [anon_sym_GT_EQ] = ACTIONS(1853),
    [anon_sym_LT_EQ] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1853),
    [anon_sym_GT] = ACTIONS(1853),
    [aux_sym_logical_operator_token1] = ACTIONS(1853),
    [aux_sym_logical_operator_token2] = ACTIONS(1853),
    [aux_sym_logical_operator_token3] = ACTIONS(1853),
    [aux_sym_logical_operator_token4] = ACTIONS(1853),
    [aux_sym_logical_operator_token5] = ACTIONS(1853),
    [aux_sym_logical_operator_token6] = ACTIONS(1853),
    [anon_sym_STAR_STAR] = ACTIONS(1853),
    [anon_sym_STAR] = ACTIONS(1853),
    [anon_sym_SLASH] = ACTIONS(1853),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1853),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1853),
    [anon_sym_DASH] = ACTIONS(1853),
    [anon_sym_PLUS] = ACTIONS(1853),
    [sym_comment] = ACTIONS(3),
  },
  [503] = {
    [anon_sym_CR] = ACTIONS(1855),
    [anon_sym_LF] = ACTIONS(1855),
    [anon_sym_DOT] = ACTIONS(1855),
    [anon_sym_LPAREN] = ACTIONS(1855),
    [anon_sym_COMMA] = ACTIONS(1855),
    [anon_sym_LT_LT] = ACTIONS(1855),
    [anon_sym_CARET_LT_LT] = ACTIONS(1855),
    [anon_sym_LBRACK] = ACTIONS(1855),
    [aux_sym_method_token7] = ACTIONS(1855),
    [aux_sym_procedure_token2] = ACTIONS(1855),
    [aux_sym_block_token2] = ACTIONS(1855),
    [anon_sym__and_LT_LT] = ACTIONS(1855),
    [anon_sym__andif_LT_LT] = ACTIONS(1855),
    [anon_sym__or_LT_LT] = ACTIONS(1855),
    [anon_sym__orif_LT_LT] = ACTIONS(1855),
    [anon_sym__xor_LT_LT] = ACTIONS(1855),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1855),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1855),
    [anon_sym_STAR_LT_LT] = ACTIONS(1855),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1855),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1855),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1855),
    [anon_sym__mod_LT_LT] = ACTIONS(1855),
    [anon_sym__div_LT_LT] = ACTIONS(1855),
    [anon_sym_DASH_LT_LT] = ACTIONS(1855),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1855),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1855),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1855),
    [aux_sym_if_token3] = ACTIONS(1855),
    [aux_sym_elif_token1] = ACTIONS(1855),
    [aux_sym_else_token1] = ACTIONS(1855),
    [aux_sym_loop_token2] = ACTIONS(1855),
    [aux_sym_finally_token1] = ACTIONS(1855),
    [aux_sym_finally_token2] = ACTIONS(1855),
    [aux_sym_catch_token2] = ACTIONS(1855),
    [aux_sym_try_token2] = ACTIONS(1855),
    [aux_sym_try_token3] = ACTIONS(1855),
    [aux_sym_protect_token3] = ACTIONS(1855),
    [aux_sym_protect_token4] = ACTIONS(1855),
    [aux_sym_lock_token2] = ACTIONS(1855),
    [anon_sym_SEMI] = ACTIONS(1855),
    [aux_sym_relational_operator_token1] = ACTIONS(1855),
    [aux_sym_relational_operator_token2] = ACTIONS(1855),
    [aux_sym_relational_operator_token3] = ACTIONS(1855),
    [anon_sym_EQ] = ACTIONS(1855),
    [anon_sym_TILDE_EQ] = ACTIONS(1855),
    [anon_sym_LT_GT] = ACTIONS(1855),
    [anon_sym_GT_EQ] = ACTIONS(1855),
    [anon_sym_LT_EQ] = ACTIONS(1855),
    [anon_sym_LT] = ACTIONS(1855),
    [anon_sym_GT] = ACTIONS(1855),
    [aux_sym_logical_operator_token1] = ACTIONS(1855),
    [aux_sym_logical_operator_token2] = ACTIONS(1855),
    [aux_sym_logical_operator_token3] = ACTIONS(1855),
    [aux_sym_logical_operator_token4] = ACTIONS(1855),
    [aux_sym_logical_operator_token5] = ACTIONS(1855),
    [aux_sym_logical_operator_token6] = ACTIONS(1855),
    [anon_sym_STAR_STAR] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_SLASH] = ACTIONS(1855),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1855),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_PLUS] = ACTIONS(1855),
    [sym_comment] = ACTIONS(3),
  },
  [504] = {
    [anon_sym_CR] = ACTIONS(1857),
    [anon_sym_LF] = ACTIONS(1857),
    [anon_sym_DOT] = ACTIONS(1857),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [anon_sym_COMMA] = ACTIONS(1857),
    [anon_sym_LT_LT] = ACTIONS(1857),
    [anon_sym_CARET_LT_LT] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1857),
    [aux_sym_method_token7] = ACTIONS(1857),
    [aux_sym_procedure_token2] = ACTIONS(1857),
    [aux_sym_block_token2] = ACTIONS(1857),
    [anon_sym__and_LT_LT] = ACTIONS(1857),
    [anon_sym__andif_LT_LT] = ACTIONS(1857),
    [anon_sym__or_LT_LT] = ACTIONS(1857),
    [anon_sym__orif_LT_LT] = ACTIONS(1857),
    [anon_sym__xor_LT_LT] = ACTIONS(1857),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1857),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1857),
    [anon_sym_STAR_LT_LT] = ACTIONS(1857),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1857),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1857),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1857),
    [anon_sym__mod_LT_LT] = ACTIONS(1857),
    [anon_sym__div_LT_LT] = ACTIONS(1857),
    [anon_sym_DASH_LT_LT] = ACTIONS(1857),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1857),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1857),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1857),
    [aux_sym_if_token3] = ACTIONS(1857),
    [aux_sym_elif_token1] = ACTIONS(1857),
    [aux_sym_else_token1] = ACTIONS(1857),
    [aux_sym_loop_token2] = ACTIONS(1857),
    [aux_sym_finally_token1] = ACTIONS(1857),
    [aux_sym_finally_token2] = ACTIONS(1857),
    [aux_sym_catch_token2] = ACTIONS(1857),
    [aux_sym_try_token2] = ACTIONS(1857),
    [aux_sym_try_token3] = ACTIONS(1857),
    [aux_sym_protect_token3] = ACTIONS(1857),
    [aux_sym_protect_token4] = ACTIONS(1857),
    [aux_sym_lock_token2] = ACTIONS(1857),
    [anon_sym_SEMI] = ACTIONS(1857),
    [aux_sym_relational_operator_token1] = ACTIONS(1857),
    [aux_sym_relational_operator_token2] = ACTIONS(1857),
    [aux_sym_relational_operator_token3] = ACTIONS(1857),
    [anon_sym_EQ] = ACTIONS(1857),
    [anon_sym_TILDE_EQ] = ACTIONS(1857),
    [anon_sym_LT_GT] = ACTIONS(1857),
    [anon_sym_GT_EQ] = ACTIONS(1857),
    [anon_sym_LT_EQ] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [aux_sym_logical_operator_token1] = ACTIONS(1857),
    [aux_sym_logical_operator_token2] = ACTIONS(1857),
    [aux_sym_logical_operator_token3] = ACTIONS(1857),
    [aux_sym_logical_operator_token4] = ACTIONS(1857),
    [aux_sym_logical_operator_token5] = ACTIONS(1857),
    [aux_sym_logical_operator_token6] = ACTIONS(1857),
    [anon_sym_STAR_STAR] = ACTIONS(1857),
    [anon_sym_STAR] = ACTIONS(1857),
    [anon_sym_SLASH] = ACTIONS(1857),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1857),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1857),
    [anon_sym_DASH] = ACTIONS(1857),
    [anon_sym_PLUS] = ACTIONS(1857),
    [sym_comment] = ACTIONS(3),
  },
  [505] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(1859),
    [anon_sym_LF] = ACTIONS(1859),
    [anon_sym_DOT] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(1859),
    [anon_sym_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_method_token7] = ACTIONS(1859),
    [aux_sym_procedure_token2] = ACTIONS(1859),
    [aux_sym_block_token2] = ACTIONS(1859),
    [anon_sym__and_LT_LT] = ACTIONS(1859),
    [anon_sym__andif_LT_LT] = ACTIONS(1859),
    [anon_sym__or_LT_LT] = ACTIONS(1859),
    [anon_sym__orif_LT_LT] = ACTIONS(1859),
    [anon_sym__xor_LT_LT] = ACTIONS(1859),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1859),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym_STAR_LT_LT] = ACTIONS(1859),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1859),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym__mod_LT_LT] = ACTIONS(1859),
    [anon_sym__div_LT_LT] = ACTIONS(1859),
    [anon_sym_DASH_LT_LT] = ACTIONS(1859),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1859),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1859),
    [aux_sym_if_token3] = ACTIONS(1859),
    [aux_sym_elif_token1] = ACTIONS(1859),
    [aux_sym_else_token1] = ACTIONS(1859),
    [aux_sym_loop_token2] = ACTIONS(1859),
    [aux_sym_finally_token1] = ACTIONS(1859),
    [aux_sym_finally_token2] = ACTIONS(1859),
    [aux_sym_catch_token2] = ACTIONS(1859),
    [aux_sym_try_token2] = ACTIONS(1859),
    [aux_sym_try_token3] = ACTIONS(1859),
    [aux_sym_protect_token4] = ACTIONS(1859),
    [aux_sym_lock_token2] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1859),
    [aux_sym_relational_operator_token1] = ACTIONS(1859),
    [aux_sym_relational_operator_token2] = ACTIONS(1859),
    [aux_sym_relational_operator_token3] = ACTIONS(1859),
    [anon_sym_EQ] = ACTIONS(1859),
    [anon_sym_TILDE_EQ] = ACTIONS(1859),
    [anon_sym_LT_GT] = ACTIONS(1859),
    [anon_sym_GT_EQ] = ACTIONS(1859),
    [anon_sym_LT_EQ] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [aux_sym_logical_operator_token1] = ACTIONS(1859),
    [aux_sym_logical_operator_token2] = ACTIONS(1859),
    [aux_sym_logical_operator_token3] = ACTIONS(1859),
    [aux_sym_logical_operator_token4] = ACTIONS(1859),
    [aux_sym_logical_operator_token5] = ACTIONS(1859),
    [aux_sym_logical_operator_token6] = ACTIONS(1859),
    [anon_sym_STAR_STAR] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1859),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1859),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1859),
    [sym_comment] = ACTIONS(3),
  },
  [506] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(1861),
    [anon_sym_LF] = ACTIONS(1861),
    [anon_sym_DOT] = ACTIONS(1861),
    [anon_sym_LPAREN] = ACTIONS(1861),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(1861),
    [anon_sym_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [aux_sym_method_token7] = ACTIONS(1861),
    [aux_sym_procedure_token2] = ACTIONS(1861),
    [aux_sym_block_token2] = ACTIONS(1861),
    [anon_sym__and_LT_LT] = ACTIONS(1861),
    [anon_sym__andif_LT_LT] = ACTIONS(1861),
    [anon_sym__or_LT_LT] = ACTIONS(1861),
    [anon_sym__orif_LT_LT] = ACTIONS(1861),
    [anon_sym__xor_LT_LT] = ACTIONS(1861),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1861),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym_STAR_LT_LT] = ACTIONS(1861),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1861),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym__mod_LT_LT] = ACTIONS(1861),
    [anon_sym__div_LT_LT] = ACTIONS(1861),
    [anon_sym_DASH_LT_LT] = ACTIONS(1861),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1861),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1861),
    [aux_sym_if_token3] = ACTIONS(1861),
    [aux_sym_elif_token1] = ACTIONS(1861),
    [aux_sym_else_token1] = ACTIONS(1861),
    [aux_sym_loop_token2] = ACTIONS(1861),
    [aux_sym_finally_token1] = ACTIONS(1861),
    [aux_sym_finally_token2] = ACTIONS(1861),
    [aux_sym_catch_token2] = ACTIONS(1861),
    [aux_sym_try_token2] = ACTIONS(1861),
    [aux_sym_try_token3] = ACTIONS(1861),
    [aux_sym_protect_token4] = ACTIONS(1861),
    [aux_sym_lock_token2] = ACTIONS(1861),
    [anon_sym_SEMI] = ACTIONS(1861),
    [aux_sym_relational_operator_token1] = ACTIONS(1861),
    [aux_sym_relational_operator_token2] = ACTIONS(1861),
    [aux_sym_relational_operator_token3] = ACTIONS(1861),
    [anon_sym_EQ] = ACTIONS(1861),
    [anon_sym_TILDE_EQ] = ACTIONS(1861),
    [anon_sym_LT_GT] = ACTIONS(1861),
    [anon_sym_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_EQ] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1861),
    [anon_sym_GT] = ACTIONS(1861),
    [aux_sym_logical_operator_token1] = ACTIONS(1861),
    [aux_sym_logical_operator_token2] = ACTIONS(1861),
    [aux_sym_logical_operator_token3] = ACTIONS(1861),
    [aux_sym_logical_operator_token4] = ACTIONS(1861),
    [aux_sym_logical_operator_token5] = ACTIONS(1861),
    [aux_sym_logical_operator_token6] = ACTIONS(1861),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_STAR] = ACTIONS(1861),
    [anon_sym_SLASH] = ACTIONS(1861),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1861),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_PLUS] = ACTIONS(1861),
    [sym_comment] = ACTIONS(3),
  },
  [507] = {
    [anon_sym_CR] = ACTIONS(1863),
    [anon_sym_LF] = ACTIONS(1863),
    [anon_sym_DOT] = ACTIONS(1863),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_COMMA] = ACTIONS(1863),
    [anon_sym_LT_LT] = ACTIONS(1863),
    [anon_sym_CARET_LT_LT] = ACTIONS(1863),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [aux_sym_method_token7] = ACTIONS(1863),
    [aux_sym_procedure_token2] = ACTIONS(1863),
    [aux_sym_block_token2] = ACTIONS(1863),
    [anon_sym__and_LT_LT] = ACTIONS(1863),
    [anon_sym__andif_LT_LT] = ACTIONS(1863),
    [anon_sym__or_LT_LT] = ACTIONS(1863),
    [anon_sym__orif_LT_LT] = ACTIONS(1863),
    [anon_sym__xor_LT_LT] = ACTIONS(1863),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1863),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1863),
    [anon_sym_STAR_LT_LT] = ACTIONS(1863),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1863),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1863),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1863),
    [anon_sym__mod_LT_LT] = ACTIONS(1863),
    [anon_sym__div_LT_LT] = ACTIONS(1863),
    [anon_sym_DASH_LT_LT] = ACTIONS(1863),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1863),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1863),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1863),
    [aux_sym_if_token3] = ACTIONS(1863),
    [aux_sym_elif_token1] = ACTIONS(1863),
    [aux_sym_else_token1] = ACTIONS(1863),
    [aux_sym_loop_token2] = ACTIONS(1863),
    [aux_sym_finally_token1] = ACTIONS(1863),
    [aux_sym_finally_token2] = ACTIONS(1863),
    [aux_sym_catch_token2] = ACTIONS(1863),
    [aux_sym_try_token2] = ACTIONS(1863),
    [aux_sym_try_token3] = ACTIONS(1863),
    [aux_sym_protect_token3] = ACTIONS(1863),
    [aux_sym_protect_token4] = ACTIONS(1863),
    [aux_sym_lock_token2] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(1863),
    [aux_sym_relational_operator_token1] = ACTIONS(1863),
    [aux_sym_relational_operator_token2] = ACTIONS(1863),
    [aux_sym_relational_operator_token3] = ACTIONS(1863),
    [anon_sym_EQ] = ACTIONS(1863),
    [anon_sym_TILDE_EQ] = ACTIONS(1863),
    [anon_sym_LT_GT] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1863),
    [anon_sym_LT_EQ] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_GT] = ACTIONS(1863),
    [aux_sym_logical_operator_token1] = ACTIONS(1863),
    [aux_sym_logical_operator_token2] = ACTIONS(1863),
    [aux_sym_logical_operator_token3] = ACTIONS(1863),
    [aux_sym_logical_operator_token4] = ACTIONS(1863),
    [aux_sym_logical_operator_token5] = ACTIONS(1863),
    [aux_sym_logical_operator_token6] = ACTIONS(1863),
    [anon_sym_STAR_STAR] = ACTIONS(1863),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_SLASH] = ACTIONS(1863),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1863),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1863),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_PLUS] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
  },
  [508] = {
    [anon_sym_CR] = ACTIONS(1865),
    [anon_sym_LF] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1865),
    [anon_sym_CARET_LT_LT] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [aux_sym_method_token7] = ACTIONS(1865),
    [aux_sym_procedure_token2] = ACTIONS(1865),
    [aux_sym_block_token2] = ACTIONS(1865),
    [anon_sym__and_LT_LT] = ACTIONS(1865),
    [anon_sym__andif_LT_LT] = ACTIONS(1865),
    [anon_sym__or_LT_LT] = ACTIONS(1865),
    [anon_sym__orif_LT_LT] = ACTIONS(1865),
    [anon_sym__xor_LT_LT] = ACTIONS(1865),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1865),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1865),
    [anon_sym_STAR_LT_LT] = ACTIONS(1865),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1865),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1865),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1865),
    [anon_sym__mod_LT_LT] = ACTIONS(1865),
    [anon_sym__div_LT_LT] = ACTIONS(1865),
    [anon_sym_DASH_LT_LT] = ACTIONS(1865),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1865),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1865),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1865),
    [aux_sym_if_token3] = ACTIONS(1865),
    [aux_sym_elif_token1] = ACTIONS(1865),
    [aux_sym_else_token1] = ACTIONS(1865),
    [aux_sym_loop_token2] = ACTIONS(1865),
    [aux_sym_finally_token1] = ACTIONS(1865),
    [aux_sym_finally_token2] = ACTIONS(1865),
    [aux_sym_catch_token2] = ACTIONS(1865),
    [aux_sym_try_token2] = ACTIONS(1865),
    [aux_sym_try_token3] = ACTIONS(1865),
    [aux_sym_protect_token3] = ACTIONS(1865),
    [aux_sym_protect_token4] = ACTIONS(1865),
    [aux_sym_lock_token2] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [aux_sym_relational_operator_token1] = ACTIONS(1865),
    [aux_sym_relational_operator_token2] = ACTIONS(1865),
    [aux_sym_relational_operator_token3] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1865),
    [anon_sym_TILDE_EQ] = ACTIONS(1865),
    [anon_sym_LT_GT] = ACTIONS(1865),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1865),
    [aux_sym_logical_operator_token1] = ACTIONS(1865),
    [aux_sym_logical_operator_token2] = ACTIONS(1865),
    [aux_sym_logical_operator_token3] = ACTIONS(1865),
    [aux_sym_logical_operator_token4] = ACTIONS(1865),
    [aux_sym_logical_operator_token5] = ACTIONS(1865),
    [aux_sym_logical_operator_token6] = ACTIONS(1865),
    [anon_sym_STAR_STAR] = ACTIONS(1865),
    [anon_sym_STAR] = ACTIONS(1865),
    [anon_sym_SLASH] = ACTIONS(1865),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1865),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1865),
    [anon_sym_PLUS] = ACTIONS(1865),
    [sym_comment] = ACTIONS(3),
  },
  [509] = {
    [anon_sym_CR] = ACTIONS(1867),
    [anon_sym_LF] = ACTIONS(1867),
    [anon_sym_DOT] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(1867),
    [anon_sym_LT_LT] = ACTIONS(1867),
    [anon_sym_CARET_LT_LT] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [aux_sym_method_token7] = ACTIONS(1867),
    [aux_sym_procedure_token2] = ACTIONS(1867),
    [aux_sym_block_token2] = ACTIONS(1867),
    [anon_sym__and_LT_LT] = ACTIONS(1867),
    [anon_sym__andif_LT_LT] = ACTIONS(1867),
    [anon_sym__or_LT_LT] = ACTIONS(1867),
    [anon_sym__orif_LT_LT] = ACTIONS(1867),
    [anon_sym__xor_LT_LT] = ACTIONS(1867),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1867),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1867),
    [anon_sym_STAR_LT_LT] = ACTIONS(1867),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1867),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1867),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1867),
    [anon_sym__mod_LT_LT] = ACTIONS(1867),
    [anon_sym__div_LT_LT] = ACTIONS(1867),
    [anon_sym_DASH_LT_LT] = ACTIONS(1867),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1867),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1867),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1867),
    [aux_sym_if_token3] = ACTIONS(1867),
    [aux_sym_elif_token1] = ACTIONS(1867),
    [aux_sym_else_token1] = ACTIONS(1867),
    [aux_sym_loop_token2] = ACTIONS(1867),
    [aux_sym_finally_token1] = ACTIONS(1867),
    [aux_sym_finally_token2] = ACTIONS(1867),
    [aux_sym_catch_token2] = ACTIONS(1867),
    [aux_sym_try_token2] = ACTIONS(1867),
    [aux_sym_try_token3] = ACTIONS(1867),
    [aux_sym_protect_token3] = ACTIONS(1867),
    [aux_sym_protect_token4] = ACTIONS(1867),
    [aux_sym_lock_token2] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1867),
    [aux_sym_relational_operator_token1] = ACTIONS(1867),
    [aux_sym_relational_operator_token2] = ACTIONS(1867),
    [aux_sym_relational_operator_token3] = ACTIONS(1867),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_TILDE_EQ] = ACTIONS(1867),
    [anon_sym_LT_GT] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [aux_sym_logical_operator_token1] = ACTIONS(1867),
    [aux_sym_logical_operator_token2] = ACTIONS(1867),
    [aux_sym_logical_operator_token3] = ACTIONS(1867),
    [aux_sym_logical_operator_token4] = ACTIONS(1867),
    [aux_sym_logical_operator_token5] = ACTIONS(1867),
    [aux_sym_logical_operator_token6] = ACTIONS(1867),
    [anon_sym_STAR_STAR] = ACTIONS(1867),
    [anon_sym_STAR] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1867),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1867),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1867),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
  },
  [510] = {
    [anon_sym_CR] = ACTIONS(1869),
    [anon_sym_LF] = ACTIONS(1869),
    [anon_sym_DOT] = ACTIONS(1869),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_COMMA] = ACTIONS(1869),
    [anon_sym_LT_LT] = ACTIONS(1869),
    [anon_sym_CARET_LT_LT] = ACTIONS(1869),
    [anon_sym_LBRACK] = ACTIONS(1869),
    [aux_sym_method_token7] = ACTIONS(1869),
    [aux_sym_procedure_token2] = ACTIONS(1869),
    [aux_sym_block_token2] = ACTIONS(1869),
    [anon_sym__and_LT_LT] = ACTIONS(1869),
    [anon_sym__andif_LT_LT] = ACTIONS(1869),
    [anon_sym__or_LT_LT] = ACTIONS(1869),
    [anon_sym__orif_LT_LT] = ACTIONS(1869),
    [anon_sym__xor_LT_LT] = ACTIONS(1869),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1869),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1869),
    [anon_sym_STAR_LT_LT] = ACTIONS(1869),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1869),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1869),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1869),
    [anon_sym__mod_LT_LT] = ACTIONS(1869),
    [anon_sym__div_LT_LT] = ACTIONS(1869),
    [anon_sym_DASH_LT_LT] = ACTIONS(1869),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1869),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1869),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1869),
    [aux_sym_if_token3] = ACTIONS(1869),
    [aux_sym_elif_token1] = ACTIONS(1869),
    [aux_sym_else_token1] = ACTIONS(1869),
    [aux_sym_loop_token2] = ACTIONS(1869),
    [aux_sym_finally_token1] = ACTIONS(1869),
    [aux_sym_finally_token2] = ACTIONS(1869),
    [aux_sym_catch_token2] = ACTIONS(1869),
    [aux_sym_try_token2] = ACTIONS(1869),
    [aux_sym_try_token3] = ACTIONS(1869),
    [aux_sym_protect_token3] = ACTIONS(1869),
    [aux_sym_protect_token4] = ACTIONS(1869),
    [aux_sym_lock_token2] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1869),
    [aux_sym_relational_operator_token1] = ACTIONS(1869),
    [aux_sym_relational_operator_token2] = ACTIONS(1869),
    [aux_sym_relational_operator_token3] = ACTIONS(1869),
    [anon_sym_EQ] = ACTIONS(1869),
    [anon_sym_TILDE_EQ] = ACTIONS(1869),
    [anon_sym_LT_GT] = ACTIONS(1869),
    [anon_sym_GT_EQ] = ACTIONS(1869),
    [anon_sym_LT_EQ] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1869),
    [anon_sym_GT] = ACTIONS(1869),
    [aux_sym_logical_operator_token1] = ACTIONS(1869),
    [aux_sym_logical_operator_token2] = ACTIONS(1869),
    [aux_sym_logical_operator_token3] = ACTIONS(1869),
    [aux_sym_logical_operator_token4] = ACTIONS(1869),
    [aux_sym_logical_operator_token5] = ACTIONS(1869),
    [aux_sym_logical_operator_token6] = ACTIONS(1869),
    [anon_sym_STAR_STAR] = ACTIONS(1869),
    [anon_sym_STAR] = ACTIONS(1869),
    [anon_sym_SLASH] = ACTIONS(1869),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1869),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1869),
    [anon_sym_DASH] = ACTIONS(1869),
    [anon_sym_PLUS] = ACTIONS(1869),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [anon_sym_CR] = ACTIONS(1871),
    [anon_sym_LF] = ACTIONS(1871),
    [anon_sym_DOT] = ACTIONS(1871),
    [anon_sym_LPAREN] = ACTIONS(1871),
    [anon_sym_COMMA] = ACTIONS(1871),
    [anon_sym_LT_LT] = ACTIONS(1871),
    [anon_sym_CARET_LT_LT] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(1871),
    [aux_sym_method_token7] = ACTIONS(1871),
    [aux_sym_procedure_token2] = ACTIONS(1871),
    [aux_sym_block_token2] = ACTIONS(1871),
    [anon_sym__and_LT_LT] = ACTIONS(1871),
    [anon_sym__andif_LT_LT] = ACTIONS(1871),
    [anon_sym__or_LT_LT] = ACTIONS(1871),
    [anon_sym__orif_LT_LT] = ACTIONS(1871),
    [anon_sym__xor_LT_LT] = ACTIONS(1871),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1871),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1871),
    [anon_sym_STAR_LT_LT] = ACTIONS(1871),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1871),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1871),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1871),
    [anon_sym__mod_LT_LT] = ACTIONS(1871),
    [anon_sym__div_LT_LT] = ACTIONS(1871),
    [anon_sym_DASH_LT_LT] = ACTIONS(1871),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1871),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1871),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1871),
    [aux_sym_if_token3] = ACTIONS(1871),
    [aux_sym_elif_token1] = ACTIONS(1871),
    [aux_sym_else_token1] = ACTIONS(1871),
    [aux_sym_loop_token2] = ACTIONS(1871),
    [aux_sym_finally_token1] = ACTIONS(1871),
    [aux_sym_finally_token2] = ACTIONS(1871),
    [aux_sym_catch_token2] = ACTIONS(1871),
    [aux_sym_try_token2] = ACTIONS(1871),
    [aux_sym_try_token3] = ACTIONS(1871),
    [aux_sym_protect_token3] = ACTIONS(1871),
    [aux_sym_protect_token4] = ACTIONS(1871),
    [aux_sym_lock_token2] = ACTIONS(1871),
    [anon_sym_SEMI] = ACTIONS(1871),
    [aux_sym_relational_operator_token1] = ACTIONS(1871),
    [aux_sym_relational_operator_token2] = ACTIONS(1871),
    [aux_sym_relational_operator_token3] = ACTIONS(1871),
    [anon_sym_EQ] = ACTIONS(1871),
    [anon_sym_TILDE_EQ] = ACTIONS(1871),
    [anon_sym_LT_GT] = ACTIONS(1871),
    [anon_sym_GT_EQ] = ACTIONS(1871),
    [anon_sym_LT_EQ] = ACTIONS(1871),
    [anon_sym_LT] = ACTIONS(1871),
    [anon_sym_GT] = ACTIONS(1871),
    [aux_sym_logical_operator_token1] = ACTIONS(1871),
    [aux_sym_logical_operator_token2] = ACTIONS(1871),
    [aux_sym_logical_operator_token3] = ACTIONS(1871),
    [aux_sym_logical_operator_token4] = ACTIONS(1871),
    [aux_sym_logical_operator_token5] = ACTIONS(1871),
    [aux_sym_logical_operator_token6] = ACTIONS(1871),
    [anon_sym_STAR_STAR] = ACTIONS(1871),
    [anon_sym_STAR] = ACTIONS(1871),
    [anon_sym_SLASH] = ACTIONS(1871),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1871),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1871),
    [anon_sym_DASH] = ACTIONS(1871),
    [anon_sym_PLUS] = ACTIONS(1871),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [anon_sym_CR] = ACTIONS(1873),
    [anon_sym_LF] = ACTIONS(1873),
    [anon_sym_DOT] = ACTIONS(1873),
    [anon_sym_LPAREN] = ACTIONS(1873),
    [anon_sym_COMMA] = ACTIONS(1873),
    [anon_sym_LT_LT] = ACTIONS(1873),
    [anon_sym_CARET_LT_LT] = ACTIONS(1873),
    [anon_sym_LBRACK] = ACTIONS(1873),
    [aux_sym_method_token7] = ACTIONS(1873),
    [aux_sym_procedure_token2] = ACTIONS(1873),
    [aux_sym_block_token2] = ACTIONS(1873),
    [anon_sym__and_LT_LT] = ACTIONS(1873),
    [anon_sym__andif_LT_LT] = ACTIONS(1873),
    [anon_sym__or_LT_LT] = ACTIONS(1873),
    [anon_sym__orif_LT_LT] = ACTIONS(1873),
    [anon_sym__xor_LT_LT] = ACTIONS(1873),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1873),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1873),
    [anon_sym_STAR_LT_LT] = ACTIONS(1873),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1873),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1873),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1873),
    [anon_sym__mod_LT_LT] = ACTIONS(1873),
    [anon_sym__div_LT_LT] = ACTIONS(1873),
    [anon_sym_DASH_LT_LT] = ACTIONS(1873),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1873),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1873),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1873),
    [aux_sym_if_token3] = ACTIONS(1873),
    [aux_sym_elif_token1] = ACTIONS(1873),
    [aux_sym_else_token1] = ACTIONS(1873),
    [aux_sym_loop_token2] = ACTIONS(1873),
    [aux_sym_finally_token1] = ACTIONS(1873),
    [aux_sym_finally_token2] = ACTIONS(1873),
    [aux_sym_catch_token2] = ACTIONS(1873),
    [aux_sym_try_token2] = ACTIONS(1873),
    [aux_sym_try_token3] = ACTIONS(1873),
    [aux_sym_protect_token3] = ACTIONS(1873),
    [aux_sym_protect_token4] = ACTIONS(1873),
    [aux_sym_lock_token2] = ACTIONS(1873),
    [anon_sym_SEMI] = ACTIONS(1873),
    [aux_sym_relational_operator_token1] = ACTIONS(1873),
    [aux_sym_relational_operator_token2] = ACTIONS(1873),
    [aux_sym_relational_operator_token3] = ACTIONS(1873),
    [anon_sym_EQ] = ACTIONS(1873),
    [anon_sym_TILDE_EQ] = ACTIONS(1873),
    [anon_sym_LT_GT] = ACTIONS(1873),
    [anon_sym_GT_EQ] = ACTIONS(1873),
    [anon_sym_LT_EQ] = ACTIONS(1873),
    [anon_sym_LT] = ACTIONS(1873),
    [anon_sym_GT] = ACTIONS(1873),
    [aux_sym_logical_operator_token1] = ACTIONS(1873),
    [aux_sym_logical_operator_token2] = ACTIONS(1873),
    [aux_sym_logical_operator_token3] = ACTIONS(1873),
    [aux_sym_logical_operator_token4] = ACTIONS(1873),
    [aux_sym_logical_operator_token5] = ACTIONS(1873),
    [aux_sym_logical_operator_token6] = ACTIONS(1873),
    [anon_sym_STAR_STAR] = ACTIONS(1873),
    [anon_sym_STAR] = ACTIONS(1873),
    [anon_sym_SLASH] = ACTIONS(1873),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1873),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1873),
    [anon_sym_DASH] = ACTIONS(1873),
    [anon_sym_PLUS] = ACTIONS(1873),
    [sym_comment] = ACTIONS(3),
  },
  [513] = {
    [anon_sym_CR] = ACTIONS(1875),
    [anon_sym_LF] = ACTIONS(1875),
    [anon_sym_DOT] = ACTIONS(1875),
    [anon_sym_LPAREN] = ACTIONS(1875),
    [anon_sym_COMMA] = ACTIONS(1875),
    [anon_sym_LT_LT] = ACTIONS(1875),
    [anon_sym_CARET_LT_LT] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(1875),
    [aux_sym_method_token7] = ACTIONS(1875),
    [aux_sym_procedure_token2] = ACTIONS(1875),
    [aux_sym_block_token2] = ACTIONS(1875),
    [anon_sym__and_LT_LT] = ACTIONS(1875),
    [anon_sym__andif_LT_LT] = ACTIONS(1875),
    [anon_sym__or_LT_LT] = ACTIONS(1875),
    [anon_sym__orif_LT_LT] = ACTIONS(1875),
    [anon_sym__xor_LT_LT] = ACTIONS(1875),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1875),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1875),
    [anon_sym_STAR_LT_LT] = ACTIONS(1875),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1875),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1875),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1875),
    [anon_sym__mod_LT_LT] = ACTIONS(1875),
    [anon_sym__div_LT_LT] = ACTIONS(1875),
    [anon_sym_DASH_LT_LT] = ACTIONS(1875),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1875),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1875),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1875),
    [aux_sym_if_token3] = ACTIONS(1875),
    [aux_sym_elif_token1] = ACTIONS(1875),
    [aux_sym_else_token1] = ACTIONS(1875),
    [aux_sym_loop_token2] = ACTIONS(1875),
    [aux_sym_finally_token1] = ACTIONS(1875),
    [aux_sym_finally_token2] = ACTIONS(1875),
    [aux_sym_catch_token2] = ACTIONS(1875),
    [aux_sym_try_token2] = ACTIONS(1875),
    [aux_sym_try_token3] = ACTIONS(1875),
    [aux_sym_protect_token3] = ACTIONS(1875),
    [aux_sym_protect_token4] = ACTIONS(1875),
    [aux_sym_lock_token2] = ACTIONS(1875),
    [anon_sym_SEMI] = ACTIONS(1875),
    [aux_sym_relational_operator_token1] = ACTIONS(1875),
    [aux_sym_relational_operator_token2] = ACTIONS(1875),
    [aux_sym_relational_operator_token3] = ACTIONS(1875),
    [anon_sym_EQ] = ACTIONS(1875),
    [anon_sym_TILDE_EQ] = ACTIONS(1875),
    [anon_sym_LT_GT] = ACTIONS(1875),
    [anon_sym_GT_EQ] = ACTIONS(1875),
    [anon_sym_LT_EQ] = ACTIONS(1875),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_GT] = ACTIONS(1875),
    [aux_sym_logical_operator_token1] = ACTIONS(1875),
    [aux_sym_logical_operator_token2] = ACTIONS(1875),
    [aux_sym_logical_operator_token3] = ACTIONS(1875),
    [aux_sym_logical_operator_token4] = ACTIONS(1875),
    [aux_sym_logical_operator_token5] = ACTIONS(1875),
    [aux_sym_logical_operator_token6] = ACTIONS(1875),
    [anon_sym_STAR_STAR] = ACTIONS(1875),
    [anon_sym_STAR] = ACTIONS(1875),
    [anon_sym_SLASH] = ACTIONS(1875),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1875),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1875),
    [anon_sym_DASH] = ACTIONS(1875),
    [anon_sym_PLUS] = ACTIONS(1875),
    [sym_comment] = ACTIONS(3),
  },
  [514] = {
    [anon_sym_CR] = ACTIONS(1877),
    [anon_sym_LF] = ACTIONS(1877),
    [anon_sym_DOT] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_COMMA] = ACTIONS(1877),
    [anon_sym_LT_LT] = ACTIONS(1877),
    [anon_sym_CARET_LT_LT] = ACTIONS(1877),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [aux_sym_method_token7] = ACTIONS(1877),
    [aux_sym_procedure_token2] = ACTIONS(1877),
    [aux_sym_block_token2] = ACTIONS(1877),
    [anon_sym__and_LT_LT] = ACTIONS(1877),
    [anon_sym__andif_LT_LT] = ACTIONS(1877),
    [anon_sym__or_LT_LT] = ACTIONS(1877),
    [anon_sym__orif_LT_LT] = ACTIONS(1877),
    [anon_sym__xor_LT_LT] = ACTIONS(1877),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1877),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1877),
    [anon_sym_STAR_LT_LT] = ACTIONS(1877),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1877),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1877),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1877),
    [anon_sym__mod_LT_LT] = ACTIONS(1877),
    [anon_sym__div_LT_LT] = ACTIONS(1877),
    [anon_sym_DASH_LT_LT] = ACTIONS(1877),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1877),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1877),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1877),
    [aux_sym_if_token3] = ACTIONS(1877),
    [aux_sym_elif_token1] = ACTIONS(1877),
    [aux_sym_else_token1] = ACTIONS(1877),
    [aux_sym_loop_token2] = ACTIONS(1877),
    [aux_sym_finally_token1] = ACTIONS(1877),
    [aux_sym_finally_token2] = ACTIONS(1877),
    [aux_sym_catch_token2] = ACTIONS(1877),
    [aux_sym_try_token2] = ACTIONS(1877),
    [aux_sym_try_token3] = ACTIONS(1877),
    [aux_sym_protect_token3] = ACTIONS(1877),
    [aux_sym_protect_token4] = ACTIONS(1877),
    [aux_sym_lock_token2] = ACTIONS(1877),
    [anon_sym_SEMI] = ACTIONS(1877),
    [aux_sym_relational_operator_token1] = ACTIONS(1877),
    [aux_sym_relational_operator_token2] = ACTIONS(1877),
    [aux_sym_relational_operator_token3] = ACTIONS(1877),
    [anon_sym_EQ] = ACTIONS(1877),
    [anon_sym_TILDE_EQ] = ACTIONS(1877),
    [anon_sym_LT_GT] = ACTIONS(1877),
    [anon_sym_GT_EQ] = ACTIONS(1877),
    [anon_sym_LT_EQ] = ACTIONS(1877),
    [anon_sym_LT] = ACTIONS(1877),
    [anon_sym_GT] = ACTIONS(1877),
    [aux_sym_logical_operator_token1] = ACTIONS(1877),
    [aux_sym_logical_operator_token2] = ACTIONS(1877),
    [aux_sym_logical_operator_token3] = ACTIONS(1877),
    [aux_sym_logical_operator_token4] = ACTIONS(1877),
    [aux_sym_logical_operator_token5] = ACTIONS(1877),
    [aux_sym_logical_operator_token6] = ACTIONS(1877),
    [anon_sym_STAR_STAR] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_SLASH] = ACTIONS(1877),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1877),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_PLUS] = ACTIONS(1877),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [anon_sym_CR] = ACTIONS(1879),
    [anon_sym_LF] = ACTIONS(1879),
    [anon_sym_DOT] = ACTIONS(1879),
    [anon_sym_LPAREN] = ACTIONS(1879),
    [anon_sym_COMMA] = ACTIONS(1879),
    [anon_sym_LT_LT] = ACTIONS(1879),
    [anon_sym_CARET_LT_LT] = ACTIONS(1879),
    [anon_sym_LBRACK] = ACTIONS(1879),
    [aux_sym_method_token7] = ACTIONS(1879),
    [aux_sym_procedure_token2] = ACTIONS(1879),
    [aux_sym_block_token2] = ACTIONS(1879),
    [anon_sym__and_LT_LT] = ACTIONS(1879),
    [anon_sym__andif_LT_LT] = ACTIONS(1879),
    [anon_sym__or_LT_LT] = ACTIONS(1879),
    [anon_sym__orif_LT_LT] = ACTIONS(1879),
    [anon_sym__xor_LT_LT] = ACTIONS(1879),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1879),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1879),
    [anon_sym_STAR_LT_LT] = ACTIONS(1879),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1879),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1879),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1879),
    [anon_sym__mod_LT_LT] = ACTIONS(1879),
    [anon_sym__div_LT_LT] = ACTIONS(1879),
    [anon_sym_DASH_LT_LT] = ACTIONS(1879),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1879),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1879),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1879),
    [aux_sym_if_token3] = ACTIONS(1879),
    [aux_sym_elif_token1] = ACTIONS(1879),
    [aux_sym_else_token1] = ACTIONS(1879),
    [aux_sym_loop_token2] = ACTIONS(1879),
    [aux_sym_finally_token1] = ACTIONS(1879),
    [aux_sym_finally_token2] = ACTIONS(1879),
    [aux_sym_catch_token2] = ACTIONS(1879),
    [aux_sym_try_token2] = ACTIONS(1879),
    [aux_sym_try_token3] = ACTIONS(1879),
    [aux_sym_protect_token3] = ACTIONS(1879),
    [aux_sym_protect_token4] = ACTIONS(1879),
    [aux_sym_lock_token2] = ACTIONS(1879),
    [anon_sym_SEMI] = ACTIONS(1879),
    [aux_sym_relational_operator_token1] = ACTIONS(1879),
    [aux_sym_relational_operator_token2] = ACTIONS(1879),
    [aux_sym_relational_operator_token3] = ACTIONS(1879),
    [anon_sym_EQ] = ACTIONS(1879),
    [anon_sym_TILDE_EQ] = ACTIONS(1879),
    [anon_sym_LT_GT] = ACTIONS(1879),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_LT_EQ] = ACTIONS(1879),
    [anon_sym_LT] = ACTIONS(1879),
    [anon_sym_GT] = ACTIONS(1879),
    [aux_sym_logical_operator_token1] = ACTIONS(1879),
    [aux_sym_logical_operator_token2] = ACTIONS(1879),
    [aux_sym_logical_operator_token3] = ACTIONS(1879),
    [aux_sym_logical_operator_token4] = ACTIONS(1879),
    [aux_sym_logical_operator_token5] = ACTIONS(1879),
    [aux_sym_logical_operator_token6] = ACTIONS(1879),
    [anon_sym_STAR_STAR] = ACTIONS(1879),
    [anon_sym_STAR] = ACTIONS(1879),
    [anon_sym_SLASH] = ACTIONS(1879),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1879),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1879),
    [anon_sym_DASH] = ACTIONS(1879),
    [anon_sym_PLUS] = ACTIONS(1879),
    [sym_comment] = ACTIONS(3),
  },
  [516] = {
    [anon_sym_CR] = ACTIONS(1881),
    [anon_sym_LF] = ACTIONS(1881),
    [anon_sym_DOT] = ACTIONS(1881),
    [anon_sym_LPAREN] = ACTIONS(1881),
    [anon_sym_COMMA] = ACTIONS(1881),
    [anon_sym_LT_LT] = ACTIONS(1881),
    [anon_sym_CARET_LT_LT] = ACTIONS(1881),
    [anon_sym_LBRACK] = ACTIONS(1881),
    [aux_sym_method_token7] = ACTIONS(1881),
    [aux_sym_procedure_token2] = ACTIONS(1881),
    [aux_sym_block_token2] = ACTIONS(1881),
    [anon_sym__and_LT_LT] = ACTIONS(1881),
    [anon_sym__andif_LT_LT] = ACTIONS(1881),
    [anon_sym__or_LT_LT] = ACTIONS(1881),
    [anon_sym__orif_LT_LT] = ACTIONS(1881),
    [anon_sym__xor_LT_LT] = ACTIONS(1881),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1881),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1881),
    [anon_sym_STAR_LT_LT] = ACTIONS(1881),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1881),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1881),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1881),
    [anon_sym__mod_LT_LT] = ACTIONS(1881),
    [anon_sym__div_LT_LT] = ACTIONS(1881),
    [anon_sym_DASH_LT_LT] = ACTIONS(1881),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1881),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1881),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1881),
    [aux_sym_if_token3] = ACTIONS(1881),
    [aux_sym_elif_token1] = ACTIONS(1881),
    [aux_sym_else_token1] = ACTIONS(1881),
    [aux_sym_loop_token2] = ACTIONS(1881),
    [aux_sym_finally_token1] = ACTIONS(1881),
    [aux_sym_finally_token2] = ACTIONS(1881),
    [aux_sym_catch_token2] = ACTIONS(1881),
    [aux_sym_try_token2] = ACTIONS(1881),
    [aux_sym_try_token3] = ACTIONS(1881),
    [aux_sym_protect_token3] = ACTIONS(1881),
    [aux_sym_protect_token4] = ACTIONS(1881),
    [aux_sym_lock_token2] = ACTIONS(1881),
    [anon_sym_SEMI] = ACTIONS(1881),
    [aux_sym_relational_operator_token1] = ACTIONS(1881),
    [aux_sym_relational_operator_token2] = ACTIONS(1881),
    [aux_sym_relational_operator_token3] = ACTIONS(1881),
    [anon_sym_EQ] = ACTIONS(1881),
    [anon_sym_TILDE_EQ] = ACTIONS(1881),
    [anon_sym_LT_GT] = ACTIONS(1881),
    [anon_sym_GT_EQ] = ACTIONS(1881),
    [anon_sym_LT_EQ] = ACTIONS(1881),
    [anon_sym_LT] = ACTIONS(1881),
    [anon_sym_GT] = ACTIONS(1881),
    [aux_sym_logical_operator_token1] = ACTIONS(1881),
    [aux_sym_logical_operator_token2] = ACTIONS(1881),
    [aux_sym_logical_operator_token3] = ACTIONS(1881),
    [aux_sym_logical_operator_token4] = ACTIONS(1881),
    [aux_sym_logical_operator_token5] = ACTIONS(1881),
    [aux_sym_logical_operator_token6] = ACTIONS(1881),
    [anon_sym_STAR_STAR] = ACTIONS(1881),
    [anon_sym_STAR] = ACTIONS(1881),
    [anon_sym_SLASH] = ACTIONS(1881),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1881),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1881),
    [anon_sym_DASH] = ACTIONS(1881),
    [anon_sym_PLUS] = ACTIONS(1881),
    [sym_comment] = ACTIONS(3),
  },
  [517] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(1845),
    [anon_sym_LF] = ACTIONS(1845),
    [anon_sym_DOT] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(1845),
    [anon_sym_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym_LBRACK] = ACTIONS(1845),
    [aux_sym_method_token7] = ACTIONS(1845),
    [aux_sym_procedure_token2] = ACTIONS(1845),
    [aux_sym_block_token2] = ACTIONS(1845),
    [anon_sym__and_LT_LT] = ACTIONS(1845),
    [anon_sym__andif_LT_LT] = ACTIONS(1845),
    [anon_sym__or_LT_LT] = ACTIONS(1845),
    [anon_sym__orif_LT_LT] = ACTIONS(1845),
    [anon_sym__xor_LT_LT] = ACTIONS(1845),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1845),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym_STAR_LT_LT] = ACTIONS(1845),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1845),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym__mod_LT_LT] = ACTIONS(1845),
    [anon_sym__div_LT_LT] = ACTIONS(1845),
    [anon_sym_DASH_LT_LT] = ACTIONS(1845),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1845),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1845),
    [aux_sym_if_token3] = ACTIONS(1845),
    [aux_sym_elif_token1] = ACTIONS(1845),
    [aux_sym_else_token1] = ACTIONS(1845),
    [aux_sym_loop_token2] = ACTIONS(1845),
    [aux_sym_finally_token1] = ACTIONS(1845),
    [aux_sym_finally_token2] = ACTIONS(1845),
    [aux_sym_catch_token2] = ACTIONS(1845),
    [aux_sym_try_token2] = ACTIONS(1845),
    [aux_sym_try_token3] = ACTIONS(1845),
    [aux_sym_protect_token4] = ACTIONS(1845),
    [aux_sym_lock_token2] = ACTIONS(1845),
    [anon_sym_SEMI] = ACTIONS(1845),
    [aux_sym_relational_operator_token1] = ACTIONS(1845),
    [aux_sym_relational_operator_token2] = ACTIONS(1845),
    [aux_sym_relational_operator_token3] = ACTIONS(1845),
    [anon_sym_EQ] = ACTIONS(1845),
    [anon_sym_TILDE_EQ] = ACTIONS(1845),
    [anon_sym_LT_GT] = ACTIONS(1845),
    [anon_sym_GT_EQ] = ACTIONS(1845),
    [anon_sym_LT_EQ] = ACTIONS(1845),
    [anon_sym_LT] = ACTIONS(1845),
    [anon_sym_GT] = ACTIONS(1845),
    [aux_sym_logical_operator_token1] = ACTIONS(1845),
    [aux_sym_logical_operator_token2] = ACTIONS(1845),
    [aux_sym_logical_operator_token3] = ACTIONS(1845),
    [aux_sym_logical_operator_token4] = ACTIONS(1845),
    [aux_sym_logical_operator_token5] = ACTIONS(1845),
    [aux_sym_logical_operator_token6] = ACTIONS(1845),
    [anon_sym_STAR_STAR] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_SLASH] = ACTIONS(1845),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1845),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1845),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [sym_comment] = ACTIONS(3),
  },
  [518] = {
    [anon_sym_CR] = ACTIONS(1883),
    [anon_sym_LF] = ACTIONS(1883),
    [anon_sym_DOT] = ACTIONS(1883),
    [anon_sym_LPAREN] = ACTIONS(1883),
    [anon_sym_COMMA] = ACTIONS(1883),
    [anon_sym_LT_LT] = ACTIONS(1883),
    [anon_sym_CARET_LT_LT] = ACTIONS(1883),
    [anon_sym_LBRACK] = ACTIONS(1883),
    [aux_sym_method_token7] = ACTIONS(1883),
    [aux_sym_procedure_token2] = ACTIONS(1883),
    [aux_sym_block_token2] = ACTIONS(1883),
    [anon_sym__and_LT_LT] = ACTIONS(1883),
    [anon_sym__andif_LT_LT] = ACTIONS(1883),
    [anon_sym__or_LT_LT] = ACTIONS(1883),
    [anon_sym__orif_LT_LT] = ACTIONS(1883),
    [anon_sym__xor_LT_LT] = ACTIONS(1883),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1883),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1883),
    [anon_sym_STAR_LT_LT] = ACTIONS(1883),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1883),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1883),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1883),
    [anon_sym__mod_LT_LT] = ACTIONS(1883),
    [anon_sym__div_LT_LT] = ACTIONS(1883),
    [anon_sym_DASH_LT_LT] = ACTIONS(1883),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1883),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1883),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1883),
    [aux_sym_if_token3] = ACTIONS(1883),
    [aux_sym_elif_token1] = ACTIONS(1883),
    [aux_sym_else_token1] = ACTIONS(1883),
    [aux_sym_loop_token2] = ACTIONS(1883),
    [aux_sym_finally_token1] = ACTIONS(1883),
    [aux_sym_finally_token2] = ACTIONS(1883),
    [aux_sym_catch_token2] = ACTIONS(1883),
    [aux_sym_try_token2] = ACTIONS(1883),
    [aux_sym_try_token3] = ACTIONS(1883),
    [aux_sym_protect_token3] = ACTIONS(1883),
    [aux_sym_protect_token4] = ACTIONS(1883),
    [aux_sym_lock_token2] = ACTIONS(1883),
    [anon_sym_SEMI] = ACTIONS(1883),
    [aux_sym_relational_operator_token1] = ACTIONS(1883),
    [aux_sym_relational_operator_token2] = ACTIONS(1883),
    [aux_sym_relational_operator_token3] = ACTIONS(1883),
    [anon_sym_EQ] = ACTIONS(1883),
    [anon_sym_TILDE_EQ] = ACTIONS(1883),
    [anon_sym_LT_GT] = ACTIONS(1883),
    [anon_sym_GT_EQ] = ACTIONS(1883),
    [anon_sym_LT_EQ] = ACTIONS(1883),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_GT] = ACTIONS(1883),
    [aux_sym_logical_operator_token1] = ACTIONS(1883),
    [aux_sym_logical_operator_token2] = ACTIONS(1883),
    [aux_sym_logical_operator_token3] = ACTIONS(1883),
    [aux_sym_logical_operator_token4] = ACTIONS(1883),
    [aux_sym_logical_operator_token5] = ACTIONS(1883),
    [aux_sym_logical_operator_token6] = ACTIONS(1883),
    [anon_sym_STAR_STAR] = ACTIONS(1883),
    [anon_sym_STAR] = ACTIONS(1883),
    [anon_sym_SLASH] = ACTIONS(1883),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1883),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1883),
    [anon_sym_DASH] = ACTIONS(1883),
    [anon_sym_PLUS] = ACTIONS(1883),
    [sym_comment] = ACTIONS(3),
  },
  [519] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(1825),
    [anon_sym_LF] = ACTIONS(1825),
    [anon_sym_DOT] = ACTIONS(1825),
    [anon_sym_LPAREN] = ACTIONS(1825),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(1825),
    [anon_sym_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym_LBRACK] = ACTIONS(1825),
    [aux_sym_method_token7] = ACTIONS(1825),
    [aux_sym_procedure_token2] = ACTIONS(1825),
    [aux_sym_block_token2] = ACTIONS(1825),
    [anon_sym__and_LT_LT] = ACTIONS(1825),
    [anon_sym__andif_LT_LT] = ACTIONS(1825),
    [anon_sym__or_LT_LT] = ACTIONS(1825),
    [anon_sym__orif_LT_LT] = ACTIONS(1825),
    [anon_sym__xor_LT_LT] = ACTIONS(1825),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1825),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym_STAR_LT_LT] = ACTIONS(1825),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1825),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym__mod_LT_LT] = ACTIONS(1825),
    [anon_sym__div_LT_LT] = ACTIONS(1825),
    [anon_sym_DASH_LT_LT] = ACTIONS(1825),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1825),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1825),
    [aux_sym_if_token3] = ACTIONS(1825),
    [aux_sym_elif_token1] = ACTIONS(1825),
    [aux_sym_else_token1] = ACTIONS(1825),
    [aux_sym_loop_token2] = ACTIONS(1825),
    [aux_sym_finally_token1] = ACTIONS(1825),
    [aux_sym_finally_token2] = ACTIONS(1825),
    [aux_sym_catch_token2] = ACTIONS(1825),
    [aux_sym_try_token2] = ACTIONS(1825),
    [aux_sym_try_token3] = ACTIONS(1825),
    [aux_sym_protect_token4] = ACTIONS(1825),
    [aux_sym_lock_token2] = ACTIONS(1825),
    [anon_sym_SEMI] = ACTIONS(1825),
    [aux_sym_relational_operator_token1] = ACTIONS(1825),
    [aux_sym_relational_operator_token2] = ACTIONS(1825),
    [aux_sym_relational_operator_token3] = ACTIONS(1825),
    [anon_sym_EQ] = ACTIONS(1825),
    [anon_sym_TILDE_EQ] = ACTIONS(1825),
    [anon_sym_LT_GT] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(1825),
    [anon_sym_LT_EQ] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1825),
    [anon_sym_GT] = ACTIONS(1825),
    [aux_sym_logical_operator_token1] = ACTIONS(1825),
    [aux_sym_logical_operator_token2] = ACTIONS(1825),
    [aux_sym_logical_operator_token3] = ACTIONS(1825),
    [aux_sym_logical_operator_token4] = ACTIONS(1825),
    [aux_sym_logical_operator_token5] = ACTIONS(1825),
    [aux_sym_logical_operator_token6] = ACTIONS(1825),
    [anon_sym_STAR_STAR] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(1825),
    [anon_sym_SLASH] = ACTIONS(1825),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1825),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1825),
    [anon_sym_DASH] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
  },
  [520] = {
    [anon_sym_CR] = ACTIONS(1885),
    [anon_sym_LF] = ACTIONS(1885),
    [anon_sym_DOT] = ACTIONS(1885),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_COMMA] = ACTIONS(1885),
    [anon_sym_LT_LT] = ACTIONS(1885),
    [anon_sym_CARET_LT_LT] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [aux_sym_method_token7] = ACTIONS(1885),
    [aux_sym_procedure_token2] = ACTIONS(1885),
    [aux_sym_block_token2] = ACTIONS(1885),
    [anon_sym__and_LT_LT] = ACTIONS(1885),
    [anon_sym__andif_LT_LT] = ACTIONS(1885),
    [anon_sym__or_LT_LT] = ACTIONS(1885),
    [anon_sym__orif_LT_LT] = ACTIONS(1885),
    [anon_sym__xor_LT_LT] = ACTIONS(1885),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1885),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1885),
    [anon_sym_STAR_LT_LT] = ACTIONS(1885),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1885),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1885),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1885),
    [anon_sym__mod_LT_LT] = ACTIONS(1885),
    [anon_sym__div_LT_LT] = ACTIONS(1885),
    [anon_sym_DASH_LT_LT] = ACTIONS(1885),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1885),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1885),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1885),
    [aux_sym_if_token3] = ACTIONS(1885),
    [aux_sym_elif_token1] = ACTIONS(1885),
    [aux_sym_else_token1] = ACTIONS(1885),
    [aux_sym_loop_token2] = ACTIONS(1885),
    [aux_sym_finally_token1] = ACTIONS(1885),
    [aux_sym_finally_token2] = ACTIONS(1885),
    [aux_sym_catch_token2] = ACTIONS(1885),
    [aux_sym_try_token2] = ACTIONS(1885),
    [aux_sym_try_token3] = ACTIONS(1885),
    [aux_sym_protect_token3] = ACTIONS(1885),
    [aux_sym_protect_token4] = ACTIONS(1885),
    [aux_sym_lock_token2] = ACTIONS(1885),
    [anon_sym_SEMI] = ACTIONS(1885),
    [aux_sym_relational_operator_token1] = ACTIONS(1885),
    [aux_sym_relational_operator_token2] = ACTIONS(1885),
    [aux_sym_relational_operator_token3] = ACTIONS(1885),
    [anon_sym_EQ] = ACTIONS(1885),
    [anon_sym_TILDE_EQ] = ACTIONS(1885),
    [anon_sym_LT_GT] = ACTIONS(1885),
    [anon_sym_GT_EQ] = ACTIONS(1885),
    [anon_sym_LT_EQ] = ACTIONS(1885),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_GT] = ACTIONS(1885),
    [aux_sym_logical_operator_token1] = ACTIONS(1885),
    [aux_sym_logical_operator_token2] = ACTIONS(1885),
    [aux_sym_logical_operator_token3] = ACTIONS(1885),
    [aux_sym_logical_operator_token4] = ACTIONS(1885),
    [aux_sym_logical_operator_token5] = ACTIONS(1885),
    [aux_sym_logical_operator_token6] = ACTIONS(1885),
    [anon_sym_STAR_STAR] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_SLASH] = ACTIONS(1885),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1885),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1885),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_PLUS] = ACTIONS(1885),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [anon_sym_CR] = ACTIONS(1887),
    [anon_sym_LF] = ACTIONS(1887),
    [anon_sym_DOT] = ACTIONS(1887),
    [anon_sym_LPAREN] = ACTIONS(1887),
    [anon_sym_COMMA] = ACTIONS(1887),
    [anon_sym_LT_LT] = ACTIONS(1887),
    [anon_sym_CARET_LT_LT] = ACTIONS(1887),
    [anon_sym_LBRACK] = ACTIONS(1887),
    [aux_sym_method_token7] = ACTIONS(1887),
    [aux_sym_procedure_token2] = ACTIONS(1887),
    [aux_sym_block_token2] = ACTIONS(1887),
    [anon_sym__and_LT_LT] = ACTIONS(1887),
    [anon_sym__andif_LT_LT] = ACTIONS(1887),
    [anon_sym__or_LT_LT] = ACTIONS(1887),
    [anon_sym__orif_LT_LT] = ACTIONS(1887),
    [anon_sym__xor_LT_LT] = ACTIONS(1887),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1887),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1887),
    [anon_sym_STAR_LT_LT] = ACTIONS(1887),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1887),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1887),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1887),
    [anon_sym__mod_LT_LT] = ACTIONS(1887),
    [anon_sym__div_LT_LT] = ACTIONS(1887),
    [anon_sym_DASH_LT_LT] = ACTIONS(1887),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1887),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1887),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1887),
    [aux_sym_if_token3] = ACTIONS(1887),
    [aux_sym_elif_token1] = ACTIONS(1887),
    [aux_sym_else_token1] = ACTIONS(1887),
    [aux_sym_loop_token2] = ACTIONS(1887),
    [aux_sym_finally_token1] = ACTIONS(1887),
    [aux_sym_finally_token2] = ACTIONS(1887),
    [aux_sym_catch_token2] = ACTIONS(1887),
    [aux_sym_try_token2] = ACTIONS(1887),
    [aux_sym_try_token3] = ACTIONS(1887),
    [aux_sym_protect_token3] = ACTIONS(1887),
    [aux_sym_protect_token4] = ACTIONS(1887),
    [aux_sym_lock_token2] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1887),
    [aux_sym_relational_operator_token1] = ACTIONS(1887),
    [aux_sym_relational_operator_token2] = ACTIONS(1887),
    [aux_sym_relational_operator_token3] = ACTIONS(1887),
    [anon_sym_EQ] = ACTIONS(1887),
    [anon_sym_TILDE_EQ] = ACTIONS(1887),
    [anon_sym_LT_GT] = ACTIONS(1887),
    [anon_sym_GT_EQ] = ACTIONS(1887),
    [anon_sym_LT_EQ] = ACTIONS(1887),
    [anon_sym_LT] = ACTIONS(1887),
    [anon_sym_GT] = ACTIONS(1887),
    [aux_sym_logical_operator_token1] = ACTIONS(1887),
    [aux_sym_logical_operator_token2] = ACTIONS(1887),
    [aux_sym_logical_operator_token3] = ACTIONS(1887),
    [aux_sym_logical_operator_token4] = ACTIONS(1887),
    [aux_sym_logical_operator_token5] = ACTIONS(1887),
    [aux_sym_logical_operator_token6] = ACTIONS(1887),
    [anon_sym_STAR_STAR] = ACTIONS(1887),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_SLASH] = ACTIONS(1887),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1887),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1887),
    [anon_sym_DASH] = ACTIONS(1887),
    [anon_sym_PLUS] = ACTIONS(1887),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [anon_sym_CR] = ACTIONS(1889),
    [anon_sym_LF] = ACTIONS(1889),
    [anon_sym_DOT] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(1889),
    [anon_sym_COMMA] = ACTIONS(1889),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_CARET_LT_LT] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(1889),
    [aux_sym_method_token7] = ACTIONS(1889),
    [aux_sym_procedure_token2] = ACTIONS(1889),
    [aux_sym_block_token2] = ACTIONS(1889),
    [anon_sym__and_LT_LT] = ACTIONS(1889),
    [anon_sym__andif_LT_LT] = ACTIONS(1889),
    [anon_sym__or_LT_LT] = ACTIONS(1889),
    [anon_sym__orif_LT_LT] = ACTIONS(1889),
    [anon_sym__xor_LT_LT] = ACTIONS(1889),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1889),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1889),
    [anon_sym_STAR_LT_LT] = ACTIONS(1889),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1889),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1889),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1889),
    [anon_sym__mod_LT_LT] = ACTIONS(1889),
    [anon_sym__div_LT_LT] = ACTIONS(1889),
    [anon_sym_DASH_LT_LT] = ACTIONS(1889),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1889),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1889),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1889),
    [aux_sym_if_token3] = ACTIONS(1889),
    [aux_sym_elif_token1] = ACTIONS(1889),
    [aux_sym_else_token1] = ACTIONS(1889),
    [aux_sym_loop_token2] = ACTIONS(1889),
    [aux_sym_finally_token1] = ACTIONS(1889),
    [aux_sym_finally_token2] = ACTIONS(1889),
    [aux_sym_catch_token2] = ACTIONS(1889),
    [aux_sym_try_token2] = ACTIONS(1889),
    [aux_sym_try_token3] = ACTIONS(1889),
    [aux_sym_protect_token3] = ACTIONS(1889),
    [aux_sym_protect_token4] = ACTIONS(1889),
    [aux_sym_lock_token2] = ACTIONS(1889),
    [anon_sym_SEMI] = ACTIONS(1889),
    [aux_sym_relational_operator_token1] = ACTIONS(1889),
    [aux_sym_relational_operator_token2] = ACTIONS(1889),
    [aux_sym_relational_operator_token3] = ACTIONS(1889),
    [anon_sym_EQ] = ACTIONS(1889),
    [anon_sym_TILDE_EQ] = ACTIONS(1889),
    [anon_sym_LT_GT] = ACTIONS(1889),
    [anon_sym_GT_EQ] = ACTIONS(1889),
    [anon_sym_LT_EQ] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_GT] = ACTIONS(1889),
    [aux_sym_logical_operator_token1] = ACTIONS(1889),
    [aux_sym_logical_operator_token2] = ACTIONS(1889),
    [aux_sym_logical_operator_token3] = ACTIONS(1889),
    [aux_sym_logical_operator_token4] = ACTIONS(1889),
    [aux_sym_logical_operator_token5] = ACTIONS(1889),
    [aux_sym_logical_operator_token6] = ACTIONS(1889),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_STAR] = ACTIONS(1889),
    [anon_sym_SLASH] = ACTIONS(1889),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1889),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_PLUS] = ACTIONS(1889),
    [sym_comment] = ACTIONS(3),
  },
  [523] = {
    [anon_sym_CR] = ACTIONS(1891),
    [anon_sym_LF] = ACTIONS(1891),
    [anon_sym_DOT] = ACTIONS(1891),
    [anon_sym_LPAREN] = ACTIONS(1891),
    [anon_sym_COMMA] = ACTIONS(1891),
    [anon_sym_LT_LT] = ACTIONS(1891),
    [anon_sym_CARET_LT_LT] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(1891),
    [aux_sym_method_token7] = ACTIONS(1891),
    [aux_sym_procedure_token2] = ACTIONS(1891),
    [aux_sym_block_token2] = ACTIONS(1891),
    [anon_sym__and_LT_LT] = ACTIONS(1891),
    [anon_sym__andif_LT_LT] = ACTIONS(1891),
    [anon_sym__or_LT_LT] = ACTIONS(1891),
    [anon_sym__orif_LT_LT] = ACTIONS(1891),
    [anon_sym__xor_LT_LT] = ACTIONS(1891),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1891),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1891),
    [anon_sym_STAR_LT_LT] = ACTIONS(1891),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1891),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1891),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1891),
    [anon_sym__mod_LT_LT] = ACTIONS(1891),
    [anon_sym__div_LT_LT] = ACTIONS(1891),
    [anon_sym_DASH_LT_LT] = ACTIONS(1891),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1891),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1891),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1891),
    [aux_sym_if_token3] = ACTIONS(1891),
    [aux_sym_elif_token1] = ACTIONS(1891),
    [aux_sym_else_token1] = ACTIONS(1891),
    [aux_sym_loop_token2] = ACTIONS(1891),
    [aux_sym_finally_token1] = ACTIONS(1891),
    [aux_sym_finally_token2] = ACTIONS(1891),
    [aux_sym_catch_token2] = ACTIONS(1891),
    [aux_sym_try_token2] = ACTIONS(1891),
    [aux_sym_try_token3] = ACTIONS(1891),
    [aux_sym_protect_token3] = ACTIONS(1891),
    [aux_sym_protect_token4] = ACTIONS(1891),
    [aux_sym_lock_token2] = ACTIONS(1891),
    [anon_sym_SEMI] = ACTIONS(1891),
    [aux_sym_relational_operator_token1] = ACTIONS(1891),
    [aux_sym_relational_operator_token2] = ACTIONS(1891),
    [aux_sym_relational_operator_token3] = ACTIONS(1891),
    [anon_sym_EQ] = ACTIONS(1891),
    [anon_sym_TILDE_EQ] = ACTIONS(1891),
    [anon_sym_LT_GT] = ACTIONS(1891),
    [anon_sym_GT_EQ] = ACTIONS(1891),
    [anon_sym_LT_EQ] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_GT] = ACTIONS(1891),
    [aux_sym_logical_operator_token1] = ACTIONS(1891),
    [aux_sym_logical_operator_token2] = ACTIONS(1891),
    [aux_sym_logical_operator_token3] = ACTIONS(1891),
    [aux_sym_logical_operator_token4] = ACTIONS(1891),
    [aux_sym_logical_operator_token5] = ACTIONS(1891),
    [aux_sym_logical_operator_token6] = ACTIONS(1891),
    [anon_sym_STAR_STAR] = ACTIONS(1891),
    [anon_sym_STAR] = ACTIONS(1891),
    [anon_sym_SLASH] = ACTIONS(1891),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1891),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1891),
    [anon_sym_DASH] = ACTIONS(1891),
    [anon_sym_PLUS] = ACTIONS(1891),
    [sym_comment] = ACTIONS(3),
  },
  [524] = {
    [anon_sym_CR] = ACTIONS(1893),
    [anon_sym_LF] = ACTIONS(1893),
    [anon_sym_DOT] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_COMMA] = ACTIONS(1893),
    [anon_sym_LT_LT] = ACTIONS(1893),
    [anon_sym_CARET_LT_LT] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1893),
    [aux_sym_method_token7] = ACTIONS(1893),
    [aux_sym_procedure_token2] = ACTIONS(1893),
    [aux_sym_block_token2] = ACTIONS(1893),
    [anon_sym__and_LT_LT] = ACTIONS(1893),
    [anon_sym__andif_LT_LT] = ACTIONS(1893),
    [anon_sym__or_LT_LT] = ACTIONS(1893),
    [anon_sym__orif_LT_LT] = ACTIONS(1893),
    [anon_sym__xor_LT_LT] = ACTIONS(1893),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1893),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1893),
    [anon_sym_STAR_LT_LT] = ACTIONS(1893),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1893),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1893),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1893),
    [anon_sym__mod_LT_LT] = ACTIONS(1893),
    [anon_sym__div_LT_LT] = ACTIONS(1893),
    [anon_sym_DASH_LT_LT] = ACTIONS(1893),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1893),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1893),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1893),
    [aux_sym_if_token3] = ACTIONS(1893),
    [aux_sym_elif_token1] = ACTIONS(1893),
    [aux_sym_else_token1] = ACTIONS(1893),
    [aux_sym_loop_token2] = ACTIONS(1893),
    [aux_sym_finally_token1] = ACTIONS(1893),
    [aux_sym_finally_token2] = ACTIONS(1893),
    [aux_sym_catch_token2] = ACTIONS(1893),
    [aux_sym_try_token2] = ACTIONS(1893),
    [aux_sym_try_token3] = ACTIONS(1893),
    [aux_sym_protect_token3] = ACTIONS(1893),
    [aux_sym_protect_token4] = ACTIONS(1893),
    [aux_sym_lock_token2] = ACTIONS(1893),
    [anon_sym_SEMI] = ACTIONS(1893),
    [aux_sym_relational_operator_token1] = ACTIONS(1893),
    [aux_sym_relational_operator_token2] = ACTIONS(1893),
    [aux_sym_relational_operator_token3] = ACTIONS(1893),
    [anon_sym_EQ] = ACTIONS(1893),
    [anon_sym_TILDE_EQ] = ACTIONS(1893),
    [anon_sym_LT_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1893),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [aux_sym_logical_operator_token1] = ACTIONS(1893),
    [aux_sym_logical_operator_token2] = ACTIONS(1893),
    [aux_sym_logical_operator_token3] = ACTIONS(1893),
    [aux_sym_logical_operator_token4] = ACTIONS(1893),
    [aux_sym_logical_operator_token5] = ACTIONS(1893),
    [aux_sym_logical_operator_token6] = ACTIONS(1893),
    [anon_sym_STAR_STAR] = ACTIONS(1893),
    [anon_sym_STAR] = ACTIONS(1893),
    [anon_sym_SLASH] = ACTIONS(1893),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1893),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_PLUS] = ACTIONS(1893),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [anon_sym_CR] = ACTIONS(1895),
    [anon_sym_LF] = ACTIONS(1895),
    [anon_sym_DOT] = ACTIONS(1895),
    [anon_sym_LPAREN] = ACTIONS(1895),
    [anon_sym_COMMA] = ACTIONS(1895),
    [anon_sym_LT_LT] = ACTIONS(1895),
    [anon_sym_CARET_LT_LT] = ACTIONS(1895),
    [anon_sym_LBRACK] = ACTIONS(1895),
    [aux_sym_method_token7] = ACTIONS(1895),
    [aux_sym_procedure_token2] = ACTIONS(1895),
    [aux_sym_block_token2] = ACTIONS(1895),
    [anon_sym__and_LT_LT] = ACTIONS(1895),
    [anon_sym__andif_LT_LT] = ACTIONS(1895),
    [anon_sym__or_LT_LT] = ACTIONS(1895),
    [anon_sym__orif_LT_LT] = ACTIONS(1895),
    [anon_sym__xor_LT_LT] = ACTIONS(1895),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1895),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1895),
    [anon_sym_STAR_LT_LT] = ACTIONS(1895),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1895),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1895),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1895),
    [anon_sym__mod_LT_LT] = ACTIONS(1895),
    [anon_sym__div_LT_LT] = ACTIONS(1895),
    [anon_sym_DASH_LT_LT] = ACTIONS(1895),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1895),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1895),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1895),
    [aux_sym_if_token3] = ACTIONS(1895),
    [aux_sym_elif_token1] = ACTIONS(1895),
    [aux_sym_else_token1] = ACTIONS(1895),
    [aux_sym_loop_token2] = ACTIONS(1895),
    [aux_sym_finally_token1] = ACTIONS(1895),
    [aux_sym_finally_token2] = ACTIONS(1895),
    [aux_sym_catch_token2] = ACTIONS(1895),
    [aux_sym_try_token2] = ACTIONS(1895),
    [aux_sym_try_token3] = ACTIONS(1895),
    [aux_sym_protect_token3] = ACTIONS(1895),
    [aux_sym_protect_token4] = ACTIONS(1895),
    [aux_sym_lock_token2] = ACTIONS(1895),
    [anon_sym_SEMI] = ACTIONS(1895),
    [aux_sym_relational_operator_token1] = ACTIONS(1895),
    [aux_sym_relational_operator_token2] = ACTIONS(1895),
    [aux_sym_relational_operator_token3] = ACTIONS(1895),
    [anon_sym_EQ] = ACTIONS(1895),
    [anon_sym_TILDE_EQ] = ACTIONS(1895),
    [anon_sym_LT_GT] = ACTIONS(1895),
    [anon_sym_GT_EQ] = ACTIONS(1895),
    [anon_sym_LT_EQ] = ACTIONS(1895),
    [anon_sym_LT] = ACTIONS(1895),
    [anon_sym_GT] = ACTIONS(1895),
    [aux_sym_logical_operator_token1] = ACTIONS(1895),
    [aux_sym_logical_operator_token2] = ACTIONS(1895),
    [aux_sym_logical_operator_token3] = ACTIONS(1895),
    [aux_sym_logical_operator_token4] = ACTIONS(1895),
    [aux_sym_logical_operator_token5] = ACTIONS(1895),
    [aux_sym_logical_operator_token6] = ACTIONS(1895),
    [anon_sym_STAR_STAR] = ACTIONS(1895),
    [anon_sym_STAR] = ACTIONS(1895),
    [anon_sym_SLASH] = ACTIONS(1895),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1895),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1895),
    [anon_sym_DASH] = ACTIONS(1895),
    [anon_sym_PLUS] = ACTIONS(1895),
    [sym_comment] = ACTIONS(3),
  },
  [526] = {
    [anon_sym_CR] = ACTIONS(1797),
    [anon_sym_LF] = ACTIONS(1797),
    [anon_sym_DOT] = ACTIONS(1797),
    [anon_sym_LPAREN] = ACTIONS(1797),
    [anon_sym_COMMA] = ACTIONS(1797),
    [anon_sym_LT_LT] = ACTIONS(1797),
    [anon_sym_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [aux_sym_method_token7] = ACTIONS(1797),
    [aux_sym_procedure_token2] = ACTIONS(1797),
    [aux_sym_block_token2] = ACTIONS(1797),
    [anon_sym__and_LT_LT] = ACTIONS(1797),
    [anon_sym__andif_LT_LT] = ACTIONS(1797),
    [anon_sym__or_LT_LT] = ACTIONS(1797),
    [anon_sym__orif_LT_LT] = ACTIONS(1797),
    [anon_sym__xor_LT_LT] = ACTIONS(1797),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1797),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym_STAR_LT_LT] = ACTIONS(1797),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1797),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym__mod_LT_LT] = ACTIONS(1797),
    [anon_sym__div_LT_LT] = ACTIONS(1797),
    [anon_sym_DASH_LT_LT] = ACTIONS(1797),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1797),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1797),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1797),
    [aux_sym_if_token3] = ACTIONS(1797),
    [aux_sym_elif_token1] = ACTIONS(1797),
    [aux_sym_else_token1] = ACTIONS(1797),
    [aux_sym_loop_token2] = ACTIONS(1797),
    [aux_sym_finally_token1] = ACTIONS(1797),
    [aux_sym_finally_token2] = ACTIONS(1897),
    [aux_sym_catch_token2] = ACTIONS(1797),
    [aux_sym_try_token2] = ACTIONS(1797),
    [aux_sym_try_token3] = ACTIONS(1797),
    [aux_sym_protect_token4] = ACTIONS(1797),
    [aux_sym_lock_token2] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1797),
    [sym_label] = ACTIONS(1899),
    [aux_sym_relational_operator_token1] = ACTIONS(1797),
    [aux_sym_relational_operator_token2] = ACTIONS(1797),
    [aux_sym_relational_operator_token3] = ACTIONS(1797),
    [anon_sym_EQ] = ACTIONS(1797),
    [anon_sym_TILDE_EQ] = ACTIONS(1797),
    [anon_sym_LT_GT] = ACTIONS(1797),
    [anon_sym_GT_EQ] = ACTIONS(1797),
    [anon_sym_LT_EQ] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(1797),
    [anon_sym_GT] = ACTIONS(1797),
    [aux_sym_logical_operator_token1] = ACTIONS(1797),
    [aux_sym_logical_operator_token2] = ACTIONS(1797),
    [aux_sym_logical_operator_token3] = ACTIONS(1797),
    [aux_sym_logical_operator_token4] = ACTIONS(1797),
    [aux_sym_logical_operator_token5] = ACTIONS(1797),
    [aux_sym_logical_operator_token6] = ACTIONS(1797),
    [anon_sym_STAR_STAR] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1797),
    [anon_sym_SLASH] = ACTIONS(1797),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1797),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1797),
    [anon_sym_DASH] = ACTIONS(1797),
    [anon_sym_PLUS] = ACTIONS(1797),
    [sym_comment] = ACTIONS(3),
  },
  [527] = {
    [anon_sym_CR] = ACTIONS(1901),
    [anon_sym_LF] = ACTIONS(1901),
    [anon_sym_DOT] = ACTIONS(1901),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_COMMA] = ACTIONS(1901),
    [anon_sym_LT_LT] = ACTIONS(1901),
    [anon_sym_CARET_LT_LT] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [aux_sym_method_token7] = ACTIONS(1901),
    [aux_sym_procedure_token2] = ACTIONS(1901),
    [aux_sym_block_token2] = ACTIONS(1901),
    [anon_sym__and_LT_LT] = ACTIONS(1901),
    [anon_sym__andif_LT_LT] = ACTIONS(1901),
    [anon_sym__or_LT_LT] = ACTIONS(1901),
    [anon_sym__orif_LT_LT] = ACTIONS(1901),
    [anon_sym__xor_LT_LT] = ACTIONS(1901),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1901),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1901),
    [anon_sym_STAR_LT_LT] = ACTIONS(1901),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1901),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1901),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1901),
    [anon_sym__mod_LT_LT] = ACTIONS(1901),
    [anon_sym__div_LT_LT] = ACTIONS(1901),
    [anon_sym_DASH_LT_LT] = ACTIONS(1901),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1901),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1901),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1901),
    [aux_sym_if_token3] = ACTIONS(1901),
    [aux_sym_elif_token1] = ACTIONS(1901),
    [aux_sym_else_token1] = ACTIONS(1901),
    [aux_sym_loop_token2] = ACTIONS(1901),
    [aux_sym_finally_token1] = ACTIONS(1901),
    [aux_sym_finally_token2] = ACTIONS(1901),
    [aux_sym_catch_token2] = ACTIONS(1901),
    [aux_sym_try_token2] = ACTIONS(1901),
    [aux_sym_try_token3] = ACTIONS(1901),
    [aux_sym_protect_token3] = ACTIONS(1901),
    [aux_sym_protect_token4] = ACTIONS(1901),
    [aux_sym_lock_token2] = ACTIONS(1901),
    [anon_sym_SEMI] = ACTIONS(1901),
    [aux_sym_relational_operator_token1] = ACTIONS(1901),
    [aux_sym_relational_operator_token2] = ACTIONS(1901),
    [aux_sym_relational_operator_token3] = ACTIONS(1901),
    [anon_sym_EQ] = ACTIONS(1901),
    [anon_sym_TILDE_EQ] = ACTIONS(1901),
    [anon_sym_LT_GT] = ACTIONS(1901),
    [anon_sym_GT_EQ] = ACTIONS(1901),
    [anon_sym_LT_EQ] = ACTIONS(1901),
    [anon_sym_LT] = ACTIONS(1901),
    [anon_sym_GT] = ACTIONS(1901),
    [aux_sym_logical_operator_token1] = ACTIONS(1901),
    [aux_sym_logical_operator_token2] = ACTIONS(1901),
    [aux_sym_logical_operator_token3] = ACTIONS(1901),
    [aux_sym_logical_operator_token4] = ACTIONS(1901),
    [aux_sym_logical_operator_token5] = ACTIONS(1901),
    [aux_sym_logical_operator_token6] = ACTIONS(1901),
    [anon_sym_STAR_STAR] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_SLASH] = ACTIONS(1901),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1901),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PLUS] = ACTIONS(1901),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [anon_sym_CR] = ACTIONS(1801),
    [anon_sym_LF] = ACTIONS(1801),
    [anon_sym_DOT] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1801),
    [anon_sym_COMMA] = ACTIONS(1801),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [aux_sym_method_token7] = ACTIONS(1801),
    [aux_sym_procedure_token2] = ACTIONS(1801),
    [aux_sym_block_token2] = ACTIONS(1801),
    [anon_sym__and_LT_LT] = ACTIONS(1801),
    [anon_sym__andif_LT_LT] = ACTIONS(1801),
    [anon_sym__or_LT_LT] = ACTIONS(1801),
    [anon_sym__orif_LT_LT] = ACTIONS(1801),
    [anon_sym__xor_LT_LT] = ACTIONS(1801),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1801),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym_STAR_LT_LT] = ACTIONS(1801),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1801),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym__mod_LT_LT] = ACTIONS(1801),
    [anon_sym__div_LT_LT] = ACTIONS(1801),
    [anon_sym_DASH_LT_LT] = ACTIONS(1801),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1801),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1801),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1801),
    [aux_sym_if_token3] = ACTIONS(1801),
    [aux_sym_elif_token1] = ACTIONS(1801),
    [aux_sym_else_token1] = ACTIONS(1801),
    [aux_sym_loop_token2] = ACTIONS(1801),
    [aux_sym_finally_token1] = ACTIONS(1801),
    [aux_sym_finally_token2] = ACTIONS(1903),
    [aux_sym_catch_token2] = ACTIONS(1801),
    [aux_sym_try_token2] = ACTIONS(1801),
    [aux_sym_try_token3] = ACTIONS(1801),
    [aux_sym_protect_token4] = ACTIONS(1801),
    [aux_sym_lock_token2] = ACTIONS(1801),
    [anon_sym_SEMI] = ACTIONS(1801),
    [sym_label] = ACTIONS(1905),
    [aux_sym_relational_operator_token1] = ACTIONS(1801),
    [aux_sym_relational_operator_token2] = ACTIONS(1801),
    [aux_sym_relational_operator_token3] = ACTIONS(1801),
    [anon_sym_EQ] = ACTIONS(1801),
    [anon_sym_TILDE_EQ] = ACTIONS(1801),
    [anon_sym_LT_GT] = ACTIONS(1801),
    [anon_sym_GT_EQ] = ACTIONS(1801),
    [anon_sym_LT_EQ] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT] = ACTIONS(1801),
    [aux_sym_logical_operator_token1] = ACTIONS(1801),
    [aux_sym_logical_operator_token2] = ACTIONS(1801),
    [aux_sym_logical_operator_token3] = ACTIONS(1801),
    [aux_sym_logical_operator_token4] = ACTIONS(1801),
    [aux_sym_logical_operator_token5] = ACTIONS(1801),
    [aux_sym_logical_operator_token6] = ACTIONS(1801),
    [anon_sym_STAR_STAR] = ACTIONS(1801),
    [anon_sym_STAR] = ACTIONS(1801),
    [anon_sym_SLASH] = ACTIONS(1801),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1801),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1801),
    [anon_sym_DASH] = ACTIONS(1801),
    [anon_sym_PLUS] = ACTIONS(1801),
    [sym_comment] = ACTIONS(3),
  },
  [529] = {
    [anon_sym_CR] = ACTIONS(1907),
    [anon_sym_LF] = ACTIONS(1907),
    [anon_sym_DOT] = ACTIONS(1907),
    [anon_sym_LPAREN] = ACTIONS(1907),
    [anon_sym_COMMA] = ACTIONS(1907),
    [anon_sym_LT_LT] = ACTIONS(1907),
    [anon_sym_CARET_LT_LT] = ACTIONS(1907),
    [anon_sym_LBRACK] = ACTIONS(1907),
    [aux_sym_method_token7] = ACTIONS(1907),
    [aux_sym_procedure_token2] = ACTIONS(1907),
    [aux_sym_block_token2] = ACTIONS(1907),
    [anon_sym__and_LT_LT] = ACTIONS(1907),
    [anon_sym__andif_LT_LT] = ACTIONS(1907),
    [anon_sym__or_LT_LT] = ACTIONS(1907),
    [anon_sym__orif_LT_LT] = ACTIONS(1907),
    [anon_sym__xor_LT_LT] = ACTIONS(1907),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1907),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1907),
    [anon_sym_STAR_LT_LT] = ACTIONS(1907),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1907),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1907),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1907),
    [anon_sym__mod_LT_LT] = ACTIONS(1907),
    [anon_sym__div_LT_LT] = ACTIONS(1907),
    [anon_sym_DASH_LT_LT] = ACTIONS(1907),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1907),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1907),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1907),
    [aux_sym_if_token3] = ACTIONS(1907),
    [aux_sym_elif_token1] = ACTIONS(1907),
    [aux_sym_else_token1] = ACTIONS(1907),
    [aux_sym_loop_token2] = ACTIONS(1907),
    [aux_sym_finally_token1] = ACTIONS(1907),
    [aux_sym_finally_token2] = ACTIONS(1907),
    [aux_sym_catch_token2] = ACTIONS(1907),
    [aux_sym_try_token2] = ACTIONS(1907),
    [aux_sym_try_token3] = ACTIONS(1907),
    [aux_sym_protect_token3] = ACTIONS(1907),
    [aux_sym_protect_token4] = ACTIONS(1907),
    [aux_sym_lock_token2] = ACTIONS(1907),
    [anon_sym_SEMI] = ACTIONS(1907),
    [aux_sym_relational_operator_token1] = ACTIONS(1907),
    [aux_sym_relational_operator_token2] = ACTIONS(1907),
    [aux_sym_relational_operator_token3] = ACTIONS(1907),
    [anon_sym_EQ] = ACTIONS(1907),
    [anon_sym_TILDE_EQ] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(1907),
    [anon_sym_GT_EQ] = ACTIONS(1907),
    [anon_sym_LT_EQ] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_GT] = ACTIONS(1907),
    [aux_sym_logical_operator_token1] = ACTIONS(1907),
    [aux_sym_logical_operator_token2] = ACTIONS(1907),
    [aux_sym_logical_operator_token3] = ACTIONS(1907),
    [aux_sym_logical_operator_token4] = ACTIONS(1907),
    [aux_sym_logical_operator_token5] = ACTIONS(1907),
    [aux_sym_logical_operator_token6] = ACTIONS(1907),
    [anon_sym_STAR_STAR] = ACTIONS(1907),
    [anon_sym_STAR] = ACTIONS(1907),
    [anon_sym_SLASH] = ACTIONS(1907),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1907),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1907),
    [anon_sym_DASH] = ACTIONS(1907),
    [anon_sym_PLUS] = ACTIONS(1907),
    [sym_comment] = ACTIONS(3),
  },
  [530] = {
    [anon_sym_CR] = ACTIONS(1909),
    [anon_sym_LF] = ACTIONS(1909),
    [anon_sym_DOT] = ACTIONS(1909),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_COMMA] = ACTIONS(1909),
    [anon_sym_LT_LT] = ACTIONS(1909),
    [anon_sym_CARET_LT_LT] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [aux_sym_method_token7] = ACTIONS(1909),
    [aux_sym_procedure_token2] = ACTIONS(1909),
    [aux_sym_block_token2] = ACTIONS(1909),
    [anon_sym__and_LT_LT] = ACTIONS(1909),
    [anon_sym__andif_LT_LT] = ACTIONS(1909),
    [anon_sym__or_LT_LT] = ACTIONS(1909),
    [anon_sym__orif_LT_LT] = ACTIONS(1909),
    [anon_sym__xor_LT_LT] = ACTIONS(1909),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1909),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1909),
    [anon_sym_STAR_LT_LT] = ACTIONS(1909),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1909),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1909),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1909),
    [anon_sym__mod_LT_LT] = ACTIONS(1909),
    [anon_sym__div_LT_LT] = ACTIONS(1909),
    [anon_sym_DASH_LT_LT] = ACTIONS(1909),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1909),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1909),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1909),
    [aux_sym_if_token3] = ACTIONS(1909),
    [aux_sym_elif_token1] = ACTIONS(1909),
    [aux_sym_else_token1] = ACTIONS(1909),
    [aux_sym_loop_token2] = ACTIONS(1909),
    [aux_sym_finally_token1] = ACTIONS(1909),
    [aux_sym_finally_token2] = ACTIONS(1909),
    [aux_sym_catch_token2] = ACTIONS(1909),
    [aux_sym_try_token2] = ACTIONS(1909),
    [aux_sym_try_token3] = ACTIONS(1909),
    [aux_sym_protect_token3] = ACTIONS(1909),
    [aux_sym_protect_token4] = ACTIONS(1909),
    [aux_sym_lock_token2] = ACTIONS(1909),
    [anon_sym_SEMI] = ACTIONS(1909),
    [aux_sym_relational_operator_token1] = ACTIONS(1909),
    [aux_sym_relational_operator_token2] = ACTIONS(1909),
    [aux_sym_relational_operator_token3] = ACTIONS(1909),
    [anon_sym_EQ] = ACTIONS(1909),
    [anon_sym_TILDE_EQ] = ACTIONS(1909),
    [anon_sym_LT_GT] = ACTIONS(1909),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_LT_EQ] = ACTIONS(1909),
    [anon_sym_LT] = ACTIONS(1909),
    [anon_sym_GT] = ACTIONS(1909),
    [aux_sym_logical_operator_token1] = ACTIONS(1909),
    [aux_sym_logical_operator_token2] = ACTIONS(1909),
    [aux_sym_logical_operator_token3] = ACTIONS(1909),
    [aux_sym_logical_operator_token4] = ACTIONS(1909),
    [aux_sym_logical_operator_token5] = ACTIONS(1909),
    [aux_sym_logical_operator_token6] = ACTIONS(1909),
    [anon_sym_STAR_STAR] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_SLASH] = ACTIONS(1909),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1909),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PLUS] = ACTIONS(1909),
    [sym_comment] = ACTIONS(3),
  },
  [531] = {
    [anon_sym_CR] = ACTIONS(1911),
    [anon_sym_LF] = ACTIONS(1911),
    [anon_sym_DOT] = ACTIONS(1911),
    [anon_sym_LPAREN] = ACTIONS(1911),
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_LT_LT] = ACTIONS(1911),
    [anon_sym_CARET_LT_LT] = ACTIONS(1911),
    [anon_sym_LBRACK] = ACTIONS(1911),
    [aux_sym_method_token7] = ACTIONS(1911),
    [aux_sym_procedure_token2] = ACTIONS(1911),
    [aux_sym_block_token2] = ACTIONS(1911),
    [anon_sym__and_LT_LT] = ACTIONS(1911),
    [anon_sym__andif_LT_LT] = ACTIONS(1911),
    [anon_sym__or_LT_LT] = ACTIONS(1911),
    [anon_sym__orif_LT_LT] = ACTIONS(1911),
    [anon_sym__xor_LT_LT] = ACTIONS(1911),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1911),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1911),
    [anon_sym_STAR_LT_LT] = ACTIONS(1911),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1911),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1911),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1911),
    [anon_sym__mod_LT_LT] = ACTIONS(1911),
    [anon_sym__div_LT_LT] = ACTIONS(1911),
    [anon_sym_DASH_LT_LT] = ACTIONS(1911),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1911),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1911),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1911),
    [aux_sym_if_token3] = ACTIONS(1911),
    [aux_sym_elif_token1] = ACTIONS(1911),
    [aux_sym_else_token1] = ACTIONS(1911),
    [aux_sym_loop_token2] = ACTIONS(1911),
    [aux_sym_finally_token1] = ACTIONS(1911),
    [aux_sym_finally_token2] = ACTIONS(1911),
    [aux_sym_catch_token2] = ACTIONS(1911),
    [aux_sym_try_token2] = ACTIONS(1911),
    [aux_sym_try_token3] = ACTIONS(1911),
    [aux_sym_protect_token3] = ACTIONS(1911),
    [aux_sym_protect_token4] = ACTIONS(1911),
    [aux_sym_lock_token2] = ACTIONS(1911),
    [anon_sym_SEMI] = ACTIONS(1911),
    [aux_sym_relational_operator_token1] = ACTIONS(1911),
    [aux_sym_relational_operator_token2] = ACTIONS(1911),
    [aux_sym_relational_operator_token3] = ACTIONS(1911),
    [anon_sym_EQ] = ACTIONS(1911),
    [anon_sym_TILDE_EQ] = ACTIONS(1911),
    [anon_sym_LT_GT] = ACTIONS(1911),
    [anon_sym_GT_EQ] = ACTIONS(1911),
    [anon_sym_LT_EQ] = ACTIONS(1911),
    [anon_sym_LT] = ACTIONS(1911),
    [anon_sym_GT] = ACTIONS(1911),
    [aux_sym_logical_operator_token1] = ACTIONS(1911),
    [aux_sym_logical_operator_token2] = ACTIONS(1911),
    [aux_sym_logical_operator_token3] = ACTIONS(1911),
    [aux_sym_logical_operator_token4] = ACTIONS(1911),
    [aux_sym_logical_operator_token5] = ACTIONS(1911),
    [aux_sym_logical_operator_token6] = ACTIONS(1911),
    [anon_sym_STAR_STAR] = ACTIONS(1911),
    [anon_sym_STAR] = ACTIONS(1911),
    [anon_sym_SLASH] = ACTIONS(1911),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1911),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1911),
    [anon_sym_DASH] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1911),
    [sym_comment] = ACTIONS(3),
  },
  [532] = {
    [anon_sym_CR] = ACTIONS(1913),
    [anon_sym_LF] = ACTIONS(1913),
    [anon_sym_DOT] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1913),
    [anon_sym_COMMA] = ACTIONS(1913),
    [anon_sym_LT_LT] = ACTIONS(1913),
    [anon_sym_CARET_LT_LT] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [aux_sym_method_token7] = ACTIONS(1913),
    [aux_sym_procedure_token2] = ACTIONS(1913),
    [aux_sym_block_token2] = ACTIONS(1913),
    [anon_sym__and_LT_LT] = ACTIONS(1913),
    [anon_sym__andif_LT_LT] = ACTIONS(1913),
    [anon_sym__or_LT_LT] = ACTIONS(1913),
    [anon_sym__orif_LT_LT] = ACTIONS(1913),
    [anon_sym__xor_LT_LT] = ACTIONS(1913),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1913),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1913),
    [anon_sym_STAR_LT_LT] = ACTIONS(1913),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1913),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1913),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1913),
    [anon_sym__mod_LT_LT] = ACTIONS(1913),
    [anon_sym__div_LT_LT] = ACTIONS(1913),
    [anon_sym_DASH_LT_LT] = ACTIONS(1913),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1913),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1913),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1913),
    [aux_sym_if_token3] = ACTIONS(1913),
    [aux_sym_elif_token1] = ACTIONS(1913),
    [aux_sym_else_token1] = ACTIONS(1913),
    [aux_sym_loop_token2] = ACTIONS(1913),
    [aux_sym_finally_token1] = ACTIONS(1913),
    [aux_sym_finally_token2] = ACTIONS(1913),
    [aux_sym_catch_token2] = ACTIONS(1913),
    [aux_sym_try_token2] = ACTIONS(1913),
    [aux_sym_try_token3] = ACTIONS(1913),
    [aux_sym_protect_token3] = ACTIONS(1913),
    [aux_sym_protect_token4] = ACTIONS(1913),
    [aux_sym_lock_token2] = ACTIONS(1913),
    [anon_sym_SEMI] = ACTIONS(1913),
    [aux_sym_relational_operator_token1] = ACTIONS(1913),
    [aux_sym_relational_operator_token2] = ACTIONS(1913),
    [aux_sym_relational_operator_token3] = ACTIONS(1913),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_TILDE_EQ] = ACTIONS(1913),
    [anon_sym_LT_GT] = ACTIONS(1913),
    [anon_sym_GT_EQ] = ACTIONS(1913),
    [anon_sym_LT_EQ] = ACTIONS(1913),
    [anon_sym_LT] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(1913),
    [aux_sym_logical_operator_token1] = ACTIONS(1913),
    [aux_sym_logical_operator_token2] = ACTIONS(1913),
    [aux_sym_logical_operator_token3] = ACTIONS(1913),
    [aux_sym_logical_operator_token4] = ACTIONS(1913),
    [aux_sym_logical_operator_token5] = ACTIONS(1913),
    [aux_sym_logical_operator_token6] = ACTIONS(1913),
    [anon_sym_STAR_STAR] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1913),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1913),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PLUS] = ACTIONS(1913),
    [sym_comment] = ACTIONS(3),
  },
  [533] = {
    [anon_sym_CR] = ACTIONS(1915),
    [anon_sym_LF] = ACTIONS(1915),
    [anon_sym_DOT] = ACTIONS(1915),
    [anon_sym_LPAREN] = ACTIONS(1915),
    [anon_sym_COMMA] = ACTIONS(1915),
    [anon_sym_LT_LT] = ACTIONS(1915),
    [anon_sym_CARET_LT_LT] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(1915),
    [aux_sym_method_token7] = ACTIONS(1915),
    [aux_sym_procedure_token2] = ACTIONS(1915),
    [aux_sym_block_token2] = ACTIONS(1915),
    [anon_sym__and_LT_LT] = ACTIONS(1915),
    [anon_sym__andif_LT_LT] = ACTIONS(1915),
    [anon_sym__or_LT_LT] = ACTIONS(1915),
    [anon_sym__orif_LT_LT] = ACTIONS(1915),
    [anon_sym__xor_LT_LT] = ACTIONS(1915),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1915),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1915),
    [anon_sym_STAR_LT_LT] = ACTIONS(1915),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1915),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1915),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1915),
    [anon_sym__mod_LT_LT] = ACTIONS(1915),
    [anon_sym__div_LT_LT] = ACTIONS(1915),
    [anon_sym_DASH_LT_LT] = ACTIONS(1915),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1915),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1915),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1915),
    [aux_sym_if_token3] = ACTIONS(1915),
    [aux_sym_elif_token1] = ACTIONS(1915),
    [aux_sym_else_token1] = ACTIONS(1915),
    [aux_sym_loop_token2] = ACTIONS(1915),
    [aux_sym_finally_token1] = ACTIONS(1915),
    [aux_sym_finally_token2] = ACTIONS(1915),
    [aux_sym_catch_token2] = ACTIONS(1915),
    [aux_sym_try_token2] = ACTIONS(1915),
    [aux_sym_try_token3] = ACTIONS(1915),
    [aux_sym_protect_token3] = ACTIONS(1915),
    [aux_sym_protect_token4] = ACTIONS(1915),
    [aux_sym_lock_token2] = ACTIONS(1915),
    [anon_sym_SEMI] = ACTIONS(1915),
    [aux_sym_relational_operator_token1] = ACTIONS(1915),
    [aux_sym_relational_operator_token2] = ACTIONS(1915),
    [aux_sym_relational_operator_token3] = ACTIONS(1915),
    [anon_sym_EQ] = ACTIONS(1915),
    [anon_sym_TILDE_EQ] = ACTIONS(1915),
    [anon_sym_LT_GT] = ACTIONS(1915),
    [anon_sym_GT_EQ] = ACTIONS(1915),
    [anon_sym_LT_EQ] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_GT] = ACTIONS(1915),
    [aux_sym_logical_operator_token1] = ACTIONS(1915),
    [aux_sym_logical_operator_token2] = ACTIONS(1915),
    [aux_sym_logical_operator_token3] = ACTIONS(1915),
    [aux_sym_logical_operator_token4] = ACTIONS(1915),
    [aux_sym_logical_operator_token5] = ACTIONS(1915),
    [aux_sym_logical_operator_token6] = ACTIONS(1915),
    [anon_sym_STAR_STAR] = ACTIONS(1915),
    [anon_sym_STAR] = ACTIONS(1915),
    [anon_sym_SLASH] = ACTIONS(1915),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1915),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1915),
    [anon_sym_DASH] = ACTIONS(1915),
    [anon_sym_PLUS] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
  },
  [534] = {
    [anon_sym_CR] = ACTIONS(1917),
    [anon_sym_LF] = ACTIONS(1917),
    [anon_sym_DOT] = ACTIONS(1917),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_LT_LT] = ACTIONS(1917),
    [anon_sym_CARET_LT_LT] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [aux_sym_method_token7] = ACTIONS(1917),
    [aux_sym_procedure_token2] = ACTIONS(1917),
    [aux_sym_block_token2] = ACTIONS(1917),
    [anon_sym__and_LT_LT] = ACTIONS(1917),
    [anon_sym__andif_LT_LT] = ACTIONS(1917),
    [anon_sym__or_LT_LT] = ACTIONS(1917),
    [anon_sym__orif_LT_LT] = ACTIONS(1917),
    [anon_sym__xor_LT_LT] = ACTIONS(1917),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1917),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1917),
    [anon_sym_STAR_LT_LT] = ACTIONS(1917),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1917),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1917),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1917),
    [anon_sym__mod_LT_LT] = ACTIONS(1917),
    [anon_sym__div_LT_LT] = ACTIONS(1917),
    [anon_sym_DASH_LT_LT] = ACTIONS(1917),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1917),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1917),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1917),
    [aux_sym_if_token3] = ACTIONS(1917),
    [aux_sym_elif_token1] = ACTIONS(1917),
    [aux_sym_else_token1] = ACTIONS(1917),
    [aux_sym_loop_token2] = ACTIONS(1917),
    [aux_sym_finally_token1] = ACTIONS(1917),
    [aux_sym_finally_token2] = ACTIONS(1917),
    [aux_sym_catch_token2] = ACTIONS(1917),
    [aux_sym_try_token2] = ACTIONS(1917),
    [aux_sym_try_token3] = ACTIONS(1917),
    [aux_sym_protect_token3] = ACTIONS(1917),
    [aux_sym_protect_token4] = ACTIONS(1917),
    [aux_sym_lock_token2] = ACTIONS(1917),
    [anon_sym_SEMI] = ACTIONS(1917),
    [aux_sym_relational_operator_token1] = ACTIONS(1917),
    [aux_sym_relational_operator_token2] = ACTIONS(1917),
    [aux_sym_relational_operator_token3] = ACTIONS(1917),
    [anon_sym_EQ] = ACTIONS(1917),
    [anon_sym_TILDE_EQ] = ACTIONS(1917),
    [anon_sym_LT_GT] = ACTIONS(1917),
    [anon_sym_GT_EQ] = ACTIONS(1917),
    [anon_sym_LT_EQ] = ACTIONS(1917),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_GT] = ACTIONS(1917),
    [aux_sym_logical_operator_token1] = ACTIONS(1917),
    [aux_sym_logical_operator_token2] = ACTIONS(1917),
    [aux_sym_logical_operator_token3] = ACTIONS(1917),
    [aux_sym_logical_operator_token4] = ACTIONS(1917),
    [aux_sym_logical_operator_token5] = ACTIONS(1917),
    [aux_sym_logical_operator_token6] = ACTIONS(1917),
    [anon_sym_STAR_STAR] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(1917),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1917),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1917),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_PLUS] = ACTIONS(1917),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(1825),
    [anon_sym_LF] = ACTIONS(1825),
    [anon_sym_DOT] = ACTIONS(1825),
    [anon_sym_LPAREN] = ACTIONS(1825),
    [anon_sym_COMMA] = ACTIONS(1825),
    [anon_sym_LT_LT] = ACTIONS(1825),
    [anon_sym_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym_LBRACK] = ACTIONS(1825),
    [aux_sym_method_token7] = ACTIONS(1825),
    [aux_sym_procedure_token2] = ACTIONS(1825),
    [aux_sym_block_token2] = ACTIONS(1825),
    [anon_sym__and_LT_LT] = ACTIONS(1825),
    [anon_sym__andif_LT_LT] = ACTIONS(1825),
    [anon_sym__or_LT_LT] = ACTIONS(1825),
    [anon_sym__orif_LT_LT] = ACTIONS(1825),
    [anon_sym__xor_LT_LT] = ACTIONS(1825),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1825),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym_STAR_LT_LT] = ACTIONS(1825),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1825),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym__mod_LT_LT] = ACTIONS(1825),
    [anon_sym__div_LT_LT] = ACTIONS(1825),
    [anon_sym_DASH_LT_LT] = ACTIONS(1825),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1825),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1825),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1825),
    [aux_sym_if_token3] = ACTIONS(1825),
    [aux_sym_elif_token1] = ACTIONS(1825),
    [aux_sym_else_token1] = ACTIONS(1825),
    [aux_sym_loop_token2] = ACTIONS(1825),
    [aux_sym_finally_token1] = ACTIONS(1825),
    [aux_sym_finally_token2] = ACTIONS(1825),
    [aux_sym_catch_token2] = ACTIONS(1825),
    [aux_sym_try_token2] = ACTIONS(1825),
    [aux_sym_try_token3] = ACTIONS(1825),
    [aux_sym_protect_token4] = ACTIONS(1825),
    [aux_sym_lock_token2] = ACTIONS(1825),
    [anon_sym_SEMI] = ACTIONS(1825),
    [aux_sym_relational_operator_token1] = ACTIONS(1825),
    [aux_sym_relational_operator_token2] = ACTIONS(1825),
    [aux_sym_relational_operator_token3] = ACTIONS(1825),
    [anon_sym_EQ] = ACTIONS(1825),
    [anon_sym_TILDE_EQ] = ACTIONS(1825),
    [anon_sym_LT_GT] = ACTIONS(1825),
    [anon_sym_GT_EQ] = ACTIONS(1825),
    [anon_sym_LT_EQ] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1825),
    [anon_sym_GT] = ACTIONS(1825),
    [aux_sym_logical_operator_token1] = ACTIONS(1825),
    [aux_sym_logical_operator_token2] = ACTIONS(1825),
    [aux_sym_logical_operator_token3] = ACTIONS(1825),
    [aux_sym_logical_operator_token4] = ACTIONS(1825),
    [aux_sym_logical_operator_token5] = ACTIONS(1825),
    [aux_sym_logical_operator_token6] = ACTIONS(1825),
    [anon_sym_STAR_STAR] = ACTIONS(1825),
    [anon_sym_STAR] = ACTIONS(1825),
    [anon_sym_SLASH] = ACTIONS(1825),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1825),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1825),
    [anon_sym_DASH] = ACTIONS(1825),
    [anon_sym_PLUS] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
  },
  [536] = {
    [aux_sym_loopbody_repeat1] = STATE(519),
    [anon_sym_CR] = ACTIONS(1919),
    [anon_sym_LF] = ACTIONS(1919),
    [anon_sym_DOT] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(1919),
    [aux_sym_procedure_token2] = ACTIONS(1919),
    [aux_sym_block_token2] = ACTIONS(1919),
    [anon_sym__and_LT_LT] = ACTIONS(1833),
    [anon_sym__andif_LT_LT] = ACTIONS(1833),
    [anon_sym__or_LT_LT] = ACTIONS(1833),
    [anon_sym__orif_LT_LT] = ACTIONS(1833),
    [anon_sym__xor_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym__mod_LT_LT] = ACTIONS(1833),
    [anon_sym__div_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1833),
    [aux_sym_if_token3] = ACTIONS(1919),
    [aux_sym_elif_token1] = ACTIONS(1919),
    [aux_sym_else_token1] = ACTIONS(1919),
    [aux_sym_loop_token2] = ACTIONS(1919),
    [aux_sym_finally_token1] = ACTIONS(1919),
    [aux_sym_finally_token2] = ACTIONS(1919),
    [aux_sym_catch_token2] = ACTIONS(1919),
    [aux_sym_try_token2] = ACTIONS(1919),
    [aux_sym_try_token3] = ACTIONS(1919),
    [aux_sym_protect_token4] = ACTIONS(1919),
    [aux_sym_lock_token2] = ACTIONS(1919),
    [anon_sym_SEMI] = ACTIONS(1919),
    [aux_sym_relational_operator_token1] = ACTIONS(1837),
    [aux_sym_relational_operator_token2] = ACTIONS(1837),
    [aux_sym_relational_operator_token3] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_TILDE_EQ] = ACTIONS(1837),
    [anon_sym_LT_GT] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_GT] = ACTIONS(1837),
    [aux_sym_logical_operator_token1] = ACTIONS(1839),
    [aux_sym_logical_operator_token2] = ACTIONS(1839),
    [aux_sym_logical_operator_token3] = ACTIONS(1839),
    [aux_sym_logical_operator_token4] = ACTIONS(1839),
    [aux_sym_logical_operator_token5] = ACTIONS(1839),
    [aux_sym_logical_operator_token6] = ACTIONS(1839),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
  },
  [537] = {
    [anon_sym_CR] = ACTIONS(1921),
    [anon_sym_LF] = ACTIONS(1921),
    [anon_sym_DOT] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_LT_LT] = ACTIONS(1921),
    [anon_sym_CARET_LT_LT] = ACTIONS(1921),
    [anon_sym_LBRACK] = ACTIONS(1921),
    [aux_sym_method_token7] = ACTIONS(1921),
    [aux_sym_procedure_token2] = ACTIONS(1921),
    [aux_sym_block_token2] = ACTIONS(1921),
    [anon_sym__and_LT_LT] = ACTIONS(1921),
    [anon_sym__andif_LT_LT] = ACTIONS(1921),
    [anon_sym__or_LT_LT] = ACTIONS(1921),
    [anon_sym__orif_LT_LT] = ACTIONS(1921),
    [anon_sym__xor_LT_LT] = ACTIONS(1921),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1921),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1921),
    [anon_sym_STAR_LT_LT] = ACTIONS(1921),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1921),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1921),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1921),
    [anon_sym__mod_LT_LT] = ACTIONS(1921),
    [anon_sym__div_LT_LT] = ACTIONS(1921),
    [anon_sym_DASH_LT_LT] = ACTIONS(1921),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1921),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1921),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1921),
    [aux_sym_if_token3] = ACTIONS(1921),
    [aux_sym_elif_token1] = ACTIONS(1921),
    [aux_sym_else_token1] = ACTIONS(1921),
    [aux_sym_loop_token2] = ACTIONS(1921),
    [aux_sym_finally_token1] = ACTIONS(1921),
    [aux_sym_finally_token2] = ACTIONS(1921),
    [aux_sym_catch_token2] = ACTIONS(1921),
    [aux_sym_try_token2] = ACTIONS(1921),
    [aux_sym_try_token3] = ACTIONS(1921),
    [aux_sym_protect_token3] = ACTIONS(1921),
    [aux_sym_protect_token4] = ACTIONS(1921),
    [aux_sym_lock_token2] = ACTIONS(1921),
    [anon_sym_SEMI] = ACTIONS(1921),
    [aux_sym_relational_operator_token1] = ACTIONS(1921),
    [aux_sym_relational_operator_token2] = ACTIONS(1921),
    [aux_sym_relational_operator_token3] = ACTIONS(1921),
    [anon_sym_EQ] = ACTIONS(1921),
    [anon_sym_TILDE_EQ] = ACTIONS(1921),
    [anon_sym_LT_GT] = ACTIONS(1921),
    [anon_sym_GT_EQ] = ACTIONS(1921),
    [anon_sym_LT_EQ] = ACTIONS(1921),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_GT] = ACTIONS(1921),
    [aux_sym_logical_operator_token1] = ACTIONS(1921),
    [aux_sym_logical_operator_token2] = ACTIONS(1921),
    [aux_sym_logical_operator_token3] = ACTIONS(1921),
    [aux_sym_logical_operator_token4] = ACTIONS(1921),
    [aux_sym_logical_operator_token5] = ACTIONS(1921),
    [aux_sym_logical_operator_token6] = ACTIONS(1921),
    [anon_sym_STAR_STAR] = ACTIONS(1921),
    [anon_sym_STAR] = ACTIONS(1921),
    [anon_sym_SLASH] = ACTIONS(1921),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1921),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1921),
    [anon_sym_PLUS] = ACTIONS(1921),
    [sym_comment] = ACTIONS(3),
  },
  [538] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(1845),
    [anon_sym_LF] = ACTIONS(1845),
    [anon_sym_DOT] = ACTIONS(1845),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_COMMA] = ACTIONS(1845),
    [anon_sym_LT_LT] = ACTIONS(1845),
    [anon_sym_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym_LBRACK] = ACTIONS(1845),
    [aux_sym_method_token7] = ACTIONS(1845),
    [aux_sym_procedure_token2] = ACTIONS(1845),
    [aux_sym_block_token2] = ACTIONS(1845),
    [anon_sym__and_LT_LT] = ACTIONS(1845),
    [anon_sym__andif_LT_LT] = ACTIONS(1845),
    [anon_sym__or_LT_LT] = ACTIONS(1845),
    [anon_sym__orif_LT_LT] = ACTIONS(1845),
    [anon_sym__xor_LT_LT] = ACTIONS(1845),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1845),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym_STAR_LT_LT] = ACTIONS(1845),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1845),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym__mod_LT_LT] = ACTIONS(1845),
    [anon_sym__div_LT_LT] = ACTIONS(1845),
    [anon_sym_DASH_LT_LT] = ACTIONS(1845),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1845),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1845),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1845),
    [aux_sym_if_token3] = ACTIONS(1845),
    [aux_sym_elif_token1] = ACTIONS(1845),
    [aux_sym_else_token1] = ACTIONS(1845),
    [aux_sym_loop_token2] = ACTIONS(1845),
    [aux_sym_finally_token1] = ACTIONS(1845),
    [aux_sym_finally_token2] = ACTIONS(1845),
    [aux_sym_catch_token2] = ACTIONS(1845),
    [aux_sym_try_token2] = ACTIONS(1845),
    [aux_sym_try_token3] = ACTIONS(1845),
    [aux_sym_protect_token4] = ACTIONS(1845),
    [aux_sym_lock_token2] = ACTIONS(1845),
    [anon_sym_SEMI] = ACTIONS(1845),
    [aux_sym_relational_operator_token1] = ACTIONS(1845),
    [aux_sym_relational_operator_token2] = ACTIONS(1845),
    [aux_sym_relational_operator_token3] = ACTIONS(1845),
    [anon_sym_EQ] = ACTIONS(1845),
    [anon_sym_TILDE_EQ] = ACTIONS(1845),
    [anon_sym_LT_GT] = ACTIONS(1845),
    [anon_sym_GT_EQ] = ACTIONS(1845),
    [anon_sym_LT_EQ] = ACTIONS(1845),
    [anon_sym_LT] = ACTIONS(1845),
    [anon_sym_GT] = ACTIONS(1845),
    [aux_sym_logical_operator_token1] = ACTIONS(1845),
    [aux_sym_logical_operator_token2] = ACTIONS(1845),
    [aux_sym_logical_operator_token3] = ACTIONS(1845),
    [aux_sym_logical_operator_token4] = ACTIONS(1845),
    [aux_sym_logical_operator_token5] = ACTIONS(1845),
    [aux_sym_logical_operator_token6] = ACTIONS(1845),
    [anon_sym_STAR_STAR] = ACTIONS(1845),
    [anon_sym_STAR] = ACTIONS(1845),
    [anon_sym_SLASH] = ACTIONS(1845),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1845),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1845),
    [anon_sym_DASH] = ACTIONS(1845),
    [anon_sym_PLUS] = ACTIONS(1845),
    [sym_comment] = ACTIONS(3),
  },
  [539] = {
    [anon_sym_CR] = ACTIONS(1923),
    [anon_sym_LF] = ACTIONS(1923),
    [anon_sym_DOT] = ACTIONS(1923),
    [anon_sym_LPAREN] = ACTIONS(1923),
    [anon_sym_COMMA] = ACTIONS(1923),
    [anon_sym_LT_LT] = ACTIONS(1923),
    [anon_sym_CARET_LT_LT] = ACTIONS(1923),
    [anon_sym_LBRACK] = ACTIONS(1923),
    [aux_sym_method_token7] = ACTIONS(1923),
    [aux_sym_procedure_token2] = ACTIONS(1923),
    [aux_sym_block_token2] = ACTIONS(1923),
    [anon_sym__and_LT_LT] = ACTIONS(1923),
    [anon_sym__andif_LT_LT] = ACTIONS(1923),
    [anon_sym__or_LT_LT] = ACTIONS(1923),
    [anon_sym__orif_LT_LT] = ACTIONS(1923),
    [anon_sym__xor_LT_LT] = ACTIONS(1923),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1923),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1923),
    [anon_sym_STAR_LT_LT] = ACTIONS(1923),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1923),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1923),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1923),
    [anon_sym__mod_LT_LT] = ACTIONS(1923),
    [anon_sym__div_LT_LT] = ACTIONS(1923),
    [anon_sym_DASH_LT_LT] = ACTIONS(1923),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1923),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1923),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1923),
    [aux_sym_if_token3] = ACTIONS(1923),
    [aux_sym_elif_token1] = ACTIONS(1923),
    [aux_sym_else_token1] = ACTIONS(1923),
    [aux_sym_loop_token2] = ACTIONS(1923),
    [aux_sym_finally_token1] = ACTIONS(1923),
    [aux_sym_finally_token2] = ACTIONS(1923),
    [aux_sym_catch_token2] = ACTIONS(1923),
    [aux_sym_try_token2] = ACTIONS(1923),
    [aux_sym_try_token3] = ACTIONS(1923),
    [aux_sym_protect_token3] = ACTIONS(1923),
    [aux_sym_protect_token4] = ACTIONS(1923),
    [aux_sym_lock_token2] = ACTIONS(1923),
    [anon_sym_SEMI] = ACTIONS(1923),
    [aux_sym_relational_operator_token1] = ACTIONS(1923),
    [aux_sym_relational_operator_token2] = ACTIONS(1923),
    [aux_sym_relational_operator_token3] = ACTIONS(1923),
    [anon_sym_EQ] = ACTIONS(1923),
    [anon_sym_TILDE_EQ] = ACTIONS(1923),
    [anon_sym_LT_GT] = ACTIONS(1923),
    [anon_sym_GT_EQ] = ACTIONS(1923),
    [anon_sym_LT_EQ] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1923),
    [anon_sym_GT] = ACTIONS(1923),
    [aux_sym_logical_operator_token1] = ACTIONS(1923),
    [aux_sym_logical_operator_token2] = ACTIONS(1923),
    [aux_sym_logical_operator_token3] = ACTIONS(1923),
    [aux_sym_logical_operator_token4] = ACTIONS(1923),
    [aux_sym_logical_operator_token5] = ACTIONS(1923),
    [aux_sym_logical_operator_token6] = ACTIONS(1923),
    [anon_sym_STAR_STAR] = ACTIONS(1923),
    [anon_sym_STAR] = ACTIONS(1923),
    [anon_sym_SLASH] = ACTIONS(1923),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1923),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1923),
    [anon_sym_DASH] = ACTIONS(1923),
    [anon_sym_PLUS] = ACTIONS(1923),
    [sym_comment] = ACTIONS(3),
  },
  [540] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(1861),
    [anon_sym_LF] = ACTIONS(1861),
    [anon_sym_DOT] = ACTIONS(1861),
    [anon_sym_LPAREN] = ACTIONS(1861),
    [anon_sym_COMMA] = ACTIONS(1861),
    [anon_sym_LT_LT] = ACTIONS(1861),
    [anon_sym_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [aux_sym_method_token7] = ACTIONS(1861),
    [aux_sym_procedure_token2] = ACTIONS(1861),
    [aux_sym_block_token2] = ACTIONS(1861),
    [anon_sym__and_LT_LT] = ACTIONS(1861),
    [anon_sym__andif_LT_LT] = ACTIONS(1861),
    [anon_sym__or_LT_LT] = ACTIONS(1861),
    [anon_sym__orif_LT_LT] = ACTIONS(1861),
    [anon_sym__xor_LT_LT] = ACTIONS(1861),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1861),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym_STAR_LT_LT] = ACTIONS(1861),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1861),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym__mod_LT_LT] = ACTIONS(1861),
    [anon_sym__div_LT_LT] = ACTIONS(1861),
    [anon_sym_DASH_LT_LT] = ACTIONS(1861),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1861),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1861),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1861),
    [aux_sym_if_token3] = ACTIONS(1861),
    [aux_sym_elif_token1] = ACTIONS(1861),
    [aux_sym_else_token1] = ACTIONS(1861),
    [aux_sym_loop_token2] = ACTIONS(1861),
    [aux_sym_finally_token1] = ACTIONS(1861),
    [aux_sym_finally_token2] = ACTIONS(1861),
    [aux_sym_catch_token2] = ACTIONS(1861),
    [aux_sym_try_token2] = ACTIONS(1861),
    [aux_sym_try_token3] = ACTIONS(1861),
    [aux_sym_protect_token4] = ACTIONS(1861),
    [aux_sym_lock_token2] = ACTIONS(1861),
    [anon_sym_SEMI] = ACTIONS(1861),
    [aux_sym_relational_operator_token1] = ACTIONS(1861),
    [aux_sym_relational_operator_token2] = ACTIONS(1861),
    [aux_sym_relational_operator_token3] = ACTIONS(1861),
    [anon_sym_EQ] = ACTIONS(1861),
    [anon_sym_TILDE_EQ] = ACTIONS(1861),
    [anon_sym_LT_GT] = ACTIONS(1861),
    [anon_sym_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_EQ] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1861),
    [anon_sym_GT] = ACTIONS(1861),
    [aux_sym_logical_operator_token1] = ACTIONS(1861),
    [aux_sym_logical_operator_token2] = ACTIONS(1861),
    [aux_sym_logical_operator_token3] = ACTIONS(1861),
    [aux_sym_logical_operator_token4] = ACTIONS(1861),
    [aux_sym_logical_operator_token5] = ACTIONS(1861),
    [aux_sym_logical_operator_token6] = ACTIONS(1861),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_STAR] = ACTIONS(1861),
    [anon_sym_SLASH] = ACTIONS(1861),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1861),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1861),
    [anon_sym_PLUS] = ACTIONS(1861),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(1859),
    [anon_sym_LF] = ACTIONS(1859),
    [anon_sym_DOT] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_COMMA] = ACTIONS(1859),
    [anon_sym_LT_LT] = ACTIONS(1859),
    [anon_sym_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [aux_sym_method_token7] = ACTIONS(1859),
    [aux_sym_procedure_token2] = ACTIONS(1859),
    [aux_sym_block_token2] = ACTIONS(1859),
    [anon_sym__and_LT_LT] = ACTIONS(1859),
    [anon_sym__andif_LT_LT] = ACTIONS(1859),
    [anon_sym__or_LT_LT] = ACTIONS(1859),
    [anon_sym__orif_LT_LT] = ACTIONS(1859),
    [anon_sym__xor_LT_LT] = ACTIONS(1859),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1859),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym_STAR_LT_LT] = ACTIONS(1859),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1859),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym__mod_LT_LT] = ACTIONS(1859),
    [anon_sym__div_LT_LT] = ACTIONS(1859),
    [anon_sym_DASH_LT_LT] = ACTIONS(1859),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1859),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1859),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1859),
    [aux_sym_if_token3] = ACTIONS(1859),
    [aux_sym_elif_token1] = ACTIONS(1859),
    [aux_sym_else_token1] = ACTIONS(1859),
    [aux_sym_loop_token2] = ACTIONS(1859),
    [aux_sym_finally_token1] = ACTIONS(1859),
    [aux_sym_finally_token2] = ACTIONS(1859),
    [aux_sym_catch_token2] = ACTIONS(1859),
    [aux_sym_try_token2] = ACTIONS(1859),
    [aux_sym_try_token3] = ACTIONS(1859),
    [aux_sym_protect_token4] = ACTIONS(1859),
    [aux_sym_lock_token2] = ACTIONS(1859),
    [anon_sym_SEMI] = ACTIONS(1859),
    [aux_sym_relational_operator_token1] = ACTIONS(1859),
    [aux_sym_relational_operator_token2] = ACTIONS(1859),
    [aux_sym_relational_operator_token3] = ACTIONS(1859),
    [anon_sym_EQ] = ACTIONS(1859),
    [anon_sym_TILDE_EQ] = ACTIONS(1859),
    [anon_sym_LT_GT] = ACTIONS(1859),
    [anon_sym_GT_EQ] = ACTIONS(1859),
    [anon_sym_LT_EQ] = ACTIONS(1859),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_GT] = ACTIONS(1859),
    [aux_sym_logical_operator_token1] = ACTIONS(1859),
    [aux_sym_logical_operator_token2] = ACTIONS(1859),
    [aux_sym_logical_operator_token3] = ACTIONS(1859),
    [aux_sym_logical_operator_token4] = ACTIONS(1859),
    [aux_sym_logical_operator_token5] = ACTIONS(1859),
    [aux_sym_logical_operator_token6] = ACTIONS(1859),
    [anon_sym_STAR_STAR] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_SLASH] = ACTIONS(1859),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1859),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_PLUS] = ACTIONS(1859),
    [sym_comment] = ACTIONS(3),
  },
  [542] = {
    [aux_sym_loopbody_repeat1] = STATE(517),
    [anon_sym_CR] = ACTIONS(1925),
    [anon_sym_LF] = ACTIONS(1925),
    [anon_sym_DOT] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(1925),
    [aux_sym_procedure_token2] = ACTIONS(1925),
    [aux_sym_block_token2] = ACTIONS(1925),
    [anon_sym__and_LT_LT] = ACTIONS(1833),
    [anon_sym__andif_LT_LT] = ACTIONS(1833),
    [anon_sym__or_LT_LT] = ACTIONS(1833),
    [anon_sym__orif_LT_LT] = ACTIONS(1833),
    [anon_sym__xor_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym__mod_LT_LT] = ACTIONS(1833),
    [anon_sym__div_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1833),
    [aux_sym_if_token3] = ACTIONS(1925),
    [aux_sym_elif_token1] = ACTIONS(1925),
    [aux_sym_else_token1] = ACTIONS(1925),
    [aux_sym_loop_token2] = ACTIONS(1925),
    [aux_sym_finally_token1] = ACTIONS(1925),
    [aux_sym_finally_token2] = ACTIONS(1925),
    [aux_sym_catch_token2] = ACTIONS(1925),
    [aux_sym_try_token2] = ACTIONS(1925),
    [aux_sym_try_token3] = ACTIONS(1925),
    [aux_sym_protect_token4] = ACTIONS(1925),
    [aux_sym_lock_token2] = ACTIONS(1925),
    [anon_sym_SEMI] = ACTIONS(1925),
    [aux_sym_relational_operator_token1] = ACTIONS(1837),
    [aux_sym_relational_operator_token2] = ACTIONS(1837),
    [aux_sym_relational_operator_token3] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_TILDE_EQ] = ACTIONS(1837),
    [anon_sym_LT_GT] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_GT] = ACTIONS(1837),
    [aux_sym_logical_operator_token1] = ACTIONS(1839),
    [aux_sym_logical_operator_token2] = ACTIONS(1839),
    [aux_sym_logical_operator_token3] = ACTIONS(1839),
    [aux_sym_logical_operator_token4] = ACTIONS(1839),
    [aux_sym_logical_operator_token5] = ACTIONS(1839),
    [aux_sym_logical_operator_token6] = ACTIONS(1839),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
  },
  [543] = {
    [anon_sym_CR] = ACTIONS(1927),
    [anon_sym_LF] = ACTIONS(1927),
    [anon_sym_DOT] = ACTIONS(1927),
    [anon_sym_LPAREN] = ACTIONS(1927),
    [anon_sym_COMMA] = ACTIONS(1927),
    [anon_sym_LT_LT] = ACTIONS(1927),
    [anon_sym_CARET_LT_LT] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(1927),
    [aux_sym_method_token7] = ACTIONS(1927),
    [aux_sym_procedure_token2] = ACTIONS(1927),
    [aux_sym_block_token2] = ACTIONS(1927),
    [anon_sym__and_LT_LT] = ACTIONS(1927),
    [anon_sym__andif_LT_LT] = ACTIONS(1927),
    [anon_sym__or_LT_LT] = ACTIONS(1927),
    [anon_sym__orif_LT_LT] = ACTIONS(1927),
    [anon_sym__xor_LT_LT] = ACTIONS(1927),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1927),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1927),
    [anon_sym_STAR_LT_LT] = ACTIONS(1927),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1927),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1927),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1927),
    [anon_sym__mod_LT_LT] = ACTIONS(1927),
    [anon_sym__div_LT_LT] = ACTIONS(1927),
    [anon_sym_DASH_LT_LT] = ACTIONS(1927),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1927),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1927),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1927),
    [aux_sym_if_token3] = ACTIONS(1927),
    [aux_sym_elif_token1] = ACTIONS(1927),
    [aux_sym_else_token1] = ACTIONS(1927),
    [aux_sym_loop_token2] = ACTIONS(1927),
    [aux_sym_finally_token1] = ACTIONS(1927),
    [aux_sym_finally_token2] = ACTIONS(1927),
    [aux_sym_catch_token2] = ACTIONS(1927),
    [aux_sym_try_token2] = ACTIONS(1927),
    [aux_sym_try_token3] = ACTIONS(1927),
    [aux_sym_protect_token3] = ACTIONS(1927),
    [aux_sym_protect_token4] = ACTIONS(1927),
    [aux_sym_lock_token2] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(1927),
    [aux_sym_relational_operator_token1] = ACTIONS(1927),
    [aux_sym_relational_operator_token2] = ACTIONS(1927),
    [aux_sym_relational_operator_token3] = ACTIONS(1927),
    [anon_sym_EQ] = ACTIONS(1927),
    [anon_sym_TILDE_EQ] = ACTIONS(1927),
    [anon_sym_LT_GT] = ACTIONS(1927),
    [anon_sym_GT_EQ] = ACTIONS(1927),
    [anon_sym_LT_EQ] = ACTIONS(1927),
    [anon_sym_LT] = ACTIONS(1927),
    [anon_sym_GT] = ACTIONS(1927),
    [aux_sym_logical_operator_token1] = ACTIONS(1927),
    [aux_sym_logical_operator_token2] = ACTIONS(1927),
    [aux_sym_logical_operator_token3] = ACTIONS(1927),
    [aux_sym_logical_operator_token4] = ACTIONS(1927),
    [aux_sym_logical_operator_token5] = ACTIONS(1927),
    [aux_sym_logical_operator_token6] = ACTIONS(1927),
    [anon_sym_STAR_STAR] = ACTIONS(1927),
    [anon_sym_STAR] = ACTIONS(1927),
    [anon_sym_SLASH] = ACTIONS(1927),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1927),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1927),
    [anon_sym_DASH] = ACTIONS(1927),
    [anon_sym_PLUS] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
  },
  [544] = {
    [anon_sym_CR] = ACTIONS(1929),
    [anon_sym_LF] = ACTIONS(1929),
    [anon_sym_DOT] = ACTIONS(1929),
    [anon_sym_LPAREN] = ACTIONS(1929),
    [anon_sym_COMMA] = ACTIONS(1929),
    [anon_sym_LT_LT] = ACTIONS(1929),
    [anon_sym_CARET_LT_LT] = ACTIONS(1929),
    [anon_sym_LBRACK] = ACTIONS(1929),
    [aux_sym_method_token7] = ACTIONS(1929),
    [aux_sym_procedure_token2] = ACTIONS(1929),
    [aux_sym_block_token2] = ACTIONS(1929),
    [anon_sym__and_LT_LT] = ACTIONS(1929),
    [anon_sym__andif_LT_LT] = ACTIONS(1929),
    [anon_sym__or_LT_LT] = ACTIONS(1929),
    [anon_sym__orif_LT_LT] = ACTIONS(1929),
    [anon_sym__xor_LT_LT] = ACTIONS(1929),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1929),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1929),
    [anon_sym_STAR_LT_LT] = ACTIONS(1929),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1929),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1929),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1929),
    [anon_sym__mod_LT_LT] = ACTIONS(1929),
    [anon_sym__div_LT_LT] = ACTIONS(1929),
    [anon_sym_DASH_LT_LT] = ACTIONS(1929),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1929),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1929),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1929),
    [aux_sym_if_token3] = ACTIONS(1929),
    [aux_sym_elif_token1] = ACTIONS(1929),
    [aux_sym_else_token1] = ACTIONS(1929),
    [aux_sym_loop_token2] = ACTIONS(1929),
    [aux_sym_finally_token1] = ACTIONS(1929),
    [aux_sym_finally_token2] = ACTIONS(1929),
    [aux_sym_catch_token2] = ACTIONS(1929),
    [aux_sym_try_token2] = ACTIONS(1929),
    [aux_sym_try_token3] = ACTIONS(1929),
    [aux_sym_protect_token3] = ACTIONS(1929),
    [aux_sym_protect_token4] = ACTIONS(1929),
    [aux_sym_lock_token2] = ACTIONS(1929),
    [anon_sym_SEMI] = ACTIONS(1929),
    [aux_sym_relational_operator_token1] = ACTIONS(1929),
    [aux_sym_relational_operator_token2] = ACTIONS(1929),
    [aux_sym_relational_operator_token3] = ACTIONS(1929),
    [anon_sym_EQ] = ACTIONS(1929),
    [anon_sym_TILDE_EQ] = ACTIONS(1929),
    [anon_sym_LT_GT] = ACTIONS(1929),
    [anon_sym_GT_EQ] = ACTIONS(1929),
    [anon_sym_LT_EQ] = ACTIONS(1929),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_GT] = ACTIONS(1929),
    [aux_sym_logical_operator_token1] = ACTIONS(1929),
    [aux_sym_logical_operator_token2] = ACTIONS(1929),
    [aux_sym_logical_operator_token3] = ACTIONS(1929),
    [aux_sym_logical_operator_token4] = ACTIONS(1929),
    [aux_sym_logical_operator_token5] = ACTIONS(1929),
    [aux_sym_logical_operator_token6] = ACTIONS(1929),
    [anon_sym_STAR_STAR] = ACTIONS(1929),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_SLASH] = ACTIONS(1929),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1929),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1929),
    [anon_sym_DASH] = ACTIONS(1929),
    [anon_sym_PLUS] = ACTIONS(1929),
    [sym_comment] = ACTIONS(3),
  },
  [545] = {
    [anon_sym_CR] = ACTIONS(1931),
    [anon_sym_LF] = ACTIONS(1931),
    [anon_sym_DOT] = ACTIONS(1931),
    [anon_sym_LPAREN] = ACTIONS(1931),
    [anon_sym_COMMA] = ACTIONS(1931),
    [anon_sym_LT_LT] = ACTIONS(1931),
    [anon_sym_CARET_LT_LT] = ACTIONS(1931),
    [anon_sym_LBRACK] = ACTIONS(1931),
    [aux_sym_method_token7] = ACTIONS(1931),
    [aux_sym_procedure_token2] = ACTIONS(1931),
    [aux_sym_block_token2] = ACTIONS(1931),
    [anon_sym__and_LT_LT] = ACTIONS(1931),
    [anon_sym__andif_LT_LT] = ACTIONS(1931),
    [anon_sym__or_LT_LT] = ACTIONS(1931),
    [anon_sym__orif_LT_LT] = ACTIONS(1931),
    [anon_sym__xor_LT_LT] = ACTIONS(1931),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1931),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1931),
    [anon_sym_STAR_LT_LT] = ACTIONS(1931),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1931),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1931),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1931),
    [anon_sym__mod_LT_LT] = ACTIONS(1931),
    [anon_sym__div_LT_LT] = ACTIONS(1931),
    [anon_sym_DASH_LT_LT] = ACTIONS(1931),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1931),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1931),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1931),
    [aux_sym_if_token3] = ACTIONS(1931),
    [aux_sym_elif_token1] = ACTIONS(1931),
    [aux_sym_else_token1] = ACTIONS(1931),
    [aux_sym_loop_token2] = ACTIONS(1931),
    [aux_sym_finally_token1] = ACTIONS(1931),
    [aux_sym_finally_token2] = ACTIONS(1931),
    [aux_sym_catch_token2] = ACTIONS(1931),
    [aux_sym_try_token2] = ACTIONS(1931),
    [aux_sym_try_token3] = ACTIONS(1931),
    [aux_sym_protect_token3] = ACTIONS(1931),
    [aux_sym_protect_token4] = ACTIONS(1931),
    [aux_sym_lock_token2] = ACTIONS(1931),
    [anon_sym_SEMI] = ACTIONS(1931),
    [aux_sym_relational_operator_token1] = ACTIONS(1931),
    [aux_sym_relational_operator_token2] = ACTIONS(1931),
    [aux_sym_relational_operator_token3] = ACTIONS(1931),
    [anon_sym_EQ] = ACTIONS(1931),
    [anon_sym_TILDE_EQ] = ACTIONS(1931),
    [anon_sym_LT_GT] = ACTIONS(1931),
    [anon_sym_GT_EQ] = ACTIONS(1931),
    [anon_sym_LT_EQ] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1931),
    [anon_sym_GT] = ACTIONS(1931),
    [aux_sym_logical_operator_token1] = ACTIONS(1931),
    [aux_sym_logical_operator_token2] = ACTIONS(1931),
    [aux_sym_logical_operator_token3] = ACTIONS(1931),
    [aux_sym_logical_operator_token4] = ACTIONS(1931),
    [aux_sym_logical_operator_token5] = ACTIONS(1931),
    [aux_sym_logical_operator_token6] = ACTIONS(1931),
    [anon_sym_STAR_STAR] = ACTIONS(1931),
    [anon_sym_STAR] = ACTIONS(1931),
    [anon_sym_SLASH] = ACTIONS(1931),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1931),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1931),
    [anon_sym_DASH] = ACTIONS(1931),
    [anon_sym_PLUS] = ACTIONS(1931),
    [sym_comment] = ACTIONS(3),
  },
  [546] = {
    [anon_sym_CR] = ACTIONS(1933),
    [anon_sym_LF] = ACTIONS(1933),
    [anon_sym_DOT] = ACTIONS(1933),
    [anon_sym_LPAREN] = ACTIONS(1933),
    [anon_sym_COMMA] = ACTIONS(1933),
    [anon_sym_LT_LT] = ACTIONS(1933),
    [anon_sym_CARET_LT_LT] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(1933),
    [aux_sym_method_token7] = ACTIONS(1933),
    [aux_sym_procedure_token2] = ACTIONS(1933),
    [aux_sym_block_token2] = ACTIONS(1933),
    [anon_sym__and_LT_LT] = ACTIONS(1933),
    [anon_sym__andif_LT_LT] = ACTIONS(1933),
    [anon_sym__or_LT_LT] = ACTIONS(1933),
    [anon_sym__orif_LT_LT] = ACTIONS(1933),
    [anon_sym__xor_LT_LT] = ACTIONS(1933),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1933),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1933),
    [anon_sym_STAR_LT_LT] = ACTIONS(1933),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1933),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1933),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1933),
    [anon_sym__mod_LT_LT] = ACTIONS(1933),
    [anon_sym__div_LT_LT] = ACTIONS(1933),
    [anon_sym_DASH_LT_LT] = ACTIONS(1933),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1933),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1933),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1933),
    [aux_sym_if_token3] = ACTIONS(1933),
    [aux_sym_elif_token1] = ACTIONS(1933),
    [aux_sym_else_token1] = ACTIONS(1933),
    [aux_sym_loop_token2] = ACTIONS(1933),
    [aux_sym_finally_token1] = ACTIONS(1933),
    [aux_sym_finally_token2] = ACTIONS(1933),
    [aux_sym_catch_token2] = ACTIONS(1933),
    [aux_sym_try_token2] = ACTIONS(1933),
    [aux_sym_try_token3] = ACTIONS(1933),
    [aux_sym_protect_token3] = ACTIONS(1933),
    [aux_sym_protect_token4] = ACTIONS(1933),
    [aux_sym_lock_token2] = ACTIONS(1933),
    [anon_sym_SEMI] = ACTIONS(1933),
    [aux_sym_relational_operator_token1] = ACTIONS(1933),
    [aux_sym_relational_operator_token2] = ACTIONS(1933),
    [aux_sym_relational_operator_token3] = ACTIONS(1933),
    [anon_sym_EQ] = ACTIONS(1933),
    [anon_sym_TILDE_EQ] = ACTIONS(1933),
    [anon_sym_LT_GT] = ACTIONS(1933),
    [anon_sym_GT_EQ] = ACTIONS(1933),
    [anon_sym_LT_EQ] = ACTIONS(1933),
    [anon_sym_LT] = ACTIONS(1933),
    [anon_sym_GT] = ACTIONS(1933),
    [aux_sym_logical_operator_token1] = ACTIONS(1933),
    [aux_sym_logical_operator_token2] = ACTIONS(1933),
    [aux_sym_logical_operator_token3] = ACTIONS(1933),
    [aux_sym_logical_operator_token4] = ACTIONS(1933),
    [aux_sym_logical_operator_token5] = ACTIONS(1933),
    [aux_sym_logical_operator_token6] = ACTIONS(1933),
    [anon_sym_STAR_STAR] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_SLASH] = ACTIONS(1933),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1933),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_PLUS] = ACTIONS(1933),
    [sym_comment] = ACTIONS(3),
  },
  [547] = {
    [anon_sym_CR] = ACTIONS(1935),
    [anon_sym_LF] = ACTIONS(1935),
    [anon_sym_DOT] = ACTIONS(1935),
    [anon_sym_LPAREN] = ACTIONS(1935),
    [anon_sym_COMMA] = ACTIONS(1935),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_CARET_LT_LT] = ACTIONS(1935),
    [anon_sym_LBRACK] = ACTIONS(1935),
    [aux_sym_method_token7] = ACTIONS(1935),
    [aux_sym_procedure_token2] = ACTIONS(1935),
    [aux_sym_block_token2] = ACTIONS(1935),
    [anon_sym__and_LT_LT] = ACTIONS(1935),
    [anon_sym__andif_LT_LT] = ACTIONS(1935),
    [anon_sym__or_LT_LT] = ACTIONS(1935),
    [anon_sym__orif_LT_LT] = ACTIONS(1935),
    [anon_sym__xor_LT_LT] = ACTIONS(1935),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1935),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1935),
    [anon_sym_STAR_LT_LT] = ACTIONS(1935),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1935),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1935),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1935),
    [anon_sym__mod_LT_LT] = ACTIONS(1935),
    [anon_sym__div_LT_LT] = ACTIONS(1935),
    [anon_sym_DASH_LT_LT] = ACTIONS(1935),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1935),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1935),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1935),
    [aux_sym_if_token3] = ACTIONS(1935),
    [aux_sym_elif_token1] = ACTIONS(1935),
    [aux_sym_else_token1] = ACTIONS(1935),
    [aux_sym_loop_token2] = ACTIONS(1935),
    [aux_sym_finally_token1] = ACTIONS(1935),
    [aux_sym_finally_token2] = ACTIONS(1935),
    [aux_sym_catch_token2] = ACTIONS(1935),
    [aux_sym_try_token2] = ACTIONS(1935),
    [aux_sym_try_token3] = ACTIONS(1935),
    [aux_sym_protect_token3] = ACTIONS(1935),
    [aux_sym_protect_token4] = ACTIONS(1935),
    [aux_sym_lock_token2] = ACTIONS(1935),
    [anon_sym_SEMI] = ACTIONS(1935),
    [aux_sym_relational_operator_token1] = ACTIONS(1935),
    [aux_sym_relational_operator_token2] = ACTIONS(1935),
    [aux_sym_relational_operator_token3] = ACTIONS(1935),
    [anon_sym_EQ] = ACTIONS(1935),
    [anon_sym_TILDE_EQ] = ACTIONS(1935),
    [anon_sym_LT_GT] = ACTIONS(1935),
    [anon_sym_GT_EQ] = ACTIONS(1935),
    [anon_sym_LT_EQ] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1935),
    [anon_sym_GT] = ACTIONS(1935),
    [aux_sym_logical_operator_token1] = ACTIONS(1935),
    [aux_sym_logical_operator_token2] = ACTIONS(1935),
    [aux_sym_logical_operator_token3] = ACTIONS(1935),
    [aux_sym_logical_operator_token4] = ACTIONS(1935),
    [aux_sym_logical_operator_token5] = ACTIONS(1935),
    [aux_sym_logical_operator_token6] = ACTIONS(1935),
    [anon_sym_STAR_STAR] = ACTIONS(1935),
    [anon_sym_STAR] = ACTIONS(1935),
    [anon_sym_SLASH] = ACTIONS(1935),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1935),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1935),
    [anon_sym_DASH] = ACTIONS(1935),
    [anon_sym_PLUS] = ACTIONS(1935),
    [sym_comment] = ACTIONS(3),
  },
  [548] = {
    [anon_sym_CR] = ACTIONS(1937),
    [anon_sym_LF] = ACTIONS(1937),
    [anon_sym_DOT] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_COMMA] = ACTIONS(1937),
    [anon_sym_LT_LT] = ACTIONS(1937),
    [anon_sym_CARET_LT_LT] = ACTIONS(1937),
    [anon_sym_LBRACK] = ACTIONS(1937),
    [aux_sym_method_token7] = ACTIONS(1937),
    [aux_sym_procedure_token2] = ACTIONS(1937),
    [aux_sym_block_token2] = ACTIONS(1937),
    [anon_sym__and_LT_LT] = ACTIONS(1937),
    [anon_sym__andif_LT_LT] = ACTIONS(1937),
    [anon_sym__or_LT_LT] = ACTIONS(1937),
    [anon_sym__orif_LT_LT] = ACTIONS(1937),
    [anon_sym__xor_LT_LT] = ACTIONS(1937),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1937),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1937),
    [anon_sym_STAR_LT_LT] = ACTIONS(1937),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1937),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1937),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1937),
    [anon_sym__mod_LT_LT] = ACTIONS(1937),
    [anon_sym__div_LT_LT] = ACTIONS(1937),
    [anon_sym_DASH_LT_LT] = ACTIONS(1937),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1937),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1937),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1937),
    [aux_sym_if_token3] = ACTIONS(1937),
    [aux_sym_elif_token1] = ACTIONS(1937),
    [aux_sym_else_token1] = ACTIONS(1937),
    [aux_sym_loop_token2] = ACTIONS(1937),
    [aux_sym_finally_token1] = ACTIONS(1937),
    [aux_sym_finally_token2] = ACTIONS(1937),
    [aux_sym_catch_token2] = ACTIONS(1937),
    [aux_sym_try_token2] = ACTIONS(1937),
    [aux_sym_try_token3] = ACTIONS(1937),
    [aux_sym_protect_token3] = ACTIONS(1937),
    [aux_sym_protect_token4] = ACTIONS(1937),
    [aux_sym_lock_token2] = ACTIONS(1937),
    [anon_sym_SEMI] = ACTIONS(1937),
    [aux_sym_relational_operator_token1] = ACTIONS(1937),
    [aux_sym_relational_operator_token2] = ACTIONS(1937),
    [aux_sym_relational_operator_token3] = ACTIONS(1937),
    [anon_sym_EQ] = ACTIONS(1937),
    [anon_sym_TILDE_EQ] = ACTIONS(1937),
    [anon_sym_LT_GT] = ACTIONS(1937),
    [anon_sym_GT_EQ] = ACTIONS(1937),
    [anon_sym_LT_EQ] = ACTIONS(1937),
    [anon_sym_LT] = ACTIONS(1937),
    [anon_sym_GT] = ACTIONS(1937),
    [aux_sym_logical_operator_token1] = ACTIONS(1937),
    [aux_sym_logical_operator_token2] = ACTIONS(1937),
    [aux_sym_logical_operator_token3] = ACTIONS(1937),
    [aux_sym_logical_operator_token4] = ACTIONS(1937),
    [aux_sym_logical_operator_token5] = ACTIONS(1937),
    [aux_sym_logical_operator_token6] = ACTIONS(1937),
    [anon_sym_STAR_STAR] = ACTIONS(1937),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_SLASH] = ACTIONS(1937),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1937),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1937),
    [anon_sym_DASH] = ACTIONS(1937),
    [anon_sym_PLUS] = ACTIONS(1937),
    [sym_comment] = ACTIONS(3),
  },
  [549] = {
    [anon_sym_CR] = ACTIONS(1939),
    [anon_sym_LF] = ACTIONS(1939),
    [anon_sym_DOT] = ACTIONS(1939),
    [anon_sym_LPAREN] = ACTIONS(1939),
    [anon_sym_COMMA] = ACTIONS(1939),
    [anon_sym_LT_LT] = ACTIONS(1939),
    [anon_sym_CARET_LT_LT] = ACTIONS(1939),
    [anon_sym_LBRACK] = ACTIONS(1939),
    [aux_sym_method_token7] = ACTIONS(1939),
    [aux_sym_procedure_token2] = ACTIONS(1939),
    [aux_sym_block_token2] = ACTIONS(1939),
    [anon_sym__and_LT_LT] = ACTIONS(1939),
    [anon_sym__andif_LT_LT] = ACTIONS(1939),
    [anon_sym__or_LT_LT] = ACTIONS(1939),
    [anon_sym__orif_LT_LT] = ACTIONS(1939),
    [anon_sym__xor_LT_LT] = ACTIONS(1939),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1939),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1939),
    [anon_sym_STAR_LT_LT] = ACTIONS(1939),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1939),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1939),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1939),
    [anon_sym__mod_LT_LT] = ACTIONS(1939),
    [anon_sym__div_LT_LT] = ACTIONS(1939),
    [anon_sym_DASH_LT_LT] = ACTIONS(1939),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1939),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1939),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1939),
    [aux_sym_if_token3] = ACTIONS(1939),
    [aux_sym_elif_token1] = ACTIONS(1939),
    [aux_sym_else_token1] = ACTIONS(1939),
    [aux_sym_loop_token2] = ACTIONS(1939),
    [aux_sym_finally_token1] = ACTIONS(1939),
    [aux_sym_finally_token2] = ACTIONS(1939),
    [aux_sym_catch_token2] = ACTIONS(1939),
    [aux_sym_try_token2] = ACTIONS(1939),
    [aux_sym_try_token3] = ACTIONS(1939),
    [aux_sym_protect_token3] = ACTIONS(1939),
    [aux_sym_protect_token4] = ACTIONS(1939),
    [aux_sym_lock_token2] = ACTIONS(1939),
    [anon_sym_SEMI] = ACTIONS(1939),
    [aux_sym_relational_operator_token1] = ACTIONS(1939),
    [aux_sym_relational_operator_token2] = ACTIONS(1939),
    [aux_sym_relational_operator_token3] = ACTIONS(1939),
    [anon_sym_EQ] = ACTIONS(1939),
    [anon_sym_TILDE_EQ] = ACTIONS(1939),
    [anon_sym_LT_GT] = ACTIONS(1939),
    [anon_sym_GT_EQ] = ACTIONS(1939),
    [anon_sym_LT_EQ] = ACTIONS(1939),
    [anon_sym_LT] = ACTIONS(1939),
    [anon_sym_GT] = ACTIONS(1939),
    [aux_sym_logical_operator_token1] = ACTIONS(1939),
    [aux_sym_logical_operator_token2] = ACTIONS(1939),
    [aux_sym_logical_operator_token3] = ACTIONS(1939),
    [aux_sym_logical_operator_token4] = ACTIONS(1939),
    [aux_sym_logical_operator_token5] = ACTIONS(1939),
    [aux_sym_logical_operator_token6] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1939),
    [anon_sym_STAR] = ACTIONS(1939),
    [anon_sym_SLASH] = ACTIONS(1939),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1939),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1939),
    [anon_sym_DASH] = ACTIONS(1939),
    [anon_sym_PLUS] = ACTIONS(1939),
    [sym_comment] = ACTIONS(3),
  },
  [550] = {
    [anon_sym_CR] = ACTIONS(1941),
    [anon_sym_LF] = ACTIONS(1941),
    [anon_sym_DOT] = ACTIONS(1941),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_COMMA] = ACTIONS(1941),
    [anon_sym_LT_LT] = ACTIONS(1941),
    [anon_sym_CARET_LT_LT] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1941),
    [aux_sym_method_token7] = ACTIONS(1941),
    [aux_sym_procedure_token2] = ACTIONS(1941),
    [aux_sym_block_token2] = ACTIONS(1941),
    [anon_sym__and_LT_LT] = ACTIONS(1941),
    [anon_sym__andif_LT_LT] = ACTIONS(1941),
    [anon_sym__or_LT_LT] = ACTIONS(1941),
    [anon_sym__orif_LT_LT] = ACTIONS(1941),
    [anon_sym__xor_LT_LT] = ACTIONS(1941),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1941),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1941),
    [anon_sym_STAR_LT_LT] = ACTIONS(1941),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1941),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1941),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1941),
    [anon_sym__mod_LT_LT] = ACTIONS(1941),
    [anon_sym__div_LT_LT] = ACTIONS(1941),
    [anon_sym_DASH_LT_LT] = ACTIONS(1941),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1941),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1941),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1941),
    [aux_sym_if_token3] = ACTIONS(1941),
    [aux_sym_elif_token1] = ACTIONS(1941),
    [aux_sym_else_token1] = ACTIONS(1941),
    [aux_sym_loop_token2] = ACTIONS(1941),
    [aux_sym_finally_token1] = ACTIONS(1941),
    [aux_sym_finally_token2] = ACTIONS(1941),
    [aux_sym_catch_token2] = ACTIONS(1941),
    [aux_sym_try_token2] = ACTIONS(1941),
    [aux_sym_try_token3] = ACTIONS(1941),
    [aux_sym_protect_token3] = ACTIONS(1941),
    [aux_sym_protect_token4] = ACTIONS(1941),
    [aux_sym_lock_token2] = ACTIONS(1941),
    [anon_sym_SEMI] = ACTIONS(1941),
    [aux_sym_relational_operator_token1] = ACTIONS(1941),
    [aux_sym_relational_operator_token2] = ACTIONS(1941),
    [aux_sym_relational_operator_token3] = ACTIONS(1941),
    [anon_sym_EQ] = ACTIONS(1941),
    [anon_sym_TILDE_EQ] = ACTIONS(1941),
    [anon_sym_LT_GT] = ACTIONS(1941),
    [anon_sym_GT_EQ] = ACTIONS(1941),
    [anon_sym_LT_EQ] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_GT] = ACTIONS(1941),
    [aux_sym_logical_operator_token1] = ACTIONS(1941),
    [aux_sym_logical_operator_token2] = ACTIONS(1941),
    [aux_sym_logical_operator_token3] = ACTIONS(1941),
    [aux_sym_logical_operator_token4] = ACTIONS(1941),
    [aux_sym_logical_operator_token5] = ACTIONS(1941),
    [aux_sym_logical_operator_token6] = ACTIONS(1941),
    [anon_sym_STAR_STAR] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(1941),
    [anon_sym_SLASH] = ACTIONS(1941),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1941),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1941),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_PLUS] = ACTIONS(1941),
    [sym_comment] = ACTIONS(3),
  },
  [551] = {
    [anon_sym_CR] = ACTIONS(1943),
    [anon_sym_LF] = ACTIONS(1943),
    [anon_sym_DOT] = ACTIONS(1943),
    [anon_sym_LPAREN] = ACTIONS(1943),
    [anon_sym_COMMA] = ACTIONS(1943),
    [anon_sym_LT_LT] = ACTIONS(1943),
    [anon_sym_CARET_LT_LT] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1943),
    [aux_sym_method_token7] = ACTIONS(1943),
    [aux_sym_procedure_token2] = ACTIONS(1943),
    [aux_sym_block_token2] = ACTIONS(1943),
    [anon_sym__and_LT_LT] = ACTIONS(1943),
    [anon_sym__andif_LT_LT] = ACTIONS(1943),
    [anon_sym__or_LT_LT] = ACTIONS(1943),
    [anon_sym__orif_LT_LT] = ACTIONS(1943),
    [anon_sym__xor_LT_LT] = ACTIONS(1943),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1943),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1943),
    [anon_sym_STAR_LT_LT] = ACTIONS(1943),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1943),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1943),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1943),
    [anon_sym__mod_LT_LT] = ACTIONS(1943),
    [anon_sym__div_LT_LT] = ACTIONS(1943),
    [anon_sym_DASH_LT_LT] = ACTIONS(1943),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1943),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1943),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1943),
    [aux_sym_if_token3] = ACTIONS(1943),
    [aux_sym_elif_token1] = ACTIONS(1943),
    [aux_sym_else_token1] = ACTIONS(1943),
    [aux_sym_loop_token2] = ACTIONS(1943),
    [aux_sym_finally_token1] = ACTIONS(1943),
    [aux_sym_finally_token2] = ACTIONS(1943),
    [aux_sym_catch_token2] = ACTIONS(1943),
    [aux_sym_try_token2] = ACTIONS(1943),
    [aux_sym_try_token3] = ACTIONS(1943),
    [aux_sym_protect_token3] = ACTIONS(1943),
    [aux_sym_protect_token4] = ACTIONS(1943),
    [aux_sym_lock_token2] = ACTIONS(1943),
    [anon_sym_SEMI] = ACTIONS(1943),
    [aux_sym_relational_operator_token1] = ACTIONS(1943),
    [aux_sym_relational_operator_token2] = ACTIONS(1943),
    [aux_sym_relational_operator_token3] = ACTIONS(1943),
    [anon_sym_EQ] = ACTIONS(1943),
    [anon_sym_TILDE_EQ] = ACTIONS(1943),
    [anon_sym_LT_GT] = ACTIONS(1943),
    [anon_sym_GT_EQ] = ACTIONS(1943),
    [anon_sym_LT_EQ] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(1943),
    [anon_sym_GT] = ACTIONS(1943),
    [aux_sym_logical_operator_token1] = ACTIONS(1943),
    [aux_sym_logical_operator_token2] = ACTIONS(1943),
    [aux_sym_logical_operator_token3] = ACTIONS(1943),
    [aux_sym_logical_operator_token4] = ACTIONS(1943),
    [aux_sym_logical_operator_token5] = ACTIONS(1943),
    [aux_sym_logical_operator_token6] = ACTIONS(1943),
    [anon_sym_STAR_STAR] = ACTIONS(1943),
    [anon_sym_STAR] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1943),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1943),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_PLUS] = ACTIONS(1943),
    [sym_comment] = ACTIONS(3),
  },
  [552] = {
    [anon_sym_CR] = ACTIONS(1945),
    [anon_sym_LF] = ACTIONS(1945),
    [anon_sym_DOT] = ACTIONS(1945),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_COMMA] = ACTIONS(1945),
    [anon_sym_LT_LT] = ACTIONS(1945),
    [anon_sym_CARET_LT_LT] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [aux_sym_method_token7] = ACTIONS(1945),
    [aux_sym_procedure_token2] = ACTIONS(1945),
    [aux_sym_block_token2] = ACTIONS(1945),
    [anon_sym__and_LT_LT] = ACTIONS(1945),
    [anon_sym__andif_LT_LT] = ACTIONS(1945),
    [anon_sym__or_LT_LT] = ACTIONS(1945),
    [anon_sym__orif_LT_LT] = ACTIONS(1945),
    [anon_sym__xor_LT_LT] = ACTIONS(1945),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1945),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1945),
    [anon_sym_STAR_LT_LT] = ACTIONS(1945),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1945),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1945),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1945),
    [anon_sym__mod_LT_LT] = ACTIONS(1945),
    [anon_sym__div_LT_LT] = ACTIONS(1945),
    [anon_sym_DASH_LT_LT] = ACTIONS(1945),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1945),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1945),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1945),
    [aux_sym_if_token3] = ACTIONS(1945),
    [aux_sym_elif_token1] = ACTIONS(1945),
    [aux_sym_else_token1] = ACTIONS(1945),
    [aux_sym_loop_token2] = ACTIONS(1945),
    [aux_sym_finally_token1] = ACTIONS(1945),
    [aux_sym_finally_token2] = ACTIONS(1945),
    [aux_sym_catch_token2] = ACTIONS(1945),
    [aux_sym_try_token2] = ACTIONS(1945),
    [aux_sym_try_token3] = ACTIONS(1945),
    [aux_sym_protect_token3] = ACTIONS(1945),
    [aux_sym_protect_token4] = ACTIONS(1945),
    [aux_sym_lock_token2] = ACTIONS(1945),
    [anon_sym_SEMI] = ACTIONS(1945),
    [aux_sym_relational_operator_token1] = ACTIONS(1945),
    [aux_sym_relational_operator_token2] = ACTIONS(1945),
    [aux_sym_relational_operator_token3] = ACTIONS(1945),
    [anon_sym_EQ] = ACTIONS(1945),
    [anon_sym_TILDE_EQ] = ACTIONS(1945),
    [anon_sym_LT_GT] = ACTIONS(1945),
    [anon_sym_GT_EQ] = ACTIONS(1945),
    [anon_sym_LT_EQ] = ACTIONS(1945),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_GT] = ACTIONS(1945),
    [aux_sym_logical_operator_token1] = ACTIONS(1945),
    [aux_sym_logical_operator_token2] = ACTIONS(1945),
    [aux_sym_logical_operator_token3] = ACTIONS(1945),
    [aux_sym_logical_operator_token4] = ACTIONS(1945),
    [aux_sym_logical_operator_token5] = ACTIONS(1945),
    [aux_sym_logical_operator_token6] = ACTIONS(1945),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_SLASH] = ACTIONS(1945),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1945),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1945),
    [anon_sym_PLUS] = ACTIONS(1945),
    [sym_comment] = ACTIONS(3),
  },
  [553] = {
    [anon_sym_CR] = ACTIONS(1947),
    [anon_sym_LF] = ACTIONS(1947),
    [anon_sym_DOT] = ACTIONS(1947),
    [anon_sym_LPAREN] = ACTIONS(1947),
    [anon_sym_COMMA] = ACTIONS(1947),
    [anon_sym_LT_LT] = ACTIONS(1947),
    [anon_sym_CARET_LT_LT] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1947),
    [aux_sym_method_token7] = ACTIONS(1947),
    [aux_sym_procedure_token2] = ACTIONS(1947),
    [aux_sym_block_token2] = ACTIONS(1947),
    [anon_sym__and_LT_LT] = ACTIONS(1947),
    [anon_sym__andif_LT_LT] = ACTIONS(1947),
    [anon_sym__or_LT_LT] = ACTIONS(1947),
    [anon_sym__orif_LT_LT] = ACTIONS(1947),
    [anon_sym__xor_LT_LT] = ACTIONS(1947),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1947),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1947),
    [anon_sym_STAR_LT_LT] = ACTIONS(1947),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1947),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1947),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1947),
    [anon_sym__mod_LT_LT] = ACTIONS(1947),
    [anon_sym__div_LT_LT] = ACTIONS(1947),
    [anon_sym_DASH_LT_LT] = ACTIONS(1947),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1947),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1947),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1947),
    [aux_sym_if_token3] = ACTIONS(1947),
    [aux_sym_elif_token1] = ACTIONS(1947),
    [aux_sym_else_token1] = ACTIONS(1947),
    [aux_sym_loop_token2] = ACTIONS(1947),
    [aux_sym_finally_token1] = ACTIONS(1947),
    [aux_sym_finally_token2] = ACTIONS(1947),
    [aux_sym_catch_token2] = ACTIONS(1947),
    [aux_sym_try_token2] = ACTIONS(1947),
    [aux_sym_try_token3] = ACTIONS(1947),
    [aux_sym_protect_token3] = ACTIONS(1947),
    [aux_sym_protect_token4] = ACTIONS(1947),
    [aux_sym_lock_token2] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1947),
    [aux_sym_relational_operator_token1] = ACTIONS(1947),
    [aux_sym_relational_operator_token2] = ACTIONS(1947),
    [aux_sym_relational_operator_token3] = ACTIONS(1947),
    [anon_sym_EQ] = ACTIONS(1947),
    [anon_sym_TILDE_EQ] = ACTIONS(1947),
    [anon_sym_LT_GT] = ACTIONS(1947),
    [anon_sym_GT_EQ] = ACTIONS(1947),
    [anon_sym_LT_EQ] = ACTIONS(1947),
    [anon_sym_LT] = ACTIONS(1947),
    [anon_sym_GT] = ACTIONS(1947),
    [aux_sym_logical_operator_token1] = ACTIONS(1947),
    [aux_sym_logical_operator_token2] = ACTIONS(1947),
    [aux_sym_logical_operator_token3] = ACTIONS(1947),
    [aux_sym_logical_operator_token4] = ACTIONS(1947),
    [aux_sym_logical_operator_token5] = ACTIONS(1947),
    [aux_sym_logical_operator_token6] = ACTIONS(1947),
    [anon_sym_STAR_STAR] = ACTIONS(1947),
    [anon_sym_STAR] = ACTIONS(1947),
    [anon_sym_SLASH] = ACTIONS(1947),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1947),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1947),
    [anon_sym_DASH] = ACTIONS(1947),
    [anon_sym_PLUS] = ACTIONS(1947),
    [sym_comment] = ACTIONS(3),
  },
  [554] = {
    [anon_sym_CR] = ACTIONS(1949),
    [anon_sym_LF] = ACTIONS(1949),
    [anon_sym_DOT] = ACTIONS(1949),
    [anon_sym_LPAREN] = ACTIONS(1949),
    [anon_sym_COMMA] = ACTIONS(1949),
    [anon_sym_LT_LT] = ACTIONS(1949),
    [anon_sym_CARET_LT_LT] = ACTIONS(1949),
    [anon_sym_LBRACK] = ACTIONS(1949),
    [aux_sym_method_token7] = ACTIONS(1949),
    [aux_sym_procedure_token2] = ACTIONS(1949),
    [aux_sym_block_token2] = ACTIONS(1949),
    [anon_sym__and_LT_LT] = ACTIONS(1949),
    [anon_sym__andif_LT_LT] = ACTIONS(1949),
    [anon_sym__or_LT_LT] = ACTIONS(1949),
    [anon_sym__orif_LT_LT] = ACTIONS(1949),
    [anon_sym__xor_LT_LT] = ACTIONS(1949),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1949),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1949),
    [anon_sym_STAR_LT_LT] = ACTIONS(1949),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1949),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1949),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1949),
    [anon_sym__mod_LT_LT] = ACTIONS(1949),
    [anon_sym__div_LT_LT] = ACTIONS(1949),
    [anon_sym_DASH_LT_LT] = ACTIONS(1949),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1949),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1949),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1949),
    [aux_sym_if_token3] = ACTIONS(1949),
    [aux_sym_elif_token1] = ACTIONS(1949),
    [aux_sym_else_token1] = ACTIONS(1949),
    [aux_sym_loop_token2] = ACTIONS(1949),
    [aux_sym_finally_token1] = ACTIONS(1949),
    [aux_sym_finally_token2] = ACTIONS(1949),
    [aux_sym_catch_token2] = ACTIONS(1949),
    [aux_sym_try_token2] = ACTIONS(1949),
    [aux_sym_try_token3] = ACTIONS(1949),
    [aux_sym_protect_token3] = ACTIONS(1949),
    [aux_sym_protect_token4] = ACTIONS(1949),
    [aux_sym_lock_token2] = ACTIONS(1949),
    [anon_sym_SEMI] = ACTIONS(1949),
    [aux_sym_relational_operator_token1] = ACTIONS(1949),
    [aux_sym_relational_operator_token2] = ACTIONS(1949),
    [aux_sym_relational_operator_token3] = ACTIONS(1949),
    [anon_sym_EQ] = ACTIONS(1949),
    [anon_sym_TILDE_EQ] = ACTIONS(1949),
    [anon_sym_LT_GT] = ACTIONS(1949),
    [anon_sym_GT_EQ] = ACTIONS(1949),
    [anon_sym_LT_EQ] = ACTIONS(1949),
    [anon_sym_LT] = ACTIONS(1949),
    [anon_sym_GT] = ACTIONS(1949),
    [aux_sym_logical_operator_token1] = ACTIONS(1949),
    [aux_sym_logical_operator_token2] = ACTIONS(1949),
    [aux_sym_logical_operator_token3] = ACTIONS(1949),
    [aux_sym_logical_operator_token4] = ACTIONS(1949),
    [aux_sym_logical_operator_token5] = ACTIONS(1949),
    [aux_sym_logical_operator_token6] = ACTIONS(1949),
    [anon_sym_STAR_STAR] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_SLASH] = ACTIONS(1949),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1949),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_PLUS] = ACTIONS(1949),
    [sym_comment] = ACTIONS(3),
  },
  [555] = {
    [anon_sym_CR] = ACTIONS(1951),
    [anon_sym_LF] = ACTIONS(1951),
    [anon_sym_DOT] = ACTIONS(1951),
    [anon_sym_LPAREN] = ACTIONS(1951),
    [anon_sym_COMMA] = ACTIONS(1951),
    [anon_sym_LT_LT] = ACTIONS(1951),
    [anon_sym_CARET_LT_LT] = ACTIONS(1951),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [aux_sym_method_token7] = ACTIONS(1951),
    [aux_sym_procedure_token2] = ACTIONS(1951),
    [aux_sym_block_token2] = ACTIONS(1951),
    [anon_sym__and_LT_LT] = ACTIONS(1951),
    [anon_sym__andif_LT_LT] = ACTIONS(1951),
    [anon_sym__or_LT_LT] = ACTIONS(1951),
    [anon_sym__orif_LT_LT] = ACTIONS(1951),
    [anon_sym__xor_LT_LT] = ACTIONS(1951),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1951),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1951),
    [anon_sym_STAR_LT_LT] = ACTIONS(1951),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1951),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1951),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1951),
    [anon_sym__mod_LT_LT] = ACTIONS(1951),
    [anon_sym__div_LT_LT] = ACTIONS(1951),
    [anon_sym_DASH_LT_LT] = ACTIONS(1951),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1951),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1951),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1951),
    [aux_sym_if_token3] = ACTIONS(1951),
    [aux_sym_elif_token1] = ACTIONS(1951),
    [aux_sym_else_token1] = ACTIONS(1951),
    [aux_sym_loop_token2] = ACTIONS(1951),
    [aux_sym_finally_token1] = ACTIONS(1951),
    [aux_sym_finally_token2] = ACTIONS(1951),
    [aux_sym_catch_token2] = ACTIONS(1951),
    [aux_sym_try_token2] = ACTIONS(1951),
    [aux_sym_try_token3] = ACTIONS(1951),
    [aux_sym_protect_token3] = ACTIONS(1951),
    [aux_sym_protect_token4] = ACTIONS(1951),
    [aux_sym_lock_token2] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1951),
    [aux_sym_relational_operator_token1] = ACTIONS(1951),
    [aux_sym_relational_operator_token2] = ACTIONS(1951),
    [aux_sym_relational_operator_token3] = ACTIONS(1951),
    [anon_sym_EQ] = ACTIONS(1951),
    [anon_sym_TILDE_EQ] = ACTIONS(1951),
    [anon_sym_LT_GT] = ACTIONS(1951),
    [anon_sym_GT_EQ] = ACTIONS(1951),
    [anon_sym_LT_EQ] = ACTIONS(1951),
    [anon_sym_LT] = ACTIONS(1951),
    [anon_sym_GT] = ACTIONS(1951),
    [aux_sym_logical_operator_token1] = ACTIONS(1951),
    [aux_sym_logical_operator_token2] = ACTIONS(1951),
    [aux_sym_logical_operator_token3] = ACTIONS(1951),
    [aux_sym_logical_operator_token4] = ACTIONS(1951),
    [aux_sym_logical_operator_token5] = ACTIONS(1951),
    [aux_sym_logical_operator_token6] = ACTIONS(1951),
    [anon_sym_STAR_STAR] = ACTIONS(1951),
    [anon_sym_STAR] = ACTIONS(1951),
    [anon_sym_SLASH] = ACTIONS(1951),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1951),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1951),
    [anon_sym_DASH] = ACTIONS(1951),
    [anon_sym_PLUS] = ACTIONS(1951),
    [sym_comment] = ACTIONS(3),
  },
  [556] = {
    [anon_sym_CR] = ACTIONS(1953),
    [anon_sym_LF] = ACTIONS(1953),
    [anon_sym_DOT] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1953),
    [anon_sym_COMMA] = ACTIONS(1953),
    [anon_sym_LT_LT] = ACTIONS(1953),
    [anon_sym_CARET_LT_LT] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [aux_sym_method_token7] = ACTIONS(1953),
    [aux_sym_procedure_token2] = ACTIONS(1953),
    [aux_sym_block_token2] = ACTIONS(1953),
    [anon_sym__and_LT_LT] = ACTIONS(1953),
    [anon_sym__andif_LT_LT] = ACTIONS(1953),
    [anon_sym__or_LT_LT] = ACTIONS(1953),
    [anon_sym__orif_LT_LT] = ACTIONS(1953),
    [anon_sym__xor_LT_LT] = ACTIONS(1953),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1953),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1953),
    [anon_sym_STAR_LT_LT] = ACTIONS(1953),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1953),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1953),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1953),
    [anon_sym__mod_LT_LT] = ACTIONS(1953),
    [anon_sym__div_LT_LT] = ACTIONS(1953),
    [anon_sym_DASH_LT_LT] = ACTIONS(1953),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1953),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1953),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1953),
    [aux_sym_if_token3] = ACTIONS(1953),
    [aux_sym_elif_token1] = ACTIONS(1953),
    [aux_sym_else_token1] = ACTIONS(1953),
    [aux_sym_loop_token2] = ACTIONS(1953),
    [aux_sym_finally_token1] = ACTIONS(1953),
    [aux_sym_finally_token2] = ACTIONS(1953),
    [aux_sym_catch_token2] = ACTIONS(1953),
    [aux_sym_try_token2] = ACTIONS(1953),
    [aux_sym_try_token3] = ACTIONS(1953),
    [aux_sym_protect_token3] = ACTIONS(1953),
    [aux_sym_protect_token4] = ACTIONS(1953),
    [aux_sym_lock_token2] = ACTIONS(1953),
    [anon_sym_SEMI] = ACTIONS(1953),
    [aux_sym_relational_operator_token1] = ACTIONS(1953),
    [aux_sym_relational_operator_token2] = ACTIONS(1953),
    [aux_sym_relational_operator_token3] = ACTIONS(1953),
    [anon_sym_EQ] = ACTIONS(1953),
    [anon_sym_TILDE_EQ] = ACTIONS(1953),
    [anon_sym_LT_GT] = ACTIONS(1953),
    [anon_sym_GT_EQ] = ACTIONS(1953),
    [anon_sym_LT_EQ] = ACTIONS(1953),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_GT] = ACTIONS(1953),
    [aux_sym_logical_operator_token1] = ACTIONS(1953),
    [aux_sym_logical_operator_token2] = ACTIONS(1953),
    [aux_sym_logical_operator_token3] = ACTIONS(1953),
    [aux_sym_logical_operator_token4] = ACTIONS(1953),
    [aux_sym_logical_operator_token5] = ACTIONS(1953),
    [aux_sym_logical_operator_token6] = ACTIONS(1953),
    [anon_sym_STAR_STAR] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1953),
    [anon_sym_SLASH] = ACTIONS(1953),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1953),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1953),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PLUS] = ACTIONS(1953),
    [sym_comment] = ACTIONS(3),
  },
  [557] = {
    [anon_sym_CR] = ACTIONS(1955),
    [anon_sym_LF] = ACTIONS(1955),
    [anon_sym_DOT] = ACTIONS(1955),
    [anon_sym_LPAREN] = ACTIONS(1955),
    [anon_sym_COMMA] = ACTIONS(1955),
    [anon_sym_LT_LT] = ACTIONS(1955),
    [anon_sym_CARET_LT_LT] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(1955),
    [aux_sym_method_token7] = ACTIONS(1955),
    [aux_sym_procedure_token2] = ACTIONS(1955),
    [aux_sym_block_token2] = ACTIONS(1955),
    [anon_sym__and_LT_LT] = ACTIONS(1955),
    [anon_sym__andif_LT_LT] = ACTIONS(1955),
    [anon_sym__or_LT_LT] = ACTIONS(1955),
    [anon_sym__orif_LT_LT] = ACTIONS(1955),
    [anon_sym__xor_LT_LT] = ACTIONS(1955),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1955),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1955),
    [anon_sym_STAR_LT_LT] = ACTIONS(1955),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1955),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1955),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1955),
    [anon_sym__mod_LT_LT] = ACTIONS(1955),
    [anon_sym__div_LT_LT] = ACTIONS(1955),
    [anon_sym_DASH_LT_LT] = ACTIONS(1955),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1955),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1955),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1955),
    [aux_sym_if_token3] = ACTIONS(1955),
    [aux_sym_elif_token1] = ACTIONS(1955),
    [aux_sym_else_token1] = ACTIONS(1955),
    [aux_sym_loop_token2] = ACTIONS(1955),
    [aux_sym_finally_token1] = ACTIONS(1955),
    [aux_sym_finally_token2] = ACTIONS(1955),
    [aux_sym_catch_token2] = ACTIONS(1955),
    [aux_sym_try_token2] = ACTIONS(1955),
    [aux_sym_try_token3] = ACTIONS(1955),
    [aux_sym_protect_token3] = ACTIONS(1955),
    [aux_sym_protect_token4] = ACTIONS(1955),
    [aux_sym_lock_token2] = ACTIONS(1955),
    [anon_sym_SEMI] = ACTIONS(1955),
    [aux_sym_relational_operator_token1] = ACTIONS(1955),
    [aux_sym_relational_operator_token2] = ACTIONS(1955),
    [aux_sym_relational_operator_token3] = ACTIONS(1955),
    [anon_sym_EQ] = ACTIONS(1955),
    [anon_sym_TILDE_EQ] = ACTIONS(1955),
    [anon_sym_LT_GT] = ACTIONS(1955),
    [anon_sym_GT_EQ] = ACTIONS(1955),
    [anon_sym_LT_EQ] = ACTIONS(1955),
    [anon_sym_LT] = ACTIONS(1955),
    [anon_sym_GT] = ACTIONS(1955),
    [aux_sym_logical_operator_token1] = ACTIONS(1955),
    [aux_sym_logical_operator_token2] = ACTIONS(1955),
    [aux_sym_logical_operator_token3] = ACTIONS(1955),
    [aux_sym_logical_operator_token4] = ACTIONS(1955),
    [aux_sym_logical_operator_token5] = ACTIONS(1955),
    [aux_sym_logical_operator_token6] = ACTIONS(1955),
    [anon_sym_STAR_STAR] = ACTIONS(1955),
    [anon_sym_STAR] = ACTIONS(1955),
    [anon_sym_SLASH] = ACTIONS(1955),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1955),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1955),
    [anon_sym_DASH] = ACTIONS(1955),
    [anon_sym_PLUS] = ACTIONS(1955),
    [sym_comment] = ACTIONS(3),
  },
  [558] = {
    [aux_sym_loopbody_repeat1] = STATE(535),
    [anon_sym_CR] = ACTIONS(1919),
    [anon_sym_LF] = ACTIONS(1919),
    [anon_sym_DOT] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1919),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(1919),
    [aux_sym_procedure_token2] = ACTIONS(1919),
    [aux_sym_block_token2] = ACTIONS(1919),
    [anon_sym__and_LT_LT] = ACTIONS(1833),
    [anon_sym__andif_LT_LT] = ACTIONS(1833),
    [anon_sym__or_LT_LT] = ACTIONS(1833),
    [anon_sym__orif_LT_LT] = ACTIONS(1833),
    [anon_sym__xor_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym__mod_LT_LT] = ACTIONS(1833),
    [anon_sym__div_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1833),
    [aux_sym_if_token3] = ACTIONS(1919),
    [aux_sym_elif_token1] = ACTIONS(1919),
    [aux_sym_else_token1] = ACTIONS(1919),
    [aux_sym_loop_token2] = ACTIONS(1919),
    [aux_sym_finally_token1] = ACTIONS(1919),
    [aux_sym_finally_token2] = ACTIONS(1919),
    [aux_sym_catch_token2] = ACTIONS(1919),
    [aux_sym_try_token2] = ACTIONS(1919),
    [aux_sym_try_token3] = ACTIONS(1919),
    [aux_sym_protect_token4] = ACTIONS(1919),
    [aux_sym_lock_token2] = ACTIONS(1919),
    [anon_sym_SEMI] = ACTIONS(1919),
    [aux_sym_relational_operator_token1] = ACTIONS(1837),
    [aux_sym_relational_operator_token2] = ACTIONS(1837),
    [aux_sym_relational_operator_token3] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_TILDE_EQ] = ACTIONS(1837),
    [anon_sym_LT_GT] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_GT] = ACTIONS(1837),
    [aux_sym_logical_operator_token1] = ACTIONS(1839),
    [aux_sym_logical_operator_token2] = ACTIONS(1839),
    [aux_sym_logical_operator_token3] = ACTIONS(1839),
    [aux_sym_logical_operator_token4] = ACTIONS(1839),
    [aux_sym_logical_operator_token5] = ACTIONS(1839),
    [aux_sym_logical_operator_token6] = ACTIONS(1839),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
  },
  [559] = {
    [anon_sym_CR] = ACTIONS(1957),
    [anon_sym_LF] = ACTIONS(1957),
    [anon_sym_DOT] = ACTIONS(1957),
    [anon_sym_LPAREN] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_LT_LT] = ACTIONS(1957),
    [anon_sym_CARET_LT_LT] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [aux_sym_method_token7] = ACTIONS(1957),
    [aux_sym_procedure_token2] = ACTIONS(1957),
    [aux_sym_block_token2] = ACTIONS(1957),
    [anon_sym__and_LT_LT] = ACTIONS(1957),
    [anon_sym__andif_LT_LT] = ACTIONS(1957),
    [anon_sym__or_LT_LT] = ACTIONS(1957),
    [anon_sym__orif_LT_LT] = ACTIONS(1957),
    [anon_sym__xor_LT_LT] = ACTIONS(1957),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1957),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1957),
    [anon_sym_STAR_LT_LT] = ACTIONS(1957),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1957),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1957),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1957),
    [anon_sym__mod_LT_LT] = ACTIONS(1957),
    [anon_sym__div_LT_LT] = ACTIONS(1957),
    [anon_sym_DASH_LT_LT] = ACTIONS(1957),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1957),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1957),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1957),
    [aux_sym_if_token3] = ACTIONS(1957),
    [aux_sym_elif_token1] = ACTIONS(1957),
    [aux_sym_else_token1] = ACTIONS(1957),
    [aux_sym_loop_token2] = ACTIONS(1957),
    [aux_sym_finally_token1] = ACTIONS(1957),
    [aux_sym_finally_token2] = ACTIONS(1957),
    [aux_sym_catch_token2] = ACTIONS(1957),
    [aux_sym_try_token2] = ACTIONS(1957),
    [aux_sym_try_token3] = ACTIONS(1957),
    [aux_sym_protect_token3] = ACTIONS(1957),
    [aux_sym_protect_token4] = ACTIONS(1957),
    [aux_sym_lock_token2] = ACTIONS(1957),
    [anon_sym_SEMI] = ACTIONS(1957),
    [aux_sym_relational_operator_token1] = ACTIONS(1957),
    [aux_sym_relational_operator_token2] = ACTIONS(1957),
    [aux_sym_relational_operator_token3] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_TILDE_EQ] = ACTIONS(1957),
    [anon_sym_LT_GT] = ACTIONS(1957),
    [anon_sym_GT_EQ] = ACTIONS(1957),
    [anon_sym_LT_EQ] = ACTIONS(1957),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_GT] = ACTIONS(1957),
    [aux_sym_logical_operator_token1] = ACTIONS(1957),
    [aux_sym_logical_operator_token2] = ACTIONS(1957),
    [aux_sym_logical_operator_token3] = ACTIONS(1957),
    [aux_sym_logical_operator_token4] = ACTIONS(1957),
    [aux_sym_logical_operator_token5] = ACTIONS(1957),
    [aux_sym_logical_operator_token6] = ACTIONS(1957),
    [anon_sym_STAR_STAR] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1957),
    [anon_sym_SLASH] = ACTIONS(1957),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1957),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1957),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PLUS] = ACTIONS(1957),
    [sym_comment] = ACTIONS(3),
  },
  [560] = {
    [anon_sym_CR] = ACTIONS(1959),
    [anon_sym_LF] = ACTIONS(1959),
    [anon_sym_DOT] = ACTIONS(1959),
    [anon_sym_LPAREN] = ACTIONS(1959),
    [anon_sym_COMMA] = ACTIONS(1959),
    [anon_sym_LT_LT] = ACTIONS(1959),
    [anon_sym_CARET_LT_LT] = ACTIONS(1959),
    [anon_sym_LBRACK] = ACTIONS(1959),
    [aux_sym_method_token7] = ACTIONS(1959),
    [aux_sym_procedure_token2] = ACTIONS(1959),
    [aux_sym_block_token2] = ACTIONS(1959),
    [anon_sym__and_LT_LT] = ACTIONS(1959),
    [anon_sym__andif_LT_LT] = ACTIONS(1959),
    [anon_sym__or_LT_LT] = ACTIONS(1959),
    [anon_sym__orif_LT_LT] = ACTIONS(1959),
    [anon_sym__xor_LT_LT] = ACTIONS(1959),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1959),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1959),
    [anon_sym_STAR_LT_LT] = ACTIONS(1959),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1959),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1959),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1959),
    [anon_sym__mod_LT_LT] = ACTIONS(1959),
    [anon_sym__div_LT_LT] = ACTIONS(1959),
    [anon_sym_DASH_LT_LT] = ACTIONS(1959),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1959),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1959),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1959),
    [aux_sym_if_token3] = ACTIONS(1959),
    [aux_sym_elif_token1] = ACTIONS(1959),
    [aux_sym_else_token1] = ACTIONS(1959),
    [aux_sym_loop_token2] = ACTIONS(1959),
    [aux_sym_finally_token1] = ACTIONS(1959),
    [aux_sym_finally_token2] = ACTIONS(1959),
    [aux_sym_catch_token2] = ACTIONS(1959),
    [aux_sym_try_token2] = ACTIONS(1959),
    [aux_sym_try_token3] = ACTIONS(1959),
    [aux_sym_protect_token3] = ACTIONS(1959),
    [aux_sym_protect_token4] = ACTIONS(1959),
    [aux_sym_lock_token2] = ACTIONS(1959),
    [anon_sym_SEMI] = ACTIONS(1959),
    [aux_sym_relational_operator_token1] = ACTIONS(1959),
    [aux_sym_relational_operator_token2] = ACTIONS(1959),
    [aux_sym_relational_operator_token3] = ACTIONS(1959),
    [anon_sym_EQ] = ACTIONS(1959),
    [anon_sym_TILDE_EQ] = ACTIONS(1959),
    [anon_sym_LT_GT] = ACTIONS(1959),
    [anon_sym_GT_EQ] = ACTIONS(1959),
    [anon_sym_LT_EQ] = ACTIONS(1959),
    [anon_sym_LT] = ACTIONS(1959),
    [anon_sym_GT] = ACTIONS(1959),
    [aux_sym_logical_operator_token1] = ACTIONS(1959),
    [aux_sym_logical_operator_token2] = ACTIONS(1959),
    [aux_sym_logical_operator_token3] = ACTIONS(1959),
    [aux_sym_logical_operator_token4] = ACTIONS(1959),
    [aux_sym_logical_operator_token5] = ACTIONS(1959),
    [aux_sym_logical_operator_token6] = ACTIONS(1959),
    [anon_sym_STAR_STAR] = ACTIONS(1959),
    [anon_sym_STAR] = ACTIONS(1959),
    [anon_sym_SLASH] = ACTIONS(1959),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1959),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1959),
    [anon_sym_DASH] = ACTIONS(1959),
    [anon_sym_PLUS] = ACTIONS(1959),
    [sym_comment] = ACTIONS(3),
  },
  [561] = {
    [anon_sym_CR] = ACTIONS(1961),
    [anon_sym_LF] = ACTIONS(1961),
    [anon_sym_DOT] = ACTIONS(1961),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_COMMA] = ACTIONS(1961),
    [anon_sym_LT_LT] = ACTIONS(1961),
    [anon_sym_CARET_LT_LT] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [aux_sym_method_token7] = ACTIONS(1961),
    [aux_sym_procedure_token2] = ACTIONS(1961),
    [aux_sym_block_token2] = ACTIONS(1961),
    [anon_sym__and_LT_LT] = ACTIONS(1961),
    [anon_sym__andif_LT_LT] = ACTIONS(1961),
    [anon_sym__or_LT_LT] = ACTIONS(1961),
    [anon_sym__orif_LT_LT] = ACTIONS(1961),
    [anon_sym__xor_LT_LT] = ACTIONS(1961),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1961),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1961),
    [anon_sym_STAR_LT_LT] = ACTIONS(1961),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1961),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1961),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1961),
    [anon_sym__mod_LT_LT] = ACTIONS(1961),
    [anon_sym__div_LT_LT] = ACTIONS(1961),
    [anon_sym_DASH_LT_LT] = ACTIONS(1961),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1961),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1961),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1961),
    [aux_sym_if_token3] = ACTIONS(1961),
    [aux_sym_elif_token1] = ACTIONS(1961),
    [aux_sym_else_token1] = ACTIONS(1961),
    [aux_sym_loop_token2] = ACTIONS(1961),
    [aux_sym_finally_token1] = ACTIONS(1961),
    [aux_sym_finally_token2] = ACTIONS(1961),
    [aux_sym_catch_token2] = ACTIONS(1961),
    [aux_sym_try_token2] = ACTIONS(1961),
    [aux_sym_try_token3] = ACTIONS(1961),
    [aux_sym_protect_token3] = ACTIONS(1961),
    [aux_sym_protect_token4] = ACTIONS(1961),
    [aux_sym_lock_token2] = ACTIONS(1961),
    [anon_sym_SEMI] = ACTIONS(1961),
    [aux_sym_relational_operator_token1] = ACTIONS(1961),
    [aux_sym_relational_operator_token2] = ACTIONS(1961),
    [aux_sym_relational_operator_token3] = ACTIONS(1961),
    [anon_sym_EQ] = ACTIONS(1961),
    [anon_sym_TILDE_EQ] = ACTIONS(1961),
    [anon_sym_LT_GT] = ACTIONS(1961),
    [anon_sym_GT_EQ] = ACTIONS(1961),
    [anon_sym_LT_EQ] = ACTIONS(1961),
    [anon_sym_LT] = ACTIONS(1961),
    [anon_sym_GT] = ACTIONS(1961),
    [aux_sym_logical_operator_token1] = ACTIONS(1961),
    [aux_sym_logical_operator_token2] = ACTIONS(1961),
    [aux_sym_logical_operator_token3] = ACTIONS(1961),
    [aux_sym_logical_operator_token4] = ACTIONS(1961),
    [aux_sym_logical_operator_token5] = ACTIONS(1961),
    [aux_sym_logical_operator_token6] = ACTIONS(1961),
    [anon_sym_STAR_STAR] = ACTIONS(1961),
    [anon_sym_STAR] = ACTIONS(1961),
    [anon_sym_SLASH] = ACTIONS(1961),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1961),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1961),
    [anon_sym_PLUS] = ACTIONS(1961),
    [sym_comment] = ACTIONS(3),
  },
  [562] = {
    [anon_sym_CR] = ACTIONS(1963),
    [anon_sym_LF] = ACTIONS(1963),
    [anon_sym_DOT] = ACTIONS(1963),
    [anon_sym_LPAREN] = ACTIONS(1963),
    [anon_sym_COMMA] = ACTIONS(1963),
    [anon_sym_LT_LT] = ACTIONS(1963),
    [anon_sym_CARET_LT_LT] = ACTIONS(1963),
    [anon_sym_LBRACK] = ACTIONS(1963),
    [aux_sym_method_token7] = ACTIONS(1963),
    [aux_sym_procedure_token2] = ACTIONS(1963),
    [aux_sym_block_token2] = ACTIONS(1963),
    [anon_sym__and_LT_LT] = ACTIONS(1963),
    [anon_sym__andif_LT_LT] = ACTIONS(1963),
    [anon_sym__or_LT_LT] = ACTIONS(1963),
    [anon_sym__orif_LT_LT] = ACTIONS(1963),
    [anon_sym__xor_LT_LT] = ACTIONS(1963),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1963),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1963),
    [anon_sym_STAR_LT_LT] = ACTIONS(1963),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1963),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1963),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1963),
    [anon_sym__mod_LT_LT] = ACTIONS(1963),
    [anon_sym__div_LT_LT] = ACTIONS(1963),
    [anon_sym_DASH_LT_LT] = ACTIONS(1963),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1963),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1963),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1963),
    [aux_sym_if_token3] = ACTIONS(1963),
    [aux_sym_elif_token1] = ACTIONS(1963),
    [aux_sym_else_token1] = ACTIONS(1963),
    [aux_sym_loop_token2] = ACTIONS(1963),
    [aux_sym_finally_token1] = ACTIONS(1963),
    [aux_sym_finally_token2] = ACTIONS(1963),
    [aux_sym_catch_token2] = ACTIONS(1963),
    [aux_sym_try_token2] = ACTIONS(1963),
    [aux_sym_try_token3] = ACTIONS(1963),
    [aux_sym_protect_token3] = ACTIONS(1963),
    [aux_sym_protect_token4] = ACTIONS(1963),
    [aux_sym_lock_token2] = ACTIONS(1963),
    [anon_sym_SEMI] = ACTIONS(1963),
    [aux_sym_relational_operator_token1] = ACTIONS(1963),
    [aux_sym_relational_operator_token2] = ACTIONS(1963),
    [aux_sym_relational_operator_token3] = ACTIONS(1963),
    [anon_sym_EQ] = ACTIONS(1963),
    [anon_sym_TILDE_EQ] = ACTIONS(1963),
    [anon_sym_LT_GT] = ACTIONS(1963),
    [anon_sym_GT_EQ] = ACTIONS(1963),
    [anon_sym_LT_EQ] = ACTIONS(1963),
    [anon_sym_LT] = ACTIONS(1963),
    [anon_sym_GT] = ACTIONS(1963),
    [aux_sym_logical_operator_token1] = ACTIONS(1963),
    [aux_sym_logical_operator_token2] = ACTIONS(1963),
    [aux_sym_logical_operator_token3] = ACTIONS(1963),
    [aux_sym_logical_operator_token4] = ACTIONS(1963),
    [aux_sym_logical_operator_token5] = ACTIONS(1963),
    [aux_sym_logical_operator_token6] = ACTIONS(1963),
    [anon_sym_STAR_STAR] = ACTIONS(1963),
    [anon_sym_STAR] = ACTIONS(1963),
    [anon_sym_SLASH] = ACTIONS(1963),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1963),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1963),
    [anon_sym_DASH] = ACTIONS(1963),
    [anon_sym_PLUS] = ACTIONS(1963),
    [sym_comment] = ACTIONS(3),
  },
  [563] = {
    [anon_sym_CR] = ACTIONS(1965),
    [anon_sym_LF] = ACTIONS(1965),
    [anon_sym_DOT] = ACTIONS(1965),
    [anon_sym_LPAREN] = ACTIONS(1965),
    [anon_sym_COMMA] = ACTIONS(1965),
    [anon_sym_LT_LT] = ACTIONS(1965),
    [anon_sym_CARET_LT_LT] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [aux_sym_method_token7] = ACTIONS(1965),
    [aux_sym_procedure_token2] = ACTIONS(1965),
    [aux_sym_block_token2] = ACTIONS(1965),
    [anon_sym__and_LT_LT] = ACTIONS(1965),
    [anon_sym__andif_LT_LT] = ACTIONS(1965),
    [anon_sym__or_LT_LT] = ACTIONS(1965),
    [anon_sym__orif_LT_LT] = ACTIONS(1965),
    [anon_sym__xor_LT_LT] = ACTIONS(1965),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1965),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1965),
    [anon_sym_STAR_LT_LT] = ACTIONS(1965),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1965),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1965),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1965),
    [anon_sym__mod_LT_LT] = ACTIONS(1965),
    [anon_sym__div_LT_LT] = ACTIONS(1965),
    [anon_sym_DASH_LT_LT] = ACTIONS(1965),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1965),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1965),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1965),
    [aux_sym_if_token3] = ACTIONS(1965),
    [aux_sym_elif_token1] = ACTIONS(1965),
    [aux_sym_else_token1] = ACTIONS(1965),
    [aux_sym_loop_token2] = ACTIONS(1965),
    [aux_sym_finally_token1] = ACTIONS(1965),
    [aux_sym_finally_token2] = ACTIONS(1965),
    [aux_sym_catch_token2] = ACTIONS(1965),
    [aux_sym_try_token2] = ACTIONS(1965),
    [aux_sym_try_token3] = ACTIONS(1965),
    [aux_sym_protect_token3] = ACTIONS(1965),
    [aux_sym_protect_token4] = ACTIONS(1965),
    [aux_sym_lock_token2] = ACTIONS(1965),
    [anon_sym_SEMI] = ACTIONS(1965),
    [aux_sym_relational_operator_token1] = ACTIONS(1965),
    [aux_sym_relational_operator_token2] = ACTIONS(1965),
    [aux_sym_relational_operator_token3] = ACTIONS(1965),
    [anon_sym_EQ] = ACTIONS(1965),
    [anon_sym_TILDE_EQ] = ACTIONS(1965),
    [anon_sym_LT_GT] = ACTIONS(1965),
    [anon_sym_GT_EQ] = ACTIONS(1965),
    [anon_sym_LT_EQ] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_GT] = ACTIONS(1965),
    [aux_sym_logical_operator_token1] = ACTIONS(1965),
    [aux_sym_logical_operator_token2] = ACTIONS(1965),
    [aux_sym_logical_operator_token3] = ACTIONS(1965),
    [aux_sym_logical_operator_token4] = ACTIONS(1965),
    [aux_sym_logical_operator_token5] = ACTIONS(1965),
    [aux_sym_logical_operator_token6] = ACTIONS(1965),
    [anon_sym_STAR_STAR] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1965),
    [anon_sym_SLASH] = ACTIONS(1965),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1965),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PLUS] = ACTIONS(1965),
    [sym_comment] = ACTIONS(3),
  },
  [564] = {
    [anon_sym_CR] = ACTIONS(1967),
    [anon_sym_LF] = ACTIONS(1967),
    [anon_sym_DOT] = ACTIONS(1967),
    [anon_sym_LPAREN] = ACTIONS(1967),
    [anon_sym_COMMA] = ACTIONS(1967),
    [anon_sym_LT_LT] = ACTIONS(1967),
    [anon_sym_CARET_LT_LT] = ACTIONS(1967),
    [anon_sym_LBRACK] = ACTIONS(1967),
    [aux_sym_method_token7] = ACTIONS(1967),
    [aux_sym_procedure_token2] = ACTIONS(1967),
    [aux_sym_block_token2] = ACTIONS(1967),
    [anon_sym__and_LT_LT] = ACTIONS(1967),
    [anon_sym__andif_LT_LT] = ACTIONS(1967),
    [anon_sym__or_LT_LT] = ACTIONS(1967),
    [anon_sym__orif_LT_LT] = ACTIONS(1967),
    [anon_sym__xor_LT_LT] = ACTIONS(1967),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1967),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1967),
    [anon_sym_STAR_LT_LT] = ACTIONS(1967),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1967),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1967),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1967),
    [anon_sym__mod_LT_LT] = ACTIONS(1967),
    [anon_sym__div_LT_LT] = ACTIONS(1967),
    [anon_sym_DASH_LT_LT] = ACTIONS(1967),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1967),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1967),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1967),
    [aux_sym_if_token3] = ACTIONS(1967),
    [aux_sym_elif_token1] = ACTIONS(1967),
    [aux_sym_else_token1] = ACTIONS(1967),
    [aux_sym_loop_token2] = ACTIONS(1967),
    [aux_sym_finally_token1] = ACTIONS(1967),
    [aux_sym_finally_token2] = ACTIONS(1967),
    [aux_sym_catch_token2] = ACTIONS(1967),
    [aux_sym_try_token2] = ACTIONS(1967),
    [aux_sym_try_token3] = ACTIONS(1967),
    [aux_sym_protect_token3] = ACTIONS(1967),
    [aux_sym_protect_token4] = ACTIONS(1967),
    [aux_sym_lock_token2] = ACTIONS(1967),
    [anon_sym_SEMI] = ACTIONS(1967),
    [aux_sym_relational_operator_token1] = ACTIONS(1967),
    [aux_sym_relational_operator_token2] = ACTIONS(1967),
    [aux_sym_relational_operator_token3] = ACTIONS(1967),
    [anon_sym_EQ] = ACTIONS(1967),
    [anon_sym_TILDE_EQ] = ACTIONS(1967),
    [anon_sym_LT_GT] = ACTIONS(1967),
    [anon_sym_GT_EQ] = ACTIONS(1967),
    [anon_sym_LT_EQ] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1967),
    [anon_sym_GT] = ACTIONS(1967),
    [aux_sym_logical_operator_token1] = ACTIONS(1967),
    [aux_sym_logical_operator_token2] = ACTIONS(1967),
    [aux_sym_logical_operator_token3] = ACTIONS(1967),
    [aux_sym_logical_operator_token4] = ACTIONS(1967),
    [aux_sym_logical_operator_token5] = ACTIONS(1967),
    [aux_sym_logical_operator_token6] = ACTIONS(1967),
    [anon_sym_STAR_STAR] = ACTIONS(1967),
    [anon_sym_STAR] = ACTIONS(1967),
    [anon_sym_SLASH] = ACTIONS(1967),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1967),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1967),
    [anon_sym_DASH] = ACTIONS(1967),
    [anon_sym_PLUS] = ACTIONS(1967),
    [sym_comment] = ACTIONS(3),
  },
  [565] = {
    [anon_sym_CR] = ACTIONS(1969),
    [anon_sym_LF] = ACTIONS(1969),
    [anon_sym_DOT] = ACTIONS(1969),
    [anon_sym_LPAREN] = ACTIONS(1969),
    [anon_sym_COMMA] = ACTIONS(1969),
    [anon_sym_LT_LT] = ACTIONS(1969),
    [anon_sym_CARET_LT_LT] = ACTIONS(1969),
    [anon_sym_LBRACK] = ACTIONS(1969),
    [aux_sym_method_token7] = ACTIONS(1969),
    [aux_sym_procedure_token2] = ACTIONS(1969),
    [aux_sym_block_token2] = ACTIONS(1969),
    [anon_sym__and_LT_LT] = ACTIONS(1969),
    [anon_sym__andif_LT_LT] = ACTIONS(1969),
    [anon_sym__or_LT_LT] = ACTIONS(1969),
    [anon_sym__orif_LT_LT] = ACTIONS(1969),
    [anon_sym__xor_LT_LT] = ACTIONS(1969),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1969),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1969),
    [anon_sym_STAR_LT_LT] = ACTIONS(1969),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1969),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1969),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1969),
    [anon_sym__mod_LT_LT] = ACTIONS(1969),
    [anon_sym__div_LT_LT] = ACTIONS(1969),
    [anon_sym_DASH_LT_LT] = ACTIONS(1969),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1969),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1969),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1969),
    [aux_sym_if_token3] = ACTIONS(1969),
    [aux_sym_elif_token1] = ACTIONS(1969),
    [aux_sym_else_token1] = ACTIONS(1969),
    [aux_sym_loop_token2] = ACTIONS(1969),
    [aux_sym_finally_token1] = ACTIONS(1969),
    [aux_sym_finally_token2] = ACTIONS(1969),
    [aux_sym_catch_token2] = ACTIONS(1969),
    [aux_sym_try_token2] = ACTIONS(1969),
    [aux_sym_try_token3] = ACTIONS(1969),
    [aux_sym_protect_token3] = ACTIONS(1969),
    [aux_sym_protect_token4] = ACTIONS(1969),
    [aux_sym_lock_token2] = ACTIONS(1969),
    [anon_sym_SEMI] = ACTIONS(1969),
    [aux_sym_relational_operator_token1] = ACTIONS(1969),
    [aux_sym_relational_operator_token2] = ACTIONS(1969),
    [aux_sym_relational_operator_token3] = ACTIONS(1969),
    [anon_sym_EQ] = ACTIONS(1969),
    [anon_sym_TILDE_EQ] = ACTIONS(1969),
    [anon_sym_LT_GT] = ACTIONS(1969),
    [anon_sym_GT_EQ] = ACTIONS(1969),
    [anon_sym_LT_EQ] = ACTIONS(1969),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_GT] = ACTIONS(1969),
    [aux_sym_logical_operator_token1] = ACTIONS(1969),
    [aux_sym_logical_operator_token2] = ACTIONS(1969),
    [aux_sym_logical_operator_token3] = ACTIONS(1969),
    [aux_sym_logical_operator_token4] = ACTIONS(1969),
    [aux_sym_logical_operator_token5] = ACTIONS(1969),
    [aux_sym_logical_operator_token6] = ACTIONS(1969),
    [anon_sym_STAR_STAR] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_SLASH] = ACTIONS(1969),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1969),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_PLUS] = ACTIONS(1969),
    [sym_comment] = ACTIONS(3),
  },
  [566] = {
    [sym__line_terminator] = STATE(14),
    [sym__terminator] = STATE(14),
    [aux_sym__codeblock_repeat1] = STATE(1030),
    [anon_sym_CR] = ACTIONS(1971),
    [anon_sym_LF] = ACTIONS(1973),
    [anon_sym_DOT] = ACTIONS(1975),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_LT_LT] = ACTIONS(1977),
    [anon_sym_CARET_LT_LT] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(1979),
    [aux_sym_procedure_token2] = ACTIONS(1979),
    [aux_sym_block_token2] = ACTIONS(1979),
    [anon_sym__and_LT_LT] = ACTIONS(1977),
    [anon_sym__andif_LT_LT] = ACTIONS(1977),
    [anon_sym__or_LT_LT] = ACTIONS(1977),
    [anon_sym__orif_LT_LT] = ACTIONS(1977),
    [anon_sym__xor_LT_LT] = ACTIONS(1977),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1977),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1977),
    [anon_sym_STAR_LT_LT] = ACTIONS(1977),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1977),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1977),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1977),
    [anon_sym__mod_LT_LT] = ACTIONS(1977),
    [anon_sym__div_LT_LT] = ACTIONS(1977),
    [anon_sym_DASH_LT_LT] = ACTIONS(1977),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1977),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1977),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1977),
    [aux_sym_if_token3] = ACTIONS(1979),
    [aux_sym_elif_token1] = ACTIONS(1979),
    [aux_sym_else_token1] = ACTIONS(1979),
    [aux_sym_loop_token2] = ACTIONS(1979),
    [aux_sym_finally_token1] = ACTIONS(1979),
    [aux_sym_catch_token2] = ACTIONS(1979),
    [aux_sym_try_token2] = ACTIONS(1979),
    [aux_sym_try_token3] = ACTIONS(1979),
    [aux_sym_protect_token4] = ACTIONS(1979),
    [aux_sym_lock_token2] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1973),
    [aux_sym_relational_operator_token1] = ACTIONS(1981),
    [aux_sym_relational_operator_token2] = ACTIONS(1981),
    [aux_sym_relational_operator_token3] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1981),
    [anon_sym_TILDE_EQ] = ACTIONS(1981),
    [anon_sym_LT_GT] = ACTIONS(1981),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1981),
    [anon_sym_LT] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1981),
    [aux_sym_logical_operator_token1] = ACTIONS(1983),
    [aux_sym_logical_operator_token2] = ACTIONS(1983),
    [aux_sym_logical_operator_token3] = ACTIONS(1983),
    [aux_sym_logical_operator_token4] = ACTIONS(1983),
    [aux_sym_logical_operator_token5] = ACTIONS(1983),
    [aux_sym_logical_operator_token6] = ACTIONS(1983),
    [anon_sym_STAR_STAR] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_SLASH] = ACTIONS(1985),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1985),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1985),
    [anon_sym_PLUS] = ACTIONS(1985),
    [sym_comment] = ACTIONS(3),
  },
  [567] = {
    [anon_sym_CR] = ACTIONS(1987),
    [anon_sym_LF] = ACTIONS(1987),
    [anon_sym_DOT] = ACTIONS(1987),
    [anon_sym_LPAREN] = ACTIONS(1987),
    [anon_sym_COMMA] = ACTIONS(1987),
    [anon_sym_LT_LT] = ACTIONS(1987),
    [anon_sym_CARET_LT_LT] = ACTIONS(1987),
    [anon_sym_LBRACK] = ACTIONS(1987),
    [aux_sym_method_token7] = ACTIONS(1987),
    [aux_sym_procedure_token2] = ACTIONS(1987),
    [aux_sym_block_token2] = ACTIONS(1987),
    [anon_sym__and_LT_LT] = ACTIONS(1987),
    [anon_sym__andif_LT_LT] = ACTIONS(1987),
    [anon_sym__or_LT_LT] = ACTIONS(1987),
    [anon_sym__orif_LT_LT] = ACTIONS(1987),
    [anon_sym__xor_LT_LT] = ACTIONS(1987),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1987),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1987),
    [anon_sym_STAR_LT_LT] = ACTIONS(1987),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1987),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1987),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1987),
    [anon_sym__mod_LT_LT] = ACTIONS(1987),
    [anon_sym__div_LT_LT] = ACTIONS(1987),
    [anon_sym_DASH_LT_LT] = ACTIONS(1987),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1987),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1987),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1987),
    [aux_sym_if_token3] = ACTIONS(1987),
    [aux_sym_elif_token1] = ACTIONS(1987),
    [aux_sym_else_token1] = ACTIONS(1987),
    [aux_sym_loop_token2] = ACTIONS(1987),
    [aux_sym_finally_token1] = ACTIONS(1987),
    [aux_sym_finally_token2] = ACTIONS(1987),
    [aux_sym_catch_token2] = ACTIONS(1987),
    [aux_sym_try_token2] = ACTIONS(1987),
    [aux_sym_try_token3] = ACTIONS(1987),
    [aux_sym_protect_token3] = ACTIONS(1987),
    [aux_sym_protect_token4] = ACTIONS(1987),
    [aux_sym_lock_token2] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1987),
    [aux_sym_relational_operator_token1] = ACTIONS(1987),
    [aux_sym_relational_operator_token2] = ACTIONS(1987),
    [aux_sym_relational_operator_token3] = ACTIONS(1987),
    [anon_sym_EQ] = ACTIONS(1987),
    [anon_sym_TILDE_EQ] = ACTIONS(1987),
    [anon_sym_LT_GT] = ACTIONS(1987),
    [anon_sym_GT_EQ] = ACTIONS(1987),
    [anon_sym_LT_EQ] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1987),
    [anon_sym_GT] = ACTIONS(1987),
    [aux_sym_logical_operator_token1] = ACTIONS(1987),
    [aux_sym_logical_operator_token2] = ACTIONS(1987),
    [aux_sym_logical_operator_token3] = ACTIONS(1987),
    [aux_sym_logical_operator_token4] = ACTIONS(1987),
    [aux_sym_logical_operator_token5] = ACTIONS(1987),
    [aux_sym_logical_operator_token6] = ACTIONS(1987),
    [anon_sym_STAR_STAR] = ACTIONS(1987),
    [anon_sym_STAR] = ACTIONS(1987),
    [anon_sym_SLASH] = ACTIONS(1987),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1987),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1987),
    [anon_sym_DASH] = ACTIONS(1987),
    [anon_sym_PLUS] = ACTIONS(1987),
    [sym_comment] = ACTIONS(3),
  },
  [568] = {
    [aux_sym_loopbody_repeat1] = STATE(538),
    [anon_sym_CR] = ACTIONS(1925),
    [anon_sym_LF] = ACTIONS(1925),
    [anon_sym_DOT] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1925),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(1925),
    [aux_sym_procedure_token2] = ACTIONS(1925),
    [aux_sym_block_token2] = ACTIONS(1925),
    [anon_sym__and_LT_LT] = ACTIONS(1833),
    [anon_sym__andif_LT_LT] = ACTIONS(1833),
    [anon_sym__or_LT_LT] = ACTIONS(1833),
    [anon_sym__orif_LT_LT] = ACTIONS(1833),
    [anon_sym__xor_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym__mod_LT_LT] = ACTIONS(1833),
    [anon_sym__div_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1833),
    [aux_sym_if_token3] = ACTIONS(1925),
    [aux_sym_elif_token1] = ACTIONS(1925),
    [aux_sym_else_token1] = ACTIONS(1925),
    [aux_sym_loop_token2] = ACTIONS(1925),
    [aux_sym_finally_token1] = ACTIONS(1925),
    [aux_sym_finally_token2] = ACTIONS(1925),
    [aux_sym_catch_token2] = ACTIONS(1925),
    [aux_sym_try_token2] = ACTIONS(1925),
    [aux_sym_try_token3] = ACTIONS(1925),
    [aux_sym_protect_token4] = ACTIONS(1925),
    [aux_sym_lock_token2] = ACTIONS(1925),
    [anon_sym_SEMI] = ACTIONS(1925),
    [aux_sym_relational_operator_token1] = ACTIONS(1837),
    [aux_sym_relational_operator_token2] = ACTIONS(1837),
    [aux_sym_relational_operator_token3] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_TILDE_EQ] = ACTIONS(1837),
    [anon_sym_LT_GT] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_GT] = ACTIONS(1837),
    [aux_sym_logical_operator_token1] = ACTIONS(1839),
    [aux_sym_logical_operator_token2] = ACTIONS(1839),
    [aux_sym_logical_operator_token3] = ACTIONS(1839),
    [aux_sym_logical_operator_token4] = ACTIONS(1839),
    [aux_sym_logical_operator_token5] = ACTIONS(1839),
    [aux_sym_logical_operator_token6] = ACTIONS(1839),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
  },
  [569] = {
    [anon_sym_CR] = ACTIONS(1989),
    [anon_sym_LF] = ACTIONS(1989),
    [anon_sym_DOT] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(1989),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_LT_LT] = ACTIONS(1989),
    [anon_sym_CARET_LT_LT] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [aux_sym_method_token7] = ACTIONS(1989),
    [aux_sym_procedure_token2] = ACTIONS(1989),
    [aux_sym_block_token2] = ACTIONS(1989),
    [anon_sym__and_LT_LT] = ACTIONS(1989),
    [anon_sym__andif_LT_LT] = ACTIONS(1989),
    [anon_sym__or_LT_LT] = ACTIONS(1989),
    [anon_sym__orif_LT_LT] = ACTIONS(1989),
    [anon_sym__xor_LT_LT] = ACTIONS(1989),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1989),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1989),
    [anon_sym_STAR_LT_LT] = ACTIONS(1989),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1989),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1989),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1989),
    [anon_sym__mod_LT_LT] = ACTIONS(1989),
    [anon_sym__div_LT_LT] = ACTIONS(1989),
    [anon_sym_DASH_LT_LT] = ACTIONS(1989),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1989),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1989),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1989),
    [aux_sym_if_token3] = ACTIONS(1989),
    [aux_sym_elif_token1] = ACTIONS(1989),
    [aux_sym_else_token1] = ACTIONS(1989),
    [aux_sym_loop_token2] = ACTIONS(1989),
    [aux_sym_finally_token1] = ACTIONS(1989),
    [aux_sym_finally_token2] = ACTIONS(1989),
    [aux_sym_catch_token2] = ACTIONS(1989),
    [aux_sym_try_token2] = ACTIONS(1989),
    [aux_sym_try_token3] = ACTIONS(1989),
    [aux_sym_protect_token3] = ACTIONS(1989),
    [aux_sym_protect_token4] = ACTIONS(1989),
    [aux_sym_lock_token2] = ACTIONS(1989),
    [anon_sym_SEMI] = ACTIONS(1989),
    [aux_sym_relational_operator_token1] = ACTIONS(1989),
    [aux_sym_relational_operator_token2] = ACTIONS(1989),
    [aux_sym_relational_operator_token3] = ACTIONS(1989),
    [anon_sym_EQ] = ACTIONS(1989),
    [anon_sym_TILDE_EQ] = ACTIONS(1989),
    [anon_sym_LT_GT] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1989),
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1989),
    [aux_sym_logical_operator_token1] = ACTIONS(1989),
    [aux_sym_logical_operator_token2] = ACTIONS(1989),
    [aux_sym_logical_operator_token3] = ACTIONS(1989),
    [aux_sym_logical_operator_token4] = ACTIONS(1989),
    [aux_sym_logical_operator_token5] = ACTIONS(1989),
    [aux_sym_logical_operator_token6] = ACTIONS(1989),
    [anon_sym_STAR_STAR] = ACTIONS(1989),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_SLASH] = ACTIONS(1989),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1989),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1989),
    [anon_sym_PLUS] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
  },
  [570] = {
    [anon_sym_CR] = ACTIONS(1991),
    [anon_sym_LF] = ACTIONS(1991),
    [anon_sym_DOT] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1991),
    [anon_sym_COMMA] = ACTIONS(1991),
    [anon_sym_LT_LT] = ACTIONS(1991),
    [anon_sym_CARET_LT_LT] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(1991),
    [aux_sym_method_token7] = ACTIONS(1991),
    [aux_sym_procedure_token2] = ACTIONS(1991),
    [aux_sym_block_token2] = ACTIONS(1991),
    [anon_sym__and_LT_LT] = ACTIONS(1991),
    [anon_sym__andif_LT_LT] = ACTIONS(1991),
    [anon_sym__or_LT_LT] = ACTIONS(1991),
    [anon_sym__orif_LT_LT] = ACTIONS(1991),
    [anon_sym__xor_LT_LT] = ACTIONS(1991),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1991),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1991),
    [anon_sym_STAR_LT_LT] = ACTIONS(1991),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1991),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1991),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1991),
    [anon_sym__mod_LT_LT] = ACTIONS(1991),
    [anon_sym__div_LT_LT] = ACTIONS(1991),
    [anon_sym_DASH_LT_LT] = ACTIONS(1991),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1991),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1991),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1991),
    [aux_sym_if_token3] = ACTIONS(1991),
    [aux_sym_elif_token1] = ACTIONS(1991),
    [aux_sym_else_token1] = ACTIONS(1991),
    [aux_sym_loop_token2] = ACTIONS(1991),
    [aux_sym_finally_token1] = ACTIONS(1991),
    [aux_sym_finally_token2] = ACTIONS(1991),
    [aux_sym_catch_token2] = ACTIONS(1991),
    [aux_sym_try_token2] = ACTIONS(1991),
    [aux_sym_try_token3] = ACTIONS(1991),
    [aux_sym_protect_token3] = ACTIONS(1991),
    [aux_sym_protect_token4] = ACTIONS(1991),
    [aux_sym_lock_token2] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1991),
    [aux_sym_relational_operator_token1] = ACTIONS(1991),
    [aux_sym_relational_operator_token2] = ACTIONS(1991),
    [aux_sym_relational_operator_token3] = ACTIONS(1991),
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_TILDE_EQ] = ACTIONS(1991),
    [anon_sym_LT_GT] = ACTIONS(1991),
    [anon_sym_GT_EQ] = ACTIONS(1991),
    [anon_sym_LT_EQ] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1991),
    [anon_sym_GT] = ACTIONS(1991),
    [aux_sym_logical_operator_token1] = ACTIONS(1991),
    [aux_sym_logical_operator_token2] = ACTIONS(1991),
    [aux_sym_logical_operator_token3] = ACTIONS(1991),
    [aux_sym_logical_operator_token4] = ACTIONS(1991),
    [aux_sym_logical_operator_token5] = ACTIONS(1991),
    [aux_sym_logical_operator_token6] = ACTIONS(1991),
    [anon_sym_STAR_STAR] = ACTIONS(1991),
    [anon_sym_STAR] = ACTIONS(1991),
    [anon_sym_SLASH] = ACTIONS(1991),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1991),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1991),
    [anon_sym_DASH] = ACTIONS(1991),
    [anon_sym_PLUS] = ACTIONS(1991),
    [sym_comment] = ACTIONS(3),
  },
  [571] = {
    [anon_sym_CR] = ACTIONS(1993),
    [anon_sym_LF] = ACTIONS(1993),
    [anon_sym_DOT] = ACTIONS(1993),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_COMMA] = ACTIONS(1993),
    [anon_sym_LT_LT] = ACTIONS(1993),
    [anon_sym_CARET_LT_LT] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [aux_sym_method_token7] = ACTIONS(1993),
    [aux_sym_procedure_token2] = ACTIONS(1993),
    [aux_sym_block_token2] = ACTIONS(1993),
    [anon_sym__and_LT_LT] = ACTIONS(1993),
    [anon_sym__andif_LT_LT] = ACTIONS(1993),
    [anon_sym__or_LT_LT] = ACTIONS(1993),
    [anon_sym__orif_LT_LT] = ACTIONS(1993),
    [anon_sym__xor_LT_LT] = ACTIONS(1993),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1993),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1993),
    [anon_sym_STAR_LT_LT] = ACTIONS(1993),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1993),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1993),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1993),
    [anon_sym__mod_LT_LT] = ACTIONS(1993),
    [anon_sym__div_LT_LT] = ACTIONS(1993),
    [anon_sym_DASH_LT_LT] = ACTIONS(1993),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1993),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1993),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1993),
    [aux_sym_if_token3] = ACTIONS(1993),
    [aux_sym_elif_token1] = ACTIONS(1993),
    [aux_sym_else_token1] = ACTIONS(1993),
    [aux_sym_loop_token2] = ACTIONS(1993),
    [aux_sym_finally_token1] = ACTIONS(1993),
    [aux_sym_finally_token2] = ACTIONS(1993),
    [aux_sym_catch_token2] = ACTIONS(1993),
    [aux_sym_try_token2] = ACTIONS(1993),
    [aux_sym_try_token3] = ACTIONS(1993),
    [aux_sym_protect_token3] = ACTIONS(1993),
    [aux_sym_protect_token4] = ACTIONS(1993),
    [aux_sym_lock_token2] = ACTIONS(1993),
    [anon_sym_SEMI] = ACTIONS(1993),
    [aux_sym_relational_operator_token1] = ACTIONS(1993),
    [aux_sym_relational_operator_token2] = ACTIONS(1993),
    [aux_sym_relational_operator_token3] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(1993),
    [anon_sym_TILDE_EQ] = ACTIONS(1993),
    [anon_sym_LT_GT] = ACTIONS(1993),
    [anon_sym_GT_EQ] = ACTIONS(1993),
    [anon_sym_LT_EQ] = ACTIONS(1993),
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_GT] = ACTIONS(1993),
    [aux_sym_logical_operator_token1] = ACTIONS(1993),
    [aux_sym_logical_operator_token2] = ACTIONS(1993),
    [aux_sym_logical_operator_token3] = ACTIONS(1993),
    [aux_sym_logical_operator_token4] = ACTIONS(1993),
    [aux_sym_logical_operator_token5] = ACTIONS(1993),
    [aux_sym_logical_operator_token6] = ACTIONS(1993),
    [anon_sym_STAR_STAR] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_SLASH] = ACTIONS(1993),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1993),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1993),
    [anon_sym_PLUS] = ACTIONS(1993),
    [sym_comment] = ACTIONS(3),
  },
  [572] = {
    [anon_sym_CR] = ACTIONS(1995),
    [anon_sym_LF] = ACTIONS(1995),
    [anon_sym_DOT] = ACTIONS(1995),
    [anon_sym_LPAREN] = ACTIONS(1995),
    [anon_sym_COMMA] = ACTIONS(1995),
    [anon_sym_LT_LT] = ACTIONS(1995),
    [anon_sym_CARET_LT_LT] = ACTIONS(1995),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [aux_sym_method_token7] = ACTIONS(1995),
    [aux_sym_procedure_token2] = ACTIONS(1995),
    [aux_sym_block_token2] = ACTIONS(1995),
    [anon_sym__and_LT_LT] = ACTIONS(1995),
    [anon_sym__andif_LT_LT] = ACTIONS(1995),
    [anon_sym__or_LT_LT] = ACTIONS(1995),
    [anon_sym__orif_LT_LT] = ACTIONS(1995),
    [anon_sym__xor_LT_LT] = ACTIONS(1995),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1995),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1995),
    [anon_sym_STAR_LT_LT] = ACTIONS(1995),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1995),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1995),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1995),
    [anon_sym__mod_LT_LT] = ACTIONS(1995),
    [anon_sym__div_LT_LT] = ACTIONS(1995),
    [anon_sym_DASH_LT_LT] = ACTIONS(1995),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1995),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1995),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1995),
    [aux_sym_if_token3] = ACTIONS(1995),
    [aux_sym_elif_token1] = ACTIONS(1995),
    [aux_sym_else_token1] = ACTIONS(1995),
    [aux_sym_loop_token2] = ACTIONS(1995),
    [aux_sym_finally_token1] = ACTIONS(1995),
    [aux_sym_finally_token2] = ACTIONS(1995),
    [aux_sym_catch_token2] = ACTIONS(1995),
    [aux_sym_try_token2] = ACTIONS(1995),
    [aux_sym_try_token3] = ACTIONS(1995),
    [aux_sym_protect_token3] = ACTIONS(1995),
    [aux_sym_protect_token4] = ACTIONS(1995),
    [aux_sym_lock_token2] = ACTIONS(1995),
    [anon_sym_SEMI] = ACTIONS(1995),
    [aux_sym_relational_operator_token1] = ACTIONS(1995),
    [aux_sym_relational_operator_token2] = ACTIONS(1995),
    [aux_sym_relational_operator_token3] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(1995),
    [anon_sym_TILDE_EQ] = ACTIONS(1995),
    [anon_sym_LT_GT] = ACTIONS(1995),
    [anon_sym_GT_EQ] = ACTIONS(1995),
    [anon_sym_LT_EQ] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1995),
    [anon_sym_GT] = ACTIONS(1995),
    [aux_sym_logical_operator_token1] = ACTIONS(1995),
    [aux_sym_logical_operator_token2] = ACTIONS(1995),
    [aux_sym_logical_operator_token3] = ACTIONS(1995),
    [aux_sym_logical_operator_token4] = ACTIONS(1995),
    [aux_sym_logical_operator_token5] = ACTIONS(1995),
    [aux_sym_logical_operator_token6] = ACTIONS(1995),
    [anon_sym_STAR_STAR] = ACTIONS(1995),
    [anon_sym_STAR] = ACTIONS(1995),
    [anon_sym_SLASH] = ACTIONS(1995),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1995),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1995),
    [anon_sym_DASH] = ACTIONS(1995),
    [anon_sym_PLUS] = ACTIONS(1995),
    [sym_comment] = ACTIONS(3),
  },
  [573] = {
    [anon_sym_CR] = ACTIONS(1997),
    [anon_sym_LF] = ACTIONS(1997),
    [anon_sym_DOT] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_COMMA] = ACTIONS(1997),
    [anon_sym_LT_LT] = ACTIONS(1997),
    [anon_sym_CARET_LT_LT] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [aux_sym_method_token7] = ACTIONS(1997),
    [aux_sym_procedure_token2] = ACTIONS(1997),
    [aux_sym_block_token2] = ACTIONS(1997),
    [anon_sym__and_LT_LT] = ACTIONS(1997),
    [anon_sym__andif_LT_LT] = ACTIONS(1997),
    [anon_sym__or_LT_LT] = ACTIONS(1997),
    [anon_sym__orif_LT_LT] = ACTIONS(1997),
    [anon_sym__xor_LT_LT] = ACTIONS(1997),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1997),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1997),
    [anon_sym_STAR_LT_LT] = ACTIONS(1997),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1997),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1997),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1997),
    [anon_sym__mod_LT_LT] = ACTIONS(1997),
    [anon_sym__div_LT_LT] = ACTIONS(1997),
    [anon_sym_DASH_LT_LT] = ACTIONS(1997),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1997),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1997),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1997),
    [aux_sym_if_token3] = ACTIONS(1997),
    [aux_sym_elif_token1] = ACTIONS(1997),
    [aux_sym_else_token1] = ACTIONS(1997),
    [aux_sym_loop_token2] = ACTIONS(1997),
    [aux_sym_finally_token1] = ACTIONS(1997),
    [aux_sym_finally_token2] = ACTIONS(1997),
    [aux_sym_catch_token2] = ACTIONS(1997),
    [aux_sym_try_token2] = ACTIONS(1997),
    [aux_sym_try_token3] = ACTIONS(1997),
    [aux_sym_protect_token3] = ACTIONS(1997),
    [aux_sym_protect_token4] = ACTIONS(1997),
    [aux_sym_lock_token2] = ACTIONS(1997),
    [anon_sym_SEMI] = ACTIONS(1997),
    [aux_sym_relational_operator_token1] = ACTIONS(1997),
    [aux_sym_relational_operator_token2] = ACTIONS(1997),
    [aux_sym_relational_operator_token3] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(1997),
    [anon_sym_TILDE_EQ] = ACTIONS(1997),
    [anon_sym_LT_GT] = ACTIONS(1997),
    [anon_sym_GT_EQ] = ACTIONS(1997),
    [anon_sym_LT_EQ] = ACTIONS(1997),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_GT] = ACTIONS(1997),
    [aux_sym_logical_operator_token1] = ACTIONS(1997),
    [aux_sym_logical_operator_token2] = ACTIONS(1997),
    [aux_sym_logical_operator_token3] = ACTIONS(1997),
    [aux_sym_logical_operator_token4] = ACTIONS(1997),
    [aux_sym_logical_operator_token5] = ACTIONS(1997),
    [aux_sym_logical_operator_token6] = ACTIONS(1997),
    [anon_sym_STAR_STAR] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_SLASH] = ACTIONS(1997),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1997),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_PLUS] = ACTIONS(1997),
    [sym_comment] = ACTIONS(3),
  },
  [574] = {
    [aux_sym_loopbody_repeat1] = STATE(540),
    [anon_sym_CR] = ACTIONS(1825),
    [anon_sym_LF] = ACTIONS(1825),
    [anon_sym_DOT] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1825),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(1825),
    [aux_sym_procedure_token2] = ACTIONS(1825),
    [aux_sym_block_token2] = ACTIONS(1825),
    [anon_sym__and_LT_LT] = ACTIONS(1833),
    [anon_sym__andif_LT_LT] = ACTIONS(1833),
    [anon_sym__or_LT_LT] = ACTIONS(1833),
    [anon_sym__orif_LT_LT] = ACTIONS(1833),
    [anon_sym__xor_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym__mod_LT_LT] = ACTIONS(1833),
    [anon_sym__div_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1833),
    [aux_sym_if_token3] = ACTIONS(1825),
    [aux_sym_elif_token1] = ACTIONS(1825),
    [aux_sym_else_token1] = ACTIONS(1825),
    [aux_sym_loop_token2] = ACTIONS(1825),
    [aux_sym_finally_token1] = ACTIONS(1825),
    [aux_sym_finally_token2] = ACTIONS(1825),
    [aux_sym_catch_token2] = ACTIONS(1825),
    [aux_sym_try_token2] = ACTIONS(1825),
    [aux_sym_try_token3] = ACTIONS(1825),
    [aux_sym_protect_token4] = ACTIONS(1825),
    [aux_sym_lock_token2] = ACTIONS(1825),
    [anon_sym_SEMI] = ACTIONS(1825),
    [aux_sym_relational_operator_token1] = ACTIONS(1837),
    [aux_sym_relational_operator_token2] = ACTIONS(1837),
    [aux_sym_relational_operator_token3] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_TILDE_EQ] = ACTIONS(1837),
    [anon_sym_LT_GT] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_GT] = ACTIONS(1837),
    [aux_sym_logical_operator_token1] = ACTIONS(1839),
    [aux_sym_logical_operator_token2] = ACTIONS(1839),
    [aux_sym_logical_operator_token3] = ACTIONS(1839),
    [aux_sym_logical_operator_token4] = ACTIONS(1839),
    [aux_sym_logical_operator_token5] = ACTIONS(1839),
    [aux_sym_logical_operator_token6] = ACTIONS(1839),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
  },
  [575] = {
    [anon_sym_CR] = ACTIONS(1999),
    [anon_sym_LF] = ACTIONS(1999),
    [anon_sym_DOT] = ACTIONS(1999),
    [anon_sym_LPAREN] = ACTIONS(1999),
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_LT_LT] = ACTIONS(1999),
    [anon_sym_CARET_LT_LT] = ACTIONS(1999),
    [anon_sym_LBRACK] = ACTIONS(1999),
    [aux_sym_method_token7] = ACTIONS(1999),
    [aux_sym_procedure_token2] = ACTIONS(1999),
    [aux_sym_block_token2] = ACTIONS(1999),
    [anon_sym__and_LT_LT] = ACTIONS(1999),
    [anon_sym__andif_LT_LT] = ACTIONS(1999),
    [anon_sym__or_LT_LT] = ACTIONS(1999),
    [anon_sym__orif_LT_LT] = ACTIONS(1999),
    [anon_sym__xor_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR_LT_LT] = ACTIONS(1999),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1999),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1999),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1999),
    [anon_sym__mod_LT_LT] = ACTIONS(1999),
    [anon_sym__div_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH_LT_LT] = ACTIONS(1999),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1999),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1999),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1999),
    [aux_sym_if_token3] = ACTIONS(1999),
    [aux_sym_elif_token1] = ACTIONS(1999),
    [aux_sym_else_token1] = ACTIONS(1999),
    [aux_sym_loop_token2] = ACTIONS(1999),
    [aux_sym_finally_token1] = ACTIONS(1999),
    [aux_sym_finally_token2] = ACTIONS(1999),
    [aux_sym_catch_token2] = ACTIONS(1999),
    [aux_sym_try_token2] = ACTIONS(1999),
    [aux_sym_try_token3] = ACTIONS(1999),
    [aux_sym_protect_token3] = ACTIONS(1999),
    [aux_sym_protect_token4] = ACTIONS(1999),
    [aux_sym_lock_token2] = ACTIONS(1999),
    [anon_sym_SEMI] = ACTIONS(1999),
    [aux_sym_relational_operator_token1] = ACTIONS(1999),
    [aux_sym_relational_operator_token2] = ACTIONS(1999),
    [aux_sym_relational_operator_token3] = ACTIONS(1999),
    [anon_sym_EQ] = ACTIONS(1999),
    [anon_sym_TILDE_EQ] = ACTIONS(1999),
    [anon_sym_LT_GT] = ACTIONS(1999),
    [anon_sym_GT_EQ] = ACTIONS(1999),
    [anon_sym_LT_EQ] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(1999),
    [anon_sym_GT] = ACTIONS(1999),
    [aux_sym_logical_operator_token1] = ACTIONS(1999),
    [aux_sym_logical_operator_token2] = ACTIONS(1999),
    [aux_sym_logical_operator_token3] = ACTIONS(1999),
    [aux_sym_logical_operator_token4] = ACTIONS(1999),
    [aux_sym_logical_operator_token5] = ACTIONS(1999),
    [aux_sym_logical_operator_token6] = ACTIONS(1999),
    [anon_sym_STAR_STAR] = ACTIONS(1999),
    [anon_sym_STAR] = ACTIONS(1999),
    [anon_sym_SLASH] = ACTIONS(1999),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1999),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1999),
    [anon_sym_DASH] = ACTIONS(1999),
    [anon_sym_PLUS] = ACTIONS(1999),
    [sym_comment] = ACTIONS(3),
  },
  [576] = {
    [aux_sym_loopbody_repeat1] = STATE(541),
    [anon_sym_CR] = ACTIONS(1845),
    [anon_sym_LF] = ACTIONS(1845),
    [anon_sym_DOT] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1845),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(1845),
    [aux_sym_procedure_token2] = ACTIONS(1845),
    [aux_sym_block_token2] = ACTIONS(1845),
    [anon_sym__and_LT_LT] = ACTIONS(1833),
    [anon_sym__andif_LT_LT] = ACTIONS(1833),
    [anon_sym__or_LT_LT] = ACTIONS(1833),
    [anon_sym__orif_LT_LT] = ACTIONS(1833),
    [anon_sym__xor_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym__mod_LT_LT] = ACTIONS(1833),
    [anon_sym__div_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1833),
    [aux_sym_if_token3] = ACTIONS(1845),
    [aux_sym_elif_token1] = ACTIONS(1845),
    [aux_sym_else_token1] = ACTIONS(1845),
    [aux_sym_loop_token2] = ACTIONS(1845),
    [aux_sym_finally_token1] = ACTIONS(1845),
    [aux_sym_finally_token2] = ACTIONS(1845),
    [aux_sym_catch_token2] = ACTIONS(1845),
    [aux_sym_try_token2] = ACTIONS(1845),
    [aux_sym_try_token3] = ACTIONS(1845),
    [aux_sym_protect_token4] = ACTIONS(1845),
    [aux_sym_lock_token2] = ACTIONS(1845),
    [anon_sym_SEMI] = ACTIONS(1845),
    [aux_sym_relational_operator_token1] = ACTIONS(1837),
    [aux_sym_relational_operator_token2] = ACTIONS(1837),
    [aux_sym_relational_operator_token3] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_TILDE_EQ] = ACTIONS(1837),
    [anon_sym_LT_GT] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_GT] = ACTIONS(1837),
    [aux_sym_logical_operator_token1] = ACTIONS(1839),
    [aux_sym_logical_operator_token2] = ACTIONS(1839),
    [aux_sym_logical_operator_token3] = ACTIONS(1839),
    [aux_sym_logical_operator_token4] = ACTIONS(1839),
    [aux_sym_logical_operator_token5] = ACTIONS(1839),
    [aux_sym_logical_operator_token6] = ACTIONS(1839),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
  },
  [577] = {
    [anon_sym_CR] = ACTIONS(2001),
    [anon_sym_LF] = ACTIONS(2001),
    [anon_sym_DOT] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_COMMA] = ACTIONS(2001),
    [anon_sym_LT_LT] = ACTIONS(2001),
    [anon_sym_CARET_LT_LT] = ACTIONS(2001),
    [anon_sym_LBRACK] = ACTIONS(2001),
    [aux_sym_method_token7] = ACTIONS(2001),
    [aux_sym_procedure_token2] = ACTIONS(2001),
    [aux_sym_block_token2] = ACTIONS(2001),
    [anon_sym__and_LT_LT] = ACTIONS(2001),
    [anon_sym__andif_LT_LT] = ACTIONS(2001),
    [anon_sym__or_LT_LT] = ACTIONS(2001),
    [anon_sym__orif_LT_LT] = ACTIONS(2001),
    [anon_sym__xor_LT_LT] = ACTIONS(2001),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2001),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2001),
    [anon_sym_STAR_LT_LT] = ACTIONS(2001),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2001),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2001),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2001),
    [anon_sym__mod_LT_LT] = ACTIONS(2001),
    [anon_sym__div_LT_LT] = ACTIONS(2001),
    [anon_sym_DASH_LT_LT] = ACTIONS(2001),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2001),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2001),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2001),
    [aux_sym_if_token3] = ACTIONS(2001),
    [aux_sym_elif_token1] = ACTIONS(2001),
    [aux_sym_else_token1] = ACTIONS(2001),
    [aux_sym_loop_token2] = ACTIONS(2001),
    [aux_sym_finally_token1] = ACTIONS(2001),
    [aux_sym_finally_token2] = ACTIONS(2001),
    [aux_sym_catch_token2] = ACTIONS(2001),
    [aux_sym_try_token2] = ACTIONS(2001),
    [aux_sym_try_token3] = ACTIONS(2001),
    [aux_sym_protect_token3] = ACTIONS(2001),
    [aux_sym_protect_token4] = ACTIONS(2001),
    [aux_sym_lock_token2] = ACTIONS(2001),
    [anon_sym_SEMI] = ACTIONS(2001),
    [aux_sym_relational_operator_token1] = ACTIONS(2001),
    [aux_sym_relational_operator_token2] = ACTIONS(2001),
    [aux_sym_relational_operator_token3] = ACTIONS(2001),
    [anon_sym_EQ] = ACTIONS(2001),
    [anon_sym_TILDE_EQ] = ACTIONS(2001),
    [anon_sym_LT_GT] = ACTIONS(2001),
    [anon_sym_GT_EQ] = ACTIONS(2001),
    [anon_sym_LT_EQ] = ACTIONS(2001),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_GT] = ACTIONS(2001),
    [aux_sym_logical_operator_token1] = ACTIONS(2001),
    [aux_sym_logical_operator_token2] = ACTIONS(2001),
    [aux_sym_logical_operator_token3] = ACTIONS(2001),
    [aux_sym_logical_operator_token4] = ACTIONS(2001),
    [aux_sym_logical_operator_token5] = ACTIONS(2001),
    [aux_sym_logical_operator_token6] = ACTIONS(2001),
    [anon_sym_STAR_STAR] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_SLASH] = ACTIONS(2001),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2001),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2001),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_PLUS] = ACTIONS(2001),
    [sym_comment] = ACTIONS(3),
  },
  [578] = {
    [anon_sym_CR] = ACTIONS(2003),
    [anon_sym_LF] = ACTIONS(2003),
    [anon_sym_DOT] = ACTIONS(2003),
    [anon_sym_LPAREN] = ACTIONS(2003),
    [anon_sym_COMMA] = ACTIONS(2003),
    [anon_sym_LT_LT] = ACTIONS(2003),
    [anon_sym_CARET_LT_LT] = ACTIONS(2003),
    [anon_sym_LBRACK] = ACTIONS(2003),
    [aux_sym_method_token7] = ACTIONS(2003),
    [aux_sym_procedure_token2] = ACTIONS(2003),
    [aux_sym_block_token2] = ACTIONS(2003),
    [anon_sym__and_LT_LT] = ACTIONS(2003),
    [anon_sym__andif_LT_LT] = ACTIONS(2003),
    [anon_sym__or_LT_LT] = ACTIONS(2003),
    [anon_sym__orif_LT_LT] = ACTIONS(2003),
    [anon_sym__xor_LT_LT] = ACTIONS(2003),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2003),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2003),
    [anon_sym_STAR_LT_LT] = ACTIONS(2003),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2003),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2003),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2003),
    [anon_sym__mod_LT_LT] = ACTIONS(2003),
    [anon_sym__div_LT_LT] = ACTIONS(2003),
    [anon_sym_DASH_LT_LT] = ACTIONS(2003),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2003),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2003),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2003),
    [aux_sym_if_token3] = ACTIONS(2003),
    [aux_sym_elif_token1] = ACTIONS(2003),
    [aux_sym_else_token1] = ACTIONS(2003),
    [aux_sym_loop_token2] = ACTIONS(2003),
    [aux_sym_finally_token1] = ACTIONS(2003),
    [aux_sym_finally_token2] = ACTIONS(2003),
    [aux_sym_catch_token2] = ACTIONS(2003),
    [aux_sym_try_token2] = ACTIONS(2003),
    [aux_sym_try_token3] = ACTIONS(2003),
    [aux_sym_protect_token3] = ACTIONS(2003),
    [aux_sym_protect_token4] = ACTIONS(2003),
    [aux_sym_lock_token2] = ACTIONS(2003),
    [anon_sym_SEMI] = ACTIONS(2003),
    [aux_sym_relational_operator_token1] = ACTIONS(2003),
    [aux_sym_relational_operator_token2] = ACTIONS(2003),
    [aux_sym_relational_operator_token3] = ACTIONS(2003),
    [anon_sym_EQ] = ACTIONS(2003),
    [anon_sym_TILDE_EQ] = ACTIONS(2003),
    [anon_sym_LT_GT] = ACTIONS(2003),
    [anon_sym_GT_EQ] = ACTIONS(2003),
    [anon_sym_LT_EQ] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(2003),
    [anon_sym_GT] = ACTIONS(2003),
    [aux_sym_logical_operator_token1] = ACTIONS(2003),
    [aux_sym_logical_operator_token2] = ACTIONS(2003),
    [aux_sym_logical_operator_token3] = ACTIONS(2003),
    [aux_sym_logical_operator_token4] = ACTIONS(2003),
    [aux_sym_logical_operator_token5] = ACTIONS(2003),
    [aux_sym_logical_operator_token6] = ACTIONS(2003),
    [anon_sym_STAR_STAR] = ACTIONS(2003),
    [anon_sym_STAR] = ACTIONS(2003),
    [anon_sym_SLASH] = ACTIONS(2003),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2003),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2003),
    [anon_sym_DASH] = ACTIONS(2003),
    [anon_sym_PLUS] = ACTIONS(2003),
    [sym_comment] = ACTIONS(3),
  },
  [579] = {
    [anon_sym_CR] = ACTIONS(2005),
    [anon_sym_LF] = ACTIONS(2005),
    [anon_sym_DOT] = ACTIONS(2005),
    [anon_sym_LPAREN] = ACTIONS(2005),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LT_LT] = ACTIONS(2005),
    [anon_sym_CARET_LT_LT] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [aux_sym_method_token7] = ACTIONS(2005),
    [aux_sym_procedure_token2] = ACTIONS(2005),
    [aux_sym_block_token2] = ACTIONS(2005),
    [anon_sym__and_LT_LT] = ACTIONS(2005),
    [anon_sym__andif_LT_LT] = ACTIONS(2005),
    [anon_sym__or_LT_LT] = ACTIONS(2005),
    [anon_sym__orif_LT_LT] = ACTIONS(2005),
    [anon_sym__xor_LT_LT] = ACTIONS(2005),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2005),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2005),
    [anon_sym_STAR_LT_LT] = ACTIONS(2005),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2005),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2005),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2005),
    [anon_sym__mod_LT_LT] = ACTIONS(2005),
    [anon_sym__div_LT_LT] = ACTIONS(2005),
    [anon_sym_DASH_LT_LT] = ACTIONS(2005),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2005),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2005),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2005),
    [aux_sym_if_token3] = ACTIONS(2005),
    [aux_sym_elif_token1] = ACTIONS(2005),
    [aux_sym_else_token1] = ACTIONS(2005),
    [aux_sym_loop_token2] = ACTIONS(2005),
    [aux_sym_finally_token1] = ACTIONS(2005),
    [aux_sym_finally_token2] = ACTIONS(2005),
    [aux_sym_catch_token2] = ACTIONS(2005),
    [aux_sym_try_token2] = ACTIONS(2005),
    [aux_sym_try_token3] = ACTIONS(2005),
    [aux_sym_protect_token3] = ACTIONS(2005),
    [aux_sym_protect_token4] = ACTIONS(2005),
    [aux_sym_lock_token2] = ACTIONS(2005),
    [anon_sym_SEMI] = ACTIONS(2005),
    [aux_sym_relational_operator_token1] = ACTIONS(2005),
    [aux_sym_relational_operator_token2] = ACTIONS(2005),
    [aux_sym_relational_operator_token3] = ACTIONS(2005),
    [anon_sym_EQ] = ACTIONS(2005),
    [anon_sym_TILDE_EQ] = ACTIONS(2005),
    [anon_sym_LT_GT] = ACTIONS(2005),
    [anon_sym_GT_EQ] = ACTIONS(2005),
    [anon_sym_LT_EQ] = ACTIONS(2005),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_GT] = ACTIONS(2005),
    [aux_sym_logical_operator_token1] = ACTIONS(2005),
    [aux_sym_logical_operator_token2] = ACTIONS(2005),
    [aux_sym_logical_operator_token3] = ACTIONS(2005),
    [aux_sym_logical_operator_token4] = ACTIONS(2005),
    [aux_sym_logical_operator_token5] = ACTIONS(2005),
    [aux_sym_logical_operator_token6] = ACTIONS(2005),
    [anon_sym_STAR_STAR] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2005),
    [anon_sym_SLASH] = ACTIONS(2005),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2005),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_PLUS] = ACTIONS(2005),
    [sym_comment] = ACTIONS(3),
  },
  [580] = {
    [anon_sym_CR] = ACTIONS(2007),
    [anon_sym_LF] = ACTIONS(2007),
    [anon_sym_DOT] = ACTIONS(2007),
    [anon_sym_LPAREN] = ACTIONS(2007),
    [anon_sym_COMMA] = ACTIONS(2007),
    [anon_sym_LT_LT] = ACTIONS(2007),
    [anon_sym_CARET_LT_LT] = ACTIONS(2007),
    [anon_sym_LBRACK] = ACTIONS(2007),
    [aux_sym_method_token7] = ACTIONS(2007),
    [aux_sym_procedure_token2] = ACTIONS(2007),
    [aux_sym_block_token2] = ACTIONS(2007),
    [anon_sym__and_LT_LT] = ACTIONS(2007),
    [anon_sym__andif_LT_LT] = ACTIONS(2007),
    [anon_sym__or_LT_LT] = ACTIONS(2007),
    [anon_sym__orif_LT_LT] = ACTIONS(2007),
    [anon_sym__xor_LT_LT] = ACTIONS(2007),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2007),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2007),
    [anon_sym_STAR_LT_LT] = ACTIONS(2007),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2007),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2007),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2007),
    [anon_sym__mod_LT_LT] = ACTIONS(2007),
    [anon_sym__div_LT_LT] = ACTIONS(2007),
    [anon_sym_DASH_LT_LT] = ACTIONS(2007),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2007),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2007),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2007),
    [aux_sym_if_token3] = ACTIONS(2007),
    [aux_sym_elif_token1] = ACTIONS(2007),
    [aux_sym_else_token1] = ACTIONS(2007),
    [aux_sym_loop_token2] = ACTIONS(2007),
    [aux_sym_finally_token1] = ACTIONS(2007),
    [aux_sym_finally_token2] = ACTIONS(2007),
    [aux_sym_catch_token2] = ACTIONS(2007),
    [aux_sym_try_token2] = ACTIONS(2007),
    [aux_sym_try_token3] = ACTIONS(2007),
    [aux_sym_protect_token3] = ACTIONS(2007),
    [aux_sym_protect_token4] = ACTIONS(2007),
    [aux_sym_lock_token2] = ACTIONS(2007),
    [anon_sym_SEMI] = ACTIONS(2007),
    [aux_sym_relational_operator_token1] = ACTIONS(2007),
    [aux_sym_relational_operator_token2] = ACTIONS(2007),
    [aux_sym_relational_operator_token3] = ACTIONS(2007),
    [anon_sym_EQ] = ACTIONS(2007),
    [anon_sym_TILDE_EQ] = ACTIONS(2007),
    [anon_sym_LT_GT] = ACTIONS(2007),
    [anon_sym_GT_EQ] = ACTIONS(2007),
    [anon_sym_LT_EQ] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2007),
    [anon_sym_GT] = ACTIONS(2007),
    [aux_sym_logical_operator_token1] = ACTIONS(2007),
    [aux_sym_logical_operator_token2] = ACTIONS(2007),
    [aux_sym_logical_operator_token3] = ACTIONS(2007),
    [aux_sym_logical_operator_token4] = ACTIONS(2007),
    [aux_sym_logical_operator_token5] = ACTIONS(2007),
    [aux_sym_logical_operator_token6] = ACTIONS(2007),
    [anon_sym_STAR_STAR] = ACTIONS(2007),
    [anon_sym_STAR] = ACTIONS(2007),
    [anon_sym_SLASH] = ACTIONS(2007),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2007),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2007),
    [anon_sym_DASH] = ACTIONS(2007),
    [anon_sym_PLUS] = ACTIONS(2007),
    [sym_comment] = ACTIONS(3),
  },
  [581] = {
    [anon_sym_CR] = ACTIONS(2009),
    [anon_sym_LF] = ACTIONS(2009),
    [anon_sym_DOT] = ACTIONS(2009),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_COMMA] = ACTIONS(2009),
    [anon_sym_LT_LT] = ACTIONS(2009),
    [anon_sym_CARET_LT_LT] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2009),
    [aux_sym_method_token7] = ACTIONS(2009),
    [aux_sym_procedure_token2] = ACTIONS(2009),
    [aux_sym_block_token2] = ACTIONS(2009),
    [anon_sym__and_LT_LT] = ACTIONS(2009),
    [anon_sym__andif_LT_LT] = ACTIONS(2009),
    [anon_sym__or_LT_LT] = ACTIONS(2009),
    [anon_sym__orif_LT_LT] = ACTIONS(2009),
    [anon_sym__xor_LT_LT] = ACTIONS(2009),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2009),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2009),
    [anon_sym_STAR_LT_LT] = ACTIONS(2009),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2009),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2009),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2009),
    [anon_sym__mod_LT_LT] = ACTIONS(2009),
    [anon_sym__div_LT_LT] = ACTIONS(2009),
    [anon_sym_DASH_LT_LT] = ACTIONS(2009),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2009),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2009),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2009),
    [aux_sym_if_token3] = ACTIONS(2009),
    [aux_sym_elif_token1] = ACTIONS(2009),
    [aux_sym_else_token1] = ACTIONS(2009),
    [aux_sym_loop_token2] = ACTIONS(2009),
    [aux_sym_finally_token1] = ACTIONS(2009),
    [aux_sym_finally_token2] = ACTIONS(2009),
    [aux_sym_catch_token2] = ACTIONS(2009),
    [aux_sym_try_token2] = ACTIONS(2009),
    [aux_sym_try_token3] = ACTIONS(2009),
    [aux_sym_protect_token3] = ACTIONS(2009),
    [aux_sym_protect_token4] = ACTIONS(2009),
    [aux_sym_lock_token2] = ACTIONS(2009),
    [anon_sym_SEMI] = ACTIONS(2009),
    [aux_sym_relational_operator_token1] = ACTIONS(2009),
    [aux_sym_relational_operator_token2] = ACTIONS(2009),
    [aux_sym_relational_operator_token3] = ACTIONS(2009),
    [anon_sym_EQ] = ACTIONS(2009),
    [anon_sym_TILDE_EQ] = ACTIONS(2009),
    [anon_sym_LT_GT] = ACTIONS(2009),
    [anon_sym_GT_EQ] = ACTIONS(2009),
    [anon_sym_LT_EQ] = ACTIONS(2009),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_GT] = ACTIONS(2009),
    [aux_sym_logical_operator_token1] = ACTIONS(2009),
    [aux_sym_logical_operator_token2] = ACTIONS(2009),
    [aux_sym_logical_operator_token3] = ACTIONS(2009),
    [aux_sym_logical_operator_token4] = ACTIONS(2009),
    [aux_sym_logical_operator_token5] = ACTIONS(2009),
    [aux_sym_logical_operator_token6] = ACTIONS(2009),
    [anon_sym_STAR_STAR] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(2009),
    [anon_sym_SLASH] = ACTIONS(2009),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2009),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2009),
    [anon_sym_DASH] = ACTIONS(2009),
    [anon_sym_PLUS] = ACTIONS(2009),
    [sym_comment] = ACTIONS(3),
  },
  [582] = {
    [anon_sym_CR] = ACTIONS(2011),
    [anon_sym_LF] = ACTIONS(2011),
    [anon_sym_DOT] = ACTIONS(2011),
    [anon_sym_LPAREN] = ACTIONS(2011),
    [anon_sym_COMMA] = ACTIONS(2011),
    [anon_sym_LT_LT] = ACTIONS(2011),
    [anon_sym_CARET_LT_LT] = ACTIONS(2011),
    [anon_sym_LBRACK] = ACTIONS(2011),
    [aux_sym_method_token7] = ACTIONS(2011),
    [aux_sym_procedure_token2] = ACTIONS(2011),
    [aux_sym_block_token2] = ACTIONS(2011),
    [anon_sym__and_LT_LT] = ACTIONS(2011),
    [anon_sym__andif_LT_LT] = ACTIONS(2011),
    [anon_sym__or_LT_LT] = ACTIONS(2011),
    [anon_sym__orif_LT_LT] = ACTIONS(2011),
    [anon_sym__xor_LT_LT] = ACTIONS(2011),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2011),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2011),
    [anon_sym_STAR_LT_LT] = ACTIONS(2011),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2011),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2011),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2011),
    [anon_sym__mod_LT_LT] = ACTIONS(2011),
    [anon_sym__div_LT_LT] = ACTIONS(2011),
    [anon_sym_DASH_LT_LT] = ACTIONS(2011),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2011),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2011),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2011),
    [aux_sym_if_token3] = ACTIONS(2011),
    [aux_sym_elif_token1] = ACTIONS(2011),
    [aux_sym_else_token1] = ACTIONS(2011),
    [aux_sym_loop_token2] = ACTIONS(2011),
    [aux_sym_finally_token1] = ACTIONS(2011),
    [aux_sym_finally_token2] = ACTIONS(2011),
    [aux_sym_catch_token2] = ACTIONS(2011),
    [aux_sym_try_token2] = ACTIONS(2011),
    [aux_sym_try_token3] = ACTIONS(2011),
    [aux_sym_protect_token3] = ACTIONS(2011),
    [aux_sym_protect_token4] = ACTIONS(2011),
    [aux_sym_lock_token2] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2011),
    [aux_sym_relational_operator_token1] = ACTIONS(2011),
    [aux_sym_relational_operator_token2] = ACTIONS(2011),
    [aux_sym_relational_operator_token3] = ACTIONS(2011),
    [anon_sym_EQ] = ACTIONS(2011),
    [anon_sym_TILDE_EQ] = ACTIONS(2011),
    [anon_sym_LT_GT] = ACTIONS(2011),
    [anon_sym_GT_EQ] = ACTIONS(2011),
    [anon_sym_LT_EQ] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2011),
    [anon_sym_GT] = ACTIONS(2011),
    [aux_sym_logical_operator_token1] = ACTIONS(2011),
    [aux_sym_logical_operator_token2] = ACTIONS(2011),
    [aux_sym_logical_operator_token3] = ACTIONS(2011),
    [aux_sym_logical_operator_token4] = ACTIONS(2011),
    [aux_sym_logical_operator_token5] = ACTIONS(2011),
    [aux_sym_logical_operator_token6] = ACTIONS(2011),
    [anon_sym_STAR_STAR] = ACTIONS(2011),
    [anon_sym_STAR] = ACTIONS(2011),
    [anon_sym_SLASH] = ACTIONS(2011),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2011),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2011),
    [anon_sym_DASH] = ACTIONS(2011),
    [anon_sym_PLUS] = ACTIONS(2011),
    [sym_comment] = ACTIONS(3),
  },
  [583] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(2013),
    [anon_sym_LF] = ACTIONS(2013),
    [anon_sym_DOT] = ACTIONS(2013),
    [anon_sym_LPAREN] = ACTIONS(2013),
    [anon_sym_COMMA] = ACTIONS(2015),
    [anon_sym_LT_LT] = ACTIONS(2013),
    [anon_sym_CARET_LT_LT] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(2013),
    [aux_sym_method_token7] = ACTIONS(2013),
    [aux_sym_procedure_token2] = ACTIONS(2013),
    [aux_sym_block_token2] = ACTIONS(2013),
    [anon_sym__and_LT_LT] = ACTIONS(2013),
    [anon_sym__andif_LT_LT] = ACTIONS(2013),
    [anon_sym__or_LT_LT] = ACTIONS(2013),
    [anon_sym__orif_LT_LT] = ACTIONS(2013),
    [anon_sym__xor_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR_LT_LT] = ACTIONS(2013),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2013),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2013),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2013),
    [anon_sym__mod_LT_LT] = ACTIONS(2013),
    [anon_sym__div_LT_LT] = ACTIONS(2013),
    [anon_sym_DASH_LT_LT] = ACTIONS(2013),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2013),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2013),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2013),
    [aux_sym_if_token3] = ACTIONS(2013),
    [aux_sym_elif_token1] = ACTIONS(2013),
    [aux_sym_else_token1] = ACTIONS(2013),
    [aux_sym_loop_token2] = ACTIONS(2013),
    [aux_sym_finally_token1] = ACTIONS(2013),
    [aux_sym_finally_token2] = ACTIONS(2013),
    [aux_sym_catch_token2] = ACTIONS(2013),
    [aux_sym_try_token2] = ACTIONS(2013),
    [aux_sym_try_token3] = ACTIONS(2013),
    [aux_sym_protect_token4] = ACTIONS(2013),
    [aux_sym_lock_token2] = ACTIONS(2013),
    [anon_sym_SEMI] = ACTIONS(2013),
    [aux_sym_relational_operator_token1] = ACTIONS(2013),
    [aux_sym_relational_operator_token2] = ACTIONS(2013),
    [aux_sym_relational_operator_token3] = ACTIONS(2013),
    [anon_sym_EQ] = ACTIONS(2013),
    [anon_sym_TILDE_EQ] = ACTIONS(2013),
    [anon_sym_LT_GT] = ACTIONS(2013),
    [anon_sym_GT_EQ] = ACTIONS(2013),
    [anon_sym_LT_EQ] = ACTIONS(2013),
    [anon_sym_LT] = ACTIONS(2013),
    [anon_sym_GT] = ACTIONS(2013),
    [aux_sym_logical_operator_token1] = ACTIONS(2013),
    [aux_sym_logical_operator_token2] = ACTIONS(2013),
    [aux_sym_logical_operator_token3] = ACTIONS(2013),
    [aux_sym_logical_operator_token4] = ACTIONS(2013),
    [aux_sym_logical_operator_token5] = ACTIONS(2013),
    [aux_sym_logical_operator_token6] = ACTIONS(2013),
    [anon_sym_STAR_STAR] = ACTIONS(2013),
    [anon_sym_STAR] = ACTIONS(2013),
    [anon_sym_SLASH] = ACTIONS(2013),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2013),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2013),
    [anon_sym_DASH] = ACTIONS(2013),
    [anon_sym_PLUS] = ACTIONS(2013),
    [sym_comment] = ACTIONS(3),
  },
  [584] = {
    [aux_sym_loopbody_repeat1] = STATE(585),
    [anon_sym_CR] = ACTIONS(2018),
    [anon_sym_LF] = ACTIONS(2018),
    [anon_sym_DOT] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(1833),
    [anon_sym_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [aux_sym_method_token7] = ACTIONS(2018),
    [aux_sym_procedure_token2] = ACTIONS(2018),
    [aux_sym_block_token2] = ACTIONS(2018),
    [anon_sym__and_LT_LT] = ACTIONS(1833),
    [anon_sym__andif_LT_LT] = ACTIONS(1833),
    [anon_sym__or_LT_LT] = ACTIONS(1833),
    [anon_sym__orif_LT_LT] = ACTIONS(1833),
    [anon_sym__xor_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_LT_LT] = ACTIONS(1833),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_LT_LT] = ACTIONS(1833),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym__mod_LT_LT] = ACTIONS(1833),
    [anon_sym__div_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_LT_LT] = ACTIONS(1833),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_LT_LT] = ACTIONS(1833),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(1833),
    [aux_sym_if_token3] = ACTIONS(2018),
    [aux_sym_elif_token1] = ACTIONS(2018),
    [aux_sym_else_token1] = ACTIONS(2018),
    [aux_sym_loop_token2] = ACTIONS(2018),
    [aux_sym_finally_token1] = ACTIONS(2018),
    [aux_sym_finally_token2] = ACTIONS(2018),
    [aux_sym_catch_token2] = ACTIONS(2018),
    [aux_sym_try_token2] = ACTIONS(2018),
    [aux_sym_try_token3] = ACTIONS(2018),
    [aux_sym_protect_token4] = ACTIONS(2018),
    [aux_sym_lock_token2] = ACTIONS(2018),
    [anon_sym_SEMI] = ACTIONS(2018),
    [aux_sym_relational_operator_token1] = ACTIONS(1837),
    [aux_sym_relational_operator_token2] = ACTIONS(1837),
    [aux_sym_relational_operator_token3] = ACTIONS(1837),
    [anon_sym_EQ] = ACTIONS(1837),
    [anon_sym_TILDE_EQ] = ACTIONS(1837),
    [anon_sym_LT_GT] = ACTIONS(1837),
    [anon_sym_GT_EQ] = ACTIONS(1837),
    [anon_sym_LT_EQ] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1837),
    [anon_sym_GT] = ACTIONS(1837),
    [aux_sym_logical_operator_token1] = ACTIONS(1839),
    [aux_sym_logical_operator_token2] = ACTIONS(1839),
    [aux_sym_logical_operator_token3] = ACTIONS(1839),
    [aux_sym_logical_operator_token4] = ACTIONS(1839),
    [aux_sym_logical_operator_token5] = ACTIONS(1839),
    [aux_sym_logical_operator_token6] = ACTIONS(1839),
    [anon_sym_STAR_STAR] = ACTIONS(1841),
    [anon_sym_STAR] = ACTIONS(1841),
    [anon_sym_SLASH] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(1841),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(1841),
    [anon_sym_DASH] = ACTIONS(1841),
    [anon_sym_PLUS] = ACTIONS(1841),
    [sym_comment] = ACTIONS(3),
  },
  [585] = {
    [aux_sym_loopbody_repeat1] = STATE(583),
    [anon_sym_CR] = ACTIONS(2020),
    [anon_sym_LF] = ACTIONS(2020),
    [anon_sym_DOT] = ACTIONS(2020),
    [anon_sym_LPAREN] = ACTIONS(2020),
    [anon_sym_COMMA] = ACTIONS(1831),
    [anon_sym_LT_LT] = ACTIONS(2020),
    [anon_sym_CARET_LT_LT] = ACTIONS(2020),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [aux_sym_method_token7] = ACTIONS(2020),
    [aux_sym_procedure_token2] = ACTIONS(2020),
    [aux_sym_block_token2] = ACTIONS(2020),
    [anon_sym__and_LT_LT] = ACTIONS(2020),
    [anon_sym__andif_LT_LT] = ACTIONS(2020),
    [anon_sym__or_LT_LT] = ACTIONS(2020),
    [anon_sym__orif_LT_LT] = ACTIONS(2020),
    [anon_sym__xor_LT_LT] = ACTIONS(2020),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2020),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2020),
    [anon_sym_STAR_LT_LT] = ACTIONS(2020),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2020),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2020),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2020),
    [anon_sym__mod_LT_LT] = ACTIONS(2020),
    [anon_sym__div_LT_LT] = ACTIONS(2020),
    [anon_sym_DASH_LT_LT] = ACTIONS(2020),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2020),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2020),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2020),
    [aux_sym_if_token3] = ACTIONS(2020),
    [aux_sym_elif_token1] = ACTIONS(2020),
    [aux_sym_else_token1] = ACTIONS(2020),
    [aux_sym_loop_token2] = ACTIONS(2020),
    [aux_sym_finally_token1] = ACTIONS(2020),
    [aux_sym_finally_token2] = ACTIONS(2020),
    [aux_sym_catch_token2] = ACTIONS(2020),
    [aux_sym_try_token2] = ACTIONS(2020),
    [aux_sym_try_token3] = ACTIONS(2020),
    [aux_sym_protect_token4] = ACTIONS(2020),
    [aux_sym_lock_token2] = ACTIONS(2020),
    [anon_sym_SEMI] = ACTIONS(2020),
    [aux_sym_relational_operator_token1] = ACTIONS(2020),
    [aux_sym_relational_operator_token2] = ACTIONS(2020),
    [aux_sym_relational_operator_token3] = ACTIONS(2020),
    [anon_sym_EQ] = ACTIONS(2020),
    [anon_sym_TILDE_EQ] = ACTIONS(2020),
    [anon_sym_LT_GT] = ACTIONS(2020),
    [anon_sym_GT_EQ] = ACTIONS(2020),
    [anon_sym_LT_EQ] = ACTIONS(2020),
    [anon_sym_LT] = ACTIONS(2020),
    [anon_sym_GT] = ACTIONS(2020),
    [aux_sym_logical_operator_token1] = ACTIONS(2020),
    [aux_sym_logical_operator_token2] = ACTIONS(2020),
    [aux_sym_logical_operator_token3] = ACTIONS(2020),
    [aux_sym_logical_operator_token4] = ACTIONS(2020),
    [aux_sym_logical_operator_token5] = ACTIONS(2020),
    [aux_sym_logical_operator_token6] = ACTIONS(2020),
    [anon_sym_STAR_STAR] = ACTIONS(2020),
    [anon_sym_STAR] = ACTIONS(2020),
    [anon_sym_SLASH] = ACTIONS(2020),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2020),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2020),
    [anon_sym_DASH] = ACTIONS(2020),
    [anon_sym_PLUS] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
  },
  [586] = {
    [anon_sym_CR] = ACTIONS(2022),
    [anon_sym_LF] = ACTIONS(2022),
    [anon_sym_DOT] = ACTIONS(2022),
    [anon_sym_LPAREN] = ACTIONS(2022),
    [anon_sym_COMMA] = ACTIONS(2022),
    [anon_sym_LT_LT] = ACTIONS(2022),
    [anon_sym_CARET_LT_LT] = ACTIONS(2022),
    [anon_sym_LBRACK] = ACTIONS(2022),
    [aux_sym_method_token7] = ACTIONS(2022),
    [aux_sym_procedure_token2] = ACTIONS(2022),
    [aux_sym_block_token2] = ACTIONS(2022),
    [anon_sym__and_LT_LT] = ACTIONS(2022),
    [anon_sym__andif_LT_LT] = ACTIONS(2022),
    [anon_sym__or_LT_LT] = ACTIONS(2022),
    [anon_sym__orif_LT_LT] = ACTIONS(2022),
    [anon_sym__xor_LT_LT] = ACTIONS(2022),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2022),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2022),
    [anon_sym_STAR_LT_LT] = ACTIONS(2022),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2022),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2022),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2022),
    [anon_sym__mod_LT_LT] = ACTIONS(2022),
    [anon_sym__div_LT_LT] = ACTIONS(2022),
    [anon_sym_DASH_LT_LT] = ACTIONS(2022),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2022),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2022),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2022),
    [aux_sym_if_token3] = ACTIONS(2022),
    [aux_sym_elif_token1] = ACTIONS(2022),
    [aux_sym_else_token1] = ACTIONS(2022),
    [aux_sym_loop_token2] = ACTIONS(2022),
    [aux_sym_finally_token1] = ACTIONS(2022),
    [aux_sym_finally_token2] = ACTIONS(2022),
    [aux_sym_catch_token2] = ACTIONS(2022),
    [aux_sym_try_token2] = ACTIONS(2022),
    [aux_sym_try_token3] = ACTIONS(2022),
    [aux_sym_protect_token3] = ACTIONS(2022),
    [aux_sym_protect_token4] = ACTIONS(2022),
    [aux_sym_lock_token2] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2022),
    [aux_sym_relational_operator_token1] = ACTIONS(2022),
    [aux_sym_relational_operator_token2] = ACTIONS(2022),
    [aux_sym_relational_operator_token3] = ACTIONS(2022),
    [anon_sym_EQ] = ACTIONS(2022),
    [anon_sym_TILDE_EQ] = ACTIONS(2022),
    [anon_sym_LT_GT] = ACTIONS(2022),
    [anon_sym_GT_EQ] = ACTIONS(2022),
    [anon_sym_LT_EQ] = ACTIONS(2022),
    [anon_sym_LT] = ACTIONS(2022),
    [anon_sym_GT] = ACTIONS(2022),
    [aux_sym_logical_operator_token1] = ACTIONS(2022),
    [aux_sym_logical_operator_token2] = ACTIONS(2022),
    [aux_sym_logical_operator_token3] = ACTIONS(2022),
    [aux_sym_logical_operator_token4] = ACTIONS(2022),
    [aux_sym_logical_operator_token5] = ACTIONS(2022),
    [aux_sym_logical_operator_token6] = ACTIONS(2022),
    [anon_sym_STAR_STAR] = ACTIONS(2022),
    [anon_sym_STAR] = ACTIONS(2022),
    [anon_sym_SLASH] = ACTIONS(2022),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2022),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2022),
    [anon_sym_DASH] = ACTIONS(2022),
    [anon_sym_PLUS] = ACTIONS(2022),
    [sym_comment] = ACTIONS(3),
  },
  [587] = {
    [anon_sym_CR] = ACTIONS(2024),
    [anon_sym_LF] = ACTIONS(2024),
    [anon_sym_DOT] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(2024),
    [anon_sym_COMMA] = ACTIONS(2024),
    [anon_sym_LT_LT] = ACTIONS(2024),
    [anon_sym_CARET_LT_LT] = ACTIONS(2024),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [aux_sym_method_token7] = ACTIONS(2024),
    [aux_sym_procedure_token2] = ACTIONS(2024),
    [aux_sym_block_token2] = ACTIONS(2024),
    [anon_sym__and_LT_LT] = ACTIONS(2024),
    [anon_sym__andif_LT_LT] = ACTIONS(2024),
    [anon_sym__or_LT_LT] = ACTIONS(2024),
    [anon_sym__orif_LT_LT] = ACTIONS(2024),
    [anon_sym__xor_LT_LT] = ACTIONS(2024),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2024),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2024),
    [anon_sym_STAR_LT_LT] = ACTIONS(2024),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2024),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2024),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2024),
    [anon_sym__mod_LT_LT] = ACTIONS(2024),
    [anon_sym__div_LT_LT] = ACTIONS(2024),
    [anon_sym_DASH_LT_LT] = ACTIONS(2024),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2024),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2024),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2024),
    [aux_sym_if_token3] = ACTIONS(2024),
    [aux_sym_elif_token1] = ACTIONS(2024),
    [aux_sym_else_token1] = ACTIONS(2024),
    [aux_sym_loop_token2] = ACTIONS(2024),
    [aux_sym_finally_token1] = ACTIONS(2024),
    [aux_sym_finally_token2] = ACTIONS(2024),
    [aux_sym_catch_token2] = ACTIONS(2024),
    [aux_sym_try_token2] = ACTIONS(2024),
    [aux_sym_try_token3] = ACTIONS(2024),
    [aux_sym_protect_token3] = ACTIONS(2024),
    [aux_sym_protect_token4] = ACTIONS(2024),
    [aux_sym_lock_token2] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(2024),
    [aux_sym_relational_operator_token1] = ACTIONS(2024),
    [aux_sym_relational_operator_token2] = ACTIONS(2024),
    [aux_sym_relational_operator_token3] = ACTIONS(2024),
    [anon_sym_EQ] = ACTIONS(2024),
    [anon_sym_TILDE_EQ] = ACTIONS(2024),
    [anon_sym_LT_GT] = ACTIONS(2024),
    [anon_sym_GT_EQ] = ACTIONS(2024),
    [anon_sym_LT_EQ] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2024),
    [anon_sym_GT] = ACTIONS(2024),
    [aux_sym_logical_operator_token1] = ACTIONS(2024),
    [aux_sym_logical_operator_token2] = ACTIONS(2024),
    [aux_sym_logical_operator_token3] = ACTIONS(2024),
    [aux_sym_logical_operator_token4] = ACTIONS(2024),
    [aux_sym_logical_operator_token5] = ACTIONS(2024),
    [aux_sym_logical_operator_token6] = ACTIONS(2024),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_STAR] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2024),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2024),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_PLUS] = ACTIONS(2024),
    [sym_comment] = ACTIONS(3),
  },
  [588] = {
    [anon_sym_CR] = ACTIONS(2026),
    [anon_sym_LF] = ACTIONS(2026),
    [anon_sym_DOT] = ACTIONS(2026),
    [anon_sym_LPAREN] = ACTIONS(2026),
    [anon_sym_COMMA] = ACTIONS(2026),
    [anon_sym_LT_LT] = ACTIONS(2026),
    [anon_sym_CARET_LT_LT] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2026),
    [aux_sym_method_token7] = ACTIONS(2026),
    [aux_sym_procedure_token2] = ACTIONS(2026),
    [aux_sym_block_token2] = ACTIONS(2026),
    [anon_sym__and_LT_LT] = ACTIONS(2026),
    [anon_sym__andif_LT_LT] = ACTIONS(2026),
    [anon_sym__or_LT_LT] = ACTIONS(2026),
    [anon_sym__orif_LT_LT] = ACTIONS(2026),
    [anon_sym__xor_LT_LT] = ACTIONS(2026),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2026),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2026),
    [anon_sym_STAR_LT_LT] = ACTIONS(2026),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2026),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2026),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2026),
    [anon_sym__mod_LT_LT] = ACTIONS(2026),
    [anon_sym__div_LT_LT] = ACTIONS(2026),
    [anon_sym_DASH_LT_LT] = ACTIONS(2026),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2026),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2026),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2026),
    [aux_sym_if_token3] = ACTIONS(2026),
    [aux_sym_elif_token1] = ACTIONS(2026),
    [aux_sym_else_token1] = ACTIONS(2026),
    [aux_sym_loop_token2] = ACTIONS(2026),
    [aux_sym_finally_token1] = ACTIONS(2026),
    [aux_sym_finally_token2] = ACTIONS(2026),
    [aux_sym_catch_token2] = ACTIONS(2026),
    [aux_sym_try_token2] = ACTIONS(2026),
    [aux_sym_try_token3] = ACTIONS(2026),
    [aux_sym_protect_token3] = ACTIONS(2026),
    [aux_sym_protect_token4] = ACTIONS(2026),
    [aux_sym_lock_token2] = ACTIONS(2026),
    [anon_sym_SEMI] = ACTIONS(2026),
    [aux_sym_relational_operator_token1] = ACTIONS(2026),
    [aux_sym_relational_operator_token2] = ACTIONS(2026),
    [aux_sym_relational_operator_token3] = ACTIONS(2026),
    [anon_sym_EQ] = ACTIONS(2026),
    [anon_sym_TILDE_EQ] = ACTIONS(2026),
    [anon_sym_LT_GT] = ACTIONS(2026),
    [anon_sym_GT_EQ] = ACTIONS(2026),
    [anon_sym_LT_EQ] = ACTIONS(2026),
    [anon_sym_LT] = ACTIONS(2026),
    [anon_sym_GT] = ACTIONS(2026),
    [aux_sym_logical_operator_token1] = ACTIONS(2026),
    [aux_sym_logical_operator_token2] = ACTIONS(2026),
    [aux_sym_logical_operator_token3] = ACTIONS(2026),
    [aux_sym_logical_operator_token4] = ACTIONS(2026),
    [aux_sym_logical_operator_token5] = ACTIONS(2026),
    [aux_sym_logical_operator_token6] = ACTIONS(2026),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_SLASH] = ACTIONS(2026),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2026),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2026),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_PLUS] = ACTIONS(2026),
    [sym_comment] = ACTIONS(3),
  },
  [589] = {
    [anon_sym_CR] = ACTIONS(2028),
    [anon_sym_LF] = ACTIONS(2028),
    [anon_sym_DOT] = ACTIONS(2028),
    [anon_sym_LPAREN] = ACTIONS(2028),
    [anon_sym_COMMA] = ACTIONS(2028),
    [anon_sym_LT_LT] = ACTIONS(2028),
    [anon_sym_CARET_LT_LT] = ACTIONS(2028),
    [anon_sym_LBRACK] = ACTIONS(2028),
    [aux_sym_method_token7] = ACTIONS(2028),
    [aux_sym_procedure_token2] = ACTIONS(2028),
    [aux_sym_block_token2] = ACTIONS(2028),
    [anon_sym__and_LT_LT] = ACTIONS(2028),
    [anon_sym__andif_LT_LT] = ACTIONS(2028),
    [anon_sym__or_LT_LT] = ACTIONS(2028),
    [anon_sym__orif_LT_LT] = ACTIONS(2028),
    [anon_sym__xor_LT_LT] = ACTIONS(2028),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2028),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2028),
    [anon_sym_STAR_LT_LT] = ACTIONS(2028),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2028),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2028),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2028),
    [anon_sym__mod_LT_LT] = ACTIONS(2028),
    [anon_sym__div_LT_LT] = ACTIONS(2028),
    [anon_sym_DASH_LT_LT] = ACTIONS(2028),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2028),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2028),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2028),
    [aux_sym_if_token3] = ACTIONS(2028),
    [aux_sym_elif_token1] = ACTIONS(2028),
    [aux_sym_else_token1] = ACTIONS(2028),
    [aux_sym_loop_token2] = ACTIONS(2028),
    [aux_sym_finally_token1] = ACTIONS(2028),
    [aux_sym_finally_token2] = ACTIONS(2028),
    [aux_sym_catch_token2] = ACTIONS(2028),
    [aux_sym_try_token2] = ACTIONS(2028),
    [aux_sym_try_token3] = ACTIONS(2028),
    [aux_sym_protect_token3] = ACTIONS(2028),
    [aux_sym_protect_token4] = ACTIONS(2028),
    [aux_sym_lock_token2] = ACTIONS(2028),
    [anon_sym_SEMI] = ACTIONS(2028),
    [aux_sym_relational_operator_token1] = ACTIONS(2028),
    [aux_sym_relational_operator_token2] = ACTIONS(2028),
    [aux_sym_relational_operator_token3] = ACTIONS(2028),
    [anon_sym_EQ] = ACTIONS(2028),
    [anon_sym_TILDE_EQ] = ACTIONS(2028),
    [anon_sym_LT_GT] = ACTIONS(2028),
    [anon_sym_GT_EQ] = ACTIONS(2028),
    [anon_sym_LT_EQ] = ACTIONS(2028),
    [anon_sym_LT] = ACTIONS(2028),
    [anon_sym_GT] = ACTIONS(2028),
    [aux_sym_logical_operator_token1] = ACTIONS(2028),
    [aux_sym_logical_operator_token2] = ACTIONS(2028),
    [aux_sym_logical_operator_token3] = ACTIONS(2028),
    [aux_sym_logical_operator_token4] = ACTIONS(2028),
    [aux_sym_logical_operator_token5] = ACTIONS(2028),
    [aux_sym_logical_operator_token6] = ACTIONS(2028),
    [anon_sym_STAR_STAR] = ACTIONS(2028),
    [anon_sym_STAR] = ACTIONS(2028),
    [anon_sym_SLASH] = ACTIONS(2028),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2028),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2028),
    [anon_sym_DASH] = ACTIONS(2028),
    [anon_sym_PLUS] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
  },
  [590] = {
    [anon_sym_CR] = ACTIONS(2030),
    [anon_sym_LF] = ACTIONS(2030),
    [anon_sym_DOT] = ACTIONS(2030),
    [anon_sym_LPAREN] = ACTIONS(2030),
    [anon_sym_COMMA] = ACTIONS(2030),
    [anon_sym_LT_LT] = ACTIONS(2030),
    [anon_sym_CARET_LT_LT] = ACTIONS(2030),
    [anon_sym_LBRACK] = ACTIONS(2030),
    [aux_sym_method_token7] = ACTIONS(2030),
    [aux_sym_procedure_token2] = ACTIONS(2030),
    [aux_sym_block_token2] = ACTIONS(2030),
    [anon_sym__and_LT_LT] = ACTIONS(2030),
    [anon_sym__andif_LT_LT] = ACTIONS(2030),
    [anon_sym__or_LT_LT] = ACTIONS(2030),
    [anon_sym__orif_LT_LT] = ACTIONS(2030),
    [anon_sym__xor_LT_LT] = ACTIONS(2030),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2030),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2030),
    [anon_sym_STAR_LT_LT] = ACTIONS(2030),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2030),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2030),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2030),
    [anon_sym__mod_LT_LT] = ACTIONS(2030),
    [anon_sym__div_LT_LT] = ACTIONS(2030),
    [anon_sym_DASH_LT_LT] = ACTIONS(2030),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2030),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2030),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2030),
    [aux_sym_if_token3] = ACTIONS(2030),
    [aux_sym_elif_token1] = ACTIONS(2030),
    [aux_sym_else_token1] = ACTIONS(2030),
    [aux_sym_loop_token2] = ACTIONS(2030),
    [aux_sym_finally_token1] = ACTIONS(2030),
    [aux_sym_finally_token2] = ACTIONS(2030),
    [aux_sym_catch_token2] = ACTIONS(2030),
    [aux_sym_try_token2] = ACTIONS(2030),
    [aux_sym_try_token3] = ACTIONS(2030),
    [aux_sym_protect_token3] = ACTIONS(2030),
    [aux_sym_protect_token4] = ACTIONS(2030),
    [aux_sym_lock_token2] = ACTIONS(2030),
    [anon_sym_SEMI] = ACTIONS(2030),
    [aux_sym_relational_operator_token1] = ACTIONS(2030),
    [aux_sym_relational_operator_token2] = ACTIONS(2030),
    [aux_sym_relational_operator_token3] = ACTIONS(2030),
    [anon_sym_EQ] = ACTIONS(2030),
    [anon_sym_TILDE_EQ] = ACTIONS(2030),
    [anon_sym_LT_GT] = ACTIONS(2030),
    [anon_sym_GT_EQ] = ACTIONS(2030),
    [anon_sym_LT_EQ] = ACTIONS(2030),
    [anon_sym_LT] = ACTIONS(2030),
    [anon_sym_GT] = ACTIONS(2030),
    [aux_sym_logical_operator_token1] = ACTIONS(2030),
    [aux_sym_logical_operator_token2] = ACTIONS(2030),
    [aux_sym_logical_operator_token3] = ACTIONS(2030),
    [aux_sym_logical_operator_token4] = ACTIONS(2030),
    [aux_sym_logical_operator_token5] = ACTIONS(2030),
    [aux_sym_logical_operator_token6] = ACTIONS(2030),
    [anon_sym_STAR_STAR] = ACTIONS(2030),
    [anon_sym_STAR] = ACTIONS(2030),
    [anon_sym_SLASH] = ACTIONS(2030),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2030),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2030),
    [anon_sym_DASH] = ACTIONS(2030),
    [anon_sym_PLUS] = ACTIONS(2030),
    [sym_comment] = ACTIONS(3),
  },
  [591] = {
    [anon_sym_CR] = ACTIONS(2032),
    [anon_sym_LF] = ACTIONS(2032),
    [anon_sym_DOT] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2032),
    [anon_sym_COMMA] = ACTIONS(2032),
    [anon_sym_LT_LT] = ACTIONS(2032),
    [anon_sym_CARET_LT_LT] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2032),
    [aux_sym_method_token7] = ACTIONS(2032),
    [aux_sym_procedure_token2] = ACTIONS(2032),
    [aux_sym_block_token2] = ACTIONS(2032),
    [anon_sym__and_LT_LT] = ACTIONS(2032),
    [anon_sym__andif_LT_LT] = ACTIONS(2032),
    [anon_sym__or_LT_LT] = ACTIONS(2032),
    [anon_sym__orif_LT_LT] = ACTIONS(2032),
    [anon_sym__xor_LT_LT] = ACTIONS(2032),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2032),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2032),
    [anon_sym_STAR_LT_LT] = ACTIONS(2032),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2032),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2032),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2032),
    [anon_sym__mod_LT_LT] = ACTIONS(2032),
    [anon_sym__div_LT_LT] = ACTIONS(2032),
    [anon_sym_DASH_LT_LT] = ACTIONS(2032),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2032),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2032),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2032),
    [aux_sym_if_token3] = ACTIONS(2032),
    [aux_sym_elif_token1] = ACTIONS(2032),
    [aux_sym_else_token1] = ACTIONS(2032),
    [aux_sym_loop_token2] = ACTIONS(2032),
    [aux_sym_finally_token1] = ACTIONS(2032),
    [aux_sym_finally_token2] = ACTIONS(2032),
    [aux_sym_catch_token2] = ACTIONS(2032),
    [aux_sym_try_token2] = ACTIONS(2032),
    [aux_sym_try_token3] = ACTIONS(2032),
    [aux_sym_protect_token3] = ACTIONS(2032),
    [aux_sym_protect_token4] = ACTIONS(2032),
    [aux_sym_lock_token2] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2032),
    [aux_sym_relational_operator_token1] = ACTIONS(2032),
    [aux_sym_relational_operator_token2] = ACTIONS(2032),
    [aux_sym_relational_operator_token3] = ACTIONS(2032),
    [anon_sym_EQ] = ACTIONS(2032),
    [anon_sym_TILDE_EQ] = ACTIONS(2032),
    [anon_sym_LT_GT] = ACTIONS(2032),
    [anon_sym_GT_EQ] = ACTIONS(2032),
    [anon_sym_LT_EQ] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(2032),
    [anon_sym_GT] = ACTIONS(2032),
    [aux_sym_logical_operator_token1] = ACTIONS(2032),
    [aux_sym_logical_operator_token2] = ACTIONS(2032),
    [aux_sym_logical_operator_token3] = ACTIONS(2032),
    [aux_sym_logical_operator_token4] = ACTIONS(2032),
    [aux_sym_logical_operator_token5] = ACTIONS(2032),
    [aux_sym_logical_operator_token6] = ACTIONS(2032),
    [anon_sym_STAR_STAR] = ACTIONS(2032),
    [anon_sym_STAR] = ACTIONS(2032),
    [anon_sym_SLASH] = ACTIONS(2032),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2032),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2032),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
  },
  [592] = {
    [anon_sym_CR] = ACTIONS(2034),
    [anon_sym_LF] = ACTIONS(2034),
    [anon_sym_DOT] = ACTIONS(2034),
    [anon_sym_LPAREN] = ACTIONS(2034),
    [anon_sym_COMMA] = ACTIONS(2034),
    [anon_sym_LT_LT] = ACTIONS(2034),
    [anon_sym_CARET_LT_LT] = ACTIONS(2034),
    [anon_sym_LBRACK] = ACTIONS(2034),
    [aux_sym_method_token7] = ACTIONS(2034),
    [aux_sym_procedure_token2] = ACTIONS(2034),
    [aux_sym_block_token2] = ACTIONS(2034),
    [anon_sym__and_LT_LT] = ACTIONS(2034),
    [anon_sym__andif_LT_LT] = ACTIONS(2034),
    [anon_sym__or_LT_LT] = ACTIONS(2034),
    [anon_sym__orif_LT_LT] = ACTIONS(2034),
    [anon_sym__xor_LT_LT] = ACTIONS(2034),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2034),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2034),
    [anon_sym_STAR_LT_LT] = ACTIONS(2034),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2034),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2034),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2034),
    [anon_sym__mod_LT_LT] = ACTIONS(2034),
    [anon_sym__div_LT_LT] = ACTIONS(2034),
    [anon_sym_DASH_LT_LT] = ACTIONS(2034),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2034),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2034),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2034),
    [aux_sym_if_token3] = ACTIONS(2034),
    [aux_sym_elif_token1] = ACTIONS(2034),
    [aux_sym_else_token1] = ACTIONS(2034),
    [aux_sym_loop_token2] = ACTIONS(2034),
    [aux_sym_finally_token1] = ACTIONS(2034),
    [aux_sym_finally_token2] = ACTIONS(2034),
    [aux_sym_catch_token2] = ACTIONS(2034),
    [aux_sym_try_token2] = ACTIONS(2034),
    [aux_sym_try_token3] = ACTIONS(2034),
    [aux_sym_protect_token3] = ACTIONS(2034),
    [aux_sym_protect_token4] = ACTIONS(2034),
    [aux_sym_lock_token2] = ACTIONS(2034),
    [anon_sym_SEMI] = ACTIONS(2034),
    [aux_sym_relational_operator_token1] = ACTIONS(2034),
    [aux_sym_relational_operator_token2] = ACTIONS(2034),
    [aux_sym_relational_operator_token3] = ACTIONS(2034),
    [anon_sym_EQ] = ACTIONS(2034),
    [anon_sym_TILDE_EQ] = ACTIONS(2034),
    [anon_sym_LT_GT] = ACTIONS(2034),
    [anon_sym_GT_EQ] = ACTIONS(2034),
    [anon_sym_LT_EQ] = ACTIONS(2034),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_GT] = ACTIONS(2034),
    [aux_sym_logical_operator_token1] = ACTIONS(2034),
    [aux_sym_logical_operator_token2] = ACTIONS(2034),
    [aux_sym_logical_operator_token3] = ACTIONS(2034),
    [aux_sym_logical_operator_token4] = ACTIONS(2034),
    [aux_sym_logical_operator_token5] = ACTIONS(2034),
    [aux_sym_logical_operator_token6] = ACTIONS(2034),
    [anon_sym_STAR_STAR] = ACTIONS(2034),
    [anon_sym_STAR] = ACTIONS(2034),
    [anon_sym_SLASH] = ACTIONS(2034),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2034),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2034),
    [anon_sym_PLUS] = ACTIONS(2034),
    [sym_comment] = ACTIONS(3),
  },
  [593] = {
    [anon_sym_CR] = ACTIONS(2036),
    [anon_sym_LF] = ACTIONS(2036),
    [anon_sym_DOT] = ACTIONS(2036),
    [anon_sym_LPAREN] = ACTIONS(2036),
    [anon_sym_COMMA] = ACTIONS(2036),
    [anon_sym_LT_LT] = ACTIONS(2036),
    [anon_sym_CARET_LT_LT] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(2036),
    [aux_sym_method_token7] = ACTIONS(2036),
    [aux_sym_procedure_token2] = ACTIONS(2036),
    [aux_sym_block_token2] = ACTIONS(2036),
    [anon_sym__and_LT_LT] = ACTIONS(2036),
    [anon_sym__andif_LT_LT] = ACTIONS(2036),
    [anon_sym__or_LT_LT] = ACTIONS(2036),
    [anon_sym__orif_LT_LT] = ACTIONS(2036),
    [anon_sym__xor_LT_LT] = ACTIONS(2036),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2036),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2036),
    [anon_sym_STAR_LT_LT] = ACTIONS(2036),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2036),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2036),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2036),
    [anon_sym__mod_LT_LT] = ACTIONS(2036),
    [anon_sym__div_LT_LT] = ACTIONS(2036),
    [anon_sym_DASH_LT_LT] = ACTIONS(2036),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2036),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2036),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2036),
    [aux_sym_if_token3] = ACTIONS(2036),
    [aux_sym_elif_token1] = ACTIONS(2036),
    [aux_sym_else_token1] = ACTIONS(2036),
    [aux_sym_loop_token2] = ACTIONS(2036),
    [aux_sym_finally_token1] = ACTIONS(2036),
    [aux_sym_finally_token2] = ACTIONS(2036),
    [aux_sym_catch_token2] = ACTIONS(2036),
    [aux_sym_try_token2] = ACTIONS(2036),
    [aux_sym_try_token3] = ACTIONS(2036),
    [aux_sym_protect_token3] = ACTIONS(2036),
    [aux_sym_protect_token4] = ACTIONS(2036),
    [aux_sym_lock_token2] = ACTIONS(2036),
    [anon_sym_SEMI] = ACTIONS(2036),
    [aux_sym_relational_operator_token1] = ACTIONS(2036),
    [aux_sym_relational_operator_token2] = ACTIONS(2036),
    [aux_sym_relational_operator_token3] = ACTIONS(2036),
    [anon_sym_EQ] = ACTIONS(2036),
    [anon_sym_TILDE_EQ] = ACTIONS(2036),
    [anon_sym_LT_GT] = ACTIONS(2036),
    [anon_sym_GT_EQ] = ACTIONS(2036),
    [anon_sym_LT_EQ] = ACTIONS(2036),
    [anon_sym_LT] = ACTIONS(2036),
    [anon_sym_GT] = ACTIONS(2036),
    [aux_sym_logical_operator_token1] = ACTIONS(2036),
    [aux_sym_logical_operator_token2] = ACTIONS(2036),
    [aux_sym_logical_operator_token3] = ACTIONS(2036),
    [aux_sym_logical_operator_token4] = ACTIONS(2036),
    [aux_sym_logical_operator_token5] = ACTIONS(2036),
    [aux_sym_logical_operator_token6] = ACTIONS(2036),
    [anon_sym_STAR_STAR] = ACTIONS(2036),
    [anon_sym_STAR] = ACTIONS(2036),
    [anon_sym_SLASH] = ACTIONS(2036),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2036),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2036),
    [anon_sym_DASH] = ACTIONS(2036),
    [anon_sym_PLUS] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
  },
  [594] = {
    [anon_sym_CR] = ACTIONS(2038),
    [anon_sym_LF] = ACTIONS(2038),
    [anon_sym_DOT] = ACTIONS(2038),
    [anon_sym_LPAREN] = ACTIONS(2038),
    [anon_sym_COMMA] = ACTIONS(2038),
    [anon_sym_LT_LT] = ACTIONS(2038),
    [anon_sym_CARET_LT_LT] = ACTIONS(2038),
    [anon_sym_LBRACK] = ACTIONS(2038),
    [aux_sym_method_token7] = ACTIONS(2038),
    [aux_sym_procedure_token2] = ACTIONS(2038),
    [aux_sym_block_token2] = ACTIONS(2038),
    [anon_sym__and_LT_LT] = ACTIONS(2038),
    [anon_sym__andif_LT_LT] = ACTIONS(2038),
    [anon_sym__or_LT_LT] = ACTIONS(2038),
    [anon_sym__orif_LT_LT] = ACTIONS(2038),
    [anon_sym__xor_LT_LT] = ACTIONS(2038),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2038),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2038),
    [anon_sym_STAR_LT_LT] = ACTIONS(2038),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2038),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2038),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2038),
    [anon_sym__mod_LT_LT] = ACTIONS(2038),
    [anon_sym__div_LT_LT] = ACTIONS(2038),
    [anon_sym_DASH_LT_LT] = ACTIONS(2038),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2038),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2038),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2038),
    [aux_sym_if_token3] = ACTIONS(2038),
    [aux_sym_elif_token1] = ACTIONS(2038),
    [aux_sym_else_token1] = ACTIONS(2038),
    [aux_sym_loop_token2] = ACTIONS(2038),
    [aux_sym_finally_token1] = ACTIONS(2038),
    [aux_sym_finally_token2] = ACTIONS(2038),
    [aux_sym_catch_token2] = ACTIONS(2038),
    [aux_sym_try_token2] = ACTIONS(2038),
    [aux_sym_try_token3] = ACTIONS(2038),
    [aux_sym_protect_token3] = ACTIONS(2038),
    [aux_sym_protect_token4] = ACTIONS(2038),
    [aux_sym_lock_token2] = ACTIONS(2038),
    [anon_sym_SEMI] = ACTIONS(2038),
    [aux_sym_relational_operator_token1] = ACTIONS(2038),
    [aux_sym_relational_operator_token2] = ACTIONS(2038),
    [aux_sym_relational_operator_token3] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(2038),
    [anon_sym_TILDE_EQ] = ACTIONS(2038),
    [anon_sym_LT_GT] = ACTIONS(2038),
    [anon_sym_GT_EQ] = ACTIONS(2038),
    [anon_sym_LT_EQ] = ACTIONS(2038),
    [anon_sym_LT] = ACTIONS(2038),
    [anon_sym_GT] = ACTIONS(2038),
    [aux_sym_logical_operator_token1] = ACTIONS(2038),
    [aux_sym_logical_operator_token2] = ACTIONS(2038),
    [aux_sym_logical_operator_token3] = ACTIONS(2038),
    [aux_sym_logical_operator_token4] = ACTIONS(2038),
    [aux_sym_logical_operator_token5] = ACTIONS(2038),
    [aux_sym_logical_operator_token6] = ACTIONS(2038),
    [anon_sym_STAR_STAR] = ACTIONS(2038),
    [anon_sym_STAR] = ACTIONS(2038),
    [anon_sym_SLASH] = ACTIONS(2038),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2038),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2038),
    [anon_sym_DASH] = ACTIONS(2038),
    [anon_sym_PLUS] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
  },
  [595] = {
    [anon_sym_CR] = ACTIONS(2040),
    [anon_sym_LF] = ACTIONS(2040),
    [anon_sym_DOT] = ACTIONS(2040),
    [anon_sym_LPAREN] = ACTIONS(2040),
    [anon_sym_COMMA] = ACTIONS(2040),
    [anon_sym_LT_LT] = ACTIONS(2040),
    [anon_sym_CARET_LT_LT] = ACTIONS(2040),
    [anon_sym_LBRACK] = ACTIONS(2040),
    [aux_sym_method_token7] = ACTIONS(2040),
    [aux_sym_procedure_token2] = ACTIONS(2040),
    [aux_sym_block_token2] = ACTIONS(2040),
    [anon_sym__and_LT_LT] = ACTIONS(2040),
    [anon_sym__andif_LT_LT] = ACTIONS(2040),
    [anon_sym__or_LT_LT] = ACTIONS(2040),
    [anon_sym__orif_LT_LT] = ACTIONS(2040),
    [anon_sym__xor_LT_LT] = ACTIONS(2040),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2040),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2040),
    [anon_sym_STAR_LT_LT] = ACTIONS(2040),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2040),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2040),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2040),
    [anon_sym__mod_LT_LT] = ACTIONS(2040),
    [anon_sym__div_LT_LT] = ACTIONS(2040),
    [anon_sym_DASH_LT_LT] = ACTIONS(2040),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2040),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2040),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2040),
    [aux_sym_if_token3] = ACTIONS(2040),
    [aux_sym_elif_token1] = ACTIONS(2040),
    [aux_sym_else_token1] = ACTIONS(2040),
    [aux_sym_loop_token2] = ACTIONS(2040),
    [aux_sym_finally_token1] = ACTIONS(2040),
    [aux_sym_finally_token2] = ACTIONS(2040),
    [aux_sym_catch_token2] = ACTIONS(2040),
    [aux_sym_try_token2] = ACTIONS(2040),
    [aux_sym_try_token3] = ACTIONS(2040),
    [aux_sym_protect_token3] = ACTIONS(2040),
    [aux_sym_protect_token4] = ACTIONS(2040),
    [aux_sym_lock_token2] = ACTIONS(2040),
    [anon_sym_SEMI] = ACTIONS(2040),
    [aux_sym_relational_operator_token1] = ACTIONS(2040),
    [aux_sym_relational_operator_token2] = ACTIONS(2040),
    [aux_sym_relational_operator_token3] = ACTIONS(2040),
    [anon_sym_EQ] = ACTIONS(2040),
    [anon_sym_TILDE_EQ] = ACTIONS(2040),
    [anon_sym_LT_GT] = ACTIONS(2040),
    [anon_sym_GT_EQ] = ACTIONS(2040),
    [anon_sym_LT_EQ] = ACTIONS(2040),
    [anon_sym_LT] = ACTIONS(2040),
    [anon_sym_GT] = ACTIONS(2040),
    [aux_sym_logical_operator_token1] = ACTIONS(2040),
    [aux_sym_logical_operator_token2] = ACTIONS(2040),
    [aux_sym_logical_operator_token3] = ACTIONS(2040),
    [aux_sym_logical_operator_token4] = ACTIONS(2040),
    [aux_sym_logical_operator_token5] = ACTIONS(2040),
    [aux_sym_logical_operator_token6] = ACTIONS(2040),
    [anon_sym_STAR_STAR] = ACTIONS(2040),
    [anon_sym_STAR] = ACTIONS(2040),
    [anon_sym_SLASH] = ACTIONS(2040),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2040),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2040),
    [anon_sym_DASH] = ACTIONS(2040),
    [anon_sym_PLUS] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
  },
  [596] = {
    [anon_sym_CR] = ACTIONS(2042),
    [anon_sym_LF] = ACTIONS(2042),
    [anon_sym_DOT] = ACTIONS(2042),
    [anon_sym_LPAREN] = ACTIONS(2042),
    [anon_sym_COMMA] = ACTIONS(2042),
    [anon_sym_LT_LT] = ACTIONS(2042),
    [anon_sym_CARET_LT_LT] = ACTIONS(2042),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [aux_sym_method_token7] = ACTIONS(2042),
    [aux_sym_procedure_token2] = ACTIONS(2042),
    [aux_sym_block_token2] = ACTIONS(2042),
    [anon_sym__and_LT_LT] = ACTIONS(2042),
    [anon_sym__andif_LT_LT] = ACTIONS(2042),
    [anon_sym__or_LT_LT] = ACTIONS(2042),
    [anon_sym__orif_LT_LT] = ACTIONS(2042),
    [anon_sym__xor_LT_LT] = ACTIONS(2042),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2042),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2042),
    [anon_sym_STAR_LT_LT] = ACTIONS(2042),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2042),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2042),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2042),
    [anon_sym__mod_LT_LT] = ACTIONS(2042),
    [anon_sym__div_LT_LT] = ACTIONS(2042),
    [anon_sym_DASH_LT_LT] = ACTIONS(2042),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2042),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2042),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2042),
    [aux_sym_if_token3] = ACTIONS(2042),
    [aux_sym_elif_token1] = ACTIONS(2042),
    [aux_sym_else_token1] = ACTIONS(2042),
    [aux_sym_loop_token2] = ACTIONS(2042),
    [aux_sym_finally_token1] = ACTIONS(2042),
    [aux_sym_finally_token2] = ACTIONS(2042),
    [aux_sym_catch_token2] = ACTIONS(2042),
    [aux_sym_try_token2] = ACTIONS(2042),
    [aux_sym_try_token3] = ACTIONS(2042),
    [aux_sym_protect_token3] = ACTIONS(2042),
    [aux_sym_protect_token4] = ACTIONS(2042),
    [aux_sym_lock_token2] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2042),
    [aux_sym_relational_operator_token1] = ACTIONS(2042),
    [aux_sym_relational_operator_token2] = ACTIONS(2042),
    [aux_sym_relational_operator_token3] = ACTIONS(2042),
    [anon_sym_EQ] = ACTIONS(2042),
    [anon_sym_TILDE_EQ] = ACTIONS(2042),
    [anon_sym_LT_GT] = ACTIONS(2042),
    [anon_sym_GT_EQ] = ACTIONS(2042),
    [anon_sym_LT_EQ] = ACTIONS(2042),
    [anon_sym_LT] = ACTIONS(2042),
    [anon_sym_GT] = ACTIONS(2042),
    [aux_sym_logical_operator_token1] = ACTIONS(2042),
    [aux_sym_logical_operator_token2] = ACTIONS(2042),
    [aux_sym_logical_operator_token3] = ACTIONS(2042),
    [aux_sym_logical_operator_token4] = ACTIONS(2042),
    [aux_sym_logical_operator_token5] = ACTIONS(2042),
    [aux_sym_logical_operator_token6] = ACTIONS(2042),
    [anon_sym_STAR_STAR] = ACTIONS(2042),
    [anon_sym_STAR] = ACTIONS(2042),
    [anon_sym_SLASH] = ACTIONS(2042),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2042),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
  },
  [597] = {
    [anon_sym_CR] = ACTIONS(2044),
    [anon_sym_LF] = ACTIONS(2044),
    [anon_sym_DOT] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(2044),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_LT_LT] = ACTIONS(2044),
    [anon_sym_CARET_LT_LT] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2044),
    [aux_sym_method_token7] = ACTIONS(2044),
    [aux_sym_procedure_token2] = ACTIONS(2044),
    [aux_sym_block_token2] = ACTIONS(2044),
    [anon_sym__and_LT_LT] = ACTIONS(2044),
    [anon_sym__andif_LT_LT] = ACTIONS(2044),
    [anon_sym__or_LT_LT] = ACTIONS(2044),
    [anon_sym__orif_LT_LT] = ACTIONS(2044),
    [anon_sym__xor_LT_LT] = ACTIONS(2044),
    [anon_sym_STAR_STAR_LT_LT] = ACTIONS(2044),
    [anon_sym_STAR_STAR_CARET_LT_LT] = ACTIONS(2044),
    [anon_sym_STAR_LT_LT] = ACTIONS(2044),
    [anon_sym_STAR_CARET_LT_LT] = ACTIONS(2044),
    [anon_sym_SLASH_LT_LT] = ACTIONS(2044),
    [anon_sym_SLASH_CARET_LT_LT] = ACTIONS(2044),
    [anon_sym__mod_LT_LT] = ACTIONS(2044),
    [anon_sym__div_LT_LT] = ACTIONS(2044),
    [anon_sym_DASH_LT_LT] = ACTIONS(2044),
    [anon_sym_DASH_CARET_LT_LT] = ACTIONS(2044),
    [anon_sym_PLUS_LT_LT] = ACTIONS(2044),
    [anon_sym_PLUS_CARET_LT_LT] = ACTIONS(2044),
    [aux_sym_if_token3] = ACTIONS(2044),
    [aux_sym_elif_token1] = ACTIONS(2044),
    [aux_sym_else_token1] = ACTIONS(2044),
    [aux_sym_loop_token2] = ACTIONS(2044),
    [aux_sym_finally_token1] = ACTIONS(2044),
    [aux_sym_finally_token2] = ACTIONS(2044),
    [aux_sym_catch_token2] = ACTIONS(2044),
    [aux_sym_try_token2] = ACTIONS(2044),
    [aux_sym_try_token3] = ACTIONS(2044),
    [aux_sym_protect_token3] = ACTIONS(2044),
    [aux_sym_protect_token4] = ACTIONS(2044),
    [aux_sym_lock_token2] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2044),
    [aux_sym_relational_operator_token1] = ACTIONS(2044),
    [aux_sym_relational_operator_token2] = ACTIONS(2044),
    [aux_sym_relational_operator_token3] = ACTIONS(2044),
    [anon_sym_EQ] = ACTIONS(2044),
    [anon_sym_TILDE_EQ] = ACTIONS(2044),
    [anon_sym_LT_GT] = ACTIONS(2044),
    [anon_sym_GT_EQ] = ACTIONS(2044),
    [anon_sym_LT_EQ] = ACTIONS(2044),
    [anon_sym_LT] = ACTIONS(2044),
    [anon_sym_GT] = ACTIONS(2044),
    [aux_sym_logical_operator_token1] = ACTIONS(2044),
    [aux_sym_logical_operator_token2] = ACTIONS(2044),
    [aux_sym_logical_operator_token3] = ACTIONS(2044),
    [aux_sym_logical_operator_token4] = ACTIONS(2044),
    [aux_sym_logical_operator_token5] = ACTIONS(2044),
    [aux_sym_logical_operator_token6] = ACTIONS(2044),
    [anon_sym_STAR_STAR] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2044),
    [anon_sym_SLASH] = ACTIONS(2044),
    [aux_sym_arithmetic_operator_token1] = ACTIONS(2044),
    [aux_sym_arithmetic_operator_token2] = ACTIONS(2044),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(618), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1845), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [87] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2056), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1833), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [170] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    ACTIONS(2062), 1,
      anon_sym_LT_LT,
    STATE(1040), 1,
      aux_sym_local_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2058), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 18,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [259] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2013), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1833), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [415] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2064), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1833), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [498] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1833), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [581] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2068), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1833), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2070), 1,
      aux_sym_finally_token2,
    ACTIONS(1915), 62,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [735] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2074), 1,
      aux_sym_finally_token2,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2072), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1833), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2076), 1,
      aux_sym_finally_token2,
    ACTIONS(1907), 62,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [891] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    STATE(631), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1845), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [976] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    STATE(630), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1825), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [1061] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    STATE(628), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1925), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [1146] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    STATE(627), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1919), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [1231] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(617), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1825), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [1318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [1391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2078), 1,
      aux_sym_finally_token2,
    ACTIONS(2080), 1,
      sym_label,
    ACTIONS(1797), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [1464] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2082), 1,
      aux_sym_finally_token2,
    ACTIONS(2084), 1,
      sym_label,
    ACTIONS(1801), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [1537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [1610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [1683] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2072), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1833), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [1766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_LPAREN,
    ACTIONS(2090), 1,
      anon_sym_LT_LT,
    ACTIONS(2086), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [1839] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(632), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2018), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [1926] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2092), 37,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [2007] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 43,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [2086] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2096), 43,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [2165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2098), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2013), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [2238] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1869), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1833), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [2321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 62,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [2392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 62,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [2463] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1827), 1,
      anon_sym_DOT,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1839), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1841), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1837), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2007), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_finally_token2,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1833), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [2546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 62,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [2617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 62,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [2688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(625), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2020), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [2761] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(614), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1919), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [2848] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2046), 1,
      anon_sym_COMMA,
    STATE(602), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1925), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [2935] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2092), 36,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [3015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2101), 1,
      aux_sym_finally_token2,
    ACTIONS(1915), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [3085] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2056), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [3167] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2064), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [3249] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2013), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [3331] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 42,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [3409] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2103), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [3491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2096), 42,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [3569] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [3651] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2007), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [3733] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_LPAREN,
    ACTIONS(2105), 1,
      anon_sym_LT_LT,
    ACTIONS(2086), 60,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [3805] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2092), 36,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [3885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2068), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [3967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2107), 1,
      aux_sym_finally_token2,
    ACTIONS(1907), 61,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [4037] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2052), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2054), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2050), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1869), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(2048), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4119] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2056), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4200] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2109), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4281] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2111), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4362] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2113), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4443] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1869), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4524] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2115), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4605] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2117), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4686] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2068), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4767] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2119), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4848] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2121), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [4929] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2123), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [5010] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2125), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [5091] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1913), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2127), 59,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_method_token6,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_LBRACK,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_loop_token2,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [5160] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2129), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [5241] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2131), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [5322] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2092), 35,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [5401] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2133), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [5482] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2066), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [5563] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2064), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [5644] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2096), 41,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [5721] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2007), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [5802] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2135), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [5883] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 41,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [5960] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2137), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [6041] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2139), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [6122] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2141), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [6203] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2143), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [6284] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2147), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2145), 57,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_method_token5,
      aux_sym_method_token6,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_procedure_token1,
      aux_sym_procedure_token2,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6351] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2151), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2149), 57,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_method_token5,
      aux_sym_method_token6,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_procedure_token1,
      aux_sym_procedure_token2,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6418] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2155), 1,
      anon_sym_COMMA,
    STATE(679), 1,
      aux_sym_try_repeat1,
    ACTIONS(2158), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2153), 54,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6488] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2162), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2160), 56,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_method_token6,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_loop_token2,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6554] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2166), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2164), 55,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2172), 1,
      aux_sym_documentation_token1,
    STATE(684), 1,
      aux_sym_documentation_repeat1,
    ACTIONS(2170), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2168), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_method_token7,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6688] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2174), 1,
      anon_sym_COMMA,
    STATE(683), 1,
      aux_sym_method_repeat1,
    ACTIONS(2151), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2149), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_procedure_token2,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6757] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      aux_sym_documentation_token1,
    STATE(684), 1,
      aux_sym_documentation_repeat1,
    ACTIONS(2179), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2177), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_method_token7,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6826] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2184), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(1015), 55,
      ts_builtin_sym_end,
      aux_sym_package_token1,
      sym__dollar,
      aux_sym_method_token1,
      aux_sym_method_token2,
      aux_sym_method_token3,
      aux_sym_method_token4,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      aux_sym_pragma_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6891] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2186), 1,
      anon_sym_COMMA,
    STATE(686), 1,
      aux_sym__identifier_list_repeat1,
    ACTIONS(2162), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2160), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_loop_token2,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [6960] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COMMA,
    STATE(691), 1,
      aux_sym__identifier_list_repeat1,
    ACTIONS(2193), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2189), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_loop_token2,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [7029] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1795), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(1793), 55,
      ts_builtin_sym_end,
      aux_sym_package_token1,
      sym__dollar,
      aux_sym_method_token1,
      aux_sym_method_token2,
      aux_sym_method_token3,
      aux_sym_method_token4,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      aux_sym_pragma_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [7094] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COMMA,
    STATE(692), 1,
      aux_sym_method_repeat1,
    ACTIONS(2199), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2195), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_procedure_token2,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [7163] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2203), 1,
      aux_sym_loop_token1,
    ACTIONS(2205), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
    ACTIONS(2201), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_procedure_token2,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [7234] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2191), 1,
      anon_sym_COMMA,
    STATE(686), 1,
      aux_sym__identifier_list_repeat1,
    ACTIONS(2209), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2207), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_loop_token2,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [7303] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_COMMA,
    STATE(683), 1,
      aux_sym_method_repeat1,
    ACTIONS(2203), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2201), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_procedure_token2,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [7372] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2205), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2215), 1,
      aux_sym_loop_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
    ACTIONS(2213), 53,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_procedure_token2,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [7443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1795), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(1793), 54,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_method_token7,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
      aux_sym_documentation_token1,
  [7507] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1795), 3,
      aux_sym_loop_token1,
      aux_sym_protect_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(1793), 52,
      aux_sym_method_token3,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token3,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_local_token1,
      aux_sym__global_assignment_token1,
      aux_sym_dynamic_token1,
      aux_sym_import_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
  [7570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 2,
      aux_sym_loop_token1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2217), 52,
      aux_sym_method_token1,
      aux_sym_method_token2,
      aux_sym_method_token3,
      aux_sym_method_token4,
      anon_sym_DOT,
      anon_sym_LPAREN,
      aux_sym_method_token6,
      aux_sym_procedure_token1,
      aux_sym_block_token1,
      aux_sym_if_token1,
      aux_sym_handling_token1,
      aux_sym_catch_token1,
      aux_sym_throw_token1,
      aux_sym_primitive_token1,
      aux_sym_iterator_token1,
      aux_sym_iterator_token2,
      aux_sym_while_token1,
      aux_sym_try_token1,
      aux_sym_loopbody_token1,
      aux_sym_leave_token1,
      aux_sym_continue_token1,
      aux_sym_protect_token1,
      aux_sym_lock_token1,
      anon_sym_PERCENT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_regex_literal,
      aux_sym_true_token1,
      aux_sym_false_token1,
      aux_sym_maybe_token1,
      aux_sym_unset_token1,
      aux_sym_super_token1,
      aux_sym_self_token1,
      aux_sym_clone_token1,
      aux_sym_thisthread_token1,
      aux_sym_class_token1,
      aux_sym_global_token1,
      aux_sym_return_token1,
      anon_sym_GT_GT,
      aux_sym_scatter_token1,
      aux_sym_allresults_token1,
      sym_dynamic_variable,
      sym_global_variable,
      sym_global_reference,
      sym_number,
      anon_sym_LBRACE,
      anon_sym_DASH,
      anon_sym_PLUS,
      aux_sym_unary_operator_token1,
      anon_sym_TILDE,
      sym_symbol,
      aux_sym_documentation_token1,
  [7632] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    STATE(707), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2227), 6,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [7713] = 12,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    STATE(704), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2243), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [7792] = 12,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    STATE(711), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2245), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [7871] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2249), 1,
      aux_sym_finally_token2,
    ACTIONS(2251), 1,
      sym_label,
    ACTIONS(1801), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2247), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [7936] = 12,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    STATE(706), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2253), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [8015] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2257), 1,
      anon_sym_COMMA,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2013), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2255), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8080] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2262), 1,
      aux_sym_finally_token2,
    ACTIONS(2264), 1,
      sym_label,
    ACTIONS(1797), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2260), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8145] = 4,
    ACTIONS(103), 1,
      sym_comment,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2266), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8208] = 12,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    STATE(710), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2268), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [8287] = 4,
    ACTIONS(103), 1,
      sym_comment,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2270), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8350] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2020), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2272), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8415] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2274), 1,
      sym_label,
    ACTIONS(1797), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2260), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8478] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2276), 1,
      sym_label,
    ACTIONS(1801), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2247), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8541] = 4,
    ACTIONS(103), 1,
      sym_comment,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2243), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8604] = 4,
    ACTIONS(103), 1,
      sym_comment,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2253), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8667] = 12,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    STATE(717), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2245), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [8745] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1955), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2292), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8805] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1953), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2294), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8865] = 4,
    ACTIONS(103), 1,
      sym_comment,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2243), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [8927] = 12,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    STATE(765), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2243), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [9005] = 4,
    ACTIONS(103), 1,
      sym_comment,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2253), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9067] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1807), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2296), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9127] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2044), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2298), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9187] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2040), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2300), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9247] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2038), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2302), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9307] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2036), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2304), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9367] = 12,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    STATE(767), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2253), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [9445] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2032), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2306), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9505] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2030), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2308), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9565] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2310), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [9641] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2028), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2312), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9701] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2314), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [9777] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2316), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [9853] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1901), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2318), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [9913] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2320), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [9989] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2324), 1,
      anon_sym_LPAREN,
    ACTIONS(2326), 1,
      anon_sym_LT_LT,
    ACTIONS(2086), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2322), 35,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [10053] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1849), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2328), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [10113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2020), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [10175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_COMMA,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2013), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [10237] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1873), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2335), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [10297] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1877), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2337), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [10357] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1891), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2339), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [10417] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    STATE(751), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1919), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [10491] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1937), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2351), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [10551] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1939), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2353), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [10611] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(820), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2227), 5,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [10691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2357), 1,
      aux_sym_finally_token2,
    ACTIONS(2359), 1,
      sym_label,
    ACTIONS(1801), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [10753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2361), 1,
      aux_sym_finally_token2,
    ACTIONS(2363), 1,
      sym_label,
    ACTIONS(1797), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [10815] = 12,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    STATE(715), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2268), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [10893] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1843), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2365), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [10953] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1851), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2367), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11013] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1893), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2369), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11073] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1853), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2371), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11133] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1855), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2373), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 51,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [11253] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2024), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2375), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11313] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_COMMA,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2013), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2255), 35,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11377] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2007), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2380), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11437] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2003), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2382), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11497] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1879), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2384), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11557] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2380), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [11633] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1999), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2386), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11693] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1993), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2388), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11753] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1819), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2390), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11813] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1991), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2392), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11873] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1989), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2394), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11933] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1963), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2396), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [11993] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1857), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2398), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12053] = 4,
    ACTIONS(103), 1,
      sym_comment,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2266), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12115] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1811), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2400), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12175] = 4,
    ACTIONS(103), 1,
      sym_comment,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2270), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12237] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2402), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [12313] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1809), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2404), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12373] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1951), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2406), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12433] = 9,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2096), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2408), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_logical_operator_token6,
  [12505] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2009), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2410), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12565] = 9,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2412), 27,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_logical_operator_token6,
  [12637] = 10,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2414), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
  [12711] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    STATE(837), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1925), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [12785] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1949), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2416), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12845] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1941), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2418), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12905] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1909), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2420), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [12965] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    STATE(734), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2018), 5,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [13041] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    STATE(840), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [13115] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2255), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [13191] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    STATE(843), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [13265] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1995), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2422), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [13325] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1923), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2424), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [13385] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    STATE(827), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1919), 5,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [13461] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1869), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2402), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [13521] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2042), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2426), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [13581] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1887), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2428), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [13641] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    STATE(828), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1925), 5,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [13717] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1987), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2430), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [13777] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1907), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2432), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [13837] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1915), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2434), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [13897] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2436), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [13973] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1969), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2438), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14033] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1913), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2127), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14093] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1867), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2440), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14153] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1865), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2442), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14213] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1967), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2444), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14273] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2034), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2446), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14333] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1805), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2448), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14393] = 12,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2450), 1,
      aux_sym_finally_token2,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2436), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [14471] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1883), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2452), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14531] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2005), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2454), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14591] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    STATE(833), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 5,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [14667] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    STATE(834), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 5,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [14743] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1885), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2456), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14803] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2011), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2458), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14863] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1959), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2460), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14923] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1927), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2462), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [14983] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1815), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2464), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15043] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1881), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2466), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15103] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1961), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2468), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15163] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1817), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2470), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15223] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1813), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2472), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15283] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1957), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2474), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15343] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1821), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2476), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15403] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1895), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2478), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15463] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1911), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2480), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15523] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1823), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2482), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15583] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2020), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2272), 35,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15647] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1847), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2484), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15707] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2022), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2486), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15767] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1871), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2488), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15827] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1917), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2490), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [15887] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1979), 1,
      aux_sym_protect_token3,
    ACTIONS(2492), 1,
      anon_sym_CR,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    STATE(1068), 1,
      aux_sym__codeblock_repeat1,
    ACTIONS(2494), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(243), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [15967] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1889), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2506), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [16089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [16151] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1921), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2508), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16211] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2001), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2510), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16271] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1875), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2512), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16331] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1931), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2514), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [16453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 1,
      anon_sym_COMMA,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [16515] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1929), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2516), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16575] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1863), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2518), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 51,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [16695] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1965), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2520), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16755] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1997), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2522), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 51,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [16875] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2026), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2524), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16935] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1947), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2526), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [16995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(735), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 51,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [17055] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1945), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2528), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [17115] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2530), 1,
      aux_sym_finally_token2,
    ACTIONS(1915), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2434), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [17177] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1943), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2532), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [17237] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1935), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2534), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [17297] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1933), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2536), 37,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [17357] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2538), 1,
      aux_sym_finally_token2,
    ACTIONS(1907), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2432), 36,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [17419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [17478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 1,
      aux_sym_finally_token2,
    ACTIONS(1915), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [17537] = 9,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2096), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2408), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_logical_operator_token6,
  [17608] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    STATE(850), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [17681] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    STATE(876), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1925), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [17754] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2007), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [17825] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    STATE(880), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1919), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [17898] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(886), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [17973] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(888), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [18048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_LPAREN,
    ACTIONS(2552), 1,
      anon_sym_LT_LT,
    ACTIONS(2086), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [18109] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(1869), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [18180] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2314), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [18255] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2316), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [18330] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2096), 31,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [18397] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2068), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [18468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 31,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [18535] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2066), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [18606] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2064), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [18677] = 10,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2414), 25,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
  [18750] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2092), 25,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [18819] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2056), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [18890] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2324), 1,
      anon_sym_LPAREN,
    ACTIONS(2554), 1,
      anon_sym_LT_LT,
    ACTIONS(2086), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2322), 34,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [18953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [19012] = 9,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2412), 26,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_RBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
      aux_sym_logical_operator_token6,
  [19083] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2320), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [19158] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(889), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1925), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [19233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [19292] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(891), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1919), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [19367] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2556), 1,
      aux_sym_finally_token2,
    ACTIONS(2072), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [19440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2558), 1,
      aux_sym_finally_token2,
    ACTIONS(2560), 1,
      sym_label,
    ACTIONS(1797), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [19501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [19560] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2402), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [19635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      aux_sym_finally_token2,
    ACTIONS(2564), 1,
      sym_label,
    ACTIONS(1801), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [19696] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2013), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [19767] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2310), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [19842] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2255), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [19917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [19978] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    STATE(900), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2253), 4,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [20057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [20118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [20179] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    STATE(872), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [20252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [20313] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    STATE(899), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2243), 4,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [20392] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    STATE(898), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2245), 4,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [20471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      anon_sym_COMMA,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2013), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [20532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(894), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2020), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [20593] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2550), 1,
      anon_sym_COMMA,
    STATE(895), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2018), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [20668] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2243), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [20731] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2253), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [20794] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2266), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [20857] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    STATE(702), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2270), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [20920] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2380), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      anon_sym_RBRACE,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [20995] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2341), 1,
      anon_sym_DOT,
    ACTIONS(2072), 6,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_finally_token2,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2347), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2349), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2345), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2343), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [21066] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2569), 1,
      anon_sym_COMMA,
    ACTIONS(2571), 1,
      anon_sym_LT_LT,
    STATE(1056), 1,
      aux_sym_local_repeat1,
    ACTIONS(2058), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 18,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [21143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2573), 1,
      aux_sym_finally_token2,
    ACTIONS(1907), 50,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [21202] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2225), 1,
      anon_sym_COMMA,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    STATE(897), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2268), 4,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_finally_token2,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [21281] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2492), 1,
      anon_sym_CR,
    ACTIONS(2575), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(166), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [21355] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2577), 1,
      aux_sym_finally_token2,
    ACTIONS(2579), 1,
      sym_label,
    ACTIONS(1801), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2247), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [21417] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1825), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2243), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [21479] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2092), 24,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [21547] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 30,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [21613] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2103), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [21683] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2096), 30,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [21749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2581), 1,
      aux_sym_finally_token2,
    ACTIONS(1915), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [21807] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(1869), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [21877] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2092), 24,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [21945] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1971), 1,
      anon_sym_CR,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2583), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(167), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22019] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1971), 1,
      anon_sym_CR,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2585), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(196), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22093] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1859), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2270), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [22155] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1861), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2266), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [22217] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1971), 1,
      anon_sym_CR,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2587), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(206), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_LPAREN,
    ACTIONS(2589), 1,
      anon_sym_LT_LT,
    ACTIONS(2086), 48,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_COMMA,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [22351] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(918), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2253), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22429] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2013), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22499] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2492), 1,
      anon_sym_CR,
    ACTIONS(2591), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(220), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22573] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2593), 1,
      aux_sym_finally_token2,
    ACTIONS(2595), 1,
      sym_label,
    ACTIONS(1797), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2260), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [22635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 1,
      aux_sym_finally_token2,
    ACTIONS(1907), 49,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [22693] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2007), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22763] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2056), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22833] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2064), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22903] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1971), 1,
      anon_sym_CR,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2599), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(172), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [22977] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2066), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23047] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2068), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2546), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2548), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2544), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2542), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23117] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(908), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2268), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23195] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(936), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2245), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23273] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(919), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2243), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23351] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(1845), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2253), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [23413] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2096), 29,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [23478] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(1869), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23547] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2125), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23616] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2109), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23685] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2007), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23754] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 29,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
  [23819] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2601), 1,
      aux_sym_finally_token2,
    ACTIONS(1915), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2434), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [23878] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2137), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [23947] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2092), 23,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [24014] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2068), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24083] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2066), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24152] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2603), 1,
      aux_sym_finally_token2,
    ACTIONS(1907), 15,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2432), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      aux_sym_logical_operator_token6,
  [24211] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2121), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24280] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2111), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24349] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2117), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24418] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2139), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24487] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2135), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24556] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2143), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24625] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2141), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24694] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2129), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24763] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2123), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24832] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2064), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24901] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2056), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [24970] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2119), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25039] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2113), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25108] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2133), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25177] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2131), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25246] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(2496), 1,
      anon_sym_DOT,
    ACTIONS(2115), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
    ACTIONS(2502), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(2504), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2500), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2498), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25315] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2607), 1,
      aux_sym_finally_token2,
    STATE(1382), 1,
      aux_sym_handling_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25391] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(2609), 1,
      anon_sym_RPAREN,
    STATE(1352), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25467] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2316), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25539] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(1487), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25615] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2314), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25687] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2310), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25759] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(1499), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25835] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(1500), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25911] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2623), 1,
      aux_sym_finally_token2,
    STATE(1402), 1,
      aux_sym_handling_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [25987] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(1483), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26063] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(2625), 1,
      anon_sym_RPAREN,
    STATE(1525), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26139] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2627), 1,
      aux_sym_finally_token2,
    STATE(1359), 1,
      aux_sym_handling_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26215] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2629), 1,
      aux_sym_finally_token2,
    STATE(1541), 1,
      aux_sym_handling_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26291] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2631), 1,
      aux_sym_finally_token2,
    STATE(1444), 1,
      aux_sym_handling_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26367] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2633), 1,
      anon_sym_COMMA,
    ACTIONS(2635), 1,
      anon_sym_RPAREN,
    STATE(1531), 1,
      aux_sym_local_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26443] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(1463), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26519] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(1339), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26595] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2637), 1,
      aux_sym_finally_token2,
    STATE(1532), 1,
      aux_sym_handling_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26671] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2639), 1,
      aux_sym_finally_token2,
    STATE(1356), 1,
      aux_sym_handling_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26747] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2641), 1,
      anon_sym_COMMA,
    ACTIONS(2643), 1,
      anon_sym_RPAREN,
    STATE(1504), 1,
      aux_sym_local_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26823] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2320), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26895] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2645), 1,
      aux_sym_finally_token2,
    STATE(1351), 1,
      aux_sym_handling_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [26971] = 9,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2094), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2412), 23,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_logical_operator_token6,
  [27039] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2402), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27111] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2380), 3,
      anon_sym_RPAREN,
      aux_sym_if_token2,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27183] = 9,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2096), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2408), 23,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
      aux_sym_logical_operator_token6,
  [27251] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(2647), 1,
      aux_sym_finally_token2,
    STATE(1423), 1,
      aux_sym_handling_repeat1,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27327] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(1387), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27403] = 10,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2414), 22,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_if_token2,
      aux_sym_loop_token1,
  [27473] = 13,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2227), 1,
      anon_sym_RPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    STATE(1388), 1,
      aux_sym_loopbody_repeat1,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27549] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2649), 2,
      anon_sym_CR,
      anon_sym_LF,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27616] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2651), 2,
      anon_sym_CR,
      anon_sym_LF,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27683] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2653), 2,
      anon_sym_CR,
      anon_sym_LF,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2655), 2,
      anon_sym_CR,
      anon_sym_LF,
    ACTIONS(2657), 45,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [27805] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_DOT,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2239), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2659), 2,
      anon_sym_COMMA,
      aux_sym_finally_token2,
    ACTIONS(2233), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2237), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2235), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2241), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2229), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27876] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2288), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2661), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(2282), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2286), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2284), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2290), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2280), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [27947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2663), 2,
      anon_sym_CR,
      anon_sym_LF,
    ACTIONS(2657), 45,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym_LBRACK,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
  [28002] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1829), 1,
      anon_sym_LPAREN,
    ACTIONS(1835), 1,
      anon_sym_LBRACK,
    ACTIONS(1975), 1,
      anon_sym_DOT,
    ACTIONS(2665), 2,
      anon_sym_CR,
      anon_sym_LF,
    ACTIONS(1983), 6,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
      aux_sym_logical_operator_token6,
    ACTIONS(1985), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(1981), 10,
      aux_sym_relational_operator_token1,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1977), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28069] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2667), 1,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28139] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2669), 1,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28209] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2671), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28279] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2673), 1,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28349] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2675), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28419] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2677), 1,
      aux_sym_if_token2,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28489] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2679), 1,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28559] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2681), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28629] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2683), 1,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28699] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2685), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28769] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2687), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28839] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2689), 1,
      aux_sym_if_token2,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28909] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2691), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [28979] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2693), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [29049] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2695), 1,
      aux_sym_if_token2,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [29119] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2697), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [29189] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2699), 1,
      aux_sym_loop_token1,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [29259] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2701), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [29329] = 11,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_LPAREN,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2278), 1,
      anon_sym_DOT,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2703), 1,
      anon_sym_RPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [29399] = 10,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LBRACK,
    ACTIONS(2619), 1,
      aux_sym_logical_operator_token6,
    ACTIONS(2705), 1,
      anon_sym_DOT,
    ACTIONS(2707), 1,
      anon_sym_LPAREN,
    ACTIONS(2613), 3,
      aux_sym_relational_operator_token1,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2617), 5,
      aux_sym_logical_operator_token1,
      aux_sym_logical_operator_token2,
      aux_sym_logical_operator_token3,
      aux_sym_logical_operator_token4,
      aux_sym_logical_operator_token5,
    ACTIONS(2615), 7,
      aux_sym_relational_operator_token2,
      aux_sym_relational_operator_token3,
      anon_sym_EQ,
      anon_sym_TILDE_EQ,
      anon_sym_LT_GT,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(2621), 7,
      anon_sym_STAR_STAR,
      anon_sym_STAR,
      anon_sym_SLASH,
      aux_sym_arithmetic_operator_token1,
      aux_sym_arithmetic_operator_token2,
      anon_sym_DASH,
      anon_sym_PLUS,
    ACTIONS(2611), 19,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
      anon_sym__and_LT_LT,
      anon_sym__andif_LT_LT,
      anon_sym__or_LT_LT,
      anon_sym__orif_LT_LT,
      anon_sym__xor_LT_LT,
      anon_sym_STAR_STAR_LT_LT,
      anon_sym_STAR_STAR_CARET_LT_LT,
      anon_sym_STAR_LT_LT,
      anon_sym_STAR_CARET_LT_LT,
      anon_sym_SLASH_LT_LT,
      anon_sym_SLASH_CARET_LT_LT,
      anon_sym__mod_LT_LT,
      anon_sym__div_LT_LT,
      anon_sym_DASH_LT_LT,
      anon_sym_DASH_CARET_LT_LT,
      anon_sym_PLUS_LT_LT,
      anon_sym_PLUS_CARET_LT_LT,
  [29466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2711), 1,
      anon_sym_COMMA,
    STATE(1023), 1,
      aux_sym_dynamic_repeat1,
    ACTIONS(2709), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    ACTIONS(2716), 1,
      anon_sym_LT_LT,
    STATE(1037), 1,
      aux_sym_local_repeat1,
    ACTIONS(2714), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2720), 1,
      anon_sym_COMMA,
    STATE(1035), 1,
      aux_sym_global_repeat1,
    ACTIONS(2718), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2720), 1,
      anon_sym_COMMA,
    STATE(1025), 1,
      aux_sym_global_repeat1,
    ACTIONS(2722), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_COMMA,
    STATE(1038), 1,
      aux_sym_dynamic_repeat1,
    ACTIONS(2724), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29614] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_COMMA,
    ACTIONS(2730), 1,
      anon_sym_LT_LT,
    STATE(1023), 1,
      aux_sym_dynamic_repeat1,
    ACTIONS(2728), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29645] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_CR,
    STATE(1030), 1,
      aux_sym__codeblock_repeat1,
    ACTIONS(1973), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(14), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(1979), 13,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
  [29678] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1971), 1,
      anon_sym_CR,
    STATE(1032), 1,
      aux_sym__codeblock_repeat1,
    ACTIONS(2732), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(15), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(2734), 13,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
  [29711] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    STATE(1041), 1,
      aux_sym__identifier_list_repeat1,
    ACTIONS(2193), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29740] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_CR,
    STATE(1032), 1,
      aux_sym__codeblock_repeat1,
    ACTIONS(2741), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(245), 2,
      sym__line_terminator,
      sym__terminator,
    ACTIONS(2139), 13,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
  [29773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2744), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym__identifier_list_repeat1,
    ACTIONS(2162), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    ACTIONS(2749), 1,
      anon_sym_LT_LT,
    STATE(1024), 1,
      aux_sym_local_repeat1,
    ACTIONS(2747), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2753), 1,
      anon_sym_COMMA,
    STATE(1035), 1,
      aux_sym_global_repeat1,
    ACTIONS(2751), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29862] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_COMMA,
    ACTIONS(2758), 1,
      anon_sym_LT_LT,
    STATE(1028), 1,
      aux_sym_dynamic_repeat1,
    ACTIONS(2756), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29893] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2762), 1,
      anon_sym_COMMA,
    STATE(1037), 1,
      aux_sym_local_repeat1,
    ACTIONS(2760), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_COMMA,
    STATE(1023), 1,
      aux_sym_dynamic_repeat1,
    ACTIONS(2765), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2709), 19,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      anon_sym_LT_LT,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [29976] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2060), 1,
      anon_sym_COMMA,
    ACTIONS(2767), 1,
      anon_sym_LT_LT,
    STATE(1037), 1,
      aux_sym_local_repeat1,
    ACTIONS(2121), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30007] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_COMMA,
    STATE(1033), 1,
      aux_sym__identifier_list_repeat1,
    ACTIONS(2209), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2162), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 18,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2769), 1,
      anon_sym_LT_LT,
    ACTIONS(2760), 17,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LT_LT,
    ACTIONS(2143), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 1,
      anon_sym_LT_LT,
    ACTIONS(2131), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30160] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 1,
      anon_sym_LT_LT,
    ACTIONS(2133), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 1,
      anon_sym_LT_LT,
    ACTIONS(2141), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2782), 1,
      anon_sym_LT_LT,
    ACTIONS(2123), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 1,
      anon_sym_LT_LT,
    ACTIONS(2129), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30283] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 17,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 1,
      anon_sym_LT_LT,
    ACTIONS(2058), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_LT_LT,
    ACTIONS(2121), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 1,
      anon_sym_LT_LT,
    ACTIONS(2119), 16,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_method_token7,
      aux_sym_procedure_token2,
      aux_sym_block_token2,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
      aux_sym_loop_token2,
      aux_sym_finally_token1,
      aux_sym_catch_token2,
      aux_sym_try_token2,
      aux_sym_try_token3,
      aux_sym_protect_token4,
      aux_sym_lock_token2,
      anon_sym_SEMI,
  [30381] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_COMMA,
    ACTIONS(2790), 1,
      anon_sym_LT_LT,
    STATE(1072), 1,
      aux_sym_local_repeat1,
    ACTIONS(2121), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [30400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      aux_sym_protect_token3,
    ACTIONS(2738), 1,
      anon_sym_CR,
    STATE(1057), 1,
      aux_sym__codeblock_repeat1,
    ACTIONS(2792), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(246), 2,
      sym__line_terminator,
      sym__terminator,
  [30421] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2795), 1,
      anon_sym_COMMA,
    ACTIONS(2797), 1,
      aux_sym_method_token5,
    ACTIONS(2799), 1,
      aux_sym_method_token6,
    ACTIONS(2801), 1,
      anon_sym_RPAREN,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1180), 1,
      sym_argument,
  [30446] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2805), 1,
      anon_sym_COMMA,
    ACTIONS(2807), 1,
      aux_sym_method_token5,
    ACTIONS(2809), 1,
      aux_sym_method_token6,
    ACTIONS(2811), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym__identifier,
    STATE(1176), 1,
      sym_argument,
  [30471] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2815), 1,
      anon_sym_LF,
    ACTIONS(2817), 1,
      anon_sym_LPAREN,
    ACTIONS(2821), 1,
      anon_sym_LBRACK,
    STATE(93), 1,
      sym__line_terminator,
    ACTIONS(2819), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [30494] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2823), 1,
      anon_sym_COMMA,
    ACTIONS(2825), 1,
      aux_sym_method_token5,
    ACTIONS(2827), 1,
      aux_sym_method_token6,
    ACTIONS(2829), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym__identifier,
    STATE(1099), 1,
      sym_argument,
  [30519] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2831), 1,
      anon_sym_COMMA,
    ACTIONS(2833), 1,
      aux_sym_method_token5,
    ACTIONS(2835), 1,
      aux_sym_method_token6,
    ACTIONS(2837), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym__identifier,
    STATE(1158), 1,
      sym_argument,
  [30544] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
    ACTIONS(2201), 4,
      anon_sym_COMMA,
      aux_sym_method_token6,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [30563] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2839), 1,
      anon_sym_COMMA,
    ACTIONS(2841), 1,
      aux_sym_method_token5,
    ACTIONS(2843), 1,
      aux_sym_method_token6,
    ACTIONS(2845), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym__identifier,
    STATE(1187), 1,
      sym_argument,
  [30588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1979), 1,
      aux_sym_protect_token3,
    ACTIONS(2492), 1,
      anon_sym_CR,
    STATE(1068), 1,
      aux_sym__codeblock_repeat1,
    ACTIONS(2494), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(243), 2,
      sym__line_terminator,
      sym__terminator,
  [30609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_COMMA,
    ACTIONS(2847), 1,
      anon_sym_LT_LT,
    STATE(1074), 1,
      aux_sym_local_repeat1,
    ACTIONS(2747), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [30628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_COMMA,
    ACTIONS(2849), 1,
      anon_sym_LT_LT,
    STATE(1071), 1,
      aux_sym_dynamic_repeat1,
    ACTIONS(2756), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [30647] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 1,
      anon_sym_CR,
    ACTIONS(2734), 1,
      aux_sym_protect_token3,
    STATE(1057), 1,
      aux_sym__codeblock_repeat1,
    ACTIONS(2851), 2,
      anon_sym_LF,
      anon_sym_SEMI,
    STATE(244), 2,
      sym__line_terminator,
      sym__terminator,
  [30668] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
    ACTIONS(2213), 4,
      anon_sym_COMMA,
      aux_sym_method_token6,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [30687] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2853), 1,
      anon_sym_COMMA,
    ACTIONS(2855), 1,
      aux_sym_method_token5,
    ACTIONS(2857), 1,
      aux_sym_method_token6,
    ACTIONS(2859), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym__identifier,
    STATE(1131), 1,
      sym_argument,
  [30712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 1,
      anon_sym_COMMA,
    ACTIONS(2861), 1,
      anon_sym_LT_LT,
    STATE(1023), 1,
      aux_sym_dynamic_repeat1,
    ACTIONS(2728), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [30731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2863), 1,
      anon_sym_COMMA,
    STATE(1072), 1,
      aux_sym_local_repeat1,
    ACTIONS(2760), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_LT_LT,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [30748] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2866), 1,
      anon_sym_LF,
    ACTIONS(2868), 1,
      anon_sym_LPAREN,
    ACTIONS(2872), 1,
      anon_sym_LBRACK,
    STATE(61), 1,
      sym__line_terminator,
    ACTIONS(2870), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [30771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_COMMA,
    ACTIONS(2874), 1,
      anon_sym_LT_LT,
    STATE(1072), 1,
      aux_sym_local_repeat1,
    ACTIONS(2714), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [30790] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2876), 1,
      anon_sym_COMMA,
    ACTIONS(2878), 1,
      aux_sym_method_token5,
    ACTIONS(2880), 1,
      aux_sym_method_token6,
    ACTIONS(2882), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym__identifier,
    STATE(1191), 1,
      sym_argument,
  [30815] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2884), 1,
      anon_sym_COMMA,
    ACTIONS(2886), 1,
      aux_sym_method_token5,
    ACTIONS(2888), 1,
      aux_sym_method_token6,
    ACTIONS(2890), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym__identifier,
    STATE(1197), 1,
      sym_argument,
  [30840] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2892), 1,
      anon_sym_COMMA,
    ACTIONS(2894), 1,
      aux_sym_method_token5,
    ACTIONS(2896), 1,
      aux_sym_method_token6,
    ACTIONS(2898), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym__identifier,
    STATE(1110), 1,
      sym_argument,
  [30865] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2900), 1,
      anon_sym_LF,
    ACTIONS(2902), 1,
      anon_sym_LPAREN,
    ACTIONS(2906), 1,
      anon_sym_LBRACK,
    STATE(77), 1,
      sym__line_terminator,
    ACTIONS(2904), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [30888] = 8,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2908), 1,
      anon_sym_COMMA,
    ACTIONS(2910), 1,
      aux_sym_method_token5,
    ACTIONS(2912), 1,
      aux_sym_method_token6,
    ACTIONS(2914), 1,
      anon_sym_RPAREN,
    STATE(677), 1,
      sym__identifier,
    STATE(1118), 1,
      sym_argument,
  [30913] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2916), 1,
      anon_sym_LF,
    ACTIONS(2918), 1,
      anon_sym_LPAREN,
    ACTIONS(2922), 1,
      anon_sym_LBRACK,
    STATE(92), 1,
      sym__line_terminator,
    ACTIONS(2920), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [30936] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(381), 1,
      aux_sym_elif_token1,
    ACTIONS(383), 1,
      aux_sym_else_token1,
    ACTIONS(2924), 1,
      aux_sym_if_token3,
    STATE(1701), 1,
      sym_else,
    STATE(1083), 2,
      sym_elif,
      aux_sym_if_repeat1,
  [30956] = 7,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2926), 1,
      anon_sym_LPAREN,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2930), 1,
      aux_sym_local_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1839), 1,
      sym__identifier_list,
  [30978] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(381), 1,
      aux_sym_elif_token1,
    ACTIONS(383), 1,
      aux_sym_else_token1,
    ACTIONS(2932), 1,
      aux_sym_if_token3,
    STATE(1729), 1,
      sym_else,
    STATE(1147), 2,
      sym_elif,
      aux_sym_if_repeat1,
  [30998] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(381), 1,
      aux_sym_elif_token1,
    ACTIONS(383), 1,
      aux_sym_else_token1,
    ACTIONS(2934), 1,
      aux_sym_if_token3,
    STATE(1895), 1,
      sym_else,
    STATE(1087), 2,
      sym_elif,
      aux_sym_if_repeat1,
  [31018] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(381), 1,
      aux_sym_elif_token1,
    ACTIONS(383), 1,
      aux_sym_else_token1,
    ACTIONS(2934), 1,
      aux_sym_if_token3,
    STATE(1895), 1,
      sym_else,
    STATE(1147), 2,
      sym_elif,
      aux_sym_if_repeat1,
  [31038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_LT_LT,
    ACTIONS(2760), 5,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31052] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(381), 1,
      aux_sym_elif_token1,
    ACTIONS(383), 1,
      aux_sym_else_token1,
    ACTIONS(2939), 1,
      aux_sym_if_token3,
    STATE(1848), 1,
      sym_else,
    STATE(1147), 2,
      sym_elif,
      aux_sym_if_repeat1,
  [31072] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2941), 1,
      anon_sym_COMMA,
    STATE(1088), 1,
      aux_sym_method_repeat1,
    ACTIONS(2149), 4,
      aux_sym_method_token5,
      aux_sym_method_token6,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [31088] = 7,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2944), 1,
      anon_sym_LPAREN,
    ACTIONS(2946), 1,
      aux_sym_local_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1918), 1,
      sym__identifier_list,
  [31110] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(381), 1,
      aux_sym_elif_token1,
    ACTIONS(383), 1,
      aux_sym_else_token1,
    ACTIONS(2924), 1,
      aux_sym_if_token3,
    STATE(1701), 1,
      sym_else,
    STATE(1147), 2,
      sym_elif,
      aux_sym_if_repeat1,
  [31130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2948), 1,
      anon_sym_LF,
    STATE(58), 1,
      sym__line_terminator,
    ACTIONS(2950), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2952), 1,
      anon_sym_LF,
    STATE(39), 1,
      sym__line_terminator,
    ACTIONS(2954), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31164] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2956), 1,
      anon_sym_COMMA,
    ACTIONS(2958), 1,
      aux_sym_method_token5,
    ACTIONS(2960), 1,
      aux_sym_method_token6,
    ACTIONS(2962), 1,
      anon_sym_RPAREN,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [31183] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2958), 1,
      aux_sym_method_token5,
    ACTIONS(2960), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2964), 1,
      anon_sym_LF,
    STATE(35), 1,
      sym__line_terminator,
    ACTIONS(2966), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31219] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2914), 1,
      anon_sym_RBRACK,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1789), 1,
      sym__arguments,
  [31238] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2968), 1,
      anon_sym_LF,
    STATE(29), 1,
      sym__line_terminator,
    ACTIONS(2970), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2972), 1,
      anon_sym_LF,
    STATE(27), 1,
      sym__line_terminator,
    ACTIONS(2974), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31272] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2976), 1,
      anon_sym_COMMA,
    ACTIONS(2978), 1,
      aux_sym_method_token5,
    ACTIONS(2980), 1,
      aux_sym_method_token6,
    ACTIONS(2982), 1,
      anon_sym_RPAREN,
    STATE(1126), 1,
      aux_sym_method_repeat1,
  [31291] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2984), 1,
      aux_sym_method_token5,
    ACTIONS(2986), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31310] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2988), 1,
      aux_sym_method_token5,
    ACTIONS(2990), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31329] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2992), 1,
      aux_sym_method_token5,
    ACTIONS(2994), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2996), 1,
      anon_sym_LT_LT,
    ACTIONS(2058), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31361] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2998), 1,
      aux_sym_method_token5,
    ACTIONS(3000), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31380] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2878), 1,
      aux_sym_method_token5,
    ACTIONS(2880), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31399] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3002), 1,
      aux_sym_method_token5,
    ACTIONS(3004), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31418] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3006), 1,
      anon_sym_LF,
    STATE(63), 1,
      sym__line_terminator,
    ACTIONS(3008), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31435] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3002), 1,
      aux_sym_method_token5,
    ACTIONS(3004), 1,
      aux_sym_method_token6,
    ACTIONS(3010), 1,
      anon_sym_COMMA,
    ACTIONS(3012), 1,
      anon_sym_RPAREN,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [31454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LT_LT,
    ACTIONS(2121), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31467] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3014), 1,
      anon_sym_COMMA,
    ACTIONS(3016), 1,
      aux_sym_method_token5,
    ACTIONS(3018), 1,
      aux_sym_method_token6,
    ACTIONS(3020), 1,
      anon_sym_RPAREN,
    STATE(1108), 1,
      aux_sym_method_repeat1,
  [31486] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3022), 1,
      anon_sym_LF,
    STATE(45), 1,
      sym__line_terminator,
    ACTIONS(3024), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3026), 1,
      anon_sym_LT_LT,
    ACTIONS(2123), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31516] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3028), 1,
      aux_sym_method_token5,
    ACTIONS(3030), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3032), 1,
      anon_sym_LF,
    STATE(51), 1,
      sym__line_terminator,
    ACTIONS(3034), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3036), 1,
      anon_sym_LT_LT,
    ACTIONS(2119), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3038), 1,
      anon_sym_LT_LT,
    ACTIONS(2131), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31578] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3040), 1,
      anon_sym_LF,
    STATE(82), 1,
      sym__line_terminator,
    ACTIONS(3042), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31595] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3044), 1,
      anon_sym_COMMA,
    ACTIONS(3046), 1,
      aux_sym_method_token5,
    ACTIONS(3048), 1,
      aux_sym_method_token6,
    ACTIONS(3050), 1,
      anon_sym_RPAREN,
    STATE(1139), 1,
      aux_sym_method_repeat1,
  [31614] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2829), 1,
      anon_sym_RBRACK,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1914), 1,
      sym__arguments,
  [31633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3052), 1,
      anon_sym_LT_LT,
    ACTIONS(2133), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3054), 1,
      anon_sym_LT_LT,
    ACTIONS(2129), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3056), 1,
      anon_sym_LF,
    STATE(86), 1,
      sym__line_terminator,
    ACTIONS(3058), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31676] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3060), 1,
      aux_sym_method_token5,
    ACTIONS(3062), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3064), 1,
      anon_sym_LF,
    STATE(68), 1,
      sym__line_terminator,
    ACTIONS(3066), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31712] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3068), 1,
      anon_sym_LF,
    STATE(59), 1,
      sym__line_terminator,
    ACTIONS(3070), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31729] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3060), 1,
      aux_sym_method_token5,
    ACTIONS(3062), 1,
      aux_sym_method_token6,
    ACTIONS(3072), 1,
      anon_sym_COMMA,
    ACTIONS(3074), 1,
      anon_sym_RPAREN,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [31748] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3076), 1,
      anon_sym_LT_LT,
    ACTIONS(2141), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3078), 1,
      anon_sym_LT_LT,
    ACTIONS(2143), 4,
      anon_sym_CR,
      anon_sym_LF,
      aux_sym_protect_token3,
      anon_sym_SEMI,
  [31774] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3080), 1,
      anon_sym_LF,
    STATE(54), 1,
      sym__line_terminator,
    ACTIONS(3082), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31791] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3084), 1,
      aux_sym_method_token5,
    ACTIONS(3086), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31810] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3088), 1,
      anon_sym_COMMA,
    ACTIONS(3090), 1,
      aux_sym_method_token5,
    ACTIONS(3092), 1,
      aux_sym_method_token6,
    ACTIONS(3094), 1,
      anon_sym_RPAREN,
    STATE(1093), 1,
      aux_sym_method_repeat1,
  [31829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3096), 1,
      anon_sym_LF,
    STATE(42), 1,
      sym__line_terminator,
    ACTIONS(3098), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31846] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3100), 1,
      anon_sym_LF,
    STATE(46), 1,
      sym__line_terminator,
    ACTIONS(3102), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31863] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3104), 1,
      anon_sym_COMMA,
    ACTIONS(3106), 1,
      aux_sym_method_token5,
    ACTIONS(3108), 1,
      aux_sym_method_token6,
    ACTIONS(3110), 1,
      anon_sym_RPAREN,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [31882] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3106), 1,
      aux_sym_method_token5,
    ACTIONS(3108), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31901] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3112), 1,
      aux_sym_method_token5,
    ACTIONS(3114), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [31920] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3116), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3118), 1,
      aux_sym__global_assignment_token1,
    ACTIONS(3120), 1,
      sym_dynamic_variable,
    STATE(662), 1,
      sym__identifier,
    STATE(1858), 1,
      sym_identifier,
  [31939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3122), 1,
      anon_sym_LF,
    STATE(79), 1,
      sym__line_terminator,
    ACTIONS(3124), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31956] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3112), 1,
      aux_sym_method_token5,
    ACTIONS(3114), 1,
      aux_sym_method_token6,
    ACTIONS(3126), 1,
      anon_sym_COMMA,
    ACTIONS(3128), 1,
      anon_sym_RPAREN,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [31975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3130), 1,
      anon_sym_LF,
    STATE(91), 1,
      sym__line_terminator,
    ACTIONS(3132), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [31992] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2898), 1,
      anon_sym_RBRACK,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1828), 1,
      sym__arguments,
  [32011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3134), 1,
      anon_sym_LF,
    STATE(67), 1,
      sym__line_terminator,
    ACTIONS(3136), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32028] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3138), 1,
      anon_sym_RBRACK,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1782), 1,
      sym__arguments,
  [32047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3140), 1,
      anon_sym_LF,
    STATE(55), 1,
      sym__line_terminator,
    ACTIONS(3142), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32064] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3144), 1,
      aux_sym_method_token5,
    ACTIONS(3146), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [32083] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3148), 1,
      anon_sym_LF,
    STATE(22), 1,
      sym__line_terminator,
    ACTIONS(3150), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32100] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3154), 1,
      aux_sym_elif_token1,
    ACTIONS(3152), 2,
      aux_sym_if_token3,
      aux_sym_else_token1,
    STATE(1147), 2,
      sym_elif,
      aux_sym_if_repeat1,
  [32115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      aux_sym_slot_accessor_token1,
    STATE(1447), 1,
      sym__identifier,
    STATE(1491), 1,
      sym_argument,
    ACTIONS(2215), 2,
      anon_sym_CR,
      anon_sym_LF,
  [32132] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3159), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1026), 1,
      sym_identifier,
    ACTIONS(3161), 2,
      sym_dynamic_variable,
      sym_global_variable,
  [32149] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2930), 1,
      aux_sym__global_assignment_token1,
    ACTIONS(3163), 1,
      anon_sym_LPAREN,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1034), 1,
      sym_identifier,
  [32168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3167), 1,
      anon_sym_LF,
    STATE(76), 1,
      sym__line_terminator,
    ACTIONS(3169), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32185] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3157), 1,
      aux_sym_slot_accessor_token1,
    STATE(1447), 1,
      sym__identifier,
    STATE(1491), 1,
      sym_argument,
    ACTIONS(2203), 2,
      anon_sym_CR,
      anon_sym_LF,
  [32202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3171), 1,
      anon_sym_LF,
    STATE(83), 1,
      sym__line_terminator,
    ACTIONS(3173), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32219] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3175), 1,
      anon_sym_COMMA,
    STATE(1088), 1,
      aux_sym_method_repeat1,
    ACTIONS(2201), 3,
      aux_sym_method_token6,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [32234] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2859), 1,
      anon_sym_RBRACK,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1705), 1,
      sym__arguments,
  [32253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3177), 1,
      anon_sym_LF,
    STATE(26), 1,
      sym__line_terminator,
    ACTIONS(3179), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3181), 1,
      anon_sym_LF,
    STATE(81), 1,
      sym__line_terminator,
    ACTIONS(3183), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32287] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      aux_sym_method_token5,
    ACTIONS(3189), 1,
      aux_sym_method_token6,
    ACTIONS(3191), 1,
      anon_sym_RPAREN,
    STATE(1134), 1,
      aux_sym_method_repeat1,
  [32306] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3193), 1,
      anon_sym_COMMA,
    STATE(1200), 1,
      aux_sym__identifier_list_repeat1,
    ACTIONS(2189), 3,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      aux_sym_iterator_token2,
  [32321] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3185), 1,
      anon_sym_COMMA,
    ACTIONS(3187), 1,
      aux_sym_method_token5,
    ACTIONS(3189), 1,
      aux_sym_method_token6,
    ACTIONS(3191), 1,
      anon_sym_RPAREN,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [32340] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3187), 1,
      aux_sym_method_token5,
    ACTIONS(3189), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [32359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3195), 1,
      anon_sym_LF,
    STATE(30), 1,
      sym__line_terminator,
    ACTIONS(3197), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3199), 1,
      anon_sym_LF,
    STATE(66), 1,
      sym__line_terminator,
    ACTIONS(3201), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32393] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3203), 1,
      aux_sym_method_token5,
    ACTIONS(3205), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [32412] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3207), 1,
      anon_sym_RBRACK,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1683), 1,
      sym__arguments,
  [32431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3209), 1,
      anon_sym_LF,
    STATE(41), 1,
      sym__line_terminator,
    ACTIONS(3211), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32448] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3213), 1,
      anon_sym_LF,
    STATE(94), 1,
      sym__line_terminator,
    ACTIONS(3215), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3217), 1,
      anon_sym_LF,
    STATE(44), 1,
      sym__line_terminator,
    ACTIONS(3219), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32482] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2946), 1,
      aux_sym__global_assignment_token1,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3221), 1,
      anon_sym_LPAREN,
    STATE(532), 1,
      sym__identifier,
    STATE(1066), 1,
      sym_identifier,
  [32501] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3223), 1,
      anon_sym_COMMA,
    STATE(1170), 1,
      aux_sym__identifier_list_repeat1,
    ACTIONS(2160), 3,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      aux_sym_iterator_token2,
  [32516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3226), 1,
      anon_sym_LF,
    STATE(47), 1,
      sym__line_terminator,
    ACTIONS(3228), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32533] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3159), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1043), 1,
      sym_identifier,
    ACTIONS(3230), 2,
      sym_dynamic_variable,
      sym_global_variable,
  [32550] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3232), 1,
      anon_sym_LF,
    STATE(90), 1,
      sym__line_terminator,
    ACTIONS(3234), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32567] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2833), 1,
      aux_sym_method_token5,
    ACTIONS(2835), 1,
      aux_sym_method_token6,
    ACTIONS(2837), 1,
      anon_sym_RPAREN,
    ACTIONS(3236), 1,
      anon_sym_COMMA,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [32586] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(2833), 1,
      aux_sym_method_token5,
    ACTIONS(2835), 1,
      aux_sym_method_token6,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [32605] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2797), 1,
      aux_sym_method_token5,
    ACTIONS(2799), 1,
      aux_sym_method_token6,
    ACTIONS(2801), 1,
      anon_sym_RPAREN,
    ACTIONS(3238), 1,
      anon_sym_COMMA,
    STATE(1182), 1,
      aux_sym_method_repeat1,
  [32624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3240), 1,
      anon_sym_LF,
    STATE(60), 1,
      sym__line_terminator,
    ACTIONS(3242), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32641] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3244), 1,
      anon_sym_LPAREN,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1937), 1,
      sym__identifier_list,
  [32660] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3116), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3246), 1,
      aux_sym__global_assignment_token1,
    ACTIONS(3248), 1,
      sym_dynamic_variable,
    STATE(662), 1,
      sym__identifier,
    STATE(1749), 1,
      sym_identifier,
  [32679] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2878), 1,
      aux_sym_method_token5,
    ACTIONS(2880), 1,
      aux_sym_method_token6,
    ACTIONS(2882), 1,
      anon_sym_RPAREN,
    ACTIONS(3250), 1,
      anon_sym_COMMA,
    STATE(1189), 1,
      aux_sym_method_repeat1,
  [32698] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3252), 1,
      anon_sym_LF,
    STATE(62), 1,
      sym__line_terminator,
    ACTIONS(3254), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32715] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2878), 1,
      aux_sym_method_token5,
    ACTIONS(2880), 1,
      aux_sym_method_token6,
    ACTIONS(2882), 1,
      anon_sym_RPAREN,
    ACTIONS(3250), 1,
      anon_sym_COMMA,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [32734] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3256), 1,
      anon_sym_COMMA,
    STATE(1154), 1,
      aux_sym_method_repeat1,
    ACTIONS(2195), 3,
      aux_sym_method_token6,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [32749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3258), 1,
      anon_sym_LF,
    STATE(84), 1,
      sym__line_terminator,
    ACTIONS(3260), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3262), 1,
      anon_sym_LF,
    STATE(40), 1,
      sym__line_terminator,
    ACTIONS(3264), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3266), 1,
      anon_sym_LF,
    STATE(38), 1,
      sym__line_terminator,
    ACTIONS(3268), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32800] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2833), 1,
      aux_sym_method_token5,
    ACTIONS(2835), 1,
      aux_sym_method_token6,
    ACTIONS(2837), 1,
      anon_sym_RPAREN,
    ACTIONS(3236), 1,
      anon_sym_COMMA,
    STATE(1160), 1,
      aux_sym_method_repeat1,
  [32819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3270), 1,
      anon_sym_LF,
    STATE(65), 1,
      sym__line_terminator,
    ACTIONS(3272), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32836] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2998), 1,
      aux_sym_method_token5,
    ACTIONS(3000), 1,
      aux_sym_method_token6,
    ACTIONS(3274), 1,
      anon_sym_COMMA,
    ACTIONS(3276), 1,
      anon_sym_RPAREN,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [32855] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3278), 1,
      anon_sym_RBRACK,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1770), 1,
      sym__arguments,
  [32874] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2998), 1,
      aux_sym_method_token5,
    ACTIONS(3000), 1,
      aux_sym_method_token6,
    ACTIONS(3274), 1,
      anon_sym_COMMA,
    ACTIONS(3276), 1,
      anon_sym_RPAREN,
    STATE(1195), 1,
      aux_sym_method_repeat1,
  [32893] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3280), 1,
      anon_sym_RBRACK,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1726), 1,
      sym__arguments,
  [32912] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3282), 1,
      anon_sym_LF,
    STATE(70), 1,
      sym__line_terminator,
    ACTIONS(3284), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32929] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3286), 1,
      anon_sym_LF,
    STATE(21), 1,
      sym__line_terminator,
    ACTIONS(3288), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32946] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2992), 1,
      aux_sym_method_token5,
    ACTIONS(2994), 1,
      aux_sym_method_token6,
    ACTIONS(3290), 1,
      anon_sym_COMMA,
    ACTIONS(3292), 1,
      anon_sym_RPAREN,
    STATE(1088), 1,
      aux_sym_method_repeat1,
  [32965] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3294), 1,
      anon_sym_LF,
    STATE(34), 1,
      sym__line_terminator,
    ACTIONS(3296), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [32982] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2841), 1,
      aux_sym_method_token5,
    ACTIONS(2843), 1,
      aux_sym_method_token6,
    ACTIONS(2845), 1,
      anon_sym_RPAREN,
    ACTIONS(3298), 1,
      anon_sym_COMMA,
    STATE(1174), 1,
      aux_sym_method_repeat1,
  [33001] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3300), 1,
      anon_sym_LF,
    STATE(80), 1,
      sym__line_terminator,
    ACTIONS(3302), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [33018] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3304), 1,
      anon_sym_LF,
    STATE(89), 1,
      sym__line_terminator,
    ACTIONS(3306), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [33035] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3193), 1,
      anon_sym_COMMA,
    STATE(1170), 1,
      aux_sym__identifier_list_repeat1,
    ACTIONS(2207), 3,
      anon_sym_RPAREN,
      anon_sym_LT_LT,
      aux_sym_iterator_token2,
  [33050] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3308), 1,
      anon_sym_LF,
    STATE(69), 1,
      sym__line_terminator,
    ACTIONS(3310), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [33067] = 6,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3312), 1,
      anon_sym_LPAREN,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1754), 1,
      sym__identifier_list,
  [33086] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3314), 1,
      anon_sym_LF,
    STATE(37), 1,
      sym__line_terminator,
    ACTIONS(3316), 2,
      anon_sym_LT_LT,
      anon_sym_CARET_LT_LT,
  [33103] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1410), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [33119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(549), 1,
      sym__identifier,
    ACTIONS(3320), 3,
      aux_sym_character_literal_token1,
      anon_sym_SPACE,
      aux_sym_slot_accessor_token1,
  [33131] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1481), 1,
      sym__arguments,
  [33147] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1478), 1,
      sym__arguments,
  [33163] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1752), 1,
      sym__identifier_list,
  [33179] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1934), 1,
      sym__identifier_list,
  [33195] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3322), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1485), 1,
      sym_identifier,
  [33211] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1461), 1,
      sym__arguments,
  [33227] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1376), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [33243] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1424), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [33259] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1425), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [33275] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3324), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1485), 1,
      sym_identifier,
  [33291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3326), 1,
      anon_sym_COMMA,
    STATE(1250), 1,
      aux_sym_method_repeat1,
    ACTIONS(2199), 2,
      anon_sym_CR,
      anon_sym_LF,
  [33305] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1486), 1,
      sym__arguments,
  [33321] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1451), 1,
      sym__arguments,
  [33337] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3328), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1485), 1,
      sym_identifier,
  [33353] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(197), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33369] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(192), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33385] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(188), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33401] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1484), 1,
      sym__arguments,
  [33417] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1457), 1,
      sym__arguments,
  [33433] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(185), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3330), 1,
      anon_sym_DQUOTE,
    STATE(1226), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3332), 2,
      aux_sym_string_literal_token1,
      aux_sym_string_literal_token2,
  [33463] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3335), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1485), 1,
      sym_identifier,
  [33479] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(183), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33495] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1495), 1,
      sym__arguments,
  [33511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3340), 1,
      anon_sym_SQUOTE,
    STATE(1230), 1,
      aux_sym_string_literal_repeat2,
    ACTIONS(3337), 2,
      aux_sym_string_literal_token2,
      aux_sym_string_literal_token3,
  [33525] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(174), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33541] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1505), 1,
      sym__arguments,
  [33557] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1441), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [33573] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1440), 1,
      sym__arguments,
  [33589] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(169), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33605] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3344), 1,
      anon_sym_SQUOTE,
    STATE(1230), 1,
      aux_sym_string_literal_repeat2,
    ACTIONS(3342), 2,
      aux_sym_string_literal_token2,
      aux_sym_string_literal_token3,
  [33619] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1546), 1,
      sym__arguments,
  [33635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3344), 1,
      anon_sym_DQUOTE,
    STATE(1226), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3346), 2,
      aux_sym_string_literal_token1,
      aux_sym_string_literal_token2,
  [33649] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(163), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33665] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1435), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [33681] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1868), 1,
      sym__identifier_list,
  [33697] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(184), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33713] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3116), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3348), 1,
      sym_dynamic_variable,
    STATE(662), 1,
      sym__identifier,
    STATE(1733), 1,
      sym_identifier,
  [33729] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1498), 1,
      sym__arguments,
  [33745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 1,
      anon_sym_SQUOTE,
    STATE(1236), 1,
      aux_sym_string_literal_repeat2,
    ACTIONS(3350), 2,
      aux_sym_string_literal_token2,
      aux_sym_string_literal_token3,
  [33759] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(159), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33775] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3354), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1310), 1,
      sym_identifier,
  [33791] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(157), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3352), 1,
      anon_sym_DQUOTE,
    STATE(1238), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3356), 2,
      aux_sym_string_literal_token1,
      aux_sym_string_literal_token2,
  [33821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3358), 1,
      anon_sym_COMMA,
    STATE(1252), 1,
      aux_sym_method_repeat1,
    ACTIONS(2203), 2,
      anon_sym_CR,
      anon_sym_LF,
  [33835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(741), 1,
      sym__identifier,
    ACTIONS(3360), 3,
      aux_sym_character_literal_token1,
      anon_sym_SPACE,
      aux_sym_slot_accessor_token1,
  [33847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3362), 1,
      anon_sym_COMMA,
    STATE(1252), 1,
      aux_sym_method_repeat1,
    ACTIONS(2151), 2,
      anon_sym_CR,
      anon_sym_LF,
  [33861] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(191), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [33877] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1422), 1,
      sym__arguments,
  [33893] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1536), 1,
      sym__arguments,
  [33909] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1414), 1,
      sym__arguments,
  [33925] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1413), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [33941] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1530), 1,
      sym__arguments,
  [33957] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3365), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1485), 1,
      sym_identifier,
  [33973] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1512), 1,
      sym__arguments,
  [33989] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1405), 1,
      sym__arguments,
  [34005] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1378), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34021] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1516), 1,
      sym__arguments,
  [34037] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1521), 1,
      sym__arguments,
  [34053] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1522), 1,
      sym__arguments,
  [34069] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1445), 1,
      sym__arguments,
  [34085] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(155), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [34101] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3367), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1485), 1,
      sym_identifier,
  [34117] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(146), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [34133] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1526), 1,
      sym__arguments,
  [34149] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1514), 1,
      sym__arguments,
  [34165] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1519), 1,
      sym__arguments,
  [34181] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1349), 1,
      sym__arguments,
  [34197] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1395), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34213] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1394), 1,
      sym__arguments,
  [34229] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1389), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_DQUOTE,
    STATE(1309), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3371), 2,
      aux_sym_string_literal_token1,
      aux_sym_string_literal_token2,
  [34259] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1443), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34275] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1346), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34291] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1355), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34307] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1496), 1,
      sym__arguments,
  [34323] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3373), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1485), 1,
      sym_identifier,
  [34339] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3375), 1,
      anon_sym_COMMA,
    ACTIONS(3377), 1,
      anon_sym_RPAREN,
    ACTIONS(3379), 1,
      anon_sym_LT_LT,
    STATE(1462), 1,
      aux_sym_local_repeat1,
  [34355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3369), 1,
      anon_sym_SQUOTE,
    STATE(1306), 1,
      aux_sym_string_literal_repeat2,
    ACTIONS(3381), 2,
      aux_sym_string_literal_token2,
      aux_sym_string_literal_token3,
  [34369] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1374), 1,
      sym__arguments,
  [34385] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1372), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34401] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1510), 1,
      sym__arguments,
  [34417] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(137), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [34433] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1543), 1,
      sym__arguments,
  [34449] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(224), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [34465] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1475), 1,
      sym__arguments,
  [34481] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1493), 1,
      sym__arguments,
  [34497] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1524), 1,
      sym__arguments,
  [34513] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1358), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34529] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1456), 1,
      sym__arguments,
  [34545] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(142), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [34561] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1492), 1,
      sym__arguments,
  [34577] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1792), 1,
      sym__identifier_list,
  [34593] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1354), 1,
      sym__arguments,
  [34609] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(148), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [34625] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1366), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34641] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1518), 1,
      sym__arguments,
  [34657] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3116), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3248), 1,
      sym_dynamic_variable,
    STATE(662), 1,
      sym__identifier,
    STATE(1749), 1,
      sym_identifier,
  [34673] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1350), 1,
      sym__arguments,
  [34689] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1465), 1,
      sym__arguments,
  [34705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_SQUOTE,
    STATE(1230), 1,
      aux_sym_string_literal_repeat2,
    ACTIONS(3342), 2,
      aux_sym_string_literal_token2,
      aux_sym_string_literal_token3,
  [34719] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1345), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34735] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1777), 1,
      sym__identifier_list,
  [34751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3383), 1,
      anon_sym_DQUOTE,
    STATE(1226), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3346), 2,
      aux_sym_string_literal_token1,
      aux_sym_string_literal_token2,
  [34765] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3385), 1,
      anon_sym_COMMA,
    ACTIONS(3387), 1,
      anon_sym_RPAREN,
    ACTIONS(3389), 1,
      anon_sym_LT_LT,
    STATE(1375), 1,
      aux_sym_local_repeat1,
  [34781] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3391), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1283), 1,
      sym_identifier,
  [34797] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1482), 1,
      sym__arguments,
  [34813] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1159), 1,
      sym_identifier,
    STATE(1704), 1,
      sym__identifier_list,
  [34829] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(207), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [34845] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1426), 1,
      sym__arguments,
  [34861] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1357), 1,
      sym__arguments,
  [34877] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1360), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34893] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1511), 1,
      sym__arguments,
  [34909] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(190), 1,
      sym__identifier_list,
    STATE(662), 1,
      sym__identifier,
    STATE(687), 1,
      sym_identifier,
  [34925] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1373), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [34941] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1472), 1,
      sym__arguments,
  [34957] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1385), 1,
      sym__arguments,
  [34973] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1447), 1,
      sym__identifier,
    STATE(1453), 1,
      sym__arguments,
  [34989] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    ACTIONS(3393), 1,
      aux_sym_method_token6,
    STATE(662), 1,
      sym__identifier,
    STATE(1485), 1,
      sym_identifier,
  [35005] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(156), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [35021] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1428), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [35037] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1031), 1,
      sym_identifier,
    STATE(1049), 1,
      sym__identifier_list,
  [35053] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1415), 1,
      sym__arguments,
  [35069] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1401), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [35085] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1427), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [35101] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1398), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [35117] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1396), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [35133] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1432), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [35149] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(136), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [35165] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(226), 1,
      sym__arguments,
    STATE(677), 1,
      sym__identifier,
    STATE(689), 1,
      sym_argument,
  [35181] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1404), 1,
      sym__arguments,
  [35197] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1183), 1,
      sym_argument,
    STATE(1417), 1,
      sym__arguments,
  [35213] = 5,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1216), 1,
      sym_argument,
    STATE(1418), 1,
      sym__arguments,
    STATE(1447), 1,
      sym__identifier,
  [35229] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3395), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [35242] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1073), 1,
      sym_identifier,
  [35255] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(20), 1,
      sym_identifier,
    STATE(662), 1,
      sym__identifier,
  [35268] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1078), 1,
      sym_identifier,
  [35281] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(101), 1,
      sym_identifier,
    STATE(662), 1,
      sym__identifier,
  [35294] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1774), 1,
      sym_argument,
  [35307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3195), 1,
      anon_sym_LF,
    STATE(30), 1,
      sym__line_terminator,
  [35320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3397), 1,
      anon_sym_LF,
    STATE(88), 1,
      sym__line_terminator,
  [35333] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1766), 1,
      sym_argument,
  [35346] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1679), 1,
      sym_argument,
  [35359] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3189), 1,
      aux_sym_method_token6,
    ACTIONS(3191), 1,
      anon_sym_RPAREN,
    ACTIONS(3399), 1,
      anon_sym_COMMA,
  [35372] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3205), 1,
      aux_sym_method_token6,
    ACTIONS(3401), 1,
      anon_sym_COMMA,
    ACTIONS(3403), 1,
      anon_sym_RPAREN,
  [35385] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(3405), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [35398] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3407), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [35411] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(681), 1,
      sym_identifier,
  [35424] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3409), 1,
      anon_sym_COMMA,
    ACTIONS(3411), 1,
      aux_sym_method_token6,
    ACTIONS(3413), 1,
      anon_sym_RPAREN,
  [35437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3181), 1,
      anon_sym_LF,
    STATE(81), 1,
      sym__line_terminator,
  [35450] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(3415), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [35463] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3417), 1,
      anon_sym_COMMA,
    ACTIONS(3419), 1,
      aux_sym_method_token6,
    ACTIONS(3421), 1,
      anon_sym_RPAREN,
  [35476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3177), 1,
      anon_sym_LF,
    STATE(26), 1,
      sym__line_terminator,
  [35489] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(3423), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [35502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3209), 1,
      anon_sym_LF,
    STATE(41), 1,
      sym__line_terminator,
  [35515] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1712), 1,
      sym_argument,
  [35528] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1759), 1,
      sym_argument,
  [35541] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3425), 1,
      aux_sym_try_token3,
    STATE(1535), 1,
      aux_sym_try_repeat2,
  [35554] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1758), 1,
      sym_argument,
  [35567] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3427), 1,
      aux_sym_try_token3,
    STATE(1383), 1,
      aux_sym_try_repeat2,
  [35580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3167), 1,
      anon_sym_LF,
    STATE(76), 1,
      sym__line_terminator,
  [35593] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1781), 1,
      sym_argument,
  [35606] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(921), 1,
      sym_identifier,
  [35619] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(859), 1,
      sym_identifier,
  [35632] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(551), 1,
      aux_sym_finally_token1,
    ACTIONS(949), 1,
      aux_sym_loop_token2,
    STATE(1697), 1,
      sym_finally,
  [35645] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3429), 1,
      aux_sym_try_token3,
    STATE(1537), 1,
      aux_sym_try_repeat2,
  [35658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3148), 1,
      anon_sym_LF,
    STATE(22), 1,
      sym__line_terminator,
  [35671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3217), 1,
      anon_sym_LF,
    STATE(44), 1,
      sym__line_terminator,
  [35684] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3431), 1,
      anon_sym_COMMA,
    ACTIONS(3433), 1,
      aux_sym_method_token6,
    ACTIONS(3435), 1,
      anon_sym_RPAREN,
  [35697] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3437), 1,
      anon_sym_COMMA,
    ACTIONS(3439), 1,
      anon_sym_RPAREN,
    STATE(1474), 1,
      aux_sym_local_repeat1,
  [35710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3441), 1,
      anon_sym_LF,
    STATE(53), 1,
      sym__line_terminator,
  [35723] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3443), 1,
      aux_sym_try_token3,
    STATE(1535), 1,
      aux_sym_try_repeat2,
  [35736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3213), 1,
      anon_sym_LF,
    STATE(94), 1,
      sym__line_terminator,
  [35749] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3445), 1,
      anon_sym_COMMA,
    ACTIONS(3448), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [35762] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1743), 1,
      sym_argument,
  [35775] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(551), 1,
      aux_sym_finally_token1,
    ACTIONS(615), 1,
      aux_sym_loop_token2,
    STATE(1737), 1,
      sym_finally,
  [35788] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(3450), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [35801] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3452), 1,
      aux_sym_try_token3,
    STATE(1535), 1,
      aux_sym_try_repeat2,
  [35814] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1605), 1,
      sym_identifier,
  [35827] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3454), 1,
      anon_sym_COMMA,
    ACTIONS(3456), 1,
      aux_sym_method_token6,
    ACTIONS(3458), 1,
      anon_sym_RPAREN,
  [35840] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(122), 1,
      sym_identifier,
    STATE(662), 1,
      sym__identifier,
  [35853] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3460), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [35866] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3462), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [35879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3140), 1,
      anon_sym_LF,
    STATE(55), 1,
      sym__line_terminator,
  [35892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3464), 1,
      anon_sym_CR,
    ACTIONS(3466), 1,
      anon_sym_LF,
    STATE(685), 1,
      sym__line_terminator,
  [35905] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1736), 1,
      sym_argument,
  [35918] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1060), 1,
      sym_identifier,
  [35931] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1044), 1,
      sym_identifier,
  [35944] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3146), 1,
      aux_sym_method_token6,
    ACTIONS(3468), 1,
      anon_sym_COMMA,
    ACTIONS(3470), 1,
      anon_sym_RPAREN,
  [35957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3472), 1,
      anon_sym_LF,
    STATE(31), 1,
      sym__line_terminator,
  [35970] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3474), 1,
      anon_sym_LF,
    STATE(72), 1,
      sym__line_terminator,
  [35983] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(620), 1,
      sym_identifier,
  [35996] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3064), 1,
      anon_sym_LF,
    STATE(68), 1,
      sym__line_terminator,
  [36009] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1772), 1,
      sym_argument,
  [36022] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1791), 1,
      sym_argument,
  [36035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3226), 1,
      anon_sym_LF,
    STATE(47), 1,
      sym__line_terminator,
  [36048] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(3476), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [36061] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1658), 1,
      sym_identifier,
  [36074] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3108), 1,
      aux_sym_method_token6,
    ACTIONS(3110), 1,
      anon_sym_RPAREN,
    ACTIONS(3478), 1,
      anon_sym_COMMA,
  [36087] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3114), 1,
      aux_sym_method_token6,
    ACTIONS(3128), 1,
      anon_sym_RPAREN,
    ACTIONS(3480), 1,
      anon_sym_COMMA,
  [36100] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1724), 1,
      sym_argument,
  [36113] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1798), 1,
      sym_argument,
  [36126] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1663), 1,
      sym_identifier,
  [36139] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1891), 1,
      sym_argument,
  [36152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3232), 1,
      anon_sym_LF,
    STATE(90), 1,
      sym__line_terminator,
  [36165] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1800), 1,
      sym_argument,
  [36178] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1874), 1,
      sym_argument,
  [36191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3100), 1,
      anon_sym_LF,
    STATE(46), 1,
      sym__line_terminator,
  [36204] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3482), 1,
      anon_sym_COMMA,
    ACTIONS(3484), 1,
      aux_sym_method_token6,
    ACTIONS(3486), 1,
      anon_sym_RPAREN,
  [36217] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3488), 1,
      anon_sym_COMMA,
    ACTIONS(3490), 1,
      aux_sym_method_token6,
    ACTIONS(3492), 1,
      anon_sym_RPAREN,
  [36230] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1785), 1,
      sym_argument,
  [36243] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3494), 1,
      anon_sym_COMMA,
    ACTIONS(3496), 1,
      aux_sym_method_token6,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
  [36256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3240), 1,
      anon_sym_LF,
    STATE(60), 1,
      sym__line_terminator,
  [36269] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1630), 1,
      sym_identifier,
  [36282] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1768), 1,
      sym_argument,
  [36295] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1916), 1,
      sym_argument,
  [36308] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3500), 1,
      anon_sym_COMMA,
    ACTIONS(3502), 1,
      aux_sym_method_token6,
    ACTIONS(3504), 1,
      anon_sym_RPAREN,
  [36321] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(3506), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [36334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3508), 1,
      anon_sym_LF,
    STATE(74), 1,
      sym__line_terminator,
  [36347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3262), 1,
      anon_sym_LF,
    STATE(40), 1,
      sym__line_terminator,
  [36360] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2880), 1,
      aux_sym_method_token6,
    ACTIONS(2882), 1,
      anon_sym_RPAREN,
    ACTIONS(3510), 1,
      anon_sym_COMMA,
  [36373] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3096), 1,
      anon_sym_LF,
    STATE(42), 1,
      sym__line_terminator,
  [36386] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3512), 1,
      anon_sym_LF,
    STATE(50), 1,
      sym__line_terminator,
  [36399] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1810), 1,
      sym_argument,
  [36412] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1799), 1,
      sym_argument,
  [36425] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(645), 1,
      sym_identifier,
  [36438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3252), 1,
      anon_sym_LF,
    STATE(62), 1,
      sym__line_terminator,
  [36451] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [36464] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1559), 1,
      sym_identifier,
  [36477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3080), 1,
      anon_sym_LF,
    STATE(54), 1,
      sym__line_terminator,
  [36490] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1626), 1,
      sym_identifier,
  [36503] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1700), 1,
      sym_argument,
  [36516] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1086), 1,
      sym_identifier,
  [36529] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(551), 1,
      aux_sym_finally_token1,
    ACTIONS(869), 1,
      aux_sym_loop_token2,
    STATE(1944), 1,
      sym_finally,
  [36542] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3086), 1,
      aux_sym_method_token6,
    ACTIONS(3514), 1,
      anon_sym_COMMA,
    ACTIONS(3516), 1,
      anon_sym_RPAREN,
  [36555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3518), 1,
      anon_sym_LF,
    STATE(57), 1,
      sym__line_terminator,
  [36568] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1803), 1,
      sym_argument,
  [36581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3520), 1,
      anon_sym_LF,
    STATE(64), 1,
      sym__line_terminator,
  [36594] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(3522), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [36607] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2835), 1,
      aux_sym_method_token6,
    ACTIONS(2837), 1,
      anon_sym_RPAREN,
    ACTIONS(3524), 1,
      anon_sym_COMMA,
  [36620] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3318), 1,
      aux_sym_slot_accessor_token1,
    STATE(1447), 1,
      sym__identifier,
    STATE(1491), 1,
      sym_argument,
  [36633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 3,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
  [36642] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1622), 1,
      sym_identifier,
  [36655] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1080), 1,
      sym_identifier,
  [36668] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1809), 1,
      sym_argument,
  [36681] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3062), 1,
      aux_sym_method_token6,
    ACTIONS(3074), 1,
      anon_sym_RPAREN,
    ACTIONS(3526), 1,
      anon_sym_COMMA,
  [36694] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1686), 1,
      sym_argument,
  [36707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3270), 1,
      anon_sym_LF,
    STATE(65), 1,
      sym__line_terminator,
  [36720] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1722), 1,
      sym_argument,
  [36733] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1824), 1,
      sym_argument,
  [36746] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3000), 1,
      aux_sym_method_token6,
    ACTIONS(3276), 1,
      anon_sym_RPAREN,
    ACTIONS(3528), 1,
      anon_sym_COMMA,
  [36759] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3266), 1,
      anon_sym_LF,
    STATE(38), 1,
      sym__line_terminator,
  [36772] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1619), 1,
      sym_identifier,
  [36785] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1673), 1,
      sym_argument,
  [36798] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1767), 1,
      sym_argument,
  [36811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3040), 1,
      anon_sym_LF,
    STATE(82), 1,
      sym__line_terminator,
  [36824] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3530), 1,
      anon_sym_COMMA,
    ACTIONS(3532), 1,
      anon_sym_RPAREN,
    STATE(1474), 1,
      aux_sym_local_repeat1,
  [36837] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3534), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [36850] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1680), 1,
      sym_argument,
  [36863] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3282), 1,
      anon_sym_LF,
    STATE(70), 1,
      sym__line_terminator,
  [36876] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1618), 1,
      sym_identifier,
  [36889] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1650), 1,
      sym_identifier,
  [36902] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1819), 1,
      sym_argument,
  [36915] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1830), 1,
      sym_argument,
  [36928] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1668), 1,
      sym_identifier,
  [36941] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1898), 1,
      sym_argument,
  [36954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3536), 1,
      anon_sym_LF,
    STATE(36), 1,
      sym__line_terminator,
  [36967] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1831), 1,
      sym_argument,
  [36980] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3538), 1,
      anon_sym_COMMA,
    ACTIONS(3541), 1,
      anon_sym_RPAREN,
    STATE(1474), 1,
      aux_sym_local_repeat1,
  [36993] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2994), 1,
      aux_sym_method_token6,
    ACTIONS(3292), 1,
      anon_sym_RPAREN,
    ACTIONS(3543), 1,
      anon_sym_COMMA,
  [37006] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(551), 1,
      aux_sym_finally_token1,
    ACTIONS(3545), 1,
      aux_sym_loop_token2,
    STATE(1801), 1,
      sym_finally,
  [37019] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1616), 1,
      sym_identifier,
  [37032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3022), 1,
      anon_sym_LF,
    STATE(45), 1,
      sym__line_terminator,
  [37045] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1823), 1,
      sym_argument,
  [37058] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1674), 1,
      sym_argument,
  [37071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3547), 1,
      anon_sym_LF,
    STATE(78), 1,
      sym__line_terminator,
  [37084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3032), 1,
      anon_sym_LF,
    STATE(51), 1,
      sym__line_terminator,
  [37097] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3549), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [37110] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3030), 1,
      aux_sym_method_token6,
    ACTIONS(3551), 1,
      anon_sym_COMMA,
    ACTIONS(3553), 1,
      anon_sym_RPAREN,
  [37123] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3555), 1,
      anon_sym_LT_LT,
    ACTIONS(3541), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [37134] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3557), 1,
      anon_sym_COMMA,
    ACTIONS(3559), 1,
      aux_sym_method_token6,
    ACTIONS(3561), 1,
      anon_sym_RPAREN,
  [37147] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3563), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [37160] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(551), 1,
      aux_sym_finally_token1,
    ACTIONS(953), 1,
      aux_sym_loop_token2,
    STATE(1817), 1,
      sym_finally,
  [37173] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1826), 1,
      sym_argument,
  [37186] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3165), 1,
      aux_sym_slot_accessor_token1,
    STATE(532), 1,
      sym__identifier,
    STATE(1042), 1,
      sym_identifier,
  [37199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 3,
      anon_sym_CR,
      anon_sym_LF,
      anon_sym_COMMA,
  [37208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3286), 1,
      anon_sym_LF,
    STATE(21), 1,
      sym__line_terminator,
  [37221] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3565), 1,
      anon_sym_COMMA,
    ACTIONS(3567), 1,
      aux_sym_method_token6,
    ACTIONS(3569), 1,
      anon_sym_RPAREN,
  [37234] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(678), 1,
      sym_argument,
  [37247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3571), 1,
      anon_sym_LF,
    STATE(48), 1,
      sym__line_terminator,
  [37260] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2986), 1,
      aux_sym_method_token6,
    ACTIONS(3573), 1,
      anon_sym_COMMA,
    ACTIONS(3575), 1,
      anon_sym_RPAREN,
  [37273] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1681), 1,
      sym_argument,
  [37286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3577), 1,
      anon_sym_LF,
    STATE(75), 1,
      sym__line_terminator,
  [37299] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3579), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [37312] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3581), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [37325] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3583), 1,
      aux_sym_try_token3,
    STATE(1535), 1,
      aux_sym_try_repeat2,
  [37338] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(549), 1,
      aux_sym_loop_token2,
    ACTIONS(551), 1,
      aux_sym_finally_token1,
    STATE(1846), 1,
      sym_finally,
  [37351] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1855), 1,
      sym_argument,
  [37364] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_RPAREN,
    ACTIONS(3585), 1,
      anon_sym_COMMA,
    STATE(1474), 1,
      aux_sym_local_repeat1,
  [37377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3294), 1,
      anon_sym_LF,
    STATE(34), 1,
      sym__line_terminator,
  [37390] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1590), 1,
      sym_identifier,
  [37403] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3587), 1,
      aux_sym_try_token3,
    STATE(1539), 1,
      aux_sym_try_repeat2,
  [37416] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3589), 1,
      aux_sym_try_token3,
    STATE(1535), 1,
      aux_sym_try_repeat2,
  [37429] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3591), 1,
      aux_sym_method_token2,
    ACTIONS(3593), 1,
      aux_sym_method_token3,
    ACTIONS(3595), 1,
      aux_sym_method_token4,
  [37442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3300), 1,
      anon_sym_LF,
    STATE(80), 1,
      sym__line_terminator,
  [37455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3597), 1,
      anon_sym_LF,
    STATE(52), 1,
      sym__line_terminator,
  [37468] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3004), 1,
      aux_sym_method_token6,
    ACTIONS(3012), 1,
      anon_sym_RPAREN,
    ACTIONS(3599), 1,
      anon_sym_COMMA,
  [37481] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1719), 1,
      sym_argument,
  [37494] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3601), 1,
      anon_sym_COMMA,
    ACTIONS(3603), 1,
      aux_sym_method_token6,
    ACTIONS(3605), 1,
      anon_sym_RPAREN,
  [37507] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1842), 1,
      sym_argument,
  [37520] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3607), 1,
      anon_sym_COMMA,
    ACTIONS(3609), 1,
      aux_sym_method_token6,
    ACTIONS(3611), 1,
      anon_sym_RPAREN,
  [37533] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3613), 1,
      aux_sym_slot_accessor_token1,
    STATE(795), 1,
      sym__identifier,
    STATE(871), 1,
      sym_identifier,
  [37546] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2990), 1,
      aux_sym_method_token6,
    ACTIONS(3615), 1,
      anon_sym_COMMA,
    ACTIONS(3617), 1,
      anon_sym_RPAREN,
  [37559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3304), 1,
      anon_sym_LF,
    STATE(89), 1,
      sym__line_terminator,
  [37572] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1845), 1,
      sym_argument,
  [37585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3308), 1,
      anon_sym_LF,
    STATE(69), 1,
      sym__line_terminator,
  [37598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3619), 1,
      anon_sym_LF,
    STATE(25), 1,
      sym__line_terminator,
  [37611] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1695), 1,
      sym_argument,
  [37624] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2960), 1,
      aux_sym_method_token6,
    ACTIONS(2962), 1,
      anon_sym_RPAREN,
    ACTIONS(3621), 1,
      anon_sym_COMMA,
  [37637] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_COMMA,
    ACTIONS(3623), 1,
      anon_sym_RPAREN,
    STATE(753), 1,
      aux_sym_loopbody_repeat1,
  [37650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2972), 1,
      anon_sym_LF,
    STATE(27), 1,
      sym__line_terminator,
  [37663] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3625), 1,
      aux_sym_try_token3,
    STATE(1535), 1,
      aux_sym_try_repeat2,
  [37676] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1485), 1,
      sym_identifier,
  [37689] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3627), 1,
      aux_sym_try_token3,
    STATE(1501), 1,
      aux_sym_try_repeat2,
  [37702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3629), 1,
      anon_sym_LF,
    STATE(71), 1,
      sym__line_terminator,
  [37715] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_RPAREN,
    ACTIONS(3631), 1,
      anon_sym_COMMA,
    STATE(1474), 1,
      aux_sym_local_repeat1,
  [37728] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(3633), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [37741] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1763), 1,
      sym_argument,
  [37754] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
  [37767] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3635), 1,
      aux_sym_try_token2,
    ACTIONS(3638), 1,
      aux_sym_try_token3,
    STATE(1535), 1,
      aux_sym_try_repeat2,
  [37780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(2952), 1,
      anon_sym_LF,
    STATE(39), 1,
      sym__line_terminator,
  [37793] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3640), 1,
      aux_sym_try_token3,
    STATE(1535), 1,
      aux_sym_try_repeat2,
  [37806] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1859), 1,
      sym_argument,
  [37819] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(569), 1,
      aux_sym_try_token2,
    ACTIONS(3642), 1,
      aux_sym_try_token3,
    STATE(1535), 1,
      aux_sym_try_repeat2,
  [37832] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(680), 1,
      sym_identifier,
  [37845] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2605), 1,
      anon_sym_COMMA,
    ACTIONS(3644), 1,
      aux_sym_finally_token2,
    STATE(1379), 1,
      aux_sym_handling_repeat1,
  [37858] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(551), 1,
      aux_sym_finally_token1,
    ACTIONS(943), 1,
      aux_sym_loop_token2,
    STATE(1885), 1,
      sym_finally,
  [37871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3646), 1,
      anon_sym_LF,
    STATE(33), 1,
      sym__line_terminator,
  [37884] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(551), 1,
      aux_sym_finally_token1,
    ACTIONS(3648), 1,
      aux_sym_loop_token2,
    STATE(1793), 1,
      sym_finally,
  [37897] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3613), 1,
      aux_sym_slot_accessor_token1,
    STATE(732), 1,
      sym_identifier,
    STATE(795), 1,
      sym__identifier,
  [37910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2813), 1,
      anon_sym_CR,
    ACTIONS(3314), 1,
      anon_sym_LF,
    STATE(37), 1,
      sym__line_terminator,
  [37923] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3650), 3,
      aux_sym_if_token3,
      aux_sym_elif_token1,
      aux_sym_else_token1,
  [37932] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2928), 1,
      aux_sym_slot_accessor_token1,
    STATE(662), 1,
      sym__identifier,
    STATE(1627), 1,
      sym_identifier,
  [37945] = 4,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2803), 1,
      aux_sym_slot_accessor_token1,
    STATE(677), 1,
      sym__identifier,
    STATE(1863), 1,
      sym_argument,
  [37958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3652), 2,
      anon_sym_CR,
      anon_sym_LF,
  [37966] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3654), 2,
      aux_sym_try_token2,
      aux_sym_try_token3,
  [37974] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2978), 1,
      aux_sym_method_token5,
    ACTIONS(2980), 1,
      aux_sym_method_token6,
  [37984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3656), 2,
      anon_sym_CR,
      anon_sym_LF,
  [37992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3658), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3660), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3662), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38016] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2998), 1,
      aux_sym_method_token5,
    ACTIONS(3000), 1,
      aux_sym_method_token6,
  [38026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3664), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38034] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2671), 1,
      anon_sym_RPAREN,
    ACTIONS(3666), 1,
      anon_sym_LT_LT,
  [38044] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2878), 1,
      aux_sym_method_token5,
    ACTIONS(2880), 1,
      aux_sym_method_token6,
  [38054] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2797), 1,
      aux_sym_method_token5,
    ACTIONS(2799), 1,
      aux_sym_method_token6,
  [38064] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3593), 1,
      aux_sym_method_token3,
    ACTIONS(3595), 1,
      aux_sym_method_token4,
  [38074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3668), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38082] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3595), 1,
      aux_sym_method_token4,
    ACTIONS(3670), 1,
      aux_sym_procedure_token1,
  [38092] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3595), 1,
      aux_sym_method_token4,
    ACTIONS(3672), 1,
      aux_sym_procedure_token1,
  [38102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3674), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38110] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3676), 1,
      anon_sym_LPAREN,
    ACTIONS(3678), 1,
      sym_label,
  [38120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3680), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38128] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3682), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38136] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3684), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3686), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3688), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3690), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3692), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3694), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38184] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3696), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38192] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3698), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3700), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3702), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3704), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3706), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3708), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38240] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3710), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38248] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3712), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3714), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3716), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38272] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3718), 1,
      aux_sym_method_token3,
    ACTIONS(3720), 1,
      aux_sym_method_token4,
  [38282] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3722), 1,
      anon_sym_LPAREN,
    ACTIONS(3724), 1,
      sym_label,
  [38292] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3726), 1,
      anon_sym_LPAREN,
    ACTIONS(3728), 1,
      sym_label,
  [38302] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3730), 1,
      anon_sym_DOT,
    ACTIONS(3732), 1,
      anon_sym_LBRACK,
  [38312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3734), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38320] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3736), 1,
      anon_sym_LPAREN,
    ACTIONS(3738), 1,
      sym_label,
  [38330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3740), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38338] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3742), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38346] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3744), 1,
      aux_sym_import_token1,
    ACTIONS(3746), 1,
      sym_dynamic_variable,
  [38356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3748), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3750), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3752), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38380] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3754), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38388] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3756), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3758), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3760), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3762), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38420] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3764), 1,
      aux_sym_slot_accessor_token1,
    STATE(56), 1,
      sym__identifier,
  [38430] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3766), 1,
      anon_sym_DOT,
    ACTIONS(3768), 1,
      anon_sym_LBRACK,
  [38440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3770), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38448] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2841), 1,
      aux_sym_method_token5,
    ACTIONS(2843), 1,
      aux_sym_method_token6,
  [38458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3772), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3774), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3776), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3778), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3780), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3782), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38506] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3784), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38514] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3786), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38522] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2687), 1,
      anon_sym_RPAREN,
    ACTIONS(3788), 1,
      anon_sym_LT_LT,
  [38532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3790), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38540] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2691), 1,
      anon_sym_RPAREN,
    ACTIONS(3792), 1,
      anon_sym_LT_LT,
  [38550] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3794), 1,
      anon_sym_RPAREN,
    ACTIONS(3796), 1,
      anon_sym_LT_LT,
  [38560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3798), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3800), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38576] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2701), 1,
      anon_sym_RPAREN,
    ACTIONS(3802), 1,
      anon_sym_LT_LT,
  [38586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3804), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3806), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3808), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38610] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3810), 1,
      anon_sym_DOT,
    ACTIONS(3812), 1,
      anon_sym_LBRACK,
  [38620] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3814), 1,
      anon_sym_RPAREN,
    ACTIONS(3816), 1,
      anon_sym_LT_LT,
  [38630] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3016), 1,
      aux_sym_method_token5,
    ACTIONS(3018), 1,
      aux_sym_method_token6,
  [38640] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3818), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38648] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3532), 1,
      anon_sym_RPAREN,
    ACTIONS(3820), 1,
      anon_sym_LT_LT,
  [38658] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3046), 1,
      aux_sym_method_token5,
    ACTIONS(3048), 1,
      aux_sym_method_token6,
  [38668] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3822), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3824), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3826), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38692] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2833), 1,
      aux_sym_method_token5,
    ACTIONS(2835), 1,
      aux_sym_method_token6,
  [38702] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3828), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38710] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3830), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3832), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3834), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3836), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3838), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3840), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38758] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3842), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3844), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38774] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3744), 1,
      aux_sym_import_token1,
    ACTIONS(3846), 1,
      sym_dynamic_variable,
  [38784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3848), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3850), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38800] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3852), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38808] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3854), 2,
      aux_sym_try_token2,
      aux_sym_try_token3,
  [38816] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3856), 1,
      anon_sym_DOT,
    ACTIONS(3858), 1,
      anon_sym_LBRACK,
  [38826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3860), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3862), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38842] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3864), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38850] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3187), 1,
      aux_sym_method_token5,
    ACTIONS(3189), 1,
      aux_sym_method_token6,
  [38860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3866), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3868), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38876] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3870), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38884] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3439), 1,
      anon_sym_RPAREN,
    ACTIONS(3872), 1,
      anon_sym_LT_LT,
  [38894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3874), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3876), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3878), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38918] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3880), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38926] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_RPAREN,
    ACTIONS(3882), 1,
      anon_sym_LT_LT,
  [38936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3884), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3886), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3888), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38960] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3890), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38968] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2681), 1,
      anon_sym_RPAREN,
    ACTIONS(3892), 1,
      anon_sym_LT_LT,
  [38978] = 3,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3090), 1,
      aux_sym_method_token5,
    ACTIONS(3092), 1,
      aux_sym_method_token6,
  [38988] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3894), 2,
      anon_sym_CR,
      anon_sym_LF,
  [38996] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3896), 2,
      anon_sym_CR,
      anon_sym_LF,
  [39004] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3898), 1,
      aux_sym_procedure_token2,
  [39011] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3611), 1,
      anon_sym_RPAREN,
  [39018] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3486), 1,
      anon_sym_RPAREN,
  [39025] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(901), 1,
      aux_sym_procedure_token2,
  [39032] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(607), 1,
      aux_sym_method_token7,
  [39039] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1189), 1,
      aux_sym_method_token7,
  [39046] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3108), 1,
      aux_sym_method_token6,
  [39053] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3110), 1,
      anon_sym_RPAREN,
  [39060] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3128), 1,
      anon_sym_RPAREN,
  [39067] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3504), 1,
      anon_sym_RPAREN,
  [39074] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(823), 1,
      aux_sym_method_token7,
  [39081] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3900), 1,
      anon_sym_RBRACK,
  [39088] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3502), 1,
      aux_sym_method_token6,
  [39095] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(807), 1,
      aux_sym_method_token7,
  [39102] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3470), 1,
      anon_sym_RPAREN,
  [39109] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3902), 1,
      anon_sym_RPAREN,
  [39116] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3904), 1,
      aux_sym_protect_token3,
  [39123] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3146), 1,
      aux_sym_method_token6,
  [39130] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(921), 1,
      aux_sym_procedure_token2,
  [39137] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2924), 1,
      aux_sym_if_token3,
  [39144] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(639), 1,
      aux_sym_method_token7,
  [39151] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3906), 1,
      aux_sym_loop_token2,
  [39158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3908), 1,
      anon_sym_LF,
  [39165] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3553), 1,
      anon_sym_RPAREN,
  [39172] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(635), 1,
      aux_sym_method_token7,
  [39179] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(615), 1,
      aux_sym_loop_token2,
  [39186] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3910), 1,
      aux_sym_loop_token2,
  [39193] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(809), 1,
      aux_sym_method_token7,
  [39200] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3435), 1,
      anon_sym_RPAREN,
  [39207] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2932), 1,
      aux_sym_if_token3,
  [39214] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3912), 1,
      aux_sym_if_token3,
  [39221] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3914), 1,
      anon_sym_LT_LT,
  [39228] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3916), 1,
      anon_sym_RPAREN,
  [39235] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3094), 1,
      anon_sym_RBRACK,
  [39242] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(627), 1,
      aux_sym_method_token7,
  [39249] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1217), 1,
      aux_sym_method_token7,
  [39256] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3189), 1,
      aux_sym_method_token6,
  [39263] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(825), 1,
      aux_sym_method_token7,
  [39270] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1229), 1,
      aux_sym_method_token7,
  [39277] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(905), 1,
      aux_sym_procedure_token2,
  [39284] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3918), 1,
      anon_sym_RPAREN,
  [39291] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3920), 1,
      aux_sym_method_token6,
  [39298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3922), 1,
      anon_sym_LF,
  [39305] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(647), 1,
      aux_sym_method_token7,
  [39312] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(609), 1,
      aux_sym_method_token7,
  [39319] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3086), 1,
      aux_sym_method_token6,
  [39326] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3411), 1,
      aux_sym_method_token6,
  [39333] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3516), 1,
      anon_sym_RPAREN,
  [39340] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(873), 1,
      aux_sym_procedure_token2,
  [39347] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3924), 1,
      aux_sym_method_token7,
  [39354] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3191), 1,
      anon_sym_RPAREN,
  [39361] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(909), 1,
      aux_sym_procedure_token2,
  [39368] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3403), 1,
      anon_sym_RPAREN,
  [39375] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3205), 1,
      aux_sym_method_token6,
  [39382] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3926), 1,
      anon_sym_RBRACK,
  [39389] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3928), 1,
      anon_sym_LT_LT,
  [39396] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(817), 1,
      aux_sym_method_token7,
  [39403] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3930), 1,
      aux_sym_if_token3,
  [39410] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(577), 1,
      aux_sym_method_token7,
  [39417] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3932), 1,
      aux_sym_loop_token2,
  [39424] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3419), 1,
      aux_sym_method_token6,
  [39431] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3934), 1,
      anon_sym_LT_LT,
  [39438] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3936), 1,
      aux_sym_lock_token2,
  [39445] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3938), 1,
      aux_sym_protect_token4,
  [39452] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3421), 1,
      anon_sym_RPAREN,
  [39459] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(869), 1,
      aux_sym_loop_token2,
  [39466] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1205), 1,
      aux_sym_procedure_token2,
  [39473] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(629), 1,
      aux_sym_method_token7,
  [39480] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(561), 1,
      aux_sym_method_token7,
  [39487] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1187), 1,
      aux_sym_loop_token2,
  [39494] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1167), 1,
      aux_sym_method_token7,
  [39501] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3458), 1,
      anon_sym_RPAREN,
  [39508] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(949), 1,
      aux_sym_loop_token2,
  [39515] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1199), 1,
      aux_sym_procedure_token2,
  [39522] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(565), 1,
      aux_sym_method_token7,
  [39529] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3940), 1,
      aux_sym_catch_token2,
  [39536] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(547), 1,
      aux_sym_method_token7,
  [39543] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3942), 1,
      anon_sym_LT_LT,
  [39550] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3944), 1,
      sym_dynamic_variable,
  [39557] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3456), 1,
      aux_sym_method_token6,
  [39564] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3946), 1,
      anon_sym_RPAREN,
  [39571] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(867), 1,
      aux_sym_procedure_token2,
  [39578] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3948), 1,
      anon_sym_LT_LT,
  [39585] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3950), 1,
      aux_sym_protect_token3,
  [39592] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3952), 1,
      aux_sym_method_token7,
  [39599] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(879), 1,
      aux_sym_procedure_token2,
  [39606] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3954), 1,
      anon_sym_RPAREN,
  [39613] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3956), 1,
      anon_sym_RPAREN,
  [39620] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(657), 1,
      aux_sym_method_token7,
  [39627] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(563), 1,
      aux_sym_method_token7,
  [39634] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3958), 1,
      aux_sym_method_token6,
  [39641] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3074), 1,
      anon_sym_RPAREN,
  [39648] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3496), 1,
      aux_sym_method_token6,
  [39655] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(913), 1,
      aux_sym_procedure_token2,
  [39662] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3498), 1,
      anon_sym_RPAREN,
  [39669] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2837), 1,
      anon_sym_RPAREN,
  [39676] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3413), 1,
      anon_sym_RPAREN,
  [39683] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(575), 1,
      aux_sym_method_token7,
  [39690] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3960), 1,
      anon_sym_RBRACK,
  [39697] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1191), 1,
      aux_sym_protect_token4,
  [39704] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2882), 1,
      anon_sym_RPAREN,
  [39711] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1195), 1,
      aux_sym_method_token7,
  [39718] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3492), 1,
      anon_sym_RPAREN,
  [39725] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(863), 1,
      aux_sym_procedure_token2,
  [39732] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(597), 1,
      aux_sym_method_token7,
  [39739] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3962), 1,
      anon_sym_RPAREN,
  [39746] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3490), 1,
      aux_sym_method_token6,
  [39753] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(573), 1,
      aux_sym_method_token7,
  [39760] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3964), 1,
      aux_sym_method_token7,
  [39767] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3966), 1,
      anon_sym_RPAREN,
  [39774] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3968), 1,
      anon_sym_RBRACK,
  [39781] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1179), 1,
      aux_sym_method_token7,
  [39788] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(605), 1,
      aux_sym_method_token7,
  [39795] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3276), 1,
      anon_sym_RPAREN,
  [39802] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3970), 1,
      aux_sym_method_token6,
  [39809] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(885), 1,
      aux_sym_procedure_token2,
  [39816] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(947), 1,
      aux_sym_procedure_token2,
  [39823] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3050), 1,
      anon_sym_RBRACK,
  [39830] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(893), 1,
      aux_sym_procedure_token2,
  [39837] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3972), 1,
      anon_sym_RPAREN,
  [39844] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3974), 1,
      anon_sym_RPAREN,
  [39851] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3976), 1,
      aux_sym_loop_token2,
  [39858] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(937), 1,
      aux_sym_procedure_token2,
  [39865] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(611), 1,
      aux_sym_method_token7,
  [39872] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3978), 1,
      anon_sym_RBRACK,
  [39879] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3980), 1,
      aux_sym_protect_token3,
  [39886] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3982), 1,
      anon_sym_RPAREN,
  [39893] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3292), 1,
      anon_sym_RPAREN,
  [39900] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3569), 1,
      anon_sym_RPAREN,
  [39907] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3984), 1,
      aux_sym_loop_token2,
  [39914] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3986), 1,
      anon_sym_RPAREN,
  [39921] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3575), 1,
      anon_sym_RPAREN,
  [39928] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(641), 1,
      aux_sym_method_token7,
  [39935] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3567), 1,
      aux_sym_method_token6,
  [39942] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(581), 1,
      aux_sym_method_token7,
  [39949] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(585), 1,
      aux_sym_method_token7,
  [39956] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3988), 1,
      aux_sym_method_token7,
  [39963] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3605), 1,
      anon_sym_RPAREN,
  [39970] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3990), 1,
      anon_sym_RPAREN,
  [39977] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(929), 1,
      aux_sym_procedure_token2,
  [39984] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3992), 1,
      aux_sym_protect_token4,
  [39991] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3484), 1,
      aux_sym_method_token6,
  [39998] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(645), 1,
      aux_sym_method_token7,
  [40005] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3994), 1,
      aux_sym_method_token6,
  [40012] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3996), 1,
      aux_sym_method_token4,
  [40019] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3545), 1,
      aux_sym_loop_token2,
  [40026] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3433), 1,
      aux_sym_method_token6,
  [40033] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3998), 1,
      anon_sym_RPAREN,
  [40040] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3030), 1,
      aux_sym_method_token6,
  [40047] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(859), 1,
      aux_sym_procedure_token2,
  [40054] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(651), 1,
      aux_sym_method_token7,
  [40061] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4000), 1,
      anon_sym_RPAREN,
  [40068] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4002), 1,
      anon_sym_RPAREN,
  [40075] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4004), 1,
      aux_sym_protect_token4,
  [40082] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4006), 1,
      anon_sym_RPAREN,
  [40089] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1201), 1,
      aux_sym_protect_token4,
  [40096] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3020), 1,
      anon_sym_RBRACK,
  [40103] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(661), 1,
      aux_sym_method_token7,
  [40110] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4008), 1,
      anon_sym_RPAREN,
  [40117] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4010), 1,
      anon_sym_RPAREN,
  [40124] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1169), 1,
      aux_sym_protect_token4,
  [40131] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(543), 1,
      aux_sym_method_token7,
  [40138] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4012), 1,
      aux_sym_method_token6,
  [40145] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4014), 1,
      aux_sym_loop_token2,
  [40152] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4016), 1,
      aux_sym_block_token2,
  [40159] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4018), 1,
      sym_number,
  [40166] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4020), 1,
      sym_dynamic_variable,
  [40173] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4022), 1,
      anon_sym_LT_LT,
  [40180] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3559), 1,
      aux_sym_method_token6,
  [40187] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(819), 1,
      aux_sym_method_token7,
  [40194] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4024), 1,
      anon_sym_RPAREN,
  [40201] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(933), 1,
      aux_sym_procedure_token2,
  [40208] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(841), 1,
      aux_sym_method_token7,
  [40215] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4026), 1,
      anon_sym_RPAREN,
  [40222] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(953), 1,
      aux_sym_loop_token2,
  [40229] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1193), 1,
      aux_sym_procedure_token2,
  [40236] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4028), 1,
      aux_sym_if_token3,
  [40243] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4030), 1,
      anon_sym_LPAREN,
  [40250] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1165), 1,
      aux_sym_method_token7,
  [40257] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(659), 1,
      aux_sym_method_token7,
  [40264] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4032), 1,
      anon_sym_LT_LT,
  [40271] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4034), 1,
      aux_sym_class_token2,
  [40278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4036), 1,
      anon_sym_LF,
  [40285] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3561), 1,
      anon_sym_RPAREN,
  [40292] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(593), 1,
      aux_sym_method_token7,
  [40299] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4038), 1,
      anon_sym_RBRACE,
  [40306] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4040), 1,
      anon_sym_LT_LT,
  [40313] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4042), 1,
      anon_sym_RPAREN,
  [40320] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(941), 1,
      aux_sym_procedure_token2,
  [40327] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(589), 1,
      aux_sym_method_token7,
  [40334] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4044), 1,
      aux_sym_protect_token3,
  [40341] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4046), 1,
      anon_sym_RPAREN,
  [40348] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4048), 1,
      anon_sym_RPAREN,
  [40355] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(583), 1,
      aux_sym_method_token7,
  [40362] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1171), 1,
      aux_sym_procedure_token2,
  [40369] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4050), 1,
      anon_sym_RPAREN,
  [40376] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4052), 1,
      aux_sym_iterator_token2,
  [40383] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(591), 1,
      aux_sym_method_token7,
  [40390] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1215), 1,
      aux_sym_loop_token2,
  [40397] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1219), 1,
      aux_sym_block_token2,
  [40404] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(845), 1,
      aux_sym_method_token7,
  [40411] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(595), 1,
      aux_sym_method_token7,
  [40418] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4054), 1,
      anon_sym_RPAREN,
  [40425] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(613), 1,
      aux_sym_method_token7,
  [40432] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2990), 1,
      aux_sym_method_token6,
  [40439] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(843), 1,
      aux_sym_method_token7,
  [40446] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1225), 1,
      aux_sym_block_token2,
  [40453] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(621), 1,
      aux_sym_method_token7,
  [40460] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3726), 1,
      anon_sym_LPAREN,
  [40467] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4056), 1,
      anon_sym_RPAREN,
  [40474] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3670), 1,
      aux_sym_procedure_token1,
  [40481] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4058), 1,
      aux_sym_loop_token2,
  [40488] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4060), 1,
      anon_sym_LPAREN,
  [40495] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(549), 1,
      aux_sym_loop_token2,
  [40502] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1227), 1,
      aux_sym_loop_token2,
  [40509] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3672), 1,
      aux_sym_procedure_token1,
  [40516] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(851), 1,
      aux_sym_method_token7,
  [40523] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3722), 1,
      anon_sym_LPAREN,
  [40530] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3720), 1,
      aux_sym_method_token4,
  [40537] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3617), 1,
      anon_sym_RPAREN,
  [40544] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4062), 1,
      aux_sym_procedure_token2,
  [40551] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4064), 1,
      ts_builtin_sym_end,
  [40558] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4066), 1,
      anon_sym_LPAREN,
  [40565] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2939), 1,
      aux_sym_if_token3,
  [40572] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(839), 1,
      aux_sym_method_token7,
  [40579] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4068), 1,
      anon_sym_LT_LT,
  [40586] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3012), 1,
      anon_sym_RPAREN,
  [40593] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4070), 1,
      anon_sym_RBRACE,
  [40600] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4072), 1,
      aux_sym_method_token7,
  [40607] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4074), 1,
      aux_sym_class_token2,
  [40614] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(889), 1,
      aux_sym_procedure_token2,
  [40621] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(637), 1,
      aux_sym_method_token7,
  [40628] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4076), 1,
      aux_sym_method_token7,
  [40635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4078), 1,
      anon_sym_LF,
  [40642] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(821), 1,
      aux_sym_method_token7,
  [40649] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1209), 1,
      aux_sym_method_token7,
  [40656] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(897), 1,
      aux_sym_procedure_token2,
  [40663] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4080), 1,
      aux_sym_lock_token2,
  [40670] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4082), 1,
      aux_sym_method_token7,
  [40677] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4084), 1,
      aux_sym_protect_token4,
  [40684] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1211), 1,
      aux_sym_method_token7,
  [40691] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1233), 1,
      aux_sym_method_token7,
  [40698] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2982), 1,
      anon_sym_RBRACK,
  [40705] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(815), 1,
      aux_sym_method_token7,
  [40712] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2962), 1,
      anon_sym_RPAREN,
  [40719] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4086), 1,
      aux_sym_method_token7,
  [40726] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4088), 1,
      anon_sym_LT_LT,
  [40733] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(811), 1,
      aux_sym_method_token7,
  [40740] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1221), 1,
      aux_sym_method_token7,
  [40747] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4090), 1,
      aux_sym_block_token2,
  [40754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(4092), 1,
      aux_sym_pragma_token2,
  [40761] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(663), 1,
      aux_sym_method_token7,
  [40768] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4094), 1,
      anon_sym_LPAREN,
  [40775] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4096), 1,
      aux_sym_slot_accessor_token1,
  [40782] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1173), 1,
      aux_sym_loop_token2,
  [40789] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4098), 1,
      sym_number,
  [40796] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(943), 1,
      aux_sym_loop_token2,
  [40803] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4100), 1,
      aux_sym_slot_accessor_token1,
  [40810] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(625), 1,
      aux_sym_method_token7,
  [40817] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4102), 1,
      aux_sym_catch_token2,
  [40824] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2934), 1,
      aux_sym_if_token3,
  [40831] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(599), 1,
      aux_sym_method_token7,
  [40838] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4104), 1,
      aux_sym_iterator_token2,
  [40845] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(649), 1,
      aux_sym_method_token7,
  [40852] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(619), 1,
      aux_sym_method_token7,
  [40859] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4106), 1,
      anon_sym_LT_LT,
  [40866] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(925), 1,
      aux_sym_procedure_token2,
  [40873] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1237), 1,
      aux_sym_method_token7,
  [40880] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4108), 1,
      anon_sym_RBRACK,
  [40887] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3000), 1,
      aux_sym_method_token6,
  [40894] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4110), 1,
      anon_sym_RPAREN,
  [40901] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2994), 1,
      aux_sym_method_token6,
  [40908] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3648), 1,
      aux_sym_loop_token2,
  [40915] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(665), 1,
      aux_sym_method_token7,
  [40922] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(2986), 1,
      aux_sym_method_token6,
  [40929] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(623), 1,
      aux_sym_method_token7,
  [40936] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(1181), 1,
      aux_sym_protect_token4,
  [40943] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3603), 1,
      aux_sym_method_token6,
  [40950] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4112), 1,
      aux_sym_loop_token2,
  [40957] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(3609), 1,
      aux_sym_method_token6,
  [40964] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(4114), 1,
      aux_sym_method_token6,
  [40971] = 2,
    ACTIONS(103), 1,
      sym_comment,
    ACTIONS(587), 1,
      aux_sym_method_token7,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(598)] = 0,
  [SMALL_STATE(599)] = 87,
  [SMALL_STATE(600)] = 170,
  [SMALL_STATE(601)] = 259,
  [SMALL_STATE(602)] = 342,
  [SMALL_STATE(603)] = 415,
  [SMALL_STATE(604)] = 498,
  [SMALL_STATE(605)] = 581,
  [SMALL_STATE(606)] = 664,
  [SMALL_STATE(607)] = 735,
  [SMALL_STATE(608)] = 820,
  [SMALL_STATE(609)] = 891,
  [SMALL_STATE(610)] = 976,
  [SMALL_STATE(611)] = 1061,
  [SMALL_STATE(612)] = 1146,
  [SMALL_STATE(613)] = 1231,
  [SMALL_STATE(614)] = 1318,
  [SMALL_STATE(615)] = 1391,
  [SMALL_STATE(616)] = 1464,
  [SMALL_STATE(617)] = 1537,
  [SMALL_STATE(618)] = 1610,
  [SMALL_STATE(619)] = 1683,
  [SMALL_STATE(620)] = 1766,
  [SMALL_STATE(621)] = 1839,
  [SMALL_STATE(622)] = 1926,
  [SMALL_STATE(623)] = 2007,
  [SMALL_STATE(624)] = 2086,
  [SMALL_STATE(625)] = 2165,
  [SMALL_STATE(626)] = 2238,
  [SMALL_STATE(627)] = 2321,
  [SMALL_STATE(628)] = 2392,
  [SMALL_STATE(629)] = 2463,
  [SMALL_STATE(630)] = 2546,
  [SMALL_STATE(631)] = 2617,
  [SMALL_STATE(632)] = 2688,
  [SMALL_STATE(633)] = 2761,
  [SMALL_STATE(634)] = 2848,
  [SMALL_STATE(635)] = 2935,
  [SMALL_STATE(636)] = 3015,
  [SMALL_STATE(637)] = 3085,
  [SMALL_STATE(638)] = 3167,
  [SMALL_STATE(639)] = 3249,
  [SMALL_STATE(640)] = 3331,
  [SMALL_STATE(641)] = 3409,
  [SMALL_STATE(642)] = 3491,
  [SMALL_STATE(643)] = 3569,
  [SMALL_STATE(644)] = 3651,
  [SMALL_STATE(645)] = 3733,
  [SMALL_STATE(646)] = 3805,
  [SMALL_STATE(647)] = 3885,
  [SMALL_STATE(648)] = 3967,
  [SMALL_STATE(649)] = 4037,
  [SMALL_STATE(650)] = 4119,
  [SMALL_STATE(651)] = 4200,
  [SMALL_STATE(652)] = 4281,
  [SMALL_STATE(653)] = 4362,
  [SMALL_STATE(654)] = 4443,
  [SMALL_STATE(655)] = 4524,
  [SMALL_STATE(656)] = 4605,
  [SMALL_STATE(657)] = 4686,
  [SMALL_STATE(658)] = 4767,
  [SMALL_STATE(659)] = 4848,
  [SMALL_STATE(660)] = 4929,
  [SMALL_STATE(661)] = 5010,
  [SMALL_STATE(662)] = 5091,
  [SMALL_STATE(663)] = 5160,
  [SMALL_STATE(664)] = 5241,
  [SMALL_STATE(665)] = 5322,
  [SMALL_STATE(666)] = 5401,
  [SMALL_STATE(667)] = 5482,
  [SMALL_STATE(668)] = 5563,
  [SMALL_STATE(669)] = 5644,
  [SMALL_STATE(670)] = 5721,
  [SMALL_STATE(671)] = 5802,
  [SMALL_STATE(672)] = 5883,
  [SMALL_STATE(673)] = 5960,
  [SMALL_STATE(674)] = 6041,
  [SMALL_STATE(675)] = 6122,
  [SMALL_STATE(676)] = 6203,
  [SMALL_STATE(677)] = 6284,
  [SMALL_STATE(678)] = 6351,
  [SMALL_STATE(679)] = 6418,
  [SMALL_STATE(680)] = 6488,
  [SMALL_STATE(681)] = 6554,
  [SMALL_STATE(682)] = 6619,
  [SMALL_STATE(683)] = 6688,
  [SMALL_STATE(684)] = 6757,
  [SMALL_STATE(685)] = 6826,
  [SMALL_STATE(686)] = 6891,
  [SMALL_STATE(687)] = 6960,
  [SMALL_STATE(688)] = 7029,
  [SMALL_STATE(689)] = 7094,
  [SMALL_STATE(690)] = 7163,
  [SMALL_STATE(691)] = 7234,
  [SMALL_STATE(692)] = 7303,
  [SMALL_STATE(693)] = 7372,
  [SMALL_STATE(694)] = 7443,
  [SMALL_STATE(695)] = 7507,
  [SMALL_STATE(696)] = 7570,
  [SMALL_STATE(697)] = 7632,
  [SMALL_STATE(698)] = 7713,
  [SMALL_STATE(699)] = 7792,
  [SMALL_STATE(700)] = 7871,
  [SMALL_STATE(701)] = 7936,
  [SMALL_STATE(702)] = 8015,
  [SMALL_STATE(703)] = 8080,
  [SMALL_STATE(704)] = 8145,
  [SMALL_STATE(705)] = 8208,
  [SMALL_STATE(706)] = 8287,
  [SMALL_STATE(707)] = 8350,
  [SMALL_STATE(708)] = 8415,
  [SMALL_STATE(709)] = 8478,
  [SMALL_STATE(710)] = 8541,
  [SMALL_STATE(711)] = 8604,
  [SMALL_STATE(712)] = 8667,
  [SMALL_STATE(713)] = 8745,
  [SMALL_STATE(714)] = 8805,
  [SMALL_STATE(715)] = 8865,
  [SMALL_STATE(716)] = 8927,
  [SMALL_STATE(717)] = 9005,
  [SMALL_STATE(718)] = 9067,
  [SMALL_STATE(719)] = 9127,
  [SMALL_STATE(720)] = 9187,
  [SMALL_STATE(721)] = 9247,
  [SMALL_STATE(722)] = 9307,
  [SMALL_STATE(723)] = 9367,
  [SMALL_STATE(724)] = 9445,
  [SMALL_STATE(725)] = 9505,
  [SMALL_STATE(726)] = 9565,
  [SMALL_STATE(727)] = 9641,
  [SMALL_STATE(728)] = 9701,
  [SMALL_STATE(729)] = 9777,
  [SMALL_STATE(730)] = 9853,
  [SMALL_STATE(731)] = 9913,
  [SMALL_STATE(732)] = 9989,
  [SMALL_STATE(733)] = 10053,
  [SMALL_STATE(734)] = 10113,
  [SMALL_STATE(735)] = 10175,
  [SMALL_STATE(736)] = 10237,
  [SMALL_STATE(737)] = 10297,
  [SMALL_STATE(738)] = 10357,
  [SMALL_STATE(739)] = 10417,
  [SMALL_STATE(740)] = 10491,
  [SMALL_STATE(741)] = 10551,
  [SMALL_STATE(742)] = 10611,
  [SMALL_STATE(743)] = 10691,
  [SMALL_STATE(744)] = 10753,
  [SMALL_STATE(745)] = 10815,
  [SMALL_STATE(746)] = 10893,
  [SMALL_STATE(747)] = 10953,
  [SMALL_STATE(748)] = 11013,
  [SMALL_STATE(749)] = 11073,
  [SMALL_STATE(750)] = 11133,
  [SMALL_STATE(751)] = 11193,
  [SMALL_STATE(752)] = 11253,
  [SMALL_STATE(753)] = 11313,
  [SMALL_STATE(754)] = 11377,
  [SMALL_STATE(755)] = 11437,
  [SMALL_STATE(756)] = 11497,
  [SMALL_STATE(757)] = 11557,
  [SMALL_STATE(758)] = 11633,
  [SMALL_STATE(759)] = 11693,
  [SMALL_STATE(760)] = 11753,
  [SMALL_STATE(761)] = 11813,
  [SMALL_STATE(762)] = 11873,
  [SMALL_STATE(763)] = 11933,
  [SMALL_STATE(764)] = 11993,
  [SMALL_STATE(765)] = 12053,
  [SMALL_STATE(766)] = 12115,
  [SMALL_STATE(767)] = 12175,
  [SMALL_STATE(768)] = 12237,
  [SMALL_STATE(769)] = 12313,
  [SMALL_STATE(770)] = 12373,
  [SMALL_STATE(771)] = 12433,
  [SMALL_STATE(772)] = 12505,
  [SMALL_STATE(773)] = 12565,
  [SMALL_STATE(774)] = 12637,
  [SMALL_STATE(775)] = 12711,
  [SMALL_STATE(776)] = 12785,
  [SMALL_STATE(777)] = 12845,
  [SMALL_STATE(778)] = 12905,
  [SMALL_STATE(779)] = 12965,
  [SMALL_STATE(780)] = 13041,
  [SMALL_STATE(781)] = 13115,
  [SMALL_STATE(782)] = 13191,
  [SMALL_STATE(783)] = 13265,
  [SMALL_STATE(784)] = 13325,
  [SMALL_STATE(785)] = 13385,
  [SMALL_STATE(786)] = 13461,
  [SMALL_STATE(787)] = 13521,
  [SMALL_STATE(788)] = 13581,
  [SMALL_STATE(789)] = 13641,
  [SMALL_STATE(790)] = 13717,
  [SMALL_STATE(791)] = 13777,
  [SMALL_STATE(792)] = 13837,
  [SMALL_STATE(793)] = 13897,
  [SMALL_STATE(794)] = 13973,
  [SMALL_STATE(795)] = 14033,
  [SMALL_STATE(796)] = 14093,
  [SMALL_STATE(797)] = 14153,
  [SMALL_STATE(798)] = 14213,
  [SMALL_STATE(799)] = 14273,
  [SMALL_STATE(800)] = 14333,
  [SMALL_STATE(801)] = 14393,
  [SMALL_STATE(802)] = 14471,
  [SMALL_STATE(803)] = 14531,
  [SMALL_STATE(804)] = 14591,
  [SMALL_STATE(805)] = 14667,
  [SMALL_STATE(806)] = 14743,
  [SMALL_STATE(807)] = 14803,
  [SMALL_STATE(808)] = 14863,
  [SMALL_STATE(809)] = 14923,
  [SMALL_STATE(810)] = 14983,
  [SMALL_STATE(811)] = 15043,
  [SMALL_STATE(812)] = 15103,
  [SMALL_STATE(813)] = 15163,
  [SMALL_STATE(814)] = 15223,
  [SMALL_STATE(815)] = 15283,
  [SMALL_STATE(816)] = 15343,
  [SMALL_STATE(817)] = 15403,
  [SMALL_STATE(818)] = 15463,
  [SMALL_STATE(819)] = 15523,
  [SMALL_STATE(820)] = 15583,
  [SMALL_STATE(821)] = 15647,
  [SMALL_STATE(822)] = 15707,
  [SMALL_STATE(823)] = 15767,
  [SMALL_STATE(824)] = 15827,
  [SMALL_STATE(825)] = 15887,
  [SMALL_STATE(826)] = 15967,
  [SMALL_STATE(827)] = 16027,
  [SMALL_STATE(828)] = 16089,
  [SMALL_STATE(829)] = 16151,
  [SMALL_STATE(830)] = 16211,
  [SMALL_STATE(831)] = 16271,
  [SMALL_STATE(832)] = 16331,
  [SMALL_STATE(833)] = 16391,
  [SMALL_STATE(834)] = 16453,
  [SMALL_STATE(835)] = 16515,
  [SMALL_STATE(836)] = 16575,
  [SMALL_STATE(837)] = 16635,
  [SMALL_STATE(838)] = 16695,
  [SMALL_STATE(839)] = 16755,
  [SMALL_STATE(840)] = 16815,
  [SMALL_STATE(841)] = 16875,
  [SMALL_STATE(842)] = 16935,
  [SMALL_STATE(843)] = 16995,
  [SMALL_STATE(844)] = 17055,
  [SMALL_STATE(845)] = 17115,
  [SMALL_STATE(846)] = 17177,
  [SMALL_STATE(847)] = 17237,
  [SMALL_STATE(848)] = 17297,
  [SMALL_STATE(849)] = 17357,
  [SMALL_STATE(850)] = 17419,
  [SMALL_STATE(851)] = 17478,
  [SMALL_STATE(852)] = 17537,
  [SMALL_STATE(853)] = 17608,
  [SMALL_STATE(854)] = 17681,
  [SMALL_STATE(855)] = 17754,
  [SMALL_STATE(856)] = 17825,
  [SMALL_STATE(857)] = 17898,
  [SMALL_STATE(858)] = 17973,
  [SMALL_STATE(859)] = 18048,
  [SMALL_STATE(860)] = 18109,
  [SMALL_STATE(861)] = 18180,
  [SMALL_STATE(862)] = 18255,
  [SMALL_STATE(863)] = 18330,
  [SMALL_STATE(864)] = 18397,
  [SMALL_STATE(865)] = 18468,
  [SMALL_STATE(866)] = 18535,
  [SMALL_STATE(867)] = 18606,
  [SMALL_STATE(868)] = 18677,
  [SMALL_STATE(869)] = 18750,
  [SMALL_STATE(870)] = 18819,
  [SMALL_STATE(871)] = 18890,
  [SMALL_STATE(872)] = 18953,
  [SMALL_STATE(873)] = 19012,
  [SMALL_STATE(874)] = 19083,
  [SMALL_STATE(875)] = 19158,
  [SMALL_STATE(876)] = 19233,
  [SMALL_STATE(877)] = 19292,
  [SMALL_STATE(878)] = 19367,
  [SMALL_STATE(879)] = 19440,
  [SMALL_STATE(880)] = 19501,
  [SMALL_STATE(881)] = 19560,
  [SMALL_STATE(882)] = 19635,
  [SMALL_STATE(883)] = 19696,
  [SMALL_STATE(884)] = 19767,
  [SMALL_STATE(885)] = 19842,
  [SMALL_STATE(886)] = 19917,
  [SMALL_STATE(887)] = 19978,
  [SMALL_STATE(888)] = 20057,
  [SMALL_STATE(889)] = 20118,
  [SMALL_STATE(890)] = 20179,
  [SMALL_STATE(891)] = 20252,
  [SMALL_STATE(892)] = 20313,
  [SMALL_STATE(893)] = 20392,
  [SMALL_STATE(894)] = 20471,
  [SMALL_STATE(895)] = 20532,
  [SMALL_STATE(896)] = 20593,
  [SMALL_STATE(897)] = 20668,
  [SMALL_STATE(898)] = 20731,
  [SMALL_STATE(899)] = 20794,
  [SMALL_STATE(900)] = 20857,
  [SMALL_STATE(901)] = 20920,
  [SMALL_STATE(902)] = 20995,
  [SMALL_STATE(903)] = 21066,
  [SMALL_STATE(904)] = 21143,
  [SMALL_STATE(905)] = 21202,
  [SMALL_STATE(906)] = 21281,
  [SMALL_STATE(907)] = 21355,
  [SMALL_STATE(908)] = 21417,
  [SMALL_STATE(909)] = 21479,
  [SMALL_STATE(910)] = 21547,
  [SMALL_STATE(911)] = 21613,
  [SMALL_STATE(912)] = 21683,
  [SMALL_STATE(913)] = 21749,
  [SMALL_STATE(914)] = 21807,
  [SMALL_STATE(915)] = 21877,
  [SMALL_STATE(916)] = 21945,
  [SMALL_STATE(917)] = 22019,
  [SMALL_STATE(918)] = 22093,
  [SMALL_STATE(919)] = 22155,
  [SMALL_STATE(920)] = 22217,
  [SMALL_STATE(921)] = 22291,
  [SMALL_STATE(922)] = 22351,
  [SMALL_STATE(923)] = 22429,
  [SMALL_STATE(924)] = 22499,
  [SMALL_STATE(925)] = 22573,
  [SMALL_STATE(926)] = 22635,
  [SMALL_STATE(927)] = 22693,
  [SMALL_STATE(928)] = 22763,
  [SMALL_STATE(929)] = 22833,
  [SMALL_STATE(930)] = 22903,
  [SMALL_STATE(931)] = 22977,
  [SMALL_STATE(932)] = 23047,
  [SMALL_STATE(933)] = 23117,
  [SMALL_STATE(934)] = 23195,
  [SMALL_STATE(935)] = 23273,
  [SMALL_STATE(936)] = 23351,
  [SMALL_STATE(937)] = 23413,
  [SMALL_STATE(938)] = 23478,
  [SMALL_STATE(939)] = 23547,
  [SMALL_STATE(940)] = 23616,
  [SMALL_STATE(941)] = 23685,
  [SMALL_STATE(942)] = 23754,
  [SMALL_STATE(943)] = 23819,
  [SMALL_STATE(944)] = 23878,
  [SMALL_STATE(945)] = 23947,
  [SMALL_STATE(946)] = 24014,
  [SMALL_STATE(947)] = 24083,
  [SMALL_STATE(948)] = 24152,
  [SMALL_STATE(949)] = 24211,
  [SMALL_STATE(950)] = 24280,
  [SMALL_STATE(951)] = 24349,
  [SMALL_STATE(952)] = 24418,
  [SMALL_STATE(953)] = 24487,
  [SMALL_STATE(954)] = 24556,
  [SMALL_STATE(955)] = 24625,
  [SMALL_STATE(956)] = 24694,
  [SMALL_STATE(957)] = 24763,
  [SMALL_STATE(958)] = 24832,
  [SMALL_STATE(959)] = 24901,
  [SMALL_STATE(960)] = 24970,
  [SMALL_STATE(961)] = 25039,
  [SMALL_STATE(962)] = 25108,
  [SMALL_STATE(963)] = 25177,
  [SMALL_STATE(964)] = 25246,
  [SMALL_STATE(965)] = 25315,
  [SMALL_STATE(966)] = 25391,
  [SMALL_STATE(967)] = 25467,
  [SMALL_STATE(968)] = 25539,
  [SMALL_STATE(969)] = 25615,
  [SMALL_STATE(970)] = 25687,
  [SMALL_STATE(971)] = 25759,
  [SMALL_STATE(972)] = 25835,
  [SMALL_STATE(973)] = 25911,
  [SMALL_STATE(974)] = 25987,
  [SMALL_STATE(975)] = 26063,
  [SMALL_STATE(976)] = 26139,
  [SMALL_STATE(977)] = 26215,
  [SMALL_STATE(978)] = 26291,
  [SMALL_STATE(979)] = 26367,
  [SMALL_STATE(980)] = 26443,
  [SMALL_STATE(981)] = 26519,
  [SMALL_STATE(982)] = 26595,
  [SMALL_STATE(983)] = 26671,
  [SMALL_STATE(984)] = 26747,
  [SMALL_STATE(985)] = 26823,
  [SMALL_STATE(986)] = 26895,
  [SMALL_STATE(987)] = 26971,
  [SMALL_STATE(988)] = 27039,
  [SMALL_STATE(989)] = 27111,
  [SMALL_STATE(990)] = 27183,
  [SMALL_STATE(991)] = 27251,
  [SMALL_STATE(992)] = 27327,
  [SMALL_STATE(993)] = 27403,
  [SMALL_STATE(994)] = 27473,
  [SMALL_STATE(995)] = 27549,
  [SMALL_STATE(996)] = 27616,
  [SMALL_STATE(997)] = 27683,
  [SMALL_STATE(998)] = 27750,
  [SMALL_STATE(999)] = 27805,
  [SMALL_STATE(1000)] = 27876,
  [SMALL_STATE(1001)] = 27947,
  [SMALL_STATE(1002)] = 28002,
  [SMALL_STATE(1003)] = 28069,
  [SMALL_STATE(1004)] = 28139,
  [SMALL_STATE(1005)] = 28209,
  [SMALL_STATE(1006)] = 28279,
  [SMALL_STATE(1007)] = 28349,
  [SMALL_STATE(1008)] = 28419,
  [SMALL_STATE(1009)] = 28489,
  [SMALL_STATE(1010)] = 28559,
  [SMALL_STATE(1011)] = 28629,
  [SMALL_STATE(1012)] = 28699,
  [SMALL_STATE(1013)] = 28769,
  [SMALL_STATE(1014)] = 28839,
  [SMALL_STATE(1015)] = 28909,
  [SMALL_STATE(1016)] = 28979,
  [SMALL_STATE(1017)] = 29049,
  [SMALL_STATE(1018)] = 29119,
  [SMALL_STATE(1019)] = 29189,
  [SMALL_STATE(1020)] = 29259,
  [SMALL_STATE(1021)] = 29329,
  [SMALL_STATE(1022)] = 29399,
  [SMALL_STATE(1023)] = 29466,
  [SMALL_STATE(1024)] = 29496,
  [SMALL_STATE(1025)] = 29527,
  [SMALL_STATE(1026)] = 29556,
  [SMALL_STATE(1027)] = 29585,
  [SMALL_STATE(1028)] = 29614,
  [SMALL_STATE(1029)] = 29645,
  [SMALL_STATE(1030)] = 29678,
  [SMALL_STATE(1031)] = 29711,
  [SMALL_STATE(1032)] = 29740,
  [SMALL_STATE(1033)] = 29773,
  [SMALL_STATE(1034)] = 29802,
  [SMALL_STATE(1035)] = 29833,
  [SMALL_STATE(1036)] = 29862,
  [SMALL_STATE(1037)] = 29893,
  [SMALL_STATE(1038)] = 29922,
  [SMALL_STATE(1039)] = 29951,
  [SMALL_STATE(1040)] = 29976,
  [SMALL_STATE(1041)] = 30007,
  [SMALL_STATE(1042)] = 30036,
  [SMALL_STATE(1043)] = 30060,
  [SMALL_STATE(1044)] = 30084,
  [SMALL_STATE(1045)] = 30110,
  [SMALL_STATE(1046)] = 30135,
  [SMALL_STATE(1047)] = 30160,
  [SMALL_STATE(1048)] = 30185,
  [SMALL_STATE(1049)] = 30210,
  [SMALL_STATE(1050)] = 30233,
  [SMALL_STATE(1051)] = 30258,
  [SMALL_STATE(1052)] = 30283,
  [SMALL_STATE(1053)] = 30306,
  [SMALL_STATE(1054)] = 30331,
  [SMALL_STATE(1055)] = 30356,
  [SMALL_STATE(1056)] = 30381,
  [SMALL_STATE(1057)] = 30400,
  [SMALL_STATE(1058)] = 30421,
  [SMALL_STATE(1059)] = 30446,
  [SMALL_STATE(1060)] = 30471,
  [SMALL_STATE(1061)] = 30494,
  [SMALL_STATE(1062)] = 30519,
  [SMALL_STATE(1063)] = 30544,
  [SMALL_STATE(1064)] = 30563,
  [SMALL_STATE(1065)] = 30588,
  [SMALL_STATE(1066)] = 30609,
  [SMALL_STATE(1067)] = 30628,
  [SMALL_STATE(1068)] = 30647,
  [SMALL_STATE(1069)] = 30668,
  [SMALL_STATE(1070)] = 30687,
  [SMALL_STATE(1071)] = 30712,
  [SMALL_STATE(1072)] = 30731,
  [SMALL_STATE(1073)] = 30748,
  [SMALL_STATE(1074)] = 30771,
  [SMALL_STATE(1075)] = 30790,
  [SMALL_STATE(1076)] = 30815,
  [SMALL_STATE(1077)] = 30840,
  [SMALL_STATE(1078)] = 30865,
  [SMALL_STATE(1079)] = 30888,
  [SMALL_STATE(1080)] = 30913,
  [SMALL_STATE(1081)] = 30936,
  [SMALL_STATE(1082)] = 30956,
  [SMALL_STATE(1083)] = 30978,
  [SMALL_STATE(1084)] = 30998,
  [SMALL_STATE(1085)] = 31018,
  [SMALL_STATE(1086)] = 31038,
  [SMALL_STATE(1087)] = 31052,
  [SMALL_STATE(1088)] = 31072,
  [SMALL_STATE(1089)] = 31088,
  [SMALL_STATE(1090)] = 31110,
  [SMALL_STATE(1091)] = 31130,
  [SMALL_STATE(1092)] = 31147,
  [SMALL_STATE(1093)] = 31164,
  [SMALL_STATE(1094)] = 31183,
  [SMALL_STATE(1095)] = 31202,
  [SMALL_STATE(1096)] = 31219,
  [SMALL_STATE(1097)] = 31238,
  [SMALL_STATE(1098)] = 31255,
  [SMALL_STATE(1099)] = 31272,
  [SMALL_STATE(1100)] = 31291,
  [SMALL_STATE(1101)] = 31310,
  [SMALL_STATE(1102)] = 31329,
  [SMALL_STATE(1103)] = 31348,
  [SMALL_STATE(1104)] = 31361,
  [SMALL_STATE(1105)] = 31380,
  [SMALL_STATE(1106)] = 31399,
  [SMALL_STATE(1107)] = 31418,
  [SMALL_STATE(1108)] = 31435,
  [SMALL_STATE(1109)] = 31454,
  [SMALL_STATE(1110)] = 31467,
  [SMALL_STATE(1111)] = 31486,
  [SMALL_STATE(1112)] = 31503,
  [SMALL_STATE(1113)] = 31516,
  [SMALL_STATE(1114)] = 31535,
  [SMALL_STATE(1115)] = 31552,
  [SMALL_STATE(1116)] = 31565,
  [SMALL_STATE(1117)] = 31578,
  [SMALL_STATE(1118)] = 31595,
  [SMALL_STATE(1119)] = 31614,
  [SMALL_STATE(1120)] = 31633,
  [SMALL_STATE(1121)] = 31646,
  [SMALL_STATE(1122)] = 31659,
  [SMALL_STATE(1123)] = 31676,
  [SMALL_STATE(1124)] = 31695,
  [SMALL_STATE(1125)] = 31712,
  [SMALL_STATE(1126)] = 31729,
  [SMALL_STATE(1127)] = 31748,
  [SMALL_STATE(1128)] = 31761,
  [SMALL_STATE(1129)] = 31774,
  [SMALL_STATE(1130)] = 31791,
  [SMALL_STATE(1131)] = 31810,
  [SMALL_STATE(1132)] = 31829,
  [SMALL_STATE(1133)] = 31846,
  [SMALL_STATE(1134)] = 31863,
  [SMALL_STATE(1135)] = 31882,
  [SMALL_STATE(1136)] = 31901,
  [SMALL_STATE(1137)] = 31920,
  [SMALL_STATE(1138)] = 31939,
  [SMALL_STATE(1139)] = 31956,
  [SMALL_STATE(1140)] = 31975,
  [SMALL_STATE(1141)] = 31992,
  [SMALL_STATE(1142)] = 32011,
  [SMALL_STATE(1143)] = 32028,
  [SMALL_STATE(1144)] = 32047,
  [SMALL_STATE(1145)] = 32064,
  [SMALL_STATE(1146)] = 32083,
  [SMALL_STATE(1147)] = 32100,
  [SMALL_STATE(1148)] = 32115,
  [SMALL_STATE(1149)] = 32132,
  [SMALL_STATE(1150)] = 32149,
  [SMALL_STATE(1151)] = 32168,
  [SMALL_STATE(1152)] = 32185,
  [SMALL_STATE(1153)] = 32202,
  [SMALL_STATE(1154)] = 32219,
  [SMALL_STATE(1155)] = 32234,
  [SMALL_STATE(1156)] = 32253,
  [SMALL_STATE(1157)] = 32270,
  [SMALL_STATE(1158)] = 32287,
  [SMALL_STATE(1159)] = 32306,
  [SMALL_STATE(1160)] = 32321,
  [SMALL_STATE(1161)] = 32340,
  [SMALL_STATE(1162)] = 32359,
  [SMALL_STATE(1163)] = 32376,
  [SMALL_STATE(1164)] = 32393,
  [SMALL_STATE(1165)] = 32412,
  [SMALL_STATE(1166)] = 32431,
  [SMALL_STATE(1167)] = 32448,
  [SMALL_STATE(1168)] = 32465,
  [SMALL_STATE(1169)] = 32482,
  [SMALL_STATE(1170)] = 32501,
  [SMALL_STATE(1171)] = 32516,
  [SMALL_STATE(1172)] = 32533,
  [SMALL_STATE(1173)] = 32550,
  [SMALL_STATE(1174)] = 32567,
  [SMALL_STATE(1175)] = 32586,
  [SMALL_STATE(1176)] = 32605,
  [SMALL_STATE(1177)] = 32624,
  [SMALL_STATE(1178)] = 32641,
  [SMALL_STATE(1179)] = 32660,
  [SMALL_STATE(1180)] = 32679,
  [SMALL_STATE(1181)] = 32698,
  [SMALL_STATE(1182)] = 32715,
  [SMALL_STATE(1183)] = 32734,
  [SMALL_STATE(1184)] = 32749,
  [SMALL_STATE(1185)] = 32766,
  [SMALL_STATE(1186)] = 32783,
  [SMALL_STATE(1187)] = 32800,
  [SMALL_STATE(1188)] = 32819,
  [SMALL_STATE(1189)] = 32836,
  [SMALL_STATE(1190)] = 32855,
  [SMALL_STATE(1191)] = 32874,
  [SMALL_STATE(1192)] = 32893,
  [SMALL_STATE(1193)] = 32912,
  [SMALL_STATE(1194)] = 32929,
  [SMALL_STATE(1195)] = 32946,
  [SMALL_STATE(1196)] = 32965,
  [SMALL_STATE(1197)] = 32982,
  [SMALL_STATE(1198)] = 33001,
  [SMALL_STATE(1199)] = 33018,
  [SMALL_STATE(1200)] = 33035,
  [SMALL_STATE(1201)] = 33050,
  [SMALL_STATE(1202)] = 33067,
  [SMALL_STATE(1203)] = 33086,
  [SMALL_STATE(1204)] = 33103,
  [SMALL_STATE(1205)] = 33119,
  [SMALL_STATE(1206)] = 33131,
  [SMALL_STATE(1207)] = 33147,
  [SMALL_STATE(1208)] = 33163,
  [SMALL_STATE(1209)] = 33179,
  [SMALL_STATE(1210)] = 33195,
  [SMALL_STATE(1211)] = 33211,
  [SMALL_STATE(1212)] = 33227,
  [SMALL_STATE(1213)] = 33243,
  [SMALL_STATE(1214)] = 33259,
  [SMALL_STATE(1215)] = 33275,
  [SMALL_STATE(1216)] = 33291,
  [SMALL_STATE(1217)] = 33305,
  [SMALL_STATE(1218)] = 33321,
  [SMALL_STATE(1219)] = 33337,
  [SMALL_STATE(1220)] = 33353,
  [SMALL_STATE(1221)] = 33369,
  [SMALL_STATE(1222)] = 33385,
  [SMALL_STATE(1223)] = 33401,
  [SMALL_STATE(1224)] = 33417,
  [SMALL_STATE(1225)] = 33433,
  [SMALL_STATE(1226)] = 33449,
  [SMALL_STATE(1227)] = 33463,
  [SMALL_STATE(1228)] = 33479,
  [SMALL_STATE(1229)] = 33495,
  [SMALL_STATE(1230)] = 33511,
  [SMALL_STATE(1231)] = 33525,
  [SMALL_STATE(1232)] = 33541,
  [SMALL_STATE(1233)] = 33557,
  [SMALL_STATE(1234)] = 33573,
  [SMALL_STATE(1235)] = 33589,
  [SMALL_STATE(1236)] = 33605,
  [SMALL_STATE(1237)] = 33619,
  [SMALL_STATE(1238)] = 33635,
  [SMALL_STATE(1239)] = 33649,
  [SMALL_STATE(1240)] = 33665,
  [SMALL_STATE(1241)] = 33681,
  [SMALL_STATE(1242)] = 33697,
  [SMALL_STATE(1243)] = 33713,
  [SMALL_STATE(1244)] = 33729,
  [SMALL_STATE(1245)] = 33745,
  [SMALL_STATE(1246)] = 33759,
  [SMALL_STATE(1247)] = 33775,
  [SMALL_STATE(1248)] = 33791,
  [SMALL_STATE(1249)] = 33807,
  [SMALL_STATE(1250)] = 33821,
  [SMALL_STATE(1251)] = 33835,
  [SMALL_STATE(1252)] = 33847,
  [SMALL_STATE(1253)] = 33861,
  [SMALL_STATE(1254)] = 33877,
  [SMALL_STATE(1255)] = 33893,
  [SMALL_STATE(1256)] = 33909,
  [SMALL_STATE(1257)] = 33925,
  [SMALL_STATE(1258)] = 33941,
  [SMALL_STATE(1259)] = 33957,
  [SMALL_STATE(1260)] = 33973,
  [SMALL_STATE(1261)] = 33989,
  [SMALL_STATE(1262)] = 34005,
  [SMALL_STATE(1263)] = 34021,
  [SMALL_STATE(1264)] = 34037,
  [SMALL_STATE(1265)] = 34053,
  [SMALL_STATE(1266)] = 34069,
  [SMALL_STATE(1267)] = 34085,
  [SMALL_STATE(1268)] = 34101,
  [SMALL_STATE(1269)] = 34117,
  [SMALL_STATE(1270)] = 34133,
  [SMALL_STATE(1271)] = 34149,
  [SMALL_STATE(1272)] = 34165,
  [SMALL_STATE(1273)] = 34181,
  [SMALL_STATE(1274)] = 34197,
  [SMALL_STATE(1275)] = 34213,
  [SMALL_STATE(1276)] = 34229,
  [SMALL_STATE(1277)] = 34245,
  [SMALL_STATE(1278)] = 34259,
  [SMALL_STATE(1279)] = 34275,
  [SMALL_STATE(1280)] = 34291,
  [SMALL_STATE(1281)] = 34307,
  [SMALL_STATE(1282)] = 34323,
  [SMALL_STATE(1283)] = 34339,
  [SMALL_STATE(1284)] = 34355,
  [SMALL_STATE(1285)] = 34369,
  [SMALL_STATE(1286)] = 34385,
  [SMALL_STATE(1287)] = 34401,
  [SMALL_STATE(1288)] = 34417,
  [SMALL_STATE(1289)] = 34433,
  [SMALL_STATE(1290)] = 34449,
  [SMALL_STATE(1291)] = 34465,
  [SMALL_STATE(1292)] = 34481,
  [SMALL_STATE(1293)] = 34497,
  [SMALL_STATE(1294)] = 34513,
  [SMALL_STATE(1295)] = 34529,
  [SMALL_STATE(1296)] = 34545,
  [SMALL_STATE(1297)] = 34561,
  [SMALL_STATE(1298)] = 34577,
  [SMALL_STATE(1299)] = 34593,
  [SMALL_STATE(1300)] = 34609,
  [SMALL_STATE(1301)] = 34625,
  [SMALL_STATE(1302)] = 34641,
  [SMALL_STATE(1303)] = 34657,
  [SMALL_STATE(1304)] = 34673,
  [SMALL_STATE(1305)] = 34689,
  [SMALL_STATE(1306)] = 34705,
  [SMALL_STATE(1307)] = 34719,
  [SMALL_STATE(1308)] = 34735,
  [SMALL_STATE(1309)] = 34751,
  [SMALL_STATE(1310)] = 34765,
  [SMALL_STATE(1311)] = 34781,
  [SMALL_STATE(1312)] = 34797,
  [SMALL_STATE(1313)] = 34813,
  [SMALL_STATE(1314)] = 34829,
  [SMALL_STATE(1315)] = 34845,
  [SMALL_STATE(1316)] = 34861,
  [SMALL_STATE(1317)] = 34877,
  [SMALL_STATE(1318)] = 34893,
  [SMALL_STATE(1319)] = 34909,
  [SMALL_STATE(1320)] = 34925,
  [SMALL_STATE(1321)] = 34941,
  [SMALL_STATE(1322)] = 34957,
  [SMALL_STATE(1323)] = 34973,
  [SMALL_STATE(1324)] = 34989,
  [SMALL_STATE(1325)] = 35005,
  [SMALL_STATE(1326)] = 35021,
  [SMALL_STATE(1327)] = 35037,
  [SMALL_STATE(1328)] = 35053,
  [SMALL_STATE(1329)] = 35069,
  [SMALL_STATE(1330)] = 35085,
  [SMALL_STATE(1331)] = 35101,
  [SMALL_STATE(1332)] = 35117,
  [SMALL_STATE(1333)] = 35133,
  [SMALL_STATE(1334)] = 35149,
  [SMALL_STATE(1335)] = 35165,
  [SMALL_STATE(1336)] = 35181,
  [SMALL_STATE(1337)] = 35197,
  [SMALL_STATE(1338)] = 35213,
  [SMALL_STATE(1339)] = 35229,
  [SMALL_STATE(1340)] = 35242,
  [SMALL_STATE(1341)] = 35255,
  [SMALL_STATE(1342)] = 35268,
  [SMALL_STATE(1343)] = 35281,
  [SMALL_STATE(1344)] = 35294,
  [SMALL_STATE(1345)] = 35307,
  [SMALL_STATE(1346)] = 35320,
  [SMALL_STATE(1347)] = 35333,
  [SMALL_STATE(1348)] = 35346,
  [SMALL_STATE(1349)] = 35359,
  [SMALL_STATE(1350)] = 35372,
  [SMALL_STATE(1351)] = 35385,
  [SMALL_STATE(1352)] = 35398,
  [SMALL_STATE(1353)] = 35411,
  [SMALL_STATE(1354)] = 35424,
  [SMALL_STATE(1355)] = 35437,
  [SMALL_STATE(1356)] = 35450,
  [SMALL_STATE(1357)] = 35463,
  [SMALL_STATE(1358)] = 35476,
  [SMALL_STATE(1359)] = 35489,
  [SMALL_STATE(1360)] = 35502,
  [SMALL_STATE(1361)] = 35515,
  [SMALL_STATE(1362)] = 35528,
  [SMALL_STATE(1363)] = 35541,
  [SMALL_STATE(1364)] = 35554,
  [SMALL_STATE(1365)] = 35567,
  [SMALL_STATE(1366)] = 35580,
  [SMALL_STATE(1367)] = 35593,
  [SMALL_STATE(1368)] = 35606,
  [SMALL_STATE(1369)] = 35619,
  [SMALL_STATE(1370)] = 35632,
  [SMALL_STATE(1371)] = 35645,
  [SMALL_STATE(1372)] = 35658,
  [SMALL_STATE(1373)] = 35671,
  [SMALL_STATE(1374)] = 35684,
  [SMALL_STATE(1375)] = 35697,
  [SMALL_STATE(1376)] = 35710,
  [SMALL_STATE(1377)] = 35723,
  [SMALL_STATE(1378)] = 35736,
  [SMALL_STATE(1379)] = 35749,
  [SMALL_STATE(1380)] = 35762,
  [SMALL_STATE(1381)] = 35775,
  [SMALL_STATE(1382)] = 35788,
  [SMALL_STATE(1383)] = 35801,
  [SMALL_STATE(1384)] = 35814,
  [SMALL_STATE(1385)] = 35827,
  [SMALL_STATE(1386)] = 35840,
  [SMALL_STATE(1387)] = 35853,
  [SMALL_STATE(1388)] = 35866,
  [SMALL_STATE(1389)] = 35879,
  [SMALL_STATE(1390)] = 35892,
  [SMALL_STATE(1391)] = 35905,
  [SMALL_STATE(1392)] = 35918,
  [SMALL_STATE(1393)] = 35931,
  [SMALL_STATE(1394)] = 35944,
  [SMALL_STATE(1395)] = 35957,
  [SMALL_STATE(1396)] = 35970,
  [SMALL_STATE(1397)] = 35983,
  [SMALL_STATE(1398)] = 35996,
  [SMALL_STATE(1399)] = 36009,
  [SMALL_STATE(1400)] = 36022,
  [SMALL_STATE(1401)] = 36035,
  [SMALL_STATE(1402)] = 36048,
  [SMALL_STATE(1403)] = 36061,
  [SMALL_STATE(1404)] = 36074,
  [SMALL_STATE(1405)] = 36087,
  [SMALL_STATE(1406)] = 36100,
  [SMALL_STATE(1407)] = 36113,
  [SMALL_STATE(1408)] = 36126,
  [SMALL_STATE(1409)] = 36139,
  [SMALL_STATE(1410)] = 36152,
  [SMALL_STATE(1411)] = 36165,
  [SMALL_STATE(1412)] = 36178,
  [SMALL_STATE(1413)] = 36191,
  [SMALL_STATE(1414)] = 36204,
  [SMALL_STATE(1415)] = 36217,
  [SMALL_STATE(1416)] = 36230,
  [SMALL_STATE(1417)] = 36243,
  [SMALL_STATE(1418)] = 36256,
  [SMALL_STATE(1419)] = 36269,
  [SMALL_STATE(1420)] = 36282,
  [SMALL_STATE(1421)] = 36295,
  [SMALL_STATE(1422)] = 36308,
  [SMALL_STATE(1423)] = 36321,
  [SMALL_STATE(1424)] = 36334,
  [SMALL_STATE(1425)] = 36347,
  [SMALL_STATE(1426)] = 36360,
  [SMALL_STATE(1427)] = 36373,
  [SMALL_STATE(1428)] = 36386,
  [SMALL_STATE(1429)] = 36399,
  [SMALL_STATE(1430)] = 36412,
  [SMALL_STATE(1431)] = 36425,
  [SMALL_STATE(1432)] = 36438,
  [SMALL_STATE(1433)] = 36451,
  [SMALL_STATE(1434)] = 36464,
  [SMALL_STATE(1435)] = 36477,
  [SMALL_STATE(1436)] = 36490,
  [SMALL_STATE(1437)] = 36503,
  [SMALL_STATE(1438)] = 36516,
  [SMALL_STATE(1439)] = 36529,
  [SMALL_STATE(1440)] = 36542,
  [SMALL_STATE(1441)] = 36555,
  [SMALL_STATE(1442)] = 36568,
  [SMALL_STATE(1443)] = 36581,
  [SMALL_STATE(1444)] = 36594,
  [SMALL_STATE(1445)] = 36607,
  [SMALL_STATE(1446)] = 36620,
  [SMALL_STATE(1447)] = 36633,
  [SMALL_STATE(1448)] = 36642,
  [SMALL_STATE(1449)] = 36655,
  [SMALL_STATE(1450)] = 36668,
  [SMALL_STATE(1451)] = 36681,
  [SMALL_STATE(1452)] = 36694,
  [SMALL_STATE(1453)] = 36707,
  [SMALL_STATE(1454)] = 36720,
  [SMALL_STATE(1455)] = 36733,
  [SMALL_STATE(1456)] = 36746,
  [SMALL_STATE(1457)] = 36759,
  [SMALL_STATE(1458)] = 36772,
  [SMALL_STATE(1459)] = 36785,
  [SMALL_STATE(1460)] = 36798,
  [SMALL_STATE(1461)] = 36811,
  [SMALL_STATE(1462)] = 36824,
  [SMALL_STATE(1463)] = 36837,
  [SMALL_STATE(1464)] = 36850,
  [SMALL_STATE(1465)] = 36863,
  [SMALL_STATE(1466)] = 36876,
  [SMALL_STATE(1467)] = 36889,
  [SMALL_STATE(1468)] = 36902,
  [SMALL_STATE(1469)] = 36915,
  [SMALL_STATE(1470)] = 36928,
  [SMALL_STATE(1471)] = 36941,
  [SMALL_STATE(1472)] = 36954,
  [SMALL_STATE(1473)] = 36967,
  [SMALL_STATE(1474)] = 36980,
  [SMALL_STATE(1475)] = 36993,
  [SMALL_STATE(1476)] = 37006,
  [SMALL_STATE(1477)] = 37019,
  [SMALL_STATE(1478)] = 37032,
  [SMALL_STATE(1479)] = 37045,
  [SMALL_STATE(1480)] = 37058,
  [SMALL_STATE(1481)] = 37071,
  [SMALL_STATE(1482)] = 37084,
  [SMALL_STATE(1483)] = 37097,
  [SMALL_STATE(1484)] = 37110,
  [SMALL_STATE(1485)] = 37123,
  [SMALL_STATE(1486)] = 37134,
  [SMALL_STATE(1487)] = 37147,
  [SMALL_STATE(1488)] = 37160,
  [SMALL_STATE(1489)] = 37173,
  [SMALL_STATE(1490)] = 37186,
  [SMALL_STATE(1491)] = 37199,
  [SMALL_STATE(1492)] = 37208,
  [SMALL_STATE(1493)] = 37221,
  [SMALL_STATE(1494)] = 37234,
  [SMALL_STATE(1495)] = 37247,
  [SMALL_STATE(1496)] = 37260,
  [SMALL_STATE(1497)] = 37273,
  [SMALL_STATE(1498)] = 37286,
  [SMALL_STATE(1499)] = 37299,
  [SMALL_STATE(1500)] = 37312,
  [SMALL_STATE(1501)] = 37325,
  [SMALL_STATE(1502)] = 37338,
  [SMALL_STATE(1503)] = 37351,
  [SMALL_STATE(1504)] = 37364,
  [SMALL_STATE(1505)] = 37377,
  [SMALL_STATE(1506)] = 37390,
  [SMALL_STATE(1507)] = 37403,
  [SMALL_STATE(1508)] = 37416,
  [SMALL_STATE(1509)] = 37429,
  [SMALL_STATE(1510)] = 37442,
  [SMALL_STATE(1511)] = 37455,
  [SMALL_STATE(1512)] = 37468,
  [SMALL_STATE(1513)] = 37481,
  [SMALL_STATE(1514)] = 37494,
  [SMALL_STATE(1515)] = 37507,
  [SMALL_STATE(1516)] = 37520,
  [SMALL_STATE(1517)] = 37533,
  [SMALL_STATE(1518)] = 37546,
  [SMALL_STATE(1519)] = 37559,
  [SMALL_STATE(1520)] = 37572,
  [SMALL_STATE(1521)] = 37585,
  [SMALL_STATE(1522)] = 37598,
  [SMALL_STATE(1523)] = 37611,
  [SMALL_STATE(1524)] = 37624,
  [SMALL_STATE(1525)] = 37637,
  [SMALL_STATE(1526)] = 37650,
  [SMALL_STATE(1527)] = 37663,
  [SMALL_STATE(1528)] = 37676,
  [SMALL_STATE(1529)] = 37689,
  [SMALL_STATE(1530)] = 37702,
  [SMALL_STATE(1531)] = 37715,
  [SMALL_STATE(1532)] = 37728,
  [SMALL_STATE(1533)] = 37741,
  [SMALL_STATE(1534)] = 37754,
  [SMALL_STATE(1535)] = 37767,
  [SMALL_STATE(1536)] = 37780,
  [SMALL_STATE(1537)] = 37793,
  [SMALL_STATE(1538)] = 37806,
  [SMALL_STATE(1539)] = 37819,
  [SMALL_STATE(1540)] = 37832,
  [SMALL_STATE(1541)] = 37845,
  [SMALL_STATE(1542)] = 37858,
  [SMALL_STATE(1543)] = 37871,
  [SMALL_STATE(1544)] = 37884,
  [SMALL_STATE(1545)] = 37897,
  [SMALL_STATE(1546)] = 37910,
  [SMALL_STATE(1547)] = 37923,
  [SMALL_STATE(1548)] = 37932,
  [SMALL_STATE(1549)] = 37945,
  [SMALL_STATE(1550)] = 37958,
  [SMALL_STATE(1551)] = 37966,
  [SMALL_STATE(1552)] = 37974,
  [SMALL_STATE(1553)] = 37984,
  [SMALL_STATE(1554)] = 37992,
  [SMALL_STATE(1555)] = 38000,
  [SMALL_STATE(1556)] = 38008,
  [SMALL_STATE(1557)] = 38016,
  [SMALL_STATE(1558)] = 38026,
  [SMALL_STATE(1559)] = 38034,
  [SMALL_STATE(1560)] = 38044,
  [SMALL_STATE(1561)] = 38054,
  [SMALL_STATE(1562)] = 38064,
  [SMALL_STATE(1563)] = 38074,
  [SMALL_STATE(1564)] = 38082,
  [SMALL_STATE(1565)] = 38092,
  [SMALL_STATE(1566)] = 38102,
  [SMALL_STATE(1567)] = 38110,
  [SMALL_STATE(1568)] = 38120,
  [SMALL_STATE(1569)] = 38128,
  [SMALL_STATE(1570)] = 38136,
  [SMALL_STATE(1571)] = 38144,
  [SMALL_STATE(1572)] = 38152,
  [SMALL_STATE(1573)] = 38160,
  [SMALL_STATE(1574)] = 38168,
  [SMALL_STATE(1575)] = 38176,
  [SMALL_STATE(1576)] = 38184,
  [SMALL_STATE(1577)] = 38192,
  [SMALL_STATE(1578)] = 38200,
  [SMALL_STATE(1579)] = 38208,
  [SMALL_STATE(1580)] = 38216,
  [SMALL_STATE(1581)] = 38224,
  [SMALL_STATE(1582)] = 38232,
  [SMALL_STATE(1583)] = 38240,
  [SMALL_STATE(1584)] = 38248,
  [SMALL_STATE(1585)] = 38256,
  [SMALL_STATE(1586)] = 38264,
  [SMALL_STATE(1587)] = 38272,
  [SMALL_STATE(1588)] = 38282,
  [SMALL_STATE(1589)] = 38292,
  [SMALL_STATE(1590)] = 38302,
  [SMALL_STATE(1591)] = 38312,
  [SMALL_STATE(1592)] = 38320,
  [SMALL_STATE(1593)] = 38330,
  [SMALL_STATE(1594)] = 38338,
  [SMALL_STATE(1595)] = 38346,
  [SMALL_STATE(1596)] = 38356,
  [SMALL_STATE(1597)] = 38364,
  [SMALL_STATE(1598)] = 38372,
  [SMALL_STATE(1599)] = 38380,
  [SMALL_STATE(1600)] = 38388,
  [SMALL_STATE(1601)] = 38396,
  [SMALL_STATE(1602)] = 38404,
  [SMALL_STATE(1603)] = 38412,
  [SMALL_STATE(1604)] = 38420,
  [SMALL_STATE(1605)] = 38430,
  [SMALL_STATE(1606)] = 38440,
  [SMALL_STATE(1607)] = 38448,
  [SMALL_STATE(1608)] = 38458,
  [SMALL_STATE(1609)] = 38466,
  [SMALL_STATE(1610)] = 38474,
  [SMALL_STATE(1611)] = 38482,
  [SMALL_STATE(1612)] = 38490,
  [SMALL_STATE(1613)] = 38498,
  [SMALL_STATE(1614)] = 38506,
  [SMALL_STATE(1615)] = 38514,
  [SMALL_STATE(1616)] = 38522,
  [SMALL_STATE(1617)] = 38532,
  [SMALL_STATE(1618)] = 38540,
  [SMALL_STATE(1619)] = 38550,
  [SMALL_STATE(1620)] = 38560,
  [SMALL_STATE(1621)] = 38568,
  [SMALL_STATE(1622)] = 38576,
  [SMALL_STATE(1623)] = 38586,
  [SMALL_STATE(1624)] = 38594,
  [SMALL_STATE(1625)] = 38602,
  [SMALL_STATE(1626)] = 38610,
  [SMALL_STATE(1627)] = 38620,
  [SMALL_STATE(1628)] = 38630,
  [SMALL_STATE(1629)] = 38640,
  [SMALL_STATE(1630)] = 38648,
  [SMALL_STATE(1631)] = 38658,
  [SMALL_STATE(1632)] = 38668,
  [SMALL_STATE(1633)] = 38676,
  [SMALL_STATE(1634)] = 38684,
  [SMALL_STATE(1635)] = 38692,
  [SMALL_STATE(1636)] = 38702,
  [SMALL_STATE(1637)] = 38710,
  [SMALL_STATE(1638)] = 38718,
  [SMALL_STATE(1639)] = 38726,
  [SMALL_STATE(1640)] = 38734,
  [SMALL_STATE(1641)] = 38742,
  [SMALL_STATE(1642)] = 38750,
  [SMALL_STATE(1643)] = 38758,
  [SMALL_STATE(1644)] = 38766,
  [SMALL_STATE(1645)] = 38774,
  [SMALL_STATE(1646)] = 38784,
  [SMALL_STATE(1647)] = 38792,
  [SMALL_STATE(1648)] = 38800,
  [SMALL_STATE(1649)] = 38808,
  [SMALL_STATE(1650)] = 38816,
  [SMALL_STATE(1651)] = 38826,
  [SMALL_STATE(1652)] = 38834,
  [SMALL_STATE(1653)] = 38842,
  [SMALL_STATE(1654)] = 38850,
  [SMALL_STATE(1655)] = 38860,
  [SMALL_STATE(1656)] = 38868,
  [SMALL_STATE(1657)] = 38876,
  [SMALL_STATE(1658)] = 38884,
  [SMALL_STATE(1659)] = 38894,
  [SMALL_STATE(1660)] = 38902,
  [SMALL_STATE(1661)] = 38910,
  [SMALL_STATE(1662)] = 38918,
  [SMALL_STATE(1663)] = 38926,
  [SMALL_STATE(1664)] = 38936,
  [SMALL_STATE(1665)] = 38944,
  [SMALL_STATE(1666)] = 38952,
  [SMALL_STATE(1667)] = 38960,
  [SMALL_STATE(1668)] = 38968,
  [SMALL_STATE(1669)] = 38978,
  [SMALL_STATE(1670)] = 38988,
  [SMALL_STATE(1671)] = 38996,
  [SMALL_STATE(1672)] = 39004,
  [SMALL_STATE(1673)] = 39011,
  [SMALL_STATE(1674)] = 39018,
  [SMALL_STATE(1675)] = 39025,
  [SMALL_STATE(1676)] = 39032,
  [SMALL_STATE(1677)] = 39039,
  [SMALL_STATE(1678)] = 39046,
  [SMALL_STATE(1679)] = 39053,
  [SMALL_STATE(1680)] = 39060,
  [SMALL_STATE(1681)] = 39067,
  [SMALL_STATE(1682)] = 39074,
  [SMALL_STATE(1683)] = 39081,
  [SMALL_STATE(1684)] = 39088,
  [SMALL_STATE(1685)] = 39095,
  [SMALL_STATE(1686)] = 39102,
  [SMALL_STATE(1687)] = 39109,
  [SMALL_STATE(1688)] = 39116,
  [SMALL_STATE(1689)] = 39123,
  [SMALL_STATE(1690)] = 39130,
  [SMALL_STATE(1691)] = 39137,
  [SMALL_STATE(1692)] = 39144,
  [SMALL_STATE(1693)] = 39151,
  [SMALL_STATE(1694)] = 39158,
  [SMALL_STATE(1695)] = 39165,
  [SMALL_STATE(1696)] = 39172,
  [SMALL_STATE(1697)] = 39179,
  [SMALL_STATE(1698)] = 39186,
  [SMALL_STATE(1699)] = 39193,
  [SMALL_STATE(1700)] = 39200,
  [SMALL_STATE(1701)] = 39207,
  [SMALL_STATE(1702)] = 39214,
  [SMALL_STATE(1703)] = 39221,
  [SMALL_STATE(1704)] = 39228,
  [SMALL_STATE(1705)] = 39235,
  [SMALL_STATE(1706)] = 39242,
  [SMALL_STATE(1707)] = 39249,
  [SMALL_STATE(1708)] = 39256,
  [SMALL_STATE(1709)] = 39263,
  [SMALL_STATE(1710)] = 39270,
  [SMALL_STATE(1711)] = 39277,
  [SMALL_STATE(1712)] = 39284,
  [SMALL_STATE(1713)] = 39291,
  [SMALL_STATE(1714)] = 39298,
  [SMALL_STATE(1715)] = 39305,
  [SMALL_STATE(1716)] = 39312,
  [SMALL_STATE(1717)] = 39319,
  [SMALL_STATE(1718)] = 39326,
  [SMALL_STATE(1719)] = 39333,
  [SMALL_STATE(1720)] = 39340,
  [SMALL_STATE(1721)] = 39347,
  [SMALL_STATE(1722)] = 39354,
  [SMALL_STATE(1723)] = 39361,
  [SMALL_STATE(1724)] = 39368,
  [SMALL_STATE(1725)] = 39375,
  [SMALL_STATE(1726)] = 39382,
  [SMALL_STATE(1727)] = 39389,
  [SMALL_STATE(1728)] = 39396,
  [SMALL_STATE(1729)] = 39403,
  [SMALL_STATE(1730)] = 39410,
  [SMALL_STATE(1731)] = 39417,
  [SMALL_STATE(1732)] = 39424,
  [SMALL_STATE(1733)] = 39431,
  [SMALL_STATE(1734)] = 39438,
  [SMALL_STATE(1735)] = 39445,
  [SMALL_STATE(1736)] = 39452,
  [SMALL_STATE(1737)] = 39459,
  [SMALL_STATE(1738)] = 39466,
  [SMALL_STATE(1739)] = 39473,
  [SMALL_STATE(1740)] = 39480,
  [SMALL_STATE(1741)] = 39487,
  [SMALL_STATE(1742)] = 39494,
  [SMALL_STATE(1743)] = 39501,
  [SMALL_STATE(1744)] = 39508,
  [SMALL_STATE(1745)] = 39515,
  [SMALL_STATE(1746)] = 39522,
  [SMALL_STATE(1747)] = 39529,
  [SMALL_STATE(1748)] = 39536,
  [SMALL_STATE(1749)] = 39543,
  [SMALL_STATE(1750)] = 39550,
  [SMALL_STATE(1751)] = 39557,
  [SMALL_STATE(1752)] = 39564,
  [SMALL_STATE(1753)] = 39571,
  [SMALL_STATE(1754)] = 39578,
  [SMALL_STATE(1755)] = 39585,
  [SMALL_STATE(1756)] = 39592,
  [SMALL_STATE(1757)] = 39599,
  [SMALL_STATE(1758)] = 39606,
  [SMALL_STATE(1759)] = 39613,
  [SMALL_STATE(1760)] = 39620,
  [SMALL_STATE(1761)] = 39627,
  [SMALL_STATE(1762)] = 39634,
  [SMALL_STATE(1763)] = 39641,
  [SMALL_STATE(1764)] = 39648,
  [SMALL_STATE(1765)] = 39655,
  [SMALL_STATE(1766)] = 39662,
  [SMALL_STATE(1767)] = 39669,
  [SMALL_STATE(1768)] = 39676,
  [SMALL_STATE(1769)] = 39683,
  [SMALL_STATE(1770)] = 39690,
  [SMALL_STATE(1771)] = 39697,
  [SMALL_STATE(1772)] = 39704,
  [SMALL_STATE(1773)] = 39711,
  [SMALL_STATE(1774)] = 39718,
  [SMALL_STATE(1775)] = 39725,
  [SMALL_STATE(1776)] = 39732,
  [SMALL_STATE(1777)] = 39739,
  [SMALL_STATE(1778)] = 39746,
  [SMALL_STATE(1779)] = 39753,
  [SMALL_STATE(1780)] = 39760,
  [SMALL_STATE(1781)] = 39767,
  [SMALL_STATE(1782)] = 39774,
  [SMALL_STATE(1783)] = 39781,
  [SMALL_STATE(1784)] = 39788,
  [SMALL_STATE(1785)] = 39795,
  [SMALL_STATE(1786)] = 39802,
  [SMALL_STATE(1787)] = 39809,
  [SMALL_STATE(1788)] = 39816,
  [SMALL_STATE(1789)] = 39823,
  [SMALL_STATE(1790)] = 39830,
  [SMALL_STATE(1791)] = 39837,
  [SMALL_STATE(1792)] = 39844,
  [SMALL_STATE(1793)] = 39851,
  [SMALL_STATE(1794)] = 39858,
  [SMALL_STATE(1795)] = 39865,
  [SMALL_STATE(1796)] = 39872,
  [SMALL_STATE(1797)] = 39879,
  [SMALL_STATE(1798)] = 39886,
  [SMALL_STATE(1799)] = 39893,
  [SMALL_STATE(1800)] = 39900,
  [SMALL_STATE(1801)] = 39907,
  [SMALL_STATE(1802)] = 39914,
  [SMALL_STATE(1803)] = 39921,
  [SMALL_STATE(1804)] = 39928,
  [SMALL_STATE(1805)] = 39935,
  [SMALL_STATE(1806)] = 39942,
  [SMALL_STATE(1807)] = 39949,
  [SMALL_STATE(1808)] = 39956,
  [SMALL_STATE(1809)] = 39963,
  [SMALL_STATE(1810)] = 39970,
  [SMALL_STATE(1811)] = 39977,
  [SMALL_STATE(1812)] = 39984,
  [SMALL_STATE(1813)] = 39991,
  [SMALL_STATE(1814)] = 39998,
  [SMALL_STATE(1815)] = 40005,
  [SMALL_STATE(1816)] = 40012,
  [SMALL_STATE(1817)] = 40019,
  [SMALL_STATE(1818)] = 40026,
  [SMALL_STATE(1819)] = 40033,
  [SMALL_STATE(1820)] = 40040,
  [SMALL_STATE(1821)] = 40047,
  [SMALL_STATE(1822)] = 40054,
  [SMALL_STATE(1823)] = 40061,
  [SMALL_STATE(1824)] = 40068,
  [SMALL_STATE(1825)] = 40075,
  [SMALL_STATE(1826)] = 40082,
  [SMALL_STATE(1827)] = 40089,
  [SMALL_STATE(1828)] = 40096,
  [SMALL_STATE(1829)] = 40103,
  [SMALL_STATE(1830)] = 40110,
  [SMALL_STATE(1831)] = 40117,
  [SMALL_STATE(1832)] = 40124,
  [SMALL_STATE(1833)] = 40131,
  [SMALL_STATE(1834)] = 40138,
  [SMALL_STATE(1835)] = 40145,
  [SMALL_STATE(1836)] = 40152,
  [SMALL_STATE(1837)] = 40159,
  [SMALL_STATE(1838)] = 40166,
  [SMALL_STATE(1839)] = 40173,
  [SMALL_STATE(1840)] = 40180,
  [SMALL_STATE(1841)] = 40187,
  [SMALL_STATE(1842)] = 40194,
  [SMALL_STATE(1843)] = 40201,
  [SMALL_STATE(1844)] = 40208,
  [SMALL_STATE(1845)] = 40215,
  [SMALL_STATE(1846)] = 40222,
  [SMALL_STATE(1847)] = 40229,
  [SMALL_STATE(1848)] = 40236,
  [SMALL_STATE(1849)] = 40243,
  [SMALL_STATE(1850)] = 40250,
  [SMALL_STATE(1851)] = 40257,
  [SMALL_STATE(1852)] = 40264,
  [SMALL_STATE(1853)] = 40271,
  [SMALL_STATE(1854)] = 40278,
  [SMALL_STATE(1855)] = 40285,
  [SMALL_STATE(1856)] = 40292,
  [SMALL_STATE(1857)] = 40299,
  [SMALL_STATE(1858)] = 40306,
  [SMALL_STATE(1859)] = 40313,
  [SMALL_STATE(1860)] = 40320,
  [SMALL_STATE(1861)] = 40327,
  [SMALL_STATE(1862)] = 40334,
  [SMALL_STATE(1863)] = 40341,
  [SMALL_STATE(1864)] = 40348,
  [SMALL_STATE(1865)] = 40355,
  [SMALL_STATE(1866)] = 40362,
  [SMALL_STATE(1867)] = 40369,
  [SMALL_STATE(1868)] = 40376,
  [SMALL_STATE(1869)] = 40383,
  [SMALL_STATE(1870)] = 40390,
  [SMALL_STATE(1871)] = 40397,
  [SMALL_STATE(1872)] = 40404,
  [SMALL_STATE(1873)] = 40411,
  [SMALL_STATE(1874)] = 40418,
  [SMALL_STATE(1875)] = 40425,
  [SMALL_STATE(1876)] = 40432,
  [SMALL_STATE(1877)] = 40439,
  [SMALL_STATE(1878)] = 40446,
  [SMALL_STATE(1879)] = 40453,
  [SMALL_STATE(1880)] = 40460,
  [SMALL_STATE(1881)] = 40467,
  [SMALL_STATE(1882)] = 40474,
  [SMALL_STATE(1883)] = 40481,
  [SMALL_STATE(1884)] = 40488,
  [SMALL_STATE(1885)] = 40495,
  [SMALL_STATE(1886)] = 40502,
  [SMALL_STATE(1887)] = 40509,
  [SMALL_STATE(1888)] = 40516,
  [SMALL_STATE(1889)] = 40523,
  [SMALL_STATE(1890)] = 40530,
  [SMALL_STATE(1891)] = 40537,
  [SMALL_STATE(1892)] = 40544,
  [SMALL_STATE(1893)] = 40551,
  [SMALL_STATE(1894)] = 40558,
  [SMALL_STATE(1895)] = 40565,
  [SMALL_STATE(1896)] = 40572,
  [SMALL_STATE(1897)] = 40579,
  [SMALL_STATE(1898)] = 40586,
  [SMALL_STATE(1899)] = 40593,
  [SMALL_STATE(1900)] = 40600,
  [SMALL_STATE(1901)] = 40607,
  [SMALL_STATE(1902)] = 40614,
  [SMALL_STATE(1903)] = 40621,
  [SMALL_STATE(1904)] = 40628,
  [SMALL_STATE(1905)] = 40635,
  [SMALL_STATE(1906)] = 40642,
  [SMALL_STATE(1907)] = 40649,
  [SMALL_STATE(1908)] = 40656,
  [SMALL_STATE(1909)] = 40663,
  [SMALL_STATE(1910)] = 40670,
  [SMALL_STATE(1911)] = 40677,
  [SMALL_STATE(1912)] = 40684,
  [SMALL_STATE(1913)] = 40691,
  [SMALL_STATE(1914)] = 40698,
  [SMALL_STATE(1915)] = 40705,
  [SMALL_STATE(1916)] = 40712,
  [SMALL_STATE(1917)] = 40719,
  [SMALL_STATE(1918)] = 40726,
  [SMALL_STATE(1919)] = 40733,
  [SMALL_STATE(1920)] = 40740,
  [SMALL_STATE(1921)] = 40747,
  [SMALL_STATE(1922)] = 40754,
  [SMALL_STATE(1923)] = 40761,
  [SMALL_STATE(1924)] = 40768,
  [SMALL_STATE(1925)] = 40775,
  [SMALL_STATE(1926)] = 40782,
  [SMALL_STATE(1927)] = 40789,
  [SMALL_STATE(1928)] = 40796,
  [SMALL_STATE(1929)] = 40803,
  [SMALL_STATE(1930)] = 40810,
  [SMALL_STATE(1931)] = 40817,
  [SMALL_STATE(1932)] = 40824,
  [SMALL_STATE(1933)] = 40831,
  [SMALL_STATE(1934)] = 40838,
  [SMALL_STATE(1935)] = 40845,
  [SMALL_STATE(1936)] = 40852,
  [SMALL_STATE(1937)] = 40859,
  [SMALL_STATE(1938)] = 40866,
  [SMALL_STATE(1939)] = 40873,
  [SMALL_STATE(1940)] = 40880,
  [SMALL_STATE(1941)] = 40887,
  [SMALL_STATE(1942)] = 40894,
  [SMALL_STATE(1943)] = 40901,
  [SMALL_STATE(1944)] = 40908,
  [SMALL_STATE(1945)] = 40915,
  [SMALL_STATE(1946)] = 40922,
  [SMALL_STATE(1947)] = 40929,
  [SMALL_STATE(1948)] = 40936,
  [SMALL_STATE(1949)] = 40943,
  [SMALL_STATE(1950)] = 40950,
  [SMALL_STATE(1951)] = 40957,
  [SMALL_STATE(1952)] = 40964,
  [SMALL_STATE(1953)] = 40971,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [61] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1901),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 4, 0, 6),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1887),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1929),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(293),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1567),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1927),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1277),
  [151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 1, 0, 0),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(621),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return, 1, 0, 0),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 4, 0, 6),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(380),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__codeblock, 2, 0, 0),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__codeblock, 3, 0, 0),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [391] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1604),
  [394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(18),
  [397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1509),
  [400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1562),
  [403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1565),
  [406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1506),
  [409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1929),
  [412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(304),
  [418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1567),
  [421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(130),
  [424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(305),
  [427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(291),
  [433] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(306),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1927),
  [442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1241),
  [445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(336),
  [448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1924),
  [457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(616),
  [460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(615),
  [463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(131),
  [466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(343),
  [469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1922),
  [472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1205),
  [475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1277),
  [478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1284),
  [481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(996),
  [484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(581),
  [487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(487),
  [490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(597),
  [493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(595),
  [496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(594),
  [499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(593),
  [502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(591),
  [505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(590),
  [508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(589),
  [511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1901),
  [514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(1137),
  [517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(5),
  [520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(258),
  [523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(369),
  [526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(370),
  [529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(254),
  [532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(371),
  [535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_repeat2, 2, 0, 3),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package, 3, 0, 0),
  [559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package, 3, 0, 0),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_repeat2, 3, 0, 13),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1593),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1594),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(99),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1570),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1554),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_package, 2, 0, 0),
  [633] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_package, 2, 0, 0),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1572),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1574),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0),
  [669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1509),
  [672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1562),
  [675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1565),
  [678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1506),
  [681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1929),
  [684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(304),
  [690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1567),
  [693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(130),
  [696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(305),
  [699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [702] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(291),
  [705] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(306),
  [708] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1927),
  [714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1241),
  [717] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(336),
  [720] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1924),
  [729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(616),
  [732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(615),
  [735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(131),
  [738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(343),
  [741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1922),
  [744] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1205),
  [747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1277),
  [750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1284),
  [753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(996),
  [756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(581),
  [759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(487),
  [762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(597),
  [765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(595),
  [768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(594),
  [771] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(593),
  [774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(591),
  [777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(590),
  [780] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(589),
  [783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1901),
  [786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(1137),
  [789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(5),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(258),
  [795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(369),
  [798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(370),
  [801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(254),
  [804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_package_repeat1, 2, 0, 0), SHIFT_REPEAT(371),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1632),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1573),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1568),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif, 3, 0, 10),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fragment, 1, 0, 0),
  [957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fragment, 1, 0, 0),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(223),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally, 1, 0, 0),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0),
  [1017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1509),
  [1020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1562),
  [1023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1565),
  [1026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1506),
  [1029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1929),
  [1032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(293),
  [1035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(304),
  [1038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1567),
  [1041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(130),
  [1044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(305),
  [1047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(129),
  [1050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(291),
  [1053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(306),
  [1056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(311),
  [1059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1927),
  [1062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1241),
  [1065] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(336),
  [1068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(338),
  [1071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [1074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1924),
  [1077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(616),
  [1080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(615),
  [1083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(131),
  [1086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(343),
  [1089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1922),
  [1092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1205),
  [1095] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1277),
  [1098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1284),
  [1101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(996),
  [1104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(581),
  [1107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(487),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(597),
  [1113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(595),
  [1116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(594),
  [1119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(593),
  [1122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(591),
  [1125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(590),
  [1128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(589),
  [1131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1901),
  [1134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(1137),
  [1137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(5),
  [1140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(258),
  [1143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(369),
  [1146] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(370),
  [1149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(254),
  [1152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0), SHIFT_REPEAT(371),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [1161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1637),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1653),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [1197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally, 3, 0, 0),
  [1199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [1201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 1, 0, 0),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [1285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [1291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [1297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [1303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [1305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(957),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [1555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [1559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [1575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [1585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [1587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [1603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [1783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [1793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__line_terminator, 2, 0, 0),
  [1795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__line_terminator, 2, 0, 0),
  [1797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue, 1, 0, 0),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [1801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_leave, 1, 0, 0),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [1805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 6, 0, 10),
  [1807] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_true, 1, 0, 0),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3, 0, 0),
  [1811] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_protect, 3, 0, 0),
  [1813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 14, 0, 0),
  [1815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 6, 0, 20),
  [1817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_leave, 6, 0, 0),
  [1819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator, 4, 0, 0),
  [1821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue, 6, 0, 0),
  [1823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_protect, 6, 0, 0),
  [1825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_leave, 4, 0, 0),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [1829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [1831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(427),
  [1839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(429),
  [1843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 3, 0, 4),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue, 4, 0, 0),
  [1847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 6, 0, 6),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lock, 4, 0, 0),
  [1851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 3, 0, 0),
  [1853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop, 3, 0, 0),
  [1855] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [1859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue, 5, 0, 0),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_leave, 5, 0, 0),
  [1863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arithmetic_operator, 3, 0, 9),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 6, 0, 10),
  [1867] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector, 3, 0, 0),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_handling, 4, 0, 10),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 7, 0, 0),
  [1873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invoke, 4, 0, 7),
  [1875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator, 9, 0, 0),
  [1877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexed_access, 4, 0, 15),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 4, 0, 10),
  [1881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 15, 0, 0),
  [1883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invoke, 3, 0, 7),
  [1885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexed_access, 3, 0, 8),
  [1887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 4, 0, 10),
  [1889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 11, 0, 0),
  [1891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 5, 0, 0),
  [1893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 4, 0, 12),
  [1895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_vector, 2, 0, 0),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_protect, 4, 0, 0),
  [1903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue, 2, 0, 0),
  [1909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 6, 0, 0),
  [1911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 13, 0, 0),
  [1913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1, 0, 0),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_leave, 2, 0, 0),
  [1917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return, 2, 0, 0),
  [1919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_leave, 3, 0, 0),
  [1921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, 0, 1),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch, 4, 0, 0),
  [1925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue, 3, 0, 0),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 4, 0, 0),
  [1929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 9, 0, 0),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2, 0, 0),
  [1933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 7, 0, 10),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator, 7, 0, 0),
  [1937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 4, 0, 14),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_literal, 2, 0, 0),
  [1941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 5, 0, 6),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_leave, 7, 0, 0),
  [1945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue, 7, 0, 0),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_protect, 7, 0, 0),
  [1949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lock, 5, 0, 0),
  [1951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_protect, 5, 0, 0),
  [1953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loopbody, 4, 0, 0),
  [1955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw, 4, 0, 0),
  [1957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 2, 0, 0),
  [1959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 16, 0, 0),
  [1961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_primitive, 2, 0, 0),
  [1963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loopbody, 5, 0, 0),
  [1965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_protect, 8, 0, 0),
  [1967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_handling, 2, 0, 0),
  [1969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop, 2, 0, 0),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1905),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [1977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__codeblock, 1, 0, 0),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [1989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 5, 0, 17),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try, 5, 0, 12),
  [1993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while, 5, 0, 10),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slot_accessor, 2, 0, 0),
  [1997] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator, 8, 0, 0),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator, 5, 0, 0),
  [2001] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 10, 0, 0),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch, 5, 0, 0),
  [2005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4, 0, 0),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_handling, 5, 0, 16),
  [2009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1, 0, 0),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 17, 0, 0),
  [2013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_loopbody_repeat1, 2, 0, 0),
  [2015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_loopbody_repeat1, 2, 0, 0), SHIFT_REPEAT(363),
  [2018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 1, 0, 0),
  [2020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_list, 2, 0, 0),
  [2022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 12, 0, 0),
  [2024] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if, 5, 0, 10),
  [2026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_procedure, 8, 0, 0),
  [2028] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_thisthread, 1, 0, 0),
  [2030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_clone, 1, 0, 0),
  [2032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_self, 1, 0, 0),
  [2034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iterator, 6, 0, 0),
  [2036] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_super, 1, 0, 0),
  [2038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unset, 1, 0, 0),
  [2040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_maybe, 1, 0, 0),
  [2042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop, 4, 0, 0),
  [2044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_false, 1, 0, 0),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [2048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [2050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [2052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [2054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [2056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gather, 2, 0, 0),
  [2058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 4, 0, 0),
  [2060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [2062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [2064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scatter, 2, 0, 0),
  [2066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_allresults, 2, 0, 0),
  [2068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, 0, 2),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [2072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw, 2, 0, 0),
  [2074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [2076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(403),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(648),
  [2082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(636),
  [2086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 3, 0, 6),
  [2088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [2090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [2092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment, 3, 0, 0),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_operator, 3, 0, 9),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_logical_operator, 3, 0, 9),
  [2098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_loopbody_repeat1, 2, 0, 0), SHIFT_REPEAT(465),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(474),
  [2103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_local_repeat1, 4, 0, 0),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [2109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 7, 0, 0),
  [2111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic, 5, 0, 0),
  [2113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 6, 0, 0),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 4, 0, 0),
  [2117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 14, 0, 0),
  [2119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 7, 0, 0),
  [2121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 5, 0, 0),
  [2123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 6, 0, 0),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic, 4, 0, 0),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1, 0, 0),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 10, 0, 0),
  [2131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 8, 0, 0),
  [2133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 9, 0, 0),
  [2135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 13, 0, 0),
  [2137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant, 5, 0, 0),
  [2139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__codeblock_repeat1, 2, 0, 0),
  [2141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 11, 0, 0),
  [2143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 12, 0, 0),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1, 0, 0),
  [2147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument, 1, 0, 0),
  [2149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_method_repeat1, 2, 0, 0),
  [2151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_method_repeat1, 2, 0, 0),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2, 0, 5),
  [2155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2, 0, 5), SHIFT_REPEAT(1353),
  [2158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_repeat1, 2, 0, 5),
  [2160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__identifier_list_repeat1, 2, 0, 0),
  [2162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__identifier_list_repeat1, 2, 0, 0),
  [2164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_repeat1, 2, 0, 3),
  [2166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_repeat1, 2, 0, 3),
  [2168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_documentation, 1, 0, 0),
  [2170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_documentation, 1, 0, 0),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [2174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_method_repeat1, 2, 0, 0), SHIFT_REPEAT(1494),
  [2177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_documentation_repeat1, 2, 0, 0),
  [2179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_documentation_repeat1, 2, 0, 0),
  [2181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_documentation_repeat1, 2, 0, 0), SHIFT_REPEAT(684),
  [2184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_fragment_repeat1, 2, 0, 0),
  [2186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1534),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_list, 1, 0, 0),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [2193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_list, 1, 0, 0),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arguments, 1, 0, 0),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arguments, 1, 0, 0),
  [2201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arguments, 2, 0, 0),
  [2203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arguments, 2, 0, 0),
  [2205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [2207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier_list, 2, 0, 0),
  [2209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier_list, 2, 0, 0),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arguments, 3, 0, 0),
  [2215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arguments, 3, 0, 0),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma, 2, 0, 0),
  [2219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pragma, 2, 0, 0),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 1, 0, 0),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [2241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_leave, 4, 0, 0),
  [2245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue, 3, 0, 0),
  [2247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_leave, 1, 0, 0),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue, 4, 0, 0),
  [2255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_loopbody_repeat1, 2, 0, 0),
  [2257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loopbody_repeat1, 2, 0, 0), SHIFT_REPEAT(384),
  [2260] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue, 1, 0, 0),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_leave, 5, 0, 0),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_leave, 3, 0, 0),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue, 5, 0, 0),
  [2272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_list, 2, 0, 0),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [2282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [2292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw, 4, 0, 0),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loopbody, 4, 0, 0),
  [2296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_true, 1, 0, 0),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_false, 1, 0, 0),
  [2300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_maybe, 1, 0, 0),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unset, 1, 0, 0),
  [2304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_super, 1, 0, 0),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self, 1, 0, 0),
  [2308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_clone, 1, 0, 0),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gather, 2, 0, 0),
  [2312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_thisthread, 1, 0, 0),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scatter, 2, 0, 0),
  [2316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_allresults, 2, 0, 0),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_protect, 4, 0, 0),
  [2320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, 0, 2),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 3, 0, 6),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [2328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lock, 4, 0, 0),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [2332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_loopbody_repeat1, 2, 0, 0), SHIFT_REPEAT(431),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invoke, 4, 0, 7),
  [2337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexed_access, 4, 0, 15),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 5, 0, 0),
  [2341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [2343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [2345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [2347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [2349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [2351] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 4, 0, 14),
  [2353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_literal, 2, 0, 0),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [2359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [2361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [2363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [2365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 3, 0, 4),
  [2367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 3, 0, 0),
  [2369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 4, 0, 12),
  [2371] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop, 3, 0, 0),
  [2373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [2375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 5, 0, 10),
  [2377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_loopbody_repeat1, 2, 0, 0), SHIFT_REPEAT(480),
  [2380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_handling, 5, 0, 16),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch, 5, 0, 0),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 4, 0, 10),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator, 5, 0, 0),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 5, 0, 10),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator, 4, 0, 0),
  [2392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 5, 0, 12),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 5, 0, 17),
  [2396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loopbody, 5, 0, 0),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3, 0, 0),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_protect, 3, 0, 0),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_handling, 4, 0, 10),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3, 0, 0),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_protect, 5, 0, 0),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_logical_operator, 3, 0, 9),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1, 0, 0),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_operator, 3, 0, 9),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, 0, 0),
  [2416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lock, 5, 0, 0),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 5, 0, 6),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 6, 0, 0),
  [2422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slot_accessor, 2, 0, 0),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch, 4, 0, 0),
  [2426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop, 4, 0, 0),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 4, 0, 10),
  [2430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue, 2, 0, 0),
  [2434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_leave, 2, 0, 0),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw, 2, 0, 0),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop, 2, 0, 0),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector, 3, 0, 0),
  [2442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 6, 0, 10),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_handling, 2, 0, 0),
  [2446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator, 6, 0, 0),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while, 6, 0, 10),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invoke, 3, 0, 7),
  [2454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, 0, 0),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexed_access, 3, 0, 8),
  [2458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 17, 0, 0),
  [2460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 16, 0, 0),
  [2462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 4, 0, 0),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 6, 0, 20),
  [2466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 15, 0, 0),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primitive, 2, 0, 0),
  [2470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_leave, 6, 0, 0),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 14, 0, 0),
  [2474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try, 2, 0, 0),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue, 6, 0, 0),
  [2478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_vector, 2, 0, 0),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 13, 0, 0),
  [2482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_protect, 6, 0, 0),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 6, 0, 6),
  [2486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 12, 0, 0),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 7, 0, 0),
  [2490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return, 2, 0, 0),
  [2492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [2496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [2500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [2504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 11, 0, 0),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, 0, 1),
  [2510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 10, 0, 0),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator, 9, 0, 0),
  [2514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2, 0, 0),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 9, 0, 0),
  [2518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arithmetic_operator, 3, 0, 9),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_protect, 8, 0, 0),
  [2522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator, 8, 0, 0),
  [2524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_procedure, 8, 0, 0),
  [2526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_protect, 7, 0, 0),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue, 7, 0, 0),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_leave, 7, 0, 0),
  [2534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iterator, 7, 0, 0),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if, 7, 0, 10),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(443),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [2546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(437),
  [2550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(430),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [2556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [2558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(432),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [2562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [2566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_loopbody_repeat1, 2, 0, 0), SHIFT_REPEAT(430),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(331),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [2593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(473),
  [2615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [2617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [2619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [2623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [2629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [2631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [2641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__global_assignment, 6, 0, 0),
  [2651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__top_level_statement, 1, 0, 0),
  [2653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__global_assignment, 4, 0, 0),
  [2655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__definition, 2, 0, 0),
  [2657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_handling_repeat1, 2, 0, 10),
  [2661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_local_repeat1, 4, 0, 0),
  [2663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__definition, 3, 0, 0),
  [2665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__global_assignment, 5, 0, 0),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1431),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dynamic_repeat1, 2, 0, 0),
  [2711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dynamic_repeat1, 2, 0, 0), SHIFT_REPEAT(1750),
  [2714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 3, 0, 0),
  [2716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [2718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global, 3, 0, 0),
  [2720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [2722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global, 2, 0, 0),
  [2724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_import, 3, 0, 0),
  [2726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [2728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic, 3, 0, 0),
  [2730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [2732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [2734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__codeblock, 2, 0, 0),
  [2736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [2738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__codeblock_repeat1, 2, 0, 0), SHIFT_REPEAT(1905),
  [2741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__codeblock_repeat1, 2, 0, 0), SHIFT_REPEAT(245),
  [2744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__identifier_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1490),
  [2747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local, 2, 0, 0),
  [2749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_global_repeat1, 2, 0, 0),
  [2753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_global_repeat1, 2, 0, 0), SHIFT_REPEAT(1172),
  [2756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic, 2, 0, 0),
  [2758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [2760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_local_repeat1, 2, 0, 0),
  [2762] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_local_repeat1, 2, 0, 0), SHIFT_REPEAT(1393),
  [2765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_import, 4, 0, 0),
  [2767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [2769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_local_repeat1, 2, 0, 0), SHIFT_REPEAT(455),
  [2772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [2774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(435),
  [2780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 2, 0, 0),
  [2782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [2784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [2786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [2790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [2792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__codeblock_repeat1, 2, 0, 0), SHIFT_REPEAT(246),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [2815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [2817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [2819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [2821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [2849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [2851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1669),
  [2855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [2859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [2861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(377),
  [2863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_local_repeat1, 2, 0, 0), SHIFT_REPEAT(1438),
  [2866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [2868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [2870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1312),
  [2872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [2874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [2882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [2886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [2888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [2890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [2900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [2902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [2904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1270),
  [2906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [2916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [2920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1330),
  [2922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [2932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [2936] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_local_repeat1, 2, 0, 0), SHIFT_REPEAT(469),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_method_repeat1, 2, 0, 0), SHIFT_REPEAT(1433),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [2950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [2952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [2954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [2958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [2964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [2966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1257),
  [2968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [2970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [2972] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [2974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [2976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [2978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [2980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [2982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [2986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [2988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [2992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [2994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [2996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [3002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [3004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [3008] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [3018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [3038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [3040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1307),
  [3044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [3046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [3048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [3050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [3052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [3054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [3056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [3058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [3062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [3064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [3066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1206),
  [3068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [3070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [3072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [3076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [3078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [3080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [3082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1320),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [3096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [3098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [3100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [3102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [3116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(662),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1338),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [3130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [3132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [3134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [3142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [3150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [3152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_repeat1, 2, 0, 0),
  [3154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_repeat1, 2, 0, 0), SHIFT_REPEAT(312),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [3159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [3161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [3163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [3165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [3175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1305),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1278),
  [3185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [3187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [3189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [3191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [3195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [3199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [3203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [3205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [3207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1272),
  [3221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [3223] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__identifier_list_repeat1, 2, 0, 0), SHIFT_REPEAT(1540),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [3228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [3232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [3234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [3240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [3242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [3252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [3260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1326),
  [3262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1331),
  [3266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [3268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [3270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [3272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [3282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [3284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1224),
  [3286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [3288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [3294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [3296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [3300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [3302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1204),
  [3304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [3306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [3308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [3310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [3314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [3316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1301),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [3320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(549),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [3326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [3330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0),
  [3332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(1226),
  [3335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [3337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat2, 2, 0, 0), SHIFT_REPEAT(1230),
  [3340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat2, 2, 0, 0),
  [3342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [3346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [3350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [3352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [3358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [3360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [3362] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_method_repeat1, 2, 0, 0), SHIFT_REPEAT(1446),
  [3365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [3369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [3371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1309),
  [3373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [3375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [3377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [3379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [3381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1306),
  [3383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [3387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [3389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [3393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [3395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [3397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [3399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [3401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [3403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [3405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [3407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [3409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [3411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [3413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [3415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [3417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1429),
  [3421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [3423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1751),
  [3433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [3435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [3441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [3443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_handling_repeat1, 2, 0, 11), SHIFT_REPEAT(389),
  [3448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_handling_repeat1, 2, 0, 11),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1455),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1854),
  [3466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [3472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [3474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [3508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [3512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [3518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [3520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1943),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [3536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [3538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_local_repeat1, 2, 0, 0), SHIFT_REPEAT(1528),
  [3541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_local_repeat1, 2, 0, 0),
  [3543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1946),
  [3545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [3547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [3553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [3565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [3567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [3571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [3577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [3579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [3585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1587),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [3597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1717),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [3603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [3605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [3607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [3609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [3615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [3617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [3619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [3621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [3623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [3625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [3629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [3631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_try_repeat2, 2, 0, 5), SHIFT_REPEAT(1341),
  [3638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_repeat2, 2, 0, 5),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [3646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [3650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif, 4, 0, 10),
  [3652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 11, 0, 18),
  [3654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_repeat2, 4, 0, 13),
  [3656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 18, 0, 25),
  [3658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 18, 0, 21),
  [3660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 17, 0, 18),
  [3662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 18, 0, 18),
  [3664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 19, 0, 25),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 7, 0, 19),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [3674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 7, 0, 18),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [3680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 17, 0, 21),
  [3682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 19, 0, 23),
  [3684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 19, 0, 21),
  [3686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 19, 0, 18),
  [3688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 20, 0, 25),
  [3690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 17, 0, 23),
  [3692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 20, 0, 23),
  [3694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 8, 0, 23),
  [3696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 20, 0, 21),
  [3698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 20, 0, 18),
  [3700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 21, 0, 25),
  [3702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 8, 0, 24),
  [3704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 21, 0, 23),
  [3706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 21, 0, 21),
  [3708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 22, 0, 25),
  [3710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 22, 0, 23),
  [3712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 23, 0, 25),
  [3714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 17, 0, 25),
  [3716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 16, 0, 18),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1894),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [3734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 8, 0, 21),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [3740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 16, 0, 21),
  [3742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 16, 0, 23),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [3748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 8, 0, 22),
  [3750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 16, 0, 25),
  [3752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 15, 0, 18),
  [3754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 15, 0, 21),
  [3756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 7, 0, 22),
  [3758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 15, 0, 23),
  [3760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__method_declaration, 2, 0, 0),
  [3762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 15, 0, 25),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [3770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 14, 0, 18),
  [3772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 7, 0, 21),
  [3774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 14, 0, 21),
  [3776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 14, 0, 23),
  [3778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 14, 0, 26),
  [3780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 14, 0, 25),
  [3782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 18, 0, 23),
  [3784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 13, 0, 18),
  [3786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 13, 0, 21),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 13, 0, 24),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [3798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 8, 0, 18),
  [3800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 13, 0, 23),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [3804] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 13, 0, 26),
  [3806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 8, 0, 19),
  [3808] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 13, 0, 25),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [3818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 12, 0, 18),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [3822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 12, 0, 25),
  [3824] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 12, 0, 22),
  [3826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 9, 0, 25),
  [3828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 12, 0, 21),
  [3830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 12, 0, 24),
  [3832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 9, 0, 26),
  [3834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 12, 0, 23),
  [3836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 12, 0, 26),
  [3838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 11, 0, 19),
  [3840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 11, 0, 22),
  [3842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 11, 0, 21),
  [3844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 9, 0, 23),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [3848] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 9, 0, 24),
  [3850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 11, 0, 24),
  [3852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 11, 0, 23),
  [3854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_repeat2, 3, 0, 3),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [3860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 11, 0, 26),
  [3862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 11, 0, 25),
  [3864] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 10, 0, 19),
  [3866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 10, 0, 18),
  [3868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 9, 0, 21),
  [3870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 10, 0, 22),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [3874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 6, 0, 19),
  [3876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 9, 0, 22),
  [3878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 10, 0, 21),
  [3880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 6, 0, 18),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [3884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 10, 0, 24),
  [3886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 10, 0, 23),
  [3888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 10, 0, 26),
  [3890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 10, 0, 25),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 9, 0, 19),
  [3896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method, 9, 0, 18),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [3910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally, 2, 0, 0),
  [3912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else, 2, 0, 0),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [4008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [4014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [4064] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [4072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [4082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1581),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [4100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [4102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [4104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [4106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [4108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [4112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally, 4, 0, 0),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_magik(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
