#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 1266
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 77
#define ALIAS_COUNT 0
#define TOKEN_COUNT 45
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 11
#define MAX_ALIAS_SEQUENCE_LENGTH 7
#define PRODUCTION_ID_COUNT 32

enum ts_symbol_identifiers {
  anon_sym_LPAREN = 1,
  anon_sym_COMMA = 2,
  anon_sym_RPAREN = 3,
  anon_sym_true = 4,
  anon_sym_false = 5,
  anon_sym_SQUOTE = 6,
  aux_sym_string_token1 = 7,
  anon_sym_SQUOTE_SQUOTE_SQUOTE = 8,
  aux_sym_string_token2 = 9,
  sym_escape_sequence = 10,
  anon_sym_AT = 11,
  anon_sym_LBRACE = 12,
  anon_sym_RBRACE = 13,
  anon_sym_LBRACK = 14,
  anon_sym_RBRACK = 15,
  anon_sym_COLON = 16,
  sym_identifier = 17,
  sym_number = 18,
  anon_sym_EQ = 19,
  anon_sym_PLUS_EQ = 20,
  anon_sym_DASH_EQ = 21,
  anon_sym_SLASH_EQ = 22,
  anon_sym_SLASH = 23,
  anon_sym_PLUS = 24,
  anon_sym_QMARK = 25,
  anon_sym_not = 26,
  anon_sym_EQ_EQ = 27,
  anon_sym_BANG_EQ = 28,
  anon_sym_GT_EQ = 29,
  anon_sym_GT = 30,
  anon_sym_LT = 31,
  anon_sym_and = 32,
  anon_sym_or = 33,
  anon_sym_in = 34,
  anon_sym_DOT = 35,
  anon_sym_endif = 36,
  anon_sym_if = 37,
  anon_sym_elif = 38,
  anon_sym_else = 39,
  anon_sym_foreach = 40,
  anon_sym_endforeach = 41,
  sym_keyword_break = 42,
  sym_keyword_continue = 43,
  sym_comment = 44,
  sym_source_file = 45,
  sym__unit = 46,
  sym_normal_command = 47,
  sym_bool = 48,
  sym_string = 49,
  sym_formatunit = 50,
  sym_dictionaries = 51,
  sym_listitem = 52,
  sym_list = 53,
  sym_pair = 54,
  sym_operatorunit = 55,
  sym_variableunit = 56,
  sym_ternaryoperator = 57,
  sym__logic_unit = 58,
  sym_var_unit = 59,
  sym_expression_statement = 60,
  sym_if_condition = 61,
  sym_if_command = 62,
  sym_elseif_command = 63,
  sym_else_command = 64,
  sym_foreach_command = 65,
  aux_sym_source_file_repeat1 = 66,
  aux_sym_normal_command_repeat1 = 67,
  aux_sym_string_repeat1 = 68,
  aux_sym_string_repeat2 = 69,
  aux_sym_dictionaries_repeat1 = 70,
  aux_sym_list_repeat1 = 71,
  aux_sym_variableunit_repeat1 = 72,
  aux_sym_var_unit_repeat1 = 73,
  aux_sym_expression_statement_repeat1 = 74,
  aux_sym_if_condition_repeat1 = 75,
  aux_sym_foreach_command_repeat1 = 76,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = "'''",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_AT] = "@",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON] = ":",
  [sym_identifier] = "identifier",
  [sym_number] = "number",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_SLASH] = "/",
  [anon_sym_PLUS] = "+",
  [anon_sym_QMARK] = "\?",
  [anon_sym_not] = "not",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT] = "<",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_in] = "in",
  [anon_sym_DOT] = ".",
  [anon_sym_endif] = "endif",
  [anon_sym_if] = "if",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_foreach] = "foreach",
  [anon_sym_endforeach] = "endforeach",
  [sym_keyword_break] = "keyword_break",
  [sym_keyword_continue] = "keyword_continue",
  [sym_comment] = "comment",
  [sym_source_file] = "source_file",
  [sym__unit] = "_unit",
  [sym_normal_command] = "normal_command",
  [sym_bool] = "bool",
  [sym_string] = "string",
  [sym_formatunit] = "formatunit",
  [sym_dictionaries] = "dictionaries",
  [sym_listitem] = "listitem",
  [sym_list] = "list",
  [sym_pair] = "pair",
  [sym_operatorunit] = "operatorunit",
  [sym_variableunit] = "variableunit",
  [sym_ternaryoperator] = "ternaryoperator",
  [sym__logic_unit] = "_logic_unit",
  [sym_var_unit] = "var_unit",
  [sym_expression_statement] = "expression_statement",
  [sym_if_condition] = "if_condition",
  [sym_if_command] = "if_command",
  [sym_elseif_command] = "elseif_command",
  [sym_else_command] = "else_command",
  [sym_foreach_command] = "foreach_command",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_normal_command_repeat1] = "normal_command_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_dictionaries_repeat1] = "dictionaries_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym_variableunit_repeat1] = "variableunit_repeat1",
  [aux_sym_var_unit_repeat1] = "var_unit_repeat1",
  [aux_sym_expression_statement_repeat1] = "expression_statement_repeat1",
  [aux_sym_if_condition_repeat1] = "if_condition_repeat1",
  [aux_sym_foreach_command_repeat1] = "foreach_command_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [sym_identifier] = sym_identifier,
  [sym_number] = sym_number,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_endif] = anon_sym_endif,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_endforeach] = anon_sym_endforeach,
  [sym_keyword_break] = sym_keyword_break,
  [sym_keyword_continue] = sym_keyword_continue,
  [sym_comment] = sym_comment,
  [sym_source_file] = sym_source_file,
  [sym__unit] = sym__unit,
  [sym_normal_command] = sym_normal_command,
  [sym_bool] = sym_bool,
  [sym_string] = sym_string,
  [sym_formatunit] = sym_formatunit,
  [sym_dictionaries] = sym_dictionaries,
  [sym_listitem] = sym_listitem,
  [sym_list] = sym_list,
  [sym_pair] = sym_pair,
  [sym_operatorunit] = sym_operatorunit,
  [sym_variableunit] = sym_variableunit,
  [sym_ternaryoperator] = sym_ternaryoperator,
  [sym__logic_unit] = sym__logic_unit,
  [sym_var_unit] = sym_var_unit,
  [sym_expression_statement] = sym_expression_statement,
  [sym_if_condition] = sym_if_condition,
  [sym_if_command] = sym_if_command,
  [sym_elseif_command] = sym_elseif_command,
  [sym_else_command] = sym_else_command,
  [sym_foreach_command] = sym_foreach_command,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_normal_command_repeat1] = aux_sym_normal_command_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_dictionaries_repeat1] = aux_sym_dictionaries_repeat1,
  [aux_sym_list_repeat1] = aux_sym_list_repeat1,
  [aux_sym_variableunit_repeat1] = aux_sym_variableunit_repeat1,
  [aux_sym_var_unit_repeat1] = aux_sym_var_unit_repeat1,
  [aux_sym_expression_statement_repeat1] = aux_sym_expression_statement_repeat1,
  [aux_sym_if_condition_repeat1] = aux_sym_if_condition_repeat1,
  [aux_sym_foreach_command_repeat1] = aux_sym_foreach_command_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endforeach] = {
    .visible = true,
    .named = false,
  },
  [sym_keyword_break] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_continue] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__unit] = {
    .visible = false,
    .named = true,
  },
  [sym_normal_command] = {
    .visible = true,
    .named = true,
  },
  [sym_bool] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_formatunit] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionaries] = {
    .visible = true,
    .named = true,
  },
  [sym_listitem] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_operatorunit] = {
    .visible = true,
    .named = true,
  },
  [sym_variableunit] = {
    .visible = true,
    .named = true,
  },
  [sym_ternaryoperator] = {
    .visible = true,
    .named = true,
  },
  [sym__logic_unit] = {
    .visible = false,
    .named = true,
  },
  [sym_var_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_condition] = {
    .visible = true,
    .named = true,
  },
  [sym_if_command] = {
    .visible = true,
    .named = true,
  },
  [sym_elseif_command] = {
    .visible = true,
    .named = true,
  },
  [sym_else_command] = {
    .visible = true,
    .named = true,
  },
  [sym_foreach_command] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_normal_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionaries_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variableunit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_var_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expression_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_condition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_foreach_command_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_array = 1,
  field_command = 2,
  field_dictionaries = 3,
  field_function = 4,
  field_index = 5,
  field_item = 6,
  field_key = 7,
  field_object = 8,
  field_property = 9,
  field_value = 10,
  field_variable = 11,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_array] = "array",
  [field_command] = "command",
  [field_dictionaries] = "dictionaries",
  [field_function] = "function",
  [field_index] = "index",
  [field_item] = "item",
  [field_key] = "key",
  [field_object] = "object",
  [field_property] = "property",
  [field_value] = "value",
  [field_variable] = "variable",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 5},
  [2] = {.index = 5, .length = 1},
  [3] = {.index = 6, .length = 1},
  [4] = {.index = 7, .length = 5},
  [5] = {.index = 12, .length = 1},
  [6] = {.index = 13, .length = 1},
  [7] = {.index = 14, .length = 1},
  [8] = {.index = 15, .length = 1},
  [9] = {.index = 16, .length = 8},
  [10] = {.index = 24, .length = 1},
  [11] = {.index = 25, .length = 2},
  [12] = {.index = 27, .length = 1},
  [13] = {.index = 28, .length = 2},
  [14] = {.index = 30, .length = 1},
  [15] = {.index = 31, .length = 1},
  [16] = {.index = 32, .length = 1},
  [17] = {.index = 33, .length = 1},
  [18] = {.index = 34, .length = 2},
  [19] = {.index = 36, .length = 2},
  [20] = {.index = 38, .length = 1},
  [21] = {.index = 39, .length = 2},
  [22] = {.index = 41, .length = 2},
  [23] = {.index = 43, .length = 1},
  [24] = {.index = 44, .length = 2},
  [25] = {.index = 46, .length = 2},
  [26] = {.index = 48, .length = 2},
  [27] = {.index = 50, .length = 4},
  [28] = {.index = 54, .length = 4},
  [29] = {.index = 58, .length = 4},
  [30] = {.index = 62, .length = 3},
  [31] = {.index = 65, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_function, 1, .inherited = true},
    {field_index, 1, .inherited = true},
    {field_object, 0},
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [5] =
    {field_value, 0},
  [6] =
    {field_value, 0, .inherited = true},
  [7] =
    {field_function, 0},
    {field_function, 1, .inherited = true},
    {field_index, 1, .inherited = true},
    {field_object, 1, .inherited = true},
    {field_property, 1, .inherited = true},
  [12] =
    {field_command, 0},
  [13] =
    {field_property, 1},
  [14] =
    {field_function, 1},
  [15] =
    {field_object, 1},
  [16] =
    {field_function, 0, .inherited = true},
    {field_function, 1, .inherited = true},
    {field_index, 0, .inherited = true},
    {field_index, 1, .inherited = true},
    {field_object, 0, .inherited = true},
    {field_object, 1, .inherited = true},
    {field_property, 0, .inherited = true},
    {field_property, 1, .inherited = true},
  [24] =
    {field_value, 1, .inherited = true},
  [25] =
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [27] =
    {field_variable, 1},
  [28] =
    {field_value, 0},
    {field_value, 1, .inherited = true},
  [30] =
    {field_index, 2},
  [31] =
    {field_key, 2},
  [32] =
    {field_variable, 0},
  [33] =
    {field_variable, 1, .inherited = true},
  [34] =
    {field_variable, 0, .inherited = true},
    {field_variable, 1, .inherited = true},
  [36] =
    {field_value, 0, .inherited = true},
    {field_value, 2, .inherited = true},
  [38] =
    {field_item, 1},
  [39] =
    {field_item, 0, .inherited = true},
    {field_item, 1, .inherited = true},
  [41] =
    {field_key, 0},
    {field_value, 2},
  [43] =
    {field_value, 1},
  [44] =
    {field_variable, 1, .inherited = true},
    {field_variable, 2},
  [46] =
    {field_array, 3},
    {field_item, 1},
  [48] =
    {field_dictionaries, 3},
    {field_item, 1},
  [50] =
    {field_index, 2},
    {field_index, 3},
    {field_index, 4},
    {field_property, 1},
  [54] =
    {field_function, 1},
    {field_index, 2},
    {field_index, 3},
    {field_index, 4},
  [58] =
    {field_index, 2},
    {field_index, 3},
    {field_index, 4},
    {field_object, 1},
  [62] =
    {field_array, 4},
    {field_item, 1},
    {field_item, 2, .inherited = true},
  [65] =
    {field_dictionaries, 4},
    {field_item, 1},
    {field_item, 2, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 3,
  [5] = 5,
  [6] = 5,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 7,
  [15] = 15,
  [16] = 15,
  [17] = 17,
  [18] = 18,
  [19] = 17,
  [20] = 17,
  [21] = 17,
  [22] = 22,
  [23] = 11,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 17,
  [29] = 29,
  [30] = 30,
  [31] = 17,
  [32] = 17,
  [33] = 10,
  [34] = 17,
  [35] = 29,
  [36] = 9,
  [37] = 22,
  [38] = 8,
  [39] = 39,
  [40] = 17,
  [41] = 41,
  [42] = 42,
  [43] = 2,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 46,
  [49] = 46,
  [50] = 46,
  [51] = 46,
  [52] = 46,
  [53] = 46,
  [54] = 46,
  [55] = 46,
  [56] = 2,
  [57] = 2,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 3,
  [63] = 3,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 3,
  [68] = 60,
  [69] = 3,
  [70] = 60,
  [71] = 71,
  [72] = 72,
  [73] = 61,
  [74] = 74,
  [75] = 75,
  [76] = 3,
  [77] = 77,
  [78] = 78,
  [79] = 61,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 71,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 60,
  [88] = 61,
  [89] = 3,
  [90] = 61,
  [91] = 91,
  [92] = 60,
  [93] = 71,
  [94] = 71,
  [95] = 9,
  [96] = 13,
  [97] = 8,
  [98] = 7,
  [99] = 5,
  [100] = 13,
  [101] = 10,
  [102] = 7,
  [103] = 15,
  [104] = 5,
  [105] = 15,
  [106] = 15,
  [107] = 12,
  [108] = 11,
  [109] = 7,
  [110] = 5,
  [111] = 11,
  [112] = 112,
  [113] = 7,
  [114] = 13,
  [115] = 8,
  [116] = 9,
  [117] = 10,
  [118] = 12,
  [119] = 5,
  [120] = 12,
  [121] = 9,
  [122] = 5,
  [123] = 7,
  [124] = 5,
  [125] = 8,
  [126] = 7,
  [127] = 11,
  [128] = 10,
  [129] = 30,
  [130] = 130,
  [131] = 26,
  [132] = 39,
  [133] = 133,
  [134] = 22,
  [135] = 15,
  [136] = 29,
  [137] = 30,
  [138] = 29,
  [139] = 25,
  [140] = 22,
  [141] = 29,
  [142] = 8,
  [143] = 9,
  [144] = 10,
  [145] = 22,
  [146] = 11,
  [147] = 29,
  [148] = 3,
  [149] = 22,
  [150] = 27,
  [151] = 151,
  [152] = 8,
  [153] = 9,
  [154] = 10,
  [155] = 22,
  [156] = 11,
  [157] = 29,
  [158] = 27,
  [159] = 159,
  [160] = 25,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 41,
  [165] = 42,
  [166] = 11,
  [167] = 167,
  [168] = 18,
  [169] = 24,
  [170] = 10,
  [171] = 15,
  [172] = 26,
  [173] = 41,
  [174] = 42,
  [175] = 3,
  [176] = 176,
  [177] = 39,
  [178] = 27,
  [179] = 25,
  [180] = 22,
  [181] = 181,
  [182] = 18,
  [183] = 41,
  [184] = 26,
  [185] = 9,
  [186] = 42,
  [187] = 8,
  [188] = 18,
  [189] = 39,
  [190] = 190,
  [191] = 24,
  [192] = 192,
  [193] = 24,
  [194] = 29,
  [195] = 15,
  [196] = 30,
  [197] = 45,
  [198] = 198,
  [199] = 199,
  [200] = 10,
  [201] = 9,
  [202] = 8,
  [203] = 7,
  [204] = 5,
  [205] = 58,
  [206] = 47,
  [207] = 47,
  [208] = 15,
  [209] = 11,
  [210] = 45,
  [211] = 47,
  [212] = 7,
  [213] = 58,
  [214] = 58,
  [215] = 5,
  [216] = 45,
  [217] = 65,
  [218] = 218,
  [219] = 85,
  [220] = 218,
  [221] = 25,
  [222] = 222,
  [223] = 27,
  [224] = 218,
  [225] = 10,
  [226] = 75,
  [227] = 77,
  [228] = 78,
  [229] = 80,
  [230] = 81,
  [231] = 82,
  [232] = 59,
  [233] = 86,
  [234] = 66,
  [235] = 235,
  [236] = 64,
  [237] = 235,
  [238] = 238,
  [239] = 222,
  [240] = 72,
  [241] = 235,
  [242] = 222,
  [243] = 243,
  [244] = 74,
  [245] = 84,
  [246] = 218,
  [247] = 238,
  [248] = 11,
  [249] = 222,
  [250] = 250,
  [251] = 64,
  [252] = 65,
  [253] = 85,
  [254] = 66,
  [255] = 222,
  [256] = 39,
  [257] = 86,
  [258] = 258,
  [259] = 59,
  [260] = 218,
  [261] = 218,
  [262] = 222,
  [263] = 29,
  [264] = 8,
  [265] = 9,
  [266] = 82,
  [267] = 81,
  [268] = 250,
  [269] = 80,
  [270] = 218,
  [271] = 78,
  [272] = 250,
  [273] = 222,
  [274] = 85,
  [275] = 238,
  [276] = 250,
  [277] = 218,
  [278] = 74,
  [279] = 222,
  [280] = 15,
  [281] = 281,
  [282] = 250,
  [283] = 235,
  [284] = 72,
  [285] = 77,
  [286] = 75,
  [287] = 218,
  [288] = 30,
  [289] = 74,
  [290] = 84,
  [291] = 222,
  [292] = 238,
  [293] = 29,
  [294] = 41,
  [295] = 84,
  [296] = 42,
  [297] = 22,
  [298] = 64,
  [299] = 22,
  [300] = 18,
  [301] = 75,
  [302] = 77,
  [303] = 78,
  [304] = 80,
  [305] = 81,
  [306] = 82,
  [307] = 59,
  [308] = 86,
  [309] = 24,
  [310] = 66,
  [311] = 72,
  [312] = 65,
  [313] = 58,
  [314] = 314,
  [315] = 314,
  [316] = 316,
  [317] = 317,
  [318] = 317,
  [319] = 314,
  [320] = 320,
  [321] = 320,
  [322] = 317,
  [323] = 314,
  [324] = 47,
  [325] = 320,
  [326] = 320,
  [327] = 327,
  [328] = 328,
  [329] = 314,
  [330] = 317,
  [331] = 320,
  [332] = 26,
  [333] = 333,
  [334] = 320,
  [335] = 314,
  [336] = 317,
  [337] = 320,
  [338] = 314,
  [339] = 320,
  [340] = 314,
  [341] = 320,
  [342] = 314,
  [343] = 80,
  [344] = 344,
  [345] = 345,
  [346] = 346,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 151,
  [351] = 344,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 346,
  [357] = 151,
  [358] = 347,
  [359] = 162,
  [360] = 167,
  [361] = 192,
  [362] = 190,
  [363] = 162,
  [364] = 161,
  [365] = 133,
  [366] = 75,
  [367] = 161,
  [368] = 163,
  [369] = 163,
  [370] = 345,
  [371] = 346,
  [372] = 347,
  [373] = 77,
  [374] = 348,
  [375] = 349,
  [376] = 344,
  [377] = 352,
  [378] = 78,
  [379] = 81,
  [380] = 133,
  [381] = 82,
  [382] = 59,
  [383] = 86,
  [384] = 167,
  [385] = 353,
  [386] = 133,
  [387] = 387,
  [388] = 354,
  [389] = 355,
  [390] = 167,
  [391] = 190,
  [392] = 3,
  [393] = 393,
  [394] = 348,
  [395] = 349,
  [396] = 344,
  [397] = 163,
  [398] = 345,
  [399] = 346,
  [400] = 66,
  [401] = 347,
  [402] = 348,
  [403] = 349,
  [404] = 65,
  [405] = 64,
  [406] = 345,
  [407] = 352,
  [408] = 353,
  [409] = 354,
  [410] = 355,
  [411] = 161,
  [412] = 352,
  [413] = 413,
  [414] = 353,
  [415] = 415,
  [416] = 192,
  [417] = 417,
  [418] = 354,
  [419] = 72,
  [420] = 151,
  [421] = 355,
  [422] = 190,
  [423] = 192,
  [424] = 3,
  [425] = 162,
  [426] = 7,
  [427] = 8,
  [428] = 9,
  [429] = 10,
  [430] = 5,
  [431] = 431,
  [432] = 11,
  [433] = 433,
  [434] = 434,
  [435] = 435,
  [436] = 435,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 438,
  [441] = 434,
  [442] = 15,
  [443] = 74,
  [444] = 84,
  [445] = 435,
  [446] = 435,
  [447] = 438,
  [448] = 433,
  [449] = 74,
  [450] = 433,
  [451] = 435,
  [452] = 438,
  [453] = 438,
  [454] = 5,
  [455] = 7,
  [456] = 438,
  [457] = 435,
  [458] = 435,
  [459] = 433,
  [460] = 434,
  [461] = 433,
  [462] = 438,
  [463] = 438,
  [464] = 435,
  [465] = 434,
  [466] = 434,
  [467] = 435,
  [468] = 438,
  [469] = 469,
  [470] = 39,
  [471] = 11,
  [472] = 469,
  [473] = 8,
  [474] = 474,
  [475] = 9,
  [476] = 10,
  [477] = 41,
  [478] = 42,
  [479] = 469,
  [480] = 469,
  [481] = 18,
  [482] = 24,
  [483] = 474,
  [484] = 474,
  [485] = 29,
  [486] = 469,
  [487] = 151,
  [488] = 25,
  [489] = 474,
  [490] = 490,
  [491] = 27,
  [492] = 492,
  [493] = 469,
  [494] = 22,
  [495] = 22,
  [496] = 474,
  [497] = 474,
  [498] = 30,
  [499] = 469,
  [500] = 29,
  [501] = 474,
  [502] = 469,
  [503] = 474,
  [504] = 474,
  [505] = 469,
  [506] = 15,
  [507] = 507,
  [508] = 508,
  [509] = 47,
  [510] = 58,
  [511] = 511,
  [512] = 512,
  [513] = 133,
  [514] = 514,
  [515] = 161,
  [516] = 167,
  [517] = 162,
  [518] = 518,
  [519] = 163,
  [520] = 520,
  [521] = 521,
  [522] = 387,
  [523] = 387,
  [524] = 3,
  [525] = 525,
  [526] = 81,
  [527] = 527,
  [528] = 82,
  [529] = 78,
  [530] = 77,
  [531] = 59,
  [532] = 387,
  [533] = 80,
  [534] = 3,
  [535] = 75,
  [536] = 3,
  [537] = 86,
  [538] = 3,
  [539] = 66,
  [540] = 540,
  [541] = 65,
  [542] = 64,
  [543] = 72,
  [544] = 3,
  [545] = 3,
  [546] = 546,
  [547] = 8,
  [548] = 9,
  [549] = 546,
  [550] = 10,
  [551] = 8,
  [552] = 5,
  [553] = 9,
  [554] = 10,
  [555] = 555,
  [556] = 11,
  [557] = 5,
  [558] = 7,
  [559] = 5,
  [560] = 7,
  [561] = 7,
  [562] = 546,
  [563] = 5,
  [564] = 555,
  [565] = 11,
  [566] = 15,
  [567] = 546,
  [568] = 546,
  [569] = 569,
  [570] = 555,
  [571] = 387,
  [572] = 555,
  [573] = 5,
  [574] = 7,
  [575] = 555,
  [576] = 15,
  [577] = 15,
  [578] = 8,
  [579] = 9,
  [580] = 546,
  [581] = 10,
  [582] = 546,
  [583] = 555,
  [584] = 555,
  [585] = 11,
  [586] = 5,
  [587] = 546,
  [588] = 7,
  [589] = 546,
  [590] = 555,
  [591] = 555,
  [592] = 7,
  [593] = 29,
  [594] = 9,
  [595] = 29,
  [596] = 15,
  [597] = 30,
  [598] = 598,
  [599] = 27,
  [600] = 25,
  [601] = 39,
  [602] = 39,
  [603] = 8,
  [604] = 24,
  [605] = 9,
  [606] = 10,
  [607] = 29,
  [608] = 41,
  [609] = 42,
  [610] = 18,
  [611] = 611,
  [612] = 490,
  [613] = 18,
  [614] = 22,
  [615] = 42,
  [616] = 41,
  [617] = 617,
  [618] = 492,
  [619] = 25,
  [620] = 490,
  [621] = 492,
  [622] = 15,
  [623] = 39,
  [624] = 624,
  [625] = 27,
  [626] = 30,
  [627] = 11,
  [628] = 628,
  [629] = 629,
  [630] = 490,
  [631] = 10,
  [632] = 632,
  [633] = 633,
  [634] = 634,
  [635] = 22,
  [636] = 29,
  [637] = 492,
  [638] = 9,
  [639] = 639,
  [640] = 640,
  [641] = 24,
  [642] = 11,
  [643] = 643,
  [644] = 22,
  [645] = 29,
  [646] = 24,
  [647] = 647,
  [648] = 8,
  [649] = 22,
  [650] = 22,
  [651] = 651,
  [652] = 652,
  [653] = 29,
  [654] = 654,
  [655] = 655,
  [656] = 15,
  [657] = 657,
  [658] = 41,
  [659] = 18,
  [660] = 8,
  [661] = 10,
  [662] = 662,
  [663] = 27,
  [664] = 25,
  [665] = 30,
  [666] = 11,
  [667] = 42,
  [668] = 668,
  [669] = 22,
  [670] = 670,
  [671] = 671,
  [672] = 672,
  [673] = 673,
  [674] = 674,
  [675] = 512,
  [676] = 676,
  [677] = 677,
  [678] = 521,
  [679] = 514,
  [680] = 680,
  [681] = 681,
  [682] = 682,
  [683] = 683,
  [684] = 684,
  [685] = 685,
  [686] = 508,
  [687] = 687,
  [688] = 688,
  [689] = 689,
  [690] = 47,
  [691] = 691,
  [692] = 672,
  [693] = 691,
  [694] = 518,
  [695] = 676,
  [696] = 672,
  [697] = 672,
  [698] = 508,
  [699] = 672,
  [700] = 670,
  [701] = 670,
  [702] = 702,
  [703] = 676,
  [704] = 518,
  [705] = 47,
  [706] = 521,
  [707] = 521,
  [708] = 708,
  [709] = 709,
  [710] = 710,
  [711] = 711,
  [712] = 712,
  [713] = 713,
  [714] = 58,
  [715] = 715,
  [716] = 670,
  [717] = 670,
  [718] = 58,
  [719] = 719,
  [720] = 670,
  [721] = 721,
  [722] = 722,
  [723] = 490,
  [724] = 58,
  [725] = 492,
  [726] = 670,
  [727] = 508,
  [728] = 728,
  [729] = 729,
  [730] = 730,
  [731] = 672,
  [732] = 732,
  [733] = 518,
  [734] = 734,
  [735] = 676,
  [736] = 512,
  [737] = 47,
  [738] = 738,
  [739] = 739,
  [740] = 514,
  [741] = 691,
  [742] = 742,
  [743] = 512,
  [744] = 691,
  [745] = 672,
  [746] = 672,
  [747] = 670,
  [748] = 514,
  [749] = 749,
  [750] = 672,
  [751] = 751,
  [752] = 752,
  [753] = 676,
  [754] = 754,
  [755] = 670,
  [756] = 64,
  [757] = 77,
  [758] = 518,
  [759] = 66,
  [760] = 521,
  [761] = 65,
  [762] = 86,
  [763] = 763,
  [764] = 59,
  [765] = 86,
  [766] = 82,
  [767] = 525,
  [768] = 82,
  [769] = 508,
  [770] = 81,
  [771] = 771,
  [772] = 59,
  [773] = 80,
  [774] = 78,
  [775] = 64,
  [776] = 527,
  [777] = 77,
  [778] = 525,
  [779] = 514,
  [780] = 512,
  [781] = 75,
  [782] = 78,
  [783] = 783,
  [784] = 527,
  [785] = 59,
  [786] = 527,
  [787] = 72,
  [788] = 64,
  [789] = 72,
  [790] = 77,
  [791] = 66,
  [792] = 66,
  [793] = 80,
  [794] = 81,
  [795] = 82,
  [796] = 86,
  [797] = 75,
  [798] = 65,
  [799] = 75,
  [800] = 78,
  [801] = 72,
  [802] = 80,
  [803] = 525,
  [804] = 65,
  [805] = 81,
  [806] = 806,
  [807] = 807,
  [808] = 808,
  [809] = 807,
  [810] = 806,
  [811] = 811,
  [812] = 812,
  [813] = 808,
  [814] = 811,
  [815] = 808,
  [816] = 811,
  [817] = 812,
  [818] = 525,
  [819] = 569,
  [820] = 811,
  [821] = 811,
  [822] = 811,
  [823] = 806,
  [824] = 807,
  [825] = 811,
  [826] = 811,
  [827] = 807,
  [828] = 806,
  [829] = 811,
  [830] = 811,
  [831] = 812,
  [832] = 808,
  [833] = 811,
  [834] = 806,
  [835] = 811,
  [836] = 569,
  [837] = 806,
  [838] = 807,
  [839] = 807,
  [840] = 811,
  [841] = 812,
  [842] = 808,
  [843] = 808,
  [844] = 812,
  [845] = 807,
  [846] = 806,
  [847] = 811,
  [848] = 569,
  [849] = 807,
  [850] = 812,
  [851] = 808,
  [852] = 811,
  [853] = 806,
  [854] = 812,
  [855] = 808,
  [856] = 812,
  [857] = 812,
  [858] = 811,
  [859] = 811,
  [860] = 807,
  [861] = 806,
  [862] = 811,
  [863] = 808,
  [864] = 617,
  [865] = 628,
  [866] = 866,
  [867] = 867,
  [868] = 866,
  [869] = 866,
  [870] = 870,
  [871] = 870,
  [872] = 872,
  [873] = 657,
  [874] = 874,
  [875] = 875,
  [876] = 655,
  [877] = 874,
  [878] = 875,
  [879] = 651,
  [880] = 647,
  [881] = 875,
  [882] = 643,
  [883] = 640,
  [884] = 634,
  [885] = 652,
  [886] = 598,
  [887] = 632,
  [888] = 629,
  [889] = 647,
  [890] = 651,
  [891] = 655,
  [892] = 617,
  [893] = 633,
  [894] = 875,
  [895] = 874,
  [896] = 617,
  [897] = 611,
  [898] = 872,
  [899] = 870,
  [900] = 866,
  [901] = 624,
  [902] = 655,
  [903] = 657,
  [904] = 874,
  [905] = 640,
  [906] = 867,
  [907] = 875,
  [908] = 629,
  [909] = 598,
  [910] = 624,
  [911] = 668,
  [912] = 867,
  [913] = 866,
  [914] = 870,
  [915] = 870,
  [916] = 634,
  [917] = 872,
  [918] = 874,
  [919] = 875,
  [920] = 632,
  [921] = 867,
  [922] = 866,
  [923] = 870,
  [924] = 874,
  [925] = 875,
  [926] = 624,
  [927] = 633,
  [928] = 874,
  [929] = 611,
  [930] = 639,
  [931] = 652,
  [932] = 628,
  [933] = 629,
  [934] = 632,
  [935] = 875,
  [936] = 639,
  [937] = 874,
  [938] = 652,
  [939] = 870,
  [940] = 866,
  [941] = 634,
  [942] = 598,
  [943] = 639,
  [944] = 640,
  [945] = 643,
  [946] = 872,
  [947] = 643,
  [948] = 668,
  [949] = 875,
  [950] = 874,
  [951] = 870,
  [952] = 866,
  [953] = 647,
  [954] = 633,
  [955] = 955,
  [956] = 956,
  [957] = 957,
  [958] = 628,
  [959] = 651,
  [960] = 668,
  [961] = 961,
  [962] = 866,
  [963] = 870,
  [964] = 657,
  [965] = 611,
  [966] = 966,
  [967] = 967,
  [968] = 966,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 972,
  [973] = 970,
  [974] = 967,
  [975] = 967,
  [976] = 972,
  [977] = 972,
  [978] = 967,
  [979] = 967,
  [980] = 971,
  [981] = 971,
  [982] = 966,
  [983] = 971,
  [984] = 971,
  [985] = 971,
  [986] = 971,
  [987] = 971,
  [988] = 972,
  [989] = 971,
  [990] = 971,
  [991] = 971,
  [992] = 966,
  [993] = 970,
  [994] = 966,
  [995] = 971,
  [996] = 970,
  [997] = 971,
  [998] = 998,
  [999] = 971,
  [1000] = 1000,
  [1001] = 1001,
  [1002] = 971,
  [1003] = 972,
  [1004] = 969,
  [1005] = 966,
  [1006] = 967,
  [1007] = 972,
  [1008] = 967,
  [1009] = 972,
  [1010] = 1000,
  [1011] = 1001,
  [1012] = 971,
  [1013] = 969,
  [1014] = 970,
  [1015] = 972,
  [1016] = 1000,
  [1017] = 1000,
  [1018] = 971,
  [1019] = 967,
  [1020] = 966,
  [1021] = 972,
  [1022] = 970,
  [1023] = 967,
  [1024] = 970,
  [1025] = 1001,
  [1026] = 971,
  [1027] = 969,
  [1028] = 1028,
  [1029] = 966,
  [1030] = 970,
  [1031] = 1000,
  [1032] = 966,
  [1033] = 1001,
  [1034] = 970,
  [1035] = 1035,
  [1036] = 1035,
  [1037] = 1037,
  [1038] = 1038,
  [1039] = 1039,
  [1040] = 1037,
  [1041] = 1041,
  [1042] = 628,
  [1043] = 617,
  [1044] = 1044,
  [1045] = 1045,
  [1046] = 1046,
  [1047] = 1046,
  [1048] = 1048,
  [1049] = 1046,
  [1050] = 633,
  [1051] = 1048,
  [1052] = 1048,
  [1053] = 1053,
  [1054] = 1048,
  [1055] = 1055,
  [1056] = 1048,
  [1057] = 1046,
  [1058] = 1046,
  [1059] = 1046,
  [1060] = 1045,
  [1061] = 1061,
  [1062] = 1062,
  [1063] = 1048,
  [1064] = 1046,
  [1065] = 1048,
  [1066] = 1046,
  [1067] = 1045,
  [1068] = 1068,
  [1069] = 1046,
  [1070] = 1061,
  [1071] = 1071,
  [1072] = 1045,
  [1073] = 1061,
  [1074] = 1048,
  [1075] = 1061,
  [1076] = 1048,
  [1077] = 1077,
  [1078] = 1078,
  [1079] = 1079,
  [1080] = 1078,
  [1081] = 1081,
  [1082] = 1082,
  [1083] = 1083,
  [1084] = 1082,
  [1085] = 1078,
  [1086] = 1081,
  [1087] = 1087,
  [1088] = 1088,
  [1089] = 1083,
  [1090] = 1090,
  [1091] = 1088,
  [1092] = 1088,
  [1093] = 1078,
  [1094] = 1079,
  [1095] = 1095,
  [1096] = 1095,
  [1097] = 1079,
  [1098] = 1082,
  [1099] = 1095,
  [1100] = 1079,
  [1101] = 1095,
  [1102] = 1078,
  [1103] = 1088,
  [1104] = 1087,
  [1105] = 1083,
  [1106] = 1087,
  [1107] = 1090,
  [1108] = 1081,
  [1109] = 1087,
  [1110] = 1087,
  [1111] = 1095,
  [1112] = 1081,
  [1113] = 1079,
  [1114] = 1082,
  [1115] = 1077,
  [1116] = 1078,
  [1117] = 1082,
  [1118] = 1082,
  [1119] = 1088,
  [1120] = 1082,
  [1121] = 1088,
  [1122] = 1122,
  [1123] = 1081,
  [1124] = 1081,
  [1125] = 1082,
  [1126] = 1088,
  [1127] = 1087,
  [1128] = 1090,
  [1129] = 1095,
  [1130] = 1090,
  [1131] = 1088,
  [1132] = 1090,
  [1133] = 1088,
  [1134] = 1079,
  [1135] = 1081,
  [1136] = 1078,
  [1137] = 1081,
  [1138] = 1082,
  [1139] = 1081,
  [1140] = 1140,
  [1141] = 1083,
  [1142] = 1087,
  [1143] = 1081,
  [1144] = 1083,
  [1145] = 1081,
  [1146] = 1087,
  [1147] = 1078,
  [1148] = 1087,
  [1149] = 1081,
  [1150] = 1095,
  [1151] = 1095,
  [1152] = 1081,
  [1153] = 1079,
  [1154] = 1081,
  [1155] = 1079,
  [1156] = 1078,
  [1157] = 1081,
  [1158] = 1081,
  [1159] = 1079,
  [1160] = 1081,
  [1161] = 1095,
  [1162] = 1081,
  [1163] = 1163,
  [1164] = 1164,
  [1165] = 1165,
  [1166] = 1166,
  [1167] = 1166,
  [1168] = 1165,
  [1169] = 1166,
  [1170] = 1166,
  [1171] = 1171,
  [1172] = 1172,
  [1173] = 1166,
  [1174] = 1174,
  [1175] = 1175,
  [1176] = 1166,
  [1177] = 1177,
  [1178] = 1178,
  [1179] = 1166,
  [1180] = 1180,
  [1181] = 1181,
  [1182] = 1166,
  [1183] = 1180,
  [1184] = 1163,
  [1185] = 1166,
  [1186] = 1186,
  [1187] = 1186,
  [1188] = 1166,
  [1189] = 1189,
  [1190] = 1186,
  [1191] = 1191,
  [1192] = 1166,
  [1193] = 1165,
  [1194] = 1163,
  [1195] = 1171,
  [1196] = 1177,
  [1197] = 1174,
  [1198] = 1189,
  [1199] = 1164,
  [1200] = 1186,
  [1201] = 1180,
  [1202] = 1202,
  [1203] = 1163,
  [1204] = 1164,
  [1205] = 1166,
  [1206] = 1165,
  [1207] = 1171,
  [1208] = 1171,
  [1209] = 1165,
  [1210] = 1186,
  [1211] = 1163,
  [1212] = 1186,
  [1213] = 1166,
  [1214] = 1171,
  [1215] = 1166,
  [1216] = 1216,
  [1217] = 1164,
  [1218] = 1166,
  [1219] = 1216,
  [1220] = 1216,
  [1221] = 1181,
  [1222] = 1163,
  [1223] = 1177,
  [1224] = 1174,
  [1225] = 1225,
  [1226] = 1171,
  [1227] = 1165,
  [1228] = 1166,
  [1229] = 1186,
  [1230] = 1177,
  [1231] = 1174,
  [1232] = 1181,
  [1233] = 1181,
  [1234] = 1177,
  [1235] = 1174,
  [1236] = 1180,
  [1237] = 1163,
  [1238] = 1177,
  [1239] = 1174,
  [1240] = 1240,
  [1241] = 1163,
  [1242] = 1177,
  [1243] = 1174,
  [1244] = 1244,
  [1245] = 1186,
  [1246] = 1177,
  [1247] = 1174,
  [1248] = 1191,
  [1249] = 1177,
  [1250] = 1174,
  [1251] = 1165,
  [1252] = 1171,
  [1253] = 1171,
  [1254] = 1171,
  [1255] = 1165,
  [1256] = 1216,
  [1257] = 1165,
  [1258] = 1166,
  [1259] = 1166,
  [1260] = 1216,
  [1261] = 1163,
  [1262] = 1186,
  [1263] = 1244,
  [1264] = 1244,
  [1265] = 1244,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(53);
      if (lookahead == '!') ADVANCE(16);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == ')') ADVANCE(56);
      if (lookahead == '+') ADVANCE(148);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '-') ADVANCE(19);
      if (lookahead == '.') ADVANCE(164);
      if (lookahead == '/') ADVANCE(146);
      if (lookahead == '0') ADVANCE(131);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '@') ADVANCE(71);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'b') ADVANCE(119);
      if (lookahead == 'c') ADVANCE(116);
      if (lookahead == 'e') ADVANCE(107);
      if (lookahead == 'f') ADVANCE(77);
      if (lookahead == 'i') ADVANCE(95);
      if (lookahead == 'n') ADVANCE(115);
      if (lookahead == 'o') ADVANCE(120);
      if (lookahead == 't') ADVANCE(121);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '}') ADVANCE(73);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(132);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(16);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'b') ADVANCE(119);
      if (lookahead == 'c') ADVANCE(116);
      if (lookahead == 'e') ADVANCE(108);
      if (lookahead == 'f') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(95);
      if (lookahead == 'n') ADVANCE(115);
      if (lookahead == 'o') ADVANCE(120);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(16);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'e') ADVANCE(112);
      if (lookahead == 'f') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(95);
      if (lookahead == 'n') ADVANCE(115);
      if (lookahead == 'o') ADVANCE(120);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(16);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'e') ADVANCE(113);
      if (lookahead == 'f') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(95);
      if (lookahead == 'n') ADVANCE(115);
      if (lookahead == 'o') ADVANCE(120);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(16);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == ')') ADVANCE(56);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'i') ADVANCE(30);
      if (lookahead == 'n') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      if (lookahead == '}') ADVANCE(73);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == ')') ADVANCE(56);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(42);
      if (lookahead == '0') ADVANCE(131);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == 'f') ADVANCE(78);
      if (lookahead == 'n') ADVANCE(115);
      if (lookahead == 't') ADVANCE(121);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '}') ADVANCE(73);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(132);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 6:
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == 'b') ADVANCE(119);
      if (lookahead == 'c') ADVANCE(116);
      if (lookahead == 'e') ADVANCE(108);
      if (lookahead == 'f') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(96);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 7:
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == 'e') ADVANCE(112);
      if (lookahead == 'f') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(96);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 8:
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == 'e') ADVANCE(113);
      if (lookahead == 'f') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(96);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 9:
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == '+') ADVANCE(17);
      if (lookahead == '-') ADVANCE(18);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(146);
      if (lookahead == '=') ADVANCE(140);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == '{') ADVANCE(72);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 10:
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(42);
      if (lookahead == '0') ADVANCE(131);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == 'f') ADVANCE(78);
      if (lookahead == 't') ADVANCE(121);
      if (lookahead == '{') ADVANCE(72);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(132);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 11:
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(42);
      if (lookahead == '0') ADVANCE(131);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(132);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 12:
      if (lookahead == '#') ADVANCE(65);
      if (lookahead == '\'') ADVANCE(14);
      if (lookahead == '@') ADVANCE(71);
      if (lookahead == '\\') ADVANCE(34);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '^') ADVANCE(67);
      END_STATE();
    case 13:
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == '\'') ADVANCE(59);
      if (lookahead == '@') ADVANCE(71);
      if (lookahead == '\\') ADVANCE(34);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(62);
      if (lookahead != 0 &&
          lookahead != '^') ADVANCE(63);
      END_STATE();
    case 14:
      if (lookahead == '\'') ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == '\'') ADVANCE(64);
      END_STATE();
    case 16:
      if (lookahead == '=') ADVANCE(153);
      END_STATE();
    case 17:
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 18:
      if (lookahead == '=') ADVANCE(143);
      END_STATE();
    case 19:
      if (lookahead == '=') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      END_STATE();
    case 20:
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 21:
      if (lookahead == 'd') ADVANCE(157);
      END_STATE();
    case 22:
      if (lookahead == 'd') ADVANCE(27);
      END_STATE();
    case 23:
      if (lookahead == 'e') ADVANCE(170);
      END_STATE();
    case 24:
      if (lookahead == 'f') ADVANCE(168);
      END_STATE();
    case 25:
      if (lookahead == 'f') ADVANCE(165);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 's') ADVANCE(23);
      END_STATE();
    case 27:
      if (lookahead == 'i') ADVANCE(25);
      END_STATE();
    case 28:
      if (lookahead == 'l') ADVANCE(26);
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 29:
      if (lookahead == 'n') ADVANCE(21);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(161);
      END_STATE();
    case 31:
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 32:
      if (lookahead == 'r') ADVANCE(159);
      END_STATE();
    case 33:
      if (lookahead == 't') ADVANCE(150);
      END_STATE();
    case 34:
      if (lookahead == 'u') ADVANCE(35);
      if (lookahead == 'x') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(70);
      if (lookahead != 0) ADVANCE(68);
      END_STATE();
    case 35:
      if (lookahead == '{') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      END_STATE();
    case 38:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(133);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(134);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(132);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(136);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(68);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(135);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 49:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(176);
      END_STATE();
    case 50:
      if (eof) ADVANCE(53);
      if (lookahead == '!') ADVANCE(16);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == ')') ADVANCE(56);
      if (lookahead == '+') ADVANCE(148);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '-') ADVANCE(19);
      if (lookahead == '.') ADVANCE(164);
      if (lookahead == '/') ADVANCE(146);
      if (lookahead == '0') ADVANCE(131);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(141);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '@') ADVANCE(71);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'b') ADVANCE(119);
      if (lookahead == 'c') ADVANCE(116);
      if (lookahead == 'e') ADVANCE(107);
      if (lookahead == 'f') ADVANCE(77);
      if (lookahead == 'i') ADVANCE(95);
      if (lookahead == 'n') ADVANCE(115);
      if (lookahead == 'o') ADVANCE(120);
      if (lookahead == 't') ADVANCE(121);
      if (lookahead == '{') ADVANCE(72);
      if (lookahead == '}') ADVANCE(73);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(132);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('d' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 51:
      if (eof) ADVANCE(53);
      if (lookahead == '!') ADVANCE(16);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead == '<') ADVANCE(156);
      if (lookahead == '=') ADVANCE(20);
      if (lookahead == '>') ADVANCE(155);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'f') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(95);
      if (lookahead == 'n') ADVANCE(115);
      if (lookahead == 'o') ADVANCE(120);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 52:
      if (eof) ADVANCE(53);
      if (lookahead == '#') ADVANCE(49);
      if (lookahead == '\'') ADVANCE(60);
      if (lookahead == '(') ADVANCE(54);
      if (lookahead == ')') ADVANCE(56);
      if (lookahead == '+') ADVANCE(147);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '.') ADVANCE(163);
      if (lookahead == '/') ADVANCE(145);
      if (lookahead == ':') ADVANCE(76);
      if (lookahead == '?') ADVANCE(149);
      if (lookahead == '[') ADVANCE(74);
      if (lookahead == ']') ADVANCE(75);
      if (lookahead == 'f') ADVANCE(117);
      if (lookahead == 'i') ADVANCE(96);
      if (lookahead == '}') ADVANCE(73);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_true);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_false);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(15);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '\n') ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '@' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(61);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '#') ADVANCE(61);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(62);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '@' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(63);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '@' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE_SQUOTE);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '\n') ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '@' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(65);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '#') ADVANCE(65);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '@' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(67);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\'' &&
          lookahead != '@' &&
          lookahead != '\\' &&
          lookahead != '^') ADVANCE(67);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(68);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(69);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(109);
      if (lookahead == 'o') ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(106);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(82);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(158);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'd') ADVANCE(100);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(171);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(167);
      if (lookahead == 'n') ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(169);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(118);
      if (lookahead == 'i') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(97);
      if (lookahead == 's') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'k') ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(103);
      if (lookahead == 'n') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(103);
      if (lookahead == 'n') ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(84);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(86);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(94);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(151);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(92);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(139);
      if (lookahead == '0') ADVANCE(136);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(38);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(39);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(45);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(130);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(132);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(139);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'n') ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(130);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(134);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'n') ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(152);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=') ADVANCE(144);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(137);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_not);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(154);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_and);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_or);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_in);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(138);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_endif);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_endif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_if);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_elif);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_else);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_foreach);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_endforeach);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_keyword_break);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_keyword_continue);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(129);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(176);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 52},
  [2] = {.lex_state = 1},
  [3] = {.lex_state = 1},
  [4] = {.lex_state = 1},
  [5] = {.lex_state = 1},
  [6] = {.lex_state = 1},
  [7] = {.lex_state = 1},
  [8] = {.lex_state = 1},
  [9] = {.lex_state = 1},
  [10] = {.lex_state = 1},
  [11] = {.lex_state = 1},
  [12] = {.lex_state = 1},
  [13] = {.lex_state = 1},
  [14] = {.lex_state = 1},
  [15] = {.lex_state = 1},
  [16] = {.lex_state = 1},
  [17] = {.lex_state = 5},
  [18] = {.lex_state = 1},
  [19] = {.lex_state = 5},
  [20] = {.lex_state = 5},
  [21] = {.lex_state = 5},
  [22] = {.lex_state = 1},
  [23] = {.lex_state = 1},
  [24] = {.lex_state = 1},
  [25] = {.lex_state = 1},
  [26] = {.lex_state = 1},
  [27] = {.lex_state = 1},
  [28] = {.lex_state = 5},
  [29] = {.lex_state = 1},
  [30] = {.lex_state = 1},
  [31] = {.lex_state = 5},
  [32] = {.lex_state = 5},
  [33] = {.lex_state = 1},
  [34] = {.lex_state = 5},
  [35] = {.lex_state = 1},
  [36] = {.lex_state = 1},
  [37] = {.lex_state = 1},
  [38] = {.lex_state = 1},
  [39] = {.lex_state = 1},
  [40] = {.lex_state = 5},
  [41] = {.lex_state = 1},
  [42] = {.lex_state = 1},
  [43] = {.lex_state = 2},
  [44] = {.lex_state = 5},
  [45] = {.lex_state = 1},
  [46] = {.lex_state = 5},
  [47] = {.lex_state = 1},
  [48] = {.lex_state = 5},
  [49] = {.lex_state = 5},
  [50] = {.lex_state = 5},
  [51] = {.lex_state = 5},
  [52] = {.lex_state = 5},
  [53] = {.lex_state = 5},
  [54] = {.lex_state = 5},
  [55] = {.lex_state = 5},
  [56] = {.lex_state = 3},
  [57] = {.lex_state = 51},
  [58] = {.lex_state = 1},
  [59] = {.lex_state = 1},
  [60] = {.lex_state = 5},
  [61] = {.lex_state = 5},
  [62] = {.lex_state = 51},
  [63] = {.lex_state = 2},
  [64] = {.lex_state = 1},
  [65] = {.lex_state = 1},
  [66] = {.lex_state = 1},
  [67] = {.lex_state = 3},
  [68] = {.lex_state = 5},
  [69] = {.lex_state = 3},
  [70] = {.lex_state = 5},
  [71] = {.lex_state = 5},
  [72] = {.lex_state = 1},
  [73] = {.lex_state = 5},
  [74] = {.lex_state = 1},
  [75] = {.lex_state = 1},
  [76] = {.lex_state = 51},
  [77] = {.lex_state = 1},
  [78] = {.lex_state = 1},
  [79] = {.lex_state = 5},
  [80] = {.lex_state = 1},
  [81] = {.lex_state = 1},
  [82] = {.lex_state = 1},
  [83] = {.lex_state = 5},
  [84] = {.lex_state = 1},
  [85] = {.lex_state = 1},
  [86] = {.lex_state = 1},
  [87] = {.lex_state = 5},
  [88] = {.lex_state = 5},
  [89] = {.lex_state = 2},
  [90] = {.lex_state = 5},
  [91] = {.lex_state = 5},
  [92] = {.lex_state = 5},
  [93] = {.lex_state = 5},
  [94] = {.lex_state = 5},
  [95] = {.lex_state = 51},
  [96] = {.lex_state = 3},
  [97] = {.lex_state = 51},
  [98] = {.lex_state = 51},
  [99] = {.lex_state = 51},
  [100] = {.lex_state = 2},
  [101] = {.lex_state = 51},
  [102] = {.lex_state = 2},
  [103] = {.lex_state = 2},
  [104] = {.lex_state = 2},
  [105] = {.lex_state = 51},
  [106] = {.lex_state = 3},
  [107] = {.lex_state = 2},
  [108] = {.lex_state = 3},
  [109] = {.lex_state = 3},
  [110] = {.lex_state = 3},
  [111] = {.lex_state = 51},
  [112] = {.lex_state = 5},
  [113] = {.lex_state = 3},
  [114] = {.lex_state = 51},
  [115] = {.lex_state = 3},
  [116] = {.lex_state = 3},
  [117] = {.lex_state = 3},
  [118] = {.lex_state = 51},
  [119] = {.lex_state = 3},
  [120] = {.lex_state = 3},
  [121] = {.lex_state = 2},
  [122] = {.lex_state = 2},
  [123] = {.lex_state = 2},
  [124] = {.lex_state = 51},
  [125] = {.lex_state = 2},
  [126] = {.lex_state = 51},
  [127] = {.lex_state = 2},
  [128] = {.lex_state = 2},
  [129] = {.lex_state = 3},
  [130] = {.lex_state = 6},
  [131] = {.lex_state = 51},
  [132] = {.lex_state = 2},
  [133] = {.lex_state = 1},
  [134] = {.lex_state = 3},
  [135] = {.lex_state = 2},
  [136] = {.lex_state = 3},
  [137] = {.lex_state = 2},
  [138] = {.lex_state = 2},
  [139] = {.lex_state = 2},
  [140] = {.lex_state = 2},
  [141] = {.lex_state = 3},
  [142] = {.lex_state = 3},
  [143] = {.lex_state = 3},
  [144] = {.lex_state = 3},
  [145] = {.lex_state = 2},
  [146] = {.lex_state = 3},
  [147] = {.lex_state = 2},
  [148] = {.lex_state = 4},
  [149] = {.lex_state = 3},
  [150] = {.lex_state = 2},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 2},
  [153] = {.lex_state = 2},
  [154] = {.lex_state = 2},
  [155] = {.lex_state = 51},
  [156] = {.lex_state = 2},
  [157] = {.lex_state = 51},
  [158] = {.lex_state = 51},
  [159] = {.lex_state = 6},
  [160] = {.lex_state = 51},
  [161] = {.lex_state = 1},
  [162] = {.lex_state = 1},
  [163] = {.lex_state = 1},
  [164] = {.lex_state = 3},
  [165] = {.lex_state = 3},
  [166] = {.lex_state = 51},
  [167] = {.lex_state = 1},
  [168] = {.lex_state = 3},
  [169] = {.lex_state = 3},
  [170] = {.lex_state = 51},
  [171] = {.lex_state = 3},
  [172] = {.lex_state = 3},
  [173] = {.lex_state = 51},
  [174] = {.lex_state = 51},
  [175] = {.lex_state = 4},
  [176] = {.lex_state = 6},
  [177] = {.lex_state = 3},
  [178] = {.lex_state = 3},
  [179] = {.lex_state = 3},
  [180] = {.lex_state = 51},
  [181] = {.lex_state = 6},
  [182] = {.lex_state = 51},
  [183] = {.lex_state = 2},
  [184] = {.lex_state = 2},
  [185] = {.lex_state = 51},
  [186] = {.lex_state = 2},
  [187] = {.lex_state = 51},
  [188] = {.lex_state = 2},
  [189] = {.lex_state = 51},
  [190] = {.lex_state = 1},
  [191] = {.lex_state = 51},
  [192] = {.lex_state = 6},
  [193] = {.lex_state = 2},
  [194] = {.lex_state = 51},
  [195] = {.lex_state = 51},
  [196] = {.lex_state = 51},
  [197] = {.lex_state = 3},
  [198] = {.lex_state = 4},
  [199] = {.lex_state = 4},
  [200] = {.lex_state = 4},
  [201] = {.lex_state = 4},
  [202] = {.lex_state = 4},
  [203] = {.lex_state = 4},
  [204] = {.lex_state = 4},
  [205] = {.lex_state = 2},
  [206] = {.lex_state = 3},
  [207] = {.lex_state = 2},
  [208] = {.lex_state = 4},
  [209] = {.lex_state = 4},
  [210] = {.lex_state = 2},
  [211] = {.lex_state = 51},
  [212] = {.lex_state = 4},
  [213] = {.lex_state = 3},
  [214] = {.lex_state = 51},
  [215] = {.lex_state = 4},
  [216] = {.lex_state = 51},
  [217] = {.lex_state = 2},
  [218] = {.lex_state = 10},
  [219] = {.lex_state = 2},
  [220] = {.lex_state = 10},
  [221] = {.lex_state = 4},
  [222] = {.lex_state = 10},
  [223] = {.lex_state = 4},
  [224] = {.lex_state = 10},
  [225] = {.lex_state = 4},
  [226] = {.lex_state = 2},
  [227] = {.lex_state = 2},
  [228] = {.lex_state = 2},
  [229] = {.lex_state = 2},
  [230] = {.lex_state = 2},
  [231] = {.lex_state = 2},
  [232] = {.lex_state = 2},
  [233] = {.lex_state = 2},
  [234] = {.lex_state = 2},
  [235] = {.lex_state = 5},
  [236] = {.lex_state = 2},
  [237] = {.lex_state = 5},
  [238] = {.lex_state = 5},
  [239] = {.lex_state = 10},
  [240] = {.lex_state = 2},
  [241] = {.lex_state = 5},
  [242] = {.lex_state = 10},
  [243] = {.lex_state = 5},
  [244] = {.lex_state = 3},
  [245] = {.lex_state = 3},
  [246] = {.lex_state = 10},
  [247] = {.lex_state = 5},
  [248] = {.lex_state = 4},
  [249] = {.lex_state = 10},
  [250] = {.lex_state = 5},
  [251] = {.lex_state = 3},
  [252] = {.lex_state = 3},
  [253] = {.lex_state = 51},
  [254] = {.lex_state = 3},
  [255] = {.lex_state = 10},
  [256] = {.lex_state = 4},
  [257] = {.lex_state = 3},
  [258] = {.lex_state = 10},
  [259] = {.lex_state = 3},
  [260] = {.lex_state = 10},
  [261] = {.lex_state = 10},
  [262] = {.lex_state = 10},
  [263] = {.lex_state = 4},
  [264] = {.lex_state = 4},
  [265] = {.lex_state = 4},
  [266] = {.lex_state = 3},
  [267] = {.lex_state = 3},
  [268] = {.lex_state = 5},
  [269] = {.lex_state = 3},
  [270] = {.lex_state = 10},
  [271] = {.lex_state = 3},
  [272] = {.lex_state = 5},
  [273] = {.lex_state = 10},
  [274] = {.lex_state = 3},
  [275] = {.lex_state = 5},
  [276] = {.lex_state = 5},
  [277] = {.lex_state = 10},
  [278] = {.lex_state = 51},
  [279] = {.lex_state = 10},
  [280] = {.lex_state = 4},
  [281] = {.lex_state = 5},
  [282] = {.lex_state = 5},
  [283] = {.lex_state = 5},
  [284] = {.lex_state = 51},
  [285] = {.lex_state = 3},
  [286] = {.lex_state = 3},
  [287] = {.lex_state = 10},
  [288] = {.lex_state = 4},
  [289] = {.lex_state = 2},
  [290] = {.lex_state = 2},
  [291] = {.lex_state = 10},
  [292] = {.lex_state = 5},
  [293] = {.lex_state = 4},
  [294] = {.lex_state = 4},
  [295] = {.lex_state = 51},
  [296] = {.lex_state = 4},
  [297] = {.lex_state = 4},
  [298] = {.lex_state = 51},
  [299] = {.lex_state = 4},
  [300] = {.lex_state = 4},
  [301] = {.lex_state = 51},
  [302] = {.lex_state = 51},
  [303] = {.lex_state = 51},
  [304] = {.lex_state = 51},
  [305] = {.lex_state = 51},
  [306] = {.lex_state = 51},
  [307] = {.lex_state = 51},
  [308] = {.lex_state = 51},
  [309] = {.lex_state = 4},
  [310] = {.lex_state = 51},
  [311] = {.lex_state = 3},
  [312] = {.lex_state = 51},
  [313] = {.lex_state = 4},
  [314] = {.lex_state = 4},
  [315] = {.lex_state = 4},
  [316] = {.lex_state = 4},
  [317] = {.lex_state = 5},
  [318] = {.lex_state = 5},
  [319] = {.lex_state = 4},
  [320] = {.lex_state = 4},
  [321] = {.lex_state = 4},
  [322] = {.lex_state = 5},
  [323] = {.lex_state = 4},
  [324] = {.lex_state = 4},
  [325] = {.lex_state = 4},
  [326] = {.lex_state = 4},
  [327] = {.lex_state = 4},
  [328] = {.lex_state = 5},
  [329] = {.lex_state = 4},
  [330] = {.lex_state = 5},
  [331] = {.lex_state = 4},
  [332] = {.lex_state = 4},
  [333] = {.lex_state = 4},
  [334] = {.lex_state = 4},
  [335] = {.lex_state = 4},
  [336] = {.lex_state = 5},
  [337] = {.lex_state = 4},
  [338] = {.lex_state = 4},
  [339] = {.lex_state = 4},
  [340] = {.lex_state = 4},
  [341] = {.lex_state = 4},
  [342] = {.lex_state = 4},
  [343] = {.lex_state = 4},
  [344] = {.lex_state = 8},
  [345] = {.lex_state = 8},
  [346] = {.lex_state = 8},
  [347] = {.lex_state = 8},
  [348] = {.lex_state = 8},
  [349] = {.lex_state = 8},
  [350] = {.lex_state = 3},
  [351] = {.lex_state = 8},
  [352] = {.lex_state = 8},
  [353] = {.lex_state = 8},
  [354] = {.lex_state = 8},
  [355] = {.lex_state = 8},
  [356] = {.lex_state = 8},
  [357] = {.lex_state = 51},
  [358] = {.lex_state = 8},
  [359] = {.lex_state = 51},
  [360] = {.lex_state = 2},
  [361] = {.lex_state = 7},
  [362] = {.lex_state = 2},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 2},
  [366] = {.lex_state = 4},
  [367] = {.lex_state = 51},
  [368] = {.lex_state = 3},
  [369] = {.lex_state = 51},
  [370] = {.lex_state = 8},
  [371] = {.lex_state = 8},
  [372] = {.lex_state = 8},
  [373] = {.lex_state = 4},
  [374] = {.lex_state = 8},
  [375] = {.lex_state = 8},
  [376] = {.lex_state = 8},
  [377] = {.lex_state = 8},
  [378] = {.lex_state = 4},
  [379] = {.lex_state = 4},
  [380] = {.lex_state = 51},
  [381] = {.lex_state = 4},
  [382] = {.lex_state = 4},
  [383] = {.lex_state = 4},
  [384] = {.lex_state = 51},
  [385] = {.lex_state = 8},
  [386] = {.lex_state = 3},
  [387] = {.lex_state = 6},
  [388] = {.lex_state = 8},
  [389] = {.lex_state = 8},
  [390] = {.lex_state = 3},
  [391] = {.lex_state = 51},
  [392] = {.lex_state = 6},
  [393] = {.lex_state = 52},
  [394] = {.lex_state = 8},
  [395] = {.lex_state = 8},
  [396] = {.lex_state = 8},
  [397] = {.lex_state = 2},
  [398] = {.lex_state = 8},
  [399] = {.lex_state = 8},
  [400] = {.lex_state = 4},
  [401] = {.lex_state = 8},
  [402] = {.lex_state = 8},
  [403] = {.lex_state = 8},
  [404] = {.lex_state = 4},
  [405] = {.lex_state = 4},
  [406] = {.lex_state = 8},
  [407] = {.lex_state = 8},
  [408] = {.lex_state = 8},
  [409] = {.lex_state = 8},
  [410] = {.lex_state = 8},
  [411] = {.lex_state = 2},
  [412] = {.lex_state = 8},
  [413] = {.lex_state = 7},
  [414] = {.lex_state = 8},
  [415] = {.lex_state = 4},
  [416] = {.lex_state = 52},
  [417] = {.lex_state = 7},
  [418] = {.lex_state = 8},
  [419] = {.lex_state = 4},
  [420] = {.lex_state = 2},
  [421] = {.lex_state = 8},
  [422] = {.lex_state = 3},
  [423] = {.lex_state = 8},
  [424] = {.lex_state = 6},
  [425] = {.lex_state = 2},
  [426] = {.lex_state = 6},
  [427] = {.lex_state = 6},
  [428] = {.lex_state = 6},
  [429] = {.lex_state = 6},
  [430] = {.lex_state = 6},
  [431] = {.lex_state = 10},
  [432] = {.lex_state = 6},
  [433] = {.lex_state = 10},
  [434] = {.lex_state = 10},
  [435] = {.lex_state = 4},
  [436] = {.lex_state = 4},
  [437] = {.lex_state = 4},
  [438] = {.lex_state = 4},
  [439] = {.lex_state = 4},
  [440] = {.lex_state = 4},
  [441] = {.lex_state = 10},
  [442] = {.lex_state = 6},
  [443] = {.lex_state = 4},
  [444] = {.lex_state = 4},
  [445] = {.lex_state = 4},
  [446] = {.lex_state = 4},
  [447] = {.lex_state = 4},
  [448] = {.lex_state = 10},
  [449] = {.lex_state = 4},
  [450] = {.lex_state = 10},
  [451] = {.lex_state = 4},
  [452] = {.lex_state = 4},
  [453] = {.lex_state = 4},
  [454] = {.lex_state = 6},
  [455] = {.lex_state = 6},
  [456] = {.lex_state = 4},
  [457] = {.lex_state = 4},
  [458] = {.lex_state = 4},
  [459] = {.lex_state = 10},
  [460] = {.lex_state = 10},
  [461] = {.lex_state = 10},
  [462] = {.lex_state = 4},
  [463] = {.lex_state = 4},
  [464] = {.lex_state = 4},
  [465] = {.lex_state = 10},
  [466] = {.lex_state = 10},
  [467] = {.lex_state = 4},
  [468] = {.lex_state = 4},
  [469] = {.lex_state = 4},
  [470] = {.lex_state = 6},
  [471] = {.lex_state = 6},
  [472] = {.lex_state = 4},
  [473] = {.lex_state = 6},
  [474] = {.lex_state = 4},
  [475] = {.lex_state = 6},
  [476] = {.lex_state = 6},
  [477] = {.lex_state = 6},
  [478] = {.lex_state = 6},
  [479] = {.lex_state = 4},
  [480] = {.lex_state = 4},
  [481] = {.lex_state = 6},
  [482] = {.lex_state = 6},
  [483] = {.lex_state = 4},
  [484] = {.lex_state = 4},
  [485] = {.lex_state = 6},
  [486] = {.lex_state = 4},
  [487] = {.lex_state = 4},
  [488] = {.lex_state = 6},
  [489] = {.lex_state = 4},
  [490] = {.lex_state = 6},
  [491] = {.lex_state = 6},
  [492] = {.lex_state = 6},
  [493] = {.lex_state = 4},
  [494] = {.lex_state = 6},
  [495] = {.lex_state = 6},
  [496] = {.lex_state = 4},
  [497] = {.lex_state = 4},
  [498] = {.lex_state = 6},
  [499] = {.lex_state = 4},
  [500] = {.lex_state = 6},
  [501] = {.lex_state = 4},
  [502] = {.lex_state = 4},
  [503] = {.lex_state = 4},
  [504] = {.lex_state = 4},
  [505] = {.lex_state = 4},
  [506] = {.lex_state = 6},
  [507] = {.lex_state = 4},
  [508] = {.lex_state = 6},
  [509] = {.lex_state = 6},
  [510] = {.lex_state = 6},
  [511] = {.lex_state = 4},
  [512] = {.lex_state = 6},
  [513] = {.lex_state = 4},
  [514] = {.lex_state = 6},
  [515] = {.lex_state = 4},
  [516] = {.lex_state = 4},
  [517] = {.lex_state = 4},
  [518] = {.lex_state = 6},
  [519] = {.lex_state = 4},
  [520] = {.lex_state = 4},
  [521] = {.lex_state = 6},
  [522] = {.lex_state = 52},
  [523] = {.lex_state = 8},
  [524] = {.lex_state = 8},
  [525] = {.lex_state = 6},
  [526] = {.lex_state = 6},
  [527] = {.lex_state = 6},
  [528] = {.lex_state = 6},
  [529] = {.lex_state = 6},
  [530] = {.lex_state = 6},
  [531] = {.lex_state = 6},
  [532] = {.lex_state = 7},
  [533] = {.lex_state = 6},
  [534] = {.lex_state = 8},
  [535] = {.lex_state = 6},
  [536] = {.lex_state = 7},
  [537] = {.lex_state = 6},
  [538] = {.lex_state = 52},
  [539] = {.lex_state = 6},
  [540] = {.lex_state = 4},
  [541] = {.lex_state = 6},
  [542] = {.lex_state = 6},
  [543] = {.lex_state = 6},
  [544] = {.lex_state = 52},
  [545] = {.lex_state = 7},
  [546] = {.lex_state = 5},
  [547] = {.lex_state = 7},
  [548] = {.lex_state = 7},
  [549] = {.lex_state = 5},
  [550] = {.lex_state = 7},
  [551] = {.lex_state = 8},
  [552] = {.lex_state = 8},
  [553] = {.lex_state = 8},
  [554] = {.lex_state = 8},
  [555] = {.lex_state = 5},
  [556] = {.lex_state = 8},
  [557] = {.lex_state = 7},
  [558] = {.lex_state = 7},
  [559] = {.lex_state = 8},
  [560] = {.lex_state = 8},
  [561] = {.lex_state = 8},
  [562] = {.lex_state = 5},
  [563] = {.lex_state = 7},
  [564] = {.lex_state = 5},
  [565] = {.lex_state = 7},
  [566] = {.lex_state = 52},
  [567] = {.lex_state = 5},
  [568] = {.lex_state = 5},
  [569] = {.lex_state = 6},
  [570] = {.lex_state = 5},
  [571] = {.lex_state = 52},
  [572] = {.lex_state = 5},
  [573] = {.lex_state = 52},
  [574] = {.lex_state = 52},
  [575] = {.lex_state = 5},
  [576] = {.lex_state = 7},
  [577] = {.lex_state = 8},
  [578] = {.lex_state = 52},
  [579] = {.lex_state = 52},
  [580] = {.lex_state = 5},
  [581] = {.lex_state = 52},
  [582] = {.lex_state = 5},
  [583] = {.lex_state = 5},
  [584] = {.lex_state = 5},
  [585] = {.lex_state = 52},
  [586] = {.lex_state = 52},
  [587] = {.lex_state = 5},
  [588] = {.lex_state = 52},
  [589] = {.lex_state = 5},
  [590] = {.lex_state = 5},
  [591] = {.lex_state = 5},
  [592] = {.lex_state = 7},
  [593] = {.lex_state = 7},
  [594] = {.lex_state = 8},
  [595] = {.lex_state = 52},
  [596] = {.lex_state = 8},
  [597] = {.lex_state = 8},
  [598] = {.lex_state = 6},
  [599] = {.lex_state = 7},
  [600] = {.lex_state = 7},
  [601] = {.lex_state = 7},
  [602] = {.lex_state = 52},
  [603] = {.lex_state = 7},
  [604] = {.lex_state = 8},
  [605] = {.lex_state = 7},
  [606] = {.lex_state = 7},
  [607] = {.lex_state = 52},
  [608] = {.lex_state = 7},
  [609] = {.lex_state = 7},
  [610] = {.lex_state = 7},
  [611] = {.lex_state = 6},
  [612] = {.lex_state = 52},
  [613] = {.lex_state = 8},
  [614] = {.lex_state = 7},
  [615] = {.lex_state = 8},
  [616] = {.lex_state = 8},
  [617] = {.lex_state = 6},
  [618] = {.lex_state = 52},
  [619] = {.lex_state = 52},
  [620] = {.lex_state = 7},
  [621] = {.lex_state = 7},
  [622] = {.lex_state = 52},
  [623] = {.lex_state = 8},
  [624] = {.lex_state = 6},
  [625] = {.lex_state = 52},
  [626] = {.lex_state = 52},
  [627] = {.lex_state = 8},
  [628] = {.lex_state = 6},
  [629] = {.lex_state = 6},
  [630] = {.lex_state = 8},
  [631] = {.lex_state = 52},
  [632] = {.lex_state = 6},
  [633] = {.lex_state = 6},
  [634] = {.lex_state = 6},
  [635] = {.lex_state = 8},
  [636] = {.lex_state = 8},
  [637] = {.lex_state = 8},
  [638] = {.lex_state = 52},
  [639] = {.lex_state = 6},
  [640] = {.lex_state = 6},
  [641] = {.lex_state = 52},
  [642] = {.lex_state = 7},
  [643] = {.lex_state = 6},
  [644] = {.lex_state = 7},
  [645] = {.lex_state = 7},
  [646] = {.lex_state = 7},
  [647] = {.lex_state = 6},
  [648] = {.lex_state = 52},
  [649] = {.lex_state = 52},
  [650] = {.lex_state = 8},
  [651] = {.lex_state = 6},
  [652] = {.lex_state = 6},
  [653] = {.lex_state = 8},
  [654] = {.lex_state = 5},
  [655] = {.lex_state = 6},
  [656] = {.lex_state = 7},
  [657] = {.lex_state = 6},
  [658] = {.lex_state = 52},
  [659] = {.lex_state = 52},
  [660] = {.lex_state = 8},
  [661] = {.lex_state = 8},
  [662] = {.lex_state = 5},
  [663] = {.lex_state = 8},
  [664] = {.lex_state = 8},
  [665] = {.lex_state = 7},
  [666] = {.lex_state = 52},
  [667] = {.lex_state = 52},
  [668] = {.lex_state = 6},
  [669] = {.lex_state = 52},
  [670] = {.lex_state = 52},
  [671] = {.lex_state = 5},
  [672] = {.lex_state = 52},
  [673] = {.lex_state = 5},
  [674] = {.lex_state = 4},
  [675] = {.lex_state = 8},
  [676] = {.lex_state = 9},
  [677] = {.lex_state = 4},
  [678] = {.lex_state = 52},
  [679] = {.lex_state = 8},
  [680] = {.lex_state = 5},
  [681] = {.lex_state = 5},
  [682] = {.lex_state = 5},
  [683] = {.lex_state = 5},
  [684] = {.lex_state = 5},
  [685] = {.lex_state = 5},
  [686] = {.lex_state = 8},
  [687] = {.lex_state = 5},
  [688] = {.lex_state = 5},
  [689] = {.lex_state = 5},
  [690] = {.lex_state = 52},
  [691] = {.lex_state = 9},
  [692] = {.lex_state = 52},
  [693] = {.lex_state = 9},
  [694] = {.lex_state = 8},
  [695] = {.lex_state = 9},
  [696] = {.lex_state = 52},
  [697] = {.lex_state = 52},
  [698] = {.lex_state = 7},
  [699] = {.lex_state = 52},
  [700] = {.lex_state = 52},
  [701] = {.lex_state = 52},
  [702] = {.lex_state = 5},
  [703] = {.lex_state = 9},
  [704] = {.lex_state = 7},
  [705] = {.lex_state = 8},
  [706] = {.lex_state = 7},
  [707] = {.lex_state = 8},
  [708] = {.lex_state = 5},
  [709] = {.lex_state = 5},
  [710] = {.lex_state = 5},
  [711] = {.lex_state = 5},
  [712] = {.lex_state = 5},
  [713] = {.lex_state = 5},
  [714] = {.lex_state = 7},
  [715] = {.lex_state = 5},
  [716] = {.lex_state = 52},
  [717] = {.lex_state = 52},
  [718] = {.lex_state = 8},
  [719] = {.lex_state = 5},
  [720] = {.lex_state = 52},
  [721] = {.lex_state = 5},
  [722] = {.lex_state = 5},
  [723] = {.lex_state = 52},
  [724] = {.lex_state = 52},
  [725] = {.lex_state = 52},
  [726] = {.lex_state = 52},
  [727] = {.lex_state = 52},
  [728] = {.lex_state = 5},
  [729] = {.lex_state = 5},
  [730] = {.lex_state = 5},
  [731] = {.lex_state = 52},
  [732] = {.lex_state = 5},
  [733] = {.lex_state = 52},
  [734] = {.lex_state = 10},
  [735] = {.lex_state = 9},
  [736] = {.lex_state = 52},
  [737] = {.lex_state = 7},
  [738] = {.lex_state = 5},
  [739] = {.lex_state = 5},
  [740] = {.lex_state = 7},
  [741] = {.lex_state = 9},
  [742] = {.lex_state = 10},
  [743] = {.lex_state = 7},
  [744] = {.lex_state = 9},
  [745] = {.lex_state = 52},
  [746] = {.lex_state = 52},
  [747] = {.lex_state = 52},
  [748] = {.lex_state = 52},
  [749] = {.lex_state = 5},
  [750] = {.lex_state = 52},
  [751] = {.lex_state = 5},
  [752] = {.lex_state = 5},
  [753] = {.lex_state = 9},
  [754] = {.lex_state = 5},
  [755] = {.lex_state = 52},
  [756] = {.lex_state = 8},
  [757] = {.lex_state = 7},
  [758] = {.lex_state = 52},
  [759] = {.lex_state = 52},
  [760] = {.lex_state = 52},
  [761] = {.lex_state = 52},
  [762] = {.lex_state = 8},
  [763] = {.lex_state = 52},
  [764] = {.lex_state = 52},
  [765] = {.lex_state = 52},
  [766] = {.lex_state = 7},
  [767] = {.lex_state = 8},
  [768] = {.lex_state = 52},
  [769] = {.lex_state = 52},
  [770] = {.lex_state = 52},
  [771] = {.lex_state = 4},
  [772] = {.lex_state = 7},
  [773] = {.lex_state = 52},
  [774] = {.lex_state = 52},
  [775] = {.lex_state = 52},
  [776] = {.lex_state = 8},
  [777] = {.lex_state = 52},
  [778] = {.lex_state = 52},
  [779] = {.lex_state = 52},
  [780] = {.lex_state = 52},
  [781] = {.lex_state = 52},
  [782] = {.lex_state = 8},
  [783] = {.lex_state = 4},
  [784] = {.lex_state = 52},
  [785] = {.lex_state = 8},
  [786] = {.lex_state = 7},
  [787] = {.lex_state = 7},
  [788] = {.lex_state = 7},
  [789] = {.lex_state = 8},
  [790] = {.lex_state = 8},
  [791] = {.lex_state = 7},
  [792] = {.lex_state = 8},
  [793] = {.lex_state = 8},
  [794] = {.lex_state = 8},
  [795] = {.lex_state = 8},
  [796] = {.lex_state = 7},
  [797] = {.lex_state = 7},
  [798] = {.lex_state = 7},
  [799] = {.lex_state = 8},
  [800] = {.lex_state = 7},
  [801] = {.lex_state = 52},
  [802] = {.lex_state = 7},
  [803] = {.lex_state = 7},
  [804] = {.lex_state = 8},
  [805] = {.lex_state = 7},
  [806] = {.lex_state = 52},
  [807] = {.lex_state = 52},
  [808] = {.lex_state = 52},
  [809] = {.lex_state = 52},
  [810] = {.lex_state = 52},
  [811] = {.lex_state = 9},
  [812] = {.lex_state = 52},
  [813] = {.lex_state = 52},
  [814] = {.lex_state = 9},
  [815] = {.lex_state = 52},
  [816] = {.lex_state = 9},
  [817] = {.lex_state = 52},
  [818] = {.lex_state = 52},
  [819] = {.lex_state = 8},
  [820] = {.lex_state = 9},
  [821] = {.lex_state = 9},
  [822] = {.lex_state = 9},
  [823] = {.lex_state = 52},
  [824] = {.lex_state = 52},
  [825] = {.lex_state = 9},
  [826] = {.lex_state = 9},
  [827] = {.lex_state = 52},
  [828] = {.lex_state = 52},
  [829] = {.lex_state = 9},
  [830] = {.lex_state = 9},
  [831] = {.lex_state = 52},
  [832] = {.lex_state = 52},
  [833] = {.lex_state = 9},
  [834] = {.lex_state = 52},
  [835] = {.lex_state = 9},
  [836] = {.lex_state = 7},
  [837] = {.lex_state = 52},
  [838] = {.lex_state = 52},
  [839] = {.lex_state = 52},
  [840] = {.lex_state = 9},
  [841] = {.lex_state = 52},
  [842] = {.lex_state = 52},
  [843] = {.lex_state = 52},
  [844] = {.lex_state = 52},
  [845] = {.lex_state = 52},
  [846] = {.lex_state = 52},
  [847] = {.lex_state = 9},
  [848] = {.lex_state = 52},
  [849] = {.lex_state = 52},
  [850] = {.lex_state = 52},
  [851] = {.lex_state = 52},
  [852] = {.lex_state = 9},
  [853] = {.lex_state = 52},
  [854] = {.lex_state = 52},
  [855] = {.lex_state = 52},
  [856] = {.lex_state = 52},
  [857] = {.lex_state = 52},
  [858] = {.lex_state = 9},
  [859] = {.lex_state = 9},
  [860] = {.lex_state = 52},
  [861] = {.lex_state = 52},
  [862] = {.lex_state = 9},
  [863] = {.lex_state = 52},
  [864] = {.lex_state = 8},
  [865] = {.lex_state = 7},
  [866] = {.lex_state = 12},
  [867] = {.lex_state = 4},
  [868] = {.lex_state = 12},
  [869] = {.lex_state = 12},
  [870] = {.lex_state = 13},
  [871] = {.lex_state = 13},
  [872] = {.lex_state = 4},
  [873] = {.lex_state = 8},
  [874] = {.lex_state = 12},
  [875] = {.lex_state = 13},
  [876] = {.lex_state = 8},
  [877] = {.lex_state = 12},
  [878] = {.lex_state = 13},
  [879] = {.lex_state = 8},
  [880] = {.lex_state = 8},
  [881] = {.lex_state = 13},
  [882] = {.lex_state = 8},
  [883] = {.lex_state = 8},
  [884] = {.lex_state = 8},
  [885] = {.lex_state = 52},
  [886] = {.lex_state = 7},
  [887] = {.lex_state = 8},
  [888] = {.lex_state = 8},
  [889] = {.lex_state = 52},
  [890] = {.lex_state = 52},
  [891] = {.lex_state = 52},
  [892] = {.lex_state = 7},
  [893] = {.lex_state = 8},
  [894] = {.lex_state = 13},
  [895] = {.lex_state = 12},
  [896] = {.lex_state = 52},
  [897] = {.lex_state = 8},
  [898] = {.lex_state = 4},
  [899] = {.lex_state = 13},
  [900] = {.lex_state = 12},
  [901] = {.lex_state = 52},
  [902] = {.lex_state = 7},
  [903] = {.lex_state = 7},
  [904] = {.lex_state = 12},
  [905] = {.lex_state = 52},
  [906] = {.lex_state = 4},
  [907] = {.lex_state = 13},
  [908] = {.lex_state = 52},
  [909] = {.lex_state = 8},
  [910] = {.lex_state = 8},
  [911] = {.lex_state = 7},
  [912] = {.lex_state = 4},
  [913] = {.lex_state = 12},
  [914] = {.lex_state = 13},
  [915] = {.lex_state = 13},
  [916] = {.lex_state = 52},
  [917] = {.lex_state = 4},
  [918] = {.lex_state = 12},
  [919] = {.lex_state = 13},
  [920] = {.lex_state = 52},
  [921] = {.lex_state = 4},
  [922] = {.lex_state = 12},
  [923] = {.lex_state = 13},
  [924] = {.lex_state = 12},
  [925] = {.lex_state = 13},
  [926] = {.lex_state = 7},
  [927] = {.lex_state = 52},
  [928] = {.lex_state = 12},
  [929] = {.lex_state = 7},
  [930] = {.lex_state = 8},
  [931] = {.lex_state = 7},
  [932] = {.lex_state = 8},
  [933] = {.lex_state = 7},
  [934] = {.lex_state = 7},
  [935] = {.lex_state = 13},
  [936] = {.lex_state = 7},
  [937] = {.lex_state = 12},
  [938] = {.lex_state = 8},
  [939] = {.lex_state = 13},
  [940] = {.lex_state = 12},
  [941] = {.lex_state = 7},
  [942] = {.lex_state = 52},
  [943] = {.lex_state = 52},
  [944] = {.lex_state = 7},
  [945] = {.lex_state = 7},
  [946] = {.lex_state = 4},
  [947] = {.lex_state = 52},
  [948] = {.lex_state = 8},
  [949] = {.lex_state = 13},
  [950] = {.lex_state = 12},
  [951] = {.lex_state = 13},
  [952] = {.lex_state = 12},
  [953] = {.lex_state = 7},
  [954] = {.lex_state = 7},
  [955] = {.lex_state = 12},
  [956] = {.lex_state = 52},
  [957] = {.lex_state = 52},
  [958] = {.lex_state = 52},
  [959] = {.lex_state = 7},
  [960] = {.lex_state = 52},
  [961] = {.lex_state = 13},
  [962] = {.lex_state = 12},
  [963] = {.lex_state = 13},
  [964] = {.lex_state = 52},
  [965] = {.lex_state = 52},
  [966] = {.lex_state = 52},
  [967] = {.lex_state = 52},
  [968] = {.lex_state = 52},
  [969] = {.lex_state = 9},
  [970] = {.lex_state = 52},
  [971] = {.lex_state = 11},
  [972] = {.lex_state = 52},
  [973] = {.lex_state = 52},
  [974] = {.lex_state = 52},
  [975] = {.lex_state = 52},
  [976] = {.lex_state = 52},
  [977] = {.lex_state = 52},
  [978] = {.lex_state = 52},
  [979] = {.lex_state = 52},
  [980] = {.lex_state = 11},
  [981] = {.lex_state = 11},
  [982] = {.lex_state = 52},
  [983] = {.lex_state = 11},
  [984] = {.lex_state = 11},
  [985] = {.lex_state = 11},
  [986] = {.lex_state = 11},
  [987] = {.lex_state = 11},
  [988] = {.lex_state = 52},
  [989] = {.lex_state = 11},
  [990] = {.lex_state = 11},
  [991] = {.lex_state = 11},
  [992] = {.lex_state = 52},
  [993] = {.lex_state = 52},
  [994] = {.lex_state = 52},
  [995] = {.lex_state = 11},
  [996] = {.lex_state = 52},
  [997] = {.lex_state = 11},
  [998] = {.lex_state = 4},
  [999] = {.lex_state = 11},
  [1000] = {.lex_state = 11},
  [1001] = {.lex_state = 9},
  [1002] = {.lex_state = 11},
  [1003] = {.lex_state = 52},
  [1004] = {.lex_state = 9},
  [1005] = {.lex_state = 52},
  [1006] = {.lex_state = 52},
  [1007] = {.lex_state = 52},
  [1008] = {.lex_state = 52},
  [1009] = {.lex_state = 52},
  [1010] = {.lex_state = 11},
  [1011] = {.lex_state = 9},
  [1012] = {.lex_state = 11},
  [1013] = {.lex_state = 9},
  [1014] = {.lex_state = 52},
  [1015] = {.lex_state = 52},
  [1016] = {.lex_state = 11},
  [1017] = {.lex_state = 11},
  [1018] = {.lex_state = 11},
  [1019] = {.lex_state = 52},
  [1020] = {.lex_state = 52},
  [1021] = {.lex_state = 52},
  [1022] = {.lex_state = 52},
  [1023] = {.lex_state = 52},
  [1024] = {.lex_state = 52},
  [1025] = {.lex_state = 9},
  [1026] = {.lex_state = 11},
  [1027] = {.lex_state = 9},
  [1028] = {.lex_state = 52},
  [1029] = {.lex_state = 52},
  [1030] = {.lex_state = 52},
  [1031] = {.lex_state = 11},
  [1032] = {.lex_state = 52},
  [1033] = {.lex_state = 9},
  [1034] = {.lex_state = 52},
  [1035] = {.lex_state = 13},
  [1036] = {.lex_state = 12},
  [1037] = {.lex_state = 12},
  [1038] = {.lex_state = 52},
  [1039] = {.lex_state = 52},
  [1040] = {.lex_state = 13},
  [1041] = {.lex_state = 4},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 52},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 4},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 4},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 4},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 11},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 52},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 52},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 0},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 0},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 0},
  [1098] = {.lex_state = 0},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 0},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 52},
  [1109] = {.lex_state = 0},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 52},
  [1113] = {.lex_state = 0},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 11},
  [1116] = {.lex_state = 0},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 0},
  [1119] = {.lex_state = 0},
  [1120] = {.lex_state = 0},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 52},
  [1124] = {.lex_state = 52},
  [1125] = {.lex_state = 0},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 0},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 0},
  [1132] = {.lex_state = 0},
  [1133] = {.lex_state = 0},
  [1134] = {.lex_state = 0},
  [1135] = {.lex_state = 52},
  [1136] = {.lex_state = 0},
  [1137] = {.lex_state = 52},
  [1138] = {.lex_state = 0},
  [1139] = {.lex_state = 52},
  [1140] = {.lex_state = 0},
  [1141] = {.lex_state = 0},
  [1142] = {.lex_state = 0},
  [1143] = {.lex_state = 52},
  [1144] = {.lex_state = 0},
  [1145] = {.lex_state = 52},
  [1146] = {.lex_state = 0},
  [1147] = {.lex_state = 0},
  [1148] = {.lex_state = 0},
  [1149] = {.lex_state = 52},
  [1150] = {.lex_state = 0},
  [1151] = {.lex_state = 0},
  [1152] = {.lex_state = 52},
  [1153] = {.lex_state = 0},
  [1154] = {.lex_state = 52},
  [1155] = {.lex_state = 0},
  [1156] = {.lex_state = 0},
  [1157] = {.lex_state = 52},
  [1158] = {.lex_state = 52},
  [1159] = {.lex_state = 0},
  [1160] = {.lex_state = 52},
  [1161] = {.lex_state = 0},
  [1162] = {.lex_state = 52},
  [1163] = {.lex_state = 0},
  [1164] = {.lex_state = 0},
  [1165] = {.lex_state = 0},
  [1166] = {.lex_state = 0},
  [1167] = {.lex_state = 0},
  [1168] = {.lex_state = 0},
  [1169] = {.lex_state = 0},
  [1170] = {.lex_state = 0},
  [1171] = {.lex_state = 0},
  [1172] = {.lex_state = 9},
  [1173] = {.lex_state = 0},
  [1174] = {.lex_state = 5},
  [1175] = {.lex_state = 0},
  [1176] = {.lex_state = 0},
  [1177] = {.lex_state = 5},
  [1178] = {.lex_state = 0},
  [1179] = {.lex_state = 0},
  [1180] = {.lex_state = 4},
  [1181] = {.lex_state = 4},
  [1182] = {.lex_state = 0},
  [1183] = {.lex_state = 4},
  [1184] = {.lex_state = 0},
  [1185] = {.lex_state = 0},
  [1186] = {.lex_state = 0},
  [1187] = {.lex_state = 0},
  [1188] = {.lex_state = 0},
  [1189] = {.lex_state = 0},
  [1190] = {.lex_state = 0},
  [1191] = {.lex_state = 0},
  [1192] = {.lex_state = 0},
  [1193] = {.lex_state = 0},
  [1194] = {.lex_state = 0},
  [1195] = {.lex_state = 0},
  [1196] = {.lex_state = 5},
  [1197] = {.lex_state = 5},
  [1198] = {.lex_state = 0},
  [1199] = {.lex_state = 0},
  [1200] = {.lex_state = 0},
  [1201] = {.lex_state = 4},
  [1202] = {.lex_state = 0},
  [1203] = {.lex_state = 0},
  [1204] = {.lex_state = 0},
  [1205] = {.lex_state = 0},
  [1206] = {.lex_state = 0},
  [1207] = {.lex_state = 0},
  [1208] = {.lex_state = 0},
  [1209] = {.lex_state = 0},
  [1210] = {.lex_state = 0},
  [1211] = {.lex_state = 0},
  [1212] = {.lex_state = 0},
  [1213] = {.lex_state = 0},
  [1214] = {.lex_state = 0},
  [1215] = {.lex_state = 0},
  [1216] = {.lex_state = 0},
  [1217] = {.lex_state = 0},
  [1218] = {.lex_state = 0},
  [1219] = {.lex_state = 0},
  [1220] = {.lex_state = 0},
  [1221] = {.lex_state = 4},
  [1222] = {.lex_state = 0},
  [1223] = {.lex_state = 5},
  [1224] = {.lex_state = 5},
  [1225] = {.lex_state = 0},
  [1226] = {.lex_state = 0},
  [1227] = {.lex_state = 0},
  [1228] = {.lex_state = 0},
  [1229] = {.lex_state = 0},
  [1230] = {.lex_state = 5},
  [1231] = {.lex_state = 5},
  [1232] = {.lex_state = 4},
  [1233] = {.lex_state = 4},
  [1234] = {.lex_state = 5},
  [1235] = {.lex_state = 5},
  [1236] = {.lex_state = 4},
  [1237] = {.lex_state = 0},
  [1238] = {.lex_state = 5},
  [1239] = {.lex_state = 5},
  [1240] = {.lex_state = 0},
  [1241] = {.lex_state = 0},
  [1242] = {.lex_state = 5},
  [1243] = {.lex_state = 5},
  [1244] = {.lex_state = 9},
  [1245] = {.lex_state = 0},
  [1246] = {.lex_state = 5},
  [1247] = {.lex_state = 5},
  [1248] = {.lex_state = 0},
  [1249] = {.lex_state = 5},
  [1250] = {.lex_state = 5},
  [1251] = {.lex_state = 0},
  [1252] = {.lex_state = 0},
  [1253] = {.lex_state = 0},
  [1254] = {.lex_state = 0},
  [1255] = {.lex_state = 0},
  [1256] = {.lex_state = 0},
  [1257] = {.lex_state = 0},
  [1258] = {.lex_state = 0},
  [1259] = {.lex_state = 0},
  [1260] = {.lex_state = 0},
  [1261] = {.lex_state = 0},
  [1262] = {.lex_state = 0},
  [1263] = {.lex_state = 9},
  [1264] = {.lex_state = 9},
  [1265] = {.lex_state = 9},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_endif] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_endforeach] = ACTIONS(1),
    [sym_keyword_break] = ACTIONS(1),
    [sym_keyword_continue] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(1240),
    [sym__unit] = STATE(393),
    [sym_normal_command] = STATE(784),
    [sym_string] = STATE(1108),
    [sym_listitem] = STATE(1108),
    [sym_operatorunit] = STATE(393),
    [sym_expression_statement] = STATE(393),
    [sym_if_condition] = STATE(393),
    [sym_if_command] = STATE(946),
    [sym_foreach_command] = STATE(393),
    [aux_sym_source_file_repeat1] = STATE(393),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_SQUOTE] = ACTIONS(7),
    [anon_sym_SQUOTE_SQUOTE_SQUOTE] = ACTIONS(9),
    [sym_identifier] = ACTIONS(11),
    [anon_sym_if] = ACTIONS(13),
    [anon_sym_foreach] = ACTIONS(15),
    [sym_comment] = ACTIONS(17),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 10,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(33), 1,
      aux_sym_expression_statement_repeat1,
    STATE(512), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(24), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(29), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(31), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(33), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(21), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [49] = 6,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(41), 1,
      anon_sym_LBRACK,
    ACTIONS(44), 1,
      anon_sym_DOT,
    STATE(10), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(37), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [89] = 6,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(44), 1,
      anon_sym_DOT,
    ACTIONS(47), 1,
      anon_sym_LBRACK,
    STATE(10), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(37), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [129] = 5,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(55), 1,
      anon_sym_DOT,
    STATE(11), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(49), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [166] = 5,
    ACTIONS(55), 1,
      anon_sym_DOT,
    ACTIONS(58), 1,
      anon_sym_LBRACK,
    STATE(11), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(49), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [203] = 5,
    ACTIONS(65), 1,
      anon_sym_LBRACK,
    ACTIONS(68), 1,
      anon_sym_DOT,
    STATE(9), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(61), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [240] = 4,
    ACTIONS(75), 1,
      anon_sym_DOT,
    STATE(15), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [275] = 4,
    ACTIONS(82), 1,
      anon_sym_DOT,
    STATE(15), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(78), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [310] = 4,
    ACTIONS(75), 1,
      anon_sym_DOT,
    STATE(15), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [345] = 4,
    ACTIONS(75), 1,
      anon_sym_DOT,
    STATE(15), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [380] = 8,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(36), 1,
      aux_sym_expression_statement_repeat1,
    STATE(514), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(29), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(89), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(85), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [423] = 8,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(38), 1,
      aux_sym_expression_statement_repeat1,
    STATE(518), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(29), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(100), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(97), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [466] = 5,
    ACTIONS(68), 1,
      anon_sym_DOT,
    ACTIONS(103), 1,
      anon_sym_LBRACK,
    STATE(9), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(61), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [503] = 4,
    ACTIONS(109), 1,
      anon_sym_DOT,
    STATE(15), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(105), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [538] = 4,
    ACTIONS(112), 1,
      anon_sym_DOT,
    STATE(16), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(105), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [572] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(117), 1,
      anon_sym_RPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(49), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(341), 1,
      sym_normal_command,
    STATE(472), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(468), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1074), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1088), 2,
      sym_dictionaries,
      sym_pair,
  [638] = 2,
    ACTIONS(133), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(131), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [668] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(135), 1,
      anon_sym_RPAREN,
    STATE(54), 1,
      aux_sym_normal_command_repeat1,
    STATE(326), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(505), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(452), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1063), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1091), 2,
      sym_dictionaries,
      sym_pair,
  [734] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(137), 1,
      anon_sym_RPAREN,
    STATE(50), 1,
      aux_sym_normal_command_repeat1,
    STATE(321), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(493), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(440), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1056), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1126), 2,
      sym_dictionaries,
      sym_pair,
  [800] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(139), 1,
      anon_sym_RPAREN,
    STATE(48), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(334), 1,
      sym_normal_command,
    STATE(502), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(453), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1065), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1103), 2,
      sym_dictionaries,
      sym_pair,
  [866] = 2,
    ACTIONS(144), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(141), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [896] = 4,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(16), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [930] = 2,
    ACTIONS(149), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(147), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [960] = 2,
    ACTIONS(153), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(151), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [990] = 6,
    ACTIONS(19), 1,
      anon_sym_LPAREN,
    ACTIONS(27), 1,
      anon_sym_LBRACK,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(33), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(31), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(33), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1028] = 2,
    ACTIONS(157), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(155), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1058] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(159), 1,
      anon_sym_RPAREN,
    STATE(46), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(337), 1,
      sym_normal_command,
    STATE(480), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(462), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1048), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1121), 2,
      sym_dictionaries,
      sym_pair,
  [1124] = 3,
    ACTIONS(65), 1,
      anon_sym_LBRACK,
    ACTIONS(63), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(61), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1156] = 2,
    ACTIONS(163), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(161), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1186] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(165), 1,
      anon_sym_RPAREN,
    STATE(52), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(339), 1,
      sym_normal_command,
    STATE(479), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(463), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1052), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1119), 2,
      sym_dictionaries,
      sym_pair,
  [1252] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(167), 1,
      anon_sym_RPAREN,
    STATE(53), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(331), 1,
      sym_normal_command,
    STATE(333), 1,
      sym_string,
    STATE(499), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(456), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1054), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1133), 2,
      sym_dictionaries,
      sym_pair,
  [1318] = 4,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(16), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1352] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(169), 1,
      anon_sym_RPAREN,
    STATE(55), 1,
      aux_sym_normal_command_repeat1,
    STATE(325), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(469), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(447), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1076), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1092), 2,
      sym_dictionaries,
      sym_pair,
  [1418] = 3,
    ACTIONS(103), 1,
      anon_sym_LBRACK,
    ACTIONS(63), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(61), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1450] = 4,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(16), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(78), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1484] = 3,
    ACTIONS(157), 1,
      anon_sym_LBRACK,
    ACTIONS(144), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(141), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1516] = 4,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(16), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1550] = 2,
    ACTIONS(173), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(171), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1580] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(175), 1,
      anon_sym_RPAREN,
    STATE(51), 1,
      aux_sym_normal_command_repeat1,
    STATE(320), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(486), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(438), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1051), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1131), 2,
      sym_dictionaries,
      sym_pair,
  [1646] = 2,
    ACTIONS(179), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(177), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1676] = 2,
    ACTIONS(183), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(181), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1706] = 10,
    ACTIONS(185), 1,
      anon_sym_LPAREN,
    ACTIONS(187), 1,
      anon_sym_LBRACK,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(154), 1,
      aux_sym_expression_statement_repeat1,
    STATE(743), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(24), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(189), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(21), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(31), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(33), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [1751] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(193), 1,
      anon_sym_LPAREN,
    ACTIONS(199), 1,
      anon_sym_SQUOTE,
    ACTIONS(202), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(205), 1,
      anon_sym_LBRACE,
    ACTIONS(208), 1,
      anon_sym_LBRACK,
    ACTIONS(211), 1,
      sym_identifier,
    ACTIONS(214), 1,
      sym_number,
    ACTIONS(217), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(415), 1,
      sym_normal_command,
    STATE(511), 1,
      sym_listitem,
    ACTIONS(196), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(507), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1122), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1202), 2,
      sym_dictionaries,
      sym_pair,
  [1814] = 6,
    STATE(521), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(29), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(89), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(85), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1851] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(342), 1,
      sym_normal_command,
    STATE(474), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(464), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1057), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1110), 2,
      sym_dictionaries,
      sym_pair,
  [1914] = 2,
    ACTIONS(222), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(220), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [1943] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(329), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(496), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(457), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1049), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1142), 2,
      sym_dictionaries,
      sym_pair,
  [2006] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(340), 1,
      sym_normal_command,
    STATE(504), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(467), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1059), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1087), 2,
      sym_dictionaries,
      sym_pair,
  [2069] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(315), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(501), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(446), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1066), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1104), 2,
      sym_dictionaries,
      sym_pair,
  [2132] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(319), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(484), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(435), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1047), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1146), 2,
      sym_dictionaries,
      sym_pair,
  [2195] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(314), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(489), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(458), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1058), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1127), 2,
      sym_dictionaries,
      sym_pair,
  [2258] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(335), 1,
      sym_normal_command,
    STATE(503), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(451), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1069), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1109), 2,
      sym_dictionaries,
      sym_pair,
  [2321] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(338), 1,
      sym_normal_command,
    STATE(483), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(436), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1046), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1148), 2,
      sym_dictionaries,
      sym_pair,
  [2384] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    STATE(44), 1,
      aux_sym_normal_command_repeat1,
    STATE(323), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(497), 1,
      sym_listitem,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(445), 2,
      sym_list,
      sym_expression_statement,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(1064), 2,
      sym_variableunit,
      sym_var_unit,
    STATE(1106), 2,
      sym_dictionaries,
      sym_pair,
  [2447] = 10,
    ACTIONS(224), 1,
      anon_sym_LPAREN,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(144), 1,
      aux_sym_expression_statement_repeat1,
    STATE(675), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(24), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(228), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(21), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(31), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(33), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [2492] = 10,
    ACTIONS(232), 1,
      anon_sym_LPAREN,
    ACTIONS(234), 1,
      anon_sym_LBRACK,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(170), 1,
      aux_sym_expression_statement_repeat1,
    STATE(736), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(236), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(24), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(21), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(31), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(33), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [2537] = 2,
    ACTIONS(242), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(240), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [2566] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [2594] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(248), 1,
      anon_sym_RBRACE,
    STATE(91), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1132), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [2656] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(250), 1,
      anon_sym_RBRACE,
    STATE(68), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1144), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [2718] = 6,
    ACTIONS(232), 1,
      anon_sym_LPAREN,
    ACTIONS(252), 1,
      anon_sym_LBRACK,
    ACTIONS(254), 1,
      anon_sym_DOT,
    STATE(101), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(37), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(39), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [2754] = 6,
    ACTIONS(185), 1,
      anon_sym_LPAREN,
    ACTIONS(257), 1,
      anon_sym_LBRACK,
    ACTIONS(260), 1,
      anon_sym_DOT,
    STATE(128), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(37), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [2790] = 2,
    ACTIONS(265), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(263), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [2818] = 2,
    ACTIONS(269), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(267), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [2846] = 2,
    ACTIONS(273), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(271), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [2874] = 6,
    ACTIONS(224), 1,
      anon_sym_LPAREN,
    ACTIONS(275), 1,
      anon_sym_LBRACK,
    ACTIONS(278), 1,
      anon_sym_DOT,
    STATE(117), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(37), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [2910] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(281), 1,
      anon_sym_RBRACE,
    STATE(91), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1128), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [2972] = 6,
    ACTIONS(224), 1,
      anon_sym_LPAREN,
    ACTIONS(278), 1,
      anon_sym_DOT,
    ACTIONS(283), 1,
      anon_sym_LBRACK,
    STATE(117), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(37), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [3008] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(285), 1,
      anon_sym_RBRACE,
    STATE(91), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1107), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [3070] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_SQUOTE,
    ACTIONS(293), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(299), 1,
      sym_identifier,
    ACTIONS(301), 1,
      sym_number,
    ACTIONS(303), 1,
      anon_sym_not,
    STATE(12), 1,
      sym_normal_command,
    STATE(13), 1,
      sym_string,
    STATE(85), 1,
      sym_listitem,
    STATE(162), 1,
      sym__logic_unit,
    STATE(190), 1,
      sym_bool,
    STATE(318), 1,
      aux_sym_var_unit_repeat1,
    STATE(569), 1,
      sym_var_unit,
    ACTIONS(289), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(45), 2,
      sym_list,
      sym_expression_statement,
    STATE(652), 3,
      sym_dictionaries,
      sym_variableunit,
      sym_ternaryoperator,
  [3132] = 2,
    ACTIONS(307), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(305), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3160] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(309), 1,
      anon_sym_RBRACE,
    STATE(70), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1083), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [3222] = 4,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(38), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(95), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3254] = 2,
    ACTIONS(313), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(311), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3282] = 6,
    ACTIONS(232), 1,
      anon_sym_LPAREN,
    ACTIONS(254), 1,
      anon_sym_DOT,
    ACTIONS(315), 1,
      anon_sym_LBRACK,
    STATE(101), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(37), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(39), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [3318] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3346] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3374] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(318), 1,
      anon_sym_RBRACE,
    STATE(60), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1089), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [3436] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3464] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3492] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3520] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_LPAREN,
    ACTIONS(324), 1,
      anon_sym_SQUOTE,
    ACTIONS(326), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(332), 1,
      sym_identifier,
    ACTIONS(334), 1,
      sym_number,
    ACTIONS(336), 1,
      anon_sym_not,
    STATE(96), 1,
      sym_string,
    STATE(120), 1,
      sym_normal_command,
    STATE(274), 1,
      sym_listitem,
    STATE(336), 1,
      aux_sym_var_unit_repeat1,
    STATE(363), 1,
      sym__logic_unit,
    STATE(422), 1,
      sym_bool,
    STATE(819), 1,
      sym_var_unit,
    ACTIONS(322), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(197), 2,
      sym_list,
      sym_expression_statement,
    STATE(938), 3,
      sym_dictionaries,
      sym_variableunit,
      sym_ternaryoperator,
  [3582] = 4,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(36), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(95), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3614] = 6,
    ACTIONS(35), 1,
      anon_sym_DOT,
    STATE(23), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(341), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(338), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3650] = 2,
    ACTIONS(313), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(311), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [3678] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(344), 1,
      anon_sym_RBRACE,
    STATE(91), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1130), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [3740] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(346), 1,
      anon_sym_RBRACE,
    STATE(92), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1105), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [3802] = 6,
    ACTIONS(185), 1,
      anon_sym_LPAREN,
    ACTIONS(260), 1,
      anon_sym_DOT,
    ACTIONS(348), 1,
      anon_sym_LBRACK,
    STATE(128), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(37), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [3838] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(350), 1,
      anon_sym_RBRACE,
    STATE(87), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1141), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [3900] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(352), 1,
      anon_sym_LPAREN,
    ACTIONS(358), 1,
      anon_sym_SQUOTE,
    ACTIONS(361), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(364), 1,
      anon_sym_RBRACE,
    ACTIONS(366), 1,
      anon_sym_LBRACK,
    ACTIONS(369), 1,
      sym_identifier,
    ACTIONS(372), 1,
      sym_number,
    ACTIONS(375), 1,
      anon_sym_not,
    STATE(91), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1175), 1,
      sym_pair,
    ACTIONS(355), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [3962] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(125), 1,
      sym_identifier,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(378), 1,
      anon_sym_RBRACE,
    STATE(91), 1,
      aux_sym_dictionaries_repeat1,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(333), 1,
      sym_string,
    STATE(437), 1,
      sym_normal_command,
    STATE(449), 1,
      sym_listitem,
    STATE(1090), 1,
      sym_pair,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(517), 2,
      sym_bool,
      sym__logic_unit,
    STATE(520), 2,
      sym_list,
      sym_expression_statement,
    STATE(1178), 2,
      sym_variableunit,
      sym_var_unit,
  [4024] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 1,
      anon_sym_LPAREN,
    ACTIONS(384), 1,
      anon_sym_SQUOTE,
    ACTIONS(386), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(388), 1,
      anon_sym_LBRACE,
    ACTIONS(390), 1,
      anon_sym_LBRACK,
    ACTIONS(392), 1,
      sym_identifier,
    ACTIONS(394), 1,
      sym_number,
    ACTIONS(396), 1,
      anon_sym_not,
    STATE(100), 1,
      sym_string,
    STATE(107), 1,
      sym_normal_command,
    STATE(219), 1,
      sym_listitem,
    STATE(317), 1,
      aux_sym_var_unit_repeat1,
    STATE(362), 1,
      sym_bool,
    STATE(425), 1,
      sym__logic_unit,
    STATE(836), 1,
      sym_var_unit,
    ACTIONS(382), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(210), 2,
      sym_list,
      sym_expression_statement,
    STATE(931), 3,
      sym_dictionaries,
      sym_variableunit,
      sym_ternaryoperator,
  [4086] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(398), 1,
      anon_sym_LPAREN,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(406), 1,
      anon_sym_LBRACE,
    ACTIONS(408), 1,
      anon_sym_LBRACK,
    ACTIONS(410), 1,
      sym_identifier,
    ACTIONS(412), 1,
      sym_number,
    ACTIONS(414), 1,
      anon_sym_not,
    STATE(114), 1,
      sym_string,
    STATE(118), 1,
      sym_normal_command,
    STATE(253), 1,
      sym_listitem,
    STATE(322), 1,
      aux_sym_var_unit_repeat1,
    STATE(359), 1,
      sym__logic_unit,
    STATE(391), 1,
      sym_bool,
    STATE(848), 1,
      sym_var_unit,
    ACTIONS(400), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(216), 2,
      sym_list,
      sym_expression_statement,
    STATE(885), 3,
      sym_dictionaries,
      sym_variableunit,
      sym_ternaryoperator,
  [4148] = 4,
    ACTIONS(416), 1,
      anon_sym_DOT,
    STATE(105), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(78), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(80), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4179] = 8,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(142), 1,
      aux_sym_expression_statement_repeat1,
    STATE(694), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(100), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(228), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(97), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [4218] = 4,
    ACTIONS(419), 1,
      anon_sym_DOT,
    STATE(105), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4249] = 5,
    ACTIONS(422), 1,
      anon_sym_LBRACK,
    ACTIONS(425), 1,
      anon_sym_DOT,
    STATE(95), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(61), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4282] = 5,
    ACTIONS(428), 1,
      anon_sym_LBRACK,
    ACTIONS(431), 1,
      anon_sym_DOT,
    STATE(111), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(49), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(51), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4315] = 8,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(152), 1,
      aux_sym_expression_statement_repeat1,
    STATE(704), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(100), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(189), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(97), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [4354] = 4,
    ACTIONS(419), 1,
      anon_sym_DOT,
    STATE(105), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4385] = 5,
    ACTIONS(434), 1,
      anon_sym_LBRACK,
    ACTIONS(436), 1,
      anon_sym_DOT,
    STATE(121), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(61), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [4418] = 4,
    ACTIONS(439), 1,
      anon_sym_DOT,
    STATE(103), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(105), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(107), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4449] = 5,
    ACTIONS(442), 1,
      anon_sym_LBRACK,
    ACTIONS(444), 1,
      anon_sym_DOT,
    STATE(127), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(49), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [4482] = 4,
    ACTIONS(447), 1,
      anon_sym_DOT,
    STATE(105), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(105), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(107), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4513] = 4,
    ACTIONS(450), 1,
      anon_sym_DOT,
    STATE(106), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(105), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(107), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4544] = 8,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(153), 1,
      aux_sym_expression_statement_repeat1,
    STATE(740), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(89), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(189), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(85), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [4583] = 4,
    ACTIONS(453), 1,
      anon_sym_DOT,
    STATE(106), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(73), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4614] = 5,
    ACTIONS(456), 1,
      anon_sym_LBRACK,
    ACTIONS(458), 1,
      anon_sym_DOT,
    STATE(116), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(61), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [4647] = 5,
    ACTIONS(461), 1,
      anon_sym_LBRACK,
    ACTIONS(464), 1,
      anon_sym_DOT,
    STATE(108), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(49), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [4680] = 4,
    ACTIONS(419), 1,
      anon_sym_DOT,
    STATE(105), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4711] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(467), 1,
      sym_identifier,
    ACTIONS(469), 1,
      sym_number,
    STATE(316), 1,
      sym_string,
    STATE(327), 1,
      sym_normal_command,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(449), 1,
      sym_listitem,
    STATE(517), 1,
      sym__logic_unit,
    STATE(540), 1,
      sym_bool,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(439), 2,
      sym_list,
      sym_expression_statement,
    STATE(1044), 3,
      sym_dictionaries,
      sym_variableunit,
      sym_var_unit,
  [4770] = 5,
    ACTIONS(458), 1,
      anon_sym_DOT,
    ACTIONS(471), 1,
      anon_sym_LBRACK,
    STATE(116), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(61), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [4803] = 8,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(187), 1,
      aux_sym_expression_statement_repeat1,
    STATE(733), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(236), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(100), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(97), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [4842] = 4,
    ACTIONS(453), 1,
      anon_sym_DOT,
    STATE(106), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(73), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4873] = 4,
    ACTIONS(474), 1,
      anon_sym_DOT,
    STATE(106), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(78), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(80), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4904] = 4,
    ACTIONS(453), 1,
      anon_sym_DOT,
    STATE(106), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(73), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [4935] = 8,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(185), 1,
      aux_sym_expression_statement_repeat1,
    STATE(748), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(236), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(89), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(85), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [4974] = 5,
    ACTIONS(464), 1,
      anon_sym_DOT,
    ACTIONS(477), 1,
      anon_sym_LBRACK,
    STATE(108), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(49), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [5007] = 8,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(143), 1,
      aux_sym_expression_statement_repeat1,
    STATE(679), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(89), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(228), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(85), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [5046] = 4,
    ACTIONS(479), 1,
      anon_sym_DOT,
    STATE(103), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(78), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(80), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [5077] = 5,
    ACTIONS(444), 1,
      anon_sym_DOT,
    ACTIONS(482), 1,
      anon_sym_LBRACK,
    STATE(127), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(49), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [5110] = 5,
    ACTIONS(436), 1,
      anon_sym_DOT,
    ACTIONS(485), 1,
      anon_sym_LBRACK,
    STATE(121), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(61), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [5143] = 5,
    ACTIONS(431), 1,
      anon_sym_DOT,
    ACTIONS(488), 1,
      anon_sym_LBRACK,
    STATE(111), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(49), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(51), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [5176] = 4,
    ACTIONS(490), 1,
      anon_sym_DOT,
    STATE(103), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [5207] = 5,
    ACTIONS(425), 1,
      anon_sym_DOT,
    ACTIONS(493), 1,
      anon_sym_LBRACK,
    STATE(95), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(61), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [5240] = 4,
    ACTIONS(490), 1,
      anon_sym_DOT,
    STATE(103), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [5271] = 4,
    ACTIONS(490), 1,
      anon_sym_DOT,
    STATE(103), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [5302] = 2,
    ACTIONS(161), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(163), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5328] = 12,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(495), 1,
      sym_identifier,
    ACTIONS(499), 1,
      anon_sym_foreach,
    ACTIONS(503), 1,
      sym_comment,
    STATE(527), 1,
      sym_normal_command,
    STATE(872), 1,
      sym_if_command,
    ACTIONS(501), 2,
      sym_keyword_break,
      sym_keyword_continue,
    STATE(1081), 2,
      sym_string,
      sym_listitem,
    ACTIONS(497), 3,
      anon_sym_endif,
      anon_sym_elif,
      anon_sym_else,
    STATE(181), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [5374] = 6,
    ACTIONS(232), 1,
      anon_sym_LPAREN,
    ACTIONS(234), 1,
      anon_sym_LBRACK,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(170), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(31), 8,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(33), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
  [5408] = 2,
    ACTIONS(171), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(173), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5434] = 2,
    ACTIONS(507), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(505), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [5460] = 3,
    ACTIONS(157), 1,
      anon_sym_LBRACK,
    ACTIONS(141), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(144), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5488] = 4,
    ACTIONS(509), 1,
      anon_sym_DOT,
    STATE(135), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(105), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [5518] = 3,
    ACTIONS(456), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(63), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5546] = 2,
    ACTIONS(161), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(163), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5572] = 3,
    ACTIONS(485), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5600] = 2,
    ACTIONS(151), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(153), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5626] = 2,
    ACTIONS(141), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(144), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5652] = 3,
    ACTIONS(471), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(63), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5680] = 4,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(171), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [5710] = 4,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(171), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(78), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [5740] = 4,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(171), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [5770] = 3,
    ACTIONS(157), 1,
      anon_sym_LBRACK,
    ACTIONS(141), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(144), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5798] = 4,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(171), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [5828] = 3,
    ACTIONS(434), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5856] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym_GT,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACK,
    ACTIONS(516), 1,
      anon_sym_DOT,
    STATE(200), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [5892] = 2,
    ACTIONS(141), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(144), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5918] = 2,
    ACTIONS(155), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(157), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [5944] = 2,
    ACTIONS(521), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(519), 14,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [5970] = 4,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(135), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [6000] = 4,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(135), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(78), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [6030] = 4,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(135), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [6060] = 2,
    ACTIONS(141), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(144), 12,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6086] = 4,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(135), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(71), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [6116] = 3,
    ACTIONS(422), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6144] = 2,
    ACTIONS(155), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(157), 12,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6170] = 12,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(495), 1,
      sym_identifier,
    ACTIONS(499), 1,
      anon_sym_foreach,
    ACTIONS(527), 1,
      sym_comment,
    STATE(527), 1,
      sym_normal_command,
    STATE(872), 1,
      sym_if_command,
    ACTIONS(525), 2,
      sym_keyword_break,
      sym_keyword_continue,
    STATE(1081), 2,
      sym_string,
      sym_listitem,
    ACTIONS(523), 3,
      anon_sym_endif,
      anon_sym_elif,
      anon_sym_else,
    STATE(176), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [6216] = 2,
    ACTIONS(151), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(153), 12,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6242] = 11,
    ACTIONS(533), 1,
      anon_sym_not,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(545), 1,
      anon_sym_and,
    ACTIONS(547), 1,
      anon_sym_or,
    ACTIONS(549), 1,
      anon_sym_in,
    ACTIONS(531), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(529), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [6286] = 11,
    ACTIONS(555), 1,
      anon_sym_not,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(567), 1,
      anon_sym_and,
    ACTIONS(569), 1,
      anon_sym_or,
    ACTIONS(571), 1,
      anon_sym_in,
    ACTIONS(553), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(551), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [6330] = 11,
    ACTIONS(555), 1,
      anon_sym_not,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(567), 1,
      anon_sym_and,
    ACTIONS(569), 1,
      anon_sym_or,
    ACTIONS(571), 1,
      anon_sym_in,
    ACTIONS(575), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(573), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [6374] = 2,
    ACTIONS(177), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(179), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6400] = 2,
    ACTIONS(181), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(183), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6426] = 4,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(195), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [6456] = 11,
    ACTIONS(533), 1,
      anon_sym_not,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(545), 1,
      anon_sym_and,
    ACTIONS(547), 1,
      anon_sym_or,
    ACTIONS(549), 1,
      anon_sym_in,
    ACTIONS(579), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(577), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [6500] = 2,
    ACTIONS(131), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(133), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6526] = 2,
    ACTIONS(147), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(149), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6552] = 4,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(195), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [6582] = 4,
    ACTIONS(581), 1,
      anon_sym_DOT,
    STATE(171), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(105), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [6612] = 6,
    ACTIONS(224), 1,
      anon_sym_LPAREN,
    ACTIONS(226), 1,
      anon_sym_LBRACK,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(144), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(31), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(33), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [6646] = 2,
    ACTIONS(177), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(179), 12,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6672] = 2,
    ACTIONS(181), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(183), 12,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6698] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(37), 1,
      anon_sym_GT,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(516), 1,
      anon_sym_DOT,
    ACTIONS(584), 1,
      anon_sym_LBRACK,
    STATE(200), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [6734] = 12,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(495), 1,
      sym_identifier,
    ACTIONS(499), 1,
      anon_sym_foreach,
    ACTIONS(591), 1,
      sym_comment,
    STATE(527), 1,
      sym_normal_command,
    STATE(872), 1,
      sym_if_command,
    ACTIONS(589), 2,
      sym_keyword_break,
      sym_keyword_continue,
    STATE(1081), 2,
      sym_string,
      sym_listitem,
    ACTIONS(587), 3,
      anon_sym_endif,
      anon_sym_elif,
      anon_sym_else,
    STATE(192), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [6780] = 2,
    ACTIONS(171), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(173), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6806] = 2,
    ACTIONS(155), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(157), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6832] = 2,
    ACTIONS(151), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(153), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6858] = 3,
    ACTIONS(157), 1,
      anon_sym_LBRACK,
    ACTIONS(141), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(144), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6886] = 12,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(495), 1,
      sym_identifier,
    ACTIONS(499), 1,
      anon_sym_foreach,
    ACTIONS(591), 1,
      sym_comment,
    STATE(527), 1,
      sym_normal_command,
    STATE(872), 1,
      sym_if_command,
    ACTIONS(595), 2,
      sym_keyword_break,
      sym_keyword_continue,
    STATE(1081), 2,
      sym_string,
      sym_listitem,
    ACTIONS(593), 3,
      anon_sym_endif,
      anon_sym_elif,
      anon_sym_else,
    STATE(192), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [6932] = 2,
    ACTIONS(131), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(133), 12,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6958] = 2,
    ACTIONS(177), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(179), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [6984] = 6,
    ACTIONS(185), 1,
      anon_sym_LPAREN,
    ACTIONS(187), 1,
      anon_sym_LBRACK,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(154), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(31), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(33), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [7018] = 4,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(195), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(78), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(80), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [7048] = 2,
    ACTIONS(181), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(183), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7074] = 4,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(195), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [7104] = 2,
    ACTIONS(131), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(133), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7130] = 2,
    ACTIONS(171), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(173), 12,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7156] = 4,
    ACTIONS(341), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(338), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [7186] = 2,
    ACTIONS(147), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(149), 12,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7212] = 11,
    ACTIONS(597), 1,
      anon_sym_SQUOTE,
    ACTIONS(600), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(603), 1,
      sym_identifier,
    ACTIONS(608), 1,
      anon_sym_if,
    ACTIONS(611), 1,
      anon_sym_foreach,
    ACTIONS(614), 1,
      sym_comment,
    STATE(527), 1,
      sym_normal_command,
    STATE(872), 1,
      sym_if_command,
    STATE(1081), 2,
      sym_string,
      sym_listitem,
    ACTIONS(606), 5,
      anon_sym_endif,
      anon_sym_elif,
      anon_sym_else,
      sym_keyword_break,
      sym_keyword_continue,
    STATE(192), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [7256] = 2,
    ACTIONS(147), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(149), 11,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7282] = 3,
    ACTIONS(493), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7310] = 4,
    ACTIONS(617), 1,
      anon_sym_DOT,
    STATE(195), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(105), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(107), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [7340] = 2,
    ACTIONS(161), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(163), 12,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7366] = 6,
    STATE(707), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(89), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(228), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(85), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7399] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_GT,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(622), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(24), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(31), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7442] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_GT,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(630), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(31), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_GT,
    ACTIONS(634), 1,
      anon_sym_DOT,
    STATE(208), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(78), 1,
      anon_sym_GT,
    ACTIONS(637), 1,
      anon_sym_DOT,
    STATE(208), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7545] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_GT,
    ACTIONS(634), 1,
      anon_sym_DOT,
    STATE(208), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7576] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_GT,
    ACTIONS(640), 1,
      anon_sym_LBRACK,
    ACTIONS(643), 1,
      anon_sym_DOT,
    STATE(201), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7609] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_GT,
    ACTIONS(646), 1,
      anon_sym_LBRACK,
    ACTIONS(649), 1,
      anon_sym_DOT,
    STATE(209), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7642] = 2,
    ACTIONS(240), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(242), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7667] = 2,
    ACTIONS(220), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(222), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7692] = 2,
    ACTIONS(220), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(222), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_GT,
    ACTIONS(652), 1,
      anon_sym_DOT,
    STATE(208), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_GT,
    ACTIONS(634), 1,
      anon_sym_DOT,
    STATE(208), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7779] = 6,
    STATE(706), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(89), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(189), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(85), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7812] = 2,
    ACTIONS(220), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(222), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7837] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_GT,
    ACTIONS(643), 1,
      anon_sym_DOT,
    ACTIONS(655), 1,
      anon_sym_LBRACK,
    STATE(201), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7870] = 2,
    ACTIONS(240), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(242), 10,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7895] = 2,
    ACTIONS(240), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(242), 11,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_DOT,
      sym_comment,
  [7920] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(49), 1,
      anon_sym_GT,
    ACTIONS(649), 1,
      anon_sym_DOT,
    ACTIONS(657), 1,
      anon_sym_LBRACK,
    STATE(209), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7953] = 6,
    STATE(678), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(236), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(89), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(85), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [7986] = 2,
    ACTIONS(269), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(267), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8010] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(659), 1,
      anon_sym_RBRACK,
    ACTIONS(661), 1,
      sym_identifier,
    ACTIONS(663), 1,
      sym_number,
    STATE(242), 1,
      aux_sym_list_repeat1,
    STATE(815), 1,
      sym_normal_command,
    STATE(817), 1,
      sym_string,
    STATE(1007), 1,
      sym_list,
    STATE(1023), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1084), 2,
      sym_bool,
      sym_variableunit,
  [8064] = 6,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(156), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(341), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(338), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8096] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(665), 1,
      anon_sym_RBRACK,
    ACTIONS(667), 1,
      sym_identifier,
    ACTIONS(669), 1,
      sym_number,
    STATE(222), 1,
      aux_sym_list_repeat1,
    STATE(812), 1,
      sym_string,
    STATE(813), 1,
      sym_normal_command,
    STATE(977), 1,
      sym_list,
    STATE(978), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1082), 2,
      sym_bool,
      sym_variableunit,
  [8150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(151), 1,
      anon_sym_GT,
    ACTIONS(153), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [8176] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(671), 1,
      anon_sym_RBRACK,
    ACTIONS(673), 1,
      sym_identifier,
    ACTIONS(675), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(827), 1,
      sym_normal_command,
    STATE(828), 1,
      sym_string,
    STATE(994), 1,
      sym_list,
    STATE(996), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1100), 1,
      sym_bool,
    STATE(1102), 1,
      sym_variableunit,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
  [8232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(155), 1,
      anon_sym_GT,
    ACTIONS(157), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [8258] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(677), 1,
      anon_sym_RBRACK,
    ACTIONS(679), 1,
      sym_identifier,
    ACTIONS(681), 1,
      sym_number,
    STATE(255), 1,
      aux_sym_list_repeat1,
    STATE(843), 1,
      sym_normal_command,
    STATE(844), 1,
      sym_string,
    STATE(967), 1,
      sym_expression_statement,
    STATE(1021), 1,
      sym_list,
    STATE(1053), 1,
      sym_listitem,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1120), 2,
      sym_bool,
      sym_variableunit,
  [8312] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(280), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [8342] = 2,
    ACTIONS(313), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(311), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8366] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8390] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8414] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8438] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8462] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8486] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8510] = 2,
    ACTIONS(313), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(311), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8534] = 2,
    ACTIONS(273), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(271), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8558] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(683), 1,
      sym_identifier,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    STATE(1199), 1,
      sym_var_unit,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(517), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [8606] = 2,
    ACTIONS(265), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(263), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8630] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(683), 1,
      sym_identifier,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    STATE(1204), 1,
      sym_var_unit,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(517), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [8678] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(398), 1,
      anon_sym_LPAREN,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(408), 1,
      anon_sym_LBRACK,
    ACTIONS(414), 1,
      anon_sym_not,
    ACTIONS(685), 1,
      sym_identifier,
    ACTIONS(687), 1,
      sym_number,
    STATE(295), 1,
      sym_normal_command,
    STATE(322), 1,
      aux_sym_var_unit_repeat1,
    STATE(889), 1,
      sym_var_unit,
    ACTIONS(400), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(278), 2,
      sym_string,
      sym_listitem,
    STATE(359), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [8726] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(689), 1,
      anon_sym_RBRACK,
    ACTIONS(691), 1,
      sym_identifier,
    ACTIONS(693), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(823), 1,
      sym_string,
    STATE(824), 1,
      sym_normal_command,
    STATE(973), 1,
      sym_expression_statement,
    STATE(982), 1,
      sym_list,
    STATE(1053), 1,
      sym_listitem,
    STATE(1085), 1,
      sym_variableunit,
    STATE(1094), 1,
      sym_bool,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
  [8782] = 2,
    ACTIONS(307), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(305), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [8806] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(683), 1,
      sym_identifier,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    STATE(1217), 1,
      sym_var_unit,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(517), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [8854] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(695), 1,
      anon_sym_RBRACK,
    ACTIONS(697), 1,
      sym_identifier,
    ACTIONS(699), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(837), 1,
      sym_string,
    STATE(849), 1,
      sym_normal_command,
    STATE(1014), 1,
      sym_expression_statement,
    STATE(1032), 1,
      sym_list,
    STATE(1053), 1,
      sym_listitem,
    STATE(1078), 1,
      sym_variableunit,
    STATE(1159), 1,
      sym_bool,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
  [8910] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_SQUOTE,
    ACTIONS(293), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      anon_sym_not,
    ACTIONS(701), 1,
      sym_identifier,
    ACTIONS(703), 1,
      sym_number,
    STATE(84), 1,
      sym_normal_command,
    STATE(130), 1,
      sym_var_unit,
    STATE(318), 1,
      aux_sym_var_unit_repeat1,
    ACTIONS(289), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(74), 2,
      sym_string,
      sym_listitem,
    STATE(162), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [8958] = 4,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(142), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(95), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [8986] = 4,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(143), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(95), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9014] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(705), 1,
      anon_sym_RBRACK,
    ACTIONS(707), 1,
      sym_identifier,
    ACTIONS(709), 1,
      sym_number,
    STATE(239), 1,
      aux_sym_list_repeat1,
    STATE(831), 1,
      sym_string,
    STATE(832), 1,
      sym_normal_command,
    STATE(1008), 1,
      sym_expression_statement,
    STATE(1009), 1,
      sym_list,
    STATE(1053), 1,
      sym_listitem,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1118), 2,
      sym_bool,
      sym_variableunit,
  [9068] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_LPAREN,
    ACTIONS(324), 1,
      anon_sym_SQUOTE,
    ACTIONS(326), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(336), 1,
      anon_sym_not,
    ACTIONS(711), 1,
      sym_identifier,
    ACTIONS(713), 1,
      sym_number,
    STATE(245), 1,
      sym_normal_command,
    STATE(336), 1,
      aux_sym_var_unit_repeat1,
    STATE(880), 1,
      sym_var_unit,
    ACTIONS(322), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(244), 2,
      sym_string,
      sym_listitem,
    STATE(363), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [9116] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(280), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [9146] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(715), 1,
      anon_sym_RBRACK,
    ACTIONS(717), 1,
      sym_identifier,
    ACTIONS(719), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(806), 1,
      sym_string,
    STATE(860), 1,
      sym_normal_command,
    STATE(1029), 1,
      sym_list,
    STATE(1034), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1136), 1,
      sym_variableunit,
    STATE(1155), 1,
      sym_bool,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
  [9202] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(683), 1,
      sym_identifier,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    STATE(1260), 1,
      sym_var_unit,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(517), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [9250] = 2,
    ACTIONS(265), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(263), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9274] = 2,
    ACTIONS(269), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(267), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9298] = 6,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(166), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(341), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(338), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [9330] = 2,
    ACTIONS(273), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(271), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9354] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(721), 1,
      anon_sym_RBRACK,
    ACTIONS(723), 1,
      sym_identifier,
    ACTIONS(725), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(807), 1,
      sym_normal_command,
    STATE(861), 1,
      sym_string,
    STATE(966), 1,
      sym_list,
    STATE(1030), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1134), 1,
      sym_bool,
    STATE(1147), 1,
      sym_variableunit,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
  [9410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(171), 1,
      anon_sym_GT,
    ACTIONS(173), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [9436] = 2,
    ACTIONS(313), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(311), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9460] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 1,
      anon_sym_SQUOTE,
    ACTIONS(733), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(736), 1,
      anon_sym_LBRACE,
    ACTIONS(739), 1,
      anon_sym_LBRACK,
    ACTIONS(742), 1,
      anon_sym_RBRACK,
    ACTIONS(744), 1,
      sym_identifier,
    ACTIONS(747), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(956), 1,
      sym_normal_command,
    STATE(957), 1,
      sym_string,
    STATE(1038), 1,
      sym_list,
    STATE(1039), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    ACTIONS(727), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1225), 3,
      sym_bool,
      sym_dictionaries,
      sym_variableunit,
  [9512] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9536] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(750), 1,
      anon_sym_RBRACK,
    ACTIONS(752), 1,
      sym_identifier,
    ACTIONS(754), 1,
      sym_number,
    STATE(262), 1,
      aux_sym_list_repeat1,
    STATE(850), 1,
      sym_string,
    STATE(851), 1,
      sym_normal_command,
    STATE(975), 1,
      sym_expression_statement,
    STATE(976), 1,
      sym_list,
    STATE(1053), 1,
      sym_listitem,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1117), 2,
      sym_bool,
      sym_variableunit,
  [9590] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(756), 1,
      anon_sym_RBRACK,
    ACTIONS(758), 1,
      sym_identifier,
    ACTIONS(760), 1,
      sym_number,
    STATE(291), 1,
      aux_sym_list_repeat1,
    STATE(841), 1,
      sym_string,
    STATE(842), 1,
      sym_normal_command,
    STATE(979), 1,
      sym_expression_statement,
    STATE(988), 1,
      sym_list,
    STATE(1053), 1,
      sym_listitem,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1114), 2,
      sym_bool,
      sym_variableunit,
  [9644] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(762), 1,
      anon_sym_RBRACK,
    ACTIONS(764), 1,
      sym_identifier,
    ACTIONS(766), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(834), 1,
      sym_string,
    STATE(838), 1,
      sym_normal_command,
    STATE(968), 1,
      sym_list,
    STATE(1022), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1079), 1,
      sym_bool,
    STATE(1080), 1,
      sym_variableunit,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
  [9700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_GT,
    ACTIONS(655), 1,
      anon_sym_LBRACK,
    ACTIONS(63), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [9728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(280), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [9758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(78), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(280), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [9788] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9812] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9836] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(683), 1,
      sym_identifier,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    STATE(1216), 1,
      sym_var_unit,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(517), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [9884] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9908] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(768), 1,
      anon_sym_RBRACK,
    ACTIONS(770), 1,
      sym_identifier,
    ACTIONS(772), 1,
      sym_number,
    STATE(273), 1,
      aux_sym_list_repeat1,
    STATE(808), 1,
      sym_normal_command,
    STATE(857), 1,
      sym_string,
    STATE(972), 1,
      sym_list,
    STATE(974), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1098), 2,
      sym_bool,
      sym_variableunit,
  [9962] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [9986] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(683), 1,
      sym_identifier,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    STATE(1220), 1,
      sym_var_unit,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(517), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [10034] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(774), 1,
      anon_sym_RBRACK,
    ACTIONS(776), 1,
      sym_identifier,
    ACTIONS(778), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(845), 1,
      sym_normal_command,
    STATE(846), 1,
      sym_string,
    STATE(992), 1,
      sym_list,
    STATE(993), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1113), 1,
      sym_bool,
    STATE(1116), 1,
      sym_variableunit,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
  [10090] = 6,
    ACTIONS(230), 1,
      anon_sym_DOT,
    STATE(146), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(341), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(338), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [10122] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_SQUOTE,
    ACTIONS(293), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      anon_sym_not,
    ACTIONS(701), 1,
      sym_identifier,
    ACTIONS(703), 1,
      sym_number,
    STATE(84), 1,
      sym_normal_command,
    STATE(318), 1,
      aux_sym_var_unit_repeat1,
    STATE(647), 1,
      sym_var_unit,
    ACTIONS(289), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(74), 2,
      sym_string,
      sym_listitem,
    STATE(162), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [10170] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(683), 1,
      sym_identifier,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    STATE(1256), 1,
      sym_var_unit,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(517), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [10218] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(780), 1,
      anon_sym_RBRACK,
    ACTIONS(782), 1,
      sym_identifier,
    ACTIONS(784), 1,
      sym_number,
    STATE(279), 1,
      aux_sym_list_repeat1,
    STATE(854), 1,
      sym_string,
    STATE(863), 1,
      sym_normal_command,
    STATE(1015), 1,
      sym_list,
    STATE(1019), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1138), 2,
      sym_bool,
      sym_variableunit,
  [10272] = 4,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(187), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 8,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(95), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
  [10300] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(786), 1,
      anon_sym_RBRACK,
    ACTIONS(788), 1,
      sym_identifier,
    ACTIONS(790), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(839), 1,
      sym_normal_command,
    STATE(853), 1,
      sym_string,
    STATE(1020), 1,
      sym_list,
    STATE(1024), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1153), 1,
      sym_bool,
    STATE(1156), 1,
      sym_variableunit,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
  [10356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_GT,
    ACTIONS(792), 1,
      anon_sym_DOT,
    STATE(280), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [10386] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_SQUOTE,
    ACTIONS(293), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(303), 1,
      anon_sym_not,
    ACTIONS(701), 1,
      sym_identifier,
    ACTIONS(703), 1,
      sym_number,
    STATE(84), 1,
      sym_normal_command,
    STATE(159), 1,
      sym_var_unit,
    STATE(318), 1,
      aux_sym_var_unit_repeat1,
    ACTIONS(289), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(74), 2,
      sym_string,
      sym_listitem,
    STATE(162), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [10434] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(683), 1,
      sym_identifier,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    STATE(1219), 1,
      sym_var_unit,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(517), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [10482] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(127), 1,
      sym_number,
    ACTIONS(129), 1,
      anon_sym_not,
    ACTIONS(683), 1,
      sym_identifier,
    STATE(330), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    STATE(1164), 1,
      sym_var_unit,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(517), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [10530] = 2,
    ACTIONS(305), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(307), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [10554] = 2,
    ACTIONS(246), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(244), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [10578] = 2,
    ACTIONS(313), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(311), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [10602] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(795), 1,
      anon_sym_RBRACK,
    ACTIONS(797), 1,
      sym_identifier,
    ACTIONS(799), 1,
      sym_number,
    STATE(249), 1,
      aux_sym_list_repeat1,
    STATE(855), 1,
      sym_normal_command,
    STATE(856), 1,
      sym_string,
    STATE(1003), 1,
      sym_list,
    STATE(1006), 1,
      sym_expression_statement,
    STATE(1053), 1,
      sym_listitem,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1125), 2,
      sym_bool,
      sym_variableunit,
  [10656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      anon_sym_GT,
    ACTIONS(163), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [10682] = 4,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(152), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(95), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [10710] = 4,
    ACTIONS(191), 1,
      anon_sym_DOT,
    STATE(153), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(95), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [10738] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(121), 1,
      anon_sym_LBRACE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(801), 1,
      anon_sym_RBRACK,
    ACTIONS(803), 1,
      sym_identifier,
    ACTIONS(805), 1,
      sym_number,
    STATE(258), 1,
      aux_sym_list_repeat1,
    STATE(809), 1,
      sym_normal_command,
    STATE(810), 1,
      sym_string,
    STATE(970), 1,
      sym_expression_statement,
    STATE(1005), 1,
      sym_list,
    STATE(1053), 1,
      sym_listitem,
    STATE(1093), 1,
      sym_variableunit,
    STATE(1097), 1,
      sym_bool,
    STATE(1225), 1,
      sym_dictionaries,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
  [10794] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 1,
      anon_sym_LPAREN,
    ACTIONS(384), 1,
      anon_sym_SQUOTE,
    ACTIONS(386), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_LBRACK,
    ACTIONS(396), 1,
      anon_sym_not,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(809), 1,
      sym_number,
    STATE(290), 1,
      sym_normal_command,
    STATE(317), 1,
      aux_sym_var_unit_repeat1,
    STATE(953), 1,
      sym_var_unit,
    ACTIONS(382), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(289), 2,
      sym_string,
      sym_listitem,
    STATE(425), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [10842] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_GT,
    ACTIONS(640), 1,
      anon_sym_LBRACK,
    ACTIONS(63), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [10870] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(177), 1,
      anon_sym_GT,
    ACTIONS(179), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [10896] = 4,
    ACTIONS(238), 1,
      anon_sym_DOT,
    STATE(185), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 8,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(95), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
  [10924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(181), 1,
      anon_sym_GT,
    ACTIONS(183), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [10950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_GT,
    ACTIONS(144), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [10976] = 2,
    ACTIONS(263), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(265), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_GT,
    ACTIONS(157), 1,
      anon_sym_LBRACK,
    ACTIONS(144), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [11028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(131), 1,
      anon_sym_GT,
    ACTIONS(133), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [11054] = 2,
    ACTIONS(311), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(313), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11078] = 2,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11102] = 2,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11126] = 2,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11150] = 2,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11174] = 2,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11198] = 2,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11222] = 2,
    ACTIONS(311), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(313), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11246] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 1,
      anon_sym_GT,
    ACTIONS(149), 17,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [11272] = 2,
    ACTIONS(271), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(273), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11296] = 2,
    ACTIONS(307), 9,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(305), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [11320] = 2,
    ACTIONS(267), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(269), 10,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
  [11344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(240), 1,
      anon_sym_GT,
    ACTIONS(242), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [11369] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(811), 1,
      anon_sym_COMMA,
    ACTIONS(815), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11408] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(819), 1,
      anon_sym_COMMA,
    ACTIONS(823), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11447] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(827), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11482] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 1,
      anon_sym_LPAREN,
    ACTIONS(384), 1,
      anon_sym_SQUOTE,
    ACTIONS(386), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_LBRACK,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(831), 1,
      sym_number,
    ACTIONS(833), 1,
      anon_sym_not,
    STATE(290), 1,
      sym_normal_command,
    STATE(328), 1,
      aux_sym_var_unit_repeat1,
    ACTIONS(382), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(289), 2,
      sym_string,
      sym_listitem,
    STATE(397), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [11527] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_SQUOTE,
    ACTIONS(293), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(701), 1,
      sym_identifier,
    ACTIONS(835), 1,
      sym_number,
    ACTIONS(837), 1,
      anon_sym_not,
    STATE(84), 1,
      sym_normal_command,
    STATE(328), 1,
      aux_sym_var_unit_repeat1,
    ACTIONS(289), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(74), 2,
      sym_string,
      sym_listitem,
    STATE(163), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [11572] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(839), 1,
      anon_sym_COMMA,
    ACTIONS(843), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11611] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(847), 1,
      anon_sym_COMMA,
    ACTIONS(851), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11650] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(855), 1,
      anon_sym_COMMA,
    ACTIONS(859), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11689] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(398), 1,
      anon_sym_LPAREN,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(408), 1,
      anon_sym_LBRACK,
    ACTIONS(685), 1,
      sym_identifier,
    ACTIONS(863), 1,
      sym_number,
    ACTIONS(865), 1,
      anon_sym_not,
    STATE(295), 1,
      sym_normal_command,
    STATE(328), 1,
      aux_sym_var_unit_repeat1,
    ACTIONS(400), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(278), 2,
      sym_string,
      sym_listitem,
    STATE(369), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [11734] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(867), 1,
      anon_sym_COMMA,
    ACTIONS(871), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(220), 1,
      anon_sym_GT,
    ACTIONS(222), 16,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_DOT,
  [11798] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(875), 1,
      anon_sym_COMMA,
    ACTIONS(879), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11837] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(883), 1,
      anon_sym_COMMA,
    ACTIONS(887), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11876] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(827), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11911] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(891), 1,
      anon_sym_LPAREN,
    ACTIONS(897), 1,
      anon_sym_SQUOTE,
    ACTIONS(900), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(903), 1,
      anon_sym_LBRACK,
    ACTIONS(906), 1,
      sym_identifier,
    ACTIONS(909), 1,
      sym_number,
    ACTIONS(912), 1,
      anon_sym_not,
    STATE(328), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    ACTIONS(894), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(677), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [11956] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(915), 1,
      anon_sym_COMMA,
    ACTIONS(919), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [11995] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(683), 1,
      sym_identifier,
    ACTIONS(923), 1,
      sym_number,
    ACTIONS(925), 1,
      anon_sym_not,
    STATE(328), 1,
      aux_sym_var_unit_repeat1,
    STATE(444), 1,
      sym_normal_command,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(519), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [12040] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(927), 1,
      anon_sym_COMMA,
    ACTIONS(931), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12079] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_GT,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(31), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(935), 1,
      anon_sym_COLON,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(100), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12149] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(939), 1,
      anon_sym_COMMA,
    ACTIONS(943), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12188] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(947), 1,
      anon_sym_COMMA,
    ACTIONS(951), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12227] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_LPAREN,
    ACTIONS(324), 1,
      anon_sym_SQUOTE,
    ACTIONS(326), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(711), 1,
      sym_identifier,
    ACTIONS(955), 1,
      sym_number,
    ACTIONS(957), 1,
      anon_sym_not,
    STATE(245), 1,
      sym_normal_command,
    STATE(328), 1,
      aux_sym_var_unit_repeat1,
    ACTIONS(322), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(244), 2,
      sym_string,
      sym_listitem,
    STATE(368), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [12272] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(959), 1,
      anon_sym_COMMA,
    ACTIONS(963), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12311] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(971), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12350] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(975), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12389] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(983), 1,
      anon_sym_COMMA,
    ACTIONS(987), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12428] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(991), 1,
      anon_sym_COMMA,
    ACTIONS(995), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12467] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1003), 1,
      anon_sym_RPAREN,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(244), 1,
      anon_sym_GT,
    ACTIONS(246), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [12530] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1011), 1,
      anon_sym_endforeach,
    ACTIONS(1013), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(401), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12570] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1015), 1,
      anon_sym_endforeach,
    ACTIONS(1017), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12610] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1019), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12650] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1021), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12690] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1023), 1,
      anon_sym_endforeach,
    ACTIONS(1025), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(345), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12730] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1027), 1,
      anon_sym_endforeach,
    ACTIONS(1029), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(346), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12770] = 2,
    ACTIONS(521), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(519), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [12792] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1031), 1,
      anon_sym_endforeach,
    ACTIONS(1033), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(347), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12832] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1035), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12872] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1037), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12912] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1039), 1,
      anon_sym_endforeach,
    ACTIONS(1041), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(352), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12952] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1043), 1,
      anon_sym_endforeach,
    ACTIONS(1045), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(353), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [12992] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1047), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13032] = 2,
    ACTIONS(521), 8,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(519), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
  [13054] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1049), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13094] = 11,
    ACTIONS(555), 1,
      anon_sym_not,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(567), 1,
      anon_sym_and,
    ACTIONS(569), 1,
      anon_sym_or,
    ACTIONS(571), 1,
      anon_sym_in,
    ACTIONS(551), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(553), 4,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
  [13134] = 11,
    ACTIONS(533), 1,
      anon_sym_not,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(545), 1,
      anon_sym_and,
    ACTIONS(547), 1,
      anon_sym_or,
    ACTIONS(549), 1,
      anon_sym_in,
    ACTIONS(579), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(577), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [13174] = 11,
    ACTIONS(597), 1,
      anon_sym_SQUOTE,
    ACTIONS(600), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(606), 1,
      anon_sym_endif,
    ACTIONS(608), 1,
      anon_sym_if,
    ACTIONS(1051), 1,
      sym_identifier,
    ACTIONS(1054), 1,
      anon_sym_foreach,
    ACTIONS(1057), 1,
      sym_comment,
    STATE(786), 1,
      sym_normal_command,
    STATE(917), 1,
      sym_if_command,
    STATE(1123), 2,
      sym_string,
      sym_listitem,
    STATE(361), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13214] = 4,
    ACTIONS(341), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(338), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [13240] = 11,
    ACTIONS(555), 1,
      anon_sym_not,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(567), 1,
      anon_sym_and,
    ACTIONS(569), 1,
      anon_sym_or,
    ACTIONS(571), 1,
      anon_sym_in,
    ACTIONS(553), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(551), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [13280] = 11,
    ACTIONS(533), 1,
      anon_sym_not,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(545), 1,
      anon_sym_and,
    ACTIONS(547), 1,
      anon_sym_or,
    ACTIONS(549), 1,
      anon_sym_in,
    ACTIONS(531), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(529), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [13320] = 2,
    ACTIONS(507), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(505), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [13342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      anon_sym_GT,
    ACTIONS(313), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [13366] = 11,
    ACTIONS(533), 1,
      anon_sym_not,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(545), 1,
      anon_sym_and,
    ACTIONS(547), 1,
      anon_sym_or,
    ACTIONS(549), 1,
      anon_sym_in,
    ACTIONS(529), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(531), 4,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
  [13406] = 11,
    ACTIONS(555), 1,
      anon_sym_not,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(567), 1,
      anon_sym_and,
    ACTIONS(569), 1,
      anon_sym_or,
    ACTIONS(571), 1,
      anon_sym_in,
    ACTIONS(575), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(573), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [13446] = 11,
    ACTIONS(555), 1,
      anon_sym_not,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(567), 1,
      anon_sym_and,
    ACTIONS(569), 1,
      anon_sym_or,
    ACTIONS(571), 1,
      anon_sym_in,
    ACTIONS(573), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(575), 4,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
  [13486] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1060), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13526] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1062), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13566] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1064), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(244), 1,
      anon_sym_GT,
    ACTIONS(246), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [13630] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1066), 1,
      anon_sym_endforeach,
    ACTIONS(1068), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(370), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13670] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1070), 1,
      anon_sym_endforeach,
    ACTIONS(1072), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(371), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13710] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1074), 1,
      anon_sym_endforeach,
    ACTIONS(1076), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(372), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13750] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1078), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [13790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(244), 1,
      anon_sym_GT,
    ACTIONS(246), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [13814] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(244), 1,
      anon_sym_GT,
    ACTIONS(246), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [13838] = 2,
    ACTIONS(507), 8,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(505), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
  [13860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(244), 1,
      anon_sym_GT,
    ACTIONS(246), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [13884] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(244), 1,
      anon_sym_GT,
    ACTIONS(246), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [13908] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(311), 1,
      anon_sym_GT,
    ACTIONS(313), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [13932] = 11,
    ACTIONS(533), 1,
      anon_sym_not,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(545), 1,
      anon_sym_and,
    ACTIONS(547), 1,
      anon_sym_or,
    ACTIONS(549), 1,
      anon_sym_in,
    ACTIONS(577), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(579), 4,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
  [13972] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1080), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14012] = 2,
    ACTIONS(507), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(505), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [14034] = 6,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(1082), 1,
      anon_sym_LPAREN,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(476), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1086), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1084), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [14064] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1090), 1,
      anon_sym_endforeach,
    ACTIONS(1092), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(377), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14104] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1094), 1,
      anon_sym_endforeach,
    ACTIONS(1096), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(385), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14144] = 11,
    ACTIONS(533), 1,
      anon_sym_not,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(545), 1,
      anon_sym_and,
    ACTIONS(547), 1,
      anon_sym_or,
    ACTIONS(549), 1,
      anon_sym_in,
    ACTIONS(579), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(577), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [14184] = 4,
    ACTIONS(341), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(338), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [14210] = 6,
    ACTIONS(1082), 1,
      anon_sym_LPAREN,
    ACTIONS(1098), 1,
      anon_sym_LBRACK,
    ACTIONS(1100), 1,
      anon_sym_DOT,
    STATE(429), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(37), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [14240] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(11), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(15), 1,
      anon_sym_foreach,
    ACTIONS(1103), 1,
      ts_builtin_sym_end,
    ACTIONS(1105), 1,
      sym_comment,
    STATE(784), 1,
      sym_normal_command,
    STATE(946), 1,
      sym_if_command,
    STATE(1108), 2,
      sym_string,
      sym_listitem,
    STATE(416), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14280] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1107), 1,
      anon_sym_endforeach,
    ACTIONS(1109), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(406), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14320] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1111), 1,
      anon_sym_endforeach,
    ACTIONS(1113), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(356), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14360] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1115), 1,
      anon_sym_endforeach,
    ACTIONS(1117), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(358), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14400] = 11,
    ACTIONS(555), 1,
      anon_sym_not,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(567), 1,
      anon_sym_and,
    ACTIONS(569), 1,
      anon_sym_or,
    ACTIONS(571), 1,
      anon_sym_in,
    ACTIONS(575), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(573), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [14440] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1119), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14480] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1121), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      anon_sym_GT,
    ACTIONS(273), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [14544] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1123), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14584] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1125), 1,
      anon_sym_endforeach,
    ACTIONS(1127), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(398), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14624] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1129), 1,
      anon_sym_endforeach,
    ACTIONS(1131), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(399), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14664] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(267), 1,
      anon_sym_GT,
    ACTIONS(269), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [14688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(263), 1,
      anon_sym_GT,
    ACTIONS(265), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [14712] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1133), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14752] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1135), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14792] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1137), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14832] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1139), 1,
      anon_sym_endforeach,
    ACTIONS(1141), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(407), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14872] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1143), 1,
      anon_sym_endforeach,
    ACTIONS(1145), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(408), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14912] = 11,
    ACTIONS(533), 1,
      anon_sym_not,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(545), 1,
      anon_sym_and,
    ACTIONS(547), 1,
      anon_sym_or,
    ACTIONS(549), 1,
      anon_sym_in,
    ACTIONS(531), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(529), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [14952] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1147), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [14992] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1149), 1,
      sym_identifier,
    ACTIONS(1151), 1,
      anon_sym_endif,
    ACTIONS(1153), 1,
      anon_sym_foreach,
    ACTIONS(1155), 1,
      sym_comment,
    STATE(786), 1,
      sym_normal_command,
    STATE(917), 1,
      sym_if_command,
    STATE(1123), 2,
      sym_string,
      sym_listitem,
    STATE(361), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [15032] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1017), 1,
      sym_comment,
    ACTIONS(1157), 1,
      anon_sym_endforeach,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [15072] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1159), 1,
      anon_sym_COMMA,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [15108] = 11,
    ACTIONS(597), 1,
      anon_sym_SQUOTE,
    ACTIONS(600), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(608), 1,
      anon_sym_if,
    ACTIONS(1163), 1,
      ts_builtin_sym_end,
    ACTIONS(1165), 1,
      sym_identifier,
    ACTIONS(1168), 1,
      anon_sym_foreach,
    ACTIONS(1171), 1,
      sym_comment,
    STATE(784), 1,
      sym_normal_command,
    STATE(946), 1,
      sym_if_command,
    STATE(1108), 2,
      sym_string,
      sym_listitem,
    STATE(416), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [15148] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1149), 1,
      sym_identifier,
    ACTIONS(1153), 1,
      anon_sym_foreach,
    ACTIONS(1174), 1,
      anon_sym_endif,
    ACTIONS(1176), 1,
      sym_comment,
    STATE(786), 1,
      sym_normal_command,
    STATE(917), 1,
      sym_if_command,
    STATE(1123), 2,
      sym_string,
      sym_listitem,
    STATE(413), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [15188] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1178), 1,
      anon_sym_endforeach,
    ACTIONS(1180), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(412), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [15228] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(305), 1,
      anon_sym_GT,
    ACTIONS(307), 15,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [15252] = 2,
    ACTIONS(521), 7,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      sym_comment,
    ACTIONS(519), 10,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [15274] = 11,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(13), 1,
      anon_sym_if,
    ACTIONS(1007), 1,
      sym_identifier,
    ACTIONS(1009), 1,
      anon_sym_foreach,
    ACTIONS(1182), 1,
      anon_sym_endforeach,
    ACTIONS(1184), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(414), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [15314] = 4,
    ACTIONS(341), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(93), 5,
      anon_sym_QMARK,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
    ACTIONS(95), 5,
      anon_sym_not,
      anon_sym_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
    ACTIONS(338), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [15340] = 11,
    ACTIONS(597), 1,
      anon_sym_SQUOTE,
    ACTIONS(600), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(606), 1,
      anon_sym_endforeach,
    ACTIONS(608), 1,
      anon_sym_if,
    ACTIONS(1186), 1,
      sym_identifier,
    ACTIONS(1189), 1,
      anon_sym_foreach,
    ACTIONS(1192), 1,
      sym_comment,
    STATE(776), 1,
      sym_normal_command,
    STATE(898), 1,
      sym_if_command,
    STATE(1160), 2,
      sym_string,
      sym_listitem,
    STATE(423), 6,
      sym__unit,
      sym_operatorunit,
      sym_expression_statement,
      sym_if_condition,
      sym_foreach_command,
      aux_sym_source_file_repeat1,
  [15380] = 6,
    ACTIONS(1082), 1,
      anon_sym_LPAREN,
    ACTIONS(1100), 1,
      anon_sym_DOT,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    STATE(429), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(37), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [15410] = 11,
    ACTIONS(555), 1,
      anon_sym_not,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(567), 1,
      anon_sym_and,
    ACTIONS(569), 1,
      anon_sym_or,
    ACTIONS(571), 1,
      anon_sym_in,
    ACTIONS(553), 3,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_QMARK,
      sym_comment,
    ACTIONS(551), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [15450] = 5,
    ACTIONS(1198), 1,
      anon_sym_LBRACK,
    ACTIONS(1201), 1,
      anon_sym_DOT,
    STATE(428), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(61), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [15477] = 4,
    ACTIONS(1204), 1,
      anon_sym_DOT,
    STATE(442), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [15502] = 4,
    ACTIONS(1207), 1,
      anon_sym_DOT,
    STATE(442), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(78), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [15527] = 4,
    ACTIONS(1204), 1,
      anon_sym_DOT,
    STATE(442), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [15552] = 5,
    ACTIONS(1210), 1,
      anon_sym_LBRACK,
    ACTIONS(1213), 1,
      anon_sym_DOT,
    STATE(432), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(49), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [15579] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(683), 1,
      sym_identifier,
    ACTIONS(1216), 1,
      sym_number,
    STATE(444), 1,
      sym_normal_command,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(674), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [15618] = 4,
    ACTIONS(1204), 1,
      anon_sym_DOT,
    STATE(442), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [15643] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(683), 1,
      sym_identifier,
    ACTIONS(1218), 1,
      sym_number,
    STATE(444), 1,
      sym_normal_command,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(516), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [15682] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 1,
      anon_sym_LPAREN,
    ACTIONS(384), 1,
      anon_sym_SQUOTE,
    ACTIONS(386), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_LBRACK,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1220), 1,
      sym_number,
    STATE(290), 1,
      sym_normal_command,
    ACTIONS(382), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(289), 2,
      sym_string,
      sym_listitem,
    STATE(411), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [15721] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(839), 1,
      anon_sym_COMMA,
    ACTIONS(843), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [15754] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(967), 1,
      anon_sym_COMMA,
    ACTIONS(971), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [15787] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [15820] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(847), 1,
      anon_sym_COMMA,
    ACTIONS(851), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [15853] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(827), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [15882] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(855), 1,
      anon_sym_COMMA,
    ACTIONS(859), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [15915] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_SQUOTE,
    ACTIONS(293), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(701), 1,
      sym_identifier,
    ACTIONS(1222), 1,
      sym_number,
    STATE(84), 1,
      sym_normal_command,
    ACTIONS(289), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(74), 2,
      sym_string,
      sym_listitem,
    STATE(161), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [15954] = 4,
    ACTIONS(1224), 1,
      anon_sym_DOT,
    STATE(442), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(105), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [15979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16033] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(867), 1,
      anon_sym_COMMA,
    ACTIONS(871), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16066] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(819), 1,
      anon_sym_COMMA,
    ACTIONS(823), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16099] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(875), 1,
      anon_sym_COMMA,
    ACTIONS(879), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16132] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 1,
      anon_sym_LPAREN,
    ACTIONS(384), 1,
      anon_sym_SQUOTE,
    ACTIONS(386), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(390), 1,
      anon_sym_LBRACK,
    ACTIONS(807), 1,
      sym_identifier,
    ACTIONS(1227), 1,
      sym_number,
    STATE(290), 1,
      sym_normal_command,
    ACTIONS(382), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(289), 2,
      sym_string,
      sym_listitem,
    STATE(360), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [16171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16198] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(287), 1,
      anon_sym_LPAREN,
    ACTIONS(291), 1,
      anon_sym_SQUOTE,
    ACTIONS(293), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(297), 1,
      anon_sym_LBRACK,
    ACTIONS(701), 1,
      sym_identifier,
    ACTIONS(1229), 1,
      sym_number,
    STATE(84), 1,
      sym_normal_command,
    ACTIONS(289), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(74), 2,
      sym_string,
      sym_listitem,
    STATE(167), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [16237] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(947), 1,
      anon_sym_COMMA,
    ACTIONS(951), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16270] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(883), 1,
      anon_sym_COMMA,
    ACTIONS(887), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16303] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(939), 1,
      anon_sym_COMMA,
    ACTIONS(943), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16336] = 5,
    ACTIONS(1213), 1,
      anon_sym_DOT,
    ACTIONS(1231), 1,
      anon_sym_LBRACK,
    STATE(432), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(49), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [16363] = 5,
    ACTIONS(1201), 1,
      anon_sym_DOT,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    STATE(428), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(61), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [16390] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(927), 1,
      anon_sym_COMMA,
    ACTIONS(931), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16423] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(915), 1,
      anon_sym_COMMA,
    ACTIONS(919), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16456] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(811), 1,
      anon_sym_COMMA,
    ACTIONS(815), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16489] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(398), 1,
      anon_sym_LPAREN,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(408), 1,
      anon_sym_LBRACK,
    ACTIONS(685), 1,
      sym_identifier,
    ACTIONS(1235), 1,
      sym_number,
    STATE(295), 1,
      sym_normal_command,
    ACTIONS(400), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(278), 2,
      sym_string,
      sym_listitem,
    STATE(384), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [16528] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(115), 1,
      anon_sym_LPAREN,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(683), 1,
      sym_identifier,
    ACTIONS(1237), 1,
      sym_number,
    STATE(444), 1,
      sym_normal_command,
    ACTIONS(119), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(443), 2,
      sym_string,
      sym_listitem,
    STATE(515), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [16567] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_LPAREN,
    ACTIONS(324), 1,
      anon_sym_SQUOTE,
    ACTIONS(326), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(711), 1,
      sym_identifier,
    ACTIONS(1239), 1,
      sym_number,
    STATE(245), 1,
      sym_normal_command,
    ACTIONS(322), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(244), 2,
      sym_string,
      sym_listitem,
    STATE(390), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [16606] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(959), 1,
      anon_sym_COMMA,
    ACTIONS(963), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16639] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(975), 1,
      anon_sym_COMMA,
    ACTIONS(979), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16672] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(999), 1,
      anon_sym_COMMA,
    ACTIONS(1003), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16705] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(398), 1,
      anon_sym_LPAREN,
    ACTIONS(402), 1,
      anon_sym_SQUOTE,
    ACTIONS(404), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(408), 1,
      anon_sym_LBRACK,
    ACTIONS(685), 1,
      sym_identifier,
    ACTIONS(1241), 1,
      sym_number,
    STATE(295), 1,
      sym_normal_command,
    ACTIONS(400), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(278), 2,
      sym_string,
      sym_listitem,
    STATE(367), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [16744] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(320), 1,
      anon_sym_LPAREN,
    ACTIONS(324), 1,
      anon_sym_SQUOTE,
    ACTIONS(326), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(711), 1,
      sym_identifier,
    ACTIONS(1243), 1,
      sym_number,
    STATE(245), 1,
      sym_normal_command,
    ACTIONS(322), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(244), 2,
      sym_string,
      sym_listitem,
    STATE(364), 4,
      sym_bool,
      sym_list,
      sym__logic_unit,
      sym_expression_statement,
  [16783] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(983), 1,
      anon_sym_COMMA,
    ACTIONS(987), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16816] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(991), 1,
      anon_sym_COMMA,
    ACTIONS(995), 1,
      anon_sym_RPAREN,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16849] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1245), 1,
      anon_sym_COMMA,
    ACTIONS(1248), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16879] = 2,
    ACTIONS(173), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(171), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [16899] = 4,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(506), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [16923] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1251), 1,
      anon_sym_COMMA,
    ACTIONS(1254), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [16953] = 4,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(506), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [16977] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1257), 1,
      anon_sym_COMMA,
    ACTIONS(1260), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17007] = 4,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(506), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(78), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17031] = 4,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(506), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17055] = 2,
    ACTIONS(179), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(177), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17075] = 2,
    ACTIONS(183), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(181), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17095] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1263), 1,
      anon_sym_COMMA,
    ACTIONS(1266), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17125] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1269), 1,
      anon_sym_COMMA,
    ACTIONS(1272), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17155] = 2,
    ACTIONS(133), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(131), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17175] = 2,
    ACTIONS(149), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(147), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17195] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1275), 1,
      anon_sym_COMMA,
    ACTIONS(1278), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17225] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1281), 1,
      anon_sym_COMMA,
    ACTIONS(1284), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17255] = 3,
    ACTIONS(1233), 1,
      anon_sym_LBRACK,
    ACTIONS(63), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(61), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1287), 1,
      anon_sym_COMMA,
    ACTIONS(1290), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 1,
      anon_sym_GT,
    ACTIONS(521), 13,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17329] = 2,
    ACTIONS(153), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(151), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17349] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1293), 1,
      anon_sym_COMMA,
    ACTIONS(1296), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17379] = 4,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(475), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1301), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1299), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17403] = 2,
    ACTIONS(157), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(155), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17423] = 4,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(473), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1301), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1299), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1303), 1,
      anon_sym_COMMA,
    ACTIONS(1306), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17477] = 3,
    ACTIONS(157), 1,
      anon_sym_LBRACK,
    ACTIONS(144), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(141), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17499] = 2,
    ACTIONS(144), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(141), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17519] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1309), 1,
      anon_sym_COMMA,
    ACTIONS(1312), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1315), 1,
      anon_sym_COMMA,
    ACTIONS(1318), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17579] = 2,
    ACTIONS(163), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(161), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17599] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1321), 1,
      anon_sym_COMMA,
    ACTIONS(1324), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17629] = 3,
    ACTIONS(1198), 1,
      anon_sym_LBRACK,
    ACTIONS(63), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(61), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17651] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1327), 1,
      anon_sym_COMMA,
    ACTIONS(1330), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17681] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1336), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17711] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1339), 1,
      anon_sym_COMMA,
    ACTIONS(1342), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17741] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1345), 1,
      anon_sym_COMMA,
    ACTIONS(1348), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17771] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1351), 1,
      anon_sym_COMMA,
    ACTIONS(1354), 1,
      anon_sym_RPAREN,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17801] = 4,
    ACTIONS(1357), 1,
      anon_sym_DOT,
    STATE(506), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(105), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    ACTIONS(1159), 1,
      anon_sym_COMMA,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17855] = 4,
    STATE(508), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(1362), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1364), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1360), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17878] = 2,
    ACTIONS(222), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(220), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17897] = 2,
    ACTIONS(242), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
    ACTIONS(240), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17916] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1367), 1,
      anon_sym_COMMA,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(93), 9,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17943] = 4,
    STATE(508), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(29), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1372), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1370), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [17966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(505), 1,
      anon_sym_GT,
    ACTIONS(507), 12,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [17987] = 4,
    STATE(508), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(29), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18010] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(1378), 1,
      anon_sym_not,
    ACTIONS(1380), 1,
      anon_sym_and,
    ACTIONS(1382), 1,
      anon_sym_or,
    ACTIONS(1384), 1,
      anon_sym_in,
    ACTIONS(531), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [18047] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(1378), 1,
      anon_sym_not,
    ACTIONS(1380), 1,
      anon_sym_and,
    ACTIONS(1382), 1,
      anon_sym_or,
    ACTIONS(1384), 1,
      anon_sym_in,
    ACTIONS(579), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [18084] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(1386), 1,
      anon_sym_not,
    ACTIONS(1388), 1,
      anon_sym_and,
    ACTIONS(1390), 1,
      anon_sym_or,
    ACTIONS(1392), 1,
      anon_sym_in,
    ACTIONS(553), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [18121] = 4,
    STATE(508), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(29), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18144] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(1386), 1,
      anon_sym_not,
    ACTIONS(1388), 1,
      anon_sym_and,
    ACTIONS(1390), 1,
      anon_sym_or,
    ACTIONS(1392), 1,
      anon_sym_in,
    ACTIONS(575), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_COLON,
  [18181] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(100), 1,
      anon_sym_COLON,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [18208] = 4,
    STATE(508), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(29), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18231] = 6,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(1394), 1,
      anon_sym_LPAREN,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(631), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1084), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(1086), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18257] = 6,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(1398), 1,
      anon_sym_LPAREN,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(661), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1086), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1084), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [18283] = 6,
    ACTIONS(1398), 1,
      anon_sym_LPAREN,
    ACTIONS(1402), 1,
      anon_sym_LBRACK,
    ACTIONS(1404), 1,
      anon_sym_DOT,
    STATE(554), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(37), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [18309] = 2,
    ACTIONS(1301), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1299), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18327] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18345] = 4,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(475), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1409), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1407), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18367] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18385] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18403] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18421] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18439] = 6,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(1411), 1,
      anon_sym_LPAREN,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(606), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1086), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1084), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [18465] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18483] = 6,
    ACTIONS(1398), 1,
      anon_sym_LPAREN,
    ACTIONS(1404), 1,
      anon_sym_DOT,
    ACTIONS(1415), 1,
      anon_sym_LBRACK,
    STATE(554), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(37), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [18509] = 2,
    ACTIONS(313), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(311), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18527] = 6,
    ACTIONS(1411), 1,
      anon_sym_LPAREN,
    ACTIONS(1418), 1,
      anon_sym_LBRACK,
    ACTIONS(1421), 1,
      anon_sym_DOT,
    STATE(550), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(37), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [18553] = 2,
    ACTIONS(313), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(311), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18571] = 6,
    ACTIONS(1394), 1,
      anon_sym_LPAREN,
    ACTIONS(1424), 1,
      anon_sym_LBRACK,
    ACTIONS(1426), 1,
      anon_sym_DOT,
    STATE(581), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(37), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(39), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18597] = 2,
    ACTIONS(273), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(271), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_GT,
    ACTIONS(1429), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(93), 8,
      anon_sym_not,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_in,
  [18637] = 2,
    ACTIONS(269), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(267), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18655] = 2,
    ACTIONS(265), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(263), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18673] = 2,
    ACTIONS(307), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(305), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [18691] = 6,
    ACTIONS(1394), 1,
      anon_sym_LPAREN,
    ACTIONS(1426), 1,
      anon_sym_DOT,
    ACTIONS(1432), 1,
      anon_sym_LBRACK,
    STATE(581), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(37), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(39), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18717] = 6,
    ACTIONS(1411), 1,
      anon_sym_LPAREN,
    ACTIONS(1421), 1,
      anon_sym_DOT,
    ACTIONS(1435), 1,
      anon_sym_LBRACK,
    STATE(550), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(39), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(37), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [18743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [18764] = 4,
    ACTIONS(1443), 1,
      anon_sym_DOT,
    STATE(576), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18785] = 4,
    ACTIONS(1446), 1,
      anon_sym_DOT,
    STATE(576), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(78), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(80), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [18827] = 4,
    ACTIONS(1443), 1,
      anon_sym_DOT,
    STATE(576), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18848] = 4,
    ACTIONS(1451), 1,
      anon_sym_DOT,
    STATE(577), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(73), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18869] = 5,
    ACTIONS(1454), 1,
      anon_sym_LBRACK,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    STATE(556), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(49), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [18892] = 4,
    ACTIONS(1460), 1,
      anon_sym_DOT,
    STATE(577), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(78), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(80), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18913] = 4,
    ACTIONS(1451), 1,
      anon_sym_DOT,
    STATE(577), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(73), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [18955] = 4,
    ACTIONS(1451), 1,
      anon_sym_DOT,
    STATE(577), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(73), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [18976] = 5,
    ACTIONS(1465), 1,
      anon_sym_LBRACK,
    ACTIONS(1468), 1,
      anon_sym_DOT,
    STATE(565), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(49), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [18999] = 5,
    ACTIONS(1471), 1,
      anon_sym_LBRACK,
    ACTIONS(1474), 1,
      anon_sym_DOT,
    STATE(548), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(61), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [19022] = 5,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1477), 1,
      anon_sym_LBRACK,
    STATE(556), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(49), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [19045] = 5,
    ACTIONS(1479), 1,
      anon_sym_LBRACK,
    ACTIONS(1482), 1,
      anon_sym_DOT,
    STATE(553), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(61), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [19068] = 5,
    ACTIONS(1482), 1,
      anon_sym_DOT,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    STATE(553), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(61), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [19091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19112] = 5,
    ACTIONS(1468), 1,
      anon_sym_DOT,
    ACTIONS(1489), 1,
      anon_sym_LBRACK,
    STATE(565), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(51), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(49), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [19135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19156] = 4,
    ACTIONS(1443), 1,
      anon_sym_DOT,
    STATE(576), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19177] = 4,
    ACTIONS(1493), 1,
      anon_sym_DOT,
    STATE(566), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(105), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(107), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19219] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19240] = 3,
    ACTIONS(1504), 1,
      anon_sym_QMARK,
    ACTIONS(1502), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1500), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [19259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1506), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19280] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1086), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [19305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1508), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19326] = 5,
    ACTIONS(1510), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_DOT,
    STATE(585), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(49), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(51), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19349] = 5,
    ACTIONS(1516), 1,
      anon_sym_LBRACK,
    ACTIONS(1519), 1,
      anon_sym_DOT,
    STATE(579), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(61), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1522), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19393] = 4,
    ACTIONS(1524), 1,
      anon_sym_DOT,
    STATE(576), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(105), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(107), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19414] = 4,
    ACTIONS(1527), 1,
      anon_sym_DOT,
    STATE(577), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(105), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(107), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19435] = 4,
    ACTIONS(1530), 1,
      anon_sym_DOT,
    STATE(566), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19456] = 4,
    ACTIONS(1533), 1,
      anon_sym_DOT,
    STATE(566), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(78), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(80), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19477] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19498] = 4,
    ACTIONS(1530), 1,
      anon_sym_DOT,
    STATE(566), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1540), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1542), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19582] = 4,
    ACTIONS(1530), 1,
      anon_sym_DOT,
    STATE(566), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19603] = 5,
    ACTIONS(1513), 1,
      anon_sym_DOT,
    ACTIONS(1544), 1,
      anon_sym_LBRACK,
    STATE(585), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(49), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(51), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19647] = 5,
    ACTIONS(1519), 1,
      anon_sym_DOT,
    ACTIONS(1548), 1,
      anon_sym_LBRACK,
    STATE(579), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(61), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [19670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1552), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19712] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 1,
      anon_sym_RPAREN,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [19733] = 5,
    ACTIONS(1474), 1,
      anon_sym_DOT,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    STATE(548), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(63), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(61), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [19756] = 3,
    ACTIONS(1556), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [19774] = 4,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(596), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(78), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [19794] = 3,
    ACTIONS(1516), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [19812] = 4,
    ACTIONS(1558), 1,
      anon_sym_DOT,
    STATE(596), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(105), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [19832] = 2,
    ACTIONS(161), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(163), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [19848] = 2,
    ACTIONS(1563), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1561), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [19864] = 2,
    ACTIONS(155), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(157), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [19880] = 2,
    ACTIONS(151), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(153), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [19896] = 2,
    ACTIONS(171), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(173), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [19912] = 2,
    ACTIONS(171), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(173), 7,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [19928] = 4,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(656), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [19948] = 2,
    ACTIONS(147), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(149), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [19964] = 4,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(656), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(80), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(78), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [19984] = 4,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(656), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [20004] = 3,
    ACTIONS(1548), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20022] = 2,
    ACTIONS(177), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(179), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20038] = 2,
    ACTIONS(181), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(183), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20054] = 2,
    ACTIONS(131), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(133), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20070] = 2,
    ACTIONS(1567), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1565), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20086] = 4,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(638), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1299), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(1301), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [20106] = 2,
    ACTIONS(131), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(133), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20122] = 3,
    ACTIONS(157), 1,
      anon_sym_LBRACK,
    ACTIONS(141), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(144), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20140] = 2,
    ACTIONS(181), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(183), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20156] = 2,
    ACTIONS(177), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(179), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20172] = 2,
    ACTIONS(1571), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1569), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20188] = 4,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(648), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1299), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(1301), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [20208] = 2,
    ACTIONS(151), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(153), 7,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20224] = 4,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(605), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1301), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1299), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [20244] = 4,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(603), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1301), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1299), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [20264] = 4,
    ACTIONS(1573), 1,
      anon_sym_DOT,
    STATE(622), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(105), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(107), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [20284] = 2,
    ACTIONS(171), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(173), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20300] = 2,
    ACTIONS(1578), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1576), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20316] = 2,
    ACTIONS(155), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(157), 7,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20332] = 2,
    ACTIONS(161), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(163), 7,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20348] = 4,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(596), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [20368] = 2,
    ACTIONS(1582), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1580), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20384] = 2,
    ACTIONS(1586), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1584), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20400] = 4,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(594), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1301), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1299), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [20420] = 4,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(622), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [20440] = 2,
    ACTIONS(1590), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1588), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20456] = 2,
    ACTIONS(1594), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1592), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20472] = 2,
    ACTIONS(1598), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1596), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20488] = 2,
    ACTIONS(141), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(144), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20504] = 3,
    ACTIONS(1479), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(63), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20522] = 4,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(660), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1301), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1299), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [20542] = 4,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(622), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(78), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(80), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [20562] = 2,
    ACTIONS(1602), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1600), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20578] = 2,
    ACTIONS(1606), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1604), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20594] = 2,
    ACTIONS(147), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(149), 7,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20610] = 4,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(656), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [20630] = 2,
    ACTIONS(1598), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1596), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20646] = 2,
    ACTIONS(141), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(144), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20662] = 3,
    ACTIONS(1471), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(63), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20680] = 2,
    ACTIONS(147), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(149), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20696] = 2,
    ACTIONS(1610), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1608), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20712] = 4,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(622), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [20732] = 2,
    ACTIONS(141), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(144), 7,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20748] = 3,
    ACTIONS(157), 1,
      anon_sym_LBRACK,
    ACTIONS(141), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(144), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20766] = 2,
    ACTIONS(1614), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1612), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20782] = 2,
    ACTIONS(1502), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1500), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20798] = 3,
    ACTIONS(1485), 1,
      anon_sym_LBRACK,
    ACTIONS(61), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(63), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(364), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1616), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [20834] = 2,
    ACTIONS(1620), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1618), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20850] = 4,
    ACTIONS(1622), 1,
      anon_sym_DOT,
    STATE(656), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(107), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(105), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [20870] = 2,
    ACTIONS(1614), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1612), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [20886] = 2,
    ACTIONS(177), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(179), 7,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20902] = 2,
    ACTIONS(131), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(133), 7,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20918] = 4,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(596), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [20938] = 4,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(596), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(73), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(71), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [20958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1437), 5,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1441), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [20976] = 2,
    ACTIONS(155), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(157), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [20992] = 2,
    ACTIONS(151), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(153), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [21008] = 2,
    ACTIONS(161), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(163), 6,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [21024] = 4,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(622), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(71), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(73), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [21044] = 2,
    ACTIONS(181), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(183), 7,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [21060] = 2,
    ACTIONS(1627), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1625), 9,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_foreach,
      sym_keyword_break,
      sym_keyword_continue,
  [21076] = 3,
    ACTIONS(157), 1,
      anon_sym_LBRACK,
    ACTIONS(141), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(144), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [21094] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1632), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [21123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21140] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1639), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [21169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1644), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21186] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(535), 1,
      anon_sym_EQ_EQ,
    ACTIONS(537), 1,
      anon_sym_BANG_EQ,
    ACTIONS(539), 1,
      anon_sym_GT_EQ,
    ACTIONS(541), 1,
      anon_sym_GT,
    ACTIONS(543), 1,
      anon_sym_LT,
    ACTIONS(1378), 1,
      anon_sym_not,
    ACTIONS(1380), 1,
      anon_sym_and,
    ACTIONS(1382), 1,
      anon_sym_or,
    ACTIONS(1384), 1,
      anon_sym_in,
  [21217] = 4,
    STATE(686), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(228), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1372), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1370), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [21236] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1646), 1,
      anon_sym_SQUOTE,
    ACTIONS(1648), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      sym_identifier,
    STATE(612), 1,
      sym_normal_command,
    STATE(618), 1,
      sym_string,
    STATE(1086), 1,
      sym_listitem,
    STATE(778), 2,
      sym_list,
      sym_expression_statement,
  [21265] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_EQ_EQ,
    ACTIONS(559), 1,
      anon_sym_BANG_EQ,
    ACTIONS(561), 1,
      anon_sym_GT_EQ,
    ACTIONS(563), 1,
      anon_sym_GT,
    ACTIONS(565), 1,
      anon_sym_LT,
    ACTIONS(1386), 1,
      anon_sym_not,
    ACTIONS(1388), 1,
      anon_sym_and,
    ACTIONS(1390), 1,
      anon_sym_or,
    ACTIONS(1392), 1,
      anon_sym_in,
  [21296] = 4,
    STATE(727), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(236), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [21315] = 4,
    STATE(686), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(228), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [21334] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21368] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21436] = 4,
    STATE(686), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(1362), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1654), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1360), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [21455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1637), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1659), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1659), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21506] = 2,
    ACTIONS(220), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(222), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [21521] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(1411), 1,
      anon_sym_LPAREN,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    ACTIONS(1663), 1,
      anon_sym_SLASH,
    STATE(606), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1661), 4,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_SLASH_EQ,
  [21546] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1665), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [21575] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(1394), 1,
      anon_sym_LPAREN,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    ACTIONS(1670), 1,
      anon_sym_SLASH,
    STATE(631), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1668), 4,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_SLASH_EQ,
  [21600] = 4,
    STATE(686), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(228), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [21619] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1672), 1,
      anon_sym_SQUOTE,
    ACTIONS(1674), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1676), 1,
      anon_sym_LBRACK,
    ACTIONS(1678), 1,
      sym_identifier,
    STATE(620), 1,
      sym_normal_command,
    STATE(621), 1,
      sym_string,
    STATE(1152), 1,
      sym_listitem,
    STATE(803), 2,
      sym_list,
      sym_expression_statement,
  [21648] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1680), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [21677] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1683), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [21706] = 4,
    STATE(698), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(1362), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1686), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1360), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [21725] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1689), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [21754] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1692), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [21783] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1695), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [21812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1700), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21829] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1702), 1,
      anon_sym_SQUOTE,
    ACTIONS(1704), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1706), 1,
      anon_sym_LBRACK,
    ACTIONS(1708), 1,
      sym_identifier,
    STATE(630), 1,
      sym_normal_command,
    STATE(637), 1,
      sym_string,
    STATE(1137), 1,
      sym_listitem,
    STATE(767), 2,
      sym_list,
      sym_expression_statement,
  [21858] = 4,
    STATE(698), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(189), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [21877] = 2,
    ACTIONS(220), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(222), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [21892] = 4,
    STATE(698), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(189), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [21911] = 4,
    STATE(686), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(228), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [21930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1659), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1659), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1659), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1659), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [21998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1659), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1657), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1659), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22032] = 2,
    ACTIONS(240), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(242), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [22047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1644), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22064] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1710), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22093] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1713), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22122] = 2,
    ACTIONS(240), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
    ACTIONS(242), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [22137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1644), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22154] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1716), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1644), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1700), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1301), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22236] = 2,
    ACTIONS(240), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(242), 6,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [22251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1301), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22270] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1719), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22299] = 4,
    STATE(727), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(1722), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1362), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1360), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [22318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1700), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1700), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1700), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22369] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1725), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1700), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22415] = 4,
    STATE(727), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(236), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [22434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1728), 4,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
    ACTIONS(1730), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_number,
  [22451] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1732), 1,
      anon_sym_SQUOTE,
    ACTIONS(1734), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1736), 1,
      anon_sym_LBRACK,
    ACTIONS(1738), 1,
      sym_identifier,
    STATE(490), 1,
      sym_normal_command,
    STATE(492), 1,
      sym_string,
    STATE(1157), 1,
      sym_listitem,
    STATE(525), 2,
      sym_list,
      sym_expression_statement,
  [22480] = 4,
    STATE(727), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(236), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1372), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1370), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [22499] = 2,
    ACTIONS(220), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(222), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      anon_sym_DOT,
      sym_comment,
  [22514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1700), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1644), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22548] = 4,
    STATE(698), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(189), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [22567] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(1082), 1,
      anon_sym_LPAREN,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    ACTIONS(1742), 1,
      anon_sym_SLASH,
    STATE(476), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1740), 4,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_SLASH_EQ,
  [22592] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1744), 4,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
    ACTIONS(1746), 5,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym_number,
  [22609] = 4,
    STATE(698), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(189), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1372), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1370), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [22628] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(1398), 1,
      anon_sym_LPAREN,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    ACTIONS(1750), 1,
      anon_sym_SLASH,
    STATE(661), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1748), 4,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_SLASH_EQ,
  [22653] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1752), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22682] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1755), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22711] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1758), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22740] = 4,
    STATE(727), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(236), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1374), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [22759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1700), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22776] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1761), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1644), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1644), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22839] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(123), 1,
      anon_sym_LBRACK,
    ACTIONS(1764), 1,
      sym_identifier,
    STATE(723), 1,
      sym_normal_command,
    STATE(725), 1,
      sym_string,
    STATE(1112), 1,
      sym_listitem,
    STATE(818), 2,
      sym_list,
      sym_expression_statement,
  [22868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 4,
      anon_sym_LPAREN,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_LBRACK,
      sym_number,
    ACTIONS(1644), 5,
      anon_sym_true,
      anon_sym_false,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_not,
  [22885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    ACTIONS(1766), 1,
      anon_sym_RBRACK,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [22914] = 2,
    ACTIONS(265), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(263), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [22928] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [22942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(769), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [22960] = 2,
    ACTIONS(271), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(273), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [22974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(769), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [22992] = 2,
    ACTIONS(267), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(269), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23006] = 2,
    ACTIONS(313), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(311), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23020] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(620), 1,
      anon_sym_LBRACK,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1629), 1,
      anon_sym_COMMA,
    STATE(225), 1,
      aux_sym_expression_statement_repeat1,
    STATE(780), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23046] = 2,
    ACTIONS(244), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23060] = 2,
    ACTIONS(311), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(313), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23074] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23088] = 2,
    ACTIONS(1301), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1299), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23102] = 2,
    ACTIONS(244), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23116] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(769), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(1769), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1362), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [23134] = 2,
    ACTIONS(244), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23148] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1772), 1,
      anon_sym_EQ_EQ,
    ACTIONS(1774), 1,
      anon_sym_BANG_EQ,
    ACTIONS(1776), 1,
      anon_sym_GT_EQ,
    ACTIONS(1778), 1,
      anon_sym_GT,
    ACTIONS(1780), 1,
      anon_sym_LT,
    ACTIONS(1782), 1,
      anon_sym_and,
    ACTIONS(1784), 1,
      anon_sym_or,
    ACTIONS(1786), 1,
      anon_sym_in,
  [23176] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23190] = 2,
    ACTIONS(244), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23204] = 2,
    ACTIONS(244), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23218] = 2,
    ACTIONS(263), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(265), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23232] = 4,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(594), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1409), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1407), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23250] = 2,
    ACTIONS(244), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(246), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23264] = 2,
    ACTIONS(1299), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(1301), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(769), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [23296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(769), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1372), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [23314] = 2,
    ACTIONS(311), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(313), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23328] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23342] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      anon_sym_EQ_EQ,
    ACTIONS(1790), 1,
      anon_sym_BANG_EQ,
    ACTIONS(1792), 1,
      anon_sym_GT_EQ,
    ACTIONS(1794), 1,
      anon_sym_GT,
    ACTIONS(1796), 1,
      anon_sym_LT,
    ACTIONS(1798), 1,
      anon_sym_and,
    ACTIONS(1800), 1,
      anon_sym_or,
    ACTIONS(1802), 1,
      anon_sym_in,
  [23370] = 4,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(638), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1409), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1407), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [23388] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23402] = 4,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(605), 1,
      aux_sym_expression_statement_repeat1,
    ACTIONS(1409), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1407), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23420] = 2,
    ACTIONS(307), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(305), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23434] = 2,
    ACTIONS(265), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(263), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23448] = 2,
    ACTIONS(307), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(305), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23462] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23476] = 2,
    ACTIONS(273), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(271), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23490] = 2,
    ACTIONS(273), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(271), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23504] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23518] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23532] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23546] = 2,
    ACTIONS(313), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(311), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23560] = 2,
    ACTIONS(313), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(311), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23574] = 2,
    ACTIONS(269), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(267), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23588] = 2,
    ACTIONS(313), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(311), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23602] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23616] = 2,
    ACTIONS(305), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
    ACTIONS(307), 5,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
  [23630] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23644] = 2,
    ACTIONS(1301), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(1299), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23658] = 2,
    ACTIONS(269), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(267), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23672] = 2,
    ACTIONS(246), 4,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_SLASH,
      anon_sym_PLUS,
      sym_comment,
    ACTIONS(244), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [23686] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1807), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1810), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23732] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1813), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23755] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1816), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23778] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1819), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23801] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1822), 1,
      sym_identifier,
    STATE(6), 1,
      sym_listitem,
    STATE(7), 1,
      sym_normal_command,
    STATE(29), 1,
      sym_expression_statement,
    STATE(1139), 1,
      sym_string,
  [23826] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1824), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23849] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1824), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23872] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1827), 1,
      sym_identifier,
    STATE(586), 1,
      sym_listitem,
    STATE(588), 1,
      sym_normal_command,
    STATE(607), 1,
      sym_expression_statement,
    STATE(1143), 1,
      sym_string,
  [23897] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1829), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23920] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1832), 1,
      sym_identifier,
    STATE(573), 1,
      sym_listitem,
    STATE(574), 1,
      sym_normal_command,
    STATE(595), 1,
      sym_expression_statement,
    STATE(1143), 1,
      sym_string,
  [23945] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1829), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23968] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1301), 7,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [23981] = 3,
    ACTIONS(1834), 1,
      anon_sym_QMARK,
    ACTIONS(1502), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1500), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [23996] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1836), 1,
      sym_identifier,
    STATE(110), 1,
      sym_listitem,
    STATE(113), 1,
      sym_normal_command,
    STATE(141), 1,
      sym_expression_statement,
    STATE(1135), 1,
      sym_string,
  [24021] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1838), 1,
      sym_identifier,
    STATE(122), 1,
      sym_listitem,
    STATE(123), 1,
      sym_normal_command,
    STATE(138), 1,
      sym_expression_statement,
    STATE(1145), 1,
      sym_string,
  [24046] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1840), 1,
      sym_identifier,
    STATE(552), 1,
      sym_listitem,
    STATE(560), 1,
      sym_normal_command,
    STATE(636), 1,
      sym_expression_statement,
    STATE(1154), 1,
      sym_string,
  [24071] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1842), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24094] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1845), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24117] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1848), 1,
      sym_identifier,
    STATE(109), 1,
      sym_normal_command,
    STATE(119), 1,
      sym_listitem,
    STATE(136), 1,
      sym_expression_statement,
    STATE(1135), 1,
      sym_string,
  [24142] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1850), 1,
      sym_identifier,
    STATE(557), 1,
      sym_listitem,
    STATE(558), 1,
      sym_normal_command,
    STATE(645), 1,
      sym_expression_statement,
    STATE(1158), 1,
      sym_string,
  [24167] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1852), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24190] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1855), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1858), 1,
      sym_identifier,
    STATE(102), 1,
      sym_normal_command,
    STATE(104), 1,
      sym_listitem,
    STATE(147), 1,
      sym_expression_statement,
    STATE(1145), 1,
      sym_string,
  [24238] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1860), 1,
      sym_identifier,
    STATE(454), 1,
      sym_listitem,
    STATE(455), 1,
      sym_normal_command,
    STATE(485), 1,
      sym_expression_statement,
    STATE(1162), 1,
      sym_string,
  [24263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1862), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24286] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1862), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24309] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1865), 1,
      sym_identifier,
    STATE(559), 1,
      sym_listitem,
    STATE(561), 1,
      sym_normal_command,
    STATE(653), 1,
      sym_expression_statement,
    STATE(1154), 1,
      sym_string,
  [24334] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1867), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24357] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1870), 1,
      sym_identifier,
    STATE(426), 1,
      sym_normal_command,
    STATE(430), 1,
      sym_listitem,
    STATE(500), 1,
      sym_expression_statement,
    STATE(1162), 1,
      sym_string,
  [24382] = 3,
    ACTIONS(1872), 1,
      anon_sym_QMARK,
    ACTIONS(1502), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1500), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [24397] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1874), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24420] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1877), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1880), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24466] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1883), 1,
      sym_identifier,
    STATE(212), 1,
      sym_normal_command,
    STATE(215), 1,
      sym_listitem,
    STATE(263), 1,
      sym_expression_statement,
    STATE(1149), 1,
      sym_string,
  [24491] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1885), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24514] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1885), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24537] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1888), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24560] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1888), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24583] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1891), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24606] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1894), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24629] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1897), 1,
      sym_identifier,
    STATE(98), 1,
      sym_normal_command,
    STATE(99), 1,
      sym_listitem,
    STATE(157), 1,
      sym_expression_statement,
    STATE(1124), 1,
      sym_string,
  [24654] = 3,
    ACTIONS(1899), 1,
      anon_sym_QMARK,
    ACTIONS(1502), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1500), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [24669] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1901), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24692] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1904), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24715] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1904), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24738] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1907), 1,
      sym_identifier,
    STATE(124), 1,
      sym_listitem,
    STATE(126), 1,
      sym_normal_command,
    STATE(194), 1,
      sym_expression_statement,
    STATE(1124), 1,
      sym_string,
  [24763] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1909), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24786] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24809] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1915), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1915), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24855] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1813), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24878] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1918), 1,
      sym_identifier,
    STATE(563), 1,
      sym_listitem,
    STATE(592), 1,
      sym_normal_command,
    STATE(593), 1,
      sym_expression_statement,
    STATE(1158), 1,
      sym_string,
  [24903] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1920), 1,
      sym_identifier,
    STATE(203), 1,
      sym_normal_command,
    STATE(204), 1,
      sym_listitem,
    STATE(293), 1,
      sym_expression_statement,
    STATE(1149), 1,
      sym_string,
  [24928] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1922), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24951] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1925), 1,
      anon_sym_RBRACK,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [24974] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1928), 1,
      sym_identifier,
    STATE(5), 1,
      sym_listitem,
    STATE(14), 1,
      sym_normal_command,
    STATE(35), 1,
      sym_expression_statement,
    STATE(1139), 1,
      sym_string,
  [24999] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_RBRACK,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [25022] = 2,
    ACTIONS(1571), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1569), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25034] = 2,
    ACTIONS(1582), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1580), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [25046] = 5,
    ACTIONS(1930), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1932), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25064] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1938), 1,
      anon_sym_endif,
    ACTIONS(1940), 1,
      anon_sym_elif,
    ACTIONS(1942), 1,
      anon_sym_else,
    STATE(1233), 1,
      sym_else_command,
    STATE(998), 2,
      sym_elseif_command,
      aux_sym_if_condition_repeat1,
  [25084] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1944), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1932), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25102] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1946), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1932), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25120] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1946), 1,
      anon_sym_SQUOTE,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1948), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25138] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1944), 1,
      anon_sym_SQUOTE,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1948), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_elif,
    ACTIONS(1942), 1,
      anon_sym_else,
    ACTIONS(1952), 1,
      anon_sym_endif,
    STATE(1183), 1,
      sym_else_command,
    STATE(867), 2,
      sym_elseif_command,
      aux_sym_if_condition_repeat1,
  [25176] = 2,
    ACTIONS(1614), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1612), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25188] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1954), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1956), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(868), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25206] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1954), 1,
      anon_sym_SQUOTE,
    ACTIONS(1958), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(871), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25224] = 2,
    ACTIONS(1620), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1618), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25236] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1960), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1962), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(869), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25254] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1960), 1,
      anon_sym_SQUOTE,
    ACTIONS(1964), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(870), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25272] = 2,
    ACTIONS(1614), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1612), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25284] = 2,
    ACTIONS(1610), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1608), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25296] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1966), 1,
      anon_sym_SQUOTE,
    ACTIONS(1968), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(963), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25314] = 2,
    ACTIONS(1598), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1596), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25326] = 2,
    ACTIONS(1606), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1604), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25338] = 2,
    ACTIONS(1598), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1596), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25350] = 2,
    ACTIONS(1502), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1500), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25362] = 2,
    ACTIONS(1563), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1561), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [25374] = 2,
    ACTIONS(1590), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1588), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25386] = 2,
    ACTIONS(1586), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25398] = 2,
    ACTIONS(1610), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1608), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25410] = 2,
    ACTIONS(1614), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1612), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25422] = 2,
    ACTIONS(1620), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1618), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25434] = 2,
    ACTIONS(1571), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1569), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [25446] = 2,
    ACTIONS(1594), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1592), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25458] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1970), 1,
      anon_sym_SQUOTE,
    ACTIONS(1972), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(899), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25476] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1970), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1974), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(900), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25494] = 2,
    ACTIONS(1571), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1569), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25506] = 2,
    ACTIONS(1567), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1565), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25518] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_elif,
    ACTIONS(1942), 1,
      anon_sym_else,
    ACTIONS(1976), 1,
      anon_sym_endif,
    STATE(1201), 1,
      sym_else_command,
    STATE(906), 2,
      sym_elseif_command,
      aux_sym_if_condition_repeat1,
  [25538] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1978), 1,
      anon_sym_SQUOTE,
    ACTIONS(1948), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25556] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1978), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1932), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25574] = 2,
    ACTIONS(1578), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1576), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25586] = 2,
    ACTIONS(1620), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1618), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [25598] = 2,
    ACTIONS(1614), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1612), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [25610] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1980), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1982), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(866), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25628] = 2,
    ACTIONS(1606), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1604), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25640] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_elif,
    ACTIONS(1942), 1,
      anon_sym_else,
    ACTIONS(1984), 1,
      anon_sym_endif,
    STATE(1221), 1,
      sym_else_command,
    STATE(998), 2,
      sym_elseif_command,
      aux_sym_if_condition_repeat1,
  [25660] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1980), 1,
      anon_sym_SQUOTE,
    ACTIONS(1986), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(915), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25678] = 2,
    ACTIONS(1586), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1584), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25690] = 2,
    ACTIONS(1563), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1561), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25702] = 2,
    ACTIONS(1578), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1576), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [25714] = 2,
    ACTIONS(1627), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1625), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [25726] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_elif,
    ACTIONS(1942), 1,
      anon_sym_else,
    ACTIONS(1988), 1,
      anon_sym_endif,
    STATE(1181), 1,
      sym_else_command,
    STATE(998), 2,
      sym_elseif_command,
      aux_sym_if_condition_repeat1,
  [25746] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1990), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1932), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25764] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1990), 1,
      anon_sym_SQUOTE,
    ACTIONS(1948), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25782] = 5,
    ACTIONS(1930), 1,
      anon_sym_SQUOTE,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1948), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25800] = 2,
    ACTIONS(1598), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1596), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25812] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_elif,
    ACTIONS(1942), 1,
      anon_sym_else,
    ACTIONS(1992), 1,
      anon_sym_endif,
    STATE(1236), 1,
      sym_else_command,
    STATE(912), 2,
      sym_elseif_command,
      aux_sym_if_condition_repeat1,
  [25832] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1994), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1996), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(913), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25850] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(1994), 1,
      anon_sym_SQUOTE,
    ACTIONS(1998), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(914), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25868] = 2,
    ACTIONS(1590), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1588), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_elif,
    ACTIONS(1942), 1,
      anon_sym_else,
    ACTIONS(2000), 1,
      anon_sym_endif,
    STATE(1232), 1,
      sym_else_command,
    STATE(998), 2,
      sym_elseif_command,
      aux_sym_if_condition_repeat1,
  [25900] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2002), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1932), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25918] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(2002), 1,
      anon_sym_SQUOTE,
    ACTIONS(1948), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25936] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2004), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2006), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(922), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [25954] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(2004), 1,
      anon_sym_SQUOTE,
    ACTIONS(2008), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(923), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [25972] = 2,
    ACTIONS(1578), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1576), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [25984] = 2,
    ACTIONS(1594), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1592), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [25996] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1966), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2010), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(962), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [26014] = 2,
    ACTIONS(1567), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1565), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26026] = 2,
    ACTIONS(1602), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1600), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [26038] = 2,
    ACTIONS(1502), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1500), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26050] = 2,
    ACTIONS(1582), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1580), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [26062] = 2,
    ACTIONS(1586), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1584), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26074] = 2,
    ACTIONS(1590), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1588), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26086] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(2012), 1,
      anon_sym_SQUOTE,
    ACTIONS(2014), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(939), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [26104] = 2,
    ACTIONS(1602), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1600), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26116] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2012), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2016), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(940), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [26134] = 2,
    ACTIONS(1502), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1500), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [26146] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(2018), 1,
      anon_sym_SQUOTE,
    ACTIONS(1948), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [26164] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2018), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1932), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [26182] = 2,
    ACTIONS(1598), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1596), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26194] = 2,
    ACTIONS(1563), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1561), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [26206] = 2,
    ACTIONS(1602), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1600), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [26218] = 2,
    ACTIONS(1606), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1604), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26230] = 2,
    ACTIONS(1598), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1596), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26242] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1940), 1,
      anon_sym_elif,
    ACTIONS(1942), 1,
      anon_sym_else,
    ACTIONS(2020), 1,
      anon_sym_endif,
    STATE(1180), 1,
      sym_else_command,
    STATE(921), 2,
      sym_elseif_command,
      aux_sym_if_condition_repeat1,
  [26262] = 2,
    ACTIONS(1598), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1596), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [26274] = 2,
    ACTIONS(1627), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1625), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
      anon_sym_endforeach,
  [26286] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(2022), 1,
      anon_sym_SQUOTE,
    ACTIONS(2024), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(951), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [26304] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2022), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2026), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(952), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [26322] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(2028), 1,
      anon_sym_SQUOTE,
    ACTIONS(1948), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [26340] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2028), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1932), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [26358] = 2,
    ACTIONS(1610), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1608), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26370] = 2,
    ACTIONS(1594), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1592), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26382] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2030), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2035), 1,
      anon_sym_AT,
    ACTIONS(2032), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [26400] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    STATE(265), 1,
      aux_sym_expression_statement_repeat1,
    STATE(779), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26420] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    STATE(264), 1,
      aux_sym_expression_statement_repeat1,
    STATE(758), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26440] = 2,
    ACTIONS(1582), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1580), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [26452] = 2,
    ACTIONS(1614), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1612), 5,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_endif,
      anon_sym_if,
      anon_sym_foreach,
  [26464] = 2,
    ACTIONS(1627), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1625), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [26476] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2038), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      anon_sym_AT,
    ACTIONS(2040), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [26494] = 5,
    ACTIONS(1934), 1,
      anon_sym_AT,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2046), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(1932), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
    STATE(955), 2,
      sym_formatunit,
      aux_sym_string_repeat2,
  [26512] = 5,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(1950), 1,
      anon_sym_AT,
    ACTIONS(2046), 1,
      anon_sym_SQUOTE,
    ACTIONS(1948), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
    STATE(961), 2,
      sym_formatunit,
      aux_sym_string_repeat1,
  [26530] = 2,
    ACTIONS(1614), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1612), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [26542] = 2,
    ACTIONS(1567), 3,
      ts_builtin_sym_end,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      sym_comment,
    ACTIONS(1565), 4,
      anon_sym_SQUOTE,
      sym_identifier,
      anon_sym_if,
      anon_sym_foreach,
  [26554] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(2048), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2054), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26588] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(2057), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26605] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(1706), 1,
      anon_sym_LBRACK,
    ACTIONS(2060), 1,
      sym_identifier,
    STATE(418), 1,
      sym_dictionaries,
    STATE(421), 1,
      sym_list,
  [26624] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2062), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26641] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2065), 1,
      sym_identifier,
    ACTIONS(2067), 1,
      sym_number,
    STATE(1237), 1,
      sym_string,
  [26660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1813), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2069), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26694] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2072), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2075), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1904), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1824), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26762] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2078), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2081), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26796] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2084), 1,
      sym_identifier,
    ACTIONS(2086), 1,
      sym_number,
    STATE(1241), 1,
      sym_string,
  [26815] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2088), 1,
      sym_identifier,
    ACTIONS(2090), 1,
      sym_number,
    STATE(1211), 1,
      sym_string,
  [26834] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(2092), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2095), 1,
      sym_identifier,
    ACTIONS(2097), 1,
      sym_number,
    STATE(1184), 1,
      sym_string,
  [26870] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2084), 1,
      sym_identifier,
    ACTIONS(2099), 1,
      sym_number,
    STATE(1241), 1,
      sym_string,
  [26889] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2101), 1,
      sym_identifier,
    ACTIONS(2103), 1,
      sym_number,
    STATE(1194), 1,
      sym_string,
  [26908] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2088), 1,
      sym_identifier,
    ACTIONS(2105), 1,
      sym_number,
    STATE(1211), 1,
      sym_string,
  [26927] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2095), 1,
      sym_identifier,
    ACTIONS(2107), 1,
      sym_number,
    STATE(1184), 1,
      sym_string,
  [26946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1885), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [26963] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2111), 1,
      sym_number,
    STATE(1261), 1,
      sym_string,
  [26982] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2113), 1,
      sym_identifier,
    ACTIONS(2115), 1,
      sym_number,
    STATE(1222), 1,
      sym_string,
  [27001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2117), 1,
      sym_identifier,
    ACTIONS(2119), 1,
      sym_number,
    STATE(1203), 1,
      sym_string,
  [27020] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(2121), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27037] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2124), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(2127), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27071] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2101), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      sym_number,
    STATE(1194), 1,
      sym_string,
  [27090] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2132), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2109), 1,
      sym_identifier,
    ACTIONS(2135), 1,
      sym_number,
    STATE(1261), 1,
      sym_string,
  [27126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 1,
      anon_sym_elif,
    ACTIONS(2137), 2,
      anon_sym_endif,
      anon_sym_else,
    STATE(998), 2,
      sym_elseif_command,
      aux_sym_if_condition_repeat1,
  [27141] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2144), 1,
      sym_number,
    STATE(1163), 1,
      sym_string,
  [27160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(1241), 1,
      sym_string,
    ACTIONS(2084), 2,
      sym_identifier,
      sym_number,
  [27177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(1706), 1,
      anon_sym_LBRACK,
    ACTIONS(2146), 1,
      sym_identifier,
    STATE(348), 1,
      sym_list,
    STATE(349), 1,
      sym_dictionaries,
  [27196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2142), 1,
      sym_identifier,
    ACTIONS(2148), 1,
      sym_number,
    STATE(1163), 1,
      sym_string,
  [27215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1915), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27232] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(1706), 1,
      anon_sym_LBRACK,
    ACTIONS(2150), 1,
      sym_identifier,
    STATE(354), 1,
      sym_dictionaries,
    STATE(355), 1,
      sym_list,
  [27251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(2152), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27268] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2155), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1829), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2158), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27319] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1862), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(1211), 1,
      sym_string,
    ACTIONS(2088), 2,
      sym_identifier,
      sym_number,
  [27353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(1706), 1,
      anon_sym_LBRACK,
    ACTIONS(2161), 1,
      sym_identifier,
    STATE(374), 1,
      sym_list,
    STATE(375), 1,
      sym_dictionaries,
  [27372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2113), 1,
      sym_identifier,
    ACTIONS(2163), 1,
      sym_number,
    STATE(1222), 1,
      sym_string,
  [27391] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(1706), 1,
      anon_sym_LBRACK,
    ACTIONS(2165), 1,
      sym_identifier,
    STATE(388), 1,
      sym_dictionaries,
    STATE(389), 1,
      sym_list,
  [27410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2167), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(1237), 1,
      sym_string,
    ACTIONS(2065), 2,
      sym_identifier,
      sym_number,
  [27461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(1222), 1,
      sym_string,
    ACTIONS(2113), 2,
      sym_identifier,
      sym_number,
  [27478] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2065), 1,
      sym_identifier,
    ACTIONS(2170), 1,
      sym_number,
    STATE(1237), 1,
      sym_string,
  [27497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2172), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27514] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(2175), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1888), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27548] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2178), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2181), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2184), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27599] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(1706), 1,
      anon_sym_LBRACK,
    ACTIONS(2187), 1,
      sym_identifier,
    STATE(402), 1,
      sym_list,
    STATE(403), 1,
      sym_dictionaries,
  [27618] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    ACTIONS(2117), 1,
      sym_identifier,
    ACTIONS(2189), 1,
      sym_number,
    STATE(1203), 1,
      sym_string,
  [27637] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(1706), 1,
      anon_sym_LBRACK,
    ACTIONS(2191), 1,
      sym_identifier,
    STATE(409), 1,
      sym_dictionaries,
    STATE(410), 1,
      sym_list,
  [27656] = 4,
    ACTIONS(3), 1,
      sym_comment,
    STATE(769), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
    ACTIONS(1376), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [27671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(2193), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27688] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2196), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_SQUOTE,
    ACTIONS(9), 1,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
    STATE(1203), 1,
      sym_string,
    ACTIONS(2117), 2,
      sym_identifier,
      sym_number,
  [27722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(2199), 1,
      anon_sym_RBRACK,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27739] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(328), 1,
      anon_sym_LBRACE,
    ACTIONS(1706), 1,
      anon_sym_LBRACK,
    ACTIONS(2202), 1,
      sym_identifier,
    STATE(394), 1,
      sym_list,
    STATE(395), 1,
      sym_dictionaries,
  [27758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    ACTIONS(2204), 1,
      anon_sym_RBRACK,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27775] = 3,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2207), 2,
      anon_sym_SQUOTE,
      anon_sym_AT,
    ACTIONS(2209), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [27787] = 3,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2207), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_AT,
    ACTIONS(2209), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [27799] = 3,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2211), 2,
      anon_sym_SQUOTE_SQUOTE_SQUOTE,
      anon_sym_AT,
    ACTIONS(2213), 2,
      aux_sym_string_token2,
      sym_escape_sequence,
  [27811] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    STATE(760), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 1,
      anon_sym_COMMA,
    STATE(1028), 1,
      aux_sym_variableunit_repeat1,
    ACTIONS(626), 2,
      anon_sym_SLASH,
      anon_sym_PLUS,
  [27839] = 3,
    ACTIONS(1936), 1,
      sym_comment,
    ACTIONS(2211), 2,
      anon_sym_SQUOTE,
      anon_sym_AT,
    ACTIONS(2213), 2,
      aux_sym_string_token1,
      sym_escape_sequence,
  [27851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 3,
      anon_sym_endif,
      anon_sym_elif,
      anon_sym_else,
  [27860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1582), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [27869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1571), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [27878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [27887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2221), 1,
      anon_sym_COLON,
    STATE(1073), 1,
      aux_sym_foreach_command_repeat1,
  [27900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
    ACTIONS(2223), 1,
      anon_sym_COMMA,
    ACTIONS(2225), 1,
      anon_sym_COLON,
  [27913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2227), 1,
      anon_sym_COMMA,
  [27926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2229), 1,
      anon_sym_COMMA,
    ACTIONS(2231), 1,
      anon_sym_RPAREN,
  [27939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 1,
      anon_sym_RPAREN,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2233), 1,
      anon_sym_COMMA,
  [27952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1594), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [27961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2235), 1,
      anon_sym_COMMA,
    ACTIONS(2237), 1,
      anon_sym_RPAREN,
  [27974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2239), 1,
      anon_sym_COMMA,
    ACTIONS(2241), 1,
      anon_sym_RPAREN,
  [27987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
  [28000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2245), 1,
      anon_sym_COMMA,
    ACTIONS(2247), 1,
      anon_sym_RPAREN,
  [28013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2249), 3,
      anon_sym_endif,
      anon_sym_elif,
      anon_sym_else,
  [28022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2251), 1,
      anon_sym_COMMA,
    ACTIONS(2253), 1,
      anon_sym_RPAREN,
  [28035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 1,
      anon_sym_RPAREN,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2255), 1,
      anon_sym_COMMA,
  [28048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 1,
      anon_sym_RPAREN,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2257), 1,
      anon_sym_COMMA,
  [28061] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
  [28074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2261), 1,
      anon_sym_COLON,
    STATE(1061), 1,
      aux_sym_foreach_command_repeat1,
  [28087] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2263), 1,
      anon_sym_COLON,
    STATE(1062), 1,
      aux_sym_foreach_command_repeat1,
  [28100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2265), 1,
      anon_sym_COMMA,
    ACTIONS(2268), 1,
      anon_sym_COLON,
    STATE(1062), 1,
      aux_sym_foreach_command_repeat1,
  [28113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2270), 1,
      anon_sym_COMMA,
    ACTIONS(2272), 1,
      anon_sym_RPAREN,
  [28126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 1,
      anon_sym_RPAREN,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2274), 1,
      anon_sym_COMMA,
  [28139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2276), 1,
      anon_sym_COMMA,
    ACTIONS(2278), 1,
      anon_sym_RPAREN,
  [28152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2280), 1,
      anon_sym_COMMA,
  [28165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2282), 1,
      anon_sym_COLON,
    STATE(1070), 1,
      aux_sym_foreach_command_repeat1,
  [28178] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2284), 3,
      anon_sym_endif,
      anon_sym_elif,
      anon_sym_else,
  [28187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 1,
      anon_sym_RPAREN,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
  [28200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2288), 1,
      anon_sym_COLON,
    STATE(1062), 1,
      aux_sym_foreach_command_repeat1,
  [28213] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2290), 3,
      anon_sym_endif,
      anon_sym_elif,
      anon_sym_else,
  [28222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2292), 1,
      anon_sym_COLON,
    STATE(1075), 1,
      aux_sym_foreach_command_repeat1,
  [28235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2294), 1,
      anon_sym_COLON,
    STATE(1062), 1,
      aux_sym_foreach_command_repeat1,
  [28248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2296), 1,
      anon_sym_COMMA,
    ACTIONS(2298), 1,
      anon_sym_RPAREN,
  [28261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_COMMA,
    ACTIONS(2300), 1,
      anon_sym_COLON,
    STATE(1062), 1,
      aux_sym_foreach_command_repeat1,
  [28274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
  [28287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2306), 1,
      sym_identifier,
    ACTIONS(2308), 1,
      sym_number,
  [28297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2310), 1,
      anon_sym_RBRACK,
  [28307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2312), 1,
      anon_sym_RBRACK,
  [28317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2314), 1,
      anon_sym_RBRACK,
  [28327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(473), 1,
      aux_sym_expression_statement_repeat1,
  [28337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2316), 1,
      anon_sym_RBRACK,
  [28347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(285), 1,
      anon_sym_RBRACE,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
  [28357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2320), 1,
      anon_sym_RBRACK,
  [28367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2322), 1,
      anon_sym_RBRACK,
  [28377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(666), 1,
      aux_sym_expression_statement_repeat1,
  [28387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 1,
      anon_sym_RPAREN,
    ACTIONS(2259), 1,
      anon_sym_COMMA,
  [28397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 1,
      anon_sym_COMMA,
    ACTIONS(2298), 1,
      anon_sym_RPAREN,
  [28407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(248), 1,
      anon_sym_RBRACE,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
  [28417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
    ACTIONS(2324), 1,
      anon_sym_RBRACE,
  [28427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2270), 1,
      anon_sym_COMMA,
    ACTIONS(2272), 1,
      anon_sym_RPAREN,
  [28437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2302), 1,
      anon_sym_COMMA,
    ACTIONS(2304), 1,
      anon_sym_RPAREN,
  [28447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2326), 1,
      anon_sym_RBRACK,
  [28457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2328), 1,
      anon_sym_RBRACK,
  [28467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2330), 1,
      anon_sym_RBRACK,
  [28477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2332), 1,
      anon_sym_RBRACK,
  [28487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2334), 1,
      anon_sym_RBRACK,
  [28497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2336), 1,
      anon_sym_RBRACK,
  [28507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2338), 1,
      anon_sym_RBRACK,
  [28517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2340), 1,
      anon_sym_RBRACK,
  [28527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2342), 1,
      anon_sym_RBRACK,
  [28537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2344), 1,
      anon_sym_RBRACK,
  [28547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_COMMA,
    ACTIONS(2278), 1,
      anon_sym_RPAREN,
  [28557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
    ACTIONS(2280), 1,
      anon_sym_COMMA,
  [28567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(378), 1,
      anon_sym_RBRACE,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
  [28577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1496), 1,
      anon_sym_RPAREN,
    ACTIONS(2274), 1,
      anon_sym_COMMA,
  [28587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
    ACTIONS(2346), 1,
      anon_sym_RBRACE,
  [28597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1396), 1,
      anon_sym_DOT,
    STATE(648), 1,
      aux_sym_expression_statement_repeat1,
  [28607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1536), 1,
      anon_sym_RPAREN,
    ACTIONS(2286), 1,
      anon_sym_COMMA,
  [28617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1550), 1,
      anon_sym_RPAREN,
    ACTIONS(2255), 1,
      anon_sym_COMMA,
  [28627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2348), 1,
      anon_sym_RBRACK,
  [28637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 1,
      anon_sym_DOT,
    STATE(248), 1,
      aux_sym_expression_statement_repeat1,
  [28647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2350), 1,
      anon_sym_RBRACK,
  [28657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2352), 1,
      anon_sym_RBRACK,
  [28667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2354), 1,
      sym_identifier,
    ACTIONS(2356), 1,
      sym_number,
  [28677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2358), 1,
      anon_sym_RBRACK,
  [28687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2360), 1,
      anon_sym_RBRACK,
  [28697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2362), 1,
      anon_sym_RBRACK,
  [28707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2239), 1,
      anon_sym_COMMA,
    ACTIONS(2241), 1,
      anon_sym_RPAREN,
  [28717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2364), 1,
      anon_sym_RBRACK,
  [28727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_COMMA,
    ACTIONS(2231), 1,
      anon_sym_RPAREN,
  [28737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
    ACTIONS(2366), 1,
      anon_sym_COMMA,
  [28747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(603), 1,
      aux_sym_expression_statement_repeat1,
  [28757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2368), 1,
      anon_sym_DOT,
    STATE(97), 1,
      aux_sym_expression_statement_repeat1,
  [28767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2370), 1,
      anon_sym_RBRACK,
  [28777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      anon_sym_COMMA,
    ACTIONS(2253), 1,
      anon_sym_RPAREN,
  [28787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1546), 1,
      anon_sym_RPAREN,
    ACTIONS(2257), 1,
      anon_sym_COMMA,
  [28797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
    ACTIONS(2372), 1,
      anon_sym_RBRACE,
  [28807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2374), 1,
      anon_sym_RBRACK,
  [28817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
    ACTIONS(2376), 1,
      anon_sym_RBRACE,
  [28827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      anon_sym_COMMA,
    ACTIONS(2237), 1,
      anon_sym_RPAREN,
  [28837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
    ACTIONS(2378), 1,
      anon_sym_RBRACE,
  [28847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 1,
      anon_sym_COMMA,
    ACTIONS(2247), 1,
      anon_sym_RPAREN,
  [28857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2380), 1,
      anon_sym_RBRACK,
  [28867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 1,
      anon_sym_DOT,
    STATE(115), 1,
      aux_sym_expression_statement_repeat1,
  [28877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2384), 1,
      anon_sym_RBRACK,
  [28887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(627), 1,
      aux_sym_expression_statement_repeat1,
  [28897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2386), 1,
      anon_sym_RBRACK,
  [28907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2388), 1,
      anon_sym_DOT,
    STATE(8), 1,
      aux_sym_expression_statement_repeat1,
  [28917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2390), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [28925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(344), 1,
      anon_sym_RBRACE,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
  [28935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1538), 1,
      anon_sym_RPAREN,
    ACTIONS(2233), 1,
      anon_sym_COMMA,
  [28945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2392), 1,
      anon_sym_DOT,
    STATE(578), 1,
      aux_sym_expression_statement_repeat1,
  [28955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(281), 1,
      anon_sym_RBRACE,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
  [28965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2394), 1,
      anon_sym_DOT,
    STATE(125), 1,
      aux_sym_expression_statement_repeat1,
  [28975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1439), 1,
      anon_sym_RPAREN,
    ACTIONS(2227), 1,
      anon_sym_COMMA,
  [28985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2396), 1,
      anon_sym_RBRACK,
  [28995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1449), 1,
      anon_sym_RPAREN,
    ACTIONS(2223), 1,
      anon_sym_COMMA,
  [29005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      anon_sym_DOT,
    STATE(202), 1,
      aux_sym_expression_statement_repeat1,
  [29015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2400), 1,
      anon_sym_RBRACK,
  [29025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2402), 1,
      anon_sym_RBRACK,
  [29035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1413), 1,
      anon_sym_DOT,
    STATE(642), 1,
      aux_sym_expression_statement_repeat1,
  [29045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2404), 1,
      anon_sym_RBRACK,
  [29055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2406), 1,
      anon_sym_DOT,
    STATE(551), 1,
      aux_sym_expression_statement_repeat1,
  [29065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2408), 1,
      anon_sym_RBRACK,
  [29075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2410), 1,
      anon_sym_RBRACK,
  [29085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      anon_sym_DOT,
    STATE(471), 1,
      aux_sym_expression_statement_repeat1,
  [29095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2412), 1,
      anon_sym_DOT,
    STATE(547), 1,
      aux_sym_expression_statement_repeat1,
  [29105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2414), 1,
      anon_sym_RBRACK,
  [29115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 1,
      anon_sym_DOT,
    STATE(660), 1,
      aux_sym_expression_statement_repeat1,
  [29125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
    ACTIONS(2416), 1,
      anon_sym_RBRACK,
  [29135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      anon_sym_DOT,
    STATE(427), 1,
      aux_sym_expression_statement_repeat1,
  [29145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2420), 1,
      anon_sym_RBRACK,
  [29152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2422), 1,
      anon_sym_COLON,
  [29159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      anon_sym_RBRACK,
  [29166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2426), 1,
      anon_sym_RBRACK,
  [29173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_RBRACK,
  [29180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2430), 1,
      anon_sym_RBRACK,
  [29187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2432), 1,
      anon_sym_RBRACK,
  [29194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2434), 1,
      anon_sym_RBRACK,
  [29201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2436), 1,
      anon_sym_RBRACK,
  [29208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 1,
      sym_identifier,
  [29215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_RBRACK,
  [29222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2442), 1,
      sym_number,
  [29229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2318), 1,
      anon_sym_COMMA,
  [29236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2444), 1,
      anon_sym_RBRACK,
  [29243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2446), 1,
      sym_number,
  [29250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_COLON,
  [29257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2448), 1,
      anon_sym_RBRACK,
  [29264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2000), 1,
      anon_sym_endif,
  [29271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2450), 1,
      anon_sym_endif,
  [29278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_RBRACK,
  [29285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1938), 1,
      anon_sym_endif,
  [29292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2454), 1,
      anon_sym_RBRACK,
  [29299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2456), 1,
      anon_sym_RBRACK,
  [29306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2458), 1,
      anon_sym_RBRACK,
  [29313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2460), 1,
      anon_sym_RBRACK,
  [29320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2462), 1,
      anon_sym_RBRACK,
  [29327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2464), 1,
      anon_sym_AT,
  [29334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_RBRACK,
  [29341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2468), 1,
      anon_sym_AT,
  [29348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 1,
      anon_sym_RBRACK,
  [29355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_RBRACK,
  [29362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2474), 1,
      anon_sym_RBRACK,
  [29369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2476), 1,
      anon_sym_RBRACK,
  [29376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2478), 1,
      sym_number,
  [29383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2480), 1,
      sym_number,
  [29390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2482), 1,
      anon_sym_AT,
  [29397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2484), 1,
      anon_sym_COLON,
  [29404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_RBRACK,
  [29411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1984), 1,
      anon_sym_endif,
  [29418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2366), 1,
      anon_sym_COMMA,
  [29425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2488), 1,
      anon_sym_RBRACK,
  [29432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2490), 1,
      anon_sym_COLON,
  [29439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2492), 1,
      anon_sym_RBRACK,
  [29446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2494), 1,
      anon_sym_RBRACK,
  [29453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2496), 1,
      anon_sym_RBRACK,
  [29460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2498), 1,
      anon_sym_RBRACK,
  [29467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2500), 1,
      anon_sym_RBRACK,
  [29474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2502), 1,
      anon_sym_RBRACK,
  [29481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2504), 1,
      anon_sym_RBRACK,
  [29488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2506), 1,
      anon_sym_RBRACK,
  [29495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_RBRACK,
  [29502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2510), 1,
      anon_sym_RBRACK,
  [29509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2512), 1,
      anon_sym_RBRACK,
  [29516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2514), 1,
      anon_sym_RPAREN,
  [29523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2516), 1,
      anon_sym_COLON,
  [29530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2518), 1,
      anon_sym_RBRACK,
  [29537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      anon_sym_RPAREN,
  [29544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2522), 1,
      anon_sym_RPAREN,
  [29551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2524), 1,
      anon_sym_endif,
  [29558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2526), 1,
      anon_sym_RBRACK,
  [29565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2528), 1,
      sym_number,
  [29572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2530), 1,
      sym_number,
  [29579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_COMMA,
  [29586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2532), 1,
      anon_sym_RBRACK,
  [29593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2534), 1,
      anon_sym_RBRACK,
  [29600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2536), 1,
      anon_sym_RBRACK,
  [29607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2538), 1,
      anon_sym_RBRACK,
  [29614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2540), 1,
      sym_number,
  [29621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2542), 1,
      sym_number,
  [29628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2544), 1,
      anon_sym_endif,
  [29635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2546), 1,
      anon_sym_endif,
  [29642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      sym_number,
  [29649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2550), 1,
      sym_number,
  [29656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1988), 1,
      anon_sym_endif,
  [29663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 1,
      anon_sym_RBRACK,
  [29670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2554), 1,
      sym_number,
  [29677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2556), 1,
      sym_number,
  [29684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2558), 1,
      ts_builtin_sym_end,
  [29691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2560), 1,
      anon_sym_RBRACK,
  [29698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2562), 1,
      sym_number,
  [29705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2564), 1,
      sym_number,
  [29712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2566), 1,
      sym_identifier,
  [29719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2568), 1,
      anon_sym_RBRACK,
  [29726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2570), 1,
      sym_number,
  [29733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2572), 1,
      sym_number,
  [29740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2574), 1,
      anon_sym_AT,
  [29747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2576), 1,
      sym_number,
  [29754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2578), 1,
      sym_number,
  [29761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2580), 1,
      anon_sym_RBRACK,
  [29768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2582), 1,
      anon_sym_RBRACK,
  [29775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2584), 1,
      anon_sym_RBRACK,
  [29782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2586), 1,
      anon_sym_RBRACK,
  [29789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2588), 1,
      anon_sym_RBRACK,
  [29796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2590), 1,
      anon_sym_RPAREN,
  [29803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2592), 1,
      anon_sym_RBRACK,
  [29810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2594), 1,
      anon_sym_RBRACK,
  [29817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2596), 1,
      anon_sym_RBRACK,
  [29824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2598), 1,
      anon_sym_RPAREN,
  [29831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 1,
      anon_sym_RBRACK,
  [29838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_RBRACK,
  [29845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2604), 1,
      sym_identifier,
  [29852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      sym_identifier,
  [29859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 1,
      sym_identifier,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 49,
  [SMALL_STATE(4)] = 89,
  [SMALL_STATE(5)] = 129,
  [SMALL_STATE(6)] = 166,
  [SMALL_STATE(7)] = 203,
  [SMALL_STATE(8)] = 240,
  [SMALL_STATE(9)] = 275,
  [SMALL_STATE(10)] = 310,
  [SMALL_STATE(11)] = 345,
  [SMALL_STATE(12)] = 380,
  [SMALL_STATE(13)] = 423,
  [SMALL_STATE(14)] = 466,
  [SMALL_STATE(15)] = 503,
  [SMALL_STATE(16)] = 538,
  [SMALL_STATE(17)] = 572,
  [SMALL_STATE(18)] = 638,
  [SMALL_STATE(19)] = 668,
  [SMALL_STATE(20)] = 734,
  [SMALL_STATE(21)] = 800,
  [SMALL_STATE(22)] = 866,
  [SMALL_STATE(23)] = 896,
  [SMALL_STATE(24)] = 930,
  [SMALL_STATE(25)] = 960,
  [SMALL_STATE(26)] = 990,
  [SMALL_STATE(27)] = 1028,
  [SMALL_STATE(28)] = 1058,
  [SMALL_STATE(29)] = 1124,
  [SMALL_STATE(30)] = 1156,
  [SMALL_STATE(31)] = 1186,
  [SMALL_STATE(32)] = 1252,
  [SMALL_STATE(33)] = 1318,
  [SMALL_STATE(34)] = 1352,
  [SMALL_STATE(35)] = 1418,
  [SMALL_STATE(36)] = 1450,
  [SMALL_STATE(37)] = 1484,
  [SMALL_STATE(38)] = 1516,
  [SMALL_STATE(39)] = 1550,
  [SMALL_STATE(40)] = 1580,
  [SMALL_STATE(41)] = 1646,
  [SMALL_STATE(42)] = 1676,
  [SMALL_STATE(43)] = 1706,
  [SMALL_STATE(44)] = 1751,
  [SMALL_STATE(45)] = 1814,
  [SMALL_STATE(46)] = 1851,
  [SMALL_STATE(47)] = 1914,
  [SMALL_STATE(48)] = 1943,
  [SMALL_STATE(49)] = 2006,
  [SMALL_STATE(50)] = 2069,
  [SMALL_STATE(51)] = 2132,
  [SMALL_STATE(52)] = 2195,
  [SMALL_STATE(53)] = 2258,
  [SMALL_STATE(54)] = 2321,
  [SMALL_STATE(55)] = 2384,
  [SMALL_STATE(56)] = 2447,
  [SMALL_STATE(57)] = 2492,
  [SMALL_STATE(58)] = 2537,
  [SMALL_STATE(59)] = 2566,
  [SMALL_STATE(60)] = 2594,
  [SMALL_STATE(61)] = 2656,
  [SMALL_STATE(62)] = 2718,
  [SMALL_STATE(63)] = 2754,
  [SMALL_STATE(64)] = 2790,
  [SMALL_STATE(65)] = 2818,
  [SMALL_STATE(66)] = 2846,
  [SMALL_STATE(67)] = 2874,
  [SMALL_STATE(68)] = 2910,
  [SMALL_STATE(69)] = 2972,
  [SMALL_STATE(70)] = 3008,
  [SMALL_STATE(71)] = 3070,
  [SMALL_STATE(72)] = 3132,
  [SMALL_STATE(73)] = 3160,
  [SMALL_STATE(74)] = 3222,
  [SMALL_STATE(75)] = 3254,
  [SMALL_STATE(76)] = 3282,
  [SMALL_STATE(77)] = 3318,
  [SMALL_STATE(78)] = 3346,
  [SMALL_STATE(79)] = 3374,
  [SMALL_STATE(80)] = 3436,
  [SMALL_STATE(81)] = 3464,
  [SMALL_STATE(82)] = 3492,
  [SMALL_STATE(83)] = 3520,
  [SMALL_STATE(84)] = 3582,
  [SMALL_STATE(85)] = 3614,
  [SMALL_STATE(86)] = 3650,
  [SMALL_STATE(87)] = 3678,
  [SMALL_STATE(88)] = 3740,
  [SMALL_STATE(89)] = 3802,
  [SMALL_STATE(90)] = 3838,
  [SMALL_STATE(91)] = 3900,
  [SMALL_STATE(92)] = 3962,
  [SMALL_STATE(93)] = 4024,
  [SMALL_STATE(94)] = 4086,
  [SMALL_STATE(95)] = 4148,
  [SMALL_STATE(96)] = 4179,
  [SMALL_STATE(97)] = 4218,
  [SMALL_STATE(98)] = 4249,
  [SMALL_STATE(99)] = 4282,
  [SMALL_STATE(100)] = 4315,
  [SMALL_STATE(101)] = 4354,
  [SMALL_STATE(102)] = 4385,
  [SMALL_STATE(103)] = 4418,
  [SMALL_STATE(104)] = 4449,
  [SMALL_STATE(105)] = 4482,
  [SMALL_STATE(106)] = 4513,
  [SMALL_STATE(107)] = 4544,
  [SMALL_STATE(108)] = 4583,
  [SMALL_STATE(109)] = 4614,
  [SMALL_STATE(110)] = 4647,
  [SMALL_STATE(111)] = 4680,
  [SMALL_STATE(112)] = 4711,
  [SMALL_STATE(113)] = 4770,
  [SMALL_STATE(114)] = 4803,
  [SMALL_STATE(115)] = 4842,
  [SMALL_STATE(116)] = 4873,
  [SMALL_STATE(117)] = 4904,
  [SMALL_STATE(118)] = 4935,
  [SMALL_STATE(119)] = 4974,
  [SMALL_STATE(120)] = 5007,
  [SMALL_STATE(121)] = 5046,
  [SMALL_STATE(122)] = 5077,
  [SMALL_STATE(123)] = 5110,
  [SMALL_STATE(124)] = 5143,
  [SMALL_STATE(125)] = 5176,
  [SMALL_STATE(126)] = 5207,
  [SMALL_STATE(127)] = 5240,
  [SMALL_STATE(128)] = 5271,
  [SMALL_STATE(129)] = 5302,
  [SMALL_STATE(130)] = 5328,
  [SMALL_STATE(131)] = 5374,
  [SMALL_STATE(132)] = 5408,
  [SMALL_STATE(133)] = 5434,
  [SMALL_STATE(134)] = 5460,
  [SMALL_STATE(135)] = 5488,
  [SMALL_STATE(136)] = 5518,
  [SMALL_STATE(137)] = 5546,
  [SMALL_STATE(138)] = 5572,
  [SMALL_STATE(139)] = 5600,
  [SMALL_STATE(140)] = 5626,
  [SMALL_STATE(141)] = 5652,
  [SMALL_STATE(142)] = 5680,
  [SMALL_STATE(143)] = 5710,
  [SMALL_STATE(144)] = 5740,
  [SMALL_STATE(145)] = 5770,
  [SMALL_STATE(146)] = 5798,
  [SMALL_STATE(147)] = 5828,
  [SMALL_STATE(148)] = 5856,
  [SMALL_STATE(149)] = 5892,
  [SMALL_STATE(150)] = 5918,
  [SMALL_STATE(151)] = 5944,
  [SMALL_STATE(152)] = 5970,
  [SMALL_STATE(153)] = 6000,
  [SMALL_STATE(154)] = 6030,
  [SMALL_STATE(155)] = 6060,
  [SMALL_STATE(156)] = 6086,
  [SMALL_STATE(157)] = 6116,
  [SMALL_STATE(158)] = 6144,
  [SMALL_STATE(159)] = 6170,
  [SMALL_STATE(160)] = 6216,
  [SMALL_STATE(161)] = 6242,
  [SMALL_STATE(162)] = 6286,
  [SMALL_STATE(163)] = 6330,
  [SMALL_STATE(164)] = 6374,
  [SMALL_STATE(165)] = 6400,
  [SMALL_STATE(166)] = 6426,
  [SMALL_STATE(167)] = 6456,
  [SMALL_STATE(168)] = 6500,
  [SMALL_STATE(169)] = 6526,
  [SMALL_STATE(170)] = 6552,
  [SMALL_STATE(171)] = 6582,
  [SMALL_STATE(172)] = 6612,
  [SMALL_STATE(173)] = 6646,
  [SMALL_STATE(174)] = 6672,
  [SMALL_STATE(175)] = 6698,
  [SMALL_STATE(176)] = 6734,
  [SMALL_STATE(177)] = 6780,
  [SMALL_STATE(178)] = 6806,
  [SMALL_STATE(179)] = 6832,
  [SMALL_STATE(180)] = 6858,
  [SMALL_STATE(181)] = 6886,
  [SMALL_STATE(182)] = 6932,
  [SMALL_STATE(183)] = 6958,
  [SMALL_STATE(184)] = 6984,
  [SMALL_STATE(185)] = 7018,
  [SMALL_STATE(186)] = 7048,
  [SMALL_STATE(187)] = 7074,
  [SMALL_STATE(188)] = 7104,
  [SMALL_STATE(189)] = 7130,
  [SMALL_STATE(190)] = 7156,
  [SMALL_STATE(191)] = 7186,
  [SMALL_STATE(192)] = 7212,
  [SMALL_STATE(193)] = 7256,
  [SMALL_STATE(194)] = 7282,
  [SMALL_STATE(195)] = 7310,
  [SMALL_STATE(196)] = 7340,
  [SMALL_STATE(197)] = 7366,
  [SMALL_STATE(198)] = 7399,
  [SMALL_STATE(199)] = 7442,
  [SMALL_STATE(200)] = 7483,
  [SMALL_STATE(201)] = 7514,
  [SMALL_STATE(202)] = 7545,
  [SMALL_STATE(203)] = 7576,
  [SMALL_STATE(204)] = 7609,
  [SMALL_STATE(205)] = 7642,
  [SMALL_STATE(206)] = 7667,
  [SMALL_STATE(207)] = 7692,
  [SMALL_STATE(208)] = 7717,
  [SMALL_STATE(209)] = 7748,
  [SMALL_STATE(210)] = 7779,
  [SMALL_STATE(211)] = 7812,
  [SMALL_STATE(212)] = 7837,
  [SMALL_STATE(213)] = 7870,
  [SMALL_STATE(214)] = 7895,
  [SMALL_STATE(215)] = 7920,
  [SMALL_STATE(216)] = 7953,
  [SMALL_STATE(217)] = 7986,
  [SMALL_STATE(218)] = 8010,
  [SMALL_STATE(219)] = 8064,
  [SMALL_STATE(220)] = 8096,
  [SMALL_STATE(221)] = 8150,
  [SMALL_STATE(222)] = 8176,
  [SMALL_STATE(223)] = 8232,
  [SMALL_STATE(224)] = 8258,
  [SMALL_STATE(225)] = 8312,
  [SMALL_STATE(226)] = 8342,
  [SMALL_STATE(227)] = 8366,
  [SMALL_STATE(228)] = 8390,
  [SMALL_STATE(229)] = 8414,
  [SMALL_STATE(230)] = 8438,
  [SMALL_STATE(231)] = 8462,
  [SMALL_STATE(232)] = 8486,
  [SMALL_STATE(233)] = 8510,
  [SMALL_STATE(234)] = 8534,
  [SMALL_STATE(235)] = 8558,
  [SMALL_STATE(236)] = 8606,
  [SMALL_STATE(237)] = 8630,
  [SMALL_STATE(238)] = 8678,
  [SMALL_STATE(239)] = 8726,
  [SMALL_STATE(240)] = 8782,
  [SMALL_STATE(241)] = 8806,
  [SMALL_STATE(242)] = 8854,
  [SMALL_STATE(243)] = 8910,
  [SMALL_STATE(244)] = 8958,
  [SMALL_STATE(245)] = 8986,
  [SMALL_STATE(246)] = 9014,
  [SMALL_STATE(247)] = 9068,
  [SMALL_STATE(248)] = 9116,
  [SMALL_STATE(249)] = 9146,
  [SMALL_STATE(250)] = 9202,
  [SMALL_STATE(251)] = 9250,
  [SMALL_STATE(252)] = 9274,
  [SMALL_STATE(253)] = 9298,
  [SMALL_STATE(254)] = 9330,
  [SMALL_STATE(255)] = 9354,
  [SMALL_STATE(256)] = 9410,
  [SMALL_STATE(257)] = 9436,
  [SMALL_STATE(258)] = 9460,
  [SMALL_STATE(259)] = 9512,
  [SMALL_STATE(260)] = 9536,
  [SMALL_STATE(261)] = 9590,
  [SMALL_STATE(262)] = 9644,
  [SMALL_STATE(263)] = 9700,
  [SMALL_STATE(264)] = 9728,
  [SMALL_STATE(265)] = 9758,
  [SMALL_STATE(266)] = 9788,
  [SMALL_STATE(267)] = 9812,
  [SMALL_STATE(268)] = 9836,
  [SMALL_STATE(269)] = 9884,
  [SMALL_STATE(270)] = 9908,
  [SMALL_STATE(271)] = 9962,
  [SMALL_STATE(272)] = 9986,
  [SMALL_STATE(273)] = 10034,
  [SMALL_STATE(274)] = 10090,
  [SMALL_STATE(275)] = 10122,
  [SMALL_STATE(276)] = 10170,
  [SMALL_STATE(277)] = 10218,
  [SMALL_STATE(278)] = 10272,
  [SMALL_STATE(279)] = 10300,
  [SMALL_STATE(280)] = 10356,
  [SMALL_STATE(281)] = 10386,
  [SMALL_STATE(282)] = 10434,
  [SMALL_STATE(283)] = 10482,
  [SMALL_STATE(284)] = 10530,
  [SMALL_STATE(285)] = 10554,
  [SMALL_STATE(286)] = 10578,
  [SMALL_STATE(287)] = 10602,
  [SMALL_STATE(288)] = 10656,
  [SMALL_STATE(289)] = 10682,
  [SMALL_STATE(290)] = 10710,
  [SMALL_STATE(291)] = 10738,
  [SMALL_STATE(292)] = 10794,
  [SMALL_STATE(293)] = 10842,
  [SMALL_STATE(294)] = 10870,
  [SMALL_STATE(295)] = 10896,
  [SMALL_STATE(296)] = 10924,
  [SMALL_STATE(297)] = 10950,
  [SMALL_STATE(298)] = 10976,
  [SMALL_STATE(299)] = 11000,
  [SMALL_STATE(300)] = 11028,
  [SMALL_STATE(301)] = 11054,
  [SMALL_STATE(302)] = 11078,
  [SMALL_STATE(303)] = 11102,
  [SMALL_STATE(304)] = 11126,
  [SMALL_STATE(305)] = 11150,
  [SMALL_STATE(306)] = 11174,
  [SMALL_STATE(307)] = 11198,
  [SMALL_STATE(308)] = 11222,
  [SMALL_STATE(309)] = 11246,
  [SMALL_STATE(310)] = 11272,
  [SMALL_STATE(311)] = 11296,
  [SMALL_STATE(312)] = 11320,
  [SMALL_STATE(313)] = 11344,
  [SMALL_STATE(314)] = 11369,
  [SMALL_STATE(315)] = 11408,
  [SMALL_STATE(316)] = 11447,
  [SMALL_STATE(317)] = 11482,
  [SMALL_STATE(318)] = 11527,
  [SMALL_STATE(319)] = 11572,
  [SMALL_STATE(320)] = 11611,
  [SMALL_STATE(321)] = 11650,
  [SMALL_STATE(322)] = 11689,
  [SMALL_STATE(323)] = 11734,
  [SMALL_STATE(324)] = 11773,
  [SMALL_STATE(325)] = 11798,
  [SMALL_STATE(326)] = 11837,
  [SMALL_STATE(327)] = 11876,
  [SMALL_STATE(328)] = 11911,
  [SMALL_STATE(329)] = 11956,
  [SMALL_STATE(330)] = 11995,
  [SMALL_STATE(331)] = 12040,
  [SMALL_STATE(332)] = 12079,
  [SMALL_STATE(333)] = 12112,
  [SMALL_STATE(334)] = 12149,
  [SMALL_STATE(335)] = 12188,
  [SMALL_STATE(336)] = 12227,
  [SMALL_STATE(337)] = 12272,
  [SMALL_STATE(338)] = 12311,
  [SMALL_STATE(339)] = 12350,
  [SMALL_STATE(340)] = 12389,
  [SMALL_STATE(341)] = 12428,
  [SMALL_STATE(342)] = 12467,
  [SMALL_STATE(343)] = 12506,
  [SMALL_STATE(344)] = 12530,
  [SMALL_STATE(345)] = 12570,
  [SMALL_STATE(346)] = 12610,
  [SMALL_STATE(347)] = 12650,
  [SMALL_STATE(348)] = 12690,
  [SMALL_STATE(349)] = 12730,
  [SMALL_STATE(350)] = 12770,
  [SMALL_STATE(351)] = 12792,
  [SMALL_STATE(352)] = 12832,
  [SMALL_STATE(353)] = 12872,
  [SMALL_STATE(354)] = 12912,
  [SMALL_STATE(355)] = 12952,
  [SMALL_STATE(356)] = 12992,
  [SMALL_STATE(357)] = 13032,
  [SMALL_STATE(358)] = 13054,
  [SMALL_STATE(359)] = 13094,
  [SMALL_STATE(360)] = 13134,
  [SMALL_STATE(361)] = 13174,
  [SMALL_STATE(362)] = 13214,
  [SMALL_STATE(363)] = 13240,
  [SMALL_STATE(364)] = 13280,
  [SMALL_STATE(365)] = 13320,
  [SMALL_STATE(366)] = 13342,
  [SMALL_STATE(367)] = 13366,
  [SMALL_STATE(368)] = 13406,
  [SMALL_STATE(369)] = 13446,
  [SMALL_STATE(370)] = 13486,
  [SMALL_STATE(371)] = 13526,
  [SMALL_STATE(372)] = 13566,
  [SMALL_STATE(373)] = 13606,
  [SMALL_STATE(374)] = 13630,
  [SMALL_STATE(375)] = 13670,
  [SMALL_STATE(376)] = 13710,
  [SMALL_STATE(377)] = 13750,
  [SMALL_STATE(378)] = 13790,
  [SMALL_STATE(379)] = 13814,
  [SMALL_STATE(380)] = 13838,
  [SMALL_STATE(381)] = 13860,
  [SMALL_STATE(382)] = 13884,
  [SMALL_STATE(383)] = 13908,
  [SMALL_STATE(384)] = 13932,
  [SMALL_STATE(385)] = 13972,
  [SMALL_STATE(386)] = 14012,
  [SMALL_STATE(387)] = 14034,
  [SMALL_STATE(388)] = 14064,
  [SMALL_STATE(389)] = 14104,
  [SMALL_STATE(390)] = 14144,
  [SMALL_STATE(391)] = 14184,
  [SMALL_STATE(392)] = 14210,
  [SMALL_STATE(393)] = 14240,
  [SMALL_STATE(394)] = 14280,
  [SMALL_STATE(395)] = 14320,
  [SMALL_STATE(396)] = 14360,
  [SMALL_STATE(397)] = 14400,
  [SMALL_STATE(398)] = 14440,
  [SMALL_STATE(399)] = 14480,
  [SMALL_STATE(400)] = 14520,
  [SMALL_STATE(401)] = 14544,
  [SMALL_STATE(402)] = 14584,
  [SMALL_STATE(403)] = 14624,
  [SMALL_STATE(404)] = 14664,
  [SMALL_STATE(405)] = 14688,
  [SMALL_STATE(406)] = 14712,
  [SMALL_STATE(407)] = 14752,
  [SMALL_STATE(408)] = 14792,
  [SMALL_STATE(409)] = 14832,
  [SMALL_STATE(410)] = 14872,
  [SMALL_STATE(411)] = 14912,
  [SMALL_STATE(412)] = 14952,
  [SMALL_STATE(413)] = 14992,
  [SMALL_STATE(414)] = 15032,
  [SMALL_STATE(415)] = 15072,
  [SMALL_STATE(416)] = 15108,
  [SMALL_STATE(417)] = 15148,
  [SMALL_STATE(418)] = 15188,
  [SMALL_STATE(419)] = 15228,
  [SMALL_STATE(420)] = 15252,
  [SMALL_STATE(421)] = 15274,
  [SMALL_STATE(422)] = 15314,
  [SMALL_STATE(423)] = 15340,
  [SMALL_STATE(424)] = 15380,
  [SMALL_STATE(425)] = 15410,
  [SMALL_STATE(426)] = 15450,
  [SMALL_STATE(427)] = 15477,
  [SMALL_STATE(428)] = 15502,
  [SMALL_STATE(429)] = 15527,
  [SMALL_STATE(430)] = 15552,
  [SMALL_STATE(431)] = 15579,
  [SMALL_STATE(432)] = 15618,
  [SMALL_STATE(433)] = 15643,
  [SMALL_STATE(434)] = 15682,
  [SMALL_STATE(435)] = 15721,
  [SMALL_STATE(436)] = 15754,
  [SMALL_STATE(437)] = 15787,
  [SMALL_STATE(438)] = 15820,
  [SMALL_STATE(439)] = 15853,
  [SMALL_STATE(440)] = 15882,
  [SMALL_STATE(441)] = 15915,
  [SMALL_STATE(442)] = 15954,
  [SMALL_STATE(443)] = 15979,
  [SMALL_STATE(444)] = 16006,
  [SMALL_STATE(445)] = 16033,
  [SMALL_STATE(446)] = 16066,
  [SMALL_STATE(447)] = 16099,
  [SMALL_STATE(448)] = 16132,
  [SMALL_STATE(449)] = 16171,
  [SMALL_STATE(450)] = 16198,
  [SMALL_STATE(451)] = 16237,
  [SMALL_STATE(452)] = 16270,
  [SMALL_STATE(453)] = 16303,
  [SMALL_STATE(454)] = 16336,
  [SMALL_STATE(455)] = 16363,
  [SMALL_STATE(456)] = 16390,
  [SMALL_STATE(457)] = 16423,
  [SMALL_STATE(458)] = 16456,
  [SMALL_STATE(459)] = 16489,
  [SMALL_STATE(460)] = 16528,
  [SMALL_STATE(461)] = 16567,
  [SMALL_STATE(462)] = 16606,
  [SMALL_STATE(463)] = 16639,
  [SMALL_STATE(464)] = 16672,
  [SMALL_STATE(465)] = 16705,
  [SMALL_STATE(466)] = 16744,
  [SMALL_STATE(467)] = 16783,
  [SMALL_STATE(468)] = 16816,
  [SMALL_STATE(469)] = 16849,
  [SMALL_STATE(470)] = 16879,
  [SMALL_STATE(471)] = 16899,
  [SMALL_STATE(472)] = 16923,
  [SMALL_STATE(473)] = 16953,
  [SMALL_STATE(474)] = 16977,
  [SMALL_STATE(475)] = 17007,
  [SMALL_STATE(476)] = 17031,
  [SMALL_STATE(477)] = 17055,
  [SMALL_STATE(478)] = 17075,
  [SMALL_STATE(479)] = 17095,
  [SMALL_STATE(480)] = 17125,
  [SMALL_STATE(481)] = 17155,
  [SMALL_STATE(482)] = 17175,
  [SMALL_STATE(483)] = 17195,
  [SMALL_STATE(484)] = 17225,
  [SMALL_STATE(485)] = 17255,
  [SMALL_STATE(486)] = 17277,
  [SMALL_STATE(487)] = 17307,
  [SMALL_STATE(488)] = 17329,
  [SMALL_STATE(489)] = 17349,
  [SMALL_STATE(490)] = 17379,
  [SMALL_STATE(491)] = 17403,
  [SMALL_STATE(492)] = 17423,
  [SMALL_STATE(493)] = 17447,
  [SMALL_STATE(494)] = 17477,
  [SMALL_STATE(495)] = 17499,
  [SMALL_STATE(496)] = 17519,
  [SMALL_STATE(497)] = 17549,
  [SMALL_STATE(498)] = 17579,
  [SMALL_STATE(499)] = 17599,
  [SMALL_STATE(500)] = 17629,
  [SMALL_STATE(501)] = 17651,
  [SMALL_STATE(502)] = 17681,
  [SMALL_STATE(503)] = 17711,
  [SMALL_STATE(504)] = 17741,
  [SMALL_STATE(505)] = 17771,
  [SMALL_STATE(506)] = 17801,
  [SMALL_STATE(507)] = 17825,
  [SMALL_STATE(508)] = 17855,
  [SMALL_STATE(509)] = 17878,
  [SMALL_STATE(510)] = 17897,
  [SMALL_STATE(511)] = 17916,
  [SMALL_STATE(512)] = 17943,
  [SMALL_STATE(513)] = 17966,
  [SMALL_STATE(514)] = 17987,
  [SMALL_STATE(515)] = 18010,
  [SMALL_STATE(516)] = 18047,
  [SMALL_STATE(517)] = 18084,
  [SMALL_STATE(518)] = 18121,
  [SMALL_STATE(519)] = 18144,
  [SMALL_STATE(520)] = 18181,
  [SMALL_STATE(521)] = 18208,
  [SMALL_STATE(522)] = 18231,
  [SMALL_STATE(523)] = 18257,
  [SMALL_STATE(524)] = 18283,
  [SMALL_STATE(525)] = 18309,
  [SMALL_STATE(526)] = 18327,
  [SMALL_STATE(527)] = 18345,
  [SMALL_STATE(528)] = 18367,
  [SMALL_STATE(529)] = 18385,
  [SMALL_STATE(530)] = 18403,
  [SMALL_STATE(531)] = 18421,
  [SMALL_STATE(532)] = 18439,
  [SMALL_STATE(533)] = 18465,
  [SMALL_STATE(534)] = 18483,
  [SMALL_STATE(535)] = 18509,
  [SMALL_STATE(536)] = 18527,
  [SMALL_STATE(537)] = 18553,
  [SMALL_STATE(538)] = 18571,
  [SMALL_STATE(539)] = 18597,
  [SMALL_STATE(540)] = 18615,
  [SMALL_STATE(541)] = 18637,
  [SMALL_STATE(542)] = 18655,
  [SMALL_STATE(543)] = 18673,
  [SMALL_STATE(544)] = 18691,
  [SMALL_STATE(545)] = 18717,
  [SMALL_STATE(546)] = 18743,
  [SMALL_STATE(547)] = 18764,
  [SMALL_STATE(548)] = 18785,
  [SMALL_STATE(549)] = 18806,
  [SMALL_STATE(550)] = 18827,
  [SMALL_STATE(551)] = 18848,
  [SMALL_STATE(552)] = 18869,
  [SMALL_STATE(553)] = 18892,
  [SMALL_STATE(554)] = 18913,
  [SMALL_STATE(555)] = 18934,
  [SMALL_STATE(556)] = 18955,
  [SMALL_STATE(557)] = 18976,
  [SMALL_STATE(558)] = 18999,
  [SMALL_STATE(559)] = 19022,
  [SMALL_STATE(560)] = 19045,
  [SMALL_STATE(561)] = 19068,
  [SMALL_STATE(562)] = 19091,
  [SMALL_STATE(563)] = 19112,
  [SMALL_STATE(564)] = 19135,
  [SMALL_STATE(565)] = 19156,
  [SMALL_STATE(566)] = 19177,
  [SMALL_STATE(567)] = 19198,
  [SMALL_STATE(568)] = 19219,
  [SMALL_STATE(569)] = 19240,
  [SMALL_STATE(570)] = 19259,
  [SMALL_STATE(571)] = 19280,
  [SMALL_STATE(572)] = 19305,
  [SMALL_STATE(573)] = 19326,
  [SMALL_STATE(574)] = 19349,
  [SMALL_STATE(575)] = 19372,
  [SMALL_STATE(576)] = 19393,
  [SMALL_STATE(577)] = 19414,
  [SMALL_STATE(578)] = 19435,
  [SMALL_STATE(579)] = 19456,
  [SMALL_STATE(580)] = 19477,
  [SMALL_STATE(581)] = 19498,
  [SMALL_STATE(582)] = 19519,
  [SMALL_STATE(583)] = 19540,
  [SMALL_STATE(584)] = 19561,
  [SMALL_STATE(585)] = 19582,
  [SMALL_STATE(586)] = 19603,
  [SMALL_STATE(587)] = 19626,
  [SMALL_STATE(588)] = 19647,
  [SMALL_STATE(589)] = 19670,
  [SMALL_STATE(590)] = 19691,
  [SMALL_STATE(591)] = 19712,
  [SMALL_STATE(592)] = 19733,
  [SMALL_STATE(593)] = 19756,
  [SMALL_STATE(594)] = 19774,
  [SMALL_STATE(595)] = 19794,
  [SMALL_STATE(596)] = 19812,
  [SMALL_STATE(597)] = 19832,
  [SMALL_STATE(598)] = 19848,
  [SMALL_STATE(599)] = 19864,
  [SMALL_STATE(600)] = 19880,
  [SMALL_STATE(601)] = 19896,
  [SMALL_STATE(602)] = 19912,
  [SMALL_STATE(603)] = 19928,
  [SMALL_STATE(604)] = 19948,
  [SMALL_STATE(605)] = 19964,
  [SMALL_STATE(606)] = 19984,
  [SMALL_STATE(607)] = 20004,
  [SMALL_STATE(608)] = 20022,
  [SMALL_STATE(609)] = 20038,
  [SMALL_STATE(610)] = 20054,
  [SMALL_STATE(611)] = 20070,
  [SMALL_STATE(612)] = 20086,
  [SMALL_STATE(613)] = 20106,
  [SMALL_STATE(614)] = 20122,
  [SMALL_STATE(615)] = 20140,
  [SMALL_STATE(616)] = 20156,
  [SMALL_STATE(617)] = 20172,
  [SMALL_STATE(618)] = 20188,
  [SMALL_STATE(619)] = 20208,
  [SMALL_STATE(620)] = 20224,
  [SMALL_STATE(621)] = 20244,
  [SMALL_STATE(622)] = 20264,
  [SMALL_STATE(623)] = 20284,
  [SMALL_STATE(624)] = 20300,
  [SMALL_STATE(625)] = 20316,
  [SMALL_STATE(626)] = 20332,
  [SMALL_STATE(627)] = 20348,
  [SMALL_STATE(628)] = 20368,
  [SMALL_STATE(629)] = 20384,
  [SMALL_STATE(630)] = 20400,
  [SMALL_STATE(631)] = 20420,
  [SMALL_STATE(632)] = 20440,
  [SMALL_STATE(633)] = 20456,
  [SMALL_STATE(634)] = 20472,
  [SMALL_STATE(635)] = 20488,
  [SMALL_STATE(636)] = 20504,
  [SMALL_STATE(637)] = 20522,
  [SMALL_STATE(638)] = 20542,
  [SMALL_STATE(639)] = 20562,
  [SMALL_STATE(640)] = 20578,
  [SMALL_STATE(641)] = 20594,
  [SMALL_STATE(642)] = 20610,
  [SMALL_STATE(643)] = 20630,
  [SMALL_STATE(644)] = 20646,
  [SMALL_STATE(645)] = 20662,
  [SMALL_STATE(646)] = 20680,
  [SMALL_STATE(647)] = 20696,
  [SMALL_STATE(648)] = 20712,
  [SMALL_STATE(649)] = 20732,
  [SMALL_STATE(650)] = 20748,
  [SMALL_STATE(651)] = 20766,
  [SMALL_STATE(652)] = 20782,
  [SMALL_STATE(653)] = 20798,
  [SMALL_STATE(654)] = 20816,
  [SMALL_STATE(655)] = 20834,
  [SMALL_STATE(656)] = 20850,
  [SMALL_STATE(657)] = 20870,
  [SMALL_STATE(658)] = 20886,
  [SMALL_STATE(659)] = 20902,
  [SMALL_STATE(660)] = 20918,
  [SMALL_STATE(661)] = 20938,
  [SMALL_STATE(662)] = 20958,
  [SMALL_STATE(663)] = 20976,
  [SMALL_STATE(664)] = 20992,
  [SMALL_STATE(665)] = 21008,
  [SMALL_STATE(666)] = 21024,
  [SMALL_STATE(667)] = 21044,
  [SMALL_STATE(668)] = 21060,
  [SMALL_STATE(669)] = 21076,
  [SMALL_STATE(670)] = 21094,
  [SMALL_STATE(671)] = 21123,
  [SMALL_STATE(672)] = 21140,
  [SMALL_STATE(673)] = 21169,
  [SMALL_STATE(674)] = 21186,
  [SMALL_STATE(675)] = 21217,
  [SMALL_STATE(676)] = 21236,
  [SMALL_STATE(677)] = 21265,
  [SMALL_STATE(678)] = 21296,
  [SMALL_STATE(679)] = 21315,
  [SMALL_STATE(680)] = 21334,
  [SMALL_STATE(681)] = 21351,
  [SMALL_STATE(682)] = 21368,
  [SMALL_STATE(683)] = 21385,
  [SMALL_STATE(684)] = 21402,
  [SMALL_STATE(685)] = 21419,
  [SMALL_STATE(686)] = 21436,
  [SMALL_STATE(687)] = 21455,
  [SMALL_STATE(688)] = 21472,
  [SMALL_STATE(689)] = 21489,
  [SMALL_STATE(690)] = 21506,
  [SMALL_STATE(691)] = 21521,
  [SMALL_STATE(692)] = 21546,
  [SMALL_STATE(693)] = 21575,
  [SMALL_STATE(694)] = 21600,
  [SMALL_STATE(695)] = 21619,
  [SMALL_STATE(696)] = 21648,
  [SMALL_STATE(697)] = 21677,
  [SMALL_STATE(698)] = 21706,
  [SMALL_STATE(699)] = 21725,
  [SMALL_STATE(700)] = 21754,
  [SMALL_STATE(701)] = 21783,
  [SMALL_STATE(702)] = 21812,
  [SMALL_STATE(703)] = 21829,
  [SMALL_STATE(704)] = 21858,
  [SMALL_STATE(705)] = 21877,
  [SMALL_STATE(706)] = 21892,
  [SMALL_STATE(707)] = 21911,
  [SMALL_STATE(708)] = 21930,
  [SMALL_STATE(709)] = 21947,
  [SMALL_STATE(710)] = 21964,
  [SMALL_STATE(711)] = 21981,
  [SMALL_STATE(712)] = 21998,
  [SMALL_STATE(713)] = 22015,
  [SMALL_STATE(714)] = 22032,
  [SMALL_STATE(715)] = 22047,
  [SMALL_STATE(716)] = 22064,
  [SMALL_STATE(717)] = 22093,
  [SMALL_STATE(718)] = 22122,
  [SMALL_STATE(719)] = 22137,
  [SMALL_STATE(720)] = 22154,
  [SMALL_STATE(721)] = 22183,
  [SMALL_STATE(722)] = 22200,
  [SMALL_STATE(723)] = 22217,
  [SMALL_STATE(724)] = 22236,
  [SMALL_STATE(725)] = 22251,
  [SMALL_STATE(726)] = 22270,
  [SMALL_STATE(727)] = 22299,
  [SMALL_STATE(728)] = 22318,
  [SMALL_STATE(729)] = 22335,
  [SMALL_STATE(730)] = 22352,
  [SMALL_STATE(731)] = 22369,
  [SMALL_STATE(732)] = 22398,
  [SMALL_STATE(733)] = 22415,
  [SMALL_STATE(734)] = 22434,
  [SMALL_STATE(735)] = 22451,
  [SMALL_STATE(736)] = 22480,
  [SMALL_STATE(737)] = 22499,
  [SMALL_STATE(738)] = 22514,
  [SMALL_STATE(739)] = 22531,
  [SMALL_STATE(740)] = 22548,
  [SMALL_STATE(741)] = 22567,
  [SMALL_STATE(742)] = 22592,
  [SMALL_STATE(743)] = 22609,
  [SMALL_STATE(744)] = 22628,
  [SMALL_STATE(745)] = 22653,
  [SMALL_STATE(746)] = 22682,
  [SMALL_STATE(747)] = 22711,
  [SMALL_STATE(748)] = 22740,
  [SMALL_STATE(749)] = 22759,
  [SMALL_STATE(750)] = 22776,
  [SMALL_STATE(751)] = 22805,
  [SMALL_STATE(752)] = 22822,
  [SMALL_STATE(753)] = 22839,
  [SMALL_STATE(754)] = 22868,
  [SMALL_STATE(755)] = 22885,
  [SMALL_STATE(756)] = 22914,
  [SMALL_STATE(757)] = 22928,
  [SMALL_STATE(758)] = 22942,
  [SMALL_STATE(759)] = 22960,
  [SMALL_STATE(760)] = 22974,
  [SMALL_STATE(761)] = 22992,
  [SMALL_STATE(762)] = 23006,
  [SMALL_STATE(763)] = 23020,
  [SMALL_STATE(764)] = 23046,
  [SMALL_STATE(765)] = 23060,
  [SMALL_STATE(766)] = 23074,
  [SMALL_STATE(767)] = 23088,
  [SMALL_STATE(768)] = 23102,
  [SMALL_STATE(769)] = 23116,
  [SMALL_STATE(770)] = 23134,
  [SMALL_STATE(771)] = 23148,
  [SMALL_STATE(772)] = 23176,
  [SMALL_STATE(773)] = 23190,
  [SMALL_STATE(774)] = 23204,
  [SMALL_STATE(775)] = 23218,
  [SMALL_STATE(776)] = 23232,
  [SMALL_STATE(777)] = 23250,
  [SMALL_STATE(778)] = 23264,
  [SMALL_STATE(779)] = 23278,
  [SMALL_STATE(780)] = 23296,
  [SMALL_STATE(781)] = 23314,
  [SMALL_STATE(782)] = 23328,
  [SMALL_STATE(783)] = 23342,
  [SMALL_STATE(784)] = 23370,
  [SMALL_STATE(785)] = 23388,
  [SMALL_STATE(786)] = 23402,
  [SMALL_STATE(787)] = 23420,
  [SMALL_STATE(788)] = 23434,
  [SMALL_STATE(789)] = 23448,
  [SMALL_STATE(790)] = 23462,
  [SMALL_STATE(791)] = 23476,
  [SMALL_STATE(792)] = 23490,
  [SMALL_STATE(793)] = 23504,
  [SMALL_STATE(794)] = 23518,
  [SMALL_STATE(795)] = 23532,
  [SMALL_STATE(796)] = 23546,
  [SMALL_STATE(797)] = 23560,
  [SMALL_STATE(798)] = 23574,
  [SMALL_STATE(799)] = 23588,
  [SMALL_STATE(800)] = 23602,
  [SMALL_STATE(801)] = 23616,
  [SMALL_STATE(802)] = 23630,
  [SMALL_STATE(803)] = 23644,
  [SMALL_STATE(804)] = 23658,
  [SMALL_STATE(805)] = 23672,
  [SMALL_STATE(806)] = 23686,
  [SMALL_STATE(807)] = 23709,
  [SMALL_STATE(808)] = 23732,
  [SMALL_STATE(809)] = 23755,
  [SMALL_STATE(810)] = 23778,
  [SMALL_STATE(811)] = 23801,
  [SMALL_STATE(812)] = 23826,
  [SMALL_STATE(813)] = 23849,
  [SMALL_STATE(814)] = 23872,
  [SMALL_STATE(815)] = 23897,
  [SMALL_STATE(816)] = 23920,
  [SMALL_STATE(817)] = 23945,
  [SMALL_STATE(818)] = 23968,
  [SMALL_STATE(819)] = 23981,
  [SMALL_STATE(820)] = 23996,
  [SMALL_STATE(821)] = 24021,
  [SMALL_STATE(822)] = 24046,
  [SMALL_STATE(823)] = 24071,
  [SMALL_STATE(824)] = 24094,
  [SMALL_STATE(825)] = 24117,
  [SMALL_STATE(826)] = 24142,
  [SMALL_STATE(827)] = 24167,
  [SMALL_STATE(828)] = 24190,
  [SMALL_STATE(829)] = 24213,
  [SMALL_STATE(830)] = 24238,
  [SMALL_STATE(831)] = 24263,
  [SMALL_STATE(832)] = 24286,
  [SMALL_STATE(833)] = 24309,
  [SMALL_STATE(834)] = 24334,
  [SMALL_STATE(835)] = 24357,
  [SMALL_STATE(836)] = 24382,
  [SMALL_STATE(837)] = 24397,
  [SMALL_STATE(838)] = 24420,
  [SMALL_STATE(839)] = 24443,
  [SMALL_STATE(840)] = 24466,
  [SMALL_STATE(841)] = 24491,
  [SMALL_STATE(842)] = 24514,
  [SMALL_STATE(843)] = 24537,
  [SMALL_STATE(844)] = 24560,
  [SMALL_STATE(845)] = 24583,
  [SMALL_STATE(846)] = 24606,
  [SMALL_STATE(847)] = 24629,
  [SMALL_STATE(848)] = 24654,
  [SMALL_STATE(849)] = 24669,
  [SMALL_STATE(850)] = 24692,
  [SMALL_STATE(851)] = 24715,
  [SMALL_STATE(852)] = 24738,
  [SMALL_STATE(853)] = 24763,
  [SMALL_STATE(854)] = 24786,
  [SMALL_STATE(855)] = 24809,
  [SMALL_STATE(856)] = 24832,
  [SMALL_STATE(857)] = 24855,
  [SMALL_STATE(858)] = 24878,
  [SMALL_STATE(859)] = 24903,
  [SMALL_STATE(860)] = 24928,
  [SMALL_STATE(861)] = 24951,
  [SMALL_STATE(862)] = 24974,
  [SMALL_STATE(863)] = 24999,
  [SMALL_STATE(864)] = 25022,
  [SMALL_STATE(865)] = 25034,
  [SMALL_STATE(866)] = 25046,
  [SMALL_STATE(867)] = 25064,
  [SMALL_STATE(868)] = 25084,
  [SMALL_STATE(869)] = 25102,
  [SMALL_STATE(870)] = 25120,
  [SMALL_STATE(871)] = 25138,
  [SMALL_STATE(872)] = 25156,
  [SMALL_STATE(873)] = 25176,
  [SMALL_STATE(874)] = 25188,
  [SMALL_STATE(875)] = 25206,
  [SMALL_STATE(876)] = 25224,
  [SMALL_STATE(877)] = 25236,
  [SMALL_STATE(878)] = 25254,
  [SMALL_STATE(879)] = 25272,
  [SMALL_STATE(880)] = 25284,
  [SMALL_STATE(881)] = 25296,
  [SMALL_STATE(882)] = 25314,
  [SMALL_STATE(883)] = 25326,
  [SMALL_STATE(884)] = 25338,
  [SMALL_STATE(885)] = 25350,
  [SMALL_STATE(886)] = 25362,
  [SMALL_STATE(887)] = 25374,
  [SMALL_STATE(888)] = 25386,
  [SMALL_STATE(889)] = 25398,
  [SMALL_STATE(890)] = 25410,
  [SMALL_STATE(891)] = 25422,
  [SMALL_STATE(892)] = 25434,
  [SMALL_STATE(893)] = 25446,
  [SMALL_STATE(894)] = 25458,
  [SMALL_STATE(895)] = 25476,
  [SMALL_STATE(896)] = 25494,
  [SMALL_STATE(897)] = 25506,
  [SMALL_STATE(898)] = 25518,
  [SMALL_STATE(899)] = 25538,
  [SMALL_STATE(900)] = 25556,
  [SMALL_STATE(901)] = 25574,
  [SMALL_STATE(902)] = 25586,
  [SMALL_STATE(903)] = 25598,
  [SMALL_STATE(904)] = 25610,
  [SMALL_STATE(905)] = 25628,
  [SMALL_STATE(906)] = 25640,
  [SMALL_STATE(907)] = 25660,
  [SMALL_STATE(908)] = 25678,
  [SMALL_STATE(909)] = 25690,
  [SMALL_STATE(910)] = 25702,
  [SMALL_STATE(911)] = 25714,
  [SMALL_STATE(912)] = 25726,
  [SMALL_STATE(913)] = 25746,
  [SMALL_STATE(914)] = 25764,
  [SMALL_STATE(915)] = 25782,
  [SMALL_STATE(916)] = 25800,
  [SMALL_STATE(917)] = 25812,
  [SMALL_STATE(918)] = 25832,
  [SMALL_STATE(919)] = 25850,
  [SMALL_STATE(920)] = 25868,
  [SMALL_STATE(921)] = 25880,
  [SMALL_STATE(922)] = 25900,
  [SMALL_STATE(923)] = 25918,
  [SMALL_STATE(924)] = 25936,
  [SMALL_STATE(925)] = 25954,
  [SMALL_STATE(926)] = 25972,
  [SMALL_STATE(927)] = 25984,
  [SMALL_STATE(928)] = 25996,
  [SMALL_STATE(929)] = 26014,
  [SMALL_STATE(930)] = 26026,
  [SMALL_STATE(931)] = 26038,
  [SMALL_STATE(932)] = 26050,
  [SMALL_STATE(933)] = 26062,
  [SMALL_STATE(934)] = 26074,
  [SMALL_STATE(935)] = 26086,
  [SMALL_STATE(936)] = 26104,
  [SMALL_STATE(937)] = 26116,
  [SMALL_STATE(938)] = 26134,
  [SMALL_STATE(939)] = 26146,
  [SMALL_STATE(940)] = 26164,
  [SMALL_STATE(941)] = 26182,
  [SMALL_STATE(942)] = 26194,
  [SMALL_STATE(943)] = 26206,
  [SMALL_STATE(944)] = 26218,
  [SMALL_STATE(945)] = 26230,
  [SMALL_STATE(946)] = 26242,
  [SMALL_STATE(947)] = 26262,
  [SMALL_STATE(948)] = 26274,
  [SMALL_STATE(949)] = 26286,
  [SMALL_STATE(950)] = 26304,
  [SMALL_STATE(951)] = 26322,
  [SMALL_STATE(952)] = 26340,
  [SMALL_STATE(953)] = 26358,
  [SMALL_STATE(954)] = 26370,
  [SMALL_STATE(955)] = 26382,
  [SMALL_STATE(956)] = 26400,
  [SMALL_STATE(957)] = 26420,
  [SMALL_STATE(958)] = 26440,
  [SMALL_STATE(959)] = 26452,
  [SMALL_STATE(960)] = 26464,
  [SMALL_STATE(961)] = 26476,
  [SMALL_STATE(962)] = 26494,
  [SMALL_STATE(963)] = 26512,
  [SMALL_STATE(964)] = 26530,
  [SMALL_STATE(965)] = 26542,
  [SMALL_STATE(966)] = 26554,
  [SMALL_STATE(967)] = 26571,
  [SMALL_STATE(968)] = 26588,
  [SMALL_STATE(969)] = 26605,
  [SMALL_STATE(970)] = 26624,
  [SMALL_STATE(971)] = 26641,
  [SMALL_STATE(972)] = 26660,
  [SMALL_STATE(973)] = 26677,
  [SMALL_STATE(974)] = 26694,
  [SMALL_STATE(975)] = 26711,
  [SMALL_STATE(976)] = 26728,
  [SMALL_STATE(977)] = 26745,
  [SMALL_STATE(978)] = 26762,
  [SMALL_STATE(979)] = 26779,
  [SMALL_STATE(980)] = 26796,
  [SMALL_STATE(981)] = 26815,
  [SMALL_STATE(982)] = 26834,
  [SMALL_STATE(983)] = 26851,
  [SMALL_STATE(984)] = 26870,
  [SMALL_STATE(985)] = 26889,
  [SMALL_STATE(986)] = 26908,
  [SMALL_STATE(987)] = 26927,
  [SMALL_STATE(988)] = 26946,
  [SMALL_STATE(989)] = 26963,
  [SMALL_STATE(990)] = 26982,
  [SMALL_STATE(991)] = 27001,
  [SMALL_STATE(992)] = 27020,
  [SMALL_STATE(993)] = 27037,
  [SMALL_STATE(994)] = 27054,
  [SMALL_STATE(995)] = 27071,
  [SMALL_STATE(996)] = 27090,
  [SMALL_STATE(997)] = 27107,
  [SMALL_STATE(998)] = 27126,
  [SMALL_STATE(999)] = 27141,
  [SMALL_STATE(1000)] = 27160,
  [SMALL_STATE(1001)] = 27177,
  [SMALL_STATE(1002)] = 27196,
  [SMALL_STATE(1003)] = 27215,
  [SMALL_STATE(1004)] = 27232,
  [SMALL_STATE(1005)] = 27251,
  [SMALL_STATE(1006)] = 27268,
  [SMALL_STATE(1007)] = 27285,
  [SMALL_STATE(1008)] = 27302,
  [SMALL_STATE(1009)] = 27319,
  [SMALL_STATE(1010)] = 27336,
  [SMALL_STATE(1011)] = 27353,
  [SMALL_STATE(1012)] = 27372,
  [SMALL_STATE(1013)] = 27391,
  [SMALL_STATE(1014)] = 27410,
  [SMALL_STATE(1015)] = 27427,
  [SMALL_STATE(1016)] = 27444,
  [SMALL_STATE(1017)] = 27461,
  [SMALL_STATE(1018)] = 27478,
  [SMALL_STATE(1019)] = 27497,
  [SMALL_STATE(1020)] = 27514,
  [SMALL_STATE(1021)] = 27531,
  [SMALL_STATE(1022)] = 27548,
  [SMALL_STATE(1023)] = 27565,
  [SMALL_STATE(1024)] = 27582,
  [SMALL_STATE(1025)] = 27599,
  [SMALL_STATE(1026)] = 27618,
  [SMALL_STATE(1027)] = 27637,
  [SMALL_STATE(1028)] = 27656,
  [SMALL_STATE(1029)] = 27671,
  [SMALL_STATE(1030)] = 27688,
  [SMALL_STATE(1031)] = 27705,
  [SMALL_STATE(1032)] = 27722,
  [SMALL_STATE(1033)] = 27739,
  [SMALL_STATE(1034)] = 27758,
  [SMALL_STATE(1035)] = 27775,
  [SMALL_STATE(1036)] = 27787,
  [SMALL_STATE(1037)] = 27799,
  [SMALL_STATE(1038)] = 27811,
  [SMALL_STATE(1039)] = 27825,
  [SMALL_STATE(1040)] = 27839,
  [SMALL_STATE(1041)] = 27851,
  [SMALL_STATE(1042)] = 27860,
  [SMALL_STATE(1043)] = 27869,
  [SMALL_STATE(1044)] = 27878,
  [SMALL_STATE(1045)] = 27887,
  [SMALL_STATE(1046)] = 27900,
  [SMALL_STATE(1047)] = 27913,
  [SMALL_STATE(1048)] = 27926,
  [SMALL_STATE(1049)] = 27939,
  [SMALL_STATE(1050)] = 27952,
  [SMALL_STATE(1051)] = 27961,
  [SMALL_STATE(1052)] = 27974,
  [SMALL_STATE(1053)] = 27987,
  [SMALL_STATE(1054)] = 28000,
  [SMALL_STATE(1055)] = 28013,
  [SMALL_STATE(1056)] = 28022,
  [SMALL_STATE(1057)] = 28035,
  [SMALL_STATE(1058)] = 28048,
  [SMALL_STATE(1059)] = 28061,
  [SMALL_STATE(1060)] = 28074,
  [SMALL_STATE(1061)] = 28087,
  [SMALL_STATE(1062)] = 28100,
  [SMALL_STATE(1063)] = 28113,
  [SMALL_STATE(1064)] = 28126,
  [SMALL_STATE(1065)] = 28139,
  [SMALL_STATE(1066)] = 28152,
  [SMALL_STATE(1067)] = 28165,
  [SMALL_STATE(1068)] = 28178,
  [SMALL_STATE(1069)] = 28187,
  [SMALL_STATE(1070)] = 28200,
  [SMALL_STATE(1071)] = 28213,
  [SMALL_STATE(1072)] = 28222,
  [SMALL_STATE(1073)] = 28235,
  [SMALL_STATE(1074)] = 28248,
  [SMALL_STATE(1075)] = 28261,
  [SMALL_STATE(1076)] = 28274,
  [SMALL_STATE(1077)] = 28287,
  [SMALL_STATE(1078)] = 28297,
  [SMALL_STATE(1079)] = 28307,
  [SMALL_STATE(1080)] = 28317,
  [SMALL_STATE(1081)] = 28327,
  [SMALL_STATE(1082)] = 28337,
  [SMALL_STATE(1083)] = 28347,
  [SMALL_STATE(1084)] = 28357,
  [SMALL_STATE(1085)] = 28367,
  [SMALL_STATE(1086)] = 28377,
  [SMALL_STATE(1087)] = 28387,
  [SMALL_STATE(1088)] = 28397,
  [SMALL_STATE(1089)] = 28407,
  [SMALL_STATE(1090)] = 28417,
  [SMALL_STATE(1091)] = 28427,
  [SMALL_STATE(1092)] = 28437,
  [SMALL_STATE(1093)] = 28447,
  [SMALL_STATE(1094)] = 28457,
  [SMALL_STATE(1095)] = 28467,
  [SMALL_STATE(1096)] = 28477,
  [SMALL_STATE(1097)] = 28487,
  [SMALL_STATE(1098)] = 28497,
  [SMALL_STATE(1099)] = 28507,
  [SMALL_STATE(1100)] = 28517,
  [SMALL_STATE(1101)] = 28527,
  [SMALL_STATE(1102)] = 28537,
  [SMALL_STATE(1103)] = 28547,
  [SMALL_STATE(1104)] = 28557,
  [SMALL_STATE(1105)] = 28567,
  [SMALL_STATE(1106)] = 28577,
  [SMALL_STATE(1107)] = 28587,
  [SMALL_STATE(1108)] = 28597,
  [SMALL_STATE(1109)] = 28607,
  [SMALL_STATE(1110)] = 28617,
  [SMALL_STATE(1111)] = 28627,
  [SMALL_STATE(1112)] = 28637,
  [SMALL_STATE(1113)] = 28647,
  [SMALL_STATE(1114)] = 28657,
  [SMALL_STATE(1115)] = 28667,
  [SMALL_STATE(1116)] = 28677,
  [SMALL_STATE(1117)] = 28687,
  [SMALL_STATE(1118)] = 28697,
  [SMALL_STATE(1119)] = 28707,
  [SMALL_STATE(1120)] = 28717,
  [SMALL_STATE(1121)] = 28727,
  [SMALL_STATE(1122)] = 28737,
  [SMALL_STATE(1123)] = 28747,
  [SMALL_STATE(1124)] = 28757,
  [SMALL_STATE(1125)] = 28767,
  [SMALL_STATE(1126)] = 28777,
  [SMALL_STATE(1127)] = 28787,
  [SMALL_STATE(1128)] = 28797,
  [SMALL_STATE(1129)] = 28807,
  [SMALL_STATE(1130)] = 28817,
  [SMALL_STATE(1131)] = 28827,
  [SMALL_STATE(1132)] = 28837,
  [SMALL_STATE(1133)] = 28847,
  [SMALL_STATE(1134)] = 28857,
  [SMALL_STATE(1135)] = 28867,
  [SMALL_STATE(1136)] = 28877,
  [SMALL_STATE(1137)] = 28887,
  [SMALL_STATE(1138)] = 28897,
  [SMALL_STATE(1139)] = 28907,
  [SMALL_STATE(1140)] = 28917,
  [SMALL_STATE(1141)] = 28925,
  [SMALL_STATE(1142)] = 28935,
  [SMALL_STATE(1143)] = 28945,
  [SMALL_STATE(1144)] = 28955,
  [SMALL_STATE(1145)] = 28965,
  [SMALL_STATE(1146)] = 28975,
  [SMALL_STATE(1147)] = 28985,
  [SMALL_STATE(1148)] = 28995,
  [SMALL_STATE(1149)] = 29005,
  [SMALL_STATE(1150)] = 29015,
  [SMALL_STATE(1151)] = 29025,
  [SMALL_STATE(1152)] = 29035,
  [SMALL_STATE(1153)] = 29045,
  [SMALL_STATE(1154)] = 29055,
  [SMALL_STATE(1155)] = 29065,
  [SMALL_STATE(1156)] = 29075,
  [SMALL_STATE(1157)] = 29085,
  [SMALL_STATE(1158)] = 29095,
  [SMALL_STATE(1159)] = 29105,
  [SMALL_STATE(1160)] = 29115,
  [SMALL_STATE(1161)] = 29125,
  [SMALL_STATE(1162)] = 29135,
  [SMALL_STATE(1163)] = 29145,
  [SMALL_STATE(1164)] = 29152,
  [SMALL_STATE(1165)] = 29159,
  [SMALL_STATE(1166)] = 29166,
  [SMALL_STATE(1167)] = 29173,
  [SMALL_STATE(1168)] = 29180,
  [SMALL_STATE(1169)] = 29187,
  [SMALL_STATE(1170)] = 29194,
  [SMALL_STATE(1171)] = 29201,
  [SMALL_STATE(1172)] = 29208,
  [SMALL_STATE(1173)] = 29215,
  [SMALL_STATE(1174)] = 29222,
  [SMALL_STATE(1175)] = 29229,
  [SMALL_STATE(1176)] = 29236,
  [SMALL_STATE(1177)] = 29243,
  [SMALL_STATE(1178)] = 29250,
  [SMALL_STATE(1179)] = 29257,
  [SMALL_STATE(1180)] = 29264,
  [SMALL_STATE(1181)] = 29271,
  [SMALL_STATE(1182)] = 29278,
  [SMALL_STATE(1183)] = 29285,
  [SMALL_STATE(1184)] = 29292,
  [SMALL_STATE(1185)] = 29299,
  [SMALL_STATE(1186)] = 29306,
  [SMALL_STATE(1187)] = 29313,
  [SMALL_STATE(1188)] = 29320,
  [SMALL_STATE(1189)] = 29327,
  [SMALL_STATE(1190)] = 29334,
  [SMALL_STATE(1191)] = 29341,
  [SMALL_STATE(1192)] = 29348,
  [SMALL_STATE(1193)] = 29355,
  [SMALL_STATE(1194)] = 29362,
  [SMALL_STATE(1195)] = 29369,
  [SMALL_STATE(1196)] = 29376,
  [SMALL_STATE(1197)] = 29383,
  [SMALL_STATE(1198)] = 29390,
  [SMALL_STATE(1199)] = 29397,
  [SMALL_STATE(1200)] = 29404,
  [SMALL_STATE(1201)] = 29411,
  [SMALL_STATE(1202)] = 29418,
  [SMALL_STATE(1203)] = 29425,
  [SMALL_STATE(1204)] = 29432,
  [SMALL_STATE(1205)] = 29439,
  [SMALL_STATE(1206)] = 29446,
  [SMALL_STATE(1207)] = 29453,
  [SMALL_STATE(1208)] = 29460,
  [SMALL_STATE(1209)] = 29467,
  [SMALL_STATE(1210)] = 29474,
  [SMALL_STATE(1211)] = 29481,
  [SMALL_STATE(1212)] = 29488,
  [SMALL_STATE(1213)] = 29495,
  [SMALL_STATE(1214)] = 29502,
  [SMALL_STATE(1215)] = 29509,
  [SMALL_STATE(1216)] = 29516,
  [SMALL_STATE(1217)] = 29523,
  [SMALL_STATE(1218)] = 29530,
  [SMALL_STATE(1219)] = 29537,
  [SMALL_STATE(1220)] = 29544,
  [SMALL_STATE(1221)] = 29551,
  [SMALL_STATE(1222)] = 29558,
  [SMALL_STATE(1223)] = 29565,
  [SMALL_STATE(1224)] = 29572,
  [SMALL_STATE(1225)] = 29579,
  [SMALL_STATE(1226)] = 29586,
  [SMALL_STATE(1227)] = 29593,
  [SMALL_STATE(1228)] = 29600,
  [SMALL_STATE(1229)] = 29607,
  [SMALL_STATE(1230)] = 29614,
  [SMALL_STATE(1231)] = 29621,
  [SMALL_STATE(1232)] = 29628,
  [SMALL_STATE(1233)] = 29635,
  [SMALL_STATE(1234)] = 29642,
  [SMALL_STATE(1235)] = 29649,
  [SMALL_STATE(1236)] = 29656,
  [SMALL_STATE(1237)] = 29663,
  [SMALL_STATE(1238)] = 29670,
  [SMALL_STATE(1239)] = 29677,
  [SMALL_STATE(1240)] = 29684,
  [SMALL_STATE(1241)] = 29691,
  [SMALL_STATE(1242)] = 29698,
  [SMALL_STATE(1243)] = 29705,
  [SMALL_STATE(1244)] = 29712,
  [SMALL_STATE(1245)] = 29719,
  [SMALL_STATE(1246)] = 29726,
  [SMALL_STATE(1247)] = 29733,
  [SMALL_STATE(1248)] = 29740,
  [SMALL_STATE(1249)] = 29747,
  [SMALL_STATE(1250)] = 29754,
  [SMALL_STATE(1251)] = 29761,
  [SMALL_STATE(1252)] = 29768,
  [SMALL_STATE(1253)] = 29775,
  [SMALL_STATE(1254)] = 29782,
  [SMALL_STATE(1255)] = 29789,
  [SMALL_STATE(1256)] = 29796,
  [SMALL_STATE(1257)] = 29803,
  [SMALL_STATE(1258)] = 29810,
  [SMALL_STATE(1259)] = 29817,
  [SMALL_STATE(1260)] = 29824,
  [SMALL_STATE(1261)] = 29831,
  [SMALL_STATE(1262)] = 29838,
  [SMALL_STATE(1263)] = 29845,
  [SMALL_STATE(1264)] = 29852,
  [SMALL_STATE(1265)] = 29859,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [21] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_variableunit, 1, .production_id = 2), REDUCE(sym__logic_unit, 1, .production_id = 2),
  [24] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), REDUCE(sym__logic_unit, 1, .production_id = 2),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [31] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logic_unit, 1, .production_id = 2),
  [33] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__logic_unit, 1, .production_id = 2),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(862),
  [37] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6),
  [39] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6),
  [41] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(991),
  [44] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(811),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [55] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT(811),
  [58] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT_REPEAT(1197),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7),
  [65] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT_REPEAT(1196),
  [68] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT(811),
  [71] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, .production_id = 1),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1),
  [75] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1), SHIFT(811),
  [78] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2, .production_id = 4),
  [80] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4),
  [82] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4), SHIFT(811),
  [85] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), REDUCE(sym_operatorunit, 3),
  [89] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), REDUCE(sym_operatorunit, 3),
  [93] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logic_unit, 1),
  [95] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__logic_unit, 1),
  [97] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1),
  [100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9),
  [107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9),
  [109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(811),
  [112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(862),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_normal_command, 6, .production_id = 5),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_command, 6, .production_id = 5),
  [135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_listitem, 4, .production_id = 14), REDUCE(aux_sym_expression_statement_repeat1, 5, .production_id = 27),
  [144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_listitem, 4, .production_id = 14), REDUCE(aux_sym_expression_statement_repeat1, 5, .production_id = 27),
  [147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_normal_command, 5, .production_id = 5),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_command, 5, .production_id = 5),
  [151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_listitem, 4, .production_id = 15),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_listitem, 4, .production_id = 15),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_listitem, 4, .production_id = 14),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_listitem, 4, .production_id = 14),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_normal_command, 4, .production_id = 5),
  [163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_command, 4, .production_id = 5),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_normal_command, 3, .production_id = 5),
  [173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_normal_command, 3, .production_id = 5),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_statement_repeat1, 5, .production_id = 29),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 5, .production_id = 29),
  [181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_expression_statement_repeat1, 5, .production_id = 28),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 5, .production_id = 28),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_normal_command_repeat1, 2), SHIFT_REPEAT(282),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_normal_command_repeat1, 2), SHIFT_REPEAT(487),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_normal_command_repeat1, 2), SHIFT_REPEAT(881),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_normal_command_repeat1, 2), SHIFT_REPEAT(928),
  [205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_normal_command_repeat1, 2), SHIFT_REPEAT(61),
  [208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_normal_command_repeat1, 2), SHIFT_REPEAT(261),
  [211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_normal_command_repeat1, 2), SHIFT_REPEAT(198),
  [214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_normal_command_repeat1, 2), SHIFT_REPEAT(517),
  [217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_normal_command_repeat1, 2), SHIFT_REPEAT(460),
  [220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4, .production_id = 17),
  [246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4, .production_id = 17),
  [248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(847),
  [257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(981),
  [260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(821),
  [263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, .production_id = 12),
  [265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, .production_id = 12),
  [267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3, .production_id = 17),
  [273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3, .production_id = 17),
  [275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(980),
  [278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(820),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 4, .production_id = 24),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 4, .production_id = 24),
  [315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(990),
  [318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(875),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__logic_unit, 1), REDUCE(sym_operatorunit, 3),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), REDUCE(sym_operatorunit, 3),
  [344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionaries_repeat1, 2), SHIFT_REPEAT(282),
  [355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dictionaries_repeat1, 2), SHIFT_REPEAT(487),
  [358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dictionaries_repeat1, 2), SHIFT_REPEAT(881),
  [361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionaries_repeat1, 2), SHIFT_REPEAT(928),
  [364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionaries_repeat1, 2),
  [366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionaries_repeat1, 2), SHIFT_REPEAT(261),
  [369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dictionaries_repeat1, 2), SHIFT_REPEAT(198),
  [372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionaries_repeat1, 2), SHIFT_REPEAT(517),
  [375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_dictionaries_repeat1, 2), SHIFT_REPEAT(460),
  [378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(949),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [400] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4), SHIFT(847),
  [419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1), SHIFT(847),
  [422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT_REPEAT(1223),
  [425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT(847),
  [428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT_REPEAT(1224),
  [431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT(847),
  [434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT(821),
  [439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(821),
  [442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [444] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT(821),
  [447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(847),
  [450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(820),
  [453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1), SHIFT(820),
  [456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT(820),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT_REPEAT(1247),
  [464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT(820),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT_REPEAT(1246),
  [474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4), SHIFT(820),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4), SHIFT(821),
  [482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT_REPEAT(1243),
  [485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT_REPEAT(1242),
  [488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1), SHIFT(821),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [497] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_command, 2),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__logic_unit, 3),
  [507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__logic_unit, 3),
  [509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(829),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(859),
  [519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool, 1),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool, 1),
  [523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_command, 2),
  [525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_unit, 2, .production_id = 10),
  [531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_unit, 2, .production_id = 10),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(783),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_unit, 1, .production_id = 3),
  [553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_unit, 1, .production_id = 3),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_unit, 2, .production_id = 11),
  [575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_unit, 2, .production_id = 11),
  [577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_unit, 3, .production_id = 19),
  [579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_unit, 3, .production_id = 19),
  [581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(825),
  [584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(1018),
  [587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elseif_command, 3),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1041),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_command, 3),
  [595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(881),
  [600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(928),
  [603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(741),
  [606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(243),
  [611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1263),
  [614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(192),
  [617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(852),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [622] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), REDUCE(sym__logic_unit, 1, .production_id = 2), SHIFT(112),
  [626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [630] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), REDUCE(sym__logic_unit, 1, .production_id = 2), REDUCE(sym_pair, 3, .production_id = 22),
  [634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1), SHIFT(859),
  [637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4), SHIFT(859),
  [640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT_REPEAT(1249),
  [643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT(859),
  [646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT_REPEAT(1250),
  [649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT(859),
  [652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(859),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(755),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(699),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(750),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 18), SHIFT_REPEAT(487),
  [730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 18), SHIFT_REPEAT(881),
  [733] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 18), SHIFT_REPEAT(928),
  [736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 18), SHIFT_REPEAT(61),
  [739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 18), SHIFT_REPEAT(261),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 18),
  [744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 18), SHIFT_REPEAT(763),
  [747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 18), SHIFT_REPEAT(1225),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(717),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(697),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(840),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [811] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(583),
  [815] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(646),
  [819] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(570),
  [823] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(24),
  [827] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), REDUCE(sym_pair, 3, .production_id = 22),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [839] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(555),
  [843] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(169),
  [847] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(546),
  [851] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(129),
  [855] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(568),
  [859] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(30),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [867] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(564),
  [871] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(193),
  [875] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(567),
  [879] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(137),
  [883] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(549),
  [887] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(626),
  [891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(282),
  [894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(487),
  [897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(881),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(928),
  [903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(261),
  [906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(332),
  [909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(677),
  [912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(431),
  [915] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(584),
  [919] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(309),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [927] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(580),
  [931] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(597),
  [935] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(112),
  [939] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(582),
  [943] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(288),
  [947] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(575),
  [951] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(604),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [959] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(589),
  [963] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(196),
  [967] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(572),
  [971] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(641),
  [975] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(587),
  [979] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(665),
  [983] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(590),
  [987] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(482),
  [991] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(562),
  [995] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(498),
  [999] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(591),
  [1003] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(191),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(887),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(897),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [1051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(691),
  [1054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1264),
  [1057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(361),
  [1060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [1062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [1064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [1068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(944),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variableunit_repeat1, 2, .production_id = 23),
  [1086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variableunit_repeat1, 2, .production_id = 23),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [1100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(835),
  [1103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(947),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(916),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(657),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(655),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(643),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(640),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(964),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(629),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(624),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(920),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(691),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_command, 2),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [1159] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_variableunit, 1), REDUCE(sym__logic_unit, 1), SHIFT(662),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(693),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1244),
  [1171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(416),
  [1174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_command, 1),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(744),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1265),
  [1192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(423),
  [1195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(989),
  [1198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT_REPEAT(1230),
  [1201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT(835),
  [1204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1), SHIFT(835),
  [1207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4), SHIFT(835),
  [1210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT_REPEAT(1231),
  [1213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT(835),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(835),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(567),
  [1248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(137),
  [1251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(562),
  [1254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(498),
  [1257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(591),
  [1260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(191),
  [1263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(587),
  [1266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(665),
  [1269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(589),
  [1272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(196),
  [1275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(572),
  [1278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(641),
  [1281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(555),
  [1284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(169),
  [1287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(546),
  [1290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(129),
  [1293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(583),
  [1296] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(646),
  [1299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variableunit_repeat1, 2),
  [1301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variableunit_repeat1, 2),
  [1303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(568),
  [1306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(30),
  [1309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(584),
  [1312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(309),
  [1315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(564),
  [1318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(193),
  [1321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(580),
  [1324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(597),
  [1327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(570),
  [1330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(24),
  [1333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(582),
  [1336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(288),
  [1339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(575),
  [1342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(604),
  [1345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(590),
  [1348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(482),
  [1351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(549),
  [1354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(626),
  [1357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(830),
  [1360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_variableunit_repeat1, 2, .production_id = 11),
  [1362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variableunit_repeat1, 2, .production_id = 11),
  [1364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variableunit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(735),
  [1367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), SHIFT(662),
  [1370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variableunit, 2, .production_id = 13),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variableunit, 2, .production_id = 13),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variableunit, 2, .production_id = 10),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variableunit, 2, .production_id = 10),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [1404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(822),
  [1407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__unit, 1),
  [1409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unit, 1),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [1415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(983),
  [1418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(985),
  [1421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(826),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [1426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(816),
  [1429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__logic_unit, 1), REDUCE(sym_pair, 3, .production_id = 22),
  [1432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 6), SHIFT(1002),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [1437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_normal_command_repeat1, 2),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_normal_command_repeat1, 2),
  [1443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1), SHIFT(826),
  [1446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4), SHIFT(826),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [1451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1), SHIFT(822),
  [1454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT_REPEAT(1239),
  [1457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT(822),
  [1460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4), SHIFT(822),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT_REPEAT(1235),
  [1468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT(826),
  [1471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT_REPEAT(1234),
  [1474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT(826),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [1479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT_REPEAT(1238),
  [1482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT(822),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(816),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [1500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operatorunit, 3),
  [1502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operatorunit, 3),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [1510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT_REPEAT(1174),
  [1513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 8), SHIFT(816),
  [1516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT_REPEAT(1177),
  [1519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 7), SHIFT(816),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(826),
  [1527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(822),
  [1530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 1), SHIFT(816),
  [1533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_expression_statement, 2, .production_id = 4), SHIFT(816),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [1558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(833),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_condition, 4),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_condition, 4),
  [1565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 5, .production_id = 26),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 5, .production_id = 26),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionaries, 3),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionaries, 3),
  [1573] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(814),
  [1576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 5, .production_id = 25),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 5, .production_id = 25),
  [1580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionaries, 4),
  [1582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionaries, 4),
  [1584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 6, .production_id = 25),
  [1586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 6, .production_id = 25),
  [1588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 6, .production_id = 26),
  [1590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 6, .production_id = 26),
  [1592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionaries, 2),
  [1594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionaries, 2),
  [1596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 6, .production_id = 30),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 6, .production_id = 30),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_condition, 2),
  [1602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_condition, 2),
  [1604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 6, .production_id = 31),
  [1606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 6, .production_id = 31),
  [1608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ternaryoperator, 5),
  [1610] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternaryoperator, 5),
  [1612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 7, .production_id = 30),
  [1614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 7, .production_id = 30),
  [1616] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_dictionaries_repeat1, 2),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreach_command, 7, .production_id = 31),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreach_command, 7, .production_id = 31),
  [1622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_expression_statement_repeat1, 2, .production_id = 9), SHIFT_REPEAT(858),
  [1625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_condition, 3),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_condition, 3),
  [1629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(742),
  [1632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(788),
  [1635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_unit_repeat1, 3, .production_id = 3),
  [1637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_var_unit_repeat1, 3, .production_id = 3),
  [1639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(383),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_unit_repeat1, 4, .production_id = 10),
  [1644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_var_unit_repeat1, 4, .production_id = 10),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [1648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variableunit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(703),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_unit_repeat1, 3, .production_id = 10),
  [1659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_var_unit_repeat1, 3, .production_id = 10),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [1665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(762),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [1672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(257),
  [1683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(537),
  [1686] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variableunit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(695),
  [1689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(765),
  [1692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(251),
  [1695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(405),
  [1698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 3),
  [1700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_var_unit_repeat1, 2, .production_id = 3),
  [1702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [1704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1710] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(756),
  [1713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(542),
  [1716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(298),
  [1719] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(236),
  [1722] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variableunit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(676),
  [1725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(86),
  [1728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2),
  [1730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2),
  [1732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(925),
  [1734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [1736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [1738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [1740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [1742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [1744] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 16),
  [1746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_list_repeat1, 2, .production_id = 16),
  [1748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [1752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(796),
  [1755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(308),
  [1758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(64),
  [1761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(233),
  [1764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [1766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1, .production_id = 2), SHIFT(775),
  [1769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variableunit_repeat1, 2, .production_id = 11), SHIFT_REPEAT(753),
  [1772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [1778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [1780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [1782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [1784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [1786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [1788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [1794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [1804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(734),
  [1807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(304),
  [1810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(231),
  [1813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(252),
  [1816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(381),
  [1819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(343),
  [1822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [1824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(761),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(65),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(793),
  [1845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(795),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(768),
  [1855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(773),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(804),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [1867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(533),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(80),
  [1877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(528),
  [1880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(766),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(404),
  [1888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(217),
  [1891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(266),
  [1894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(269),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(82),
  [1904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(541),
  [1907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [1909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(802),
  [1912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(798),
  [1915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(312),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(306),
  [1925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(229),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [1930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [1934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [1936] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [1950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [1952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [1958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(313),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(718),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [2002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [2004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(737),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [2022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [2030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [2032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(955),
  [2035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(1077),
  [2038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [2040] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(961),
  [2043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(1115),
  [2046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [2048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(228),
  [2051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(742),
  [2054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(236),
  [2057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(529),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [2062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(366),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [2069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(799),
  [2072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(251),
  [2075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(542),
  [2078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(775),
  [2081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(405),
  [2084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [2092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(782),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [2121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(271),
  [2124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(286),
  [2127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(774),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [2132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(781),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [2137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_condition_repeat1, 2),
  [2139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_if_condition_repeat1, 2), SHIFT_REPEAT(281),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [2152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(378),
  [2155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(298),
  [2158] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(756),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [2167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(75),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [2172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(788),
  [2175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(800),
  [2178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(535),
  [2181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(64),
  [2184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(797),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [2193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(303),
  [2196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(226),
  [2199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(78),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [2204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variableunit, 1), SHIFT(301),
  [2207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formatunit, 3, .production_id = 12),
  [2209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formatunit, 3, .production_id = 12),
  [2211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_formatunit, 3),
  [2213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formatunit, 3),
  [2215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_command, 4),
  [2217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 22),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [2229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [2249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_command, 4),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_foreach_command_repeat1, 2, .production_id = 21), SHIFT_REPEAT(1172),
  [2268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_foreach_command_repeat1, 2, .production_id = 21),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [2284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_command, 3),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elseif_command, 3),
  [2292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [2294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [2296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [2298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [2308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [2312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [2316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [2326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [2334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [2336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [2364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_foreach_command_repeat1, 2, .production_id = 20),
  [2392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [2394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [2396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [2398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [2408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [2410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [2438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [2444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [2446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [2460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [2478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [2508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [2514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1253),
  [2558] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [2576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [2578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [2580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [2582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [2588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [2600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [2602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_meson() {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
