#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 314
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 49
#define ALIAS_COUNT 2
#define TOKEN_COUNT 25
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 7
#define MAX_ALIAS_SEQUENCE_LENGTH 15
#define PRODUCTION_ID_COUNT 67

enum {
  sym_identifier = 1,
  anon_sym_pool = 2,
  anon_sym_rule = 3,
  anon_sym_EQ = 4,
  anon_sym_default = 5,
  anon_sym_build = 6,
  anon_sym_PIPE = 7,
  anon_sym_COLON = 8,
  anon_sym_PIPE_PIPE = 9,
  anon_sym_PIPE_AT = 10,
  anon_sym_include = 11,
  anon_sym_subninja = 12,
  aux_sym_text_token1 = 13,
  anon_sym_ = 14,
  aux_sym_path_token1 = 15,
  anon_sym_DOLLAR = 16,
  aux_sym_quote_token1 = 17,
  aux_sym_split_token1 = 18,
  anon_sym_LBRACE = 19,
  anon_sym_RBRACE = 20,
  sym_simple_identifier = 21,
  sym_comment = 22,
  sym__nl = 23,
  sym__indent = 24,
  sym_manifest = 25,
  sym__stmt = 26,
  sym_pool = 27,
  sym_rule = 28,
  sym_let = 29,
  sym_default = 30,
  sym_build = 31,
  sym_include = 32,
  sym_subninja = 33,
  sym_body = 34,
  sym_text = 35,
  sym__targets = 36,
  sym_paths = 37,
  sym_path = 38,
  sym__escape = 39,
  sym_quote = 40,
  sym_split = 41,
  sym_expansion = 42,
  sym__simple_var_expansion = 43,
  sym__var_expansion = 44,
  aux_sym_manifest_repeat1 = 45,
  aux_sym_body_repeat1 = 46,
  aux_sym_text_repeat1 = 47,
  aux_sym_path_repeat1 = 48,
  alias_sym_dependencies = 49,
  alias_sym_outputs = 50,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_pool] = "pool",
  [anon_sym_rule] = "rule",
  [anon_sym_EQ] = "=",
  [anon_sym_default] = "default",
  [anon_sym_build] = "build",
  [anon_sym_PIPE] = "|",
  [anon_sym_COLON] = ":",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PIPE_AT] = "|@",
  [anon_sym_include] = "include",
  [anon_sym_subninja] = "subninja",
  [aux_sym_text_token1] = "text_token1",
  [anon_sym_] = " ",
  [aux_sym_path_token1] = "path_token1",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_quote_token1] = "quote_token1",
  [aux_sym_split_token1] = "split_token1",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym_simple_identifier] = "identifier",
  [sym_comment] = "comment",
  [sym__nl] = "_nl",
  [sym__indent] = "_indent",
  [sym_manifest] = "manifest",
  [sym__stmt] = "_stmt",
  [sym_pool] = "pool",
  [sym_rule] = "rule",
  [sym_let] = "let",
  [sym_default] = "default",
  [sym_build] = "build",
  [sym_include] = "include",
  [sym_subninja] = "subninja",
  [sym_body] = "body",
  [sym_text] = "text",
  [sym__targets] = "_targets",
  [sym_paths] = "targets",
  [sym_path] = "path",
  [sym__escape] = "_escape",
  [sym_quote] = "quote",
  [sym_split] = "split",
  [sym_expansion] = "expansion",
  [sym__simple_var_expansion] = "_simple_var_expansion",
  [sym__var_expansion] = "_var_expansion",
  [aux_sym_manifest_repeat1] = "manifest_repeat1",
  [aux_sym_body_repeat1] = "body_repeat1",
  [aux_sym_text_repeat1] = "text_repeat1",
  [aux_sym_path_repeat1] = "path_repeat1",
  [alias_sym_dependencies] = "dependencies",
  [alias_sym_outputs] = "outputs",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_pool] = anon_sym_pool,
  [anon_sym_rule] = anon_sym_rule,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_build] = anon_sym_build,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PIPE_AT] = anon_sym_PIPE_AT,
  [anon_sym_include] = anon_sym_include,
  [anon_sym_subninja] = anon_sym_subninja,
  [aux_sym_text_token1] = aux_sym_text_token1,
  [anon_sym_] = anon_sym_,
  [aux_sym_path_token1] = aux_sym_path_token1,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_quote_token1] = aux_sym_quote_token1,
  [aux_sym_split_token1] = aux_sym_split_token1,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [sym_simple_identifier] = sym_identifier,
  [sym_comment] = sym_comment,
  [sym__nl] = sym__nl,
  [sym__indent] = sym__indent,
  [sym_manifest] = sym_manifest,
  [sym__stmt] = sym__stmt,
  [sym_pool] = sym_pool,
  [sym_rule] = sym_rule,
  [sym_let] = sym_let,
  [sym_default] = sym_default,
  [sym_build] = sym_build,
  [sym_include] = sym_include,
  [sym_subninja] = sym_subninja,
  [sym_body] = sym_body,
  [sym_text] = sym_text,
  [sym__targets] = sym__targets,
  [sym_paths] = sym_paths,
  [sym_path] = sym_path,
  [sym__escape] = sym__escape,
  [sym_quote] = sym_quote,
  [sym_split] = sym_split,
  [sym_expansion] = sym_expansion,
  [sym__simple_var_expansion] = sym__simple_var_expansion,
  [sym__var_expansion] = sym__var_expansion,
  [aux_sym_manifest_repeat1] = aux_sym_manifest_repeat1,
  [aux_sym_body_repeat1] = aux_sym_body_repeat1,
  [aux_sym_text_repeat1] = aux_sym_text_repeat1,
  [aux_sym_path_repeat1] = aux_sym_path_repeat1,
  [alias_sym_dependencies] = alias_sym_dependencies,
  [alias_sym_outputs] = alias_sym_outputs,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_pool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rule] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_build] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_include] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_subninja] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_text_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_path_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_quote_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_split_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_simple_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__nl] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym_manifest] = {
    .visible = true,
    .named = true,
  },
  [sym__stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_pool] = {
    .visible = true,
    .named = true,
  },
  [sym_rule] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym_default] = {
    .visible = true,
    .named = true,
  },
  [sym_build] = {
    .visible = true,
    .named = true,
  },
  [sym_include] = {
    .visible = true,
    .named = true,
  },
  [sym_subninja] = {
    .visible = true,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym_text] = {
    .visible = true,
    .named = true,
  },
  [sym__targets] = {
    .visible = false,
    .named = true,
  },
  [sym_paths] = {
    .visible = true,
    .named = true,
  },
  [sym_path] = {
    .visible = true,
    .named = true,
  },
  [sym__escape] = {
    .visible = false,
    .named = true,
  },
  [sym_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_split] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_var_expansion] = {
    .visible = false,
    .named = true,
  },
  [sym__var_expansion] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_manifest_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_text_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_path_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_dependencies] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_outputs] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_explicit = 1,
  field_implict = 2,
  field_name = 3,
  field_order_only = 4,
  field_rule = 5,
  field_validation = 6,
  field_value = 7,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_explicit] = "explicit",
  [field_implict] = "implict",
  [field_name] = "name",
  [field_order_only] = "order_only",
  [field_rule] = "rule",
  [field_validation] = "validation",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 2},
  [4] = {.index = 4, .length = 2},
  [5] = {.index = 6, .length = 2},
  [6] = {.index = 8, .length = 2},
  [7] = {.index = 10, .length = 2},
  [8] = {.index = 12, .length = 2},
  [9] = {.index = 14, .length = 2},
  [10] = {.index = 16, .length = 3},
  [11] = {.index = 19, .length = 3},
  [12] = {.index = 22, .length = 3},
  [13] = {.index = 25, .length = 3},
  [14] = {.index = 28, .length = 3},
  [15] = {.index = 31, .length = 3},
  [16] = {.index = 34, .length = 3},
  [17] = {.index = 37, .length = 3},
  [18] = {.index = 40, .length = 3},
  [19] = {.index = 43, .length = 3},
  [20] = {.index = 46, .length = 3},
  [21] = {.index = 49, .length = 3},
  [22] = {.index = 52, .length = 3},
  [23] = {.index = 55, .length = 3},
  [24] = {.index = 58, .length = 3},
  [25] = {.index = 61, .length = 4},
  [26] = {.index = 65, .length = 4},
  [27] = {.index = 69, .length = 4},
  [28] = {.index = 73, .length = 4},
  [29] = {.index = 77, .length = 4},
  [30] = {.index = 81, .length = 4},
  [31] = {.index = 85, .length = 4},
  [32] = {.index = 89, .length = 4},
  [33] = {.index = 93, .length = 4},
  [34] = {.index = 97, .length = 4},
  [35] = {.index = 101, .length = 4},
  [36] = {.index = 105, .length = 4},
  [37] = {.index = 109, .length = 4},
  [38] = {.index = 113, .length = 4},
  [39] = {.index = 117, .length = 4},
  [40] = {.index = 121, .length = 4},
  [41] = {.index = 125, .length = 4},
  [42] = {.index = 129, .length = 4},
  [43] = {.index = 133, .length = 4},
  [44] = {.index = 137, .length = 4},
  [45] = {.index = 141, .length = 5},
  [46] = {.index = 146, .length = 5},
  [47] = {.index = 151, .length = 5},
  [48] = {.index = 156, .length = 5},
  [49] = {.index = 161, .length = 5},
  [50] = {.index = 166, .length = 5},
  [51] = {.index = 171, .length = 5},
  [52] = {.index = 176, .length = 5},
  [53] = {.index = 181, .length = 5},
  [54] = {.index = 186, .length = 5},
  [55] = {.index = 191, .length = 5},
  [56] = {.index = 196, .length = 5},
  [57] = {.index = 201, .length = 5},
  [58] = {.index = 206, .length = 5},
  [59] = {.index = 211, .length = 5},
  [60] = {.index = 216, .length = 6},
  [61] = {.index = 222, .length = 6},
  [62] = {.index = 228, .length = 6},
  [63] = {.index = 234, .length = 6},
  [64] = {.index = 240, .length = 6},
  [65] = {.index = 246, .length = 6},
  [66] = {.index = 252, .length = 7},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_rule, 2},
  [2] =
    {field_name, 0},
    {field_value, 2},
  [4] =
    {field_explicit, 3},
    {field_rule, 2},
  [6] =
    {field_explicit, 1},
    {field_rule, 3},
  [8] =
    {field_implict, 2},
    {field_rule, 4},
  [10] =
    {field_implict, 4},
    {field_rule, 2},
  [12] =
    {field_order_only, 4},
    {field_rule, 2},
  [14] =
    {field_rule, 2},
    {field_validation, 4},
  [16] =
    {field_explicit, 1},
    {field_explicit, 4},
    {field_rule, 3},
  [19] =
    {field_explicit, 5},
    {field_implict, 2},
    {field_rule, 4},
  [22] =
    {field_explicit, 3},
    {field_implict, 5},
    {field_rule, 2},
  [25] =
    {field_explicit, 3},
    {field_order_only, 5},
    {field_rule, 2},
  [28] =
    {field_explicit, 3},
    {field_rule, 2},
    {field_validation, 5},
  [31] =
    {field_explicit, 1},
    {field_implict, 3},
    {field_rule, 5},
  [34] =
    {field_explicit, 1},
    {field_implict, 5},
    {field_rule, 3},
  [37] =
    {field_explicit, 1},
    {field_order_only, 5},
    {field_rule, 3},
  [40] =
    {field_explicit, 1},
    {field_rule, 3},
    {field_validation, 5},
  [43] =
    {field_implict, 2},
    {field_implict, 6},
    {field_rule, 4},
  [46] =
    {field_implict, 2},
    {field_order_only, 6},
    {field_rule, 4},
  [49] =
    {field_implict, 2},
    {field_rule, 4},
    {field_validation, 6},
  [52] =
    {field_implict, 4},
    {field_order_only, 6},
    {field_rule, 2},
  [55] =
    {field_implict, 4},
    {field_rule, 2},
    {field_validation, 6},
  [58] =
    {field_order_only, 4},
    {field_rule, 2},
    {field_validation, 6},
  [61] =
    {field_explicit, 1},
    {field_explicit, 6},
    {field_implict, 3},
    {field_rule, 5},
  [65] =
    {field_explicit, 1},
    {field_explicit, 4},
    {field_implict, 6},
    {field_rule, 3},
  [69] =
    {field_explicit, 1},
    {field_explicit, 4},
    {field_order_only, 6},
    {field_rule, 3},
  [73] =
    {field_explicit, 1},
    {field_explicit, 4},
    {field_rule, 3},
    {field_validation, 6},
  [77] =
    {field_explicit, 5},
    {field_implict, 2},
    {field_implict, 7},
    {field_rule, 4},
  [81] =
    {field_explicit, 5},
    {field_implict, 2},
    {field_order_only, 7},
    {field_rule, 4},
  [85] =
    {field_explicit, 5},
    {field_implict, 2},
    {field_rule, 4},
    {field_validation, 7},
  [89] =
    {field_explicit, 3},
    {field_implict, 5},
    {field_order_only, 7},
    {field_rule, 2},
  [93] =
    {field_explicit, 3},
    {field_implict, 5},
    {field_rule, 2},
    {field_validation, 7},
  [97] =
    {field_explicit, 3},
    {field_order_only, 5},
    {field_rule, 2},
    {field_validation, 7},
  [101] =
    {field_explicit, 1},
    {field_implict, 3},
    {field_implict, 7},
    {field_rule, 5},
  [105] =
    {field_explicit, 1},
    {field_implict, 3},
    {field_order_only, 7},
    {field_rule, 5},
  [109] =
    {field_explicit, 1},
    {field_implict, 3},
    {field_rule, 5},
    {field_validation, 7},
  [113] =
    {field_explicit, 1},
    {field_implict, 5},
    {field_order_only, 7},
    {field_rule, 3},
  [117] =
    {field_explicit, 1},
    {field_implict, 5},
    {field_rule, 3},
    {field_validation, 7},
  [121] =
    {field_explicit, 1},
    {field_order_only, 5},
    {field_rule, 3},
    {field_validation, 7},
  [125] =
    {field_implict, 2},
    {field_implict, 6},
    {field_order_only, 8},
    {field_rule, 4},
  [129] =
    {field_implict, 2},
    {field_implict, 6},
    {field_rule, 4},
    {field_validation, 8},
  [133] =
    {field_implict, 2},
    {field_order_only, 6},
    {field_rule, 4},
    {field_validation, 8},
  [137] =
    {field_implict, 4},
    {field_order_only, 6},
    {field_rule, 2},
    {field_validation, 8},
  [141] =
    {field_explicit, 1},
    {field_explicit, 6},
    {field_implict, 3},
    {field_implict, 8},
    {field_rule, 5},
  [146] =
    {field_explicit, 1},
    {field_explicit, 6},
    {field_implict, 3},
    {field_order_only, 8},
    {field_rule, 5},
  [151] =
    {field_explicit, 1},
    {field_explicit, 6},
    {field_implict, 3},
    {field_rule, 5},
    {field_validation, 8},
  [156] =
    {field_explicit, 1},
    {field_explicit, 4},
    {field_implict, 6},
    {field_order_only, 8},
    {field_rule, 3},
  [161] =
    {field_explicit, 1},
    {field_explicit, 4},
    {field_implict, 6},
    {field_rule, 3},
    {field_validation, 8},
  [166] =
    {field_explicit, 1},
    {field_explicit, 4},
    {field_order_only, 6},
    {field_rule, 3},
    {field_validation, 8},
  [171] =
    {field_explicit, 5},
    {field_implict, 2},
    {field_implict, 7},
    {field_order_only, 9},
    {field_rule, 4},
  [176] =
    {field_explicit, 5},
    {field_implict, 2},
    {field_implict, 7},
    {field_rule, 4},
    {field_validation, 9},
  [181] =
    {field_explicit, 5},
    {field_implict, 2},
    {field_order_only, 7},
    {field_rule, 4},
    {field_validation, 9},
  [186] =
    {field_explicit, 3},
    {field_implict, 5},
    {field_order_only, 7},
    {field_rule, 2},
    {field_validation, 9},
  [191] =
    {field_explicit, 1},
    {field_implict, 3},
    {field_implict, 7},
    {field_order_only, 9},
    {field_rule, 5},
  [196] =
    {field_explicit, 1},
    {field_implict, 3},
    {field_implict, 7},
    {field_rule, 5},
    {field_validation, 9},
  [201] =
    {field_explicit, 1},
    {field_implict, 3},
    {field_order_only, 7},
    {field_rule, 5},
    {field_validation, 9},
  [206] =
    {field_explicit, 1},
    {field_implict, 5},
    {field_order_only, 7},
    {field_rule, 3},
    {field_validation, 9},
  [211] =
    {field_implict, 2},
    {field_implict, 6},
    {field_order_only, 8},
    {field_rule, 4},
    {field_validation, 10},
  [216] =
    {field_explicit, 1},
    {field_explicit, 6},
    {field_implict, 3},
    {field_implict, 8},
    {field_order_only, 10},
    {field_rule, 5},
  [222] =
    {field_explicit, 1},
    {field_explicit, 6},
    {field_implict, 3},
    {field_implict, 8},
    {field_rule, 5},
    {field_validation, 10},
  [228] =
    {field_explicit, 1},
    {field_explicit, 6},
    {field_implict, 3},
    {field_order_only, 8},
    {field_rule, 5},
    {field_validation, 10},
  [234] =
    {field_explicit, 1},
    {field_explicit, 4},
    {field_implict, 6},
    {field_order_only, 8},
    {field_rule, 3},
    {field_validation, 10},
  [240] =
    {field_explicit, 5},
    {field_implict, 2},
    {field_implict, 7},
    {field_order_only, 9},
    {field_rule, 4},
    {field_validation, 11},
  [246] =
    {field_explicit, 1},
    {field_implict, 3},
    {field_implict, 7},
    {field_order_only, 9},
    {field_rule, 5},
    {field_validation, 11},
  [252] =
    {field_explicit, 1},
    {field_explicit, 6},
    {field_implict, 3},
    {field_implict, 8},
    {field_order_only, 10},
    {field_rule, 5},
    {field_validation, 12},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [4] = {
    [3] = alias_sym_dependencies,
  },
  [5] = {
    [1] = alias_sym_outputs,
  },
  [6] = {
    [2] = alias_sym_outputs,
  },
  [7] = {
    [4] = alias_sym_dependencies,
  },
  [8] = {
    [4] = alias_sym_dependencies,
  },
  [9] = {
    [4] = alias_sym_dependencies,
  },
  [10] = {
    [1] = alias_sym_outputs,
    [4] = alias_sym_dependencies,
  },
  [11] = {
    [2] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
  },
  [12] = {
    [3] = alias_sym_dependencies,
    [5] = alias_sym_dependencies,
  },
  [13] = {
    [3] = alias_sym_dependencies,
    [5] = alias_sym_dependencies,
  },
  [14] = {
    [3] = alias_sym_dependencies,
    [5] = alias_sym_dependencies,
  },
  [15] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
  },
  [16] = {
    [1] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
  },
  [17] = {
    [1] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
  },
  [18] = {
    [1] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
  },
  [19] = {
    [2] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
  },
  [20] = {
    [2] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
  },
  [21] = {
    [2] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
  },
  [22] = {
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
  },
  [23] = {
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
  },
  [24] = {
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
  },
  [25] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
  },
  [26] = {
    [1] = alias_sym_outputs,
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
  },
  [27] = {
    [1] = alias_sym_outputs,
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
  },
  [28] = {
    [1] = alias_sym_outputs,
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
  },
  [29] = {
    [2] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
  },
  [30] = {
    [2] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
  },
  [31] = {
    [2] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
  },
  [32] = {
    [3] = alias_sym_dependencies,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
  },
  [33] = {
    [3] = alias_sym_dependencies,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
  },
  [34] = {
    [3] = alias_sym_dependencies,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
  },
  [35] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [7] = alias_sym_dependencies,
  },
  [36] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [7] = alias_sym_dependencies,
  },
  [37] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [7] = alias_sym_dependencies,
  },
  [38] = {
    [1] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
  },
  [39] = {
    [1] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
  },
  [40] = {
    [1] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
  },
  [41] = {
    [2] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [42] = {
    [2] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [43] = {
    [2] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [44] = {
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [45] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [46] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [47] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [48] = {
    [1] = alias_sym_outputs,
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [49] = {
    [1] = alias_sym_outputs,
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [50] = {
    [1] = alias_sym_outputs,
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
  },
  [51] = {
    [2] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
  },
  [52] = {
    [2] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
  },
  [53] = {
    [2] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
  },
  [54] = {
    [3] = alias_sym_dependencies,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
  },
  [55] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
  },
  [56] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
  },
  [57] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
  },
  [58] = {
    [1] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
  },
  [59] = {
    [2] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
    [10] = alias_sym_dependencies,
  },
  [60] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
    [10] = alias_sym_dependencies,
  },
  [61] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
    [10] = alias_sym_dependencies,
  },
  [62] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
    [10] = alias_sym_dependencies,
  },
  [63] = {
    [1] = alias_sym_outputs,
    [4] = alias_sym_dependencies,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
    [10] = alias_sym_dependencies,
  },
  [64] = {
    [2] = alias_sym_outputs,
    [5] = alias_sym_dependencies,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
    [11] = alias_sym_dependencies,
  },
  [65] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [7] = alias_sym_dependencies,
    [9] = alias_sym_dependencies,
    [11] = alias_sym_dependencies,
  },
  [66] = {
    [1] = alias_sym_outputs,
    [3] = alias_sym_outputs,
    [6] = alias_sym_dependencies,
    [8] = alias_sym_dependencies,
    [10] = alias_sym_dependencies,
    [12] = alias_sym_dependencies,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_paths, 3,
    sym_paths,
    alias_sym_dependencies,
    alias_sym_outputs,
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(16);
      if (lookahead == '\n') ADVANCE(32);
      if (lookahead == '\r') ADVANCE(2);
      if (lookahead == ' ') SKIP(15)
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '$') ADVANCE(29);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '{') ADVANCE(33);
      if (lookahead == '|') ADVANCE(18);
      if (lookahead == '}') ADVANCE(34);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(32);
      if (lookahead == '\r') ADVANCE(3);
      if (lookahead == ' ') ADVANCE(31);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '$' ||
          lookahead == ':') ADVANCE(30);
      if (lookahead == '{') ADVANCE(33);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(35);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(32);
      if (lookahead == '\r') ADVANCE(9);
      if (lookahead == ' ') SKIP(9)
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '$') ADVANCE(29);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '|') ADVANCE(18);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(32);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(35);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(4);
      if (lookahead == ' ') SKIP(4)
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '|') ADVANCE(18);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(5);
      if (lookahead == ' ') SKIP(5)
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '$') ADVANCE(29);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '|') ADVANCE(18);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(6);
      if (lookahead == ' ') ADVANCE(39);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 7:
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(23);
      if (lookahead == ' ') ADVANCE(23);
      if (lookahead == '#') ADVANCE(22);
      if (lookahead == '$') ADVANCE(29);
      if (lookahead != 0) ADVANCE(24);
      END_STATE();
    case 8:
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(8);
      if (lookahead == ' ') ADVANCE(25);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '|') ADVANCE(18);
      END_STATE();
    case 9:
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(9);
      if (lookahead == ' ') SKIP(9)
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '$') ADVANCE(29);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '|') ADVANCE(18);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 10:
      if (lookahead == '\n') ADVANCE(37);
      if (lookahead == '\r') ADVANCE(10);
      if (lookahead != 0) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(35);
      END_STATE();
    case 12:
      if (eof) ADVANCE(16);
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(4);
      if (lookahead == ' ') SKIP(13)
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '|') ADVANCE(18);
      if (lookahead == '}') ADVANCE(34);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 13:
      if (eof) ADVANCE(16);
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(4);
      if (lookahead == ' ') SKIP(13)
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '|') ADVANCE(18);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 14:
      if (eof) ADVANCE(16);
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(6);
      if (lookahead == ' ') ADVANCE(39);
      if (lookahead == '#') ADVANCE(10);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 15:
      if (eof) ADVANCE(16);
      if (lookahead == '\n') ADVANCE(38);
      if (lookahead == '\r') ADVANCE(9);
      if (lookahead == ' ') SKIP(15)
      if (lookahead == '#') ADVANCE(27);
      if (lookahead == '$') ADVANCE(29);
      if (lookahead == ':') ADVANCE(19);
      if (lookahead == '=') ADVANCE(17);
      if (lookahead == '|') ADVANCE(18);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      if (lookahead != 0) ADVANCE(26);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '@') ADVANCE(21);
      if (lookahead == '|') ADVANCE(20);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_PIPE_AT);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(aux_sym_text_token1);
      if (lookahead == '\n') ADVANCE(37);
      if (lookahead == '\r') ADVANCE(22);
      if (lookahead == '$') ADVANCE(10);
      if (lookahead != 0) ADVANCE(22);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(aux_sym_text_token1);
      if (lookahead == '\r') ADVANCE(23);
      if (lookahead == ' ') ADVANCE(23);
      if (lookahead == '#') ADVANCE(22);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$') ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(aux_sym_text_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '$') ADVANCE(24);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_);
      if (lookahead == '\r') ADVANCE(8);
      if (lookahead == ' ') ADVANCE(25);
      if (lookahead == '#') ADVANCE(10);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(aux_sym_path_token1);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym_path_token1);
      if (lookahead == '\n') ADVANCE(37);
      if (lookahead == '\r') ADVANCE(10);
      if (lookahead != 0) ADVANCE(10);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(aux_sym_path_token1);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(aux_sym_quote_token1);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(aux_sym_quote_token1);
      if (lookahead == '#') ADVANCE(10);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(aux_sym_split_token1);
      if (lookahead == ' ') ADVANCE(32);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_simple_identifier);
      if (lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym__nl);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym__indent);
      if (lookahead == '\r') ADVANCE(6);
      if (lookahead == ' ') ADVANCE(39);
      if (lookahead == '#') ADVANCE(10);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'b') ADVANCE(1);
      if (lookahead == 'd') ADVANCE(2);
      if (lookahead == 'i') ADVANCE(3);
      if (lookahead == 'p') ADVANCE(4);
      if (lookahead == 'r') ADVANCE(5);
      if (lookahead == 's') ADVANCE(6);
      if (lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'u') ADVANCE(7);
      END_STATE();
    case 2:
      if (lookahead == 'e') ADVANCE(8);
      END_STATE();
    case 3:
      if (lookahead == 'n') ADVANCE(9);
      END_STATE();
    case 4:
      if (lookahead == 'o') ADVANCE(10);
      END_STATE();
    case 5:
      if (lookahead == 'u') ADVANCE(11);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(12);
      END_STATE();
    case 7:
      if (lookahead == 'i') ADVANCE(13);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(14);
      END_STATE();
    case 9:
      if (lookahead == 'c') ADVANCE(15);
      END_STATE();
    case 10:
      if (lookahead == 'o') ADVANCE(16);
      END_STATE();
    case 11:
      if (lookahead == 'l') ADVANCE(17);
      END_STATE();
    case 12:
      if (lookahead == 'b') ADVANCE(18);
      END_STATE();
    case 13:
      if (lookahead == 'l') ADVANCE(19);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(20);
      END_STATE();
    case 15:
      if (lookahead == 'l') ADVANCE(21);
      END_STATE();
    case 16:
      if (lookahead == 'l') ADVANCE(22);
      END_STATE();
    case 17:
      if (lookahead == 'e') ADVANCE(23);
      END_STATE();
    case 18:
      if (lookahead == 'n') ADVANCE(24);
      END_STATE();
    case 19:
      if (lookahead == 'd') ADVANCE(25);
      END_STATE();
    case 20:
      if (lookahead == 'u') ADVANCE(26);
      END_STATE();
    case 21:
      if (lookahead == 'u') ADVANCE(27);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_pool);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_rule);
      END_STATE();
    case 24:
      if (lookahead == 'i') ADVANCE(28);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_build);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(29);
      END_STATE();
    case 27:
      if (lookahead == 'd') ADVANCE(30);
      END_STATE();
    case 28:
      if (lookahead == 'n') ADVANCE(31);
      END_STATE();
    case 29:
      if (lookahead == 't') ADVANCE(32);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 31:
      if (lookahead == 'j') ADVANCE(34);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_include);
      END_STATE();
    case 34:
      if (lookahead == 'a') ADVANCE(35);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_subninja);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 12},
  [2] = {.lex_state = 12},
  [3] = {.lex_state = 12},
  [4] = {.lex_state = 5},
  [5] = {.lex_state = 5},
  [6] = {.lex_state = 5},
  [7] = {.lex_state = 14},
  [8] = {.lex_state = 14},
  [9] = {.lex_state = 14},
  [10] = {.lex_state = 14},
  [11] = {.lex_state = 14},
  [12] = {.lex_state = 14},
  [13] = {.lex_state = 14},
  [14] = {.lex_state = 14},
  [15] = {.lex_state = 14},
  [16] = {.lex_state = 14},
  [17] = {.lex_state = 14},
  [18] = {.lex_state = 14},
  [19] = {.lex_state = 14},
  [20] = {.lex_state = 14},
  [21] = {.lex_state = 14},
  [22] = {.lex_state = 14},
  [23] = {.lex_state = 14},
  [24] = {.lex_state = 14},
  [25] = {.lex_state = 14},
  [26] = {.lex_state = 14},
  [27] = {.lex_state = 14},
  [28] = {.lex_state = 14},
  [29] = {.lex_state = 14},
  [30] = {.lex_state = 14},
  [31] = {.lex_state = 14},
  [32] = {.lex_state = 14},
  [33] = {.lex_state = 14},
  [34] = {.lex_state = 14},
  [35] = {.lex_state = 14},
  [36] = {.lex_state = 14},
  [37] = {.lex_state = 14},
  [38] = {.lex_state = 14},
  [39] = {.lex_state = 14},
  [40] = {.lex_state = 14},
  [41] = {.lex_state = 14},
  [42] = {.lex_state = 14},
  [43] = {.lex_state = 14},
  [44] = {.lex_state = 14},
  [45] = {.lex_state = 14},
  [46] = {.lex_state = 14},
  [47] = {.lex_state = 14},
  [48] = {.lex_state = 14},
  [49] = {.lex_state = 14},
  [50] = {.lex_state = 14},
  [51] = {.lex_state = 14},
  [52] = {.lex_state = 14},
  [53] = {.lex_state = 14},
  [54] = {.lex_state = 14},
  [55] = {.lex_state = 14},
  [56] = {.lex_state = 14},
  [57] = {.lex_state = 14},
  [58] = {.lex_state = 14},
  [59] = {.lex_state = 14},
  [60] = {.lex_state = 14},
  [61] = {.lex_state = 14},
  [62] = {.lex_state = 14},
  [63] = {.lex_state = 14},
  [64] = {.lex_state = 14},
  [65] = {.lex_state = 14},
  [66] = {.lex_state = 14},
  [67] = {.lex_state = 14},
  [68] = {.lex_state = 14},
  [69] = {.lex_state = 14},
  [70] = {.lex_state = 14},
  [71] = {.lex_state = 14},
  [72] = {.lex_state = 14},
  [73] = {.lex_state = 14},
  [74] = {.lex_state = 7},
  [75] = {.lex_state = 14},
  [76] = {.lex_state = 7},
  [77] = {.lex_state = 7},
  [78] = {.lex_state = 5},
  [79] = {.lex_state = 7},
  [80] = {.lex_state = 5},
  [81] = {.lex_state = 12},
  [82] = {.lex_state = 12},
  [83] = {.lex_state = 12},
  [84] = {.lex_state = 12},
  [85] = {.lex_state = 12},
  [86] = {.lex_state = 12},
  [87] = {.lex_state = 12},
  [88] = {.lex_state = 12},
  [89] = {.lex_state = 12},
  [90] = {.lex_state = 12},
  [91] = {.lex_state = 12},
  [92] = {.lex_state = 12},
  [93] = {.lex_state = 12},
  [94] = {.lex_state = 12},
  [95] = {.lex_state = 12},
  [96] = {.lex_state = 12},
  [97] = {.lex_state = 12},
  [98] = {.lex_state = 12},
  [99] = {.lex_state = 12},
  [100] = {.lex_state = 12},
  [101] = {.lex_state = 12},
  [102] = {.lex_state = 12},
  [103] = {.lex_state = 12},
  [104] = {.lex_state = 12},
  [105] = {.lex_state = 12},
  [106] = {.lex_state = 12},
  [107] = {.lex_state = 12},
  [108] = {.lex_state = 12},
  [109] = {.lex_state = 12},
  [110] = {.lex_state = 12},
  [111] = {.lex_state = 12},
  [112] = {.lex_state = 12},
  [113] = {.lex_state = 12},
  [114] = {.lex_state = 12},
  [115] = {.lex_state = 12},
  [116] = {.lex_state = 12},
  [117] = {.lex_state = 12},
  [118] = {.lex_state = 12},
  [119] = {.lex_state = 12},
  [120] = {.lex_state = 12},
  [121] = {.lex_state = 12},
  [122] = {.lex_state = 12},
  [123] = {.lex_state = 12},
  [124] = {.lex_state = 12},
  [125] = {.lex_state = 12},
  [126] = {.lex_state = 12},
  [127] = {.lex_state = 12},
  [128] = {.lex_state = 12},
  [129] = {.lex_state = 12},
  [130] = {.lex_state = 12},
  [131] = {.lex_state = 12},
  [132] = {.lex_state = 12},
  [133] = {.lex_state = 12},
  [134] = {.lex_state = 12},
  [135] = {.lex_state = 12},
  [136] = {.lex_state = 12},
  [137] = {.lex_state = 12},
  [138] = {.lex_state = 12},
  [139] = {.lex_state = 12},
  [140] = {.lex_state = 12},
  [141] = {.lex_state = 12},
  [142] = {.lex_state = 12},
  [143] = {.lex_state = 12},
  [144] = {.lex_state = 12},
  [145] = {.lex_state = 12},
  [146] = {.lex_state = 12},
  [147] = {.lex_state = 12},
  [148] = {.lex_state = 12},
  [149] = {.lex_state = 12},
  [150] = {.lex_state = 12},
  [151] = {.lex_state = 5},
  [152] = {.lex_state = 5},
  [153] = {.lex_state = 5},
  [154] = {.lex_state = 5},
  [155] = {.lex_state = 5},
  [156] = {.lex_state = 8},
  [157] = {.lex_state = 8},
  [158] = {.lex_state = 8},
  [159] = {.lex_state = 8},
  [160] = {.lex_state = 12},
  [161] = {.lex_state = 12},
  [162] = {.lex_state = 12},
  [163] = {.lex_state = 1},
  [164] = {.lex_state = 12},
  [165] = {.lex_state = 12},
  [166] = {.lex_state = 1},
  [167] = {.lex_state = 8},
  [168] = {.lex_state = 7},
  [169] = {.lex_state = 7},
  [170] = {.lex_state = 7},
  [171] = {.lex_state = 7},
  [172] = {.lex_state = 12},
  [173] = {.lex_state = 14},
  [174] = {.lex_state = 14},
  [175] = {.lex_state = 8},
  [176] = {.lex_state = 12},
  [177] = {.lex_state = 12},
  [178] = {.lex_state = 12},
  [179] = {.lex_state = 12},
  [180] = {.lex_state = 12},
  [181] = {.lex_state = 7},
  [182] = {.lex_state = 12},
  [183] = {.lex_state = 12},
  [184] = {.lex_state = 8},
  [185] = {.lex_state = 8},
  [186] = {.lex_state = 8},
  [187] = {.lex_state = 8},
  [188] = {.lex_state = 8},
  [189] = {.lex_state = 12},
  [190] = {.lex_state = 8},
  [191] = {.lex_state = 12},
  [192] = {.lex_state = 8},
  [193] = {.lex_state = 8},
  [194] = {.lex_state = 8},
  [195] = {.lex_state = 8},
  [196] = {.lex_state = 8},
  [197] = {.lex_state = 8},
  [198] = {.lex_state = 8},
  [199] = {.lex_state = 12},
  [200] = {.lex_state = 8},
  [201] = {.lex_state = 8},
  [202] = {.lex_state = 8},
  [203] = {.lex_state = 12},
  [204] = {.lex_state = 12},
  [205] = {.lex_state = 8},
  [206] = {.lex_state = 8},
  [207] = {.lex_state = 8},
  [208] = {.lex_state = 8},
  [209] = {.lex_state = 12},
  [210] = {.lex_state = 8},
  [211] = {.lex_state = 8},
  [212] = {.lex_state = 0},
  [213] = {.lex_state = 8},
  [214] = {.lex_state = 8},
  [215] = {.lex_state = 8},
  [216] = {.lex_state = 8},
  [217] = {.lex_state = 8},
  [218] = {.lex_state = 8},
  [219] = {.lex_state = 12},
  [220] = {.lex_state = 8},
  [221] = {.lex_state = 8},
  [222] = {.lex_state = 12},
  [223] = {.lex_state = 12},
  [224] = {.lex_state = 8},
  [225] = {.lex_state = 8},
  [226] = {.lex_state = 8},
  [227] = {.lex_state = 8},
  [228] = {.lex_state = 8},
  [229] = {.lex_state = 12},
  [230] = {.lex_state = 12},
  [231] = {.lex_state = 8},
  [232] = {.lex_state = 8},
  [233] = {.lex_state = 8},
  [234] = {.lex_state = 8},
  [235] = {.lex_state = 8},
  [236] = {.lex_state = 8},
  [237] = {.lex_state = 8},
  [238] = {.lex_state = 8},
  [239] = {.lex_state = 8},
  [240] = {.lex_state = 12},
  [241] = {.lex_state = 12},
  [242] = {.lex_state = 12},
  [243] = {.lex_state = 8},
  [244] = {.lex_state = 12},
  [245] = {.lex_state = 8},
  [246] = {.lex_state = 12},
  [247] = {.lex_state = 8},
  [248] = {.lex_state = 8},
  [249] = {.lex_state = 8},
  [250] = {.lex_state = 8},
  [251] = {.lex_state = 8},
  [252] = {.lex_state = 8},
  [253] = {.lex_state = 8},
  [254] = {.lex_state = 8},
  [255] = {.lex_state = 12},
  [256] = {.lex_state = 8},
  [257] = {.lex_state = 8},
  [258] = {.lex_state = 8},
  [259] = {.lex_state = 8},
  [260] = {.lex_state = 0},
  [261] = {.lex_state = 12},
  [262] = {.lex_state = 12},
  [263] = {.lex_state = 12},
  [264] = {.lex_state = 12},
  [265] = {.lex_state = 12},
  [266] = {.lex_state = 12},
  [267] = {.lex_state = 12},
  [268] = {.lex_state = 12},
  [269] = {.lex_state = 12},
  [270] = {.lex_state = 12},
  [271] = {.lex_state = 12},
  [272] = {.lex_state = 0},
  [273] = {.lex_state = 12},
  [274] = {.lex_state = 12},
  [275] = {.lex_state = 12},
  [276] = {.lex_state = 12},
  [277] = {.lex_state = 12},
  [278] = {.lex_state = 12},
  [279] = {.lex_state = 12},
  [280] = {.lex_state = 12},
  [281] = {.lex_state = 12},
  [282] = {.lex_state = 12},
  [283] = {.lex_state = 12},
  [284] = {.lex_state = 12},
  [285] = {.lex_state = 12},
  [286] = {.lex_state = 12},
  [287] = {.lex_state = 12},
  [288] = {.lex_state = 12},
  [289] = {.lex_state = 12},
  [290] = {.lex_state = 12},
  [291] = {.lex_state = 12},
  [292] = {.lex_state = 12},
  [293] = {.lex_state = 12},
  [294] = {.lex_state = 12},
  [295] = {.lex_state = 12},
  [296] = {.lex_state = 12},
  [297] = {.lex_state = 12},
  [298] = {.lex_state = 12},
  [299] = {.lex_state = 0},
  [300] = {.lex_state = 12},
  [301] = {.lex_state = 12},
  [302] = {.lex_state = 12},
  [303] = {.lex_state = 12},
  [304] = {.lex_state = 12},
  [305] = {.lex_state = 12},
  [306] = {.lex_state = 12},
  [307] = {.lex_state = 12},
  [308] = {.lex_state = 12},
  [309] = {.lex_state = 12},
  [310] = {.lex_state = 12},
  [311] = {.lex_state = 12},
  [312] = {.lex_state = 12},
  [313] = {.lex_state = 12},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_pool] = ACTIONS(1),
    [anon_sym_rule] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_build] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE_AT] = ACTIONS(1),
    [anon_sym_include] = ACTIONS(1),
    [anon_sym_subninja] = ACTIONS(1),
    [aux_sym_path_token1] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [aux_sym_split_token1] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__nl] = ACTIONS(1),
  },
  [1] = {
    [sym_manifest] = STATE(299),
    [sym__stmt] = STATE(3),
    [sym_pool] = STATE(3),
    [sym_rule] = STATE(3),
    [sym_let] = STATE(3),
    [sym_default] = STATE(3),
    [sym_build] = STATE(3),
    [sym_include] = STATE(3),
    [sym_subninja] = STATE(3),
    [aux_sym_manifest_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_pool] = ACTIONS(9),
    [anon_sym_rule] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(13),
    [anon_sym_build] = ACTIONS(15),
    [anon_sym_include] = ACTIONS(17),
    [anon_sym_subninja] = ACTIONS(19),
    [sym_comment] = ACTIONS(3),
    [sym__nl] = ACTIONS(21),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(23), 1,
      ts_builtin_sym_end,
    ACTIONS(25), 1,
      sym_identifier,
    ACTIONS(28), 1,
      anon_sym_pool,
    ACTIONS(31), 1,
      anon_sym_rule,
    ACTIONS(34), 1,
      anon_sym_default,
    ACTIONS(37), 1,
      anon_sym_build,
    ACTIONS(40), 1,
      anon_sym_include,
    ACTIONS(43), 1,
      anon_sym_subninja,
    ACTIONS(46), 1,
      sym__nl,
    STATE(2), 9,
      sym__stmt,
      sym_pool,
      sym_rule,
      sym_let,
      sym_default,
      sym_build,
      sym_include,
      sym_subninja,
      aux_sym_manifest_repeat1,
  [42] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(9), 1,
      anon_sym_pool,
    ACTIONS(11), 1,
      anon_sym_rule,
    ACTIONS(13), 1,
      anon_sym_default,
    ACTIONS(15), 1,
      anon_sym_build,
    ACTIONS(17), 1,
      anon_sym_include,
    ACTIONS(19), 1,
      anon_sym_subninja,
    ACTIONS(49), 1,
      ts_builtin_sym_end,
    ACTIONS(51), 1,
      sym__nl,
    STATE(2), 9,
      sym__stmt,
      sym_pool,
      sym_rule,
      sym_let,
      sym_default,
      sym_build,
      sym_include,
      sym_subninja,
      aux_sym_manifest_repeat1,
  [84] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_PIPE,
    ACTIONS(57), 1,
      aux_sym_path_token1,
    ACTIONS(59), 1,
      anon_sym_DOLLAR,
    STATE(160), 1,
      sym_path,
    STATE(151), 2,
      sym__simple_var_expansion,
      sym__var_expansion,
    ACTIONS(55), 4,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE_AT,
      sym__nl,
    STATE(6), 5,
      sym__escape,
      sym_quote,
      sym_split,
      sym_expansion,
      aux_sym_path_repeat1,
  [117] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(61), 1,
      anon_sym_PIPE,
    ACTIONS(65), 1,
      aux_sym_path_token1,
    ACTIONS(68), 1,
      anon_sym_DOLLAR,
    STATE(151), 2,
      sym__simple_var_expansion,
      sym__var_expansion,
    ACTIONS(63), 4,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE_AT,
      sym__nl,
    STATE(5), 5,
      sym__escape,
      sym_quote,
      sym_split,
      sym_expansion,
      aux_sym_path_repeat1,
  [147] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(59), 1,
      anon_sym_DOLLAR,
    ACTIONS(71), 1,
      anon_sym_PIPE,
    ACTIONS(75), 1,
      aux_sym_path_token1,
    STATE(151), 2,
      sym__simple_var_expansion,
      sym__var_expansion,
    ACTIONS(73), 4,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE_AT,
      sym__nl,
    STATE(5), 5,
      sym__escape,
      sym_quote,
      sym_split,
      sym_expansion,
      aux_sym_path_repeat1,
  [177] = 6,
    ACTIONS(77), 1,
      ts_builtin_sym_end,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(87), 1,
      sym_body,
    ACTIONS(79), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [203] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(85), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(124), 1,
      sym_body,
    ACTIONS(87), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [229] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(89), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(107), 1,
      sym_body,
    ACTIONS(91), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [255] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(93), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(85), 1,
      sym_body,
    ACTIONS(95), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [281] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(97), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(83), 1,
      sym_body,
    ACTIONS(99), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [307] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(101), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(102), 1,
      sym_body,
    ACTIONS(103), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [333] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(105), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(119), 1,
      sym_body,
    ACTIONS(107), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [359] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(109), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(114), 1,
      sym_body,
    ACTIONS(111), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [385] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(113), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(135), 1,
      sym_body,
    ACTIONS(115), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [411] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(117), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(137), 1,
      sym_body,
    ACTIONS(119), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [437] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(121), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(140), 1,
      sym_body,
    ACTIONS(123), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [463] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(125), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(116), 1,
      sym_body,
    ACTIONS(127), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [489] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(129), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(90), 1,
      sym_body,
    ACTIONS(131), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [515] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(133), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(93), 1,
      sym_body,
    ACTIONS(135), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [541] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(137), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(105), 1,
      sym_body,
    ACTIONS(139), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [567] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(141), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(148), 1,
      sym_body,
    ACTIONS(143), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [593] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(145), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(104), 1,
      sym_body,
    ACTIONS(147), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [619] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(149), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(129), 1,
      sym_body,
    ACTIONS(151), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [645] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(153), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(109), 1,
      sym_body,
    ACTIONS(155), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [671] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(157), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(147), 1,
      sym_body,
    ACTIONS(159), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [697] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(161), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(146), 1,
      sym_body,
    ACTIONS(163), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [723] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(165), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(142), 1,
      sym_body,
    ACTIONS(167), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [749] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(169), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(113), 1,
      sym_body,
    ACTIONS(171), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [775] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(173), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(145), 1,
      sym_body,
    ACTIONS(175), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [801] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(177), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(101), 1,
      sym_body,
    ACTIONS(179), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [827] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(181), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(111), 1,
      sym_body,
    ACTIONS(183), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [853] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(185), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(100), 1,
      sym_body,
    ACTIONS(187), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [879] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(189), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(99), 1,
      sym_body,
    ACTIONS(191), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [905] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(193), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(97), 1,
      sym_body,
    ACTIONS(195), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [931] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(197), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(112), 1,
      sym_body,
    ACTIONS(199), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [957] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(201), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(132), 1,
      sym_body,
    ACTIONS(203), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [983] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(205), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(96), 1,
      sym_body,
    ACTIONS(207), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1009] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(209), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(149), 1,
      sym_body,
    ACTIONS(211), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1035] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(213), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(95), 1,
      sym_body,
    ACTIONS(215), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1061] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(217), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(131), 1,
      sym_body,
    ACTIONS(219), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1087] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(221), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(88), 1,
      sym_body,
    ACTIONS(223), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1113] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(225), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(117), 1,
      sym_body,
    ACTIONS(227), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1139] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(229), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(110), 1,
      sym_body,
    ACTIONS(231), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1165] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(233), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(82), 1,
      sym_body,
    ACTIONS(235), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1191] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(237), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(108), 1,
      sym_body,
    ACTIONS(239), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1217] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(241), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(86), 1,
      sym_body,
    ACTIONS(243), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1243] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(245), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(144), 1,
      sym_body,
    ACTIONS(247), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1269] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(249), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(118), 1,
      sym_body,
    ACTIONS(251), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1295] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(253), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(103), 1,
      sym_body,
    ACTIONS(255), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1321] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(257), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(136), 1,
      sym_body,
    ACTIONS(259), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1347] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(261), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(139), 1,
      sym_body,
    ACTIONS(263), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1373] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(265), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(150), 1,
      sym_body,
    ACTIONS(267), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1399] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(269), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(141), 1,
      sym_body,
    ACTIONS(271), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1425] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(273), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(120), 1,
      sym_body,
    ACTIONS(275), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1451] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(277), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(121), 1,
      sym_body,
    ACTIONS(279), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1477] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(281), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(94), 1,
      sym_body,
    ACTIONS(283), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1503] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(285), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(81), 1,
      sym_body,
    ACTIONS(287), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1529] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(289), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(91), 1,
      sym_body,
    ACTIONS(291), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1555] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(293), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(92), 1,
      sym_body,
    ACTIONS(295), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1581] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(297), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(143), 1,
      sym_body,
    ACTIONS(299), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1607] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(301), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(98), 1,
      sym_body,
    ACTIONS(303), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1633] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(305), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(84), 1,
      sym_body,
    ACTIONS(307), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1659] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(309), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(134), 1,
      sym_body,
    ACTIONS(311), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1685] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(313), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(133), 1,
      sym_body,
    ACTIONS(315), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1711] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(317), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(130), 1,
      sym_body,
    ACTIONS(319), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1737] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(321), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(89), 1,
      sym_body,
    ACTIONS(323), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1763] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(325), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(126), 1,
      sym_body,
    ACTIONS(327), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1789] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(329), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(106), 1,
      sym_body,
    ACTIONS(331), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1815] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(333), 1,
      ts_builtin_sym_end,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(125), 1,
      sym_body,
    ACTIONS(335), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1841] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(337), 1,
      ts_builtin_sym_end,
    ACTIONS(341), 1,
      sym__indent,
    STATE(71), 1,
      aux_sym_body_repeat1,
    ACTIONS(339), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1864] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    ACTIONS(344), 1,
      ts_builtin_sym_end,
    STATE(71), 1,
      aux_sym_body_repeat1,
    ACTIONS(346), 8,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
  [1887] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(337), 1,
      ts_builtin_sym_end,
    ACTIONS(339), 9,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
      sym__indent,
  [1905] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(348), 1,
      aux_sym_text_token1,
    ACTIONS(351), 1,
      anon_sym_DOLLAR,
    ACTIONS(354), 1,
      sym__nl,
    STATE(170), 2,
      sym__simple_var_expansion,
      sym__var_expansion,
    STATE(74), 5,
      sym__escape,
      sym_quote,
      sym_split,
      sym_expansion,
      aux_sym_text_repeat1,
  [1929] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(356), 1,
      ts_builtin_sym_end,
    ACTIONS(358), 9,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
      sym__nl,
      sym__indent,
  [1947] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(360), 1,
      aux_sym_text_token1,
    ACTIONS(362), 1,
      anon_sym_DOLLAR,
    ACTIONS(364), 1,
      sym__nl,
    STATE(170), 2,
      sym__simple_var_expansion,
      sym__var_expansion,
    STATE(74), 5,
      sym__escape,
      sym_quote,
      sym_split,
      sym_expansion,
      aux_sym_text_repeat1,
  [1971] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_DOLLAR,
    ACTIONS(366), 1,
      aux_sym_text_token1,
    STATE(281), 1,
      sym_text,
    STATE(170), 2,
      sym__simple_var_expansion,
      sym__var_expansion,
    STATE(76), 5,
      sym__escape,
      sym_quote,
      sym_split,
      sym_expansion,
      aux_sym_text_repeat1,
  [1995] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      aux_sym_path_token1,
    ACTIONS(59), 1,
      anon_sym_DOLLAR,
    STATE(289), 1,
      sym_path,
    STATE(151), 2,
      sym__simple_var_expansion,
      sym__var_expansion,
    STATE(6), 5,
      sym__escape,
      sym_quote,
      sym_split,
      sym_expansion,
      aux_sym_path_repeat1,
  [2019] = 6,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(362), 1,
      anon_sym_DOLLAR,
    ACTIONS(366), 1,
      aux_sym_text_token1,
    STATE(286), 1,
      sym_text,
    STATE(170), 2,
      sym__simple_var_expansion,
      sym__var_expansion,
    STATE(76), 5,
      sym__escape,
      sym_quote,
      sym_split,
      sym_expansion,
      aux_sym_text_repeat1,
  [2043] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(57), 1,
      aux_sym_path_token1,
    ACTIONS(59), 1,
      anon_sym_DOLLAR,
    STATE(290), 1,
      sym_path,
    STATE(151), 2,
      sym__simple_var_expansion,
      sym__var_expansion,
    STATE(6), 5,
      sym__escape,
      sym_quote,
      sym_split,
      sym_expansion,
      aux_sym_path_repeat1,
  [2067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(368), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(370), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(372), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(374), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(376), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(378), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(380), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(382), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(384), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(386), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(388), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(390), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(392), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(394), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(396), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(398), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(402), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(404), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(406), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(408), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(410), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(412), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(414), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(418), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(422), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(424), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(426), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(428), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(430), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(432), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(434), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(438), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(440), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(442), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(446), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(448), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(450), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(452), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(454), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(456), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(458), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(460), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(462), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(466), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(470), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2509] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(472), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(474), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(476), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(478), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(482), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(484), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(486), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(488), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(490), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(494), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(498), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(500), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(502), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(356), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(358), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(504), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(506), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(508), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(510), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(514), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(516), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(518), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(520), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(522), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(524), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(526), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(528), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(530), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(532), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(534), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(538), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(540), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(542), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(544), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(546), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(548), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(550), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(552), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(554), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(556), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(558), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(560), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(562), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(564), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(566), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(568), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(570), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(572), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(574), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(576), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(578), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [2985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(580), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(582), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(586), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(588), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(590), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(592), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(594), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(596), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(598), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(600), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(602), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(604), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(606), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(608), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(610), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(612), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(614), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(618), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(620), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(622), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(626), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(630), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(632), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(634), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(636), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(638), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(640), 2,
      ts_builtin_sym_end,
      sym__nl,
    ACTIONS(642), 7,
      anon_sym_pool,
      anon_sym_rule,
      anon_sym_default,
      anon_sym_build,
      anon_sym_include,
      anon_sym_subninja,
      sym_identifier,
  [3257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 2,
      anon_sym_PIPE,
      aux_sym_path_token1,
    ACTIONS(646), 5,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE_AT,
      anon_sym_DOLLAR,
      sym__nl,
  [3272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(648), 2,
      anon_sym_PIPE,
      aux_sym_path_token1,
    ACTIONS(650), 5,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE_AT,
      anon_sym_DOLLAR,
      sym__nl,
  [3287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(652), 2,
      anon_sym_PIPE,
      aux_sym_path_token1,
    ACTIONS(654), 5,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE_AT,
      anon_sym_DOLLAR,
      sym__nl,
  [3302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(656), 2,
      anon_sym_PIPE,
      aux_sym_path_token1,
    ACTIONS(658), 5,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE_AT,
      anon_sym_DOLLAR,
      sym__nl,
  [3317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 2,
      anon_sym_PIPE,
      aux_sym_path_token1,
    ACTIONS(662), 5,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE_AT,
      anon_sym_DOLLAR,
      sym__nl,
  [3332] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(664), 1,
      anon_sym_PIPE,
    ACTIONS(666), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(668), 1,
      anon_sym_PIPE_AT,
    ACTIONS(670), 1,
      anon_sym_,
    ACTIONS(672), 1,
      sym__nl,
    STATE(165), 1,
      sym_paths,
  [3354] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    ACTIONS(674), 1,
      anon_sym_PIPE,
    ACTIONS(676), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(678), 1,
      anon_sym_PIPE_AT,
    ACTIONS(680), 1,
      sym__nl,
    STATE(162), 1,
      sym_paths,
  [3376] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    ACTIONS(682), 1,
      anon_sym_PIPE,
    ACTIONS(684), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(686), 1,
      anon_sym_PIPE_AT,
    ACTIONS(688), 1,
      sym__nl,
    STATE(161), 1,
      sym_paths,
  [3398] = 7,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    ACTIONS(690), 1,
      anon_sym_PIPE,
    ACTIONS(692), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(694), 1,
      anon_sym_PIPE_AT,
    ACTIONS(696), 1,
      sym__nl,
    STATE(164), 1,
      sym_paths,
  [3420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 1,
      anon_sym_PIPE,
    ACTIONS(700), 4,
      anon_sym_COLON,
      anon_sym_PIPE_PIPE,
      anon_sym_PIPE_AT,
      sym__nl,
  [3433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(702), 1,
      anon_sym_PIPE,
    ACTIONS(704), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(706), 1,
      anon_sym_PIPE_AT,
    ACTIONS(708), 1,
      sym__nl,
  [3449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 1,
      anon_sym_PIPE,
    ACTIONS(712), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(714), 1,
      anon_sym_PIPE_AT,
    ACTIONS(716), 1,
      sym__nl,
  [3465] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(718), 1,
      aux_sym_quote_token1,
    ACTIONS(720), 1,
      aux_sym_split_token1,
    ACTIONS(722), 1,
      anon_sym_LBRACE,
    ACTIONS(724), 1,
      sym_simple_identifier,
  [3481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(726), 1,
      anon_sym_PIPE,
    ACTIONS(728), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(730), 1,
      anon_sym_PIPE_AT,
    ACTIONS(732), 1,
      sym__nl,
  [3497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 1,
      anon_sym_PIPE,
    ACTIONS(736), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(738), 1,
      anon_sym_PIPE_AT,
    ACTIONS(740), 1,
      sym__nl,
  [3513] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(742), 1,
      aux_sym_quote_token1,
    ACTIONS(744), 1,
      aux_sym_split_token1,
    ACTIONS(746), 1,
      anon_sym_LBRACE,
    ACTIONS(748), 1,
      sym_simple_identifier,
  [3529] = 5,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    ACTIONS(750), 1,
      anon_sym_PIPE,
    ACTIONS(752), 1,
      anon_sym_COLON,
    STATE(212), 1,
      sym_paths,
  [3545] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(652), 3,
      aux_sym_text_token1,
      anon_sym_DOLLAR,
      sym__nl,
  [3554] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(648), 3,
      aux_sym_text_token1,
      anon_sym_DOLLAR,
      sym__nl,
  [3563] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(644), 3,
      aux_sym_text_token1,
      anon_sym_DOLLAR,
      sym__nl,
  [3572] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(656), 3,
      aux_sym_text_token1,
      anon_sym_DOLLAR,
      sym__nl,
  [3581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(754), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(756), 1,
      anon_sym_PIPE_AT,
    ACTIONS(758), 1,
      sym__nl,
  [3594] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(123), 1,
      sym_body,
  [3607] = 4,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym__indent,
    STATE(72), 1,
      aux_sym_body_repeat1,
    STATE(122), 1,
      sym_body,
  [3620] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(296), 2,
      sym__targets,
      sym_paths,
  [3631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(760), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(762), 1,
      anon_sym_PIPE_AT,
    ACTIONS(764), 1,
      sym__nl,
  [3644] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(766), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(768), 1,
      anon_sym_PIPE_AT,
    ACTIONS(770), 1,
      sym__nl,
  [3657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(772), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(774), 1,
      anon_sym_PIPE_AT,
    ACTIONS(776), 1,
      sym__nl,
  [3670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(778), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(780), 1,
      anon_sym_PIPE_AT,
    ACTIONS(782), 1,
      sym__nl,
  [3683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(784), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(786), 1,
      anon_sym_PIPE_AT,
    ACTIONS(788), 1,
      sym__nl,
  [3696] = 2,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(660), 3,
      aux_sym_text_token1,
      anon_sym_DOLLAR,
      sym__nl,
  [3705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(790), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(792), 1,
      anon_sym_PIPE_AT,
    ACTIONS(794), 1,
      sym__nl,
  [3718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(798), 1,
      anon_sym_PIPE_AT,
    ACTIONS(800), 1,
      sym__nl,
  [3731] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(266), 1,
      sym_paths,
  [3741] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(223), 1,
      sym_paths,
  [3751] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(219), 1,
      sym_paths,
  [3761] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(285), 1,
      sym_paths,
  [3771] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(279), 1,
      sym_paths,
  [3781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(802), 1,
      anon_sym_PIPE_AT,
    ACTIONS(804), 1,
      sym__nl,
  [3791] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(182), 1,
      sym_paths,
  [3801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(806), 1,
      anon_sym_PIPE_AT,
    ACTIONS(808), 1,
      sym__nl,
  [3811] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(287), 1,
      sym_paths,
  [3821] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(277), 1,
      sym_paths,
  [3831] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(263), 1,
      sym_paths,
  [3841] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(255), 1,
      sym_paths,
  [3851] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(203), 1,
      sym_paths,
  [3861] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(230), 1,
      sym_paths,
  [3871] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(274), 1,
      sym_paths,
  [3881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(810), 1,
      anon_sym_PIPE_AT,
    ACTIONS(812), 1,
      sym__nl,
  [3891] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(273), 1,
      sym_paths,
  [3901] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(301), 1,
      sym_paths,
  [3911] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(303), 1,
      sym_paths,
  [3921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(814), 1,
      anon_sym_PIPE_AT,
    ACTIONS(816), 1,
      sym__nl,
  [3931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(818), 1,
      anon_sym_PIPE_AT,
    ACTIONS(820), 1,
      sym__nl,
  [3941] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(291), 1,
      sym_paths,
  [3951] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(268), 1,
      sym_paths,
  [3961] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(204), 1,
      sym_paths,
  [3971] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(305), 1,
      sym_paths,
  [3981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(822), 1,
      anon_sym_PIPE_AT,
    ACTIONS(824), 1,
      sym__nl,
  [3991] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(260), 1,
      sym_paths,
  [4001] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(189), 1,
      sym_paths,
  [4011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(826), 1,
      anon_sym_PIPE,
    ACTIONS(828), 1,
      anon_sym_COLON,
  [4021] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(172), 1,
      sym_paths,
  [4031] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(307), 1,
      sym_paths,
  [4041] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(262), 1,
      sym_paths,
  [4051] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(308), 1,
      sym_paths,
  [4061] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(242), 1,
      sym_paths,
  [4071] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(209), 1,
      sym_paths,
  [4081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(830), 1,
      anon_sym_PIPE_AT,
    ACTIONS(832), 1,
      sym__nl,
  [4091] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(272), 1,
      sym_paths,
  [4101] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(293), 1,
      sym_paths,
  [4111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(834), 1,
      sym_identifier,
    STATE(73), 1,
      sym_let,
  [4121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(836), 1,
      anon_sym_PIPE_AT,
    ACTIONS(838), 1,
      sym__nl,
  [4131] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(306), 1,
      sym_paths,
  [4141] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(191), 1,
      sym_paths,
  [4151] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(176), 1,
      sym_paths,
  [4161] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(183), 1,
      sym_paths,
  [4171] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(241), 1,
      sym_paths,
  [4181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(840), 1,
      anon_sym_PIPE_AT,
    ACTIONS(842), 1,
      sym__nl,
  [4191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(844), 1,
      anon_sym_PIPE_AT,
    ACTIONS(846), 1,
      sym__nl,
  [4201] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(267), 1,
      sym_paths,
  [4211] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(295), 1,
      sym_paths,
  [4221] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(288), 1,
      sym_paths,
  [4231] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(199), 1,
      sym_paths,
  [4241] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(246), 1,
      sym_paths,
  [4251] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(264), 1,
      sym_paths,
  [4261] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(177), 1,
      sym_paths,
  [4271] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(304), 1,
      sym_paths,
  [4281] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(292), 1,
      sym_paths,
  [4291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(848), 1,
      anon_sym_PIPE_AT,
    ACTIONS(850), 1,
      sym__nl,
  [4301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(852), 1,
      anon_sym_PIPE_AT,
    ACTIONS(854), 1,
      sym__nl,
  [4311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(856), 1,
      anon_sym_PIPE_AT,
    ACTIONS(858), 1,
      sym__nl,
  [4321] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(178), 1,
      sym_paths,
  [4331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(860), 1,
      anon_sym_PIPE_AT,
    ACTIONS(862), 1,
      sym__nl,
  [4341] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(270), 1,
      sym_paths,
  [4351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(864), 1,
      anon_sym_PIPE_AT,
    ACTIONS(866), 1,
      sym__nl,
  [4361] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(298), 1,
      sym_paths,
  [4371] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(284), 1,
      sym_paths,
  [4381] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(244), 1,
      sym_paths,
  [4391] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(265), 1,
      sym_paths,
  [4401] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(276), 1,
      sym_paths,
  [4411] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(229), 1,
      sym_paths,
  [4421] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(275), 1,
      sym_paths,
  [4431] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(180), 1,
      sym_paths,
  [4441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(868), 1,
      anon_sym_PIPE_AT,
    ACTIONS(870), 1,
      sym__nl,
  [4451] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(269), 1,
      sym_paths,
  [4461] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(240), 1,
      sym_paths,
  [4471] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(179), 1,
      sym_paths,
  [4481] = 3,
    ACTIONS(81), 1,
      sym_comment,
    ACTIONS(670), 1,
      anon_sym_,
    STATE(280), 1,
      sym_paths,
  [4491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_COLON,
  [4498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(874), 1,
      sym__nl,
  [4505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(876), 1,
      sym__nl,
  [4512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(878), 1,
      sym__nl,
  [4519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(880), 1,
      sym__nl,
  [4526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(882), 1,
      sym__nl,
  [4533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(884), 1,
      sym__nl,
  [4540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(886), 1,
      sym__nl,
  [4547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(888), 1,
      sym__nl,
  [4554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(890), 1,
      sym__nl,
  [4561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 1,
      sym__nl,
  [4568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(894), 1,
      anon_sym_RBRACE,
  [4575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 1,
      anon_sym_COLON,
  [4582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(898), 1,
      sym__nl,
  [4589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 1,
      sym__nl,
  [4596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(902), 1,
      sym__nl,
  [4603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(904), 1,
      sym__nl,
  [4610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(906), 1,
      sym__nl,
  [4617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(908), 1,
      sym_identifier,
  [4624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(910), 1,
      sym__nl,
  [4631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(912), 1,
      sym__nl,
  [4638] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(914), 1,
      sym__nl,
  [4645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(916), 1,
      sym_identifier,
  [4652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(918), 1,
      sym_identifier,
  [4659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(920), 1,
      sym__nl,
  [4666] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 1,
      sym__nl,
  [4673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(924), 1,
      sym__nl,
  [4680] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(926), 1,
      sym__nl,
  [4687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(928), 1,
      sym__nl,
  [4694] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(930), 1,
      sym__nl,
  [4701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(932), 1,
      sym__nl,
  [4708] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(934), 1,
      sym__nl,
  [4715] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(936), 1,
      sym__nl,
  [4722] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 1,
      sym__nl,
  [4729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(940), 1,
      sym_identifier,
  [4736] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(942), 1,
      sym__nl,
  [4743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(944), 1,
      sym__nl,
  [4750] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 1,
      sym__nl,
  [4757] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(948), 1,
      sym__nl,
  [4764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(950), 1,
      ts_builtin_sym_end,
  [4771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 1,
      anon_sym_EQ,
  [4778] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(954), 1,
      sym__nl,
  [4785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(956), 1,
      sym_identifier,
  [4792] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(958), 1,
      sym__nl,
  [4799] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 1,
      sym__nl,
  [4806] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(962), 1,
      sym__nl,
  [4813] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(964), 1,
      sym__nl,
  [4820] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 1,
      sym__nl,
  [4827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(968), 1,
      sym__nl,
  [4834] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(970), 1,
      sym_identifier,
  [4841] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 1,
      anon_sym_RBRACE,
  [4848] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(974), 1,
      sym_identifier,
  [4855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(976), 1,
      sym_identifier,
  [4862] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 1,
      anon_sym_EQ,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 42,
  [SMALL_STATE(4)] = 84,
  [SMALL_STATE(5)] = 117,
  [SMALL_STATE(6)] = 147,
  [SMALL_STATE(7)] = 177,
  [SMALL_STATE(8)] = 203,
  [SMALL_STATE(9)] = 229,
  [SMALL_STATE(10)] = 255,
  [SMALL_STATE(11)] = 281,
  [SMALL_STATE(12)] = 307,
  [SMALL_STATE(13)] = 333,
  [SMALL_STATE(14)] = 359,
  [SMALL_STATE(15)] = 385,
  [SMALL_STATE(16)] = 411,
  [SMALL_STATE(17)] = 437,
  [SMALL_STATE(18)] = 463,
  [SMALL_STATE(19)] = 489,
  [SMALL_STATE(20)] = 515,
  [SMALL_STATE(21)] = 541,
  [SMALL_STATE(22)] = 567,
  [SMALL_STATE(23)] = 593,
  [SMALL_STATE(24)] = 619,
  [SMALL_STATE(25)] = 645,
  [SMALL_STATE(26)] = 671,
  [SMALL_STATE(27)] = 697,
  [SMALL_STATE(28)] = 723,
  [SMALL_STATE(29)] = 749,
  [SMALL_STATE(30)] = 775,
  [SMALL_STATE(31)] = 801,
  [SMALL_STATE(32)] = 827,
  [SMALL_STATE(33)] = 853,
  [SMALL_STATE(34)] = 879,
  [SMALL_STATE(35)] = 905,
  [SMALL_STATE(36)] = 931,
  [SMALL_STATE(37)] = 957,
  [SMALL_STATE(38)] = 983,
  [SMALL_STATE(39)] = 1009,
  [SMALL_STATE(40)] = 1035,
  [SMALL_STATE(41)] = 1061,
  [SMALL_STATE(42)] = 1087,
  [SMALL_STATE(43)] = 1113,
  [SMALL_STATE(44)] = 1139,
  [SMALL_STATE(45)] = 1165,
  [SMALL_STATE(46)] = 1191,
  [SMALL_STATE(47)] = 1217,
  [SMALL_STATE(48)] = 1243,
  [SMALL_STATE(49)] = 1269,
  [SMALL_STATE(50)] = 1295,
  [SMALL_STATE(51)] = 1321,
  [SMALL_STATE(52)] = 1347,
  [SMALL_STATE(53)] = 1373,
  [SMALL_STATE(54)] = 1399,
  [SMALL_STATE(55)] = 1425,
  [SMALL_STATE(56)] = 1451,
  [SMALL_STATE(57)] = 1477,
  [SMALL_STATE(58)] = 1503,
  [SMALL_STATE(59)] = 1529,
  [SMALL_STATE(60)] = 1555,
  [SMALL_STATE(61)] = 1581,
  [SMALL_STATE(62)] = 1607,
  [SMALL_STATE(63)] = 1633,
  [SMALL_STATE(64)] = 1659,
  [SMALL_STATE(65)] = 1685,
  [SMALL_STATE(66)] = 1711,
  [SMALL_STATE(67)] = 1737,
  [SMALL_STATE(68)] = 1763,
  [SMALL_STATE(69)] = 1789,
  [SMALL_STATE(70)] = 1815,
  [SMALL_STATE(71)] = 1841,
  [SMALL_STATE(72)] = 1864,
  [SMALL_STATE(73)] = 1887,
  [SMALL_STATE(74)] = 1905,
  [SMALL_STATE(75)] = 1929,
  [SMALL_STATE(76)] = 1947,
  [SMALL_STATE(77)] = 1971,
  [SMALL_STATE(78)] = 1995,
  [SMALL_STATE(79)] = 2019,
  [SMALL_STATE(80)] = 2043,
  [SMALL_STATE(81)] = 2067,
  [SMALL_STATE(82)] = 2084,
  [SMALL_STATE(83)] = 2101,
  [SMALL_STATE(84)] = 2118,
  [SMALL_STATE(85)] = 2135,
  [SMALL_STATE(86)] = 2152,
  [SMALL_STATE(87)] = 2169,
  [SMALL_STATE(88)] = 2186,
  [SMALL_STATE(89)] = 2203,
  [SMALL_STATE(90)] = 2220,
  [SMALL_STATE(91)] = 2237,
  [SMALL_STATE(92)] = 2254,
  [SMALL_STATE(93)] = 2271,
  [SMALL_STATE(94)] = 2288,
  [SMALL_STATE(95)] = 2305,
  [SMALL_STATE(96)] = 2322,
  [SMALL_STATE(97)] = 2339,
  [SMALL_STATE(98)] = 2356,
  [SMALL_STATE(99)] = 2373,
  [SMALL_STATE(100)] = 2390,
  [SMALL_STATE(101)] = 2407,
  [SMALL_STATE(102)] = 2424,
  [SMALL_STATE(103)] = 2441,
  [SMALL_STATE(104)] = 2458,
  [SMALL_STATE(105)] = 2475,
  [SMALL_STATE(106)] = 2492,
  [SMALL_STATE(107)] = 2509,
  [SMALL_STATE(108)] = 2526,
  [SMALL_STATE(109)] = 2543,
  [SMALL_STATE(110)] = 2560,
  [SMALL_STATE(111)] = 2577,
  [SMALL_STATE(112)] = 2594,
  [SMALL_STATE(113)] = 2611,
  [SMALL_STATE(114)] = 2628,
  [SMALL_STATE(115)] = 2645,
  [SMALL_STATE(116)] = 2662,
  [SMALL_STATE(117)] = 2679,
  [SMALL_STATE(118)] = 2696,
  [SMALL_STATE(119)] = 2713,
  [SMALL_STATE(120)] = 2730,
  [SMALL_STATE(121)] = 2747,
  [SMALL_STATE(122)] = 2764,
  [SMALL_STATE(123)] = 2781,
  [SMALL_STATE(124)] = 2798,
  [SMALL_STATE(125)] = 2815,
  [SMALL_STATE(126)] = 2832,
  [SMALL_STATE(127)] = 2849,
  [SMALL_STATE(128)] = 2866,
  [SMALL_STATE(129)] = 2883,
  [SMALL_STATE(130)] = 2900,
  [SMALL_STATE(131)] = 2917,
  [SMALL_STATE(132)] = 2934,
  [SMALL_STATE(133)] = 2951,
  [SMALL_STATE(134)] = 2968,
  [SMALL_STATE(135)] = 2985,
  [SMALL_STATE(136)] = 3002,
  [SMALL_STATE(137)] = 3019,
  [SMALL_STATE(138)] = 3036,
  [SMALL_STATE(139)] = 3053,
  [SMALL_STATE(140)] = 3070,
  [SMALL_STATE(141)] = 3087,
  [SMALL_STATE(142)] = 3104,
  [SMALL_STATE(143)] = 3121,
  [SMALL_STATE(144)] = 3138,
  [SMALL_STATE(145)] = 3155,
  [SMALL_STATE(146)] = 3172,
  [SMALL_STATE(147)] = 3189,
  [SMALL_STATE(148)] = 3206,
  [SMALL_STATE(149)] = 3223,
  [SMALL_STATE(150)] = 3240,
  [SMALL_STATE(151)] = 3257,
  [SMALL_STATE(152)] = 3272,
  [SMALL_STATE(153)] = 3287,
  [SMALL_STATE(154)] = 3302,
  [SMALL_STATE(155)] = 3317,
  [SMALL_STATE(156)] = 3332,
  [SMALL_STATE(157)] = 3354,
  [SMALL_STATE(158)] = 3376,
  [SMALL_STATE(159)] = 3398,
  [SMALL_STATE(160)] = 3420,
  [SMALL_STATE(161)] = 3433,
  [SMALL_STATE(162)] = 3449,
  [SMALL_STATE(163)] = 3465,
  [SMALL_STATE(164)] = 3481,
  [SMALL_STATE(165)] = 3497,
  [SMALL_STATE(166)] = 3513,
  [SMALL_STATE(167)] = 3529,
  [SMALL_STATE(168)] = 3545,
  [SMALL_STATE(169)] = 3554,
  [SMALL_STATE(170)] = 3563,
  [SMALL_STATE(171)] = 3572,
  [SMALL_STATE(172)] = 3581,
  [SMALL_STATE(173)] = 3594,
  [SMALL_STATE(174)] = 3607,
  [SMALL_STATE(175)] = 3620,
  [SMALL_STATE(176)] = 3631,
  [SMALL_STATE(177)] = 3644,
  [SMALL_STATE(178)] = 3657,
  [SMALL_STATE(179)] = 3670,
  [SMALL_STATE(180)] = 3683,
  [SMALL_STATE(181)] = 3696,
  [SMALL_STATE(182)] = 3705,
  [SMALL_STATE(183)] = 3718,
  [SMALL_STATE(184)] = 3731,
  [SMALL_STATE(185)] = 3741,
  [SMALL_STATE(186)] = 3751,
  [SMALL_STATE(187)] = 3761,
  [SMALL_STATE(188)] = 3771,
  [SMALL_STATE(189)] = 3781,
  [SMALL_STATE(190)] = 3791,
  [SMALL_STATE(191)] = 3801,
  [SMALL_STATE(192)] = 3811,
  [SMALL_STATE(193)] = 3821,
  [SMALL_STATE(194)] = 3831,
  [SMALL_STATE(195)] = 3841,
  [SMALL_STATE(196)] = 3851,
  [SMALL_STATE(197)] = 3861,
  [SMALL_STATE(198)] = 3871,
  [SMALL_STATE(199)] = 3881,
  [SMALL_STATE(200)] = 3891,
  [SMALL_STATE(201)] = 3901,
  [SMALL_STATE(202)] = 3911,
  [SMALL_STATE(203)] = 3921,
  [SMALL_STATE(204)] = 3931,
  [SMALL_STATE(205)] = 3941,
  [SMALL_STATE(206)] = 3951,
  [SMALL_STATE(207)] = 3961,
  [SMALL_STATE(208)] = 3971,
  [SMALL_STATE(209)] = 3981,
  [SMALL_STATE(210)] = 3991,
  [SMALL_STATE(211)] = 4001,
  [SMALL_STATE(212)] = 4011,
  [SMALL_STATE(213)] = 4021,
  [SMALL_STATE(214)] = 4031,
  [SMALL_STATE(215)] = 4041,
  [SMALL_STATE(216)] = 4051,
  [SMALL_STATE(217)] = 4061,
  [SMALL_STATE(218)] = 4071,
  [SMALL_STATE(219)] = 4081,
  [SMALL_STATE(220)] = 4091,
  [SMALL_STATE(221)] = 4101,
  [SMALL_STATE(222)] = 4111,
  [SMALL_STATE(223)] = 4121,
  [SMALL_STATE(224)] = 4131,
  [SMALL_STATE(225)] = 4141,
  [SMALL_STATE(226)] = 4151,
  [SMALL_STATE(227)] = 4161,
  [SMALL_STATE(228)] = 4171,
  [SMALL_STATE(229)] = 4181,
  [SMALL_STATE(230)] = 4191,
  [SMALL_STATE(231)] = 4201,
  [SMALL_STATE(232)] = 4211,
  [SMALL_STATE(233)] = 4221,
  [SMALL_STATE(234)] = 4231,
  [SMALL_STATE(235)] = 4241,
  [SMALL_STATE(236)] = 4251,
  [SMALL_STATE(237)] = 4261,
  [SMALL_STATE(238)] = 4271,
  [SMALL_STATE(239)] = 4281,
  [SMALL_STATE(240)] = 4291,
  [SMALL_STATE(241)] = 4301,
  [SMALL_STATE(242)] = 4311,
  [SMALL_STATE(243)] = 4321,
  [SMALL_STATE(244)] = 4331,
  [SMALL_STATE(245)] = 4341,
  [SMALL_STATE(246)] = 4351,
  [SMALL_STATE(247)] = 4361,
  [SMALL_STATE(248)] = 4371,
  [SMALL_STATE(249)] = 4381,
  [SMALL_STATE(250)] = 4391,
  [SMALL_STATE(251)] = 4401,
  [SMALL_STATE(252)] = 4411,
  [SMALL_STATE(253)] = 4421,
  [SMALL_STATE(254)] = 4431,
  [SMALL_STATE(255)] = 4441,
  [SMALL_STATE(256)] = 4451,
  [SMALL_STATE(257)] = 4461,
  [SMALL_STATE(258)] = 4471,
  [SMALL_STATE(259)] = 4481,
  [SMALL_STATE(260)] = 4491,
  [SMALL_STATE(261)] = 4498,
  [SMALL_STATE(262)] = 4505,
  [SMALL_STATE(263)] = 4512,
  [SMALL_STATE(264)] = 4519,
  [SMALL_STATE(265)] = 4526,
  [SMALL_STATE(266)] = 4533,
  [SMALL_STATE(267)] = 4540,
  [SMALL_STATE(268)] = 4547,
  [SMALL_STATE(269)] = 4554,
  [SMALL_STATE(270)] = 4561,
  [SMALL_STATE(271)] = 4568,
  [SMALL_STATE(272)] = 4575,
  [SMALL_STATE(273)] = 4582,
  [SMALL_STATE(274)] = 4589,
  [SMALL_STATE(275)] = 4596,
  [SMALL_STATE(276)] = 4603,
  [SMALL_STATE(277)] = 4610,
  [SMALL_STATE(278)] = 4617,
  [SMALL_STATE(279)] = 4624,
  [SMALL_STATE(280)] = 4631,
  [SMALL_STATE(281)] = 4638,
  [SMALL_STATE(282)] = 4645,
  [SMALL_STATE(283)] = 4652,
  [SMALL_STATE(284)] = 4659,
  [SMALL_STATE(285)] = 4666,
  [SMALL_STATE(286)] = 4673,
  [SMALL_STATE(287)] = 4680,
  [SMALL_STATE(288)] = 4687,
  [SMALL_STATE(289)] = 4694,
  [SMALL_STATE(290)] = 4701,
  [SMALL_STATE(291)] = 4708,
  [SMALL_STATE(292)] = 4715,
  [SMALL_STATE(293)] = 4722,
  [SMALL_STATE(294)] = 4729,
  [SMALL_STATE(295)] = 4736,
  [SMALL_STATE(296)] = 4743,
  [SMALL_STATE(297)] = 4750,
  [SMALL_STATE(298)] = 4757,
  [SMALL_STATE(299)] = 4764,
  [SMALL_STATE(300)] = 4771,
  [SMALL_STATE(301)] = 4778,
  [SMALL_STATE(302)] = 4785,
  [SMALL_STATE(303)] = 4792,
  [SMALL_STATE(304)] = 4799,
  [SMALL_STATE(305)] = 4806,
  [SMALL_STATE(306)] = 4813,
  [SMALL_STATE(307)] = 4820,
  [SMALL_STATE(308)] = 4827,
  [SMALL_STATE(309)] = 4834,
  [SMALL_STATE(310)] = 4841,
  [SMALL_STATE(311)] = 4848,
  [SMALL_STATE(312)] = 4855,
  [SMALL_STATE(313)] = 4862,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_manifest, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(302),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [23] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_manifest_repeat1, 2),
  [25] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_manifest_repeat1, 2), SHIFT_REPEAT(300),
  [28] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_manifest_repeat1, 2), SHIFT_REPEAT(302),
  [31] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_manifest_repeat1, 2), SHIFT_REPEAT(311),
  [34] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_manifest_repeat1, 2), SHIFT_REPEAT(175),
  [37] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_manifest_repeat1, 2), SHIFT_REPEAT(167),
  [40] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_manifest_repeat1, 2), SHIFT_REPEAT(80),
  [43] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_manifest_repeat1, 2), SHIFT_REPEAT(78),
  [46] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_manifest_repeat1, 2), SHIFT_REPEAT(2),
  [49] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_manifest, 1),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paths, 1),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paths, 1),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_path_repeat1, 2),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_path_repeat1, 2),
  [65] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_path_repeat1, 2), SHIFT_REPEAT(5),
  [68] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_path_repeat1, 2), SHIFT_REPEAT(166),
  [71] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_path, 1),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_path, 1),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [77] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 39),
  [79] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 39),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [85] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 25),
  [87] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 25),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 29),
  [91] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 29),
  [93] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 14, .production_id = 66),
  [95] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 14, .production_id = 66),
  [97] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 50),
  [99] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 50),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 6, .production_id = 6),
  [103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 6, .production_id = 6),
  [105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 26),
  [107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 26),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 28),
  [111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 28),
  [113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 24),
  [115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 24),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 23),
  [119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 23),
  [121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 22),
  [123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 22),
  [125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 27),
  [127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 27),
  [129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 13, .production_id = 65),
  [131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 13, .production_id = 65),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 13, .production_id = 64),
  [135] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 13, .production_id = 64),
  [137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 30),
  [139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 30),
  [141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 63),
  [143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 63),
  [145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 31),
  [147] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 31),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 21),
  [151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 21),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 6, .production_id = 7),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 6, .production_id = 7),
  [157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 62),
  [159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 62),
  [161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 61),
  [163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 61),
  [165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 20),
  [167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 20),
  [169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 19),
  [171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 19),
  [173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 60),
  [175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 60),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 32),
  [179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 32),
  [181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 6, .production_id = 8),
  [183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 6, .production_id = 8),
  [185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 33),
  [187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 33),
  [189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 34),
  [191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 34),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 35),
  [195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 35),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 6, .production_id = 9),
  [199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 6, .production_id = 9),
  [201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 17),
  [203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 17),
  [205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 36),
  [207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 36),
  [209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 16),
  [211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 16),
  [213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 37),
  [215] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 37),
  [217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 18),
  [219] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 18),
  [221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 38),
  [223] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 38),
  [225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 15),
  [227] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 15),
  [229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 47),
  [231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 47),
  [233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 49),
  [235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 49),
  [237] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 46),
  [239] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 46),
  [241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 40),
  [243] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 40),
  [245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 59),
  [247] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 59),
  [249] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 48),
  [251] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 48),
  [253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 4, .production_id = 2),
  [255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 4, .production_id = 2),
  [257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 14),
  [259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 14),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 13),
  [263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 13),
  [265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 12),
  [267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 12),
  [269] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 58),
  [271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 58),
  [273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 41),
  [275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 41),
  [277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 51),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 51),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 5, .production_id = 5),
  [283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 5, .production_id = 5),
  [285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 52),
  [287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 52),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 42),
  [291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 42),
  [293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 43),
  [295] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 43),
  [297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 11),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 11),
  [301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 44),
  [303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 44),
  [305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 6, .production_id = 10),
  [307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 6, .production_id = 10),
  [309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 57),
  [311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 57),
  [313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 56),
  [315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 56),
  [317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 55),
  [319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 55),
  [321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 5, .production_id = 4),
  [323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 5, .production_id = 4),
  [325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 54),
  [327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 54),
  [329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 45),
  [331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 45),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 53),
  [335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 53),
  [337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_body_repeat1, 2),
  [339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2),
  [341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_body_repeat1, 2), SHIFT_REPEAT(222),
  [344] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_body, 1),
  [346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_body, 1),
  [348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(74),
  [351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2), SHIFT_REPEAT(163),
  [354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_text_repeat1, 2),
  [356] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 4, .production_id = 3),
  [358] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let, 4, .production_id = 3),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_text, 1),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 52),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 52),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 49),
  [374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 49),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 50),
  [378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 50),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 10),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 10),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 15, .production_id = 66),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 15, .production_id = 66),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 40),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 40),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 39),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 39),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 38),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 38),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 6, .production_id = 4),
  [402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 6, .production_id = 4),
  [404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 14, .production_id = 65),
  [406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 14, .production_id = 65),
  [408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 42),
  [410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 42),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 43),
  [414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 43),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 14, .production_id = 64),
  [418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 14, .production_id = 64),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 6, .production_id = 5),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 6, .production_id = 5),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 37),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 37),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 36),
  [430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 36),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 35),
  [434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 35),
  [436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 44),
  [438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 44),
  [440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 34),
  [442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 34),
  [444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 33),
  [446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 33),
  [448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 32),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 32),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 6),
  [454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 6),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 5, .production_id = 2),
  [458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 5, .production_id = 2),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 31),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 31),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 30),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 30),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 45),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 45),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 10, .production_id = 29),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 10, .production_id = 29),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 46),
  [478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 46),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 7),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 7),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 47),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 47),
  [488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 8),
  [490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 8),
  [492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 7, .production_id = 9),
  [494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 7, .production_id = 9),
  [496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 19),
  [498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 19),
  [500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 28),
  [502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 28),
  [504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 27),
  [506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 27),
  [508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 15),
  [510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 15),
  [512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 48),
  [514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 48),
  [516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 26),
  [518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 26),
  [520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 11, .production_id = 41),
  [522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 11, .production_id = 41),
  [524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 51),
  [526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 51),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule, 4, .production_id = 1),
  [530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rule, 4, .production_id = 1),
  [532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pool, 4, .production_id = 1),
  [534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pool, 4, .production_id = 1),
  [536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 25),
  [538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 25),
  [540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 53),
  [542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 53),
  [544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 54),
  [546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 54),
  [548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subninja, 3),
  [550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subninja, 3),
  [552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_include, 3),
  [554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_include, 3),
  [556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 21),
  [558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 21),
  [560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 55),
  [562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 55),
  [564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 18),
  [566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 18),
  [568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 17),
  [570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 17),
  [572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 56),
  [574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 56),
  [576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 57),
  [578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 57),
  [580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 24),
  [582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 24),
  [584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 14),
  [586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 14),
  [588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 23),
  [590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 23),
  [592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default, 3),
  [594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default, 3),
  [596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 13),
  [598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 13),
  [600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 22),
  [602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 22),
  [604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 12, .production_id = 58),
  [606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 12, .production_id = 58),
  [608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 9, .production_id = 20),
  [610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 9, .production_id = 20),
  [612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 11),
  [614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 11),
  [616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 13, .production_id = 59),
  [618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 13, .production_id = 59),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 13, .production_id = 60),
  [622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 13, .production_id = 60),
  [624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 13, .production_id = 61),
  [626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 13, .production_id = 61),
  [628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 13, .production_id = 62),
  [630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 13, .production_id = 62),
  [632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 13, .production_id = 63),
  [634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 13, .production_id = 63),
  [636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 16),
  [638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 16),
  [640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_build, 8, .production_id = 12),
  [642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_build, 8, .production_id = 12),
  [644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expansion, 1),
  [646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expansion, 1),
  [648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quote, 2),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quote, 2),
  [652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_split, 2),
  [654] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_split, 2),
  [656] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_var_expansion, 2),
  [658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_var_expansion, 2),
  [660] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__var_expansion, 4),
  [662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__var_expansion, 4),
  [664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [678] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(252),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paths, 2),
  [700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paths, 2),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [742] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [750] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [950] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ninja(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
